"""
The Unicode Standard - Version 15.0.0.

https://www.unicode.org/Public/zipped/15.0.0/UCD.zip/UnicodeData.txt
"""

NONE = ""
NULL = chr(0)
START_OF_HEADING = chr(1)
START_OF_TEXT = chr(2)
END_OF_TEXT = chr(3)
END_OF_TRANSMISSION = chr(4)
ENQUIRY = chr(5)
ACKNOWLEDGE = chr(6)
BELL = chr(7)
BACKSPACE = chr(8)
CHARACTER_TABULATION = chr(9)
LINE_FEED = chr(10)
LINE_TABULATION = chr(11)
FORM_FEED = chr(12)
CARRIAGE_RETURN = chr(13)
SHIFT_OUT = chr(14)
SHIFT_IN = chr(15)
DATA_LINK_ESCAPE = chr(16)
DEVICE_CONTROL_ONE = chr(17)
DEVICE_CONTROL_TWO = chr(18)
DEVICE_CONTROL_THREE = chr(19)
DEVICE_CONTROL_FOUR = chr(20)
NEGATIVE_ACKNOWLEDGE = chr(21)
SYNCHRONOUS_IDLE = chr(22)
END_OF_TRANSMISSION_BLOCK = chr(23)
CANCEL = chr(24)
END_OF_MEDIUM = chr(25)
SUBSTITUTE = chr(26)
ESCAPE = chr(27)
INFORMATION_SEPARATOR_FOUR = chr(28)
INFORMATION_SEPARATOR_THREE = chr(29)
INFORMATION_SEPARATOR_TWO = chr(30)
INFORMATION_SEPARATOR_ONE = chr(31)
SPACE = chr(32)
EXCLAMATION_MARK = chr(33)
QUOTATION_MARK = chr(34)
NUMBER_SIGN = chr(35)
DOLLAR_SIGN = chr(36)
PERCENT_SIGN = chr(37)
AMPERSAND = chr(38)
APOSTROPHE = chr(39)
LEFT_PARENTHESIS = chr(40)
RIGHT_PARENTHESIS = chr(41)
ASTERISK = chr(42)
PLUS_SIGN = chr(43)
COMMA = chr(44)
HYPHEN_MINUS = chr(45)
FULL_STOP = chr(46)
SOLIDUS = chr(47)
DIGIT_ZERO = chr(48)
DIGIT_ONE = chr(49)
DIGIT_TWO = chr(50)
DIGIT_THREE = chr(51)
DIGIT_FOUR = chr(52)
DIGIT_FIVE = chr(53)
DIGIT_SIX = chr(54)
DIGIT_SEVEN = chr(55)
DIGIT_EIGHT = chr(56)
DIGIT_NINE = chr(57)
COLON = chr(58)
SEMICOLON = chr(59)
LESS_THAN_SIGN = chr(60)
EQUALS_SIGN = chr(61)
GREATER_THAN_SIGN = chr(62)
QUESTION_MARK = chr(63)
COMMERCIAL_AT = chr(64)
LATIN_CAPITAL_LETTER_A = chr(65)
LATIN_CAPITAL_LETTER_B = chr(66)
LATIN_CAPITAL_LETTER_C = chr(67)
LATIN_CAPITAL_LETTER_D = chr(68)
LATIN_CAPITAL_LETTER_E = chr(69)
LATIN_CAPITAL_LETTER_F = chr(70)
LATIN_CAPITAL_LETTER_G = chr(71)
LATIN_CAPITAL_LETTER_H = chr(72)
LATIN_CAPITAL_LETTER_I = chr(73)
LATIN_CAPITAL_LETTER_J = chr(74)
LATIN_CAPITAL_LETTER_K = chr(75)
LATIN_CAPITAL_LETTER_L = chr(76)
LATIN_CAPITAL_LETTER_M = chr(77)
LATIN_CAPITAL_LETTER_N = chr(78)
LATIN_CAPITAL_LETTER_O = chr(79)
LATIN_CAPITAL_LETTER_P = chr(80)
LATIN_CAPITAL_LETTER_Q = chr(81)
LATIN_CAPITAL_LETTER_R = chr(82)
LATIN_CAPITAL_LETTER_S = chr(83)
LATIN_CAPITAL_LETTER_T = chr(84)
LATIN_CAPITAL_LETTER_U = chr(85)
LATIN_CAPITAL_LETTER_V = chr(86)
LATIN_CAPITAL_LETTER_W = chr(87)
LATIN_CAPITAL_LETTER_X = chr(88)
LATIN_CAPITAL_LETTER_Y = chr(89)
LATIN_CAPITAL_LETTER_Z = chr(90)
LEFT_SQUARE_BRACKET = chr(91)
REVERSE_SOLIDUS = chr(92)
RIGHT_SQUARE_BRACKET = chr(93)
CIRCUMFLEX_ACCENT = chr(94)
LOW_LINE = chr(95)
GRAVE_ACCENT = chr(96)
LATIN_SMALL_LETTER_A = chr(97)
LATIN_SMALL_LETTER_B = chr(98)
LATIN_SMALL_LETTER_C = chr(99)
LATIN_SMALL_LETTER_D = chr(100)
LATIN_SMALL_LETTER_E = chr(101)
LATIN_SMALL_LETTER_F = chr(102)
LATIN_SMALL_LETTER_G = chr(103)
LATIN_SMALL_LETTER_H = chr(104)
LATIN_SMALL_LETTER_I = chr(105)
LATIN_SMALL_LETTER_J = chr(106)
LATIN_SMALL_LETTER_K = chr(107)
LATIN_SMALL_LETTER_L = chr(108)
LATIN_SMALL_LETTER_M = chr(109)
LATIN_SMALL_LETTER_N = chr(110)
LATIN_SMALL_LETTER_O = chr(111)
LATIN_SMALL_LETTER_P = chr(112)
LATIN_SMALL_LETTER_Q = chr(113)
LATIN_SMALL_LETTER_R = chr(114)
LATIN_SMALL_LETTER_S = chr(115)
LATIN_SMALL_LETTER_T = chr(116)
LATIN_SMALL_LETTER_U = chr(117)
LATIN_SMALL_LETTER_V = chr(118)
LATIN_SMALL_LETTER_W = chr(119)
LATIN_SMALL_LETTER_X = chr(120)
LATIN_SMALL_LETTER_Y = chr(121)
LATIN_SMALL_LETTER_Z = chr(122)
LEFT_CURLY_BRACKET = chr(123)
VERTICAL_LINE = chr(124)
RIGHT_CURLY_BRACKET = chr(125)
TILDE = chr(126)
DELETE = chr(127)
Single_Graphic_Character_Introducer = chr(128)
Single_Graphic_Character_Introducer = chr(129)
BREAK_PERMITTED_HERE = chr(130)
NO_BREAK_HERE = chr(131)
Single_Graphic_Character_Introducer = chr(132)
NEXT_LINE = chr(133)
START_OF_SELECTED_AREA = chr(134)
END_OF_SELECTED_AREA = chr(135)
CHARACTER_TABULATION_SET = chr(136)
CHARACTER_TABULATION_WITH_JUSTIFICATION = chr(137)
LINE_TABULATION_SET = chr(138)
PARTIAL_LINE_FORWARD = chr(139)
PARTIAL_LINE_BACKWARD = chr(140)
REVERSE_LINE_FEED = chr(141)
SINGLE_SHIFT_TWO = chr(142)
SINGLE_SHIFT_THREE = chr(143)
DEVICE_CONTROL_STRING = chr(144)
PRIVATE_USE_ONE = chr(145)
PRIVATE_USE_TWO = chr(146)
SET_TRANSMIT_STATE = chr(147)
CANCEL_CHARACTER = chr(148)
MESSAGE_WAITING = chr(149)
START_OF_GUARDED_AREA = chr(150)
END_OF_GUARDED_AREA = chr(151)
START_OF_STRING = chr(152)
Single_Graphic_Character_Introducer = chr(153)
SINGLE_CHARACTER_INTRODUCER = chr(154)
CONTROL_SEQUENCE_INTRODUCER = chr(155)
STRING_TERMINATOR = chr(156)
OPERATING_SYSTEM_COMMAND = chr(157)
PRIVACY_MESSAGE = chr(158)
APPLICATION_PROGRAM_COMMAND = chr(159)
NO_BREAK_SPACE = chr(160)
INVERTED_EXCLAMATION_MARK = chr(161)
CENT_SIGN = chr(162)
POUND_SIGN = chr(163)
CURRENCY_SIGN = chr(164)
YEN_SIGN = chr(165)
BROKEN_BAR = chr(166)
SECTION_SIGN = chr(167)
DIAERESIS = chr(168)
COPYRIGHT_SIGN = chr(169)
FEMININE_ORDINAL_INDICATOR = chr(170)
LEFT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK = chr(171)
NOT_SIGN = chr(172)
SOFT_HYPHEN = chr(173)
REGISTERED_SIGN = chr(174)
MACRON = chr(175)
DEGREE_SIGN = chr(176)
PLUS_MINUS_SIGN = chr(177)
SUPERSCRIPT_TWO = chr(178)
SUPERSCRIPT_THREE = chr(179)
ACUTE_ACCENT = chr(180)
MICRO_SIGN = chr(181)
PILCROW_SIGN = chr(182)
MIDDLE_DOT = chr(183)
CEDILLA = chr(184)
SUPERSCRIPT_ONE = chr(185)
MASCULINE_ORDINAL_INDICATOR = chr(186)
RIGHT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK = chr(187)
VULGAR_FRACTION_ONE_QUARTER = chr(188)
VULGAR_FRACTION_ONE_HALF = chr(189)
VULGAR_FRACTION_THREE_QUARTERS = chr(190)
INVERTED_QUESTION_MARK = chr(191)
LATIN_CAPITAL_LETTER_A_WITH_GRAVE = chr(192)
LATIN_CAPITAL_LETTER_A_WITH_ACUTE = chr(193)
LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX = chr(194)
LATIN_CAPITAL_LETTER_A_WITH_TILDE = chr(195)
LATIN_CAPITAL_LETTER_A_WITH_DIAERESIS = chr(196)
LATIN_CAPITAL_LETTER_A_WITH_RING_ABOVE = chr(197)
LATIN_CAPITAL_LETTER_AE = chr(198)
LATIN_CAPITAL_LETTER_C_WITH_CEDILLA = chr(199)
LATIN_CAPITAL_LETTER_E_WITH_GRAVE = chr(200)
LATIN_CAPITAL_LETTER_E_WITH_ACUTE = chr(201)
LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX = chr(202)
LATIN_CAPITAL_LETTER_E_WITH_DIAERESIS = chr(203)
LATIN_CAPITAL_LETTER_I_WITH_GRAVE = chr(204)
LATIN_CAPITAL_LETTER_I_WITH_ACUTE = chr(205)
LATIN_CAPITAL_LETTER_I_WITH_CIRCUMFLEX = chr(206)
LATIN_CAPITAL_LETTER_I_WITH_DIAERESIS = chr(207)
LATIN_CAPITAL_LETTER_ETH = chr(208)
LATIN_CAPITAL_LETTER_N_WITH_TILDE = chr(209)
LATIN_CAPITAL_LETTER_O_WITH_GRAVE = chr(210)
LATIN_CAPITAL_LETTER_O_WITH_ACUTE = chr(211)
LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX = chr(212)
LATIN_CAPITAL_LETTER_O_WITH_TILDE = chr(213)
LATIN_CAPITAL_LETTER_O_WITH_DIAERESIS = chr(214)
MULTIPLICATION_SIGN = chr(215)
LATIN_CAPITAL_LETTER_O_WITH_STROKE = chr(216)
LATIN_CAPITAL_LETTER_U_WITH_GRAVE = chr(217)
LATIN_CAPITAL_LETTER_U_WITH_ACUTE = chr(218)
LATIN_CAPITAL_LETTER_U_WITH_CIRCUMFLEX = chr(219)
LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS = chr(220)
LATIN_CAPITAL_LETTER_Y_WITH_ACUTE = chr(221)
LATIN_CAPITAL_LETTER_THORN = chr(222)
LATIN_SMALL_LETTER_SHARP_S = chr(223)
LATIN_SMALL_LETTER_A_WITH_GRAVE = chr(224)
LATIN_SMALL_LETTER_A_WITH_ACUTE = chr(225)
LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX = chr(226)
LATIN_SMALL_LETTER_A_WITH_TILDE = chr(227)
LATIN_SMALL_LETTER_A_WITH_DIAERESIS = chr(228)
LATIN_SMALL_LETTER_A_WITH_RING_ABOVE = chr(229)
LATIN_SMALL_LETTER_AE = chr(230)
LATIN_SMALL_LETTER_C_WITH_CEDILLA = chr(231)
LATIN_SMALL_LETTER_E_WITH_GRAVE = chr(232)
LATIN_SMALL_LETTER_E_WITH_ACUTE = chr(233)
LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX = chr(234)
LATIN_SMALL_LETTER_E_WITH_DIAERESIS = chr(235)
LATIN_SMALL_LETTER_I_WITH_GRAVE = chr(236)
LATIN_SMALL_LETTER_I_WITH_ACUTE = chr(237)
LATIN_SMALL_LETTER_I_WITH_CIRCUMFLEX = chr(238)
LATIN_SMALL_LETTER_I_WITH_DIAERESIS = chr(239)
LATIN_SMALL_LETTER_ETH = chr(240)
LATIN_SMALL_LETTER_N_WITH_TILDE = chr(241)
LATIN_SMALL_LETTER_O_WITH_GRAVE = chr(242)
LATIN_SMALL_LETTER_O_WITH_ACUTE = chr(243)
LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX = chr(244)
LATIN_SMALL_LETTER_O_WITH_TILDE = chr(245)
LATIN_SMALL_LETTER_O_WITH_DIAERESIS = chr(246)
DIVISION_SIGN = chr(247)
LATIN_SMALL_LETTER_O_WITH_STROKE = chr(248)
LATIN_SMALL_LETTER_U_WITH_GRAVE = chr(249)
LATIN_SMALL_LETTER_U_WITH_ACUTE = chr(250)
LATIN_SMALL_LETTER_U_WITH_CIRCUMFLEX = chr(251)
LATIN_SMALL_LETTER_U_WITH_DIAERESIS = chr(252)
LATIN_SMALL_LETTER_Y_WITH_ACUTE = chr(253)
LATIN_SMALL_LETTER_THORN = chr(254)
LATIN_SMALL_LETTER_Y_WITH_DIAERESIS = chr(255)
LATIN_CAPITAL_LETTER_A_WITH_MACRON = chr(256)
LATIN_SMALL_LETTER_A_WITH_MACRON = chr(257)
LATIN_CAPITAL_LETTER_A_WITH_BREVE = chr(258)
LATIN_SMALL_LETTER_A_WITH_BREVE = chr(259)
LATIN_CAPITAL_LETTER_A_WITH_OGONEK = chr(260)
LATIN_SMALL_LETTER_A_WITH_OGONEK = chr(261)
LATIN_CAPITAL_LETTER_C_WITH_ACUTE = chr(262)
LATIN_SMALL_LETTER_C_WITH_ACUTE = chr(263)
LATIN_CAPITAL_LETTER_C_WITH_CIRCUMFLEX = chr(264)
LATIN_SMALL_LETTER_C_WITH_CIRCUMFLEX = chr(265)
LATIN_CAPITAL_LETTER_C_WITH_DOT_ABOVE = chr(266)
LATIN_SMALL_LETTER_C_WITH_DOT_ABOVE = chr(267)
LATIN_CAPITAL_LETTER_C_WITH_CARON = chr(268)
LATIN_SMALL_LETTER_C_WITH_CARON = chr(269)
LATIN_CAPITAL_LETTER_D_WITH_CARON = chr(270)
LATIN_SMALL_LETTER_D_WITH_CARON = chr(271)
LATIN_CAPITAL_LETTER_D_WITH_STROKE = chr(272)
LATIN_SMALL_LETTER_D_WITH_STROKE = chr(273)
LATIN_CAPITAL_LETTER_E_WITH_MACRON = chr(274)
LATIN_SMALL_LETTER_E_WITH_MACRON = chr(275)
LATIN_CAPITAL_LETTER_E_WITH_BREVE = chr(276)
LATIN_SMALL_LETTER_E_WITH_BREVE = chr(277)
LATIN_CAPITAL_LETTER_E_WITH_DOT_ABOVE = chr(278)
LATIN_SMALL_LETTER_E_WITH_DOT_ABOVE = chr(279)
LATIN_CAPITAL_LETTER_E_WITH_OGONEK = chr(280)
LATIN_SMALL_LETTER_E_WITH_OGONEK = chr(281)
LATIN_CAPITAL_LETTER_E_WITH_CARON = chr(282)
LATIN_SMALL_LETTER_E_WITH_CARON = chr(283)
LATIN_CAPITAL_LETTER_G_WITH_CIRCUMFLEX = chr(284)
LATIN_SMALL_LETTER_G_WITH_CIRCUMFLEX = chr(285)
LATIN_CAPITAL_LETTER_G_WITH_BREVE = chr(286)
LATIN_SMALL_LETTER_G_WITH_BREVE = chr(287)
LATIN_CAPITAL_LETTER_G_WITH_DOT_ABOVE = chr(288)
LATIN_SMALL_LETTER_G_WITH_DOT_ABOVE = chr(289)
LATIN_CAPITAL_LETTER_G_WITH_CEDILLA = chr(290)
LATIN_SMALL_LETTER_G_WITH_CEDILLA = chr(291)
LATIN_CAPITAL_LETTER_H_WITH_CIRCUMFLEX = chr(292)
LATIN_SMALL_LETTER_H_WITH_CIRCUMFLEX = chr(293)
LATIN_CAPITAL_LETTER_H_WITH_STROKE = chr(294)
LATIN_SMALL_LETTER_H_WITH_STROKE = chr(295)
LATIN_CAPITAL_LETTER_I_WITH_TILDE = chr(296)
LATIN_SMALL_LETTER_I_WITH_TILDE = chr(297)
LATIN_CAPITAL_LETTER_I_WITH_MACRON = chr(298)
LATIN_SMALL_LETTER_I_WITH_MACRON = chr(299)
LATIN_CAPITAL_LETTER_I_WITH_BREVE = chr(300)
LATIN_SMALL_LETTER_I_WITH_BREVE = chr(301)
LATIN_CAPITAL_LETTER_I_WITH_OGONEK = chr(302)
LATIN_SMALL_LETTER_I_WITH_OGONEK = chr(303)
LATIN_CAPITAL_LETTER_I_WITH_DOT_ABOVE = chr(304)
LATIN_SMALL_LETTER_DOTLESS_I = chr(305)
LATIN_CAPITAL_LIGATURE_IJ = chr(306)
LATIN_SMALL_LIGATURE_IJ = chr(307)
LATIN_CAPITAL_LETTER_J_WITH_CIRCUMFLEX = chr(308)
LATIN_SMALL_LETTER_J_WITH_CIRCUMFLEX = chr(309)
LATIN_CAPITAL_LETTER_K_WITH_CEDILLA = chr(310)
LATIN_SMALL_LETTER_K_WITH_CEDILLA = chr(311)
LATIN_SMALL_LETTER_KRA = chr(312)
LATIN_CAPITAL_LETTER_L_WITH_ACUTE = chr(313)
LATIN_SMALL_LETTER_L_WITH_ACUTE = chr(314)
LATIN_CAPITAL_LETTER_L_WITH_CEDILLA = chr(315)
LATIN_SMALL_LETTER_L_WITH_CEDILLA = chr(316)
LATIN_CAPITAL_LETTER_L_WITH_CARON = chr(317)
LATIN_SMALL_LETTER_L_WITH_CARON = chr(318)
LATIN_CAPITAL_LETTER_L_WITH_MIDDLE_DOT = chr(319)
LATIN_SMALL_LETTER_L_WITH_MIDDLE_DOT = chr(320)
LATIN_CAPITAL_LETTER_L_WITH_STROKE = chr(321)
LATIN_SMALL_LETTER_L_WITH_STROKE = chr(322)
LATIN_CAPITAL_LETTER_N_WITH_ACUTE = chr(323)
LATIN_SMALL_LETTER_N_WITH_ACUTE = chr(324)
LATIN_CAPITAL_LETTER_N_WITH_CEDILLA = chr(325)
LATIN_SMALL_LETTER_N_WITH_CEDILLA = chr(326)
LATIN_CAPITAL_LETTER_N_WITH_CARON = chr(327)
LATIN_SMALL_LETTER_N_WITH_CARON = chr(328)
LATIN_SMALL_LETTER_N_PRECEDED_BY_APOSTROPHE = chr(329)
LATIN_CAPITAL_LETTER_ENG = chr(330)
LATIN_SMALL_LETTER_ENG = chr(331)
LATIN_CAPITAL_LETTER_O_WITH_MACRON = chr(332)
LATIN_SMALL_LETTER_O_WITH_MACRON = chr(333)
LATIN_CAPITAL_LETTER_O_WITH_BREVE = chr(334)
LATIN_SMALL_LETTER_O_WITH_BREVE = chr(335)
LATIN_CAPITAL_LETTER_O_WITH_DOUBLE_ACUTE = chr(336)
LATIN_SMALL_LETTER_O_WITH_DOUBLE_ACUTE = chr(337)
LATIN_CAPITAL_LIGATURE_OE = chr(338)
LATIN_SMALL_LIGATURE_OE = chr(339)
LATIN_CAPITAL_LETTER_R_WITH_ACUTE = chr(340)
LATIN_SMALL_LETTER_R_WITH_ACUTE = chr(341)
LATIN_CAPITAL_LETTER_R_WITH_CEDILLA = chr(342)
LATIN_SMALL_LETTER_R_WITH_CEDILLA = chr(343)
LATIN_CAPITAL_LETTER_R_WITH_CARON = chr(344)
LATIN_SMALL_LETTER_R_WITH_CARON = chr(345)
LATIN_CAPITAL_LETTER_S_WITH_ACUTE = chr(346)
LATIN_SMALL_LETTER_S_WITH_ACUTE = chr(347)
LATIN_CAPITAL_LETTER_S_WITH_CIRCUMFLEX = chr(348)
LATIN_SMALL_LETTER_S_WITH_CIRCUMFLEX = chr(349)
LATIN_CAPITAL_LETTER_S_WITH_CEDILLA = chr(350)
LATIN_SMALL_LETTER_S_WITH_CEDILLA = chr(351)
LATIN_CAPITAL_LETTER_S_WITH_CARON = chr(352)
LATIN_SMALL_LETTER_S_WITH_CARON = chr(353)
LATIN_CAPITAL_LETTER_T_WITH_CEDILLA = chr(354)
LATIN_SMALL_LETTER_T_WITH_CEDILLA = chr(355)
LATIN_CAPITAL_LETTER_T_WITH_CARON = chr(356)
LATIN_SMALL_LETTER_T_WITH_CARON = chr(357)
LATIN_CAPITAL_LETTER_T_WITH_STROKE = chr(358)
LATIN_SMALL_LETTER_T_WITH_STROKE = chr(359)
LATIN_CAPITAL_LETTER_U_WITH_TILDE = chr(360)
LATIN_SMALL_LETTER_U_WITH_TILDE = chr(361)
LATIN_CAPITAL_LETTER_U_WITH_MACRON = chr(362)
LATIN_SMALL_LETTER_U_WITH_MACRON = chr(363)
LATIN_CAPITAL_LETTER_U_WITH_BREVE = chr(364)
LATIN_SMALL_LETTER_U_WITH_BREVE = chr(365)
LATIN_CAPITAL_LETTER_U_WITH_RING_ABOVE = chr(366)
LATIN_SMALL_LETTER_U_WITH_RING_ABOVE = chr(367)
LATIN_CAPITAL_LETTER_U_WITH_DOUBLE_ACUTE = chr(368)
LATIN_SMALL_LETTER_U_WITH_DOUBLE_ACUTE = chr(369)
LATIN_CAPITAL_LETTER_U_WITH_OGONEK = chr(370)
LATIN_SMALL_LETTER_U_WITH_OGONEK = chr(371)
LATIN_CAPITAL_LETTER_W_WITH_CIRCUMFLEX = chr(372)
LATIN_SMALL_LETTER_W_WITH_CIRCUMFLEX = chr(373)
LATIN_CAPITAL_LETTER_Y_WITH_CIRCUMFLEX = chr(374)
LATIN_SMALL_LETTER_Y_WITH_CIRCUMFLEX = chr(375)
LATIN_CAPITAL_LETTER_Y_WITH_DIAERESIS = chr(376)
LATIN_CAPITAL_LETTER_Z_WITH_ACUTE = chr(377)
LATIN_SMALL_LETTER_Z_WITH_ACUTE = chr(378)
LATIN_CAPITAL_LETTER_Z_WITH_DOT_ABOVE = chr(379)
LATIN_SMALL_LETTER_Z_WITH_DOT_ABOVE = chr(380)
LATIN_CAPITAL_LETTER_Z_WITH_CARON = chr(381)
LATIN_SMALL_LETTER_Z_WITH_CARON = chr(382)
LATIN_SMALL_LETTER_LONG_S = chr(383)
LATIN_SMALL_LETTER_B_WITH_STROKE = chr(384)
LATIN_CAPITAL_LETTER_B_WITH_HOOK = chr(385)
LATIN_CAPITAL_LETTER_B_WITH_TOPBAR = chr(386)
LATIN_SMALL_LETTER_B_WITH_TOPBAR = chr(387)
LATIN_CAPITAL_LETTER_TONE_SIX = chr(388)
LATIN_SMALL_LETTER_TONE_SIX = chr(389)
LATIN_CAPITAL_LETTER_OPEN_O = chr(390)
LATIN_CAPITAL_LETTER_C_WITH_HOOK = chr(391)
LATIN_SMALL_LETTER_C_WITH_HOOK = chr(392)
LATIN_CAPITAL_LETTER_AFRICAN_D = chr(393)
LATIN_CAPITAL_LETTER_D_WITH_HOOK = chr(394)
LATIN_CAPITAL_LETTER_D_WITH_TOPBAR = chr(395)
LATIN_SMALL_LETTER_D_WITH_TOPBAR = chr(396)
LATIN_SMALL_LETTER_TURNED_DELTA = chr(397)
LATIN_CAPITAL_LETTER_REVERSED_E = chr(398)
LATIN_CAPITAL_LETTER_SCHWA = chr(399)
LATIN_CAPITAL_LETTER_OPEN_E = chr(400)
LATIN_CAPITAL_LETTER_F_WITH_HOOK = chr(401)
LATIN_SMALL_LETTER_F_WITH_HOOK = chr(402)
LATIN_CAPITAL_LETTER_G_WITH_HOOK = chr(403)
LATIN_CAPITAL_LETTER_GAMMA = chr(404)
LATIN_SMALL_LETTER_HV = chr(405)
LATIN_CAPITAL_LETTER_IOTA = chr(406)
LATIN_CAPITAL_LETTER_I_WITH_STROKE = chr(407)
LATIN_CAPITAL_LETTER_K_WITH_HOOK = chr(408)
LATIN_SMALL_LETTER_K_WITH_HOOK = chr(409)
LATIN_SMALL_LETTER_L_WITH_BAR = chr(410)
LATIN_SMALL_LETTER_LAMBDA_WITH_STROKE = chr(411)
LATIN_CAPITAL_LETTER_TURNED_M = chr(412)
LATIN_CAPITAL_LETTER_N_WITH_LEFT_HOOK = chr(413)
LATIN_SMALL_LETTER_N_WITH_LONG_RIGHT_LEG = chr(414)
LATIN_CAPITAL_LETTER_O_WITH_MIDDLE_TILDE = chr(415)
LATIN_CAPITAL_LETTER_O_WITH_HORN = chr(416)
LATIN_SMALL_LETTER_O_WITH_HORN = chr(417)
LATIN_CAPITAL_LETTER_OI = chr(418)
LATIN_SMALL_LETTER_OI = chr(419)
LATIN_CAPITAL_LETTER_P_WITH_HOOK = chr(420)
LATIN_SMALL_LETTER_P_WITH_HOOK = chr(421)
LATIN_LETTER_YR = chr(422)
LATIN_CAPITAL_LETTER_TONE_TWO = chr(423)
LATIN_SMALL_LETTER_TONE_TWO = chr(424)
LATIN_CAPITAL_LETTER_ESH = chr(425)
LATIN_LETTER_REVERSED_ESH_LOOP = chr(426)
LATIN_SMALL_LETTER_T_WITH_PALATAL_HOOK = chr(427)
LATIN_CAPITAL_LETTER_T_WITH_HOOK = chr(428)
LATIN_SMALL_LETTER_T_WITH_HOOK = chr(429)
LATIN_CAPITAL_LETTER_T_WITH_RETROFLEX_HOOK = chr(430)
LATIN_CAPITAL_LETTER_U_WITH_HORN = chr(431)
LATIN_SMALL_LETTER_U_WITH_HORN = chr(432)
LATIN_CAPITAL_LETTER_UPSILON = chr(433)
LATIN_CAPITAL_LETTER_V_WITH_HOOK = chr(434)
LATIN_CAPITAL_LETTER_Y_WITH_HOOK = chr(435)
LATIN_SMALL_LETTER_Y_WITH_HOOK = chr(436)
LATIN_CAPITAL_LETTER_Z_WITH_STROKE = chr(437)
LATIN_SMALL_LETTER_Z_WITH_STROKE = chr(438)
LATIN_CAPITAL_LETTER_EZH = chr(439)
LATIN_CAPITAL_LETTER_EZH_REVERSED = chr(440)
LATIN_SMALL_LETTER_EZH_REVERSED = chr(441)
LATIN_SMALL_LETTER_EZH_WITH_TAIL = chr(442)
LATIN_LETTER_TWO_WITH_STROKE = chr(443)
LATIN_CAPITAL_LETTER_TONE_FIVE = chr(444)
LATIN_SMALL_LETTER_TONE_FIVE = chr(445)
LATIN_LETTER_INVERTED_GLOTTAL_STOP_WITH_STROKE = chr(446)
LATIN_LETTER_WYNN = chr(447)
LATIN_LETTER_DENTAL_CLICK = chr(448)
LATIN_LETTER_LATERAL_CLICK = chr(449)
LATIN_LETTER_ALVEOLAR_CLICK = chr(450)
LATIN_LETTER_RETROFLEX_CLICK = chr(451)
LATIN_CAPITAL_LETTER_DZ_WITH_CARON = chr(452)
LATIN_CAPITAL_LETTER_D_WITH_SMALL_LETTER_Z_WITH_CARON = chr(453)
LATIN_SMALL_LETTER_DZ_WITH_CARON = chr(454)
LATIN_CAPITAL_LETTER_LJ = chr(455)
LATIN_CAPITAL_LETTER_L_WITH_SMALL_LETTER_J = chr(456)
LATIN_SMALL_LETTER_LJ = chr(457)
LATIN_CAPITAL_LETTER_NJ = chr(458)
LATIN_CAPITAL_LETTER_N_WITH_SMALL_LETTER_J = chr(459)
LATIN_SMALL_LETTER_NJ = chr(460)
LATIN_CAPITAL_LETTER_A_WITH_CARON = chr(461)
LATIN_SMALL_LETTER_A_WITH_CARON = chr(462)
LATIN_CAPITAL_LETTER_I_WITH_CARON = chr(463)
LATIN_SMALL_LETTER_I_WITH_CARON = chr(464)
LATIN_CAPITAL_LETTER_O_WITH_CARON = chr(465)
LATIN_SMALL_LETTER_O_WITH_CARON = chr(466)
LATIN_CAPITAL_LETTER_U_WITH_CARON = chr(467)
LATIN_SMALL_LETTER_U_WITH_CARON = chr(468)
LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS_AND_MACRON = chr(469)
LATIN_SMALL_LETTER_U_WITH_DIAERESIS_AND_MACRON = chr(470)
LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS_AND_ACUTE = chr(471)
LATIN_SMALL_LETTER_U_WITH_DIAERESIS_AND_ACUTE = chr(472)
LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS_AND_CARON = chr(473)
LATIN_SMALL_LETTER_U_WITH_DIAERESIS_AND_CARON = chr(474)
LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS_AND_GRAVE = chr(475)
LATIN_SMALL_LETTER_U_WITH_DIAERESIS_AND_GRAVE = chr(476)
LATIN_SMALL_LETTER_TURNED_E = chr(477)
LATIN_CAPITAL_LETTER_A_WITH_DIAERESIS_AND_MACRON = chr(478)
LATIN_SMALL_LETTER_A_WITH_DIAERESIS_AND_MACRON = chr(479)
LATIN_CAPITAL_LETTER_A_WITH_DOT_ABOVE_AND_MACRON = chr(480)
LATIN_SMALL_LETTER_A_WITH_DOT_ABOVE_AND_MACRON = chr(481)
LATIN_CAPITAL_LETTER_AE_WITH_MACRON = chr(482)
LATIN_SMALL_LETTER_AE_WITH_MACRON = chr(483)
LATIN_CAPITAL_LETTER_G_WITH_STROKE = chr(484)
LATIN_SMALL_LETTER_G_WITH_STROKE = chr(485)
LATIN_CAPITAL_LETTER_G_WITH_CARON = chr(486)
LATIN_SMALL_LETTER_G_WITH_CARON = chr(487)
LATIN_CAPITAL_LETTER_K_WITH_CARON = chr(488)
LATIN_SMALL_LETTER_K_WITH_CARON = chr(489)
LATIN_CAPITAL_LETTER_O_WITH_OGONEK = chr(490)
LATIN_SMALL_LETTER_O_WITH_OGONEK = chr(491)
LATIN_CAPITAL_LETTER_O_WITH_OGONEK_AND_MACRON = chr(492)
LATIN_SMALL_LETTER_O_WITH_OGONEK_AND_MACRON = chr(493)
LATIN_CAPITAL_LETTER_EZH_WITH_CARON = chr(494)
LATIN_SMALL_LETTER_EZH_WITH_CARON = chr(495)
LATIN_SMALL_LETTER_J_WITH_CARON = chr(496)
LATIN_CAPITAL_LETTER_DZ = chr(497)
LATIN_CAPITAL_LETTER_D_WITH_SMALL_LETTER_Z = chr(498)
LATIN_SMALL_LETTER_DZ = chr(499)
LATIN_CAPITAL_LETTER_G_WITH_ACUTE = chr(500)
LATIN_SMALL_LETTER_G_WITH_ACUTE = chr(501)
LATIN_CAPITAL_LETTER_HWAIR = chr(502)
LATIN_CAPITAL_LETTER_WYNN = chr(503)
LATIN_CAPITAL_LETTER_N_WITH_GRAVE = chr(504)
LATIN_SMALL_LETTER_N_WITH_GRAVE = chr(505)
LATIN_CAPITAL_LETTER_A_WITH_RING_ABOVE_AND_ACUTE = chr(506)
LATIN_SMALL_LETTER_A_WITH_RING_ABOVE_AND_ACUTE = chr(507)
LATIN_CAPITAL_LETTER_AE_WITH_ACUTE = chr(508)
LATIN_SMALL_LETTER_AE_WITH_ACUTE = chr(509)
LATIN_CAPITAL_LETTER_O_WITH_STROKE_AND_ACUTE = chr(510)
LATIN_SMALL_LETTER_O_WITH_STROKE_AND_ACUTE = chr(511)
LATIN_CAPITAL_LETTER_A_WITH_DOUBLE_GRAVE = chr(512)
LATIN_SMALL_LETTER_A_WITH_DOUBLE_GRAVE = chr(513)
LATIN_CAPITAL_LETTER_A_WITH_INVERTED_BREVE = chr(514)
LATIN_SMALL_LETTER_A_WITH_INVERTED_BREVE = chr(515)
LATIN_CAPITAL_LETTER_E_WITH_DOUBLE_GRAVE = chr(516)
LATIN_SMALL_LETTER_E_WITH_DOUBLE_GRAVE = chr(517)
LATIN_CAPITAL_LETTER_E_WITH_INVERTED_BREVE = chr(518)
LATIN_SMALL_LETTER_E_WITH_INVERTED_BREVE = chr(519)
LATIN_CAPITAL_LETTER_I_WITH_DOUBLE_GRAVE = chr(520)
LATIN_SMALL_LETTER_I_WITH_DOUBLE_GRAVE = chr(521)
LATIN_CAPITAL_LETTER_I_WITH_INVERTED_BREVE = chr(522)
LATIN_SMALL_LETTER_I_WITH_INVERTED_BREVE = chr(523)
LATIN_CAPITAL_LETTER_O_WITH_DOUBLE_GRAVE = chr(524)
LATIN_SMALL_LETTER_O_WITH_DOUBLE_GRAVE = chr(525)
LATIN_CAPITAL_LETTER_O_WITH_INVERTED_BREVE = chr(526)
LATIN_SMALL_LETTER_O_WITH_INVERTED_BREVE = chr(527)
LATIN_CAPITAL_LETTER_R_WITH_DOUBLE_GRAVE = chr(528)
LATIN_SMALL_LETTER_R_WITH_DOUBLE_GRAVE = chr(529)
LATIN_CAPITAL_LETTER_R_WITH_INVERTED_BREVE = chr(530)
LATIN_SMALL_LETTER_R_WITH_INVERTED_BREVE = chr(531)
LATIN_CAPITAL_LETTER_U_WITH_DOUBLE_GRAVE = chr(532)
LATIN_SMALL_LETTER_U_WITH_DOUBLE_GRAVE = chr(533)
LATIN_CAPITAL_LETTER_U_WITH_INVERTED_BREVE = chr(534)
LATIN_SMALL_LETTER_U_WITH_INVERTED_BREVE = chr(535)
LATIN_CAPITAL_LETTER_S_WITH_COMMA_BELOW = chr(536)
LATIN_SMALL_LETTER_S_WITH_COMMA_BELOW = chr(537)
LATIN_CAPITAL_LETTER_T_WITH_COMMA_BELOW = chr(538)
LATIN_SMALL_LETTER_T_WITH_COMMA_BELOW = chr(539)
LATIN_CAPITAL_LETTER_YOGH = chr(540)
LATIN_SMALL_LETTER_YOGH = chr(541)
LATIN_CAPITAL_LETTER_H_WITH_CARON = chr(542)
LATIN_SMALL_LETTER_H_WITH_CARON = chr(543)
LATIN_CAPITAL_LETTER_N_WITH_LONG_RIGHT_LEG = chr(544)
LATIN_SMALL_LETTER_D_WITH_CURL = chr(545)
LATIN_CAPITAL_LETTER_OU = chr(546)
LATIN_SMALL_LETTER_OU = chr(547)
LATIN_CAPITAL_LETTER_Z_WITH_HOOK = chr(548)
LATIN_SMALL_LETTER_Z_WITH_HOOK = chr(549)
LATIN_CAPITAL_LETTER_A_WITH_DOT_ABOVE = chr(550)
LATIN_SMALL_LETTER_A_WITH_DOT_ABOVE = chr(551)
LATIN_CAPITAL_LETTER_E_WITH_CEDILLA = chr(552)
LATIN_SMALL_LETTER_E_WITH_CEDILLA = chr(553)
LATIN_CAPITAL_LETTER_O_WITH_DIAERESIS_AND_MACRON = chr(554)
LATIN_SMALL_LETTER_O_WITH_DIAERESIS_AND_MACRON = chr(555)
LATIN_CAPITAL_LETTER_O_WITH_TILDE_AND_MACRON = chr(556)
LATIN_SMALL_LETTER_O_WITH_TILDE_AND_MACRON = chr(557)
LATIN_CAPITAL_LETTER_O_WITH_DOT_ABOVE = chr(558)
LATIN_SMALL_LETTER_O_WITH_DOT_ABOVE = chr(559)
LATIN_CAPITAL_LETTER_O_WITH_DOT_ABOVE_AND_MACRON = chr(560)
LATIN_SMALL_LETTER_O_WITH_DOT_ABOVE_AND_MACRON = chr(561)
LATIN_CAPITAL_LETTER_Y_WITH_MACRON = chr(562)
LATIN_SMALL_LETTER_Y_WITH_MACRON = chr(563)
LATIN_SMALL_LETTER_L_WITH_CURL = chr(564)
LATIN_SMALL_LETTER_N_WITH_CURL = chr(565)
LATIN_SMALL_LETTER_T_WITH_CURL = chr(566)
LATIN_SMALL_LETTER_DOTLESS_J = chr(567)
LATIN_SMALL_LETTER_DB_DIGRAPH = chr(568)
LATIN_SMALL_LETTER_QP_DIGRAPH = chr(569)
LATIN_CAPITAL_LETTER_A_WITH_STROKE = chr(570)
LATIN_CAPITAL_LETTER_C_WITH_STROKE = chr(571)
LATIN_SMALL_LETTER_C_WITH_STROKE = chr(572)
LATIN_CAPITAL_LETTER_L_WITH_BAR = chr(573)
LATIN_CAPITAL_LETTER_T_WITH_DIAGONAL_STROKE = chr(574)
LATIN_SMALL_LETTER_S_WITH_SWASH_TAIL = chr(575)
LATIN_SMALL_LETTER_Z_WITH_SWASH_TAIL = chr(576)
LATIN_CAPITAL_LETTER_GLOTTAL_STOP = chr(577)
LATIN_SMALL_LETTER_GLOTTAL_STOP = chr(578)
LATIN_CAPITAL_LETTER_B_WITH_STROKE = chr(579)
LATIN_CAPITAL_LETTER_U_BAR = chr(580)
LATIN_CAPITAL_LETTER_TURNED_V = chr(581)
LATIN_CAPITAL_LETTER_E_WITH_STROKE = chr(582)
LATIN_SMALL_LETTER_E_WITH_STROKE = chr(583)
LATIN_CAPITAL_LETTER_J_WITH_STROKE = chr(584)
LATIN_SMALL_LETTER_J_WITH_STROKE = chr(585)
LATIN_CAPITAL_LETTER_SMALL_Q_WITH_HOOK_TAIL = chr(586)
LATIN_SMALL_LETTER_Q_WITH_HOOK_TAIL = chr(587)
LATIN_CAPITAL_LETTER_R_WITH_STROKE = chr(588)
LATIN_SMALL_LETTER_R_WITH_STROKE = chr(589)
LATIN_CAPITAL_LETTER_Y_WITH_STROKE = chr(590)
LATIN_SMALL_LETTER_Y_WITH_STROKE = chr(591)
LATIN_SMALL_LETTER_TURNED_A = chr(592)
LATIN_SMALL_LETTER_ALPHA = chr(593)
LATIN_SMALL_LETTER_TURNED_ALPHA = chr(594)
LATIN_SMALL_LETTER_B_WITH_HOOK = chr(595)
LATIN_SMALL_LETTER_OPEN_O = chr(596)
LATIN_SMALL_LETTER_C_WITH_CURL = chr(597)
LATIN_SMALL_LETTER_D_WITH_TAIL = chr(598)
LATIN_SMALL_LETTER_D_WITH_HOOK = chr(599)
LATIN_SMALL_LETTER_REVERSED_E = chr(600)
LATIN_SMALL_LETTER_SCHWA = chr(601)
LATIN_SMALL_LETTER_SCHWA_WITH_HOOK = chr(602)
LATIN_SMALL_LETTER_OPEN_E = chr(603)
LATIN_SMALL_LETTER_REVERSED_OPEN_E = chr(604)
LATIN_SMALL_LETTER_REVERSED_OPEN_E_WITH_HOOK = chr(605)
LATIN_SMALL_LETTER_CLOSED_REVERSED_OPEN_E = chr(606)
LATIN_SMALL_LETTER_DOTLESS_J_WITH_STROKE = chr(607)
LATIN_SMALL_LETTER_G_WITH_HOOK = chr(608)
LATIN_SMALL_LETTER_SCRIPT_G = chr(609)
LATIN_LETTER_SMALL_CAPITAL_G = chr(610)
LATIN_SMALL_LETTER_GAMMA = chr(611)
LATIN_SMALL_LETTER_RAMS_HORN = chr(612)
LATIN_SMALL_LETTER_TURNED_H = chr(613)
LATIN_SMALL_LETTER_H_WITH_HOOK = chr(614)
LATIN_SMALL_LETTER_HENG_WITH_HOOK = chr(615)
LATIN_SMALL_LETTER_I_WITH_STROKE = chr(616)
LATIN_SMALL_LETTER_IOTA = chr(617)
LATIN_LETTER_SMALL_CAPITAL_I = chr(618)
LATIN_SMALL_LETTER_L_WITH_MIDDLE_TILDE = chr(619)
LATIN_SMALL_LETTER_L_WITH_BELT = chr(620)
LATIN_SMALL_LETTER_L_WITH_RETROFLEX_HOOK = chr(621)
LATIN_SMALL_LETTER_LEZH = chr(622)
LATIN_SMALL_LETTER_TURNED_M = chr(623)
LATIN_SMALL_LETTER_TURNED_M_WITH_LONG_LEG = chr(624)
LATIN_SMALL_LETTER_M_WITH_HOOK = chr(625)
LATIN_SMALL_LETTER_N_WITH_LEFT_HOOK = chr(626)
LATIN_SMALL_LETTER_N_WITH_RETROFLEX_HOOK = chr(627)
LATIN_LETTER_SMALL_CAPITAL_N = chr(628)
LATIN_SMALL_LETTER_BARRED_O = chr(629)
LATIN_LETTER_SMALL_CAPITAL_OE = chr(630)
LATIN_SMALL_LETTER_CLOSED_OMEGA = chr(631)
LATIN_SMALL_LETTER_PHI = chr(632)
LATIN_SMALL_LETTER_TURNED_R = chr(633)
LATIN_SMALL_LETTER_TURNED_R_WITH_LONG_LEG = chr(634)
LATIN_SMALL_LETTER_TURNED_R_WITH_HOOK = chr(635)
LATIN_SMALL_LETTER_R_WITH_LONG_LEG = chr(636)
LATIN_SMALL_LETTER_R_WITH_TAIL = chr(637)
LATIN_SMALL_LETTER_R_WITH_FISHHOOK = chr(638)
LATIN_SMALL_LETTER_REVERSED_R_WITH_FISHHOOK = chr(639)
LATIN_LETTER_SMALL_CAPITAL_R = chr(640)
LATIN_LETTER_SMALL_CAPITAL_INVERTED_R = chr(641)
LATIN_SMALL_LETTER_S_WITH_HOOK = chr(642)
LATIN_SMALL_LETTER_ESH = chr(643)
LATIN_SMALL_LETTER_DOTLESS_J_WITH_STROKE_AND_HOOK = chr(644)
LATIN_SMALL_LETTER_SQUAT_REVERSED_ESH = chr(645)
LATIN_SMALL_LETTER_ESH_WITH_CURL = chr(646)
LATIN_SMALL_LETTER_TURNED_T = chr(647)
LATIN_SMALL_LETTER_T_WITH_RETROFLEX_HOOK = chr(648)
LATIN_SMALL_LETTER_U_BAR = chr(649)
LATIN_SMALL_LETTER_UPSILON = chr(650)
LATIN_SMALL_LETTER_V_WITH_HOOK = chr(651)
LATIN_SMALL_LETTER_TURNED_V = chr(652)
LATIN_SMALL_LETTER_TURNED_W = chr(653)
LATIN_SMALL_LETTER_TURNED_Y = chr(654)
LATIN_LETTER_SMALL_CAPITAL_Y = chr(655)
LATIN_SMALL_LETTER_Z_WITH_RETROFLEX_HOOK = chr(656)
LATIN_SMALL_LETTER_Z_WITH_CURL = chr(657)
LATIN_SMALL_LETTER_EZH = chr(658)
LATIN_SMALL_LETTER_EZH_WITH_CURL = chr(659)
LATIN_LETTER_GLOTTAL_STOP = chr(660)
LATIN_LETTER_PHARYNGEAL_VOICED_FRICATIVE = chr(661)
LATIN_LETTER_INVERTED_GLOTTAL_STOP = chr(662)
LATIN_LETTER_STRETCHED_C = chr(663)
LATIN_LETTER_BILABIAL_CLICK = chr(664)
LATIN_LETTER_SMALL_CAPITAL_B = chr(665)
LATIN_SMALL_LETTER_CLOSED_OPEN_E = chr(666)
LATIN_LETTER_SMALL_CAPITAL_G_WITH_HOOK = chr(667)
LATIN_LETTER_SMALL_CAPITAL_H = chr(668)
LATIN_SMALL_LETTER_J_WITH_CROSSED_TAIL = chr(669)
LATIN_SMALL_LETTER_TURNED_K = chr(670)
LATIN_LETTER_SMALL_CAPITAL_L = chr(671)
LATIN_SMALL_LETTER_Q_WITH_HOOK = chr(672)
LATIN_LETTER_GLOTTAL_STOP_WITH_STROKE = chr(673)
LATIN_LETTER_REVERSED_GLOTTAL_STOP_WITH_STROKE = chr(674)
LATIN_SMALL_LETTER_DZ_DIGRAPH = chr(675)
LATIN_SMALL_LETTER_DEZH_DIGRAPH = chr(676)
LATIN_SMALL_LETTER_DZ_DIGRAPH_WITH_CURL = chr(677)
LATIN_SMALL_LETTER_TS_DIGRAPH = chr(678)
LATIN_SMALL_LETTER_TESH_DIGRAPH = chr(679)
LATIN_SMALL_LETTER_TC_DIGRAPH_WITH_CURL = chr(680)
LATIN_SMALL_LETTER_FENG_DIGRAPH = chr(681)
LATIN_SMALL_LETTER_LS_DIGRAPH = chr(682)
LATIN_SMALL_LETTER_LZ_DIGRAPH = chr(683)
LATIN_LETTER_BILABIAL_PERCUSSIVE = chr(684)
LATIN_LETTER_BIDENTAL_PERCUSSIVE = chr(685)
LATIN_SMALL_LETTER_TURNED_H_WITH_FISHHOOK = chr(686)
LATIN_SMALL_LETTER_TURNED_H_WITH_FISHHOOK_AND_TAIL = chr(687)
MODIFIER_LETTER_SMALL_H = chr(688)
MODIFIER_LETTER_SMALL_H_WITH_HOOK = chr(689)
MODIFIER_LETTER_SMALL_J = chr(690)
MODIFIER_LETTER_SMALL_R = chr(691)
MODIFIER_LETTER_SMALL_TURNED_R = chr(692)
MODIFIER_LETTER_SMALL_TURNED_R_WITH_HOOK = chr(693)
MODIFIER_LETTER_SMALL_CAPITAL_INVERTED_R = chr(694)
MODIFIER_LETTER_SMALL_W = chr(695)
MODIFIER_LETTER_SMALL_Y = chr(696)
MODIFIER_LETTER_PRIME = chr(697)
MODIFIER_LETTER_DOUBLE_PRIME = chr(698)
MODIFIER_LETTER_TURNED_COMMA = chr(699)
MODIFIER_LETTER_APOSTROPHE = chr(700)
MODIFIER_LETTER_REVERSED_COMMA = chr(701)
MODIFIER_LETTER_RIGHT_HALF_RING = chr(702)
MODIFIER_LETTER_LEFT_HALF_RING = chr(703)
MODIFIER_LETTER_GLOTTAL_STOP = chr(704)
MODIFIER_LETTER_REVERSED_GLOTTAL_STOP = chr(705)
MODIFIER_LETTER_LEFT_ARROWHEAD = chr(706)
MODIFIER_LETTER_RIGHT_ARROWHEAD = chr(707)
MODIFIER_LETTER_UP_ARROWHEAD = chr(708)
MODIFIER_LETTER_DOWN_ARROWHEAD = chr(709)
MODIFIER_LETTER_CIRCUMFLEX_ACCENT = chr(710)
CARON = chr(711)
MODIFIER_LETTER_VERTICAL_LINE = chr(712)
MODIFIER_LETTER_MACRON = chr(713)
MODIFIER_LETTER_ACUTE_ACCENT = chr(714)
MODIFIER_LETTER_GRAVE_ACCENT = chr(715)
MODIFIER_LETTER_LOW_VERTICAL_LINE = chr(716)
MODIFIER_LETTER_LOW_MACRON = chr(717)
MODIFIER_LETTER_LOW_GRAVE_ACCENT = chr(718)
MODIFIER_LETTER_LOW_ACUTE_ACCENT = chr(719)
MODIFIER_LETTER_TRIANGULAR_COLON = chr(720)
MODIFIER_LETTER_HALF_TRIANGULAR_COLON = chr(721)
MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING = chr(722)
MODIFIER_LETTER_CENTRED_LEFT_HALF_RING = chr(723)
MODIFIER_LETTER_UP_TACK = chr(724)
MODIFIER_LETTER_DOWN_TACK = chr(725)
MODIFIER_LETTER_PLUS_SIGN = chr(726)
MODIFIER_LETTER_MINUS_SIGN = chr(727)
BREVE = chr(728)
DOT_ABOVE = chr(729)
RING_ABOVE = chr(730)
OGONEK = chr(731)
SMALL_TILDE = chr(732)
DOUBLE_ACUTE_ACCENT = chr(733)
MODIFIER_LETTER_RHOTIC_HOOK = chr(734)
MODIFIER_LETTER_CROSS_ACCENT = chr(735)
MODIFIER_LETTER_SMALL_GAMMA = chr(736)
MODIFIER_LETTER_SMALL_L = chr(737)
MODIFIER_LETTER_SMALL_S = chr(738)
MODIFIER_LETTER_SMALL_X = chr(739)
MODIFIER_LETTER_SMALL_REVERSED_GLOTTAL_STOP = chr(740)
MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR = chr(741)
MODIFIER_LETTER_HIGH_TONE_BAR = chr(742)
MODIFIER_LETTER_MID_TONE_BAR = chr(743)
MODIFIER_LETTER_LOW_TONE_BAR = chr(744)
MODIFIER_LETTER_EXTRA_LOW_TONE_BAR = chr(745)
MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK = chr(746)
MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK = chr(747)
MODIFIER_LETTER_VOICING = chr(748)
MODIFIER_LETTER_UNASPIRATED = chr(749)
MODIFIER_LETTER_DOUBLE_APOSTROPHE = chr(750)
MODIFIER_LETTER_LOW_DOWN_ARROWHEAD = chr(751)
MODIFIER_LETTER_LOW_UP_ARROWHEAD = chr(752)
MODIFIER_LETTER_LOW_LEFT_ARROWHEAD = chr(753)
MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD = chr(754)
MODIFIER_LETTER_LOW_RING = chr(755)
MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT = chr(756)
MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT = chr(757)
MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT = chr(758)
MODIFIER_LETTER_LOW_TILDE = chr(759)
MODIFIER_LETTER_RAISED_COLON = chr(760)
MODIFIER_LETTER_BEGIN_HIGH_TONE = chr(761)
MODIFIER_LETTER_END_HIGH_TONE = chr(762)
MODIFIER_LETTER_BEGIN_LOW_TONE = chr(763)
MODIFIER_LETTER_END_LOW_TONE = chr(764)
MODIFIER_LETTER_SHELF = chr(765)
MODIFIER_LETTER_OPEN_SHELF = chr(766)
MODIFIER_LETTER_LOW_LEFT_ARROW = chr(767)
COMBINING_GRAVE_ACCENT = chr(768)
COMBINING_ACUTE_ACCENT = chr(769)
COMBINING_CIRCUMFLEX_ACCENT = chr(770)
COMBINING_TILDE = chr(771)
COMBINING_MACRON = chr(772)
COMBINING_OVERLINE = chr(773)
COMBINING_BREVE = chr(774)
COMBINING_DOT_ABOVE = chr(775)
COMBINING_DIAERESIS = chr(776)
COMBINING_HOOK_ABOVE = chr(777)
COMBINING_RING_ABOVE = chr(778)
COMBINING_DOUBLE_ACUTE_ACCENT = chr(779)
COMBINING_CARON = chr(780)
COMBINING_VERTICAL_LINE_ABOVE = chr(781)
COMBINING_DOUBLE_VERTICAL_LINE_ABOVE = chr(782)
COMBINING_DOUBLE_GRAVE_ACCENT = chr(783)
COMBINING_CANDRABINDU = chr(784)
COMBINING_INVERTED_BREVE = chr(785)
COMBINING_TURNED_COMMA_ABOVE = chr(786)
COMBINING_COMMA_ABOVE = chr(787)
COMBINING_REVERSED_COMMA_ABOVE = chr(788)
COMBINING_COMMA_ABOVE_RIGHT = chr(789)
COMBINING_GRAVE_ACCENT_BELOW = chr(790)
COMBINING_ACUTE_ACCENT_BELOW = chr(791)
COMBINING_LEFT_TACK_BELOW = chr(792)
COMBINING_RIGHT_TACK_BELOW = chr(793)
COMBINING_LEFT_ANGLE_ABOVE = chr(794)
COMBINING_HORN = chr(795)
COMBINING_LEFT_HALF_RING_BELOW = chr(796)
COMBINING_UP_TACK_BELOW = chr(797)
COMBINING_DOWN_TACK_BELOW = chr(798)
COMBINING_PLUS_SIGN_BELOW = chr(799)
COMBINING_MINUS_SIGN_BELOW = chr(800)
COMBINING_PALATALIZED_HOOK_BELOW = chr(801)
COMBINING_RETROFLEX_HOOK_BELOW = chr(802)
COMBINING_DOT_BELOW = chr(803)
COMBINING_DIAERESIS_BELOW = chr(804)
COMBINING_RING_BELOW = chr(805)
COMBINING_COMMA_BELOW = chr(806)
COMBINING_CEDILLA = chr(807)
COMBINING_OGONEK = chr(808)
COMBINING_VERTICAL_LINE_BELOW = chr(809)
COMBINING_BRIDGE_BELOW = chr(810)
COMBINING_INVERTED_DOUBLE_ARCH_BELOW = chr(811)
COMBINING_CARON_BELOW = chr(812)
COMBINING_CIRCUMFLEX_ACCENT_BELOW = chr(813)
COMBINING_BREVE_BELOW = chr(814)
COMBINING_INVERTED_BREVE_BELOW = chr(815)
COMBINING_TILDE_BELOW = chr(816)
COMBINING_MACRON_BELOW = chr(817)
COMBINING_LOW_LINE = chr(818)
COMBINING_DOUBLE_LOW_LINE = chr(819)
COMBINING_TILDE_OVERLAY = chr(820)
COMBINING_SHORT_STROKE_OVERLAY = chr(821)
COMBINING_LONG_STROKE_OVERLAY = chr(822)
COMBINING_SHORT_SOLIDUS_OVERLAY = chr(823)
COMBINING_LONG_SOLIDUS_OVERLAY = chr(824)
COMBINING_RIGHT_HALF_RING_BELOW = chr(825)
COMBINING_INVERTED_BRIDGE_BELOW = chr(826)
COMBINING_SQUARE_BELOW = chr(827)
COMBINING_SEAGULL_BELOW = chr(828)
COMBINING_X_ABOVE = chr(829)
COMBINING_VERTICAL_TILDE = chr(830)
COMBINING_DOUBLE_OVERLINE = chr(831)
COMBINING_GRAVE_TONE_MARK = chr(832)
COMBINING_ACUTE_TONE_MARK = chr(833)
COMBINING_GREEK_PERISPOMENI = chr(834)
COMBINING_GREEK_KORONIS = chr(835)
COMBINING_GREEK_DIALYTIKA_TONOS = chr(836)
COMBINING_GREEK_YPOGEGRAMMENI = chr(837)
COMBINING_BRIDGE_ABOVE = chr(838)
COMBINING_EQUALS_SIGN_BELOW = chr(839)
COMBINING_DOUBLE_VERTICAL_LINE_BELOW = chr(840)
COMBINING_LEFT_ANGLE_BELOW = chr(841)
COMBINING_NOT_TILDE_ABOVE = chr(842)
COMBINING_HOMOTHETIC_ABOVE = chr(843)
COMBINING_ALMOST_EQUAL_TO_ABOVE = chr(844)
COMBINING_LEFT_RIGHT_ARROW_BELOW = chr(845)
COMBINING_UPWARDS_ARROW_BELOW = chr(846)
COMBINING_GRAPHEME_JOINER = chr(847)
COMBINING_RIGHT_ARROWHEAD_ABOVE = chr(848)
COMBINING_LEFT_HALF_RING_ABOVE = chr(849)
COMBINING_FERMATA = chr(850)
COMBINING_X_BELOW = chr(851)
COMBINING_LEFT_ARROWHEAD_BELOW = chr(852)
COMBINING_RIGHT_ARROWHEAD_BELOW = chr(853)
COMBINING_RIGHT_ARROWHEAD_AND_UP_ARROWHEAD_BELOW = chr(854)
COMBINING_RIGHT_HALF_RING_ABOVE = chr(855)
COMBINING_DOT_ABOVE_RIGHT = chr(856)
COMBINING_ASTERISK_BELOW = chr(857)
COMBINING_DOUBLE_RING_BELOW = chr(858)
COMBINING_ZIGZAG_ABOVE = chr(859)
COMBINING_DOUBLE_BREVE_BELOW = chr(860)
COMBINING_DOUBLE_BREVE = chr(861)
COMBINING_DOUBLE_MACRON = chr(862)
COMBINING_DOUBLE_MACRON_BELOW = chr(863)
COMBINING_DOUBLE_TILDE = chr(864)
COMBINING_DOUBLE_INVERTED_BREVE = chr(865)
COMBINING_DOUBLE_RIGHTWARDS_ARROW_BELOW = chr(866)
COMBINING_LATIN_SMALL_LETTER_A = chr(867)
COMBINING_LATIN_SMALL_LETTER_E = chr(868)
COMBINING_LATIN_SMALL_LETTER_I = chr(869)
COMBINING_LATIN_SMALL_LETTER_O = chr(870)
COMBINING_LATIN_SMALL_LETTER_U = chr(871)
COMBINING_LATIN_SMALL_LETTER_C = chr(872)
COMBINING_LATIN_SMALL_LETTER_D = chr(873)
COMBINING_LATIN_SMALL_LETTER_H = chr(874)
COMBINING_LATIN_SMALL_LETTER_M = chr(875)
COMBINING_LATIN_SMALL_LETTER_R = chr(876)
COMBINING_LATIN_SMALL_LETTER_T = chr(877)
COMBINING_LATIN_SMALL_LETTER_V = chr(878)
COMBINING_LATIN_SMALL_LETTER_X = chr(879)
GREEK_CAPITAL_LETTER_HETA = chr(880)
GREEK_SMALL_LETTER_HETA = chr(881)
GREEK_CAPITAL_LETTER_ARCHAIC_SAMPI = chr(882)
GREEK_SMALL_LETTER_ARCHAIC_SAMPI = chr(883)
GREEK_NUMERAL_SIGN = chr(884)
GREEK_LOWER_NUMERAL_SIGN = chr(885)
GREEK_CAPITAL_LETTER_PAMPHYLIAN_DIGAMMA = chr(886)
GREEK_SMALL_LETTER_PAMPHYLIAN_DIGAMMA = chr(887)
GREEK_YPOGEGRAMMENI = chr(890)
GREEK_SMALL_REVERSED_LUNATE_SIGMA_SYMBOL = chr(891)
GREEK_SMALL_DOTTED_LUNATE_SIGMA_SYMBOL = chr(892)
GREEK_SMALL_REVERSED_DOTTED_LUNATE_SIGMA_SYMBOL = chr(893)
GREEK_QUESTION_MARK = chr(894)
GREEK_CAPITAL_LETTER_YOT = chr(895)
GREEK_TONOS = chr(900)
GREEK_DIALYTIKA_TONOS = chr(901)
GREEK_CAPITAL_LETTER_ALPHA_WITH_TONOS = chr(902)
GREEK_ANO_TELEIA = chr(903)
GREEK_CAPITAL_LETTER_EPSILON_WITH_TONOS = chr(904)
GREEK_CAPITAL_LETTER_ETA_WITH_TONOS = chr(905)
GREEK_CAPITAL_LETTER_IOTA_WITH_TONOS = chr(906)
GREEK_CAPITAL_LETTER_OMICRON_WITH_TONOS = chr(908)
GREEK_CAPITAL_LETTER_UPSILON_WITH_TONOS = chr(910)
GREEK_CAPITAL_LETTER_OMEGA_WITH_TONOS = chr(911)
GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA_AND_TONOS = chr(912)
GREEK_CAPITAL_LETTER_ALPHA = chr(913)
GREEK_CAPITAL_LETTER_BETA = chr(914)
GREEK_CAPITAL_LETTER_GAMMA = chr(915)
GREEK_CAPITAL_LETTER_DELTA = chr(916)
GREEK_CAPITAL_LETTER_EPSILON = chr(917)
GREEK_CAPITAL_LETTER_ZETA = chr(918)
GREEK_CAPITAL_LETTER_ETA = chr(919)
GREEK_CAPITAL_LETTER_THETA = chr(920)
GREEK_CAPITAL_LETTER_IOTA = chr(921)
GREEK_CAPITAL_LETTER_KAPPA = chr(922)
GREEK_CAPITAL_LETTER_LAMDA = chr(923)
GREEK_CAPITAL_LETTER_MU = chr(924)
GREEK_CAPITAL_LETTER_NU = chr(925)
GREEK_CAPITAL_LETTER_XI = chr(926)
GREEK_CAPITAL_LETTER_OMICRON = chr(927)
GREEK_CAPITAL_LETTER_PI = chr(928)
GREEK_CAPITAL_LETTER_RHO = chr(929)
GREEK_CAPITAL_LETTER_SIGMA = chr(931)
GREEK_CAPITAL_LETTER_TAU = chr(932)
GREEK_CAPITAL_LETTER_UPSILON = chr(933)
GREEK_CAPITAL_LETTER_PHI = chr(934)
GREEK_CAPITAL_LETTER_CHI = chr(935)
GREEK_CAPITAL_LETTER_PSI = chr(936)
GREEK_CAPITAL_LETTER_OMEGA = chr(937)
GREEK_CAPITAL_LETTER_IOTA_WITH_DIALYTIKA = chr(938)
GREEK_CAPITAL_LETTER_UPSILON_WITH_DIALYTIKA = chr(939)
GREEK_SMALL_LETTER_ALPHA_WITH_TONOS = chr(940)
GREEK_SMALL_LETTER_EPSILON_WITH_TONOS = chr(941)
GREEK_SMALL_LETTER_ETA_WITH_TONOS = chr(942)
GREEK_SMALL_LETTER_IOTA_WITH_TONOS = chr(943)
GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA_AND_TONOS = chr(944)
GREEK_SMALL_LETTER_ALPHA = chr(945)
GREEK_SMALL_LETTER_BETA = chr(946)
GREEK_SMALL_LETTER_GAMMA = chr(947)
GREEK_SMALL_LETTER_DELTA = chr(948)
GREEK_SMALL_LETTER_EPSILON = chr(949)
GREEK_SMALL_LETTER_ZETA = chr(950)
GREEK_SMALL_LETTER_ETA = chr(951)
GREEK_SMALL_LETTER_THETA = chr(952)
GREEK_SMALL_LETTER_IOTA = chr(953)
GREEK_SMALL_LETTER_KAPPA = chr(954)
GREEK_SMALL_LETTER_LAMDA = chr(955)
GREEK_SMALL_LETTER_MU = chr(956)
GREEK_SMALL_LETTER_NU = chr(957)
GREEK_SMALL_LETTER_XI = chr(958)
GREEK_SMALL_LETTER_OMICRON = chr(959)
GREEK_SMALL_LETTER_PI = chr(960)
GREEK_SMALL_LETTER_RHO = chr(961)
GREEK_SMALL_LETTER_FINAL_SIGMA = chr(962)
GREEK_SMALL_LETTER_SIGMA = chr(963)
GREEK_SMALL_LETTER_TAU = chr(964)
GREEK_SMALL_LETTER_UPSILON = chr(965)
GREEK_SMALL_LETTER_PHI = chr(966)
GREEK_SMALL_LETTER_CHI = chr(967)
GREEK_SMALL_LETTER_PSI = chr(968)
GREEK_SMALL_LETTER_OMEGA = chr(969)
GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA = chr(970)
GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA = chr(971)
GREEK_SMALL_LETTER_OMICRON_WITH_TONOS = chr(972)
GREEK_SMALL_LETTER_UPSILON_WITH_TONOS = chr(973)
GREEK_SMALL_LETTER_OMEGA_WITH_TONOS = chr(974)
GREEK_CAPITAL_KAI_SYMBOL = chr(975)
GREEK_BETA_SYMBOL = chr(976)
GREEK_THETA_SYMBOL = chr(977)
GREEK_UPSILON_WITH_HOOK_SYMBOL = chr(978)
GREEK_UPSILON_WITH_ACUTE_AND_HOOK_SYMBOL = chr(979)
GREEK_UPSILON_WITH_DIAERESIS_AND_HOOK_SYMBOL = chr(980)
GREEK_PHI_SYMBOL = chr(981)
GREEK_PI_SYMBOL = chr(982)
GREEK_KAI_SYMBOL = chr(983)
GREEK_LETTER_ARCHAIC_KOPPA = chr(984)
GREEK_SMALL_LETTER_ARCHAIC_KOPPA = chr(985)
GREEK_LETTER_STIGMA = chr(986)
GREEK_SMALL_LETTER_STIGMA = chr(987)
GREEK_LETTER_DIGAMMA = chr(988)
GREEK_SMALL_LETTER_DIGAMMA = chr(989)
GREEK_LETTER_KOPPA = chr(990)
GREEK_SMALL_LETTER_KOPPA = chr(991)
GREEK_LETTER_SAMPI = chr(992)
GREEK_SMALL_LETTER_SAMPI = chr(993)
COPTIC_CAPITAL_LETTER_SHEI = chr(994)
COPTIC_SMALL_LETTER_SHEI = chr(995)
COPTIC_CAPITAL_LETTER_FEI = chr(996)
COPTIC_SMALL_LETTER_FEI = chr(997)
COPTIC_CAPITAL_LETTER_KHEI = chr(998)
COPTIC_SMALL_LETTER_KHEI = chr(999)
COPTIC_CAPITAL_LETTER_HORI = chr(1000)
COPTIC_SMALL_LETTER_HORI = chr(1001)
COPTIC_CAPITAL_LETTER_GANGIA = chr(1002)
COPTIC_SMALL_LETTER_GANGIA = chr(1003)
COPTIC_CAPITAL_LETTER_SHIMA = chr(1004)
COPTIC_SMALL_LETTER_SHIMA = chr(1005)
COPTIC_CAPITAL_LETTER_DEI = chr(1006)
COPTIC_SMALL_LETTER_DEI = chr(1007)
GREEK_KAPPA_SYMBOL = chr(1008)
GREEK_RHO_SYMBOL = chr(1009)
GREEK_LUNATE_SIGMA_SYMBOL = chr(1010)
GREEK_LETTER_YOT = chr(1011)
GREEK_CAPITAL_THETA_SYMBOL = chr(1012)
GREEK_LUNATE_EPSILON_SYMBOL = chr(1013)
GREEK_REVERSED_LUNATE_EPSILON_SYMBOL = chr(1014)
GREEK_CAPITAL_LETTER_SHO = chr(1015)
GREEK_SMALL_LETTER_SHO = chr(1016)
GREEK_CAPITAL_LUNATE_SIGMA_SYMBOL = chr(1017)
GREEK_CAPITAL_LETTER_SAN = chr(1018)
GREEK_SMALL_LETTER_SAN = chr(1019)
GREEK_RHO_WITH_STROKE_SYMBOL = chr(1020)
GREEK_CAPITAL_REVERSED_LUNATE_SIGMA_SYMBOL = chr(1021)
GREEK_CAPITAL_DOTTED_LUNATE_SIGMA_SYMBOL = chr(1022)
GREEK_CAPITAL_REVERSED_DOTTED_LUNATE_SIGMA_SYMBOL = chr(1023)
CYRILLIC_CAPITAL_LETTER_IE_WITH_GRAVE = chr(1024)
CYRILLIC_CAPITAL_LETTER_IO = chr(1025)
CYRILLIC_CAPITAL_LETTER_DJE = chr(1026)
CYRILLIC_CAPITAL_LETTER_GJE = chr(1027)
CYRILLIC_CAPITAL_LETTER_UKRAINIAN_IE = chr(1028)
CYRILLIC_CAPITAL_LETTER_DZE = chr(1029)
CYRILLIC_CAPITAL_LETTER_BYELORUSSIAN_UKRAINIAN_I = chr(1030)
CYRILLIC_CAPITAL_LETTER_YI = chr(1031)
CYRILLIC_CAPITAL_LETTER_JE = chr(1032)
CYRILLIC_CAPITAL_LETTER_LJE = chr(1033)
CYRILLIC_CAPITAL_LETTER_NJE = chr(1034)
CYRILLIC_CAPITAL_LETTER_TSHE = chr(1035)
CYRILLIC_CAPITAL_LETTER_KJE = chr(1036)
CYRILLIC_CAPITAL_LETTER_I_WITH_GRAVE = chr(1037)
CYRILLIC_CAPITAL_LETTER_SHORT_U = chr(1038)
CYRILLIC_CAPITAL_LETTER_DZHE = chr(1039)
CYRILLIC_CAPITAL_LETTER_A = chr(1040)
CYRILLIC_CAPITAL_LETTER_BE = chr(1041)
CYRILLIC_CAPITAL_LETTER_VE = chr(1042)
CYRILLIC_CAPITAL_LETTER_GHE = chr(1043)
CYRILLIC_CAPITAL_LETTER_DE = chr(1044)
CYRILLIC_CAPITAL_LETTER_IE = chr(1045)
CYRILLIC_CAPITAL_LETTER_ZHE = chr(1046)
CYRILLIC_CAPITAL_LETTER_ZE = chr(1047)
CYRILLIC_CAPITAL_LETTER_I = chr(1048)
CYRILLIC_CAPITAL_LETTER_SHORT_I = chr(1049)
CYRILLIC_CAPITAL_LETTER_KA = chr(1050)
CYRILLIC_CAPITAL_LETTER_EL = chr(1051)
CYRILLIC_CAPITAL_LETTER_EM = chr(1052)
CYRILLIC_CAPITAL_LETTER_EN = chr(1053)
CYRILLIC_CAPITAL_LETTER_O = chr(1054)
CYRILLIC_CAPITAL_LETTER_PE = chr(1055)
CYRILLIC_CAPITAL_LETTER_ER = chr(1056)
CYRILLIC_CAPITAL_LETTER_ES = chr(1057)
CYRILLIC_CAPITAL_LETTER_TE = chr(1058)
CYRILLIC_CAPITAL_LETTER_U = chr(1059)
CYRILLIC_CAPITAL_LETTER_EF = chr(1060)
CYRILLIC_CAPITAL_LETTER_HA = chr(1061)
CYRILLIC_CAPITAL_LETTER_TSE = chr(1062)
CYRILLIC_CAPITAL_LETTER_CHE = chr(1063)
CYRILLIC_CAPITAL_LETTER_SHA = chr(1064)
CYRILLIC_CAPITAL_LETTER_SHCHA = chr(1065)
CYRILLIC_CAPITAL_LETTER_HARD_SIGN = chr(1066)
CYRILLIC_CAPITAL_LETTER_YERU = chr(1067)
CYRILLIC_CAPITAL_LETTER_SOFT_SIGN = chr(1068)
CYRILLIC_CAPITAL_LETTER_E = chr(1069)
CYRILLIC_CAPITAL_LETTER_YU = chr(1070)
CYRILLIC_CAPITAL_LETTER_YA = chr(1071)
CYRILLIC_SMALL_LETTER_A = chr(1072)
CYRILLIC_SMALL_LETTER_BE = chr(1073)
CYRILLIC_SMALL_LETTER_VE = chr(1074)
CYRILLIC_SMALL_LETTER_GHE = chr(1075)
CYRILLIC_SMALL_LETTER_DE = chr(1076)
CYRILLIC_SMALL_LETTER_IE = chr(1077)
CYRILLIC_SMALL_LETTER_ZHE = chr(1078)
CYRILLIC_SMALL_LETTER_ZE = chr(1079)
CYRILLIC_SMALL_LETTER_I = chr(1080)
CYRILLIC_SMALL_LETTER_SHORT_I = chr(1081)
CYRILLIC_SMALL_LETTER_KA = chr(1082)
CYRILLIC_SMALL_LETTER_EL = chr(1083)
CYRILLIC_SMALL_LETTER_EM = chr(1084)
CYRILLIC_SMALL_LETTER_EN = chr(1085)
CYRILLIC_SMALL_LETTER_O = chr(1086)
CYRILLIC_SMALL_LETTER_PE = chr(1087)
CYRILLIC_SMALL_LETTER_ER = chr(1088)
CYRILLIC_SMALL_LETTER_ES = chr(1089)
CYRILLIC_SMALL_LETTER_TE = chr(1090)
CYRILLIC_SMALL_LETTER_U = chr(1091)
CYRILLIC_SMALL_LETTER_EF = chr(1092)
CYRILLIC_SMALL_LETTER_HA = chr(1093)
CYRILLIC_SMALL_LETTER_TSE = chr(1094)
CYRILLIC_SMALL_LETTER_CHE = chr(1095)
CYRILLIC_SMALL_LETTER_SHA = chr(1096)
CYRILLIC_SMALL_LETTER_SHCHA = chr(1097)
CYRILLIC_SMALL_LETTER_HARD_SIGN = chr(1098)
CYRILLIC_SMALL_LETTER_YERU = chr(1099)
CYRILLIC_SMALL_LETTER_SOFT_SIGN = chr(1100)
CYRILLIC_SMALL_LETTER_E = chr(1101)
CYRILLIC_SMALL_LETTER_YU = chr(1102)
CYRILLIC_SMALL_LETTER_YA = chr(1103)
CYRILLIC_SMALL_LETTER_IE_WITH_GRAVE = chr(1104)
CYRILLIC_SMALL_LETTER_IO = chr(1105)
CYRILLIC_SMALL_LETTER_DJE = chr(1106)
CYRILLIC_SMALL_LETTER_GJE = chr(1107)
CYRILLIC_SMALL_LETTER_UKRAINIAN_IE = chr(1108)
CYRILLIC_SMALL_LETTER_DZE = chr(1109)
CYRILLIC_SMALL_LETTER_BYELORUSSIAN_UKRAINIAN_I = chr(1110)
CYRILLIC_SMALL_LETTER_YI = chr(1111)
CYRILLIC_SMALL_LETTER_JE = chr(1112)
CYRILLIC_SMALL_LETTER_LJE = chr(1113)
CYRILLIC_SMALL_LETTER_NJE = chr(1114)
CYRILLIC_SMALL_LETTER_TSHE = chr(1115)
CYRILLIC_SMALL_LETTER_KJE = chr(1116)
CYRILLIC_SMALL_LETTER_I_WITH_GRAVE = chr(1117)
CYRILLIC_SMALL_LETTER_SHORT_U = chr(1118)
CYRILLIC_SMALL_LETTER_DZHE = chr(1119)
CYRILLIC_CAPITAL_LETTER_OMEGA = chr(1120)
CYRILLIC_SMALL_LETTER_OMEGA = chr(1121)
CYRILLIC_CAPITAL_LETTER_YAT = chr(1122)
CYRILLIC_SMALL_LETTER_YAT = chr(1123)
CYRILLIC_CAPITAL_LETTER_IOTIFIED_E = chr(1124)
CYRILLIC_SMALL_LETTER_IOTIFIED_E = chr(1125)
CYRILLIC_CAPITAL_LETTER_LITTLE_YUS = chr(1126)
CYRILLIC_SMALL_LETTER_LITTLE_YUS = chr(1127)
CYRILLIC_CAPITAL_LETTER_IOTIFIED_LITTLE_YUS = chr(1128)
CYRILLIC_SMALL_LETTER_IOTIFIED_LITTLE_YUS = chr(1129)
CYRILLIC_CAPITAL_LETTER_BIG_YUS = chr(1130)
CYRILLIC_SMALL_LETTER_BIG_YUS = chr(1131)
CYRILLIC_CAPITAL_LETTER_IOTIFIED_BIG_YUS = chr(1132)
CYRILLIC_SMALL_LETTER_IOTIFIED_BIG_YUS = chr(1133)
CYRILLIC_CAPITAL_LETTER_KSI = chr(1134)
CYRILLIC_SMALL_LETTER_KSI = chr(1135)
CYRILLIC_CAPITAL_LETTER_PSI = chr(1136)
CYRILLIC_SMALL_LETTER_PSI = chr(1137)
CYRILLIC_CAPITAL_LETTER_FITA = chr(1138)
CYRILLIC_SMALL_LETTER_FITA = chr(1139)
CYRILLIC_CAPITAL_LETTER_IZHITSA = chr(1140)
CYRILLIC_SMALL_LETTER_IZHITSA = chr(1141)
CYRILLIC_CAPITAL_LETTER_IZHITSA_WITH_DOUBLE_GRAVE_ACCENT = chr(1142)
CYRILLIC_SMALL_LETTER_IZHITSA_WITH_DOUBLE_GRAVE_ACCENT = chr(1143)
CYRILLIC_CAPITAL_LETTER_UK = chr(1144)
CYRILLIC_SMALL_LETTER_UK = chr(1145)
CYRILLIC_CAPITAL_LETTER_ROUND_OMEGA = chr(1146)
CYRILLIC_SMALL_LETTER_ROUND_OMEGA = chr(1147)
CYRILLIC_CAPITAL_LETTER_OMEGA_WITH_TITLO = chr(1148)
CYRILLIC_SMALL_LETTER_OMEGA_WITH_TITLO = chr(1149)
CYRILLIC_CAPITAL_LETTER_OT = chr(1150)
CYRILLIC_SMALL_LETTER_OT = chr(1151)
CYRILLIC_CAPITAL_LETTER_KOPPA = chr(1152)
CYRILLIC_SMALL_LETTER_KOPPA = chr(1153)
CYRILLIC_THOUSANDS_SIGN = chr(1154)
COMBINING_CYRILLIC_TITLO = chr(1155)
COMBINING_CYRILLIC_PALATALIZATION = chr(1156)
COMBINING_CYRILLIC_DASIA_PNEUMATA = chr(1157)
COMBINING_CYRILLIC_PSILI_PNEUMATA = chr(1158)
COMBINING_CYRILLIC_POKRYTIE = chr(1159)
COMBINING_CYRILLIC_HUNDRED_THOUSANDS_SIGN = chr(1160)
COMBINING_CYRILLIC_MILLIONS_SIGN = chr(1161)
CYRILLIC_CAPITAL_LETTER_SHORT_I_WITH_TAIL = chr(1162)
CYRILLIC_SMALL_LETTER_SHORT_I_WITH_TAIL = chr(1163)
CYRILLIC_CAPITAL_LETTER_SEMISOFT_SIGN = chr(1164)
CYRILLIC_SMALL_LETTER_SEMISOFT_SIGN = chr(1165)
CYRILLIC_CAPITAL_LETTER_ER_WITH_TICK = chr(1166)
CYRILLIC_SMALL_LETTER_ER_WITH_TICK = chr(1167)
CYRILLIC_CAPITAL_LETTER_GHE_WITH_UPTURN = chr(1168)
CYRILLIC_SMALL_LETTER_GHE_WITH_UPTURN = chr(1169)
CYRILLIC_CAPITAL_LETTER_GHE_WITH_STROKE = chr(1170)
CYRILLIC_SMALL_LETTER_GHE_WITH_STROKE = chr(1171)
CYRILLIC_CAPITAL_LETTER_GHE_WITH_MIDDLE_HOOK = chr(1172)
CYRILLIC_SMALL_LETTER_GHE_WITH_MIDDLE_HOOK = chr(1173)
CYRILLIC_CAPITAL_LETTER_ZHE_WITH_DESCENDER = chr(1174)
CYRILLIC_SMALL_LETTER_ZHE_WITH_DESCENDER = chr(1175)
CYRILLIC_CAPITAL_LETTER_ZE_WITH_DESCENDER = chr(1176)
CYRILLIC_SMALL_LETTER_ZE_WITH_DESCENDER = chr(1177)
CYRILLIC_CAPITAL_LETTER_KA_WITH_DESCENDER = chr(1178)
CYRILLIC_SMALL_LETTER_KA_WITH_DESCENDER = chr(1179)
CYRILLIC_CAPITAL_LETTER_KA_WITH_VERTICAL_STROKE = chr(1180)
CYRILLIC_SMALL_LETTER_KA_WITH_VERTICAL_STROKE = chr(1181)
CYRILLIC_CAPITAL_LETTER_KA_WITH_STROKE = chr(1182)
CYRILLIC_SMALL_LETTER_KA_WITH_STROKE = chr(1183)
CYRILLIC_CAPITAL_LETTER_BASHKIR_KA = chr(1184)
CYRILLIC_SMALL_LETTER_BASHKIR_KA = chr(1185)
CYRILLIC_CAPITAL_LETTER_EN_WITH_DESCENDER = chr(1186)
CYRILLIC_SMALL_LETTER_EN_WITH_DESCENDER = chr(1187)
CYRILLIC_CAPITAL_LIGATURE_EN_GHE = chr(1188)
CYRILLIC_SMALL_LIGATURE_EN_GHE = chr(1189)
CYRILLIC_CAPITAL_LETTER_PE_WITH_MIDDLE_HOOK = chr(1190)
CYRILLIC_SMALL_LETTER_PE_WITH_MIDDLE_HOOK = chr(1191)
CYRILLIC_CAPITAL_LETTER_ABKHASIAN_HA = chr(1192)
CYRILLIC_SMALL_LETTER_ABKHASIAN_HA = chr(1193)
CYRILLIC_CAPITAL_LETTER_ES_WITH_DESCENDER = chr(1194)
CYRILLIC_SMALL_LETTER_ES_WITH_DESCENDER = chr(1195)
CYRILLIC_CAPITAL_LETTER_TE_WITH_DESCENDER = chr(1196)
CYRILLIC_SMALL_LETTER_TE_WITH_DESCENDER = chr(1197)
CYRILLIC_CAPITAL_LETTER_STRAIGHT_U = chr(1198)
CYRILLIC_SMALL_LETTER_STRAIGHT_U = chr(1199)
CYRILLIC_CAPITAL_LETTER_STRAIGHT_U_WITH_STROKE = chr(1200)
CYRILLIC_SMALL_LETTER_STRAIGHT_U_WITH_STROKE = chr(1201)
CYRILLIC_CAPITAL_LETTER_HA_WITH_DESCENDER = chr(1202)
CYRILLIC_SMALL_LETTER_HA_WITH_DESCENDER = chr(1203)
CYRILLIC_CAPITAL_LIGATURE_TE_TSE = chr(1204)
CYRILLIC_SMALL_LIGATURE_TE_TSE = chr(1205)
CYRILLIC_CAPITAL_LETTER_CHE_WITH_DESCENDER = chr(1206)
CYRILLIC_SMALL_LETTER_CHE_WITH_DESCENDER = chr(1207)
CYRILLIC_CAPITAL_LETTER_CHE_WITH_VERTICAL_STROKE = chr(1208)
CYRILLIC_SMALL_LETTER_CHE_WITH_VERTICAL_STROKE = chr(1209)
CYRILLIC_CAPITAL_LETTER_SHHA = chr(1210)
CYRILLIC_SMALL_LETTER_SHHA = chr(1211)
CYRILLIC_CAPITAL_LETTER_ABKHASIAN_CHE = chr(1212)
CYRILLIC_SMALL_LETTER_ABKHASIAN_CHE = chr(1213)
CYRILLIC_CAPITAL_LETTER_ABKHASIAN_CHE_WITH_DESCENDER = chr(1214)
CYRILLIC_SMALL_LETTER_ABKHASIAN_CHE_WITH_DESCENDER = chr(1215)
CYRILLIC_LETTER_PALOCHKA = chr(1216)
CYRILLIC_CAPITAL_LETTER_ZHE_WITH_BREVE = chr(1217)
CYRILLIC_SMALL_LETTER_ZHE_WITH_BREVE = chr(1218)
CYRILLIC_CAPITAL_LETTER_KA_WITH_HOOK = chr(1219)
CYRILLIC_SMALL_LETTER_KA_WITH_HOOK = chr(1220)
CYRILLIC_CAPITAL_LETTER_EL_WITH_TAIL = chr(1221)
CYRILLIC_SMALL_LETTER_EL_WITH_TAIL = chr(1222)
CYRILLIC_CAPITAL_LETTER_EN_WITH_HOOK = chr(1223)
CYRILLIC_SMALL_LETTER_EN_WITH_HOOK = chr(1224)
CYRILLIC_CAPITAL_LETTER_EN_WITH_TAIL = chr(1225)
CYRILLIC_SMALL_LETTER_EN_WITH_TAIL = chr(1226)
CYRILLIC_CAPITAL_LETTER_KHAKASSIAN_CHE = chr(1227)
CYRILLIC_SMALL_LETTER_KHAKASSIAN_CHE = chr(1228)
CYRILLIC_CAPITAL_LETTER_EM_WITH_TAIL = chr(1229)
CYRILLIC_SMALL_LETTER_EM_WITH_TAIL = chr(1230)
CYRILLIC_SMALL_LETTER_PALOCHKA = chr(1231)
CYRILLIC_CAPITAL_LETTER_A_WITH_BREVE = chr(1232)
CYRILLIC_SMALL_LETTER_A_WITH_BREVE = chr(1233)
CYRILLIC_CAPITAL_LETTER_A_WITH_DIAERESIS = chr(1234)
CYRILLIC_SMALL_LETTER_A_WITH_DIAERESIS = chr(1235)
CYRILLIC_CAPITAL_LIGATURE_A_IE = chr(1236)
CYRILLIC_SMALL_LIGATURE_A_IE = chr(1237)
CYRILLIC_CAPITAL_LETTER_IE_WITH_BREVE = chr(1238)
CYRILLIC_SMALL_LETTER_IE_WITH_BREVE = chr(1239)
CYRILLIC_CAPITAL_LETTER_SCHWA = chr(1240)
CYRILLIC_SMALL_LETTER_SCHWA = chr(1241)
CYRILLIC_CAPITAL_LETTER_SCHWA_WITH_DIAERESIS = chr(1242)
CYRILLIC_SMALL_LETTER_SCHWA_WITH_DIAERESIS = chr(1243)
CYRILLIC_CAPITAL_LETTER_ZHE_WITH_DIAERESIS = chr(1244)
CYRILLIC_SMALL_LETTER_ZHE_WITH_DIAERESIS = chr(1245)
CYRILLIC_CAPITAL_LETTER_ZE_WITH_DIAERESIS = chr(1246)
CYRILLIC_SMALL_LETTER_ZE_WITH_DIAERESIS = chr(1247)
CYRILLIC_CAPITAL_LETTER_ABKHASIAN_DZE = chr(1248)
CYRILLIC_SMALL_LETTER_ABKHASIAN_DZE = chr(1249)
CYRILLIC_CAPITAL_LETTER_I_WITH_MACRON = chr(1250)
CYRILLIC_SMALL_LETTER_I_WITH_MACRON = chr(1251)
CYRILLIC_CAPITAL_LETTER_I_WITH_DIAERESIS = chr(1252)
CYRILLIC_SMALL_LETTER_I_WITH_DIAERESIS = chr(1253)
CYRILLIC_CAPITAL_LETTER_O_WITH_DIAERESIS = chr(1254)
CYRILLIC_SMALL_LETTER_O_WITH_DIAERESIS = chr(1255)
CYRILLIC_CAPITAL_LETTER_BARRED_O = chr(1256)
CYRILLIC_SMALL_LETTER_BARRED_O = chr(1257)
CYRILLIC_CAPITAL_LETTER_BARRED_O_WITH_DIAERESIS = chr(1258)
CYRILLIC_SMALL_LETTER_BARRED_O_WITH_DIAERESIS = chr(1259)
CYRILLIC_CAPITAL_LETTER_E_WITH_DIAERESIS = chr(1260)
CYRILLIC_SMALL_LETTER_E_WITH_DIAERESIS = chr(1261)
CYRILLIC_CAPITAL_LETTER_U_WITH_MACRON = chr(1262)
CYRILLIC_SMALL_LETTER_U_WITH_MACRON = chr(1263)
CYRILLIC_CAPITAL_LETTER_U_WITH_DIAERESIS = chr(1264)
CYRILLIC_SMALL_LETTER_U_WITH_DIAERESIS = chr(1265)
CYRILLIC_CAPITAL_LETTER_U_WITH_DOUBLE_ACUTE = chr(1266)
CYRILLIC_SMALL_LETTER_U_WITH_DOUBLE_ACUTE = chr(1267)
CYRILLIC_CAPITAL_LETTER_CHE_WITH_DIAERESIS = chr(1268)
CYRILLIC_SMALL_LETTER_CHE_WITH_DIAERESIS = chr(1269)
CYRILLIC_CAPITAL_LETTER_GHE_WITH_DESCENDER = chr(1270)
CYRILLIC_SMALL_LETTER_GHE_WITH_DESCENDER = chr(1271)
CYRILLIC_CAPITAL_LETTER_YERU_WITH_DIAERESIS = chr(1272)
CYRILLIC_SMALL_LETTER_YERU_WITH_DIAERESIS = chr(1273)
CYRILLIC_CAPITAL_LETTER_GHE_WITH_STROKE_AND_HOOK = chr(1274)
CYRILLIC_SMALL_LETTER_GHE_WITH_STROKE_AND_HOOK = chr(1275)
CYRILLIC_CAPITAL_LETTER_HA_WITH_HOOK = chr(1276)
CYRILLIC_SMALL_LETTER_HA_WITH_HOOK = chr(1277)
CYRILLIC_CAPITAL_LETTER_HA_WITH_STROKE = chr(1278)
CYRILLIC_SMALL_LETTER_HA_WITH_STROKE = chr(1279)
CYRILLIC_CAPITAL_LETTER_KOMI_DE = chr(1280)
CYRILLIC_SMALL_LETTER_KOMI_DE = chr(1281)
CYRILLIC_CAPITAL_LETTER_KOMI_DJE = chr(1282)
CYRILLIC_SMALL_LETTER_KOMI_DJE = chr(1283)
CYRILLIC_CAPITAL_LETTER_KOMI_ZJE = chr(1284)
CYRILLIC_SMALL_LETTER_KOMI_ZJE = chr(1285)
CYRILLIC_CAPITAL_LETTER_KOMI_DZJE = chr(1286)
CYRILLIC_SMALL_LETTER_KOMI_DZJE = chr(1287)
CYRILLIC_CAPITAL_LETTER_KOMI_LJE = chr(1288)
CYRILLIC_SMALL_LETTER_KOMI_LJE = chr(1289)
CYRILLIC_CAPITAL_LETTER_KOMI_NJE = chr(1290)
CYRILLIC_SMALL_LETTER_KOMI_NJE = chr(1291)
CYRILLIC_CAPITAL_LETTER_KOMI_SJE = chr(1292)
CYRILLIC_SMALL_LETTER_KOMI_SJE = chr(1293)
CYRILLIC_CAPITAL_LETTER_KOMI_TJE = chr(1294)
CYRILLIC_SMALL_LETTER_KOMI_TJE = chr(1295)
CYRILLIC_CAPITAL_LETTER_REVERSED_ZE = chr(1296)
CYRILLIC_SMALL_LETTER_REVERSED_ZE = chr(1297)
CYRILLIC_CAPITAL_LETTER_EL_WITH_HOOK = chr(1298)
CYRILLIC_SMALL_LETTER_EL_WITH_HOOK = chr(1299)
CYRILLIC_CAPITAL_LETTER_LHA = chr(1300)
CYRILLIC_SMALL_LETTER_LHA = chr(1301)
CYRILLIC_CAPITAL_LETTER_RHA = chr(1302)
CYRILLIC_SMALL_LETTER_RHA = chr(1303)
CYRILLIC_CAPITAL_LETTER_YAE = chr(1304)
CYRILLIC_SMALL_LETTER_YAE = chr(1305)
CYRILLIC_CAPITAL_LETTER_QA = chr(1306)
CYRILLIC_SMALL_LETTER_QA = chr(1307)
CYRILLIC_CAPITAL_LETTER_WE = chr(1308)
CYRILLIC_SMALL_LETTER_WE = chr(1309)
CYRILLIC_CAPITAL_LETTER_ALEUT_KA = chr(1310)
CYRILLIC_SMALL_LETTER_ALEUT_KA = chr(1311)
CYRILLIC_CAPITAL_LETTER_EL_WITH_MIDDLE_HOOK = chr(1312)
CYRILLIC_SMALL_LETTER_EL_WITH_MIDDLE_HOOK = chr(1313)
CYRILLIC_CAPITAL_LETTER_EN_WITH_MIDDLE_HOOK = chr(1314)
CYRILLIC_SMALL_LETTER_EN_WITH_MIDDLE_HOOK = chr(1315)
CYRILLIC_CAPITAL_LETTER_PE_WITH_DESCENDER = chr(1316)
CYRILLIC_SMALL_LETTER_PE_WITH_DESCENDER = chr(1317)
CYRILLIC_CAPITAL_LETTER_SHHA_WITH_DESCENDER = chr(1318)
CYRILLIC_SMALL_LETTER_SHHA_WITH_DESCENDER = chr(1319)
CYRILLIC_CAPITAL_LETTER_EN_WITH_LEFT_HOOK = chr(1320)
CYRILLIC_SMALL_LETTER_EN_WITH_LEFT_HOOK = chr(1321)
CYRILLIC_CAPITAL_LETTER_DZZHE = chr(1322)
CYRILLIC_SMALL_LETTER_DZZHE = chr(1323)
CYRILLIC_CAPITAL_LETTER_DCHE = chr(1324)
CYRILLIC_SMALL_LETTER_DCHE = chr(1325)
CYRILLIC_CAPITAL_LETTER_EL_WITH_DESCENDER = chr(1326)
CYRILLIC_SMALL_LETTER_EL_WITH_DESCENDER = chr(1327)
ARMENIAN_CAPITAL_LETTER_AYB = chr(1329)
ARMENIAN_CAPITAL_LETTER_BEN = chr(1330)
ARMENIAN_CAPITAL_LETTER_GIM = chr(1331)
ARMENIAN_CAPITAL_LETTER_DA = chr(1332)
ARMENIAN_CAPITAL_LETTER_ECH = chr(1333)
ARMENIAN_CAPITAL_LETTER_ZA = chr(1334)
ARMENIAN_CAPITAL_LETTER_EH = chr(1335)
ARMENIAN_CAPITAL_LETTER_ET = chr(1336)
ARMENIAN_CAPITAL_LETTER_TO = chr(1337)
ARMENIAN_CAPITAL_LETTER_ZHE = chr(1338)
ARMENIAN_CAPITAL_LETTER_INI = chr(1339)
ARMENIAN_CAPITAL_LETTER_LIWN = chr(1340)
ARMENIAN_CAPITAL_LETTER_XEH = chr(1341)
ARMENIAN_CAPITAL_LETTER_CA = chr(1342)
ARMENIAN_CAPITAL_LETTER_KEN = chr(1343)
ARMENIAN_CAPITAL_LETTER_HO = chr(1344)
ARMENIAN_CAPITAL_LETTER_JA = chr(1345)
ARMENIAN_CAPITAL_LETTER_GHAD = chr(1346)
ARMENIAN_CAPITAL_LETTER_CHEH = chr(1347)
ARMENIAN_CAPITAL_LETTER_MEN = chr(1348)
ARMENIAN_CAPITAL_LETTER_YI = chr(1349)
ARMENIAN_CAPITAL_LETTER_NOW = chr(1350)
ARMENIAN_CAPITAL_LETTER_SHA = chr(1351)
ARMENIAN_CAPITAL_LETTER_VO = chr(1352)
ARMENIAN_CAPITAL_LETTER_CHA = chr(1353)
ARMENIAN_CAPITAL_LETTER_PEH = chr(1354)
ARMENIAN_CAPITAL_LETTER_JHEH = chr(1355)
ARMENIAN_CAPITAL_LETTER_RA = chr(1356)
ARMENIAN_CAPITAL_LETTER_SEH = chr(1357)
ARMENIAN_CAPITAL_LETTER_VEW = chr(1358)
ARMENIAN_CAPITAL_LETTER_TIWN = chr(1359)
ARMENIAN_CAPITAL_LETTER_REH = chr(1360)
ARMENIAN_CAPITAL_LETTER_CO = chr(1361)
ARMENIAN_CAPITAL_LETTER_YIWN = chr(1362)
ARMENIAN_CAPITAL_LETTER_PIWR = chr(1363)
ARMENIAN_CAPITAL_LETTER_KEH = chr(1364)
ARMENIAN_CAPITAL_LETTER_OH = chr(1365)
ARMENIAN_CAPITAL_LETTER_FEH = chr(1366)
ARMENIAN_MODIFIER_LETTER_LEFT_HALF_RING = chr(1369)
ARMENIAN_APOSTROPHE = chr(1370)
ARMENIAN_EMPHASIS_MARK = chr(1371)
ARMENIAN_EXCLAMATION_MARK = chr(1372)
ARMENIAN_COMMA = chr(1373)
ARMENIAN_QUESTION_MARK = chr(1374)
ARMENIAN_ABBREVIATION_MARK = chr(1375)
ARMENIAN_SMALL_LETTER_TURNED_AYB = chr(1376)
ARMENIAN_SMALL_LETTER_AYB = chr(1377)
ARMENIAN_SMALL_LETTER_BEN = chr(1378)
ARMENIAN_SMALL_LETTER_GIM = chr(1379)
ARMENIAN_SMALL_LETTER_DA = chr(1380)
ARMENIAN_SMALL_LETTER_ECH = chr(1381)
ARMENIAN_SMALL_LETTER_ZA = chr(1382)
ARMENIAN_SMALL_LETTER_EH = chr(1383)
ARMENIAN_SMALL_LETTER_ET = chr(1384)
ARMENIAN_SMALL_LETTER_TO = chr(1385)
ARMENIAN_SMALL_LETTER_ZHE = chr(1386)
ARMENIAN_SMALL_LETTER_INI = chr(1387)
ARMENIAN_SMALL_LETTER_LIWN = chr(1388)
ARMENIAN_SMALL_LETTER_XEH = chr(1389)
ARMENIAN_SMALL_LETTER_CA = chr(1390)
ARMENIAN_SMALL_LETTER_KEN = chr(1391)
ARMENIAN_SMALL_LETTER_HO = chr(1392)
ARMENIAN_SMALL_LETTER_JA = chr(1393)
ARMENIAN_SMALL_LETTER_GHAD = chr(1394)
ARMENIAN_SMALL_LETTER_CHEH = chr(1395)
ARMENIAN_SMALL_LETTER_MEN = chr(1396)
ARMENIAN_SMALL_LETTER_YI = chr(1397)
ARMENIAN_SMALL_LETTER_NOW = chr(1398)
ARMENIAN_SMALL_LETTER_SHA = chr(1399)
ARMENIAN_SMALL_LETTER_VO = chr(1400)
ARMENIAN_SMALL_LETTER_CHA = chr(1401)
ARMENIAN_SMALL_LETTER_PEH = chr(1402)
ARMENIAN_SMALL_LETTER_JHEH = chr(1403)
ARMENIAN_SMALL_LETTER_RA = chr(1404)
ARMENIAN_SMALL_LETTER_SEH = chr(1405)
ARMENIAN_SMALL_LETTER_VEW = chr(1406)
ARMENIAN_SMALL_LETTER_TIWN = chr(1407)
ARMENIAN_SMALL_LETTER_REH = chr(1408)
ARMENIAN_SMALL_LETTER_CO = chr(1409)
ARMENIAN_SMALL_LETTER_YIWN = chr(1410)
ARMENIAN_SMALL_LETTER_PIWR = chr(1411)
ARMENIAN_SMALL_LETTER_KEH = chr(1412)
ARMENIAN_SMALL_LETTER_OH = chr(1413)
ARMENIAN_SMALL_LETTER_FEH = chr(1414)
ARMENIAN_SMALL_LIGATURE_ECH_YIWN = chr(1415)
ARMENIAN_SMALL_LETTER_YI_WITH_STROKE = chr(1416)
ARMENIAN_FULL_STOP = chr(1417)
ARMENIAN_HYPHEN = chr(1418)
RIGHT_FACING_ARMENIAN_ETERNITY_SIGN = chr(1421)
LEFT_FACING_ARMENIAN_ETERNITY_SIGN = chr(1422)
ARMENIAN_DRAM_SIGN = chr(1423)
HEBREW_ACCENT_ETNAHTA = chr(1425)
HEBREW_ACCENT_SEGOL = chr(1426)
HEBREW_ACCENT_SHALSHELET = chr(1427)
HEBREW_ACCENT_ZAQEF_QATAN = chr(1428)
HEBREW_ACCENT_ZAQEF_GADOL = chr(1429)
HEBREW_ACCENT_TIPEHA = chr(1430)
HEBREW_ACCENT_REVIA = chr(1431)
HEBREW_ACCENT_ZARQA = chr(1432)
HEBREW_ACCENT_PASHTA = chr(1433)
HEBREW_ACCENT_YETIV = chr(1434)
HEBREW_ACCENT_TEVIR = chr(1435)
HEBREW_ACCENT_GERESH = chr(1436)
HEBREW_ACCENT_GERESH_MUQDAM = chr(1437)
HEBREW_ACCENT_GERSHAYIM = chr(1438)
HEBREW_ACCENT_QARNEY_PARA = chr(1439)
HEBREW_ACCENT_TELISHA_GEDOLA = chr(1440)
HEBREW_ACCENT_PAZER = chr(1441)
HEBREW_ACCENT_ATNAH_HAFUKH = chr(1442)
HEBREW_ACCENT_MUNAH = chr(1443)
HEBREW_ACCENT_MAHAPAKH = chr(1444)
HEBREW_ACCENT_MERKHA = chr(1445)
HEBREW_ACCENT_MERKHA_KEFULA = chr(1446)
HEBREW_ACCENT_DARGA = chr(1447)
HEBREW_ACCENT_QADMA = chr(1448)
HEBREW_ACCENT_TELISHA_QETANA = chr(1449)
HEBREW_ACCENT_YERAH_BEN_YOMO = chr(1450)
HEBREW_ACCENT_OLE = chr(1451)
HEBREW_ACCENT_ILUY = chr(1452)
HEBREW_ACCENT_DEHI = chr(1453)
HEBREW_ACCENT_ZINOR = chr(1454)
HEBREW_MARK_MASORA_CIRCLE = chr(1455)
HEBREW_POINT_SHEVA = chr(1456)
HEBREW_POINT_HATAF_SEGOL = chr(1457)
HEBREW_POINT_HATAF_PATAH = chr(1458)
HEBREW_POINT_HATAF_QAMATS = chr(1459)
HEBREW_POINT_HIRIQ = chr(1460)
HEBREW_POINT_TSERE = chr(1461)
HEBREW_POINT_SEGOL = chr(1462)
HEBREW_POINT_PATAH = chr(1463)
HEBREW_POINT_QAMATS = chr(1464)
HEBREW_POINT_HOLAM = chr(1465)
HEBREW_POINT_HOLAM_HASER_FOR_VAV = chr(1466)
HEBREW_POINT_QUBUTS = chr(1467)
HEBREW_POINT_DAGESH_OR_MAPIQ = chr(1468)
HEBREW_POINT_METEG = chr(1469)
HEBREW_PUNCTUATION_MAQAF = chr(1470)
HEBREW_POINT_RAFE = chr(1471)
HEBREW_PUNCTUATION_PASEQ = chr(1472)
HEBREW_POINT_SHIN_DOT = chr(1473)
HEBREW_POINT_SIN_DOT = chr(1474)
HEBREW_PUNCTUATION_SOF_PASUQ = chr(1475)
HEBREW_MARK_UPPER_DOT = chr(1476)
HEBREW_MARK_LOWER_DOT = chr(1477)
HEBREW_PUNCTUATION_NUN_HAFUKHA = chr(1478)
HEBREW_POINT_QAMATS_QATAN = chr(1479)
HEBREW_LETTER_ALEF = chr(1488)
HEBREW_LETTER_BET = chr(1489)
HEBREW_LETTER_GIMEL = chr(1490)
HEBREW_LETTER_DALET = chr(1491)
HEBREW_LETTER_HE = chr(1492)
HEBREW_LETTER_VAV = chr(1493)
HEBREW_LETTER_ZAYIN = chr(1494)
HEBREW_LETTER_HET = chr(1495)
HEBREW_LETTER_TET = chr(1496)
HEBREW_LETTER_YOD = chr(1497)
HEBREW_LETTER_FINAL_KAF = chr(1498)
HEBREW_LETTER_KAF = chr(1499)
HEBREW_LETTER_LAMED = chr(1500)
HEBREW_LETTER_FINAL_MEM = chr(1501)
HEBREW_LETTER_MEM = chr(1502)
HEBREW_LETTER_FINAL_NUN = chr(1503)
HEBREW_LETTER_NUN = chr(1504)
HEBREW_LETTER_SAMEKH = chr(1505)
HEBREW_LETTER_AYIN = chr(1506)
HEBREW_LETTER_FINAL_PE = chr(1507)
HEBREW_LETTER_PE = chr(1508)
HEBREW_LETTER_FINAL_TSADI = chr(1509)
HEBREW_LETTER_TSADI = chr(1510)
HEBREW_LETTER_QOF = chr(1511)
HEBREW_LETTER_RESH = chr(1512)
HEBREW_LETTER_SHIN = chr(1513)
HEBREW_LETTER_TAV = chr(1514)
HEBREW_YOD_TRIANGLE = chr(1519)
HEBREW_LIGATURE_YIDDISH_DOUBLE_VAV = chr(1520)
HEBREW_LIGATURE_YIDDISH_VAV_YOD = chr(1521)
HEBREW_LIGATURE_YIDDISH_DOUBLE_YOD = chr(1522)
HEBREW_PUNCTUATION_GERESH = chr(1523)
HEBREW_PUNCTUATION_GERSHAYIM = chr(1524)
ARABIC_NUMBER_SIGN = chr(1536)
ARABIC_SIGN_SANAH = chr(1537)
ARABIC_FOOTNOTE_MARKER = chr(1538)
ARABIC_SIGN_SAFHA = chr(1539)
ARABIC_SIGN_SAMVAT = chr(1540)
ARABIC_NUMBER_MARK_ABOVE = chr(1541)
ARABIC_INDIC_CUBE_ROOT = chr(1542)
ARABIC_INDIC_FOURTH_ROOT = chr(1543)
ARABIC_RAY = chr(1544)
ARABIC_INDIC_PER_MILLE_SIGN = chr(1545)
ARABIC_INDIC_PER_TEN_THOUSAND_SIGN = chr(1546)
AFGHANI_SIGN = chr(1547)
ARABIC_COMMA = chr(1548)
ARABIC_DATE_SEPARATOR = chr(1549)
ARABIC_POETIC_VERSE_SIGN = chr(1550)
ARABIC_SIGN_MISRA = chr(1551)
ARABIC_SIGN_SALLALLAHOU_ALAYHE_WASSALLAM = chr(1552)
ARABIC_SIGN_ALAYHE_ASSALLAM = chr(1553)
ARABIC_SIGN_RAHMATULLAH_ALAYHE = chr(1554)
ARABIC_SIGN_RADI_ALLAHOU_ANHU = chr(1555)
ARABIC_SIGN_TAKHALLUS = chr(1556)
ARABIC_SMALL_HIGH_TAH = chr(1557)
ARABIC_SMALL_HIGH_LIGATURE_ALEF_WITH_LAM_WITH_YEH = chr(1558)
ARABIC_SMALL_HIGH_ZAIN = chr(1559)
ARABIC_SMALL_FATHA = chr(1560)
ARABIC_SMALL_DAMMA = chr(1561)
ARABIC_SMALL_KASRA = chr(1562)
ARABIC_SEMICOLON = chr(1563)
ARABIC_LETTER_MARK = chr(1564)
ARABIC_END_OF_TEXT_MARK = chr(1565)
ARABIC_TRIPLE_DOT_PUNCTUATION_MARK = chr(1566)
ARABIC_QUESTION_MARK = chr(1567)
ARABIC_LETTER_KASHMIRI_YEH = chr(1568)
ARABIC_LETTER_HAMZA = chr(1569)
ARABIC_LETTER_ALEF_WITH_MADDA_ABOVE = chr(1570)
ARABIC_LETTER_ALEF_WITH_HAMZA_ABOVE = chr(1571)
ARABIC_LETTER_WAW_WITH_HAMZA_ABOVE = chr(1572)
ARABIC_LETTER_ALEF_WITH_HAMZA_BELOW = chr(1573)
ARABIC_LETTER_YEH_WITH_HAMZA_ABOVE = chr(1574)
ARABIC_LETTER_ALEF = chr(1575)
ARABIC_LETTER_BEH = chr(1576)
ARABIC_LETTER_TEH_MARBUTA = chr(1577)
ARABIC_LETTER_TEH = chr(1578)
ARABIC_LETTER_THEH = chr(1579)
ARABIC_LETTER_JEEM = chr(1580)
ARABIC_LETTER_HAH = chr(1581)
ARABIC_LETTER_KHAH = chr(1582)
ARABIC_LETTER_DAL = chr(1583)
ARABIC_LETTER_THAL = chr(1584)
ARABIC_LETTER_REH = chr(1585)
ARABIC_LETTER_ZAIN = chr(1586)
ARABIC_LETTER_SEEN = chr(1587)
ARABIC_LETTER_SHEEN = chr(1588)
ARABIC_LETTER_SAD = chr(1589)
ARABIC_LETTER_DAD = chr(1590)
ARABIC_LETTER_TAH = chr(1591)
ARABIC_LETTER_ZAH = chr(1592)
ARABIC_LETTER_AIN = chr(1593)
ARABIC_LETTER_GHAIN = chr(1594)
ARABIC_LETTER_KEHEH_WITH_TWO_DOTS_ABOVE = chr(1595)
ARABIC_LETTER_KEHEH_WITH_THREE_DOTS_BELOW = chr(1596)
ARABIC_LETTER_FARSI_YEH_WITH_INVERTED_V = chr(1597)
ARABIC_LETTER_FARSI_YEH_WITH_TWO_DOTS_ABOVE = chr(1598)
ARABIC_LETTER_FARSI_YEH_WITH_THREE_DOTS_ABOVE = chr(1599)
ARABIC_TATWEEL = chr(1600)
ARABIC_LETTER_FEH = chr(1601)
ARABIC_LETTER_QAF = chr(1602)
ARABIC_LETTER_KAF = chr(1603)
ARABIC_LETTER_LAM = chr(1604)
ARABIC_LETTER_MEEM = chr(1605)
ARABIC_LETTER_NOON = chr(1606)
ARABIC_LETTER_HEH = chr(1607)
ARABIC_LETTER_WAW = chr(1608)
ARABIC_LETTER_ALEF_MAKSURA = chr(1609)
ARABIC_LETTER_YEH = chr(1610)
ARABIC_FATHATAN = chr(1611)
ARABIC_DAMMATAN = chr(1612)
ARABIC_KASRATAN = chr(1613)
ARABIC_FATHA = chr(1614)
ARABIC_DAMMA = chr(1615)
ARABIC_KASRA = chr(1616)
ARABIC_SHADDA = chr(1617)
ARABIC_SUKUN = chr(1618)
ARABIC_MADDAH_ABOVE = chr(1619)
ARABIC_HAMZA_ABOVE = chr(1620)
ARABIC_HAMZA_BELOW = chr(1621)
ARABIC_SUBSCRIPT_ALEF = chr(1622)
ARABIC_INVERTED_DAMMA = chr(1623)
ARABIC_MARK_NOON_GHUNNA = chr(1624)
ARABIC_ZWARAKAY = chr(1625)
ARABIC_VOWEL_SIGN_SMALL_V_ABOVE = chr(1626)
ARABIC_VOWEL_SIGN_INVERTED_SMALL_V_ABOVE = chr(1627)
ARABIC_VOWEL_SIGN_DOT_BELOW = chr(1628)
ARABIC_REVERSED_DAMMA = chr(1629)
ARABIC_FATHA_WITH_TWO_DOTS = chr(1630)
ARABIC_WAVY_HAMZA_BELOW = chr(1631)
ARABIC_INDIC_DIGIT_ZERO = chr(1632)
ARABIC_INDIC_DIGIT_ONE = chr(1633)
ARABIC_INDIC_DIGIT_TWO = chr(1634)
ARABIC_INDIC_DIGIT_THREE = chr(1635)
ARABIC_INDIC_DIGIT_FOUR = chr(1636)
ARABIC_INDIC_DIGIT_FIVE = chr(1637)
ARABIC_INDIC_DIGIT_SIX = chr(1638)
ARABIC_INDIC_DIGIT_SEVEN = chr(1639)
ARABIC_INDIC_DIGIT_EIGHT = chr(1640)
ARABIC_INDIC_DIGIT_NINE = chr(1641)
ARABIC_PERCENT_SIGN = chr(1642)
ARABIC_DECIMAL_SEPARATOR = chr(1643)
ARABIC_THOUSANDS_SEPARATOR = chr(1644)
ARABIC_FIVE_POINTED_STAR = chr(1645)
ARABIC_LETTER_DOTLESS_BEH = chr(1646)
ARABIC_LETTER_DOTLESS_QAF = chr(1647)
ARABIC_LETTER_SUPERSCRIPT_ALEF = chr(1648)
ARABIC_LETTER_ALEF_WASLA = chr(1649)
ARABIC_LETTER_ALEF_WITH_WAVY_HAMZA_ABOVE = chr(1650)
ARABIC_LETTER_ALEF_WITH_WAVY_HAMZA_BELOW = chr(1651)
ARABIC_LETTER_HIGH_HAMZA = chr(1652)
ARABIC_LETTER_HIGH_HAMZA_ALEF = chr(1653)
ARABIC_LETTER_HIGH_HAMZA_WAW = chr(1654)
ARABIC_LETTER_U_WITH_HAMZA_ABOVE = chr(1655)
ARABIC_LETTER_HIGH_HAMZA_YEH = chr(1656)
ARABIC_LETTER_TTEH = chr(1657)
ARABIC_LETTER_TTEHEH = chr(1658)
ARABIC_LETTER_BEEH = chr(1659)
ARABIC_LETTER_TEH_WITH_RING = chr(1660)
ARABIC_LETTER_TEH_WITH_THREE_DOTS_ABOVE_DOWNWARDS = chr(1661)
ARABIC_LETTER_PEH = chr(1662)
ARABIC_LETTER_TEHEH = chr(1663)
ARABIC_LETTER_BEHEH = chr(1664)
ARABIC_LETTER_HAH_WITH_HAMZA_ABOVE = chr(1665)
ARABIC_LETTER_HAH_WITH_TWO_DOTS_VERTICAL_ABOVE = chr(1666)
ARABIC_LETTER_NYEH = chr(1667)
ARABIC_LETTER_DYEH = chr(1668)
ARABIC_LETTER_HAH_WITH_THREE_DOTS_ABOVE = chr(1669)
ARABIC_LETTER_TCHEH = chr(1670)
ARABIC_LETTER_TCHEHEH = chr(1671)
ARABIC_LETTER_DDAL = chr(1672)
ARABIC_LETTER_DAL_WITH_RING = chr(1673)
ARABIC_LETTER_DAL_WITH_DOT_BELOW = chr(1674)
ARABIC_LETTER_DAL_WITH_DOT_BELOW_AND_SMALL_TAH = chr(1675)
ARABIC_LETTER_DAHAL = chr(1676)
ARABIC_LETTER_DDAHAL = chr(1677)
ARABIC_LETTER_DUL = chr(1678)
ARABIC_LETTER_DAL_WITH_THREE_DOTS_ABOVE_DOWNWARDS = chr(1679)
ARABIC_LETTER_DAL_WITH_FOUR_DOTS_ABOVE = chr(1680)
ARABIC_LETTER_RREH = chr(1681)
ARABIC_LETTER_REH_WITH_SMALL_V = chr(1682)
ARABIC_LETTER_REH_WITH_RING = chr(1683)
ARABIC_LETTER_REH_WITH_DOT_BELOW = chr(1684)
ARABIC_LETTER_REH_WITH_SMALL_V_BELOW = chr(1685)
ARABIC_LETTER_REH_WITH_DOT_BELOW_AND_DOT_ABOVE = chr(1686)
ARABIC_LETTER_REH_WITH_TWO_DOTS_ABOVE = chr(1687)
ARABIC_LETTER_JEH = chr(1688)
ARABIC_LETTER_REH_WITH_FOUR_DOTS_ABOVE = chr(1689)
ARABIC_LETTER_SEEN_WITH_DOT_BELOW_AND_DOT_ABOVE = chr(1690)
ARABIC_LETTER_SEEN_WITH_THREE_DOTS_BELOW = chr(1691)
ARABIC_LETTER_SEEN_WITH_THREE_DOTS_BELOW_AND_THREE_DOTS_ABOVE = chr(1692)
ARABIC_LETTER_SAD_WITH_TWO_DOTS_BELOW = chr(1693)
ARABIC_LETTER_SAD_WITH_THREE_DOTS_ABOVE = chr(1694)
ARABIC_LETTER_TAH_WITH_THREE_DOTS_ABOVE = chr(1695)
ARABIC_LETTER_AIN_WITH_THREE_DOTS_ABOVE = chr(1696)
ARABIC_LETTER_DOTLESS_FEH = chr(1697)
ARABIC_LETTER_FEH_WITH_DOT_MOVED_BELOW = chr(1698)
ARABIC_LETTER_FEH_WITH_DOT_BELOW = chr(1699)
ARABIC_LETTER_VEH = chr(1700)
ARABIC_LETTER_FEH_WITH_THREE_DOTS_BELOW = chr(1701)
ARABIC_LETTER_PEHEH = chr(1702)
ARABIC_LETTER_QAF_WITH_DOT_ABOVE = chr(1703)
ARABIC_LETTER_QAF_WITH_THREE_DOTS_ABOVE = chr(1704)
ARABIC_LETTER_KEHEH = chr(1705)
ARABIC_LETTER_SWASH_KAF = chr(1706)
ARABIC_LETTER_KAF_WITH_RING = chr(1707)
ARABIC_LETTER_KAF_WITH_DOT_ABOVE = chr(1708)
ARABIC_LETTER_NG = chr(1709)
ARABIC_LETTER_KAF_WITH_THREE_DOTS_BELOW = chr(1710)
ARABIC_LETTER_GAF = chr(1711)
ARABIC_LETTER_GAF_WITH_RING = chr(1712)
ARABIC_LETTER_NGOEH = chr(1713)
ARABIC_LETTER_GAF_WITH_TWO_DOTS_BELOW = chr(1714)
ARABIC_LETTER_GUEH = chr(1715)
ARABIC_LETTER_GAF_WITH_THREE_DOTS_ABOVE = chr(1716)
ARABIC_LETTER_LAM_WITH_SMALL_V = chr(1717)
ARABIC_LETTER_LAM_WITH_DOT_ABOVE = chr(1718)
ARABIC_LETTER_LAM_WITH_THREE_DOTS_ABOVE = chr(1719)
ARABIC_LETTER_LAM_WITH_THREE_DOTS_BELOW = chr(1720)
ARABIC_LETTER_NOON_WITH_DOT_BELOW = chr(1721)
ARABIC_LETTER_NOON_GHUNNA = chr(1722)
ARABIC_LETTER_RNOON = chr(1723)
ARABIC_LETTER_NOON_WITH_RING = chr(1724)
ARABIC_LETTER_NOON_WITH_THREE_DOTS_ABOVE = chr(1725)
ARABIC_LETTER_HEH_DOACHASHMEE = chr(1726)
ARABIC_LETTER_TCHEH_WITH_DOT_ABOVE = chr(1727)
ARABIC_LETTER_HEH_WITH_YEH_ABOVE = chr(1728)
ARABIC_LETTER_HEH_GOAL = chr(1729)
ARABIC_LETTER_HEH_GOAL_WITH_HAMZA_ABOVE = chr(1730)
ARABIC_LETTER_TEH_MARBUTA_GOAL = chr(1731)
ARABIC_LETTER_WAW_WITH_RING = chr(1732)
ARABIC_LETTER_KIRGHIZ_OE = chr(1733)
ARABIC_LETTER_OE = chr(1734)
ARABIC_LETTER_U = chr(1735)
ARABIC_LETTER_YU = chr(1736)
ARABIC_LETTER_KIRGHIZ_YU = chr(1737)
ARABIC_LETTER_WAW_WITH_TWO_DOTS_ABOVE = chr(1738)
ARABIC_LETTER_VE = chr(1739)
ARABIC_LETTER_FARSI_YEH = chr(1740)
ARABIC_LETTER_YEH_WITH_TAIL = chr(1741)
ARABIC_LETTER_YEH_WITH_SMALL_V = chr(1742)
ARABIC_LETTER_WAW_WITH_DOT_ABOVE = chr(1743)
ARABIC_LETTER_E = chr(1744)
ARABIC_LETTER_YEH_WITH_THREE_DOTS_BELOW = chr(1745)
ARABIC_LETTER_YEH_BARREE = chr(1746)
ARABIC_LETTER_YEH_BARREE_WITH_HAMZA_ABOVE = chr(1747)
ARABIC_FULL_STOP = chr(1748)
ARABIC_LETTER_AE = chr(1749)
ARABIC_SMALL_HIGH_LIGATURE_SAD_WITH_LAM_WITH_ALEF_MAKSURA = chr(1750)
ARABIC_SMALL_HIGH_LIGATURE_QAF_WITH_LAM_WITH_ALEF_MAKSURA = chr(1751)
ARABIC_SMALL_HIGH_MEEM_INITIAL_FORM = chr(1752)
ARABIC_SMALL_HIGH_LAM_ALEF = chr(1753)
ARABIC_SMALL_HIGH_JEEM = chr(1754)
ARABIC_SMALL_HIGH_THREE_DOTS = chr(1755)
ARABIC_SMALL_HIGH_SEEN = chr(1756)
ARABIC_END_OF_AYAH = chr(1757)
ARABIC_START_OF_RUB_EL_HIZB = chr(1758)
ARABIC_SMALL_HIGH_ROUNDED_ZERO = chr(1759)
ARABIC_SMALL_HIGH_UPRIGHT_RECTANGULAR_ZERO = chr(1760)
ARABIC_SMALL_HIGH_DOTLESS_HEAD_OF_KHAH = chr(1761)
ARABIC_SMALL_HIGH_MEEM_ISOLATED_FORM = chr(1762)
ARABIC_SMALL_LOW_SEEN = chr(1763)
ARABIC_SMALL_HIGH_MADDA = chr(1764)
ARABIC_SMALL_WAW = chr(1765)
ARABIC_SMALL_YEH = chr(1766)
ARABIC_SMALL_HIGH_YEH = chr(1767)
ARABIC_SMALL_HIGH_NOON = chr(1768)
ARABIC_PLACE_OF_SAJDAH = chr(1769)
ARABIC_EMPTY_CENTRE_LOW_STOP = chr(1770)
ARABIC_EMPTY_CENTRE_HIGH_STOP = chr(1771)
ARABIC_ROUNDED_HIGH_STOP_WITH_FILLED_CENTRE = chr(1772)
ARABIC_SMALL_LOW_MEEM = chr(1773)
ARABIC_LETTER_DAL_WITH_INVERTED_V = chr(1774)
ARABIC_LETTER_REH_WITH_INVERTED_V = chr(1775)
EXTENDED_ARABIC_INDIC_DIGIT_ZERO = chr(1776)
EXTENDED_ARABIC_INDIC_DIGIT_ONE = chr(1777)
EXTENDED_ARABIC_INDIC_DIGIT_TWO = chr(1778)
EXTENDED_ARABIC_INDIC_DIGIT_THREE = chr(1779)
EXTENDED_ARABIC_INDIC_DIGIT_FOUR = chr(1780)
EXTENDED_ARABIC_INDIC_DIGIT_FIVE = chr(1781)
EXTENDED_ARABIC_INDIC_DIGIT_SIX = chr(1782)
EXTENDED_ARABIC_INDIC_DIGIT_SEVEN = chr(1783)
EXTENDED_ARABIC_INDIC_DIGIT_EIGHT = chr(1784)
EXTENDED_ARABIC_INDIC_DIGIT_NINE = chr(1785)
ARABIC_LETTER_SHEEN_WITH_DOT_BELOW = chr(1786)
ARABIC_LETTER_DAD_WITH_DOT_BELOW = chr(1787)
ARABIC_LETTER_GHAIN_WITH_DOT_BELOW = chr(1788)
ARABIC_SIGN_SINDHI_AMPERSAND = chr(1789)
ARABIC_SIGN_SINDHI_POSTPOSITION_MEN = chr(1790)
ARABIC_LETTER_HEH_WITH_INVERTED_V = chr(1791)
SYRIAC_END_OF_PARAGRAPH = chr(1792)
SYRIAC_SUPRALINEAR_FULL_STOP = chr(1793)
SYRIAC_SUBLINEAR_FULL_STOP = chr(1794)
SYRIAC_SUPRALINEAR_COLON = chr(1795)
SYRIAC_SUBLINEAR_COLON = chr(1796)
SYRIAC_HORIZONTAL_COLON = chr(1797)
SYRIAC_COLON_SKEWED_LEFT = chr(1798)
SYRIAC_COLON_SKEWED_RIGHT = chr(1799)
SYRIAC_SUPRALINEAR_COLON_SKEWED_LEFT = chr(1800)
SYRIAC_SUBLINEAR_COLON_SKEWED_RIGHT = chr(1801)
SYRIAC_CONTRACTION = chr(1802)
SYRIAC_HARKLEAN_OBELUS = chr(1803)
SYRIAC_HARKLEAN_METOBELUS = chr(1804)
SYRIAC_HARKLEAN_ASTERISCUS = chr(1805)
SYRIAC_ABBREVIATION_MARK = chr(1807)
SYRIAC_LETTER_ALAPH = chr(1808)
SYRIAC_LETTER_SUPERSCRIPT_ALAPH = chr(1809)
SYRIAC_LETTER_BETH = chr(1810)
SYRIAC_LETTER_GAMAL = chr(1811)
SYRIAC_LETTER_GAMAL_GARSHUNI = chr(1812)
SYRIAC_LETTER_DALATH = chr(1813)
SYRIAC_LETTER_DOTLESS_DALATH_RISH = chr(1814)
SYRIAC_LETTER_HE = chr(1815)
SYRIAC_LETTER_WAW = chr(1816)
SYRIAC_LETTER_ZAIN = chr(1817)
SYRIAC_LETTER_HETH = chr(1818)
SYRIAC_LETTER_TETH = chr(1819)
SYRIAC_LETTER_TETH_GARSHUNI = chr(1820)
SYRIAC_LETTER_YUDH = chr(1821)
SYRIAC_LETTER_YUDH_HE = chr(1822)
SYRIAC_LETTER_KAPH = chr(1823)
SYRIAC_LETTER_LAMADH = chr(1824)
SYRIAC_LETTER_MIM = chr(1825)
SYRIAC_LETTER_NUN = chr(1826)
SYRIAC_LETTER_SEMKATH = chr(1827)
SYRIAC_LETTER_FINAL_SEMKATH = chr(1828)
SYRIAC_LETTER_E = chr(1829)
SYRIAC_LETTER_PE = chr(1830)
SYRIAC_LETTER_REVERSED_PE = chr(1831)
SYRIAC_LETTER_SADHE = chr(1832)
SYRIAC_LETTER_QAPH = chr(1833)
SYRIAC_LETTER_RISH = chr(1834)
SYRIAC_LETTER_SHIN = chr(1835)
SYRIAC_LETTER_TAW = chr(1836)
SYRIAC_LETTER_PERSIAN_BHETH = chr(1837)
SYRIAC_LETTER_PERSIAN_GHAMAL = chr(1838)
SYRIAC_LETTER_PERSIAN_DHALATH = chr(1839)
SYRIAC_PTHAHA_ABOVE = chr(1840)
SYRIAC_PTHAHA_BELOW = chr(1841)
SYRIAC_PTHAHA_DOTTED = chr(1842)
SYRIAC_ZQAPHA_ABOVE = chr(1843)
SYRIAC_ZQAPHA_BELOW = chr(1844)
SYRIAC_ZQAPHA_DOTTED = chr(1845)
SYRIAC_RBASA_ABOVE = chr(1846)
SYRIAC_RBASA_BELOW = chr(1847)
SYRIAC_DOTTED_ZLAMA_HORIZONTAL = chr(1848)
SYRIAC_DOTTED_ZLAMA_ANGULAR = chr(1849)
SYRIAC_HBASA_ABOVE = chr(1850)
SYRIAC_HBASA_BELOW = chr(1851)
SYRIAC_HBASA_ESASA_DOTTED = chr(1852)
SYRIAC_ESASA_ABOVE = chr(1853)
SYRIAC_ESASA_BELOW = chr(1854)
SYRIAC_RWAHA = chr(1855)
SYRIAC_FEMININE_DOT = chr(1856)
SYRIAC_QUSHSHAYA = chr(1857)
SYRIAC_RUKKAKHA = chr(1858)
SYRIAC_TWO_VERTICAL_DOTS_ABOVE = chr(1859)
SYRIAC_TWO_VERTICAL_DOTS_BELOW = chr(1860)
SYRIAC_THREE_DOTS_ABOVE = chr(1861)
SYRIAC_THREE_DOTS_BELOW = chr(1862)
SYRIAC_OBLIQUE_LINE_ABOVE = chr(1863)
SYRIAC_OBLIQUE_LINE_BELOW = chr(1864)
SYRIAC_MUSIC = chr(1865)
SYRIAC_BARREKH = chr(1866)
SYRIAC_LETTER_SOGDIAN_ZHAIN = chr(1869)
SYRIAC_LETTER_SOGDIAN_KHAPH = chr(1870)
SYRIAC_LETTER_SOGDIAN_FE = chr(1871)
ARABIC_LETTER_BEH_WITH_THREE_DOTS_HORIZONTALLY_BELOW = chr(1872)
ARABIC_LETTER_BEH_WITH_DOT_BELOW_AND_THREE_DOTS_ABOVE = chr(1873)
ARABIC_LETTER_BEH_WITH_THREE_DOTS_POINTING_UPWARDS_BELOW = chr(1874)
ARABIC_LETTER_BEH_WITH_THREE_DOTS_POINTING_UPWARDS_BELOW_AND_TWO_DOTS_ABOVE = chr(1875)
ARABIC_LETTER_BEH_WITH_TWO_DOTS_BELOW_AND_DOT_ABOVE = chr(1876)
ARABIC_LETTER_BEH_WITH_INVERTED_SMALL_V_BELOW = chr(1877)
ARABIC_LETTER_BEH_WITH_SMALL_V = chr(1878)
ARABIC_LETTER_HAH_WITH_TWO_DOTS_ABOVE = chr(1879)
ARABIC_LETTER_HAH_WITH_THREE_DOTS_POINTING_UPWARDS_BELOW = chr(1880)
ARABIC_LETTER_DAL_WITH_TWO_DOTS_VERTICALLY_BELOW_AND_SMALL_TAH = chr(1881)
ARABIC_LETTER_DAL_WITH_INVERTED_SMALL_V_BELOW = chr(1882)
ARABIC_LETTER_REH_WITH_STROKE = chr(1883)
ARABIC_LETTER_SEEN_WITH_FOUR_DOTS_ABOVE = chr(1884)
ARABIC_LETTER_AIN_WITH_TWO_DOTS_ABOVE = chr(1885)
ARABIC_LETTER_AIN_WITH_THREE_DOTS_POINTING_DOWNWARDS_ABOVE = chr(1886)
ARABIC_LETTER_AIN_WITH_TWO_DOTS_VERTICALLY_ABOVE = chr(1887)
ARABIC_LETTER_FEH_WITH_TWO_DOTS_BELOW = chr(1888)
ARABIC_LETTER_FEH_WITH_THREE_DOTS_POINTING_UPWARDS_BELOW = chr(1889)
ARABIC_LETTER_KEHEH_WITH_DOT_ABOVE = chr(1890)
ARABIC_LETTER_KEHEH_WITH_THREE_DOTS_ABOVE = chr(1891)
ARABIC_LETTER_KEHEH_WITH_THREE_DOTS_POINTING_UPWARDS_BELOW = chr(1892)
ARABIC_LETTER_MEEM_WITH_DOT_ABOVE = chr(1893)
ARABIC_LETTER_MEEM_WITH_DOT_BELOW = chr(1894)
ARABIC_LETTER_NOON_WITH_TWO_DOTS_BELOW = chr(1895)
ARABIC_LETTER_NOON_WITH_SMALL_TAH = chr(1896)
ARABIC_LETTER_NOON_WITH_SMALL_V = chr(1897)
ARABIC_LETTER_LAM_WITH_BAR = chr(1898)
ARABIC_LETTER_REH_WITH_TWO_DOTS_VERTICALLY_ABOVE = chr(1899)
ARABIC_LETTER_REH_WITH_HAMZA_ABOVE = chr(1900)
ARABIC_LETTER_SEEN_WITH_TWO_DOTS_VERTICALLY_ABOVE = chr(1901)
ARABIC_LETTER_HAH_WITH_SMALL_ARABIC_LETTER_TAH_BELOW = chr(1902)
ARABIC_LETTER_HAH_WITH_SMALL_ARABIC_LETTER_TAH_AND_TWO_DOTS = chr(1903)
ARABIC_LETTER_SEEN_WITH_SMALL_ARABIC_LETTER_TAH_AND_TWO_DOTS = chr(1904)
ARABIC_LETTER_REH_WITH_SMALL_ARABIC_LETTER_TAH_AND_TWO_DOTS = chr(1905)
ARABIC_LETTER_HAH_WITH_SMALL_ARABIC_LETTER_TAH_ABOVE = chr(1906)
ARABIC_LETTER_ALEF_WITH_EXTENDED_ARABIC_INDIC_DIGIT_TWO_ABOVE = chr(1907)
ARABIC_LETTER_ALEF_WITH_EXTENDED_ARABIC_INDIC_DIGIT_THREE_ABOVE = chr(1908)
ARABIC_LETTER_FARSI_YEH_WITH_EXTENDED_ARABIC_INDIC_DIGIT_TWO_ABOVE = chr(1909)
ARABIC_LETTER_FARSI_YEH_WITH_EXTENDED_ARABIC_INDIC_DIGIT_THREE_ABOVE = chr(1910)
ARABIC_LETTER_FARSI_YEH_WITH_EXTENDED_ARABIC_INDIC_DIGIT_FOUR_BELOW = chr(1911)
ARABIC_LETTER_WAW_WITH_EXTENDED_ARABIC_INDIC_DIGIT_TWO_ABOVE = chr(1912)
ARABIC_LETTER_WAW_WITH_EXTENDED_ARABIC_INDIC_DIGIT_THREE_ABOVE = chr(1913)
ARABIC_LETTER_YEH_BARREE_WITH_EXTENDED_ARABIC_INDIC_DIGIT_TWO_ABOVE = chr(1914)
ARABIC_LETTER_YEH_BARREE_WITH_EXTENDED_ARABIC_INDIC_DIGIT_THREE_ABOVE = chr(1915)
ARABIC_LETTER_HAH_WITH_EXTENDED_ARABIC_INDIC_DIGIT_FOUR_BELOW = chr(1916)
ARABIC_LETTER_SEEN_WITH_EXTENDED_ARABIC_INDIC_DIGIT_FOUR_ABOVE = chr(1917)
ARABIC_LETTER_SEEN_WITH_INVERTED_V = chr(1918)
ARABIC_LETTER_KAF_WITH_TWO_DOTS_ABOVE = chr(1919)
THAANA_LETTER_HAA = chr(1920)
THAANA_LETTER_SHAVIYANI = chr(1921)
THAANA_LETTER_NOONU = chr(1922)
THAANA_LETTER_RAA = chr(1923)
THAANA_LETTER_BAA = chr(1924)
THAANA_LETTER_LHAVIYANI = chr(1925)
THAANA_LETTER_KAAFU = chr(1926)
THAANA_LETTER_ALIFU = chr(1927)
THAANA_LETTER_VAAVU = chr(1928)
THAANA_LETTER_MEEMU = chr(1929)
THAANA_LETTER_FAAFU = chr(1930)
THAANA_LETTER_DHAALU = chr(1931)
THAANA_LETTER_THAA = chr(1932)
THAANA_LETTER_LAAMU = chr(1933)
THAANA_LETTER_GAAFU = chr(1934)
THAANA_LETTER_GNAVIYANI = chr(1935)
THAANA_LETTER_SEENU = chr(1936)
THAANA_LETTER_DAVIYANI = chr(1937)
THAANA_LETTER_ZAVIYANI = chr(1938)
THAANA_LETTER_TAVIYANI = chr(1939)
THAANA_LETTER_YAA = chr(1940)
THAANA_LETTER_PAVIYANI = chr(1941)
THAANA_LETTER_JAVIYANI = chr(1942)
THAANA_LETTER_CHAVIYANI = chr(1943)
THAANA_LETTER_TTAA = chr(1944)
THAANA_LETTER_HHAA = chr(1945)
THAANA_LETTER_KHAA = chr(1946)
THAANA_LETTER_THAALU = chr(1947)
THAANA_LETTER_ZAA = chr(1948)
THAANA_LETTER_SHEENU = chr(1949)
THAANA_LETTER_SAADHU = chr(1950)
THAANA_LETTER_DAADHU = chr(1951)
THAANA_LETTER_TO = chr(1952)
THAANA_LETTER_ZO = chr(1953)
THAANA_LETTER_AINU = chr(1954)
THAANA_LETTER_GHAINU = chr(1955)
THAANA_LETTER_QAAFU = chr(1956)
THAANA_LETTER_WAAVU = chr(1957)
THAANA_ABAFILI = chr(1958)
THAANA_AABAAFILI = chr(1959)
THAANA_IBIFILI = chr(1960)
THAANA_EEBEEFILI = chr(1961)
THAANA_UBUFILI = chr(1962)
THAANA_OOBOOFILI = chr(1963)
THAANA_EBEFILI = chr(1964)
THAANA_EYBEYFILI = chr(1965)
THAANA_OBOFILI = chr(1966)
THAANA_OABOAFILI = chr(1967)
THAANA_SUKUN = chr(1968)
THAANA_LETTER_NAA = chr(1969)
NKO_DIGIT_ZERO = chr(1984)
NKO_DIGIT_ONE = chr(1985)
NKO_DIGIT_TWO = chr(1986)
NKO_DIGIT_THREE = chr(1987)
NKO_DIGIT_FOUR = chr(1988)
NKO_DIGIT_FIVE = chr(1989)
NKO_DIGIT_SIX = chr(1990)
NKO_DIGIT_SEVEN = chr(1991)
NKO_DIGIT_EIGHT = chr(1992)
NKO_DIGIT_NINE = chr(1993)
NKO_LETTER_A = chr(1994)
NKO_LETTER_EE = chr(1995)
NKO_LETTER_I = chr(1996)
NKO_LETTER_E = chr(1997)
NKO_LETTER_U = chr(1998)
NKO_LETTER_OO = chr(1999)
NKO_LETTER_O = chr(2000)
NKO_LETTER_DAGBASINNA = chr(2001)
NKO_LETTER_N = chr(2002)
NKO_LETTER_BA = chr(2003)
NKO_LETTER_PA = chr(2004)
NKO_LETTER_TA = chr(2005)
NKO_LETTER_JA = chr(2006)
NKO_LETTER_CHA = chr(2007)
NKO_LETTER_DA = chr(2008)
NKO_LETTER_RA = chr(2009)
NKO_LETTER_RRA = chr(2010)
NKO_LETTER_SA = chr(2011)
NKO_LETTER_GBA = chr(2012)
NKO_LETTER_FA = chr(2013)
NKO_LETTER_KA = chr(2014)
NKO_LETTER_LA = chr(2015)
NKO_LETTER_NA_WOLOSO = chr(2016)
NKO_LETTER_MA = chr(2017)
NKO_LETTER_NYA = chr(2018)
NKO_LETTER_NA = chr(2019)
NKO_LETTER_HA = chr(2020)
NKO_LETTER_WA = chr(2021)
NKO_LETTER_YA = chr(2022)
NKO_LETTER_NYA_WOLOSO = chr(2023)
NKO_LETTER_JONA_JA = chr(2024)
NKO_LETTER_JONA_CHA = chr(2025)
NKO_LETTER_JONA_RA = chr(2026)
NKO_COMBINING_SHORT_HIGH_TONE = chr(2027)
NKO_COMBINING_SHORT_LOW_TONE = chr(2028)
NKO_COMBINING_SHORT_RISING_TONE = chr(2029)
NKO_COMBINING_LONG_DESCENDING_TONE = chr(2030)
NKO_COMBINING_LONG_HIGH_TONE = chr(2031)
NKO_COMBINING_LONG_LOW_TONE = chr(2032)
NKO_COMBINING_LONG_RISING_TONE = chr(2033)
NKO_COMBINING_NASALIZATION_MARK = chr(2034)
NKO_COMBINING_DOUBLE_DOT_ABOVE = chr(2035)
NKO_HIGH_TONE_APOSTROPHE = chr(2036)
NKO_LOW_TONE_APOSTROPHE = chr(2037)
NKO_SYMBOL_OO_DENNEN = chr(2038)
NKO_SYMBOL_GBAKURUNEN = chr(2039)
NKO_COMMA = chr(2040)
NKO_EXCLAMATION_MARK = chr(2041)
NKO_LAJANYALAN = chr(2042)
NKO_DANTAYALAN = chr(2045)
NKO_DOROME_SIGN = chr(2046)
NKO_TAMAN_SIGN = chr(2047)
SAMARITAN_LETTER_ALAF = chr(2048)
SAMARITAN_LETTER_BIT = chr(2049)
SAMARITAN_LETTER_GAMAN = chr(2050)
SAMARITAN_LETTER_DALAT = chr(2051)
SAMARITAN_LETTER_IY = chr(2052)
SAMARITAN_LETTER_BAA = chr(2053)
SAMARITAN_LETTER_ZEN = chr(2054)
SAMARITAN_LETTER_IT = chr(2055)
SAMARITAN_LETTER_TIT = chr(2056)
SAMARITAN_LETTER_YUT = chr(2057)
SAMARITAN_LETTER_KAAF = chr(2058)
SAMARITAN_LETTER_LABAT = chr(2059)
SAMARITAN_LETTER_MIM = chr(2060)
SAMARITAN_LETTER_NUN = chr(2061)
SAMARITAN_LETTER_SINGAAT = chr(2062)
SAMARITAN_LETTER_IN = chr(2063)
SAMARITAN_LETTER_FI = chr(2064)
SAMARITAN_LETTER_TSAADIY = chr(2065)
SAMARITAN_LETTER_QUF = chr(2066)
SAMARITAN_LETTER_RISH = chr(2067)
SAMARITAN_LETTER_SHAN = chr(2068)
SAMARITAN_LETTER_TAAF = chr(2069)
SAMARITAN_MARK_IN = chr(2070)
SAMARITAN_MARK_IN_ALAF = chr(2071)
SAMARITAN_MARK_OCCLUSION = chr(2072)
SAMARITAN_MARK_DAGESH = chr(2073)
SAMARITAN_MODIFIER_LETTER_EPENTHETIC_YUT = chr(2074)
SAMARITAN_MARK_EPENTHETIC_YUT = chr(2075)
SAMARITAN_VOWEL_SIGN_LONG_E = chr(2076)
SAMARITAN_VOWEL_SIGN_E = chr(2077)
SAMARITAN_VOWEL_SIGN_OVERLONG_AA = chr(2078)
SAMARITAN_VOWEL_SIGN_LONG_AA = chr(2079)
SAMARITAN_VOWEL_SIGN_AA = chr(2080)
SAMARITAN_VOWEL_SIGN_OVERLONG_A = chr(2081)
SAMARITAN_VOWEL_SIGN_LONG_A = chr(2082)
SAMARITAN_VOWEL_SIGN_A = chr(2083)
SAMARITAN_MODIFIER_LETTER_SHORT_A = chr(2084)
SAMARITAN_VOWEL_SIGN_SHORT_A = chr(2085)
SAMARITAN_VOWEL_SIGN_LONG_U = chr(2086)
SAMARITAN_VOWEL_SIGN_U = chr(2087)
SAMARITAN_MODIFIER_LETTER_I = chr(2088)
SAMARITAN_VOWEL_SIGN_LONG_I = chr(2089)
SAMARITAN_VOWEL_SIGN_I = chr(2090)
SAMARITAN_VOWEL_SIGN_O = chr(2091)
SAMARITAN_VOWEL_SIGN_SUKUN = chr(2092)
SAMARITAN_MARK_NEQUDAA = chr(2093)
SAMARITAN_PUNCTUATION_NEQUDAA = chr(2096)
SAMARITAN_PUNCTUATION_AFSAAQ = chr(2097)
SAMARITAN_PUNCTUATION_ANGED = chr(2098)
SAMARITAN_PUNCTUATION_BAU = chr(2099)
SAMARITAN_PUNCTUATION_ATMAAU = chr(2100)
SAMARITAN_PUNCTUATION_SHIYYAALAA = chr(2101)
SAMARITAN_ABBREVIATION_MARK = chr(2102)
SAMARITAN_PUNCTUATION_MELODIC_QITSA = chr(2103)
SAMARITAN_PUNCTUATION_ZIQAA = chr(2104)
SAMARITAN_PUNCTUATION_QITSA = chr(2105)
SAMARITAN_PUNCTUATION_ZAEF = chr(2106)
SAMARITAN_PUNCTUATION_TURU = chr(2107)
SAMARITAN_PUNCTUATION_ARKAANU = chr(2108)
SAMARITAN_PUNCTUATION_SOF_MASHFAAT = chr(2109)
SAMARITAN_PUNCTUATION_ANNAAU = chr(2110)
MANDAIC_LETTER_HALQA = chr(2112)
MANDAIC_LETTER_AB = chr(2113)
MANDAIC_LETTER_AG = chr(2114)
MANDAIC_LETTER_AD = chr(2115)
MANDAIC_LETTER_AH = chr(2116)
MANDAIC_LETTER_USHENNA = chr(2117)
MANDAIC_LETTER_AZ = chr(2118)
MANDAIC_LETTER_IT = chr(2119)
MANDAIC_LETTER_ATT = chr(2120)
MANDAIC_LETTER_AKSA = chr(2121)
MANDAIC_LETTER_AK = chr(2122)
MANDAIC_LETTER_AL = chr(2123)
MANDAIC_LETTER_AM = chr(2124)
MANDAIC_LETTER_AN = chr(2125)
MANDAIC_LETTER_AS = chr(2126)
MANDAIC_LETTER_IN = chr(2127)
MANDAIC_LETTER_AP = chr(2128)
MANDAIC_LETTER_ASZ = chr(2129)
MANDAIC_LETTER_AQ = chr(2130)
MANDAIC_LETTER_AR = chr(2131)
MANDAIC_LETTER_ASH = chr(2132)
MANDAIC_LETTER_AT = chr(2133)
MANDAIC_LETTER_DUSHENNA = chr(2134)
MANDAIC_LETTER_KAD = chr(2135)
MANDAIC_LETTER_AIN = chr(2136)
MANDAIC_AFFRICATION_MARK = chr(2137)
MANDAIC_VOCALIZATION_MARK = chr(2138)
MANDAIC_GEMINATION_MARK = chr(2139)
MANDAIC_PUNCTUATION = chr(2142)
SYRIAC_LETTER_MALAYALAM_NGA = chr(2144)
SYRIAC_LETTER_MALAYALAM_JA = chr(2145)
SYRIAC_LETTER_MALAYALAM_NYA = chr(2146)
SYRIAC_LETTER_MALAYALAM_TTA = chr(2147)
SYRIAC_LETTER_MALAYALAM_NNA = chr(2148)
SYRIAC_LETTER_MALAYALAM_NNNA = chr(2149)
SYRIAC_LETTER_MALAYALAM_BHA = chr(2150)
SYRIAC_LETTER_MALAYALAM_RA = chr(2151)
SYRIAC_LETTER_MALAYALAM_LLA = chr(2152)
SYRIAC_LETTER_MALAYALAM_LLLA = chr(2153)
SYRIAC_LETTER_MALAYALAM_SSA = chr(2154)
ARABIC_LETTER_ALEF_WITH_ATTACHED_FATHA = chr(2160)
ARABIC_LETTER_ALEF_WITH_ATTACHED_TOP_RIGHT_FATHA = chr(2161)
ARABIC_LETTER_ALEF_WITH_RIGHT_MIDDLE_STROKE = chr(2162)
ARABIC_LETTER_ALEF_WITH_LEFT_MIDDLE_STROKE = chr(2163)
ARABIC_LETTER_ALEF_WITH_ATTACHED_KASRA = chr(2164)
ARABIC_LETTER_ALEF_WITH_ATTACHED_BOTTOM_RIGHT_KASRA = chr(2165)
ARABIC_LETTER_ALEF_WITH_ATTACHED_ROUND_DOT_ABOVE = chr(2166)
ARABIC_LETTER_ALEF_WITH_ATTACHED_RIGHT_ROUND_DOT = chr(2167)
ARABIC_LETTER_ALEF_WITH_ATTACHED_LEFT_ROUND_DOT = chr(2168)
ARABIC_LETTER_ALEF_WITH_ATTACHED_ROUND_DOT_BELOW = chr(2169)
ARABIC_LETTER_ALEF_WITH_DOT_ABOVE = chr(2170)
ARABIC_LETTER_ALEF_WITH_ATTACHED_TOP_RIGHT_FATHA_AND_DOT_ABOVE = chr(2171)
ARABIC_LETTER_ALEF_WITH_RIGHT_MIDDLE_STROKE_AND_DOT_ABOVE = chr(2172)
ARABIC_LETTER_ALEF_WITH_ATTACHED_BOTTOM_RIGHT_KASRA_AND_DOT_ABOVE = chr(2173)
ARABIC_LETTER_ALEF_WITH_ATTACHED_TOP_RIGHT_FATHA_AND_LEFT_RING = chr(2174)
ARABIC_LETTER_ALEF_WITH_RIGHT_MIDDLE_STROKE_AND_LEFT_RING = chr(2175)
ARABIC_LETTER_ALEF_WITH_ATTACHED_BOTTOM_RIGHT_KASRA_AND_LEFT_RING = chr(2176)
ARABIC_LETTER_ALEF_WITH_ATTACHED_RIGHT_HAMZA = chr(2177)
ARABIC_LETTER_ALEF_WITH_ATTACHED_LEFT_HAMZA = chr(2178)
ARABIC_TATWEEL_WITH_OVERSTRUCK_HAMZA = chr(2179)
ARABIC_TATWEEL_WITH_OVERSTRUCK_WAW = chr(2180)
ARABIC_TATWEEL_WITH_TWO_DOTS_BELOW = chr(2181)
ARABIC_LETTER_THIN_YEH = chr(2182)
ARABIC_BASELINE_ROUND_DOT = chr(2183)
ARABIC_RAISED_ROUND_DOT = chr(2184)
ARABIC_LETTER_NOON_WITH_INVERTED_SMALL_V = chr(2185)
ARABIC_LETTER_HAH_WITH_INVERTED_SMALL_V_BELOW = chr(2186)
ARABIC_LETTER_TAH_WITH_DOT_BELOW = chr(2187)
ARABIC_LETTER_TAH_WITH_THREE_DOTS_BELOW = chr(2188)
ARABIC_LETTER_KEHEH_WITH_TWO_DOTS_VERTICALLY_BELOW = chr(2189)
ARABIC_VERTICAL_TAIL = chr(2190)
ARABIC_POUND_MARK_ABOVE = chr(2192)
ARABIC_PIASTRE_MARK_ABOVE = chr(2193)
ARABIC_SMALL_HIGH_WORD_AL_JUZ = chr(2200)
ARABIC_SMALL_LOW_WORD_ISHMAAM = chr(2201)
ARABIC_SMALL_LOW_WORD_IMAALA = chr(2202)
ARABIC_SMALL_LOW_WORD_TASHEEL = chr(2203)
ARABIC_MADDA_WAAJIB = chr(2204)
ARABIC_SUPERSCRIPT_ALEF_MOKHASSAS = chr(2205)
ARABIC_DOUBLED_MADDA = chr(2206)
ARABIC_HALF_MADDA_OVER_MADDA = chr(2207)
ARABIC_LETTER_BEH_WITH_SMALL_V_BELOW = chr(2208)
ARABIC_LETTER_BEH_WITH_HAMZA_ABOVE = chr(2209)
ARABIC_LETTER_JEEM_WITH_TWO_DOTS_ABOVE = chr(2210)
ARABIC_LETTER_TAH_WITH_TWO_DOTS_ABOVE = chr(2211)
ARABIC_LETTER_FEH_WITH_DOT_BELOW_AND_THREE_DOTS_ABOVE = chr(2212)
ARABIC_LETTER_QAF_WITH_DOT_BELOW = chr(2213)
ARABIC_LETTER_LAM_WITH_DOUBLE_BAR = chr(2214)
ARABIC_LETTER_MEEM_WITH_THREE_DOTS_ABOVE = chr(2215)
ARABIC_LETTER_YEH_WITH_TWO_DOTS_BELOW_AND_HAMZA_ABOVE = chr(2216)
ARABIC_LETTER_YEH_WITH_TWO_DOTS_BELOW_AND_DOT_ABOVE = chr(2217)
ARABIC_LETTER_REH_WITH_LOOP = chr(2218)
ARABIC_LETTER_WAW_WITH_DOT_WITHIN = chr(2219)
ARABIC_LETTER_ROHINGYA_YEH = chr(2220)
ARABIC_LETTER_LOW_ALEF = chr(2221)
ARABIC_LETTER_DAL_WITH_THREE_DOTS_BELOW = chr(2222)
ARABIC_LETTER_SAD_WITH_THREE_DOTS_BELOW = chr(2223)
ARABIC_LETTER_GAF_WITH_INVERTED_STROKE = chr(2224)
ARABIC_LETTER_STRAIGHT_WAW = chr(2225)
ARABIC_LETTER_ZAIN_WITH_INVERTED_V_ABOVE = chr(2226)
ARABIC_LETTER_AIN_WITH_THREE_DOTS_BELOW = chr(2227)
ARABIC_LETTER_KAF_WITH_DOT_BELOW = chr(2228)
ARABIC_LETTER_QAF_WITH_DOT_BELOW_AND_NO_DOTS_ABOVE = chr(2229)
ARABIC_LETTER_BEH_WITH_SMALL_MEEM_ABOVE = chr(2230)
ARABIC_LETTER_PEH_WITH_SMALL_MEEM_ABOVE = chr(2231)
ARABIC_LETTER_TEH_WITH_SMALL_TEH_ABOVE = chr(2232)
ARABIC_LETTER_REH_WITH_SMALL_NOON_ABOVE = chr(2233)
ARABIC_LETTER_YEH_WITH_TWO_DOTS_BELOW_AND_SMALL_NOON_ABOVE = chr(2234)
ARABIC_LETTER_AFRICAN_FEH = chr(2235)
ARABIC_LETTER_AFRICAN_QAF = chr(2236)
ARABIC_LETTER_AFRICAN_NOON = chr(2237)
ARABIC_LETTER_PEH_WITH_SMALL_V = chr(2238)
ARABIC_LETTER_TEH_WITH_SMALL_V = chr(2239)
ARABIC_LETTER_TTEH_WITH_SMALL_V = chr(2240)
ARABIC_LETTER_TCHEH_WITH_SMALL_V = chr(2241)
ARABIC_LETTER_KEHEH_WITH_SMALL_V = chr(2242)
ARABIC_LETTER_GHAIN_WITH_THREE_DOTS_ABOVE = chr(2243)
ARABIC_LETTER_AFRICAN_QAF_WITH_THREE_DOTS_ABOVE = chr(2244)
ARABIC_LETTER_JEEM_WITH_THREE_DOTS_ABOVE = chr(2245)
ARABIC_LETTER_JEEM_WITH_THREE_DOTS_BELOW = chr(2246)
ARABIC_LETTER_LAM_WITH_SMALL_ARABIC_LETTER_TAH_ABOVE = chr(2247)
ARABIC_LETTER_GRAF = chr(2248)
ARABIC_SMALL_FARSI_YEH = chr(2249)
ARABIC_SMALL_HIGH_FARSI_YEH = chr(2250)
ARABIC_SMALL_HIGH_YEH_BARREE_WITH_TWO_DOTS_BELOW = chr(2251)
ARABIC_SMALL_HIGH_WORD_SAH = chr(2252)
ARABIC_SMALL_HIGH_ZAH = chr(2253)
ARABIC_LARGE_ROUND_DOT_ABOVE = chr(2254)
ARABIC_LARGE_ROUND_DOT_BELOW = chr(2255)
ARABIC_SUKUN_BELOW = chr(2256)
ARABIC_LARGE_CIRCLE_BELOW = chr(2257)
ARABIC_LARGE_ROUND_DOT_INSIDE_CIRCLE_BELOW = chr(2258)
ARABIC_SMALL_LOW_WAW = chr(2259)
ARABIC_SMALL_HIGH_WORD_AR_RUB = chr(2260)
ARABIC_SMALL_HIGH_SAD = chr(2261)
ARABIC_SMALL_HIGH_AIN = chr(2262)
ARABIC_SMALL_HIGH_QAF = chr(2263)
ARABIC_SMALL_HIGH_NOON_WITH_KASRA = chr(2264)
ARABIC_SMALL_LOW_NOON_WITH_KASRA = chr(2265)
ARABIC_SMALL_HIGH_WORD_ATH_THALATHA = chr(2266)
ARABIC_SMALL_HIGH_WORD_AS_SAJDA = chr(2267)
ARABIC_SMALL_HIGH_WORD_AN_NISF = chr(2268)
ARABIC_SMALL_HIGH_WORD_SAKTA = chr(2269)
ARABIC_SMALL_HIGH_WORD_QIF = chr(2270)
ARABIC_SMALL_HIGH_WORD_WAQFA = chr(2271)
ARABIC_SMALL_HIGH_FOOTNOTE_MARKER = chr(2272)
ARABIC_SMALL_HIGH_SIGN_SAFHA = chr(2273)
ARABIC_DISPUTED_END_OF_AYAH = chr(2274)
ARABIC_TURNED_DAMMA_BELOW = chr(2275)
ARABIC_CURLY_FATHA = chr(2276)
ARABIC_CURLY_DAMMA = chr(2277)
ARABIC_CURLY_KASRA = chr(2278)
ARABIC_CURLY_FATHATAN = chr(2279)
ARABIC_CURLY_DAMMATAN = chr(2280)
ARABIC_CURLY_KASRATAN = chr(2281)
ARABIC_TONE_ONE_DOT_ABOVE = chr(2282)
ARABIC_TONE_TWO_DOTS_ABOVE = chr(2283)
ARABIC_TONE_LOOP_ABOVE = chr(2284)
ARABIC_TONE_ONE_DOT_BELOW = chr(2285)
ARABIC_TONE_TWO_DOTS_BELOW = chr(2286)
ARABIC_TONE_LOOP_BELOW = chr(2287)
ARABIC_OPEN_FATHATAN = chr(2288)
ARABIC_OPEN_DAMMATAN = chr(2289)
ARABIC_OPEN_KASRATAN = chr(2290)
ARABIC_SMALL_HIGH_WAW = chr(2291)
ARABIC_FATHA_WITH_RING = chr(2292)
ARABIC_FATHA_WITH_DOT_ABOVE = chr(2293)
ARABIC_KASRA_WITH_DOT_BELOW = chr(2294)
ARABIC_LEFT_ARROWHEAD_ABOVE = chr(2295)
ARABIC_RIGHT_ARROWHEAD_ABOVE = chr(2296)
ARABIC_LEFT_ARROWHEAD_BELOW = chr(2297)
ARABIC_RIGHT_ARROWHEAD_BELOW = chr(2298)
ARABIC_DOUBLE_RIGHT_ARROWHEAD_ABOVE = chr(2299)
ARABIC_DOUBLE_RIGHT_ARROWHEAD_ABOVE_WITH_DOT = chr(2300)
ARABIC_RIGHT_ARROWHEAD_ABOVE_WITH_DOT = chr(2301)
ARABIC_DAMMA_WITH_DOT = chr(2302)
ARABIC_MARK_SIDEWAYS_NOON_GHUNNA = chr(2303)
DEVANAGARI_SIGN_INVERTED_CANDRABINDU = chr(2304)
DEVANAGARI_SIGN_CANDRABINDU = chr(2305)
DEVANAGARI_SIGN_ANUSVARA = chr(2306)
DEVANAGARI_SIGN_VISARGA = chr(2307)
DEVANAGARI_LETTER_SHORT_A = chr(2308)
DEVANAGARI_LETTER_A = chr(2309)
DEVANAGARI_LETTER_AA = chr(2310)
DEVANAGARI_LETTER_I = chr(2311)
DEVANAGARI_LETTER_II = chr(2312)
DEVANAGARI_LETTER_U = chr(2313)
DEVANAGARI_LETTER_UU = chr(2314)
DEVANAGARI_LETTER_VOCALIC_R = chr(2315)
DEVANAGARI_LETTER_VOCALIC_L = chr(2316)
DEVANAGARI_LETTER_CANDRA_E = chr(2317)
DEVANAGARI_LETTER_SHORT_E = chr(2318)
DEVANAGARI_LETTER_E = chr(2319)
DEVANAGARI_LETTER_AI = chr(2320)
DEVANAGARI_LETTER_CANDRA_O = chr(2321)
DEVANAGARI_LETTER_SHORT_O = chr(2322)
DEVANAGARI_LETTER_O = chr(2323)
DEVANAGARI_LETTER_AU = chr(2324)
DEVANAGARI_LETTER_KA = chr(2325)
DEVANAGARI_LETTER_KHA = chr(2326)
DEVANAGARI_LETTER_GA = chr(2327)
DEVANAGARI_LETTER_GHA = chr(2328)
DEVANAGARI_LETTER_NGA = chr(2329)
DEVANAGARI_LETTER_CA = chr(2330)
DEVANAGARI_LETTER_CHA = chr(2331)
DEVANAGARI_LETTER_JA = chr(2332)
DEVANAGARI_LETTER_JHA = chr(2333)
DEVANAGARI_LETTER_NYA = chr(2334)
DEVANAGARI_LETTER_TTA = chr(2335)
DEVANAGARI_LETTER_TTHA = chr(2336)
DEVANAGARI_LETTER_DDA = chr(2337)
DEVANAGARI_LETTER_DDHA = chr(2338)
DEVANAGARI_LETTER_NNA = chr(2339)
DEVANAGARI_LETTER_TA = chr(2340)
DEVANAGARI_LETTER_THA = chr(2341)
DEVANAGARI_LETTER_DA = chr(2342)
DEVANAGARI_LETTER_DHA = chr(2343)
DEVANAGARI_LETTER_NA = chr(2344)
DEVANAGARI_LETTER_NNNA = chr(2345)
DEVANAGARI_LETTER_PA = chr(2346)
DEVANAGARI_LETTER_PHA = chr(2347)
DEVANAGARI_LETTER_BA = chr(2348)
DEVANAGARI_LETTER_BHA = chr(2349)
DEVANAGARI_LETTER_MA = chr(2350)
DEVANAGARI_LETTER_YA = chr(2351)
DEVANAGARI_LETTER_RA = chr(2352)
DEVANAGARI_LETTER_RRA = chr(2353)
DEVANAGARI_LETTER_LA = chr(2354)
DEVANAGARI_LETTER_LLA = chr(2355)
DEVANAGARI_LETTER_LLLA = chr(2356)
DEVANAGARI_LETTER_VA = chr(2357)
DEVANAGARI_LETTER_SHA = chr(2358)
DEVANAGARI_LETTER_SSA = chr(2359)
DEVANAGARI_LETTER_SA = chr(2360)
DEVANAGARI_LETTER_HA = chr(2361)
DEVANAGARI_VOWEL_SIGN_OE = chr(2362)
DEVANAGARI_VOWEL_SIGN_OOE = chr(2363)
DEVANAGARI_SIGN_NUKTA = chr(2364)
DEVANAGARI_SIGN_AVAGRAHA = chr(2365)
DEVANAGARI_VOWEL_SIGN_AA = chr(2366)
DEVANAGARI_VOWEL_SIGN_I = chr(2367)
DEVANAGARI_VOWEL_SIGN_II = chr(2368)
DEVANAGARI_VOWEL_SIGN_U = chr(2369)
DEVANAGARI_VOWEL_SIGN_UU = chr(2370)
DEVANAGARI_VOWEL_SIGN_VOCALIC_R = chr(2371)
DEVANAGARI_VOWEL_SIGN_VOCALIC_RR = chr(2372)
DEVANAGARI_VOWEL_SIGN_CANDRA_E = chr(2373)
DEVANAGARI_VOWEL_SIGN_SHORT_E = chr(2374)
DEVANAGARI_VOWEL_SIGN_E = chr(2375)
DEVANAGARI_VOWEL_SIGN_AI = chr(2376)
DEVANAGARI_VOWEL_SIGN_CANDRA_O = chr(2377)
DEVANAGARI_VOWEL_SIGN_SHORT_O = chr(2378)
DEVANAGARI_VOWEL_SIGN_O = chr(2379)
DEVANAGARI_VOWEL_SIGN_AU = chr(2380)
DEVANAGARI_SIGN_VIRAMA = chr(2381)
DEVANAGARI_VOWEL_SIGN_PRISHTHAMATRA_E = chr(2382)
DEVANAGARI_VOWEL_SIGN_AW = chr(2383)
DEVANAGARI_OM = chr(2384)
DEVANAGARI_STRESS_SIGN_UDATTA = chr(2385)
DEVANAGARI_STRESS_SIGN_ANUDATTA = chr(2386)
DEVANAGARI_GRAVE_ACCENT = chr(2387)
DEVANAGARI_ACUTE_ACCENT = chr(2388)
DEVANAGARI_VOWEL_SIGN_CANDRA_LONG_E = chr(2389)
DEVANAGARI_VOWEL_SIGN_UE = chr(2390)
DEVANAGARI_VOWEL_SIGN_UUE = chr(2391)
DEVANAGARI_LETTER_QA = chr(2392)
DEVANAGARI_LETTER_KHHA = chr(2393)
DEVANAGARI_LETTER_GHHA = chr(2394)
DEVANAGARI_LETTER_ZA = chr(2395)
DEVANAGARI_LETTER_DDDHA = chr(2396)
DEVANAGARI_LETTER_RHA = chr(2397)
DEVANAGARI_LETTER_FA = chr(2398)
DEVANAGARI_LETTER_YYA = chr(2399)
DEVANAGARI_LETTER_VOCALIC_RR = chr(2400)
DEVANAGARI_LETTER_VOCALIC_LL = chr(2401)
DEVANAGARI_VOWEL_SIGN_VOCALIC_L = chr(2402)
DEVANAGARI_VOWEL_SIGN_VOCALIC_LL = chr(2403)
DEVANAGARI_DANDA = chr(2404)
DEVANAGARI_DOUBLE_DANDA = chr(2405)
DEVANAGARI_DIGIT_ZERO = chr(2406)
DEVANAGARI_DIGIT_ONE = chr(2407)
DEVANAGARI_DIGIT_TWO = chr(2408)
DEVANAGARI_DIGIT_THREE = chr(2409)
DEVANAGARI_DIGIT_FOUR = chr(2410)
DEVANAGARI_DIGIT_FIVE = chr(2411)
DEVANAGARI_DIGIT_SIX = chr(2412)
DEVANAGARI_DIGIT_SEVEN = chr(2413)
DEVANAGARI_DIGIT_EIGHT = chr(2414)
DEVANAGARI_DIGIT_NINE = chr(2415)
DEVANAGARI_ABBREVIATION_SIGN = chr(2416)
DEVANAGARI_SIGN_HIGH_SPACING_DOT = chr(2417)
DEVANAGARI_LETTER_CANDRA_A = chr(2418)
DEVANAGARI_LETTER_OE = chr(2419)
DEVANAGARI_LETTER_OOE = chr(2420)
DEVANAGARI_LETTER_AW = chr(2421)
DEVANAGARI_LETTER_UE = chr(2422)
DEVANAGARI_LETTER_UUE = chr(2423)
DEVANAGARI_LETTER_MARWARI_DDA = chr(2424)
DEVANAGARI_LETTER_ZHA = chr(2425)
DEVANAGARI_LETTER_HEAVY_YA = chr(2426)
DEVANAGARI_LETTER_GGA = chr(2427)
DEVANAGARI_LETTER_JJA = chr(2428)
DEVANAGARI_LETTER_GLOTTAL_STOP = chr(2429)
DEVANAGARI_LETTER_DDDA = chr(2430)
DEVANAGARI_LETTER_BBA = chr(2431)
BENGALI_ANJI = chr(2432)
BENGALI_SIGN_CANDRABINDU = chr(2433)
BENGALI_SIGN_ANUSVARA = chr(2434)
BENGALI_SIGN_VISARGA = chr(2435)
BENGALI_LETTER_A = chr(2437)
BENGALI_LETTER_AA = chr(2438)
BENGALI_LETTER_I = chr(2439)
BENGALI_LETTER_II = chr(2440)
BENGALI_LETTER_U = chr(2441)
BENGALI_LETTER_UU = chr(2442)
BENGALI_LETTER_VOCALIC_R = chr(2443)
BENGALI_LETTER_VOCALIC_L = chr(2444)
BENGALI_LETTER_E = chr(2447)
BENGALI_LETTER_AI = chr(2448)
BENGALI_LETTER_O = chr(2451)
BENGALI_LETTER_AU = chr(2452)
BENGALI_LETTER_KA = chr(2453)
BENGALI_LETTER_KHA = chr(2454)
BENGALI_LETTER_GA = chr(2455)
BENGALI_LETTER_GHA = chr(2456)
BENGALI_LETTER_NGA = chr(2457)
BENGALI_LETTER_CA = chr(2458)
BENGALI_LETTER_CHA = chr(2459)
BENGALI_LETTER_JA = chr(2460)
BENGALI_LETTER_JHA = chr(2461)
BENGALI_LETTER_NYA = chr(2462)
BENGALI_LETTER_TTA = chr(2463)
BENGALI_LETTER_TTHA = chr(2464)
BENGALI_LETTER_DDA = chr(2465)
BENGALI_LETTER_DDHA = chr(2466)
BENGALI_LETTER_NNA = chr(2467)
BENGALI_LETTER_TA = chr(2468)
BENGALI_LETTER_THA = chr(2469)
BENGALI_LETTER_DA = chr(2470)
BENGALI_LETTER_DHA = chr(2471)
BENGALI_LETTER_NA = chr(2472)
BENGALI_LETTER_PA = chr(2474)
BENGALI_LETTER_PHA = chr(2475)
BENGALI_LETTER_BA = chr(2476)
BENGALI_LETTER_BHA = chr(2477)
BENGALI_LETTER_MA = chr(2478)
BENGALI_LETTER_YA = chr(2479)
BENGALI_LETTER_RA = chr(2480)
BENGALI_LETTER_LA = chr(2482)
BENGALI_LETTER_SHA = chr(2486)
BENGALI_LETTER_SSA = chr(2487)
BENGALI_LETTER_SA = chr(2488)
BENGALI_LETTER_HA = chr(2489)
BENGALI_SIGN_NUKTA = chr(2492)
BENGALI_SIGN_AVAGRAHA = chr(2493)
BENGALI_VOWEL_SIGN_AA = chr(2494)
BENGALI_VOWEL_SIGN_I = chr(2495)
BENGALI_VOWEL_SIGN_II = chr(2496)
BENGALI_VOWEL_SIGN_U = chr(2497)
BENGALI_VOWEL_SIGN_UU = chr(2498)
BENGALI_VOWEL_SIGN_VOCALIC_R = chr(2499)
BENGALI_VOWEL_SIGN_VOCALIC_RR = chr(2500)
BENGALI_VOWEL_SIGN_E = chr(2503)
BENGALI_VOWEL_SIGN_AI = chr(2504)
BENGALI_VOWEL_SIGN_O = chr(2507)
BENGALI_VOWEL_SIGN_AU = chr(2508)
BENGALI_SIGN_VIRAMA = chr(2509)
BENGALI_LETTER_KHANDA_TA = chr(2510)
BENGALI_AU_LENGTH_MARK = chr(2519)
BENGALI_LETTER_RRA = chr(2524)
BENGALI_LETTER_RHA = chr(2525)
BENGALI_LETTER_YYA = chr(2527)
BENGALI_LETTER_VOCALIC_RR = chr(2528)
BENGALI_LETTER_VOCALIC_LL = chr(2529)
BENGALI_VOWEL_SIGN_VOCALIC_L = chr(2530)
BENGALI_VOWEL_SIGN_VOCALIC_LL = chr(2531)
BENGALI_DIGIT_ZERO = chr(2534)
BENGALI_DIGIT_ONE = chr(2535)
BENGALI_DIGIT_TWO = chr(2536)
BENGALI_DIGIT_THREE = chr(2537)
BENGALI_DIGIT_FOUR = chr(2538)
BENGALI_DIGIT_FIVE = chr(2539)
BENGALI_DIGIT_SIX = chr(2540)
BENGALI_DIGIT_SEVEN = chr(2541)
BENGALI_DIGIT_EIGHT = chr(2542)
BENGALI_DIGIT_NINE = chr(2543)
BENGALI_LETTER_RA_WITH_MIDDLE_DIAGONAL = chr(2544)
BENGALI_LETTER_RA_WITH_LOWER_DIAGONAL = chr(2545)
BENGALI_RUPEE_MARK = chr(2546)
BENGALI_RUPEE_SIGN = chr(2547)
BENGALI_CURRENCY_NUMERATOR_ONE = chr(2548)
BENGALI_CURRENCY_NUMERATOR_TWO = chr(2549)
BENGALI_CURRENCY_NUMERATOR_THREE = chr(2550)
BENGALI_CURRENCY_NUMERATOR_FOUR = chr(2551)
BENGALI_CURRENCY_NUMERATOR_ONE_LESS_THAN_THE_DENOMINATOR = chr(2552)
BENGALI_CURRENCY_DENOMINATOR_SIXTEEN = chr(2553)
BENGALI_ISSHAR = chr(2554)
BENGALI_GANDA_MARK = chr(2555)
BENGALI_LETTER_VEDIC_ANUSVARA = chr(2556)
BENGALI_ABBREVIATION_SIGN = chr(2557)
BENGALI_SANDHI_MARK = chr(2558)
GURMUKHI_SIGN_ADAK_BINDI = chr(2561)
GURMUKHI_SIGN_BINDI = chr(2562)
GURMUKHI_SIGN_VISARGA = chr(2563)
GURMUKHI_LETTER_A = chr(2565)
GURMUKHI_LETTER_AA = chr(2566)
GURMUKHI_LETTER_I = chr(2567)
GURMUKHI_LETTER_II = chr(2568)
GURMUKHI_LETTER_U = chr(2569)
GURMUKHI_LETTER_UU = chr(2570)
GURMUKHI_LETTER_EE = chr(2575)
GURMUKHI_LETTER_AI = chr(2576)
GURMUKHI_LETTER_OO = chr(2579)
GURMUKHI_LETTER_AU = chr(2580)
GURMUKHI_LETTER_KA = chr(2581)
GURMUKHI_LETTER_KHA = chr(2582)
GURMUKHI_LETTER_GA = chr(2583)
GURMUKHI_LETTER_GHA = chr(2584)
GURMUKHI_LETTER_NGA = chr(2585)
GURMUKHI_LETTER_CA = chr(2586)
GURMUKHI_LETTER_CHA = chr(2587)
GURMUKHI_LETTER_JA = chr(2588)
GURMUKHI_LETTER_JHA = chr(2589)
GURMUKHI_LETTER_NYA = chr(2590)
GURMUKHI_LETTER_TTA = chr(2591)
GURMUKHI_LETTER_TTHA = chr(2592)
GURMUKHI_LETTER_DDA = chr(2593)
GURMUKHI_LETTER_DDHA = chr(2594)
GURMUKHI_LETTER_NNA = chr(2595)
GURMUKHI_LETTER_TA = chr(2596)
GURMUKHI_LETTER_THA = chr(2597)
GURMUKHI_LETTER_DA = chr(2598)
GURMUKHI_LETTER_DHA = chr(2599)
GURMUKHI_LETTER_NA = chr(2600)
GURMUKHI_LETTER_PA = chr(2602)
GURMUKHI_LETTER_PHA = chr(2603)
GURMUKHI_LETTER_BA = chr(2604)
GURMUKHI_LETTER_BHA = chr(2605)
GURMUKHI_LETTER_MA = chr(2606)
GURMUKHI_LETTER_YA = chr(2607)
GURMUKHI_LETTER_RA = chr(2608)
GURMUKHI_LETTER_LA = chr(2610)
GURMUKHI_LETTER_LLA = chr(2611)
GURMUKHI_LETTER_VA = chr(2613)
GURMUKHI_LETTER_SHA = chr(2614)
GURMUKHI_LETTER_SA = chr(2616)
GURMUKHI_LETTER_HA = chr(2617)
GURMUKHI_SIGN_NUKTA = chr(2620)
GURMUKHI_VOWEL_SIGN_AA = chr(2622)
GURMUKHI_VOWEL_SIGN_I = chr(2623)
GURMUKHI_VOWEL_SIGN_II = chr(2624)
GURMUKHI_VOWEL_SIGN_U = chr(2625)
GURMUKHI_VOWEL_SIGN_UU = chr(2626)
GURMUKHI_VOWEL_SIGN_EE = chr(2631)
GURMUKHI_VOWEL_SIGN_AI = chr(2632)
GURMUKHI_VOWEL_SIGN_OO = chr(2635)
GURMUKHI_VOWEL_SIGN_AU = chr(2636)
GURMUKHI_SIGN_VIRAMA = chr(2637)
GURMUKHI_SIGN_UDAAT = chr(2641)
GURMUKHI_LETTER_KHHA = chr(2649)
GURMUKHI_LETTER_GHHA = chr(2650)
GURMUKHI_LETTER_ZA = chr(2651)
GURMUKHI_LETTER_RRA = chr(2652)
GURMUKHI_LETTER_FA = chr(2654)
GURMUKHI_DIGIT_ZERO = chr(2662)
GURMUKHI_DIGIT_ONE = chr(2663)
GURMUKHI_DIGIT_TWO = chr(2664)
GURMUKHI_DIGIT_THREE = chr(2665)
GURMUKHI_DIGIT_FOUR = chr(2666)
GURMUKHI_DIGIT_FIVE = chr(2667)
GURMUKHI_DIGIT_SIX = chr(2668)
GURMUKHI_DIGIT_SEVEN = chr(2669)
GURMUKHI_DIGIT_EIGHT = chr(2670)
GURMUKHI_DIGIT_NINE = chr(2671)
GURMUKHI_TIPPI = chr(2672)
GURMUKHI_ADDAK = chr(2673)
GURMUKHI_IRI = chr(2674)
GURMUKHI_URA = chr(2675)
GURMUKHI_EK_ONKAR = chr(2676)
GURMUKHI_SIGN_YAKASH = chr(2677)
GURMUKHI_ABBREVIATION_SIGN = chr(2678)
GUJARATI_SIGN_CANDRABINDU = chr(2689)
GUJARATI_SIGN_ANUSVARA = chr(2690)
GUJARATI_SIGN_VISARGA = chr(2691)
GUJARATI_LETTER_A = chr(2693)
GUJARATI_LETTER_AA = chr(2694)
GUJARATI_LETTER_I = chr(2695)
GUJARATI_LETTER_II = chr(2696)
GUJARATI_LETTER_U = chr(2697)
GUJARATI_LETTER_UU = chr(2698)
GUJARATI_LETTER_VOCALIC_R = chr(2699)
GUJARATI_LETTER_VOCALIC_L = chr(2700)
GUJARATI_VOWEL_CANDRA_E = chr(2701)
GUJARATI_LETTER_E = chr(2703)
GUJARATI_LETTER_AI = chr(2704)
GUJARATI_VOWEL_CANDRA_O = chr(2705)
GUJARATI_LETTER_O = chr(2707)
GUJARATI_LETTER_AU = chr(2708)
GUJARATI_LETTER_KA = chr(2709)
GUJARATI_LETTER_KHA = chr(2710)
GUJARATI_LETTER_GA = chr(2711)
GUJARATI_LETTER_GHA = chr(2712)
GUJARATI_LETTER_NGA = chr(2713)
GUJARATI_LETTER_CA = chr(2714)
GUJARATI_LETTER_CHA = chr(2715)
GUJARATI_LETTER_JA = chr(2716)
GUJARATI_LETTER_JHA = chr(2717)
GUJARATI_LETTER_NYA = chr(2718)
GUJARATI_LETTER_TTA = chr(2719)
GUJARATI_LETTER_TTHA = chr(2720)
GUJARATI_LETTER_DDA = chr(2721)
GUJARATI_LETTER_DDHA = chr(2722)
GUJARATI_LETTER_NNA = chr(2723)
GUJARATI_LETTER_TA = chr(2724)
GUJARATI_LETTER_THA = chr(2725)
GUJARATI_LETTER_DA = chr(2726)
GUJARATI_LETTER_DHA = chr(2727)
GUJARATI_LETTER_NA = chr(2728)
GUJARATI_LETTER_PA = chr(2730)
GUJARATI_LETTER_PHA = chr(2731)
GUJARATI_LETTER_BA = chr(2732)
GUJARATI_LETTER_BHA = chr(2733)
GUJARATI_LETTER_MA = chr(2734)
GUJARATI_LETTER_YA = chr(2735)
GUJARATI_LETTER_RA = chr(2736)
GUJARATI_LETTER_LA = chr(2738)
GUJARATI_LETTER_LLA = chr(2739)
GUJARATI_LETTER_VA = chr(2741)
GUJARATI_LETTER_SHA = chr(2742)
GUJARATI_LETTER_SSA = chr(2743)
GUJARATI_LETTER_SA = chr(2744)
GUJARATI_LETTER_HA = chr(2745)
GUJARATI_SIGN_NUKTA = chr(2748)
GUJARATI_SIGN_AVAGRAHA = chr(2749)
GUJARATI_VOWEL_SIGN_AA = chr(2750)
GUJARATI_VOWEL_SIGN_I = chr(2751)
GUJARATI_VOWEL_SIGN_II = chr(2752)
GUJARATI_VOWEL_SIGN_U = chr(2753)
GUJARATI_VOWEL_SIGN_UU = chr(2754)
GUJARATI_VOWEL_SIGN_VOCALIC_R = chr(2755)
GUJARATI_VOWEL_SIGN_VOCALIC_RR = chr(2756)
GUJARATI_VOWEL_SIGN_CANDRA_E = chr(2757)
GUJARATI_VOWEL_SIGN_E = chr(2759)
GUJARATI_VOWEL_SIGN_AI = chr(2760)
GUJARATI_VOWEL_SIGN_CANDRA_O = chr(2761)
GUJARATI_VOWEL_SIGN_O = chr(2763)
GUJARATI_VOWEL_SIGN_AU = chr(2764)
GUJARATI_SIGN_VIRAMA = chr(2765)
GUJARATI_OM = chr(2768)
GUJARATI_LETTER_VOCALIC_RR = chr(2784)
GUJARATI_LETTER_VOCALIC_LL = chr(2785)
GUJARATI_VOWEL_SIGN_VOCALIC_L = chr(2786)
GUJARATI_VOWEL_SIGN_VOCALIC_LL = chr(2787)
GUJARATI_DIGIT_ZERO = chr(2790)
GUJARATI_DIGIT_ONE = chr(2791)
GUJARATI_DIGIT_TWO = chr(2792)
GUJARATI_DIGIT_THREE = chr(2793)
GUJARATI_DIGIT_FOUR = chr(2794)
GUJARATI_DIGIT_FIVE = chr(2795)
GUJARATI_DIGIT_SIX = chr(2796)
GUJARATI_DIGIT_SEVEN = chr(2797)
GUJARATI_DIGIT_EIGHT = chr(2798)
GUJARATI_DIGIT_NINE = chr(2799)
GUJARATI_ABBREVIATION_SIGN = chr(2800)
GUJARATI_RUPEE_SIGN = chr(2801)
GUJARATI_LETTER_ZHA = chr(2809)
GUJARATI_SIGN_SUKUN = chr(2810)
GUJARATI_SIGN_SHADDA = chr(2811)
GUJARATI_SIGN_MADDAH = chr(2812)
GUJARATI_SIGN_THREE_DOT_NUKTA_ABOVE = chr(2813)
GUJARATI_SIGN_CIRCLE_NUKTA_ABOVE = chr(2814)
GUJARATI_SIGN_TWO_CIRCLE_NUKTA_ABOVE = chr(2815)
ORIYA_SIGN_CANDRABINDU = chr(2817)
ORIYA_SIGN_ANUSVARA = chr(2818)
ORIYA_SIGN_VISARGA = chr(2819)
ORIYA_LETTER_A = chr(2821)
ORIYA_LETTER_AA = chr(2822)
ORIYA_LETTER_I = chr(2823)
ORIYA_LETTER_II = chr(2824)
ORIYA_LETTER_U = chr(2825)
ORIYA_LETTER_UU = chr(2826)
ORIYA_LETTER_VOCALIC_R = chr(2827)
ORIYA_LETTER_VOCALIC_L = chr(2828)
ORIYA_LETTER_E = chr(2831)
ORIYA_LETTER_AI = chr(2832)
ORIYA_LETTER_O = chr(2835)
ORIYA_LETTER_AU = chr(2836)
ORIYA_LETTER_KA = chr(2837)
ORIYA_LETTER_KHA = chr(2838)
ORIYA_LETTER_GA = chr(2839)
ORIYA_LETTER_GHA = chr(2840)
ORIYA_LETTER_NGA = chr(2841)
ORIYA_LETTER_CA = chr(2842)
ORIYA_LETTER_CHA = chr(2843)
ORIYA_LETTER_JA = chr(2844)
ORIYA_LETTER_JHA = chr(2845)
ORIYA_LETTER_NYA = chr(2846)
ORIYA_LETTER_TTA = chr(2847)
ORIYA_LETTER_TTHA = chr(2848)
ORIYA_LETTER_DDA = chr(2849)
ORIYA_LETTER_DDHA = chr(2850)
ORIYA_LETTER_NNA = chr(2851)
ORIYA_LETTER_TA = chr(2852)
ORIYA_LETTER_THA = chr(2853)
ORIYA_LETTER_DA = chr(2854)
ORIYA_LETTER_DHA = chr(2855)
ORIYA_LETTER_NA = chr(2856)
ORIYA_LETTER_PA = chr(2858)
ORIYA_LETTER_PHA = chr(2859)
ORIYA_LETTER_BA = chr(2860)
ORIYA_LETTER_BHA = chr(2861)
ORIYA_LETTER_MA = chr(2862)
ORIYA_LETTER_YA = chr(2863)
ORIYA_LETTER_RA = chr(2864)
ORIYA_LETTER_LA = chr(2866)
ORIYA_LETTER_LLA = chr(2867)
ORIYA_LETTER_VA = chr(2869)
ORIYA_LETTER_SHA = chr(2870)
ORIYA_LETTER_SSA = chr(2871)
ORIYA_LETTER_SA = chr(2872)
ORIYA_LETTER_HA = chr(2873)
ORIYA_SIGN_NUKTA = chr(2876)
ORIYA_SIGN_AVAGRAHA = chr(2877)
ORIYA_VOWEL_SIGN_AA = chr(2878)
ORIYA_VOWEL_SIGN_I = chr(2879)
ORIYA_VOWEL_SIGN_II = chr(2880)
ORIYA_VOWEL_SIGN_U = chr(2881)
ORIYA_VOWEL_SIGN_UU = chr(2882)
ORIYA_VOWEL_SIGN_VOCALIC_R = chr(2883)
ORIYA_VOWEL_SIGN_VOCALIC_RR = chr(2884)
ORIYA_VOWEL_SIGN_E = chr(2887)
ORIYA_VOWEL_SIGN_AI = chr(2888)
ORIYA_VOWEL_SIGN_O = chr(2891)
ORIYA_VOWEL_SIGN_AU = chr(2892)
ORIYA_SIGN_VIRAMA = chr(2893)
ORIYA_SIGN_OVERLINE = chr(2901)
ORIYA_AI_LENGTH_MARK = chr(2902)
ORIYA_AU_LENGTH_MARK = chr(2903)
ORIYA_LETTER_RRA = chr(2908)
ORIYA_LETTER_RHA = chr(2909)
ORIYA_LETTER_YYA = chr(2911)
ORIYA_LETTER_VOCALIC_RR = chr(2912)
ORIYA_LETTER_VOCALIC_LL = chr(2913)
ORIYA_VOWEL_SIGN_VOCALIC_L = chr(2914)
ORIYA_VOWEL_SIGN_VOCALIC_LL = chr(2915)
ORIYA_DIGIT_ZERO = chr(2918)
ORIYA_DIGIT_ONE = chr(2919)
ORIYA_DIGIT_TWO = chr(2920)
ORIYA_DIGIT_THREE = chr(2921)
ORIYA_DIGIT_FOUR = chr(2922)
ORIYA_DIGIT_FIVE = chr(2923)
ORIYA_DIGIT_SIX = chr(2924)
ORIYA_DIGIT_SEVEN = chr(2925)
ORIYA_DIGIT_EIGHT = chr(2926)
ORIYA_DIGIT_NINE = chr(2927)
ORIYA_ISSHAR = chr(2928)
ORIYA_LETTER_WA = chr(2929)
ORIYA_FRACTION_ONE_QUARTER = chr(2930)
ORIYA_FRACTION_ONE_HALF = chr(2931)
ORIYA_FRACTION_THREE_QUARTERS = chr(2932)
ORIYA_FRACTION_ONE_SIXTEENTH = chr(2933)
ORIYA_FRACTION_ONE_EIGHTH = chr(2934)
ORIYA_FRACTION_THREE_SIXTEENTHS = chr(2935)
TAMIL_SIGN_ANUSVARA = chr(2946)
TAMIL_SIGN_VISARGA = chr(2947)
TAMIL_LETTER_A = chr(2949)
TAMIL_LETTER_AA = chr(2950)
TAMIL_LETTER_I = chr(2951)
TAMIL_LETTER_II = chr(2952)
TAMIL_LETTER_U = chr(2953)
TAMIL_LETTER_UU = chr(2954)
TAMIL_LETTER_E = chr(2958)
TAMIL_LETTER_EE = chr(2959)
TAMIL_LETTER_AI = chr(2960)
TAMIL_LETTER_O = chr(2962)
TAMIL_LETTER_OO = chr(2963)
TAMIL_LETTER_AU = chr(2964)
TAMIL_LETTER_KA = chr(2965)
TAMIL_LETTER_NGA = chr(2969)
TAMIL_LETTER_CA = chr(2970)
TAMIL_LETTER_JA = chr(2972)
TAMIL_LETTER_NYA = chr(2974)
TAMIL_LETTER_TTA = chr(2975)
TAMIL_LETTER_NNA = chr(2979)
TAMIL_LETTER_TA = chr(2980)
TAMIL_LETTER_NA = chr(2984)
TAMIL_LETTER_NNNA = chr(2985)
TAMIL_LETTER_PA = chr(2986)
TAMIL_LETTER_MA = chr(2990)
TAMIL_LETTER_YA = chr(2991)
TAMIL_LETTER_RA = chr(2992)
TAMIL_LETTER_RRA = chr(2993)
TAMIL_LETTER_LA = chr(2994)
TAMIL_LETTER_LLA = chr(2995)
TAMIL_LETTER_LLLA = chr(2996)
TAMIL_LETTER_VA = chr(2997)
TAMIL_LETTER_SHA = chr(2998)
TAMIL_LETTER_SSA = chr(2999)
TAMIL_LETTER_SA = chr(3000)
TAMIL_LETTER_HA = chr(3001)
TAMIL_VOWEL_SIGN_AA = chr(3006)
TAMIL_VOWEL_SIGN_I = chr(3007)
TAMIL_VOWEL_SIGN_II = chr(3008)
TAMIL_VOWEL_SIGN_U = chr(3009)
TAMIL_VOWEL_SIGN_UU = chr(3010)
TAMIL_VOWEL_SIGN_E = chr(3014)
TAMIL_VOWEL_SIGN_EE = chr(3015)
TAMIL_VOWEL_SIGN_AI = chr(3016)
TAMIL_VOWEL_SIGN_O = chr(3018)
TAMIL_VOWEL_SIGN_OO = chr(3019)
TAMIL_VOWEL_SIGN_AU = chr(3020)
TAMIL_SIGN_VIRAMA = chr(3021)
TAMIL_OM = chr(3024)
TAMIL_AU_LENGTH_MARK = chr(3031)
TAMIL_DIGIT_ZERO = chr(3046)
TAMIL_DIGIT_ONE = chr(3047)
TAMIL_DIGIT_TWO = chr(3048)
TAMIL_DIGIT_THREE = chr(3049)
TAMIL_DIGIT_FOUR = chr(3050)
TAMIL_DIGIT_FIVE = chr(3051)
TAMIL_DIGIT_SIX = chr(3052)
TAMIL_DIGIT_SEVEN = chr(3053)
TAMIL_DIGIT_EIGHT = chr(3054)
TAMIL_DIGIT_NINE = chr(3055)
TAMIL_NUMBER_TEN = chr(3056)
TAMIL_NUMBER_ONE_HUNDRED = chr(3057)
TAMIL_NUMBER_ONE_THOUSAND = chr(3058)
TAMIL_DAY_SIGN = chr(3059)
TAMIL_MONTH_SIGN = chr(3060)
TAMIL_YEAR_SIGN = chr(3061)
TAMIL_DEBIT_SIGN = chr(3062)
TAMIL_CREDIT_SIGN = chr(3063)
TAMIL_AS_ABOVE_SIGN = chr(3064)
TAMIL_RUPEE_SIGN = chr(3065)
TAMIL_NUMBER_SIGN = chr(3066)
TELUGU_SIGN_COMBINING_CANDRABINDU_ABOVE = chr(3072)
TELUGU_SIGN_CANDRABINDU = chr(3073)
TELUGU_SIGN_ANUSVARA = chr(3074)
TELUGU_SIGN_VISARGA = chr(3075)
TELUGU_SIGN_COMBINING_ANUSVARA_ABOVE = chr(3076)
TELUGU_LETTER_A = chr(3077)
TELUGU_LETTER_AA = chr(3078)
TELUGU_LETTER_I = chr(3079)
TELUGU_LETTER_II = chr(3080)
TELUGU_LETTER_U = chr(3081)
TELUGU_LETTER_UU = chr(3082)
TELUGU_LETTER_VOCALIC_R = chr(3083)
TELUGU_LETTER_VOCALIC_L = chr(3084)
TELUGU_LETTER_E = chr(3086)
TELUGU_LETTER_EE = chr(3087)
TELUGU_LETTER_AI = chr(3088)
TELUGU_LETTER_O = chr(3090)
TELUGU_LETTER_OO = chr(3091)
TELUGU_LETTER_AU = chr(3092)
TELUGU_LETTER_KA = chr(3093)
TELUGU_LETTER_KHA = chr(3094)
TELUGU_LETTER_GA = chr(3095)
TELUGU_LETTER_GHA = chr(3096)
TELUGU_LETTER_NGA = chr(3097)
TELUGU_LETTER_CA = chr(3098)
TELUGU_LETTER_CHA = chr(3099)
TELUGU_LETTER_JA = chr(3100)
TELUGU_LETTER_JHA = chr(3101)
TELUGU_LETTER_NYA = chr(3102)
TELUGU_LETTER_TTA = chr(3103)
TELUGU_LETTER_TTHA = chr(3104)
TELUGU_LETTER_DDA = chr(3105)
TELUGU_LETTER_DDHA = chr(3106)
TELUGU_LETTER_NNA = chr(3107)
TELUGU_LETTER_TA = chr(3108)
TELUGU_LETTER_THA = chr(3109)
TELUGU_LETTER_DA = chr(3110)
TELUGU_LETTER_DHA = chr(3111)
TELUGU_LETTER_NA = chr(3112)
TELUGU_LETTER_PA = chr(3114)
TELUGU_LETTER_PHA = chr(3115)
TELUGU_LETTER_BA = chr(3116)
TELUGU_LETTER_BHA = chr(3117)
TELUGU_LETTER_MA = chr(3118)
TELUGU_LETTER_YA = chr(3119)
TELUGU_LETTER_RA = chr(3120)
TELUGU_LETTER_RRA = chr(3121)
TELUGU_LETTER_LA = chr(3122)
TELUGU_LETTER_LLA = chr(3123)
TELUGU_LETTER_LLLA = chr(3124)
TELUGU_LETTER_VA = chr(3125)
TELUGU_LETTER_SHA = chr(3126)
TELUGU_LETTER_SSA = chr(3127)
TELUGU_LETTER_SA = chr(3128)
TELUGU_LETTER_HA = chr(3129)
TELUGU_SIGN_NUKTA = chr(3132)
TELUGU_SIGN_AVAGRAHA = chr(3133)
TELUGU_VOWEL_SIGN_AA = chr(3134)
TELUGU_VOWEL_SIGN_I = chr(3135)
TELUGU_VOWEL_SIGN_II = chr(3136)
TELUGU_VOWEL_SIGN_U = chr(3137)
TELUGU_VOWEL_SIGN_UU = chr(3138)
TELUGU_VOWEL_SIGN_VOCALIC_R = chr(3139)
TELUGU_VOWEL_SIGN_VOCALIC_RR = chr(3140)
TELUGU_VOWEL_SIGN_E = chr(3142)
TELUGU_VOWEL_SIGN_EE = chr(3143)
TELUGU_VOWEL_SIGN_AI = chr(3144)
TELUGU_VOWEL_SIGN_O = chr(3146)
TELUGU_VOWEL_SIGN_OO = chr(3147)
TELUGU_VOWEL_SIGN_AU = chr(3148)
TELUGU_SIGN_VIRAMA = chr(3149)
TELUGU_LENGTH_MARK = chr(3157)
TELUGU_AI_LENGTH_MARK = chr(3158)
TELUGU_LETTER_TSA = chr(3160)
TELUGU_LETTER_DZA = chr(3161)
TELUGU_LETTER_RRRA = chr(3162)
TELUGU_LETTER_NAKAARA_POLLU = chr(3165)
TELUGU_LETTER_VOCALIC_RR = chr(3168)
TELUGU_LETTER_VOCALIC_LL = chr(3169)
TELUGU_VOWEL_SIGN_VOCALIC_L = chr(3170)
TELUGU_VOWEL_SIGN_VOCALIC_LL = chr(3171)
TELUGU_DIGIT_ZERO = chr(3174)
TELUGU_DIGIT_ONE = chr(3175)
TELUGU_DIGIT_TWO = chr(3176)
TELUGU_DIGIT_THREE = chr(3177)
TELUGU_DIGIT_FOUR = chr(3178)
TELUGU_DIGIT_FIVE = chr(3179)
TELUGU_DIGIT_SIX = chr(3180)
TELUGU_DIGIT_SEVEN = chr(3181)
TELUGU_DIGIT_EIGHT = chr(3182)
TELUGU_DIGIT_NINE = chr(3183)
TELUGU_SIGN_SIDDHAM = chr(3191)
TELUGU_FRACTION_DIGIT_ZERO_FOR_ODD_POWERS_OF_FOUR = chr(3192)
TELUGU_FRACTION_DIGIT_ONE_FOR_ODD_POWERS_OF_FOUR = chr(3193)
TELUGU_FRACTION_DIGIT_TWO_FOR_ODD_POWERS_OF_FOUR = chr(3194)
TELUGU_FRACTION_DIGIT_THREE_FOR_ODD_POWERS_OF_FOUR = chr(3195)
TELUGU_FRACTION_DIGIT_ONE_FOR_EVEN_POWERS_OF_FOUR = chr(3196)
TELUGU_FRACTION_DIGIT_TWO_FOR_EVEN_POWERS_OF_FOUR = chr(3197)
TELUGU_FRACTION_DIGIT_THREE_FOR_EVEN_POWERS_OF_FOUR = chr(3198)
TELUGU_SIGN_TUUMU = chr(3199)
KANNADA_SIGN_SPACING_CANDRABINDU = chr(3200)
KANNADA_SIGN_CANDRABINDU = chr(3201)
KANNADA_SIGN_ANUSVARA = chr(3202)
KANNADA_SIGN_VISARGA = chr(3203)
KANNADA_SIGN_SIDDHAM = chr(3204)
KANNADA_LETTER_A = chr(3205)
KANNADA_LETTER_AA = chr(3206)
KANNADA_LETTER_I = chr(3207)
KANNADA_LETTER_II = chr(3208)
KANNADA_LETTER_U = chr(3209)
KANNADA_LETTER_UU = chr(3210)
KANNADA_LETTER_VOCALIC_R = chr(3211)
KANNADA_LETTER_VOCALIC_L = chr(3212)
KANNADA_LETTER_E = chr(3214)
KANNADA_LETTER_EE = chr(3215)
KANNADA_LETTER_AI = chr(3216)
KANNADA_LETTER_O = chr(3218)
KANNADA_LETTER_OO = chr(3219)
KANNADA_LETTER_AU = chr(3220)
KANNADA_LETTER_KA = chr(3221)
KANNADA_LETTER_KHA = chr(3222)
KANNADA_LETTER_GA = chr(3223)
KANNADA_LETTER_GHA = chr(3224)
KANNADA_LETTER_NGA = chr(3225)
KANNADA_LETTER_CA = chr(3226)
KANNADA_LETTER_CHA = chr(3227)
KANNADA_LETTER_JA = chr(3228)
KANNADA_LETTER_JHA = chr(3229)
KANNADA_LETTER_NYA = chr(3230)
KANNADA_LETTER_TTA = chr(3231)
KANNADA_LETTER_TTHA = chr(3232)
KANNADA_LETTER_DDA = chr(3233)
KANNADA_LETTER_DDHA = chr(3234)
KANNADA_LETTER_NNA = chr(3235)
KANNADA_LETTER_TA = chr(3236)
KANNADA_LETTER_THA = chr(3237)
KANNADA_LETTER_DA = chr(3238)
KANNADA_LETTER_DHA = chr(3239)
KANNADA_LETTER_NA = chr(3240)
KANNADA_LETTER_PA = chr(3242)
KANNADA_LETTER_PHA = chr(3243)
KANNADA_LETTER_BA = chr(3244)
KANNADA_LETTER_BHA = chr(3245)
KANNADA_LETTER_MA = chr(3246)
KANNADA_LETTER_YA = chr(3247)
KANNADA_LETTER_RA = chr(3248)
KANNADA_LETTER_RRA = chr(3249)
KANNADA_LETTER_LA = chr(3250)
KANNADA_LETTER_LLA = chr(3251)
KANNADA_LETTER_VA = chr(3253)
KANNADA_LETTER_SHA = chr(3254)
KANNADA_LETTER_SSA = chr(3255)
KANNADA_LETTER_SA = chr(3256)
KANNADA_LETTER_HA = chr(3257)
KANNADA_SIGN_NUKTA = chr(3260)
KANNADA_SIGN_AVAGRAHA = chr(3261)
KANNADA_VOWEL_SIGN_AA = chr(3262)
KANNADA_VOWEL_SIGN_I = chr(3263)
KANNADA_VOWEL_SIGN_II = chr(3264)
KANNADA_VOWEL_SIGN_U = chr(3265)
KANNADA_VOWEL_SIGN_UU = chr(3266)
KANNADA_VOWEL_SIGN_VOCALIC_R = chr(3267)
KANNADA_VOWEL_SIGN_VOCALIC_RR = chr(3268)
KANNADA_VOWEL_SIGN_E = chr(3270)
KANNADA_VOWEL_SIGN_EE = chr(3271)
KANNADA_VOWEL_SIGN_AI = chr(3272)
KANNADA_VOWEL_SIGN_O = chr(3274)
KANNADA_VOWEL_SIGN_OO = chr(3275)
KANNADA_VOWEL_SIGN_AU = chr(3276)
KANNADA_SIGN_VIRAMA = chr(3277)
KANNADA_LENGTH_MARK = chr(3285)
KANNADA_AI_LENGTH_MARK = chr(3286)
KANNADA_LETTER_NAKAARA_POLLU = chr(3293)
KANNADA_LETTER_FA = chr(3294)
KANNADA_LETTER_VOCALIC_RR = chr(3296)
KANNADA_LETTER_VOCALIC_LL = chr(3297)
KANNADA_VOWEL_SIGN_VOCALIC_L = chr(3298)
KANNADA_VOWEL_SIGN_VOCALIC_LL = chr(3299)
KANNADA_DIGIT_ZERO = chr(3302)
KANNADA_DIGIT_ONE = chr(3303)
KANNADA_DIGIT_TWO = chr(3304)
KANNADA_DIGIT_THREE = chr(3305)
KANNADA_DIGIT_FOUR = chr(3306)
KANNADA_DIGIT_FIVE = chr(3307)
KANNADA_DIGIT_SIX = chr(3308)
KANNADA_DIGIT_SEVEN = chr(3309)
KANNADA_DIGIT_EIGHT = chr(3310)
KANNADA_DIGIT_NINE = chr(3311)
KANNADA_SIGN_JIHVAMULIYA = chr(3313)
KANNADA_SIGN_UPADHMANIYA = chr(3314)
KANNADA_SIGN_COMBINING_ANUSVARA_ABOVE_RIGHT = chr(3315)
MALAYALAM_SIGN_COMBINING_ANUSVARA_ABOVE = chr(3328)
MALAYALAM_SIGN_CANDRABINDU = chr(3329)
MALAYALAM_SIGN_ANUSVARA = chr(3330)
MALAYALAM_SIGN_VISARGA = chr(3331)
MALAYALAM_LETTER_VEDIC_ANUSVARA = chr(3332)
MALAYALAM_LETTER_A = chr(3333)
MALAYALAM_LETTER_AA = chr(3334)
MALAYALAM_LETTER_I = chr(3335)
MALAYALAM_LETTER_II = chr(3336)
MALAYALAM_LETTER_U = chr(3337)
MALAYALAM_LETTER_UU = chr(3338)
MALAYALAM_LETTER_VOCALIC_R = chr(3339)
MALAYALAM_LETTER_VOCALIC_L = chr(3340)
MALAYALAM_LETTER_E = chr(3342)
MALAYALAM_LETTER_EE = chr(3343)
MALAYALAM_LETTER_AI = chr(3344)
MALAYALAM_LETTER_O = chr(3346)
MALAYALAM_LETTER_OO = chr(3347)
MALAYALAM_LETTER_AU = chr(3348)
MALAYALAM_LETTER_KA = chr(3349)
MALAYALAM_LETTER_KHA = chr(3350)
MALAYALAM_LETTER_GA = chr(3351)
MALAYALAM_LETTER_GHA = chr(3352)
MALAYALAM_LETTER_NGA = chr(3353)
MALAYALAM_LETTER_CA = chr(3354)
MALAYALAM_LETTER_CHA = chr(3355)
MALAYALAM_LETTER_JA = chr(3356)
MALAYALAM_LETTER_JHA = chr(3357)
MALAYALAM_LETTER_NYA = chr(3358)
MALAYALAM_LETTER_TTA = chr(3359)
MALAYALAM_LETTER_TTHA = chr(3360)
MALAYALAM_LETTER_DDA = chr(3361)
MALAYALAM_LETTER_DDHA = chr(3362)
MALAYALAM_LETTER_NNA = chr(3363)
MALAYALAM_LETTER_TA = chr(3364)
MALAYALAM_LETTER_THA = chr(3365)
MALAYALAM_LETTER_DA = chr(3366)
MALAYALAM_LETTER_DHA = chr(3367)
MALAYALAM_LETTER_NA = chr(3368)
MALAYALAM_LETTER_NNNA = chr(3369)
MALAYALAM_LETTER_PA = chr(3370)
MALAYALAM_LETTER_PHA = chr(3371)
MALAYALAM_LETTER_BA = chr(3372)
MALAYALAM_LETTER_BHA = chr(3373)
MALAYALAM_LETTER_MA = chr(3374)
MALAYALAM_LETTER_YA = chr(3375)
MALAYALAM_LETTER_RA = chr(3376)
MALAYALAM_LETTER_RRA = chr(3377)
MALAYALAM_LETTER_LA = chr(3378)
MALAYALAM_LETTER_LLA = chr(3379)
MALAYALAM_LETTER_LLLA = chr(3380)
MALAYALAM_LETTER_VA = chr(3381)
MALAYALAM_LETTER_SHA = chr(3382)
MALAYALAM_LETTER_SSA = chr(3383)
MALAYALAM_LETTER_SA = chr(3384)
MALAYALAM_LETTER_HA = chr(3385)
MALAYALAM_LETTER_TTTA = chr(3386)
MALAYALAM_SIGN_VERTICAL_BAR_VIRAMA = chr(3387)
MALAYALAM_SIGN_CIRCULAR_VIRAMA = chr(3388)
MALAYALAM_SIGN_AVAGRAHA = chr(3389)
MALAYALAM_VOWEL_SIGN_AA = chr(3390)
MALAYALAM_VOWEL_SIGN_I = chr(3391)
MALAYALAM_VOWEL_SIGN_II = chr(3392)
MALAYALAM_VOWEL_SIGN_U = chr(3393)
MALAYALAM_VOWEL_SIGN_UU = chr(3394)
MALAYALAM_VOWEL_SIGN_VOCALIC_R = chr(3395)
MALAYALAM_VOWEL_SIGN_VOCALIC_RR = chr(3396)
MALAYALAM_VOWEL_SIGN_E = chr(3398)
MALAYALAM_VOWEL_SIGN_EE = chr(3399)
MALAYALAM_VOWEL_SIGN_AI = chr(3400)
MALAYALAM_VOWEL_SIGN_O = chr(3402)
MALAYALAM_VOWEL_SIGN_OO = chr(3403)
MALAYALAM_VOWEL_SIGN_AU = chr(3404)
MALAYALAM_SIGN_VIRAMA = chr(3405)
MALAYALAM_LETTER_DOT_REPH = chr(3406)
MALAYALAM_SIGN_PARA = chr(3407)
MALAYALAM_LETTER_CHILLU_M = chr(3412)
MALAYALAM_LETTER_CHILLU_Y = chr(3413)
MALAYALAM_LETTER_CHILLU_LLL = chr(3414)
MALAYALAM_AU_LENGTH_MARK = chr(3415)
MALAYALAM_FRACTION_ONE_ONE_HUNDRED_AND_SIXTIETH = chr(3416)
MALAYALAM_FRACTION_ONE_FORTIETH = chr(3417)
MALAYALAM_FRACTION_THREE_EIGHTIETHS = chr(3418)
MALAYALAM_FRACTION_ONE_TWENTIETH = chr(3419)
MALAYALAM_FRACTION_ONE_TENTH = chr(3420)
MALAYALAM_FRACTION_THREE_TWENTIETHS = chr(3421)
MALAYALAM_FRACTION_ONE_FIFTH = chr(3422)
MALAYALAM_LETTER_ARCHAIC_II = chr(3423)
MALAYALAM_LETTER_VOCALIC_RR = chr(3424)
MALAYALAM_LETTER_VOCALIC_LL = chr(3425)
MALAYALAM_VOWEL_SIGN_VOCALIC_L = chr(3426)
MALAYALAM_VOWEL_SIGN_VOCALIC_LL = chr(3427)
MALAYALAM_DIGIT_ZERO = chr(3430)
MALAYALAM_DIGIT_ONE = chr(3431)
MALAYALAM_DIGIT_TWO = chr(3432)
MALAYALAM_DIGIT_THREE = chr(3433)
MALAYALAM_DIGIT_FOUR = chr(3434)
MALAYALAM_DIGIT_FIVE = chr(3435)
MALAYALAM_DIGIT_SIX = chr(3436)
MALAYALAM_DIGIT_SEVEN = chr(3437)
MALAYALAM_DIGIT_EIGHT = chr(3438)
MALAYALAM_DIGIT_NINE = chr(3439)
MALAYALAM_NUMBER_TEN = chr(3440)
MALAYALAM_NUMBER_ONE_HUNDRED = chr(3441)
MALAYALAM_NUMBER_ONE_THOUSAND = chr(3442)
MALAYALAM_FRACTION_ONE_QUARTER = chr(3443)
MALAYALAM_FRACTION_ONE_HALF = chr(3444)
MALAYALAM_FRACTION_THREE_QUARTERS = chr(3445)
MALAYALAM_FRACTION_ONE_SIXTEENTH = chr(3446)
MALAYALAM_FRACTION_ONE_EIGHTH = chr(3447)
MALAYALAM_FRACTION_THREE_SIXTEENTHS = chr(3448)
MALAYALAM_DATE_MARK = chr(3449)
MALAYALAM_LETTER_CHILLU_NN = chr(3450)
MALAYALAM_LETTER_CHILLU_N = chr(3451)
MALAYALAM_LETTER_CHILLU_RR = chr(3452)
MALAYALAM_LETTER_CHILLU_L = chr(3453)
MALAYALAM_LETTER_CHILLU_LL = chr(3454)
MALAYALAM_LETTER_CHILLU_K = chr(3455)
SINHALA_SIGN_CANDRABINDU = chr(3457)
SINHALA_SIGN_ANUSVARAYA = chr(3458)
SINHALA_SIGN_VISARGAYA = chr(3459)
SINHALA_LETTER_AYANNA = chr(3461)
SINHALA_LETTER_AAYANNA = chr(3462)
SINHALA_LETTER_AEYANNA = chr(3463)
SINHALA_LETTER_AEEYANNA = chr(3464)
SINHALA_LETTER_IYANNA = chr(3465)
SINHALA_LETTER_IIYANNA = chr(3466)
SINHALA_LETTER_UYANNA = chr(3467)
SINHALA_LETTER_UUYANNA = chr(3468)
SINHALA_LETTER_IRUYANNA = chr(3469)
SINHALA_LETTER_IRUUYANNA = chr(3470)
SINHALA_LETTER_ILUYANNA = chr(3471)
SINHALA_LETTER_ILUUYANNA = chr(3472)
SINHALA_LETTER_EYANNA = chr(3473)
SINHALA_LETTER_EEYANNA = chr(3474)
SINHALA_LETTER_AIYANNA = chr(3475)
SINHALA_LETTER_OYANNA = chr(3476)
SINHALA_LETTER_OOYANNA = chr(3477)
SINHALA_LETTER_AUYANNA = chr(3478)
SINHALA_LETTER_ALPAPRAANA_KAYANNA = chr(3482)
SINHALA_LETTER_MAHAAPRAANA_KAYANNA = chr(3483)
SINHALA_LETTER_ALPAPRAANA_GAYANNA = chr(3484)
SINHALA_LETTER_MAHAAPRAANA_GAYANNA = chr(3485)
SINHALA_LETTER_KANTAJA_NAASIKYAYA = chr(3486)
SINHALA_LETTER_SANYAKA_GAYANNA = chr(3487)
SINHALA_LETTER_ALPAPRAANA_CAYANNA = chr(3488)
SINHALA_LETTER_MAHAAPRAANA_CAYANNA = chr(3489)
SINHALA_LETTER_ALPAPRAANA_JAYANNA = chr(3490)
SINHALA_LETTER_MAHAAPRAANA_JAYANNA = chr(3491)
SINHALA_LETTER_TAALUJA_NAASIKYAYA = chr(3492)
SINHALA_LETTER_TAALUJA_SANYOOGA_NAAKSIKYAYA = chr(3493)
SINHALA_LETTER_SANYAKA_JAYANNA = chr(3494)
SINHALA_LETTER_ALPAPRAANA_TTAYANNA = chr(3495)
SINHALA_LETTER_MAHAAPRAANA_TTAYANNA = chr(3496)
SINHALA_LETTER_ALPAPRAANA_DDAYANNA = chr(3497)
SINHALA_LETTER_MAHAAPRAANA_DDAYANNA = chr(3498)
SINHALA_LETTER_MUURDHAJA_NAYANNA = chr(3499)
SINHALA_LETTER_SANYAKA_DDAYANNA = chr(3500)
SINHALA_LETTER_ALPAPRAANA_TAYANNA = chr(3501)
SINHALA_LETTER_MAHAAPRAANA_TAYANNA = chr(3502)
SINHALA_LETTER_ALPAPRAANA_DAYANNA = chr(3503)
SINHALA_LETTER_MAHAAPRAANA_DAYANNA = chr(3504)
SINHALA_LETTER_DANTAJA_NAYANNA = chr(3505)
SINHALA_LETTER_SANYAKA_DAYANNA = chr(3507)
SINHALA_LETTER_ALPAPRAANA_PAYANNA = chr(3508)
SINHALA_LETTER_MAHAAPRAANA_PAYANNA = chr(3509)
SINHALA_LETTER_ALPAPRAANA_BAYANNA = chr(3510)
SINHALA_LETTER_MAHAAPRAANA_BAYANNA = chr(3511)
SINHALA_LETTER_MAYANNA = chr(3512)
SINHALA_LETTER_AMBA_BAYANNA = chr(3513)
SINHALA_LETTER_YAYANNA = chr(3514)
SINHALA_LETTER_RAYANNA = chr(3515)
SINHALA_LETTER_DANTAJA_LAYANNA = chr(3517)
SINHALA_LETTER_VAYANNA = chr(3520)
SINHALA_LETTER_TAALUJA_SAYANNA = chr(3521)
SINHALA_LETTER_MUURDHAJA_SAYANNA = chr(3522)
SINHALA_LETTER_DANTAJA_SAYANNA = chr(3523)
SINHALA_LETTER_HAYANNA = chr(3524)
SINHALA_LETTER_MUURDHAJA_LAYANNA = chr(3525)
SINHALA_LETTER_FAYANNA = chr(3526)
SINHALA_SIGN_AL_LAKUNA = chr(3530)
SINHALA_VOWEL_SIGN_AELA_PILLA = chr(3535)
SINHALA_VOWEL_SIGN_KETTI_AEDA_PILLA = chr(3536)
SINHALA_VOWEL_SIGN_DIGA_AEDA_PILLA = chr(3537)
SINHALA_VOWEL_SIGN_KETTI_IS_PILLA = chr(3538)
SINHALA_VOWEL_SIGN_DIGA_IS_PILLA = chr(3539)
SINHALA_VOWEL_SIGN_KETTI_PAA_PILLA = chr(3540)
SINHALA_VOWEL_SIGN_DIGA_PAA_PILLA = chr(3542)
SINHALA_VOWEL_SIGN_GAETTA_PILLA = chr(3544)
SINHALA_VOWEL_SIGN_KOMBUVA = chr(3545)
SINHALA_VOWEL_SIGN_DIGA_KOMBUVA = chr(3546)
SINHALA_VOWEL_SIGN_KOMBU_DEKA = chr(3547)
SINHALA_VOWEL_SIGN_KOMBUVA_HAA_AELA_PILLA = chr(3548)
SINHALA_VOWEL_SIGN_KOMBUVA_HAA_DIGA_AELA_PILLA = chr(3549)
SINHALA_VOWEL_SIGN_KOMBUVA_HAA_GAYANUKITTA = chr(3550)
SINHALA_VOWEL_SIGN_GAYANUKITTA = chr(3551)
SINHALA_LITH_DIGIT_ZERO = chr(3558)
SINHALA_LITH_DIGIT_ONE = chr(3559)
SINHALA_LITH_DIGIT_TWO = chr(3560)
SINHALA_LITH_DIGIT_THREE = chr(3561)
SINHALA_LITH_DIGIT_FOUR = chr(3562)
SINHALA_LITH_DIGIT_FIVE = chr(3563)
SINHALA_LITH_DIGIT_SIX = chr(3564)
SINHALA_LITH_DIGIT_SEVEN = chr(3565)
SINHALA_LITH_DIGIT_EIGHT = chr(3566)
SINHALA_LITH_DIGIT_NINE = chr(3567)
SINHALA_VOWEL_SIGN_DIGA_GAETTA_PILLA = chr(3570)
SINHALA_VOWEL_SIGN_DIGA_GAYANUKITTA = chr(3571)
SINHALA_PUNCTUATION_KUNDDALIYA = chr(3572)
THAI_CHARACTER_KO_KAI = chr(3585)
THAI_CHARACTER_KHO_KHAI = chr(3586)
THAI_CHARACTER_KHO_KHUAT = chr(3587)
THAI_CHARACTER_KHO_KHWAI = chr(3588)
THAI_CHARACTER_KHO_KHON = chr(3589)
THAI_CHARACTER_KHO_RAKHANG = chr(3590)
THAI_CHARACTER_NGO_NGU = chr(3591)
THAI_CHARACTER_CHO_CHAN = chr(3592)
THAI_CHARACTER_CHO_CHING = chr(3593)
THAI_CHARACTER_CHO_CHANG = chr(3594)
THAI_CHARACTER_SO_SO = chr(3595)
THAI_CHARACTER_CHO_CHOE = chr(3596)
THAI_CHARACTER_YO_YING = chr(3597)
THAI_CHARACTER_DO_CHADA = chr(3598)
THAI_CHARACTER_TO_PATAK = chr(3599)
THAI_CHARACTER_THO_THAN = chr(3600)
THAI_CHARACTER_THO_NANGMONTHO = chr(3601)
THAI_CHARACTER_THO_PHUTHAO = chr(3602)
THAI_CHARACTER_NO_NEN = chr(3603)
THAI_CHARACTER_DO_DEK = chr(3604)
THAI_CHARACTER_TO_TAO = chr(3605)
THAI_CHARACTER_THO_THUNG = chr(3606)
THAI_CHARACTER_THO_THAHAN = chr(3607)
THAI_CHARACTER_THO_THONG = chr(3608)
THAI_CHARACTER_NO_NU = chr(3609)
THAI_CHARACTER_BO_BAIMAI = chr(3610)
THAI_CHARACTER_PO_PLA = chr(3611)
THAI_CHARACTER_PHO_PHUNG = chr(3612)
THAI_CHARACTER_FO_FA = chr(3613)
THAI_CHARACTER_PHO_PHAN = chr(3614)
THAI_CHARACTER_FO_FAN = chr(3615)
THAI_CHARACTER_PHO_SAMPHAO = chr(3616)
THAI_CHARACTER_MO_MA = chr(3617)
THAI_CHARACTER_YO_YAK = chr(3618)
THAI_CHARACTER_RO_RUA = chr(3619)
THAI_CHARACTER_RU = chr(3620)
THAI_CHARACTER_LO_LING = chr(3621)
THAI_CHARACTER_LU = chr(3622)
THAI_CHARACTER_WO_WAEN = chr(3623)
THAI_CHARACTER_SO_SALA = chr(3624)
THAI_CHARACTER_SO_RUSI = chr(3625)
THAI_CHARACTER_SO_SUA = chr(3626)
THAI_CHARACTER_HO_HIP = chr(3627)
THAI_CHARACTER_LO_CHULA = chr(3628)
THAI_CHARACTER_O_ANG = chr(3629)
THAI_CHARACTER_HO_NOKHUK = chr(3630)
THAI_CHARACTER_PAIYANNOI = chr(3631)
THAI_CHARACTER_SARA_A = chr(3632)
THAI_CHARACTER_MAI_HAN_AKAT = chr(3633)
THAI_CHARACTER_SARA_AA = chr(3634)
THAI_CHARACTER_SARA_AM = chr(3635)
THAI_CHARACTER_SARA_I = chr(3636)
THAI_CHARACTER_SARA_II = chr(3637)
THAI_CHARACTER_SARA_UE = chr(3638)
THAI_CHARACTER_SARA_UEE = chr(3639)
THAI_CHARACTER_SARA_U = chr(3640)
THAI_CHARACTER_SARA_UU = chr(3641)
THAI_CHARACTER_PHINTHU = chr(3642)
THAI_CURRENCY_SYMBOL_BAHT = chr(3647)
THAI_CHARACTER_SARA_E = chr(3648)
THAI_CHARACTER_SARA_AE = chr(3649)
THAI_CHARACTER_SARA_O = chr(3650)
THAI_CHARACTER_SARA_AI_MAIMUAN = chr(3651)
THAI_CHARACTER_SARA_AI_MAIMALAI = chr(3652)
THAI_CHARACTER_LAKKHANGYAO = chr(3653)
THAI_CHARACTER_MAIYAMOK = chr(3654)
THAI_CHARACTER_MAITAIKHU = chr(3655)
THAI_CHARACTER_MAI_EK = chr(3656)
THAI_CHARACTER_MAI_THO = chr(3657)
THAI_CHARACTER_MAI_TRI = chr(3658)
THAI_CHARACTER_MAI_CHATTAWA = chr(3659)
THAI_CHARACTER_THANTHAKHAT = chr(3660)
THAI_CHARACTER_NIKHAHIT = chr(3661)
THAI_CHARACTER_YAMAKKAN = chr(3662)
THAI_CHARACTER_FONGMAN = chr(3663)
THAI_DIGIT_ZERO = chr(3664)
THAI_DIGIT_ONE = chr(3665)
THAI_DIGIT_TWO = chr(3666)
THAI_DIGIT_THREE = chr(3667)
THAI_DIGIT_FOUR = chr(3668)
THAI_DIGIT_FIVE = chr(3669)
THAI_DIGIT_SIX = chr(3670)
THAI_DIGIT_SEVEN = chr(3671)
THAI_DIGIT_EIGHT = chr(3672)
THAI_DIGIT_NINE = chr(3673)
THAI_CHARACTER_ANGKHANKHU = chr(3674)
THAI_CHARACTER_KHOMUT = chr(3675)
LAO_LETTER_KO = chr(3713)
LAO_LETTER_KHO_SUNG = chr(3714)
LAO_LETTER_KHO_TAM = chr(3716)
LAO_LETTER_PALI_GHA = chr(3718)
LAO_LETTER_NGO = chr(3719)
LAO_LETTER_CO = chr(3720)
LAO_LETTER_PALI_CHA = chr(3721)
LAO_LETTER_SO_TAM = chr(3722)
LAO_LETTER_PALI_JHA = chr(3724)
LAO_LETTER_NYO = chr(3725)
LAO_LETTER_PALI_NYA = chr(3726)
LAO_LETTER_PALI_TTA = chr(3727)
LAO_LETTER_PALI_TTHA = chr(3728)
LAO_LETTER_PALI_DDA = chr(3729)
LAO_LETTER_PALI_DDHA = chr(3730)
LAO_LETTER_PALI_NNA = chr(3731)
LAO_LETTER_DO = chr(3732)
LAO_LETTER_TO = chr(3733)
LAO_LETTER_THO_SUNG = chr(3734)
LAO_LETTER_THO_TAM = chr(3735)
LAO_LETTER_PALI_DHA = chr(3736)
LAO_LETTER_NO = chr(3737)
LAO_LETTER_BO = chr(3738)
LAO_LETTER_PO = chr(3739)
LAO_LETTER_PHO_SUNG = chr(3740)
LAO_LETTER_FO_TAM = chr(3741)
LAO_LETTER_PHO_TAM = chr(3742)
LAO_LETTER_FO_SUNG = chr(3743)
LAO_LETTER_PALI_BHA = chr(3744)
LAO_LETTER_MO = chr(3745)
LAO_LETTER_YO = chr(3746)
LAO_LETTER_LO_LING = chr(3747)
LAO_LETTER_LO_LOOT = chr(3749)
LAO_LETTER_WO = chr(3751)
LAO_LETTER_SANSKRIT_SHA = chr(3752)
LAO_LETTER_SANSKRIT_SSA = chr(3753)
LAO_LETTER_SO_SUNG = chr(3754)
LAO_LETTER_HO_SUNG = chr(3755)
LAO_LETTER_PALI_LLA = chr(3756)
LAO_LETTER_O = chr(3757)
LAO_LETTER_HO_TAM = chr(3758)
LAO_ELLIPSIS = chr(3759)
LAO_VOWEL_SIGN_A = chr(3760)
LAO_VOWEL_SIGN_MAI_KAN = chr(3761)
LAO_VOWEL_SIGN_AA = chr(3762)
LAO_VOWEL_SIGN_AM = chr(3763)
LAO_VOWEL_SIGN_I = chr(3764)
LAO_VOWEL_SIGN_II = chr(3765)
LAO_VOWEL_SIGN_Y = chr(3766)
LAO_VOWEL_SIGN_YY = chr(3767)
LAO_VOWEL_SIGN_U = chr(3768)
LAO_VOWEL_SIGN_UU = chr(3769)
LAO_SIGN_PALI_VIRAMA = chr(3770)
LAO_VOWEL_SIGN_MAI_KON = chr(3771)
LAO_SEMIVOWEL_SIGN_LO = chr(3772)
LAO_SEMIVOWEL_SIGN_NYO = chr(3773)
LAO_VOWEL_SIGN_E = chr(3776)
LAO_VOWEL_SIGN_EI = chr(3777)
LAO_VOWEL_SIGN_O = chr(3778)
LAO_VOWEL_SIGN_AY = chr(3779)
LAO_VOWEL_SIGN_AI = chr(3780)
LAO_KO_LA = chr(3782)
LAO_TONE_MAI_EK = chr(3784)
LAO_TONE_MAI_THO = chr(3785)
LAO_TONE_MAI_TI = chr(3786)
LAO_TONE_MAI_CATAWA = chr(3787)
LAO_CANCELLATION_MARK = chr(3788)
LAO_NIGGAHITA = chr(3789)
LAO_YAMAKKAN = chr(3790)
LAO_DIGIT_ZERO = chr(3792)
LAO_DIGIT_ONE = chr(3793)
LAO_DIGIT_TWO = chr(3794)
LAO_DIGIT_THREE = chr(3795)
LAO_DIGIT_FOUR = chr(3796)
LAO_DIGIT_FIVE = chr(3797)
LAO_DIGIT_SIX = chr(3798)
LAO_DIGIT_SEVEN = chr(3799)
LAO_DIGIT_EIGHT = chr(3800)
LAO_DIGIT_NINE = chr(3801)
LAO_HO_NO = chr(3804)
LAO_HO_MO = chr(3805)
LAO_LETTER_KHMU_GO = chr(3806)
LAO_LETTER_KHMU_NYO = chr(3807)
TIBETAN_SYLLABLE_OM = chr(3840)
TIBETAN_MARK_GTER_YIG_MGO_TRUNCATED_A = chr(3841)
TIBETAN_MARK_GTER_YIG_MGO__UM_RNAM_BCAD_MA = chr(3842)
TIBETAN_MARK_GTER_YIG_MGO__UM_GTER_TSHEG_MA = chr(3843)
TIBETAN_MARK_INITIAL_YIG_MGO_MDUN_MA = chr(3844)
TIBETAN_MARK_CLOSING_YIG_MGO_SGAB_MA = chr(3845)
TIBETAN_MARK_CARET_YIG_MGO_PHUR_SHAD_MA = chr(3846)
TIBETAN_MARK_YIG_MGO_TSHEG_SHAD_MA = chr(3847)
TIBETAN_MARK_SBRUL_SHAD = chr(3848)
TIBETAN_MARK_BSKUR_YIG_MGO = chr(3849)
TIBETAN_MARK_BKA__SHOG_YIG_MGO = chr(3850)
TIBETAN_MARK_INTERSYLLABIC_TSHEG = chr(3851)
TIBETAN_MARK_DELIMITER_TSHEG_BSTAR = chr(3852)
TIBETAN_MARK_SHAD = chr(3853)
TIBETAN_MARK_NYIS_SHAD = chr(3854)
TIBETAN_MARK_TSHEG_SHAD = chr(3855)
TIBETAN_MARK_NYIS_TSHEG_SHAD = chr(3856)
TIBETAN_MARK_RIN_CHEN_SPUNGS_SHAD = chr(3857)
TIBETAN_MARK_RGYA_GRAM_SHAD = chr(3858)
TIBETAN_MARK_CARET__DZUD_RTAGS_ME_LONG_CAN = chr(3859)
TIBETAN_MARK_GTER_TSHEG = chr(3860)
TIBETAN_LOGOTYPE_SIGN_CHAD_RTAGS = chr(3861)
TIBETAN_LOGOTYPE_SIGN_LHAG_RTAGS = chr(3862)
TIBETAN_ASTROLOGICAL_SIGN_SGRA_GCAN__CHAR_RTAGS = chr(3863)
TIBETAN_ASTROLOGICAL_SIGN__KHYUD_PA = chr(3864)
TIBETAN_ASTROLOGICAL_SIGN_SDONG_TSHUGS = chr(3865)
TIBETAN_SIGN_RDEL_DKAR_GCIG = chr(3866)
TIBETAN_SIGN_RDEL_DKAR_GNYIS = chr(3867)
TIBETAN_SIGN_RDEL_DKAR_GSUM = chr(3868)
TIBETAN_SIGN_RDEL_NAG_GCIG = chr(3869)
TIBETAN_SIGN_RDEL_NAG_GNYIS = chr(3870)
TIBETAN_SIGN_RDEL_DKAR_RDEL_NAG = chr(3871)
TIBETAN_DIGIT_ZERO = chr(3872)
TIBETAN_DIGIT_ONE = chr(3873)
TIBETAN_DIGIT_TWO = chr(3874)
TIBETAN_DIGIT_THREE = chr(3875)
TIBETAN_DIGIT_FOUR = chr(3876)
TIBETAN_DIGIT_FIVE = chr(3877)
TIBETAN_DIGIT_SIX = chr(3878)
TIBETAN_DIGIT_SEVEN = chr(3879)
TIBETAN_DIGIT_EIGHT = chr(3880)
TIBETAN_DIGIT_NINE = chr(3881)
TIBETAN_DIGIT_HALF_ONE = chr(3882)
TIBETAN_DIGIT_HALF_TWO = chr(3883)
TIBETAN_DIGIT_HALF_THREE = chr(3884)
TIBETAN_DIGIT_HALF_FOUR = chr(3885)
TIBETAN_DIGIT_HALF_FIVE = chr(3886)
TIBETAN_DIGIT_HALF_SIX = chr(3887)
TIBETAN_DIGIT_HALF_SEVEN = chr(3888)
TIBETAN_DIGIT_HALF_EIGHT = chr(3889)
TIBETAN_DIGIT_HALF_NINE = chr(3890)
TIBETAN_DIGIT_HALF_ZERO = chr(3891)
TIBETAN_MARK_BSDUS_RTAGS = chr(3892)
TIBETAN_MARK_NGAS_BZUNG_NYI_ZLA = chr(3893)
TIBETAN_MARK_CARET__DZUD_RTAGS_BZHI_MIG_CAN = chr(3894)
TIBETAN_MARK_NGAS_BZUNG_SGOR_RTAGS = chr(3895)
TIBETAN_MARK_CHE_MGO = chr(3896)
TIBETAN_MARK_TSA__PHRU = chr(3897)
TIBETAN_MARK_GUG_RTAGS_GYON = chr(3898)
TIBETAN_MARK_GUG_RTAGS_GYAS = chr(3899)
TIBETAN_MARK_ANG_KHANG_GYON = chr(3900)
TIBETAN_MARK_ANG_KHANG_GYAS = chr(3901)
TIBETAN_SIGN_YAR_TSHES = chr(3902)
TIBETAN_SIGN_MAR_TSHES = chr(3903)
TIBETAN_LETTER_KA = chr(3904)
TIBETAN_LETTER_KHA = chr(3905)
TIBETAN_LETTER_GA = chr(3906)
TIBETAN_LETTER_GHA = chr(3907)
TIBETAN_LETTER_NGA = chr(3908)
TIBETAN_LETTER_CA = chr(3909)
TIBETAN_LETTER_CHA = chr(3910)
TIBETAN_LETTER_JA = chr(3911)
TIBETAN_LETTER_NYA = chr(3913)
TIBETAN_LETTER_TTA = chr(3914)
TIBETAN_LETTER_TTHA = chr(3915)
TIBETAN_LETTER_DDA = chr(3916)
TIBETAN_LETTER_DDHA = chr(3917)
TIBETAN_LETTER_NNA = chr(3918)
TIBETAN_LETTER_TA = chr(3919)
TIBETAN_LETTER_THA = chr(3920)
TIBETAN_LETTER_DA = chr(3921)
TIBETAN_LETTER_DHA = chr(3922)
TIBETAN_LETTER_NA = chr(3923)
TIBETAN_LETTER_PA = chr(3924)
TIBETAN_LETTER_PHA = chr(3925)
TIBETAN_LETTER_BA = chr(3926)
TIBETAN_LETTER_BHA = chr(3927)
TIBETAN_LETTER_MA = chr(3928)
TIBETAN_LETTER_TSA = chr(3929)
TIBETAN_LETTER_TSHA = chr(3930)
TIBETAN_LETTER_DZA = chr(3931)
TIBETAN_LETTER_DZHA = chr(3932)
TIBETAN_LETTER_WA = chr(3933)
TIBETAN_LETTER_ZHA = chr(3934)
TIBETAN_LETTER_ZA = chr(3935)
TIBETAN_LETTER__A = chr(3936)
TIBETAN_LETTER_YA = chr(3937)
TIBETAN_LETTER_RA = chr(3938)
TIBETAN_LETTER_LA = chr(3939)
TIBETAN_LETTER_SHA = chr(3940)
TIBETAN_LETTER_SSA = chr(3941)
TIBETAN_LETTER_SA = chr(3942)
TIBETAN_LETTER_HA = chr(3943)
TIBETAN_LETTER_A = chr(3944)
TIBETAN_LETTER_KSSA = chr(3945)
TIBETAN_LETTER_FIXED_FORM_RA = chr(3946)
TIBETAN_LETTER_KKA = chr(3947)
TIBETAN_LETTER_RRA = chr(3948)
TIBETAN_VOWEL_SIGN_AA = chr(3953)
TIBETAN_VOWEL_SIGN_I = chr(3954)
TIBETAN_VOWEL_SIGN_II = chr(3955)
TIBETAN_VOWEL_SIGN_U = chr(3956)
TIBETAN_VOWEL_SIGN_UU = chr(3957)
TIBETAN_VOWEL_SIGN_VOCALIC_R = chr(3958)
TIBETAN_VOWEL_SIGN_VOCALIC_RR = chr(3959)
TIBETAN_VOWEL_SIGN_VOCALIC_L = chr(3960)
TIBETAN_VOWEL_SIGN_VOCALIC_LL = chr(3961)
TIBETAN_VOWEL_SIGN_E = chr(3962)
TIBETAN_VOWEL_SIGN_EE = chr(3963)
TIBETAN_VOWEL_SIGN_O = chr(3964)
TIBETAN_VOWEL_SIGN_OO = chr(3965)
TIBETAN_SIGN_RJES_SU_NGA_RO = chr(3966)
TIBETAN_SIGN_RNAM_BCAD = chr(3967)
TIBETAN_VOWEL_SIGN_REVERSED_I = chr(3968)
TIBETAN_VOWEL_SIGN_REVERSED_II = chr(3969)
TIBETAN_SIGN_NYI_ZLA_NAA_DA = chr(3970)
TIBETAN_SIGN_SNA_LDAN = chr(3971)
TIBETAN_MARK_HALANTA = chr(3972)
TIBETAN_MARK_PALUTA = chr(3973)
TIBETAN_SIGN_LCI_RTAGS = chr(3974)
TIBETAN_SIGN_YANG_RTAGS = chr(3975)
TIBETAN_SIGN_LCE_TSA_CAN = chr(3976)
TIBETAN_SIGN_MCHU_CAN = chr(3977)
TIBETAN_SIGN_GRU_CAN_RGYINGS = chr(3978)
TIBETAN_SIGN_GRU_MED_RGYINGS = chr(3979)
TIBETAN_SIGN_INVERTED_MCHU_CAN = chr(3980)
TIBETAN_SUBJOINED_SIGN_LCE_TSA_CAN = chr(3981)
TIBETAN_SUBJOINED_SIGN_MCHU_CAN = chr(3982)
TIBETAN_SUBJOINED_SIGN_INVERTED_MCHU_CAN = chr(3983)
TIBETAN_SUBJOINED_LETTER_KA = chr(3984)
TIBETAN_SUBJOINED_LETTER_KHA = chr(3985)
TIBETAN_SUBJOINED_LETTER_GA = chr(3986)
TIBETAN_SUBJOINED_LETTER_GHA = chr(3987)
TIBETAN_SUBJOINED_LETTER_NGA = chr(3988)
TIBETAN_SUBJOINED_LETTER_CA = chr(3989)
TIBETAN_SUBJOINED_LETTER_CHA = chr(3990)
TIBETAN_SUBJOINED_LETTER_JA = chr(3991)
TIBETAN_SUBJOINED_LETTER_NYA = chr(3993)
TIBETAN_SUBJOINED_LETTER_TTA = chr(3994)
TIBETAN_SUBJOINED_LETTER_TTHA = chr(3995)
TIBETAN_SUBJOINED_LETTER_DDA = chr(3996)
TIBETAN_SUBJOINED_LETTER_DDHA = chr(3997)
TIBETAN_SUBJOINED_LETTER_NNA = chr(3998)
TIBETAN_SUBJOINED_LETTER_TA = chr(3999)
TIBETAN_SUBJOINED_LETTER_THA = chr(4000)
TIBETAN_SUBJOINED_LETTER_DA = chr(4001)
TIBETAN_SUBJOINED_LETTER_DHA = chr(4002)
TIBETAN_SUBJOINED_LETTER_NA = chr(4003)
TIBETAN_SUBJOINED_LETTER_PA = chr(4004)
TIBETAN_SUBJOINED_LETTER_PHA = chr(4005)
TIBETAN_SUBJOINED_LETTER_BA = chr(4006)
TIBETAN_SUBJOINED_LETTER_BHA = chr(4007)
TIBETAN_SUBJOINED_LETTER_MA = chr(4008)
TIBETAN_SUBJOINED_LETTER_TSA = chr(4009)
TIBETAN_SUBJOINED_LETTER_TSHA = chr(4010)
TIBETAN_SUBJOINED_LETTER_DZA = chr(4011)
TIBETAN_SUBJOINED_LETTER_DZHA = chr(4012)
TIBETAN_SUBJOINED_LETTER_WA = chr(4013)
TIBETAN_SUBJOINED_LETTER_ZHA = chr(4014)
TIBETAN_SUBJOINED_LETTER_ZA = chr(4015)
TIBETAN_SUBJOINED_LETTER__A = chr(4016)
TIBETAN_SUBJOINED_LETTER_YA = chr(4017)
TIBETAN_SUBJOINED_LETTER_RA = chr(4018)
TIBETAN_SUBJOINED_LETTER_LA = chr(4019)
TIBETAN_SUBJOINED_LETTER_SHA = chr(4020)
TIBETAN_SUBJOINED_LETTER_SSA = chr(4021)
TIBETAN_SUBJOINED_LETTER_SA = chr(4022)
TIBETAN_SUBJOINED_LETTER_HA = chr(4023)
TIBETAN_SUBJOINED_LETTER_A = chr(4024)
TIBETAN_SUBJOINED_LETTER_KSSA = chr(4025)
TIBETAN_SUBJOINED_LETTER_FIXED_FORM_WA = chr(4026)
TIBETAN_SUBJOINED_LETTER_FIXED_FORM_YA = chr(4027)
TIBETAN_SUBJOINED_LETTER_FIXED_FORM_RA = chr(4028)
TIBETAN_KU_RU_KHA = chr(4030)
TIBETAN_KU_RU_KHA_BZHI_MIG_CAN = chr(4031)
TIBETAN_CANTILLATION_SIGN_HEAVY_BEAT = chr(4032)
TIBETAN_CANTILLATION_SIGN_LIGHT_BEAT = chr(4033)
TIBETAN_CANTILLATION_SIGN_CANG_TE_U = chr(4034)
TIBETAN_CANTILLATION_SIGN_SBUB__CHAL = chr(4035)
TIBETAN_SYMBOL_DRIL_BU = chr(4036)
TIBETAN_SYMBOL_RDO_RJE = chr(4037)
TIBETAN_SYMBOL_PADMA_GDAN = chr(4038)
TIBETAN_SYMBOL_RDO_RJE_RGYA_GRAM = chr(4039)
TIBETAN_SYMBOL_PHUR_PA = chr(4040)
TIBETAN_SYMBOL_NOR_BU = chr(4041)
TIBETAN_SYMBOL_NOR_BU_NYIS__KHYIL = chr(4042)
TIBETAN_SYMBOL_NOR_BU_GSUM__KHYIL = chr(4043)
TIBETAN_SYMBOL_NOR_BU_BZHI__KHYIL = chr(4044)
TIBETAN_SIGN_RDEL_NAG_RDEL_DKAR = chr(4046)
TIBETAN_SIGN_RDEL_NAG_GSUM = chr(4047)
TIBETAN_MARK_BSKA__SHOG_GI_MGO_RGYAN = chr(4048)
TIBETAN_MARK_MNYAM_YIG_GI_MGO_RGYAN = chr(4049)
TIBETAN_MARK_NYIS_TSHEG = chr(4050)
TIBETAN_MARK_INITIAL_BRDA_RNYING_YIG_MGO_MDUN_MA = chr(4051)
TIBETAN_MARK_CLOSING_BRDA_RNYING_YIG_MGO_SGAB_MA = chr(4052)
RIGHT_FACING_SVASTI_SIGN = chr(4053)
LEFT_FACING_SVASTI_SIGN = chr(4054)
RIGHT_FACING_SVASTI_SIGN_WITH_DOTS = chr(4055)
LEFT_FACING_SVASTI_SIGN_WITH_DOTS = chr(4056)
TIBETAN_MARK_LEADING_MCHAN_RTAGS = chr(4057)
TIBETAN_MARK_TRAILING_MCHAN_RTAGS = chr(4058)
MYANMAR_LETTER_KA = chr(4096)
MYANMAR_LETTER_KHA = chr(4097)
MYANMAR_LETTER_GA = chr(4098)
MYANMAR_LETTER_GHA = chr(4099)
MYANMAR_LETTER_NGA = chr(4100)
MYANMAR_LETTER_CA = chr(4101)
MYANMAR_LETTER_CHA = chr(4102)
MYANMAR_LETTER_JA = chr(4103)
MYANMAR_LETTER_JHA = chr(4104)
MYANMAR_LETTER_NYA = chr(4105)
MYANMAR_LETTER_NNYA = chr(4106)
MYANMAR_LETTER_TTA = chr(4107)
MYANMAR_LETTER_TTHA = chr(4108)
MYANMAR_LETTER_DDA = chr(4109)
MYANMAR_LETTER_DDHA = chr(4110)
MYANMAR_LETTER_NNA = chr(4111)
MYANMAR_LETTER_TA = chr(4112)
MYANMAR_LETTER_THA = chr(4113)
MYANMAR_LETTER_DA = chr(4114)
MYANMAR_LETTER_DHA = chr(4115)
MYANMAR_LETTER_NA = chr(4116)
MYANMAR_LETTER_PA = chr(4117)
MYANMAR_LETTER_PHA = chr(4118)
MYANMAR_LETTER_BA = chr(4119)
MYANMAR_LETTER_BHA = chr(4120)
MYANMAR_LETTER_MA = chr(4121)
MYANMAR_LETTER_YA = chr(4122)
MYANMAR_LETTER_RA = chr(4123)
MYANMAR_LETTER_LA = chr(4124)
MYANMAR_LETTER_WA = chr(4125)
MYANMAR_LETTER_SA = chr(4126)
MYANMAR_LETTER_HA = chr(4127)
MYANMAR_LETTER_LLA = chr(4128)
MYANMAR_LETTER_A = chr(4129)
MYANMAR_LETTER_SHAN_A = chr(4130)
MYANMAR_LETTER_I = chr(4131)
MYANMAR_LETTER_II = chr(4132)
MYANMAR_LETTER_U = chr(4133)
MYANMAR_LETTER_UU = chr(4134)
MYANMAR_LETTER_E = chr(4135)
MYANMAR_LETTER_MON_E = chr(4136)
MYANMAR_LETTER_O = chr(4137)
MYANMAR_LETTER_AU = chr(4138)
MYANMAR_VOWEL_SIGN_TALL_AA = chr(4139)
MYANMAR_VOWEL_SIGN_AA = chr(4140)
MYANMAR_VOWEL_SIGN_I = chr(4141)
MYANMAR_VOWEL_SIGN_II = chr(4142)
MYANMAR_VOWEL_SIGN_U = chr(4143)
MYANMAR_VOWEL_SIGN_UU = chr(4144)
MYANMAR_VOWEL_SIGN_E = chr(4145)
MYANMAR_VOWEL_SIGN_AI = chr(4146)
MYANMAR_VOWEL_SIGN_MON_II = chr(4147)
MYANMAR_VOWEL_SIGN_MON_O = chr(4148)
MYANMAR_VOWEL_SIGN_E_ABOVE = chr(4149)
MYANMAR_SIGN_ANUSVARA = chr(4150)
MYANMAR_SIGN_DOT_BELOW = chr(4151)
MYANMAR_SIGN_VISARGA = chr(4152)
MYANMAR_SIGN_VIRAMA = chr(4153)
MYANMAR_SIGN_ASAT = chr(4154)
MYANMAR_CONSONANT_SIGN_MEDIAL_YA = chr(4155)
MYANMAR_CONSONANT_SIGN_MEDIAL_RA = chr(4156)
MYANMAR_CONSONANT_SIGN_MEDIAL_WA = chr(4157)
MYANMAR_CONSONANT_SIGN_MEDIAL_HA = chr(4158)
MYANMAR_LETTER_GREAT_SA = chr(4159)
MYANMAR_DIGIT_ZERO = chr(4160)
MYANMAR_DIGIT_ONE = chr(4161)
MYANMAR_DIGIT_TWO = chr(4162)
MYANMAR_DIGIT_THREE = chr(4163)
MYANMAR_DIGIT_FOUR = chr(4164)
MYANMAR_DIGIT_FIVE = chr(4165)
MYANMAR_DIGIT_SIX = chr(4166)
MYANMAR_DIGIT_SEVEN = chr(4167)
MYANMAR_DIGIT_EIGHT = chr(4168)
MYANMAR_DIGIT_NINE = chr(4169)
MYANMAR_SIGN_LITTLE_SECTION = chr(4170)
MYANMAR_SIGN_SECTION = chr(4171)
MYANMAR_SYMBOL_LOCATIVE = chr(4172)
MYANMAR_SYMBOL_COMPLETED = chr(4173)
MYANMAR_SYMBOL_AFOREMENTIONED = chr(4174)
MYANMAR_SYMBOL_GENITIVE = chr(4175)
MYANMAR_LETTER_SHA = chr(4176)
MYANMAR_LETTER_SSA = chr(4177)
MYANMAR_LETTER_VOCALIC_R = chr(4178)
MYANMAR_LETTER_VOCALIC_RR = chr(4179)
MYANMAR_LETTER_VOCALIC_L = chr(4180)
MYANMAR_LETTER_VOCALIC_LL = chr(4181)
MYANMAR_VOWEL_SIGN_VOCALIC_R = chr(4182)
MYANMAR_VOWEL_SIGN_VOCALIC_RR = chr(4183)
MYANMAR_VOWEL_SIGN_VOCALIC_L = chr(4184)
MYANMAR_VOWEL_SIGN_VOCALIC_LL = chr(4185)
MYANMAR_LETTER_MON_NGA = chr(4186)
MYANMAR_LETTER_MON_JHA = chr(4187)
MYANMAR_LETTER_MON_BBA = chr(4188)
MYANMAR_LETTER_MON_BBE = chr(4189)
MYANMAR_CONSONANT_SIGN_MON_MEDIAL_NA = chr(4190)
MYANMAR_CONSONANT_SIGN_MON_MEDIAL_MA = chr(4191)
MYANMAR_CONSONANT_SIGN_MON_MEDIAL_LA = chr(4192)
MYANMAR_LETTER_SGAW_KAREN_SHA = chr(4193)
MYANMAR_VOWEL_SIGN_SGAW_KAREN_EU = chr(4194)
MYANMAR_TONE_MARK_SGAW_KAREN_HATHI = chr(4195)
MYANMAR_TONE_MARK_SGAW_KAREN_KE_PHO = chr(4196)
MYANMAR_LETTER_WESTERN_PWO_KAREN_THA = chr(4197)
MYANMAR_LETTER_WESTERN_PWO_KAREN_PWA = chr(4198)
MYANMAR_VOWEL_SIGN_WESTERN_PWO_KAREN_EU = chr(4199)
MYANMAR_VOWEL_SIGN_WESTERN_PWO_KAREN_UE = chr(4200)
MYANMAR_SIGN_WESTERN_PWO_KAREN_TONE_1 = chr(4201)
MYANMAR_SIGN_WESTERN_PWO_KAREN_TONE_2 = chr(4202)
MYANMAR_SIGN_WESTERN_PWO_KAREN_TONE_3 = chr(4203)
MYANMAR_SIGN_WESTERN_PWO_KAREN_TONE_4 = chr(4204)
MYANMAR_SIGN_WESTERN_PWO_KAREN_TONE_5 = chr(4205)
MYANMAR_LETTER_EASTERN_PWO_KAREN_NNA = chr(4206)
MYANMAR_LETTER_EASTERN_PWO_KAREN_YWA = chr(4207)
MYANMAR_LETTER_EASTERN_PWO_KAREN_GHWA = chr(4208)
MYANMAR_VOWEL_SIGN_GEBA_KAREN_I = chr(4209)
MYANMAR_VOWEL_SIGN_KAYAH_OE = chr(4210)
MYANMAR_VOWEL_SIGN_KAYAH_U = chr(4211)
MYANMAR_VOWEL_SIGN_KAYAH_EE = chr(4212)
MYANMAR_LETTER_SHAN_KA = chr(4213)
MYANMAR_LETTER_SHAN_KHA = chr(4214)
MYANMAR_LETTER_SHAN_GA = chr(4215)
MYANMAR_LETTER_SHAN_CA = chr(4216)
MYANMAR_LETTER_SHAN_ZA = chr(4217)
MYANMAR_LETTER_SHAN_NYA = chr(4218)
MYANMAR_LETTER_SHAN_DA = chr(4219)
MYANMAR_LETTER_SHAN_NA = chr(4220)
MYANMAR_LETTER_SHAN_PHA = chr(4221)
MYANMAR_LETTER_SHAN_FA = chr(4222)
MYANMAR_LETTER_SHAN_BA = chr(4223)
MYANMAR_LETTER_SHAN_THA = chr(4224)
MYANMAR_LETTER_SHAN_HA = chr(4225)
MYANMAR_CONSONANT_SIGN_SHAN_MEDIAL_WA = chr(4226)
MYANMAR_VOWEL_SIGN_SHAN_AA = chr(4227)
MYANMAR_VOWEL_SIGN_SHAN_E = chr(4228)
MYANMAR_VOWEL_SIGN_SHAN_E_ABOVE = chr(4229)
MYANMAR_VOWEL_SIGN_SHAN_FINAL_Y = chr(4230)
MYANMAR_SIGN_SHAN_TONE_2 = chr(4231)
MYANMAR_SIGN_SHAN_TONE_3 = chr(4232)
MYANMAR_SIGN_SHAN_TONE_5 = chr(4233)
MYANMAR_SIGN_SHAN_TONE_6 = chr(4234)
MYANMAR_SIGN_SHAN_COUNCIL_TONE_2 = chr(4235)
MYANMAR_SIGN_SHAN_COUNCIL_TONE_3 = chr(4236)
MYANMAR_SIGN_SHAN_COUNCIL_EMPHATIC_TONE = chr(4237)
MYANMAR_LETTER_RUMAI_PALAUNG_FA = chr(4238)
MYANMAR_SIGN_RUMAI_PALAUNG_TONE_5 = chr(4239)
MYANMAR_SHAN_DIGIT_ZERO = chr(4240)
MYANMAR_SHAN_DIGIT_ONE = chr(4241)
MYANMAR_SHAN_DIGIT_TWO = chr(4242)
MYANMAR_SHAN_DIGIT_THREE = chr(4243)
MYANMAR_SHAN_DIGIT_FOUR = chr(4244)
MYANMAR_SHAN_DIGIT_FIVE = chr(4245)
MYANMAR_SHAN_DIGIT_SIX = chr(4246)
MYANMAR_SHAN_DIGIT_SEVEN = chr(4247)
MYANMAR_SHAN_DIGIT_EIGHT = chr(4248)
MYANMAR_SHAN_DIGIT_NINE = chr(4249)
MYANMAR_SIGN_KHAMTI_TONE_1 = chr(4250)
MYANMAR_SIGN_KHAMTI_TONE_3 = chr(4251)
MYANMAR_VOWEL_SIGN_AITON_A = chr(4252)
MYANMAR_VOWEL_SIGN_AITON_AI = chr(4253)
MYANMAR_SYMBOL_SHAN_ONE = chr(4254)
MYANMAR_SYMBOL_SHAN_EXCLAMATION = chr(4255)
GEORGIAN_CAPITAL_LETTER_AN = chr(4256)
GEORGIAN_CAPITAL_LETTER_BAN = chr(4257)
GEORGIAN_CAPITAL_LETTER_GAN = chr(4258)
GEORGIAN_CAPITAL_LETTER_DON = chr(4259)
GEORGIAN_CAPITAL_LETTER_EN = chr(4260)
GEORGIAN_CAPITAL_LETTER_VIN = chr(4261)
GEORGIAN_CAPITAL_LETTER_ZEN = chr(4262)
GEORGIAN_CAPITAL_LETTER_TAN = chr(4263)
GEORGIAN_CAPITAL_LETTER_IN = chr(4264)
GEORGIAN_CAPITAL_LETTER_KAN = chr(4265)
GEORGIAN_CAPITAL_LETTER_LAS = chr(4266)
GEORGIAN_CAPITAL_LETTER_MAN = chr(4267)
GEORGIAN_CAPITAL_LETTER_NAR = chr(4268)
GEORGIAN_CAPITAL_LETTER_ON = chr(4269)
GEORGIAN_CAPITAL_LETTER_PAR = chr(4270)
GEORGIAN_CAPITAL_LETTER_ZHAR = chr(4271)
GEORGIAN_CAPITAL_LETTER_RAE = chr(4272)
GEORGIAN_CAPITAL_LETTER_SAN = chr(4273)
GEORGIAN_CAPITAL_LETTER_TAR = chr(4274)
GEORGIAN_CAPITAL_LETTER_UN = chr(4275)
GEORGIAN_CAPITAL_LETTER_PHAR = chr(4276)
GEORGIAN_CAPITAL_LETTER_KHAR = chr(4277)
GEORGIAN_CAPITAL_LETTER_GHAN = chr(4278)
GEORGIAN_CAPITAL_LETTER_QAR = chr(4279)
GEORGIAN_CAPITAL_LETTER_SHIN = chr(4280)
GEORGIAN_CAPITAL_LETTER_CHIN = chr(4281)
GEORGIAN_CAPITAL_LETTER_CAN = chr(4282)
GEORGIAN_CAPITAL_LETTER_JIL = chr(4283)
GEORGIAN_CAPITAL_LETTER_CIL = chr(4284)
GEORGIAN_CAPITAL_LETTER_CHAR = chr(4285)
GEORGIAN_CAPITAL_LETTER_XAN = chr(4286)
GEORGIAN_CAPITAL_LETTER_JHAN = chr(4287)
GEORGIAN_CAPITAL_LETTER_HAE = chr(4288)
GEORGIAN_CAPITAL_LETTER_HE = chr(4289)
GEORGIAN_CAPITAL_LETTER_HIE = chr(4290)
GEORGIAN_CAPITAL_LETTER_WE = chr(4291)
GEORGIAN_CAPITAL_LETTER_HAR = chr(4292)
GEORGIAN_CAPITAL_LETTER_HOE = chr(4293)
GEORGIAN_CAPITAL_LETTER_YN = chr(4295)
GEORGIAN_CAPITAL_LETTER_AEN = chr(4301)
GEORGIAN_LETTER_AN = chr(4304)
GEORGIAN_LETTER_BAN = chr(4305)
GEORGIAN_LETTER_GAN = chr(4306)
GEORGIAN_LETTER_DON = chr(4307)
GEORGIAN_LETTER_EN = chr(4308)
GEORGIAN_LETTER_VIN = chr(4309)
GEORGIAN_LETTER_ZEN = chr(4310)
GEORGIAN_LETTER_TAN = chr(4311)
GEORGIAN_LETTER_IN = chr(4312)
GEORGIAN_LETTER_KAN = chr(4313)
GEORGIAN_LETTER_LAS = chr(4314)
GEORGIAN_LETTER_MAN = chr(4315)
GEORGIAN_LETTER_NAR = chr(4316)
GEORGIAN_LETTER_ON = chr(4317)
GEORGIAN_LETTER_PAR = chr(4318)
GEORGIAN_LETTER_ZHAR = chr(4319)
GEORGIAN_LETTER_RAE = chr(4320)
GEORGIAN_LETTER_SAN = chr(4321)
GEORGIAN_LETTER_TAR = chr(4322)
GEORGIAN_LETTER_UN = chr(4323)
GEORGIAN_LETTER_PHAR = chr(4324)
GEORGIAN_LETTER_KHAR = chr(4325)
GEORGIAN_LETTER_GHAN = chr(4326)
GEORGIAN_LETTER_QAR = chr(4327)
GEORGIAN_LETTER_SHIN = chr(4328)
GEORGIAN_LETTER_CHIN = chr(4329)
GEORGIAN_LETTER_CAN = chr(4330)
GEORGIAN_LETTER_JIL = chr(4331)
GEORGIAN_LETTER_CIL = chr(4332)
GEORGIAN_LETTER_CHAR = chr(4333)
GEORGIAN_LETTER_XAN = chr(4334)
GEORGIAN_LETTER_JHAN = chr(4335)
GEORGIAN_LETTER_HAE = chr(4336)
GEORGIAN_LETTER_HE = chr(4337)
GEORGIAN_LETTER_HIE = chr(4338)
GEORGIAN_LETTER_WE = chr(4339)
GEORGIAN_LETTER_HAR = chr(4340)
GEORGIAN_LETTER_HOE = chr(4341)
GEORGIAN_LETTER_FI = chr(4342)
GEORGIAN_LETTER_YN = chr(4343)
GEORGIAN_LETTER_ELIFI = chr(4344)
GEORGIAN_LETTER_TURNED_GAN = chr(4345)
GEORGIAN_LETTER_AIN = chr(4346)
GEORGIAN_PARAGRAPH_SEPARATOR = chr(4347)
MODIFIER_LETTER_GEORGIAN_NAR = chr(4348)
GEORGIAN_LETTER_AEN = chr(4349)
GEORGIAN_LETTER_HARD_SIGN = chr(4350)
GEORGIAN_LETTER_LABIAL_SIGN = chr(4351)
HANGUL_CHOSEONG_KIYEOK = chr(4352)
HANGUL_CHOSEONG_SSANGKIYEOK = chr(4353)
HANGUL_CHOSEONG_NIEUN = chr(4354)
HANGUL_CHOSEONG_TIKEUT = chr(4355)
HANGUL_CHOSEONG_SSANGTIKEUT = chr(4356)
HANGUL_CHOSEONG_RIEUL = chr(4357)
HANGUL_CHOSEONG_MIEUM = chr(4358)
HANGUL_CHOSEONG_PIEUP = chr(4359)
HANGUL_CHOSEONG_SSANGPIEUP = chr(4360)
HANGUL_CHOSEONG_SIOS = chr(4361)
HANGUL_CHOSEONG_SSANGSIOS = chr(4362)
HANGUL_CHOSEONG_IEUNG = chr(4363)
HANGUL_CHOSEONG_CIEUC = chr(4364)
HANGUL_CHOSEONG_SSANGCIEUC = chr(4365)
HANGUL_CHOSEONG_CHIEUCH = chr(4366)
HANGUL_CHOSEONG_KHIEUKH = chr(4367)
HANGUL_CHOSEONG_THIEUTH = chr(4368)
HANGUL_CHOSEONG_PHIEUPH = chr(4369)
HANGUL_CHOSEONG_HIEUH = chr(4370)
HANGUL_CHOSEONG_NIEUN_KIYEOK = chr(4371)
HANGUL_CHOSEONG_SSANGNIEUN = chr(4372)
HANGUL_CHOSEONG_NIEUN_TIKEUT = chr(4373)
HANGUL_CHOSEONG_NIEUN_PIEUP = chr(4374)
HANGUL_CHOSEONG_TIKEUT_KIYEOK = chr(4375)
HANGUL_CHOSEONG_RIEUL_NIEUN = chr(4376)
HANGUL_CHOSEONG_SSANGRIEUL = chr(4377)
HANGUL_CHOSEONG_RIEUL_HIEUH = chr(4378)
HANGUL_CHOSEONG_KAPYEOUNRIEUL = chr(4379)
HANGUL_CHOSEONG_MIEUM_PIEUP = chr(4380)
HANGUL_CHOSEONG_KAPYEOUNMIEUM = chr(4381)
HANGUL_CHOSEONG_PIEUP_KIYEOK = chr(4382)
HANGUL_CHOSEONG_PIEUP_NIEUN = chr(4383)
HANGUL_CHOSEONG_PIEUP_TIKEUT = chr(4384)
HANGUL_CHOSEONG_PIEUP_SIOS = chr(4385)
HANGUL_CHOSEONG_PIEUP_SIOS_KIYEOK = chr(4386)
HANGUL_CHOSEONG_PIEUP_SIOS_TIKEUT = chr(4387)
HANGUL_CHOSEONG_PIEUP_SIOS_PIEUP = chr(4388)
HANGUL_CHOSEONG_PIEUP_SSANGSIOS = chr(4389)
HANGUL_CHOSEONG_PIEUP_SIOS_CIEUC = chr(4390)
HANGUL_CHOSEONG_PIEUP_CIEUC = chr(4391)
HANGUL_CHOSEONG_PIEUP_CHIEUCH = chr(4392)
HANGUL_CHOSEONG_PIEUP_THIEUTH = chr(4393)
HANGUL_CHOSEONG_PIEUP_PHIEUPH = chr(4394)
HANGUL_CHOSEONG_KAPYEOUNPIEUP = chr(4395)
HANGUL_CHOSEONG_KAPYEOUNSSANGPIEUP = chr(4396)
HANGUL_CHOSEONG_SIOS_KIYEOK = chr(4397)
HANGUL_CHOSEONG_SIOS_NIEUN = chr(4398)
HANGUL_CHOSEONG_SIOS_TIKEUT = chr(4399)
HANGUL_CHOSEONG_SIOS_RIEUL = chr(4400)
HANGUL_CHOSEONG_SIOS_MIEUM = chr(4401)
HANGUL_CHOSEONG_SIOS_PIEUP = chr(4402)
HANGUL_CHOSEONG_SIOS_PIEUP_KIYEOK = chr(4403)
HANGUL_CHOSEONG_SIOS_SSANGSIOS = chr(4404)
HANGUL_CHOSEONG_SIOS_IEUNG = chr(4405)
HANGUL_CHOSEONG_SIOS_CIEUC = chr(4406)
HANGUL_CHOSEONG_SIOS_CHIEUCH = chr(4407)
HANGUL_CHOSEONG_SIOS_KHIEUKH = chr(4408)
HANGUL_CHOSEONG_SIOS_THIEUTH = chr(4409)
HANGUL_CHOSEONG_SIOS_PHIEUPH = chr(4410)
HANGUL_CHOSEONG_SIOS_HIEUH = chr(4411)
HANGUL_CHOSEONG_CHITUEUMSIOS = chr(4412)
HANGUL_CHOSEONG_CHITUEUMSSANGSIOS = chr(4413)
HANGUL_CHOSEONG_CEONGCHIEUMSIOS = chr(4414)
HANGUL_CHOSEONG_CEONGCHIEUMSSANGSIOS = chr(4415)
HANGUL_CHOSEONG_PANSIOS = chr(4416)
HANGUL_CHOSEONG_IEUNG_KIYEOK = chr(4417)
HANGUL_CHOSEONG_IEUNG_TIKEUT = chr(4418)
HANGUL_CHOSEONG_IEUNG_MIEUM = chr(4419)
HANGUL_CHOSEONG_IEUNG_PIEUP = chr(4420)
HANGUL_CHOSEONG_IEUNG_SIOS = chr(4421)
HANGUL_CHOSEONG_IEUNG_PANSIOS = chr(4422)
HANGUL_CHOSEONG_SSANGIEUNG = chr(4423)
HANGUL_CHOSEONG_IEUNG_CIEUC = chr(4424)
HANGUL_CHOSEONG_IEUNG_CHIEUCH = chr(4425)
HANGUL_CHOSEONG_IEUNG_THIEUTH = chr(4426)
HANGUL_CHOSEONG_IEUNG_PHIEUPH = chr(4427)
HANGUL_CHOSEONG_YESIEUNG = chr(4428)
HANGUL_CHOSEONG_CIEUC_IEUNG = chr(4429)
HANGUL_CHOSEONG_CHITUEUMCIEUC = chr(4430)
HANGUL_CHOSEONG_CHITUEUMSSANGCIEUC = chr(4431)
HANGUL_CHOSEONG_CEONGCHIEUMCIEUC = chr(4432)
HANGUL_CHOSEONG_CEONGCHIEUMSSANGCIEUC = chr(4433)
HANGUL_CHOSEONG_CHIEUCH_KHIEUKH = chr(4434)
HANGUL_CHOSEONG_CHIEUCH_HIEUH = chr(4435)
HANGUL_CHOSEONG_CHITUEUMCHIEUCH = chr(4436)
HANGUL_CHOSEONG_CEONGCHIEUMCHIEUCH = chr(4437)
HANGUL_CHOSEONG_PHIEUPH_PIEUP = chr(4438)
HANGUL_CHOSEONG_KAPYEOUNPHIEUPH = chr(4439)
HANGUL_CHOSEONG_SSANGHIEUH = chr(4440)
HANGUL_CHOSEONG_YEORINHIEUH = chr(4441)
HANGUL_CHOSEONG_KIYEOK_TIKEUT = chr(4442)
HANGUL_CHOSEONG_NIEUN_SIOS = chr(4443)
HANGUL_CHOSEONG_NIEUN_CIEUC = chr(4444)
HANGUL_CHOSEONG_NIEUN_HIEUH = chr(4445)
HANGUL_CHOSEONG_TIKEUT_RIEUL = chr(4446)
HANGUL_CHOSEONG_FILLER = chr(4447)
HANGUL_JUNGSEONG_FILLER = chr(4448)
HANGUL_JUNGSEONG_A = chr(4449)
HANGUL_JUNGSEONG_AE = chr(4450)
HANGUL_JUNGSEONG_YA = chr(4451)
HANGUL_JUNGSEONG_YAE = chr(4452)
HANGUL_JUNGSEONG_EO = chr(4453)
HANGUL_JUNGSEONG_E = chr(4454)
HANGUL_JUNGSEONG_YEO = chr(4455)
HANGUL_JUNGSEONG_YE = chr(4456)
HANGUL_JUNGSEONG_O = chr(4457)
HANGUL_JUNGSEONG_WA = chr(4458)
HANGUL_JUNGSEONG_WAE = chr(4459)
HANGUL_JUNGSEONG_OE = chr(4460)
HANGUL_JUNGSEONG_YO = chr(4461)
HANGUL_JUNGSEONG_U = chr(4462)
HANGUL_JUNGSEONG_WEO = chr(4463)
HANGUL_JUNGSEONG_WE = chr(4464)
HANGUL_JUNGSEONG_WI = chr(4465)
HANGUL_JUNGSEONG_YU = chr(4466)
HANGUL_JUNGSEONG_EU = chr(4467)
HANGUL_JUNGSEONG_YI = chr(4468)
HANGUL_JUNGSEONG_I = chr(4469)
HANGUL_JUNGSEONG_A_O = chr(4470)
HANGUL_JUNGSEONG_A_U = chr(4471)
HANGUL_JUNGSEONG_YA_O = chr(4472)
HANGUL_JUNGSEONG_YA_YO = chr(4473)
HANGUL_JUNGSEONG_EO_O = chr(4474)
HANGUL_JUNGSEONG_EO_U = chr(4475)
HANGUL_JUNGSEONG_EO_EU = chr(4476)
HANGUL_JUNGSEONG_YEO_O = chr(4477)
HANGUL_JUNGSEONG_YEO_U = chr(4478)
HANGUL_JUNGSEONG_O_EO = chr(4479)
HANGUL_JUNGSEONG_O_E = chr(4480)
HANGUL_JUNGSEONG_O_YE = chr(4481)
HANGUL_JUNGSEONG_O_O = chr(4482)
HANGUL_JUNGSEONG_O_U = chr(4483)
HANGUL_JUNGSEONG_YO_YA = chr(4484)
HANGUL_JUNGSEONG_YO_YAE = chr(4485)
HANGUL_JUNGSEONG_YO_YEO = chr(4486)
HANGUL_JUNGSEONG_YO_O = chr(4487)
HANGUL_JUNGSEONG_YO_I = chr(4488)
HANGUL_JUNGSEONG_U_A = chr(4489)
HANGUL_JUNGSEONG_U_AE = chr(4490)
HANGUL_JUNGSEONG_U_EO_EU = chr(4491)
HANGUL_JUNGSEONG_U_YE = chr(4492)
HANGUL_JUNGSEONG_U_U = chr(4493)
HANGUL_JUNGSEONG_YU_A = chr(4494)
HANGUL_JUNGSEONG_YU_EO = chr(4495)
HANGUL_JUNGSEONG_YU_E = chr(4496)
HANGUL_JUNGSEONG_YU_YEO = chr(4497)
HANGUL_JUNGSEONG_YU_YE = chr(4498)
HANGUL_JUNGSEONG_YU_U = chr(4499)
HANGUL_JUNGSEONG_YU_I = chr(4500)
HANGUL_JUNGSEONG_EU_U = chr(4501)
HANGUL_JUNGSEONG_EU_EU = chr(4502)
HANGUL_JUNGSEONG_YI_U = chr(4503)
HANGUL_JUNGSEONG_I_A = chr(4504)
HANGUL_JUNGSEONG_I_YA = chr(4505)
HANGUL_JUNGSEONG_I_O = chr(4506)
HANGUL_JUNGSEONG_I_U = chr(4507)
HANGUL_JUNGSEONG_I_EU = chr(4508)
HANGUL_JUNGSEONG_I_ARAEA = chr(4509)
HANGUL_JUNGSEONG_ARAEA = chr(4510)
HANGUL_JUNGSEONG_ARAEA_EO = chr(4511)
HANGUL_JUNGSEONG_ARAEA_U = chr(4512)
HANGUL_JUNGSEONG_ARAEA_I = chr(4513)
HANGUL_JUNGSEONG_SSANGARAEA = chr(4514)
HANGUL_JUNGSEONG_A_EU = chr(4515)
HANGUL_JUNGSEONG_YA_U = chr(4516)
HANGUL_JUNGSEONG_YEO_YA = chr(4517)
HANGUL_JUNGSEONG_O_YA = chr(4518)
HANGUL_JUNGSEONG_O_YAE = chr(4519)
HANGUL_JONGSEONG_KIYEOK = chr(4520)
HANGUL_JONGSEONG_SSANGKIYEOK = chr(4521)
HANGUL_JONGSEONG_KIYEOK_SIOS = chr(4522)
HANGUL_JONGSEONG_NIEUN = chr(4523)
HANGUL_JONGSEONG_NIEUN_CIEUC = chr(4524)
HANGUL_JONGSEONG_NIEUN_HIEUH = chr(4525)
HANGUL_JONGSEONG_TIKEUT = chr(4526)
HANGUL_JONGSEONG_RIEUL = chr(4527)
HANGUL_JONGSEONG_RIEUL_KIYEOK = chr(4528)
HANGUL_JONGSEONG_RIEUL_MIEUM = chr(4529)
HANGUL_JONGSEONG_RIEUL_PIEUP = chr(4530)
HANGUL_JONGSEONG_RIEUL_SIOS = chr(4531)
HANGUL_JONGSEONG_RIEUL_THIEUTH = chr(4532)
HANGUL_JONGSEONG_RIEUL_PHIEUPH = chr(4533)
HANGUL_JONGSEONG_RIEUL_HIEUH = chr(4534)
HANGUL_JONGSEONG_MIEUM = chr(4535)
HANGUL_JONGSEONG_PIEUP = chr(4536)
HANGUL_JONGSEONG_PIEUP_SIOS = chr(4537)
HANGUL_JONGSEONG_SIOS = chr(4538)
HANGUL_JONGSEONG_SSANGSIOS = chr(4539)
HANGUL_JONGSEONG_IEUNG = chr(4540)
HANGUL_JONGSEONG_CIEUC = chr(4541)
HANGUL_JONGSEONG_CHIEUCH = chr(4542)
HANGUL_JONGSEONG_KHIEUKH = chr(4543)
HANGUL_JONGSEONG_THIEUTH = chr(4544)
HANGUL_JONGSEONG_PHIEUPH = chr(4545)
HANGUL_JONGSEONG_HIEUH = chr(4546)
HANGUL_JONGSEONG_KIYEOK_RIEUL = chr(4547)
HANGUL_JONGSEONG_KIYEOK_SIOS_KIYEOK = chr(4548)
HANGUL_JONGSEONG_NIEUN_KIYEOK = chr(4549)
HANGUL_JONGSEONG_NIEUN_TIKEUT = chr(4550)
HANGUL_JONGSEONG_NIEUN_SIOS = chr(4551)
HANGUL_JONGSEONG_NIEUN_PANSIOS = chr(4552)
HANGUL_JONGSEONG_NIEUN_THIEUTH = chr(4553)
HANGUL_JONGSEONG_TIKEUT_KIYEOK = chr(4554)
HANGUL_JONGSEONG_TIKEUT_RIEUL = chr(4555)
HANGUL_JONGSEONG_RIEUL_KIYEOK_SIOS = chr(4556)
HANGUL_JONGSEONG_RIEUL_NIEUN = chr(4557)
HANGUL_JONGSEONG_RIEUL_TIKEUT = chr(4558)
HANGUL_JONGSEONG_RIEUL_TIKEUT_HIEUH = chr(4559)
HANGUL_JONGSEONG_SSANGRIEUL = chr(4560)
HANGUL_JONGSEONG_RIEUL_MIEUM_KIYEOK = chr(4561)
HANGUL_JONGSEONG_RIEUL_MIEUM_SIOS = chr(4562)
HANGUL_JONGSEONG_RIEUL_PIEUP_SIOS = chr(4563)
HANGUL_JONGSEONG_RIEUL_PIEUP_HIEUH = chr(4564)
HANGUL_JONGSEONG_RIEUL_KAPYEOUNPIEUP = chr(4565)
HANGUL_JONGSEONG_RIEUL_SSANGSIOS = chr(4566)
HANGUL_JONGSEONG_RIEUL_PANSIOS = chr(4567)
HANGUL_JONGSEONG_RIEUL_KHIEUKH = chr(4568)
HANGUL_JONGSEONG_RIEUL_YEORINHIEUH = chr(4569)
HANGUL_JONGSEONG_MIEUM_KIYEOK = chr(4570)
HANGUL_JONGSEONG_MIEUM_RIEUL = chr(4571)
HANGUL_JONGSEONG_MIEUM_PIEUP = chr(4572)
HANGUL_JONGSEONG_MIEUM_SIOS = chr(4573)
HANGUL_JONGSEONG_MIEUM_SSANGSIOS = chr(4574)
HANGUL_JONGSEONG_MIEUM_PANSIOS = chr(4575)
HANGUL_JONGSEONG_MIEUM_CHIEUCH = chr(4576)
HANGUL_JONGSEONG_MIEUM_HIEUH = chr(4577)
HANGUL_JONGSEONG_KAPYEOUNMIEUM = chr(4578)
HANGUL_JONGSEONG_PIEUP_RIEUL = chr(4579)
HANGUL_JONGSEONG_PIEUP_PHIEUPH = chr(4580)
HANGUL_JONGSEONG_PIEUP_HIEUH = chr(4581)
HANGUL_JONGSEONG_KAPYEOUNPIEUP = chr(4582)
HANGUL_JONGSEONG_SIOS_KIYEOK = chr(4583)
HANGUL_JONGSEONG_SIOS_TIKEUT = chr(4584)
HANGUL_JONGSEONG_SIOS_RIEUL = chr(4585)
HANGUL_JONGSEONG_SIOS_PIEUP = chr(4586)
HANGUL_JONGSEONG_PANSIOS = chr(4587)
HANGUL_JONGSEONG_IEUNG_KIYEOK = chr(4588)
HANGUL_JONGSEONG_IEUNG_SSANGKIYEOK = chr(4589)
HANGUL_JONGSEONG_SSANGIEUNG = chr(4590)
HANGUL_JONGSEONG_IEUNG_KHIEUKH = chr(4591)
HANGUL_JONGSEONG_YESIEUNG = chr(4592)
HANGUL_JONGSEONG_YESIEUNG_SIOS = chr(4593)
HANGUL_JONGSEONG_YESIEUNG_PANSIOS = chr(4594)
HANGUL_JONGSEONG_PHIEUPH_PIEUP = chr(4595)
HANGUL_JONGSEONG_KAPYEOUNPHIEUPH = chr(4596)
HANGUL_JONGSEONG_HIEUH_NIEUN = chr(4597)
HANGUL_JONGSEONG_HIEUH_RIEUL = chr(4598)
HANGUL_JONGSEONG_HIEUH_MIEUM = chr(4599)
HANGUL_JONGSEONG_HIEUH_PIEUP = chr(4600)
HANGUL_JONGSEONG_YEORINHIEUH = chr(4601)
HANGUL_JONGSEONG_KIYEOK_NIEUN = chr(4602)
HANGUL_JONGSEONG_KIYEOK_PIEUP = chr(4603)
HANGUL_JONGSEONG_KIYEOK_CHIEUCH = chr(4604)
HANGUL_JONGSEONG_KIYEOK_KHIEUKH = chr(4605)
HANGUL_JONGSEONG_KIYEOK_HIEUH = chr(4606)
HANGUL_JONGSEONG_SSANGNIEUN = chr(4607)
ETHIOPIC_SYLLABLE_HA = chr(4608)
ETHIOPIC_SYLLABLE_HU = chr(4609)
ETHIOPIC_SYLLABLE_HI = chr(4610)
ETHIOPIC_SYLLABLE_HAA = chr(4611)
ETHIOPIC_SYLLABLE_HEE = chr(4612)
ETHIOPIC_SYLLABLE_HE = chr(4613)
ETHIOPIC_SYLLABLE_HO = chr(4614)
ETHIOPIC_SYLLABLE_HOA = chr(4615)
ETHIOPIC_SYLLABLE_LA = chr(4616)
ETHIOPIC_SYLLABLE_LU = chr(4617)
ETHIOPIC_SYLLABLE_LI = chr(4618)
ETHIOPIC_SYLLABLE_LAA = chr(4619)
ETHIOPIC_SYLLABLE_LEE = chr(4620)
ETHIOPIC_SYLLABLE_LE = chr(4621)
ETHIOPIC_SYLLABLE_LO = chr(4622)
ETHIOPIC_SYLLABLE_LWA = chr(4623)
ETHIOPIC_SYLLABLE_HHA = chr(4624)
ETHIOPIC_SYLLABLE_HHU = chr(4625)
ETHIOPIC_SYLLABLE_HHI = chr(4626)
ETHIOPIC_SYLLABLE_HHAA = chr(4627)
ETHIOPIC_SYLLABLE_HHEE = chr(4628)
ETHIOPIC_SYLLABLE_HHE = chr(4629)
ETHIOPIC_SYLLABLE_HHO = chr(4630)
ETHIOPIC_SYLLABLE_HHWA = chr(4631)
ETHIOPIC_SYLLABLE_MA = chr(4632)
ETHIOPIC_SYLLABLE_MU = chr(4633)
ETHIOPIC_SYLLABLE_MI = chr(4634)
ETHIOPIC_SYLLABLE_MAA = chr(4635)
ETHIOPIC_SYLLABLE_MEE = chr(4636)
ETHIOPIC_SYLLABLE_ME = chr(4637)
ETHIOPIC_SYLLABLE_MO = chr(4638)
ETHIOPIC_SYLLABLE_MWA = chr(4639)
ETHIOPIC_SYLLABLE_SZA = chr(4640)
ETHIOPIC_SYLLABLE_SZU = chr(4641)
ETHIOPIC_SYLLABLE_SZI = chr(4642)
ETHIOPIC_SYLLABLE_SZAA = chr(4643)
ETHIOPIC_SYLLABLE_SZEE = chr(4644)
ETHIOPIC_SYLLABLE_SZE = chr(4645)
ETHIOPIC_SYLLABLE_SZO = chr(4646)
ETHIOPIC_SYLLABLE_SZWA = chr(4647)
ETHIOPIC_SYLLABLE_RA = chr(4648)
ETHIOPIC_SYLLABLE_RU = chr(4649)
ETHIOPIC_SYLLABLE_RI = chr(4650)
ETHIOPIC_SYLLABLE_RAA = chr(4651)
ETHIOPIC_SYLLABLE_REE = chr(4652)
ETHIOPIC_SYLLABLE_RE = chr(4653)
ETHIOPIC_SYLLABLE_RO = chr(4654)
ETHIOPIC_SYLLABLE_RWA = chr(4655)
ETHIOPIC_SYLLABLE_SA = chr(4656)
ETHIOPIC_SYLLABLE_SU = chr(4657)
ETHIOPIC_SYLLABLE_SI = chr(4658)
ETHIOPIC_SYLLABLE_SAA = chr(4659)
ETHIOPIC_SYLLABLE_SEE = chr(4660)
ETHIOPIC_SYLLABLE_SE = chr(4661)
ETHIOPIC_SYLLABLE_SO = chr(4662)
ETHIOPIC_SYLLABLE_SWA = chr(4663)
ETHIOPIC_SYLLABLE_SHA = chr(4664)
ETHIOPIC_SYLLABLE_SHU = chr(4665)
ETHIOPIC_SYLLABLE_SHI = chr(4666)
ETHIOPIC_SYLLABLE_SHAA = chr(4667)
ETHIOPIC_SYLLABLE_SHEE = chr(4668)
ETHIOPIC_SYLLABLE_SHE = chr(4669)
ETHIOPIC_SYLLABLE_SHO = chr(4670)
ETHIOPIC_SYLLABLE_SHWA = chr(4671)
ETHIOPIC_SYLLABLE_QA = chr(4672)
ETHIOPIC_SYLLABLE_QU = chr(4673)
ETHIOPIC_SYLLABLE_QI = chr(4674)
ETHIOPIC_SYLLABLE_QAA = chr(4675)
ETHIOPIC_SYLLABLE_QEE = chr(4676)
ETHIOPIC_SYLLABLE_QE = chr(4677)
ETHIOPIC_SYLLABLE_QO = chr(4678)
ETHIOPIC_SYLLABLE_QOA = chr(4679)
ETHIOPIC_SYLLABLE_QWA = chr(4680)
ETHIOPIC_SYLLABLE_QWI = chr(4682)
ETHIOPIC_SYLLABLE_QWAA = chr(4683)
ETHIOPIC_SYLLABLE_QWEE = chr(4684)
ETHIOPIC_SYLLABLE_QWE = chr(4685)
ETHIOPIC_SYLLABLE_QHA = chr(4688)
ETHIOPIC_SYLLABLE_QHU = chr(4689)
ETHIOPIC_SYLLABLE_QHI = chr(4690)
ETHIOPIC_SYLLABLE_QHAA = chr(4691)
ETHIOPIC_SYLLABLE_QHEE = chr(4692)
ETHIOPIC_SYLLABLE_QHE = chr(4693)
ETHIOPIC_SYLLABLE_QHO = chr(4694)
ETHIOPIC_SYLLABLE_QHWA = chr(4696)
ETHIOPIC_SYLLABLE_QHWI = chr(4698)
ETHIOPIC_SYLLABLE_QHWAA = chr(4699)
ETHIOPIC_SYLLABLE_QHWEE = chr(4700)
ETHIOPIC_SYLLABLE_QHWE = chr(4701)
ETHIOPIC_SYLLABLE_BA = chr(4704)
ETHIOPIC_SYLLABLE_BU = chr(4705)
ETHIOPIC_SYLLABLE_BI = chr(4706)
ETHIOPIC_SYLLABLE_BAA = chr(4707)
ETHIOPIC_SYLLABLE_BEE = chr(4708)
ETHIOPIC_SYLLABLE_BE = chr(4709)
ETHIOPIC_SYLLABLE_BO = chr(4710)
ETHIOPIC_SYLLABLE_BWA = chr(4711)
ETHIOPIC_SYLLABLE_VA = chr(4712)
ETHIOPIC_SYLLABLE_VU = chr(4713)
ETHIOPIC_SYLLABLE_VI = chr(4714)
ETHIOPIC_SYLLABLE_VAA = chr(4715)
ETHIOPIC_SYLLABLE_VEE = chr(4716)
ETHIOPIC_SYLLABLE_VE = chr(4717)
ETHIOPIC_SYLLABLE_VO = chr(4718)
ETHIOPIC_SYLLABLE_VWA = chr(4719)
ETHIOPIC_SYLLABLE_TA = chr(4720)
ETHIOPIC_SYLLABLE_TU = chr(4721)
ETHIOPIC_SYLLABLE_TI = chr(4722)
ETHIOPIC_SYLLABLE_TAA = chr(4723)
ETHIOPIC_SYLLABLE_TEE = chr(4724)
ETHIOPIC_SYLLABLE_TE = chr(4725)
ETHIOPIC_SYLLABLE_TO = chr(4726)
ETHIOPIC_SYLLABLE_TWA = chr(4727)
ETHIOPIC_SYLLABLE_CA = chr(4728)
ETHIOPIC_SYLLABLE_CU = chr(4729)
ETHIOPIC_SYLLABLE_CI = chr(4730)
ETHIOPIC_SYLLABLE_CAA = chr(4731)
ETHIOPIC_SYLLABLE_CEE = chr(4732)
ETHIOPIC_SYLLABLE_CE = chr(4733)
ETHIOPIC_SYLLABLE_CO = chr(4734)
ETHIOPIC_SYLLABLE_CWA = chr(4735)
ETHIOPIC_SYLLABLE_XA = chr(4736)
ETHIOPIC_SYLLABLE_XU = chr(4737)
ETHIOPIC_SYLLABLE_XI = chr(4738)
ETHIOPIC_SYLLABLE_XAA = chr(4739)
ETHIOPIC_SYLLABLE_XEE = chr(4740)
ETHIOPIC_SYLLABLE_XE = chr(4741)
ETHIOPIC_SYLLABLE_XO = chr(4742)
ETHIOPIC_SYLLABLE_XOA = chr(4743)
ETHIOPIC_SYLLABLE_XWA = chr(4744)
ETHIOPIC_SYLLABLE_XWI = chr(4746)
ETHIOPIC_SYLLABLE_XWAA = chr(4747)
ETHIOPIC_SYLLABLE_XWEE = chr(4748)
ETHIOPIC_SYLLABLE_XWE = chr(4749)
ETHIOPIC_SYLLABLE_NA = chr(4752)
ETHIOPIC_SYLLABLE_NU = chr(4753)
ETHIOPIC_SYLLABLE_NI = chr(4754)
ETHIOPIC_SYLLABLE_NAA = chr(4755)
ETHIOPIC_SYLLABLE_NEE = chr(4756)
ETHIOPIC_SYLLABLE_NE = chr(4757)
ETHIOPIC_SYLLABLE_NO = chr(4758)
ETHIOPIC_SYLLABLE_NWA = chr(4759)
ETHIOPIC_SYLLABLE_NYA = chr(4760)
ETHIOPIC_SYLLABLE_NYU = chr(4761)
ETHIOPIC_SYLLABLE_NYI = chr(4762)
ETHIOPIC_SYLLABLE_NYAA = chr(4763)
ETHIOPIC_SYLLABLE_NYEE = chr(4764)
ETHIOPIC_SYLLABLE_NYE = chr(4765)
ETHIOPIC_SYLLABLE_NYO = chr(4766)
ETHIOPIC_SYLLABLE_NYWA = chr(4767)
ETHIOPIC_SYLLABLE_GLOTTAL_A = chr(4768)
ETHIOPIC_SYLLABLE_GLOTTAL_U = chr(4769)
ETHIOPIC_SYLLABLE_GLOTTAL_I = chr(4770)
ETHIOPIC_SYLLABLE_GLOTTAL_AA = chr(4771)
ETHIOPIC_SYLLABLE_GLOTTAL_EE = chr(4772)
ETHIOPIC_SYLLABLE_GLOTTAL_E = chr(4773)
ETHIOPIC_SYLLABLE_GLOTTAL_O = chr(4774)
ETHIOPIC_SYLLABLE_GLOTTAL_WA = chr(4775)
ETHIOPIC_SYLLABLE_KA = chr(4776)
ETHIOPIC_SYLLABLE_KU = chr(4777)
ETHIOPIC_SYLLABLE_KI = chr(4778)
ETHIOPIC_SYLLABLE_KAA = chr(4779)
ETHIOPIC_SYLLABLE_KEE = chr(4780)
ETHIOPIC_SYLLABLE_KE = chr(4781)
ETHIOPIC_SYLLABLE_KO = chr(4782)
ETHIOPIC_SYLLABLE_KOA = chr(4783)
ETHIOPIC_SYLLABLE_KWA = chr(4784)
ETHIOPIC_SYLLABLE_KWI = chr(4786)
ETHIOPIC_SYLLABLE_KWAA = chr(4787)
ETHIOPIC_SYLLABLE_KWEE = chr(4788)
ETHIOPIC_SYLLABLE_KWE = chr(4789)
ETHIOPIC_SYLLABLE_KXA = chr(4792)
ETHIOPIC_SYLLABLE_KXU = chr(4793)
ETHIOPIC_SYLLABLE_KXI = chr(4794)
ETHIOPIC_SYLLABLE_KXAA = chr(4795)
ETHIOPIC_SYLLABLE_KXEE = chr(4796)
ETHIOPIC_SYLLABLE_KXE = chr(4797)
ETHIOPIC_SYLLABLE_KXO = chr(4798)
ETHIOPIC_SYLLABLE_KXWA = chr(4800)
ETHIOPIC_SYLLABLE_KXWI = chr(4802)
ETHIOPIC_SYLLABLE_KXWAA = chr(4803)
ETHIOPIC_SYLLABLE_KXWEE = chr(4804)
ETHIOPIC_SYLLABLE_KXWE = chr(4805)
ETHIOPIC_SYLLABLE_WA = chr(4808)
ETHIOPIC_SYLLABLE_WU = chr(4809)
ETHIOPIC_SYLLABLE_WI = chr(4810)
ETHIOPIC_SYLLABLE_WAA = chr(4811)
ETHIOPIC_SYLLABLE_WEE = chr(4812)
ETHIOPIC_SYLLABLE_WE = chr(4813)
ETHIOPIC_SYLLABLE_WO = chr(4814)
ETHIOPIC_SYLLABLE_WOA = chr(4815)
ETHIOPIC_SYLLABLE_PHARYNGEAL_A = chr(4816)
ETHIOPIC_SYLLABLE_PHARYNGEAL_U = chr(4817)
ETHIOPIC_SYLLABLE_PHARYNGEAL_I = chr(4818)
ETHIOPIC_SYLLABLE_PHARYNGEAL_AA = chr(4819)
ETHIOPIC_SYLLABLE_PHARYNGEAL_EE = chr(4820)
ETHIOPIC_SYLLABLE_PHARYNGEAL_E = chr(4821)
ETHIOPIC_SYLLABLE_PHARYNGEAL_O = chr(4822)
ETHIOPIC_SYLLABLE_ZA = chr(4824)
ETHIOPIC_SYLLABLE_ZU = chr(4825)
ETHIOPIC_SYLLABLE_ZI = chr(4826)
ETHIOPIC_SYLLABLE_ZAA = chr(4827)
ETHIOPIC_SYLLABLE_ZEE = chr(4828)
ETHIOPIC_SYLLABLE_ZE = chr(4829)
ETHIOPIC_SYLLABLE_ZO = chr(4830)
ETHIOPIC_SYLLABLE_ZWA = chr(4831)
ETHIOPIC_SYLLABLE_ZHA = chr(4832)
ETHIOPIC_SYLLABLE_ZHU = chr(4833)
ETHIOPIC_SYLLABLE_ZHI = chr(4834)
ETHIOPIC_SYLLABLE_ZHAA = chr(4835)
ETHIOPIC_SYLLABLE_ZHEE = chr(4836)
ETHIOPIC_SYLLABLE_ZHE = chr(4837)
ETHIOPIC_SYLLABLE_ZHO = chr(4838)
ETHIOPIC_SYLLABLE_ZHWA = chr(4839)
ETHIOPIC_SYLLABLE_YA = chr(4840)
ETHIOPIC_SYLLABLE_YU = chr(4841)
ETHIOPIC_SYLLABLE_YI = chr(4842)
ETHIOPIC_SYLLABLE_YAA = chr(4843)
ETHIOPIC_SYLLABLE_YEE = chr(4844)
ETHIOPIC_SYLLABLE_YE = chr(4845)
ETHIOPIC_SYLLABLE_YO = chr(4846)
ETHIOPIC_SYLLABLE_YOA = chr(4847)
ETHIOPIC_SYLLABLE_DA = chr(4848)
ETHIOPIC_SYLLABLE_DU = chr(4849)
ETHIOPIC_SYLLABLE_DI = chr(4850)
ETHIOPIC_SYLLABLE_DAA = chr(4851)
ETHIOPIC_SYLLABLE_DEE = chr(4852)
ETHIOPIC_SYLLABLE_DE = chr(4853)
ETHIOPIC_SYLLABLE_DO = chr(4854)
ETHIOPIC_SYLLABLE_DWA = chr(4855)
ETHIOPIC_SYLLABLE_DDA = chr(4856)
ETHIOPIC_SYLLABLE_DDU = chr(4857)
ETHIOPIC_SYLLABLE_DDI = chr(4858)
ETHIOPIC_SYLLABLE_DDAA = chr(4859)
ETHIOPIC_SYLLABLE_DDEE = chr(4860)
ETHIOPIC_SYLLABLE_DDE = chr(4861)
ETHIOPIC_SYLLABLE_DDO = chr(4862)
ETHIOPIC_SYLLABLE_DDWA = chr(4863)
ETHIOPIC_SYLLABLE_JA = chr(4864)
ETHIOPIC_SYLLABLE_JU = chr(4865)
ETHIOPIC_SYLLABLE_JI = chr(4866)
ETHIOPIC_SYLLABLE_JAA = chr(4867)
ETHIOPIC_SYLLABLE_JEE = chr(4868)
ETHIOPIC_SYLLABLE_JE = chr(4869)
ETHIOPIC_SYLLABLE_JO = chr(4870)
ETHIOPIC_SYLLABLE_JWA = chr(4871)
ETHIOPIC_SYLLABLE_GA = chr(4872)
ETHIOPIC_SYLLABLE_GU = chr(4873)
ETHIOPIC_SYLLABLE_GI = chr(4874)
ETHIOPIC_SYLLABLE_GAA = chr(4875)
ETHIOPIC_SYLLABLE_GEE = chr(4876)
ETHIOPIC_SYLLABLE_GE = chr(4877)
ETHIOPIC_SYLLABLE_GO = chr(4878)
ETHIOPIC_SYLLABLE_GOA = chr(4879)
ETHIOPIC_SYLLABLE_GWA = chr(4880)
ETHIOPIC_SYLLABLE_GWI = chr(4882)
ETHIOPIC_SYLLABLE_GWAA = chr(4883)
ETHIOPIC_SYLLABLE_GWEE = chr(4884)
ETHIOPIC_SYLLABLE_GWE = chr(4885)
ETHIOPIC_SYLLABLE_GGA = chr(4888)
ETHIOPIC_SYLLABLE_GGU = chr(4889)
ETHIOPIC_SYLLABLE_GGI = chr(4890)
ETHIOPIC_SYLLABLE_GGAA = chr(4891)
ETHIOPIC_SYLLABLE_GGEE = chr(4892)
ETHIOPIC_SYLLABLE_GGE = chr(4893)
ETHIOPIC_SYLLABLE_GGO = chr(4894)
ETHIOPIC_SYLLABLE_GGWAA = chr(4895)
ETHIOPIC_SYLLABLE_THA = chr(4896)
ETHIOPIC_SYLLABLE_THU = chr(4897)
ETHIOPIC_SYLLABLE_THI = chr(4898)
ETHIOPIC_SYLLABLE_THAA = chr(4899)
ETHIOPIC_SYLLABLE_THEE = chr(4900)
ETHIOPIC_SYLLABLE_THE = chr(4901)
ETHIOPIC_SYLLABLE_THO = chr(4902)
ETHIOPIC_SYLLABLE_THWA = chr(4903)
ETHIOPIC_SYLLABLE_CHA = chr(4904)
ETHIOPIC_SYLLABLE_CHU = chr(4905)
ETHIOPIC_SYLLABLE_CHI = chr(4906)
ETHIOPIC_SYLLABLE_CHAA = chr(4907)
ETHIOPIC_SYLLABLE_CHEE = chr(4908)
ETHIOPIC_SYLLABLE_CHE = chr(4909)
ETHIOPIC_SYLLABLE_CHO = chr(4910)
ETHIOPIC_SYLLABLE_CHWA = chr(4911)
ETHIOPIC_SYLLABLE_PHA = chr(4912)
ETHIOPIC_SYLLABLE_PHU = chr(4913)
ETHIOPIC_SYLLABLE_PHI = chr(4914)
ETHIOPIC_SYLLABLE_PHAA = chr(4915)
ETHIOPIC_SYLLABLE_PHEE = chr(4916)
ETHIOPIC_SYLLABLE_PHE = chr(4917)
ETHIOPIC_SYLLABLE_PHO = chr(4918)
ETHIOPIC_SYLLABLE_PHWA = chr(4919)
ETHIOPIC_SYLLABLE_TSA = chr(4920)
ETHIOPIC_SYLLABLE_TSU = chr(4921)
ETHIOPIC_SYLLABLE_TSI = chr(4922)
ETHIOPIC_SYLLABLE_TSAA = chr(4923)
ETHIOPIC_SYLLABLE_TSEE = chr(4924)
ETHIOPIC_SYLLABLE_TSE = chr(4925)
ETHIOPIC_SYLLABLE_TSO = chr(4926)
ETHIOPIC_SYLLABLE_TSWA = chr(4927)
ETHIOPIC_SYLLABLE_TZA = chr(4928)
ETHIOPIC_SYLLABLE_TZU = chr(4929)
ETHIOPIC_SYLLABLE_TZI = chr(4930)
ETHIOPIC_SYLLABLE_TZAA = chr(4931)
ETHIOPIC_SYLLABLE_TZEE = chr(4932)
ETHIOPIC_SYLLABLE_TZE = chr(4933)
ETHIOPIC_SYLLABLE_TZO = chr(4934)
ETHIOPIC_SYLLABLE_TZOA = chr(4935)
ETHIOPIC_SYLLABLE_FA = chr(4936)
ETHIOPIC_SYLLABLE_FU = chr(4937)
ETHIOPIC_SYLLABLE_FI = chr(4938)
ETHIOPIC_SYLLABLE_FAA = chr(4939)
ETHIOPIC_SYLLABLE_FEE = chr(4940)
ETHIOPIC_SYLLABLE_FE = chr(4941)
ETHIOPIC_SYLLABLE_FO = chr(4942)
ETHIOPIC_SYLLABLE_FWA = chr(4943)
ETHIOPIC_SYLLABLE_PA = chr(4944)
ETHIOPIC_SYLLABLE_PU = chr(4945)
ETHIOPIC_SYLLABLE_PI = chr(4946)
ETHIOPIC_SYLLABLE_PAA = chr(4947)
ETHIOPIC_SYLLABLE_PEE = chr(4948)
ETHIOPIC_SYLLABLE_PE = chr(4949)
ETHIOPIC_SYLLABLE_PO = chr(4950)
ETHIOPIC_SYLLABLE_PWA = chr(4951)
ETHIOPIC_SYLLABLE_RYA = chr(4952)
ETHIOPIC_SYLLABLE_MYA = chr(4953)
ETHIOPIC_SYLLABLE_FYA = chr(4954)
ETHIOPIC_COMBINING_GEMINATION_AND_VOWEL_LENGTH_MARK = chr(4957)
ETHIOPIC_COMBINING_VOWEL_LENGTH_MARK = chr(4958)
ETHIOPIC_COMBINING_GEMINATION_MARK = chr(4959)
ETHIOPIC_SECTION_MARK = chr(4960)
ETHIOPIC_WORDSPACE = chr(4961)
ETHIOPIC_FULL_STOP = chr(4962)
ETHIOPIC_COMMA = chr(4963)
ETHIOPIC_SEMICOLON = chr(4964)
ETHIOPIC_COLON = chr(4965)
ETHIOPIC_PREFACE_COLON = chr(4966)
ETHIOPIC_QUESTION_MARK = chr(4967)
ETHIOPIC_PARAGRAPH_SEPARATOR = chr(4968)
ETHIOPIC_DIGIT_ONE = chr(4969)
ETHIOPIC_DIGIT_TWO = chr(4970)
ETHIOPIC_DIGIT_THREE = chr(4971)
ETHIOPIC_DIGIT_FOUR = chr(4972)
ETHIOPIC_DIGIT_FIVE = chr(4973)
ETHIOPIC_DIGIT_SIX = chr(4974)
ETHIOPIC_DIGIT_SEVEN = chr(4975)
ETHIOPIC_DIGIT_EIGHT = chr(4976)
ETHIOPIC_DIGIT_NINE = chr(4977)
ETHIOPIC_NUMBER_TEN = chr(4978)
ETHIOPIC_NUMBER_TWENTY = chr(4979)
ETHIOPIC_NUMBER_THIRTY = chr(4980)
ETHIOPIC_NUMBER_FORTY = chr(4981)
ETHIOPIC_NUMBER_FIFTY = chr(4982)
ETHIOPIC_NUMBER_SIXTY = chr(4983)
ETHIOPIC_NUMBER_SEVENTY = chr(4984)
ETHIOPIC_NUMBER_EIGHTY = chr(4985)
ETHIOPIC_NUMBER_NINETY = chr(4986)
ETHIOPIC_NUMBER_HUNDRED = chr(4987)
ETHIOPIC_NUMBER_TEN_THOUSAND = chr(4988)
ETHIOPIC_SYLLABLE_SEBATBEIT_MWA = chr(4992)
ETHIOPIC_SYLLABLE_MWI = chr(4993)
ETHIOPIC_SYLLABLE_MWEE = chr(4994)
ETHIOPIC_SYLLABLE_MWE = chr(4995)
ETHIOPIC_SYLLABLE_SEBATBEIT_BWA = chr(4996)
ETHIOPIC_SYLLABLE_BWI = chr(4997)
ETHIOPIC_SYLLABLE_BWEE = chr(4998)
ETHIOPIC_SYLLABLE_BWE = chr(4999)
ETHIOPIC_SYLLABLE_SEBATBEIT_FWA = chr(5000)
ETHIOPIC_SYLLABLE_FWI = chr(5001)
ETHIOPIC_SYLLABLE_FWEE = chr(5002)
ETHIOPIC_SYLLABLE_FWE = chr(5003)
ETHIOPIC_SYLLABLE_SEBATBEIT_PWA = chr(5004)
ETHIOPIC_SYLLABLE_PWI = chr(5005)
ETHIOPIC_SYLLABLE_PWEE = chr(5006)
ETHIOPIC_SYLLABLE_PWE = chr(5007)
ETHIOPIC_TONAL_MARK_YIZET = chr(5008)
ETHIOPIC_TONAL_MARK_DERET = chr(5009)
ETHIOPIC_TONAL_MARK_RIKRIK = chr(5010)
ETHIOPIC_TONAL_MARK_SHORT_RIKRIK = chr(5011)
ETHIOPIC_TONAL_MARK_DIFAT = chr(5012)
ETHIOPIC_TONAL_MARK_KENAT = chr(5013)
ETHIOPIC_TONAL_MARK_CHIRET = chr(5014)
ETHIOPIC_TONAL_MARK_HIDET = chr(5015)
ETHIOPIC_TONAL_MARK_DERET_HIDET = chr(5016)
ETHIOPIC_TONAL_MARK_KURT = chr(5017)
CHEROKEE_LETTER_A = chr(5024)
CHEROKEE_LETTER_E = chr(5025)
CHEROKEE_LETTER_I = chr(5026)
CHEROKEE_LETTER_O = chr(5027)
CHEROKEE_LETTER_U = chr(5028)
CHEROKEE_LETTER_V = chr(5029)
CHEROKEE_LETTER_GA = chr(5030)
CHEROKEE_LETTER_KA = chr(5031)
CHEROKEE_LETTER_GE = chr(5032)
CHEROKEE_LETTER_GI = chr(5033)
CHEROKEE_LETTER_GO = chr(5034)
CHEROKEE_LETTER_GU = chr(5035)
CHEROKEE_LETTER_GV = chr(5036)
CHEROKEE_LETTER_HA = chr(5037)
CHEROKEE_LETTER_HE = chr(5038)
CHEROKEE_LETTER_HI = chr(5039)
CHEROKEE_LETTER_HO = chr(5040)
CHEROKEE_LETTER_HU = chr(5041)
CHEROKEE_LETTER_HV = chr(5042)
CHEROKEE_LETTER_LA = chr(5043)
CHEROKEE_LETTER_LE = chr(5044)
CHEROKEE_LETTER_LI = chr(5045)
CHEROKEE_LETTER_LO = chr(5046)
CHEROKEE_LETTER_LU = chr(5047)
CHEROKEE_LETTER_LV = chr(5048)
CHEROKEE_LETTER_MA = chr(5049)
CHEROKEE_LETTER_ME = chr(5050)
CHEROKEE_LETTER_MI = chr(5051)
CHEROKEE_LETTER_MO = chr(5052)
CHEROKEE_LETTER_MU = chr(5053)
CHEROKEE_LETTER_NA = chr(5054)
CHEROKEE_LETTER_HNA = chr(5055)
CHEROKEE_LETTER_NAH = chr(5056)
CHEROKEE_LETTER_NE = chr(5057)
CHEROKEE_LETTER_NI = chr(5058)
CHEROKEE_LETTER_NO = chr(5059)
CHEROKEE_LETTER_NU = chr(5060)
CHEROKEE_LETTER_NV = chr(5061)
CHEROKEE_LETTER_QUA = chr(5062)
CHEROKEE_LETTER_QUE = chr(5063)
CHEROKEE_LETTER_QUI = chr(5064)
CHEROKEE_LETTER_QUO = chr(5065)
CHEROKEE_LETTER_QUU = chr(5066)
CHEROKEE_LETTER_QUV = chr(5067)
CHEROKEE_LETTER_SA = chr(5068)
CHEROKEE_LETTER_S = chr(5069)
CHEROKEE_LETTER_SE = chr(5070)
CHEROKEE_LETTER_SI = chr(5071)
CHEROKEE_LETTER_SO = chr(5072)
CHEROKEE_LETTER_SU = chr(5073)
CHEROKEE_LETTER_SV = chr(5074)
CHEROKEE_LETTER_DA = chr(5075)
CHEROKEE_LETTER_TA = chr(5076)
CHEROKEE_LETTER_DE = chr(5077)
CHEROKEE_LETTER_TE = chr(5078)
CHEROKEE_LETTER_DI = chr(5079)
CHEROKEE_LETTER_TI = chr(5080)
CHEROKEE_LETTER_DO = chr(5081)
CHEROKEE_LETTER_DU = chr(5082)
CHEROKEE_LETTER_DV = chr(5083)
CHEROKEE_LETTER_DLA = chr(5084)
CHEROKEE_LETTER_TLA = chr(5085)
CHEROKEE_LETTER_TLE = chr(5086)
CHEROKEE_LETTER_TLI = chr(5087)
CHEROKEE_LETTER_TLO = chr(5088)
CHEROKEE_LETTER_TLU = chr(5089)
CHEROKEE_LETTER_TLV = chr(5090)
CHEROKEE_LETTER_TSA = chr(5091)
CHEROKEE_LETTER_TSE = chr(5092)
CHEROKEE_LETTER_TSI = chr(5093)
CHEROKEE_LETTER_TSO = chr(5094)
CHEROKEE_LETTER_TSU = chr(5095)
CHEROKEE_LETTER_TSV = chr(5096)
CHEROKEE_LETTER_WA = chr(5097)
CHEROKEE_LETTER_WE = chr(5098)
CHEROKEE_LETTER_WI = chr(5099)
CHEROKEE_LETTER_WO = chr(5100)
CHEROKEE_LETTER_WU = chr(5101)
CHEROKEE_LETTER_WV = chr(5102)
CHEROKEE_LETTER_YA = chr(5103)
CHEROKEE_LETTER_YE = chr(5104)
CHEROKEE_LETTER_YI = chr(5105)
CHEROKEE_LETTER_YO = chr(5106)
CHEROKEE_LETTER_YU = chr(5107)
CHEROKEE_LETTER_YV = chr(5108)
CHEROKEE_LETTER_MV = chr(5109)
CHEROKEE_SMALL_LETTER_YE = chr(5112)
CHEROKEE_SMALL_LETTER_YI = chr(5113)
CHEROKEE_SMALL_LETTER_YO = chr(5114)
CHEROKEE_SMALL_LETTER_YU = chr(5115)
CHEROKEE_SMALL_LETTER_YV = chr(5116)
CHEROKEE_SMALL_LETTER_MV = chr(5117)
CANADIAN_SYLLABICS_HYPHEN = chr(5120)
CANADIAN_SYLLABICS_E = chr(5121)
CANADIAN_SYLLABICS_AAI = chr(5122)
CANADIAN_SYLLABICS_I = chr(5123)
CANADIAN_SYLLABICS_II = chr(5124)
CANADIAN_SYLLABICS_O = chr(5125)
CANADIAN_SYLLABICS_OO = chr(5126)
CANADIAN_SYLLABICS_Y_CREE_OO = chr(5127)
CANADIAN_SYLLABICS_CARRIER_EE = chr(5128)
CANADIAN_SYLLABICS_CARRIER_I = chr(5129)
CANADIAN_SYLLABICS_A = chr(5130)
CANADIAN_SYLLABICS_AA = chr(5131)
CANADIAN_SYLLABICS_WE = chr(5132)
CANADIAN_SYLLABICS_WEST_CREE_WE = chr(5133)
CANADIAN_SYLLABICS_WI = chr(5134)
CANADIAN_SYLLABICS_WEST_CREE_WI = chr(5135)
CANADIAN_SYLLABICS_WII = chr(5136)
CANADIAN_SYLLABICS_WEST_CREE_WII = chr(5137)
CANADIAN_SYLLABICS_WO = chr(5138)
CANADIAN_SYLLABICS_WEST_CREE_WO = chr(5139)
CANADIAN_SYLLABICS_WOO = chr(5140)
CANADIAN_SYLLABICS_WEST_CREE_WOO = chr(5141)
CANADIAN_SYLLABICS_NASKAPI_WOO = chr(5142)
CANADIAN_SYLLABICS_WA = chr(5143)
CANADIAN_SYLLABICS_WEST_CREE_WA = chr(5144)
CANADIAN_SYLLABICS_WAA = chr(5145)
CANADIAN_SYLLABICS_WEST_CREE_WAA = chr(5146)
CANADIAN_SYLLABICS_NASKAPI_WAA = chr(5147)
CANADIAN_SYLLABICS_AI = chr(5148)
CANADIAN_SYLLABICS_Y_CREE_W = chr(5149)
CANADIAN_SYLLABICS_GLOTTAL_STOP = chr(5150)
CANADIAN_SYLLABICS_FINAL_ACUTE = chr(5151)
CANADIAN_SYLLABICS_FINAL_GRAVE = chr(5152)
CANADIAN_SYLLABICS_FINAL_BOTTOM_HALF_RING = chr(5153)
CANADIAN_SYLLABICS_FINAL_TOP_HALF_RING = chr(5154)
CANADIAN_SYLLABICS_FINAL_RIGHT_HALF_RING = chr(5155)
CANADIAN_SYLLABICS_FINAL_RING = chr(5156)
CANADIAN_SYLLABICS_FINAL_DOUBLE_ACUTE = chr(5157)
CANADIAN_SYLLABICS_FINAL_DOUBLE_SHORT_VERTICAL_STROKES = chr(5158)
CANADIAN_SYLLABICS_FINAL_MIDDLE_DOT = chr(5159)
CANADIAN_SYLLABICS_FINAL_SHORT_HORIZONTAL_STROKE = chr(5160)
CANADIAN_SYLLABICS_FINAL_PLUS = chr(5161)
CANADIAN_SYLLABICS_FINAL_DOWN_TACK = chr(5162)
CANADIAN_SYLLABICS_EN = chr(5163)
CANADIAN_SYLLABICS_IN = chr(5164)
CANADIAN_SYLLABICS_ON = chr(5165)
CANADIAN_SYLLABICS_AN = chr(5166)
CANADIAN_SYLLABICS_PE = chr(5167)
CANADIAN_SYLLABICS_PAAI = chr(5168)
CANADIAN_SYLLABICS_PI = chr(5169)
CANADIAN_SYLLABICS_PII = chr(5170)
CANADIAN_SYLLABICS_PO = chr(5171)
CANADIAN_SYLLABICS_POO = chr(5172)
CANADIAN_SYLLABICS_Y_CREE_POO = chr(5173)
CANADIAN_SYLLABICS_CARRIER_HEE = chr(5174)
CANADIAN_SYLLABICS_CARRIER_HI = chr(5175)
CANADIAN_SYLLABICS_PA = chr(5176)
CANADIAN_SYLLABICS_PAA = chr(5177)
CANADIAN_SYLLABICS_PWE = chr(5178)
CANADIAN_SYLLABICS_WEST_CREE_PWE = chr(5179)
CANADIAN_SYLLABICS_PWI = chr(5180)
CANADIAN_SYLLABICS_WEST_CREE_PWI = chr(5181)
CANADIAN_SYLLABICS_PWII = chr(5182)
CANADIAN_SYLLABICS_WEST_CREE_PWII = chr(5183)
CANADIAN_SYLLABICS_PWO = chr(5184)
CANADIAN_SYLLABICS_WEST_CREE_PWO = chr(5185)
CANADIAN_SYLLABICS_PWOO = chr(5186)
CANADIAN_SYLLABICS_WEST_CREE_PWOO = chr(5187)
CANADIAN_SYLLABICS_PWA = chr(5188)
CANADIAN_SYLLABICS_WEST_CREE_PWA = chr(5189)
CANADIAN_SYLLABICS_PWAA = chr(5190)
CANADIAN_SYLLABICS_WEST_CREE_PWAA = chr(5191)
CANADIAN_SYLLABICS_Y_CREE_PWAA = chr(5192)
CANADIAN_SYLLABICS_P = chr(5193)
CANADIAN_SYLLABICS_WEST_CREE_P = chr(5194)
CANADIAN_SYLLABICS_CARRIER_H = chr(5195)
CANADIAN_SYLLABICS_TE = chr(5196)
CANADIAN_SYLLABICS_TAAI = chr(5197)
CANADIAN_SYLLABICS_TI = chr(5198)
CANADIAN_SYLLABICS_TII = chr(5199)
CANADIAN_SYLLABICS_TO = chr(5200)
CANADIAN_SYLLABICS_TOO = chr(5201)
CANADIAN_SYLLABICS_Y_CREE_TOO = chr(5202)
CANADIAN_SYLLABICS_CARRIER_DEE = chr(5203)
CANADIAN_SYLLABICS_CARRIER_DI = chr(5204)
CANADIAN_SYLLABICS_TA = chr(5205)
CANADIAN_SYLLABICS_TAA = chr(5206)
CANADIAN_SYLLABICS_TWE = chr(5207)
CANADIAN_SYLLABICS_WEST_CREE_TWE = chr(5208)
CANADIAN_SYLLABICS_TWI = chr(5209)
CANADIAN_SYLLABICS_WEST_CREE_TWI = chr(5210)
CANADIAN_SYLLABICS_TWII = chr(5211)
CANADIAN_SYLLABICS_WEST_CREE_TWII = chr(5212)
CANADIAN_SYLLABICS_TWO = chr(5213)
CANADIAN_SYLLABICS_WEST_CREE_TWO = chr(5214)
CANADIAN_SYLLABICS_TWOO = chr(5215)
CANADIAN_SYLLABICS_WEST_CREE_TWOO = chr(5216)
CANADIAN_SYLLABICS_TWA = chr(5217)
CANADIAN_SYLLABICS_WEST_CREE_TWA = chr(5218)
CANADIAN_SYLLABICS_TWAA = chr(5219)
CANADIAN_SYLLABICS_WEST_CREE_TWAA = chr(5220)
CANADIAN_SYLLABICS_NASKAPI_TWAA = chr(5221)
CANADIAN_SYLLABICS_T = chr(5222)
CANADIAN_SYLLABICS_TTE = chr(5223)
CANADIAN_SYLLABICS_TTI = chr(5224)
CANADIAN_SYLLABICS_TTO = chr(5225)
CANADIAN_SYLLABICS_TTA = chr(5226)
CANADIAN_SYLLABICS_KE = chr(5227)
CANADIAN_SYLLABICS_KAAI = chr(5228)
CANADIAN_SYLLABICS_KI = chr(5229)
CANADIAN_SYLLABICS_KII = chr(5230)
CANADIAN_SYLLABICS_KO = chr(5231)
CANADIAN_SYLLABICS_KOO = chr(5232)
CANADIAN_SYLLABICS_Y_CREE_KOO = chr(5233)
CANADIAN_SYLLABICS_KA = chr(5234)
CANADIAN_SYLLABICS_KAA = chr(5235)
CANADIAN_SYLLABICS_KWE = chr(5236)
CANADIAN_SYLLABICS_WEST_CREE_KWE = chr(5237)
CANADIAN_SYLLABICS_KWI = chr(5238)
CANADIAN_SYLLABICS_WEST_CREE_KWI = chr(5239)
CANADIAN_SYLLABICS_KWII = chr(5240)
CANADIAN_SYLLABICS_WEST_CREE_KWII = chr(5241)
CANADIAN_SYLLABICS_KWO = chr(5242)
CANADIAN_SYLLABICS_WEST_CREE_KWO = chr(5243)
CANADIAN_SYLLABICS_KWOO = chr(5244)
CANADIAN_SYLLABICS_WEST_CREE_KWOO = chr(5245)
CANADIAN_SYLLABICS_KWA = chr(5246)
CANADIAN_SYLLABICS_WEST_CREE_KWA = chr(5247)
CANADIAN_SYLLABICS_KWAA = chr(5248)
CANADIAN_SYLLABICS_WEST_CREE_KWAA = chr(5249)
CANADIAN_SYLLABICS_NASKAPI_KWAA = chr(5250)
CANADIAN_SYLLABICS_K = chr(5251)
CANADIAN_SYLLABICS_KW = chr(5252)
CANADIAN_SYLLABICS_SOUTH_SLAVEY_KEH = chr(5253)
CANADIAN_SYLLABICS_SOUTH_SLAVEY_KIH = chr(5254)
CANADIAN_SYLLABICS_SOUTH_SLAVEY_KOH = chr(5255)
CANADIAN_SYLLABICS_SOUTH_SLAVEY_KAH = chr(5256)
CANADIAN_SYLLABICS_CE = chr(5257)
CANADIAN_SYLLABICS_CAAI = chr(5258)
CANADIAN_SYLLABICS_CI = chr(5259)
CANADIAN_SYLLABICS_CII = chr(5260)
CANADIAN_SYLLABICS_CO = chr(5261)
CANADIAN_SYLLABICS_COO = chr(5262)
CANADIAN_SYLLABICS_Y_CREE_COO = chr(5263)
CANADIAN_SYLLABICS_CA = chr(5264)
CANADIAN_SYLLABICS_CAA = chr(5265)
CANADIAN_SYLLABICS_CWE = chr(5266)
CANADIAN_SYLLABICS_WEST_CREE_CWE = chr(5267)
CANADIAN_SYLLABICS_CWI = chr(5268)
CANADIAN_SYLLABICS_WEST_CREE_CWI = chr(5269)
CANADIAN_SYLLABICS_CWII = chr(5270)
CANADIAN_SYLLABICS_WEST_CREE_CWII = chr(5271)
CANADIAN_SYLLABICS_CWO = chr(5272)
CANADIAN_SYLLABICS_WEST_CREE_CWO = chr(5273)
CANADIAN_SYLLABICS_CWOO = chr(5274)
CANADIAN_SYLLABICS_WEST_CREE_CWOO = chr(5275)
CANADIAN_SYLLABICS_CWA = chr(5276)
CANADIAN_SYLLABICS_WEST_CREE_CWA = chr(5277)
CANADIAN_SYLLABICS_CWAA = chr(5278)
CANADIAN_SYLLABICS_WEST_CREE_CWAA = chr(5279)
CANADIAN_SYLLABICS_NASKAPI_CWAA = chr(5280)
CANADIAN_SYLLABICS_C = chr(5281)
CANADIAN_SYLLABICS_SAYISI_TH = chr(5282)
CANADIAN_SYLLABICS_ME = chr(5283)
CANADIAN_SYLLABICS_MAAI = chr(5284)
CANADIAN_SYLLABICS_MI = chr(5285)
CANADIAN_SYLLABICS_MII = chr(5286)
CANADIAN_SYLLABICS_MO = chr(5287)
CANADIAN_SYLLABICS_MOO = chr(5288)
CANADIAN_SYLLABICS_Y_CREE_MOO = chr(5289)
CANADIAN_SYLLABICS_MA = chr(5290)
CANADIAN_SYLLABICS_MAA = chr(5291)
CANADIAN_SYLLABICS_MWE = chr(5292)
CANADIAN_SYLLABICS_WEST_CREE_MWE = chr(5293)
CANADIAN_SYLLABICS_MWI = chr(5294)
CANADIAN_SYLLABICS_WEST_CREE_MWI = chr(5295)
CANADIAN_SYLLABICS_MWII = chr(5296)
CANADIAN_SYLLABICS_WEST_CREE_MWII = chr(5297)
CANADIAN_SYLLABICS_MWO = chr(5298)
CANADIAN_SYLLABICS_WEST_CREE_MWO = chr(5299)
CANADIAN_SYLLABICS_MWOO = chr(5300)
CANADIAN_SYLLABICS_WEST_CREE_MWOO = chr(5301)
CANADIAN_SYLLABICS_MWA = chr(5302)
CANADIAN_SYLLABICS_WEST_CREE_MWA = chr(5303)
CANADIAN_SYLLABICS_MWAA = chr(5304)
CANADIAN_SYLLABICS_WEST_CREE_MWAA = chr(5305)
CANADIAN_SYLLABICS_NASKAPI_MWAA = chr(5306)
CANADIAN_SYLLABICS_M = chr(5307)
CANADIAN_SYLLABICS_WEST_CREE_M = chr(5308)
CANADIAN_SYLLABICS_MH = chr(5309)
CANADIAN_SYLLABICS_ATHAPASCAN_M = chr(5310)
CANADIAN_SYLLABICS_SAYISI_M = chr(5311)
CANADIAN_SYLLABICS_NE = chr(5312)
CANADIAN_SYLLABICS_NAAI = chr(5313)
CANADIAN_SYLLABICS_NI = chr(5314)
CANADIAN_SYLLABICS_NII = chr(5315)
CANADIAN_SYLLABICS_NO = chr(5316)
CANADIAN_SYLLABICS_NOO = chr(5317)
CANADIAN_SYLLABICS_Y_CREE_NOO = chr(5318)
CANADIAN_SYLLABICS_NA = chr(5319)
CANADIAN_SYLLABICS_NAA = chr(5320)
CANADIAN_SYLLABICS_NWE = chr(5321)
CANADIAN_SYLLABICS_WEST_CREE_NWE = chr(5322)
CANADIAN_SYLLABICS_NWA = chr(5323)
CANADIAN_SYLLABICS_WEST_CREE_NWA = chr(5324)
CANADIAN_SYLLABICS_NWAA = chr(5325)
CANADIAN_SYLLABICS_WEST_CREE_NWAA = chr(5326)
CANADIAN_SYLLABICS_NASKAPI_NWAA = chr(5327)
CANADIAN_SYLLABICS_N = chr(5328)
CANADIAN_SYLLABICS_CARRIER_NG = chr(5329)
CANADIAN_SYLLABICS_NH = chr(5330)
CANADIAN_SYLLABICS_LE = chr(5331)
CANADIAN_SYLLABICS_LAAI = chr(5332)
CANADIAN_SYLLABICS_LI = chr(5333)
CANADIAN_SYLLABICS_LII = chr(5334)
CANADIAN_SYLLABICS_LO = chr(5335)
CANADIAN_SYLLABICS_LOO = chr(5336)
CANADIAN_SYLLABICS_Y_CREE_LOO = chr(5337)
CANADIAN_SYLLABICS_LA = chr(5338)
CANADIAN_SYLLABICS_LAA = chr(5339)
CANADIAN_SYLLABICS_LWE = chr(5340)
CANADIAN_SYLLABICS_WEST_CREE_LWE = chr(5341)
CANADIAN_SYLLABICS_LWI = chr(5342)
CANADIAN_SYLLABICS_WEST_CREE_LWI = chr(5343)
CANADIAN_SYLLABICS_LWII = chr(5344)
CANADIAN_SYLLABICS_WEST_CREE_LWII = chr(5345)
CANADIAN_SYLLABICS_LWO = chr(5346)
CANADIAN_SYLLABICS_WEST_CREE_LWO = chr(5347)
CANADIAN_SYLLABICS_LWOO = chr(5348)
CANADIAN_SYLLABICS_WEST_CREE_LWOO = chr(5349)
CANADIAN_SYLLABICS_LWA = chr(5350)
CANADIAN_SYLLABICS_WEST_CREE_LWA = chr(5351)
CANADIAN_SYLLABICS_LWAA = chr(5352)
CANADIAN_SYLLABICS_WEST_CREE_LWAA = chr(5353)
CANADIAN_SYLLABICS_L = chr(5354)
CANADIAN_SYLLABICS_WEST_CREE_L = chr(5355)
CANADIAN_SYLLABICS_MEDIAL_L = chr(5356)
CANADIAN_SYLLABICS_SE = chr(5357)
CANADIAN_SYLLABICS_SAAI = chr(5358)
CANADIAN_SYLLABICS_SI = chr(5359)
CANADIAN_SYLLABICS_SII = chr(5360)
CANADIAN_SYLLABICS_SO = chr(5361)
CANADIAN_SYLLABICS_SOO = chr(5362)
CANADIAN_SYLLABICS_Y_CREE_SOO = chr(5363)
CANADIAN_SYLLABICS_SA = chr(5364)
CANADIAN_SYLLABICS_SAA = chr(5365)
CANADIAN_SYLLABICS_SWE = chr(5366)
CANADIAN_SYLLABICS_WEST_CREE_SWE = chr(5367)
CANADIAN_SYLLABICS_SWI = chr(5368)
CANADIAN_SYLLABICS_WEST_CREE_SWI = chr(5369)
CANADIAN_SYLLABICS_SWII = chr(5370)
CANADIAN_SYLLABICS_WEST_CREE_SWII = chr(5371)
CANADIAN_SYLLABICS_SWO = chr(5372)
CANADIAN_SYLLABICS_WEST_CREE_SWO = chr(5373)
CANADIAN_SYLLABICS_SWOO = chr(5374)
CANADIAN_SYLLABICS_WEST_CREE_SWOO = chr(5375)
CANADIAN_SYLLABICS_SWA = chr(5376)
CANADIAN_SYLLABICS_WEST_CREE_SWA = chr(5377)
CANADIAN_SYLLABICS_SWAA = chr(5378)
CANADIAN_SYLLABICS_WEST_CREE_SWAA = chr(5379)
CANADIAN_SYLLABICS_NASKAPI_SWAA = chr(5380)
CANADIAN_SYLLABICS_S = chr(5381)
CANADIAN_SYLLABICS_ATHAPASCAN_S = chr(5382)
CANADIAN_SYLLABICS_SW = chr(5383)
CANADIAN_SYLLABICS_BLACKFOOT_S = chr(5384)
CANADIAN_SYLLABICS_MOOSE_CREE_SK = chr(5385)
CANADIAN_SYLLABICS_NASKAPI_SKW = chr(5386)
CANADIAN_SYLLABICS_NASKAPI_S_W = chr(5387)
CANADIAN_SYLLABICS_NASKAPI_SPWA = chr(5388)
CANADIAN_SYLLABICS_NASKAPI_STWA = chr(5389)
CANADIAN_SYLLABICS_NASKAPI_SKWA = chr(5390)
CANADIAN_SYLLABICS_NASKAPI_SCWA = chr(5391)
CANADIAN_SYLLABICS_SHE = chr(5392)
CANADIAN_SYLLABICS_SHI = chr(5393)
CANADIAN_SYLLABICS_SHII = chr(5394)
CANADIAN_SYLLABICS_SHO = chr(5395)
CANADIAN_SYLLABICS_SHOO = chr(5396)
CANADIAN_SYLLABICS_SHA = chr(5397)
CANADIAN_SYLLABICS_SHAA = chr(5398)
CANADIAN_SYLLABICS_SHWE = chr(5399)
CANADIAN_SYLLABICS_WEST_CREE_SHWE = chr(5400)
CANADIAN_SYLLABICS_SHWI = chr(5401)
CANADIAN_SYLLABICS_WEST_CREE_SHWI = chr(5402)
CANADIAN_SYLLABICS_SHWII = chr(5403)
CANADIAN_SYLLABICS_WEST_CREE_SHWII = chr(5404)
CANADIAN_SYLLABICS_SHWO = chr(5405)
CANADIAN_SYLLABICS_WEST_CREE_SHWO = chr(5406)
CANADIAN_SYLLABICS_SHWOO = chr(5407)
CANADIAN_SYLLABICS_WEST_CREE_SHWOO = chr(5408)
CANADIAN_SYLLABICS_SHWA = chr(5409)
CANADIAN_SYLLABICS_WEST_CREE_SHWA = chr(5410)
CANADIAN_SYLLABICS_SHWAA = chr(5411)
CANADIAN_SYLLABICS_WEST_CREE_SHWAA = chr(5412)
CANADIAN_SYLLABICS_SH = chr(5413)
CANADIAN_SYLLABICS_YE = chr(5414)
CANADIAN_SYLLABICS_YAAI = chr(5415)
CANADIAN_SYLLABICS_YI = chr(5416)
CANADIAN_SYLLABICS_YII = chr(5417)
CANADIAN_SYLLABICS_YO = chr(5418)
CANADIAN_SYLLABICS_YOO = chr(5419)
CANADIAN_SYLLABICS_Y_CREE_YOO = chr(5420)
CANADIAN_SYLLABICS_YA = chr(5421)
CANADIAN_SYLLABICS_YAA = chr(5422)
CANADIAN_SYLLABICS_YWE = chr(5423)
CANADIAN_SYLLABICS_WEST_CREE_YWE = chr(5424)
CANADIAN_SYLLABICS_YWI = chr(5425)
CANADIAN_SYLLABICS_WEST_CREE_YWI = chr(5426)
CANADIAN_SYLLABICS_YWII = chr(5427)
CANADIAN_SYLLABICS_WEST_CREE_YWII = chr(5428)
CANADIAN_SYLLABICS_YWO = chr(5429)
CANADIAN_SYLLABICS_WEST_CREE_YWO = chr(5430)
CANADIAN_SYLLABICS_YWOO = chr(5431)
CANADIAN_SYLLABICS_WEST_CREE_YWOO = chr(5432)
CANADIAN_SYLLABICS_YWA = chr(5433)
CANADIAN_SYLLABICS_WEST_CREE_YWA = chr(5434)
CANADIAN_SYLLABICS_YWAA = chr(5435)
CANADIAN_SYLLABICS_WEST_CREE_YWAA = chr(5436)
CANADIAN_SYLLABICS_NASKAPI_YWAA = chr(5437)
CANADIAN_SYLLABICS_Y = chr(5438)
CANADIAN_SYLLABICS_BIBLE_CREE_Y = chr(5439)
CANADIAN_SYLLABICS_WEST_CREE_Y = chr(5440)
CANADIAN_SYLLABICS_SAYISI_YI = chr(5441)
CANADIAN_SYLLABICS_RE = chr(5442)
CANADIAN_SYLLABICS_R_CREE_RE = chr(5443)
CANADIAN_SYLLABICS_WEST_CREE_LE = chr(5444)
CANADIAN_SYLLABICS_RAAI = chr(5445)
CANADIAN_SYLLABICS_RI = chr(5446)
CANADIAN_SYLLABICS_RII = chr(5447)
CANADIAN_SYLLABICS_RO = chr(5448)
CANADIAN_SYLLABICS_ROO = chr(5449)
CANADIAN_SYLLABICS_WEST_CREE_LO = chr(5450)
CANADIAN_SYLLABICS_RA = chr(5451)
CANADIAN_SYLLABICS_RAA = chr(5452)
CANADIAN_SYLLABICS_WEST_CREE_LA = chr(5453)
CANADIAN_SYLLABICS_RWAA = chr(5454)
CANADIAN_SYLLABICS_WEST_CREE_RWAA = chr(5455)
CANADIAN_SYLLABICS_R = chr(5456)
CANADIAN_SYLLABICS_WEST_CREE_R = chr(5457)
CANADIAN_SYLLABICS_MEDIAL_R = chr(5458)
CANADIAN_SYLLABICS_FE = chr(5459)
CANADIAN_SYLLABICS_FAAI = chr(5460)
CANADIAN_SYLLABICS_FI = chr(5461)
CANADIAN_SYLLABICS_FII = chr(5462)
CANADIAN_SYLLABICS_FO = chr(5463)
CANADIAN_SYLLABICS_FOO = chr(5464)
CANADIAN_SYLLABICS_FA = chr(5465)
CANADIAN_SYLLABICS_FAA = chr(5466)
CANADIAN_SYLLABICS_FWAA = chr(5467)
CANADIAN_SYLLABICS_WEST_CREE_FWAA = chr(5468)
CANADIAN_SYLLABICS_F = chr(5469)
CANADIAN_SYLLABICS_THE = chr(5470)
CANADIAN_SYLLABICS_N_CREE_THE = chr(5471)
CANADIAN_SYLLABICS_THI = chr(5472)
CANADIAN_SYLLABICS_N_CREE_THI = chr(5473)
CANADIAN_SYLLABICS_THII = chr(5474)
CANADIAN_SYLLABICS_N_CREE_THII = chr(5475)
CANADIAN_SYLLABICS_THO = chr(5476)
CANADIAN_SYLLABICS_THOO = chr(5477)
CANADIAN_SYLLABICS_THA = chr(5478)
CANADIAN_SYLLABICS_THAA = chr(5479)
CANADIAN_SYLLABICS_THWAA = chr(5480)
CANADIAN_SYLLABICS_WEST_CREE_THWAA = chr(5481)
CANADIAN_SYLLABICS_TH = chr(5482)
CANADIAN_SYLLABICS_TTHE = chr(5483)
CANADIAN_SYLLABICS_TTHI = chr(5484)
CANADIAN_SYLLABICS_TTHO = chr(5485)
CANADIAN_SYLLABICS_TTHA = chr(5486)
CANADIAN_SYLLABICS_TTH = chr(5487)
CANADIAN_SYLLABICS_TYE = chr(5488)
CANADIAN_SYLLABICS_TYI = chr(5489)
CANADIAN_SYLLABICS_TYO = chr(5490)
CANADIAN_SYLLABICS_TYA = chr(5491)
CANADIAN_SYLLABICS_NUNAVIK_HE = chr(5492)
CANADIAN_SYLLABICS_NUNAVIK_HI = chr(5493)
CANADIAN_SYLLABICS_NUNAVIK_HII = chr(5494)
CANADIAN_SYLLABICS_NUNAVIK_HO = chr(5495)
CANADIAN_SYLLABICS_NUNAVIK_HOO = chr(5496)
CANADIAN_SYLLABICS_NUNAVIK_HA = chr(5497)
CANADIAN_SYLLABICS_NUNAVIK_HAA = chr(5498)
CANADIAN_SYLLABICS_NUNAVIK_H = chr(5499)
CANADIAN_SYLLABICS_NUNAVUT_H = chr(5500)
CANADIAN_SYLLABICS_HK = chr(5501)
CANADIAN_SYLLABICS_QAAI = chr(5502)
CANADIAN_SYLLABICS_QI = chr(5503)
CANADIAN_SYLLABICS_QII = chr(5504)
CANADIAN_SYLLABICS_QO = chr(5505)
CANADIAN_SYLLABICS_QOO = chr(5506)
CANADIAN_SYLLABICS_QA = chr(5507)
CANADIAN_SYLLABICS_QAA = chr(5508)
CANADIAN_SYLLABICS_Q = chr(5509)
CANADIAN_SYLLABICS_TLHE = chr(5510)
CANADIAN_SYLLABICS_TLHI = chr(5511)
CANADIAN_SYLLABICS_TLHO = chr(5512)
CANADIAN_SYLLABICS_TLHA = chr(5513)
CANADIAN_SYLLABICS_WEST_CREE_RE = chr(5514)
CANADIAN_SYLLABICS_WEST_CREE_RI = chr(5515)
CANADIAN_SYLLABICS_WEST_CREE_RO = chr(5516)
CANADIAN_SYLLABICS_WEST_CREE_RA = chr(5517)
CANADIAN_SYLLABICS_NGAAI = chr(5518)
CANADIAN_SYLLABICS_NGI = chr(5519)
CANADIAN_SYLLABICS_NGII = chr(5520)
CANADIAN_SYLLABICS_NGO = chr(5521)
CANADIAN_SYLLABICS_NGOO = chr(5522)
CANADIAN_SYLLABICS_NGA = chr(5523)
CANADIAN_SYLLABICS_NGAA = chr(5524)
CANADIAN_SYLLABICS_NG = chr(5525)
CANADIAN_SYLLABICS_NNG = chr(5526)
CANADIAN_SYLLABICS_SAYISI_SHE = chr(5527)
CANADIAN_SYLLABICS_SAYISI_SHI = chr(5528)
CANADIAN_SYLLABICS_SAYISI_SHO = chr(5529)
CANADIAN_SYLLABICS_SAYISI_SHA = chr(5530)
CANADIAN_SYLLABICS_WOODS_CREE_THE = chr(5531)
CANADIAN_SYLLABICS_WOODS_CREE_THI = chr(5532)
CANADIAN_SYLLABICS_WOODS_CREE_THO = chr(5533)
CANADIAN_SYLLABICS_WOODS_CREE_THA = chr(5534)
CANADIAN_SYLLABICS_WOODS_CREE_TH = chr(5535)
CANADIAN_SYLLABICS_LHI = chr(5536)
CANADIAN_SYLLABICS_LHII = chr(5537)
CANADIAN_SYLLABICS_LHO = chr(5538)
CANADIAN_SYLLABICS_LHOO = chr(5539)
CANADIAN_SYLLABICS_LHA = chr(5540)
CANADIAN_SYLLABICS_LHAA = chr(5541)
CANADIAN_SYLLABICS_LH = chr(5542)
CANADIAN_SYLLABICS_TH_CREE_THE = chr(5543)
CANADIAN_SYLLABICS_TH_CREE_THI = chr(5544)
CANADIAN_SYLLABICS_TH_CREE_THII = chr(5545)
CANADIAN_SYLLABICS_TH_CREE_THO = chr(5546)
CANADIAN_SYLLABICS_TH_CREE_THOO = chr(5547)
CANADIAN_SYLLABICS_TH_CREE_THA = chr(5548)
CANADIAN_SYLLABICS_TH_CREE_THAA = chr(5549)
CANADIAN_SYLLABICS_TH_CREE_TH = chr(5550)
CANADIAN_SYLLABICS_AIVILIK_B = chr(5551)
CANADIAN_SYLLABICS_BLACKFOOT_E = chr(5552)
CANADIAN_SYLLABICS_BLACKFOOT_I = chr(5553)
CANADIAN_SYLLABICS_BLACKFOOT_O = chr(5554)
CANADIAN_SYLLABICS_BLACKFOOT_A = chr(5555)
CANADIAN_SYLLABICS_BLACKFOOT_WE = chr(5556)
CANADIAN_SYLLABICS_BLACKFOOT_WI = chr(5557)
CANADIAN_SYLLABICS_BLACKFOOT_WO = chr(5558)
CANADIAN_SYLLABICS_BLACKFOOT_WA = chr(5559)
CANADIAN_SYLLABICS_BLACKFOOT_NE = chr(5560)
CANADIAN_SYLLABICS_BLACKFOOT_NI = chr(5561)
CANADIAN_SYLLABICS_BLACKFOOT_NO = chr(5562)
CANADIAN_SYLLABICS_BLACKFOOT_NA = chr(5563)
CANADIAN_SYLLABICS_BLACKFOOT_KE = chr(5564)
CANADIAN_SYLLABICS_BLACKFOOT_KI = chr(5565)
CANADIAN_SYLLABICS_BLACKFOOT_KO = chr(5566)
CANADIAN_SYLLABICS_BLACKFOOT_KA = chr(5567)
CANADIAN_SYLLABICS_SAYISI_HE = chr(5568)
CANADIAN_SYLLABICS_SAYISI_HI = chr(5569)
CANADIAN_SYLLABICS_SAYISI_HO = chr(5570)
CANADIAN_SYLLABICS_SAYISI_HA = chr(5571)
CANADIAN_SYLLABICS_CARRIER_GHU = chr(5572)
CANADIAN_SYLLABICS_CARRIER_GHO = chr(5573)
CANADIAN_SYLLABICS_CARRIER_GHE = chr(5574)
CANADIAN_SYLLABICS_CARRIER_GHEE = chr(5575)
CANADIAN_SYLLABICS_CARRIER_GHI = chr(5576)
CANADIAN_SYLLABICS_CARRIER_GHA = chr(5577)
CANADIAN_SYLLABICS_CARRIER_RU = chr(5578)
CANADIAN_SYLLABICS_CARRIER_RO = chr(5579)
CANADIAN_SYLLABICS_CARRIER_RE = chr(5580)
CANADIAN_SYLLABICS_CARRIER_REE = chr(5581)
CANADIAN_SYLLABICS_CARRIER_RI = chr(5582)
CANADIAN_SYLLABICS_CARRIER_RA = chr(5583)
CANADIAN_SYLLABICS_CARRIER_WU = chr(5584)
CANADIAN_SYLLABICS_CARRIER_WO = chr(5585)
CANADIAN_SYLLABICS_CARRIER_WE = chr(5586)
CANADIAN_SYLLABICS_CARRIER_WEE = chr(5587)
CANADIAN_SYLLABICS_CARRIER_WI = chr(5588)
CANADIAN_SYLLABICS_CARRIER_WA = chr(5589)
CANADIAN_SYLLABICS_CARRIER_HWU = chr(5590)
CANADIAN_SYLLABICS_CARRIER_HWO = chr(5591)
CANADIAN_SYLLABICS_CARRIER_HWE = chr(5592)
CANADIAN_SYLLABICS_CARRIER_HWEE = chr(5593)
CANADIAN_SYLLABICS_CARRIER_HWI = chr(5594)
CANADIAN_SYLLABICS_CARRIER_HWA = chr(5595)
CANADIAN_SYLLABICS_CARRIER_THU = chr(5596)
CANADIAN_SYLLABICS_CARRIER_THO = chr(5597)
CANADIAN_SYLLABICS_CARRIER_THE = chr(5598)
CANADIAN_SYLLABICS_CARRIER_THEE = chr(5599)
CANADIAN_SYLLABICS_CARRIER_THI = chr(5600)
CANADIAN_SYLLABICS_CARRIER_THA = chr(5601)
CANADIAN_SYLLABICS_CARRIER_TTU = chr(5602)
CANADIAN_SYLLABICS_CARRIER_TTO = chr(5603)
CANADIAN_SYLLABICS_CARRIER_TTE = chr(5604)
CANADIAN_SYLLABICS_CARRIER_TTEE = chr(5605)
CANADIAN_SYLLABICS_CARRIER_TTI = chr(5606)
CANADIAN_SYLLABICS_CARRIER_TTA = chr(5607)
CANADIAN_SYLLABICS_CARRIER_PU = chr(5608)
CANADIAN_SYLLABICS_CARRIER_PO = chr(5609)
CANADIAN_SYLLABICS_CARRIER_PE = chr(5610)
CANADIAN_SYLLABICS_CARRIER_PEE = chr(5611)
CANADIAN_SYLLABICS_CARRIER_PI = chr(5612)
CANADIAN_SYLLABICS_CARRIER_PA = chr(5613)
CANADIAN_SYLLABICS_CARRIER_P = chr(5614)
CANADIAN_SYLLABICS_CARRIER_GU = chr(5615)
CANADIAN_SYLLABICS_CARRIER_GO = chr(5616)
CANADIAN_SYLLABICS_CARRIER_GE = chr(5617)
CANADIAN_SYLLABICS_CARRIER_GEE = chr(5618)
CANADIAN_SYLLABICS_CARRIER_GI = chr(5619)
CANADIAN_SYLLABICS_CARRIER_GA = chr(5620)
CANADIAN_SYLLABICS_CARRIER_KHU = chr(5621)
CANADIAN_SYLLABICS_CARRIER_KHO = chr(5622)
CANADIAN_SYLLABICS_CARRIER_KHE = chr(5623)
CANADIAN_SYLLABICS_CARRIER_KHEE = chr(5624)
CANADIAN_SYLLABICS_CARRIER_KHI = chr(5625)
CANADIAN_SYLLABICS_CARRIER_KHA = chr(5626)
CANADIAN_SYLLABICS_CARRIER_KKU = chr(5627)
CANADIAN_SYLLABICS_CARRIER_KKO = chr(5628)
CANADIAN_SYLLABICS_CARRIER_KKE = chr(5629)
CANADIAN_SYLLABICS_CARRIER_KKEE = chr(5630)
CANADIAN_SYLLABICS_CARRIER_KKI = chr(5631)
CANADIAN_SYLLABICS_CARRIER_KKA = chr(5632)
CANADIAN_SYLLABICS_CARRIER_KK = chr(5633)
CANADIAN_SYLLABICS_CARRIER_NU = chr(5634)
CANADIAN_SYLLABICS_CARRIER_NO = chr(5635)
CANADIAN_SYLLABICS_CARRIER_NE = chr(5636)
CANADIAN_SYLLABICS_CARRIER_NEE = chr(5637)
CANADIAN_SYLLABICS_CARRIER_NI = chr(5638)
CANADIAN_SYLLABICS_CARRIER_NA = chr(5639)
CANADIAN_SYLLABICS_CARRIER_MU = chr(5640)
CANADIAN_SYLLABICS_CARRIER_MO = chr(5641)
CANADIAN_SYLLABICS_CARRIER_ME = chr(5642)
CANADIAN_SYLLABICS_CARRIER_MEE = chr(5643)
CANADIAN_SYLLABICS_CARRIER_MI = chr(5644)
CANADIAN_SYLLABICS_CARRIER_MA = chr(5645)
CANADIAN_SYLLABICS_CARRIER_YU = chr(5646)
CANADIAN_SYLLABICS_CARRIER_YO = chr(5647)
CANADIAN_SYLLABICS_CARRIER_YE = chr(5648)
CANADIAN_SYLLABICS_CARRIER_YEE = chr(5649)
CANADIAN_SYLLABICS_CARRIER_YI = chr(5650)
CANADIAN_SYLLABICS_CARRIER_YA = chr(5651)
CANADIAN_SYLLABICS_CARRIER_JU = chr(5652)
CANADIAN_SYLLABICS_SAYISI_JU = chr(5653)
CANADIAN_SYLLABICS_CARRIER_JO = chr(5654)
CANADIAN_SYLLABICS_CARRIER_JE = chr(5655)
CANADIAN_SYLLABICS_CARRIER_JEE = chr(5656)
CANADIAN_SYLLABICS_CARRIER_JI = chr(5657)
CANADIAN_SYLLABICS_SAYISI_JI = chr(5658)
CANADIAN_SYLLABICS_CARRIER_JA = chr(5659)
CANADIAN_SYLLABICS_CARRIER_JJU = chr(5660)
CANADIAN_SYLLABICS_CARRIER_JJO = chr(5661)
CANADIAN_SYLLABICS_CARRIER_JJE = chr(5662)
CANADIAN_SYLLABICS_CARRIER_JJEE = chr(5663)
CANADIAN_SYLLABICS_CARRIER_JJI = chr(5664)
CANADIAN_SYLLABICS_CARRIER_JJA = chr(5665)
CANADIAN_SYLLABICS_CARRIER_LU = chr(5666)
CANADIAN_SYLLABICS_CARRIER_LO = chr(5667)
CANADIAN_SYLLABICS_CARRIER_LE = chr(5668)
CANADIAN_SYLLABICS_CARRIER_LEE = chr(5669)
CANADIAN_SYLLABICS_CARRIER_LI = chr(5670)
CANADIAN_SYLLABICS_CARRIER_LA = chr(5671)
CANADIAN_SYLLABICS_CARRIER_DLU = chr(5672)
CANADIAN_SYLLABICS_CARRIER_DLO = chr(5673)
CANADIAN_SYLLABICS_CARRIER_DLE = chr(5674)
CANADIAN_SYLLABICS_CARRIER_DLEE = chr(5675)
CANADIAN_SYLLABICS_CARRIER_DLI = chr(5676)
CANADIAN_SYLLABICS_CARRIER_DLA = chr(5677)
CANADIAN_SYLLABICS_CARRIER_LHU = chr(5678)
CANADIAN_SYLLABICS_CARRIER_LHO = chr(5679)
CANADIAN_SYLLABICS_CARRIER_LHE = chr(5680)
CANADIAN_SYLLABICS_CARRIER_LHEE = chr(5681)
CANADIAN_SYLLABICS_CARRIER_LHI = chr(5682)
CANADIAN_SYLLABICS_CARRIER_LHA = chr(5683)
CANADIAN_SYLLABICS_CARRIER_TLHU = chr(5684)
CANADIAN_SYLLABICS_CARRIER_TLHO = chr(5685)
CANADIAN_SYLLABICS_CARRIER_TLHE = chr(5686)
CANADIAN_SYLLABICS_CARRIER_TLHEE = chr(5687)
CANADIAN_SYLLABICS_CARRIER_TLHI = chr(5688)
CANADIAN_SYLLABICS_CARRIER_TLHA = chr(5689)
CANADIAN_SYLLABICS_CARRIER_TLU = chr(5690)
CANADIAN_SYLLABICS_CARRIER_TLO = chr(5691)
CANADIAN_SYLLABICS_CARRIER_TLE = chr(5692)
CANADIAN_SYLLABICS_CARRIER_TLEE = chr(5693)
CANADIAN_SYLLABICS_CARRIER_TLI = chr(5694)
CANADIAN_SYLLABICS_CARRIER_TLA = chr(5695)
CANADIAN_SYLLABICS_CARRIER_ZU = chr(5696)
CANADIAN_SYLLABICS_CARRIER_ZO = chr(5697)
CANADIAN_SYLLABICS_CARRIER_ZE = chr(5698)
CANADIAN_SYLLABICS_CARRIER_ZEE = chr(5699)
CANADIAN_SYLLABICS_CARRIER_ZI = chr(5700)
CANADIAN_SYLLABICS_CARRIER_ZA = chr(5701)
CANADIAN_SYLLABICS_CARRIER_Z = chr(5702)
CANADIAN_SYLLABICS_CARRIER_INITIAL_Z = chr(5703)
CANADIAN_SYLLABICS_CARRIER_DZU = chr(5704)
CANADIAN_SYLLABICS_CARRIER_DZO = chr(5705)
CANADIAN_SYLLABICS_CARRIER_DZE = chr(5706)
CANADIAN_SYLLABICS_CARRIER_DZEE = chr(5707)
CANADIAN_SYLLABICS_CARRIER_DZI = chr(5708)
CANADIAN_SYLLABICS_CARRIER_DZA = chr(5709)
CANADIAN_SYLLABICS_CARRIER_SU = chr(5710)
CANADIAN_SYLLABICS_CARRIER_SO = chr(5711)
CANADIAN_SYLLABICS_CARRIER_SE = chr(5712)
CANADIAN_SYLLABICS_CARRIER_SEE = chr(5713)
CANADIAN_SYLLABICS_CARRIER_SI = chr(5714)
CANADIAN_SYLLABICS_CARRIER_SA = chr(5715)
CANADIAN_SYLLABICS_CARRIER_SHU = chr(5716)
CANADIAN_SYLLABICS_CARRIER_SHO = chr(5717)
CANADIAN_SYLLABICS_CARRIER_SHE = chr(5718)
CANADIAN_SYLLABICS_CARRIER_SHEE = chr(5719)
CANADIAN_SYLLABICS_CARRIER_SHI = chr(5720)
CANADIAN_SYLLABICS_CARRIER_SHA = chr(5721)
CANADIAN_SYLLABICS_CARRIER_SH = chr(5722)
CANADIAN_SYLLABICS_CARRIER_TSU = chr(5723)
CANADIAN_SYLLABICS_CARRIER_TSO = chr(5724)
CANADIAN_SYLLABICS_CARRIER_TSE = chr(5725)
CANADIAN_SYLLABICS_CARRIER_TSEE = chr(5726)
CANADIAN_SYLLABICS_CARRIER_TSI = chr(5727)
CANADIAN_SYLLABICS_CARRIER_TSA = chr(5728)
CANADIAN_SYLLABICS_CARRIER_CHU = chr(5729)
CANADIAN_SYLLABICS_CARRIER_CHO = chr(5730)
CANADIAN_SYLLABICS_CARRIER_CHE = chr(5731)
CANADIAN_SYLLABICS_CARRIER_CHEE = chr(5732)
CANADIAN_SYLLABICS_CARRIER_CHI = chr(5733)
CANADIAN_SYLLABICS_CARRIER_CHA = chr(5734)
CANADIAN_SYLLABICS_CARRIER_TTSU = chr(5735)
CANADIAN_SYLLABICS_CARRIER_TTSO = chr(5736)
CANADIAN_SYLLABICS_CARRIER_TTSE = chr(5737)
CANADIAN_SYLLABICS_CARRIER_TTSEE = chr(5738)
CANADIAN_SYLLABICS_CARRIER_TTSI = chr(5739)
CANADIAN_SYLLABICS_CARRIER_TTSA = chr(5740)
CANADIAN_SYLLABICS_CHI_SIGN = chr(5741)
CANADIAN_SYLLABICS_FULL_STOP = chr(5742)
CANADIAN_SYLLABICS_QAI = chr(5743)
CANADIAN_SYLLABICS_NGAI = chr(5744)
CANADIAN_SYLLABICS_NNGI = chr(5745)
CANADIAN_SYLLABICS_NNGII = chr(5746)
CANADIAN_SYLLABICS_NNGO = chr(5747)
CANADIAN_SYLLABICS_NNGOO = chr(5748)
CANADIAN_SYLLABICS_NNGA = chr(5749)
CANADIAN_SYLLABICS_NNGAA = chr(5750)
CANADIAN_SYLLABICS_WOODS_CREE_THWEE = chr(5751)
CANADIAN_SYLLABICS_WOODS_CREE_THWI = chr(5752)
CANADIAN_SYLLABICS_WOODS_CREE_THWII = chr(5753)
CANADIAN_SYLLABICS_WOODS_CREE_THWO = chr(5754)
CANADIAN_SYLLABICS_WOODS_CREE_THWOO = chr(5755)
CANADIAN_SYLLABICS_WOODS_CREE_THWA = chr(5756)
CANADIAN_SYLLABICS_WOODS_CREE_THWAA = chr(5757)
CANADIAN_SYLLABICS_WOODS_CREE_FINAL_TH = chr(5758)
CANADIAN_SYLLABICS_BLACKFOOT_W = chr(5759)
OGHAM_SPACE_MARK = chr(5760)
OGHAM_LETTER_BEITH = chr(5761)
OGHAM_LETTER_LUIS = chr(5762)
OGHAM_LETTER_FEARN = chr(5763)
OGHAM_LETTER_SAIL = chr(5764)
OGHAM_LETTER_NION = chr(5765)
OGHAM_LETTER_UATH = chr(5766)
OGHAM_LETTER_DAIR = chr(5767)
OGHAM_LETTER_TINNE = chr(5768)
OGHAM_LETTER_COLL = chr(5769)
OGHAM_LETTER_CEIRT = chr(5770)
OGHAM_LETTER_MUIN = chr(5771)
OGHAM_LETTER_GORT = chr(5772)
OGHAM_LETTER_NGEADAL = chr(5773)
OGHAM_LETTER_STRAIF = chr(5774)
OGHAM_LETTER_RUIS = chr(5775)
OGHAM_LETTER_AILM = chr(5776)
OGHAM_LETTER_ONN = chr(5777)
OGHAM_LETTER_UR = chr(5778)
OGHAM_LETTER_EADHADH = chr(5779)
OGHAM_LETTER_IODHADH = chr(5780)
OGHAM_LETTER_EABHADH = chr(5781)
OGHAM_LETTER_OR = chr(5782)
OGHAM_LETTER_UILLEANN = chr(5783)
OGHAM_LETTER_IFIN = chr(5784)
OGHAM_LETTER_EAMHANCHOLL = chr(5785)
OGHAM_LETTER_PEITH = chr(5786)
OGHAM_FEATHER_MARK = chr(5787)
OGHAM_REVERSED_FEATHER_MARK = chr(5788)
RUNIC_LETTER_FEHU_FEOH_FE_F = chr(5792)
RUNIC_LETTER_V = chr(5793)
RUNIC_LETTER_URUZ_UR_U = chr(5794)
RUNIC_LETTER_YR = chr(5795)
RUNIC_LETTER_Y = chr(5796)
RUNIC_LETTER_W = chr(5797)
RUNIC_LETTER_THURISAZ_THURS_THORN = chr(5798)
RUNIC_LETTER_ETH = chr(5799)
RUNIC_LETTER_ANSUZ_A = chr(5800)
RUNIC_LETTER_OS_O = chr(5801)
RUNIC_LETTER_AC_A = chr(5802)
RUNIC_LETTER_AESC = chr(5803)
RUNIC_LETTER_LONG_BRANCH_OSS_O = chr(5804)
RUNIC_LETTER_SHORT_TWIG_OSS_O = chr(5805)
RUNIC_LETTER_O = chr(5806)
RUNIC_LETTER_OE = chr(5807)
RUNIC_LETTER_ON = chr(5808)
RUNIC_LETTER_RAIDO_RAD_REID_R = chr(5809)
RUNIC_LETTER_KAUNA = chr(5810)
RUNIC_LETTER_CEN = chr(5811)
RUNIC_LETTER_KAUN_K = chr(5812)
RUNIC_LETTER_G = chr(5813)
RUNIC_LETTER_ENG = chr(5814)
RUNIC_LETTER_GEBO_GYFU_G = chr(5815)
RUNIC_LETTER_GAR = chr(5816)
RUNIC_LETTER_WUNJO_WYNN_W = chr(5817)
RUNIC_LETTER_HAGLAZ_H = chr(5818)
RUNIC_LETTER_HAEGL_H = chr(5819)
RUNIC_LETTER_LONG_BRANCH_HAGALL_H = chr(5820)
RUNIC_LETTER_SHORT_TWIG_HAGALL_H = chr(5821)
RUNIC_LETTER_NAUDIZ_NYD_NAUD_N = chr(5822)
RUNIC_LETTER_SHORT_TWIG_NAUD_N = chr(5823)
RUNIC_LETTER_DOTTED_N = chr(5824)
RUNIC_LETTER_ISAZ_IS_ISS_I = chr(5825)
RUNIC_LETTER_E = chr(5826)
RUNIC_LETTER_JERAN_J = chr(5827)
RUNIC_LETTER_GER = chr(5828)
RUNIC_LETTER_LONG_BRANCH_AR_AE = chr(5829)
RUNIC_LETTER_SHORT_TWIG_AR_A = chr(5830)
RUNIC_LETTER_IWAZ_EOH = chr(5831)
RUNIC_LETTER_PERTHO_PEORTH_P = chr(5832)
RUNIC_LETTER_ALGIZ_EOLHX = chr(5833)
RUNIC_LETTER_SOWILO_S = chr(5834)
RUNIC_LETTER_SIGEL_LONG_BRANCH_SOL_S = chr(5835)
RUNIC_LETTER_SHORT_TWIG_SOL_S = chr(5836)
RUNIC_LETTER_C = chr(5837)
RUNIC_LETTER_Z = chr(5838)
RUNIC_LETTER_TIWAZ_TIR_TYR_T = chr(5839)
RUNIC_LETTER_SHORT_TWIG_TYR_T = chr(5840)
RUNIC_LETTER_D = chr(5841)
RUNIC_LETTER_BERKANAN_BEORC_BJARKAN_B = chr(5842)
RUNIC_LETTER_SHORT_TWIG_BJARKAN_B = chr(5843)
RUNIC_LETTER_DOTTED_P = chr(5844)
RUNIC_LETTER_OPEN_P = chr(5845)
RUNIC_LETTER_EHWAZ_EH_E = chr(5846)
RUNIC_LETTER_MANNAZ_MAN_M = chr(5847)
RUNIC_LETTER_LONG_BRANCH_MADR_M = chr(5848)
RUNIC_LETTER_SHORT_TWIG_MADR_M = chr(5849)
RUNIC_LETTER_LAUKAZ_LAGU_LOGR_L = chr(5850)
RUNIC_LETTER_DOTTED_L = chr(5851)
RUNIC_LETTER_INGWAZ = chr(5852)
RUNIC_LETTER_ING = chr(5853)
RUNIC_LETTER_DAGAZ_DAEG_D = chr(5854)
RUNIC_LETTER_OTHALAN_ETHEL_O = chr(5855)
RUNIC_LETTER_EAR = chr(5856)
RUNIC_LETTER_IOR = chr(5857)
RUNIC_LETTER_CWEORTH = chr(5858)
RUNIC_LETTER_CALC = chr(5859)
RUNIC_LETTER_CEALC = chr(5860)
RUNIC_LETTER_STAN = chr(5861)
RUNIC_LETTER_LONG_BRANCH_YR = chr(5862)
RUNIC_LETTER_SHORT_TWIG_YR = chr(5863)
RUNIC_LETTER_ICELANDIC_YR = chr(5864)
RUNIC_LETTER_Q = chr(5865)
RUNIC_LETTER_X = chr(5866)
RUNIC_SINGLE_PUNCTUATION = chr(5867)
RUNIC_MULTIPLE_PUNCTUATION = chr(5868)
RUNIC_CROSS_PUNCTUATION = chr(5869)
RUNIC_ARLAUG_SYMBOL = chr(5870)
RUNIC_TVIMADUR_SYMBOL = chr(5871)
RUNIC_BELGTHOR_SYMBOL = chr(5872)
RUNIC_LETTER_K = chr(5873)
RUNIC_LETTER_SH = chr(5874)
RUNIC_LETTER_OO = chr(5875)
RUNIC_LETTER_FRANKS_CASKET_OS = chr(5876)
RUNIC_LETTER_FRANKS_CASKET_IS = chr(5877)
RUNIC_LETTER_FRANKS_CASKET_EH = chr(5878)
RUNIC_LETTER_FRANKS_CASKET_AC = chr(5879)
RUNIC_LETTER_FRANKS_CASKET_AESC = chr(5880)
TAGALOG_LETTER_A = chr(5888)
TAGALOG_LETTER_I = chr(5889)
TAGALOG_LETTER_U = chr(5890)
TAGALOG_LETTER_KA = chr(5891)
TAGALOG_LETTER_GA = chr(5892)
TAGALOG_LETTER_NGA = chr(5893)
TAGALOG_LETTER_TA = chr(5894)
TAGALOG_LETTER_DA = chr(5895)
TAGALOG_LETTER_NA = chr(5896)
TAGALOG_LETTER_PA = chr(5897)
TAGALOG_LETTER_BA = chr(5898)
TAGALOG_LETTER_MA = chr(5899)
TAGALOG_LETTER_YA = chr(5900)
TAGALOG_LETTER_RA = chr(5901)
TAGALOG_LETTER_LA = chr(5902)
TAGALOG_LETTER_WA = chr(5903)
TAGALOG_LETTER_SA = chr(5904)
TAGALOG_LETTER_HA = chr(5905)
TAGALOG_VOWEL_SIGN_I = chr(5906)
TAGALOG_VOWEL_SIGN_U = chr(5907)
TAGALOG_SIGN_VIRAMA = chr(5908)
TAGALOG_SIGN_PAMUDPOD = chr(5909)
TAGALOG_LETTER_ARCHAIC_RA = chr(5919)
HANUNOO_LETTER_A = chr(5920)
HANUNOO_LETTER_I = chr(5921)
HANUNOO_LETTER_U = chr(5922)
HANUNOO_LETTER_KA = chr(5923)
HANUNOO_LETTER_GA = chr(5924)
HANUNOO_LETTER_NGA = chr(5925)
HANUNOO_LETTER_TA = chr(5926)
HANUNOO_LETTER_DA = chr(5927)
HANUNOO_LETTER_NA = chr(5928)
HANUNOO_LETTER_PA = chr(5929)
HANUNOO_LETTER_BA = chr(5930)
HANUNOO_LETTER_MA = chr(5931)
HANUNOO_LETTER_YA = chr(5932)
HANUNOO_LETTER_RA = chr(5933)
HANUNOO_LETTER_LA = chr(5934)
HANUNOO_LETTER_WA = chr(5935)
HANUNOO_LETTER_SA = chr(5936)
HANUNOO_LETTER_HA = chr(5937)
HANUNOO_VOWEL_SIGN_I = chr(5938)
HANUNOO_VOWEL_SIGN_U = chr(5939)
HANUNOO_SIGN_PAMUDPOD = chr(5940)
PHILIPPINE_SINGLE_PUNCTUATION = chr(5941)
PHILIPPINE_DOUBLE_PUNCTUATION = chr(5942)
BUHID_LETTER_A = chr(5952)
BUHID_LETTER_I = chr(5953)
BUHID_LETTER_U = chr(5954)
BUHID_LETTER_KA = chr(5955)
BUHID_LETTER_GA = chr(5956)
BUHID_LETTER_NGA = chr(5957)
BUHID_LETTER_TA = chr(5958)
BUHID_LETTER_DA = chr(5959)
BUHID_LETTER_NA = chr(5960)
BUHID_LETTER_PA = chr(5961)
BUHID_LETTER_BA = chr(5962)
BUHID_LETTER_MA = chr(5963)
BUHID_LETTER_YA = chr(5964)
BUHID_LETTER_RA = chr(5965)
BUHID_LETTER_LA = chr(5966)
BUHID_LETTER_WA = chr(5967)
BUHID_LETTER_SA = chr(5968)
BUHID_LETTER_HA = chr(5969)
BUHID_VOWEL_SIGN_I = chr(5970)
BUHID_VOWEL_SIGN_U = chr(5971)
TAGBANWA_LETTER_A = chr(5984)
TAGBANWA_LETTER_I = chr(5985)
TAGBANWA_LETTER_U = chr(5986)
TAGBANWA_LETTER_KA = chr(5987)
TAGBANWA_LETTER_GA = chr(5988)
TAGBANWA_LETTER_NGA = chr(5989)
TAGBANWA_LETTER_TA = chr(5990)
TAGBANWA_LETTER_DA = chr(5991)
TAGBANWA_LETTER_NA = chr(5992)
TAGBANWA_LETTER_PA = chr(5993)
TAGBANWA_LETTER_BA = chr(5994)
TAGBANWA_LETTER_MA = chr(5995)
TAGBANWA_LETTER_YA = chr(5996)
TAGBANWA_LETTER_LA = chr(5998)
TAGBANWA_LETTER_WA = chr(5999)
TAGBANWA_LETTER_SA = chr(6000)
TAGBANWA_VOWEL_SIGN_I = chr(6002)
TAGBANWA_VOWEL_SIGN_U = chr(6003)
KHMER_LETTER_KA = chr(6016)
KHMER_LETTER_KHA = chr(6017)
KHMER_LETTER_KO = chr(6018)
KHMER_LETTER_KHO = chr(6019)
KHMER_LETTER_NGO = chr(6020)
KHMER_LETTER_CA = chr(6021)
KHMER_LETTER_CHA = chr(6022)
KHMER_LETTER_CO = chr(6023)
KHMER_LETTER_CHO = chr(6024)
KHMER_LETTER_NYO = chr(6025)
KHMER_LETTER_DA = chr(6026)
KHMER_LETTER_TTHA = chr(6027)
KHMER_LETTER_DO = chr(6028)
KHMER_LETTER_TTHO = chr(6029)
KHMER_LETTER_NNO = chr(6030)
KHMER_LETTER_TA = chr(6031)
KHMER_LETTER_THA = chr(6032)
KHMER_LETTER_TO = chr(6033)
KHMER_LETTER_THO = chr(6034)
KHMER_LETTER_NO = chr(6035)
KHMER_LETTER_BA = chr(6036)
KHMER_LETTER_PHA = chr(6037)
KHMER_LETTER_PO = chr(6038)
KHMER_LETTER_PHO = chr(6039)
KHMER_LETTER_MO = chr(6040)
KHMER_LETTER_YO = chr(6041)
KHMER_LETTER_RO = chr(6042)
KHMER_LETTER_LO = chr(6043)
KHMER_LETTER_VO = chr(6044)
KHMER_LETTER_SHA = chr(6045)
KHMER_LETTER_SSO = chr(6046)
KHMER_LETTER_SA = chr(6047)
KHMER_LETTER_HA = chr(6048)
KHMER_LETTER_LA = chr(6049)
KHMER_LETTER_QA = chr(6050)
KHMER_INDEPENDENT_VOWEL_QAQ = chr(6051)
KHMER_INDEPENDENT_VOWEL_QAA = chr(6052)
KHMER_INDEPENDENT_VOWEL_QI = chr(6053)
KHMER_INDEPENDENT_VOWEL_QII = chr(6054)
KHMER_INDEPENDENT_VOWEL_QU = chr(6055)
KHMER_INDEPENDENT_VOWEL_QUK = chr(6056)
KHMER_INDEPENDENT_VOWEL_QUU = chr(6057)
KHMER_INDEPENDENT_VOWEL_QUUV = chr(6058)
KHMER_INDEPENDENT_VOWEL_RY = chr(6059)
KHMER_INDEPENDENT_VOWEL_RYY = chr(6060)
KHMER_INDEPENDENT_VOWEL_LY = chr(6061)
KHMER_INDEPENDENT_VOWEL_LYY = chr(6062)
KHMER_INDEPENDENT_VOWEL_QE = chr(6063)
KHMER_INDEPENDENT_VOWEL_QAI = chr(6064)
KHMER_INDEPENDENT_VOWEL_QOO_TYPE_ONE = chr(6065)
KHMER_INDEPENDENT_VOWEL_QOO_TYPE_TWO = chr(6066)
KHMER_INDEPENDENT_VOWEL_QAU = chr(6067)
KHMER_VOWEL_INHERENT_AQ = chr(6068)
KHMER_VOWEL_INHERENT_AA = chr(6069)
KHMER_VOWEL_SIGN_AA = chr(6070)
KHMER_VOWEL_SIGN_I = chr(6071)
KHMER_VOWEL_SIGN_II = chr(6072)
KHMER_VOWEL_SIGN_Y = chr(6073)
KHMER_VOWEL_SIGN_YY = chr(6074)
KHMER_VOWEL_SIGN_U = chr(6075)
KHMER_VOWEL_SIGN_UU = chr(6076)
KHMER_VOWEL_SIGN_UA = chr(6077)
KHMER_VOWEL_SIGN_OE = chr(6078)
KHMER_VOWEL_SIGN_YA = chr(6079)
KHMER_VOWEL_SIGN_IE = chr(6080)
KHMER_VOWEL_SIGN_E = chr(6081)
KHMER_VOWEL_SIGN_AE = chr(6082)
KHMER_VOWEL_SIGN_AI = chr(6083)
KHMER_VOWEL_SIGN_OO = chr(6084)
KHMER_VOWEL_SIGN_AU = chr(6085)
KHMER_SIGN_NIKAHIT = chr(6086)
KHMER_SIGN_REAHMUK = chr(6087)
KHMER_SIGN_YUUKALEAPINTU = chr(6088)
KHMER_SIGN_MUUSIKATOAN = chr(6089)
KHMER_SIGN_TRIISAP = chr(6090)
KHMER_SIGN_BANTOC = chr(6091)
KHMER_SIGN_ROBAT = chr(6092)
KHMER_SIGN_TOANDAKHIAT = chr(6093)
KHMER_SIGN_KAKABAT = chr(6094)
KHMER_SIGN_AHSDA = chr(6095)
KHMER_SIGN_SAMYOK_SANNYA = chr(6096)
KHMER_SIGN_VIRIAM = chr(6097)
KHMER_SIGN_COENG = chr(6098)
KHMER_SIGN_BATHAMASAT = chr(6099)
KHMER_SIGN_KHAN = chr(6100)
KHMER_SIGN_BARIYOOSAN = chr(6101)
KHMER_SIGN_CAMNUC_PII_KUUH = chr(6102)
KHMER_SIGN_LEK_TOO = chr(6103)
KHMER_SIGN_BEYYAL = chr(6104)
KHMER_SIGN_PHNAEK_MUAN = chr(6105)
KHMER_SIGN_KOOMUUT = chr(6106)
KHMER_CURRENCY_SYMBOL_RIEL = chr(6107)
KHMER_SIGN_AVAKRAHASANYA = chr(6108)
KHMER_SIGN_ATTHACAN = chr(6109)
KHMER_DIGIT_ZERO = chr(6112)
KHMER_DIGIT_ONE = chr(6113)
KHMER_DIGIT_TWO = chr(6114)
KHMER_DIGIT_THREE = chr(6115)
KHMER_DIGIT_FOUR = chr(6116)
KHMER_DIGIT_FIVE = chr(6117)
KHMER_DIGIT_SIX = chr(6118)
KHMER_DIGIT_SEVEN = chr(6119)
KHMER_DIGIT_EIGHT = chr(6120)
KHMER_DIGIT_NINE = chr(6121)
KHMER_SYMBOL_LEK_ATTAK_SON = chr(6128)
KHMER_SYMBOL_LEK_ATTAK_MUOY = chr(6129)
KHMER_SYMBOL_LEK_ATTAK_PII = chr(6130)
KHMER_SYMBOL_LEK_ATTAK_BEI = chr(6131)
KHMER_SYMBOL_LEK_ATTAK_BUON = chr(6132)
KHMER_SYMBOL_LEK_ATTAK_PRAM = chr(6133)
KHMER_SYMBOL_LEK_ATTAK_PRAM_MUOY = chr(6134)
KHMER_SYMBOL_LEK_ATTAK_PRAM_PII = chr(6135)
KHMER_SYMBOL_LEK_ATTAK_PRAM_BEI = chr(6136)
KHMER_SYMBOL_LEK_ATTAK_PRAM_BUON = chr(6137)
MONGOLIAN_BIRGA = chr(6144)
MONGOLIAN_ELLIPSIS = chr(6145)
MONGOLIAN_COMMA = chr(6146)
MONGOLIAN_FULL_STOP = chr(6147)
MONGOLIAN_COLON = chr(6148)
MONGOLIAN_FOUR_DOTS = chr(6149)
MONGOLIAN_TODO_SOFT_HYPHEN = chr(6150)
MONGOLIAN_SIBE_SYLLABLE_BOUNDARY_MARKER = chr(6151)
MONGOLIAN_MANCHU_COMMA = chr(6152)
MONGOLIAN_MANCHU_FULL_STOP = chr(6153)
MONGOLIAN_NIRUGU = chr(6154)
MONGOLIAN_FREE_VARIATION_SELECTOR_ONE = chr(6155)
MONGOLIAN_FREE_VARIATION_SELECTOR_TWO = chr(6156)
MONGOLIAN_FREE_VARIATION_SELECTOR_THREE = chr(6157)
MONGOLIAN_VOWEL_SEPARATOR = chr(6158)
MONGOLIAN_FREE_VARIATION_SELECTOR_FOUR = chr(6159)
MONGOLIAN_DIGIT_ZERO = chr(6160)
MONGOLIAN_DIGIT_ONE = chr(6161)
MONGOLIAN_DIGIT_TWO = chr(6162)
MONGOLIAN_DIGIT_THREE = chr(6163)
MONGOLIAN_DIGIT_FOUR = chr(6164)
MONGOLIAN_DIGIT_FIVE = chr(6165)
MONGOLIAN_DIGIT_SIX = chr(6166)
MONGOLIAN_DIGIT_SEVEN = chr(6167)
MONGOLIAN_DIGIT_EIGHT = chr(6168)
MONGOLIAN_DIGIT_NINE = chr(6169)
MONGOLIAN_LETTER_A = chr(6176)
MONGOLIAN_LETTER_E = chr(6177)
MONGOLIAN_LETTER_I = chr(6178)
MONGOLIAN_LETTER_O = chr(6179)
MONGOLIAN_LETTER_U = chr(6180)
MONGOLIAN_LETTER_OE = chr(6181)
MONGOLIAN_LETTER_UE = chr(6182)
MONGOLIAN_LETTER_EE = chr(6183)
MONGOLIAN_LETTER_NA = chr(6184)
MONGOLIAN_LETTER_ANG = chr(6185)
MONGOLIAN_LETTER_BA = chr(6186)
MONGOLIAN_LETTER_PA = chr(6187)
MONGOLIAN_LETTER_QA = chr(6188)
MONGOLIAN_LETTER_GA = chr(6189)
MONGOLIAN_LETTER_MA = chr(6190)
MONGOLIAN_LETTER_LA = chr(6191)
MONGOLIAN_LETTER_SA = chr(6192)
MONGOLIAN_LETTER_SHA = chr(6193)
MONGOLIAN_LETTER_TA = chr(6194)
MONGOLIAN_LETTER_DA = chr(6195)
MONGOLIAN_LETTER_CHA = chr(6196)
MONGOLIAN_LETTER_JA = chr(6197)
MONGOLIAN_LETTER_YA = chr(6198)
MONGOLIAN_LETTER_RA = chr(6199)
MONGOLIAN_LETTER_WA = chr(6200)
MONGOLIAN_LETTER_FA = chr(6201)
MONGOLIAN_LETTER_KA = chr(6202)
MONGOLIAN_LETTER_KHA = chr(6203)
MONGOLIAN_LETTER_TSA = chr(6204)
MONGOLIAN_LETTER_ZA = chr(6205)
MONGOLIAN_LETTER_HAA = chr(6206)
MONGOLIAN_LETTER_ZRA = chr(6207)
MONGOLIAN_LETTER_LHA = chr(6208)
MONGOLIAN_LETTER_ZHI = chr(6209)
MONGOLIAN_LETTER_CHI = chr(6210)
MONGOLIAN_LETTER_TODO_LONG_VOWEL_SIGN = chr(6211)
MONGOLIAN_LETTER_TODO_E = chr(6212)
MONGOLIAN_LETTER_TODO_I = chr(6213)
MONGOLIAN_LETTER_TODO_O = chr(6214)
MONGOLIAN_LETTER_TODO_U = chr(6215)
MONGOLIAN_LETTER_TODO_OE = chr(6216)
MONGOLIAN_LETTER_TODO_UE = chr(6217)
MONGOLIAN_LETTER_TODO_ANG = chr(6218)
MONGOLIAN_LETTER_TODO_BA = chr(6219)
MONGOLIAN_LETTER_TODO_PA = chr(6220)
MONGOLIAN_LETTER_TODO_QA = chr(6221)
MONGOLIAN_LETTER_TODO_GA = chr(6222)
MONGOLIAN_LETTER_TODO_MA = chr(6223)
MONGOLIAN_LETTER_TODO_TA = chr(6224)
MONGOLIAN_LETTER_TODO_DA = chr(6225)
MONGOLIAN_LETTER_TODO_CHA = chr(6226)
MONGOLIAN_LETTER_TODO_JA = chr(6227)
MONGOLIAN_LETTER_TODO_TSA = chr(6228)
MONGOLIAN_LETTER_TODO_YA = chr(6229)
MONGOLIAN_LETTER_TODO_WA = chr(6230)
MONGOLIAN_LETTER_TODO_KA = chr(6231)
MONGOLIAN_LETTER_TODO_GAA = chr(6232)
MONGOLIAN_LETTER_TODO_HAA = chr(6233)
MONGOLIAN_LETTER_TODO_JIA = chr(6234)
MONGOLIAN_LETTER_TODO_NIA = chr(6235)
MONGOLIAN_LETTER_TODO_DZA = chr(6236)
MONGOLIAN_LETTER_SIBE_E = chr(6237)
MONGOLIAN_LETTER_SIBE_I = chr(6238)
MONGOLIAN_LETTER_SIBE_IY = chr(6239)
MONGOLIAN_LETTER_SIBE_UE = chr(6240)
MONGOLIAN_LETTER_SIBE_U = chr(6241)
MONGOLIAN_LETTER_SIBE_ANG = chr(6242)
MONGOLIAN_LETTER_SIBE_KA = chr(6243)
MONGOLIAN_LETTER_SIBE_GA = chr(6244)
MONGOLIAN_LETTER_SIBE_HA = chr(6245)
MONGOLIAN_LETTER_SIBE_PA = chr(6246)
MONGOLIAN_LETTER_SIBE_SHA = chr(6247)
MONGOLIAN_LETTER_SIBE_TA = chr(6248)
MONGOLIAN_LETTER_SIBE_DA = chr(6249)
MONGOLIAN_LETTER_SIBE_JA = chr(6250)
MONGOLIAN_LETTER_SIBE_FA = chr(6251)
MONGOLIAN_LETTER_SIBE_GAA = chr(6252)
MONGOLIAN_LETTER_SIBE_HAA = chr(6253)
MONGOLIAN_LETTER_SIBE_TSA = chr(6254)
MONGOLIAN_LETTER_SIBE_ZA = chr(6255)
MONGOLIAN_LETTER_SIBE_RAA = chr(6256)
MONGOLIAN_LETTER_SIBE_CHA = chr(6257)
MONGOLIAN_LETTER_SIBE_ZHA = chr(6258)
MONGOLIAN_LETTER_MANCHU_I = chr(6259)
MONGOLIAN_LETTER_MANCHU_KA = chr(6260)
MONGOLIAN_LETTER_MANCHU_RA = chr(6261)
MONGOLIAN_LETTER_MANCHU_FA = chr(6262)
MONGOLIAN_LETTER_MANCHU_ZHA = chr(6263)
MONGOLIAN_LETTER_CHA_WITH_TWO_DOTS = chr(6264)
MONGOLIAN_LETTER_ALI_GALI_ANUSVARA_ONE = chr(6272)
MONGOLIAN_LETTER_ALI_GALI_VISARGA_ONE = chr(6273)
MONGOLIAN_LETTER_ALI_GALI_DAMARU = chr(6274)
MONGOLIAN_LETTER_ALI_GALI_UBADAMA = chr(6275)
MONGOLIAN_LETTER_ALI_GALI_INVERTED_UBADAMA = chr(6276)
MONGOLIAN_LETTER_ALI_GALI_BALUDA = chr(6277)
MONGOLIAN_LETTER_ALI_GALI_THREE_BALUDA = chr(6278)
MONGOLIAN_LETTER_ALI_GALI_A = chr(6279)
MONGOLIAN_LETTER_ALI_GALI_I = chr(6280)
MONGOLIAN_LETTER_ALI_GALI_KA = chr(6281)
MONGOLIAN_LETTER_ALI_GALI_NGA = chr(6282)
MONGOLIAN_LETTER_ALI_GALI_CA = chr(6283)
MONGOLIAN_LETTER_ALI_GALI_TTA = chr(6284)
MONGOLIAN_LETTER_ALI_GALI_TTHA = chr(6285)
MONGOLIAN_LETTER_ALI_GALI_DDA = chr(6286)
MONGOLIAN_LETTER_ALI_GALI_NNA = chr(6287)
MONGOLIAN_LETTER_ALI_GALI_TA = chr(6288)
MONGOLIAN_LETTER_ALI_GALI_DA = chr(6289)
MONGOLIAN_LETTER_ALI_GALI_PA = chr(6290)
MONGOLIAN_LETTER_ALI_GALI_PHA = chr(6291)
MONGOLIAN_LETTER_ALI_GALI_SSA = chr(6292)
MONGOLIAN_LETTER_ALI_GALI_ZHA = chr(6293)
MONGOLIAN_LETTER_ALI_GALI_ZA = chr(6294)
MONGOLIAN_LETTER_ALI_GALI_AH = chr(6295)
MONGOLIAN_LETTER_TODO_ALI_GALI_TA = chr(6296)
MONGOLIAN_LETTER_TODO_ALI_GALI_ZHA = chr(6297)
MONGOLIAN_LETTER_MANCHU_ALI_GALI_GHA = chr(6298)
MONGOLIAN_LETTER_MANCHU_ALI_GALI_NGA = chr(6299)
MONGOLIAN_LETTER_MANCHU_ALI_GALI_CA = chr(6300)
MONGOLIAN_LETTER_MANCHU_ALI_GALI_JHA = chr(6301)
MONGOLIAN_LETTER_MANCHU_ALI_GALI_TTA = chr(6302)
MONGOLIAN_LETTER_MANCHU_ALI_GALI_DDHA = chr(6303)
MONGOLIAN_LETTER_MANCHU_ALI_GALI_TA = chr(6304)
MONGOLIAN_LETTER_MANCHU_ALI_GALI_DHA = chr(6305)
MONGOLIAN_LETTER_MANCHU_ALI_GALI_SSA = chr(6306)
MONGOLIAN_LETTER_MANCHU_ALI_GALI_CYA = chr(6307)
MONGOLIAN_LETTER_MANCHU_ALI_GALI_ZHA = chr(6308)
MONGOLIAN_LETTER_MANCHU_ALI_GALI_ZA = chr(6309)
MONGOLIAN_LETTER_ALI_GALI_HALF_U = chr(6310)
MONGOLIAN_LETTER_ALI_GALI_HALF_YA = chr(6311)
MONGOLIAN_LETTER_MANCHU_ALI_GALI_BHA = chr(6312)
MONGOLIAN_LETTER_ALI_GALI_DAGALGA = chr(6313)
MONGOLIAN_LETTER_MANCHU_ALI_GALI_LHA = chr(6314)
CANADIAN_SYLLABICS_OY = chr(6320)
CANADIAN_SYLLABICS_AY = chr(6321)
CANADIAN_SYLLABICS_AAY = chr(6322)
CANADIAN_SYLLABICS_WAY = chr(6323)
CANADIAN_SYLLABICS_POY = chr(6324)
CANADIAN_SYLLABICS_PAY = chr(6325)
CANADIAN_SYLLABICS_PWOY = chr(6326)
CANADIAN_SYLLABICS_TAY = chr(6327)
CANADIAN_SYLLABICS_KAY = chr(6328)
CANADIAN_SYLLABICS_KWAY = chr(6329)
CANADIAN_SYLLABICS_MAY = chr(6330)
CANADIAN_SYLLABICS_NOY = chr(6331)
CANADIAN_SYLLABICS_NAY = chr(6332)
CANADIAN_SYLLABICS_LAY = chr(6333)
CANADIAN_SYLLABICS_SOY = chr(6334)
CANADIAN_SYLLABICS_SAY = chr(6335)
CANADIAN_SYLLABICS_SHOY = chr(6336)
CANADIAN_SYLLABICS_SHAY = chr(6337)
CANADIAN_SYLLABICS_SHWOY = chr(6338)
CANADIAN_SYLLABICS_YOY = chr(6339)
CANADIAN_SYLLABICS_YAY = chr(6340)
CANADIAN_SYLLABICS_RAY = chr(6341)
CANADIAN_SYLLABICS_NWI = chr(6342)
CANADIAN_SYLLABICS_OJIBWAY_NWI = chr(6343)
CANADIAN_SYLLABICS_NWII = chr(6344)
CANADIAN_SYLLABICS_OJIBWAY_NWII = chr(6345)
CANADIAN_SYLLABICS_NWO = chr(6346)
CANADIAN_SYLLABICS_OJIBWAY_NWO = chr(6347)
CANADIAN_SYLLABICS_NWOO = chr(6348)
CANADIAN_SYLLABICS_OJIBWAY_NWOO = chr(6349)
CANADIAN_SYLLABICS_RWEE = chr(6350)
CANADIAN_SYLLABICS_RWI = chr(6351)
CANADIAN_SYLLABICS_RWII = chr(6352)
CANADIAN_SYLLABICS_RWO = chr(6353)
CANADIAN_SYLLABICS_RWOO = chr(6354)
CANADIAN_SYLLABICS_RWA = chr(6355)
CANADIAN_SYLLABICS_OJIBWAY_P = chr(6356)
CANADIAN_SYLLABICS_OJIBWAY_T = chr(6357)
CANADIAN_SYLLABICS_OJIBWAY_K = chr(6358)
CANADIAN_SYLLABICS_OJIBWAY_C = chr(6359)
CANADIAN_SYLLABICS_OJIBWAY_M = chr(6360)
CANADIAN_SYLLABICS_OJIBWAY_N = chr(6361)
CANADIAN_SYLLABICS_OJIBWAY_S = chr(6362)
CANADIAN_SYLLABICS_OJIBWAY_SH = chr(6363)
CANADIAN_SYLLABICS_EASTERN_W = chr(6364)
CANADIAN_SYLLABICS_WESTERN_W = chr(6365)
CANADIAN_SYLLABICS_FINAL_SMALL_RING = chr(6366)
CANADIAN_SYLLABICS_FINAL_RAISED_DOT = chr(6367)
CANADIAN_SYLLABICS_R_CREE_RWE = chr(6368)
CANADIAN_SYLLABICS_WEST_CREE_LOO = chr(6369)
CANADIAN_SYLLABICS_WEST_CREE_LAA = chr(6370)
CANADIAN_SYLLABICS_THWE = chr(6371)
CANADIAN_SYLLABICS_THWA = chr(6372)
CANADIAN_SYLLABICS_TTHWE = chr(6373)
CANADIAN_SYLLABICS_TTHOO = chr(6374)
CANADIAN_SYLLABICS_TTHAA = chr(6375)
CANADIAN_SYLLABICS_TLHWE = chr(6376)
CANADIAN_SYLLABICS_TLHOO = chr(6377)
CANADIAN_SYLLABICS_SAYISI_SHWE = chr(6378)
CANADIAN_SYLLABICS_SAYISI_SHOO = chr(6379)
CANADIAN_SYLLABICS_SAYISI_HOO = chr(6380)
CANADIAN_SYLLABICS_CARRIER_GWU = chr(6381)
CANADIAN_SYLLABICS_CARRIER_DENE_GEE = chr(6382)
CANADIAN_SYLLABICS_CARRIER_GAA = chr(6383)
CANADIAN_SYLLABICS_CARRIER_GWA = chr(6384)
CANADIAN_SYLLABICS_SAYISI_JUU = chr(6385)
CANADIAN_SYLLABICS_CARRIER_JWA = chr(6386)
CANADIAN_SYLLABICS_BEAVER_DENE_L = chr(6387)
CANADIAN_SYLLABICS_BEAVER_DENE_R = chr(6388)
CANADIAN_SYLLABICS_CARRIER_DENTAL_S = chr(6389)
LIMBU_VOWEL_CARRIER_LETTER = chr(6400)
LIMBU_LETTER_KA = chr(6401)
LIMBU_LETTER_KHA = chr(6402)
LIMBU_LETTER_GA = chr(6403)
LIMBU_LETTER_GHA = chr(6404)
LIMBU_LETTER_NGA = chr(6405)
LIMBU_LETTER_CA = chr(6406)
LIMBU_LETTER_CHA = chr(6407)
LIMBU_LETTER_JA = chr(6408)
LIMBU_LETTER_JHA = chr(6409)
LIMBU_LETTER_YAN = chr(6410)
LIMBU_LETTER_TA = chr(6411)
LIMBU_LETTER_THA = chr(6412)
LIMBU_LETTER_DA = chr(6413)
LIMBU_LETTER_DHA = chr(6414)
LIMBU_LETTER_NA = chr(6415)
LIMBU_LETTER_PA = chr(6416)
LIMBU_LETTER_PHA = chr(6417)
LIMBU_LETTER_BA = chr(6418)
LIMBU_LETTER_BHA = chr(6419)
LIMBU_LETTER_MA = chr(6420)
LIMBU_LETTER_YA = chr(6421)
LIMBU_LETTER_RA = chr(6422)
LIMBU_LETTER_LA = chr(6423)
LIMBU_LETTER_WA = chr(6424)
LIMBU_LETTER_SHA = chr(6425)
LIMBU_LETTER_SSA = chr(6426)
LIMBU_LETTER_SA = chr(6427)
LIMBU_LETTER_HA = chr(6428)
LIMBU_LETTER_GYAN = chr(6429)
LIMBU_LETTER_TRA = chr(6430)
LIMBU_VOWEL_SIGN_A = chr(6432)
LIMBU_VOWEL_SIGN_I = chr(6433)
LIMBU_VOWEL_SIGN_U = chr(6434)
LIMBU_VOWEL_SIGN_EE = chr(6435)
LIMBU_VOWEL_SIGN_AI = chr(6436)
LIMBU_VOWEL_SIGN_OO = chr(6437)
LIMBU_VOWEL_SIGN_AU = chr(6438)
LIMBU_VOWEL_SIGN_E = chr(6439)
LIMBU_VOWEL_SIGN_O = chr(6440)
LIMBU_SUBJOINED_LETTER_YA = chr(6441)
LIMBU_SUBJOINED_LETTER_RA = chr(6442)
LIMBU_SUBJOINED_LETTER_WA = chr(6443)
LIMBU_SMALL_LETTER_KA = chr(6448)
LIMBU_SMALL_LETTER_NGA = chr(6449)
LIMBU_SMALL_LETTER_ANUSVARA = chr(6450)
LIMBU_SMALL_LETTER_TA = chr(6451)
LIMBU_SMALL_LETTER_NA = chr(6452)
LIMBU_SMALL_LETTER_PA = chr(6453)
LIMBU_SMALL_LETTER_MA = chr(6454)
LIMBU_SMALL_LETTER_RA = chr(6455)
LIMBU_SMALL_LETTER_LA = chr(6456)
LIMBU_SIGN_MUKPHRENG = chr(6457)
LIMBU_SIGN_KEMPHRENG = chr(6458)
LIMBU_SIGN_SA_I = chr(6459)
LIMBU_SIGN_LOO = chr(6464)
LIMBU_EXCLAMATION_MARK = chr(6468)
LIMBU_QUESTION_MARK = chr(6469)
LIMBU_DIGIT_ZERO = chr(6470)
LIMBU_DIGIT_ONE = chr(6471)
LIMBU_DIGIT_TWO = chr(6472)
LIMBU_DIGIT_THREE = chr(6473)
LIMBU_DIGIT_FOUR = chr(6474)
LIMBU_DIGIT_FIVE = chr(6475)
LIMBU_DIGIT_SIX = chr(6476)
LIMBU_DIGIT_SEVEN = chr(6477)
LIMBU_DIGIT_EIGHT = chr(6478)
LIMBU_DIGIT_NINE = chr(6479)
TAI_LE_LETTER_KA = chr(6480)
TAI_LE_LETTER_XA = chr(6481)
TAI_LE_LETTER_NGA = chr(6482)
TAI_LE_LETTER_TSA = chr(6483)
TAI_LE_LETTER_SA = chr(6484)
TAI_LE_LETTER_YA = chr(6485)
TAI_LE_LETTER_TA = chr(6486)
TAI_LE_LETTER_THA = chr(6487)
TAI_LE_LETTER_LA = chr(6488)
TAI_LE_LETTER_PA = chr(6489)
TAI_LE_LETTER_PHA = chr(6490)
TAI_LE_LETTER_MA = chr(6491)
TAI_LE_LETTER_FA = chr(6492)
TAI_LE_LETTER_VA = chr(6493)
TAI_LE_LETTER_HA = chr(6494)
TAI_LE_LETTER_QA = chr(6495)
TAI_LE_LETTER_KHA = chr(6496)
TAI_LE_LETTER_TSHA = chr(6497)
TAI_LE_LETTER_NA = chr(6498)
TAI_LE_LETTER_A = chr(6499)
TAI_LE_LETTER_I = chr(6500)
TAI_LE_LETTER_EE = chr(6501)
TAI_LE_LETTER_EH = chr(6502)
TAI_LE_LETTER_U = chr(6503)
TAI_LE_LETTER_OO = chr(6504)
TAI_LE_LETTER_O = chr(6505)
TAI_LE_LETTER_UE = chr(6506)
TAI_LE_LETTER_E = chr(6507)
TAI_LE_LETTER_AUE = chr(6508)
TAI_LE_LETTER_AI = chr(6509)
TAI_LE_LETTER_TONE_2 = chr(6512)
TAI_LE_LETTER_TONE_3 = chr(6513)
TAI_LE_LETTER_TONE_4 = chr(6514)
TAI_LE_LETTER_TONE_5 = chr(6515)
TAI_LE_LETTER_TONE_6 = chr(6516)
NEW_TAI_LUE_LETTER_HIGH_QA = chr(6528)
NEW_TAI_LUE_LETTER_LOW_QA = chr(6529)
NEW_TAI_LUE_LETTER_HIGH_KA = chr(6530)
NEW_TAI_LUE_LETTER_HIGH_XA = chr(6531)
NEW_TAI_LUE_LETTER_HIGH_NGA = chr(6532)
NEW_TAI_LUE_LETTER_LOW_KA = chr(6533)
NEW_TAI_LUE_LETTER_LOW_XA = chr(6534)
NEW_TAI_LUE_LETTER_LOW_NGA = chr(6535)
NEW_TAI_LUE_LETTER_HIGH_TSA = chr(6536)
NEW_TAI_LUE_LETTER_HIGH_SA = chr(6537)
NEW_TAI_LUE_LETTER_HIGH_YA = chr(6538)
NEW_TAI_LUE_LETTER_LOW_TSA = chr(6539)
NEW_TAI_LUE_LETTER_LOW_SA = chr(6540)
NEW_TAI_LUE_LETTER_LOW_YA = chr(6541)
NEW_TAI_LUE_LETTER_HIGH_TA = chr(6542)
NEW_TAI_LUE_LETTER_HIGH_THA = chr(6543)
NEW_TAI_LUE_LETTER_HIGH_NA = chr(6544)
NEW_TAI_LUE_LETTER_LOW_TA = chr(6545)
NEW_TAI_LUE_LETTER_LOW_THA = chr(6546)
NEW_TAI_LUE_LETTER_LOW_NA = chr(6547)
NEW_TAI_LUE_LETTER_HIGH_PA = chr(6548)
NEW_TAI_LUE_LETTER_HIGH_PHA = chr(6549)
NEW_TAI_LUE_LETTER_HIGH_MA = chr(6550)
NEW_TAI_LUE_LETTER_LOW_PA = chr(6551)
NEW_TAI_LUE_LETTER_LOW_PHA = chr(6552)
NEW_TAI_LUE_LETTER_LOW_MA = chr(6553)
NEW_TAI_LUE_LETTER_HIGH_FA = chr(6554)
NEW_TAI_LUE_LETTER_HIGH_VA = chr(6555)
NEW_TAI_LUE_LETTER_HIGH_LA = chr(6556)
NEW_TAI_LUE_LETTER_LOW_FA = chr(6557)
NEW_TAI_LUE_LETTER_LOW_VA = chr(6558)
NEW_TAI_LUE_LETTER_LOW_LA = chr(6559)
NEW_TAI_LUE_LETTER_HIGH_HA = chr(6560)
NEW_TAI_LUE_LETTER_HIGH_DA = chr(6561)
NEW_TAI_LUE_LETTER_HIGH_BA = chr(6562)
NEW_TAI_LUE_LETTER_LOW_HA = chr(6563)
NEW_TAI_LUE_LETTER_LOW_DA = chr(6564)
NEW_TAI_LUE_LETTER_LOW_BA = chr(6565)
NEW_TAI_LUE_LETTER_HIGH_KVA = chr(6566)
NEW_TAI_LUE_LETTER_HIGH_XVA = chr(6567)
NEW_TAI_LUE_LETTER_LOW_KVA = chr(6568)
NEW_TAI_LUE_LETTER_LOW_XVA = chr(6569)
NEW_TAI_LUE_LETTER_HIGH_SUA = chr(6570)
NEW_TAI_LUE_LETTER_LOW_SUA = chr(6571)
NEW_TAI_LUE_VOWEL_SIGN_VOWEL_SHORTENER = chr(6576)
NEW_TAI_LUE_VOWEL_SIGN_AA = chr(6577)
NEW_TAI_LUE_VOWEL_SIGN_II = chr(6578)
NEW_TAI_LUE_VOWEL_SIGN_U = chr(6579)
NEW_TAI_LUE_VOWEL_SIGN_UU = chr(6580)
NEW_TAI_LUE_VOWEL_SIGN_E = chr(6581)
NEW_TAI_LUE_VOWEL_SIGN_AE = chr(6582)
NEW_TAI_LUE_VOWEL_SIGN_O = chr(6583)
NEW_TAI_LUE_VOWEL_SIGN_OA = chr(6584)
NEW_TAI_LUE_VOWEL_SIGN_UE = chr(6585)
NEW_TAI_LUE_VOWEL_SIGN_AY = chr(6586)
NEW_TAI_LUE_VOWEL_SIGN_AAY = chr(6587)
NEW_TAI_LUE_VOWEL_SIGN_UY = chr(6588)
NEW_TAI_LUE_VOWEL_SIGN_OY = chr(6589)
NEW_TAI_LUE_VOWEL_SIGN_OAY = chr(6590)
NEW_TAI_LUE_VOWEL_SIGN_UEY = chr(6591)
NEW_TAI_LUE_VOWEL_SIGN_IY = chr(6592)
NEW_TAI_LUE_LETTER_FINAL_V = chr(6593)
NEW_TAI_LUE_LETTER_FINAL_NG = chr(6594)
NEW_TAI_LUE_LETTER_FINAL_N = chr(6595)
NEW_TAI_LUE_LETTER_FINAL_M = chr(6596)
NEW_TAI_LUE_LETTER_FINAL_K = chr(6597)
NEW_TAI_LUE_LETTER_FINAL_D = chr(6598)
NEW_TAI_LUE_LETTER_FINAL_B = chr(6599)
NEW_TAI_LUE_TONE_MARK_1 = chr(6600)
NEW_TAI_LUE_TONE_MARK_2 = chr(6601)
NEW_TAI_LUE_DIGIT_ZERO = chr(6608)
NEW_TAI_LUE_DIGIT_ONE = chr(6609)
NEW_TAI_LUE_DIGIT_TWO = chr(6610)
NEW_TAI_LUE_DIGIT_THREE = chr(6611)
NEW_TAI_LUE_DIGIT_FOUR = chr(6612)
NEW_TAI_LUE_DIGIT_FIVE = chr(6613)
NEW_TAI_LUE_DIGIT_SIX = chr(6614)
NEW_TAI_LUE_DIGIT_SEVEN = chr(6615)
NEW_TAI_LUE_DIGIT_EIGHT = chr(6616)
NEW_TAI_LUE_DIGIT_NINE = chr(6617)
NEW_TAI_LUE_THAM_DIGIT_ONE = chr(6618)
NEW_TAI_LUE_SIGN_LAE = chr(6622)
NEW_TAI_LUE_SIGN_LAEV = chr(6623)
KHMER_SYMBOL_PATHAMASAT = chr(6624)
KHMER_SYMBOL_MUOY_KOET = chr(6625)
KHMER_SYMBOL_PII_KOET = chr(6626)
KHMER_SYMBOL_BEI_KOET = chr(6627)
KHMER_SYMBOL_BUON_KOET = chr(6628)
KHMER_SYMBOL_PRAM_KOET = chr(6629)
KHMER_SYMBOL_PRAM_MUOY_KOET = chr(6630)
KHMER_SYMBOL_PRAM_PII_KOET = chr(6631)
KHMER_SYMBOL_PRAM_BEI_KOET = chr(6632)
KHMER_SYMBOL_PRAM_BUON_KOET = chr(6633)
KHMER_SYMBOL_DAP_KOET = chr(6634)
KHMER_SYMBOL_DAP_MUOY_KOET = chr(6635)
KHMER_SYMBOL_DAP_PII_KOET = chr(6636)
KHMER_SYMBOL_DAP_BEI_KOET = chr(6637)
KHMER_SYMBOL_DAP_BUON_KOET = chr(6638)
KHMER_SYMBOL_DAP_PRAM_KOET = chr(6639)
KHMER_SYMBOL_TUTEYASAT = chr(6640)
KHMER_SYMBOL_MUOY_ROC = chr(6641)
KHMER_SYMBOL_PII_ROC = chr(6642)
KHMER_SYMBOL_BEI_ROC = chr(6643)
KHMER_SYMBOL_BUON_ROC = chr(6644)
KHMER_SYMBOL_PRAM_ROC = chr(6645)
KHMER_SYMBOL_PRAM_MUOY_ROC = chr(6646)
KHMER_SYMBOL_PRAM_PII_ROC = chr(6647)
KHMER_SYMBOL_PRAM_BEI_ROC = chr(6648)
KHMER_SYMBOL_PRAM_BUON_ROC = chr(6649)
KHMER_SYMBOL_DAP_ROC = chr(6650)
KHMER_SYMBOL_DAP_MUOY_ROC = chr(6651)
KHMER_SYMBOL_DAP_PII_ROC = chr(6652)
KHMER_SYMBOL_DAP_BEI_ROC = chr(6653)
KHMER_SYMBOL_DAP_BUON_ROC = chr(6654)
KHMER_SYMBOL_DAP_PRAM_ROC = chr(6655)
BUGINESE_LETTER_KA = chr(6656)
BUGINESE_LETTER_GA = chr(6657)
BUGINESE_LETTER_NGA = chr(6658)
BUGINESE_LETTER_NGKA = chr(6659)
BUGINESE_LETTER_PA = chr(6660)
BUGINESE_LETTER_BA = chr(6661)
BUGINESE_LETTER_MA = chr(6662)
BUGINESE_LETTER_MPA = chr(6663)
BUGINESE_LETTER_TA = chr(6664)
BUGINESE_LETTER_DA = chr(6665)
BUGINESE_LETTER_NA = chr(6666)
BUGINESE_LETTER_NRA = chr(6667)
BUGINESE_LETTER_CA = chr(6668)
BUGINESE_LETTER_JA = chr(6669)
BUGINESE_LETTER_NYA = chr(6670)
BUGINESE_LETTER_NYCA = chr(6671)
BUGINESE_LETTER_YA = chr(6672)
BUGINESE_LETTER_RA = chr(6673)
BUGINESE_LETTER_LA = chr(6674)
BUGINESE_LETTER_VA = chr(6675)
BUGINESE_LETTER_SA = chr(6676)
BUGINESE_LETTER_A = chr(6677)
BUGINESE_LETTER_HA = chr(6678)
BUGINESE_VOWEL_SIGN_I = chr(6679)
BUGINESE_VOWEL_SIGN_U = chr(6680)
BUGINESE_VOWEL_SIGN_E = chr(6681)
BUGINESE_VOWEL_SIGN_O = chr(6682)
BUGINESE_VOWEL_SIGN_AE = chr(6683)
BUGINESE_PALLAWA = chr(6686)
BUGINESE_END_OF_SECTION = chr(6687)
TAI_THAM_LETTER_HIGH_KA = chr(6688)
TAI_THAM_LETTER_HIGH_KHA = chr(6689)
TAI_THAM_LETTER_HIGH_KXA = chr(6690)
TAI_THAM_LETTER_LOW_KA = chr(6691)
TAI_THAM_LETTER_LOW_KXA = chr(6692)
TAI_THAM_LETTER_LOW_KHA = chr(6693)
TAI_THAM_LETTER_NGA = chr(6694)
TAI_THAM_LETTER_HIGH_CA = chr(6695)
TAI_THAM_LETTER_HIGH_CHA = chr(6696)
TAI_THAM_LETTER_LOW_CA = chr(6697)
TAI_THAM_LETTER_LOW_SA = chr(6698)
TAI_THAM_LETTER_LOW_CHA = chr(6699)
TAI_THAM_LETTER_NYA = chr(6700)
TAI_THAM_LETTER_RATA = chr(6701)
TAI_THAM_LETTER_HIGH_RATHA = chr(6702)
TAI_THAM_LETTER_DA = chr(6703)
TAI_THAM_LETTER_LOW_RATHA = chr(6704)
TAI_THAM_LETTER_RANA = chr(6705)
TAI_THAM_LETTER_HIGH_TA = chr(6706)
TAI_THAM_LETTER_HIGH_THA = chr(6707)
TAI_THAM_LETTER_LOW_TA = chr(6708)
TAI_THAM_LETTER_LOW_THA = chr(6709)
TAI_THAM_LETTER_NA = chr(6710)
TAI_THAM_LETTER_BA = chr(6711)
TAI_THAM_LETTER_HIGH_PA = chr(6712)
TAI_THAM_LETTER_HIGH_PHA = chr(6713)
TAI_THAM_LETTER_HIGH_FA = chr(6714)
TAI_THAM_LETTER_LOW_PA = chr(6715)
TAI_THAM_LETTER_LOW_FA = chr(6716)
TAI_THAM_LETTER_LOW_PHA = chr(6717)
TAI_THAM_LETTER_MA = chr(6718)
TAI_THAM_LETTER_LOW_YA = chr(6719)
TAI_THAM_LETTER_HIGH_YA = chr(6720)
TAI_THAM_LETTER_RA = chr(6721)
TAI_THAM_LETTER_RUE = chr(6722)
TAI_THAM_LETTER_LA = chr(6723)
TAI_THAM_LETTER_LUE = chr(6724)
TAI_THAM_LETTER_WA = chr(6725)
TAI_THAM_LETTER_HIGH_SHA = chr(6726)
TAI_THAM_LETTER_HIGH_SSA = chr(6727)
TAI_THAM_LETTER_HIGH_SA = chr(6728)
TAI_THAM_LETTER_HIGH_HA = chr(6729)
TAI_THAM_LETTER_LLA = chr(6730)
TAI_THAM_LETTER_A = chr(6731)
TAI_THAM_LETTER_LOW_HA = chr(6732)
TAI_THAM_LETTER_I = chr(6733)
TAI_THAM_LETTER_II = chr(6734)
TAI_THAM_LETTER_U = chr(6735)
TAI_THAM_LETTER_UU = chr(6736)
TAI_THAM_LETTER_EE = chr(6737)
TAI_THAM_LETTER_OO = chr(6738)
TAI_THAM_LETTER_LAE = chr(6739)
TAI_THAM_LETTER_GREAT_SA = chr(6740)
TAI_THAM_CONSONANT_SIGN_MEDIAL_RA = chr(6741)
TAI_THAM_CONSONANT_SIGN_MEDIAL_LA = chr(6742)
TAI_THAM_CONSONANT_SIGN_LA_TANG_LAI = chr(6743)
TAI_THAM_SIGN_MAI_KANG_LAI = chr(6744)
TAI_THAM_CONSONANT_SIGN_FINAL_NGA = chr(6745)
TAI_THAM_CONSONANT_SIGN_LOW_PA = chr(6746)
TAI_THAM_CONSONANT_SIGN_HIGH_RATHA_OR_LOW_PA = chr(6747)
TAI_THAM_CONSONANT_SIGN_MA = chr(6748)
TAI_THAM_CONSONANT_SIGN_BA = chr(6749)
TAI_THAM_CONSONANT_SIGN_SA = chr(6750)
TAI_THAM_SIGN_SAKOT = chr(6752)
TAI_THAM_VOWEL_SIGN_A = chr(6753)
TAI_THAM_VOWEL_SIGN_MAI_SAT = chr(6754)
TAI_THAM_VOWEL_SIGN_AA = chr(6755)
TAI_THAM_VOWEL_SIGN_TALL_AA = chr(6756)
TAI_THAM_VOWEL_SIGN_I = chr(6757)
TAI_THAM_VOWEL_SIGN_II = chr(6758)
TAI_THAM_VOWEL_SIGN_UE = chr(6759)
TAI_THAM_VOWEL_SIGN_UUE = chr(6760)
TAI_THAM_VOWEL_SIGN_U = chr(6761)
TAI_THAM_VOWEL_SIGN_UU = chr(6762)
TAI_THAM_VOWEL_SIGN_O = chr(6763)
TAI_THAM_VOWEL_SIGN_OA_BELOW = chr(6764)
TAI_THAM_VOWEL_SIGN_OY = chr(6765)
TAI_THAM_VOWEL_SIGN_E = chr(6766)
TAI_THAM_VOWEL_SIGN_AE = chr(6767)
TAI_THAM_VOWEL_SIGN_OO = chr(6768)
TAI_THAM_VOWEL_SIGN_AI = chr(6769)
TAI_THAM_VOWEL_SIGN_THAM_AI = chr(6770)
TAI_THAM_VOWEL_SIGN_OA_ABOVE = chr(6771)
TAI_THAM_SIGN_MAI_KANG = chr(6772)
TAI_THAM_SIGN_TONE_1 = chr(6773)
TAI_THAM_SIGN_TONE_2 = chr(6774)
TAI_THAM_SIGN_KHUEN_TONE_3 = chr(6775)
TAI_THAM_SIGN_KHUEN_TONE_4 = chr(6776)
TAI_THAM_SIGN_KHUEN_TONE_5 = chr(6777)
TAI_THAM_SIGN_RA_HAAM = chr(6778)
TAI_THAM_SIGN_MAI_SAM = chr(6779)
TAI_THAM_SIGN_KHUEN_LUE_KARAN = chr(6780)
TAI_THAM_COMBINING_CRYPTOGRAMMIC_DOT = chr(6783)
TAI_THAM_HORA_DIGIT_ZERO = chr(6784)
TAI_THAM_HORA_DIGIT_ONE = chr(6785)
TAI_THAM_HORA_DIGIT_TWO = chr(6786)
TAI_THAM_HORA_DIGIT_THREE = chr(6787)
TAI_THAM_HORA_DIGIT_FOUR = chr(6788)
TAI_THAM_HORA_DIGIT_FIVE = chr(6789)
TAI_THAM_HORA_DIGIT_SIX = chr(6790)
TAI_THAM_HORA_DIGIT_SEVEN = chr(6791)
TAI_THAM_HORA_DIGIT_EIGHT = chr(6792)
TAI_THAM_HORA_DIGIT_NINE = chr(6793)
TAI_THAM_THAM_DIGIT_ZERO = chr(6800)
TAI_THAM_THAM_DIGIT_ONE = chr(6801)
TAI_THAM_THAM_DIGIT_TWO = chr(6802)
TAI_THAM_THAM_DIGIT_THREE = chr(6803)
TAI_THAM_THAM_DIGIT_FOUR = chr(6804)
TAI_THAM_THAM_DIGIT_FIVE = chr(6805)
TAI_THAM_THAM_DIGIT_SIX = chr(6806)
TAI_THAM_THAM_DIGIT_SEVEN = chr(6807)
TAI_THAM_THAM_DIGIT_EIGHT = chr(6808)
TAI_THAM_THAM_DIGIT_NINE = chr(6809)
TAI_THAM_SIGN_WIANG = chr(6816)
TAI_THAM_SIGN_WIANGWAAK = chr(6817)
TAI_THAM_SIGN_SAWAN = chr(6818)
TAI_THAM_SIGN_KEOW = chr(6819)
TAI_THAM_SIGN_HOY = chr(6820)
TAI_THAM_SIGN_DOKMAI = chr(6821)
TAI_THAM_SIGN_REVERSED_ROTATED_RANA = chr(6822)
TAI_THAM_SIGN_MAI_YAMOK = chr(6823)
TAI_THAM_SIGN_KAAN = chr(6824)
TAI_THAM_SIGN_KAANKUU = chr(6825)
TAI_THAM_SIGN_SATKAAN = chr(6826)
TAI_THAM_SIGN_SATKAANKUU = chr(6827)
TAI_THAM_SIGN_HANG = chr(6828)
TAI_THAM_SIGN_CAANG = chr(6829)
COMBINING_DOUBLED_CIRCUMFLEX_ACCENT = chr(6832)
COMBINING_DIAERESIS_RING = chr(6833)
COMBINING_INFINITY = chr(6834)
COMBINING_DOWNWARDS_ARROW = chr(6835)
COMBINING_TRIPLE_DOT = chr(6836)
COMBINING_X_X_BELOW = chr(6837)
COMBINING_WIGGLY_LINE_BELOW = chr(6838)
COMBINING_OPEN_MARK_BELOW = chr(6839)
COMBINING_DOUBLE_OPEN_MARK_BELOW = chr(6840)
COMBINING_LIGHT_CENTRALIZATION_STROKE_BELOW = chr(6841)
COMBINING_STRONG_CENTRALIZATION_STROKE_BELOW = chr(6842)
COMBINING_PARENTHESES_ABOVE = chr(6843)
COMBINING_DOUBLE_PARENTHESES_ABOVE = chr(6844)
COMBINING_PARENTHESES_BELOW = chr(6845)
COMBINING_PARENTHESES_OVERLAY = chr(6846)
COMBINING_LATIN_SMALL_LETTER_W_BELOW = chr(6847)
COMBINING_LATIN_SMALL_LETTER_TURNED_W_BELOW = chr(6848)
COMBINING_LEFT_PARENTHESIS_ABOVE_LEFT = chr(6849)
COMBINING_RIGHT_PARENTHESIS_ABOVE_RIGHT = chr(6850)
COMBINING_LEFT_PARENTHESIS_BELOW_LEFT = chr(6851)
COMBINING_RIGHT_PARENTHESIS_BELOW_RIGHT = chr(6852)
COMBINING_SQUARE_BRACKETS_ABOVE = chr(6853)
COMBINING_NUMBER_SIGN_ABOVE = chr(6854)
COMBINING_INVERTED_DOUBLE_ARCH_ABOVE = chr(6855)
COMBINING_PLUS_SIGN_ABOVE = chr(6856)
COMBINING_DOUBLE_PLUS_SIGN_ABOVE = chr(6857)
COMBINING_DOUBLE_PLUS_SIGN_BELOW = chr(6858)
COMBINING_TRIPLE_ACUTE_ACCENT = chr(6859)
COMBINING_LATIN_SMALL_LETTER_INSULAR_G = chr(6860)
COMBINING_LATIN_SMALL_LETTER_INSULAR_R = chr(6861)
COMBINING_LATIN_SMALL_LETTER_INSULAR_T = chr(6862)
BALINESE_SIGN_ULU_RICEM = chr(6912)
BALINESE_SIGN_ULU_CANDRA = chr(6913)
BALINESE_SIGN_CECEK = chr(6914)
BALINESE_SIGN_SURANG = chr(6915)
BALINESE_SIGN_BISAH = chr(6916)
BALINESE_LETTER_AKARA = chr(6917)
BALINESE_LETTER_AKARA_TEDUNG = chr(6918)
BALINESE_LETTER_IKARA = chr(6919)
BALINESE_LETTER_IKARA_TEDUNG = chr(6920)
BALINESE_LETTER_UKARA = chr(6921)
BALINESE_LETTER_UKARA_TEDUNG = chr(6922)
BALINESE_LETTER_RA_REPA = chr(6923)
BALINESE_LETTER_RA_REPA_TEDUNG = chr(6924)
BALINESE_LETTER_LA_LENGA = chr(6925)
BALINESE_LETTER_LA_LENGA_TEDUNG = chr(6926)
BALINESE_LETTER_EKARA = chr(6927)
BALINESE_LETTER_AIKARA = chr(6928)
BALINESE_LETTER_OKARA = chr(6929)
BALINESE_LETTER_OKARA_TEDUNG = chr(6930)
BALINESE_LETTER_KA = chr(6931)
BALINESE_LETTER_KA_MAHAPRANA = chr(6932)
BALINESE_LETTER_GA = chr(6933)
BALINESE_LETTER_GA_GORA = chr(6934)
BALINESE_LETTER_NGA = chr(6935)
BALINESE_LETTER_CA = chr(6936)
BALINESE_LETTER_CA_LACA = chr(6937)
BALINESE_LETTER_JA = chr(6938)
BALINESE_LETTER_JA_JERA = chr(6939)
BALINESE_LETTER_NYA = chr(6940)
BALINESE_LETTER_TA_LATIK = chr(6941)
BALINESE_LETTER_TA_MURDA_MAHAPRANA = chr(6942)
BALINESE_LETTER_DA_MURDA_ALPAPRANA = chr(6943)
BALINESE_LETTER_DA_MURDA_MAHAPRANA = chr(6944)
BALINESE_LETTER_NA_RAMBAT = chr(6945)
BALINESE_LETTER_TA = chr(6946)
BALINESE_LETTER_TA_TAWA = chr(6947)
BALINESE_LETTER_DA = chr(6948)
BALINESE_LETTER_DA_MADU = chr(6949)
BALINESE_LETTER_NA = chr(6950)
BALINESE_LETTER_PA = chr(6951)
BALINESE_LETTER_PA_KAPAL = chr(6952)
BALINESE_LETTER_BA = chr(6953)
BALINESE_LETTER_BA_KEMBANG = chr(6954)
BALINESE_LETTER_MA = chr(6955)
BALINESE_LETTER_YA = chr(6956)
BALINESE_LETTER_RA = chr(6957)
BALINESE_LETTER_LA = chr(6958)
BALINESE_LETTER_WA = chr(6959)
BALINESE_LETTER_SA_SAGA = chr(6960)
BALINESE_LETTER_SA_SAPA = chr(6961)
BALINESE_LETTER_SA = chr(6962)
BALINESE_LETTER_HA = chr(6963)
BALINESE_SIGN_REREKAN = chr(6964)
BALINESE_VOWEL_SIGN_TEDUNG = chr(6965)
BALINESE_VOWEL_SIGN_ULU = chr(6966)
BALINESE_VOWEL_SIGN_ULU_SARI = chr(6967)
BALINESE_VOWEL_SIGN_SUKU = chr(6968)
BALINESE_VOWEL_SIGN_SUKU_ILUT = chr(6969)
BALINESE_VOWEL_SIGN_RA_REPA = chr(6970)
BALINESE_VOWEL_SIGN_RA_REPA_TEDUNG = chr(6971)
BALINESE_VOWEL_SIGN_LA_LENGA = chr(6972)
BALINESE_VOWEL_SIGN_LA_LENGA_TEDUNG = chr(6973)
BALINESE_VOWEL_SIGN_TALING = chr(6974)
BALINESE_VOWEL_SIGN_TALING_REPA = chr(6975)
BALINESE_VOWEL_SIGN_TALING_TEDUNG = chr(6976)
BALINESE_VOWEL_SIGN_TALING_REPA_TEDUNG = chr(6977)
BALINESE_VOWEL_SIGN_PEPET = chr(6978)
BALINESE_VOWEL_SIGN_PEPET_TEDUNG = chr(6979)
BALINESE_ADEG_ADEG = chr(6980)
BALINESE_LETTER_KAF_SASAK = chr(6981)
BALINESE_LETTER_KHOT_SASAK = chr(6982)
BALINESE_LETTER_TZIR_SASAK = chr(6983)
BALINESE_LETTER_EF_SASAK = chr(6984)
BALINESE_LETTER_VE_SASAK = chr(6985)
BALINESE_LETTER_ZAL_SASAK = chr(6986)
BALINESE_LETTER_ASYURA_SASAK = chr(6987)
BALINESE_LETTER_ARCHAIC_JNYA = chr(6988)
BALINESE_DIGIT_ZERO = chr(6992)
BALINESE_DIGIT_ONE = chr(6993)
BALINESE_DIGIT_TWO = chr(6994)
BALINESE_DIGIT_THREE = chr(6995)
BALINESE_DIGIT_FOUR = chr(6996)
BALINESE_DIGIT_FIVE = chr(6997)
BALINESE_DIGIT_SIX = chr(6998)
BALINESE_DIGIT_SEVEN = chr(6999)
BALINESE_DIGIT_EIGHT = chr(7000)
BALINESE_DIGIT_NINE = chr(7001)
BALINESE_PANTI = chr(7002)
BALINESE_PAMADA = chr(7003)
BALINESE_WINDU = chr(7004)
BALINESE_CARIK_PAMUNGKAH = chr(7005)
BALINESE_CARIK_SIKI = chr(7006)
BALINESE_CARIK_PAREREN = chr(7007)
BALINESE_PAMENENG = chr(7008)
BALINESE_MUSICAL_SYMBOL_DONG = chr(7009)
BALINESE_MUSICAL_SYMBOL_DENG = chr(7010)
BALINESE_MUSICAL_SYMBOL_DUNG = chr(7011)
BALINESE_MUSICAL_SYMBOL_DANG = chr(7012)
BALINESE_MUSICAL_SYMBOL_DANG_SURANG = chr(7013)
BALINESE_MUSICAL_SYMBOL_DING = chr(7014)
BALINESE_MUSICAL_SYMBOL_DAENG = chr(7015)
BALINESE_MUSICAL_SYMBOL_DEUNG = chr(7016)
BALINESE_MUSICAL_SYMBOL_DAING = chr(7017)
BALINESE_MUSICAL_SYMBOL_DANG_GEDE = chr(7018)
BALINESE_MUSICAL_SYMBOL_COMBINING_TEGEH = chr(7019)
BALINESE_MUSICAL_SYMBOL_COMBINING_ENDEP = chr(7020)
BALINESE_MUSICAL_SYMBOL_COMBINING_KEMPUL = chr(7021)
BALINESE_MUSICAL_SYMBOL_COMBINING_KEMPLI = chr(7022)
BALINESE_MUSICAL_SYMBOL_COMBINING_JEGOGAN = chr(7023)
BALINESE_MUSICAL_SYMBOL_COMBINING_KEMPUL_WITH_JEGOGAN = chr(7024)
BALINESE_MUSICAL_SYMBOL_COMBINING_KEMPLI_WITH_JEGOGAN = chr(7025)
BALINESE_MUSICAL_SYMBOL_COMBINING_BENDE = chr(7026)
BALINESE_MUSICAL_SYMBOL_COMBINING_GONG = chr(7027)
BALINESE_MUSICAL_SYMBOL_RIGHT_HAND_OPEN_DUG = chr(7028)
BALINESE_MUSICAL_SYMBOL_RIGHT_HAND_OPEN_DAG = chr(7029)
BALINESE_MUSICAL_SYMBOL_RIGHT_HAND_CLOSED_TUK = chr(7030)
BALINESE_MUSICAL_SYMBOL_RIGHT_HAND_CLOSED_TAK = chr(7031)
BALINESE_MUSICAL_SYMBOL_LEFT_HAND_OPEN_PANG = chr(7032)
BALINESE_MUSICAL_SYMBOL_LEFT_HAND_OPEN_PUNG = chr(7033)
BALINESE_MUSICAL_SYMBOL_LEFT_HAND_CLOSED_PLAK = chr(7034)
BALINESE_MUSICAL_SYMBOL_LEFT_HAND_CLOSED_PLUK = chr(7035)
BALINESE_MUSICAL_SYMBOL_LEFT_HAND_OPEN_PING = chr(7036)
BALINESE_PANTI_LANTANG = chr(7037)
BALINESE_PAMADA_LANTANG = chr(7038)
SUNDANESE_SIGN_PANYECEK = chr(7040)
SUNDANESE_SIGN_PANGLAYAR = chr(7041)
SUNDANESE_SIGN_PANGWISAD = chr(7042)
SUNDANESE_LETTER_A = chr(7043)
SUNDANESE_LETTER_I = chr(7044)
SUNDANESE_LETTER_U = chr(7045)
SUNDANESE_LETTER_AE = chr(7046)
SUNDANESE_LETTER_O = chr(7047)
SUNDANESE_LETTER_E = chr(7048)
SUNDANESE_LETTER_EU = chr(7049)
SUNDANESE_LETTER_KA = chr(7050)
SUNDANESE_LETTER_QA = chr(7051)
SUNDANESE_LETTER_GA = chr(7052)
SUNDANESE_LETTER_NGA = chr(7053)
SUNDANESE_LETTER_CA = chr(7054)
SUNDANESE_LETTER_JA = chr(7055)
SUNDANESE_LETTER_ZA = chr(7056)
SUNDANESE_LETTER_NYA = chr(7057)
SUNDANESE_LETTER_TA = chr(7058)
SUNDANESE_LETTER_DA = chr(7059)
SUNDANESE_LETTER_NA = chr(7060)
SUNDANESE_LETTER_PA = chr(7061)
SUNDANESE_LETTER_FA = chr(7062)
SUNDANESE_LETTER_VA = chr(7063)
SUNDANESE_LETTER_BA = chr(7064)
SUNDANESE_LETTER_MA = chr(7065)
SUNDANESE_LETTER_YA = chr(7066)
SUNDANESE_LETTER_RA = chr(7067)
SUNDANESE_LETTER_LA = chr(7068)
SUNDANESE_LETTER_WA = chr(7069)
SUNDANESE_LETTER_SA = chr(7070)
SUNDANESE_LETTER_XA = chr(7071)
SUNDANESE_LETTER_HA = chr(7072)
SUNDANESE_CONSONANT_SIGN_PAMINGKAL = chr(7073)
SUNDANESE_CONSONANT_SIGN_PANYAKRA = chr(7074)
SUNDANESE_CONSONANT_SIGN_PANYIKU = chr(7075)
SUNDANESE_VOWEL_SIGN_PANGHULU = chr(7076)
SUNDANESE_VOWEL_SIGN_PANYUKU = chr(7077)
SUNDANESE_VOWEL_SIGN_PANAELAENG = chr(7078)
SUNDANESE_VOWEL_SIGN_PANOLONG = chr(7079)
SUNDANESE_VOWEL_SIGN_PAMEPET = chr(7080)
SUNDANESE_VOWEL_SIGN_PANEULEUNG = chr(7081)
SUNDANESE_SIGN_PAMAAEH = chr(7082)
SUNDANESE_SIGN_VIRAMA = chr(7083)
SUNDANESE_CONSONANT_SIGN_PASANGAN_MA = chr(7084)
SUNDANESE_CONSONANT_SIGN_PASANGAN_WA = chr(7085)
SUNDANESE_LETTER_KHA = chr(7086)
SUNDANESE_LETTER_SYA = chr(7087)
SUNDANESE_DIGIT_ZERO = chr(7088)
SUNDANESE_DIGIT_ONE = chr(7089)
SUNDANESE_DIGIT_TWO = chr(7090)
SUNDANESE_DIGIT_THREE = chr(7091)
SUNDANESE_DIGIT_FOUR = chr(7092)
SUNDANESE_DIGIT_FIVE = chr(7093)
SUNDANESE_DIGIT_SIX = chr(7094)
SUNDANESE_DIGIT_SEVEN = chr(7095)
SUNDANESE_DIGIT_EIGHT = chr(7096)
SUNDANESE_DIGIT_NINE = chr(7097)
SUNDANESE_AVAGRAHA = chr(7098)
SUNDANESE_LETTER_REU = chr(7099)
SUNDANESE_LETTER_LEU = chr(7100)
SUNDANESE_LETTER_BHA = chr(7101)
SUNDANESE_LETTER_FINAL_K = chr(7102)
SUNDANESE_LETTER_FINAL_M = chr(7103)
BATAK_LETTER_A = chr(7104)
BATAK_LETTER_SIMALUNGUN_A = chr(7105)
BATAK_LETTER_HA = chr(7106)
BATAK_LETTER_SIMALUNGUN_HA = chr(7107)
BATAK_LETTER_MANDAILING_HA = chr(7108)
BATAK_LETTER_BA = chr(7109)
BATAK_LETTER_KARO_BA = chr(7110)
BATAK_LETTER_PA = chr(7111)
BATAK_LETTER_SIMALUNGUN_PA = chr(7112)
BATAK_LETTER_NA = chr(7113)
BATAK_LETTER_MANDAILING_NA = chr(7114)
BATAK_LETTER_WA = chr(7115)
BATAK_LETTER_SIMALUNGUN_WA = chr(7116)
BATAK_LETTER_PAKPAK_WA = chr(7117)
BATAK_LETTER_GA = chr(7118)
BATAK_LETTER_SIMALUNGUN_GA = chr(7119)
BATAK_LETTER_JA = chr(7120)
BATAK_LETTER_DA = chr(7121)
BATAK_LETTER_RA = chr(7122)
BATAK_LETTER_SIMALUNGUN_RA = chr(7123)
BATAK_LETTER_MA = chr(7124)
BATAK_LETTER_SIMALUNGUN_MA = chr(7125)
BATAK_LETTER_SOUTHERN_TA = chr(7126)
BATAK_LETTER_NORTHERN_TA = chr(7127)
BATAK_LETTER_SA = chr(7128)
BATAK_LETTER_SIMALUNGUN_SA = chr(7129)
BATAK_LETTER_MANDAILING_SA = chr(7130)
BATAK_LETTER_YA = chr(7131)
BATAK_LETTER_SIMALUNGUN_YA = chr(7132)
BATAK_LETTER_NGA = chr(7133)
BATAK_LETTER_LA = chr(7134)
BATAK_LETTER_SIMALUNGUN_LA = chr(7135)
BATAK_LETTER_NYA = chr(7136)
BATAK_LETTER_CA = chr(7137)
BATAK_LETTER_NDA = chr(7138)
BATAK_LETTER_MBA = chr(7139)
BATAK_LETTER_I = chr(7140)
BATAK_LETTER_U = chr(7141)
BATAK_SIGN_TOMPI = chr(7142)
BATAK_VOWEL_SIGN_E = chr(7143)
BATAK_VOWEL_SIGN_PAKPAK_E = chr(7144)
BATAK_VOWEL_SIGN_EE = chr(7145)
BATAK_VOWEL_SIGN_I = chr(7146)
BATAK_VOWEL_SIGN_KARO_I = chr(7147)
BATAK_VOWEL_SIGN_O = chr(7148)
BATAK_VOWEL_SIGN_KARO_O = chr(7149)
BATAK_VOWEL_SIGN_U = chr(7150)
BATAK_VOWEL_SIGN_U_FOR_SIMALUNGUN_SA = chr(7151)
BATAK_CONSONANT_SIGN_NG = chr(7152)
BATAK_CONSONANT_SIGN_H = chr(7153)
BATAK_PANGOLAT = chr(7154)
BATAK_PANONGONAN = chr(7155)
BATAK_SYMBOL_BINDU_NA_METEK = chr(7164)
BATAK_SYMBOL_BINDU_PINARBORAS = chr(7165)
BATAK_SYMBOL_BINDU_JUDUL = chr(7166)
BATAK_SYMBOL_BINDU_PANGOLAT = chr(7167)
LEPCHA_LETTER_KA = chr(7168)
LEPCHA_LETTER_KLA = chr(7169)
LEPCHA_LETTER_KHA = chr(7170)
LEPCHA_LETTER_GA = chr(7171)
LEPCHA_LETTER_GLA = chr(7172)
LEPCHA_LETTER_NGA = chr(7173)
LEPCHA_LETTER_CA = chr(7174)
LEPCHA_LETTER_CHA = chr(7175)
LEPCHA_LETTER_JA = chr(7176)
LEPCHA_LETTER_NYA = chr(7177)
LEPCHA_LETTER_TA = chr(7178)
LEPCHA_LETTER_THA = chr(7179)
LEPCHA_LETTER_DA = chr(7180)
LEPCHA_LETTER_NA = chr(7181)
LEPCHA_LETTER_PA = chr(7182)
LEPCHA_LETTER_PLA = chr(7183)
LEPCHA_LETTER_PHA = chr(7184)
LEPCHA_LETTER_FA = chr(7185)
LEPCHA_LETTER_FLA = chr(7186)
LEPCHA_LETTER_BA = chr(7187)
LEPCHA_LETTER_BLA = chr(7188)
LEPCHA_LETTER_MA = chr(7189)
LEPCHA_LETTER_MLA = chr(7190)
LEPCHA_LETTER_TSA = chr(7191)
LEPCHA_LETTER_TSHA = chr(7192)
LEPCHA_LETTER_DZA = chr(7193)
LEPCHA_LETTER_YA = chr(7194)
LEPCHA_LETTER_RA = chr(7195)
LEPCHA_LETTER_LA = chr(7196)
LEPCHA_LETTER_HA = chr(7197)
LEPCHA_LETTER_HLA = chr(7198)
LEPCHA_LETTER_VA = chr(7199)
LEPCHA_LETTER_SA = chr(7200)
LEPCHA_LETTER_SHA = chr(7201)
LEPCHA_LETTER_WA = chr(7202)
LEPCHA_LETTER_A = chr(7203)
LEPCHA_SUBJOINED_LETTER_YA = chr(7204)
LEPCHA_SUBJOINED_LETTER_RA = chr(7205)
LEPCHA_VOWEL_SIGN_AA = chr(7206)
LEPCHA_VOWEL_SIGN_I = chr(7207)
LEPCHA_VOWEL_SIGN_O = chr(7208)
LEPCHA_VOWEL_SIGN_OO = chr(7209)
LEPCHA_VOWEL_SIGN_U = chr(7210)
LEPCHA_VOWEL_SIGN_UU = chr(7211)
LEPCHA_VOWEL_SIGN_E = chr(7212)
LEPCHA_CONSONANT_SIGN_K = chr(7213)
LEPCHA_CONSONANT_SIGN_M = chr(7214)
LEPCHA_CONSONANT_SIGN_L = chr(7215)
LEPCHA_CONSONANT_SIGN_N = chr(7216)
LEPCHA_CONSONANT_SIGN_P = chr(7217)
LEPCHA_CONSONANT_SIGN_R = chr(7218)
LEPCHA_CONSONANT_SIGN_T = chr(7219)
LEPCHA_CONSONANT_SIGN_NYIN_DO = chr(7220)
LEPCHA_CONSONANT_SIGN_KANG = chr(7221)
LEPCHA_SIGN_RAN = chr(7222)
LEPCHA_SIGN_NUKTA = chr(7223)
LEPCHA_PUNCTUATION_TA_ROL = chr(7227)
LEPCHA_PUNCTUATION_NYET_THYOOM_TA_ROL = chr(7228)
LEPCHA_PUNCTUATION_CER_WA = chr(7229)
LEPCHA_PUNCTUATION_TSHOOK_CER_WA = chr(7230)
LEPCHA_PUNCTUATION_TSHOOK = chr(7231)
LEPCHA_DIGIT_ZERO = chr(7232)
LEPCHA_DIGIT_ONE = chr(7233)
LEPCHA_DIGIT_TWO = chr(7234)
LEPCHA_DIGIT_THREE = chr(7235)
LEPCHA_DIGIT_FOUR = chr(7236)
LEPCHA_DIGIT_FIVE = chr(7237)
LEPCHA_DIGIT_SIX = chr(7238)
LEPCHA_DIGIT_SEVEN = chr(7239)
LEPCHA_DIGIT_EIGHT = chr(7240)
LEPCHA_DIGIT_NINE = chr(7241)
LEPCHA_LETTER_TTA = chr(7245)
LEPCHA_LETTER_TTHA = chr(7246)
LEPCHA_LETTER_DDA = chr(7247)
OL_CHIKI_DIGIT_ZERO = chr(7248)
OL_CHIKI_DIGIT_ONE = chr(7249)
OL_CHIKI_DIGIT_TWO = chr(7250)
OL_CHIKI_DIGIT_THREE = chr(7251)
OL_CHIKI_DIGIT_FOUR = chr(7252)
OL_CHIKI_DIGIT_FIVE = chr(7253)
OL_CHIKI_DIGIT_SIX = chr(7254)
OL_CHIKI_DIGIT_SEVEN = chr(7255)
OL_CHIKI_DIGIT_EIGHT = chr(7256)
OL_CHIKI_DIGIT_NINE = chr(7257)
OL_CHIKI_LETTER_LA = chr(7258)
OL_CHIKI_LETTER_AT = chr(7259)
OL_CHIKI_LETTER_AG = chr(7260)
OL_CHIKI_LETTER_ANG = chr(7261)
OL_CHIKI_LETTER_AL = chr(7262)
OL_CHIKI_LETTER_LAA = chr(7263)
OL_CHIKI_LETTER_AAK = chr(7264)
OL_CHIKI_LETTER_AAJ = chr(7265)
OL_CHIKI_LETTER_AAM = chr(7266)
OL_CHIKI_LETTER_AAW = chr(7267)
OL_CHIKI_LETTER_LI = chr(7268)
OL_CHIKI_LETTER_IS = chr(7269)
OL_CHIKI_LETTER_IH = chr(7270)
OL_CHIKI_LETTER_INY = chr(7271)
OL_CHIKI_LETTER_IR = chr(7272)
OL_CHIKI_LETTER_LU = chr(7273)
OL_CHIKI_LETTER_UC = chr(7274)
OL_CHIKI_LETTER_UD = chr(7275)
OL_CHIKI_LETTER_UNN = chr(7276)
OL_CHIKI_LETTER_UY = chr(7277)
OL_CHIKI_LETTER_LE = chr(7278)
OL_CHIKI_LETTER_EP = chr(7279)
OL_CHIKI_LETTER_EDD = chr(7280)
OL_CHIKI_LETTER_EN = chr(7281)
OL_CHIKI_LETTER_ERR = chr(7282)
OL_CHIKI_LETTER_LO = chr(7283)
OL_CHIKI_LETTER_OTT = chr(7284)
OL_CHIKI_LETTER_OB = chr(7285)
OL_CHIKI_LETTER_OV = chr(7286)
OL_CHIKI_LETTER_OH = chr(7287)
OL_CHIKI_MU_TTUDDAG = chr(7288)
OL_CHIKI_GAAHLAA_TTUDDAAG = chr(7289)
OL_CHIKI_MU_GAAHLAA_TTUDDAAG = chr(7290)
OL_CHIKI_RELAA = chr(7291)
OL_CHIKI_PHAARKAA = chr(7292)
OL_CHIKI_AHAD = chr(7293)
OL_CHIKI_PUNCTUATION_MUCAAD = chr(7294)
OL_CHIKI_PUNCTUATION_DOUBLE_MUCAAD = chr(7295)
CYRILLIC_SMALL_LETTER_ROUNDED_VE = chr(7296)
CYRILLIC_SMALL_LETTER_LONG_LEGGED_DE = chr(7297)
CYRILLIC_SMALL_LETTER_NARROW_O = chr(7298)
CYRILLIC_SMALL_LETTER_WIDE_ES = chr(7299)
CYRILLIC_SMALL_LETTER_TALL_TE = chr(7300)
CYRILLIC_SMALL_LETTER_THREE_LEGGED_TE = chr(7301)
CYRILLIC_SMALL_LETTER_TALL_HARD_SIGN = chr(7302)
CYRILLIC_SMALL_LETTER_TALL_YAT = chr(7303)
CYRILLIC_SMALL_LETTER_UNBLENDED_UK = chr(7304)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_AN = chr(7312)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_BAN = chr(7313)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_GAN = chr(7314)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_DON = chr(7315)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_EN = chr(7316)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_VIN = chr(7317)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_ZEN = chr(7318)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_TAN = chr(7319)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_IN = chr(7320)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_KAN = chr(7321)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_LAS = chr(7322)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_MAN = chr(7323)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_NAR = chr(7324)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_ON = chr(7325)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_PAR = chr(7326)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_ZHAR = chr(7327)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_RAE = chr(7328)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_SAN = chr(7329)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_TAR = chr(7330)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_UN = chr(7331)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_PHAR = chr(7332)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_KHAR = chr(7333)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_GHAN = chr(7334)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_QAR = chr(7335)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_SHIN = chr(7336)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_CHIN = chr(7337)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_CAN = chr(7338)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_JIL = chr(7339)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_CIL = chr(7340)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_CHAR = chr(7341)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_XAN = chr(7342)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_JHAN = chr(7343)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_HAE = chr(7344)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_HE = chr(7345)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_HIE = chr(7346)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_WE = chr(7347)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_HAR = chr(7348)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_HOE = chr(7349)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_FI = chr(7350)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_YN = chr(7351)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_ELIFI = chr(7352)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_TURNED_GAN = chr(7353)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_AIN = chr(7354)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_AEN = chr(7357)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_HARD_SIGN = chr(7358)
GEORGIAN_MTAVRULI_CAPITAL_LETTER_LABIAL_SIGN = chr(7359)
SUNDANESE_PUNCTUATION_BINDU_SURYA = chr(7360)
SUNDANESE_PUNCTUATION_BINDU_PANGLONG = chr(7361)
SUNDANESE_PUNCTUATION_BINDU_PURNAMA = chr(7362)
SUNDANESE_PUNCTUATION_BINDU_CAKRA = chr(7363)
SUNDANESE_PUNCTUATION_BINDU_LEU_SATANGA = chr(7364)
SUNDANESE_PUNCTUATION_BINDU_KA_SATANGA = chr(7365)
SUNDANESE_PUNCTUATION_BINDU_DA_SATANGA = chr(7366)
SUNDANESE_PUNCTUATION_BINDU_BA_SATANGA = chr(7367)
VEDIC_TONE_KARSHANA = chr(7376)
VEDIC_TONE_SHARA = chr(7377)
VEDIC_TONE_PRENKHA = chr(7378)
VEDIC_SIGN_NIHSHVASA = chr(7379)
VEDIC_SIGN_YAJURVEDIC_MIDLINE_SVARITA = chr(7380)
VEDIC_TONE_YAJURVEDIC_AGGRAVATED_INDEPENDENT_SVARITA = chr(7381)
VEDIC_TONE_YAJURVEDIC_INDEPENDENT_SVARITA = chr(7382)
VEDIC_TONE_YAJURVEDIC_KATHAKA_INDEPENDENT_SVARITA = chr(7383)
VEDIC_TONE_CANDRA_BELOW = chr(7384)
VEDIC_TONE_YAJURVEDIC_KATHAKA_INDEPENDENT_SVARITA_SCHROEDER = chr(7385)
VEDIC_TONE_DOUBLE_SVARITA = chr(7386)
VEDIC_TONE_TRIPLE_SVARITA = chr(7387)
VEDIC_TONE_KATHAKA_ANUDATTA = chr(7388)
VEDIC_TONE_DOT_BELOW = chr(7389)
VEDIC_TONE_TWO_DOTS_BELOW = chr(7390)
VEDIC_TONE_THREE_DOTS_BELOW = chr(7391)
VEDIC_TONE_RIGVEDIC_KASHMIRI_INDEPENDENT_SVARITA = chr(7392)
VEDIC_TONE_ATHARVAVEDIC_INDEPENDENT_SVARITA = chr(7393)
VEDIC_SIGN_VISARGA_SVARITA = chr(7394)
VEDIC_SIGN_VISARGA_UDATTA = chr(7395)
VEDIC_SIGN_REVERSED_VISARGA_UDATTA = chr(7396)
VEDIC_SIGN_VISARGA_ANUDATTA = chr(7397)
VEDIC_SIGN_REVERSED_VISARGA_ANUDATTA = chr(7398)
VEDIC_SIGN_VISARGA_UDATTA_WITH_TAIL = chr(7399)
VEDIC_SIGN_VISARGA_ANUDATTA_WITH_TAIL = chr(7400)
VEDIC_SIGN_ANUSVARA_ANTARGOMUKHA = chr(7401)
VEDIC_SIGN_ANUSVARA_BAHIRGOMUKHA = chr(7402)
VEDIC_SIGN_ANUSVARA_VAMAGOMUKHA = chr(7403)
VEDIC_SIGN_ANUSVARA_VAMAGOMUKHA_WITH_TAIL = chr(7404)
VEDIC_SIGN_TIRYAK = chr(7405)
VEDIC_SIGN_HEXIFORM_LONG_ANUSVARA = chr(7406)
VEDIC_SIGN_LONG_ANUSVARA = chr(7407)
VEDIC_SIGN_RTHANG_LONG_ANUSVARA = chr(7408)
VEDIC_SIGN_ANUSVARA_UBHAYATO_MUKHA = chr(7409)
VEDIC_SIGN_ARDHAVISARGA = chr(7410)
VEDIC_SIGN_ROTATED_ARDHAVISARGA = chr(7411)
VEDIC_TONE_CANDRA_ABOVE = chr(7412)
VEDIC_SIGN_JIHVAMULIYA = chr(7413)
VEDIC_SIGN_UPADHMANIYA = chr(7414)
VEDIC_SIGN_ATIKRAMA = chr(7415)
VEDIC_TONE_RING_ABOVE = chr(7416)
VEDIC_TONE_DOUBLE_RING_ABOVE = chr(7417)
VEDIC_SIGN_DOUBLE_ANUSVARA_ANTARGOMUKHA = chr(7418)
LATIN_LETTER_SMALL_CAPITAL_A = chr(7424)
LATIN_LETTER_SMALL_CAPITAL_AE = chr(7425)
LATIN_SMALL_LETTER_TURNED_AE = chr(7426)
LATIN_LETTER_SMALL_CAPITAL_BARRED_B = chr(7427)
LATIN_LETTER_SMALL_CAPITAL_C = chr(7428)
LATIN_LETTER_SMALL_CAPITAL_D = chr(7429)
LATIN_LETTER_SMALL_CAPITAL_ETH = chr(7430)
LATIN_LETTER_SMALL_CAPITAL_E = chr(7431)
LATIN_SMALL_LETTER_TURNED_OPEN_E = chr(7432)
LATIN_SMALL_LETTER_TURNED_I = chr(7433)
LATIN_LETTER_SMALL_CAPITAL_J = chr(7434)
LATIN_LETTER_SMALL_CAPITAL_K = chr(7435)
LATIN_LETTER_SMALL_CAPITAL_L_WITH_STROKE = chr(7436)
LATIN_LETTER_SMALL_CAPITAL_M = chr(7437)
LATIN_LETTER_SMALL_CAPITAL_REVERSED_N = chr(7438)
LATIN_LETTER_SMALL_CAPITAL_O = chr(7439)
LATIN_LETTER_SMALL_CAPITAL_OPEN_O = chr(7440)
LATIN_SMALL_LETTER_SIDEWAYS_O = chr(7441)
LATIN_SMALL_LETTER_SIDEWAYS_OPEN_O = chr(7442)
LATIN_SMALL_LETTER_SIDEWAYS_O_WITH_STROKE = chr(7443)
LATIN_SMALL_LETTER_TURNED_OE = chr(7444)
LATIN_LETTER_SMALL_CAPITAL_OU = chr(7445)
LATIN_SMALL_LETTER_TOP_HALF_O = chr(7446)
LATIN_SMALL_LETTER_BOTTOM_HALF_O = chr(7447)
LATIN_LETTER_SMALL_CAPITAL_P = chr(7448)
LATIN_LETTER_SMALL_CAPITAL_REVERSED_R = chr(7449)
LATIN_LETTER_SMALL_CAPITAL_TURNED_R = chr(7450)
LATIN_LETTER_SMALL_CAPITAL_T = chr(7451)
LATIN_LETTER_SMALL_CAPITAL_U = chr(7452)
LATIN_SMALL_LETTER_SIDEWAYS_U = chr(7453)
LATIN_SMALL_LETTER_SIDEWAYS_DIAERESIZED_U = chr(7454)
LATIN_SMALL_LETTER_SIDEWAYS_TURNED_M = chr(7455)
LATIN_LETTER_SMALL_CAPITAL_V = chr(7456)
LATIN_LETTER_SMALL_CAPITAL_W = chr(7457)
LATIN_LETTER_SMALL_CAPITAL_Z = chr(7458)
LATIN_LETTER_SMALL_CAPITAL_EZH = chr(7459)
LATIN_LETTER_VOICED_LARYNGEAL_SPIRANT = chr(7460)
LATIN_LETTER_AIN = chr(7461)
GREEK_LETTER_SMALL_CAPITAL_GAMMA = chr(7462)
GREEK_LETTER_SMALL_CAPITAL_LAMDA = chr(7463)
GREEK_LETTER_SMALL_CAPITAL_PI = chr(7464)
GREEK_LETTER_SMALL_CAPITAL_RHO = chr(7465)
GREEK_LETTER_SMALL_CAPITAL_PSI = chr(7466)
CYRILLIC_LETTER_SMALL_CAPITAL_EL = chr(7467)
MODIFIER_LETTER_CAPITAL_A = chr(7468)
MODIFIER_LETTER_CAPITAL_AE = chr(7469)
MODIFIER_LETTER_CAPITAL_B = chr(7470)
MODIFIER_LETTER_CAPITAL_BARRED_B = chr(7471)
MODIFIER_LETTER_CAPITAL_D = chr(7472)
MODIFIER_LETTER_CAPITAL_E = chr(7473)
MODIFIER_LETTER_CAPITAL_REVERSED_E = chr(7474)
MODIFIER_LETTER_CAPITAL_G = chr(7475)
MODIFIER_LETTER_CAPITAL_H = chr(7476)
MODIFIER_LETTER_CAPITAL_I = chr(7477)
MODIFIER_LETTER_CAPITAL_J = chr(7478)
MODIFIER_LETTER_CAPITAL_K = chr(7479)
MODIFIER_LETTER_CAPITAL_L = chr(7480)
MODIFIER_LETTER_CAPITAL_M = chr(7481)
MODIFIER_LETTER_CAPITAL_N = chr(7482)
MODIFIER_LETTER_CAPITAL_REVERSED_N = chr(7483)
MODIFIER_LETTER_CAPITAL_O = chr(7484)
MODIFIER_LETTER_CAPITAL_OU = chr(7485)
MODIFIER_LETTER_CAPITAL_P = chr(7486)
MODIFIER_LETTER_CAPITAL_R = chr(7487)
MODIFIER_LETTER_CAPITAL_T = chr(7488)
MODIFIER_LETTER_CAPITAL_U = chr(7489)
MODIFIER_LETTER_CAPITAL_W = chr(7490)
MODIFIER_LETTER_SMALL_A = chr(7491)
MODIFIER_LETTER_SMALL_TURNED_A = chr(7492)
MODIFIER_LETTER_SMALL_ALPHA = chr(7493)
MODIFIER_LETTER_SMALL_TURNED_AE = chr(7494)
MODIFIER_LETTER_SMALL_B = chr(7495)
MODIFIER_LETTER_SMALL_D = chr(7496)
MODIFIER_LETTER_SMALL_E = chr(7497)
MODIFIER_LETTER_SMALL_SCHWA = chr(7498)
MODIFIER_LETTER_SMALL_OPEN_E = chr(7499)
MODIFIER_LETTER_SMALL_TURNED_OPEN_E = chr(7500)
MODIFIER_LETTER_SMALL_G = chr(7501)
MODIFIER_LETTER_SMALL_TURNED_I = chr(7502)
MODIFIER_LETTER_SMALL_K = chr(7503)
MODIFIER_LETTER_SMALL_M = chr(7504)
MODIFIER_LETTER_SMALL_ENG = chr(7505)
MODIFIER_LETTER_SMALL_O = chr(7506)
MODIFIER_LETTER_SMALL_OPEN_O = chr(7507)
MODIFIER_LETTER_SMALL_TOP_HALF_O = chr(7508)
MODIFIER_LETTER_SMALL_BOTTOM_HALF_O = chr(7509)
MODIFIER_LETTER_SMALL_P = chr(7510)
MODIFIER_LETTER_SMALL_T = chr(7511)
MODIFIER_LETTER_SMALL_U = chr(7512)
MODIFIER_LETTER_SMALL_SIDEWAYS_U = chr(7513)
MODIFIER_LETTER_SMALL_TURNED_M = chr(7514)
MODIFIER_LETTER_SMALL_V = chr(7515)
MODIFIER_LETTER_SMALL_AIN = chr(7516)
MODIFIER_LETTER_SMALL_BETA = chr(7517)
MODIFIER_LETTER_SMALL_GREEK_GAMMA = chr(7518)
MODIFIER_LETTER_SMALL_DELTA = chr(7519)
MODIFIER_LETTER_SMALL_GREEK_PHI = chr(7520)
MODIFIER_LETTER_SMALL_CHI = chr(7521)
LATIN_SUBSCRIPT_SMALL_LETTER_I = chr(7522)
LATIN_SUBSCRIPT_SMALL_LETTER_R = chr(7523)
LATIN_SUBSCRIPT_SMALL_LETTER_U = chr(7524)
LATIN_SUBSCRIPT_SMALL_LETTER_V = chr(7525)
GREEK_SUBSCRIPT_SMALL_LETTER_BETA = chr(7526)
GREEK_SUBSCRIPT_SMALL_LETTER_GAMMA = chr(7527)
GREEK_SUBSCRIPT_SMALL_LETTER_RHO = chr(7528)
GREEK_SUBSCRIPT_SMALL_LETTER_PHI = chr(7529)
GREEK_SUBSCRIPT_SMALL_LETTER_CHI = chr(7530)
LATIN_SMALL_LETTER_UE = chr(7531)
LATIN_SMALL_LETTER_B_WITH_MIDDLE_TILDE = chr(7532)
LATIN_SMALL_LETTER_D_WITH_MIDDLE_TILDE = chr(7533)
LATIN_SMALL_LETTER_F_WITH_MIDDLE_TILDE = chr(7534)
LATIN_SMALL_LETTER_M_WITH_MIDDLE_TILDE = chr(7535)
LATIN_SMALL_LETTER_N_WITH_MIDDLE_TILDE = chr(7536)
LATIN_SMALL_LETTER_P_WITH_MIDDLE_TILDE = chr(7537)
LATIN_SMALL_LETTER_R_WITH_MIDDLE_TILDE = chr(7538)
LATIN_SMALL_LETTER_R_WITH_FISHHOOK_AND_MIDDLE_TILDE = chr(7539)
LATIN_SMALL_LETTER_S_WITH_MIDDLE_TILDE = chr(7540)
LATIN_SMALL_LETTER_T_WITH_MIDDLE_TILDE = chr(7541)
LATIN_SMALL_LETTER_Z_WITH_MIDDLE_TILDE = chr(7542)
LATIN_SMALL_LETTER_TURNED_G = chr(7543)
MODIFIER_LETTER_CYRILLIC_EN = chr(7544)
LATIN_SMALL_LETTER_INSULAR_G = chr(7545)
LATIN_SMALL_LETTER_TH_WITH_STRIKETHROUGH = chr(7546)
LATIN_SMALL_CAPITAL_LETTER_I_WITH_STROKE = chr(7547)
LATIN_SMALL_LETTER_IOTA_WITH_STROKE = chr(7548)
LATIN_SMALL_LETTER_P_WITH_STROKE = chr(7549)
LATIN_SMALL_CAPITAL_LETTER_U_WITH_STROKE = chr(7550)
LATIN_SMALL_LETTER_UPSILON_WITH_STROKE = chr(7551)
LATIN_SMALL_LETTER_B_WITH_PALATAL_HOOK = chr(7552)
LATIN_SMALL_LETTER_D_WITH_PALATAL_HOOK = chr(7553)
LATIN_SMALL_LETTER_F_WITH_PALATAL_HOOK = chr(7554)
LATIN_SMALL_LETTER_G_WITH_PALATAL_HOOK = chr(7555)
LATIN_SMALL_LETTER_K_WITH_PALATAL_HOOK = chr(7556)
LATIN_SMALL_LETTER_L_WITH_PALATAL_HOOK = chr(7557)
LATIN_SMALL_LETTER_M_WITH_PALATAL_HOOK = chr(7558)
LATIN_SMALL_LETTER_N_WITH_PALATAL_HOOK = chr(7559)
LATIN_SMALL_LETTER_P_WITH_PALATAL_HOOK = chr(7560)
LATIN_SMALL_LETTER_R_WITH_PALATAL_HOOK = chr(7561)
LATIN_SMALL_LETTER_S_WITH_PALATAL_HOOK = chr(7562)
LATIN_SMALL_LETTER_ESH_WITH_PALATAL_HOOK = chr(7563)
LATIN_SMALL_LETTER_V_WITH_PALATAL_HOOK = chr(7564)
LATIN_SMALL_LETTER_X_WITH_PALATAL_HOOK = chr(7565)
LATIN_SMALL_LETTER_Z_WITH_PALATAL_HOOK = chr(7566)
LATIN_SMALL_LETTER_A_WITH_RETROFLEX_HOOK = chr(7567)
LATIN_SMALL_LETTER_ALPHA_WITH_RETROFLEX_HOOK = chr(7568)
LATIN_SMALL_LETTER_D_WITH_HOOK_AND_TAIL = chr(7569)
LATIN_SMALL_LETTER_E_WITH_RETROFLEX_HOOK = chr(7570)
LATIN_SMALL_LETTER_OPEN_E_WITH_RETROFLEX_HOOK = chr(7571)
LATIN_SMALL_LETTER_REVERSED_OPEN_E_WITH_RETROFLEX_HOOK = chr(7572)
LATIN_SMALL_LETTER_SCHWA_WITH_RETROFLEX_HOOK = chr(7573)
LATIN_SMALL_LETTER_I_WITH_RETROFLEX_HOOK = chr(7574)
LATIN_SMALL_LETTER_OPEN_O_WITH_RETROFLEX_HOOK = chr(7575)
LATIN_SMALL_LETTER_ESH_WITH_RETROFLEX_HOOK = chr(7576)
LATIN_SMALL_LETTER_U_WITH_RETROFLEX_HOOK = chr(7577)
LATIN_SMALL_LETTER_EZH_WITH_RETROFLEX_HOOK = chr(7578)
MODIFIER_LETTER_SMALL_TURNED_ALPHA = chr(7579)
MODIFIER_LETTER_SMALL_C = chr(7580)
MODIFIER_LETTER_SMALL_C_WITH_CURL = chr(7581)
MODIFIER_LETTER_SMALL_ETH = chr(7582)
MODIFIER_LETTER_SMALL_REVERSED_OPEN_E = chr(7583)
MODIFIER_LETTER_SMALL_F = chr(7584)
MODIFIER_LETTER_SMALL_DOTLESS_J_WITH_STROKE = chr(7585)
MODIFIER_LETTER_SMALL_SCRIPT_G = chr(7586)
MODIFIER_LETTER_SMALL_TURNED_H = chr(7587)
MODIFIER_LETTER_SMALL_I_WITH_STROKE = chr(7588)
MODIFIER_LETTER_SMALL_IOTA = chr(7589)
MODIFIER_LETTER_SMALL_CAPITAL_I = chr(7590)
MODIFIER_LETTER_SMALL_CAPITAL_I_WITH_STROKE = chr(7591)
MODIFIER_LETTER_SMALL_J_WITH_CROSSED_TAIL = chr(7592)
MODIFIER_LETTER_SMALL_L_WITH_RETROFLEX_HOOK = chr(7593)
MODIFIER_LETTER_SMALL_L_WITH_PALATAL_HOOK = chr(7594)
MODIFIER_LETTER_SMALL_CAPITAL_L = chr(7595)
MODIFIER_LETTER_SMALL_M_WITH_HOOK = chr(7596)
MODIFIER_LETTER_SMALL_TURNED_M_WITH_LONG_LEG = chr(7597)
MODIFIER_LETTER_SMALL_N_WITH_LEFT_HOOK = chr(7598)
MODIFIER_LETTER_SMALL_N_WITH_RETROFLEX_HOOK = chr(7599)
MODIFIER_LETTER_SMALL_CAPITAL_N = chr(7600)
MODIFIER_LETTER_SMALL_BARRED_O = chr(7601)
MODIFIER_LETTER_SMALL_PHI = chr(7602)
MODIFIER_LETTER_SMALL_S_WITH_HOOK = chr(7603)
MODIFIER_LETTER_SMALL_ESH = chr(7604)
MODIFIER_LETTER_SMALL_T_WITH_PALATAL_HOOK = chr(7605)
MODIFIER_LETTER_SMALL_U_BAR = chr(7606)
MODIFIER_LETTER_SMALL_UPSILON = chr(7607)
MODIFIER_LETTER_SMALL_CAPITAL_U = chr(7608)
MODIFIER_LETTER_SMALL_V_WITH_HOOK = chr(7609)
MODIFIER_LETTER_SMALL_TURNED_V = chr(7610)
MODIFIER_LETTER_SMALL_Z = chr(7611)
MODIFIER_LETTER_SMALL_Z_WITH_RETROFLEX_HOOK = chr(7612)
MODIFIER_LETTER_SMALL_Z_WITH_CURL = chr(7613)
MODIFIER_LETTER_SMALL_EZH = chr(7614)
MODIFIER_LETTER_SMALL_THETA = chr(7615)
COMBINING_DOTTED_GRAVE_ACCENT = chr(7616)
COMBINING_DOTTED_ACUTE_ACCENT = chr(7617)
COMBINING_SNAKE_BELOW = chr(7618)
COMBINING_SUSPENSION_MARK = chr(7619)
COMBINING_MACRON_ACUTE = chr(7620)
COMBINING_GRAVE_MACRON = chr(7621)
COMBINING_MACRON_GRAVE = chr(7622)
COMBINING_ACUTE_MACRON = chr(7623)
COMBINING_GRAVE_ACUTE_GRAVE = chr(7624)
COMBINING_ACUTE_GRAVE_ACUTE = chr(7625)
COMBINING_LATIN_SMALL_LETTER_R_BELOW = chr(7626)
COMBINING_BREVE_MACRON = chr(7627)
COMBINING_MACRON_BREVE = chr(7628)
COMBINING_DOUBLE_CIRCUMFLEX_ABOVE = chr(7629)
COMBINING_OGONEK_ABOVE = chr(7630)
COMBINING_ZIGZAG_BELOW = chr(7631)
COMBINING_IS_BELOW = chr(7632)
COMBINING_UR_ABOVE = chr(7633)
COMBINING_US_ABOVE = chr(7634)
COMBINING_LATIN_SMALL_LETTER_FLATTENED_OPEN_A_ABOVE = chr(7635)
COMBINING_LATIN_SMALL_LETTER_AE = chr(7636)
COMBINING_LATIN_SMALL_LETTER_AO = chr(7637)
COMBINING_LATIN_SMALL_LETTER_AV = chr(7638)
COMBINING_LATIN_SMALL_LETTER_C_CEDILLA = chr(7639)
COMBINING_LATIN_SMALL_LETTER_INSULAR_D = chr(7640)
COMBINING_LATIN_SMALL_LETTER_ETH = chr(7641)
COMBINING_LATIN_SMALL_LETTER_G = chr(7642)
COMBINING_LATIN_LETTER_SMALL_CAPITAL_G = chr(7643)
COMBINING_LATIN_SMALL_LETTER_K = chr(7644)
COMBINING_LATIN_SMALL_LETTER_L = chr(7645)
COMBINING_LATIN_LETTER_SMALL_CAPITAL_L = chr(7646)
COMBINING_LATIN_LETTER_SMALL_CAPITAL_M = chr(7647)
COMBINING_LATIN_SMALL_LETTER_N = chr(7648)
COMBINING_LATIN_LETTER_SMALL_CAPITAL_N = chr(7649)
COMBINING_LATIN_LETTER_SMALL_CAPITAL_R = chr(7650)
COMBINING_LATIN_SMALL_LETTER_R_ROTUNDA = chr(7651)
COMBINING_LATIN_SMALL_LETTER_S = chr(7652)
COMBINING_LATIN_SMALL_LETTER_LONG_S = chr(7653)
COMBINING_LATIN_SMALL_LETTER_Z = chr(7654)
COMBINING_LATIN_SMALL_LETTER_ALPHA = chr(7655)
COMBINING_LATIN_SMALL_LETTER_B = chr(7656)
COMBINING_LATIN_SMALL_LETTER_BETA = chr(7657)
COMBINING_LATIN_SMALL_LETTER_SCHWA = chr(7658)
COMBINING_LATIN_SMALL_LETTER_F = chr(7659)
COMBINING_LATIN_SMALL_LETTER_L_WITH_DOUBLE_MIDDLE_TILDE = chr(7660)
COMBINING_LATIN_SMALL_LETTER_O_WITH_LIGHT_CENTRALIZATION_STROKE = chr(7661)
COMBINING_LATIN_SMALL_LETTER_P = chr(7662)
COMBINING_LATIN_SMALL_LETTER_ESH = chr(7663)
COMBINING_LATIN_SMALL_LETTER_U_WITH_LIGHT_CENTRALIZATION_STROKE = chr(7664)
COMBINING_LATIN_SMALL_LETTER_W = chr(7665)
COMBINING_LATIN_SMALL_LETTER_A_WITH_DIAERESIS = chr(7666)
COMBINING_LATIN_SMALL_LETTER_O_WITH_DIAERESIS = chr(7667)
COMBINING_LATIN_SMALL_LETTER_U_WITH_DIAERESIS = chr(7668)
COMBINING_UP_TACK_ABOVE = chr(7669)
COMBINING_KAVYKA_ABOVE_RIGHT = chr(7670)
COMBINING_KAVYKA_ABOVE_LEFT = chr(7671)
COMBINING_DOT_ABOVE_LEFT = chr(7672)
COMBINING_WIDE_INVERTED_BRIDGE_BELOW = chr(7673)
COMBINING_DOT_BELOW_LEFT = chr(7674)
COMBINING_DELETION_MARK = chr(7675)
COMBINING_DOUBLE_INVERTED_BREVE_BELOW = chr(7676)
COMBINING_ALMOST_EQUAL_TO_BELOW = chr(7677)
COMBINING_LEFT_ARROWHEAD_ABOVE = chr(7678)
COMBINING_RIGHT_ARROWHEAD_AND_DOWN_ARROWHEAD_BELOW = chr(7679)
LATIN_CAPITAL_LETTER_A_WITH_RING_BELOW = chr(7680)
LATIN_SMALL_LETTER_A_WITH_RING_BELOW = chr(7681)
LATIN_CAPITAL_LETTER_B_WITH_DOT_ABOVE = chr(7682)
LATIN_SMALL_LETTER_B_WITH_DOT_ABOVE = chr(7683)
LATIN_CAPITAL_LETTER_B_WITH_DOT_BELOW = chr(7684)
LATIN_SMALL_LETTER_B_WITH_DOT_BELOW = chr(7685)
LATIN_CAPITAL_LETTER_B_WITH_LINE_BELOW = chr(7686)
LATIN_SMALL_LETTER_B_WITH_LINE_BELOW = chr(7687)
LATIN_CAPITAL_LETTER_C_WITH_CEDILLA_AND_ACUTE = chr(7688)
LATIN_SMALL_LETTER_C_WITH_CEDILLA_AND_ACUTE = chr(7689)
LATIN_CAPITAL_LETTER_D_WITH_DOT_ABOVE = chr(7690)
LATIN_SMALL_LETTER_D_WITH_DOT_ABOVE = chr(7691)
LATIN_CAPITAL_LETTER_D_WITH_DOT_BELOW = chr(7692)
LATIN_SMALL_LETTER_D_WITH_DOT_BELOW = chr(7693)
LATIN_CAPITAL_LETTER_D_WITH_LINE_BELOW = chr(7694)
LATIN_SMALL_LETTER_D_WITH_LINE_BELOW = chr(7695)
LATIN_CAPITAL_LETTER_D_WITH_CEDILLA = chr(7696)
LATIN_SMALL_LETTER_D_WITH_CEDILLA = chr(7697)
LATIN_CAPITAL_LETTER_D_WITH_CIRCUMFLEX_BELOW = chr(7698)
LATIN_SMALL_LETTER_D_WITH_CIRCUMFLEX_BELOW = chr(7699)
LATIN_CAPITAL_LETTER_E_WITH_MACRON_AND_GRAVE = chr(7700)
LATIN_SMALL_LETTER_E_WITH_MACRON_AND_GRAVE = chr(7701)
LATIN_CAPITAL_LETTER_E_WITH_MACRON_AND_ACUTE = chr(7702)
LATIN_SMALL_LETTER_E_WITH_MACRON_AND_ACUTE = chr(7703)
LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_BELOW = chr(7704)
LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_BELOW = chr(7705)
LATIN_CAPITAL_LETTER_E_WITH_TILDE_BELOW = chr(7706)
LATIN_SMALL_LETTER_E_WITH_TILDE_BELOW = chr(7707)
LATIN_CAPITAL_LETTER_E_WITH_CEDILLA_AND_BREVE = chr(7708)
LATIN_SMALL_LETTER_E_WITH_CEDILLA_AND_BREVE = chr(7709)
LATIN_CAPITAL_LETTER_F_WITH_DOT_ABOVE = chr(7710)
LATIN_SMALL_LETTER_F_WITH_DOT_ABOVE = chr(7711)
LATIN_CAPITAL_LETTER_G_WITH_MACRON = chr(7712)
LATIN_SMALL_LETTER_G_WITH_MACRON = chr(7713)
LATIN_CAPITAL_LETTER_H_WITH_DOT_ABOVE = chr(7714)
LATIN_SMALL_LETTER_H_WITH_DOT_ABOVE = chr(7715)
LATIN_CAPITAL_LETTER_H_WITH_DOT_BELOW = chr(7716)
LATIN_SMALL_LETTER_H_WITH_DOT_BELOW = chr(7717)
LATIN_CAPITAL_LETTER_H_WITH_DIAERESIS = chr(7718)
LATIN_SMALL_LETTER_H_WITH_DIAERESIS = chr(7719)
LATIN_CAPITAL_LETTER_H_WITH_CEDILLA = chr(7720)
LATIN_SMALL_LETTER_H_WITH_CEDILLA = chr(7721)
LATIN_CAPITAL_LETTER_H_WITH_BREVE_BELOW = chr(7722)
LATIN_SMALL_LETTER_H_WITH_BREVE_BELOW = chr(7723)
LATIN_CAPITAL_LETTER_I_WITH_TILDE_BELOW = chr(7724)
LATIN_SMALL_LETTER_I_WITH_TILDE_BELOW = chr(7725)
LATIN_CAPITAL_LETTER_I_WITH_DIAERESIS_AND_ACUTE = chr(7726)
LATIN_SMALL_LETTER_I_WITH_DIAERESIS_AND_ACUTE = chr(7727)
LATIN_CAPITAL_LETTER_K_WITH_ACUTE = chr(7728)
LATIN_SMALL_LETTER_K_WITH_ACUTE = chr(7729)
LATIN_CAPITAL_LETTER_K_WITH_DOT_BELOW = chr(7730)
LATIN_SMALL_LETTER_K_WITH_DOT_BELOW = chr(7731)
LATIN_CAPITAL_LETTER_K_WITH_LINE_BELOW = chr(7732)
LATIN_SMALL_LETTER_K_WITH_LINE_BELOW = chr(7733)
LATIN_CAPITAL_LETTER_L_WITH_DOT_BELOW = chr(7734)
LATIN_SMALL_LETTER_L_WITH_DOT_BELOW = chr(7735)
LATIN_CAPITAL_LETTER_L_WITH_DOT_BELOW_AND_MACRON = chr(7736)
LATIN_SMALL_LETTER_L_WITH_DOT_BELOW_AND_MACRON = chr(7737)
LATIN_CAPITAL_LETTER_L_WITH_LINE_BELOW = chr(7738)
LATIN_SMALL_LETTER_L_WITH_LINE_BELOW = chr(7739)
LATIN_CAPITAL_LETTER_L_WITH_CIRCUMFLEX_BELOW = chr(7740)
LATIN_SMALL_LETTER_L_WITH_CIRCUMFLEX_BELOW = chr(7741)
LATIN_CAPITAL_LETTER_M_WITH_ACUTE = chr(7742)
LATIN_SMALL_LETTER_M_WITH_ACUTE = chr(7743)
LATIN_CAPITAL_LETTER_M_WITH_DOT_ABOVE = chr(7744)
LATIN_SMALL_LETTER_M_WITH_DOT_ABOVE = chr(7745)
LATIN_CAPITAL_LETTER_M_WITH_DOT_BELOW = chr(7746)
LATIN_SMALL_LETTER_M_WITH_DOT_BELOW = chr(7747)
LATIN_CAPITAL_LETTER_N_WITH_DOT_ABOVE = chr(7748)
LATIN_SMALL_LETTER_N_WITH_DOT_ABOVE = chr(7749)
LATIN_CAPITAL_LETTER_N_WITH_DOT_BELOW = chr(7750)
LATIN_SMALL_LETTER_N_WITH_DOT_BELOW = chr(7751)
LATIN_CAPITAL_LETTER_N_WITH_LINE_BELOW = chr(7752)
LATIN_SMALL_LETTER_N_WITH_LINE_BELOW = chr(7753)
LATIN_CAPITAL_LETTER_N_WITH_CIRCUMFLEX_BELOW = chr(7754)
LATIN_SMALL_LETTER_N_WITH_CIRCUMFLEX_BELOW = chr(7755)
LATIN_CAPITAL_LETTER_O_WITH_TILDE_AND_ACUTE = chr(7756)
LATIN_SMALL_LETTER_O_WITH_TILDE_AND_ACUTE = chr(7757)
LATIN_CAPITAL_LETTER_O_WITH_TILDE_AND_DIAERESIS = chr(7758)
LATIN_SMALL_LETTER_O_WITH_TILDE_AND_DIAERESIS = chr(7759)
LATIN_CAPITAL_LETTER_O_WITH_MACRON_AND_GRAVE = chr(7760)
LATIN_SMALL_LETTER_O_WITH_MACRON_AND_GRAVE = chr(7761)
LATIN_CAPITAL_LETTER_O_WITH_MACRON_AND_ACUTE = chr(7762)
LATIN_SMALL_LETTER_O_WITH_MACRON_AND_ACUTE = chr(7763)
LATIN_CAPITAL_LETTER_P_WITH_ACUTE = chr(7764)
LATIN_SMALL_LETTER_P_WITH_ACUTE = chr(7765)
LATIN_CAPITAL_LETTER_P_WITH_DOT_ABOVE = chr(7766)
LATIN_SMALL_LETTER_P_WITH_DOT_ABOVE = chr(7767)
LATIN_CAPITAL_LETTER_R_WITH_DOT_ABOVE = chr(7768)
LATIN_SMALL_LETTER_R_WITH_DOT_ABOVE = chr(7769)
LATIN_CAPITAL_LETTER_R_WITH_DOT_BELOW = chr(7770)
LATIN_SMALL_LETTER_R_WITH_DOT_BELOW = chr(7771)
LATIN_CAPITAL_LETTER_R_WITH_DOT_BELOW_AND_MACRON = chr(7772)
LATIN_SMALL_LETTER_R_WITH_DOT_BELOW_AND_MACRON = chr(7773)
LATIN_CAPITAL_LETTER_R_WITH_LINE_BELOW = chr(7774)
LATIN_SMALL_LETTER_R_WITH_LINE_BELOW = chr(7775)
LATIN_CAPITAL_LETTER_S_WITH_DOT_ABOVE = chr(7776)
LATIN_SMALL_LETTER_S_WITH_DOT_ABOVE = chr(7777)
LATIN_CAPITAL_LETTER_S_WITH_DOT_BELOW = chr(7778)
LATIN_SMALL_LETTER_S_WITH_DOT_BELOW = chr(7779)
LATIN_CAPITAL_LETTER_S_WITH_ACUTE_AND_DOT_ABOVE = chr(7780)
LATIN_SMALL_LETTER_S_WITH_ACUTE_AND_DOT_ABOVE = chr(7781)
LATIN_CAPITAL_LETTER_S_WITH_CARON_AND_DOT_ABOVE = chr(7782)
LATIN_SMALL_LETTER_S_WITH_CARON_AND_DOT_ABOVE = chr(7783)
LATIN_CAPITAL_LETTER_S_WITH_DOT_BELOW_AND_DOT_ABOVE = chr(7784)
LATIN_SMALL_LETTER_S_WITH_DOT_BELOW_AND_DOT_ABOVE = chr(7785)
LATIN_CAPITAL_LETTER_T_WITH_DOT_ABOVE = chr(7786)
LATIN_SMALL_LETTER_T_WITH_DOT_ABOVE = chr(7787)
LATIN_CAPITAL_LETTER_T_WITH_DOT_BELOW = chr(7788)
LATIN_SMALL_LETTER_T_WITH_DOT_BELOW = chr(7789)
LATIN_CAPITAL_LETTER_T_WITH_LINE_BELOW = chr(7790)
LATIN_SMALL_LETTER_T_WITH_LINE_BELOW = chr(7791)
LATIN_CAPITAL_LETTER_T_WITH_CIRCUMFLEX_BELOW = chr(7792)
LATIN_SMALL_LETTER_T_WITH_CIRCUMFLEX_BELOW = chr(7793)
LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS_BELOW = chr(7794)
LATIN_SMALL_LETTER_U_WITH_DIAERESIS_BELOW = chr(7795)
LATIN_CAPITAL_LETTER_U_WITH_TILDE_BELOW = chr(7796)
LATIN_SMALL_LETTER_U_WITH_TILDE_BELOW = chr(7797)
LATIN_CAPITAL_LETTER_U_WITH_CIRCUMFLEX_BELOW = chr(7798)
LATIN_SMALL_LETTER_U_WITH_CIRCUMFLEX_BELOW = chr(7799)
LATIN_CAPITAL_LETTER_U_WITH_TILDE_AND_ACUTE = chr(7800)
LATIN_SMALL_LETTER_U_WITH_TILDE_AND_ACUTE = chr(7801)
LATIN_CAPITAL_LETTER_U_WITH_MACRON_AND_DIAERESIS = chr(7802)
LATIN_SMALL_LETTER_U_WITH_MACRON_AND_DIAERESIS = chr(7803)
LATIN_CAPITAL_LETTER_V_WITH_TILDE = chr(7804)
LATIN_SMALL_LETTER_V_WITH_TILDE = chr(7805)
LATIN_CAPITAL_LETTER_V_WITH_DOT_BELOW = chr(7806)
LATIN_SMALL_LETTER_V_WITH_DOT_BELOW = chr(7807)
LATIN_CAPITAL_LETTER_W_WITH_GRAVE = chr(7808)
LATIN_SMALL_LETTER_W_WITH_GRAVE = chr(7809)
LATIN_CAPITAL_LETTER_W_WITH_ACUTE = chr(7810)
LATIN_SMALL_LETTER_W_WITH_ACUTE = chr(7811)
LATIN_CAPITAL_LETTER_W_WITH_DIAERESIS = chr(7812)
LATIN_SMALL_LETTER_W_WITH_DIAERESIS = chr(7813)
LATIN_CAPITAL_LETTER_W_WITH_DOT_ABOVE = chr(7814)
LATIN_SMALL_LETTER_W_WITH_DOT_ABOVE = chr(7815)
LATIN_CAPITAL_LETTER_W_WITH_DOT_BELOW = chr(7816)
LATIN_SMALL_LETTER_W_WITH_DOT_BELOW = chr(7817)
LATIN_CAPITAL_LETTER_X_WITH_DOT_ABOVE = chr(7818)
LATIN_SMALL_LETTER_X_WITH_DOT_ABOVE = chr(7819)
LATIN_CAPITAL_LETTER_X_WITH_DIAERESIS = chr(7820)
LATIN_SMALL_LETTER_X_WITH_DIAERESIS = chr(7821)
LATIN_CAPITAL_LETTER_Y_WITH_DOT_ABOVE = chr(7822)
LATIN_SMALL_LETTER_Y_WITH_DOT_ABOVE = chr(7823)
LATIN_CAPITAL_LETTER_Z_WITH_CIRCUMFLEX = chr(7824)
LATIN_SMALL_LETTER_Z_WITH_CIRCUMFLEX = chr(7825)
LATIN_CAPITAL_LETTER_Z_WITH_DOT_BELOW = chr(7826)
LATIN_SMALL_LETTER_Z_WITH_DOT_BELOW = chr(7827)
LATIN_CAPITAL_LETTER_Z_WITH_LINE_BELOW = chr(7828)
LATIN_SMALL_LETTER_Z_WITH_LINE_BELOW = chr(7829)
LATIN_SMALL_LETTER_H_WITH_LINE_BELOW = chr(7830)
LATIN_SMALL_LETTER_T_WITH_DIAERESIS = chr(7831)
LATIN_SMALL_LETTER_W_WITH_RING_ABOVE = chr(7832)
LATIN_SMALL_LETTER_Y_WITH_RING_ABOVE = chr(7833)
LATIN_SMALL_LETTER_A_WITH_RIGHT_HALF_RING = chr(7834)
LATIN_SMALL_LETTER_LONG_S_WITH_DOT_ABOVE = chr(7835)
LATIN_SMALL_LETTER_LONG_S_WITH_DIAGONAL_STROKE = chr(7836)
LATIN_SMALL_LETTER_LONG_S_WITH_HIGH_STROKE = chr(7837)
LATIN_CAPITAL_LETTER_SHARP_S = chr(7838)
LATIN_SMALL_LETTER_DELTA = chr(7839)
LATIN_CAPITAL_LETTER_A_WITH_DOT_BELOW = chr(7840)
LATIN_SMALL_LETTER_A_WITH_DOT_BELOW = chr(7841)
LATIN_CAPITAL_LETTER_A_WITH_HOOK_ABOVE = chr(7842)
LATIN_SMALL_LETTER_A_WITH_HOOK_ABOVE = chr(7843)
LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX_AND_ACUTE = chr(7844)
LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX_AND_ACUTE = chr(7845)
LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX_AND_GRAVE = chr(7846)
LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX_AND_GRAVE = chr(7847)
LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX_AND_HOOK_ABOVE = chr(7848)
LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX_AND_HOOK_ABOVE = chr(7849)
LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX_AND_TILDE = chr(7850)
LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX_AND_TILDE = chr(7851)
LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX_AND_DOT_BELOW = chr(7852)
LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX_AND_DOT_BELOW = chr(7853)
LATIN_CAPITAL_LETTER_A_WITH_BREVE_AND_ACUTE = chr(7854)
LATIN_SMALL_LETTER_A_WITH_BREVE_AND_ACUTE = chr(7855)
LATIN_CAPITAL_LETTER_A_WITH_BREVE_AND_GRAVE = chr(7856)
LATIN_SMALL_LETTER_A_WITH_BREVE_AND_GRAVE = chr(7857)
LATIN_CAPITAL_LETTER_A_WITH_BREVE_AND_HOOK_ABOVE = chr(7858)
LATIN_SMALL_LETTER_A_WITH_BREVE_AND_HOOK_ABOVE = chr(7859)
LATIN_CAPITAL_LETTER_A_WITH_BREVE_AND_TILDE = chr(7860)
LATIN_SMALL_LETTER_A_WITH_BREVE_AND_TILDE = chr(7861)
LATIN_CAPITAL_LETTER_A_WITH_BREVE_AND_DOT_BELOW = chr(7862)
LATIN_SMALL_LETTER_A_WITH_BREVE_AND_DOT_BELOW = chr(7863)
LATIN_CAPITAL_LETTER_E_WITH_DOT_BELOW = chr(7864)
LATIN_SMALL_LETTER_E_WITH_DOT_BELOW = chr(7865)
LATIN_CAPITAL_LETTER_E_WITH_HOOK_ABOVE = chr(7866)
LATIN_SMALL_LETTER_E_WITH_HOOK_ABOVE = chr(7867)
LATIN_CAPITAL_LETTER_E_WITH_TILDE = chr(7868)
LATIN_SMALL_LETTER_E_WITH_TILDE = chr(7869)
LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_AND_ACUTE = chr(7870)
LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_AND_ACUTE = chr(7871)
LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_AND_GRAVE = chr(7872)
LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_AND_GRAVE = chr(7873)
LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_AND_HOOK_ABOVE = chr(7874)
LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_AND_HOOK_ABOVE = chr(7875)
LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_AND_TILDE = chr(7876)
LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_AND_TILDE = chr(7877)
LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_AND_DOT_BELOW = chr(7878)
LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_AND_DOT_BELOW = chr(7879)
LATIN_CAPITAL_LETTER_I_WITH_HOOK_ABOVE = chr(7880)
LATIN_SMALL_LETTER_I_WITH_HOOK_ABOVE = chr(7881)
LATIN_CAPITAL_LETTER_I_WITH_DOT_BELOW = chr(7882)
LATIN_SMALL_LETTER_I_WITH_DOT_BELOW = chr(7883)
LATIN_CAPITAL_LETTER_O_WITH_DOT_BELOW = chr(7884)
LATIN_SMALL_LETTER_O_WITH_DOT_BELOW = chr(7885)
LATIN_CAPITAL_LETTER_O_WITH_HOOK_ABOVE = chr(7886)
LATIN_SMALL_LETTER_O_WITH_HOOK_ABOVE = chr(7887)
LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX_AND_ACUTE = chr(7888)
LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX_AND_ACUTE = chr(7889)
LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX_AND_GRAVE = chr(7890)
LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX_AND_GRAVE = chr(7891)
LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX_AND_HOOK_ABOVE = chr(7892)
LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX_AND_HOOK_ABOVE = chr(7893)
LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX_AND_TILDE = chr(7894)
LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX_AND_TILDE = chr(7895)
LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX_AND_DOT_BELOW = chr(7896)
LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX_AND_DOT_BELOW = chr(7897)
LATIN_CAPITAL_LETTER_O_WITH_HORN_AND_ACUTE = chr(7898)
LATIN_SMALL_LETTER_O_WITH_HORN_AND_ACUTE = chr(7899)
LATIN_CAPITAL_LETTER_O_WITH_HORN_AND_GRAVE = chr(7900)
LATIN_SMALL_LETTER_O_WITH_HORN_AND_GRAVE = chr(7901)
LATIN_CAPITAL_LETTER_O_WITH_HORN_AND_HOOK_ABOVE = chr(7902)
LATIN_SMALL_LETTER_O_WITH_HORN_AND_HOOK_ABOVE = chr(7903)
LATIN_CAPITAL_LETTER_O_WITH_HORN_AND_TILDE = chr(7904)
LATIN_SMALL_LETTER_O_WITH_HORN_AND_TILDE = chr(7905)
LATIN_CAPITAL_LETTER_O_WITH_HORN_AND_DOT_BELOW = chr(7906)
LATIN_SMALL_LETTER_O_WITH_HORN_AND_DOT_BELOW = chr(7907)
LATIN_CAPITAL_LETTER_U_WITH_DOT_BELOW = chr(7908)
LATIN_SMALL_LETTER_U_WITH_DOT_BELOW = chr(7909)
LATIN_CAPITAL_LETTER_U_WITH_HOOK_ABOVE = chr(7910)
LATIN_SMALL_LETTER_U_WITH_HOOK_ABOVE = chr(7911)
LATIN_CAPITAL_LETTER_U_WITH_HORN_AND_ACUTE = chr(7912)
LATIN_SMALL_LETTER_U_WITH_HORN_AND_ACUTE = chr(7913)
LATIN_CAPITAL_LETTER_U_WITH_HORN_AND_GRAVE = chr(7914)
LATIN_SMALL_LETTER_U_WITH_HORN_AND_GRAVE = chr(7915)
LATIN_CAPITAL_LETTER_U_WITH_HORN_AND_HOOK_ABOVE = chr(7916)
LATIN_SMALL_LETTER_U_WITH_HORN_AND_HOOK_ABOVE = chr(7917)
LATIN_CAPITAL_LETTER_U_WITH_HORN_AND_TILDE = chr(7918)
LATIN_SMALL_LETTER_U_WITH_HORN_AND_TILDE = chr(7919)
LATIN_CAPITAL_LETTER_U_WITH_HORN_AND_DOT_BELOW = chr(7920)
LATIN_SMALL_LETTER_U_WITH_HORN_AND_DOT_BELOW = chr(7921)
LATIN_CAPITAL_LETTER_Y_WITH_GRAVE = chr(7922)
LATIN_SMALL_LETTER_Y_WITH_GRAVE = chr(7923)
LATIN_CAPITAL_LETTER_Y_WITH_DOT_BELOW = chr(7924)
LATIN_SMALL_LETTER_Y_WITH_DOT_BELOW = chr(7925)
LATIN_CAPITAL_LETTER_Y_WITH_HOOK_ABOVE = chr(7926)
LATIN_SMALL_LETTER_Y_WITH_HOOK_ABOVE = chr(7927)
LATIN_CAPITAL_LETTER_Y_WITH_TILDE = chr(7928)
LATIN_SMALL_LETTER_Y_WITH_TILDE = chr(7929)
LATIN_CAPITAL_LETTER_MIDDLE_WELSH_LL = chr(7930)
LATIN_SMALL_LETTER_MIDDLE_WELSH_LL = chr(7931)
LATIN_CAPITAL_LETTER_MIDDLE_WELSH_V = chr(7932)
LATIN_SMALL_LETTER_MIDDLE_WELSH_V = chr(7933)
LATIN_CAPITAL_LETTER_Y_WITH_LOOP = chr(7934)
LATIN_SMALL_LETTER_Y_WITH_LOOP = chr(7935)
GREEK_SMALL_LETTER_ALPHA_WITH_PSILI = chr(7936)
GREEK_SMALL_LETTER_ALPHA_WITH_DASIA = chr(7937)
GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_VARIA = chr(7938)
GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_VARIA = chr(7939)
GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_OXIA = chr(7940)
GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_OXIA = chr(7941)
GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_PERISPOMENI = chr(7942)
GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_PERISPOMENI = chr(7943)
GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI = chr(7944)
GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA = chr(7945)
GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_VARIA = chr(7946)
GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_VARIA = chr(7947)
GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_OXIA = chr(7948)
GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_OXIA = chr(7949)
GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_PERISPOMENI = chr(7950)
GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_PERISPOMENI = chr(7951)
GREEK_SMALL_LETTER_EPSILON_WITH_PSILI = chr(7952)
GREEK_SMALL_LETTER_EPSILON_WITH_DASIA = chr(7953)
GREEK_SMALL_LETTER_EPSILON_WITH_PSILI_AND_VARIA = chr(7954)
GREEK_SMALL_LETTER_EPSILON_WITH_DASIA_AND_VARIA = chr(7955)
GREEK_SMALL_LETTER_EPSILON_WITH_PSILI_AND_OXIA = chr(7956)
GREEK_SMALL_LETTER_EPSILON_WITH_DASIA_AND_OXIA = chr(7957)
GREEK_CAPITAL_LETTER_EPSILON_WITH_PSILI = chr(7960)
GREEK_CAPITAL_LETTER_EPSILON_WITH_DASIA = chr(7961)
GREEK_CAPITAL_LETTER_EPSILON_WITH_PSILI_AND_VARIA = chr(7962)
GREEK_CAPITAL_LETTER_EPSILON_WITH_DASIA_AND_VARIA = chr(7963)
GREEK_CAPITAL_LETTER_EPSILON_WITH_PSILI_AND_OXIA = chr(7964)
GREEK_CAPITAL_LETTER_EPSILON_WITH_DASIA_AND_OXIA = chr(7965)
GREEK_SMALL_LETTER_ETA_WITH_PSILI = chr(7968)
GREEK_SMALL_LETTER_ETA_WITH_DASIA = chr(7969)
GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_VARIA = chr(7970)
GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_VARIA = chr(7971)
GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_OXIA = chr(7972)
GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_OXIA = chr(7973)
GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_PERISPOMENI = chr(7974)
GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_PERISPOMENI = chr(7975)
GREEK_CAPITAL_LETTER_ETA_WITH_PSILI = chr(7976)
GREEK_CAPITAL_LETTER_ETA_WITH_DASIA = chr(7977)
GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_VARIA = chr(7978)
GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_VARIA = chr(7979)
GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_OXIA = chr(7980)
GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_OXIA = chr(7981)
GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_PERISPOMENI = chr(7982)
GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_PERISPOMENI = chr(7983)
GREEK_SMALL_LETTER_IOTA_WITH_PSILI = chr(7984)
GREEK_SMALL_LETTER_IOTA_WITH_DASIA = chr(7985)
GREEK_SMALL_LETTER_IOTA_WITH_PSILI_AND_VARIA = chr(7986)
GREEK_SMALL_LETTER_IOTA_WITH_DASIA_AND_VARIA = chr(7987)
GREEK_SMALL_LETTER_IOTA_WITH_PSILI_AND_OXIA = chr(7988)
GREEK_SMALL_LETTER_IOTA_WITH_DASIA_AND_OXIA = chr(7989)
GREEK_SMALL_LETTER_IOTA_WITH_PSILI_AND_PERISPOMENI = chr(7990)
GREEK_SMALL_LETTER_IOTA_WITH_DASIA_AND_PERISPOMENI = chr(7991)
GREEK_CAPITAL_LETTER_IOTA_WITH_PSILI = chr(7992)
GREEK_CAPITAL_LETTER_IOTA_WITH_DASIA = chr(7993)
GREEK_CAPITAL_LETTER_IOTA_WITH_PSILI_AND_VARIA = chr(7994)
GREEK_CAPITAL_LETTER_IOTA_WITH_DASIA_AND_VARIA = chr(7995)
GREEK_CAPITAL_LETTER_IOTA_WITH_PSILI_AND_OXIA = chr(7996)
GREEK_CAPITAL_LETTER_IOTA_WITH_DASIA_AND_OXIA = chr(7997)
GREEK_CAPITAL_LETTER_IOTA_WITH_PSILI_AND_PERISPOMENI = chr(7998)
GREEK_CAPITAL_LETTER_IOTA_WITH_DASIA_AND_PERISPOMENI = chr(7999)
GREEK_SMALL_LETTER_OMICRON_WITH_PSILI = chr(8000)
GREEK_SMALL_LETTER_OMICRON_WITH_DASIA = chr(8001)
GREEK_SMALL_LETTER_OMICRON_WITH_PSILI_AND_VARIA = chr(8002)
GREEK_SMALL_LETTER_OMICRON_WITH_DASIA_AND_VARIA = chr(8003)
GREEK_SMALL_LETTER_OMICRON_WITH_PSILI_AND_OXIA = chr(8004)
GREEK_SMALL_LETTER_OMICRON_WITH_DASIA_AND_OXIA = chr(8005)
GREEK_CAPITAL_LETTER_OMICRON_WITH_PSILI = chr(8008)
GREEK_CAPITAL_LETTER_OMICRON_WITH_DASIA = chr(8009)
GREEK_CAPITAL_LETTER_OMICRON_WITH_PSILI_AND_VARIA = chr(8010)
GREEK_CAPITAL_LETTER_OMICRON_WITH_DASIA_AND_VARIA = chr(8011)
GREEK_CAPITAL_LETTER_OMICRON_WITH_PSILI_AND_OXIA = chr(8012)
GREEK_CAPITAL_LETTER_OMICRON_WITH_DASIA_AND_OXIA = chr(8013)
GREEK_SMALL_LETTER_UPSILON_WITH_PSILI = chr(8016)
GREEK_SMALL_LETTER_UPSILON_WITH_DASIA = chr(8017)
GREEK_SMALL_LETTER_UPSILON_WITH_PSILI_AND_VARIA = chr(8018)
GREEK_SMALL_LETTER_UPSILON_WITH_DASIA_AND_VARIA = chr(8019)
GREEK_SMALL_LETTER_UPSILON_WITH_PSILI_AND_OXIA = chr(8020)
GREEK_SMALL_LETTER_UPSILON_WITH_DASIA_AND_OXIA = chr(8021)
GREEK_SMALL_LETTER_UPSILON_WITH_PSILI_AND_PERISPOMENI = chr(8022)
GREEK_SMALL_LETTER_UPSILON_WITH_DASIA_AND_PERISPOMENI = chr(8023)
GREEK_CAPITAL_LETTER_UPSILON_WITH_DASIA = chr(8025)
GREEK_CAPITAL_LETTER_UPSILON_WITH_DASIA_AND_VARIA = chr(8027)
GREEK_CAPITAL_LETTER_UPSILON_WITH_DASIA_AND_OXIA = chr(8029)
GREEK_CAPITAL_LETTER_UPSILON_WITH_DASIA_AND_PERISPOMENI = chr(8031)
GREEK_SMALL_LETTER_OMEGA_WITH_PSILI = chr(8032)
GREEK_SMALL_LETTER_OMEGA_WITH_DASIA = chr(8033)
GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_VARIA = chr(8034)
GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_VARIA = chr(8035)
GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_OXIA = chr(8036)
GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_OXIA = chr(8037)
GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_PERISPOMENI = chr(8038)
GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_PERISPOMENI = chr(8039)
GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI = chr(8040)
GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA = chr(8041)
GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_VARIA = chr(8042)
GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_VARIA = chr(8043)
GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_OXIA = chr(8044)
GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_OXIA = chr(8045)
GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_PERISPOMENI = chr(8046)
GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_PERISPOMENI = chr(8047)
GREEK_SMALL_LETTER_ALPHA_WITH_VARIA = chr(8048)
GREEK_SMALL_LETTER_ALPHA_WITH_OXIA = chr(8049)
GREEK_SMALL_LETTER_EPSILON_WITH_VARIA = chr(8050)
GREEK_SMALL_LETTER_EPSILON_WITH_OXIA = chr(8051)
GREEK_SMALL_LETTER_ETA_WITH_VARIA = chr(8052)
GREEK_SMALL_LETTER_ETA_WITH_OXIA = chr(8053)
GREEK_SMALL_LETTER_IOTA_WITH_VARIA = chr(8054)
GREEK_SMALL_LETTER_IOTA_WITH_OXIA = chr(8055)
GREEK_SMALL_LETTER_OMICRON_WITH_VARIA = chr(8056)
GREEK_SMALL_LETTER_OMICRON_WITH_OXIA = chr(8057)
GREEK_SMALL_LETTER_UPSILON_WITH_VARIA = chr(8058)
GREEK_SMALL_LETTER_UPSILON_WITH_OXIA = chr(8059)
GREEK_SMALL_LETTER_OMEGA_WITH_VARIA = chr(8060)
GREEK_SMALL_LETTER_OMEGA_WITH_OXIA = chr(8061)
GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_YPOGEGRAMMENI = chr(8064)
GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_YPOGEGRAMMENI = chr(8065)
GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_VARIA_AND_YPOGEGRAMMENI = chr(8066)
GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_VARIA_AND_YPOGEGRAMMENI = chr(8067)
GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_OXIA_AND_YPOGEGRAMMENI = chr(8068)
GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_OXIA_AND_YPOGEGRAMMENI = chr(8069)
GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_PERISPOMENI_AND_YPOGEGRAMMENI = chr(8070)
GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_PERISPOMENI_AND_YPOGEGRAMMENI = chr(8071)
GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_PROSGEGRAMMENI = chr(8072)
GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_PROSGEGRAMMENI = chr(8073)
GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_VARIA_AND_PROSGEGRAMMENI = chr(8074)
GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_VARIA_AND_PROSGEGRAMMENI = chr(8075)
GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_OXIA_AND_PROSGEGRAMMENI = chr(8076)
GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_OXIA_AND_PROSGEGRAMMENI = chr(8077)
GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_PERISPOMENI_AND_PROSGEGRAMMENI = chr(8078)
GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_PERISPOMENI_AND_PROSGEGRAMMENI = chr(8079)
GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_YPOGEGRAMMENI = chr(8080)
GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_YPOGEGRAMMENI = chr(8081)
GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_VARIA_AND_YPOGEGRAMMENI = chr(8082)
GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_VARIA_AND_YPOGEGRAMMENI = chr(8083)
GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_OXIA_AND_YPOGEGRAMMENI = chr(8084)
GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_OXIA_AND_YPOGEGRAMMENI = chr(8085)
GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_PERISPOMENI_AND_YPOGEGRAMMENI = chr(8086)
GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_PERISPOMENI_AND_YPOGEGRAMMENI = chr(8087)
GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_PROSGEGRAMMENI = chr(8088)
GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_PROSGEGRAMMENI = chr(8089)
GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_VARIA_AND_PROSGEGRAMMENI = chr(8090)
GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_VARIA_AND_PROSGEGRAMMENI = chr(8091)
GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_OXIA_AND_PROSGEGRAMMENI = chr(8092)
GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_OXIA_AND_PROSGEGRAMMENI = chr(8093)
GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_PERISPOMENI_AND_PROSGEGRAMMENI = chr(8094)
GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_PERISPOMENI_AND_PROSGEGRAMMENI = chr(8095)
GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_YPOGEGRAMMENI = chr(8096)
GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_YPOGEGRAMMENI = chr(8097)
GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_VARIA_AND_YPOGEGRAMMENI = chr(8098)
GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_VARIA_AND_YPOGEGRAMMENI = chr(8099)
GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_OXIA_AND_YPOGEGRAMMENI = chr(8100)
GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_OXIA_AND_YPOGEGRAMMENI = chr(8101)
GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_PERISPOMENI_AND_YPOGEGRAMMENI = chr(8102)
GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_PERISPOMENI_AND_YPOGEGRAMMENI = chr(8103)
GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_PROSGEGRAMMENI = chr(8104)
GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_PROSGEGRAMMENI = chr(8105)
GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_VARIA_AND_PROSGEGRAMMENI = chr(8106)
GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_VARIA_AND_PROSGEGRAMMENI = chr(8107)
GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_OXIA_AND_PROSGEGRAMMENI = chr(8108)
GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_OXIA_AND_PROSGEGRAMMENI = chr(8109)
GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_PERISPOMENI_AND_PROSGEGRAMMENI = chr(8110)
GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_PERISPOMENI_AND_PROSGEGRAMMENI = chr(8111)
GREEK_SMALL_LETTER_ALPHA_WITH_VRACHY = chr(8112)
GREEK_SMALL_LETTER_ALPHA_WITH_MACRON = chr(8113)
GREEK_SMALL_LETTER_ALPHA_WITH_VARIA_AND_YPOGEGRAMMENI = chr(8114)
GREEK_SMALL_LETTER_ALPHA_WITH_YPOGEGRAMMENI = chr(8115)
GREEK_SMALL_LETTER_ALPHA_WITH_OXIA_AND_YPOGEGRAMMENI = chr(8116)
GREEK_SMALL_LETTER_ALPHA_WITH_PERISPOMENI = chr(8118)
GREEK_SMALL_LETTER_ALPHA_WITH_PERISPOMENI_AND_YPOGEGRAMMENI = chr(8119)
GREEK_CAPITAL_LETTER_ALPHA_WITH_VRACHY = chr(8120)
GREEK_CAPITAL_LETTER_ALPHA_WITH_MACRON = chr(8121)
GREEK_CAPITAL_LETTER_ALPHA_WITH_VARIA = chr(8122)
GREEK_CAPITAL_LETTER_ALPHA_WITH_OXIA = chr(8123)
GREEK_CAPITAL_LETTER_ALPHA_WITH_PROSGEGRAMMENI = chr(8124)
GREEK_KORONIS = chr(8125)
GREEK_PROSGEGRAMMENI = chr(8126)
GREEK_PSILI = chr(8127)
GREEK_PERISPOMENI = chr(8128)
GREEK_DIALYTIKA_AND_PERISPOMENI = chr(8129)
GREEK_SMALL_LETTER_ETA_WITH_VARIA_AND_YPOGEGRAMMENI = chr(8130)
GREEK_SMALL_LETTER_ETA_WITH_YPOGEGRAMMENI = chr(8131)
GREEK_SMALL_LETTER_ETA_WITH_OXIA_AND_YPOGEGRAMMENI = chr(8132)
GREEK_SMALL_LETTER_ETA_WITH_PERISPOMENI = chr(8134)
GREEK_SMALL_LETTER_ETA_WITH_PERISPOMENI_AND_YPOGEGRAMMENI = chr(8135)
GREEK_CAPITAL_LETTER_EPSILON_WITH_VARIA = chr(8136)
GREEK_CAPITAL_LETTER_EPSILON_WITH_OXIA = chr(8137)
GREEK_CAPITAL_LETTER_ETA_WITH_VARIA = chr(8138)
GREEK_CAPITAL_LETTER_ETA_WITH_OXIA = chr(8139)
GREEK_CAPITAL_LETTER_ETA_WITH_PROSGEGRAMMENI = chr(8140)
GREEK_PSILI_AND_VARIA = chr(8141)
GREEK_PSILI_AND_OXIA = chr(8142)
GREEK_PSILI_AND_PERISPOMENI = chr(8143)
GREEK_SMALL_LETTER_IOTA_WITH_VRACHY = chr(8144)
GREEK_SMALL_LETTER_IOTA_WITH_MACRON = chr(8145)
GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA_AND_VARIA = chr(8146)
GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA_AND_OXIA = chr(8147)
GREEK_SMALL_LETTER_IOTA_WITH_PERISPOMENI = chr(8150)
GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA_AND_PERISPOMENI = chr(8151)
GREEK_CAPITAL_LETTER_IOTA_WITH_VRACHY = chr(8152)
GREEK_CAPITAL_LETTER_IOTA_WITH_MACRON = chr(8153)
GREEK_CAPITAL_LETTER_IOTA_WITH_VARIA = chr(8154)
GREEK_CAPITAL_LETTER_IOTA_WITH_OXIA = chr(8155)
GREEK_DASIA_AND_VARIA = chr(8157)
GREEK_DASIA_AND_OXIA = chr(8158)
GREEK_DASIA_AND_PERISPOMENI = chr(8159)
GREEK_SMALL_LETTER_UPSILON_WITH_VRACHY = chr(8160)
GREEK_SMALL_LETTER_UPSILON_WITH_MACRON = chr(8161)
GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA_AND_VARIA = chr(8162)
GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA_AND_OXIA = chr(8163)
GREEK_SMALL_LETTER_RHO_WITH_PSILI = chr(8164)
GREEK_SMALL_LETTER_RHO_WITH_DASIA = chr(8165)
GREEK_SMALL_LETTER_UPSILON_WITH_PERISPOMENI = chr(8166)
GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA_AND_PERISPOMENI = chr(8167)
GREEK_CAPITAL_LETTER_UPSILON_WITH_VRACHY = chr(8168)
GREEK_CAPITAL_LETTER_UPSILON_WITH_MACRON = chr(8169)
GREEK_CAPITAL_LETTER_UPSILON_WITH_VARIA = chr(8170)
GREEK_CAPITAL_LETTER_UPSILON_WITH_OXIA = chr(8171)
GREEK_CAPITAL_LETTER_RHO_WITH_DASIA = chr(8172)
GREEK_DIALYTIKA_AND_VARIA = chr(8173)
GREEK_DIALYTIKA_AND_OXIA = chr(8174)
GREEK_VARIA = chr(8175)
GREEK_SMALL_LETTER_OMEGA_WITH_VARIA_AND_YPOGEGRAMMENI = chr(8178)
GREEK_SMALL_LETTER_OMEGA_WITH_YPOGEGRAMMENI = chr(8179)
GREEK_SMALL_LETTER_OMEGA_WITH_OXIA_AND_YPOGEGRAMMENI = chr(8180)
GREEK_SMALL_LETTER_OMEGA_WITH_PERISPOMENI = chr(8182)
GREEK_SMALL_LETTER_OMEGA_WITH_PERISPOMENI_AND_YPOGEGRAMMENI = chr(8183)
GREEK_CAPITAL_LETTER_OMICRON_WITH_VARIA = chr(8184)
GREEK_CAPITAL_LETTER_OMICRON_WITH_OXIA = chr(8185)
GREEK_CAPITAL_LETTER_OMEGA_WITH_VARIA = chr(8186)
GREEK_CAPITAL_LETTER_OMEGA_WITH_OXIA = chr(8187)
GREEK_CAPITAL_LETTER_OMEGA_WITH_PROSGEGRAMMENI = chr(8188)
GREEK_OXIA = chr(8189)
GREEK_DASIA = chr(8190)
EN_QUAD = chr(8192)
EM_QUAD = chr(8193)
EN_SPACE = chr(8194)
EM_SPACE = chr(8195)
THREE_PER_EM_SPACE = chr(8196)
FOUR_PER_EM_SPACE = chr(8197)
SIX_PER_EM_SPACE = chr(8198)
FIGURE_SPACE = chr(8199)
PUNCTUATION_SPACE = chr(8200)
THIN_SPACE = chr(8201)
HAIR_SPACE = chr(8202)
ZERO_WIDTH_SPACE = chr(8203)
ZERO_WIDTH_NON_JOINER = chr(8204)
ZERO_WIDTH_JOINER = chr(8205)
LEFT_TO_RIGHT_MARK = chr(8206)
RIGHT_TO_LEFT_MARK = chr(8207)
HYPHEN = chr(8208)
NON_BREAKING_HYPHEN = chr(8209)
FIGURE_DASH = chr(8210)
EN_DASH = chr(8211)
EM_DASH = chr(8212)
HORIZONTAL_BAR = chr(8213)
DOUBLE_VERTICAL_LINE = chr(8214)
DOUBLE_LOW_LINE = chr(8215)
LEFT_SINGLE_QUOTATION_MARK = chr(8216)
RIGHT_SINGLE_QUOTATION_MARK = chr(8217)
SINGLE_LOW_9_QUOTATION_MARK = chr(8218)
SINGLE_HIGH_REVERSED_9_QUOTATION_MARK = chr(8219)
LEFT_DOUBLE_QUOTATION_MARK = chr(8220)
RIGHT_DOUBLE_QUOTATION_MARK = chr(8221)
DOUBLE_LOW_9_QUOTATION_MARK = chr(8222)
DOUBLE_HIGH_REVERSED_9_QUOTATION_MARK = chr(8223)
DAGGER = chr(8224)
DOUBLE_DAGGER = chr(8225)
BULLET = chr(8226)
TRIANGULAR_BULLET = chr(8227)
ONE_DOT_LEADER = chr(8228)
TWO_DOT_LEADER = chr(8229)
HORIZONTAL_ELLIPSIS = chr(8230)
HYPHENATION_POINT = chr(8231)
LINE_SEPARATOR = chr(8232)
PARAGRAPH_SEPARATOR = chr(8233)
LEFT_TO_RIGHT_EMBEDDING = chr(8234)
RIGHT_TO_LEFT_EMBEDDING = chr(8235)
POP_DIRECTIONAL_FORMATTING = chr(8236)
LEFT_TO_RIGHT_OVERRIDE = chr(8237)
RIGHT_TO_LEFT_OVERRIDE = chr(8238)
NARROW_NO_BREAK_SPACE = chr(8239)
PER_MILLE_SIGN = chr(8240)
PER_TEN_THOUSAND_SIGN = chr(8241)
PRIME = chr(8242)
DOUBLE_PRIME = chr(8243)
TRIPLE_PRIME = chr(8244)
REVERSED_PRIME = chr(8245)
REVERSED_DOUBLE_PRIME = chr(8246)
REVERSED_TRIPLE_PRIME = chr(8247)
CARET = chr(8248)
SINGLE_LEFT_POINTING_ANGLE_QUOTATION_MARK = chr(8249)
SINGLE_RIGHT_POINTING_ANGLE_QUOTATION_MARK = chr(8250)
REFERENCE_MARK = chr(8251)
DOUBLE_EXCLAMATION_MARK = chr(8252)
INTERROBANG = chr(8253)
OVERLINE = chr(8254)
UNDERTIE = chr(8255)
CHARACTER_TIE = chr(8256)
CARET_INSERTION_POINT = chr(8257)
ASTERISM = chr(8258)
HYPHEN_BULLET = chr(8259)
FRACTION_SLASH = chr(8260)
LEFT_SQUARE_BRACKET_WITH_QUILL = chr(8261)
RIGHT_SQUARE_BRACKET_WITH_QUILL = chr(8262)
DOUBLE_QUESTION_MARK = chr(8263)
QUESTION_EXCLAMATION_MARK = chr(8264)
EXCLAMATION_QUESTION_MARK = chr(8265)
TIRONIAN_SIGN_ET = chr(8266)
REVERSED_PILCROW_SIGN = chr(8267)
BLACK_LEFTWARDS_BULLET = chr(8268)
BLACK_RIGHTWARDS_BULLET = chr(8269)
LOW_ASTERISK = chr(8270)
REVERSED_SEMICOLON = chr(8271)
CLOSE_UP = chr(8272)
TWO_ASTERISKS_ALIGNED_VERTICALLY = chr(8273)
COMMERCIAL_MINUS_SIGN = chr(8274)
SWUNG_DASH = chr(8275)
INVERTED_UNDERTIE = chr(8276)
FLOWER_PUNCTUATION_MARK = chr(8277)
THREE_DOT_PUNCTUATION = chr(8278)
QUADRUPLE_PRIME = chr(8279)
FOUR_DOT_PUNCTUATION = chr(8280)
FIVE_DOT_PUNCTUATION = chr(8281)
TWO_DOT_PUNCTUATION = chr(8282)
FOUR_DOT_MARK = chr(8283)
DOTTED_CROSS = chr(8284)
TRICOLON = chr(8285)
VERTICAL_FOUR_DOTS = chr(8286)
MEDIUM_MATHEMATICAL_SPACE = chr(8287)
WORD_JOINER = chr(8288)
FUNCTION_APPLICATION = chr(8289)
INVISIBLE_TIMES = chr(8290)
INVISIBLE_SEPARATOR = chr(8291)
INVISIBLE_PLUS = chr(8292)
LEFT_TO_RIGHT_ISOLATE = chr(8294)
RIGHT_TO_LEFT_ISOLATE = chr(8295)
FIRST_STRONG_ISOLATE = chr(8296)
POP_DIRECTIONAL_ISOLATE = chr(8297)
INHIBIT_SYMMETRIC_SWAPPING = chr(8298)
ACTIVATE_SYMMETRIC_SWAPPING = chr(8299)
INHIBIT_ARABIC_FORM_SHAPING = chr(8300)
ACTIVATE_ARABIC_FORM_SHAPING = chr(8301)
NATIONAL_DIGIT_SHAPES = chr(8302)
NOMINAL_DIGIT_SHAPES = chr(8303)
SUPERSCRIPT_ZERO = chr(8304)
SUPERSCRIPT_LATIN_SMALL_LETTER_I = chr(8305)
SUPERSCRIPT_FOUR = chr(8308)
SUPERSCRIPT_FIVE = chr(8309)
SUPERSCRIPT_SIX = chr(8310)
SUPERSCRIPT_SEVEN = chr(8311)
SUPERSCRIPT_EIGHT = chr(8312)
SUPERSCRIPT_NINE = chr(8313)
SUPERSCRIPT_PLUS_SIGN = chr(8314)
SUPERSCRIPT_MINUS = chr(8315)
SUPERSCRIPT_EQUALS_SIGN = chr(8316)
SUPERSCRIPT_LEFT_PARENTHESIS = chr(8317)
SUPERSCRIPT_RIGHT_PARENTHESIS = chr(8318)
SUPERSCRIPT_LATIN_SMALL_LETTER_N = chr(8319)
SUBSCRIPT_ZERO = chr(8320)
SUBSCRIPT_ONE = chr(8321)
SUBSCRIPT_TWO = chr(8322)
SUBSCRIPT_THREE = chr(8323)
SUBSCRIPT_FOUR = chr(8324)
SUBSCRIPT_FIVE = chr(8325)
SUBSCRIPT_SIX = chr(8326)
SUBSCRIPT_SEVEN = chr(8327)
SUBSCRIPT_EIGHT = chr(8328)
SUBSCRIPT_NINE = chr(8329)
SUBSCRIPT_PLUS_SIGN = chr(8330)
SUBSCRIPT_MINUS = chr(8331)
SUBSCRIPT_EQUALS_SIGN = chr(8332)
SUBSCRIPT_LEFT_PARENTHESIS = chr(8333)
SUBSCRIPT_RIGHT_PARENTHESIS = chr(8334)
LATIN_SUBSCRIPT_SMALL_LETTER_A = chr(8336)
LATIN_SUBSCRIPT_SMALL_LETTER_E = chr(8337)
LATIN_SUBSCRIPT_SMALL_LETTER_O = chr(8338)
LATIN_SUBSCRIPT_SMALL_LETTER_X = chr(8339)
LATIN_SUBSCRIPT_SMALL_LETTER_SCHWA = chr(8340)
LATIN_SUBSCRIPT_SMALL_LETTER_H = chr(8341)
LATIN_SUBSCRIPT_SMALL_LETTER_K = chr(8342)
LATIN_SUBSCRIPT_SMALL_LETTER_L = chr(8343)
LATIN_SUBSCRIPT_SMALL_LETTER_M = chr(8344)
LATIN_SUBSCRIPT_SMALL_LETTER_N = chr(8345)
LATIN_SUBSCRIPT_SMALL_LETTER_P = chr(8346)
LATIN_SUBSCRIPT_SMALL_LETTER_S = chr(8347)
LATIN_SUBSCRIPT_SMALL_LETTER_T = chr(8348)
EURO_CURRENCY_SIGN = chr(8352)
COLON_SIGN = chr(8353)
CRUZEIRO_SIGN = chr(8354)
FRENCH_FRANC_SIGN = chr(8355)
LIRA_SIGN = chr(8356)
MILL_SIGN = chr(8357)
NAIRA_SIGN = chr(8358)
PESETA_SIGN = chr(8359)
RUPEE_SIGN = chr(8360)
WON_SIGN = chr(8361)
NEW_SHEQEL_SIGN = chr(8362)
DONG_SIGN = chr(8363)
EURO_SIGN = chr(8364)
KIP_SIGN = chr(8365)
TUGRIK_SIGN = chr(8366)
DRACHMA_SIGN = chr(8367)
GERMAN_PENNY_SIGN = chr(8368)
PESO_SIGN = chr(8369)
GUARANI_SIGN = chr(8370)
AUSTRAL_SIGN = chr(8371)
HRYVNIA_SIGN = chr(8372)
CEDI_SIGN = chr(8373)
LIVRE_TOURNOIS_SIGN = chr(8374)
SPESMILO_SIGN = chr(8375)
TENGE_SIGN = chr(8376)
INDIAN_RUPEE_SIGN = chr(8377)
TURKISH_LIRA_SIGN = chr(8378)
NORDIC_MARK_SIGN = chr(8379)
MANAT_SIGN = chr(8380)
RUBLE_SIGN = chr(8381)
LARI_SIGN = chr(8382)
BITCOIN_SIGN = chr(8383)
SOM_SIGN = chr(8384)
COMBINING_LEFT_HARPOON_ABOVE = chr(8400)
COMBINING_RIGHT_HARPOON_ABOVE = chr(8401)
COMBINING_LONG_VERTICAL_LINE_OVERLAY = chr(8402)
COMBINING_SHORT_VERTICAL_LINE_OVERLAY = chr(8403)
COMBINING_ANTICLOCKWISE_ARROW_ABOVE = chr(8404)
COMBINING_CLOCKWISE_ARROW_ABOVE = chr(8405)
COMBINING_LEFT_ARROW_ABOVE = chr(8406)
COMBINING_RIGHT_ARROW_ABOVE = chr(8407)
COMBINING_RING_OVERLAY = chr(8408)
COMBINING_CLOCKWISE_RING_OVERLAY = chr(8409)
COMBINING_ANTICLOCKWISE_RING_OVERLAY = chr(8410)
COMBINING_THREE_DOTS_ABOVE = chr(8411)
COMBINING_FOUR_DOTS_ABOVE = chr(8412)
COMBINING_ENCLOSING_CIRCLE = chr(8413)
COMBINING_ENCLOSING_SQUARE = chr(8414)
COMBINING_ENCLOSING_DIAMOND = chr(8415)
COMBINING_ENCLOSING_CIRCLE_BACKSLASH = chr(8416)
COMBINING_LEFT_RIGHT_ARROW_ABOVE = chr(8417)
COMBINING_ENCLOSING_SCREEN = chr(8418)
COMBINING_ENCLOSING_KEYCAP = chr(8419)
COMBINING_ENCLOSING_UPWARD_POINTING_TRIANGLE = chr(8420)
COMBINING_REVERSE_SOLIDUS_OVERLAY = chr(8421)
COMBINING_DOUBLE_VERTICAL_STROKE_OVERLAY = chr(8422)
COMBINING_ANNUITY_SYMBOL = chr(8423)
COMBINING_TRIPLE_UNDERDOT = chr(8424)
COMBINING_WIDE_BRIDGE_ABOVE = chr(8425)
COMBINING_LEFTWARDS_ARROW_OVERLAY = chr(8426)
COMBINING_LONG_DOUBLE_SOLIDUS_OVERLAY = chr(8427)
COMBINING_RIGHTWARDS_HARPOON_WITH_BARB_DOWNWARDS = chr(8428)
COMBINING_LEFTWARDS_HARPOON_WITH_BARB_DOWNWARDS = chr(8429)
COMBINING_LEFT_ARROW_BELOW = chr(8430)
COMBINING_RIGHT_ARROW_BELOW = chr(8431)
COMBINING_ASTERISK_ABOVE = chr(8432)
ACCOUNT_OF = chr(8448)
ADDRESSED_TO_THE_SUBJECT = chr(8449)
DOUBLE_STRUCK_CAPITAL_C = chr(8450)
DEGREE_CELSIUS = chr(8451)
CENTRE_LINE_SYMBOL = chr(8452)
CARE_OF = chr(8453)
CADA_UNA = chr(8454)
EULER_CONSTANT = chr(8455)
SCRUPLE = chr(8456)
DEGREE_FAHRENHEIT = chr(8457)
SCRIPT_SMALL_G = chr(8458)
SCRIPT_CAPITAL_H = chr(8459)
BLACK_LETTER_CAPITAL_H = chr(8460)
DOUBLE_STRUCK_CAPITAL_H = chr(8461)
PLANCK_CONSTANT = chr(8462)
PLANCK_CONSTANT_OVER_TWO_PI = chr(8463)
SCRIPT_CAPITAL_I = chr(8464)
BLACK_LETTER_CAPITAL_I = chr(8465)
SCRIPT_CAPITAL_L = chr(8466)
SCRIPT_SMALL_L = chr(8467)
L_B_BAR_SYMBOL = chr(8468)
DOUBLE_STRUCK_CAPITAL_N = chr(8469)
NUMERO_SIGN = chr(8470)
SOUND_RECORDING_COPYRIGHT = chr(8471)
SCRIPT_CAPITAL_P = chr(8472)
DOUBLE_STRUCK_CAPITAL_P = chr(8473)
DOUBLE_STRUCK_CAPITAL_Q = chr(8474)
SCRIPT_CAPITAL_R = chr(8475)
BLACK_LETTER_CAPITAL_R = chr(8476)
DOUBLE_STRUCK_CAPITAL_R = chr(8477)
PRESCRIPTION_TAKE = chr(8478)
RESPONSE = chr(8479)
SERVICE_MARK = chr(8480)
TELEPHONE_SIGN = chr(8481)
TRADE_MARK_SIGN = chr(8482)
VERSICLE = chr(8483)
DOUBLE_STRUCK_CAPITAL_Z = chr(8484)
OUNCE_SIGN = chr(8485)
OHM_SIGN = chr(8486)
INVERTED_OHM_SIGN = chr(8487)
BLACK_LETTER_CAPITAL_Z = chr(8488)
TURNED_GREEK_SMALL_LETTER_IOTA = chr(8489)
KELVIN_SIGN = chr(8490)
ANGSTROM_SIGN = chr(8491)
SCRIPT_CAPITAL_B = chr(8492)
BLACK_LETTER_CAPITAL_C = chr(8493)
ESTIMATED_SYMBOL = chr(8494)
SCRIPT_SMALL_E = chr(8495)
SCRIPT_CAPITAL_E = chr(8496)
SCRIPT_CAPITAL_F = chr(8497)
TURNED_CAPITAL_F = chr(8498)
SCRIPT_CAPITAL_M = chr(8499)
SCRIPT_SMALL_O = chr(8500)
ALEF_SYMBOL = chr(8501)
BET_SYMBOL = chr(8502)
GIMEL_SYMBOL = chr(8503)
DALET_SYMBOL = chr(8504)
INFORMATION_SOURCE = chr(8505)
ROTATED_CAPITAL_Q = chr(8506)
FACSIMILE_SIGN = chr(8507)
DOUBLE_STRUCK_SMALL_PI = chr(8508)
DOUBLE_STRUCK_SMALL_GAMMA = chr(8509)
DOUBLE_STRUCK_CAPITAL_GAMMA = chr(8510)
DOUBLE_STRUCK_CAPITAL_PI = chr(8511)
DOUBLE_STRUCK_N_ARY_SUMMATION = chr(8512)
TURNED_SANS_SERIF_CAPITAL_G = chr(8513)
TURNED_SANS_SERIF_CAPITAL_L = chr(8514)
REVERSED_SANS_SERIF_CAPITAL_L = chr(8515)
TURNED_SANS_SERIF_CAPITAL_Y = chr(8516)
DOUBLE_STRUCK_ITALIC_CAPITAL_D = chr(8517)
DOUBLE_STRUCK_ITALIC_SMALL_D = chr(8518)
DOUBLE_STRUCK_ITALIC_SMALL_E = chr(8519)
DOUBLE_STRUCK_ITALIC_SMALL_I = chr(8520)
DOUBLE_STRUCK_ITALIC_SMALL_J = chr(8521)
PROPERTY_LINE = chr(8522)
TURNED_AMPERSAND = chr(8523)
PER_SIGN = chr(8524)
AKTIESELSKAB = chr(8525)
TURNED_SMALL_F = chr(8526)
SYMBOL_FOR_SAMARITAN_SOURCE = chr(8527)
VULGAR_FRACTION_ONE_SEVENTH = chr(8528)
VULGAR_FRACTION_ONE_NINTH = chr(8529)
VULGAR_FRACTION_ONE_TENTH = chr(8530)
VULGAR_FRACTION_ONE_THIRD = chr(8531)
VULGAR_FRACTION_TWO_THIRDS = chr(8532)
VULGAR_FRACTION_ONE_FIFTH = chr(8533)
VULGAR_FRACTION_TWO_FIFTHS = chr(8534)
VULGAR_FRACTION_THREE_FIFTHS = chr(8535)
VULGAR_FRACTION_FOUR_FIFTHS = chr(8536)
VULGAR_FRACTION_ONE_SIXTH = chr(8537)
VULGAR_FRACTION_FIVE_SIXTHS = chr(8538)
VULGAR_FRACTION_ONE_EIGHTH = chr(8539)
VULGAR_FRACTION_THREE_EIGHTHS = chr(8540)
VULGAR_FRACTION_FIVE_EIGHTHS = chr(8541)
VULGAR_FRACTION_SEVEN_EIGHTHS = chr(8542)
FRACTION_NUMERATOR_ONE = chr(8543)
ROMAN_NUMERAL_ONE = chr(8544)
ROMAN_NUMERAL_TWO = chr(8545)
ROMAN_NUMERAL_THREE = chr(8546)
ROMAN_NUMERAL_FOUR = chr(8547)
ROMAN_NUMERAL_FIVE = chr(8548)
ROMAN_NUMERAL_SIX = chr(8549)
ROMAN_NUMERAL_SEVEN = chr(8550)
ROMAN_NUMERAL_EIGHT = chr(8551)
ROMAN_NUMERAL_NINE = chr(8552)
ROMAN_NUMERAL_TEN = chr(8553)
ROMAN_NUMERAL_ELEVEN = chr(8554)
ROMAN_NUMERAL_TWELVE = chr(8555)
ROMAN_NUMERAL_FIFTY = chr(8556)
ROMAN_NUMERAL_ONE_HUNDRED = chr(8557)
ROMAN_NUMERAL_FIVE_HUNDRED = chr(8558)
ROMAN_NUMERAL_ONE_THOUSAND = chr(8559)
SMALL_ROMAN_NUMERAL_ONE = chr(8560)
SMALL_ROMAN_NUMERAL_TWO = chr(8561)
SMALL_ROMAN_NUMERAL_THREE = chr(8562)
SMALL_ROMAN_NUMERAL_FOUR = chr(8563)
SMALL_ROMAN_NUMERAL_FIVE = chr(8564)
SMALL_ROMAN_NUMERAL_SIX = chr(8565)
SMALL_ROMAN_NUMERAL_SEVEN = chr(8566)
SMALL_ROMAN_NUMERAL_EIGHT = chr(8567)
SMALL_ROMAN_NUMERAL_NINE = chr(8568)
SMALL_ROMAN_NUMERAL_TEN = chr(8569)
SMALL_ROMAN_NUMERAL_ELEVEN = chr(8570)
SMALL_ROMAN_NUMERAL_TWELVE = chr(8571)
SMALL_ROMAN_NUMERAL_FIFTY = chr(8572)
SMALL_ROMAN_NUMERAL_ONE_HUNDRED = chr(8573)
SMALL_ROMAN_NUMERAL_FIVE_HUNDRED = chr(8574)
SMALL_ROMAN_NUMERAL_ONE_THOUSAND = chr(8575)
ROMAN_NUMERAL_ONE_THOUSAND_C_D = chr(8576)
ROMAN_NUMERAL_FIVE_THOUSAND = chr(8577)
ROMAN_NUMERAL_TEN_THOUSAND = chr(8578)
ROMAN_NUMERAL_REVERSED_ONE_HUNDRED = chr(8579)
LATIN_SMALL_LETTER_REVERSED_C = chr(8580)
ROMAN_NUMERAL_SIX_LATE_FORM = chr(8581)
ROMAN_NUMERAL_FIFTY_EARLY_FORM = chr(8582)
ROMAN_NUMERAL_FIFTY_THOUSAND = chr(8583)
ROMAN_NUMERAL_ONE_HUNDRED_THOUSAND = chr(8584)
VULGAR_FRACTION_ZERO_THIRDS = chr(8585)
TURNED_DIGIT_TWO = chr(8586)
TURNED_DIGIT_THREE = chr(8587)
LEFTWARDS_ARROW = chr(8592)
UPWARDS_ARROW = chr(8593)
RIGHTWARDS_ARROW = chr(8594)
DOWNWARDS_ARROW = chr(8595)
LEFT_RIGHT_ARROW = chr(8596)
UP_DOWN_ARROW = chr(8597)
NORTH_WEST_ARROW = chr(8598)
NORTH_EAST_ARROW = chr(8599)
SOUTH_EAST_ARROW = chr(8600)
SOUTH_WEST_ARROW = chr(8601)
LEFTWARDS_ARROW_WITH_STROKE = chr(8602)
RIGHTWARDS_ARROW_WITH_STROKE = chr(8603)
LEFTWARDS_WAVE_ARROW = chr(8604)
RIGHTWARDS_WAVE_ARROW = chr(8605)
LEFTWARDS_TWO_HEADED_ARROW = chr(8606)
UPWARDS_TWO_HEADED_ARROW = chr(8607)
RIGHTWARDS_TWO_HEADED_ARROW = chr(8608)
DOWNWARDS_TWO_HEADED_ARROW = chr(8609)
LEFTWARDS_ARROW_WITH_TAIL = chr(8610)
RIGHTWARDS_ARROW_WITH_TAIL = chr(8611)
LEFTWARDS_ARROW_FROM_BAR = chr(8612)
UPWARDS_ARROW_FROM_BAR = chr(8613)
RIGHTWARDS_ARROW_FROM_BAR = chr(8614)
DOWNWARDS_ARROW_FROM_BAR = chr(8615)
UP_DOWN_ARROW_WITH_BASE = chr(8616)
LEFTWARDS_ARROW_WITH_HOOK = chr(8617)
RIGHTWARDS_ARROW_WITH_HOOK = chr(8618)
LEFTWARDS_ARROW_WITH_LOOP = chr(8619)
RIGHTWARDS_ARROW_WITH_LOOP = chr(8620)
LEFT_RIGHT_WAVE_ARROW = chr(8621)
LEFT_RIGHT_ARROW_WITH_STROKE = chr(8622)
DOWNWARDS_ZIGZAG_ARROW = chr(8623)
UPWARDS_ARROW_WITH_TIP_LEFTWARDS = chr(8624)
UPWARDS_ARROW_WITH_TIP_RIGHTWARDS = chr(8625)
DOWNWARDS_ARROW_WITH_TIP_LEFTWARDS = chr(8626)
DOWNWARDS_ARROW_WITH_TIP_RIGHTWARDS = chr(8627)
RIGHTWARDS_ARROW_WITH_CORNER_DOWNWARDS = chr(8628)
DOWNWARDS_ARROW_WITH_CORNER_LEFTWARDS = chr(8629)
ANTICLOCKWISE_TOP_SEMICIRCLE_ARROW = chr(8630)
CLOCKWISE_TOP_SEMICIRCLE_ARROW = chr(8631)
NORTH_WEST_ARROW_TO_LONG_BAR = chr(8632)
LEFTWARDS_ARROW_TO_BAR_OVER_RIGHTWARDS_ARROW_TO_BAR = chr(8633)
ANTICLOCKWISE_OPEN_CIRCLE_ARROW = chr(8634)
CLOCKWISE_OPEN_CIRCLE_ARROW = chr(8635)
LEFTWARDS_HARPOON_WITH_BARB_UPWARDS = chr(8636)
LEFTWARDS_HARPOON_WITH_BARB_DOWNWARDS = chr(8637)
UPWARDS_HARPOON_WITH_BARB_RIGHTWARDS = chr(8638)
UPWARDS_HARPOON_WITH_BARB_LEFTWARDS = chr(8639)
RIGHTWARDS_HARPOON_WITH_BARB_UPWARDS = chr(8640)
RIGHTWARDS_HARPOON_WITH_BARB_DOWNWARDS = chr(8641)
DOWNWARDS_HARPOON_WITH_BARB_RIGHTWARDS = chr(8642)
DOWNWARDS_HARPOON_WITH_BARB_LEFTWARDS = chr(8643)
RIGHTWARDS_ARROW_OVER_LEFTWARDS_ARROW = chr(8644)
UPWARDS_ARROW_LEFTWARDS_OF_DOWNWARDS_ARROW = chr(8645)
LEFTWARDS_ARROW_OVER_RIGHTWARDS_ARROW = chr(8646)
LEFTWARDS_PAIRED_ARROWS = chr(8647)
UPWARDS_PAIRED_ARROWS = chr(8648)
RIGHTWARDS_PAIRED_ARROWS = chr(8649)
DOWNWARDS_PAIRED_ARROWS = chr(8650)
LEFTWARDS_HARPOON_OVER_RIGHTWARDS_HARPOON = chr(8651)
RIGHTWARDS_HARPOON_OVER_LEFTWARDS_HARPOON = chr(8652)
LEFTWARDS_DOUBLE_ARROW_WITH_STROKE = chr(8653)
LEFT_RIGHT_DOUBLE_ARROW_WITH_STROKE = chr(8654)
RIGHTWARDS_DOUBLE_ARROW_WITH_STROKE = chr(8655)
LEFTWARDS_DOUBLE_ARROW = chr(8656)
UPWARDS_DOUBLE_ARROW = chr(8657)
RIGHTWARDS_DOUBLE_ARROW = chr(8658)
DOWNWARDS_DOUBLE_ARROW = chr(8659)
LEFT_RIGHT_DOUBLE_ARROW = chr(8660)
UP_DOWN_DOUBLE_ARROW = chr(8661)
NORTH_WEST_DOUBLE_ARROW = chr(8662)
NORTH_EAST_DOUBLE_ARROW = chr(8663)
SOUTH_EAST_DOUBLE_ARROW = chr(8664)
SOUTH_WEST_DOUBLE_ARROW = chr(8665)
LEFTWARDS_TRIPLE_ARROW = chr(8666)
RIGHTWARDS_TRIPLE_ARROW = chr(8667)
LEFTWARDS_SQUIGGLE_ARROW = chr(8668)
RIGHTWARDS_SQUIGGLE_ARROW = chr(8669)
UPWARDS_ARROW_WITH_DOUBLE_STROKE = chr(8670)
DOWNWARDS_ARROW_WITH_DOUBLE_STROKE = chr(8671)
LEFTWARDS_DASHED_ARROW = chr(8672)
UPWARDS_DASHED_ARROW = chr(8673)
RIGHTWARDS_DASHED_ARROW = chr(8674)
DOWNWARDS_DASHED_ARROW = chr(8675)
LEFTWARDS_ARROW_TO_BAR = chr(8676)
RIGHTWARDS_ARROW_TO_BAR = chr(8677)
LEFTWARDS_WHITE_ARROW = chr(8678)
UPWARDS_WHITE_ARROW = chr(8679)
RIGHTWARDS_WHITE_ARROW = chr(8680)
DOWNWARDS_WHITE_ARROW = chr(8681)
UPWARDS_WHITE_ARROW_FROM_BAR = chr(8682)
UPWARDS_WHITE_ARROW_ON_PEDESTAL = chr(8683)
UPWARDS_WHITE_ARROW_ON_PEDESTAL_WITH_HORIZONTAL_BAR = chr(8684)
UPWARDS_WHITE_ARROW_ON_PEDESTAL_WITH_VERTICAL_BAR = chr(8685)
UPWARDS_WHITE_DOUBLE_ARROW = chr(8686)
UPWARDS_WHITE_DOUBLE_ARROW_ON_PEDESTAL = chr(8687)
RIGHTWARDS_WHITE_ARROW_FROM_WALL = chr(8688)
NORTH_WEST_ARROW_TO_CORNER = chr(8689)
SOUTH_EAST_ARROW_TO_CORNER = chr(8690)
UP_DOWN_WHITE_ARROW = chr(8691)
RIGHT_ARROW_WITH_SMALL_CIRCLE = chr(8692)
DOWNWARDS_ARROW_LEFTWARDS_OF_UPWARDS_ARROW = chr(8693)
THREE_RIGHTWARDS_ARROWS = chr(8694)
LEFTWARDS_ARROW_WITH_VERTICAL_STROKE = chr(8695)
RIGHTWARDS_ARROW_WITH_VERTICAL_STROKE = chr(8696)
LEFT_RIGHT_ARROW_WITH_VERTICAL_STROKE = chr(8697)
LEFTWARDS_ARROW_WITH_DOUBLE_VERTICAL_STROKE = chr(8698)
RIGHTWARDS_ARROW_WITH_DOUBLE_VERTICAL_STROKE = chr(8699)
LEFT_RIGHT_ARROW_WITH_DOUBLE_VERTICAL_STROKE = chr(8700)
LEFTWARDS_OPEN_HEADED_ARROW = chr(8701)
RIGHTWARDS_OPEN_HEADED_ARROW = chr(8702)
LEFT_RIGHT_OPEN_HEADED_ARROW = chr(8703)
FOR_ALL = chr(8704)
COMPLEMENT = chr(8705)
PARTIAL_DIFFERENTIAL = chr(8706)
THERE_EXISTS = chr(8707)
THERE_DOES_NOT_EXIST = chr(8708)
EMPTY_SET = chr(8709)
INCREMENT = chr(8710)
NABLA = chr(8711)
ELEMENT_OF = chr(8712)
NOT_AN_ELEMENT_OF = chr(8713)
SMALL_ELEMENT_OF = chr(8714)
CONTAINS_AS_MEMBER = chr(8715)
DOES_NOT_CONTAIN_AS_MEMBER = chr(8716)
SMALL_CONTAINS_AS_MEMBER = chr(8717)
END_OF_PROOF = chr(8718)
N_ARY_PRODUCT = chr(8719)
N_ARY_COPRODUCT = chr(8720)
N_ARY_SUMMATION = chr(8721)
MINUS_SIGN = chr(8722)
MINUS_OR_PLUS_SIGN = chr(8723)
DOT_PLUS = chr(8724)
DIVISION_SLASH = chr(8725)
SET_MINUS = chr(8726)
ASTERISK_OPERATOR = chr(8727)
RING_OPERATOR = chr(8728)
BULLET_OPERATOR = chr(8729)
SQUARE_ROOT = chr(8730)
CUBE_ROOT = chr(8731)
FOURTH_ROOT = chr(8732)
PROPORTIONAL_TO = chr(8733)
INFINITY = chr(8734)
RIGHT_ANGLE = chr(8735)
ANGLE = chr(8736)
MEASURED_ANGLE = chr(8737)
SPHERICAL_ANGLE = chr(8738)
DIVIDES = chr(8739)
DOES_NOT_DIVIDE = chr(8740)
PARALLEL_TO = chr(8741)
NOT_PARALLEL_TO = chr(8742)
LOGICAL_AND = chr(8743)
LOGICAL_OR = chr(8744)
INTERSECTION = chr(8745)
UNION = chr(8746)
INTEGRAL = chr(8747)
DOUBLE_INTEGRAL = chr(8748)
TRIPLE_INTEGRAL = chr(8749)
CONTOUR_INTEGRAL = chr(8750)
SURFACE_INTEGRAL = chr(8751)
VOLUME_INTEGRAL = chr(8752)
CLOCKWISE_INTEGRAL = chr(8753)
CLOCKWISE_CONTOUR_INTEGRAL = chr(8754)
ANTICLOCKWISE_CONTOUR_INTEGRAL = chr(8755)
THEREFORE = chr(8756)
BECAUSE = chr(8757)
RATIO = chr(8758)
PROPORTION = chr(8759)
DOT_MINUS = chr(8760)
EXCESS = chr(8761)
GEOMETRIC_PROPORTION = chr(8762)
HOMOTHETIC = chr(8763)
TILDE_OPERATOR = chr(8764)
REVERSED_TILDE = chr(8765)
INVERTED_LAZY_S = chr(8766)
SINE_WAVE = chr(8767)
WREATH_PRODUCT = chr(8768)
NOT_TILDE = chr(8769)
MINUS_TILDE = chr(8770)
ASYMPTOTICALLY_EQUAL_TO = chr(8771)
NOT_ASYMPTOTICALLY_EQUAL_TO = chr(8772)
APPROXIMATELY_EQUAL_TO = chr(8773)
APPROXIMATELY_BUT_NOT_ACTUALLY_EQUAL_TO = chr(8774)
NEITHER_APPROXIMATELY_NOR_ACTUALLY_EQUAL_TO = chr(8775)
ALMOST_EQUAL_TO = chr(8776)
NOT_ALMOST_EQUAL_TO = chr(8777)
ALMOST_EQUAL_OR_EQUAL_TO = chr(8778)
TRIPLE_TILDE = chr(8779)
ALL_EQUAL_TO = chr(8780)
EQUIVALENT_TO = chr(8781)
GEOMETRICALLY_EQUIVALENT_TO = chr(8782)
DIFFERENCE_BETWEEN = chr(8783)
APPROACHES_THE_LIMIT = chr(8784)
GEOMETRICALLY_EQUAL_TO = chr(8785)
APPROXIMATELY_EQUAL_TO_OR_THE_IMAGE_OF = chr(8786)
IMAGE_OF_OR_APPROXIMATELY_EQUAL_TO = chr(8787)
COLON_EQUALS = chr(8788)
EQUALS_COLON = chr(8789)
RING_IN_EQUAL_TO = chr(8790)
RING_EQUAL_TO = chr(8791)
CORRESPONDS_TO = chr(8792)
ESTIMATES = chr(8793)
EQUIANGULAR_TO = chr(8794)
STAR_EQUALS = chr(8795)
DELTA_EQUAL_TO = chr(8796)
EQUAL_TO_BY_DEFINITION = chr(8797)
MEASURED_BY = chr(8798)
QUESTIONED_EQUAL_TO = chr(8799)
NOT_EQUAL_TO = chr(8800)
IDENTICAL_TO = chr(8801)
NOT_IDENTICAL_TO = chr(8802)
STRICTLY_EQUIVALENT_TO = chr(8803)
LESS_THAN_OR_EQUAL_TO = chr(8804)
GREATER_THAN_OR_EQUAL_TO = chr(8805)
LESS_THAN_OVER_EQUAL_TO = chr(8806)
GREATER_THAN_OVER_EQUAL_TO = chr(8807)
LESS_THAN_BUT_NOT_EQUAL_TO = chr(8808)
GREATER_THAN_BUT_NOT_EQUAL_TO = chr(8809)
MUCH_LESS_THAN = chr(8810)
MUCH_GREATER_THAN = chr(8811)
BETWEEN = chr(8812)
NOT_EQUIVALENT_TO = chr(8813)
NOT_LESS_THAN = chr(8814)
NOT_GREATER_THAN = chr(8815)
NEITHER_LESS_THAN_NOR_EQUAL_TO = chr(8816)
NEITHER_GREATER_THAN_NOR_EQUAL_TO = chr(8817)
LESS_THAN_OR_EQUIVALENT_TO = chr(8818)
GREATER_THAN_OR_EQUIVALENT_TO = chr(8819)
NEITHER_LESS_THAN_NOR_EQUIVALENT_TO = chr(8820)
NEITHER_GREATER_THAN_NOR_EQUIVALENT_TO = chr(8821)
LESS_THAN_OR_GREATER_THAN = chr(8822)
GREATER_THAN_OR_LESS_THAN = chr(8823)
NEITHER_LESS_THAN_NOR_GREATER_THAN = chr(8824)
NEITHER_GREATER_THAN_NOR_LESS_THAN = chr(8825)
PRECEDES = chr(8826)
SUCCEEDS = chr(8827)
PRECEDES_OR_EQUAL_TO = chr(8828)
SUCCEEDS_OR_EQUAL_TO = chr(8829)
PRECEDES_OR_EQUIVALENT_TO = chr(8830)
SUCCEEDS_OR_EQUIVALENT_TO = chr(8831)
DOES_NOT_PRECEDE = chr(8832)
DOES_NOT_SUCCEED = chr(8833)
SUBSET_OF = chr(8834)
SUPERSET_OF = chr(8835)
NOT_A_SUBSET_OF = chr(8836)
NOT_A_SUPERSET_OF = chr(8837)
SUBSET_OF_OR_EQUAL_TO = chr(8838)
SUPERSET_OF_OR_EQUAL_TO = chr(8839)
NEITHER_A_SUBSET_OF_NOR_EQUAL_TO = chr(8840)
NEITHER_A_SUPERSET_OF_NOR_EQUAL_TO = chr(8841)
SUBSET_OF_WITH_NOT_EQUAL_TO = chr(8842)
SUPERSET_OF_WITH_NOT_EQUAL_TO = chr(8843)
MULTISET = chr(8844)
MULTISET_MULTIPLICATION = chr(8845)
MULTISET_UNION = chr(8846)
SQUARE_IMAGE_OF = chr(8847)
SQUARE_ORIGINAL_OF = chr(8848)
SQUARE_IMAGE_OF_OR_EQUAL_TO = chr(8849)
SQUARE_ORIGINAL_OF_OR_EQUAL_TO = chr(8850)
SQUARE_CAP = chr(8851)
SQUARE_CUP = chr(8852)
CIRCLED_PLUS = chr(8853)
CIRCLED_MINUS = chr(8854)
CIRCLED_TIMES = chr(8855)
CIRCLED_DIVISION_SLASH = chr(8856)
CIRCLED_DOT_OPERATOR = chr(8857)
CIRCLED_RING_OPERATOR = chr(8858)
CIRCLED_ASTERISK_OPERATOR = chr(8859)
CIRCLED_EQUALS = chr(8860)
CIRCLED_DASH = chr(8861)
SQUARED_PLUS = chr(8862)
SQUARED_MINUS = chr(8863)
SQUARED_TIMES = chr(8864)
SQUARED_DOT_OPERATOR = chr(8865)
RIGHT_TACK = chr(8866)
LEFT_TACK = chr(8867)
DOWN_TACK = chr(8868)
UP_TACK = chr(8869)
ASSERTION = chr(8870)
MODELS = chr(8871)
TRUE = chr(8872)
FORCES = chr(8873)
TRIPLE_VERTICAL_BAR_RIGHT_TURNSTILE = chr(8874)
DOUBLE_VERTICAL_BAR_DOUBLE_RIGHT_TURNSTILE = chr(8875)
DOES_NOT_PROVE = chr(8876)
NOT_TRUE = chr(8877)
DOES_NOT_FORCE = chr(8878)
NEGATED_DOUBLE_VERTICAL_BAR_DOUBLE_RIGHT_TURNSTILE = chr(8879)
PRECEDES_UNDER_RELATION = chr(8880)
SUCCEEDS_UNDER_RELATION = chr(8881)
NORMAL_SUBGROUP_OF = chr(8882)
CONTAINS_AS_NORMAL_SUBGROUP = chr(8883)
NORMAL_SUBGROUP_OF_OR_EQUAL_TO = chr(8884)
CONTAINS_AS_NORMAL_SUBGROUP_OR_EQUAL_TO = chr(8885)
ORIGINAL_OF = chr(8886)
IMAGE_OF = chr(8887)
MULTIMAP = chr(8888)
HERMITIAN_CONJUGATE_MATRIX = chr(8889)
INTERCALATE = chr(8890)
XOR = chr(8891)
NAND = chr(8892)
NOR = chr(8893)
RIGHT_ANGLE_WITH_ARC = chr(8894)
RIGHT_TRIANGLE = chr(8895)
N_ARY_LOGICAL_AND = chr(8896)
N_ARY_LOGICAL_OR = chr(8897)
N_ARY_INTERSECTION = chr(8898)
N_ARY_UNION = chr(8899)
DIAMOND_OPERATOR = chr(8900)
DOT_OPERATOR = chr(8901)
STAR_OPERATOR = chr(8902)
DIVISION_TIMES = chr(8903)
BOWTIE = chr(8904)
LEFT_NORMAL_FACTOR_SEMIDIRECT_PRODUCT = chr(8905)
RIGHT_NORMAL_FACTOR_SEMIDIRECT_PRODUCT = chr(8906)
LEFT_SEMIDIRECT_PRODUCT = chr(8907)
RIGHT_SEMIDIRECT_PRODUCT = chr(8908)
REVERSED_TILDE_EQUALS = chr(8909)
CURLY_LOGICAL_OR = chr(8910)
CURLY_LOGICAL_AND = chr(8911)
DOUBLE_SUBSET = chr(8912)
DOUBLE_SUPERSET = chr(8913)
DOUBLE_INTERSECTION = chr(8914)
DOUBLE_UNION = chr(8915)
PITCHFORK = chr(8916)
EQUAL_AND_PARALLEL_TO = chr(8917)
LESS_THAN_WITH_DOT = chr(8918)
GREATER_THAN_WITH_DOT = chr(8919)
VERY_MUCH_LESS_THAN = chr(8920)
VERY_MUCH_GREATER_THAN = chr(8921)
LESS_THAN_EQUAL_TO_OR_GREATER_THAN = chr(8922)
GREATER_THAN_EQUAL_TO_OR_LESS_THAN = chr(8923)
EQUAL_TO_OR_LESS_THAN = chr(8924)
EQUAL_TO_OR_GREATER_THAN = chr(8925)
EQUAL_TO_OR_PRECEDES = chr(8926)
EQUAL_TO_OR_SUCCEEDS = chr(8927)
DOES_NOT_PRECEDE_OR_EQUAL = chr(8928)
DOES_NOT_SUCCEED_OR_EQUAL = chr(8929)
NOT_SQUARE_IMAGE_OF_OR_EQUAL_TO = chr(8930)
NOT_SQUARE_ORIGINAL_OF_OR_EQUAL_TO = chr(8931)
SQUARE_IMAGE_OF_OR_NOT_EQUAL_TO = chr(8932)
SQUARE_ORIGINAL_OF_OR_NOT_EQUAL_TO = chr(8933)
LESS_THAN_BUT_NOT_EQUIVALENT_TO = chr(8934)
GREATER_THAN_BUT_NOT_EQUIVALENT_TO = chr(8935)
PRECEDES_BUT_NOT_EQUIVALENT_TO = chr(8936)
SUCCEEDS_BUT_NOT_EQUIVALENT_TO = chr(8937)
NOT_NORMAL_SUBGROUP_OF = chr(8938)
DOES_NOT_CONTAIN_AS_NORMAL_SUBGROUP = chr(8939)
NOT_NORMAL_SUBGROUP_OF_OR_EQUAL_TO = chr(8940)
DOES_NOT_CONTAIN_AS_NORMAL_SUBGROUP_OR_EQUAL = chr(8941)
VERTICAL_ELLIPSIS = chr(8942)
MIDLINE_HORIZONTAL_ELLIPSIS = chr(8943)
UP_RIGHT_DIAGONAL_ELLIPSIS = chr(8944)
DOWN_RIGHT_DIAGONAL_ELLIPSIS = chr(8945)
ELEMENT_OF_WITH_LONG_HORIZONTAL_STROKE = chr(8946)
ELEMENT_OF_WITH_VERTICAL_BAR_AT_END_OF_HORIZONTAL_STROKE = chr(8947)
SMALL_ELEMENT_OF_WITH_VERTICAL_BAR_AT_END_OF_HORIZONTAL_STROKE = chr(8948)
ELEMENT_OF_WITH_DOT_ABOVE = chr(8949)
ELEMENT_OF_WITH_OVERBAR = chr(8950)
SMALL_ELEMENT_OF_WITH_OVERBAR = chr(8951)
ELEMENT_OF_WITH_UNDERBAR = chr(8952)
ELEMENT_OF_WITH_TWO_HORIZONTAL_STROKES = chr(8953)
CONTAINS_WITH_LONG_HORIZONTAL_STROKE = chr(8954)
CONTAINS_WITH_VERTICAL_BAR_AT_END_OF_HORIZONTAL_STROKE = chr(8955)
SMALL_CONTAINS_WITH_VERTICAL_BAR_AT_END_OF_HORIZONTAL_STROKE = chr(8956)
CONTAINS_WITH_OVERBAR = chr(8957)
SMALL_CONTAINS_WITH_OVERBAR = chr(8958)
Z_NOTATION_BAG_MEMBERSHIP = chr(8959)
DIAMETER_SIGN = chr(8960)
ELECTRIC_ARROW = chr(8961)
HOUSE = chr(8962)
UP_ARROWHEAD = chr(8963)
DOWN_ARROWHEAD = chr(8964)
PROJECTIVE = chr(8965)
PERSPECTIVE = chr(8966)
WAVY_LINE = chr(8967)
LEFT_CEILING = chr(8968)
RIGHT_CEILING = chr(8969)
LEFT_FLOOR = chr(8970)
RIGHT_FLOOR = chr(8971)
BOTTOM_RIGHT_CROP = chr(8972)
BOTTOM_LEFT_CROP = chr(8973)
TOP_RIGHT_CROP = chr(8974)
TOP_LEFT_CROP = chr(8975)
REVERSED_NOT_SIGN = chr(8976)
SQUARE_LOZENGE = chr(8977)
ARC = chr(8978)
SEGMENT = chr(8979)
SECTOR = chr(8980)
TELEPHONE_RECORDER = chr(8981)
POSITION_INDICATOR = chr(8982)
VIEWDATA_SQUARE = chr(8983)
PLACE_OF_INTEREST_SIGN = chr(8984)
TURNED_NOT_SIGN = chr(8985)
WATCH = chr(8986)
HOURGLASS = chr(8987)
TOP_LEFT_CORNER = chr(8988)
TOP_RIGHT_CORNER = chr(8989)
BOTTOM_LEFT_CORNER = chr(8990)
BOTTOM_RIGHT_CORNER = chr(8991)
TOP_HALF_INTEGRAL = chr(8992)
BOTTOM_HALF_INTEGRAL = chr(8993)
FROWN = chr(8994)
SMILE = chr(8995)
UP_ARROWHEAD_BETWEEN_TWO_HORIZONTAL_BARS = chr(8996)
OPTION_KEY = chr(8997)
ERASE_TO_THE_RIGHT = chr(8998)
X_IN_A_RECTANGLE_BOX = chr(8999)
KEYBOARD = chr(9000)
LEFT_POINTING_ANGLE_BRACKET = chr(9001)
RIGHT_POINTING_ANGLE_BRACKET = chr(9002)
ERASE_TO_THE_LEFT = chr(9003)
BENZENE_RING = chr(9004)
CYLINDRICITY = chr(9005)
ALL_AROUND_PROFILE = chr(9006)
SYMMETRY = chr(9007)
TOTAL_RUNOUT = chr(9008)
DIMENSION_ORIGIN = chr(9009)
CONICAL_TAPER = chr(9010)
SLOPE = chr(9011)
COUNTERBORE = chr(9012)
COUNTERSINK = chr(9013)
APL_FUNCTIONAL_SYMBOL_I_BEAM = chr(9014)
APL_FUNCTIONAL_SYMBOL_SQUISH_QUAD = chr(9015)
APL_FUNCTIONAL_SYMBOL_QUAD_EQUAL = chr(9016)
APL_FUNCTIONAL_SYMBOL_QUAD_DIVIDE = chr(9017)
APL_FUNCTIONAL_SYMBOL_QUAD_DIAMOND = chr(9018)
APL_FUNCTIONAL_SYMBOL_QUAD_JOT = chr(9019)
APL_FUNCTIONAL_SYMBOL_QUAD_CIRCLE = chr(9020)
APL_FUNCTIONAL_SYMBOL_CIRCLE_STILE = chr(9021)
APL_FUNCTIONAL_SYMBOL_CIRCLE_JOT = chr(9022)
APL_FUNCTIONAL_SYMBOL_SLASH_BAR = chr(9023)
APL_FUNCTIONAL_SYMBOL_BACKSLASH_BAR = chr(9024)
APL_FUNCTIONAL_SYMBOL_QUAD_SLASH = chr(9025)
APL_FUNCTIONAL_SYMBOL_QUAD_BACKSLASH = chr(9026)
APL_FUNCTIONAL_SYMBOL_QUAD_LESS_THAN = chr(9027)
APL_FUNCTIONAL_SYMBOL_QUAD_GREATER_THAN = chr(9028)
APL_FUNCTIONAL_SYMBOL_LEFTWARDS_VANE = chr(9029)
APL_FUNCTIONAL_SYMBOL_RIGHTWARDS_VANE = chr(9030)
APL_FUNCTIONAL_SYMBOL_QUAD_LEFTWARDS_ARROW = chr(9031)
APL_FUNCTIONAL_SYMBOL_QUAD_RIGHTWARDS_ARROW = chr(9032)
APL_FUNCTIONAL_SYMBOL_CIRCLE_BACKSLASH = chr(9033)
APL_FUNCTIONAL_SYMBOL_DOWN_TACK_UNDERBAR = chr(9034)
APL_FUNCTIONAL_SYMBOL_DELTA_STILE = chr(9035)
APL_FUNCTIONAL_SYMBOL_QUAD_DOWN_CARET = chr(9036)
APL_FUNCTIONAL_SYMBOL_QUAD_DELTA = chr(9037)
APL_FUNCTIONAL_SYMBOL_DOWN_TACK_JOT = chr(9038)
APL_FUNCTIONAL_SYMBOL_UPWARDS_VANE = chr(9039)
APL_FUNCTIONAL_SYMBOL_QUAD_UPWARDS_ARROW = chr(9040)
APL_FUNCTIONAL_SYMBOL_UP_TACK_OVERBAR = chr(9041)
APL_FUNCTIONAL_SYMBOL_DEL_STILE = chr(9042)
APL_FUNCTIONAL_SYMBOL_QUAD_UP_CARET = chr(9043)
APL_FUNCTIONAL_SYMBOL_QUAD_DEL = chr(9044)
APL_FUNCTIONAL_SYMBOL_UP_TACK_JOT = chr(9045)
APL_FUNCTIONAL_SYMBOL_DOWNWARDS_VANE = chr(9046)
APL_FUNCTIONAL_SYMBOL_QUAD_DOWNWARDS_ARROW = chr(9047)
APL_FUNCTIONAL_SYMBOL_QUOTE_UNDERBAR = chr(9048)
APL_FUNCTIONAL_SYMBOL_DELTA_UNDERBAR = chr(9049)
APL_FUNCTIONAL_SYMBOL_DIAMOND_UNDERBAR = chr(9050)
APL_FUNCTIONAL_SYMBOL_JOT_UNDERBAR = chr(9051)
APL_FUNCTIONAL_SYMBOL_CIRCLE_UNDERBAR = chr(9052)
APL_FUNCTIONAL_SYMBOL_UP_SHOE_JOT = chr(9053)
APL_FUNCTIONAL_SYMBOL_QUOTE_QUAD = chr(9054)
APL_FUNCTIONAL_SYMBOL_CIRCLE_STAR = chr(9055)
APL_FUNCTIONAL_SYMBOL_QUAD_COLON = chr(9056)
APL_FUNCTIONAL_SYMBOL_UP_TACK_DIAERESIS = chr(9057)
APL_FUNCTIONAL_SYMBOL_DEL_DIAERESIS = chr(9058)
APL_FUNCTIONAL_SYMBOL_STAR_DIAERESIS = chr(9059)
APL_FUNCTIONAL_SYMBOL_JOT_DIAERESIS = chr(9060)
APL_FUNCTIONAL_SYMBOL_CIRCLE_DIAERESIS = chr(9061)
APL_FUNCTIONAL_SYMBOL_DOWN_SHOE_STILE = chr(9062)
APL_FUNCTIONAL_SYMBOL_LEFT_SHOE_STILE = chr(9063)
APL_FUNCTIONAL_SYMBOL_TILDE_DIAERESIS = chr(9064)
APL_FUNCTIONAL_SYMBOL_GREATER_THAN_DIAERESIS = chr(9065)
APL_FUNCTIONAL_SYMBOL_COMMA_BAR = chr(9066)
APL_FUNCTIONAL_SYMBOL_DEL_TILDE = chr(9067)
APL_FUNCTIONAL_SYMBOL_ZILDE = chr(9068)
APL_FUNCTIONAL_SYMBOL_STILE_TILDE = chr(9069)
APL_FUNCTIONAL_SYMBOL_SEMICOLON_UNDERBAR = chr(9070)
APL_FUNCTIONAL_SYMBOL_QUAD_NOT_EQUAL = chr(9071)
APL_FUNCTIONAL_SYMBOL_QUAD_QUESTION = chr(9072)
APL_FUNCTIONAL_SYMBOL_DOWN_CARET_TILDE = chr(9073)
APL_FUNCTIONAL_SYMBOL_UP_CARET_TILDE = chr(9074)
APL_FUNCTIONAL_SYMBOL_IOTA = chr(9075)
APL_FUNCTIONAL_SYMBOL_RHO = chr(9076)
APL_FUNCTIONAL_SYMBOL_OMEGA = chr(9077)
APL_FUNCTIONAL_SYMBOL_ALPHA_UNDERBAR = chr(9078)
APL_FUNCTIONAL_SYMBOL_EPSILON_UNDERBAR = chr(9079)
APL_FUNCTIONAL_SYMBOL_IOTA_UNDERBAR = chr(9080)
APL_FUNCTIONAL_SYMBOL_OMEGA_UNDERBAR = chr(9081)
APL_FUNCTIONAL_SYMBOL_ALPHA = chr(9082)
NOT_CHECK_MARK = chr(9083)
RIGHT_ANGLE_WITH_DOWNWARDS_ZIGZAG_ARROW = chr(9084)
SHOULDERED_OPEN_BOX = chr(9085)
BELL_SYMBOL = chr(9086)
VERTICAL_LINE_WITH_MIDDLE_DOT = chr(9087)
INSERTION_SYMBOL = chr(9088)
CONTINUOUS_UNDERLINE_SYMBOL = chr(9089)
DISCONTINUOUS_UNDERLINE_SYMBOL = chr(9090)
EMPHASIS_SYMBOL = chr(9091)
COMPOSITION_SYMBOL = chr(9092)
WHITE_SQUARE_WITH_CENTRE_VERTICAL_LINE = chr(9093)
ENTER_SYMBOL = chr(9094)
ALTERNATIVE_KEY_SYMBOL = chr(9095)
HELM_SYMBOL = chr(9096)
CIRCLED_HORIZONTAL_BAR_WITH_NOTCH = chr(9097)
CIRCLED_TRIANGLE_DOWN = chr(9098)
BROKEN_CIRCLE_WITH_NORTHWEST_ARROW = chr(9099)
UNDO_SYMBOL = chr(9100)
MONOSTABLE_SYMBOL = chr(9101)
HYSTERESIS_SYMBOL = chr(9102)
OPEN_CIRCUIT_OUTPUT_H_TYPE_SYMBOL = chr(9103)
OPEN_CIRCUIT_OUTPUT_L_TYPE_SYMBOL = chr(9104)
PASSIVE_PULL_DOWN_OUTPUT_SYMBOL = chr(9105)
PASSIVE_PULL_UP_OUTPUT_SYMBOL = chr(9106)
DIRECT_CURRENT_SYMBOL_FORM_TWO = chr(9107)
SOFTWARE_FUNCTION_SYMBOL = chr(9108)
APL_FUNCTIONAL_SYMBOL_QUAD = chr(9109)
DECIMAL_SEPARATOR_KEY_SYMBOL = chr(9110)
PREVIOUS_PAGE = chr(9111)
NEXT_PAGE = chr(9112)
PRINT_SCREEN_SYMBOL = chr(9113)
CLEAR_SCREEN_SYMBOL = chr(9114)
LEFT_PARENTHESIS_UPPER_HOOK = chr(9115)
LEFT_PARENTHESIS_EXTENSION = chr(9116)
LEFT_PARENTHESIS_LOWER_HOOK = chr(9117)
RIGHT_PARENTHESIS_UPPER_HOOK = chr(9118)
RIGHT_PARENTHESIS_EXTENSION = chr(9119)
RIGHT_PARENTHESIS_LOWER_HOOK = chr(9120)
LEFT_SQUARE_BRACKET_UPPER_CORNER = chr(9121)
LEFT_SQUARE_BRACKET_EXTENSION = chr(9122)
LEFT_SQUARE_BRACKET_LOWER_CORNER = chr(9123)
RIGHT_SQUARE_BRACKET_UPPER_CORNER = chr(9124)
RIGHT_SQUARE_BRACKET_EXTENSION = chr(9125)
RIGHT_SQUARE_BRACKET_LOWER_CORNER = chr(9126)
LEFT_CURLY_BRACKET_UPPER_HOOK = chr(9127)
LEFT_CURLY_BRACKET_MIDDLE_PIECE = chr(9128)
LEFT_CURLY_BRACKET_LOWER_HOOK = chr(9129)
CURLY_BRACKET_EXTENSION = chr(9130)
RIGHT_CURLY_BRACKET_UPPER_HOOK = chr(9131)
RIGHT_CURLY_BRACKET_MIDDLE_PIECE = chr(9132)
RIGHT_CURLY_BRACKET_LOWER_HOOK = chr(9133)
INTEGRAL_EXTENSION = chr(9134)
HORIZONTAL_LINE_EXTENSION = chr(9135)
UPPER_LEFT_OR_LOWER_RIGHT_CURLY_BRACKET_SECTION = chr(9136)
UPPER_RIGHT_OR_LOWER_LEFT_CURLY_BRACKET_SECTION = chr(9137)
SUMMATION_TOP = chr(9138)
SUMMATION_BOTTOM = chr(9139)
TOP_SQUARE_BRACKET = chr(9140)
BOTTOM_SQUARE_BRACKET = chr(9141)
BOTTOM_SQUARE_BRACKET_OVER_TOP_SQUARE_BRACKET = chr(9142)
RADICAL_SYMBOL_BOTTOM = chr(9143)
LEFT_VERTICAL_BOX_LINE = chr(9144)
RIGHT_VERTICAL_BOX_LINE = chr(9145)
HORIZONTAL_SCAN_LINE_1 = chr(9146)
HORIZONTAL_SCAN_LINE_3 = chr(9147)
HORIZONTAL_SCAN_LINE_7 = chr(9148)
HORIZONTAL_SCAN_LINE_9 = chr(9149)
DENTISTRY_SYMBOL_LIGHT_VERTICAL_AND_TOP_RIGHT = chr(9150)
DENTISTRY_SYMBOL_LIGHT_VERTICAL_AND_BOTTOM_RIGHT = chr(9151)
DENTISTRY_SYMBOL_LIGHT_VERTICAL_WITH_CIRCLE = chr(9152)
DENTISTRY_SYMBOL_LIGHT_DOWN_AND_HORIZONTAL_WITH_CIRCLE = chr(9153)
DENTISTRY_SYMBOL_LIGHT_UP_AND_HORIZONTAL_WITH_CIRCLE = chr(9154)
DENTISTRY_SYMBOL_LIGHT_VERTICAL_WITH_TRIANGLE = chr(9155)
DENTISTRY_SYMBOL_LIGHT_DOWN_AND_HORIZONTAL_WITH_TRIANGLE = chr(9156)
DENTISTRY_SYMBOL_LIGHT_UP_AND_HORIZONTAL_WITH_TRIANGLE = chr(9157)
DENTISTRY_SYMBOL_LIGHT_VERTICAL_AND_WAVE = chr(9158)
DENTISTRY_SYMBOL_LIGHT_DOWN_AND_HORIZONTAL_WITH_WAVE = chr(9159)
DENTISTRY_SYMBOL_LIGHT_UP_AND_HORIZONTAL_WITH_WAVE = chr(9160)
DENTISTRY_SYMBOL_LIGHT_DOWN_AND_HORIZONTAL = chr(9161)
DENTISTRY_SYMBOL_LIGHT_UP_AND_HORIZONTAL = chr(9162)
DENTISTRY_SYMBOL_LIGHT_VERTICAL_AND_TOP_LEFT = chr(9163)
DENTISTRY_SYMBOL_LIGHT_VERTICAL_AND_BOTTOM_LEFT = chr(9164)
SQUARE_FOOT = chr(9165)
RETURN_SYMBOL = chr(9166)
EJECT_SYMBOL = chr(9167)
VERTICAL_LINE_EXTENSION = chr(9168)
METRICAL_BREVE = chr(9169)
METRICAL_LONG_OVER_SHORT = chr(9170)
METRICAL_SHORT_OVER_LONG = chr(9171)
METRICAL_LONG_OVER_TWO_SHORTS = chr(9172)
METRICAL_TWO_SHORTS_OVER_LONG = chr(9173)
METRICAL_TWO_SHORTS_JOINED = chr(9174)
METRICAL_TRISEME = chr(9175)
METRICAL_TETRASEME = chr(9176)
METRICAL_PENTASEME = chr(9177)
EARTH_GROUND = chr(9178)
FUSE = chr(9179)
TOP_PARENTHESIS = chr(9180)
BOTTOM_PARENTHESIS = chr(9181)
TOP_CURLY_BRACKET = chr(9182)
BOTTOM_CURLY_BRACKET = chr(9183)
TOP_TORTOISE_SHELL_BRACKET = chr(9184)
BOTTOM_TORTOISE_SHELL_BRACKET = chr(9185)
WHITE_TRAPEZIUM = chr(9186)
BENZENE_RING_WITH_CIRCLE = chr(9187)
STRAIGHTNESS = chr(9188)
FLATNESS = chr(9189)
AC_CURRENT = chr(9190)
ELECTRICAL_INTERSECTION = chr(9191)
DECIMAL_EXPONENT_SYMBOL = chr(9192)
BLACK_RIGHT_POINTING_DOUBLE_TRIANGLE = chr(9193)
BLACK_LEFT_POINTING_DOUBLE_TRIANGLE = chr(9194)
BLACK_UP_POINTING_DOUBLE_TRIANGLE = chr(9195)
BLACK_DOWN_POINTING_DOUBLE_TRIANGLE = chr(9196)
BLACK_RIGHT_POINTING_DOUBLE_TRIANGLE_WITH_VERTICAL_BAR = chr(9197)
BLACK_LEFT_POINTING_DOUBLE_TRIANGLE_WITH_VERTICAL_BAR = chr(9198)
BLACK_RIGHT_POINTING_TRIANGLE_WITH_DOUBLE_VERTICAL_BAR = chr(9199)
ALARM_CLOCK = chr(9200)
STOPWATCH = chr(9201)
TIMER_CLOCK = chr(9202)
HOURGLASS_WITH_FLOWING_SAND = chr(9203)
BLACK_MEDIUM_LEFT_POINTING_TRIANGLE = chr(9204)
BLACK_MEDIUM_RIGHT_POINTING_TRIANGLE = chr(9205)
BLACK_MEDIUM_UP_POINTING_TRIANGLE = chr(9206)
BLACK_MEDIUM_DOWN_POINTING_TRIANGLE = chr(9207)
DOUBLE_VERTICAL_BAR = chr(9208)
BLACK_SQUARE_FOR_STOP = chr(9209)
BLACK_CIRCLE_FOR_RECORD = chr(9210)
POWER_SYMBOL = chr(9211)
POWER_ON_OFF_SYMBOL = chr(9212)
POWER_ON_SYMBOL = chr(9213)
POWER_SLEEP_SYMBOL = chr(9214)
OBSERVER_EYE_SYMBOL = chr(9215)
SYMBOL_FOR_NULL = chr(9216)
SYMBOL_FOR_START_OF_HEADING = chr(9217)
SYMBOL_FOR_START_OF_TEXT = chr(9218)
SYMBOL_FOR_END_OF_TEXT = chr(9219)
SYMBOL_FOR_END_OF_TRANSMISSION = chr(9220)
SYMBOL_FOR_ENQUIRY = chr(9221)
SYMBOL_FOR_ACKNOWLEDGE = chr(9222)
SYMBOL_FOR_BELL = chr(9223)
SYMBOL_FOR_BACKSPACE = chr(9224)
SYMBOL_FOR_HORIZONTAL_TABULATION = chr(9225)
SYMBOL_FOR_LINE_FEED = chr(9226)
SYMBOL_FOR_VERTICAL_TABULATION = chr(9227)
SYMBOL_FOR_FORM_FEED = chr(9228)
SYMBOL_FOR_CARRIAGE_RETURN = chr(9229)
SYMBOL_FOR_SHIFT_OUT = chr(9230)
SYMBOL_FOR_SHIFT_IN = chr(9231)
SYMBOL_FOR_DATA_LINK_ESCAPE = chr(9232)
SYMBOL_FOR_DEVICE_CONTROL_ONE = chr(9233)
SYMBOL_FOR_DEVICE_CONTROL_TWO = chr(9234)
SYMBOL_FOR_DEVICE_CONTROL_THREE = chr(9235)
SYMBOL_FOR_DEVICE_CONTROL_FOUR = chr(9236)
SYMBOL_FOR_NEGATIVE_ACKNOWLEDGE = chr(9237)
SYMBOL_FOR_SYNCHRONOUS_IDLE = chr(9238)
SYMBOL_FOR_END_OF_TRANSMISSION_BLOCK = chr(9239)
SYMBOL_FOR_CANCEL = chr(9240)
SYMBOL_FOR_END_OF_MEDIUM = chr(9241)
SYMBOL_FOR_SUBSTITUTE = chr(9242)
SYMBOL_FOR_ESCAPE = chr(9243)
SYMBOL_FOR_FILE_SEPARATOR = chr(9244)
SYMBOL_FOR_GROUP_SEPARATOR = chr(9245)
SYMBOL_FOR_RECORD_SEPARATOR = chr(9246)
SYMBOL_FOR_UNIT_SEPARATOR = chr(9247)
SYMBOL_FOR_SPACE = chr(9248)
SYMBOL_FOR_DELETE = chr(9249)
BLANK_SYMBOL = chr(9250)
OPEN_BOX = chr(9251)
SYMBOL_FOR_NEWLINE = chr(9252)
SYMBOL_FOR_DELETE_FORM_TWO = chr(9253)
SYMBOL_FOR_SUBSTITUTE_FORM_TWO = chr(9254)
OCR_HOOK = chr(9280)
OCR_CHAIR = chr(9281)
OCR_FORK = chr(9282)
OCR_INVERTED_FORK = chr(9283)
OCR_BELT_BUCKLE = chr(9284)
OCR_BOW_TIE = chr(9285)
OCR_BRANCH_BANK_IDENTIFICATION = chr(9286)
OCR_AMOUNT_OF_CHECK = chr(9287)
OCR_DASH = chr(9288)
OCR_CUSTOMER_ACCOUNT_NUMBER = chr(9289)
OCR_DOUBLE_BACKSLASH = chr(9290)
CIRCLED_DIGIT_ONE = chr(9312)
CIRCLED_DIGIT_TWO = chr(9313)
CIRCLED_DIGIT_THREE = chr(9314)
CIRCLED_DIGIT_FOUR = chr(9315)
CIRCLED_DIGIT_FIVE = chr(9316)
CIRCLED_DIGIT_SIX = chr(9317)
CIRCLED_DIGIT_SEVEN = chr(9318)
CIRCLED_DIGIT_EIGHT = chr(9319)
CIRCLED_DIGIT_NINE = chr(9320)
CIRCLED_NUMBER_TEN = chr(9321)
CIRCLED_NUMBER_ELEVEN = chr(9322)
CIRCLED_NUMBER_TWELVE = chr(9323)
CIRCLED_NUMBER_THIRTEEN = chr(9324)
CIRCLED_NUMBER_FOURTEEN = chr(9325)
CIRCLED_NUMBER_FIFTEEN = chr(9326)
CIRCLED_NUMBER_SIXTEEN = chr(9327)
CIRCLED_NUMBER_SEVENTEEN = chr(9328)
CIRCLED_NUMBER_EIGHTEEN = chr(9329)
CIRCLED_NUMBER_NINETEEN = chr(9330)
CIRCLED_NUMBER_TWENTY = chr(9331)
PARENTHESIZED_DIGIT_ONE = chr(9332)
PARENTHESIZED_DIGIT_TWO = chr(9333)
PARENTHESIZED_DIGIT_THREE = chr(9334)
PARENTHESIZED_DIGIT_FOUR = chr(9335)
PARENTHESIZED_DIGIT_FIVE = chr(9336)
PARENTHESIZED_DIGIT_SIX = chr(9337)
PARENTHESIZED_DIGIT_SEVEN = chr(9338)
PARENTHESIZED_DIGIT_EIGHT = chr(9339)
PARENTHESIZED_DIGIT_NINE = chr(9340)
PARENTHESIZED_NUMBER_TEN = chr(9341)
PARENTHESIZED_NUMBER_ELEVEN = chr(9342)
PARENTHESIZED_NUMBER_TWELVE = chr(9343)
PARENTHESIZED_NUMBER_THIRTEEN = chr(9344)
PARENTHESIZED_NUMBER_FOURTEEN = chr(9345)
PARENTHESIZED_NUMBER_FIFTEEN = chr(9346)
PARENTHESIZED_NUMBER_SIXTEEN = chr(9347)
PARENTHESIZED_NUMBER_SEVENTEEN = chr(9348)
PARENTHESIZED_NUMBER_EIGHTEEN = chr(9349)
PARENTHESIZED_NUMBER_NINETEEN = chr(9350)
PARENTHESIZED_NUMBER_TWENTY = chr(9351)
DIGIT_ONE_FULL_STOP = chr(9352)
DIGIT_TWO_FULL_STOP = chr(9353)
DIGIT_THREE_FULL_STOP = chr(9354)
DIGIT_FOUR_FULL_STOP = chr(9355)
DIGIT_FIVE_FULL_STOP = chr(9356)
DIGIT_SIX_FULL_STOP = chr(9357)
DIGIT_SEVEN_FULL_STOP = chr(9358)
DIGIT_EIGHT_FULL_STOP = chr(9359)
DIGIT_NINE_FULL_STOP = chr(9360)
NUMBER_TEN_FULL_STOP = chr(9361)
NUMBER_ELEVEN_FULL_STOP = chr(9362)
NUMBER_TWELVE_FULL_STOP = chr(9363)
NUMBER_THIRTEEN_FULL_STOP = chr(9364)
NUMBER_FOURTEEN_FULL_STOP = chr(9365)
NUMBER_FIFTEEN_FULL_STOP = chr(9366)
NUMBER_SIXTEEN_FULL_STOP = chr(9367)
NUMBER_SEVENTEEN_FULL_STOP = chr(9368)
NUMBER_EIGHTEEN_FULL_STOP = chr(9369)
NUMBER_NINETEEN_FULL_STOP = chr(9370)
NUMBER_TWENTY_FULL_STOP = chr(9371)
PARENTHESIZED_LATIN_SMALL_LETTER_A = chr(9372)
PARENTHESIZED_LATIN_SMALL_LETTER_B = chr(9373)
PARENTHESIZED_LATIN_SMALL_LETTER_C = chr(9374)
PARENTHESIZED_LATIN_SMALL_LETTER_D = chr(9375)
PARENTHESIZED_LATIN_SMALL_LETTER_E = chr(9376)
PARENTHESIZED_LATIN_SMALL_LETTER_F = chr(9377)
PARENTHESIZED_LATIN_SMALL_LETTER_G = chr(9378)
PARENTHESIZED_LATIN_SMALL_LETTER_H = chr(9379)
PARENTHESIZED_LATIN_SMALL_LETTER_I = chr(9380)
PARENTHESIZED_LATIN_SMALL_LETTER_J = chr(9381)
PARENTHESIZED_LATIN_SMALL_LETTER_K = chr(9382)
PARENTHESIZED_LATIN_SMALL_LETTER_L = chr(9383)
PARENTHESIZED_LATIN_SMALL_LETTER_M = chr(9384)
PARENTHESIZED_LATIN_SMALL_LETTER_N = chr(9385)
PARENTHESIZED_LATIN_SMALL_LETTER_O = chr(9386)
PARENTHESIZED_LATIN_SMALL_LETTER_P = chr(9387)
PARENTHESIZED_LATIN_SMALL_LETTER_Q = chr(9388)
PARENTHESIZED_LATIN_SMALL_LETTER_R = chr(9389)
PARENTHESIZED_LATIN_SMALL_LETTER_S = chr(9390)
PARENTHESIZED_LATIN_SMALL_LETTER_T = chr(9391)
PARENTHESIZED_LATIN_SMALL_LETTER_U = chr(9392)
PARENTHESIZED_LATIN_SMALL_LETTER_V = chr(9393)
PARENTHESIZED_LATIN_SMALL_LETTER_W = chr(9394)
PARENTHESIZED_LATIN_SMALL_LETTER_X = chr(9395)
PARENTHESIZED_LATIN_SMALL_LETTER_Y = chr(9396)
PARENTHESIZED_LATIN_SMALL_LETTER_Z = chr(9397)
CIRCLED_LATIN_CAPITAL_LETTER_A = chr(9398)
CIRCLED_LATIN_CAPITAL_LETTER_B = chr(9399)
CIRCLED_LATIN_CAPITAL_LETTER_C = chr(9400)
CIRCLED_LATIN_CAPITAL_LETTER_D = chr(9401)
CIRCLED_LATIN_CAPITAL_LETTER_E = chr(9402)
CIRCLED_LATIN_CAPITAL_LETTER_F = chr(9403)
CIRCLED_LATIN_CAPITAL_LETTER_G = chr(9404)
CIRCLED_LATIN_CAPITAL_LETTER_H = chr(9405)
CIRCLED_LATIN_CAPITAL_LETTER_I = chr(9406)
CIRCLED_LATIN_CAPITAL_LETTER_J = chr(9407)
CIRCLED_LATIN_CAPITAL_LETTER_K = chr(9408)
CIRCLED_LATIN_CAPITAL_LETTER_L = chr(9409)
CIRCLED_LATIN_CAPITAL_LETTER_M = chr(9410)
CIRCLED_LATIN_CAPITAL_LETTER_N = chr(9411)
CIRCLED_LATIN_CAPITAL_LETTER_O = chr(9412)
CIRCLED_LATIN_CAPITAL_LETTER_P = chr(9413)
CIRCLED_LATIN_CAPITAL_LETTER_Q = chr(9414)
CIRCLED_LATIN_CAPITAL_LETTER_R = chr(9415)
CIRCLED_LATIN_CAPITAL_LETTER_S = chr(9416)
CIRCLED_LATIN_CAPITAL_LETTER_T = chr(9417)
CIRCLED_LATIN_CAPITAL_LETTER_U = chr(9418)
CIRCLED_LATIN_CAPITAL_LETTER_V = chr(9419)
CIRCLED_LATIN_CAPITAL_LETTER_W = chr(9420)
CIRCLED_LATIN_CAPITAL_LETTER_X = chr(9421)
CIRCLED_LATIN_CAPITAL_LETTER_Y = chr(9422)
CIRCLED_LATIN_CAPITAL_LETTER_Z = chr(9423)
CIRCLED_LATIN_SMALL_LETTER_A = chr(9424)
CIRCLED_LATIN_SMALL_LETTER_B = chr(9425)
CIRCLED_LATIN_SMALL_LETTER_C = chr(9426)
CIRCLED_LATIN_SMALL_LETTER_D = chr(9427)
CIRCLED_LATIN_SMALL_LETTER_E = chr(9428)
CIRCLED_LATIN_SMALL_LETTER_F = chr(9429)
CIRCLED_LATIN_SMALL_LETTER_G = chr(9430)
CIRCLED_LATIN_SMALL_LETTER_H = chr(9431)
CIRCLED_LATIN_SMALL_LETTER_I = chr(9432)
CIRCLED_LATIN_SMALL_LETTER_J = chr(9433)
CIRCLED_LATIN_SMALL_LETTER_K = chr(9434)
CIRCLED_LATIN_SMALL_LETTER_L = chr(9435)
CIRCLED_LATIN_SMALL_LETTER_M = chr(9436)
CIRCLED_LATIN_SMALL_LETTER_N = chr(9437)
CIRCLED_LATIN_SMALL_LETTER_O = chr(9438)
CIRCLED_LATIN_SMALL_LETTER_P = chr(9439)
CIRCLED_LATIN_SMALL_LETTER_Q = chr(9440)
CIRCLED_LATIN_SMALL_LETTER_R = chr(9441)
CIRCLED_LATIN_SMALL_LETTER_S = chr(9442)
CIRCLED_LATIN_SMALL_LETTER_T = chr(9443)
CIRCLED_LATIN_SMALL_LETTER_U = chr(9444)
CIRCLED_LATIN_SMALL_LETTER_V = chr(9445)
CIRCLED_LATIN_SMALL_LETTER_W = chr(9446)
CIRCLED_LATIN_SMALL_LETTER_X = chr(9447)
CIRCLED_LATIN_SMALL_LETTER_Y = chr(9448)
CIRCLED_LATIN_SMALL_LETTER_Z = chr(9449)
CIRCLED_DIGIT_ZERO = chr(9450)
NEGATIVE_CIRCLED_NUMBER_ELEVEN = chr(9451)
NEGATIVE_CIRCLED_NUMBER_TWELVE = chr(9452)
NEGATIVE_CIRCLED_NUMBER_THIRTEEN = chr(9453)
NEGATIVE_CIRCLED_NUMBER_FOURTEEN = chr(9454)
NEGATIVE_CIRCLED_NUMBER_FIFTEEN = chr(9455)
NEGATIVE_CIRCLED_NUMBER_SIXTEEN = chr(9456)
NEGATIVE_CIRCLED_NUMBER_SEVENTEEN = chr(9457)
NEGATIVE_CIRCLED_NUMBER_EIGHTEEN = chr(9458)
NEGATIVE_CIRCLED_NUMBER_NINETEEN = chr(9459)
NEGATIVE_CIRCLED_NUMBER_TWENTY = chr(9460)
DOUBLE_CIRCLED_DIGIT_ONE = chr(9461)
DOUBLE_CIRCLED_DIGIT_TWO = chr(9462)
DOUBLE_CIRCLED_DIGIT_THREE = chr(9463)
DOUBLE_CIRCLED_DIGIT_FOUR = chr(9464)
DOUBLE_CIRCLED_DIGIT_FIVE = chr(9465)
DOUBLE_CIRCLED_DIGIT_SIX = chr(9466)
DOUBLE_CIRCLED_DIGIT_SEVEN = chr(9467)
DOUBLE_CIRCLED_DIGIT_EIGHT = chr(9468)
DOUBLE_CIRCLED_DIGIT_NINE = chr(9469)
DOUBLE_CIRCLED_NUMBER_TEN = chr(9470)
NEGATIVE_CIRCLED_DIGIT_ZERO = chr(9471)
BOX_DRAWINGS_LIGHT_HORIZONTAL = chr(9472)
BOX_DRAWINGS_HEAVY_HORIZONTAL = chr(9473)
BOX_DRAWINGS_LIGHT_VERTICAL = chr(9474)
BOX_DRAWINGS_HEAVY_VERTICAL = chr(9475)
BOX_DRAWINGS_LIGHT_TRIPLE_DASH_HORIZONTAL = chr(9476)
BOX_DRAWINGS_HEAVY_TRIPLE_DASH_HORIZONTAL = chr(9477)
BOX_DRAWINGS_LIGHT_TRIPLE_DASH_VERTICAL = chr(9478)
BOX_DRAWINGS_HEAVY_TRIPLE_DASH_VERTICAL = chr(9479)
BOX_DRAWINGS_LIGHT_QUADRUPLE_DASH_HORIZONTAL = chr(9480)
BOX_DRAWINGS_HEAVY_QUADRUPLE_DASH_HORIZONTAL = chr(9481)
BOX_DRAWINGS_LIGHT_QUADRUPLE_DASH_VERTICAL = chr(9482)
BOX_DRAWINGS_HEAVY_QUADRUPLE_DASH_VERTICAL = chr(9483)
BOX_DRAWINGS_LIGHT_DOWN_AND_RIGHT = chr(9484)
BOX_DRAWINGS_DOWN_LIGHT_AND_RIGHT_HEAVY = chr(9485)
BOX_DRAWINGS_DOWN_HEAVY_AND_RIGHT_LIGHT = chr(9486)
BOX_DRAWINGS_HEAVY_DOWN_AND_RIGHT = chr(9487)
BOX_DRAWINGS_LIGHT_DOWN_AND_LEFT = chr(9488)
BOX_DRAWINGS_DOWN_LIGHT_AND_LEFT_HEAVY = chr(9489)
BOX_DRAWINGS_DOWN_HEAVY_AND_LEFT_LIGHT = chr(9490)
BOX_DRAWINGS_HEAVY_DOWN_AND_LEFT = chr(9491)
BOX_DRAWINGS_LIGHT_UP_AND_RIGHT = chr(9492)
BOX_DRAWINGS_UP_LIGHT_AND_RIGHT_HEAVY = chr(9493)
BOX_DRAWINGS_UP_HEAVY_AND_RIGHT_LIGHT = chr(9494)
BOX_DRAWINGS_HEAVY_UP_AND_RIGHT = chr(9495)
BOX_DRAWINGS_LIGHT_UP_AND_LEFT = chr(9496)
BOX_DRAWINGS_UP_LIGHT_AND_LEFT_HEAVY = chr(9497)
BOX_DRAWINGS_UP_HEAVY_AND_LEFT_LIGHT = chr(9498)
BOX_DRAWINGS_HEAVY_UP_AND_LEFT = chr(9499)
BOX_DRAWINGS_LIGHT_VERTICAL_AND_RIGHT = chr(9500)
BOX_DRAWINGS_VERTICAL_LIGHT_AND_RIGHT_HEAVY = chr(9501)
BOX_DRAWINGS_UP_HEAVY_AND_RIGHT_DOWN_LIGHT = chr(9502)
BOX_DRAWINGS_DOWN_HEAVY_AND_RIGHT_UP_LIGHT = chr(9503)
BOX_DRAWINGS_VERTICAL_HEAVY_AND_RIGHT_LIGHT = chr(9504)
BOX_DRAWINGS_DOWN_LIGHT_AND_RIGHT_UP_HEAVY = chr(9505)
BOX_DRAWINGS_UP_LIGHT_AND_RIGHT_DOWN_HEAVY = chr(9506)
BOX_DRAWINGS_HEAVY_VERTICAL_AND_RIGHT = chr(9507)
BOX_DRAWINGS_LIGHT_VERTICAL_AND_LEFT = chr(9508)
BOX_DRAWINGS_VERTICAL_LIGHT_AND_LEFT_HEAVY = chr(9509)
BOX_DRAWINGS_UP_HEAVY_AND_LEFT_DOWN_LIGHT = chr(9510)
BOX_DRAWINGS_DOWN_HEAVY_AND_LEFT_UP_LIGHT = chr(9511)
BOX_DRAWINGS_VERTICAL_HEAVY_AND_LEFT_LIGHT = chr(9512)
BOX_DRAWINGS_DOWN_LIGHT_AND_LEFT_UP_HEAVY = chr(9513)
BOX_DRAWINGS_UP_LIGHT_AND_LEFT_DOWN_HEAVY = chr(9514)
BOX_DRAWINGS_HEAVY_VERTICAL_AND_LEFT = chr(9515)
BOX_DRAWINGS_LIGHT_DOWN_AND_HORIZONTAL = chr(9516)
BOX_DRAWINGS_LEFT_HEAVY_AND_RIGHT_DOWN_LIGHT = chr(9517)
BOX_DRAWINGS_RIGHT_HEAVY_AND_LEFT_DOWN_LIGHT = chr(9518)
BOX_DRAWINGS_DOWN_LIGHT_AND_HORIZONTAL_HEAVY = chr(9519)
BOX_DRAWINGS_DOWN_HEAVY_AND_HORIZONTAL_LIGHT = chr(9520)
BOX_DRAWINGS_RIGHT_LIGHT_AND_LEFT_DOWN_HEAVY = chr(9521)
BOX_DRAWINGS_LEFT_LIGHT_AND_RIGHT_DOWN_HEAVY = chr(9522)
BOX_DRAWINGS_HEAVY_DOWN_AND_HORIZONTAL = chr(9523)
BOX_DRAWINGS_LIGHT_UP_AND_HORIZONTAL = chr(9524)
BOX_DRAWINGS_LEFT_HEAVY_AND_RIGHT_UP_LIGHT = chr(9525)
BOX_DRAWINGS_RIGHT_HEAVY_AND_LEFT_UP_LIGHT = chr(9526)
BOX_DRAWINGS_UP_LIGHT_AND_HORIZONTAL_HEAVY = chr(9527)
BOX_DRAWINGS_UP_HEAVY_AND_HORIZONTAL_LIGHT = chr(9528)
BOX_DRAWINGS_RIGHT_LIGHT_AND_LEFT_UP_HEAVY = chr(9529)
BOX_DRAWINGS_LEFT_LIGHT_AND_RIGHT_UP_HEAVY = chr(9530)
BOX_DRAWINGS_HEAVY_UP_AND_HORIZONTAL = chr(9531)
BOX_DRAWINGS_LIGHT_VERTICAL_AND_HORIZONTAL = chr(9532)
BOX_DRAWINGS_LEFT_HEAVY_AND_RIGHT_VERTICAL_LIGHT = chr(9533)
BOX_DRAWINGS_RIGHT_HEAVY_AND_LEFT_VERTICAL_LIGHT = chr(9534)
BOX_DRAWINGS_VERTICAL_LIGHT_AND_HORIZONTAL_HEAVY = chr(9535)
BOX_DRAWINGS_UP_HEAVY_AND_DOWN_HORIZONTAL_LIGHT = chr(9536)
BOX_DRAWINGS_DOWN_HEAVY_AND_UP_HORIZONTAL_LIGHT = chr(9537)
BOX_DRAWINGS_VERTICAL_HEAVY_AND_HORIZONTAL_LIGHT = chr(9538)
BOX_DRAWINGS_LEFT_UP_HEAVY_AND_RIGHT_DOWN_LIGHT = chr(9539)
BOX_DRAWINGS_RIGHT_UP_HEAVY_AND_LEFT_DOWN_LIGHT = chr(9540)
BOX_DRAWINGS_LEFT_DOWN_HEAVY_AND_RIGHT_UP_LIGHT = chr(9541)
BOX_DRAWINGS_RIGHT_DOWN_HEAVY_AND_LEFT_UP_LIGHT = chr(9542)
BOX_DRAWINGS_DOWN_LIGHT_AND_UP_HORIZONTAL_HEAVY = chr(9543)
BOX_DRAWINGS_UP_LIGHT_AND_DOWN_HORIZONTAL_HEAVY = chr(9544)
BOX_DRAWINGS_RIGHT_LIGHT_AND_LEFT_VERTICAL_HEAVY = chr(9545)
BOX_DRAWINGS_LEFT_LIGHT_AND_RIGHT_VERTICAL_HEAVY = chr(9546)
BOX_DRAWINGS_HEAVY_VERTICAL_AND_HORIZONTAL = chr(9547)
BOX_DRAWINGS_LIGHT_DOUBLE_DASH_HORIZONTAL = chr(9548)
BOX_DRAWINGS_HEAVY_DOUBLE_DASH_HORIZONTAL = chr(9549)
BOX_DRAWINGS_LIGHT_DOUBLE_DASH_VERTICAL = chr(9550)
BOX_DRAWINGS_HEAVY_DOUBLE_DASH_VERTICAL = chr(9551)
BOX_DRAWINGS_DOUBLE_HORIZONTAL = chr(9552)
BOX_DRAWINGS_DOUBLE_VERTICAL = chr(9553)
BOX_DRAWINGS_DOWN_SINGLE_AND_RIGHT_DOUBLE = chr(9554)
BOX_DRAWINGS_DOWN_DOUBLE_AND_RIGHT_SINGLE = chr(9555)
BOX_DRAWINGS_DOUBLE_DOWN_AND_RIGHT = chr(9556)
BOX_DRAWINGS_DOWN_SINGLE_AND_LEFT_DOUBLE = chr(9557)
BOX_DRAWINGS_DOWN_DOUBLE_AND_LEFT_SINGLE = chr(9558)
BOX_DRAWINGS_DOUBLE_DOWN_AND_LEFT = chr(9559)
BOX_DRAWINGS_UP_SINGLE_AND_RIGHT_DOUBLE = chr(9560)
BOX_DRAWINGS_UP_DOUBLE_AND_RIGHT_SINGLE = chr(9561)
BOX_DRAWINGS_DOUBLE_UP_AND_RIGHT = chr(9562)
BOX_DRAWINGS_UP_SINGLE_AND_LEFT_DOUBLE = chr(9563)
BOX_DRAWINGS_UP_DOUBLE_AND_LEFT_SINGLE = chr(9564)
BOX_DRAWINGS_DOUBLE_UP_AND_LEFT = chr(9565)
BOX_DRAWINGS_VERTICAL_SINGLE_AND_RIGHT_DOUBLE = chr(9566)
BOX_DRAWINGS_VERTICAL_DOUBLE_AND_RIGHT_SINGLE = chr(9567)
BOX_DRAWINGS_DOUBLE_VERTICAL_AND_RIGHT = chr(9568)
BOX_DRAWINGS_VERTICAL_SINGLE_AND_LEFT_DOUBLE = chr(9569)
BOX_DRAWINGS_VERTICAL_DOUBLE_AND_LEFT_SINGLE = chr(9570)
BOX_DRAWINGS_DOUBLE_VERTICAL_AND_LEFT = chr(9571)
BOX_DRAWINGS_DOWN_SINGLE_AND_HORIZONTAL_DOUBLE = chr(9572)
BOX_DRAWINGS_DOWN_DOUBLE_AND_HORIZONTAL_SINGLE = chr(9573)
BOX_DRAWINGS_DOUBLE_DOWN_AND_HORIZONTAL = chr(9574)
BOX_DRAWINGS_UP_SINGLE_AND_HORIZONTAL_DOUBLE = chr(9575)
BOX_DRAWINGS_UP_DOUBLE_AND_HORIZONTAL_SINGLE = chr(9576)
BOX_DRAWINGS_DOUBLE_UP_AND_HORIZONTAL = chr(9577)
BOX_DRAWINGS_VERTICAL_SINGLE_AND_HORIZONTAL_DOUBLE = chr(9578)
BOX_DRAWINGS_VERTICAL_DOUBLE_AND_HORIZONTAL_SINGLE = chr(9579)
BOX_DRAWINGS_DOUBLE_VERTICAL_AND_HORIZONTAL = chr(9580)
BOX_DRAWINGS_LIGHT_ARC_DOWN_AND_RIGHT = chr(9581)
BOX_DRAWINGS_LIGHT_ARC_DOWN_AND_LEFT = chr(9582)
BOX_DRAWINGS_LIGHT_ARC_UP_AND_LEFT = chr(9583)
BOX_DRAWINGS_LIGHT_ARC_UP_AND_RIGHT = chr(9584)
BOX_DRAWINGS_LIGHT_DIAGONAL_UPPER_RIGHT_TO_LOWER_LEFT = chr(9585)
BOX_DRAWINGS_LIGHT_DIAGONAL_UPPER_LEFT_TO_LOWER_RIGHT = chr(9586)
BOX_DRAWINGS_LIGHT_DIAGONAL_CROSS = chr(9587)
BOX_DRAWINGS_LIGHT_LEFT = chr(9588)
BOX_DRAWINGS_LIGHT_UP = chr(9589)
BOX_DRAWINGS_LIGHT_RIGHT = chr(9590)
BOX_DRAWINGS_LIGHT_DOWN = chr(9591)
BOX_DRAWINGS_HEAVY_LEFT = chr(9592)
BOX_DRAWINGS_HEAVY_UP = chr(9593)
BOX_DRAWINGS_HEAVY_RIGHT = chr(9594)
BOX_DRAWINGS_HEAVY_DOWN = chr(9595)
BOX_DRAWINGS_LIGHT_LEFT_AND_HEAVY_RIGHT = chr(9596)
BOX_DRAWINGS_LIGHT_UP_AND_HEAVY_DOWN = chr(9597)
BOX_DRAWINGS_HEAVY_LEFT_AND_LIGHT_RIGHT = chr(9598)
BOX_DRAWINGS_HEAVY_UP_AND_LIGHT_DOWN = chr(9599)
UPPER_HALF_BLOCK = chr(9600)
LOWER_ONE_EIGHTH_BLOCK = chr(9601)
LOWER_ONE_QUARTER_BLOCK = chr(9602)
LOWER_THREE_EIGHTHS_BLOCK = chr(9603)
LOWER_HALF_BLOCK = chr(9604)
LOWER_FIVE_EIGHTHS_BLOCK = chr(9605)
LOWER_THREE_QUARTERS_BLOCK = chr(9606)
LOWER_SEVEN_EIGHTHS_BLOCK = chr(9607)
FULL_BLOCK = chr(9608)
LEFT_SEVEN_EIGHTHS_BLOCK = chr(9609)
LEFT_THREE_QUARTERS_BLOCK = chr(9610)
LEFT_FIVE_EIGHTHS_BLOCK = chr(9611)
LEFT_HALF_BLOCK = chr(9612)
LEFT_THREE_EIGHTHS_BLOCK = chr(9613)
LEFT_ONE_QUARTER_BLOCK = chr(9614)
LEFT_ONE_EIGHTH_BLOCK = chr(9615)
RIGHT_HALF_BLOCK = chr(9616)
LIGHT_SHADE = chr(9617)
MEDIUM_SHADE = chr(9618)
DARK_SHADE = chr(9619)
UPPER_ONE_EIGHTH_BLOCK = chr(9620)
RIGHT_ONE_EIGHTH_BLOCK = chr(9621)
QUADRANT_LOWER_LEFT = chr(9622)
QUADRANT_LOWER_RIGHT = chr(9623)
QUADRANT_UPPER_LEFT = chr(9624)
QUADRANT_UPPER_LEFT_AND_LOWER_LEFT_AND_LOWER_RIGHT = chr(9625)
QUADRANT_UPPER_LEFT_AND_LOWER_RIGHT = chr(9626)
QUADRANT_UPPER_LEFT_AND_UPPER_RIGHT_AND_LOWER_LEFT = chr(9627)
QUADRANT_UPPER_LEFT_AND_UPPER_RIGHT_AND_LOWER_RIGHT = chr(9628)
QUADRANT_UPPER_RIGHT = chr(9629)
QUADRANT_UPPER_RIGHT_AND_LOWER_LEFT = chr(9630)
QUADRANT_UPPER_RIGHT_AND_LOWER_LEFT_AND_LOWER_RIGHT = chr(9631)
BLACK_SQUARE = chr(9632)
WHITE_SQUARE = chr(9633)
WHITE_SQUARE_WITH_ROUNDED_CORNERS = chr(9634)
WHITE_SQUARE_CONTAINING_BLACK_SMALL_SQUARE = chr(9635)
SQUARE_WITH_HORIZONTAL_FILL = chr(9636)
SQUARE_WITH_VERTICAL_FILL = chr(9637)
SQUARE_WITH_ORTHOGONAL_CROSSHATCH_FILL = chr(9638)
SQUARE_WITH_UPPER_LEFT_TO_LOWER_RIGHT_FILL = chr(9639)
SQUARE_WITH_UPPER_RIGHT_TO_LOWER_LEFT_FILL = chr(9640)
SQUARE_WITH_DIAGONAL_CROSSHATCH_FILL = chr(9641)
BLACK_SMALL_SQUARE = chr(9642)
WHITE_SMALL_SQUARE = chr(9643)
BLACK_RECTANGLE = chr(9644)
WHITE_RECTANGLE = chr(9645)
BLACK_VERTICAL_RECTANGLE = chr(9646)
WHITE_VERTICAL_RECTANGLE = chr(9647)
BLACK_PARALLELOGRAM = chr(9648)
WHITE_PARALLELOGRAM = chr(9649)
BLACK_UP_POINTING_TRIANGLE = chr(9650)
WHITE_UP_POINTING_TRIANGLE = chr(9651)
BLACK_UP_POINTING_SMALL_TRIANGLE = chr(9652)
WHITE_UP_POINTING_SMALL_TRIANGLE = chr(9653)
BLACK_RIGHT_POINTING_TRIANGLE = chr(9654)
WHITE_RIGHT_POINTING_TRIANGLE = chr(9655)
BLACK_RIGHT_POINTING_SMALL_TRIANGLE = chr(9656)
WHITE_RIGHT_POINTING_SMALL_TRIANGLE = chr(9657)
BLACK_RIGHT_POINTING_POINTER = chr(9658)
WHITE_RIGHT_POINTING_POINTER = chr(9659)
BLACK_DOWN_POINTING_TRIANGLE = chr(9660)
WHITE_DOWN_POINTING_TRIANGLE = chr(9661)
BLACK_DOWN_POINTING_SMALL_TRIANGLE = chr(9662)
WHITE_DOWN_POINTING_SMALL_TRIANGLE = chr(9663)
BLACK_LEFT_POINTING_TRIANGLE = chr(9664)
WHITE_LEFT_POINTING_TRIANGLE = chr(9665)
BLACK_LEFT_POINTING_SMALL_TRIANGLE = chr(9666)
WHITE_LEFT_POINTING_SMALL_TRIANGLE = chr(9667)
BLACK_LEFT_POINTING_POINTER = chr(9668)
WHITE_LEFT_POINTING_POINTER = chr(9669)
BLACK_DIAMOND = chr(9670)
WHITE_DIAMOND = chr(9671)
WHITE_DIAMOND_CONTAINING_BLACK_SMALL_DIAMOND = chr(9672)
FISHEYE = chr(9673)
LOZENGE = chr(9674)
WHITE_CIRCLE = chr(9675)
DOTTED_CIRCLE = chr(9676)
CIRCLE_WITH_VERTICAL_FILL = chr(9677)
BULLSEYE = chr(9678)
BLACK_CIRCLE = chr(9679)
CIRCLE_WITH_LEFT_HALF_BLACK = chr(9680)
CIRCLE_WITH_RIGHT_HALF_BLACK = chr(9681)
CIRCLE_WITH_LOWER_HALF_BLACK = chr(9682)
CIRCLE_WITH_UPPER_HALF_BLACK = chr(9683)
CIRCLE_WITH_UPPER_RIGHT_QUADRANT_BLACK = chr(9684)
CIRCLE_WITH_ALL_BUT_UPPER_LEFT_QUADRANT_BLACK = chr(9685)
LEFT_HALF_BLACK_CIRCLE = chr(9686)
RIGHT_HALF_BLACK_CIRCLE = chr(9687)
INVERSE_BULLET = chr(9688)
INVERSE_WHITE_CIRCLE = chr(9689)
UPPER_HALF_INVERSE_WHITE_CIRCLE = chr(9690)
LOWER_HALF_INVERSE_WHITE_CIRCLE = chr(9691)
UPPER_LEFT_QUADRANT_CIRCULAR_ARC = chr(9692)
UPPER_RIGHT_QUADRANT_CIRCULAR_ARC = chr(9693)
LOWER_RIGHT_QUADRANT_CIRCULAR_ARC = chr(9694)
LOWER_LEFT_QUADRANT_CIRCULAR_ARC = chr(9695)
UPPER_HALF_CIRCLE = chr(9696)
LOWER_HALF_CIRCLE = chr(9697)
BLACK_LOWER_RIGHT_TRIANGLE = chr(9698)
BLACK_LOWER_LEFT_TRIANGLE = chr(9699)
BLACK_UPPER_LEFT_TRIANGLE = chr(9700)
BLACK_UPPER_RIGHT_TRIANGLE = chr(9701)
WHITE_BULLET = chr(9702)
SQUARE_WITH_LEFT_HALF_BLACK = chr(9703)
SQUARE_WITH_RIGHT_HALF_BLACK = chr(9704)
SQUARE_WITH_UPPER_LEFT_DIAGONAL_HALF_BLACK = chr(9705)
SQUARE_WITH_LOWER_RIGHT_DIAGONAL_HALF_BLACK = chr(9706)
WHITE_SQUARE_WITH_VERTICAL_BISECTING_LINE = chr(9707)
WHITE_UP_POINTING_TRIANGLE_WITH_DOT = chr(9708)
UP_POINTING_TRIANGLE_WITH_LEFT_HALF_BLACK = chr(9709)
UP_POINTING_TRIANGLE_WITH_RIGHT_HALF_BLACK = chr(9710)
LARGE_CIRCLE = chr(9711)
WHITE_SQUARE_WITH_UPPER_LEFT_QUADRANT = chr(9712)
WHITE_SQUARE_WITH_LOWER_LEFT_QUADRANT = chr(9713)
WHITE_SQUARE_WITH_LOWER_RIGHT_QUADRANT = chr(9714)
WHITE_SQUARE_WITH_UPPER_RIGHT_QUADRANT = chr(9715)
WHITE_CIRCLE_WITH_UPPER_LEFT_QUADRANT = chr(9716)
WHITE_CIRCLE_WITH_LOWER_LEFT_QUADRANT = chr(9717)
WHITE_CIRCLE_WITH_LOWER_RIGHT_QUADRANT = chr(9718)
WHITE_CIRCLE_WITH_UPPER_RIGHT_QUADRANT = chr(9719)
UPPER_LEFT_TRIANGLE = chr(9720)
UPPER_RIGHT_TRIANGLE = chr(9721)
LOWER_LEFT_TRIANGLE = chr(9722)
WHITE_MEDIUM_SQUARE = chr(9723)
BLACK_MEDIUM_SQUARE = chr(9724)
WHITE_MEDIUM_SMALL_SQUARE = chr(9725)
BLACK_MEDIUM_SMALL_SQUARE = chr(9726)
LOWER_RIGHT_TRIANGLE = chr(9727)
BLACK_SUN_WITH_RAYS = chr(9728)
CLOUD = chr(9729)
UMBRELLA = chr(9730)
SNOWMAN = chr(9731)
COMET = chr(9732)
BLACK_STAR = chr(9733)
WHITE_STAR = chr(9734)
LIGHTNING = chr(9735)
THUNDERSTORM = chr(9736)
SUN = chr(9737)
ASCENDING_NODE = chr(9738)
DESCENDING_NODE = chr(9739)
CONJUNCTION = chr(9740)
OPPOSITION = chr(9741)
BLACK_TELEPHONE = chr(9742)
WHITE_TELEPHONE = chr(9743)
BALLOT_BOX = chr(9744)
BALLOT_BOX_WITH_CHECK = chr(9745)
BALLOT_BOX_WITH_X = chr(9746)
SALTIRE = chr(9747)
UMBRELLA_WITH_RAIN_DROPS = chr(9748)
HOT_BEVERAGE = chr(9749)
WHITE_SHOGI_PIECE = chr(9750)
BLACK_SHOGI_PIECE = chr(9751)
SHAMROCK = chr(9752)
REVERSED_ROTATED_FLORAL_HEART_BULLET = chr(9753)
BLACK_LEFT_POINTING_INDEX = chr(9754)
BLACK_RIGHT_POINTING_INDEX = chr(9755)
WHITE_LEFT_POINTING_INDEX = chr(9756)
WHITE_UP_POINTING_INDEX = chr(9757)
WHITE_RIGHT_POINTING_INDEX = chr(9758)
WHITE_DOWN_POINTING_INDEX = chr(9759)
SKULL_AND_CROSSBONES = chr(9760)
CAUTION_SIGN = chr(9761)
RADIOACTIVE_SIGN = chr(9762)
BIOHAZARD_SIGN = chr(9763)
CADUCEUS = chr(9764)
ANKH = chr(9765)
ORTHODOX_CROSS = chr(9766)
CHI_RHO = chr(9767)
CROSS_OF_LORRAINE = chr(9768)
CROSS_OF_JERUSALEM = chr(9769)
STAR_AND_CRESCENT = chr(9770)
FARSI_SYMBOL = chr(9771)
ADI_SHAKTI = chr(9772)
HAMMER_AND_SICKLE = chr(9773)
PEACE_SYMBOL = chr(9774)
YIN_YANG = chr(9775)
TRIGRAM_FOR_HEAVEN = chr(9776)
TRIGRAM_FOR_LAKE = chr(9777)
TRIGRAM_FOR_FIRE = chr(9778)
TRIGRAM_FOR_THUNDER = chr(9779)
TRIGRAM_FOR_WIND = chr(9780)
TRIGRAM_FOR_WATER = chr(9781)
TRIGRAM_FOR_MOUNTAIN = chr(9782)
TRIGRAM_FOR_EARTH = chr(9783)
WHEEL_OF_DHARMA = chr(9784)
WHITE_FROWNING_FACE = chr(9785)
WHITE_SMILING_FACE = chr(9786)
BLACK_SMILING_FACE = chr(9787)
WHITE_SUN_WITH_RAYS = chr(9788)
FIRST_QUARTER_MOON = chr(9789)
LAST_QUARTER_MOON = chr(9790)
MERCURY = chr(9791)
FEMALE_SIGN = chr(9792)
EARTH = chr(9793)
MALE_SIGN = chr(9794)
JUPITER = chr(9795)
SATURN = chr(9796)
URANUS = chr(9797)
NEPTUNE = chr(9798)
PLUTO = chr(9799)
ARIES = chr(9800)
TAURUS = chr(9801)
GEMINI = chr(9802)
CANCER = chr(9803)
LEO = chr(9804)
VIRGO = chr(9805)
LIBRA = chr(9806)
SCORPIUS = chr(9807)
SAGITTARIUS = chr(9808)
CAPRICORN = chr(9809)
AQUARIUS = chr(9810)
PISCES = chr(9811)
WHITE_CHESS_KING = chr(9812)
WHITE_CHESS_QUEEN = chr(9813)
WHITE_CHESS_ROOK = chr(9814)
WHITE_CHESS_BISHOP = chr(9815)
WHITE_CHESS_KNIGHT = chr(9816)
WHITE_CHESS_PAWN = chr(9817)
BLACK_CHESS_KING = chr(9818)
BLACK_CHESS_QUEEN = chr(9819)
BLACK_CHESS_ROOK = chr(9820)
BLACK_CHESS_BISHOP = chr(9821)
BLACK_CHESS_KNIGHT = chr(9822)
BLACK_CHESS_PAWN = chr(9823)
BLACK_SPADE_SUIT = chr(9824)
WHITE_HEART_SUIT = chr(9825)
WHITE_DIAMOND_SUIT = chr(9826)
BLACK_CLUB_SUIT = chr(9827)
WHITE_SPADE_SUIT = chr(9828)
BLACK_HEART_SUIT = chr(9829)
BLACK_DIAMOND_SUIT = chr(9830)
WHITE_CLUB_SUIT = chr(9831)
HOT_SPRINGS = chr(9832)
QUARTER_NOTE = chr(9833)
EIGHTH_NOTE = chr(9834)
BEAMED_EIGHTH_NOTES = chr(9835)
BEAMED_SIXTEENTH_NOTES = chr(9836)
MUSIC_FLAT_SIGN = chr(9837)
MUSIC_NATURAL_SIGN = chr(9838)
MUSIC_SHARP_SIGN = chr(9839)
WEST_SYRIAC_CROSS = chr(9840)
EAST_SYRIAC_CROSS = chr(9841)
UNIVERSAL_RECYCLING_SYMBOL = chr(9842)
RECYCLING_SYMBOL_FOR_TYPE_1_PLASTICS = chr(9843)
RECYCLING_SYMBOL_FOR_TYPE_2_PLASTICS = chr(9844)
RECYCLING_SYMBOL_FOR_TYPE_3_PLASTICS = chr(9845)
RECYCLING_SYMBOL_FOR_TYPE_4_PLASTICS = chr(9846)
RECYCLING_SYMBOL_FOR_TYPE_5_PLASTICS = chr(9847)
RECYCLING_SYMBOL_FOR_TYPE_6_PLASTICS = chr(9848)
RECYCLING_SYMBOL_FOR_TYPE_7_PLASTICS = chr(9849)
RECYCLING_SYMBOL_FOR_GENERIC_MATERIALS = chr(9850)
BLACK_UNIVERSAL_RECYCLING_SYMBOL = chr(9851)
RECYCLED_PAPER_SYMBOL = chr(9852)
PARTIALLY_RECYCLED_PAPER_SYMBOL = chr(9853)
PERMANENT_PAPER_SIGN = chr(9854)
WHEELCHAIR_SYMBOL = chr(9855)
DIE_FACE_1 = chr(9856)
DIE_FACE_2 = chr(9857)
DIE_FACE_3 = chr(9858)
DIE_FACE_4 = chr(9859)
DIE_FACE_5 = chr(9860)
DIE_FACE_6 = chr(9861)
WHITE_CIRCLE_WITH_DOT_RIGHT = chr(9862)
WHITE_CIRCLE_WITH_TWO_DOTS = chr(9863)
BLACK_CIRCLE_WITH_WHITE_DOT_RIGHT = chr(9864)
BLACK_CIRCLE_WITH_TWO_WHITE_DOTS = chr(9865)
MONOGRAM_FOR_YANG = chr(9866)
MONOGRAM_FOR_YIN = chr(9867)
DIGRAM_FOR_GREATER_YANG = chr(9868)
DIGRAM_FOR_LESSER_YIN = chr(9869)
DIGRAM_FOR_LESSER_YANG = chr(9870)
DIGRAM_FOR_GREATER_YIN = chr(9871)
WHITE_FLAG = chr(9872)
BLACK_FLAG = chr(9873)
HAMMER_AND_PICK = chr(9874)
ANCHOR = chr(9875)
CROSSED_SWORDS = chr(9876)
STAFF_OF_AESCULAPIUS = chr(9877)
SCALES = chr(9878)
ALEMBIC = chr(9879)
FLOWER = chr(9880)
GEAR = chr(9881)
STAFF_OF_HERMES = chr(9882)
ATOM_SYMBOL = chr(9883)
FLEUR_DE_LIS = chr(9884)
OUTLINED_WHITE_STAR = chr(9885)
THREE_LINES_CONVERGING_RIGHT = chr(9886)
THREE_LINES_CONVERGING_LEFT = chr(9887)
WARNING_SIGN = chr(9888)
HIGH_VOLTAGE_SIGN = chr(9889)
DOUBLED_FEMALE_SIGN = chr(9890)
DOUBLED_MALE_SIGN = chr(9891)
INTERLOCKED_FEMALE_AND_MALE_SIGN = chr(9892)
MALE_AND_FEMALE_SIGN = chr(9893)
MALE_WITH_STROKE_SIGN = chr(9894)
MALE_WITH_STROKE_AND_MALE_AND_FEMALE_SIGN = chr(9895)
VERTICAL_MALE_WITH_STROKE_SIGN = chr(9896)
HORIZONTAL_MALE_WITH_STROKE_SIGN = chr(9897)
MEDIUM_WHITE_CIRCLE = chr(9898)
MEDIUM_BLACK_CIRCLE = chr(9899)
MEDIUM_SMALL_WHITE_CIRCLE = chr(9900)
MARRIAGE_SYMBOL = chr(9901)
DIVORCE_SYMBOL = chr(9902)
UNMARRIED_PARTNERSHIP_SYMBOL = chr(9903)
COFFIN = chr(9904)
FUNERAL_URN = chr(9905)
NEUTER = chr(9906)
CERES = chr(9907)
PALLAS = chr(9908)
JUNO = chr(9909)
VESTA = chr(9910)
CHIRON = chr(9911)
BLACK_MOON_LILITH = chr(9912)
SEXTILE = chr(9913)
SEMISEXTILE = chr(9914)
QUINCUNX = chr(9915)
SESQUIQUADRATE = chr(9916)
SOCCER_BALL = chr(9917)
BASEBALL = chr(9918)
SQUARED_KEY = chr(9919)
WHITE_DRAUGHTS_MAN = chr(9920)
WHITE_DRAUGHTS_KING = chr(9921)
BLACK_DRAUGHTS_MAN = chr(9922)
BLACK_DRAUGHTS_KING = chr(9923)
SNOWMAN_WITHOUT_SNOW = chr(9924)
SUN_BEHIND_CLOUD = chr(9925)
RAIN = chr(9926)
BLACK_SNOWMAN = chr(9927)
THUNDER_CLOUD_AND_RAIN = chr(9928)
TURNED_WHITE_SHOGI_PIECE = chr(9929)
TURNED_BLACK_SHOGI_PIECE = chr(9930)
WHITE_DIAMOND_IN_SQUARE = chr(9931)
CROSSING_LANES = chr(9932)
DISABLED_CAR = chr(9933)
OPHIUCHUS = chr(9934)
PICK = chr(9935)
CAR_SLIDING = chr(9936)
HELMET_WITH_WHITE_CROSS = chr(9937)
CIRCLED_CROSSING_LANES = chr(9938)
CHAINS = chr(9939)
NO_ENTRY = chr(9940)
ALTERNATE_ONE_WAY_LEFT_WAY_TRAFFIC = chr(9941)
BLACK_TWO_WAY_LEFT_WAY_TRAFFIC = chr(9942)
WHITE_TWO_WAY_LEFT_WAY_TRAFFIC = chr(9943)
BLACK_LEFT_LANE_MERGE = chr(9944)
WHITE_LEFT_LANE_MERGE = chr(9945)
DRIVE_SLOW_SIGN = chr(9946)
HEAVY_WHITE_DOWN_POINTING_TRIANGLE = chr(9947)
LEFT_CLOSED_ENTRY = chr(9948)
SQUARED_SALTIRE = chr(9949)
FALLING_DIAGONAL_IN_WHITE_CIRCLE_IN_BLACK_SQUARE = chr(9950)
BLACK_TRUCK = chr(9951)
RESTRICTED_LEFT_ENTRY_1 = chr(9952)
RESTRICTED_LEFT_ENTRY_2 = chr(9953)
ASTRONOMICAL_SYMBOL_FOR_URANUS = chr(9954)
HEAVY_CIRCLE_WITH_STROKE_AND_TWO_DOTS_ABOVE = chr(9955)
PENTAGRAM = chr(9956)
RIGHT_HANDED_INTERLACED_PENTAGRAM = chr(9957)
LEFT_HANDED_INTERLACED_PENTAGRAM = chr(9958)
INVERTED_PENTAGRAM = chr(9959)
BLACK_CROSS_ON_SHIELD = chr(9960)
SHINTO_SHRINE = chr(9961)
CHURCH = chr(9962)
CASTLE = chr(9963)
HISTORIC_SITE = chr(9964)
GEAR_WITHOUT_HUB = chr(9965)
GEAR_WITH_HANDLES = chr(9966)
MAP_SYMBOL_FOR_LIGHTHOUSE = chr(9967)
MOUNTAIN = chr(9968)
UMBRELLA_ON_GROUND = chr(9969)
FOUNTAIN = chr(9970)
FLAG_IN_HOLE = chr(9971)
FERRY = chr(9972)
SAILBOAT = chr(9973)
SQUARE_FOUR_CORNERS = chr(9974)
SKIER = chr(9975)
ICE_SKATE = chr(9976)
PERSON_WITH_BALL = chr(9977)
TENT = chr(9978)
JAPANESE_BANK_SYMBOL = chr(9979)
HEADSTONE_GRAVEYARD_SYMBOL = chr(9980)
FUEL_PUMP = chr(9981)
CUP_ON_BLACK_SQUARE = chr(9982)
WHITE_FLAG_WITH_HORIZONTAL_MIDDLE_BLACK_STRIPE = chr(9983)
BLACK_SAFETY_SCISSORS = chr(9984)
UPPER_BLADE_SCISSORS = chr(9985)
BLACK_SCISSORS = chr(9986)
LOWER_BLADE_SCISSORS = chr(9987)
WHITE_SCISSORS = chr(9988)
WHITE_HEAVY_CHECK_MARK = chr(9989)
TELEPHONE_LOCATION_SIGN = chr(9990)
TAPE_DRIVE = chr(9991)
AIRPLANE = chr(9992)
ENVELOPE = chr(9993)
RAISED_FIST = chr(9994)
RAISED_HAND = chr(9995)
VICTORY_HAND = chr(9996)
WRITING_HAND = chr(9997)
LOWER_RIGHT_PENCIL = chr(9998)
PENCIL = chr(9999)
UPPER_RIGHT_PENCIL = chr(10000)
WHITE_NIB = chr(10001)
BLACK_NIB = chr(10002)
CHECK_MARK = chr(10003)
HEAVY_CHECK_MARK = chr(10004)
MULTIPLICATION_X = chr(10005)
HEAVY_MULTIPLICATION_X = chr(10006)
BALLOT_X = chr(10007)
HEAVY_BALLOT_X = chr(10008)
OUTLINED_GREEK_CROSS = chr(10009)
HEAVY_GREEK_CROSS = chr(10010)
OPEN_CENTRE_CROSS = chr(10011)
HEAVY_OPEN_CENTRE_CROSS = chr(10012)
LATIN_CROSS = chr(10013)
SHADOWED_WHITE_LATIN_CROSS = chr(10014)
OUTLINED_LATIN_CROSS = chr(10015)
MALTESE_CROSS = chr(10016)
STAR_OF_DAVID = chr(10017)
FOUR_TEARDROP_SPOKED_ASTERISK = chr(10018)
FOUR_BALLOON_SPOKED_ASTERISK = chr(10019)
HEAVY_FOUR_BALLOON_SPOKED_ASTERISK = chr(10020)
FOUR_CLUB_SPOKED_ASTERISK = chr(10021)
BLACK_FOUR_POINTED_STAR = chr(10022)
WHITE_FOUR_POINTED_STAR = chr(10023)
SPARKLES = chr(10024)
STRESS_OUTLINED_WHITE_STAR = chr(10025)
CIRCLED_WHITE_STAR = chr(10026)
OPEN_CENTRE_BLACK_STAR = chr(10027)
BLACK_CENTRE_WHITE_STAR = chr(10028)
OUTLINED_BLACK_STAR = chr(10029)
HEAVY_OUTLINED_BLACK_STAR = chr(10030)
PINWHEEL_STAR = chr(10031)
SHADOWED_WHITE_STAR = chr(10032)
HEAVY_ASTERISK = chr(10033)
OPEN_CENTRE_ASTERISK = chr(10034)
EIGHT_SPOKED_ASTERISK = chr(10035)
EIGHT_POINTED_BLACK_STAR = chr(10036)
EIGHT_POINTED_PINWHEEL_STAR = chr(10037)
SIX_POINTED_BLACK_STAR = chr(10038)
EIGHT_POINTED_RECTILINEAR_BLACK_STAR = chr(10039)
HEAVY_EIGHT_POINTED_RECTILINEAR_BLACK_STAR = chr(10040)
TWELVE_POINTED_BLACK_STAR = chr(10041)
SIXTEEN_POINTED_ASTERISK = chr(10042)
TEARDROP_SPOKED_ASTERISK = chr(10043)
OPEN_CENTRE_TEARDROP_SPOKED_ASTERISK = chr(10044)
HEAVY_TEARDROP_SPOKED_ASTERISK = chr(10045)
SIX_PETALLED_BLACK_AND_WHITE_FLORETTE = chr(10046)
BLACK_FLORETTE = chr(10047)
WHITE_FLORETTE = chr(10048)
EIGHT_PETALLED_OUTLINED_BLACK_FLORETTE = chr(10049)
CIRCLED_OPEN_CENTRE_EIGHT_POINTED_STAR = chr(10050)
HEAVY_TEARDROP_SPOKED_PINWHEEL_ASTERISK = chr(10051)
SNOWFLAKE = chr(10052)
TIGHT_TRIFOLIATE_SNOWFLAKE = chr(10053)
HEAVY_CHEVRON_SNOWFLAKE = chr(10054)
SPARKLE = chr(10055)
HEAVY_SPARKLE = chr(10056)
BALLOON_SPOKED_ASTERISK = chr(10057)
EIGHT_TEARDROP_SPOKED_PROPELLER_ASTERISK = chr(10058)
HEAVY_EIGHT_TEARDROP_SPOKED_PROPELLER_ASTERISK = chr(10059)
CROSS_MARK = chr(10060)
SHADOWED_WHITE_CIRCLE = chr(10061)
NEGATIVE_SQUARED_CROSS_MARK = chr(10062)
LOWER_RIGHT_DROP_SHADOWED_WHITE_SQUARE = chr(10063)
UPPER_RIGHT_DROP_SHADOWED_WHITE_SQUARE = chr(10064)
LOWER_RIGHT_SHADOWED_WHITE_SQUARE = chr(10065)
UPPER_RIGHT_SHADOWED_WHITE_SQUARE = chr(10066)
BLACK_QUESTION_MARK_ORNAMENT = chr(10067)
WHITE_QUESTION_MARK_ORNAMENT = chr(10068)
WHITE_EXCLAMATION_MARK_ORNAMENT = chr(10069)
BLACK_DIAMOND_MINUS_WHITE_X = chr(10070)
HEAVY_EXCLAMATION_MARK_SYMBOL = chr(10071)
LIGHT_VERTICAL_BAR = chr(10072)
MEDIUM_VERTICAL_BAR = chr(10073)
HEAVY_VERTICAL_BAR = chr(10074)
HEAVY_SINGLE_TURNED_COMMA_QUOTATION_MARK_ORNAMENT = chr(10075)
HEAVY_SINGLE_COMMA_QUOTATION_MARK_ORNAMENT = chr(10076)
HEAVY_DOUBLE_TURNED_COMMA_QUOTATION_MARK_ORNAMENT = chr(10077)
HEAVY_DOUBLE_COMMA_QUOTATION_MARK_ORNAMENT = chr(10078)
HEAVY_LOW_SINGLE_COMMA_QUOTATION_MARK_ORNAMENT = chr(10079)
HEAVY_LOW_DOUBLE_COMMA_QUOTATION_MARK_ORNAMENT = chr(10080)
CURVED_STEM_PARAGRAPH_SIGN_ORNAMENT = chr(10081)
HEAVY_EXCLAMATION_MARK_ORNAMENT = chr(10082)
HEAVY_HEART_EXCLAMATION_MARK_ORNAMENT = chr(10083)
HEAVY_BLACK_HEART = chr(10084)
ROTATED_HEAVY_BLACK_HEART_BULLET = chr(10085)
FLORAL_HEART = chr(10086)
ROTATED_FLORAL_HEART_BULLET = chr(10087)
MEDIUM_LEFT_PARENTHESIS_ORNAMENT = chr(10088)
MEDIUM_RIGHT_PARENTHESIS_ORNAMENT = chr(10089)
MEDIUM_FLATTENED_LEFT_PARENTHESIS_ORNAMENT = chr(10090)
MEDIUM_FLATTENED_RIGHT_PARENTHESIS_ORNAMENT = chr(10091)
MEDIUM_LEFT_POINTING_ANGLE_BRACKET_ORNAMENT = chr(10092)
MEDIUM_RIGHT_POINTING_ANGLE_BRACKET_ORNAMENT = chr(10093)
HEAVY_LEFT_POINTING_ANGLE_QUOTATION_MARK_ORNAMENT = chr(10094)
HEAVY_RIGHT_POINTING_ANGLE_QUOTATION_MARK_ORNAMENT = chr(10095)
HEAVY_LEFT_POINTING_ANGLE_BRACKET_ORNAMENT = chr(10096)
HEAVY_RIGHT_POINTING_ANGLE_BRACKET_ORNAMENT = chr(10097)
LIGHT_LEFT_TORTOISE_SHELL_BRACKET_ORNAMENT = chr(10098)
LIGHT_RIGHT_TORTOISE_SHELL_BRACKET_ORNAMENT = chr(10099)
MEDIUM_LEFT_CURLY_BRACKET_ORNAMENT = chr(10100)
MEDIUM_RIGHT_CURLY_BRACKET_ORNAMENT = chr(10101)
DINGBAT_NEGATIVE_CIRCLED_DIGIT_ONE = chr(10102)
DINGBAT_NEGATIVE_CIRCLED_DIGIT_TWO = chr(10103)
DINGBAT_NEGATIVE_CIRCLED_DIGIT_THREE = chr(10104)
DINGBAT_NEGATIVE_CIRCLED_DIGIT_FOUR = chr(10105)
DINGBAT_NEGATIVE_CIRCLED_DIGIT_FIVE = chr(10106)
DINGBAT_NEGATIVE_CIRCLED_DIGIT_SIX = chr(10107)
DINGBAT_NEGATIVE_CIRCLED_DIGIT_SEVEN = chr(10108)
DINGBAT_NEGATIVE_CIRCLED_DIGIT_EIGHT = chr(10109)
DINGBAT_NEGATIVE_CIRCLED_DIGIT_NINE = chr(10110)
DINGBAT_NEGATIVE_CIRCLED_NUMBER_TEN = chr(10111)
DINGBAT_CIRCLED_SANS_SERIF_DIGIT_ONE = chr(10112)
DINGBAT_CIRCLED_SANS_SERIF_DIGIT_TWO = chr(10113)
DINGBAT_CIRCLED_SANS_SERIF_DIGIT_THREE = chr(10114)
DINGBAT_CIRCLED_SANS_SERIF_DIGIT_FOUR = chr(10115)
DINGBAT_CIRCLED_SANS_SERIF_DIGIT_FIVE = chr(10116)
DINGBAT_CIRCLED_SANS_SERIF_DIGIT_SIX = chr(10117)
DINGBAT_CIRCLED_SANS_SERIF_DIGIT_SEVEN = chr(10118)
DINGBAT_CIRCLED_SANS_SERIF_DIGIT_EIGHT = chr(10119)
DINGBAT_CIRCLED_SANS_SERIF_DIGIT_NINE = chr(10120)
DINGBAT_CIRCLED_SANS_SERIF_NUMBER_TEN = chr(10121)
DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_ONE = chr(10122)
DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_TWO = chr(10123)
DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_THREE = chr(10124)
DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_FOUR = chr(10125)
DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_FIVE = chr(10126)
DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_SIX = chr(10127)
DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_SEVEN = chr(10128)
DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_EIGHT = chr(10129)
DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_NINE = chr(10130)
DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_NUMBER_TEN = chr(10131)
HEAVY_WIDE_HEADED_RIGHTWARDS_ARROW = chr(10132)
HEAVY_PLUS_SIGN = chr(10133)
HEAVY_MINUS_SIGN = chr(10134)
HEAVY_DIVISION_SIGN = chr(10135)
HEAVY_SOUTH_EAST_ARROW = chr(10136)
HEAVY_RIGHTWARDS_ARROW = chr(10137)
HEAVY_NORTH_EAST_ARROW = chr(10138)
DRAFTING_POINT_RIGHTWARDS_ARROW = chr(10139)
HEAVY_ROUND_TIPPED_RIGHTWARDS_ARROW = chr(10140)
TRIANGLE_HEADED_RIGHTWARDS_ARROW = chr(10141)
HEAVY_TRIANGLE_HEADED_RIGHTWARDS_ARROW = chr(10142)
DASHED_TRIANGLE_HEADED_RIGHTWARDS_ARROW = chr(10143)
HEAVY_DASHED_TRIANGLE_HEADED_RIGHTWARDS_ARROW = chr(10144)
BLACK_RIGHTWARDS_ARROW = chr(10145)
THREE_D_TOP_LIGHTED_RIGHTWARDS_ARROWHEAD = chr(10146)
THREE_D_BOTTOM_LIGHTED_RIGHTWARDS_ARROWHEAD = chr(10147)
BLACK_RIGHTWARDS_ARROWHEAD = chr(10148)
HEAVY_BLACK_CURVED_DOWNWARDS_AND_RIGHTWARDS_ARROW = chr(10149)
HEAVY_BLACK_CURVED_UPWARDS_AND_RIGHTWARDS_ARROW = chr(10150)
SQUAT_BLACK_RIGHTWARDS_ARROW = chr(10151)
HEAVY_CONCAVE_POINTED_BLACK_RIGHTWARDS_ARROW = chr(10152)
RIGHT_SHADED_WHITE_RIGHTWARDS_ARROW = chr(10153)
LEFT_SHADED_WHITE_RIGHTWARDS_ARROW = chr(10154)
BACK_TILTED_SHADOWED_WHITE_RIGHTWARDS_ARROW = chr(10155)
FRONT_TILTED_SHADOWED_WHITE_RIGHTWARDS_ARROW = chr(10156)
HEAVY_LOWER_RIGHT_SHADOWED_WHITE_RIGHTWARDS_ARROW = chr(10157)
HEAVY_UPPER_RIGHT_SHADOWED_WHITE_RIGHTWARDS_ARROW = chr(10158)
NOTCHED_LOWER_RIGHT_SHADOWED_WHITE_RIGHTWARDS_ARROW = chr(10159)
CURLY_LOOP = chr(10160)
NOTCHED_UPPER_RIGHT_SHADOWED_WHITE_RIGHTWARDS_ARROW = chr(10161)
CIRCLED_HEAVY_WHITE_RIGHTWARDS_ARROW = chr(10162)
WHITE_FEATHERED_RIGHTWARDS_ARROW = chr(10163)
BLACK_FEATHERED_SOUTH_EAST_ARROW = chr(10164)
BLACK_FEATHERED_RIGHTWARDS_ARROW = chr(10165)
BLACK_FEATHERED_NORTH_EAST_ARROW = chr(10166)
HEAVY_BLACK_FEATHERED_SOUTH_EAST_ARROW = chr(10167)
HEAVY_BLACK_FEATHERED_RIGHTWARDS_ARROW = chr(10168)
HEAVY_BLACK_FEATHERED_NORTH_EAST_ARROW = chr(10169)
TEARDROP_BARBED_RIGHTWARDS_ARROW = chr(10170)
HEAVY_TEARDROP_SHANKED_RIGHTWARDS_ARROW = chr(10171)
WEDGE_TAILED_RIGHTWARDS_ARROW = chr(10172)
HEAVY_WEDGE_TAILED_RIGHTWARDS_ARROW = chr(10173)
OPEN_OUTLINED_RIGHTWARDS_ARROW = chr(10174)
DOUBLE_CURLY_LOOP = chr(10175)
THREE_DIMENSIONAL_ANGLE = chr(10176)
WHITE_TRIANGLE_CONTAINING_SMALL_WHITE_TRIANGLE = chr(10177)
PERPENDICULAR = chr(10178)
OPEN_SUBSET = chr(10179)
OPEN_SUPERSET = chr(10180)
LEFT_S_SHAPED_BAG_DELIMITER = chr(10181)
RIGHT_S_SHAPED_BAG_DELIMITER = chr(10182)
OR_WITH_DOT_INSIDE = chr(10183)
REVERSE_SOLIDUS_PRECEDING_SUBSET = chr(10184)
SUPERSET_PRECEDING_SOLIDUS = chr(10185)
VERTICAL_BAR_WITH_HORIZONTAL_STROKE = chr(10186)
MATHEMATICAL_RISING_DIAGONAL = chr(10187)
LONG_DIVISION = chr(10188)
MATHEMATICAL_FALLING_DIAGONAL = chr(10189)
SQUARED_LOGICAL_AND = chr(10190)
SQUARED_LOGICAL_OR = chr(10191)
WHITE_DIAMOND_WITH_CENTRED_DOT = chr(10192)
AND_WITH_DOT = chr(10193)
ELEMENT_OF_OPENING_UPWARDS = chr(10194)
LOWER_RIGHT_CORNER_WITH_DOT = chr(10195)
UPPER_LEFT_CORNER_WITH_DOT = chr(10196)
LEFT_OUTER_JOIN = chr(10197)
RIGHT_OUTER_JOIN = chr(10198)
FULL_OUTER_JOIN = chr(10199)
LARGE_UP_TACK = chr(10200)
LARGE_DOWN_TACK = chr(10201)
LEFT_AND_RIGHT_DOUBLE_TURNSTILE = chr(10202)
LEFT_AND_RIGHT_TACK = chr(10203)
LEFT_MULTIMAP = chr(10204)
LONG_RIGHT_TACK = chr(10205)
LONG_LEFT_TACK = chr(10206)
UP_TACK_WITH_CIRCLE_ABOVE = chr(10207)
LOZENGE_DIVIDED_BY_HORIZONTAL_RULE = chr(10208)
WHITE_CONCAVE_SIDED_DIAMOND = chr(10209)
WHITE_CONCAVE_SIDED_DIAMOND_WITH_LEFTWARDS_TICK = chr(10210)
WHITE_CONCAVE_SIDED_DIAMOND_WITH_RIGHTWARDS_TICK = chr(10211)
WHITE_SQUARE_WITH_LEFTWARDS_TICK = chr(10212)
WHITE_SQUARE_WITH_RIGHTWARDS_TICK = chr(10213)
MATHEMATICAL_LEFT_WHITE_SQUARE_BRACKET = chr(10214)
MATHEMATICAL_RIGHT_WHITE_SQUARE_BRACKET = chr(10215)
MATHEMATICAL_LEFT_ANGLE_BRACKET = chr(10216)
MATHEMATICAL_RIGHT_ANGLE_BRACKET = chr(10217)
MATHEMATICAL_LEFT_DOUBLE_ANGLE_BRACKET = chr(10218)
MATHEMATICAL_RIGHT_DOUBLE_ANGLE_BRACKET = chr(10219)
MATHEMATICAL_LEFT_WHITE_TORTOISE_SHELL_BRACKET = chr(10220)
MATHEMATICAL_RIGHT_WHITE_TORTOISE_SHELL_BRACKET = chr(10221)
MATHEMATICAL_LEFT_FLATTENED_PARENTHESIS = chr(10222)
MATHEMATICAL_RIGHT_FLATTENED_PARENTHESIS = chr(10223)
UPWARDS_QUADRUPLE_ARROW = chr(10224)
DOWNWARDS_QUADRUPLE_ARROW = chr(10225)
ANTICLOCKWISE_GAPPED_CIRCLE_ARROW = chr(10226)
CLOCKWISE_GAPPED_CIRCLE_ARROW = chr(10227)
RIGHT_ARROW_WITH_CIRCLED_PLUS = chr(10228)
LONG_LEFTWARDS_ARROW = chr(10229)
LONG_RIGHTWARDS_ARROW = chr(10230)
LONG_LEFT_RIGHT_ARROW = chr(10231)
LONG_LEFTWARDS_DOUBLE_ARROW = chr(10232)
LONG_RIGHTWARDS_DOUBLE_ARROW = chr(10233)
LONG_LEFT_RIGHT_DOUBLE_ARROW = chr(10234)
LONG_LEFTWARDS_ARROW_FROM_BAR = chr(10235)
LONG_RIGHTWARDS_ARROW_FROM_BAR = chr(10236)
LONG_LEFTWARDS_DOUBLE_ARROW_FROM_BAR = chr(10237)
LONG_RIGHTWARDS_DOUBLE_ARROW_FROM_BAR = chr(10238)
LONG_RIGHTWARDS_SQUIGGLE_ARROW = chr(10239)
BRAILLE_PATTERN_BLANK = chr(10240)
BRAILLE_PATTERN_DOTS_1 = chr(10241)
BRAILLE_PATTERN_DOTS_2 = chr(10242)
BRAILLE_PATTERN_DOTS_12 = chr(10243)
BRAILLE_PATTERN_DOTS_3 = chr(10244)
BRAILLE_PATTERN_DOTS_13 = chr(10245)
BRAILLE_PATTERN_DOTS_23 = chr(10246)
BRAILLE_PATTERN_DOTS_123 = chr(10247)
BRAILLE_PATTERN_DOTS_4 = chr(10248)
BRAILLE_PATTERN_DOTS_14 = chr(10249)
BRAILLE_PATTERN_DOTS_24 = chr(10250)
BRAILLE_PATTERN_DOTS_124 = chr(10251)
BRAILLE_PATTERN_DOTS_34 = chr(10252)
BRAILLE_PATTERN_DOTS_134 = chr(10253)
BRAILLE_PATTERN_DOTS_234 = chr(10254)
BRAILLE_PATTERN_DOTS_1234 = chr(10255)
BRAILLE_PATTERN_DOTS_5 = chr(10256)
BRAILLE_PATTERN_DOTS_15 = chr(10257)
BRAILLE_PATTERN_DOTS_25 = chr(10258)
BRAILLE_PATTERN_DOTS_125 = chr(10259)
BRAILLE_PATTERN_DOTS_35 = chr(10260)
BRAILLE_PATTERN_DOTS_135 = chr(10261)
BRAILLE_PATTERN_DOTS_235 = chr(10262)
BRAILLE_PATTERN_DOTS_1235 = chr(10263)
BRAILLE_PATTERN_DOTS_45 = chr(10264)
BRAILLE_PATTERN_DOTS_145 = chr(10265)
BRAILLE_PATTERN_DOTS_245 = chr(10266)
BRAILLE_PATTERN_DOTS_1245 = chr(10267)
BRAILLE_PATTERN_DOTS_345 = chr(10268)
BRAILLE_PATTERN_DOTS_1345 = chr(10269)
BRAILLE_PATTERN_DOTS_2345 = chr(10270)
BRAILLE_PATTERN_DOTS_12345 = chr(10271)
BRAILLE_PATTERN_DOTS_6 = chr(10272)
BRAILLE_PATTERN_DOTS_16 = chr(10273)
BRAILLE_PATTERN_DOTS_26 = chr(10274)
BRAILLE_PATTERN_DOTS_126 = chr(10275)
BRAILLE_PATTERN_DOTS_36 = chr(10276)
BRAILLE_PATTERN_DOTS_136 = chr(10277)
BRAILLE_PATTERN_DOTS_236 = chr(10278)
BRAILLE_PATTERN_DOTS_1236 = chr(10279)
BRAILLE_PATTERN_DOTS_46 = chr(10280)
BRAILLE_PATTERN_DOTS_146 = chr(10281)
BRAILLE_PATTERN_DOTS_246 = chr(10282)
BRAILLE_PATTERN_DOTS_1246 = chr(10283)
BRAILLE_PATTERN_DOTS_346 = chr(10284)
BRAILLE_PATTERN_DOTS_1346 = chr(10285)
BRAILLE_PATTERN_DOTS_2346 = chr(10286)
BRAILLE_PATTERN_DOTS_12346 = chr(10287)
BRAILLE_PATTERN_DOTS_56 = chr(10288)
BRAILLE_PATTERN_DOTS_156 = chr(10289)
BRAILLE_PATTERN_DOTS_256 = chr(10290)
BRAILLE_PATTERN_DOTS_1256 = chr(10291)
BRAILLE_PATTERN_DOTS_356 = chr(10292)
BRAILLE_PATTERN_DOTS_1356 = chr(10293)
BRAILLE_PATTERN_DOTS_2356 = chr(10294)
BRAILLE_PATTERN_DOTS_12356 = chr(10295)
BRAILLE_PATTERN_DOTS_456 = chr(10296)
BRAILLE_PATTERN_DOTS_1456 = chr(10297)
BRAILLE_PATTERN_DOTS_2456 = chr(10298)
BRAILLE_PATTERN_DOTS_12456 = chr(10299)
BRAILLE_PATTERN_DOTS_3456 = chr(10300)
BRAILLE_PATTERN_DOTS_13456 = chr(10301)
BRAILLE_PATTERN_DOTS_23456 = chr(10302)
BRAILLE_PATTERN_DOTS_123456 = chr(10303)
BRAILLE_PATTERN_DOTS_7 = chr(10304)
BRAILLE_PATTERN_DOTS_17 = chr(10305)
BRAILLE_PATTERN_DOTS_27 = chr(10306)
BRAILLE_PATTERN_DOTS_127 = chr(10307)
BRAILLE_PATTERN_DOTS_37 = chr(10308)
BRAILLE_PATTERN_DOTS_137 = chr(10309)
BRAILLE_PATTERN_DOTS_237 = chr(10310)
BRAILLE_PATTERN_DOTS_1237 = chr(10311)
BRAILLE_PATTERN_DOTS_47 = chr(10312)
BRAILLE_PATTERN_DOTS_147 = chr(10313)
BRAILLE_PATTERN_DOTS_247 = chr(10314)
BRAILLE_PATTERN_DOTS_1247 = chr(10315)
BRAILLE_PATTERN_DOTS_347 = chr(10316)
BRAILLE_PATTERN_DOTS_1347 = chr(10317)
BRAILLE_PATTERN_DOTS_2347 = chr(10318)
BRAILLE_PATTERN_DOTS_12347 = chr(10319)
BRAILLE_PATTERN_DOTS_57 = chr(10320)
BRAILLE_PATTERN_DOTS_157 = chr(10321)
BRAILLE_PATTERN_DOTS_257 = chr(10322)
BRAILLE_PATTERN_DOTS_1257 = chr(10323)
BRAILLE_PATTERN_DOTS_357 = chr(10324)
BRAILLE_PATTERN_DOTS_1357 = chr(10325)
BRAILLE_PATTERN_DOTS_2357 = chr(10326)
BRAILLE_PATTERN_DOTS_12357 = chr(10327)
BRAILLE_PATTERN_DOTS_457 = chr(10328)
BRAILLE_PATTERN_DOTS_1457 = chr(10329)
BRAILLE_PATTERN_DOTS_2457 = chr(10330)
BRAILLE_PATTERN_DOTS_12457 = chr(10331)
BRAILLE_PATTERN_DOTS_3457 = chr(10332)
BRAILLE_PATTERN_DOTS_13457 = chr(10333)
BRAILLE_PATTERN_DOTS_23457 = chr(10334)
BRAILLE_PATTERN_DOTS_123457 = chr(10335)
BRAILLE_PATTERN_DOTS_67 = chr(10336)
BRAILLE_PATTERN_DOTS_167 = chr(10337)
BRAILLE_PATTERN_DOTS_267 = chr(10338)
BRAILLE_PATTERN_DOTS_1267 = chr(10339)
BRAILLE_PATTERN_DOTS_367 = chr(10340)
BRAILLE_PATTERN_DOTS_1367 = chr(10341)
BRAILLE_PATTERN_DOTS_2367 = chr(10342)
BRAILLE_PATTERN_DOTS_12367 = chr(10343)
BRAILLE_PATTERN_DOTS_467 = chr(10344)
BRAILLE_PATTERN_DOTS_1467 = chr(10345)
BRAILLE_PATTERN_DOTS_2467 = chr(10346)
BRAILLE_PATTERN_DOTS_12467 = chr(10347)
BRAILLE_PATTERN_DOTS_3467 = chr(10348)
BRAILLE_PATTERN_DOTS_13467 = chr(10349)
BRAILLE_PATTERN_DOTS_23467 = chr(10350)
BRAILLE_PATTERN_DOTS_123467 = chr(10351)
BRAILLE_PATTERN_DOTS_567 = chr(10352)
BRAILLE_PATTERN_DOTS_1567 = chr(10353)
BRAILLE_PATTERN_DOTS_2567 = chr(10354)
BRAILLE_PATTERN_DOTS_12567 = chr(10355)
BRAILLE_PATTERN_DOTS_3567 = chr(10356)
BRAILLE_PATTERN_DOTS_13567 = chr(10357)
BRAILLE_PATTERN_DOTS_23567 = chr(10358)
BRAILLE_PATTERN_DOTS_123567 = chr(10359)
BRAILLE_PATTERN_DOTS_4567 = chr(10360)
BRAILLE_PATTERN_DOTS_14567 = chr(10361)
BRAILLE_PATTERN_DOTS_24567 = chr(10362)
BRAILLE_PATTERN_DOTS_124567 = chr(10363)
BRAILLE_PATTERN_DOTS_34567 = chr(10364)
BRAILLE_PATTERN_DOTS_134567 = chr(10365)
BRAILLE_PATTERN_DOTS_234567 = chr(10366)
BRAILLE_PATTERN_DOTS_1234567 = chr(10367)
BRAILLE_PATTERN_DOTS_8 = chr(10368)
BRAILLE_PATTERN_DOTS_18 = chr(10369)
BRAILLE_PATTERN_DOTS_28 = chr(10370)
BRAILLE_PATTERN_DOTS_128 = chr(10371)
BRAILLE_PATTERN_DOTS_38 = chr(10372)
BRAILLE_PATTERN_DOTS_138 = chr(10373)
BRAILLE_PATTERN_DOTS_238 = chr(10374)
BRAILLE_PATTERN_DOTS_1238 = chr(10375)
BRAILLE_PATTERN_DOTS_48 = chr(10376)
BRAILLE_PATTERN_DOTS_148 = chr(10377)
BRAILLE_PATTERN_DOTS_248 = chr(10378)
BRAILLE_PATTERN_DOTS_1248 = chr(10379)
BRAILLE_PATTERN_DOTS_348 = chr(10380)
BRAILLE_PATTERN_DOTS_1348 = chr(10381)
BRAILLE_PATTERN_DOTS_2348 = chr(10382)
BRAILLE_PATTERN_DOTS_12348 = chr(10383)
BRAILLE_PATTERN_DOTS_58 = chr(10384)
BRAILLE_PATTERN_DOTS_158 = chr(10385)
BRAILLE_PATTERN_DOTS_258 = chr(10386)
BRAILLE_PATTERN_DOTS_1258 = chr(10387)
BRAILLE_PATTERN_DOTS_358 = chr(10388)
BRAILLE_PATTERN_DOTS_1358 = chr(10389)
BRAILLE_PATTERN_DOTS_2358 = chr(10390)
BRAILLE_PATTERN_DOTS_12358 = chr(10391)
BRAILLE_PATTERN_DOTS_458 = chr(10392)
BRAILLE_PATTERN_DOTS_1458 = chr(10393)
BRAILLE_PATTERN_DOTS_2458 = chr(10394)
BRAILLE_PATTERN_DOTS_12458 = chr(10395)
BRAILLE_PATTERN_DOTS_3458 = chr(10396)
BRAILLE_PATTERN_DOTS_13458 = chr(10397)
BRAILLE_PATTERN_DOTS_23458 = chr(10398)
BRAILLE_PATTERN_DOTS_123458 = chr(10399)
BRAILLE_PATTERN_DOTS_68 = chr(10400)
BRAILLE_PATTERN_DOTS_168 = chr(10401)
BRAILLE_PATTERN_DOTS_268 = chr(10402)
BRAILLE_PATTERN_DOTS_1268 = chr(10403)
BRAILLE_PATTERN_DOTS_368 = chr(10404)
BRAILLE_PATTERN_DOTS_1368 = chr(10405)
BRAILLE_PATTERN_DOTS_2368 = chr(10406)
BRAILLE_PATTERN_DOTS_12368 = chr(10407)
BRAILLE_PATTERN_DOTS_468 = chr(10408)
BRAILLE_PATTERN_DOTS_1468 = chr(10409)
BRAILLE_PATTERN_DOTS_2468 = chr(10410)
BRAILLE_PATTERN_DOTS_12468 = chr(10411)
BRAILLE_PATTERN_DOTS_3468 = chr(10412)
BRAILLE_PATTERN_DOTS_13468 = chr(10413)
BRAILLE_PATTERN_DOTS_23468 = chr(10414)
BRAILLE_PATTERN_DOTS_123468 = chr(10415)
BRAILLE_PATTERN_DOTS_568 = chr(10416)
BRAILLE_PATTERN_DOTS_1568 = chr(10417)
BRAILLE_PATTERN_DOTS_2568 = chr(10418)
BRAILLE_PATTERN_DOTS_12568 = chr(10419)
BRAILLE_PATTERN_DOTS_3568 = chr(10420)
BRAILLE_PATTERN_DOTS_13568 = chr(10421)
BRAILLE_PATTERN_DOTS_23568 = chr(10422)
BRAILLE_PATTERN_DOTS_123568 = chr(10423)
BRAILLE_PATTERN_DOTS_4568 = chr(10424)
BRAILLE_PATTERN_DOTS_14568 = chr(10425)
BRAILLE_PATTERN_DOTS_24568 = chr(10426)
BRAILLE_PATTERN_DOTS_124568 = chr(10427)
BRAILLE_PATTERN_DOTS_34568 = chr(10428)
BRAILLE_PATTERN_DOTS_134568 = chr(10429)
BRAILLE_PATTERN_DOTS_234568 = chr(10430)
BRAILLE_PATTERN_DOTS_1234568 = chr(10431)
BRAILLE_PATTERN_DOTS_78 = chr(10432)
BRAILLE_PATTERN_DOTS_178 = chr(10433)
BRAILLE_PATTERN_DOTS_278 = chr(10434)
BRAILLE_PATTERN_DOTS_1278 = chr(10435)
BRAILLE_PATTERN_DOTS_378 = chr(10436)
BRAILLE_PATTERN_DOTS_1378 = chr(10437)
BRAILLE_PATTERN_DOTS_2378 = chr(10438)
BRAILLE_PATTERN_DOTS_12378 = chr(10439)
BRAILLE_PATTERN_DOTS_478 = chr(10440)
BRAILLE_PATTERN_DOTS_1478 = chr(10441)
BRAILLE_PATTERN_DOTS_2478 = chr(10442)
BRAILLE_PATTERN_DOTS_12478 = chr(10443)
BRAILLE_PATTERN_DOTS_3478 = chr(10444)
BRAILLE_PATTERN_DOTS_13478 = chr(10445)
BRAILLE_PATTERN_DOTS_23478 = chr(10446)
BRAILLE_PATTERN_DOTS_123478 = chr(10447)
BRAILLE_PATTERN_DOTS_578 = chr(10448)
BRAILLE_PATTERN_DOTS_1578 = chr(10449)
BRAILLE_PATTERN_DOTS_2578 = chr(10450)
BRAILLE_PATTERN_DOTS_12578 = chr(10451)
BRAILLE_PATTERN_DOTS_3578 = chr(10452)
BRAILLE_PATTERN_DOTS_13578 = chr(10453)
BRAILLE_PATTERN_DOTS_23578 = chr(10454)
BRAILLE_PATTERN_DOTS_123578 = chr(10455)
BRAILLE_PATTERN_DOTS_4578 = chr(10456)
BRAILLE_PATTERN_DOTS_14578 = chr(10457)
BRAILLE_PATTERN_DOTS_24578 = chr(10458)
BRAILLE_PATTERN_DOTS_124578 = chr(10459)
BRAILLE_PATTERN_DOTS_34578 = chr(10460)
BRAILLE_PATTERN_DOTS_134578 = chr(10461)
BRAILLE_PATTERN_DOTS_234578 = chr(10462)
BRAILLE_PATTERN_DOTS_1234578 = chr(10463)
BRAILLE_PATTERN_DOTS_678 = chr(10464)
BRAILLE_PATTERN_DOTS_1678 = chr(10465)
BRAILLE_PATTERN_DOTS_2678 = chr(10466)
BRAILLE_PATTERN_DOTS_12678 = chr(10467)
BRAILLE_PATTERN_DOTS_3678 = chr(10468)
BRAILLE_PATTERN_DOTS_13678 = chr(10469)
BRAILLE_PATTERN_DOTS_23678 = chr(10470)
BRAILLE_PATTERN_DOTS_123678 = chr(10471)
BRAILLE_PATTERN_DOTS_4678 = chr(10472)
BRAILLE_PATTERN_DOTS_14678 = chr(10473)
BRAILLE_PATTERN_DOTS_24678 = chr(10474)
BRAILLE_PATTERN_DOTS_124678 = chr(10475)
BRAILLE_PATTERN_DOTS_34678 = chr(10476)
BRAILLE_PATTERN_DOTS_134678 = chr(10477)
BRAILLE_PATTERN_DOTS_234678 = chr(10478)
BRAILLE_PATTERN_DOTS_1234678 = chr(10479)
BRAILLE_PATTERN_DOTS_5678 = chr(10480)
BRAILLE_PATTERN_DOTS_15678 = chr(10481)
BRAILLE_PATTERN_DOTS_25678 = chr(10482)
BRAILLE_PATTERN_DOTS_125678 = chr(10483)
BRAILLE_PATTERN_DOTS_35678 = chr(10484)
BRAILLE_PATTERN_DOTS_135678 = chr(10485)
BRAILLE_PATTERN_DOTS_235678 = chr(10486)
BRAILLE_PATTERN_DOTS_1235678 = chr(10487)
BRAILLE_PATTERN_DOTS_45678 = chr(10488)
BRAILLE_PATTERN_DOTS_145678 = chr(10489)
BRAILLE_PATTERN_DOTS_245678 = chr(10490)
BRAILLE_PATTERN_DOTS_1245678 = chr(10491)
BRAILLE_PATTERN_DOTS_345678 = chr(10492)
BRAILLE_PATTERN_DOTS_1345678 = chr(10493)
BRAILLE_PATTERN_DOTS_2345678 = chr(10494)
BRAILLE_PATTERN_DOTS_12345678 = chr(10495)
RIGHTWARDS_TWO_HEADED_ARROW_WITH_VERTICAL_STROKE = chr(10496)
RIGHTWARDS_TWO_HEADED_ARROW_WITH_DOUBLE_VERTICAL_STROKE = chr(10497)
LEFTWARDS_DOUBLE_ARROW_WITH_VERTICAL_STROKE = chr(10498)
RIGHTWARDS_DOUBLE_ARROW_WITH_VERTICAL_STROKE = chr(10499)
LEFT_RIGHT_DOUBLE_ARROW_WITH_VERTICAL_STROKE = chr(10500)
RIGHTWARDS_TWO_HEADED_ARROW_FROM_BAR = chr(10501)
LEFTWARDS_DOUBLE_ARROW_FROM_BAR = chr(10502)
RIGHTWARDS_DOUBLE_ARROW_FROM_BAR = chr(10503)
DOWNWARDS_ARROW_WITH_HORIZONTAL_STROKE = chr(10504)
UPWARDS_ARROW_WITH_HORIZONTAL_STROKE = chr(10505)
UPWARDS_TRIPLE_ARROW = chr(10506)
DOWNWARDS_TRIPLE_ARROW = chr(10507)
LEFTWARDS_DOUBLE_DASH_ARROW = chr(10508)
RIGHTWARDS_DOUBLE_DASH_ARROW = chr(10509)
LEFTWARDS_TRIPLE_DASH_ARROW = chr(10510)
RIGHTWARDS_TRIPLE_DASH_ARROW = chr(10511)
RIGHTWARDS_TWO_HEADED_TRIPLE_DASH_ARROW = chr(10512)
RIGHTWARDS_ARROW_WITH_DOTTED_STEM = chr(10513)
UPWARDS_ARROW_TO_BAR = chr(10514)
DOWNWARDS_ARROW_TO_BAR = chr(10515)
RIGHTWARDS_ARROW_WITH_TAIL_WITH_VERTICAL_STROKE = chr(10516)
RIGHTWARDS_ARROW_WITH_TAIL_WITH_DOUBLE_VERTICAL_STROKE = chr(10517)
RIGHTWARDS_TWO_HEADED_ARROW_WITH_TAIL = chr(10518)
RIGHTWARDS_TWO_HEADED_ARROW_WITH_TAIL_WITH_VERTICAL_STROKE = chr(10519)
RIGHTWARDS_TWO_HEADED_ARROW_WITH_TAIL_WITH_DOUBLE_VERTICAL_STROKE = chr(10520)
LEFTWARDS_ARROW_TAIL = chr(10521)
RIGHTWARDS_ARROW_TAIL = chr(10522)
LEFTWARDS_DOUBLE_ARROW_TAIL = chr(10523)
RIGHTWARDS_DOUBLE_ARROW_TAIL = chr(10524)
LEFTWARDS_ARROW_TO_BLACK_DIAMOND = chr(10525)
RIGHTWARDS_ARROW_TO_BLACK_DIAMOND = chr(10526)
LEFTWARDS_ARROW_FROM_BAR_TO_BLACK_DIAMOND = chr(10527)
RIGHTWARDS_ARROW_FROM_BAR_TO_BLACK_DIAMOND = chr(10528)
NORTH_WEST_AND_SOUTH_EAST_ARROW = chr(10529)
NORTH_EAST_AND_SOUTH_WEST_ARROW = chr(10530)
NORTH_WEST_ARROW_WITH_HOOK = chr(10531)
NORTH_EAST_ARROW_WITH_HOOK = chr(10532)
SOUTH_EAST_ARROW_WITH_HOOK = chr(10533)
SOUTH_WEST_ARROW_WITH_HOOK = chr(10534)
NORTH_WEST_ARROW_AND_NORTH_EAST_ARROW = chr(10535)
NORTH_EAST_ARROW_AND_SOUTH_EAST_ARROW = chr(10536)
SOUTH_EAST_ARROW_AND_SOUTH_WEST_ARROW = chr(10537)
SOUTH_WEST_ARROW_AND_NORTH_WEST_ARROW = chr(10538)
RISING_DIAGONAL_CROSSING_FALLING_DIAGONAL = chr(10539)
FALLING_DIAGONAL_CROSSING_RISING_DIAGONAL = chr(10540)
SOUTH_EAST_ARROW_CROSSING_NORTH_EAST_ARROW = chr(10541)
NORTH_EAST_ARROW_CROSSING_SOUTH_EAST_ARROW = chr(10542)
FALLING_DIAGONAL_CROSSING_NORTH_EAST_ARROW = chr(10543)
RISING_DIAGONAL_CROSSING_SOUTH_EAST_ARROW = chr(10544)
NORTH_EAST_ARROW_CROSSING_NORTH_WEST_ARROW = chr(10545)
NORTH_WEST_ARROW_CROSSING_NORTH_EAST_ARROW = chr(10546)
WAVE_ARROW_POINTING_DIRECTLY_RIGHT = chr(10547)
ARROW_POINTING_RIGHTWARDS_THEN_CURVING_UPWARDS = chr(10548)
ARROW_POINTING_RIGHTWARDS_THEN_CURVING_DOWNWARDS = chr(10549)
ARROW_POINTING_DOWNWARDS_THEN_CURVING_LEFTWARDS = chr(10550)
ARROW_POINTING_DOWNWARDS_THEN_CURVING_RIGHTWARDS = chr(10551)
RIGHT_SIDE_ARC_CLOCKWISE_ARROW = chr(10552)
LEFT_SIDE_ARC_ANTICLOCKWISE_ARROW = chr(10553)
TOP_ARC_ANTICLOCKWISE_ARROW = chr(10554)
BOTTOM_ARC_ANTICLOCKWISE_ARROW = chr(10555)
TOP_ARC_CLOCKWISE_ARROW_WITH_MINUS = chr(10556)
TOP_ARC_ANTICLOCKWISE_ARROW_WITH_PLUS = chr(10557)
LOWER_RIGHT_SEMICIRCULAR_CLOCKWISE_ARROW = chr(10558)
LOWER_LEFT_SEMICIRCULAR_ANTICLOCKWISE_ARROW = chr(10559)
ANTICLOCKWISE_CLOSED_CIRCLE_ARROW = chr(10560)
CLOCKWISE_CLOSED_CIRCLE_ARROW = chr(10561)
RIGHTWARDS_ARROW_ABOVE_SHORT_LEFTWARDS_ARROW = chr(10562)
LEFTWARDS_ARROW_ABOVE_SHORT_RIGHTWARDS_ARROW = chr(10563)
SHORT_RIGHTWARDS_ARROW_ABOVE_LEFTWARDS_ARROW = chr(10564)
RIGHTWARDS_ARROW_WITH_PLUS_BELOW = chr(10565)
LEFTWARDS_ARROW_WITH_PLUS_BELOW = chr(10566)
RIGHTWARDS_ARROW_THROUGH_X = chr(10567)
LEFT_RIGHT_ARROW_THROUGH_SMALL_CIRCLE = chr(10568)
UPWARDS_TWO_HEADED_ARROW_FROM_SMALL_CIRCLE = chr(10569)
LEFT_BARB_UP_RIGHT_BARB_DOWN_HARPOON = chr(10570)
LEFT_BARB_DOWN_RIGHT_BARB_UP_HARPOON = chr(10571)
UP_BARB_RIGHT_DOWN_BARB_LEFT_HARPOON = chr(10572)
UP_BARB_LEFT_DOWN_BARB_RIGHT_HARPOON = chr(10573)
LEFT_BARB_UP_RIGHT_BARB_UP_HARPOON = chr(10574)
UP_BARB_RIGHT_DOWN_BARB_RIGHT_HARPOON = chr(10575)
LEFT_BARB_DOWN_RIGHT_BARB_DOWN_HARPOON = chr(10576)
UP_BARB_LEFT_DOWN_BARB_LEFT_HARPOON = chr(10577)
LEFTWARDS_HARPOON_WITH_BARB_UP_TO_BAR = chr(10578)
RIGHTWARDS_HARPOON_WITH_BARB_UP_TO_BAR = chr(10579)
UPWARDS_HARPOON_WITH_BARB_RIGHT_TO_BAR = chr(10580)
DOWNWARDS_HARPOON_WITH_BARB_RIGHT_TO_BAR = chr(10581)
LEFTWARDS_HARPOON_WITH_BARB_DOWN_TO_BAR = chr(10582)
RIGHTWARDS_HARPOON_WITH_BARB_DOWN_TO_BAR = chr(10583)
UPWARDS_HARPOON_WITH_BARB_LEFT_TO_BAR = chr(10584)
DOWNWARDS_HARPOON_WITH_BARB_LEFT_TO_BAR = chr(10585)
LEFTWARDS_HARPOON_WITH_BARB_UP_FROM_BAR = chr(10586)
RIGHTWARDS_HARPOON_WITH_BARB_UP_FROM_BAR = chr(10587)
UPWARDS_HARPOON_WITH_BARB_RIGHT_FROM_BAR = chr(10588)
DOWNWARDS_HARPOON_WITH_BARB_RIGHT_FROM_BAR = chr(10589)
LEFTWARDS_HARPOON_WITH_BARB_DOWN_FROM_BAR = chr(10590)
RIGHTWARDS_HARPOON_WITH_BARB_DOWN_FROM_BAR = chr(10591)
UPWARDS_HARPOON_WITH_BARB_LEFT_FROM_BAR = chr(10592)
DOWNWARDS_HARPOON_WITH_BARB_LEFT_FROM_BAR = chr(10593)
LEFTWARDS_HARPOON_WITH_BARB_UP_ABOVE_LEFTWARDS_HARPOON_WITH_BARB_DOWN = chr(10594)
UPWARDS_HARPOON_WITH_BARB_LEFT_BESIDE_UPWARDS_HARPOON_WITH_BARB_RIGHT = chr(10595)
RIGHTWARDS_HARPOON_WITH_BARB_UP_ABOVE_RIGHTWARDS_HARPOON_WITH_BARB_DOWN = chr(10596)
DOWNWARDS_HARPOON_WITH_BARB_LEFT_BESIDE_DOWNWARDS_HARPOON_WITH_BARB_RIGHT = chr(10597)
LEFTWARDS_HARPOON_WITH_BARB_UP_ABOVE_RIGHTWARDS_HARPOON_WITH_BARB_UP = chr(10598)
LEFTWARDS_HARPOON_WITH_BARB_DOWN_ABOVE_RIGHTWARDS_HARPOON_WITH_BARB_DOWN = chr(10599)
RIGHTWARDS_HARPOON_WITH_BARB_UP_ABOVE_LEFTWARDS_HARPOON_WITH_BARB_UP = chr(10600)
RIGHTWARDS_HARPOON_WITH_BARB_DOWN_ABOVE_LEFTWARDS_HARPOON_WITH_BARB_DOWN = chr(10601)
LEFTWARDS_HARPOON_WITH_BARB_UP_ABOVE_LONG_DASH = chr(10602)
LEFTWARDS_HARPOON_WITH_BARB_DOWN_BELOW_LONG_DASH = chr(10603)
RIGHTWARDS_HARPOON_WITH_BARB_UP_ABOVE_LONG_DASH = chr(10604)
RIGHTWARDS_HARPOON_WITH_BARB_DOWN_BELOW_LONG_DASH = chr(10605)
UPWARDS_HARPOON_WITH_BARB_LEFT_BESIDE_DOWNWARDS_HARPOON_WITH_BARB_RIGHT = chr(10606)
DOWNWARDS_HARPOON_WITH_BARB_LEFT_BESIDE_UPWARDS_HARPOON_WITH_BARB_RIGHT = chr(10607)
RIGHT_DOUBLE_ARROW_WITH_ROUNDED_HEAD = chr(10608)
EQUALS_SIGN_ABOVE_RIGHTWARDS_ARROW = chr(10609)
TILDE_OPERATOR_ABOVE_RIGHTWARDS_ARROW = chr(10610)
LEFTWARDS_ARROW_ABOVE_TILDE_OPERATOR = chr(10611)
RIGHTWARDS_ARROW_ABOVE_TILDE_OPERATOR = chr(10612)
RIGHTWARDS_ARROW_ABOVE_ALMOST_EQUAL_TO = chr(10613)
LESS_THAN_ABOVE_LEFTWARDS_ARROW = chr(10614)
LEFTWARDS_ARROW_THROUGH_LESS_THAN = chr(10615)
GREATER_THAN_ABOVE_RIGHTWARDS_ARROW = chr(10616)
SUBSET_ABOVE_RIGHTWARDS_ARROW = chr(10617)
LEFTWARDS_ARROW_THROUGH_SUBSET = chr(10618)
SUPERSET_ABOVE_LEFTWARDS_ARROW = chr(10619)
LEFT_FISH_TAIL = chr(10620)
RIGHT_FISH_TAIL = chr(10621)
UP_FISH_TAIL = chr(10622)
DOWN_FISH_TAIL = chr(10623)
TRIPLE_VERTICAL_BAR_DELIMITER = chr(10624)
Z_NOTATION_SPOT = chr(10625)
Z_NOTATION_TYPE_COLON = chr(10626)
LEFT_WHITE_CURLY_BRACKET = chr(10627)
RIGHT_WHITE_CURLY_BRACKET = chr(10628)
LEFT_WHITE_PARENTHESIS = chr(10629)
RIGHT_WHITE_PARENTHESIS = chr(10630)
Z_NOTATION_LEFT_IMAGE_BRACKET = chr(10631)
Z_NOTATION_RIGHT_IMAGE_BRACKET = chr(10632)
Z_NOTATION_LEFT_BINDING_BRACKET = chr(10633)
Z_NOTATION_RIGHT_BINDING_BRACKET = chr(10634)
LEFT_SQUARE_BRACKET_WITH_UNDERBAR = chr(10635)
RIGHT_SQUARE_BRACKET_WITH_UNDERBAR = chr(10636)
LEFT_SQUARE_BRACKET_WITH_TICK_IN_TOP_CORNER = chr(10637)
RIGHT_SQUARE_BRACKET_WITH_TICK_IN_BOTTOM_CORNER = chr(10638)
LEFT_SQUARE_BRACKET_WITH_TICK_IN_BOTTOM_CORNER = chr(10639)
RIGHT_SQUARE_BRACKET_WITH_TICK_IN_TOP_CORNER = chr(10640)
LEFT_ANGLE_BRACKET_WITH_DOT = chr(10641)
RIGHT_ANGLE_BRACKET_WITH_DOT = chr(10642)
LEFT_ARC_LESS_THAN_BRACKET = chr(10643)
RIGHT_ARC_GREATER_THAN_BRACKET = chr(10644)
DOUBLE_LEFT_ARC_GREATER_THAN_BRACKET = chr(10645)
DOUBLE_RIGHT_ARC_LESS_THAN_BRACKET = chr(10646)
LEFT_BLACK_TORTOISE_SHELL_BRACKET = chr(10647)
RIGHT_BLACK_TORTOISE_SHELL_BRACKET = chr(10648)
DOTTED_FENCE = chr(10649)
VERTICAL_ZIGZAG_LINE = chr(10650)
MEASURED_ANGLE_OPENING_LEFT = chr(10651)
RIGHT_ANGLE_VARIANT_WITH_SQUARE = chr(10652)
MEASURED_RIGHT_ANGLE_WITH_DOT = chr(10653)
ANGLE_WITH_S_INSIDE = chr(10654)
ACUTE_ANGLE = chr(10655)
SPHERICAL_ANGLE_OPENING_LEFT = chr(10656)
SPHERICAL_ANGLE_OPENING_UP = chr(10657)
TURNED_ANGLE = chr(10658)
REVERSED_ANGLE = chr(10659)
ANGLE_WITH_UNDERBAR = chr(10660)
REVERSED_ANGLE_WITH_UNDERBAR = chr(10661)
OBLIQUE_ANGLE_OPENING_UP = chr(10662)
OBLIQUE_ANGLE_OPENING_DOWN = chr(10663)
MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_UP_AND_RIGHT = chr(10664)
MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_UP_AND_LEFT = chr(10665)
MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_DOWN_AND_RIGHT = chr(10666)
MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_DOWN_AND_LEFT = chr(10667)
MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_RIGHT_AND_UP = chr(10668)
MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_LEFT_AND_UP = chr(10669)
MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_RIGHT_AND_DOWN = chr(10670)
MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_LEFT_AND_DOWN = chr(10671)
REVERSED_EMPTY_SET = chr(10672)
EMPTY_SET_WITH_OVERBAR = chr(10673)
EMPTY_SET_WITH_SMALL_CIRCLE_ABOVE = chr(10674)
EMPTY_SET_WITH_RIGHT_ARROW_ABOVE = chr(10675)
EMPTY_SET_WITH_LEFT_ARROW_ABOVE = chr(10676)
CIRCLE_WITH_HORIZONTAL_BAR = chr(10677)
CIRCLED_VERTICAL_BAR = chr(10678)
CIRCLED_PARALLEL = chr(10679)
CIRCLED_REVERSE_SOLIDUS = chr(10680)
CIRCLED_PERPENDICULAR = chr(10681)
CIRCLE_DIVIDED_BY_HORIZONTAL_BAR_AND_TOP_HALF_DIVIDED_BY_VERTICAL_BAR = chr(10682)
CIRCLE_WITH_SUPERIMPOSED_X = chr(10683)
CIRCLED_ANTICLOCKWISE_ROTATED_DIVISION_SIGN = chr(10684)
UP_ARROW_THROUGH_CIRCLE = chr(10685)
CIRCLED_WHITE_BULLET = chr(10686)
CIRCLED_BULLET = chr(10687)
CIRCLED_LESS_THAN = chr(10688)
CIRCLED_GREATER_THAN = chr(10689)
CIRCLE_WITH_SMALL_CIRCLE_TO_THE_RIGHT = chr(10690)
CIRCLE_WITH_TWO_HORIZONTAL_STROKES_TO_THE_RIGHT = chr(10691)
SQUARED_RISING_DIAGONAL_SLASH = chr(10692)
SQUARED_FALLING_DIAGONAL_SLASH = chr(10693)
SQUARED_ASTERISK = chr(10694)
SQUARED_SMALL_CIRCLE = chr(10695)
SQUARED_SQUARE = chr(10696)
TWO_JOINED_SQUARES = chr(10697)
TRIANGLE_WITH_DOT_ABOVE = chr(10698)
TRIANGLE_WITH_UNDERBAR = chr(10699)
S_IN_TRIANGLE = chr(10700)
TRIANGLE_WITH_SERIFS_AT_BOTTOM = chr(10701)
RIGHT_TRIANGLE_ABOVE_LEFT_TRIANGLE = chr(10702)
LEFT_TRIANGLE_BESIDE_VERTICAL_BAR = chr(10703)
VERTICAL_BAR_BESIDE_RIGHT_TRIANGLE = chr(10704)
BOWTIE_WITH_LEFT_HALF_BLACK = chr(10705)
BOWTIE_WITH_RIGHT_HALF_BLACK = chr(10706)
BLACK_BOWTIE = chr(10707)
TIMES_WITH_LEFT_HALF_BLACK = chr(10708)
TIMES_WITH_RIGHT_HALF_BLACK = chr(10709)
WHITE_HOURGLASS = chr(10710)
BLACK_HOURGLASS = chr(10711)
LEFT_WIGGLY_FENCE = chr(10712)
RIGHT_WIGGLY_FENCE = chr(10713)
LEFT_DOUBLE_WIGGLY_FENCE = chr(10714)
RIGHT_DOUBLE_WIGGLY_FENCE = chr(10715)
INCOMPLETE_INFINITY = chr(10716)
TIE_OVER_INFINITY = chr(10717)
INFINITY_NEGATED_WITH_VERTICAL_BAR = chr(10718)
DOUBLE_ENDED_MULTIMAP = chr(10719)
SQUARE_WITH_CONTOURED_OUTLINE = chr(10720)
INCREASES_AS = chr(10721)
SHUFFLE_PRODUCT = chr(10722)
EQUALS_SIGN_AND_SLANTED_PARALLEL = chr(10723)
EQUALS_SIGN_AND_SLANTED_PARALLEL_WITH_TILDE_ABOVE = chr(10724)
IDENTICAL_TO_AND_SLANTED_PARALLEL = chr(10725)
GLEICH_STARK = chr(10726)
THERMODYNAMIC = chr(10727)
DOWN_POINTING_TRIANGLE_WITH_LEFT_HALF_BLACK = chr(10728)
DOWN_POINTING_TRIANGLE_WITH_RIGHT_HALF_BLACK = chr(10729)
BLACK_DIAMOND_WITH_DOWN_ARROW = chr(10730)
BLACK_LOZENGE = chr(10731)
WHITE_CIRCLE_WITH_DOWN_ARROW = chr(10732)
BLACK_CIRCLE_WITH_DOWN_ARROW = chr(10733)
ERROR_BARRED_WHITE_SQUARE = chr(10734)
ERROR_BARRED_BLACK_SQUARE = chr(10735)
ERROR_BARRED_WHITE_DIAMOND = chr(10736)
ERROR_BARRED_BLACK_DIAMOND = chr(10737)
ERROR_BARRED_WHITE_CIRCLE = chr(10738)
ERROR_BARRED_BLACK_CIRCLE = chr(10739)
RULE_DELAYED = chr(10740)
REVERSE_SOLIDUS_OPERATOR = chr(10741)
SOLIDUS_WITH_OVERBAR = chr(10742)
REVERSE_SOLIDUS_WITH_HORIZONTAL_STROKE = chr(10743)
BIG_SOLIDUS = chr(10744)
BIG_REVERSE_SOLIDUS = chr(10745)
DOUBLE_PLUS = chr(10746)
TRIPLE_PLUS = chr(10747)
LEFT_POINTING_CURVED_ANGLE_BRACKET = chr(10748)
RIGHT_POINTING_CURVED_ANGLE_BRACKET = chr(10749)
TINY = chr(10750)
MINY = chr(10751)
N_ARY_CIRCLED_DOT_OPERATOR = chr(10752)
N_ARY_CIRCLED_PLUS_OPERATOR = chr(10753)
N_ARY_CIRCLED_TIMES_OPERATOR = chr(10754)
N_ARY_UNION_OPERATOR_WITH_DOT = chr(10755)
N_ARY_UNION_OPERATOR_WITH_PLUS = chr(10756)
N_ARY_SQUARE_INTERSECTION_OPERATOR = chr(10757)
N_ARY_SQUARE_UNION_OPERATOR = chr(10758)
TWO_LOGICAL_AND_OPERATOR = chr(10759)
TWO_LOGICAL_OR_OPERATOR = chr(10760)
N_ARY_TIMES_OPERATOR = chr(10761)
MODULO_TWO_SUM = chr(10762)
SUMMATION_WITH_INTEGRAL = chr(10763)
QUADRUPLE_INTEGRAL_OPERATOR = chr(10764)
FINITE_PART_INTEGRAL = chr(10765)
INTEGRAL_WITH_DOUBLE_STROKE = chr(10766)
INTEGRAL_AVERAGE_WITH_SLASH = chr(10767)
CIRCULATION_FUNCTION = chr(10768)
ANTICLOCKWISE_INTEGRATION = chr(10769)
LINE_INTEGRATION_WITH_RECTANGULAR_PATH_AROUND_POLE = chr(10770)
LINE_INTEGRATION_WITH_SEMICIRCULAR_PATH_AROUND_POLE = chr(10771)
LINE_INTEGRATION_NOT_INCLUDING_THE_POLE = chr(10772)
INTEGRAL_AROUND_A_POINT_OPERATOR = chr(10773)
QUATERNION_INTEGRAL_OPERATOR = chr(10774)
INTEGRAL_WITH_LEFTWARDS_ARROW_WITH_HOOK = chr(10775)
INTEGRAL_WITH_TIMES_SIGN = chr(10776)
INTEGRAL_WITH_INTERSECTION = chr(10777)
INTEGRAL_WITH_UNION = chr(10778)
INTEGRAL_WITH_OVERBAR = chr(10779)
INTEGRAL_WITH_UNDERBAR = chr(10780)
JOIN = chr(10781)
LARGE_LEFT_TRIANGLE_OPERATOR = chr(10782)
Z_NOTATION_SCHEMA_COMPOSITION = chr(10783)
Z_NOTATION_SCHEMA_PIPING = chr(10784)
Z_NOTATION_SCHEMA_PROJECTION = chr(10785)
PLUS_SIGN_WITH_SMALL_CIRCLE_ABOVE = chr(10786)
PLUS_SIGN_WITH_CIRCUMFLEX_ACCENT_ABOVE = chr(10787)
PLUS_SIGN_WITH_TILDE_ABOVE = chr(10788)
PLUS_SIGN_WITH_DOT_BELOW = chr(10789)
PLUS_SIGN_WITH_TILDE_BELOW = chr(10790)
PLUS_SIGN_WITH_SUBSCRIPT_TWO = chr(10791)
PLUS_SIGN_WITH_BLACK_TRIANGLE = chr(10792)
MINUS_SIGN_WITH_COMMA_ABOVE = chr(10793)
MINUS_SIGN_WITH_DOT_BELOW = chr(10794)
MINUS_SIGN_WITH_FALLING_DOTS = chr(10795)
MINUS_SIGN_WITH_RISING_DOTS = chr(10796)
PLUS_SIGN_IN_LEFT_HALF_CIRCLE = chr(10797)
PLUS_SIGN_IN_RIGHT_HALF_CIRCLE = chr(10798)
VECTOR_OR_CROSS_PRODUCT = chr(10799)
MULTIPLICATION_SIGN_WITH_DOT_ABOVE = chr(10800)
MULTIPLICATION_SIGN_WITH_UNDERBAR = chr(10801)
SEMIDIRECT_PRODUCT_WITH_BOTTOM_CLOSED = chr(10802)
SMASH_PRODUCT = chr(10803)
MULTIPLICATION_SIGN_IN_LEFT_HALF_CIRCLE = chr(10804)
MULTIPLICATION_SIGN_IN_RIGHT_HALF_CIRCLE = chr(10805)
CIRCLED_MULTIPLICATION_SIGN_WITH_CIRCUMFLEX_ACCENT = chr(10806)
MULTIPLICATION_SIGN_IN_DOUBLE_CIRCLE = chr(10807)
CIRCLED_DIVISION_SIGN = chr(10808)
PLUS_SIGN_IN_TRIANGLE = chr(10809)
MINUS_SIGN_IN_TRIANGLE = chr(10810)
MULTIPLICATION_SIGN_IN_TRIANGLE = chr(10811)
INTERIOR_PRODUCT = chr(10812)
RIGHTHAND_INTERIOR_PRODUCT = chr(10813)
Z_NOTATION_RELATIONAL_COMPOSITION = chr(10814)
AMALGAMATION_OR_COPRODUCT = chr(10815)
INTERSECTION_WITH_DOT = chr(10816)
UNION_WITH_MINUS_SIGN = chr(10817)
UNION_WITH_OVERBAR = chr(10818)
INTERSECTION_WITH_OVERBAR = chr(10819)
INTERSECTION_WITH_LOGICAL_AND = chr(10820)
UNION_WITH_LOGICAL_OR = chr(10821)
UNION_ABOVE_INTERSECTION = chr(10822)
INTERSECTION_ABOVE_UNION = chr(10823)
UNION_ABOVE_BAR_ABOVE_INTERSECTION = chr(10824)
INTERSECTION_ABOVE_BAR_ABOVE_UNION = chr(10825)
UNION_BESIDE_AND_JOINED_WITH_UNION = chr(10826)
INTERSECTION_BESIDE_AND_JOINED_WITH_INTERSECTION = chr(10827)
CLOSED_UNION_WITH_SERIFS = chr(10828)
CLOSED_INTERSECTION_WITH_SERIFS = chr(10829)
DOUBLE_SQUARE_INTERSECTION = chr(10830)
DOUBLE_SQUARE_UNION = chr(10831)
CLOSED_UNION_WITH_SERIFS_AND_SMASH_PRODUCT = chr(10832)
LOGICAL_AND_WITH_DOT_ABOVE = chr(10833)
LOGICAL_OR_WITH_DOT_ABOVE = chr(10834)
DOUBLE_LOGICAL_AND = chr(10835)
DOUBLE_LOGICAL_OR = chr(10836)
TWO_INTERSECTING_LOGICAL_AND = chr(10837)
TWO_INTERSECTING_LOGICAL_OR = chr(10838)
SLOPING_LARGE_OR = chr(10839)
SLOPING_LARGE_AND = chr(10840)
LOGICAL_OR_OVERLAPPING_LOGICAL_AND = chr(10841)
LOGICAL_AND_WITH_MIDDLE_STEM = chr(10842)
LOGICAL_OR_WITH_MIDDLE_STEM = chr(10843)
LOGICAL_AND_WITH_HORIZONTAL_DASH = chr(10844)
LOGICAL_OR_WITH_HORIZONTAL_DASH = chr(10845)
LOGICAL_AND_WITH_DOUBLE_OVERBAR = chr(10846)
LOGICAL_AND_WITH_UNDERBAR = chr(10847)
LOGICAL_AND_WITH_DOUBLE_UNDERBAR = chr(10848)
SMALL_VEE_WITH_UNDERBAR = chr(10849)
LOGICAL_OR_WITH_DOUBLE_OVERBAR = chr(10850)
LOGICAL_OR_WITH_DOUBLE_UNDERBAR = chr(10851)
Z_NOTATION_DOMAIN_ANTIRESTRICTION = chr(10852)
Z_NOTATION_RANGE_ANTIRESTRICTION = chr(10853)
EQUALS_SIGN_WITH_DOT_BELOW = chr(10854)
IDENTICAL_WITH_DOT_ABOVE = chr(10855)
TRIPLE_HORIZONTAL_BAR_WITH_DOUBLE_VERTICAL_STROKE = chr(10856)
TRIPLE_HORIZONTAL_BAR_WITH_TRIPLE_VERTICAL_STROKE = chr(10857)
TILDE_OPERATOR_WITH_DOT_ABOVE = chr(10858)
TILDE_OPERATOR_WITH_RISING_DOTS = chr(10859)
SIMILAR_MINUS_SIMILAR = chr(10860)
CONGRUENT_WITH_DOT_ABOVE = chr(10861)
EQUALS_WITH_ASTERISK = chr(10862)
ALMOST_EQUAL_TO_WITH_CIRCUMFLEX_ACCENT = chr(10863)
APPROXIMATELY_EQUAL_OR_EQUAL_TO = chr(10864)
EQUALS_SIGN_ABOVE_PLUS_SIGN = chr(10865)
PLUS_SIGN_ABOVE_EQUALS_SIGN = chr(10866)
EQUALS_SIGN_ABOVE_TILDE_OPERATOR = chr(10867)
DOUBLE_COLON_EQUAL = chr(10868)
TWO_CONSECUTIVE_EQUALS_SIGNS = chr(10869)
THREE_CONSECUTIVE_EQUALS_SIGNS = chr(10870)
EQUALS_SIGN_WITH_TWO_DOTS_ABOVE_AND_TWO_DOTS_BELOW = chr(10871)
EQUIVALENT_WITH_FOUR_DOTS_ABOVE = chr(10872)
LESS_THAN_WITH_CIRCLE_INSIDE = chr(10873)
GREATER_THAN_WITH_CIRCLE_INSIDE = chr(10874)
LESS_THAN_WITH_QUESTION_MARK_ABOVE = chr(10875)
GREATER_THAN_WITH_QUESTION_MARK_ABOVE = chr(10876)
LESS_THAN_OR_SLANTED_EQUAL_TO = chr(10877)
GREATER_THAN_OR_SLANTED_EQUAL_TO = chr(10878)
LESS_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_INSIDE = chr(10879)
GREATER_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_INSIDE = chr(10880)
LESS_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_ABOVE = chr(10881)
GREATER_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_ABOVE = chr(10882)
LESS_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_ABOVE_RIGHT = chr(10883)
GREATER_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_ABOVE_LEFT = chr(10884)
LESS_THAN_OR_APPROXIMATE = chr(10885)
GREATER_THAN_OR_APPROXIMATE = chr(10886)
LESS_THAN_AND_SINGLE_LINE_NOT_EQUAL_TO = chr(10887)
GREATER_THAN_AND_SINGLE_LINE_NOT_EQUAL_TO = chr(10888)
LESS_THAN_AND_NOT_APPROXIMATE = chr(10889)
GREATER_THAN_AND_NOT_APPROXIMATE = chr(10890)
LESS_THAN_ABOVE_DOUBLE_LINE_EQUAL_ABOVE_GREATER_THAN = chr(10891)
GREATER_THAN_ABOVE_DOUBLE_LINE_EQUAL_ABOVE_LESS_THAN = chr(10892)
LESS_THAN_ABOVE_SIMILAR_OR_EQUAL = chr(10893)
GREATER_THAN_ABOVE_SIMILAR_OR_EQUAL = chr(10894)
LESS_THAN_ABOVE_SIMILAR_ABOVE_GREATER_THAN = chr(10895)
GREATER_THAN_ABOVE_SIMILAR_ABOVE_LESS_THAN = chr(10896)
LESS_THAN_ABOVE_GREATER_THAN_ABOVE_DOUBLE_LINE_EQUAL = chr(10897)
GREATER_THAN_ABOVE_LESS_THAN_ABOVE_DOUBLE_LINE_EQUAL = chr(10898)
LESS_THAN_ABOVE_SLANTED_EQUAL_ABOVE_GREATER_THAN_ABOVE_SLANTED_EQUAL = chr(10899)
GREATER_THAN_ABOVE_SLANTED_EQUAL_ABOVE_LESS_THAN_ABOVE_SLANTED_EQUAL = chr(10900)
SLANTED_EQUAL_TO_OR_LESS_THAN = chr(10901)
SLANTED_EQUAL_TO_OR_GREATER_THAN = chr(10902)
SLANTED_EQUAL_TO_OR_LESS_THAN_WITH_DOT_INSIDE = chr(10903)
SLANTED_EQUAL_TO_OR_GREATER_THAN_WITH_DOT_INSIDE = chr(10904)
DOUBLE_LINE_EQUAL_TO_OR_LESS_THAN = chr(10905)
DOUBLE_LINE_EQUAL_TO_OR_GREATER_THAN = chr(10906)
DOUBLE_LINE_SLANTED_EQUAL_TO_OR_LESS_THAN = chr(10907)
DOUBLE_LINE_SLANTED_EQUAL_TO_OR_GREATER_THAN = chr(10908)
SIMILAR_OR_LESS_THAN = chr(10909)
SIMILAR_OR_GREATER_THAN = chr(10910)
SIMILAR_ABOVE_LESS_THAN_ABOVE_EQUALS_SIGN = chr(10911)
SIMILAR_ABOVE_GREATER_THAN_ABOVE_EQUALS_SIGN = chr(10912)
DOUBLE_NESTED_LESS_THAN = chr(10913)
DOUBLE_NESTED_GREATER_THAN = chr(10914)
DOUBLE_NESTED_LESS_THAN_WITH_UNDERBAR = chr(10915)
GREATER_THAN_OVERLAPPING_LESS_THAN = chr(10916)
GREATER_THAN_BESIDE_LESS_THAN = chr(10917)
LESS_THAN_CLOSED_BY_CURVE = chr(10918)
GREATER_THAN_CLOSED_BY_CURVE = chr(10919)
LESS_THAN_CLOSED_BY_CURVE_ABOVE_SLANTED_EQUAL = chr(10920)
GREATER_THAN_CLOSED_BY_CURVE_ABOVE_SLANTED_EQUAL = chr(10921)
SMALLER_THAN = chr(10922)
LARGER_THAN = chr(10923)
SMALLER_THAN_OR_EQUAL_TO = chr(10924)
LARGER_THAN_OR_EQUAL_TO = chr(10925)
EQUALS_SIGN_WITH_BUMPY_ABOVE = chr(10926)
PRECEDES_ABOVE_SINGLE_LINE_EQUALS_SIGN = chr(10927)
SUCCEEDS_ABOVE_SINGLE_LINE_EQUALS_SIGN = chr(10928)
PRECEDES_ABOVE_SINGLE_LINE_NOT_EQUAL_TO = chr(10929)
SUCCEEDS_ABOVE_SINGLE_LINE_NOT_EQUAL_TO = chr(10930)
PRECEDES_ABOVE_EQUALS_SIGN = chr(10931)
SUCCEEDS_ABOVE_EQUALS_SIGN = chr(10932)
PRECEDES_ABOVE_NOT_EQUAL_TO = chr(10933)
SUCCEEDS_ABOVE_NOT_EQUAL_TO = chr(10934)
PRECEDES_ABOVE_ALMOST_EQUAL_TO = chr(10935)
SUCCEEDS_ABOVE_ALMOST_EQUAL_TO = chr(10936)
PRECEDES_ABOVE_NOT_ALMOST_EQUAL_TO = chr(10937)
SUCCEEDS_ABOVE_NOT_ALMOST_EQUAL_TO = chr(10938)
DOUBLE_PRECEDES = chr(10939)
DOUBLE_SUCCEEDS = chr(10940)
SUBSET_WITH_DOT = chr(10941)
SUPERSET_WITH_DOT = chr(10942)
SUBSET_WITH_PLUS_SIGN_BELOW = chr(10943)
SUPERSET_WITH_PLUS_SIGN_BELOW = chr(10944)
SUBSET_WITH_MULTIPLICATION_SIGN_BELOW = chr(10945)
SUPERSET_WITH_MULTIPLICATION_SIGN_BELOW = chr(10946)
SUBSET_OF_OR_EQUAL_TO_WITH_DOT_ABOVE = chr(10947)
SUPERSET_OF_OR_EQUAL_TO_WITH_DOT_ABOVE = chr(10948)
SUBSET_OF_ABOVE_EQUALS_SIGN = chr(10949)
SUPERSET_OF_ABOVE_EQUALS_SIGN = chr(10950)
SUBSET_OF_ABOVE_TILDE_OPERATOR = chr(10951)
SUPERSET_OF_ABOVE_TILDE_OPERATOR = chr(10952)
SUBSET_OF_ABOVE_ALMOST_EQUAL_TO = chr(10953)
SUPERSET_OF_ABOVE_ALMOST_EQUAL_TO = chr(10954)
SUBSET_OF_ABOVE_NOT_EQUAL_TO = chr(10955)
SUPERSET_OF_ABOVE_NOT_EQUAL_TO = chr(10956)
SQUARE_LEFT_OPEN_BOX_OPERATOR = chr(10957)
SQUARE_RIGHT_OPEN_BOX_OPERATOR = chr(10958)
CLOSED_SUBSET = chr(10959)
CLOSED_SUPERSET = chr(10960)
CLOSED_SUBSET_OR_EQUAL_TO = chr(10961)
CLOSED_SUPERSET_OR_EQUAL_TO = chr(10962)
SUBSET_ABOVE_SUPERSET = chr(10963)
SUPERSET_ABOVE_SUBSET = chr(10964)
SUBSET_ABOVE_SUBSET = chr(10965)
SUPERSET_ABOVE_SUPERSET = chr(10966)
SUPERSET_BESIDE_SUBSET = chr(10967)
SUPERSET_BESIDE_AND_JOINED_BY_DASH_WITH_SUBSET = chr(10968)
ELEMENT_OF_OPENING_DOWNWARDS = chr(10969)
PITCHFORK_WITH_TEE_TOP = chr(10970)
TRANSVERSAL_INTERSECTION = chr(10971)
FORKING = chr(10972)
NONFORKING = chr(10973)
SHORT_LEFT_TACK = chr(10974)
SHORT_DOWN_TACK = chr(10975)
SHORT_UP_TACK = chr(10976)
PERPENDICULAR_WITH_S = chr(10977)
VERTICAL_BAR_TRIPLE_RIGHT_TURNSTILE = chr(10978)
DOUBLE_VERTICAL_BAR_LEFT_TURNSTILE = chr(10979)
VERTICAL_BAR_DOUBLE_LEFT_TURNSTILE = chr(10980)
DOUBLE_VERTICAL_BAR_DOUBLE_LEFT_TURNSTILE = chr(10981)
LONG_DASH_FROM_LEFT_MEMBER_OF_DOUBLE_VERTICAL = chr(10982)
SHORT_DOWN_TACK_WITH_OVERBAR = chr(10983)
SHORT_UP_TACK_WITH_UNDERBAR = chr(10984)
SHORT_UP_TACK_ABOVE_SHORT_DOWN_TACK = chr(10985)
DOUBLE_DOWN_TACK = chr(10986)
DOUBLE_UP_TACK = chr(10987)
DOUBLE_STROKE_NOT_SIGN = chr(10988)
REVERSED_DOUBLE_STROKE_NOT_SIGN = chr(10989)
DOES_NOT_DIVIDE_WITH_REVERSED_NEGATION_SLASH = chr(10990)
VERTICAL_LINE_WITH_CIRCLE_ABOVE = chr(10991)
VERTICAL_LINE_WITH_CIRCLE_BELOW = chr(10992)
DOWN_TACK_WITH_CIRCLE_BELOW = chr(10993)
PARALLEL_WITH_HORIZONTAL_STROKE = chr(10994)
PARALLEL_WITH_TILDE_OPERATOR = chr(10995)
TRIPLE_VERTICAL_BAR_BINARY_RELATION = chr(10996)
TRIPLE_VERTICAL_BAR_WITH_HORIZONTAL_STROKE = chr(10997)
TRIPLE_COLON_OPERATOR = chr(10998)
TRIPLE_NESTED_LESS_THAN = chr(10999)
TRIPLE_NESTED_GREATER_THAN = chr(11000)
DOUBLE_LINE_SLANTED_LESS_THAN_OR_EQUAL_TO = chr(11001)
DOUBLE_LINE_SLANTED_GREATER_THAN_OR_EQUAL_TO = chr(11002)
TRIPLE_SOLIDUS_BINARY_RELATION = chr(11003)
LARGE_TRIPLE_VERTICAL_BAR_OPERATOR = chr(11004)
DOUBLE_SOLIDUS_OPERATOR = chr(11005)
WHITE_VERTICAL_BAR = chr(11006)
N_ARY_WHITE_VERTICAL_BAR = chr(11007)
NORTH_EAST_WHITE_ARROW = chr(11008)
NORTH_WEST_WHITE_ARROW = chr(11009)
SOUTH_EAST_WHITE_ARROW = chr(11010)
SOUTH_WEST_WHITE_ARROW = chr(11011)
LEFT_RIGHT_WHITE_ARROW = chr(11012)
LEFTWARDS_BLACK_ARROW = chr(11013)
UPWARDS_BLACK_ARROW = chr(11014)
DOWNWARDS_BLACK_ARROW = chr(11015)
NORTH_EAST_BLACK_ARROW = chr(11016)
NORTH_WEST_BLACK_ARROW = chr(11017)
SOUTH_EAST_BLACK_ARROW = chr(11018)
SOUTH_WEST_BLACK_ARROW = chr(11019)
LEFT_RIGHT_BLACK_ARROW = chr(11020)
UP_DOWN_BLACK_ARROW = chr(11021)
RIGHTWARDS_ARROW_WITH_TIP_DOWNWARDS = chr(11022)
RIGHTWARDS_ARROW_WITH_TIP_UPWARDS = chr(11023)
LEFTWARDS_ARROW_WITH_TIP_DOWNWARDS = chr(11024)
LEFTWARDS_ARROW_WITH_TIP_UPWARDS = chr(11025)
SQUARE_WITH_TOP_HALF_BLACK = chr(11026)
SQUARE_WITH_BOTTOM_HALF_BLACK = chr(11027)
SQUARE_WITH_UPPER_RIGHT_DIAGONAL_HALF_BLACK = chr(11028)
SQUARE_WITH_LOWER_LEFT_DIAGONAL_HALF_BLACK = chr(11029)
DIAMOND_WITH_LEFT_HALF_BLACK = chr(11030)
DIAMOND_WITH_RIGHT_HALF_BLACK = chr(11031)
DIAMOND_WITH_TOP_HALF_BLACK = chr(11032)
DIAMOND_WITH_BOTTOM_HALF_BLACK = chr(11033)
DOTTED_SQUARE = chr(11034)
BLACK_LARGE_SQUARE = chr(11035)
WHITE_LARGE_SQUARE = chr(11036)
BLACK_VERY_SMALL_SQUARE = chr(11037)
WHITE_VERY_SMALL_SQUARE = chr(11038)
BLACK_PENTAGON = chr(11039)
WHITE_PENTAGON = chr(11040)
WHITE_HEXAGON = chr(11041)
BLACK_HEXAGON = chr(11042)
HORIZONTAL_BLACK_HEXAGON = chr(11043)
BLACK_LARGE_CIRCLE = chr(11044)
BLACK_MEDIUM_DIAMOND = chr(11045)
WHITE_MEDIUM_DIAMOND = chr(11046)
BLACK_MEDIUM_LOZENGE = chr(11047)
WHITE_MEDIUM_LOZENGE = chr(11048)
BLACK_SMALL_DIAMOND = chr(11049)
BLACK_SMALL_LOZENGE = chr(11050)
WHITE_SMALL_LOZENGE = chr(11051)
BLACK_HORIZONTAL_ELLIPSE = chr(11052)
WHITE_HORIZONTAL_ELLIPSE = chr(11053)
BLACK_VERTICAL_ELLIPSE = chr(11054)
WHITE_VERTICAL_ELLIPSE = chr(11055)
LEFT_ARROW_WITH_SMALL_CIRCLE = chr(11056)
THREE_LEFTWARDS_ARROWS = chr(11057)
LEFT_ARROW_WITH_CIRCLED_PLUS = chr(11058)
LONG_LEFTWARDS_SQUIGGLE_ARROW = chr(11059)
LEFTWARDS_TWO_HEADED_ARROW_WITH_VERTICAL_STROKE = chr(11060)
LEFTWARDS_TWO_HEADED_ARROW_WITH_DOUBLE_VERTICAL_STROKE = chr(11061)
LEFTWARDS_TWO_HEADED_ARROW_FROM_BAR = chr(11062)
LEFTWARDS_TWO_HEADED_TRIPLE_DASH_ARROW = chr(11063)
LEFTWARDS_ARROW_WITH_DOTTED_STEM = chr(11064)
LEFTWARDS_ARROW_WITH_TAIL_WITH_VERTICAL_STROKE = chr(11065)
LEFTWARDS_ARROW_WITH_TAIL_WITH_DOUBLE_VERTICAL_STROKE = chr(11066)
LEFTWARDS_TWO_HEADED_ARROW_WITH_TAIL = chr(11067)
LEFTWARDS_TWO_HEADED_ARROW_WITH_TAIL_WITH_VERTICAL_STROKE = chr(11068)
LEFTWARDS_TWO_HEADED_ARROW_WITH_TAIL_WITH_DOUBLE_VERTICAL_STROKE = chr(11069)
LEFTWARDS_ARROW_THROUGH_X = chr(11070)
WAVE_ARROW_POINTING_DIRECTLY_LEFT = chr(11071)
EQUALS_SIGN_ABOVE_LEFTWARDS_ARROW = chr(11072)
REVERSE_TILDE_OPERATOR_ABOVE_LEFTWARDS_ARROW = chr(11073)
LEFTWARDS_ARROW_ABOVE_REVERSE_ALMOST_EQUAL_TO = chr(11074)
RIGHTWARDS_ARROW_THROUGH_GREATER_THAN = chr(11075)
RIGHTWARDS_ARROW_THROUGH_SUPERSET = chr(11076)
LEFTWARDS_QUADRUPLE_ARROW = chr(11077)
RIGHTWARDS_QUADRUPLE_ARROW = chr(11078)
REVERSE_TILDE_OPERATOR_ABOVE_RIGHTWARDS_ARROW = chr(11079)
RIGHTWARDS_ARROW_ABOVE_REVERSE_ALMOST_EQUAL_TO = chr(11080)
TILDE_OPERATOR_ABOVE_LEFTWARDS_ARROW = chr(11081)
LEFTWARDS_ARROW_ABOVE_ALMOST_EQUAL_TO = chr(11082)
LEFTWARDS_ARROW_ABOVE_REVERSE_TILDE_OPERATOR = chr(11083)
RIGHTWARDS_ARROW_ABOVE_REVERSE_TILDE_OPERATOR = chr(11084)
DOWNWARDS_TRIANGLE_HEADED_ZIGZAG_ARROW = chr(11085)
SHORT_SLANTED_NORTH_ARROW = chr(11086)
SHORT_BACKSLANTED_SOUTH_ARROW = chr(11087)
WHITE_MEDIUM_STAR = chr(11088)
BLACK_SMALL_STAR = chr(11089)
WHITE_SMALL_STAR = chr(11090)
BLACK_RIGHT_POINTING_PENTAGON = chr(11091)
WHITE_RIGHT_POINTING_PENTAGON = chr(11092)
HEAVY_LARGE_CIRCLE = chr(11093)
HEAVY_OVAL_WITH_OVAL_INSIDE = chr(11094)
HEAVY_CIRCLE_WITH_CIRCLE_INSIDE = chr(11095)
HEAVY_CIRCLE = chr(11096)
HEAVY_CIRCLED_SALTIRE = chr(11097)
SLANTED_NORTH_ARROW_WITH_HOOKED_HEAD = chr(11098)
BACKSLANTED_SOUTH_ARROW_WITH_HOOKED_TAIL = chr(11099)
SLANTED_NORTH_ARROW_WITH_HORIZONTAL_TAIL = chr(11100)
BACKSLANTED_SOUTH_ARROW_WITH_HORIZONTAL_TAIL = chr(11101)
BENT_ARROW_POINTING_DOWNWARDS_THEN_NORTH_EAST = chr(11102)
SHORT_BENT_ARROW_POINTING_DOWNWARDS_THEN_NORTH_EAST = chr(11103)
LEFTWARDS_TRIANGLE_HEADED_ARROW = chr(11104)
UPWARDS_TRIANGLE_HEADED_ARROW = chr(11105)
RIGHTWARDS_TRIANGLE_HEADED_ARROW = chr(11106)
DOWNWARDS_TRIANGLE_HEADED_ARROW = chr(11107)
LEFT_RIGHT_TRIANGLE_HEADED_ARROW = chr(11108)
UP_DOWN_TRIANGLE_HEADED_ARROW = chr(11109)
NORTH_WEST_TRIANGLE_HEADED_ARROW = chr(11110)
NORTH_EAST_TRIANGLE_HEADED_ARROW = chr(11111)
SOUTH_EAST_TRIANGLE_HEADED_ARROW = chr(11112)
SOUTH_WEST_TRIANGLE_HEADED_ARROW = chr(11113)
LEFTWARDS_TRIANGLE_HEADED_DASHED_ARROW = chr(11114)
UPWARDS_TRIANGLE_HEADED_DASHED_ARROW = chr(11115)
RIGHTWARDS_TRIANGLE_HEADED_DASHED_ARROW = chr(11116)
DOWNWARDS_TRIANGLE_HEADED_DASHED_ARROW = chr(11117)
CLOCKWISE_TRIANGLE_HEADED_OPEN_CIRCLE_ARROW = chr(11118)
ANTICLOCKWISE_TRIANGLE_HEADED_OPEN_CIRCLE_ARROW = chr(11119)
LEFTWARDS_TRIANGLE_HEADED_ARROW_TO_BAR = chr(11120)
UPWARDS_TRIANGLE_HEADED_ARROW_TO_BAR = chr(11121)
RIGHTWARDS_TRIANGLE_HEADED_ARROW_TO_BAR = chr(11122)
DOWNWARDS_TRIANGLE_HEADED_ARROW_TO_BAR = chr(11123)
NORTH_WEST_TRIANGLE_HEADED_ARROW_TO_BAR = chr(11126)
NORTH_EAST_TRIANGLE_HEADED_ARROW_TO_BAR = chr(11127)
SOUTH_EAST_TRIANGLE_HEADED_ARROW_TO_BAR = chr(11128)
SOUTH_WEST_TRIANGLE_HEADED_ARROW_TO_BAR = chr(11129)
LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_DOUBLE_HORIZONTAL_STROKE = chr(11130)
UPWARDS_TRIANGLE_HEADED_ARROW_WITH_DOUBLE_HORIZONTAL_STROKE = chr(11131)
RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_DOUBLE_HORIZONTAL_STROKE = chr(11132)
DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_DOUBLE_HORIZONTAL_STROKE = chr(11133)
HORIZONTAL_TAB_KEY = chr(11134)
VERTICAL_TAB_KEY = chr(11135)
LEFTWARDS_TRIANGLE_HEADED_ARROW_OVER_RIGHTWARDS_TRIANGLE_HEADED_ARROW = chr(11136)
UPWARDS_TRIANGLE_HEADED_ARROW_LEFTWARDS_OF_DOWNWARDS_TRIANGLE_HEADED_ARROW = chr(11137)
RIGHTWARDS_TRIANGLE_HEADED_ARROW_OVER_LEFTWARDS_TRIANGLE_HEADED_ARROW = chr(11138)
DOWNWARDS_TRIANGLE_HEADED_ARROW_LEFTWARDS_OF_UPWARDS_TRIANGLE_HEADED_ARROW = chr(11139)
LEFTWARDS_TRIANGLE_HEADED_PAIRED_ARROWS = chr(11140)
UPWARDS_TRIANGLE_HEADED_PAIRED_ARROWS = chr(11141)
RIGHTWARDS_TRIANGLE_HEADED_PAIRED_ARROWS = chr(11142)
DOWNWARDS_TRIANGLE_HEADED_PAIRED_ARROWS = chr(11143)
LEFTWARDS_BLACK_CIRCLED_WHITE_ARROW = chr(11144)
UPWARDS_BLACK_CIRCLED_WHITE_ARROW = chr(11145)
RIGHTWARDS_BLACK_CIRCLED_WHITE_ARROW = chr(11146)
DOWNWARDS_BLACK_CIRCLED_WHITE_ARROW = chr(11147)
ANTICLOCKWISE_TRIANGLE_HEADED_RIGHT_U_SHAPED_ARROW = chr(11148)
ANTICLOCKWISE_TRIANGLE_HEADED_BOTTOM_U_SHAPED_ARROW = chr(11149)
ANTICLOCKWISE_TRIANGLE_HEADED_LEFT_U_SHAPED_ARROW = chr(11150)
ANTICLOCKWISE_TRIANGLE_HEADED_TOP_U_SHAPED_ARROW = chr(11151)
RETURN_LEFT = chr(11152)
RETURN_RIGHT = chr(11153)
NEWLINE_LEFT = chr(11154)
NEWLINE_RIGHT = chr(11155)
FOUR_CORNER_ARROWS_CIRCLING_ANTICLOCKWISE = chr(11156)
RIGHTWARDS_BLACK_ARROW = chr(11157)
SYMBOL_FOR_TYPE_A_ELECTRONICS = chr(11159)
THREE_D_TOP_LIGHTED_LEFTWARDS_EQUILATERAL_ARROWHEAD = chr(11160)
THREE_D_RIGHT_LIGHTED_UPWARDS_EQUILATERAL_ARROWHEAD = chr(11161)
THREE_D_TOP_LIGHTED_RIGHTWARDS_EQUILATERAL_ARROWHEAD = chr(11162)
THREE_D_LEFT_LIGHTED_DOWNWARDS_EQUILATERAL_ARROWHEAD = chr(11163)
BLACK_LEFTWARDS_EQUILATERAL_ARROWHEAD = chr(11164)
BLACK_UPWARDS_EQUILATERAL_ARROWHEAD = chr(11165)
BLACK_RIGHTWARDS_EQUILATERAL_ARROWHEAD = chr(11166)
BLACK_DOWNWARDS_EQUILATERAL_ARROWHEAD = chr(11167)
DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_LEFTWARDS = chr(11168)
DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_RIGHTWARDS = chr(11169)
UPWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_LEFTWARDS = chr(11170)
UPWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_RIGHTWARDS = chr(11171)
LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_UPWARDS = chr(11172)
RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_UPWARDS = chr(11173)
LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_DOWNWARDS = chr(11174)
RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_DOWNWARDS = chr(11175)
BLACK_CURVED_DOWNWARDS_AND_LEFTWARDS_ARROW = chr(11176)
BLACK_CURVED_DOWNWARDS_AND_RIGHTWARDS_ARROW = chr(11177)
BLACK_CURVED_UPWARDS_AND_LEFTWARDS_ARROW = chr(11178)
BLACK_CURVED_UPWARDS_AND_RIGHTWARDS_ARROW = chr(11179)
BLACK_CURVED_LEFTWARDS_AND_UPWARDS_ARROW = chr(11180)
BLACK_CURVED_RIGHTWARDS_AND_UPWARDS_ARROW = chr(11181)
BLACK_CURVED_LEFTWARDS_AND_DOWNWARDS_ARROW = chr(11182)
BLACK_CURVED_RIGHTWARDS_AND_DOWNWARDS_ARROW = chr(11183)
RIBBON_ARROW_DOWN_LEFT = chr(11184)
RIBBON_ARROW_DOWN_RIGHT = chr(11185)
RIBBON_ARROW_UP_LEFT = chr(11186)
RIBBON_ARROW_UP_RIGHT = chr(11187)
RIBBON_ARROW_LEFT_UP = chr(11188)
RIBBON_ARROW_RIGHT_UP = chr(11189)
RIBBON_ARROW_LEFT_DOWN = chr(11190)
RIBBON_ARROW_RIGHT_DOWN = chr(11191)
UPWARDS_WHITE_ARROW_FROM_BAR_WITH_HORIZONTAL_BAR = chr(11192)
UP_ARROWHEAD_IN_A_RECTANGLE_BOX = chr(11193)
OVERLAPPING_WHITE_SQUARES = chr(11194)
OVERLAPPING_WHITE_AND_BLACK_SQUARES = chr(11195)
OVERLAPPING_BLACK_SQUARES = chr(11196)
BALLOT_BOX_WITH_LIGHT_X = chr(11197)
CIRCLED_X = chr(11198)
CIRCLED_BOLD_X = chr(11199)
BLACK_SQUARE_CENTRED = chr(11200)
BLACK_DIAMOND_CENTRED = chr(11201)
TURNED_BLACK_PENTAGON = chr(11202)
HORIZONTAL_BLACK_OCTAGON = chr(11203)
BLACK_OCTAGON = chr(11204)
BLACK_MEDIUM_UP_POINTING_TRIANGLE_CENTRED = chr(11205)
BLACK_MEDIUM_DOWN_POINTING_TRIANGLE_CENTRED = chr(11206)
BLACK_MEDIUM_LEFT_POINTING_TRIANGLE_CENTRED = chr(11207)
BLACK_MEDIUM_RIGHT_POINTING_TRIANGLE_CENTRED = chr(11208)
NEPTUNE_FORM_TWO = chr(11209)
TOP_HALF_BLACK_CIRCLE = chr(11210)
BOTTOM_HALF_BLACK_CIRCLE = chr(11211)
LIGHT_FOUR_POINTED_BLACK_CUSP = chr(11212)
ROTATED_LIGHT_FOUR_POINTED_BLACK_CUSP = chr(11213)
WHITE_FOUR_POINTED_CUSP = chr(11214)
ROTATED_WHITE_FOUR_POINTED_CUSP = chr(11215)
SQUARE_POSITION_INDICATOR = chr(11216)
UNCERTAINTY_SIGN = chr(11217)
GROUP_MARK = chr(11218)
PLUTO_FORM_TWO = chr(11219)
PLUTO_FORM_THREE = chr(11220)
PLUTO_FORM_FOUR = chr(11221)
PLUTO_FORM_FIVE = chr(11222)
TRANSPLUTO = chr(11223)
PROSERPINA = chr(11224)
ASTRAEA = chr(11225)
HYGIEA = chr(11226)
PHOLUS = chr(11227)
NESSUS = chr(11228)
WHITE_MOON_SELENA = chr(11229)
BLACK_DIAMOND_ON_CROSS = chr(11230)
TRUE_LIGHT_MOON_ARTA = chr(11231)
CUPIDO = chr(11232)
HADES = chr(11233)
ZEUS = chr(11234)
KRONOS = chr(11235)
APOLLON = chr(11236)
ADMETOS = chr(11237)
VULCANUS = chr(11238)
POSEIDON = chr(11239)
LEFT_HALF_BLACK_STAR = chr(11240)
RIGHT_HALF_BLACK_STAR = chr(11241)
STAR_WITH_LEFT_HALF_BLACK = chr(11242)
STAR_WITH_RIGHT_HALF_BLACK = chr(11243)
LEFTWARDS_TWO_HEADED_ARROW_WITH_TRIANGLE_ARROWHEADS = chr(11244)
UPWARDS_TWO_HEADED_ARROW_WITH_TRIANGLE_ARROWHEADS = chr(11245)
RIGHTWARDS_TWO_HEADED_ARROW_WITH_TRIANGLE_ARROWHEADS = chr(11246)
DOWNWARDS_TWO_HEADED_ARROW_WITH_TRIANGLE_ARROWHEADS = chr(11247)
ERIS_FORM_ONE = chr(11248)
ERIS_FORM_TWO = chr(11249)
SEDNA = chr(11250)
RUSSIAN_ASTROLOGICAL_SYMBOL_VIGINTILE = chr(11251)
RUSSIAN_ASTROLOGICAL_SYMBOL_NOVILE = chr(11252)
RUSSIAN_ASTROLOGICAL_SYMBOL_QUINTILE = chr(11253)
RUSSIAN_ASTROLOGICAL_SYMBOL_BINOVILE = chr(11254)
RUSSIAN_ASTROLOGICAL_SYMBOL_SENTAGON = chr(11255)
RUSSIAN_ASTROLOGICAL_SYMBOL_TREDECILE = chr(11256)
EQUALS_SIGN_WITH_INFINITY_BELOW = chr(11257)
UNITED_SYMBOL = chr(11258)
SEPARATED_SYMBOL = chr(11259)
DOUBLED_SYMBOL = chr(11260)
PASSED_SYMBOL = chr(11261)
REVERSED_RIGHT_ANGLE = chr(11262)
HELLSCHREIBER_PAUSE_SYMBOL = chr(11263)
GLAGOLITIC_CAPITAL_LETTER_AZU = chr(11264)
GLAGOLITIC_CAPITAL_LETTER_BUKY = chr(11265)
GLAGOLITIC_CAPITAL_LETTER_VEDE = chr(11266)
GLAGOLITIC_CAPITAL_LETTER_GLAGOLI = chr(11267)
GLAGOLITIC_CAPITAL_LETTER_DOBRO = chr(11268)
GLAGOLITIC_CAPITAL_LETTER_YESTU = chr(11269)
GLAGOLITIC_CAPITAL_LETTER_ZHIVETE = chr(11270)
GLAGOLITIC_CAPITAL_LETTER_DZELO = chr(11271)
GLAGOLITIC_CAPITAL_LETTER_ZEMLJA = chr(11272)
GLAGOLITIC_CAPITAL_LETTER_IZHE = chr(11273)
GLAGOLITIC_CAPITAL_LETTER_INITIAL_IZHE = chr(11274)
GLAGOLITIC_CAPITAL_LETTER_I = chr(11275)
GLAGOLITIC_CAPITAL_LETTER_DJERVI = chr(11276)
GLAGOLITIC_CAPITAL_LETTER_KAKO = chr(11277)
GLAGOLITIC_CAPITAL_LETTER_LJUDIJE = chr(11278)
GLAGOLITIC_CAPITAL_LETTER_MYSLITE = chr(11279)
GLAGOLITIC_CAPITAL_LETTER_NASHI = chr(11280)
GLAGOLITIC_CAPITAL_LETTER_ONU = chr(11281)
GLAGOLITIC_CAPITAL_LETTER_POKOJI = chr(11282)
GLAGOLITIC_CAPITAL_LETTER_RITSI = chr(11283)
GLAGOLITIC_CAPITAL_LETTER_SLOVO = chr(11284)
GLAGOLITIC_CAPITAL_LETTER_TVRIDO = chr(11285)
GLAGOLITIC_CAPITAL_LETTER_UKU = chr(11286)
GLAGOLITIC_CAPITAL_LETTER_FRITU = chr(11287)
GLAGOLITIC_CAPITAL_LETTER_HERU = chr(11288)
GLAGOLITIC_CAPITAL_LETTER_OTU = chr(11289)
GLAGOLITIC_CAPITAL_LETTER_PE = chr(11290)
GLAGOLITIC_CAPITAL_LETTER_SHTA = chr(11291)
GLAGOLITIC_CAPITAL_LETTER_TSI = chr(11292)
GLAGOLITIC_CAPITAL_LETTER_CHRIVI = chr(11293)
GLAGOLITIC_CAPITAL_LETTER_SHA = chr(11294)
GLAGOLITIC_CAPITAL_LETTER_YERU = chr(11295)
GLAGOLITIC_CAPITAL_LETTER_YERI = chr(11296)
GLAGOLITIC_CAPITAL_LETTER_YATI = chr(11297)
GLAGOLITIC_CAPITAL_LETTER_SPIDERY_HA = chr(11298)
GLAGOLITIC_CAPITAL_LETTER_YU = chr(11299)
GLAGOLITIC_CAPITAL_LETTER_SMALL_YUS = chr(11300)
GLAGOLITIC_CAPITAL_LETTER_SMALL_YUS_WITH_TAIL = chr(11301)
GLAGOLITIC_CAPITAL_LETTER_YO = chr(11302)
GLAGOLITIC_CAPITAL_LETTER_IOTATED_SMALL_YUS = chr(11303)
GLAGOLITIC_CAPITAL_LETTER_BIG_YUS = chr(11304)
GLAGOLITIC_CAPITAL_LETTER_IOTATED_BIG_YUS = chr(11305)
GLAGOLITIC_CAPITAL_LETTER_FITA = chr(11306)
GLAGOLITIC_CAPITAL_LETTER_IZHITSA = chr(11307)
GLAGOLITIC_CAPITAL_LETTER_SHTAPIC = chr(11308)
GLAGOLITIC_CAPITAL_LETTER_TROKUTASTI_A = chr(11309)
GLAGOLITIC_CAPITAL_LETTER_LATINATE_MYSLITE = chr(11310)
GLAGOLITIC_CAPITAL_LETTER_CAUDATE_CHRIVI = chr(11311)
GLAGOLITIC_SMALL_LETTER_AZU = chr(11312)
GLAGOLITIC_SMALL_LETTER_BUKY = chr(11313)
GLAGOLITIC_SMALL_LETTER_VEDE = chr(11314)
GLAGOLITIC_SMALL_LETTER_GLAGOLI = chr(11315)
GLAGOLITIC_SMALL_LETTER_DOBRO = chr(11316)
GLAGOLITIC_SMALL_LETTER_YESTU = chr(11317)
GLAGOLITIC_SMALL_LETTER_ZHIVETE = chr(11318)
GLAGOLITIC_SMALL_LETTER_DZELO = chr(11319)
GLAGOLITIC_SMALL_LETTER_ZEMLJA = chr(11320)
GLAGOLITIC_SMALL_LETTER_IZHE = chr(11321)
GLAGOLITIC_SMALL_LETTER_INITIAL_IZHE = chr(11322)
GLAGOLITIC_SMALL_LETTER_I = chr(11323)
GLAGOLITIC_SMALL_LETTER_DJERVI = chr(11324)
GLAGOLITIC_SMALL_LETTER_KAKO = chr(11325)
GLAGOLITIC_SMALL_LETTER_LJUDIJE = chr(11326)
GLAGOLITIC_SMALL_LETTER_MYSLITE = chr(11327)
GLAGOLITIC_SMALL_LETTER_NASHI = chr(11328)
GLAGOLITIC_SMALL_LETTER_ONU = chr(11329)
GLAGOLITIC_SMALL_LETTER_POKOJI = chr(11330)
GLAGOLITIC_SMALL_LETTER_RITSI = chr(11331)
GLAGOLITIC_SMALL_LETTER_SLOVO = chr(11332)
GLAGOLITIC_SMALL_LETTER_TVRIDO = chr(11333)
GLAGOLITIC_SMALL_LETTER_UKU = chr(11334)
GLAGOLITIC_SMALL_LETTER_FRITU = chr(11335)
GLAGOLITIC_SMALL_LETTER_HERU = chr(11336)
GLAGOLITIC_SMALL_LETTER_OTU = chr(11337)
GLAGOLITIC_SMALL_LETTER_PE = chr(11338)
GLAGOLITIC_SMALL_LETTER_SHTA = chr(11339)
GLAGOLITIC_SMALL_LETTER_TSI = chr(11340)
GLAGOLITIC_SMALL_LETTER_CHRIVI = chr(11341)
GLAGOLITIC_SMALL_LETTER_SHA = chr(11342)
GLAGOLITIC_SMALL_LETTER_YERU = chr(11343)
GLAGOLITIC_SMALL_LETTER_YERI = chr(11344)
GLAGOLITIC_SMALL_LETTER_YATI = chr(11345)
GLAGOLITIC_SMALL_LETTER_SPIDERY_HA = chr(11346)
GLAGOLITIC_SMALL_LETTER_YU = chr(11347)
GLAGOLITIC_SMALL_LETTER_SMALL_YUS = chr(11348)
GLAGOLITIC_SMALL_LETTER_SMALL_YUS_WITH_TAIL = chr(11349)
GLAGOLITIC_SMALL_LETTER_YO = chr(11350)
GLAGOLITIC_SMALL_LETTER_IOTATED_SMALL_YUS = chr(11351)
GLAGOLITIC_SMALL_LETTER_BIG_YUS = chr(11352)
GLAGOLITIC_SMALL_LETTER_IOTATED_BIG_YUS = chr(11353)
GLAGOLITIC_SMALL_LETTER_FITA = chr(11354)
GLAGOLITIC_SMALL_LETTER_IZHITSA = chr(11355)
GLAGOLITIC_SMALL_LETTER_SHTAPIC = chr(11356)
GLAGOLITIC_SMALL_LETTER_TROKUTASTI_A = chr(11357)
GLAGOLITIC_SMALL_LETTER_LATINATE_MYSLITE = chr(11358)
GLAGOLITIC_SMALL_LETTER_CAUDATE_CHRIVI = chr(11359)
LATIN_CAPITAL_LETTER_L_WITH_DOUBLE_BAR = chr(11360)
LATIN_SMALL_LETTER_L_WITH_DOUBLE_BAR = chr(11361)
LATIN_CAPITAL_LETTER_L_WITH_MIDDLE_TILDE = chr(11362)
LATIN_CAPITAL_LETTER_P_WITH_STROKE = chr(11363)
LATIN_CAPITAL_LETTER_R_WITH_TAIL = chr(11364)
LATIN_SMALL_LETTER_A_WITH_STROKE = chr(11365)
LATIN_SMALL_LETTER_T_WITH_DIAGONAL_STROKE = chr(11366)
LATIN_CAPITAL_LETTER_H_WITH_DESCENDER = chr(11367)
LATIN_SMALL_LETTER_H_WITH_DESCENDER = chr(11368)
LATIN_CAPITAL_LETTER_K_WITH_DESCENDER = chr(11369)
LATIN_SMALL_LETTER_K_WITH_DESCENDER = chr(11370)
LATIN_CAPITAL_LETTER_Z_WITH_DESCENDER = chr(11371)
LATIN_SMALL_LETTER_Z_WITH_DESCENDER = chr(11372)
LATIN_CAPITAL_LETTER_ALPHA = chr(11373)
LATIN_CAPITAL_LETTER_M_WITH_HOOK = chr(11374)
LATIN_CAPITAL_LETTER_TURNED_A = chr(11375)
LATIN_CAPITAL_LETTER_TURNED_ALPHA = chr(11376)
LATIN_SMALL_LETTER_V_WITH_RIGHT_HOOK = chr(11377)
LATIN_CAPITAL_LETTER_W_WITH_HOOK = chr(11378)
LATIN_SMALL_LETTER_W_WITH_HOOK = chr(11379)
LATIN_SMALL_LETTER_V_WITH_CURL = chr(11380)
LATIN_CAPITAL_LETTER_HALF_H = chr(11381)
LATIN_SMALL_LETTER_HALF_H = chr(11382)
LATIN_SMALL_LETTER_TAILLESS_PHI = chr(11383)
LATIN_SMALL_LETTER_E_WITH_NOTCH = chr(11384)
LATIN_SMALL_LETTER_TURNED_R_WITH_TAIL = chr(11385)
LATIN_SMALL_LETTER_O_WITH_LOW_RING_INSIDE = chr(11386)
LATIN_LETTER_SMALL_CAPITAL_TURNED_E = chr(11387)
LATIN_SUBSCRIPT_SMALL_LETTER_J = chr(11388)
MODIFIER_LETTER_CAPITAL_V = chr(11389)
LATIN_CAPITAL_LETTER_S_WITH_SWASH_TAIL = chr(11390)
LATIN_CAPITAL_LETTER_Z_WITH_SWASH_TAIL = chr(11391)
COPTIC_CAPITAL_LETTER_ALFA = chr(11392)
COPTIC_SMALL_LETTER_ALFA = chr(11393)
COPTIC_CAPITAL_LETTER_VIDA = chr(11394)
COPTIC_SMALL_LETTER_VIDA = chr(11395)
COPTIC_CAPITAL_LETTER_GAMMA = chr(11396)
COPTIC_SMALL_LETTER_GAMMA = chr(11397)
COPTIC_CAPITAL_LETTER_DALDA = chr(11398)
COPTIC_SMALL_LETTER_DALDA = chr(11399)
COPTIC_CAPITAL_LETTER_EIE = chr(11400)
COPTIC_SMALL_LETTER_EIE = chr(11401)
COPTIC_CAPITAL_LETTER_SOU = chr(11402)
COPTIC_SMALL_LETTER_SOU = chr(11403)
COPTIC_CAPITAL_LETTER_ZATA = chr(11404)
COPTIC_SMALL_LETTER_ZATA = chr(11405)
COPTIC_CAPITAL_LETTER_HATE = chr(11406)
COPTIC_SMALL_LETTER_HATE = chr(11407)
COPTIC_CAPITAL_LETTER_THETHE = chr(11408)
COPTIC_SMALL_LETTER_THETHE = chr(11409)
COPTIC_CAPITAL_LETTER_IAUDA = chr(11410)
COPTIC_SMALL_LETTER_IAUDA = chr(11411)
COPTIC_CAPITAL_LETTER_KAPA = chr(11412)
COPTIC_SMALL_LETTER_KAPA = chr(11413)
COPTIC_CAPITAL_LETTER_LAULA = chr(11414)
COPTIC_SMALL_LETTER_LAULA = chr(11415)
COPTIC_CAPITAL_LETTER_MI = chr(11416)
COPTIC_SMALL_LETTER_MI = chr(11417)
COPTIC_CAPITAL_LETTER_NI = chr(11418)
COPTIC_SMALL_LETTER_NI = chr(11419)
COPTIC_CAPITAL_LETTER_KSI = chr(11420)
COPTIC_SMALL_LETTER_KSI = chr(11421)
COPTIC_CAPITAL_LETTER_O = chr(11422)
COPTIC_SMALL_LETTER_O = chr(11423)
COPTIC_CAPITAL_LETTER_PI = chr(11424)
COPTIC_SMALL_LETTER_PI = chr(11425)
COPTIC_CAPITAL_LETTER_RO = chr(11426)
COPTIC_SMALL_LETTER_RO = chr(11427)
COPTIC_CAPITAL_LETTER_SIMA = chr(11428)
COPTIC_SMALL_LETTER_SIMA = chr(11429)
COPTIC_CAPITAL_LETTER_TAU = chr(11430)
COPTIC_SMALL_LETTER_TAU = chr(11431)
COPTIC_CAPITAL_LETTER_UA = chr(11432)
COPTIC_SMALL_LETTER_UA = chr(11433)
COPTIC_CAPITAL_LETTER_FI = chr(11434)
COPTIC_SMALL_LETTER_FI = chr(11435)
COPTIC_CAPITAL_LETTER_KHI = chr(11436)
COPTIC_SMALL_LETTER_KHI = chr(11437)
COPTIC_CAPITAL_LETTER_PSI = chr(11438)
COPTIC_SMALL_LETTER_PSI = chr(11439)
COPTIC_CAPITAL_LETTER_OOU = chr(11440)
COPTIC_SMALL_LETTER_OOU = chr(11441)
COPTIC_CAPITAL_LETTER_DIALECT_P_ALEF = chr(11442)
COPTIC_SMALL_LETTER_DIALECT_P_ALEF = chr(11443)
COPTIC_CAPITAL_LETTER_OLD_COPTIC_AIN = chr(11444)
COPTIC_SMALL_LETTER_OLD_COPTIC_AIN = chr(11445)
COPTIC_CAPITAL_LETTER_CRYPTOGRAMMIC_EIE = chr(11446)
COPTIC_SMALL_LETTER_CRYPTOGRAMMIC_EIE = chr(11447)
COPTIC_CAPITAL_LETTER_DIALECT_P_KAPA = chr(11448)
COPTIC_SMALL_LETTER_DIALECT_P_KAPA = chr(11449)
COPTIC_CAPITAL_LETTER_DIALECT_P_NI = chr(11450)
COPTIC_SMALL_LETTER_DIALECT_P_NI = chr(11451)
COPTIC_CAPITAL_LETTER_CRYPTOGRAMMIC_NI = chr(11452)
COPTIC_SMALL_LETTER_CRYPTOGRAMMIC_NI = chr(11453)
COPTIC_CAPITAL_LETTER_OLD_COPTIC_OOU = chr(11454)
COPTIC_SMALL_LETTER_OLD_COPTIC_OOU = chr(11455)
COPTIC_CAPITAL_LETTER_SAMPI = chr(11456)
COPTIC_SMALL_LETTER_SAMPI = chr(11457)
COPTIC_CAPITAL_LETTER_CROSSED_SHEI = chr(11458)
COPTIC_SMALL_LETTER_CROSSED_SHEI = chr(11459)
COPTIC_CAPITAL_LETTER_OLD_COPTIC_SHEI = chr(11460)
COPTIC_SMALL_LETTER_OLD_COPTIC_SHEI = chr(11461)
COPTIC_CAPITAL_LETTER_OLD_COPTIC_ESH = chr(11462)
COPTIC_SMALL_LETTER_OLD_COPTIC_ESH = chr(11463)
COPTIC_CAPITAL_LETTER_AKHMIMIC_KHEI = chr(11464)
COPTIC_SMALL_LETTER_AKHMIMIC_KHEI = chr(11465)
COPTIC_CAPITAL_LETTER_DIALECT_P_HORI = chr(11466)
COPTIC_SMALL_LETTER_DIALECT_P_HORI = chr(11467)
COPTIC_CAPITAL_LETTER_OLD_COPTIC_HORI = chr(11468)
COPTIC_SMALL_LETTER_OLD_COPTIC_HORI = chr(11469)
COPTIC_CAPITAL_LETTER_OLD_COPTIC_HA = chr(11470)
COPTIC_SMALL_LETTER_OLD_COPTIC_HA = chr(11471)
COPTIC_CAPITAL_LETTER_L_SHAPED_HA = chr(11472)
COPTIC_SMALL_LETTER_L_SHAPED_HA = chr(11473)
COPTIC_CAPITAL_LETTER_OLD_COPTIC_HEI = chr(11474)
COPTIC_SMALL_LETTER_OLD_COPTIC_HEI = chr(11475)
COPTIC_CAPITAL_LETTER_OLD_COPTIC_HAT = chr(11476)
COPTIC_SMALL_LETTER_OLD_COPTIC_HAT = chr(11477)
COPTIC_CAPITAL_LETTER_OLD_COPTIC_GANGIA = chr(11478)
COPTIC_SMALL_LETTER_OLD_COPTIC_GANGIA = chr(11479)
COPTIC_CAPITAL_LETTER_OLD_COPTIC_DJA = chr(11480)
COPTIC_SMALL_LETTER_OLD_COPTIC_DJA = chr(11481)
COPTIC_CAPITAL_LETTER_OLD_COPTIC_SHIMA = chr(11482)
COPTIC_SMALL_LETTER_OLD_COPTIC_SHIMA = chr(11483)
COPTIC_CAPITAL_LETTER_OLD_NUBIAN_SHIMA = chr(11484)
COPTIC_SMALL_LETTER_OLD_NUBIAN_SHIMA = chr(11485)
COPTIC_CAPITAL_LETTER_OLD_NUBIAN_NGI = chr(11486)
COPTIC_SMALL_LETTER_OLD_NUBIAN_NGI = chr(11487)
COPTIC_CAPITAL_LETTER_OLD_NUBIAN_NYI = chr(11488)
COPTIC_SMALL_LETTER_OLD_NUBIAN_NYI = chr(11489)
COPTIC_CAPITAL_LETTER_OLD_NUBIAN_WAU = chr(11490)
COPTIC_SMALL_LETTER_OLD_NUBIAN_WAU = chr(11491)
COPTIC_SYMBOL_KAI = chr(11492)
COPTIC_SYMBOL_MI_RO = chr(11493)
COPTIC_SYMBOL_PI_RO = chr(11494)
COPTIC_SYMBOL_STAUROS = chr(11495)
COPTIC_SYMBOL_TAU_RO = chr(11496)
COPTIC_SYMBOL_KHI_RO = chr(11497)
COPTIC_SYMBOL_SHIMA_SIMA = chr(11498)
COPTIC_CAPITAL_LETTER_CRYPTOGRAMMIC_SHEI = chr(11499)
COPTIC_SMALL_LETTER_CRYPTOGRAMMIC_SHEI = chr(11500)
COPTIC_CAPITAL_LETTER_CRYPTOGRAMMIC_GANGIA = chr(11501)
COPTIC_SMALL_LETTER_CRYPTOGRAMMIC_GANGIA = chr(11502)
COPTIC_COMBINING_NI_ABOVE = chr(11503)
COPTIC_COMBINING_SPIRITUS_ASPER = chr(11504)
COPTIC_COMBINING_SPIRITUS_LENIS = chr(11505)
COPTIC_CAPITAL_LETTER_BOHAIRIC_KHEI = chr(11506)
COPTIC_SMALL_LETTER_BOHAIRIC_KHEI = chr(11507)
COPTIC_OLD_NUBIAN_FULL_STOP = chr(11513)
COPTIC_OLD_NUBIAN_DIRECT_QUESTION_MARK = chr(11514)
COPTIC_OLD_NUBIAN_INDIRECT_QUESTION_MARK = chr(11515)
COPTIC_OLD_NUBIAN_VERSE_DIVIDER = chr(11516)
COPTIC_FRACTION_ONE_HALF = chr(11517)
COPTIC_FULL_STOP = chr(11518)
COPTIC_MORPHOLOGICAL_DIVIDER = chr(11519)
GEORGIAN_SMALL_LETTER_AN = chr(11520)
GEORGIAN_SMALL_LETTER_BAN = chr(11521)
GEORGIAN_SMALL_LETTER_GAN = chr(11522)
GEORGIAN_SMALL_LETTER_DON = chr(11523)
GEORGIAN_SMALL_LETTER_EN = chr(11524)
GEORGIAN_SMALL_LETTER_VIN = chr(11525)
GEORGIAN_SMALL_LETTER_ZEN = chr(11526)
GEORGIAN_SMALL_LETTER_TAN = chr(11527)
GEORGIAN_SMALL_LETTER_IN = chr(11528)
GEORGIAN_SMALL_LETTER_KAN = chr(11529)
GEORGIAN_SMALL_LETTER_LAS = chr(11530)
GEORGIAN_SMALL_LETTER_MAN = chr(11531)
GEORGIAN_SMALL_LETTER_NAR = chr(11532)
GEORGIAN_SMALL_LETTER_ON = chr(11533)
GEORGIAN_SMALL_LETTER_PAR = chr(11534)
GEORGIAN_SMALL_LETTER_ZHAR = chr(11535)
GEORGIAN_SMALL_LETTER_RAE = chr(11536)
GEORGIAN_SMALL_LETTER_SAN = chr(11537)
GEORGIAN_SMALL_LETTER_TAR = chr(11538)
GEORGIAN_SMALL_LETTER_UN = chr(11539)
GEORGIAN_SMALL_LETTER_PHAR = chr(11540)
GEORGIAN_SMALL_LETTER_KHAR = chr(11541)
GEORGIAN_SMALL_LETTER_GHAN = chr(11542)
GEORGIAN_SMALL_LETTER_QAR = chr(11543)
GEORGIAN_SMALL_LETTER_SHIN = chr(11544)
GEORGIAN_SMALL_LETTER_CHIN = chr(11545)
GEORGIAN_SMALL_LETTER_CAN = chr(11546)
GEORGIAN_SMALL_LETTER_JIL = chr(11547)
GEORGIAN_SMALL_LETTER_CIL = chr(11548)
GEORGIAN_SMALL_LETTER_CHAR = chr(11549)
GEORGIAN_SMALL_LETTER_XAN = chr(11550)
GEORGIAN_SMALL_LETTER_JHAN = chr(11551)
GEORGIAN_SMALL_LETTER_HAE = chr(11552)
GEORGIAN_SMALL_LETTER_HE = chr(11553)
GEORGIAN_SMALL_LETTER_HIE = chr(11554)
GEORGIAN_SMALL_LETTER_WE = chr(11555)
GEORGIAN_SMALL_LETTER_HAR = chr(11556)
GEORGIAN_SMALL_LETTER_HOE = chr(11557)
GEORGIAN_SMALL_LETTER_YN = chr(11559)
GEORGIAN_SMALL_LETTER_AEN = chr(11565)
TIFINAGH_LETTER_YA = chr(11568)
TIFINAGH_LETTER_YAB = chr(11569)
TIFINAGH_LETTER_YABH = chr(11570)
TIFINAGH_LETTER_YAG = chr(11571)
TIFINAGH_LETTER_YAGHH = chr(11572)
TIFINAGH_LETTER_BERBER_ACADEMY_YAJ = chr(11573)
TIFINAGH_LETTER_YAJ = chr(11574)
TIFINAGH_LETTER_YAD = chr(11575)
TIFINAGH_LETTER_YADH = chr(11576)
TIFINAGH_LETTER_YADD = chr(11577)
TIFINAGH_LETTER_YADDH = chr(11578)
TIFINAGH_LETTER_YEY = chr(11579)
TIFINAGH_LETTER_YAF = chr(11580)
TIFINAGH_LETTER_YAK = chr(11581)
TIFINAGH_LETTER_TUAREG_YAK = chr(11582)
TIFINAGH_LETTER_YAKHH = chr(11583)
TIFINAGH_LETTER_YAH = chr(11584)
TIFINAGH_LETTER_BERBER_ACADEMY_YAH = chr(11585)
TIFINAGH_LETTER_TUAREG_YAH = chr(11586)
TIFINAGH_LETTER_YAHH = chr(11587)
TIFINAGH_LETTER_YAA = chr(11588)
TIFINAGH_LETTER_YAKH = chr(11589)
TIFINAGH_LETTER_TUAREG_YAKH = chr(11590)
TIFINAGH_LETTER_YAQ = chr(11591)
TIFINAGH_LETTER_TUAREG_YAQ = chr(11592)
TIFINAGH_LETTER_YI = chr(11593)
TIFINAGH_LETTER_YAZH = chr(11594)
TIFINAGH_LETTER_AHAGGAR_YAZH = chr(11595)
TIFINAGH_LETTER_TUAREG_YAZH = chr(11596)
TIFINAGH_LETTER_YAL = chr(11597)
TIFINAGH_LETTER_YAM = chr(11598)
TIFINAGH_LETTER_YAN = chr(11599)
TIFINAGH_LETTER_TUAREG_YAGN = chr(11600)
TIFINAGH_LETTER_TUAREG_YANG = chr(11601)
TIFINAGH_LETTER_YAP = chr(11602)
TIFINAGH_LETTER_YU = chr(11603)
TIFINAGH_LETTER_YAR = chr(11604)
TIFINAGH_LETTER_YARR = chr(11605)
TIFINAGH_LETTER_YAGH = chr(11606)
TIFINAGH_LETTER_TUAREG_YAGH = chr(11607)
TIFINAGH_LETTER_AYER_YAGH = chr(11608)
TIFINAGH_LETTER_YAS = chr(11609)
TIFINAGH_LETTER_YASS = chr(11610)
TIFINAGH_LETTER_YASH = chr(11611)
TIFINAGH_LETTER_YAT = chr(11612)
TIFINAGH_LETTER_YATH = chr(11613)
TIFINAGH_LETTER_YACH = chr(11614)
TIFINAGH_LETTER_YATT = chr(11615)
TIFINAGH_LETTER_YAV = chr(11616)
TIFINAGH_LETTER_YAW = chr(11617)
TIFINAGH_LETTER_YAY = chr(11618)
TIFINAGH_LETTER_YAZ = chr(11619)
TIFINAGH_LETTER_TAWELLEMET_YAZ = chr(11620)
TIFINAGH_LETTER_YAZZ = chr(11621)
TIFINAGH_LETTER_YE = chr(11622)
TIFINAGH_LETTER_YO = chr(11623)
TIFINAGH_MODIFIER_LETTER_LABIALIZATION_MARK = chr(11631)
TIFINAGH_SEPARATOR_MARK = chr(11632)
TIFINAGH_CONSONANT_JOINER = chr(11647)
ETHIOPIC_SYLLABLE_LOA = chr(11648)
ETHIOPIC_SYLLABLE_MOA = chr(11649)
ETHIOPIC_SYLLABLE_ROA = chr(11650)
ETHIOPIC_SYLLABLE_SOA = chr(11651)
ETHIOPIC_SYLLABLE_SHOA = chr(11652)
ETHIOPIC_SYLLABLE_BOA = chr(11653)
ETHIOPIC_SYLLABLE_TOA = chr(11654)
ETHIOPIC_SYLLABLE_COA = chr(11655)
ETHIOPIC_SYLLABLE_NOA = chr(11656)
ETHIOPIC_SYLLABLE_NYOA = chr(11657)
ETHIOPIC_SYLLABLE_GLOTTAL_OA = chr(11658)
ETHIOPIC_SYLLABLE_ZOA = chr(11659)
ETHIOPIC_SYLLABLE_DOA = chr(11660)
ETHIOPIC_SYLLABLE_DDOA = chr(11661)
ETHIOPIC_SYLLABLE_JOA = chr(11662)
ETHIOPIC_SYLLABLE_THOA = chr(11663)
ETHIOPIC_SYLLABLE_CHOA = chr(11664)
ETHIOPIC_SYLLABLE_PHOA = chr(11665)
ETHIOPIC_SYLLABLE_POA = chr(11666)
ETHIOPIC_SYLLABLE_GGWA = chr(11667)
ETHIOPIC_SYLLABLE_GGWI = chr(11668)
ETHIOPIC_SYLLABLE_GGWEE = chr(11669)
ETHIOPIC_SYLLABLE_GGWE = chr(11670)
ETHIOPIC_SYLLABLE_SSA = chr(11680)
ETHIOPIC_SYLLABLE_SSU = chr(11681)
ETHIOPIC_SYLLABLE_SSI = chr(11682)
ETHIOPIC_SYLLABLE_SSAA = chr(11683)
ETHIOPIC_SYLLABLE_SSEE = chr(11684)
ETHIOPIC_SYLLABLE_SSE = chr(11685)
ETHIOPIC_SYLLABLE_SSO = chr(11686)
ETHIOPIC_SYLLABLE_CCA = chr(11688)
ETHIOPIC_SYLLABLE_CCU = chr(11689)
ETHIOPIC_SYLLABLE_CCI = chr(11690)
ETHIOPIC_SYLLABLE_CCAA = chr(11691)
ETHIOPIC_SYLLABLE_CCEE = chr(11692)
ETHIOPIC_SYLLABLE_CCE = chr(11693)
ETHIOPIC_SYLLABLE_CCO = chr(11694)
ETHIOPIC_SYLLABLE_ZZA = chr(11696)
ETHIOPIC_SYLLABLE_ZZU = chr(11697)
ETHIOPIC_SYLLABLE_ZZI = chr(11698)
ETHIOPIC_SYLLABLE_ZZAA = chr(11699)
ETHIOPIC_SYLLABLE_ZZEE = chr(11700)
ETHIOPIC_SYLLABLE_ZZE = chr(11701)
ETHIOPIC_SYLLABLE_ZZO = chr(11702)
ETHIOPIC_SYLLABLE_CCHA = chr(11704)
ETHIOPIC_SYLLABLE_CCHU = chr(11705)
ETHIOPIC_SYLLABLE_CCHI = chr(11706)
ETHIOPIC_SYLLABLE_CCHAA = chr(11707)
ETHIOPIC_SYLLABLE_CCHEE = chr(11708)
ETHIOPIC_SYLLABLE_CCHE = chr(11709)
ETHIOPIC_SYLLABLE_CCHO = chr(11710)
ETHIOPIC_SYLLABLE_QYA = chr(11712)
ETHIOPIC_SYLLABLE_QYU = chr(11713)
ETHIOPIC_SYLLABLE_QYI = chr(11714)
ETHIOPIC_SYLLABLE_QYAA = chr(11715)
ETHIOPIC_SYLLABLE_QYEE = chr(11716)
ETHIOPIC_SYLLABLE_QYE = chr(11717)
ETHIOPIC_SYLLABLE_QYO = chr(11718)
ETHIOPIC_SYLLABLE_KYA = chr(11720)
ETHIOPIC_SYLLABLE_KYU = chr(11721)
ETHIOPIC_SYLLABLE_KYI = chr(11722)
ETHIOPIC_SYLLABLE_KYAA = chr(11723)
ETHIOPIC_SYLLABLE_KYEE = chr(11724)
ETHIOPIC_SYLLABLE_KYE = chr(11725)
ETHIOPIC_SYLLABLE_KYO = chr(11726)
ETHIOPIC_SYLLABLE_XYA = chr(11728)
ETHIOPIC_SYLLABLE_XYU = chr(11729)
ETHIOPIC_SYLLABLE_XYI = chr(11730)
ETHIOPIC_SYLLABLE_XYAA = chr(11731)
ETHIOPIC_SYLLABLE_XYEE = chr(11732)
ETHIOPIC_SYLLABLE_XYE = chr(11733)
ETHIOPIC_SYLLABLE_XYO = chr(11734)
ETHIOPIC_SYLLABLE_GYA = chr(11736)
ETHIOPIC_SYLLABLE_GYU = chr(11737)
ETHIOPIC_SYLLABLE_GYI = chr(11738)
ETHIOPIC_SYLLABLE_GYAA = chr(11739)
ETHIOPIC_SYLLABLE_GYEE = chr(11740)
ETHIOPIC_SYLLABLE_GYE = chr(11741)
ETHIOPIC_SYLLABLE_GYO = chr(11742)
COMBINING_CYRILLIC_LETTER_BE = chr(11744)
COMBINING_CYRILLIC_LETTER_VE = chr(11745)
COMBINING_CYRILLIC_LETTER_GHE = chr(11746)
COMBINING_CYRILLIC_LETTER_DE = chr(11747)
COMBINING_CYRILLIC_LETTER_ZHE = chr(11748)
COMBINING_CYRILLIC_LETTER_ZE = chr(11749)
COMBINING_CYRILLIC_LETTER_KA = chr(11750)
COMBINING_CYRILLIC_LETTER_EL = chr(11751)
COMBINING_CYRILLIC_LETTER_EM = chr(11752)
COMBINING_CYRILLIC_LETTER_EN = chr(11753)
COMBINING_CYRILLIC_LETTER_O = chr(11754)
COMBINING_CYRILLIC_LETTER_PE = chr(11755)
COMBINING_CYRILLIC_LETTER_ER = chr(11756)
COMBINING_CYRILLIC_LETTER_ES = chr(11757)
COMBINING_CYRILLIC_LETTER_TE = chr(11758)
COMBINING_CYRILLIC_LETTER_HA = chr(11759)
COMBINING_CYRILLIC_LETTER_TSE = chr(11760)
COMBINING_CYRILLIC_LETTER_CHE = chr(11761)
COMBINING_CYRILLIC_LETTER_SHA = chr(11762)
COMBINING_CYRILLIC_LETTER_SHCHA = chr(11763)
COMBINING_CYRILLIC_LETTER_FITA = chr(11764)
COMBINING_CYRILLIC_LETTER_ES_TE = chr(11765)
COMBINING_CYRILLIC_LETTER_A = chr(11766)
COMBINING_CYRILLIC_LETTER_IE = chr(11767)
COMBINING_CYRILLIC_LETTER_DJERV = chr(11768)
COMBINING_CYRILLIC_LETTER_MONOGRAPH_UK = chr(11769)
COMBINING_CYRILLIC_LETTER_YAT = chr(11770)
COMBINING_CYRILLIC_LETTER_YU = chr(11771)
COMBINING_CYRILLIC_LETTER_IOTIFIED_A = chr(11772)
COMBINING_CYRILLIC_LETTER_LITTLE_YUS = chr(11773)
COMBINING_CYRILLIC_LETTER_BIG_YUS = chr(11774)
COMBINING_CYRILLIC_LETTER_IOTIFIED_BIG_YUS = chr(11775)
RIGHT_ANGLE_SUBSTITUTION_MARKER = chr(11776)
RIGHT_ANGLE_DOTTED_SUBSTITUTION_MARKER = chr(11777)
LEFT_SUBSTITUTION_BRACKET = chr(11778)
RIGHT_SUBSTITUTION_BRACKET = chr(11779)
LEFT_DOTTED_SUBSTITUTION_BRACKET = chr(11780)
RIGHT_DOTTED_SUBSTITUTION_BRACKET = chr(11781)
RAISED_INTERPOLATION_MARKER = chr(11782)
RAISED_DOTTED_INTERPOLATION_MARKER = chr(11783)
DOTTED_TRANSPOSITION_MARKER = chr(11784)
LEFT_TRANSPOSITION_BRACKET = chr(11785)
RIGHT_TRANSPOSITION_BRACKET = chr(11786)
RAISED_SQUARE = chr(11787)
LEFT_RAISED_OMISSION_BRACKET = chr(11788)
RIGHT_RAISED_OMISSION_BRACKET = chr(11789)
EDITORIAL_CORONIS = chr(11790)
PARAGRAPHOS = chr(11791)
FORKED_PARAGRAPHOS = chr(11792)
REVERSED_FORKED_PARAGRAPHOS = chr(11793)
HYPODIASTOLE = chr(11794)
DOTTED_OBELOS = chr(11795)
DOWNWARDS_ANCORA = chr(11796)
UPWARDS_ANCORA = chr(11797)
DOTTED_RIGHT_POINTING_ANGLE = chr(11798)
DOUBLE_OBLIQUE_HYPHEN = chr(11799)
INVERTED_INTERROBANG = chr(11800)
PALM_BRANCH = chr(11801)
HYPHEN_WITH_DIAERESIS = chr(11802)
TILDE_WITH_RING_ABOVE = chr(11803)
LEFT_LOW_PARAPHRASE_BRACKET = chr(11804)
RIGHT_LOW_PARAPHRASE_BRACKET = chr(11805)
TILDE_WITH_DOT_ABOVE = chr(11806)
TILDE_WITH_DOT_BELOW = chr(11807)
LEFT_VERTICAL_BAR_WITH_QUILL = chr(11808)
RIGHT_VERTICAL_BAR_WITH_QUILL = chr(11809)
TOP_LEFT_HALF_BRACKET = chr(11810)
TOP_RIGHT_HALF_BRACKET = chr(11811)
BOTTOM_LEFT_HALF_BRACKET = chr(11812)
BOTTOM_RIGHT_HALF_BRACKET = chr(11813)
LEFT_SIDEWAYS_U_BRACKET = chr(11814)
RIGHT_SIDEWAYS_U_BRACKET = chr(11815)
LEFT_DOUBLE_PARENTHESIS = chr(11816)
RIGHT_DOUBLE_PARENTHESIS = chr(11817)
TWO_DOTS_OVER_ONE_DOT_PUNCTUATION = chr(11818)
ONE_DOT_OVER_TWO_DOTS_PUNCTUATION = chr(11819)
SQUARED_FOUR_DOT_PUNCTUATION = chr(11820)
FIVE_DOT_MARK = chr(11821)
REVERSED_QUESTION_MARK = chr(11822)
VERTICAL_TILDE = chr(11823)
RING_POINT = chr(11824)
WORD_SEPARATOR_MIDDLE_DOT = chr(11825)
TURNED_COMMA = chr(11826)
RAISED_DOT = chr(11827)
RAISED_COMMA = chr(11828)
TURNED_SEMICOLON = chr(11829)
DAGGER_WITH_LEFT_GUARD = chr(11830)
DAGGER_WITH_RIGHT_GUARD = chr(11831)
TURNED_DAGGER = chr(11832)
TOP_HALF_SECTION_SIGN = chr(11833)
TWO_EM_DASH = chr(11834)
THREE_EM_DASH = chr(11835)
STENOGRAPHIC_FULL_STOP = chr(11836)
VERTICAL_SIX_DOTS = chr(11837)
WIGGLY_VERTICAL_LINE = chr(11838)
CAPITULUM = chr(11839)
DOUBLE_HYPHEN = chr(11840)
REVERSED_COMMA = chr(11841)
DOUBLE_LOW_REVERSED_9_QUOTATION_MARK = chr(11842)
DASH_WITH_LEFT_UPTURN = chr(11843)
DOUBLE_SUSPENSION_MARK = chr(11844)
INVERTED_LOW_KAVYKA = chr(11845)
INVERTED_LOW_KAVYKA_WITH_KAVYKA_ABOVE = chr(11846)
LOW_KAVYKA = chr(11847)
LOW_KAVYKA_WITH_DOT = chr(11848)
DOUBLE_STACKED_COMMA = chr(11849)
DOTTED_SOLIDUS = chr(11850)
TRIPLE_DAGGER = chr(11851)
MEDIEVAL_COMMA = chr(11852)
PARAGRAPHUS_MARK = chr(11853)
PUNCTUS_ELEVATUS_MARK = chr(11854)
CORNISH_VERSE_DIVIDER = chr(11855)
CROSS_PATTY_WITH_RIGHT_CROSSBAR = chr(11856)
CROSS_PATTY_WITH_LEFT_CROSSBAR = chr(11857)
TIRONIAN_SIGN_CAPITAL_ET = chr(11858)
MEDIEVAL_EXCLAMATION_MARK = chr(11859)
MEDIEVAL_QUESTION_MARK = chr(11860)
LEFT_SQUARE_BRACKET_WITH_STROKE = chr(11861)
RIGHT_SQUARE_BRACKET_WITH_STROKE = chr(11862)
LEFT_SQUARE_BRACKET_WITH_DOUBLE_STROKE = chr(11863)
RIGHT_SQUARE_BRACKET_WITH_DOUBLE_STROKE = chr(11864)
TOP_HALF_LEFT_PARENTHESIS = chr(11865)
TOP_HALF_RIGHT_PARENTHESIS = chr(11866)
BOTTOM_HALF_LEFT_PARENTHESIS = chr(11867)
BOTTOM_HALF_RIGHT_PARENTHESIS = chr(11868)
OBLIQUE_HYPHEN = chr(11869)
CJK_RADICAL_REPEAT = chr(11904)
CJK_RADICAL_CLIFF = chr(11905)
CJK_RADICAL_SECOND_ONE = chr(11906)
CJK_RADICAL_SECOND_TWO = chr(11907)
CJK_RADICAL_SECOND_THREE = chr(11908)
CJK_RADICAL_PERSON = chr(11909)
CJK_RADICAL_BOX = chr(11910)
CJK_RADICAL_TABLE = chr(11911)
CJK_RADICAL_KNIFE_ONE = chr(11912)
CJK_RADICAL_KNIFE_TWO = chr(11913)
CJK_RADICAL_DIVINATION = chr(11914)
CJK_RADICAL_SEAL = chr(11915)
CJK_RADICAL_SMALL_ONE = chr(11916)
CJK_RADICAL_SMALL_TWO = chr(11917)
CJK_RADICAL_LAME_ONE = chr(11918)
CJK_RADICAL_LAME_TWO = chr(11919)
CJK_RADICAL_LAME_THREE = chr(11920)
CJK_RADICAL_LAME_FOUR = chr(11921)
CJK_RADICAL_SNAKE = chr(11922)
CJK_RADICAL_THREAD = chr(11923)
CJK_RADICAL_SNOUT_ONE = chr(11924)
CJK_RADICAL_SNOUT_TWO = chr(11925)
CJK_RADICAL_HEART_ONE = chr(11926)
CJK_RADICAL_HEART_TWO = chr(11927)
CJK_RADICAL_HAND = chr(11928)
CJK_RADICAL_RAP = chr(11929)
CJK_RADICAL_CHOKE = chr(11931)
CJK_RADICAL_SUN = chr(11932)
CJK_RADICAL_MOON = chr(11933)
CJK_RADICAL_DEATH = chr(11934)
CJK_RADICAL_MOTHER = chr(11935)
CJK_RADICAL_CIVILIAN = chr(11936)
CJK_RADICAL_WATER_ONE = chr(11937)
CJK_RADICAL_WATER_TWO = chr(11938)
CJK_RADICAL_FIRE = chr(11939)
CJK_RADICAL_PAW_ONE = chr(11940)
CJK_RADICAL_PAW_TWO = chr(11941)
CJK_RADICAL_SIMPLIFIED_HALF_TREE_TRUNK = chr(11942)
CJK_RADICAL_COW = chr(11943)
CJK_RADICAL_DOG = chr(11944)
CJK_RADICAL_JADE = chr(11945)
CJK_RADICAL_BOLT_OF_CLOTH = chr(11946)
CJK_RADICAL_EYE = chr(11947)
CJK_RADICAL_SPIRIT_ONE = chr(11948)
CJK_RADICAL_SPIRIT_TWO = chr(11949)
CJK_RADICAL_BAMBOO = chr(11950)
CJK_RADICAL_SILK = chr(11951)
CJK_RADICAL_C_SIMPLIFIED_SILK = chr(11952)
CJK_RADICAL_NET_ONE = chr(11953)
CJK_RADICAL_NET_TWO = chr(11954)
CJK_RADICAL_NET_THREE = chr(11955)
CJK_RADICAL_NET_FOUR = chr(11956)
CJK_RADICAL_MESH = chr(11957)
CJK_RADICAL_SHEEP = chr(11958)
CJK_RADICAL_RAM = chr(11959)
CJK_RADICAL_EWE = chr(11960)
CJK_RADICAL_OLD = chr(11961)
CJK_RADICAL_BRUSH_ONE = chr(11962)
CJK_RADICAL_BRUSH_TWO = chr(11963)
CJK_RADICAL_MEAT = chr(11964)
CJK_RADICAL_MORTAR = chr(11965)
CJK_RADICAL_GRASS_ONE = chr(11966)
CJK_RADICAL_GRASS_TWO = chr(11967)
CJK_RADICAL_GRASS_THREE = chr(11968)
CJK_RADICAL_TIGER = chr(11969)
CJK_RADICAL_CLOTHES = chr(11970)
CJK_RADICAL_WEST_ONE = chr(11971)
CJK_RADICAL_WEST_TWO = chr(11972)
CJK_RADICAL_C_SIMPLIFIED_SEE = chr(11973)
CJK_RADICAL_SIMPLIFIED_HORN = chr(11974)
CJK_RADICAL_HORN = chr(11975)
CJK_RADICAL_C_SIMPLIFIED_SPEECH = chr(11976)
CJK_RADICAL_C_SIMPLIFIED_SHELL = chr(11977)
CJK_RADICAL_FOOT = chr(11978)
CJK_RADICAL_C_SIMPLIFIED_CART = chr(11979)
CJK_RADICAL_SIMPLIFIED_WALK = chr(11980)
CJK_RADICAL_WALK_ONE = chr(11981)
CJK_RADICAL_WALK_TWO = chr(11982)
CJK_RADICAL_CITY = chr(11983)
CJK_RADICAL_C_SIMPLIFIED_GOLD = chr(11984)
CJK_RADICAL_LONG_ONE = chr(11985)
CJK_RADICAL_LONG_TWO = chr(11986)
CJK_RADICAL_C_SIMPLIFIED_LONG = chr(11987)
CJK_RADICAL_C_SIMPLIFIED_GATE = chr(11988)
CJK_RADICAL_MOUND_ONE = chr(11989)
CJK_RADICAL_MOUND_TWO = chr(11990)
CJK_RADICAL_RAIN = chr(11991)
CJK_RADICAL_BLUE = chr(11992)
CJK_RADICAL_C_SIMPLIFIED_TANNED_LEATHER = chr(11993)
CJK_RADICAL_C_SIMPLIFIED_LEAF = chr(11994)
CJK_RADICAL_C_SIMPLIFIED_WIND = chr(11995)
CJK_RADICAL_C_SIMPLIFIED_FLY = chr(11996)
CJK_RADICAL_EAT_ONE = chr(11997)
CJK_RADICAL_EAT_TWO = chr(11998)
CJK_RADICAL_EAT_THREE = chr(11999)
CJK_RADICAL_C_SIMPLIFIED_EAT = chr(12000)
CJK_RADICAL_HEAD = chr(12001)
CJK_RADICAL_C_SIMPLIFIED_HORSE = chr(12002)
CJK_RADICAL_BONE = chr(12003)
CJK_RADICAL_GHOST = chr(12004)
CJK_RADICAL_C_SIMPLIFIED_FISH = chr(12005)
CJK_RADICAL_C_SIMPLIFIED_BIRD = chr(12006)
CJK_RADICAL_C_SIMPLIFIED_SALT = chr(12007)
CJK_RADICAL_SIMPLIFIED_WHEAT = chr(12008)
CJK_RADICAL_SIMPLIFIED_YELLOW = chr(12009)
CJK_RADICAL_C_SIMPLIFIED_FROG = chr(12010)
CJK_RADICAL_J_SIMPLIFIED_EVEN = chr(12011)
CJK_RADICAL_C_SIMPLIFIED_EVEN = chr(12012)
CJK_RADICAL_J_SIMPLIFIED_TOOTH = chr(12013)
CJK_RADICAL_C_SIMPLIFIED_TOOTH = chr(12014)
CJK_RADICAL_J_SIMPLIFIED_DRAGON = chr(12015)
CJK_RADICAL_C_SIMPLIFIED_DRAGON = chr(12016)
CJK_RADICAL_TURTLE = chr(12017)
CJK_RADICAL_J_SIMPLIFIED_TURTLE = chr(12018)
CJK_RADICAL_C_SIMPLIFIED_TURTLE = chr(12019)
KANGXI_RADICAL_ONE = chr(12032)
KANGXI_RADICAL_LINE = chr(12033)
KANGXI_RADICAL_DOT = chr(12034)
KANGXI_RADICAL_SLASH = chr(12035)
KANGXI_RADICAL_SECOND = chr(12036)
KANGXI_RADICAL_HOOK = chr(12037)
KANGXI_RADICAL_TWO = chr(12038)
KANGXI_RADICAL_LID = chr(12039)
KANGXI_RADICAL_MAN = chr(12040)
KANGXI_RADICAL_LEGS = chr(12041)
KANGXI_RADICAL_ENTER = chr(12042)
KANGXI_RADICAL_EIGHT = chr(12043)
KANGXI_RADICAL_DOWN_BOX = chr(12044)
KANGXI_RADICAL_COVER = chr(12045)
KANGXI_RADICAL_ICE = chr(12046)
KANGXI_RADICAL_TABLE = chr(12047)
KANGXI_RADICAL_OPEN_BOX = chr(12048)
KANGXI_RADICAL_KNIFE = chr(12049)
KANGXI_RADICAL_POWER = chr(12050)
KANGXI_RADICAL_WRAP = chr(12051)
KANGXI_RADICAL_SPOON = chr(12052)
KANGXI_RADICAL_RIGHT_OPEN_BOX = chr(12053)
KANGXI_RADICAL_HIDING_ENCLOSURE = chr(12054)
KANGXI_RADICAL_TEN = chr(12055)
KANGXI_RADICAL_DIVINATION = chr(12056)
KANGXI_RADICAL_SEAL = chr(12057)
KANGXI_RADICAL_CLIFF = chr(12058)
KANGXI_RADICAL_PRIVATE = chr(12059)
KANGXI_RADICAL_AGAIN = chr(12060)
KANGXI_RADICAL_MOUTH = chr(12061)
KANGXI_RADICAL_ENCLOSURE = chr(12062)
KANGXI_RADICAL_EARTH = chr(12063)
KANGXI_RADICAL_SCHOLAR = chr(12064)
KANGXI_RADICAL_GO = chr(12065)
KANGXI_RADICAL_GO_SLOWLY = chr(12066)
KANGXI_RADICAL_EVENING = chr(12067)
KANGXI_RADICAL_BIG = chr(12068)
KANGXI_RADICAL_WOMAN = chr(12069)
KANGXI_RADICAL_CHILD = chr(12070)
KANGXI_RADICAL_ROOF = chr(12071)
KANGXI_RADICAL_INCH = chr(12072)
KANGXI_RADICAL_SMALL = chr(12073)
KANGXI_RADICAL_LAME = chr(12074)
KANGXI_RADICAL_CORPSE = chr(12075)
KANGXI_RADICAL_SPROUT = chr(12076)
KANGXI_RADICAL_MOUNTAIN = chr(12077)
KANGXI_RADICAL_RIVER = chr(12078)
KANGXI_RADICAL_WORK = chr(12079)
KANGXI_RADICAL_ONESELF = chr(12080)
KANGXI_RADICAL_TURBAN = chr(12081)
KANGXI_RADICAL_DRY = chr(12082)
KANGXI_RADICAL_SHORT_THREAD = chr(12083)
KANGXI_RADICAL_DOTTED_CLIFF = chr(12084)
KANGXI_RADICAL_LONG_STRIDE = chr(12085)
KANGXI_RADICAL_TWO_HANDS = chr(12086)
KANGXI_RADICAL_SHOOT = chr(12087)
KANGXI_RADICAL_BOW = chr(12088)
KANGXI_RADICAL_SNOUT = chr(12089)
KANGXI_RADICAL_BRISTLE = chr(12090)
KANGXI_RADICAL_STEP = chr(12091)
KANGXI_RADICAL_HEART = chr(12092)
KANGXI_RADICAL_HALBERD = chr(12093)
KANGXI_RADICAL_DOOR = chr(12094)
KANGXI_RADICAL_HAND = chr(12095)
KANGXI_RADICAL_BRANCH = chr(12096)
KANGXI_RADICAL_RAP = chr(12097)
KANGXI_RADICAL_SCRIPT = chr(12098)
KANGXI_RADICAL_DIPPER = chr(12099)
KANGXI_RADICAL_AXE = chr(12100)
KANGXI_RADICAL_SQUARE = chr(12101)
KANGXI_RADICAL_NOT = chr(12102)
KANGXI_RADICAL_SUN = chr(12103)
KANGXI_RADICAL_SAY = chr(12104)
KANGXI_RADICAL_MOON = chr(12105)
KANGXI_RADICAL_TREE = chr(12106)
KANGXI_RADICAL_LACK = chr(12107)
KANGXI_RADICAL_STOP = chr(12108)
KANGXI_RADICAL_DEATH = chr(12109)
KANGXI_RADICAL_WEAPON = chr(12110)
KANGXI_RADICAL_DO_NOT = chr(12111)
KANGXI_RADICAL_COMPARE = chr(12112)
KANGXI_RADICAL_FUR = chr(12113)
KANGXI_RADICAL_CLAN = chr(12114)
KANGXI_RADICAL_STEAM = chr(12115)
KANGXI_RADICAL_WATER = chr(12116)
KANGXI_RADICAL_FIRE = chr(12117)
KANGXI_RADICAL_CLAW = chr(12118)
KANGXI_RADICAL_FATHER = chr(12119)
KANGXI_RADICAL_DOUBLE_X = chr(12120)
KANGXI_RADICAL_HALF_TREE_TRUNK = chr(12121)
KANGXI_RADICAL_SLICE = chr(12122)
KANGXI_RADICAL_FANG = chr(12123)
KANGXI_RADICAL_COW = chr(12124)
KANGXI_RADICAL_DOG = chr(12125)
KANGXI_RADICAL_PROFOUND = chr(12126)
KANGXI_RADICAL_JADE = chr(12127)
KANGXI_RADICAL_MELON = chr(12128)
KANGXI_RADICAL_TILE = chr(12129)
KANGXI_RADICAL_SWEET = chr(12130)
KANGXI_RADICAL_LIFE = chr(12131)
KANGXI_RADICAL_USE = chr(12132)
KANGXI_RADICAL_FIELD = chr(12133)
KANGXI_RADICAL_BOLT_OF_CLOTH = chr(12134)
KANGXI_RADICAL_SICKNESS = chr(12135)
KANGXI_RADICAL_DOTTED_TENT = chr(12136)
KANGXI_RADICAL_WHITE = chr(12137)
KANGXI_RADICAL_SKIN = chr(12138)
KANGXI_RADICAL_DISH = chr(12139)
KANGXI_RADICAL_EYE = chr(12140)
KANGXI_RADICAL_SPEAR = chr(12141)
KANGXI_RADICAL_ARROW = chr(12142)
KANGXI_RADICAL_STONE = chr(12143)
KANGXI_RADICAL_SPIRIT = chr(12144)
KANGXI_RADICAL_TRACK = chr(12145)
KANGXI_RADICAL_GRAIN = chr(12146)
KANGXI_RADICAL_CAVE = chr(12147)
KANGXI_RADICAL_STAND = chr(12148)
KANGXI_RADICAL_BAMBOO = chr(12149)
KANGXI_RADICAL_RICE = chr(12150)
KANGXI_RADICAL_SILK = chr(12151)
KANGXI_RADICAL_JAR = chr(12152)
KANGXI_RADICAL_NET = chr(12153)
KANGXI_RADICAL_SHEEP = chr(12154)
KANGXI_RADICAL_FEATHER = chr(12155)
KANGXI_RADICAL_OLD = chr(12156)
KANGXI_RADICAL_AND = chr(12157)
KANGXI_RADICAL_PLOW = chr(12158)
KANGXI_RADICAL_EAR = chr(12159)
KANGXI_RADICAL_BRUSH = chr(12160)
KANGXI_RADICAL_MEAT = chr(12161)
KANGXI_RADICAL_MINISTER = chr(12162)
KANGXI_RADICAL_SELF = chr(12163)
KANGXI_RADICAL_ARRIVE = chr(12164)
KANGXI_RADICAL_MORTAR = chr(12165)
KANGXI_RADICAL_TONGUE = chr(12166)
KANGXI_RADICAL_OPPOSE = chr(12167)
KANGXI_RADICAL_BOAT = chr(12168)
KANGXI_RADICAL_STOPPING = chr(12169)
KANGXI_RADICAL_COLOR = chr(12170)
KANGXI_RADICAL_GRASS = chr(12171)
KANGXI_RADICAL_TIGER = chr(12172)
KANGXI_RADICAL_INSECT = chr(12173)
KANGXI_RADICAL_BLOOD = chr(12174)
KANGXI_RADICAL_WALK_ENCLOSURE = chr(12175)
KANGXI_RADICAL_CLOTHES = chr(12176)
KANGXI_RADICAL_WEST = chr(12177)
KANGXI_RADICAL_SEE = chr(12178)
KANGXI_RADICAL_HORN = chr(12179)
KANGXI_RADICAL_SPEECH = chr(12180)
KANGXI_RADICAL_VALLEY = chr(12181)
KANGXI_RADICAL_BEAN = chr(12182)
KANGXI_RADICAL_PIG = chr(12183)
KANGXI_RADICAL_BADGER = chr(12184)
KANGXI_RADICAL_SHELL = chr(12185)
KANGXI_RADICAL_RED = chr(12186)
KANGXI_RADICAL_RUN = chr(12187)
KANGXI_RADICAL_FOOT = chr(12188)
KANGXI_RADICAL_BODY = chr(12189)
KANGXI_RADICAL_CART = chr(12190)
KANGXI_RADICAL_BITTER = chr(12191)
KANGXI_RADICAL_MORNING = chr(12192)
KANGXI_RADICAL_WALK = chr(12193)
KANGXI_RADICAL_CITY = chr(12194)
KANGXI_RADICAL_WINE = chr(12195)
KANGXI_RADICAL_DISTINGUISH = chr(12196)
KANGXI_RADICAL_VILLAGE = chr(12197)
KANGXI_RADICAL_GOLD = chr(12198)
KANGXI_RADICAL_LONG = chr(12199)
KANGXI_RADICAL_GATE = chr(12200)
KANGXI_RADICAL_MOUND = chr(12201)
KANGXI_RADICAL_SLAVE = chr(12202)
KANGXI_RADICAL_SHORT_TAILED_BIRD = chr(12203)
KANGXI_RADICAL_RAIN = chr(12204)
KANGXI_RADICAL_BLUE = chr(12205)
KANGXI_RADICAL_WRONG = chr(12206)
KANGXI_RADICAL_FACE = chr(12207)
KANGXI_RADICAL_LEATHER = chr(12208)
KANGXI_RADICAL_TANNED_LEATHER = chr(12209)
KANGXI_RADICAL_LEEK = chr(12210)
KANGXI_RADICAL_SOUND = chr(12211)
KANGXI_RADICAL_LEAF = chr(12212)
KANGXI_RADICAL_WIND = chr(12213)
KANGXI_RADICAL_FLY = chr(12214)
KANGXI_RADICAL_EAT = chr(12215)
KANGXI_RADICAL_HEAD = chr(12216)
KANGXI_RADICAL_FRAGRANT = chr(12217)
KANGXI_RADICAL_HORSE = chr(12218)
KANGXI_RADICAL_BONE = chr(12219)
KANGXI_RADICAL_TALL = chr(12220)
KANGXI_RADICAL_HAIR = chr(12221)
KANGXI_RADICAL_FIGHT = chr(12222)
KANGXI_RADICAL_SACRIFICIAL_WINE = chr(12223)
KANGXI_RADICAL_CAULDRON = chr(12224)
KANGXI_RADICAL_GHOST = chr(12225)
KANGXI_RADICAL_FISH = chr(12226)
KANGXI_RADICAL_BIRD = chr(12227)
KANGXI_RADICAL_SALT = chr(12228)
KANGXI_RADICAL_DEER = chr(12229)
KANGXI_RADICAL_WHEAT = chr(12230)
KANGXI_RADICAL_HEMP = chr(12231)
KANGXI_RADICAL_YELLOW = chr(12232)
KANGXI_RADICAL_MILLET = chr(12233)
KANGXI_RADICAL_BLACK = chr(12234)
KANGXI_RADICAL_EMBROIDERY = chr(12235)
KANGXI_RADICAL_FROG = chr(12236)
KANGXI_RADICAL_TRIPOD = chr(12237)
KANGXI_RADICAL_DRUM = chr(12238)
KANGXI_RADICAL_RAT = chr(12239)
KANGXI_RADICAL_NOSE = chr(12240)
KANGXI_RADICAL_EVEN = chr(12241)
KANGXI_RADICAL_TOOTH = chr(12242)
KANGXI_RADICAL_DRAGON = chr(12243)
KANGXI_RADICAL_TURTLE = chr(12244)
KANGXI_RADICAL_FLUTE = chr(12245)
IDEOGRAPHIC_DESCRIPTION_CHARACTER_LEFT_TO_RIGHT = chr(12272)
IDEOGRAPHIC_DESCRIPTION_CHARACTER_ABOVE_TO_BELOW = chr(12273)
IDEOGRAPHIC_DESCRIPTION_CHARACTER_LEFT_TO_MIDDLE_AND_RIGHT = chr(12274)
IDEOGRAPHIC_DESCRIPTION_CHARACTER_ABOVE_TO_MIDDLE_AND_BELOW = chr(12275)
IDEOGRAPHIC_DESCRIPTION_CHARACTER_FULL_SURROUND = chr(12276)
IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_ABOVE = chr(12277)
IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_BELOW = chr(12278)
IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_LEFT = chr(12279)
IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_UPPER_LEFT = chr(12280)
IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_UPPER_RIGHT = chr(12281)
IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_LOWER_LEFT = chr(12282)
IDEOGRAPHIC_DESCRIPTION_CHARACTER_OVERLAID = chr(12283)
IDEOGRAPHIC_SPACE = chr(12288)
IDEOGRAPHIC_COMMA = chr(12289)
IDEOGRAPHIC_FULL_STOP = chr(12290)
DITTO_MARK = chr(12291)
JAPANESE_INDUSTRIAL_STANDARD_SYMBOL = chr(12292)
IDEOGRAPHIC_ITERATION_MARK = chr(12293)
IDEOGRAPHIC_CLOSING_MARK = chr(12294)
IDEOGRAPHIC_NUMBER_ZERO = chr(12295)
LEFT_ANGLE_BRACKET = chr(12296)
RIGHT_ANGLE_BRACKET = chr(12297)
LEFT_DOUBLE_ANGLE_BRACKET = chr(12298)
RIGHT_DOUBLE_ANGLE_BRACKET = chr(12299)
LEFT_CORNER_BRACKET = chr(12300)
RIGHT_CORNER_BRACKET = chr(12301)
LEFT_WHITE_CORNER_BRACKET = chr(12302)
RIGHT_WHITE_CORNER_BRACKET = chr(12303)
LEFT_BLACK_LENTICULAR_BRACKET = chr(12304)
RIGHT_BLACK_LENTICULAR_BRACKET = chr(12305)
POSTAL_MARK = chr(12306)
GETA_MARK = chr(12307)
LEFT_TORTOISE_SHELL_BRACKET = chr(12308)
RIGHT_TORTOISE_SHELL_BRACKET = chr(12309)
LEFT_WHITE_LENTICULAR_BRACKET = chr(12310)
RIGHT_WHITE_LENTICULAR_BRACKET = chr(12311)
LEFT_WHITE_TORTOISE_SHELL_BRACKET = chr(12312)
RIGHT_WHITE_TORTOISE_SHELL_BRACKET = chr(12313)
LEFT_WHITE_SQUARE_BRACKET = chr(12314)
RIGHT_WHITE_SQUARE_BRACKET = chr(12315)
WAVE_DASH = chr(12316)
REVERSED_DOUBLE_PRIME_QUOTATION_MARK = chr(12317)
DOUBLE_PRIME_QUOTATION_MARK = chr(12318)
LOW_DOUBLE_PRIME_QUOTATION_MARK = chr(12319)
POSTAL_MARK_FACE = chr(12320)
HANGZHOU_NUMERAL_ONE = chr(12321)
HANGZHOU_NUMERAL_TWO = chr(12322)
HANGZHOU_NUMERAL_THREE = chr(12323)
HANGZHOU_NUMERAL_FOUR = chr(12324)
HANGZHOU_NUMERAL_FIVE = chr(12325)
HANGZHOU_NUMERAL_SIX = chr(12326)
HANGZHOU_NUMERAL_SEVEN = chr(12327)
HANGZHOU_NUMERAL_EIGHT = chr(12328)
HANGZHOU_NUMERAL_NINE = chr(12329)
IDEOGRAPHIC_LEVEL_TONE_MARK = chr(12330)
IDEOGRAPHIC_RISING_TONE_MARK = chr(12331)
IDEOGRAPHIC_DEPARTING_TONE_MARK = chr(12332)
IDEOGRAPHIC_ENTERING_TONE_MARK = chr(12333)
HANGUL_SINGLE_DOT_TONE_MARK = chr(12334)
HANGUL_DOUBLE_DOT_TONE_MARK = chr(12335)
WAVY_DASH = chr(12336)
VERTICAL_KANA_REPEAT_MARK = chr(12337)
VERTICAL_KANA_REPEAT_WITH_VOICED_SOUND_MARK = chr(12338)
VERTICAL_KANA_REPEAT_MARK_UPPER_HALF = chr(12339)
VERTICAL_KANA_REPEAT_WITH_VOICED_SOUND_MARK_UPPER_HALF = chr(12340)
VERTICAL_KANA_REPEAT_MARK_LOWER_HALF = chr(12341)
CIRCLED_POSTAL_MARK = chr(12342)
IDEOGRAPHIC_TELEGRAPH_LINE_FEED_SEPARATOR_SYMBOL = chr(12343)
HANGZHOU_NUMERAL_TEN = chr(12344)
HANGZHOU_NUMERAL_TWENTY = chr(12345)
HANGZHOU_NUMERAL_THIRTY = chr(12346)
VERTICAL_IDEOGRAPHIC_ITERATION_MARK = chr(12347)
MASU_MARK = chr(12348)
PART_ALTERNATION_MARK = chr(12349)
IDEOGRAPHIC_VARIATION_INDICATOR = chr(12350)
IDEOGRAPHIC_HALF_FILL_SPACE = chr(12351)
HIRAGANA_LETTER_SMALL_A = chr(12353)
HIRAGANA_LETTER_A = chr(12354)
HIRAGANA_LETTER_SMALL_I = chr(12355)
HIRAGANA_LETTER_I = chr(12356)
HIRAGANA_LETTER_SMALL_U = chr(12357)
HIRAGANA_LETTER_U = chr(12358)
HIRAGANA_LETTER_SMALL_E = chr(12359)
HIRAGANA_LETTER_E = chr(12360)
HIRAGANA_LETTER_SMALL_O = chr(12361)
HIRAGANA_LETTER_O = chr(12362)
HIRAGANA_LETTER_KA = chr(12363)
HIRAGANA_LETTER_GA = chr(12364)
HIRAGANA_LETTER_KI = chr(12365)
HIRAGANA_LETTER_GI = chr(12366)
HIRAGANA_LETTER_KU = chr(12367)
HIRAGANA_LETTER_GU = chr(12368)
HIRAGANA_LETTER_KE = chr(12369)
HIRAGANA_LETTER_GE = chr(12370)
HIRAGANA_LETTER_KO = chr(12371)
HIRAGANA_LETTER_GO = chr(12372)
HIRAGANA_LETTER_SA = chr(12373)
HIRAGANA_LETTER_ZA = chr(12374)
HIRAGANA_LETTER_SI = chr(12375)
HIRAGANA_LETTER_ZI = chr(12376)
HIRAGANA_LETTER_SU = chr(12377)
HIRAGANA_LETTER_ZU = chr(12378)
HIRAGANA_LETTER_SE = chr(12379)
HIRAGANA_LETTER_ZE = chr(12380)
HIRAGANA_LETTER_SO = chr(12381)
HIRAGANA_LETTER_ZO = chr(12382)
HIRAGANA_LETTER_TA = chr(12383)
HIRAGANA_LETTER_DA = chr(12384)
HIRAGANA_LETTER_TI = chr(12385)
HIRAGANA_LETTER_DI = chr(12386)
HIRAGANA_LETTER_SMALL_TU = chr(12387)
HIRAGANA_LETTER_TU = chr(12388)
HIRAGANA_LETTER_DU = chr(12389)
HIRAGANA_LETTER_TE = chr(12390)
HIRAGANA_LETTER_DE = chr(12391)
HIRAGANA_LETTER_TO = chr(12392)
HIRAGANA_LETTER_DO = chr(12393)
HIRAGANA_LETTER_NA = chr(12394)
HIRAGANA_LETTER_NI = chr(12395)
HIRAGANA_LETTER_NU = chr(12396)
HIRAGANA_LETTER_NE = chr(12397)
HIRAGANA_LETTER_NO = chr(12398)
HIRAGANA_LETTER_HA = chr(12399)
HIRAGANA_LETTER_BA = chr(12400)
HIRAGANA_LETTER_PA = chr(12401)
HIRAGANA_LETTER_HI = chr(12402)
HIRAGANA_LETTER_BI = chr(12403)
HIRAGANA_LETTER_PI = chr(12404)
HIRAGANA_LETTER_HU = chr(12405)
HIRAGANA_LETTER_BU = chr(12406)
HIRAGANA_LETTER_PU = chr(12407)
HIRAGANA_LETTER_HE = chr(12408)
HIRAGANA_LETTER_BE = chr(12409)
HIRAGANA_LETTER_PE = chr(12410)
HIRAGANA_LETTER_HO = chr(12411)
HIRAGANA_LETTER_BO = chr(12412)
HIRAGANA_LETTER_PO = chr(12413)
HIRAGANA_LETTER_MA = chr(12414)
HIRAGANA_LETTER_MI = chr(12415)
HIRAGANA_LETTER_MU = chr(12416)
HIRAGANA_LETTER_ME = chr(12417)
HIRAGANA_LETTER_MO = chr(12418)
HIRAGANA_LETTER_SMALL_YA = chr(12419)
HIRAGANA_LETTER_YA = chr(12420)
HIRAGANA_LETTER_SMALL_YU = chr(12421)
HIRAGANA_LETTER_YU = chr(12422)
HIRAGANA_LETTER_SMALL_YO = chr(12423)
HIRAGANA_LETTER_YO = chr(12424)
HIRAGANA_LETTER_RA = chr(12425)
HIRAGANA_LETTER_RI = chr(12426)
HIRAGANA_LETTER_RU = chr(12427)
HIRAGANA_LETTER_RE = chr(12428)
HIRAGANA_LETTER_RO = chr(12429)
HIRAGANA_LETTER_SMALL_WA = chr(12430)
HIRAGANA_LETTER_WA = chr(12431)
HIRAGANA_LETTER_WI = chr(12432)
HIRAGANA_LETTER_WE = chr(12433)
HIRAGANA_LETTER_WO = chr(12434)
HIRAGANA_LETTER_N = chr(12435)
HIRAGANA_LETTER_VU = chr(12436)
HIRAGANA_LETTER_SMALL_KA = chr(12437)
HIRAGANA_LETTER_SMALL_KE = chr(12438)
COMBINING_KATAKANA_HIRAGANA_VOICED_SOUND_MARK = chr(12441)
COMBINING_KATAKANA_HIRAGANA_SEMI_VOICED_SOUND_MARK = chr(12442)
KATAKANA_HIRAGANA_VOICED_SOUND_MARK = chr(12443)
KATAKANA_HIRAGANA_SEMI_VOICED_SOUND_MARK = chr(12444)
HIRAGANA_ITERATION_MARK = chr(12445)
HIRAGANA_VOICED_ITERATION_MARK = chr(12446)
HIRAGANA_DIGRAPH_YORI = chr(12447)
KATAKANA_HIRAGANA_DOUBLE_HYPHEN = chr(12448)
KATAKANA_LETTER_SMALL_A = chr(12449)
KATAKANA_LETTER_A = chr(12450)
KATAKANA_LETTER_SMALL_I = chr(12451)
KATAKANA_LETTER_I = chr(12452)
KATAKANA_LETTER_SMALL_U = chr(12453)
KATAKANA_LETTER_U = chr(12454)
KATAKANA_LETTER_SMALL_E = chr(12455)
KATAKANA_LETTER_E = chr(12456)
KATAKANA_LETTER_SMALL_O = chr(12457)
KATAKANA_LETTER_O = chr(12458)
KATAKANA_LETTER_KA = chr(12459)
KATAKANA_LETTER_GA = chr(12460)
KATAKANA_LETTER_KI = chr(12461)
KATAKANA_LETTER_GI = chr(12462)
KATAKANA_LETTER_KU = chr(12463)
KATAKANA_LETTER_GU = chr(12464)
KATAKANA_LETTER_KE = chr(12465)
KATAKANA_LETTER_GE = chr(12466)
KATAKANA_LETTER_KO = chr(12467)
KATAKANA_LETTER_GO = chr(12468)
KATAKANA_LETTER_SA = chr(12469)
KATAKANA_LETTER_ZA = chr(12470)
KATAKANA_LETTER_SI = chr(12471)
KATAKANA_LETTER_ZI = chr(12472)
KATAKANA_LETTER_SU = chr(12473)
KATAKANA_LETTER_ZU = chr(12474)
KATAKANA_LETTER_SE = chr(12475)
KATAKANA_LETTER_ZE = chr(12476)
KATAKANA_LETTER_SO = chr(12477)
KATAKANA_LETTER_ZO = chr(12478)
KATAKANA_LETTER_TA = chr(12479)
KATAKANA_LETTER_DA = chr(12480)
KATAKANA_LETTER_TI = chr(12481)
KATAKANA_LETTER_DI = chr(12482)
KATAKANA_LETTER_SMALL_TU = chr(12483)
KATAKANA_LETTER_TU = chr(12484)
KATAKANA_LETTER_DU = chr(12485)
KATAKANA_LETTER_TE = chr(12486)
KATAKANA_LETTER_DE = chr(12487)
KATAKANA_LETTER_TO = chr(12488)
KATAKANA_LETTER_DO = chr(12489)
KATAKANA_LETTER_NA = chr(12490)
KATAKANA_LETTER_NI = chr(12491)
KATAKANA_LETTER_NU = chr(12492)
KATAKANA_LETTER_NE = chr(12493)
KATAKANA_LETTER_NO = chr(12494)
KATAKANA_LETTER_HA = chr(12495)
KATAKANA_LETTER_BA = chr(12496)
KATAKANA_LETTER_PA = chr(12497)
KATAKANA_LETTER_HI = chr(12498)
KATAKANA_LETTER_BI = chr(12499)
KATAKANA_LETTER_PI = chr(12500)
KATAKANA_LETTER_HU = chr(12501)
KATAKANA_LETTER_BU = chr(12502)
KATAKANA_LETTER_PU = chr(12503)
KATAKANA_LETTER_HE = chr(12504)
KATAKANA_LETTER_BE = chr(12505)
KATAKANA_LETTER_PE = chr(12506)
KATAKANA_LETTER_HO = chr(12507)
KATAKANA_LETTER_BO = chr(12508)
KATAKANA_LETTER_PO = chr(12509)
KATAKANA_LETTER_MA = chr(12510)
KATAKANA_LETTER_MI = chr(12511)
KATAKANA_LETTER_MU = chr(12512)
KATAKANA_LETTER_ME = chr(12513)
KATAKANA_LETTER_MO = chr(12514)
KATAKANA_LETTER_SMALL_YA = chr(12515)
KATAKANA_LETTER_YA = chr(12516)
KATAKANA_LETTER_SMALL_YU = chr(12517)
KATAKANA_LETTER_YU = chr(12518)
KATAKANA_LETTER_SMALL_YO = chr(12519)
KATAKANA_LETTER_YO = chr(12520)
KATAKANA_LETTER_RA = chr(12521)
KATAKANA_LETTER_RI = chr(12522)
KATAKANA_LETTER_RU = chr(12523)
KATAKANA_LETTER_RE = chr(12524)
KATAKANA_LETTER_RO = chr(12525)
KATAKANA_LETTER_SMALL_WA = chr(12526)
KATAKANA_LETTER_WA = chr(12527)
KATAKANA_LETTER_WI = chr(12528)
KATAKANA_LETTER_WE = chr(12529)
KATAKANA_LETTER_WO = chr(12530)
KATAKANA_LETTER_N = chr(12531)
KATAKANA_LETTER_VU = chr(12532)
KATAKANA_LETTER_SMALL_KA = chr(12533)
KATAKANA_LETTER_SMALL_KE = chr(12534)
KATAKANA_LETTER_VA = chr(12535)
KATAKANA_LETTER_VI = chr(12536)
KATAKANA_LETTER_VE = chr(12537)
KATAKANA_LETTER_VO = chr(12538)
KATAKANA_MIDDLE_DOT = chr(12539)
KATAKANA_HIRAGANA_PROLONGED_SOUND_MARK = chr(12540)
KATAKANA_ITERATION_MARK = chr(12541)
KATAKANA_VOICED_ITERATION_MARK = chr(12542)
KATAKANA_DIGRAPH_KOTO = chr(12543)
BOPOMOFO_LETTER_B = chr(12549)
BOPOMOFO_LETTER_P = chr(12550)
BOPOMOFO_LETTER_M = chr(12551)
BOPOMOFO_LETTER_F = chr(12552)
BOPOMOFO_LETTER_D = chr(12553)
BOPOMOFO_LETTER_T = chr(12554)
BOPOMOFO_LETTER_N = chr(12555)
BOPOMOFO_LETTER_L = chr(12556)
BOPOMOFO_LETTER_G = chr(12557)
BOPOMOFO_LETTER_K = chr(12558)
BOPOMOFO_LETTER_H = chr(12559)
BOPOMOFO_LETTER_J = chr(12560)
BOPOMOFO_LETTER_Q = chr(12561)
BOPOMOFO_LETTER_X = chr(12562)
BOPOMOFO_LETTER_ZH = chr(12563)
BOPOMOFO_LETTER_CH = chr(12564)
BOPOMOFO_LETTER_SH = chr(12565)
BOPOMOFO_LETTER_R = chr(12566)
BOPOMOFO_LETTER_Z = chr(12567)
BOPOMOFO_LETTER_C = chr(12568)
BOPOMOFO_LETTER_S = chr(12569)
BOPOMOFO_LETTER_A = chr(12570)
BOPOMOFO_LETTER_O = chr(12571)
BOPOMOFO_LETTER_E = chr(12572)
BOPOMOFO_LETTER_EH = chr(12573)
BOPOMOFO_LETTER_AI = chr(12574)
BOPOMOFO_LETTER_EI = chr(12575)
BOPOMOFO_LETTER_AU = chr(12576)
BOPOMOFO_LETTER_OU = chr(12577)
BOPOMOFO_LETTER_AN = chr(12578)
BOPOMOFO_LETTER_EN = chr(12579)
BOPOMOFO_LETTER_ANG = chr(12580)
BOPOMOFO_LETTER_ENG = chr(12581)
BOPOMOFO_LETTER_ER = chr(12582)
BOPOMOFO_LETTER_I = chr(12583)
BOPOMOFO_LETTER_U = chr(12584)
BOPOMOFO_LETTER_IU = chr(12585)
BOPOMOFO_LETTER_V = chr(12586)
BOPOMOFO_LETTER_NG = chr(12587)
BOPOMOFO_LETTER_GN = chr(12588)
BOPOMOFO_LETTER_IH = chr(12589)
BOPOMOFO_LETTER_O_WITH_DOT_ABOVE = chr(12590)
BOPOMOFO_LETTER_NN = chr(12591)
HANGUL_LETTER_KIYEOK = chr(12593)
HANGUL_LETTER_SSANGKIYEOK = chr(12594)
HANGUL_LETTER_KIYEOK_SIOS = chr(12595)
HANGUL_LETTER_NIEUN = chr(12596)
HANGUL_LETTER_NIEUN_CIEUC = chr(12597)
HANGUL_LETTER_NIEUN_HIEUH = chr(12598)
HANGUL_LETTER_TIKEUT = chr(12599)
HANGUL_LETTER_SSANGTIKEUT = chr(12600)
HANGUL_LETTER_RIEUL = chr(12601)
HANGUL_LETTER_RIEUL_KIYEOK = chr(12602)
HANGUL_LETTER_RIEUL_MIEUM = chr(12603)
HANGUL_LETTER_RIEUL_PIEUP = chr(12604)
HANGUL_LETTER_RIEUL_SIOS = chr(12605)
HANGUL_LETTER_RIEUL_THIEUTH = chr(12606)
HANGUL_LETTER_RIEUL_PHIEUPH = chr(12607)
HANGUL_LETTER_RIEUL_HIEUH = chr(12608)
HANGUL_LETTER_MIEUM = chr(12609)
HANGUL_LETTER_PIEUP = chr(12610)
HANGUL_LETTER_SSANGPIEUP = chr(12611)
HANGUL_LETTER_PIEUP_SIOS = chr(12612)
HANGUL_LETTER_SIOS = chr(12613)
HANGUL_LETTER_SSANGSIOS = chr(12614)
HANGUL_LETTER_IEUNG = chr(12615)
HANGUL_LETTER_CIEUC = chr(12616)
HANGUL_LETTER_SSANGCIEUC = chr(12617)
HANGUL_LETTER_CHIEUCH = chr(12618)
HANGUL_LETTER_KHIEUKH = chr(12619)
HANGUL_LETTER_THIEUTH = chr(12620)
HANGUL_LETTER_PHIEUPH = chr(12621)
HANGUL_LETTER_HIEUH = chr(12622)
HANGUL_LETTER_A = chr(12623)
HANGUL_LETTER_AE = chr(12624)
HANGUL_LETTER_YA = chr(12625)
HANGUL_LETTER_YAE = chr(12626)
HANGUL_LETTER_EO = chr(12627)
HANGUL_LETTER_E = chr(12628)
HANGUL_LETTER_YEO = chr(12629)
HANGUL_LETTER_YE = chr(12630)
HANGUL_LETTER_O = chr(12631)
HANGUL_LETTER_WA = chr(12632)
HANGUL_LETTER_WAE = chr(12633)
HANGUL_LETTER_OE = chr(12634)
HANGUL_LETTER_YO = chr(12635)
HANGUL_LETTER_U = chr(12636)
HANGUL_LETTER_WEO = chr(12637)
HANGUL_LETTER_WE = chr(12638)
HANGUL_LETTER_WI = chr(12639)
HANGUL_LETTER_YU = chr(12640)
HANGUL_LETTER_EU = chr(12641)
HANGUL_LETTER_YI = chr(12642)
HANGUL_LETTER_I = chr(12643)
HANGUL_FILLER = chr(12644)
HANGUL_LETTER_SSANGNIEUN = chr(12645)
HANGUL_LETTER_NIEUN_TIKEUT = chr(12646)
HANGUL_LETTER_NIEUN_SIOS = chr(12647)
HANGUL_LETTER_NIEUN_PANSIOS = chr(12648)
HANGUL_LETTER_RIEUL_KIYEOK_SIOS = chr(12649)
HANGUL_LETTER_RIEUL_TIKEUT = chr(12650)
HANGUL_LETTER_RIEUL_PIEUP_SIOS = chr(12651)
HANGUL_LETTER_RIEUL_PANSIOS = chr(12652)
HANGUL_LETTER_RIEUL_YEORINHIEUH = chr(12653)
HANGUL_LETTER_MIEUM_PIEUP = chr(12654)
HANGUL_LETTER_MIEUM_SIOS = chr(12655)
HANGUL_LETTER_MIEUM_PANSIOS = chr(12656)
HANGUL_LETTER_KAPYEOUNMIEUM = chr(12657)
HANGUL_LETTER_PIEUP_KIYEOK = chr(12658)
HANGUL_LETTER_PIEUP_TIKEUT = chr(12659)
HANGUL_LETTER_PIEUP_SIOS_KIYEOK = chr(12660)
HANGUL_LETTER_PIEUP_SIOS_TIKEUT = chr(12661)
HANGUL_LETTER_PIEUP_CIEUC = chr(12662)
HANGUL_LETTER_PIEUP_THIEUTH = chr(12663)
HANGUL_LETTER_KAPYEOUNPIEUP = chr(12664)
HANGUL_LETTER_KAPYEOUNSSANGPIEUP = chr(12665)
HANGUL_LETTER_SIOS_KIYEOK = chr(12666)
HANGUL_LETTER_SIOS_NIEUN = chr(12667)
HANGUL_LETTER_SIOS_TIKEUT = chr(12668)
HANGUL_LETTER_SIOS_PIEUP = chr(12669)
HANGUL_LETTER_SIOS_CIEUC = chr(12670)
HANGUL_LETTER_PANSIOS = chr(12671)
HANGUL_LETTER_SSANGIEUNG = chr(12672)
HANGUL_LETTER_YESIEUNG = chr(12673)
HANGUL_LETTER_YESIEUNG_SIOS = chr(12674)
HANGUL_LETTER_YESIEUNG_PANSIOS = chr(12675)
HANGUL_LETTER_KAPYEOUNPHIEUPH = chr(12676)
HANGUL_LETTER_SSANGHIEUH = chr(12677)
HANGUL_LETTER_YEORINHIEUH = chr(12678)
HANGUL_LETTER_YO_YA = chr(12679)
HANGUL_LETTER_YO_YAE = chr(12680)
HANGUL_LETTER_YO_I = chr(12681)
HANGUL_LETTER_YU_YEO = chr(12682)
HANGUL_LETTER_YU_YE = chr(12683)
HANGUL_LETTER_YU_I = chr(12684)
HANGUL_LETTER_ARAEA = chr(12685)
HANGUL_LETTER_ARAEAE = chr(12686)
IDEOGRAPHIC_ANNOTATION_LINKING_MARK = chr(12688)
IDEOGRAPHIC_ANNOTATION_REVERSE_MARK = chr(12689)
IDEOGRAPHIC_ANNOTATION_ONE_MARK = chr(12690)
IDEOGRAPHIC_ANNOTATION_TWO_MARK = chr(12691)
IDEOGRAPHIC_ANNOTATION_THREE_MARK = chr(12692)
IDEOGRAPHIC_ANNOTATION_FOUR_MARK = chr(12693)
IDEOGRAPHIC_ANNOTATION_TOP_MARK = chr(12694)
IDEOGRAPHIC_ANNOTATION_MIDDLE_MARK = chr(12695)
IDEOGRAPHIC_ANNOTATION_BOTTOM_MARK = chr(12696)
IDEOGRAPHIC_ANNOTATION_FIRST_MARK = chr(12697)
IDEOGRAPHIC_ANNOTATION_SECOND_MARK = chr(12698)
IDEOGRAPHIC_ANNOTATION_THIRD_MARK = chr(12699)
IDEOGRAPHIC_ANNOTATION_FOURTH_MARK = chr(12700)
IDEOGRAPHIC_ANNOTATION_HEAVEN_MARK = chr(12701)
IDEOGRAPHIC_ANNOTATION_EARTH_MARK = chr(12702)
IDEOGRAPHIC_ANNOTATION_MAN_MARK = chr(12703)
BOPOMOFO_LETTER_BU = chr(12704)
BOPOMOFO_LETTER_ZI = chr(12705)
BOPOMOFO_LETTER_JI = chr(12706)
BOPOMOFO_LETTER_GU = chr(12707)
BOPOMOFO_LETTER_EE = chr(12708)
BOPOMOFO_LETTER_ENN = chr(12709)
BOPOMOFO_LETTER_OO = chr(12710)
BOPOMOFO_LETTER_ONN = chr(12711)
BOPOMOFO_LETTER_IR = chr(12712)
BOPOMOFO_LETTER_ANN = chr(12713)
BOPOMOFO_LETTER_INN = chr(12714)
BOPOMOFO_LETTER_UNN = chr(12715)
BOPOMOFO_LETTER_IM = chr(12716)
BOPOMOFO_LETTER_NGG = chr(12717)
BOPOMOFO_LETTER_AINN = chr(12718)
BOPOMOFO_LETTER_AUNN = chr(12719)
BOPOMOFO_LETTER_AM = chr(12720)
BOPOMOFO_LETTER_OM = chr(12721)
BOPOMOFO_LETTER_ONG = chr(12722)
BOPOMOFO_LETTER_INNN = chr(12723)
BOPOMOFO_FINAL_LETTER_P = chr(12724)
BOPOMOFO_FINAL_LETTER_T = chr(12725)
BOPOMOFO_FINAL_LETTER_K = chr(12726)
BOPOMOFO_FINAL_LETTER_H = chr(12727)
BOPOMOFO_LETTER_GH = chr(12728)
BOPOMOFO_LETTER_LH = chr(12729)
BOPOMOFO_LETTER_ZY = chr(12730)
BOPOMOFO_FINAL_LETTER_G = chr(12731)
BOPOMOFO_LETTER_GW = chr(12732)
BOPOMOFO_LETTER_KW = chr(12733)
BOPOMOFO_LETTER_OE = chr(12734)
BOPOMOFO_LETTER_AH = chr(12735)
CJK_STROKE_T = chr(12736)
CJK_STROKE_WG = chr(12737)
CJK_STROKE_XG = chr(12738)
CJK_STROKE_BXG = chr(12739)
CJK_STROKE_SW = chr(12740)
CJK_STROKE_HZZ = chr(12741)
CJK_STROKE_HZG = chr(12742)
CJK_STROKE_HP = chr(12743)
CJK_STROKE_HZWG = chr(12744)
CJK_STROKE_SZWG = chr(12745)
CJK_STROKE_HZT = chr(12746)
CJK_STROKE_HZZP = chr(12747)
CJK_STROKE_HPWG = chr(12748)
CJK_STROKE_HZW = chr(12749)
CJK_STROKE_HZZZ = chr(12750)
CJK_STROKE_N = chr(12751)
CJK_STROKE_H = chr(12752)
CJK_STROKE_S = chr(12753)
CJK_STROKE_P = chr(12754)
CJK_STROKE_SP = chr(12755)
CJK_STROKE_D = chr(12756)
CJK_STROKE_HZ = chr(12757)
CJK_STROKE_HG = chr(12758)
CJK_STROKE_SZ = chr(12759)
CJK_STROKE_SWZ = chr(12760)
CJK_STROKE_ST = chr(12761)
CJK_STROKE_SG = chr(12762)
CJK_STROKE_PD = chr(12763)
CJK_STROKE_PZ = chr(12764)
CJK_STROKE_TN = chr(12765)
CJK_STROKE_SZZ = chr(12766)
CJK_STROKE_SWG = chr(12767)
CJK_STROKE_HXWG = chr(12768)
CJK_STROKE_HZZZG = chr(12769)
CJK_STROKE_PG = chr(12770)
CJK_STROKE_Q = chr(12771)
KATAKANA_LETTER_SMALL_KU = chr(12784)
KATAKANA_LETTER_SMALL_SI = chr(12785)
KATAKANA_LETTER_SMALL_SU = chr(12786)
KATAKANA_LETTER_SMALL_TO = chr(12787)
KATAKANA_LETTER_SMALL_NU = chr(12788)
KATAKANA_LETTER_SMALL_HA = chr(12789)
KATAKANA_LETTER_SMALL_HI = chr(12790)
KATAKANA_LETTER_SMALL_HU = chr(12791)
KATAKANA_LETTER_SMALL_HE = chr(12792)
KATAKANA_LETTER_SMALL_HO = chr(12793)
KATAKANA_LETTER_SMALL_MU = chr(12794)
KATAKANA_LETTER_SMALL_RA = chr(12795)
KATAKANA_LETTER_SMALL_RI = chr(12796)
KATAKANA_LETTER_SMALL_RU = chr(12797)
KATAKANA_LETTER_SMALL_RE = chr(12798)
KATAKANA_LETTER_SMALL_RO = chr(12799)
PARENTHESIZED_HANGUL_KIYEOK = chr(12800)
PARENTHESIZED_HANGUL_NIEUN = chr(12801)
PARENTHESIZED_HANGUL_TIKEUT = chr(12802)
PARENTHESIZED_HANGUL_RIEUL = chr(12803)
PARENTHESIZED_HANGUL_MIEUM = chr(12804)
PARENTHESIZED_HANGUL_PIEUP = chr(12805)
PARENTHESIZED_HANGUL_SIOS = chr(12806)
PARENTHESIZED_HANGUL_IEUNG = chr(12807)
PARENTHESIZED_HANGUL_CIEUC = chr(12808)
PARENTHESIZED_HANGUL_CHIEUCH = chr(12809)
PARENTHESIZED_HANGUL_KHIEUKH = chr(12810)
PARENTHESIZED_HANGUL_THIEUTH = chr(12811)
PARENTHESIZED_HANGUL_PHIEUPH = chr(12812)
PARENTHESIZED_HANGUL_HIEUH = chr(12813)
PARENTHESIZED_HANGUL_KIYEOK_A = chr(12814)
PARENTHESIZED_HANGUL_NIEUN_A = chr(12815)
PARENTHESIZED_HANGUL_TIKEUT_A = chr(12816)
PARENTHESIZED_HANGUL_RIEUL_A = chr(12817)
PARENTHESIZED_HANGUL_MIEUM_A = chr(12818)
PARENTHESIZED_HANGUL_PIEUP_A = chr(12819)
PARENTHESIZED_HANGUL_SIOS_A = chr(12820)
PARENTHESIZED_HANGUL_IEUNG_A = chr(12821)
PARENTHESIZED_HANGUL_CIEUC_A = chr(12822)
PARENTHESIZED_HANGUL_CHIEUCH_A = chr(12823)
PARENTHESIZED_HANGUL_KHIEUKH_A = chr(12824)
PARENTHESIZED_HANGUL_THIEUTH_A = chr(12825)
PARENTHESIZED_HANGUL_PHIEUPH_A = chr(12826)
PARENTHESIZED_HANGUL_HIEUH_A = chr(12827)
PARENTHESIZED_HANGUL_CIEUC_U = chr(12828)
PARENTHESIZED_KOREAN_CHARACTER_OJEON = chr(12829)
PARENTHESIZED_KOREAN_CHARACTER_O_HU = chr(12830)
PARENTHESIZED_IDEOGRAPH_ONE = chr(12832)
PARENTHESIZED_IDEOGRAPH_TWO = chr(12833)
PARENTHESIZED_IDEOGRAPH_THREE = chr(12834)
PARENTHESIZED_IDEOGRAPH_FOUR = chr(12835)
PARENTHESIZED_IDEOGRAPH_FIVE = chr(12836)
PARENTHESIZED_IDEOGRAPH_SIX = chr(12837)
PARENTHESIZED_IDEOGRAPH_SEVEN = chr(12838)
PARENTHESIZED_IDEOGRAPH_EIGHT = chr(12839)
PARENTHESIZED_IDEOGRAPH_NINE = chr(12840)
PARENTHESIZED_IDEOGRAPH_TEN = chr(12841)
PARENTHESIZED_IDEOGRAPH_MOON = chr(12842)
PARENTHESIZED_IDEOGRAPH_FIRE = chr(12843)
PARENTHESIZED_IDEOGRAPH_WATER = chr(12844)
PARENTHESIZED_IDEOGRAPH_WOOD = chr(12845)
PARENTHESIZED_IDEOGRAPH_METAL = chr(12846)
PARENTHESIZED_IDEOGRAPH_EARTH = chr(12847)
PARENTHESIZED_IDEOGRAPH_SUN = chr(12848)
PARENTHESIZED_IDEOGRAPH_STOCK = chr(12849)
PARENTHESIZED_IDEOGRAPH_HAVE = chr(12850)
PARENTHESIZED_IDEOGRAPH_SOCIETY = chr(12851)
PARENTHESIZED_IDEOGRAPH_NAME = chr(12852)
PARENTHESIZED_IDEOGRAPH_SPECIAL = chr(12853)
PARENTHESIZED_IDEOGRAPH_FINANCIAL = chr(12854)
PARENTHESIZED_IDEOGRAPH_CONGRATULATION = chr(12855)
PARENTHESIZED_IDEOGRAPH_LABOR = chr(12856)
PARENTHESIZED_IDEOGRAPH_REPRESENT = chr(12857)
PARENTHESIZED_IDEOGRAPH_CALL = chr(12858)
PARENTHESIZED_IDEOGRAPH_STUDY = chr(12859)
PARENTHESIZED_IDEOGRAPH_SUPERVISE = chr(12860)
PARENTHESIZED_IDEOGRAPH_ENTERPRISE = chr(12861)
PARENTHESIZED_IDEOGRAPH_RESOURCE = chr(12862)
PARENTHESIZED_IDEOGRAPH_ALLIANCE = chr(12863)
PARENTHESIZED_IDEOGRAPH_FESTIVAL = chr(12864)
PARENTHESIZED_IDEOGRAPH_REST = chr(12865)
PARENTHESIZED_IDEOGRAPH_SELF = chr(12866)
PARENTHESIZED_IDEOGRAPH_REACH = chr(12867)
CIRCLED_IDEOGRAPH_QUESTION = chr(12868)
CIRCLED_IDEOGRAPH_KINDERGARTEN = chr(12869)
CIRCLED_IDEOGRAPH_SCHOOL = chr(12870)
CIRCLED_IDEOGRAPH_KOTO = chr(12871)
CIRCLED_NUMBER_TEN_ON_BLACK_SQUARE = chr(12872)
CIRCLED_NUMBER_TWENTY_ON_BLACK_SQUARE = chr(12873)
CIRCLED_NUMBER_THIRTY_ON_BLACK_SQUARE = chr(12874)
CIRCLED_NUMBER_FORTY_ON_BLACK_SQUARE = chr(12875)
CIRCLED_NUMBER_FIFTY_ON_BLACK_SQUARE = chr(12876)
CIRCLED_NUMBER_SIXTY_ON_BLACK_SQUARE = chr(12877)
CIRCLED_NUMBER_SEVENTY_ON_BLACK_SQUARE = chr(12878)
CIRCLED_NUMBER_EIGHTY_ON_BLACK_SQUARE = chr(12879)
PARTNERSHIP_SIGN = chr(12880)
CIRCLED_NUMBER_TWENTY_ONE = chr(12881)
CIRCLED_NUMBER_TWENTY_TWO = chr(12882)
CIRCLED_NUMBER_TWENTY_THREE = chr(12883)
CIRCLED_NUMBER_TWENTY_FOUR = chr(12884)
CIRCLED_NUMBER_TWENTY_FIVE = chr(12885)
CIRCLED_NUMBER_TWENTY_SIX = chr(12886)
CIRCLED_NUMBER_TWENTY_SEVEN = chr(12887)
CIRCLED_NUMBER_TWENTY_EIGHT = chr(12888)
CIRCLED_NUMBER_TWENTY_NINE = chr(12889)
CIRCLED_NUMBER_THIRTY = chr(12890)
CIRCLED_NUMBER_THIRTY_ONE = chr(12891)
CIRCLED_NUMBER_THIRTY_TWO = chr(12892)
CIRCLED_NUMBER_THIRTY_THREE = chr(12893)
CIRCLED_NUMBER_THIRTY_FOUR = chr(12894)
CIRCLED_NUMBER_THIRTY_FIVE = chr(12895)
CIRCLED_HANGUL_KIYEOK = chr(12896)
CIRCLED_HANGUL_NIEUN = chr(12897)
CIRCLED_HANGUL_TIKEUT = chr(12898)
CIRCLED_HANGUL_RIEUL = chr(12899)
CIRCLED_HANGUL_MIEUM = chr(12900)
CIRCLED_HANGUL_PIEUP = chr(12901)
CIRCLED_HANGUL_SIOS = chr(12902)
CIRCLED_HANGUL_IEUNG = chr(12903)
CIRCLED_HANGUL_CIEUC = chr(12904)
CIRCLED_HANGUL_CHIEUCH = chr(12905)
CIRCLED_HANGUL_KHIEUKH = chr(12906)
CIRCLED_HANGUL_THIEUTH = chr(12907)
CIRCLED_HANGUL_PHIEUPH = chr(12908)
CIRCLED_HANGUL_HIEUH = chr(12909)
CIRCLED_HANGUL_KIYEOK_A = chr(12910)
CIRCLED_HANGUL_NIEUN_A = chr(12911)
CIRCLED_HANGUL_TIKEUT_A = chr(12912)
CIRCLED_HANGUL_RIEUL_A = chr(12913)
CIRCLED_HANGUL_MIEUM_A = chr(12914)
CIRCLED_HANGUL_PIEUP_A = chr(12915)
CIRCLED_HANGUL_SIOS_A = chr(12916)
CIRCLED_HANGUL_IEUNG_A = chr(12917)
CIRCLED_HANGUL_CIEUC_A = chr(12918)
CIRCLED_HANGUL_CHIEUCH_A = chr(12919)
CIRCLED_HANGUL_KHIEUKH_A = chr(12920)
CIRCLED_HANGUL_THIEUTH_A = chr(12921)
CIRCLED_HANGUL_PHIEUPH_A = chr(12922)
CIRCLED_HANGUL_HIEUH_A = chr(12923)
CIRCLED_KOREAN_CHARACTER_CHAMKO = chr(12924)
CIRCLED_KOREAN_CHARACTER_JUEUI = chr(12925)
CIRCLED_HANGUL_IEUNG_U = chr(12926)
KOREAN_STANDARD_SYMBOL = chr(12927)
CIRCLED_IDEOGRAPH_ONE = chr(12928)
CIRCLED_IDEOGRAPH_TWO = chr(12929)
CIRCLED_IDEOGRAPH_THREE = chr(12930)
CIRCLED_IDEOGRAPH_FOUR = chr(12931)
CIRCLED_IDEOGRAPH_FIVE = chr(12932)
CIRCLED_IDEOGRAPH_SIX = chr(12933)
CIRCLED_IDEOGRAPH_SEVEN = chr(12934)
CIRCLED_IDEOGRAPH_EIGHT = chr(12935)
CIRCLED_IDEOGRAPH_NINE = chr(12936)
CIRCLED_IDEOGRAPH_TEN = chr(12937)
CIRCLED_IDEOGRAPH_MOON = chr(12938)
CIRCLED_IDEOGRAPH_FIRE = chr(12939)
CIRCLED_IDEOGRAPH_WATER = chr(12940)
CIRCLED_IDEOGRAPH_WOOD = chr(12941)
CIRCLED_IDEOGRAPH_METAL = chr(12942)
CIRCLED_IDEOGRAPH_EARTH = chr(12943)
CIRCLED_IDEOGRAPH_SUN = chr(12944)
CIRCLED_IDEOGRAPH_STOCK = chr(12945)
CIRCLED_IDEOGRAPH_HAVE = chr(12946)
CIRCLED_IDEOGRAPH_SOCIETY = chr(12947)
CIRCLED_IDEOGRAPH_NAME = chr(12948)
CIRCLED_IDEOGRAPH_SPECIAL = chr(12949)
CIRCLED_IDEOGRAPH_FINANCIAL = chr(12950)
CIRCLED_IDEOGRAPH_CONGRATULATION = chr(12951)
CIRCLED_IDEOGRAPH_LABOR = chr(12952)
CIRCLED_IDEOGRAPH_SECRET = chr(12953)
CIRCLED_IDEOGRAPH_MALE = chr(12954)
CIRCLED_IDEOGRAPH_FEMALE = chr(12955)
CIRCLED_IDEOGRAPH_SUITABLE = chr(12956)
CIRCLED_IDEOGRAPH_EXCELLENT = chr(12957)
CIRCLED_IDEOGRAPH_PRINT = chr(12958)
CIRCLED_IDEOGRAPH_ATTENTION = chr(12959)
CIRCLED_IDEOGRAPH_ITEM = chr(12960)
CIRCLED_IDEOGRAPH_REST = chr(12961)
CIRCLED_IDEOGRAPH_COPY = chr(12962)
CIRCLED_IDEOGRAPH_CORRECT = chr(12963)
CIRCLED_IDEOGRAPH_HIGH = chr(12964)
CIRCLED_IDEOGRAPH_CENTRE = chr(12965)
CIRCLED_IDEOGRAPH_LOW = chr(12966)
CIRCLED_IDEOGRAPH_LEFT = chr(12967)
CIRCLED_IDEOGRAPH_RIGHT = chr(12968)
CIRCLED_IDEOGRAPH_MEDICINE = chr(12969)
CIRCLED_IDEOGRAPH_RELIGION = chr(12970)
CIRCLED_IDEOGRAPH_STUDY = chr(12971)
CIRCLED_IDEOGRAPH_SUPERVISE = chr(12972)
CIRCLED_IDEOGRAPH_ENTERPRISE = chr(12973)
CIRCLED_IDEOGRAPH_RESOURCE = chr(12974)
CIRCLED_IDEOGRAPH_ALLIANCE = chr(12975)
CIRCLED_IDEOGRAPH_NIGHT = chr(12976)
CIRCLED_NUMBER_THIRTY_SIX = chr(12977)
CIRCLED_NUMBER_THIRTY_SEVEN = chr(12978)
CIRCLED_NUMBER_THIRTY_EIGHT = chr(12979)
CIRCLED_NUMBER_THIRTY_NINE = chr(12980)
CIRCLED_NUMBER_FORTY = chr(12981)
CIRCLED_NUMBER_FORTY_ONE = chr(12982)
CIRCLED_NUMBER_FORTY_TWO = chr(12983)
CIRCLED_NUMBER_FORTY_THREE = chr(12984)
CIRCLED_NUMBER_FORTY_FOUR = chr(12985)
CIRCLED_NUMBER_FORTY_FIVE = chr(12986)
CIRCLED_NUMBER_FORTY_SIX = chr(12987)
CIRCLED_NUMBER_FORTY_SEVEN = chr(12988)
CIRCLED_NUMBER_FORTY_EIGHT = chr(12989)
CIRCLED_NUMBER_FORTY_NINE = chr(12990)
CIRCLED_NUMBER_FIFTY = chr(12991)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_JANUARY = chr(12992)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_FEBRUARY = chr(12993)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_MARCH = chr(12994)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_APRIL = chr(12995)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_MAY = chr(12996)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_JUNE = chr(12997)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_JULY = chr(12998)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_AUGUST = chr(12999)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_SEPTEMBER = chr(13000)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_OCTOBER = chr(13001)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_NOVEMBER = chr(13002)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DECEMBER = chr(13003)
SQUARE_HG = chr(13004)
SQUARE_ERG = chr(13005)
SQUARE_EV = chr(13006)
LIMITED_LIABILITY_SIGN = chr(13007)
CIRCLED_KATAKANA_A = chr(13008)
CIRCLED_KATAKANA_I = chr(13009)
CIRCLED_KATAKANA_U = chr(13010)
CIRCLED_KATAKANA_E = chr(13011)
CIRCLED_KATAKANA_O = chr(13012)
CIRCLED_KATAKANA_KA = chr(13013)
CIRCLED_KATAKANA_KI = chr(13014)
CIRCLED_KATAKANA_KU = chr(13015)
CIRCLED_KATAKANA_KE = chr(13016)
CIRCLED_KATAKANA_KO = chr(13017)
CIRCLED_KATAKANA_SA = chr(13018)
CIRCLED_KATAKANA_SI = chr(13019)
CIRCLED_KATAKANA_SU = chr(13020)
CIRCLED_KATAKANA_SE = chr(13021)
CIRCLED_KATAKANA_SO = chr(13022)
CIRCLED_KATAKANA_TA = chr(13023)
CIRCLED_KATAKANA_TI = chr(13024)
CIRCLED_KATAKANA_TU = chr(13025)
CIRCLED_KATAKANA_TE = chr(13026)
CIRCLED_KATAKANA_TO = chr(13027)
CIRCLED_KATAKANA_NA = chr(13028)
CIRCLED_KATAKANA_NI = chr(13029)
CIRCLED_KATAKANA_NU = chr(13030)
CIRCLED_KATAKANA_NE = chr(13031)
CIRCLED_KATAKANA_NO = chr(13032)
CIRCLED_KATAKANA_HA = chr(13033)
CIRCLED_KATAKANA_HI = chr(13034)
CIRCLED_KATAKANA_HU = chr(13035)
CIRCLED_KATAKANA_HE = chr(13036)
CIRCLED_KATAKANA_HO = chr(13037)
CIRCLED_KATAKANA_MA = chr(13038)
CIRCLED_KATAKANA_MI = chr(13039)
CIRCLED_KATAKANA_MU = chr(13040)
CIRCLED_KATAKANA_ME = chr(13041)
CIRCLED_KATAKANA_MO = chr(13042)
CIRCLED_KATAKANA_YA = chr(13043)
CIRCLED_KATAKANA_YU = chr(13044)
CIRCLED_KATAKANA_YO = chr(13045)
CIRCLED_KATAKANA_RA = chr(13046)
CIRCLED_KATAKANA_RI = chr(13047)
CIRCLED_KATAKANA_RU = chr(13048)
CIRCLED_KATAKANA_RE = chr(13049)
CIRCLED_KATAKANA_RO = chr(13050)
CIRCLED_KATAKANA_WA = chr(13051)
CIRCLED_KATAKANA_WI = chr(13052)
CIRCLED_KATAKANA_WE = chr(13053)
CIRCLED_KATAKANA_WO = chr(13054)
SQUARE_ERA_NAME_REIWA = chr(13055)
SQUARE_APAATO = chr(13056)
SQUARE_ARUHUA = chr(13057)
SQUARE_ANPEA = chr(13058)
SQUARE_AARU = chr(13059)
SQUARE_ININGU = chr(13060)
SQUARE_INTI = chr(13061)
SQUARE_UON = chr(13062)
SQUARE_ESUKUUDO = chr(13063)
SQUARE_EEKAA = chr(13064)
SQUARE_ONSU = chr(13065)
SQUARE_OOMU = chr(13066)
SQUARE_KAIRI = chr(13067)
SQUARE_KARATTO = chr(13068)
SQUARE_KARORII = chr(13069)
SQUARE_GARON = chr(13070)
SQUARE_GANMA = chr(13071)
SQUARE_GIGA = chr(13072)
SQUARE_GINII = chr(13073)
SQUARE_KYURII = chr(13074)
SQUARE_GIRUDAA = chr(13075)
SQUARE_KIRO = chr(13076)
SQUARE_KIROGURAMU = chr(13077)
SQUARE_KIROMEETORU = chr(13078)
SQUARE_KIROWATTO = chr(13079)
SQUARE_GURAMU = chr(13080)
SQUARE_GURAMUTON = chr(13081)
SQUARE_KURUZEIRO = chr(13082)
SQUARE_KUROONE = chr(13083)
SQUARE_KEESU = chr(13084)
SQUARE_KORUNA = chr(13085)
SQUARE_KOOPO = chr(13086)
SQUARE_SAIKURU = chr(13087)
SQUARE_SANTIIMU = chr(13088)
SQUARE_SIRINGU = chr(13089)
SQUARE_SENTI = chr(13090)
SQUARE_SENTO = chr(13091)
SQUARE_DAASU = chr(13092)
SQUARE_DESI = chr(13093)
SQUARE_DORU = chr(13094)
SQUARE_TON = chr(13095)
SQUARE_NANO = chr(13096)
SQUARE_NOTTO = chr(13097)
SQUARE_HAITU = chr(13098)
SQUARE_PAASENTO = chr(13099)
SQUARE_PAATU = chr(13100)
SQUARE_BAARERU = chr(13101)
SQUARE_PIASUTORU = chr(13102)
SQUARE_PIKURU = chr(13103)
SQUARE_PIKO = chr(13104)
SQUARE_BIRU = chr(13105)
SQUARE_HUARADDO = chr(13106)
SQUARE_HUIITO = chr(13107)
SQUARE_BUSSYERU = chr(13108)
SQUARE_HURAN = chr(13109)
SQUARE_HEKUTAARU = chr(13110)
SQUARE_PESO = chr(13111)
SQUARE_PENIHI = chr(13112)
SQUARE_HERUTU = chr(13113)
SQUARE_PENSU = chr(13114)
SQUARE_PEEZI = chr(13115)
SQUARE_BEETA = chr(13116)
SQUARE_POINTO = chr(13117)
SQUARE_BORUTO = chr(13118)
SQUARE_HON = chr(13119)
SQUARE_PONDO = chr(13120)
SQUARE_HOORU = chr(13121)
SQUARE_HOON = chr(13122)
SQUARE_MAIKURO = chr(13123)
SQUARE_MAIRU = chr(13124)
SQUARE_MAHHA = chr(13125)
SQUARE_MARUKU = chr(13126)
SQUARE_MANSYON = chr(13127)
SQUARE_MIKURON = chr(13128)
SQUARE_MIRI = chr(13129)
SQUARE_MIRIBAARU = chr(13130)
SQUARE_MEGA = chr(13131)
SQUARE_MEGATON = chr(13132)
SQUARE_MEETORU = chr(13133)
SQUARE_YAADO = chr(13134)
SQUARE_YAARU = chr(13135)
SQUARE_YUAN = chr(13136)
SQUARE_RITTORU = chr(13137)
SQUARE_RIRA = chr(13138)
SQUARE_RUPII = chr(13139)
SQUARE_RUUBURU = chr(13140)
SQUARE_REMU = chr(13141)
SQUARE_RENTOGEN = chr(13142)
SQUARE_WATTO = chr(13143)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_ZERO = chr(13144)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_ONE = chr(13145)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWO = chr(13146)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_THREE = chr(13147)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_FOUR = chr(13148)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_FIVE = chr(13149)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_SIX = chr(13150)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_SEVEN = chr(13151)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_EIGHT = chr(13152)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_NINE = chr(13153)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TEN = chr(13154)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_ELEVEN = chr(13155)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWELVE = chr(13156)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_THIRTEEN = chr(13157)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_FOURTEEN = chr(13158)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_FIFTEEN = chr(13159)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_SIXTEEN = chr(13160)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_SEVENTEEN = chr(13161)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_EIGHTEEN = chr(13162)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_NINETEEN = chr(13163)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWENTY = chr(13164)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWENTY_ONE = chr(13165)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWENTY_TWO = chr(13166)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWENTY_THREE = chr(13167)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWENTY_FOUR = chr(13168)
SQUARE_HPA = chr(13169)
SQUARE_DA = chr(13170)
SQUARE_AU = chr(13171)
SQUARE_BAR = chr(13172)
SQUARE_OV = chr(13173)
SQUARE_PC = chr(13174)
SQUARE_DM = chr(13175)
SQUARE_DM_SQUARED = chr(13176)
SQUARE_DM_CUBED = chr(13177)
SQUARE_IU = chr(13178)
SQUARE_ERA_NAME_HEISEI = chr(13179)
SQUARE_ERA_NAME_SYOUWA = chr(13180)
SQUARE_ERA_NAME_TAISYOU = chr(13181)
SQUARE_ERA_NAME_MEIZI = chr(13182)
SQUARE_CORPORATION = chr(13183)
SQUARE_PA_AMPS = chr(13184)
SQUARE_NA = chr(13185)
SQUARE_MU_A = chr(13186)
SQUARE_MA = chr(13187)
SQUARE_KA = chr(13188)
SQUARE_KB = chr(13189)
SQUARE_MB = chr(13190)
SQUARE_GB = chr(13191)
SQUARE_CAL = chr(13192)
SQUARE_KCAL = chr(13193)
SQUARE_PF = chr(13194)
SQUARE_NF = chr(13195)
SQUARE_MU_F = chr(13196)
SQUARE_MU_G = chr(13197)
SQUARE_MG = chr(13198)
SQUARE_KG = chr(13199)
SQUARE_HZ = chr(13200)
SQUARE_KHZ = chr(13201)
SQUARE_MHZ = chr(13202)
SQUARE_GHZ = chr(13203)
SQUARE_THZ = chr(13204)
SQUARE_MU_L = chr(13205)
SQUARE_ML = chr(13206)
SQUARE_DL = chr(13207)
SQUARE_KL = chr(13208)
SQUARE_FM = chr(13209)
SQUARE_NM = chr(13210)
SQUARE_MU_M = chr(13211)
SQUARE_MM = chr(13212)
SQUARE_CM = chr(13213)
SQUARE_KM = chr(13214)
SQUARE_MM_SQUARED = chr(13215)
SQUARE_CM_SQUARED = chr(13216)
SQUARE_M_SQUARED = chr(13217)
SQUARE_KM_SQUARED = chr(13218)
SQUARE_MM_CUBED = chr(13219)
SQUARE_CM_CUBED = chr(13220)
SQUARE_M_CUBED = chr(13221)
SQUARE_KM_CUBED = chr(13222)
SQUARE_M_OVER_S = chr(13223)
SQUARE_M_OVER_S_SQUARED = chr(13224)
SQUARE_PA = chr(13225)
SQUARE_KPA = chr(13226)
SQUARE_MPA = chr(13227)
SQUARE_GPA = chr(13228)
SQUARE_RAD = chr(13229)
SQUARE_RAD_OVER_S = chr(13230)
SQUARE_RAD_OVER_S_SQUARED = chr(13231)
SQUARE_PS = chr(13232)
SQUARE_NS = chr(13233)
SQUARE_MU_S = chr(13234)
SQUARE_MS = chr(13235)
SQUARE_PV = chr(13236)
SQUARE_NV = chr(13237)
SQUARE_MU_V = chr(13238)
SQUARE_MV = chr(13239)
SQUARE_KV = chr(13240)
SQUARE_MV_MEGA = chr(13241)
SQUARE_PW = chr(13242)
SQUARE_NW = chr(13243)
SQUARE_MU_W = chr(13244)
SQUARE_MW = chr(13245)
SQUARE_KW = chr(13246)
SQUARE_MW_MEGA = chr(13247)
SQUARE_K_OHM = chr(13248)
SQUARE_M_OHM = chr(13249)
SQUARE_AM = chr(13250)
SQUARE_BQ = chr(13251)
SQUARE_CC = chr(13252)
SQUARE_CD = chr(13253)
SQUARE_C_OVER_KG = chr(13254)
SQUARE_CO = chr(13255)
SQUARE_DB = chr(13256)
SQUARE_GY = chr(13257)
SQUARE_HA = chr(13258)
SQUARE_HP = chr(13259)
SQUARE_IN = chr(13260)
SQUARE_KK = chr(13261)
SQUARE_KM_CAPITAL = chr(13262)
SQUARE_KT = chr(13263)
SQUARE_LM = chr(13264)
SQUARE_LN = chr(13265)
SQUARE_LOG = chr(13266)
SQUARE_LX = chr(13267)
SQUARE_MB_SMALL = chr(13268)
SQUARE_MIL = chr(13269)
SQUARE_MOL = chr(13270)
SQUARE_PH = chr(13271)
SQUARE_PM = chr(13272)
SQUARE_PPM = chr(13273)
SQUARE_PR = chr(13274)
SQUARE_SR = chr(13275)
SQUARE_SV = chr(13276)
SQUARE_WB = chr(13277)
SQUARE_V_OVER_M = chr(13278)
SQUARE_A_OVER_M = chr(13279)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_ONE = chr(13280)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWO = chr(13281)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_THREE = chr(13282)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_FOUR = chr(13283)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_FIVE = chr(13284)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_SIX = chr(13285)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_SEVEN = chr(13286)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_EIGHT = chr(13287)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_NINE = chr(13288)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TEN = chr(13289)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_ELEVEN = chr(13290)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWELVE = chr(13291)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_THIRTEEN = chr(13292)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_FOURTEEN = chr(13293)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_FIFTEEN = chr(13294)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_SIXTEEN = chr(13295)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_SEVENTEEN = chr(13296)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_EIGHTEEN = chr(13297)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_NINETEEN = chr(13298)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY = chr(13299)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_ONE = chr(13300)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_TWO = chr(13301)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_THREE = chr(13302)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_FOUR = chr(13303)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_FIVE = chr(13304)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_SIX = chr(13305)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_SEVEN = chr(13306)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_EIGHT = chr(13307)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_NINE = chr(13308)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_THIRTY = chr(13309)
IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_THIRTY_ONE = chr(13310)
SQUARE_GAL = chr(13311)
HEXAGRAM_FOR_THE_CREATIVE_HEAVEN = chr(19904)
HEXAGRAM_FOR_THE_RECEPTIVE_EARTH = chr(19905)
HEXAGRAM_FOR_DIFFICULTY_AT_THE_BEGINNING = chr(19906)
HEXAGRAM_FOR_YOUTHFUL_FOLLY = chr(19907)
HEXAGRAM_FOR_WAITING = chr(19908)
HEXAGRAM_FOR_CONFLICT = chr(19909)
HEXAGRAM_FOR_THE_ARMY = chr(19910)
HEXAGRAM_FOR_HOLDING_TOGETHER = chr(19911)
HEXAGRAM_FOR_SMALL_TAMING = chr(19912)
HEXAGRAM_FOR_TREADING = chr(19913)
HEXAGRAM_FOR_PEACE = chr(19914)
HEXAGRAM_FOR_STANDSTILL = chr(19915)
HEXAGRAM_FOR_FELLOWSHIP = chr(19916)
HEXAGRAM_FOR_GREAT_POSSESSION = chr(19917)
HEXAGRAM_FOR_MODESTY = chr(19918)
HEXAGRAM_FOR_ENTHUSIASM = chr(19919)
HEXAGRAM_FOR_FOLLOWING = chr(19920)
HEXAGRAM_FOR_WORK_ON_THE_DECAYED = chr(19921)
HEXAGRAM_FOR_APPROACH = chr(19922)
HEXAGRAM_FOR_CONTEMPLATION = chr(19923)
HEXAGRAM_FOR_BITING_THROUGH = chr(19924)
HEXAGRAM_FOR_GRACE = chr(19925)
HEXAGRAM_FOR_SPLITTING_APART = chr(19926)
HEXAGRAM_FOR_RETURN = chr(19927)
HEXAGRAM_FOR_INNOCENCE = chr(19928)
HEXAGRAM_FOR_GREAT_TAMING = chr(19929)
HEXAGRAM_FOR_MOUTH_CORNERS = chr(19930)
HEXAGRAM_FOR_GREAT_PREPONDERANCE = chr(19931)
HEXAGRAM_FOR_THE_ABYSMAL_WATER = chr(19932)
HEXAGRAM_FOR_THE_CLINGING_FIRE = chr(19933)
HEXAGRAM_FOR_INFLUENCE = chr(19934)
HEXAGRAM_FOR_DURATION = chr(19935)
HEXAGRAM_FOR_RETREAT = chr(19936)
HEXAGRAM_FOR_GREAT_POWER = chr(19937)
HEXAGRAM_FOR_PROGRESS = chr(19938)
HEXAGRAM_FOR_DARKENING_OF_THE_LIGHT = chr(19939)
HEXAGRAM_FOR_THE_FAMILY = chr(19940)
HEXAGRAM_FOR_OPPOSITION = chr(19941)
HEXAGRAM_FOR_OBSTRUCTION = chr(19942)
HEXAGRAM_FOR_DELIVERANCE = chr(19943)
HEXAGRAM_FOR_DECREASE = chr(19944)
HEXAGRAM_FOR_INCREASE = chr(19945)
HEXAGRAM_FOR_BREAKTHROUGH = chr(19946)
HEXAGRAM_FOR_COMING_TO_MEET = chr(19947)
HEXAGRAM_FOR_GATHERING_TOGETHER = chr(19948)
HEXAGRAM_FOR_PUSHING_UPWARD = chr(19949)
HEXAGRAM_FOR_OPPRESSION = chr(19950)
HEXAGRAM_FOR_THE_WELL = chr(19951)
HEXAGRAM_FOR_REVOLUTION = chr(19952)
HEXAGRAM_FOR_THE_CAULDRON = chr(19953)
HEXAGRAM_FOR_THE_AROUSING_THUNDER = chr(19954)
HEXAGRAM_FOR_THE_KEEPING_STILL_MOUNTAIN = chr(19955)
HEXAGRAM_FOR_DEVELOPMENT = chr(19956)
HEXAGRAM_FOR_THE_MARRYING_MAIDEN = chr(19957)
HEXAGRAM_FOR_ABUNDANCE = chr(19958)
HEXAGRAM_FOR_THE_WANDERER = chr(19959)
HEXAGRAM_FOR_THE_GENTLE_WIND = chr(19960)
HEXAGRAM_FOR_THE_JOYOUS_LAKE = chr(19961)
HEXAGRAM_FOR_DISPERSION = chr(19962)
HEXAGRAM_FOR_LIMITATION = chr(19963)
HEXAGRAM_FOR_INNER_TRUTH = chr(19964)
HEXAGRAM_FOR_SMALL_PREPONDERANCE = chr(19965)
HEXAGRAM_FOR_AFTER_COMPLETION = chr(19966)
HEXAGRAM_FOR_BEFORE_COMPLETION = chr(19967)
YI_SYLLABLE_IT = chr(40960)
YI_SYLLABLE_IX = chr(40961)
YI_SYLLABLE_I = chr(40962)
YI_SYLLABLE_IP = chr(40963)
YI_SYLLABLE_IET = chr(40964)
YI_SYLLABLE_IEX = chr(40965)
YI_SYLLABLE_IE = chr(40966)
YI_SYLLABLE_IEP = chr(40967)
YI_SYLLABLE_AT = chr(40968)
YI_SYLLABLE_AX = chr(40969)
YI_SYLLABLE_A = chr(40970)
YI_SYLLABLE_AP = chr(40971)
YI_SYLLABLE_UOX = chr(40972)
YI_SYLLABLE_UO = chr(40973)
YI_SYLLABLE_UOP = chr(40974)
YI_SYLLABLE_OT = chr(40975)
YI_SYLLABLE_OX = chr(40976)
YI_SYLLABLE_O = chr(40977)
YI_SYLLABLE_OP = chr(40978)
YI_SYLLABLE_EX = chr(40979)
YI_SYLLABLE_E = chr(40980)
YI_SYLLABLE_WU = chr(40981)
YI_SYLLABLE_BIT = chr(40982)
YI_SYLLABLE_BIX = chr(40983)
YI_SYLLABLE_BI = chr(40984)
YI_SYLLABLE_BIP = chr(40985)
YI_SYLLABLE_BIET = chr(40986)
YI_SYLLABLE_BIEX = chr(40987)
YI_SYLLABLE_BIE = chr(40988)
YI_SYLLABLE_BIEP = chr(40989)
YI_SYLLABLE_BAT = chr(40990)
YI_SYLLABLE_BAX = chr(40991)
YI_SYLLABLE_BA = chr(40992)
YI_SYLLABLE_BAP = chr(40993)
YI_SYLLABLE_BUOX = chr(40994)
YI_SYLLABLE_BUO = chr(40995)
YI_SYLLABLE_BUOP = chr(40996)
YI_SYLLABLE_BOT = chr(40997)
YI_SYLLABLE_BOX = chr(40998)
YI_SYLLABLE_BO = chr(40999)
YI_SYLLABLE_BOP = chr(41000)
YI_SYLLABLE_BEX = chr(41001)
YI_SYLLABLE_BE = chr(41002)
YI_SYLLABLE_BEP = chr(41003)
YI_SYLLABLE_BUT = chr(41004)
YI_SYLLABLE_BUX = chr(41005)
YI_SYLLABLE_BU = chr(41006)
YI_SYLLABLE_BUP = chr(41007)
YI_SYLLABLE_BURX = chr(41008)
YI_SYLLABLE_BUR = chr(41009)
YI_SYLLABLE_BYT = chr(41010)
YI_SYLLABLE_BYX = chr(41011)
YI_SYLLABLE_BY = chr(41012)
YI_SYLLABLE_BYP = chr(41013)
YI_SYLLABLE_BYRX = chr(41014)
YI_SYLLABLE_BYR = chr(41015)
YI_SYLLABLE_PIT = chr(41016)
YI_SYLLABLE_PIX = chr(41017)
YI_SYLLABLE_PI = chr(41018)
YI_SYLLABLE_PIP = chr(41019)
YI_SYLLABLE_PIEX = chr(41020)
YI_SYLLABLE_PIE = chr(41021)
YI_SYLLABLE_PIEP = chr(41022)
YI_SYLLABLE_PAT = chr(41023)
YI_SYLLABLE_PAX = chr(41024)
YI_SYLLABLE_PA = chr(41025)
YI_SYLLABLE_PAP = chr(41026)
YI_SYLLABLE_PUOX = chr(41027)
YI_SYLLABLE_PUO = chr(41028)
YI_SYLLABLE_PUOP = chr(41029)
YI_SYLLABLE_POT = chr(41030)
YI_SYLLABLE_POX = chr(41031)
YI_SYLLABLE_PO = chr(41032)
YI_SYLLABLE_POP = chr(41033)
YI_SYLLABLE_PUT = chr(41034)
YI_SYLLABLE_PUX = chr(41035)
YI_SYLLABLE_PU = chr(41036)
YI_SYLLABLE_PUP = chr(41037)
YI_SYLLABLE_PURX = chr(41038)
YI_SYLLABLE_PUR = chr(41039)
YI_SYLLABLE_PYT = chr(41040)
YI_SYLLABLE_PYX = chr(41041)
YI_SYLLABLE_PY = chr(41042)
YI_SYLLABLE_PYP = chr(41043)
YI_SYLLABLE_PYRX = chr(41044)
YI_SYLLABLE_PYR = chr(41045)
YI_SYLLABLE_BBIT = chr(41046)
YI_SYLLABLE_BBIX = chr(41047)
YI_SYLLABLE_BBI = chr(41048)
YI_SYLLABLE_BBIP = chr(41049)
YI_SYLLABLE_BBIET = chr(41050)
YI_SYLLABLE_BBIEX = chr(41051)
YI_SYLLABLE_BBIE = chr(41052)
YI_SYLLABLE_BBIEP = chr(41053)
YI_SYLLABLE_BBAT = chr(41054)
YI_SYLLABLE_BBAX = chr(41055)
YI_SYLLABLE_BBA = chr(41056)
YI_SYLLABLE_BBAP = chr(41057)
YI_SYLLABLE_BBUOX = chr(41058)
YI_SYLLABLE_BBUO = chr(41059)
YI_SYLLABLE_BBUOP = chr(41060)
YI_SYLLABLE_BBOT = chr(41061)
YI_SYLLABLE_BBOX = chr(41062)
YI_SYLLABLE_BBO = chr(41063)
YI_SYLLABLE_BBOP = chr(41064)
YI_SYLLABLE_BBEX = chr(41065)
YI_SYLLABLE_BBE = chr(41066)
YI_SYLLABLE_BBEP = chr(41067)
YI_SYLLABLE_BBUT = chr(41068)
YI_SYLLABLE_BBUX = chr(41069)
YI_SYLLABLE_BBU = chr(41070)
YI_SYLLABLE_BBUP = chr(41071)
YI_SYLLABLE_BBURX = chr(41072)
YI_SYLLABLE_BBUR = chr(41073)
YI_SYLLABLE_BBYT = chr(41074)
YI_SYLLABLE_BBYX = chr(41075)
YI_SYLLABLE_BBY = chr(41076)
YI_SYLLABLE_BBYP = chr(41077)
YI_SYLLABLE_NBIT = chr(41078)
YI_SYLLABLE_NBIX = chr(41079)
YI_SYLLABLE_NBI = chr(41080)
YI_SYLLABLE_NBIP = chr(41081)
YI_SYLLABLE_NBIEX = chr(41082)
YI_SYLLABLE_NBIE = chr(41083)
YI_SYLLABLE_NBIEP = chr(41084)
YI_SYLLABLE_NBAT = chr(41085)
YI_SYLLABLE_NBAX = chr(41086)
YI_SYLLABLE_NBA = chr(41087)
YI_SYLLABLE_NBAP = chr(41088)
YI_SYLLABLE_NBOT = chr(41089)
YI_SYLLABLE_NBOX = chr(41090)
YI_SYLLABLE_NBO = chr(41091)
YI_SYLLABLE_NBOP = chr(41092)
YI_SYLLABLE_NBUT = chr(41093)
YI_SYLLABLE_NBUX = chr(41094)
YI_SYLLABLE_NBU = chr(41095)
YI_SYLLABLE_NBUP = chr(41096)
YI_SYLLABLE_NBURX = chr(41097)
YI_SYLLABLE_NBUR = chr(41098)
YI_SYLLABLE_NBYT = chr(41099)
YI_SYLLABLE_NBYX = chr(41100)
YI_SYLLABLE_NBY = chr(41101)
YI_SYLLABLE_NBYP = chr(41102)
YI_SYLLABLE_NBYRX = chr(41103)
YI_SYLLABLE_NBYR = chr(41104)
YI_SYLLABLE_HMIT = chr(41105)
YI_SYLLABLE_HMIX = chr(41106)
YI_SYLLABLE_HMI = chr(41107)
YI_SYLLABLE_HMIP = chr(41108)
YI_SYLLABLE_HMIEX = chr(41109)
YI_SYLLABLE_HMIE = chr(41110)
YI_SYLLABLE_HMIEP = chr(41111)
YI_SYLLABLE_HMAT = chr(41112)
YI_SYLLABLE_HMAX = chr(41113)
YI_SYLLABLE_HMA = chr(41114)
YI_SYLLABLE_HMAP = chr(41115)
YI_SYLLABLE_HMUOX = chr(41116)
YI_SYLLABLE_HMUO = chr(41117)
YI_SYLLABLE_HMUOP = chr(41118)
YI_SYLLABLE_HMOT = chr(41119)
YI_SYLLABLE_HMOX = chr(41120)
YI_SYLLABLE_HMO = chr(41121)
YI_SYLLABLE_HMOP = chr(41122)
YI_SYLLABLE_HMUT = chr(41123)
YI_SYLLABLE_HMUX = chr(41124)
YI_SYLLABLE_HMU = chr(41125)
YI_SYLLABLE_HMUP = chr(41126)
YI_SYLLABLE_HMURX = chr(41127)
YI_SYLLABLE_HMUR = chr(41128)
YI_SYLLABLE_HMYX = chr(41129)
YI_SYLLABLE_HMY = chr(41130)
YI_SYLLABLE_HMYP = chr(41131)
YI_SYLLABLE_HMYRX = chr(41132)
YI_SYLLABLE_HMYR = chr(41133)
YI_SYLLABLE_MIT = chr(41134)
YI_SYLLABLE_MIX = chr(41135)
YI_SYLLABLE_MI = chr(41136)
YI_SYLLABLE_MIP = chr(41137)
YI_SYLLABLE_MIEX = chr(41138)
YI_SYLLABLE_MIE = chr(41139)
YI_SYLLABLE_MIEP = chr(41140)
YI_SYLLABLE_MAT = chr(41141)
YI_SYLLABLE_MAX = chr(41142)
YI_SYLLABLE_MA = chr(41143)
YI_SYLLABLE_MAP = chr(41144)
YI_SYLLABLE_MUOT = chr(41145)
YI_SYLLABLE_MUOX = chr(41146)
YI_SYLLABLE_MUO = chr(41147)
YI_SYLLABLE_MUOP = chr(41148)
YI_SYLLABLE_MOT = chr(41149)
YI_SYLLABLE_MOX = chr(41150)
YI_SYLLABLE_MO = chr(41151)
YI_SYLLABLE_MOP = chr(41152)
YI_SYLLABLE_MEX = chr(41153)
YI_SYLLABLE_ME = chr(41154)
YI_SYLLABLE_MUT = chr(41155)
YI_SYLLABLE_MUX = chr(41156)
YI_SYLLABLE_MU = chr(41157)
YI_SYLLABLE_MUP = chr(41158)
YI_SYLLABLE_MURX = chr(41159)
YI_SYLLABLE_MUR = chr(41160)
YI_SYLLABLE_MYT = chr(41161)
YI_SYLLABLE_MYX = chr(41162)
YI_SYLLABLE_MY = chr(41163)
YI_SYLLABLE_MYP = chr(41164)
YI_SYLLABLE_FIT = chr(41165)
YI_SYLLABLE_FIX = chr(41166)
YI_SYLLABLE_FI = chr(41167)
YI_SYLLABLE_FIP = chr(41168)
YI_SYLLABLE_FAT = chr(41169)
YI_SYLLABLE_FAX = chr(41170)
YI_SYLLABLE_FA = chr(41171)
YI_SYLLABLE_FAP = chr(41172)
YI_SYLLABLE_FOX = chr(41173)
YI_SYLLABLE_FO = chr(41174)
YI_SYLLABLE_FOP = chr(41175)
YI_SYLLABLE_FUT = chr(41176)
YI_SYLLABLE_FUX = chr(41177)
YI_SYLLABLE_FU = chr(41178)
YI_SYLLABLE_FUP = chr(41179)
YI_SYLLABLE_FURX = chr(41180)
YI_SYLLABLE_FUR = chr(41181)
YI_SYLLABLE_FYT = chr(41182)
YI_SYLLABLE_FYX = chr(41183)
YI_SYLLABLE_FY = chr(41184)
YI_SYLLABLE_FYP = chr(41185)
YI_SYLLABLE_VIT = chr(41186)
YI_SYLLABLE_VIX = chr(41187)
YI_SYLLABLE_VI = chr(41188)
YI_SYLLABLE_VIP = chr(41189)
YI_SYLLABLE_VIET = chr(41190)
YI_SYLLABLE_VIEX = chr(41191)
YI_SYLLABLE_VIE = chr(41192)
YI_SYLLABLE_VIEP = chr(41193)
YI_SYLLABLE_VAT = chr(41194)
YI_SYLLABLE_VAX = chr(41195)
YI_SYLLABLE_VA = chr(41196)
YI_SYLLABLE_VAP = chr(41197)
YI_SYLLABLE_VOT = chr(41198)
YI_SYLLABLE_VOX = chr(41199)
YI_SYLLABLE_VO = chr(41200)
YI_SYLLABLE_VOP = chr(41201)
YI_SYLLABLE_VEX = chr(41202)
YI_SYLLABLE_VEP = chr(41203)
YI_SYLLABLE_VUT = chr(41204)
YI_SYLLABLE_VUX = chr(41205)
YI_SYLLABLE_VU = chr(41206)
YI_SYLLABLE_VUP = chr(41207)
YI_SYLLABLE_VURX = chr(41208)
YI_SYLLABLE_VUR = chr(41209)
YI_SYLLABLE_VYT = chr(41210)
YI_SYLLABLE_VYX = chr(41211)
YI_SYLLABLE_VY = chr(41212)
YI_SYLLABLE_VYP = chr(41213)
YI_SYLLABLE_VYRX = chr(41214)
YI_SYLLABLE_VYR = chr(41215)
YI_SYLLABLE_DIT = chr(41216)
YI_SYLLABLE_DIX = chr(41217)
YI_SYLLABLE_DI = chr(41218)
YI_SYLLABLE_DIP = chr(41219)
YI_SYLLABLE_DIEX = chr(41220)
YI_SYLLABLE_DIE = chr(41221)
YI_SYLLABLE_DIEP = chr(41222)
YI_SYLLABLE_DAT = chr(41223)
YI_SYLLABLE_DAX = chr(41224)
YI_SYLLABLE_DA = chr(41225)
YI_SYLLABLE_DAP = chr(41226)
YI_SYLLABLE_DUOX = chr(41227)
YI_SYLLABLE_DUO = chr(41228)
YI_SYLLABLE_DOT = chr(41229)
YI_SYLLABLE_DOX = chr(41230)
YI_SYLLABLE_DO = chr(41231)
YI_SYLLABLE_DOP = chr(41232)
YI_SYLLABLE_DEX = chr(41233)
YI_SYLLABLE_DE = chr(41234)
YI_SYLLABLE_DEP = chr(41235)
YI_SYLLABLE_DUT = chr(41236)
YI_SYLLABLE_DUX = chr(41237)
YI_SYLLABLE_DU = chr(41238)
YI_SYLLABLE_DUP = chr(41239)
YI_SYLLABLE_DURX = chr(41240)
YI_SYLLABLE_DUR = chr(41241)
YI_SYLLABLE_TIT = chr(41242)
YI_SYLLABLE_TIX = chr(41243)
YI_SYLLABLE_TI = chr(41244)
YI_SYLLABLE_TIP = chr(41245)
YI_SYLLABLE_TIEX = chr(41246)
YI_SYLLABLE_TIE = chr(41247)
YI_SYLLABLE_TIEP = chr(41248)
YI_SYLLABLE_TAT = chr(41249)
YI_SYLLABLE_TAX = chr(41250)
YI_SYLLABLE_TA = chr(41251)
YI_SYLLABLE_TAP = chr(41252)
YI_SYLLABLE_TUOT = chr(41253)
YI_SYLLABLE_TUOX = chr(41254)
YI_SYLLABLE_TUO = chr(41255)
YI_SYLLABLE_TUOP = chr(41256)
YI_SYLLABLE_TOT = chr(41257)
YI_SYLLABLE_TOX = chr(41258)
YI_SYLLABLE_TO = chr(41259)
YI_SYLLABLE_TOP = chr(41260)
YI_SYLLABLE_TEX = chr(41261)
YI_SYLLABLE_TE = chr(41262)
YI_SYLLABLE_TEP = chr(41263)
YI_SYLLABLE_TUT = chr(41264)
YI_SYLLABLE_TUX = chr(41265)
YI_SYLLABLE_TU = chr(41266)
YI_SYLLABLE_TUP = chr(41267)
YI_SYLLABLE_TURX = chr(41268)
YI_SYLLABLE_TUR = chr(41269)
YI_SYLLABLE_DDIT = chr(41270)
YI_SYLLABLE_DDIX = chr(41271)
YI_SYLLABLE_DDI = chr(41272)
YI_SYLLABLE_DDIP = chr(41273)
YI_SYLLABLE_DDIEX = chr(41274)
YI_SYLLABLE_DDIE = chr(41275)
YI_SYLLABLE_DDIEP = chr(41276)
YI_SYLLABLE_DDAT = chr(41277)
YI_SYLLABLE_DDAX = chr(41278)
YI_SYLLABLE_DDA = chr(41279)
YI_SYLLABLE_DDAP = chr(41280)
YI_SYLLABLE_DDUOX = chr(41281)
YI_SYLLABLE_DDUO = chr(41282)
YI_SYLLABLE_DDUOP = chr(41283)
YI_SYLLABLE_DDOT = chr(41284)
YI_SYLLABLE_DDOX = chr(41285)
YI_SYLLABLE_DDO = chr(41286)
YI_SYLLABLE_DDOP = chr(41287)
YI_SYLLABLE_DDEX = chr(41288)
YI_SYLLABLE_DDE = chr(41289)
YI_SYLLABLE_DDEP = chr(41290)
YI_SYLLABLE_DDUT = chr(41291)
YI_SYLLABLE_DDUX = chr(41292)
YI_SYLLABLE_DDU = chr(41293)
YI_SYLLABLE_DDUP = chr(41294)
YI_SYLLABLE_DDURX = chr(41295)
YI_SYLLABLE_DDUR = chr(41296)
YI_SYLLABLE_NDIT = chr(41297)
YI_SYLLABLE_NDIX = chr(41298)
YI_SYLLABLE_NDI = chr(41299)
YI_SYLLABLE_NDIP = chr(41300)
YI_SYLLABLE_NDIEX = chr(41301)
YI_SYLLABLE_NDIE = chr(41302)
YI_SYLLABLE_NDAT = chr(41303)
YI_SYLLABLE_NDAX = chr(41304)
YI_SYLLABLE_NDA = chr(41305)
YI_SYLLABLE_NDAP = chr(41306)
YI_SYLLABLE_NDOT = chr(41307)
YI_SYLLABLE_NDOX = chr(41308)
YI_SYLLABLE_NDO = chr(41309)
YI_SYLLABLE_NDOP = chr(41310)
YI_SYLLABLE_NDEX = chr(41311)
YI_SYLLABLE_NDE = chr(41312)
YI_SYLLABLE_NDEP = chr(41313)
YI_SYLLABLE_NDUT = chr(41314)
YI_SYLLABLE_NDUX = chr(41315)
YI_SYLLABLE_NDU = chr(41316)
YI_SYLLABLE_NDUP = chr(41317)
YI_SYLLABLE_NDURX = chr(41318)
YI_SYLLABLE_NDUR = chr(41319)
YI_SYLLABLE_HNIT = chr(41320)
YI_SYLLABLE_HNIX = chr(41321)
YI_SYLLABLE_HNI = chr(41322)
YI_SYLLABLE_HNIP = chr(41323)
YI_SYLLABLE_HNIET = chr(41324)
YI_SYLLABLE_HNIEX = chr(41325)
YI_SYLLABLE_HNIE = chr(41326)
YI_SYLLABLE_HNIEP = chr(41327)
YI_SYLLABLE_HNAT = chr(41328)
YI_SYLLABLE_HNAX = chr(41329)
YI_SYLLABLE_HNA = chr(41330)
YI_SYLLABLE_HNAP = chr(41331)
YI_SYLLABLE_HNUOX = chr(41332)
YI_SYLLABLE_HNUO = chr(41333)
YI_SYLLABLE_HNOT = chr(41334)
YI_SYLLABLE_HNOX = chr(41335)
YI_SYLLABLE_HNOP = chr(41336)
YI_SYLLABLE_HNEX = chr(41337)
YI_SYLLABLE_HNE = chr(41338)
YI_SYLLABLE_HNEP = chr(41339)
YI_SYLLABLE_HNUT = chr(41340)
YI_SYLLABLE_NIT = chr(41341)
YI_SYLLABLE_NIX = chr(41342)
YI_SYLLABLE_NI = chr(41343)
YI_SYLLABLE_NIP = chr(41344)
YI_SYLLABLE_NIEX = chr(41345)
YI_SYLLABLE_NIE = chr(41346)
YI_SYLLABLE_NIEP = chr(41347)
YI_SYLLABLE_NAX = chr(41348)
YI_SYLLABLE_NA = chr(41349)
YI_SYLLABLE_NAP = chr(41350)
YI_SYLLABLE_NUOX = chr(41351)
YI_SYLLABLE_NUO = chr(41352)
YI_SYLLABLE_NUOP = chr(41353)
YI_SYLLABLE_NOT = chr(41354)
YI_SYLLABLE_NOX = chr(41355)
YI_SYLLABLE_NO = chr(41356)
YI_SYLLABLE_NOP = chr(41357)
YI_SYLLABLE_NEX = chr(41358)
YI_SYLLABLE_NE = chr(41359)
YI_SYLLABLE_NEP = chr(41360)
YI_SYLLABLE_NUT = chr(41361)
YI_SYLLABLE_NUX = chr(41362)
YI_SYLLABLE_NU = chr(41363)
YI_SYLLABLE_NUP = chr(41364)
YI_SYLLABLE_NURX = chr(41365)
YI_SYLLABLE_NUR = chr(41366)
YI_SYLLABLE_HLIT = chr(41367)
YI_SYLLABLE_HLIX = chr(41368)
YI_SYLLABLE_HLI = chr(41369)
YI_SYLLABLE_HLIP = chr(41370)
YI_SYLLABLE_HLIEX = chr(41371)
YI_SYLLABLE_HLIE = chr(41372)
YI_SYLLABLE_HLIEP = chr(41373)
YI_SYLLABLE_HLAT = chr(41374)
YI_SYLLABLE_HLAX = chr(41375)
YI_SYLLABLE_HLA = chr(41376)
YI_SYLLABLE_HLAP = chr(41377)
YI_SYLLABLE_HLUOX = chr(41378)
YI_SYLLABLE_HLUO = chr(41379)
YI_SYLLABLE_HLUOP = chr(41380)
YI_SYLLABLE_HLOX = chr(41381)
YI_SYLLABLE_HLO = chr(41382)
YI_SYLLABLE_HLOP = chr(41383)
YI_SYLLABLE_HLEX = chr(41384)
YI_SYLLABLE_HLE = chr(41385)
YI_SYLLABLE_HLEP = chr(41386)
YI_SYLLABLE_HLUT = chr(41387)
YI_SYLLABLE_HLUX = chr(41388)
YI_SYLLABLE_HLU = chr(41389)
YI_SYLLABLE_HLUP = chr(41390)
YI_SYLLABLE_HLURX = chr(41391)
YI_SYLLABLE_HLUR = chr(41392)
YI_SYLLABLE_HLYT = chr(41393)
YI_SYLLABLE_HLYX = chr(41394)
YI_SYLLABLE_HLY = chr(41395)
YI_SYLLABLE_HLYP = chr(41396)
YI_SYLLABLE_HLYRX = chr(41397)
YI_SYLLABLE_HLYR = chr(41398)
YI_SYLLABLE_LIT = chr(41399)
YI_SYLLABLE_LIX = chr(41400)
YI_SYLLABLE_LI = chr(41401)
YI_SYLLABLE_LIP = chr(41402)
YI_SYLLABLE_LIET = chr(41403)
YI_SYLLABLE_LIEX = chr(41404)
YI_SYLLABLE_LIE = chr(41405)
YI_SYLLABLE_LIEP = chr(41406)
YI_SYLLABLE_LAT = chr(41407)
YI_SYLLABLE_LAX = chr(41408)
YI_SYLLABLE_LA = chr(41409)
YI_SYLLABLE_LAP = chr(41410)
YI_SYLLABLE_LUOT = chr(41411)
YI_SYLLABLE_LUOX = chr(41412)
YI_SYLLABLE_LUO = chr(41413)
YI_SYLLABLE_LUOP = chr(41414)
YI_SYLLABLE_LOT = chr(41415)
YI_SYLLABLE_LOX = chr(41416)
YI_SYLLABLE_LO = chr(41417)
YI_SYLLABLE_LOP = chr(41418)
YI_SYLLABLE_LEX = chr(41419)
YI_SYLLABLE_LE = chr(41420)
YI_SYLLABLE_LEP = chr(41421)
YI_SYLLABLE_LUT = chr(41422)
YI_SYLLABLE_LUX = chr(41423)
YI_SYLLABLE_LU = chr(41424)
YI_SYLLABLE_LUP = chr(41425)
YI_SYLLABLE_LURX = chr(41426)
YI_SYLLABLE_LUR = chr(41427)
YI_SYLLABLE_LYT = chr(41428)
YI_SYLLABLE_LYX = chr(41429)
YI_SYLLABLE_LY = chr(41430)
YI_SYLLABLE_LYP = chr(41431)
YI_SYLLABLE_LYRX = chr(41432)
YI_SYLLABLE_LYR = chr(41433)
YI_SYLLABLE_GIT = chr(41434)
YI_SYLLABLE_GIX = chr(41435)
YI_SYLLABLE_GI = chr(41436)
YI_SYLLABLE_GIP = chr(41437)
YI_SYLLABLE_GIET = chr(41438)
YI_SYLLABLE_GIEX = chr(41439)
YI_SYLLABLE_GIE = chr(41440)
YI_SYLLABLE_GIEP = chr(41441)
YI_SYLLABLE_GAT = chr(41442)
YI_SYLLABLE_GAX = chr(41443)
YI_SYLLABLE_GA = chr(41444)
YI_SYLLABLE_GAP = chr(41445)
YI_SYLLABLE_GUOT = chr(41446)
YI_SYLLABLE_GUOX = chr(41447)
YI_SYLLABLE_GUO = chr(41448)
YI_SYLLABLE_GUOP = chr(41449)
YI_SYLLABLE_GOT = chr(41450)
YI_SYLLABLE_GOX = chr(41451)
YI_SYLLABLE_GO = chr(41452)
YI_SYLLABLE_GOP = chr(41453)
YI_SYLLABLE_GET = chr(41454)
YI_SYLLABLE_GEX = chr(41455)
YI_SYLLABLE_GE = chr(41456)
YI_SYLLABLE_GEP = chr(41457)
YI_SYLLABLE_GUT = chr(41458)
YI_SYLLABLE_GUX = chr(41459)
YI_SYLLABLE_GU = chr(41460)
YI_SYLLABLE_GUP = chr(41461)
YI_SYLLABLE_GURX = chr(41462)
YI_SYLLABLE_GUR = chr(41463)
YI_SYLLABLE_KIT = chr(41464)
YI_SYLLABLE_KIX = chr(41465)
YI_SYLLABLE_KI = chr(41466)
YI_SYLLABLE_KIP = chr(41467)
YI_SYLLABLE_KIEX = chr(41468)
YI_SYLLABLE_KIE = chr(41469)
YI_SYLLABLE_KIEP = chr(41470)
YI_SYLLABLE_KAT = chr(41471)
YI_SYLLABLE_KAX = chr(41472)
YI_SYLLABLE_KA = chr(41473)
YI_SYLLABLE_KAP = chr(41474)
YI_SYLLABLE_KUOX = chr(41475)
YI_SYLLABLE_KUO = chr(41476)
YI_SYLLABLE_KUOP = chr(41477)
YI_SYLLABLE_KOT = chr(41478)
YI_SYLLABLE_KOX = chr(41479)
YI_SYLLABLE_KO = chr(41480)
YI_SYLLABLE_KOP = chr(41481)
YI_SYLLABLE_KET = chr(41482)
YI_SYLLABLE_KEX = chr(41483)
YI_SYLLABLE_KE = chr(41484)
YI_SYLLABLE_KEP = chr(41485)
YI_SYLLABLE_KUT = chr(41486)
YI_SYLLABLE_KUX = chr(41487)
YI_SYLLABLE_KU = chr(41488)
YI_SYLLABLE_KUP = chr(41489)
YI_SYLLABLE_KURX = chr(41490)
YI_SYLLABLE_KUR = chr(41491)
YI_SYLLABLE_GGIT = chr(41492)
YI_SYLLABLE_GGIX = chr(41493)
YI_SYLLABLE_GGI = chr(41494)
YI_SYLLABLE_GGIEX = chr(41495)
YI_SYLLABLE_GGIE = chr(41496)
YI_SYLLABLE_GGIEP = chr(41497)
YI_SYLLABLE_GGAT = chr(41498)
YI_SYLLABLE_GGAX = chr(41499)
YI_SYLLABLE_GGA = chr(41500)
YI_SYLLABLE_GGAP = chr(41501)
YI_SYLLABLE_GGUOT = chr(41502)
YI_SYLLABLE_GGUOX = chr(41503)
YI_SYLLABLE_GGUO = chr(41504)
YI_SYLLABLE_GGUOP = chr(41505)
YI_SYLLABLE_GGOT = chr(41506)
YI_SYLLABLE_GGOX = chr(41507)
YI_SYLLABLE_GGO = chr(41508)
YI_SYLLABLE_GGOP = chr(41509)
YI_SYLLABLE_GGET = chr(41510)
YI_SYLLABLE_GGEX = chr(41511)
YI_SYLLABLE_GGE = chr(41512)
YI_SYLLABLE_GGEP = chr(41513)
YI_SYLLABLE_GGUT = chr(41514)
YI_SYLLABLE_GGUX = chr(41515)
YI_SYLLABLE_GGU = chr(41516)
YI_SYLLABLE_GGUP = chr(41517)
YI_SYLLABLE_GGURX = chr(41518)
YI_SYLLABLE_GGUR = chr(41519)
YI_SYLLABLE_MGIEX = chr(41520)
YI_SYLLABLE_MGIE = chr(41521)
YI_SYLLABLE_MGAT = chr(41522)
YI_SYLLABLE_MGAX = chr(41523)
YI_SYLLABLE_MGA = chr(41524)
YI_SYLLABLE_MGAP = chr(41525)
YI_SYLLABLE_MGUOX = chr(41526)
YI_SYLLABLE_MGUO = chr(41527)
YI_SYLLABLE_MGUOP = chr(41528)
YI_SYLLABLE_MGOT = chr(41529)
YI_SYLLABLE_MGOX = chr(41530)
YI_SYLLABLE_MGO = chr(41531)
YI_SYLLABLE_MGOP = chr(41532)
YI_SYLLABLE_MGEX = chr(41533)
YI_SYLLABLE_MGE = chr(41534)
YI_SYLLABLE_MGEP = chr(41535)
YI_SYLLABLE_MGUT = chr(41536)
YI_SYLLABLE_MGUX = chr(41537)
YI_SYLLABLE_MGU = chr(41538)
YI_SYLLABLE_MGUP = chr(41539)
YI_SYLLABLE_MGURX = chr(41540)
YI_SYLLABLE_MGUR = chr(41541)
YI_SYLLABLE_HXIT = chr(41542)
YI_SYLLABLE_HXIX = chr(41543)
YI_SYLLABLE_HXI = chr(41544)
YI_SYLLABLE_HXIP = chr(41545)
YI_SYLLABLE_HXIET = chr(41546)
YI_SYLLABLE_HXIEX = chr(41547)
YI_SYLLABLE_HXIE = chr(41548)
YI_SYLLABLE_HXIEP = chr(41549)
YI_SYLLABLE_HXAT = chr(41550)
YI_SYLLABLE_HXAX = chr(41551)
YI_SYLLABLE_HXA = chr(41552)
YI_SYLLABLE_HXAP = chr(41553)
YI_SYLLABLE_HXUOT = chr(41554)
YI_SYLLABLE_HXUOX = chr(41555)
YI_SYLLABLE_HXUO = chr(41556)
YI_SYLLABLE_HXUOP = chr(41557)
YI_SYLLABLE_HXOT = chr(41558)
YI_SYLLABLE_HXOX = chr(41559)
YI_SYLLABLE_HXO = chr(41560)
YI_SYLLABLE_HXOP = chr(41561)
YI_SYLLABLE_HXEX = chr(41562)
YI_SYLLABLE_HXE = chr(41563)
YI_SYLLABLE_HXEP = chr(41564)
YI_SYLLABLE_NGIEX = chr(41565)
YI_SYLLABLE_NGIE = chr(41566)
YI_SYLLABLE_NGIEP = chr(41567)
YI_SYLLABLE_NGAT = chr(41568)
YI_SYLLABLE_NGAX = chr(41569)
YI_SYLLABLE_NGA = chr(41570)
YI_SYLLABLE_NGAP = chr(41571)
YI_SYLLABLE_NGUOT = chr(41572)
YI_SYLLABLE_NGUOX = chr(41573)
YI_SYLLABLE_NGUO = chr(41574)
YI_SYLLABLE_NGOT = chr(41575)
YI_SYLLABLE_NGOX = chr(41576)
YI_SYLLABLE_NGO = chr(41577)
YI_SYLLABLE_NGOP = chr(41578)
YI_SYLLABLE_NGEX = chr(41579)
YI_SYLLABLE_NGE = chr(41580)
YI_SYLLABLE_NGEP = chr(41581)
YI_SYLLABLE_HIT = chr(41582)
YI_SYLLABLE_HIEX = chr(41583)
YI_SYLLABLE_HIE = chr(41584)
YI_SYLLABLE_HAT = chr(41585)
YI_SYLLABLE_HAX = chr(41586)
YI_SYLLABLE_HA = chr(41587)
YI_SYLLABLE_HAP = chr(41588)
YI_SYLLABLE_HUOT = chr(41589)
YI_SYLLABLE_HUOX = chr(41590)
YI_SYLLABLE_HUO = chr(41591)
YI_SYLLABLE_HUOP = chr(41592)
YI_SYLLABLE_HOT = chr(41593)
YI_SYLLABLE_HOX = chr(41594)
YI_SYLLABLE_HO = chr(41595)
YI_SYLLABLE_HOP = chr(41596)
YI_SYLLABLE_HEX = chr(41597)
YI_SYLLABLE_HE = chr(41598)
YI_SYLLABLE_HEP = chr(41599)
YI_SYLLABLE_WAT = chr(41600)
YI_SYLLABLE_WAX = chr(41601)
YI_SYLLABLE_WA = chr(41602)
YI_SYLLABLE_WAP = chr(41603)
YI_SYLLABLE_WUOX = chr(41604)
YI_SYLLABLE_WUO = chr(41605)
YI_SYLLABLE_WUOP = chr(41606)
YI_SYLLABLE_WOX = chr(41607)
YI_SYLLABLE_WO = chr(41608)
YI_SYLLABLE_WOP = chr(41609)
YI_SYLLABLE_WEX = chr(41610)
YI_SYLLABLE_WE = chr(41611)
YI_SYLLABLE_WEP = chr(41612)
YI_SYLLABLE_ZIT = chr(41613)
YI_SYLLABLE_ZIX = chr(41614)
YI_SYLLABLE_ZI = chr(41615)
YI_SYLLABLE_ZIP = chr(41616)
YI_SYLLABLE_ZIEX = chr(41617)
YI_SYLLABLE_ZIE = chr(41618)
YI_SYLLABLE_ZIEP = chr(41619)
YI_SYLLABLE_ZAT = chr(41620)
YI_SYLLABLE_ZAX = chr(41621)
YI_SYLLABLE_ZA = chr(41622)
YI_SYLLABLE_ZAP = chr(41623)
YI_SYLLABLE_ZUOX = chr(41624)
YI_SYLLABLE_ZUO = chr(41625)
YI_SYLLABLE_ZUOP = chr(41626)
YI_SYLLABLE_ZOT = chr(41627)
YI_SYLLABLE_ZOX = chr(41628)
YI_SYLLABLE_ZO = chr(41629)
YI_SYLLABLE_ZOP = chr(41630)
YI_SYLLABLE_ZEX = chr(41631)
YI_SYLLABLE_ZE = chr(41632)
YI_SYLLABLE_ZEP = chr(41633)
YI_SYLLABLE_ZUT = chr(41634)
YI_SYLLABLE_ZUX = chr(41635)
YI_SYLLABLE_ZU = chr(41636)
YI_SYLLABLE_ZUP = chr(41637)
YI_SYLLABLE_ZURX = chr(41638)
YI_SYLLABLE_ZUR = chr(41639)
YI_SYLLABLE_ZYT = chr(41640)
YI_SYLLABLE_ZYX = chr(41641)
YI_SYLLABLE_ZY = chr(41642)
YI_SYLLABLE_ZYP = chr(41643)
YI_SYLLABLE_ZYRX = chr(41644)
YI_SYLLABLE_ZYR = chr(41645)
YI_SYLLABLE_CIT = chr(41646)
YI_SYLLABLE_CIX = chr(41647)
YI_SYLLABLE_CI = chr(41648)
YI_SYLLABLE_CIP = chr(41649)
YI_SYLLABLE_CIET = chr(41650)
YI_SYLLABLE_CIEX = chr(41651)
YI_SYLLABLE_CIE = chr(41652)
YI_SYLLABLE_CIEP = chr(41653)
YI_SYLLABLE_CAT = chr(41654)
YI_SYLLABLE_CAX = chr(41655)
YI_SYLLABLE_CA = chr(41656)
YI_SYLLABLE_CAP = chr(41657)
YI_SYLLABLE_CUOX = chr(41658)
YI_SYLLABLE_CUO = chr(41659)
YI_SYLLABLE_CUOP = chr(41660)
YI_SYLLABLE_COT = chr(41661)
YI_SYLLABLE_COX = chr(41662)
YI_SYLLABLE_CO = chr(41663)
YI_SYLLABLE_COP = chr(41664)
YI_SYLLABLE_CEX = chr(41665)
YI_SYLLABLE_CE = chr(41666)
YI_SYLLABLE_CEP = chr(41667)
YI_SYLLABLE_CUT = chr(41668)
YI_SYLLABLE_CUX = chr(41669)
YI_SYLLABLE_CU = chr(41670)
YI_SYLLABLE_CUP = chr(41671)
YI_SYLLABLE_CURX = chr(41672)
YI_SYLLABLE_CUR = chr(41673)
YI_SYLLABLE_CYT = chr(41674)
YI_SYLLABLE_CYX = chr(41675)
YI_SYLLABLE_CY = chr(41676)
YI_SYLLABLE_CYP = chr(41677)
YI_SYLLABLE_CYRX = chr(41678)
YI_SYLLABLE_CYR = chr(41679)
YI_SYLLABLE_ZZIT = chr(41680)
YI_SYLLABLE_ZZIX = chr(41681)
YI_SYLLABLE_ZZI = chr(41682)
YI_SYLLABLE_ZZIP = chr(41683)
YI_SYLLABLE_ZZIET = chr(41684)
YI_SYLLABLE_ZZIEX = chr(41685)
YI_SYLLABLE_ZZIE = chr(41686)
YI_SYLLABLE_ZZIEP = chr(41687)
YI_SYLLABLE_ZZAT = chr(41688)
YI_SYLLABLE_ZZAX = chr(41689)
YI_SYLLABLE_ZZA = chr(41690)
YI_SYLLABLE_ZZAP = chr(41691)
YI_SYLLABLE_ZZOX = chr(41692)
YI_SYLLABLE_ZZO = chr(41693)
YI_SYLLABLE_ZZOP = chr(41694)
YI_SYLLABLE_ZZEX = chr(41695)
YI_SYLLABLE_ZZE = chr(41696)
YI_SYLLABLE_ZZEP = chr(41697)
YI_SYLLABLE_ZZUX = chr(41698)
YI_SYLLABLE_ZZU = chr(41699)
YI_SYLLABLE_ZZUP = chr(41700)
YI_SYLLABLE_ZZURX = chr(41701)
YI_SYLLABLE_ZZUR = chr(41702)
YI_SYLLABLE_ZZYT = chr(41703)
YI_SYLLABLE_ZZYX = chr(41704)
YI_SYLLABLE_ZZY = chr(41705)
YI_SYLLABLE_ZZYP = chr(41706)
YI_SYLLABLE_ZZYRX = chr(41707)
YI_SYLLABLE_ZZYR = chr(41708)
YI_SYLLABLE_NZIT = chr(41709)
YI_SYLLABLE_NZIX = chr(41710)
YI_SYLLABLE_NZI = chr(41711)
YI_SYLLABLE_NZIP = chr(41712)
YI_SYLLABLE_NZIEX = chr(41713)
YI_SYLLABLE_NZIE = chr(41714)
YI_SYLLABLE_NZIEP = chr(41715)
YI_SYLLABLE_NZAT = chr(41716)
YI_SYLLABLE_NZAX = chr(41717)
YI_SYLLABLE_NZA = chr(41718)
YI_SYLLABLE_NZAP = chr(41719)
YI_SYLLABLE_NZUOX = chr(41720)
YI_SYLLABLE_NZUO = chr(41721)
YI_SYLLABLE_NZOX = chr(41722)
YI_SYLLABLE_NZOP = chr(41723)
YI_SYLLABLE_NZEX = chr(41724)
YI_SYLLABLE_NZE = chr(41725)
YI_SYLLABLE_NZUX = chr(41726)
YI_SYLLABLE_NZU = chr(41727)
YI_SYLLABLE_NZUP = chr(41728)
YI_SYLLABLE_NZURX = chr(41729)
YI_SYLLABLE_NZUR = chr(41730)
YI_SYLLABLE_NZYT = chr(41731)
YI_SYLLABLE_NZYX = chr(41732)
YI_SYLLABLE_NZY = chr(41733)
YI_SYLLABLE_NZYP = chr(41734)
YI_SYLLABLE_NZYRX = chr(41735)
YI_SYLLABLE_NZYR = chr(41736)
YI_SYLLABLE_SIT = chr(41737)
YI_SYLLABLE_SIX = chr(41738)
YI_SYLLABLE_SI = chr(41739)
YI_SYLLABLE_SIP = chr(41740)
YI_SYLLABLE_SIEX = chr(41741)
YI_SYLLABLE_SIE = chr(41742)
YI_SYLLABLE_SIEP = chr(41743)
YI_SYLLABLE_SAT = chr(41744)
YI_SYLLABLE_SAX = chr(41745)
YI_SYLLABLE_SA = chr(41746)
YI_SYLLABLE_SAP = chr(41747)
YI_SYLLABLE_SUOX = chr(41748)
YI_SYLLABLE_SUO = chr(41749)
YI_SYLLABLE_SUOP = chr(41750)
YI_SYLLABLE_SOT = chr(41751)
YI_SYLLABLE_SOX = chr(41752)
YI_SYLLABLE_SO = chr(41753)
YI_SYLLABLE_SOP = chr(41754)
YI_SYLLABLE_SEX = chr(41755)
YI_SYLLABLE_SE = chr(41756)
YI_SYLLABLE_SEP = chr(41757)
YI_SYLLABLE_SUT = chr(41758)
YI_SYLLABLE_SUX = chr(41759)
YI_SYLLABLE_SU = chr(41760)
YI_SYLLABLE_SUP = chr(41761)
YI_SYLLABLE_SURX = chr(41762)
YI_SYLLABLE_SUR = chr(41763)
YI_SYLLABLE_SYT = chr(41764)
YI_SYLLABLE_SYX = chr(41765)
YI_SYLLABLE_SY = chr(41766)
YI_SYLLABLE_SYP = chr(41767)
YI_SYLLABLE_SYRX = chr(41768)
YI_SYLLABLE_SYR = chr(41769)
YI_SYLLABLE_SSIT = chr(41770)
YI_SYLLABLE_SSIX = chr(41771)
YI_SYLLABLE_SSI = chr(41772)
YI_SYLLABLE_SSIP = chr(41773)
YI_SYLLABLE_SSIEX = chr(41774)
YI_SYLLABLE_SSIE = chr(41775)
YI_SYLLABLE_SSIEP = chr(41776)
YI_SYLLABLE_SSAT = chr(41777)
YI_SYLLABLE_SSAX = chr(41778)
YI_SYLLABLE_SSA = chr(41779)
YI_SYLLABLE_SSAP = chr(41780)
YI_SYLLABLE_SSOT = chr(41781)
YI_SYLLABLE_SSOX = chr(41782)
YI_SYLLABLE_SSO = chr(41783)
YI_SYLLABLE_SSOP = chr(41784)
YI_SYLLABLE_SSEX = chr(41785)
YI_SYLLABLE_SSE = chr(41786)
YI_SYLLABLE_SSEP = chr(41787)
YI_SYLLABLE_SSUT = chr(41788)
YI_SYLLABLE_SSUX = chr(41789)
YI_SYLLABLE_SSU = chr(41790)
YI_SYLLABLE_SSUP = chr(41791)
YI_SYLLABLE_SSYT = chr(41792)
YI_SYLLABLE_SSYX = chr(41793)
YI_SYLLABLE_SSY = chr(41794)
YI_SYLLABLE_SSYP = chr(41795)
YI_SYLLABLE_SSYRX = chr(41796)
YI_SYLLABLE_SSYR = chr(41797)
YI_SYLLABLE_ZHAT = chr(41798)
YI_SYLLABLE_ZHAX = chr(41799)
YI_SYLLABLE_ZHA = chr(41800)
YI_SYLLABLE_ZHAP = chr(41801)
YI_SYLLABLE_ZHUOX = chr(41802)
YI_SYLLABLE_ZHUO = chr(41803)
YI_SYLLABLE_ZHUOP = chr(41804)
YI_SYLLABLE_ZHOT = chr(41805)
YI_SYLLABLE_ZHOX = chr(41806)
YI_SYLLABLE_ZHO = chr(41807)
YI_SYLLABLE_ZHOP = chr(41808)
YI_SYLLABLE_ZHET = chr(41809)
YI_SYLLABLE_ZHEX = chr(41810)
YI_SYLLABLE_ZHE = chr(41811)
YI_SYLLABLE_ZHEP = chr(41812)
YI_SYLLABLE_ZHUT = chr(41813)
YI_SYLLABLE_ZHUX = chr(41814)
YI_SYLLABLE_ZHU = chr(41815)
YI_SYLLABLE_ZHUP = chr(41816)
YI_SYLLABLE_ZHURX = chr(41817)
YI_SYLLABLE_ZHUR = chr(41818)
YI_SYLLABLE_ZHYT = chr(41819)
YI_SYLLABLE_ZHYX = chr(41820)
YI_SYLLABLE_ZHY = chr(41821)
YI_SYLLABLE_ZHYP = chr(41822)
YI_SYLLABLE_ZHYRX = chr(41823)
YI_SYLLABLE_ZHYR = chr(41824)
YI_SYLLABLE_CHAT = chr(41825)
YI_SYLLABLE_CHAX = chr(41826)
YI_SYLLABLE_CHA = chr(41827)
YI_SYLLABLE_CHAP = chr(41828)
YI_SYLLABLE_CHUOT = chr(41829)
YI_SYLLABLE_CHUOX = chr(41830)
YI_SYLLABLE_CHUO = chr(41831)
YI_SYLLABLE_CHUOP = chr(41832)
YI_SYLLABLE_CHOT = chr(41833)
YI_SYLLABLE_CHOX = chr(41834)
YI_SYLLABLE_CHO = chr(41835)
YI_SYLLABLE_CHOP = chr(41836)
YI_SYLLABLE_CHET = chr(41837)
YI_SYLLABLE_CHEX = chr(41838)
YI_SYLLABLE_CHE = chr(41839)
YI_SYLLABLE_CHEP = chr(41840)
YI_SYLLABLE_CHUX = chr(41841)
YI_SYLLABLE_CHU = chr(41842)
YI_SYLLABLE_CHUP = chr(41843)
YI_SYLLABLE_CHURX = chr(41844)
YI_SYLLABLE_CHUR = chr(41845)
YI_SYLLABLE_CHYT = chr(41846)
YI_SYLLABLE_CHYX = chr(41847)
YI_SYLLABLE_CHY = chr(41848)
YI_SYLLABLE_CHYP = chr(41849)
YI_SYLLABLE_CHYRX = chr(41850)
YI_SYLLABLE_CHYR = chr(41851)
YI_SYLLABLE_RRAX = chr(41852)
YI_SYLLABLE_RRA = chr(41853)
YI_SYLLABLE_RRUOX = chr(41854)
YI_SYLLABLE_RRUO = chr(41855)
YI_SYLLABLE_RROT = chr(41856)
YI_SYLLABLE_RROX = chr(41857)
YI_SYLLABLE_RRO = chr(41858)
YI_SYLLABLE_RROP = chr(41859)
YI_SYLLABLE_RRET = chr(41860)
YI_SYLLABLE_RREX = chr(41861)
YI_SYLLABLE_RRE = chr(41862)
YI_SYLLABLE_RREP = chr(41863)
YI_SYLLABLE_RRUT = chr(41864)
YI_SYLLABLE_RRUX = chr(41865)
YI_SYLLABLE_RRU = chr(41866)
YI_SYLLABLE_RRUP = chr(41867)
YI_SYLLABLE_RRURX = chr(41868)
YI_SYLLABLE_RRUR = chr(41869)
YI_SYLLABLE_RRYT = chr(41870)
YI_SYLLABLE_RRYX = chr(41871)
YI_SYLLABLE_RRY = chr(41872)
YI_SYLLABLE_RRYP = chr(41873)
YI_SYLLABLE_RRYRX = chr(41874)
YI_SYLLABLE_RRYR = chr(41875)
YI_SYLLABLE_NRAT = chr(41876)
YI_SYLLABLE_NRAX = chr(41877)
YI_SYLLABLE_NRA = chr(41878)
YI_SYLLABLE_NRAP = chr(41879)
YI_SYLLABLE_NROX = chr(41880)
YI_SYLLABLE_NRO = chr(41881)
YI_SYLLABLE_NROP = chr(41882)
YI_SYLLABLE_NRET = chr(41883)
YI_SYLLABLE_NREX = chr(41884)
YI_SYLLABLE_NRE = chr(41885)
YI_SYLLABLE_NREP = chr(41886)
YI_SYLLABLE_NRUT = chr(41887)
YI_SYLLABLE_NRUX = chr(41888)
YI_SYLLABLE_NRU = chr(41889)
YI_SYLLABLE_NRUP = chr(41890)
YI_SYLLABLE_NRURX = chr(41891)
YI_SYLLABLE_NRUR = chr(41892)
YI_SYLLABLE_NRYT = chr(41893)
YI_SYLLABLE_NRYX = chr(41894)
YI_SYLLABLE_NRY = chr(41895)
YI_SYLLABLE_NRYP = chr(41896)
YI_SYLLABLE_NRYRX = chr(41897)
YI_SYLLABLE_NRYR = chr(41898)
YI_SYLLABLE_SHAT = chr(41899)
YI_SYLLABLE_SHAX = chr(41900)
YI_SYLLABLE_SHA = chr(41901)
YI_SYLLABLE_SHAP = chr(41902)
YI_SYLLABLE_SHUOX = chr(41903)
YI_SYLLABLE_SHUO = chr(41904)
YI_SYLLABLE_SHUOP = chr(41905)
YI_SYLLABLE_SHOT = chr(41906)
YI_SYLLABLE_SHOX = chr(41907)
YI_SYLLABLE_SHO = chr(41908)
YI_SYLLABLE_SHOP = chr(41909)
YI_SYLLABLE_SHET = chr(41910)
YI_SYLLABLE_SHEX = chr(41911)
YI_SYLLABLE_SHE = chr(41912)
YI_SYLLABLE_SHEP = chr(41913)
YI_SYLLABLE_SHUT = chr(41914)
YI_SYLLABLE_SHUX = chr(41915)
YI_SYLLABLE_SHU = chr(41916)
YI_SYLLABLE_SHUP = chr(41917)
YI_SYLLABLE_SHURX = chr(41918)
YI_SYLLABLE_SHUR = chr(41919)
YI_SYLLABLE_SHYT = chr(41920)
YI_SYLLABLE_SHYX = chr(41921)
YI_SYLLABLE_SHY = chr(41922)
YI_SYLLABLE_SHYP = chr(41923)
YI_SYLLABLE_SHYRX = chr(41924)
YI_SYLLABLE_SHYR = chr(41925)
YI_SYLLABLE_RAT = chr(41926)
YI_SYLLABLE_RAX = chr(41927)
YI_SYLLABLE_RA = chr(41928)
YI_SYLLABLE_RAP = chr(41929)
YI_SYLLABLE_RUOX = chr(41930)
YI_SYLLABLE_RUO = chr(41931)
YI_SYLLABLE_RUOP = chr(41932)
YI_SYLLABLE_ROT = chr(41933)
YI_SYLLABLE_ROX = chr(41934)
YI_SYLLABLE_RO = chr(41935)
YI_SYLLABLE_ROP = chr(41936)
YI_SYLLABLE_REX = chr(41937)
YI_SYLLABLE_RE = chr(41938)
YI_SYLLABLE_REP = chr(41939)
YI_SYLLABLE_RUT = chr(41940)
YI_SYLLABLE_RUX = chr(41941)
YI_SYLLABLE_RU = chr(41942)
YI_SYLLABLE_RUP = chr(41943)
YI_SYLLABLE_RURX = chr(41944)
YI_SYLLABLE_RUR = chr(41945)
YI_SYLLABLE_RYT = chr(41946)
YI_SYLLABLE_RYX = chr(41947)
YI_SYLLABLE_RY = chr(41948)
YI_SYLLABLE_RYP = chr(41949)
YI_SYLLABLE_RYRX = chr(41950)
YI_SYLLABLE_RYR = chr(41951)
YI_SYLLABLE_JIT = chr(41952)
YI_SYLLABLE_JIX = chr(41953)
YI_SYLLABLE_JI = chr(41954)
YI_SYLLABLE_JIP = chr(41955)
YI_SYLLABLE_JIET = chr(41956)
YI_SYLLABLE_JIEX = chr(41957)
YI_SYLLABLE_JIE = chr(41958)
YI_SYLLABLE_JIEP = chr(41959)
YI_SYLLABLE_JUOT = chr(41960)
YI_SYLLABLE_JUOX = chr(41961)
YI_SYLLABLE_JUO = chr(41962)
YI_SYLLABLE_JUOP = chr(41963)
YI_SYLLABLE_JOT = chr(41964)
YI_SYLLABLE_JOX = chr(41965)
YI_SYLLABLE_JO = chr(41966)
YI_SYLLABLE_JOP = chr(41967)
YI_SYLLABLE_JUT = chr(41968)
YI_SYLLABLE_JUX = chr(41969)
YI_SYLLABLE_JU = chr(41970)
YI_SYLLABLE_JUP = chr(41971)
YI_SYLLABLE_JURX = chr(41972)
YI_SYLLABLE_JUR = chr(41973)
YI_SYLLABLE_JYT = chr(41974)
YI_SYLLABLE_JYX = chr(41975)
YI_SYLLABLE_JY = chr(41976)
YI_SYLLABLE_JYP = chr(41977)
YI_SYLLABLE_JYRX = chr(41978)
YI_SYLLABLE_JYR = chr(41979)
YI_SYLLABLE_QIT = chr(41980)
YI_SYLLABLE_QIX = chr(41981)
YI_SYLLABLE_QI = chr(41982)
YI_SYLLABLE_QIP = chr(41983)
YI_SYLLABLE_QIET = chr(41984)
YI_SYLLABLE_QIEX = chr(41985)
YI_SYLLABLE_QIE = chr(41986)
YI_SYLLABLE_QIEP = chr(41987)
YI_SYLLABLE_QUOT = chr(41988)
YI_SYLLABLE_QUOX = chr(41989)
YI_SYLLABLE_QUO = chr(41990)
YI_SYLLABLE_QUOP = chr(41991)
YI_SYLLABLE_QOT = chr(41992)
YI_SYLLABLE_QOX = chr(41993)
YI_SYLLABLE_QO = chr(41994)
YI_SYLLABLE_QOP = chr(41995)
YI_SYLLABLE_QUT = chr(41996)
YI_SYLLABLE_QUX = chr(41997)
YI_SYLLABLE_QU = chr(41998)
YI_SYLLABLE_QUP = chr(41999)
YI_SYLLABLE_QURX = chr(42000)
YI_SYLLABLE_QUR = chr(42001)
YI_SYLLABLE_QYT = chr(42002)
YI_SYLLABLE_QYX = chr(42003)
YI_SYLLABLE_QY = chr(42004)
YI_SYLLABLE_QYP = chr(42005)
YI_SYLLABLE_QYRX = chr(42006)
YI_SYLLABLE_QYR = chr(42007)
YI_SYLLABLE_JJIT = chr(42008)
YI_SYLLABLE_JJIX = chr(42009)
YI_SYLLABLE_JJI = chr(42010)
YI_SYLLABLE_JJIP = chr(42011)
YI_SYLLABLE_JJIET = chr(42012)
YI_SYLLABLE_JJIEX = chr(42013)
YI_SYLLABLE_JJIE = chr(42014)
YI_SYLLABLE_JJIEP = chr(42015)
YI_SYLLABLE_JJUOX = chr(42016)
YI_SYLLABLE_JJUO = chr(42017)
YI_SYLLABLE_JJUOP = chr(42018)
YI_SYLLABLE_JJOT = chr(42019)
YI_SYLLABLE_JJOX = chr(42020)
YI_SYLLABLE_JJO = chr(42021)
YI_SYLLABLE_JJOP = chr(42022)
YI_SYLLABLE_JJUT = chr(42023)
YI_SYLLABLE_JJUX = chr(42024)
YI_SYLLABLE_JJU = chr(42025)
YI_SYLLABLE_JJUP = chr(42026)
YI_SYLLABLE_JJURX = chr(42027)
YI_SYLLABLE_JJUR = chr(42028)
YI_SYLLABLE_JJYT = chr(42029)
YI_SYLLABLE_JJYX = chr(42030)
YI_SYLLABLE_JJY = chr(42031)
YI_SYLLABLE_JJYP = chr(42032)
YI_SYLLABLE_NJIT = chr(42033)
YI_SYLLABLE_NJIX = chr(42034)
YI_SYLLABLE_NJI = chr(42035)
YI_SYLLABLE_NJIP = chr(42036)
YI_SYLLABLE_NJIET = chr(42037)
YI_SYLLABLE_NJIEX = chr(42038)
YI_SYLLABLE_NJIE = chr(42039)
YI_SYLLABLE_NJIEP = chr(42040)
YI_SYLLABLE_NJUOX = chr(42041)
YI_SYLLABLE_NJUO = chr(42042)
YI_SYLLABLE_NJOT = chr(42043)
YI_SYLLABLE_NJOX = chr(42044)
YI_SYLLABLE_NJO = chr(42045)
YI_SYLLABLE_NJOP = chr(42046)
YI_SYLLABLE_NJUX = chr(42047)
YI_SYLLABLE_NJU = chr(42048)
YI_SYLLABLE_NJUP = chr(42049)
YI_SYLLABLE_NJURX = chr(42050)
YI_SYLLABLE_NJUR = chr(42051)
YI_SYLLABLE_NJYT = chr(42052)
YI_SYLLABLE_NJYX = chr(42053)
YI_SYLLABLE_NJY = chr(42054)
YI_SYLLABLE_NJYP = chr(42055)
YI_SYLLABLE_NJYRX = chr(42056)
YI_SYLLABLE_NJYR = chr(42057)
YI_SYLLABLE_NYIT = chr(42058)
YI_SYLLABLE_NYIX = chr(42059)
YI_SYLLABLE_NYI = chr(42060)
YI_SYLLABLE_NYIP = chr(42061)
YI_SYLLABLE_NYIET = chr(42062)
YI_SYLLABLE_NYIEX = chr(42063)
YI_SYLLABLE_NYIE = chr(42064)
YI_SYLLABLE_NYIEP = chr(42065)
YI_SYLLABLE_NYUOX = chr(42066)
YI_SYLLABLE_NYUO = chr(42067)
YI_SYLLABLE_NYUOP = chr(42068)
YI_SYLLABLE_NYOT = chr(42069)
YI_SYLLABLE_NYOX = chr(42070)
YI_SYLLABLE_NYO = chr(42071)
YI_SYLLABLE_NYOP = chr(42072)
YI_SYLLABLE_NYUT = chr(42073)
YI_SYLLABLE_NYUX = chr(42074)
YI_SYLLABLE_NYU = chr(42075)
YI_SYLLABLE_NYUP = chr(42076)
YI_SYLLABLE_XIT = chr(42077)
YI_SYLLABLE_XIX = chr(42078)
YI_SYLLABLE_XI = chr(42079)
YI_SYLLABLE_XIP = chr(42080)
YI_SYLLABLE_XIET = chr(42081)
YI_SYLLABLE_XIEX = chr(42082)
YI_SYLLABLE_XIE = chr(42083)
YI_SYLLABLE_XIEP = chr(42084)
YI_SYLLABLE_XUOX = chr(42085)
YI_SYLLABLE_XUO = chr(42086)
YI_SYLLABLE_XOT = chr(42087)
YI_SYLLABLE_XOX = chr(42088)
YI_SYLLABLE_XO = chr(42089)
YI_SYLLABLE_XOP = chr(42090)
YI_SYLLABLE_XYT = chr(42091)
YI_SYLLABLE_XYX = chr(42092)
YI_SYLLABLE_XY = chr(42093)
YI_SYLLABLE_XYP = chr(42094)
YI_SYLLABLE_XYRX = chr(42095)
YI_SYLLABLE_XYR = chr(42096)
YI_SYLLABLE_YIT = chr(42097)
YI_SYLLABLE_YIX = chr(42098)
YI_SYLLABLE_YI = chr(42099)
YI_SYLLABLE_YIP = chr(42100)
YI_SYLLABLE_YIET = chr(42101)
YI_SYLLABLE_YIEX = chr(42102)
YI_SYLLABLE_YIE = chr(42103)
YI_SYLLABLE_YIEP = chr(42104)
YI_SYLLABLE_YUOT = chr(42105)
YI_SYLLABLE_YUOX = chr(42106)
YI_SYLLABLE_YUO = chr(42107)
YI_SYLLABLE_YUOP = chr(42108)
YI_SYLLABLE_YOT = chr(42109)
YI_SYLLABLE_YOX = chr(42110)
YI_SYLLABLE_YO = chr(42111)
YI_SYLLABLE_YOP = chr(42112)
YI_SYLLABLE_YUT = chr(42113)
YI_SYLLABLE_YUX = chr(42114)
YI_SYLLABLE_YU = chr(42115)
YI_SYLLABLE_YUP = chr(42116)
YI_SYLLABLE_YURX = chr(42117)
YI_SYLLABLE_YUR = chr(42118)
YI_SYLLABLE_YYT = chr(42119)
YI_SYLLABLE_YYX = chr(42120)
YI_SYLLABLE_YY = chr(42121)
YI_SYLLABLE_YYP = chr(42122)
YI_SYLLABLE_YYRX = chr(42123)
YI_SYLLABLE_YYR = chr(42124)
YI_RADICAL_QOT = chr(42128)
YI_RADICAL_LI = chr(42129)
YI_RADICAL_KIT = chr(42130)
YI_RADICAL_NYIP = chr(42131)
YI_RADICAL_CYP = chr(42132)
YI_RADICAL_SSI = chr(42133)
YI_RADICAL_GGOP = chr(42134)
YI_RADICAL_GEP = chr(42135)
YI_RADICAL_MI = chr(42136)
YI_RADICAL_HXIT = chr(42137)
YI_RADICAL_LYR = chr(42138)
YI_RADICAL_BBUT = chr(42139)
YI_RADICAL_MOP = chr(42140)
YI_RADICAL_YO = chr(42141)
YI_RADICAL_PUT = chr(42142)
YI_RADICAL_HXUO = chr(42143)
YI_RADICAL_TAT = chr(42144)
YI_RADICAL_GA = chr(42145)
YI_RADICAL_ZUP = chr(42146)
YI_RADICAL_CYT = chr(42147)
YI_RADICAL_DDUR = chr(42148)
YI_RADICAL_BUR = chr(42149)
YI_RADICAL_GGUO = chr(42150)
YI_RADICAL_NYOP = chr(42151)
YI_RADICAL_TU = chr(42152)
YI_RADICAL_OP = chr(42153)
YI_RADICAL_JJUT = chr(42154)
YI_RADICAL_ZOT = chr(42155)
YI_RADICAL_PYT = chr(42156)
YI_RADICAL_HMO = chr(42157)
YI_RADICAL_YIT = chr(42158)
YI_RADICAL_VUR = chr(42159)
YI_RADICAL_SHY = chr(42160)
YI_RADICAL_VEP = chr(42161)
YI_RADICAL_ZA = chr(42162)
YI_RADICAL_JO = chr(42163)
YI_RADICAL_NZUP = chr(42164)
YI_RADICAL_JJY = chr(42165)
YI_RADICAL_GOT = chr(42166)
YI_RADICAL_JJIE = chr(42167)
YI_RADICAL_WO = chr(42168)
YI_RADICAL_DU = chr(42169)
YI_RADICAL_SHUR = chr(42170)
YI_RADICAL_LIE = chr(42171)
YI_RADICAL_CY = chr(42172)
YI_RADICAL_CUOP = chr(42173)
YI_RADICAL_CIP = chr(42174)
YI_RADICAL_HXOP = chr(42175)
YI_RADICAL_SHAT = chr(42176)
YI_RADICAL_ZUR = chr(42177)
YI_RADICAL_SHOP = chr(42178)
YI_RADICAL_CHE = chr(42179)
YI_RADICAL_ZZIET = chr(42180)
YI_RADICAL_NBIE = chr(42181)
YI_RADICAL_KE = chr(42182)
LISU_LETTER_BA = chr(42192)
LISU_LETTER_PA = chr(42193)
LISU_LETTER_PHA = chr(42194)
LISU_LETTER_DA = chr(42195)
LISU_LETTER_TA = chr(42196)
LISU_LETTER_THA = chr(42197)
LISU_LETTER_GA = chr(42198)
LISU_LETTER_KA = chr(42199)
LISU_LETTER_KHA = chr(42200)
LISU_LETTER_JA = chr(42201)
LISU_LETTER_CA = chr(42202)
LISU_LETTER_CHA = chr(42203)
LISU_LETTER_DZA = chr(42204)
LISU_LETTER_TSA = chr(42205)
LISU_LETTER_TSHA = chr(42206)
LISU_LETTER_MA = chr(42207)
LISU_LETTER_NA = chr(42208)
LISU_LETTER_LA = chr(42209)
LISU_LETTER_SA = chr(42210)
LISU_LETTER_ZHA = chr(42211)
LISU_LETTER_ZA = chr(42212)
LISU_LETTER_NGA = chr(42213)
LISU_LETTER_HA = chr(42214)
LISU_LETTER_XA = chr(42215)
LISU_LETTER_HHA = chr(42216)
LISU_LETTER_FA = chr(42217)
LISU_LETTER_WA = chr(42218)
LISU_LETTER_SHA = chr(42219)
LISU_LETTER_YA = chr(42220)
LISU_LETTER_GHA = chr(42221)
LISU_LETTER_A = chr(42222)
LISU_LETTER_AE = chr(42223)
LISU_LETTER_E = chr(42224)
LISU_LETTER_EU = chr(42225)
LISU_LETTER_I = chr(42226)
LISU_LETTER_O = chr(42227)
LISU_LETTER_U = chr(42228)
LISU_LETTER_UE = chr(42229)
LISU_LETTER_UH = chr(42230)
LISU_LETTER_OE = chr(42231)
LISU_LETTER_TONE_MYA_TI = chr(42232)
LISU_LETTER_TONE_NA_PO = chr(42233)
LISU_LETTER_TONE_MYA_CYA = chr(42234)
LISU_LETTER_TONE_MYA_BO = chr(42235)
LISU_LETTER_TONE_MYA_NA = chr(42236)
LISU_LETTER_TONE_MYA_JEU = chr(42237)
LISU_PUNCTUATION_COMMA = chr(42238)
LISU_PUNCTUATION_FULL_STOP = chr(42239)
VAI_SYLLABLE_EE = chr(42240)
VAI_SYLLABLE_EEN = chr(42241)
VAI_SYLLABLE_HEE = chr(42242)
VAI_SYLLABLE_WEE = chr(42243)
VAI_SYLLABLE_WEEN = chr(42244)
VAI_SYLLABLE_PEE = chr(42245)
VAI_SYLLABLE_BHEE = chr(42246)
VAI_SYLLABLE_BEE = chr(42247)
VAI_SYLLABLE_MBEE = chr(42248)
VAI_SYLLABLE_KPEE = chr(42249)
VAI_SYLLABLE_MGBEE = chr(42250)
VAI_SYLLABLE_GBEE = chr(42251)
VAI_SYLLABLE_FEE = chr(42252)
VAI_SYLLABLE_VEE = chr(42253)
VAI_SYLLABLE_TEE = chr(42254)
VAI_SYLLABLE_THEE = chr(42255)
VAI_SYLLABLE_DHEE = chr(42256)
VAI_SYLLABLE_DHHEE = chr(42257)
VAI_SYLLABLE_LEE = chr(42258)
VAI_SYLLABLE_REE = chr(42259)
VAI_SYLLABLE_DEE = chr(42260)
VAI_SYLLABLE_NDEE = chr(42261)
VAI_SYLLABLE_SEE = chr(42262)
VAI_SYLLABLE_SHEE = chr(42263)
VAI_SYLLABLE_ZEE = chr(42264)
VAI_SYLLABLE_ZHEE = chr(42265)
VAI_SYLLABLE_CEE = chr(42266)
VAI_SYLLABLE_JEE = chr(42267)
VAI_SYLLABLE_NJEE = chr(42268)
VAI_SYLLABLE_YEE = chr(42269)
VAI_SYLLABLE_KEE = chr(42270)
VAI_SYLLABLE_NGGEE = chr(42271)
VAI_SYLLABLE_GEE = chr(42272)
VAI_SYLLABLE_MEE = chr(42273)
VAI_SYLLABLE_NEE = chr(42274)
VAI_SYLLABLE_NYEE = chr(42275)
VAI_SYLLABLE_I = chr(42276)
VAI_SYLLABLE_IN = chr(42277)
VAI_SYLLABLE_HI = chr(42278)
VAI_SYLLABLE_HIN = chr(42279)
VAI_SYLLABLE_WI = chr(42280)
VAI_SYLLABLE_WIN = chr(42281)
VAI_SYLLABLE_PI = chr(42282)
VAI_SYLLABLE_BHI = chr(42283)
VAI_SYLLABLE_BI = chr(42284)
VAI_SYLLABLE_MBI = chr(42285)
VAI_SYLLABLE_KPI = chr(42286)
VAI_SYLLABLE_MGBI = chr(42287)
VAI_SYLLABLE_GBI = chr(42288)
VAI_SYLLABLE_FI = chr(42289)
VAI_SYLLABLE_VI = chr(42290)
VAI_SYLLABLE_TI = chr(42291)
VAI_SYLLABLE_THI = chr(42292)
VAI_SYLLABLE_DHI = chr(42293)
VAI_SYLLABLE_DHHI = chr(42294)
VAI_SYLLABLE_LI = chr(42295)
VAI_SYLLABLE_RI = chr(42296)
VAI_SYLLABLE_DI = chr(42297)
VAI_SYLLABLE_NDI = chr(42298)
VAI_SYLLABLE_SI = chr(42299)
VAI_SYLLABLE_SHI = chr(42300)
VAI_SYLLABLE_ZI = chr(42301)
VAI_SYLLABLE_ZHI = chr(42302)
VAI_SYLLABLE_CI = chr(42303)
VAI_SYLLABLE_JI = chr(42304)
VAI_SYLLABLE_NJI = chr(42305)
VAI_SYLLABLE_YI = chr(42306)
VAI_SYLLABLE_KI = chr(42307)
VAI_SYLLABLE_NGGI = chr(42308)
VAI_SYLLABLE_GI = chr(42309)
VAI_SYLLABLE_MI = chr(42310)
VAI_SYLLABLE_NI = chr(42311)
VAI_SYLLABLE_NYI = chr(42312)
VAI_SYLLABLE_A = chr(42313)
VAI_SYLLABLE_AN = chr(42314)
VAI_SYLLABLE_NGAN = chr(42315)
VAI_SYLLABLE_HA = chr(42316)
VAI_SYLLABLE_HAN = chr(42317)
VAI_SYLLABLE_WA = chr(42318)
VAI_SYLLABLE_WAN = chr(42319)
VAI_SYLLABLE_PA = chr(42320)
VAI_SYLLABLE_BHA = chr(42321)
VAI_SYLLABLE_BA = chr(42322)
VAI_SYLLABLE_MBA = chr(42323)
VAI_SYLLABLE_KPA = chr(42324)
VAI_SYLLABLE_KPAN = chr(42325)
VAI_SYLLABLE_MGBA = chr(42326)
VAI_SYLLABLE_GBA = chr(42327)
VAI_SYLLABLE_FA = chr(42328)
VAI_SYLLABLE_VA = chr(42329)
VAI_SYLLABLE_TA = chr(42330)
VAI_SYLLABLE_THA = chr(42331)
VAI_SYLLABLE_DHA = chr(42332)
VAI_SYLLABLE_DHHA = chr(42333)
VAI_SYLLABLE_LA = chr(42334)
VAI_SYLLABLE_RA = chr(42335)
VAI_SYLLABLE_DA = chr(42336)
VAI_SYLLABLE_NDA = chr(42337)
VAI_SYLLABLE_SA = chr(42338)
VAI_SYLLABLE_SHA = chr(42339)
VAI_SYLLABLE_ZA = chr(42340)
VAI_SYLLABLE_ZHA = chr(42341)
VAI_SYLLABLE_CA = chr(42342)
VAI_SYLLABLE_JA = chr(42343)
VAI_SYLLABLE_NJA = chr(42344)
VAI_SYLLABLE_YA = chr(42345)
VAI_SYLLABLE_KA = chr(42346)
VAI_SYLLABLE_KAN = chr(42347)
VAI_SYLLABLE_NGGA = chr(42348)
VAI_SYLLABLE_GA = chr(42349)
VAI_SYLLABLE_MA = chr(42350)
VAI_SYLLABLE_NA = chr(42351)
VAI_SYLLABLE_NYA = chr(42352)
VAI_SYLLABLE_OO = chr(42353)
VAI_SYLLABLE_OON = chr(42354)
VAI_SYLLABLE_HOO = chr(42355)
VAI_SYLLABLE_WOO = chr(42356)
VAI_SYLLABLE_WOON = chr(42357)
VAI_SYLLABLE_POO = chr(42358)
VAI_SYLLABLE_BHOO = chr(42359)
VAI_SYLLABLE_BOO = chr(42360)
VAI_SYLLABLE_MBOO = chr(42361)
VAI_SYLLABLE_KPOO = chr(42362)
VAI_SYLLABLE_MGBOO = chr(42363)
VAI_SYLLABLE_GBOO = chr(42364)
VAI_SYLLABLE_FOO = chr(42365)
VAI_SYLLABLE_VOO = chr(42366)
VAI_SYLLABLE_TOO = chr(42367)
VAI_SYLLABLE_THOO = chr(42368)
VAI_SYLLABLE_DHOO = chr(42369)
VAI_SYLLABLE_DHHOO = chr(42370)
VAI_SYLLABLE_LOO = chr(42371)
VAI_SYLLABLE_ROO = chr(42372)
VAI_SYLLABLE_DOO = chr(42373)
VAI_SYLLABLE_NDOO = chr(42374)
VAI_SYLLABLE_SOO = chr(42375)
VAI_SYLLABLE_SHOO = chr(42376)
VAI_SYLLABLE_ZOO = chr(42377)
VAI_SYLLABLE_ZHOO = chr(42378)
VAI_SYLLABLE_COO = chr(42379)
VAI_SYLLABLE_JOO = chr(42380)
VAI_SYLLABLE_NJOO = chr(42381)
VAI_SYLLABLE_YOO = chr(42382)
VAI_SYLLABLE_KOO = chr(42383)
VAI_SYLLABLE_NGGOO = chr(42384)
VAI_SYLLABLE_GOO = chr(42385)
VAI_SYLLABLE_MOO = chr(42386)
VAI_SYLLABLE_NOO = chr(42387)
VAI_SYLLABLE_NYOO = chr(42388)
VAI_SYLLABLE_U = chr(42389)
VAI_SYLLABLE_UN = chr(42390)
VAI_SYLLABLE_HU = chr(42391)
VAI_SYLLABLE_HUN = chr(42392)
VAI_SYLLABLE_WU = chr(42393)
VAI_SYLLABLE_WUN = chr(42394)
VAI_SYLLABLE_PU = chr(42395)
VAI_SYLLABLE_BHU = chr(42396)
VAI_SYLLABLE_BU = chr(42397)
VAI_SYLLABLE_MBU = chr(42398)
VAI_SYLLABLE_KPU = chr(42399)
VAI_SYLLABLE_MGBU = chr(42400)
VAI_SYLLABLE_GBU = chr(42401)
VAI_SYLLABLE_FU = chr(42402)
VAI_SYLLABLE_VU = chr(42403)
VAI_SYLLABLE_TU = chr(42404)
VAI_SYLLABLE_THU = chr(42405)
VAI_SYLLABLE_DHU = chr(42406)
VAI_SYLLABLE_DHHU = chr(42407)
VAI_SYLLABLE_LU = chr(42408)
VAI_SYLLABLE_RU = chr(42409)
VAI_SYLLABLE_DU = chr(42410)
VAI_SYLLABLE_NDU = chr(42411)
VAI_SYLLABLE_SU = chr(42412)
VAI_SYLLABLE_SHU = chr(42413)
VAI_SYLLABLE_ZU = chr(42414)
VAI_SYLLABLE_ZHU = chr(42415)
VAI_SYLLABLE_CU = chr(42416)
VAI_SYLLABLE_JU = chr(42417)
VAI_SYLLABLE_NJU = chr(42418)
VAI_SYLLABLE_YU = chr(42419)
VAI_SYLLABLE_KU = chr(42420)
VAI_SYLLABLE_NGGU = chr(42421)
VAI_SYLLABLE_GU = chr(42422)
VAI_SYLLABLE_MU = chr(42423)
VAI_SYLLABLE_NU = chr(42424)
VAI_SYLLABLE_NYU = chr(42425)
VAI_SYLLABLE_O = chr(42426)
VAI_SYLLABLE_ON = chr(42427)
VAI_SYLLABLE_NGON = chr(42428)
VAI_SYLLABLE_HO = chr(42429)
VAI_SYLLABLE_HON = chr(42430)
VAI_SYLLABLE_WO = chr(42431)
VAI_SYLLABLE_WON = chr(42432)
VAI_SYLLABLE_PO = chr(42433)
VAI_SYLLABLE_BHO = chr(42434)
VAI_SYLLABLE_BO = chr(42435)
VAI_SYLLABLE_MBO = chr(42436)
VAI_SYLLABLE_KPO = chr(42437)
VAI_SYLLABLE_MGBO = chr(42438)
VAI_SYLLABLE_GBO = chr(42439)
VAI_SYLLABLE_GBON = chr(42440)
VAI_SYLLABLE_FO = chr(42441)
VAI_SYLLABLE_VO = chr(42442)
VAI_SYLLABLE_TO = chr(42443)
VAI_SYLLABLE_THO = chr(42444)
VAI_SYLLABLE_DHO = chr(42445)
VAI_SYLLABLE_DHHO = chr(42446)
VAI_SYLLABLE_LO = chr(42447)
VAI_SYLLABLE_RO = chr(42448)
VAI_SYLLABLE_DO = chr(42449)
VAI_SYLLABLE_NDO = chr(42450)
VAI_SYLLABLE_SO = chr(42451)
VAI_SYLLABLE_SHO = chr(42452)
VAI_SYLLABLE_ZO = chr(42453)
VAI_SYLLABLE_ZHO = chr(42454)
VAI_SYLLABLE_CO = chr(42455)
VAI_SYLLABLE_JO = chr(42456)
VAI_SYLLABLE_NJO = chr(42457)
VAI_SYLLABLE_YO = chr(42458)
VAI_SYLLABLE_KO = chr(42459)
VAI_SYLLABLE_NGGO = chr(42460)
VAI_SYLLABLE_GO = chr(42461)
VAI_SYLLABLE_MO = chr(42462)
VAI_SYLLABLE_NO = chr(42463)
VAI_SYLLABLE_NYO = chr(42464)
VAI_SYLLABLE_E = chr(42465)
VAI_SYLLABLE_EN = chr(42466)
VAI_SYLLABLE_NGEN = chr(42467)
VAI_SYLLABLE_HE = chr(42468)
VAI_SYLLABLE_HEN = chr(42469)
VAI_SYLLABLE_WE = chr(42470)
VAI_SYLLABLE_WEN = chr(42471)
VAI_SYLLABLE_PE = chr(42472)
VAI_SYLLABLE_BHE = chr(42473)
VAI_SYLLABLE_BE = chr(42474)
VAI_SYLLABLE_MBE = chr(42475)
VAI_SYLLABLE_KPE = chr(42476)
VAI_SYLLABLE_KPEN = chr(42477)
VAI_SYLLABLE_MGBE = chr(42478)
VAI_SYLLABLE_GBE = chr(42479)
VAI_SYLLABLE_GBEN = chr(42480)
VAI_SYLLABLE_FE = chr(42481)
VAI_SYLLABLE_VE = chr(42482)
VAI_SYLLABLE_TE = chr(42483)
VAI_SYLLABLE_THE = chr(42484)
VAI_SYLLABLE_DHE = chr(42485)
VAI_SYLLABLE_DHHE = chr(42486)
VAI_SYLLABLE_LE = chr(42487)
VAI_SYLLABLE_RE = chr(42488)
VAI_SYLLABLE_DE = chr(42489)
VAI_SYLLABLE_NDE = chr(42490)
VAI_SYLLABLE_SE = chr(42491)
VAI_SYLLABLE_SHE = chr(42492)
VAI_SYLLABLE_ZE = chr(42493)
VAI_SYLLABLE_ZHE = chr(42494)
VAI_SYLLABLE_CE = chr(42495)
VAI_SYLLABLE_JE = chr(42496)
VAI_SYLLABLE_NJE = chr(42497)
VAI_SYLLABLE_YE = chr(42498)
VAI_SYLLABLE_KE = chr(42499)
VAI_SYLLABLE_NGGE = chr(42500)
VAI_SYLLABLE_NGGEN = chr(42501)
VAI_SYLLABLE_GE = chr(42502)
VAI_SYLLABLE_GEN = chr(42503)
VAI_SYLLABLE_ME = chr(42504)
VAI_SYLLABLE_NE = chr(42505)
VAI_SYLLABLE_NYE = chr(42506)
VAI_SYLLABLE_NG = chr(42507)
VAI_SYLLABLE_LENGTHENER = chr(42508)
VAI_COMMA = chr(42509)
VAI_FULL_STOP = chr(42510)
VAI_QUESTION_MARK = chr(42511)
VAI_SYLLABLE_NDOLE_FA = chr(42512)
VAI_SYLLABLE_NDOLE_KA = chr(42513)
VAI_SYLLABLE_NDOLE_SOO = chr(42514)
VAI_SYMBOL_FEENG = chr(42515)
VAI_SYMBOL_KEENG = chr(42516)
VAI_SYMBOL_TING = chr(42517)
VAI_SYMBOL_NII = chr(42518)
VAI_SYMBOL_BANG = chr(42519)
VAI_SYMBOL_FAA = chr(42520)
VAI_SYMBOL_TAA = chr(42521)
VAI_SYMBOL_DANG = chr(42522)
VAI_SYMBOL_DOONG = chr(42523)
VAI_SYMBOL_KUNG = chr(42524)
VAI_SYMBOL_TONG = chr(42525)
VAI_SYMBOL_DO_O = chr(42526)
VAI_SYMBOL_JONG = chr(42527)
VAI_DIGIT_ZERO = chr(42528)
VAI_DIGIT_ONE = chr(42529)
VAI_DIGIT_TWO = chr(42530)
VAI_DIGIT_THREE = chr(42531)
VAI_DIGIT_FOUR = chr(42532)
VAI_DIGIT_FIVE = chr(42533)
VAI_DIGIT_SIX = chr(42534)
VAI_DIGIT_SEVEN = chr(42535)
VAI_DIGIT_EIGHT = chr(42536)
VAI_DIGIT_NINE = chr(42537)
VAI_SYLLABLE_NDOLE_MA = chr(42538)
VAI_SYLLABLE_NDOLE_DO = chr(42539)
CYRILLIC_CAPITAL_LETTER_ZEMLYA = chr(42560)
CYRILLIC_SMALL_LETTER_ZEMLYA = chr(42561)
CYRILLIC_CAPITAL_LETTER_DZELO = chr(42562)
CYRILLIC_SMALL_LETTER_DZELO = chr(42563)
CYRILLIC_CAPITAL_LETTER_REVERSED_DZE = chr(42564)
CYRILLIC_SMALL_LETTER_REVERSED_DZE = chr(42565)
CYRILLIC_CAPITAL_LETTER_IOTA = chr(42566)
CYRILLIC_SMALL_LETTER_IOTA = chr(42567)
CYRILLIC_CAPITAL_LETTER_DJERV = chr(42568)
CYRILLIC_SMALL_LETTER_DJERV = chr(42569)
CYRILLIC_CAPITAL_LETTER_MONOGRAPH_UK = chr(42570)
CYRILLIC_SMALL_LETTER_MONOGRAPH_UK = chr(42571)
CYRILLIC_CAPITAL_LETTER_BROAD_OMEGA = chr(42572)
CYRILLIC_SMALL_LETTER_BROAD_OMEGA = chr(42573)
CYRILLIC_CAPITAL_LETTER_NEUTRAL_YER = chr(42574)
CYRILLIC_SMALL_LETTER_NEUTRAL_YER = chr(42575)
CYRILLIC_CAPITAL_LETTER_YERU_WITH_BACK_YER = chr(42576)
CYRILLIC_SMALL_LETTER_YERU_WITH_BACK_YER = chr(42577)
CYRILLIC_CAPITAL_LETTER_IOTIFIED_YAT = chr(42578)
CYRILLIC_SMALL_LETTER_IOTIFIED_YAT = chr(42579)
CYRILLIC_CAPITAL_LETTER_REVERSED_YU = chr(42580)
CYRILLIC_SMALL_LETTER_REVERSED_YU = chr(42581)
CYRILLIC_CAPITAL_LETTER_IOTIFIED_A = chr(42582)
CYRILLIC_SMALL_LETTER_IOTIFIED_A = chr(42583)
CYRILLIC_CAPITAL_LETTER_CLOSED_LITTLE_YUS = chr(42584)
CYRILLIC_SMALL_LETTER_CLOSED_LITTLE_YUS = chr(42585)
CYRILLIC_CAPITAL_LETTER_BLENDED_YUS = chr(42586)
CYRILLIC_SMALL_LETTER_BLENDED_YUS = chr(42587)
CYRILLIC_CAPITAL_LETTER_IOTIFIED_CLOSED_LITTLE_YUS = chr(42588)
CYRILLIC_SMALL_LETTER_IOTIFIED_CLOSED_LITTLE_YUS = chr(42589)
CYRILLIC_CAPITAL_LETTER_YN = chr(42590)
CYRILLIC_SMALL_LETTER_YN = chr(42591)
CYRILLIC_CAPITAL_LETTER_REVERSED_TSE = chr(42592)
CYRILLIC_SMALL_LETTER_REVERSED_TSE = chr(42593)
CYRILLIC_CAPITAL_LETTER_SOFT_DE = chr(42594)
CYRILLIC_SMALL_LETTER_SOFT_DE = chr(42595)
CYRILLIC_CAPITAL_LETTER_SOFT_EL = chr(42596)
CYRILLIC_SMALL_LETTER_SOFT_EL = chr(42597)
CYRILLIC_CAPITAL_LETTER_SOFT_EM = chr(42598)
CYRILLIC_SMALL_LETTER_SOFT_EM = chr(42599)
CYRILLIC_CAPITAL_LETTER_MONOCULAR_O = chr(42600)
CYRILLIC_SMALL_LETTER_MONOCULAR_O = chr(42601)
CYRILLIC_CAPITAL_LETTER_BINOCULAR_O = chr(42602)
CYRILLIC_SMALL_LETTER_BINOCULAR_O = chr(42603)
CYRILLIC_CAPITAL_LETTER_DOUBLE_MONOCULAR_O = chr(42604)
CYRILLIC_SMALL_LETTER_DOUBLE_MONOCULAR_O = chr(42605)
CYRILLIC_LETTER_MULTIOCULAR_O = chr(42606)
COMBINING_CYRILLIC_VZMET = chr(42607)
COMBINING_CYRILLIC_TEN_MILLIONS_SIGN = chr(42608)
COMBINING_CYRILLIC_HUNDRED_MILLIONS_SIGN = chr(42609)
COMBINING_CYRILLIC_THOUSAND_MILLIONS_SIGN = chr(42610)
SLAVONIC_ASTERISK = chr(42611)
COMBINING_CYRILLIC_LETTER_UKRAINIAN_IE = chr(42612)
COMBINING_CYRILLIC_LETTER_I = chr(42613)
COMBINING_CYRILLIC_LETTER_YI = chr(42614)
COMBINING_CYRILLIC_LETTER_U = chr(42615)
COMBINING_CYRILLIC_LETTER_HARD_SIGN = chr(42616)
COMBINING_CYRILLIC_LETTER_YERU = chr(42617)
COMBINING_CYRILLIC_LETTER_SOFT_SIGN = chr(42618)
COMBINING_CYRILLIC_LETTER_OMEGA = chr(42619)
COMBINING_CYRILLIC_KAVYKA = chr(42620)
COMBINING_CYRILLIC_PAYEROK = chr(42621)
CYRILLIC_KAVYKA = chr(42622)
CYRILLIC_PAYEROK = chr(42623)
CYRILLIC_CAPITAL_LETTER_DWE = chr(42624)
CYRILLIC_SMALL_LETTER_DWE = chr(42625)
CYRILLIC_CAPITAL_LETTER_DZWE = chr(42626)
CYRILLIC_SMALL_LETTER_DZWE = chr(42627)
CYRILLIC_CAPITAL_LETTER_ZHWE = chr(42628)
CYRILLIC_SMALL_LETTER_ZHWE = chr(42629)
CYRILLIC_CAPITAL_LETTER_CCHE = chr(42630)
CYRILLIC_SMALL_LETTER_CCHE = chr(42631)
CYRILLIC_CAPITAL_LETTER_DZZE = chr(42632)
CYRILLIC_SMALL_LETTER_DZZE = chr(42633)
CYRILLIC_CAPITAL_LETTER_TE_WITH_MIDDLE_HOOK = chr(42634)
CYRILLIC_SMALL_LETTER_TE_WITH_MIDDLE_HOOK = chr(42635)
CYRILLIC_CAPITAL_LETTER_TWE = chr(42636)
CYRILLIC_SMALL_LETTER_TWE = chr(42637)
CYRILLIC_CAPITAL_LETTER_TSWE = chr(42638)
CYRILLIC_SMALL_LETTER_TSWE = chr(42639)
CYRILLIC_CAPITAL_LETTER_TSSE = chr(42640)
CYRILLIC_SMALL_LETTER_TSSE = chr(42641)
CYRILLIC_CAPITAL_LETTER_TCHE = chr(42642)
CYRILLIC_SMALL_LETTER_TCHE = chr(42643)
CYRILLIC_CAPITAL_LETTER_HWE = chr(42644)
CYRILLIC_SMALL_LETTER_HWE = chr(42645)
CYRILLIC_CAPITAL_LETTER_SHWE = chr(42646)
CYRILLIC_SMALL_LETTER_SHWE = chr(42647)
CYRILLIC_CAPITAL_LETTER_DOUBLE_O = chr(42648)
CYRILLIC_SMALL_LETTER_DOUBLE_O = chr(42649)
CYRILLIC_CAPITAL_LETTER_CROSSED_O = chr(42650)
CYRILLIC_SMALL_LETTER_CROSSED_O = chr(42651)
MODIFIER_LETTER_CYRILLIC_HARD_SIGN = chr(42652)
MODIFIER_LETTER_CYRILLIC_SOFT_SIGN = chr(42653)
COMBINING_CYRILLIC_LETTER_EF = chr(42654)
COMBINING_CYRILLIC_LETTER_IOTIFIED_E = chr(42655)
BAMUM_LETTER_A = chr(42656)
BAMUM_LETTER_KA = chr(42657)
BAMUM_LETTER_U = chr(42658)
BAMUM_LETTER_KU = chr(42659)
BAMUM_LETTER_EE = chr(42660)
BAMUM_LETTER_REE = chr(42661)
BAMUM_LETTER_TAE = chr(42662)
BAMUM_LETTER_O = chr(42663)
BAMUM_LETTER_NYI = chr(42664)
BAMUM_LETTER_I = chr(42665)
BAMUM_LETTER_LA = chr(42666)
BAMUM_LETTER_PA = chr(42667)
BAMUM_LETTER_RII = chr(42668)
BAMUM_LETTER_RIEE = chr(42669)
BAMUM_LETTER_LEEEE = chr(42670)
BAMUM_LETTER_MEEEE = chr(42671)
BAMUM_LETTER_TAA = chr(42672)
BAMUM_LETTER_NDAA = chr(42673)
BAMUM_LETTER_NJAEM = chr(42674)
BAMUM_LETTER_M = chr(42675)
BAMUM_LETTER_SUU = chr(42676)
BAMUM_LETTER_MU = chr(42677)
BAMUM_LETTER_SHII = chr(42678)
BAMUM_LETTER_SI = chr(42679)
BAMUM_LETTER_SHEUX = chr(42680)
BAMUM_LETTER_SEUX = chr(42681)
BAMUM_LETTER_KYEE = chr(42682)
BAMUM_LETTER_KET = chr(42683)
BAMUM_LETTER_NUAE = chr(42684)
BAMUM_LETTER_NU = chr(42685)
BAMUM_LETTER_NJUAE = chr(42686)
BAMUM_LETTER_YOQ = chr(42687)
BAMUM_LETTER_SHU = chr(42688)
BAMUM_LETTER_YUQ = chr(42689)
BAMUM_LETTER_YA = chr(42690)
BAMUM_LETTER_NSHA = chr(42691)
BAMUM_LETTER_KEUX = chr(42692)
BAMUM_LETTER_PEUX = chr(42693)
BAMUM_LETTER_NJEE = chr(42694)
BAMUM_LETTER_NTEE = chr(42695)
BAMUM_LETTER_PUE = chr(42696)
BAMUM_LETTER_WUE = chr(42697)
BAMUM_LETTER_PEE = chr(42698)
BAMUM_LETTER_FEE = chr(42699)
BAMUM_LETTER_RU = chr(42700)
BAMUM_LETTER_LU = chr(42701)
BAMUM_LETTER_MI = chr(42702)
BAMUM_LETTER_NI = chr(42703)
BAMUM_LETTER_REUX = chr(42704)
BAMUM_LETTER_RAE = chr(42705)
BAMUM_LETTER_KEN = chr(42706)
BAMUM_LETTER_NGKWAEN = chr(42707)
BAMUM_LETTER_NGGA = chr(42708)
BAMUM_LETTER_NGA = chr(42709)
BAMUM_LETTER_SHO = chr(42710)
BAMUM_LETTER_PUAE = chr(42711)
BAMUM_LETTER_FU = chr(42712)
BAMUM_LETTER_FOM = chr(42713)
BAMUM_LETTER_WA = chr(42714)
BAMUM_LETTER_NA = chr(42715)
BAMUM_LETTER_LI = chr(42716)
BAMUM_LETTER_PI = chr(42717)
BAMUM_LETTER_LOQ = chr(42718)
BAMUM_LETTER_KO = chr(42719)
BAMUM_LETTER_MBEN = chr(42720)
BAMUM_LETTER_REN = chr(42721)
BAMUM_LETTER_MEN = chr(42722)
BAMUM_LETTER_MA = chr(42723)
BAMUM_LETTER_TI = chr(42724)
BAMUM_LETTER_KI = chr(42725)
BAMUM_LETTER_MO = chr(42726)
BAMUM_LETTER_MBAA = chr(42727)
BAMUM_LETTER_TET = chr(42728)
BAMUM_LETTER_KPA = chr(42729)
BAMUM_LETTER_TEN = chr(42730)
BAMUM_LETTER_NTUU = chr(42731)
BAMUM_LETTER_SAMBA = chr(42732)
BAMUM_LETTER_FAAMAE = chr(42733)
BAMUM_LETTER_KOVUU = chr(42734)
BAMUM_LETTER_KOGHOM = chr(42735)
BAMUM_COMBINING_MARK_KOQNDON = chr(42736)
BAMUM_COMBINING_MARK_TUKWENTIS = chr(42737)
BAMUM_NJAEMLI = chr(42738)
BAMUM_FULL_STOP = chr(42739)
BAMUM_COLON = chr(42740)
BAMUM_COMMA = chr(42741)
BAMUM_SEMICOLON = chr(42742)
BAMUM_QUESTION_MARK = chr(42743)
MODIFIER_LETTER_CHINESE_TONE_YIN_PING = chr(42752)
MODIFIER_LETTER_CHINESE_TONE_YANG_PING = chr(42753)
MODIFIER_LETTER_CHINESE_TONE_YIN_SHANG = chr(42754)
MODIFIER_LETTER_CHINESE_TONE_YANG_SHANG = chr(42755)
MODIFIER_LETTER_CHINESE_TONE_YIN_QU = chr(42756)
MODIFIER_LETTER_CHINESE_TONE_YANG_QU = chr(42757)
MODIFIER_LETTER_CHINESE_TONE_YIN_RU = chr(42758)
MODIFIER_LETTER_CHINESE_TONE_YANG_RU = chr(42759)
MODIFIER_LETTER_EXTRA_HIGH_DOTTED_TONE_BAR = chr(42760)
MODIFIER_LETTER_HIGH_DOTTED_TONE_BAR = chr(42761)
MODIFIER_LETTER_MID_DOTTED_TONE_BAR = chr(42762)
MODIFIER_LETTER_LOW_DOTTED_TONE_BAR = chr(42763)
MODIFIER_LETTER_EXTRA_LOW_DOTTED_TONE_BAR = chr(42764)
MODIFIER_LETTER_EXTRA_HIGH_DOTTED_LEFT_STEM_TONE_BAR = chr(42765)
MODIFIER_LETTER_HIGH_DOTTED_LEFT_STEM_TONE_BAR = chr(42766)
MODIFIER_LETTER_MID_DOTTED_LEFT_STEM_TONE_BAR = chr(42767)
MODIFIER_LETTER_LOW_DOTTED_LEFT_STEM_TONE_BAR = chr(42768)
MODIFIER_LETTER_EXTRA_LOW_DOTTED_LEFT_STEM_TONE_BAR = chr(42769)
MODIFIER_LETTER_EXTRA_HIGH_LEFT_STEM_TONE_BAR = chr(42770)
MODIFIER_LETTER_HIGH_LEFT_STEM_TONE_BAR = chr(42771)
MODIFIER_LETTER_MID_LEFT_STEM_TONE_BAR = chr(42772)
MODIFIER_LETTER_LOW_LEFT_STEM_TONE_BAR = chr(42773)
MODIFIER_LETTER_EXTRA_LOW_LEFT_STEM_TONE_BAR = chr(42774)
MODIFIER_LETTER_DOT_VERTICAL_BAR = chr(42775)
MODIFIER_LETTER_DOT_SLASH = chr(42776)
MODIFIER_LETTER_DOT_HORIZONTAL_BAR = chr(42777)
MODIFIER_LETTER_LOWER_RIGHT_CORNER_ANGLE = chr(42778)
MODIFIER_LETTER_RAISED_UP_ARROW = chr(42779)
MODIFIER_LETTER_RAISED_DOWN_ARROW = chr(42780)
MODIFIER_LETTER_RAISED_EXCLAMATION_MARK = chr(42781)
MODIFIER_LETTER_RAISED_INVERTED_EXCLAMATION_MARK = chr(42782)
MODIFIER_LETTER_LOW_INVERTED_EXCLAMATION_MARK = chr(42783)
MODIFIER_LETTER_STRESS_AND_HIGH_TONE = chr(42784)
MODIFIER_LETTER_STRESS_AND_LOW_TONE = chr(42785)
LATIN_CAPITAL_LETTER_EGYPTOLOGICAL_ALEF = chr(42786)
LATIN_SMALL_LETTER_EGYPTOLOGICAL_ALEF = chr(42787)
LATIN_CAPITAL_LETTER_EGYPTOLOGICAL_AIN = chr(42788)
LATIN_SMALL_LETTER_EGYPTOLOGICAL_AIN = chr(42789)
LATIN_CAPITAL_LETTER_HENG = chr(42790)
LATIN_SMALL_LETTER_HENG = chr(42791)
LATIN_CAPITAL_LETTER_TZ = chr(42792)
LATIN_SMALL_LETTER_TZ = chr(42793)
LATIN_CAPITAL_LETTER_TRESILLO = chr(42794)
LATIN_SMALL_LETTER_TRESILLO = chr(42795)
LATIN_CAPITAL_LETTER_CUATRILLO = chr(42796)
LATIN_SMALL_LETTER_CUATRILLO = chr(42797)
LATIN_CAPITAL_LETTER_CUATRILLO_WITH_COMMA = chr(42798)
LATIN_SMALL_LETTER_CUATRILLO_WITH_COMMA = chr(42799)
LATIN_LETTER_SMALL_CAPITAL_F = chr(42800)
LATIN_LETTER_SMALL_CAPITAL_S = chr(42801)
LATIN_CAPITAL_LETTER_AA = chr(42802)
LATIN_SMALL_LETTER_AA = chr(42803)
LATIN_CAPITAL_LETTER_AO = chr(42804)
LATIN_SMALL_LETTER_AO = chr(42805)
LATIN_CAPITAL_LETTER_AU = chr(42806)
LATIN_SMALL_LETTER_AU = chr(42807)
LATIN_CAPITAL_LETTER_AV = chr(42808)
LATIN_SMALL_LETTER_AV = chr(42809)
LATIN_CAPITAL_LETTER_AV_WITH_HORIZONTAL_BAR = chr(42810)
LATIN_SMALL_LETTER_AV_WITH_HORIZONTAL_BAR = chr(42811)
LATIN_CAPITAL_LETTER_AY = chr(42812)
LATIN_SMALL_LETTER_AY = chr(42813)
LATIN_CAPITAL_LETTER_REVERSED_C_WITH_DOT = chr(42814)
LATIN_SMALL_LETTER_REVERSED_C_WITH_DOT = chr(42815)
LATIN_CAPITAL_LETTER_K_WITH_STROKE = chr(42816)
LATIN_SMALL_LETTER_K_WITH_STROKE = chr(42817)
LATIN_CAPITAL_LETTER_K_WITH_DIAGONAL_STROKE = chr(42818)
LATIN_SMALL_LETTER_K_WITH_DIAGONAL_STROKE = chr(42819)
LATIN_CAPITAL_LETTER_K_WITH_STROKE_AND_DIAGONAL_STROKE = chr(42820)
LATIN_SMALL_LETTER_K_WITH_STROKE_AND_DIAGONAL_STROKE = chr(42821)
LATIN_CAPITAL_LETTER_BROKEN_L = chr(42822)
LATIN_SMALL_LETTER_BROKEN_L = chr(42823)
LATIN_CAPITAL_LETTER_L_WITH_HIGH_STROKE = chr(42824)
LATIN_SMALL_LETTER_L_WITH_HIGH_STROKE = chr(42825)
LATIN_CAPITAL_LETTER_O_WITH_LONG_STROKE_OVERLAY = chr(42826)
LATIN_SMALL_LETTER_O_WITH_LONG_STROKE_OVERLAY = chr(42827)
LATIN_CAPITAL_LETTER_O_WITH_LOOP = chr(42828)
LATIN_SMALL_LETTER_O_WITH_LOOP = chr(42829)
LATIN_CAPITAL_LETTER_OO = chr(42830)
LATIN_SMALL_LETTER_OO = chr(42831)
LATIN_CAPITAL_LETTER_P_WITH_STROKE_THROUGH_DESCENDER = chr(42832)
LATIN_SMALL_LETTER_P_WITH_STROKE_THROUGH_DESCENDER = chr(42833)
LATIN_CAPITAL_LETTER_P_WITH_FLOURISH = chr(42834)
LATIN_SMALL_LETTER_P_WITH_FLOURISH = chr(42835)
LATIN_CAPITAL_LETTER_P_WITH_SQUIRREL_TAIL = chr(42836)
LATIN_SMALL_LETTER_P_WITH_SQUIRREL_TAIL = chr(42837)
LATIN_CAPITAL_LETTER_Q_WITH_STROKE_THROUGH_DESCENDER = chr(42838)
LATIN_SMALL_LETTER_Q_WITH_STROKE_THROUGH_DESCENDER = chr(42839)
LATIN_CAPITAL_LETTER_Q_WITH_DIAGONAL_STROKE = chr(42840)
LATIN_SMALL_LETTER_Q_WITH_DIAGONAL_STROKE = chr(42841)
LATIN_CAPITAL_LETTER_R_ROTUNDA = chr(42842)
LATIN_SMALL_LETTER_R_ROTUNDA = chr(42843)
LATIN_CAPITAL_LETTER_RUM_ROTUNDA = chr(42844)
LATIN_SMALL_LETTER_RUM_ROTUNDA = chr(42845)
LATIN_CAPITAL_LETTER_V_WITH_DIAGONAL_STROKE = chr(42846)
LATIN_SMALL_LETTER_V_WITH_DIAGONAL_STROKE = chr(42847)
LATIN_CAPITAL_LETTER_VY = chr(42848)
LATIN_SMALL_LETTER_VY = chr(42849)
LATIN_CAPITAL_LETTER_VISIGOTHIC_Z = chr(42850)
LATIN_SMALL_LETTER_VISIGOTHIC_Z = chr(42851)
LATIN_CAPITAL_LETTER_THORN_WITH_STROKE = chr(42852)
LATIN_SMALL_LETTER_THORN_WITH_STROKE = chr(42853)
LATIN_CAPITAL_LETTER_THORN_WITH_STROKE_THROUGH_DESCENDER = chr(42854)
LATIN_SMALL_LETTER_THORN_WITH_STROKE_THROUGH_DESCENDER = chr(42855)
LATIN_CAPITAL_LETTER_VEND = chr(42856)
LATIN_SMALL_LETTER_VEND = chr(42857)
LATIN_CAPITAL_LETTER_ET = chr(42858)
LATIN_SMALL_LETTER_ET = chr(42859)
LATIN_CAPITAL_LETTER_IS = chr(42860)
LATIN_SMALL_LETTER_IS = chr(42861)
LATIN_CAPITAL_LETTER_CON = chr(42862)
LATIN_SMALL_LETTER_CON = chr(42863)
MODIFIER_LETTER_US = chr(42864)
LATIN_SMALL_LETTER_DUM = chr(42865)
LATIN_SMALL_LETTER_LUM = chr(42866)
LATIN_SMALL_LETTER_MUM = chr(42867)
LATIN_SMALL_LETTER_NUM = chr(42868)
LATIN_SMALL_LETTER_RUM = chr(42869)
LATIN_LETTER_SMALL_CAPITAL_RUM = chr(42870)
LATIN_SMALL_LETTER_TUM = chr(42871)
LATIN_SMALL_LETTER_UM = chr(42872)
LATIN_CAPITAL_LETTER_INSULAR_D = chr(42873)
LATIN_SMALL_LETTER_INSULAR_D = chr(42874)
LATIN_CAPITAL_LETTER_INSULAR_F = chr(42875)
LATIN_SMALL_LETTER_INSULAR_F = chr(42876)
LATIN_CAPITAL_LETTER_INSULAR_G = chr(42877)
LATIN_CAPITAL_LETTER_TURNED_INSULAR_G = chr(42878)
LATIN_SMALL_LETTER_TURNED_INSULAR_G = chr(42879)
LATIN_CAPITAL_LETTER_TURNED_L = chr(42880)
LATIN_SMALL_LETTER_TURNED_L = chr(42881)
LATIN_CAPITAL_LETTER_INSULAR_R = chr(42882)
LATIN_SMALL_LETTER_INSULAR_R = chr(42883)
LATIN_CAPITAL_LETTER_INSULAR_S = chr(42884)
LATIN_SMALL_LETTER_INSULAR_S = chr(42885)
LATIN_CAPITAL_LETTER_INSULAR_T = chr(42886)
LATIN_SMALL_LETTER_INSULAR_T = chr(42887)
MODIFIER_LETTER_LOW_CIRCUMFLEX_ACCENT = chr(42888)
MODIFIER_LETTER_COLON = chr(42889)
MODIFIER_LETTER_SHORT_EQUALS_SIGN = chr(42890)
LATIN_CAPITAL_LETTER_SALTILLO = chr(42891)
LATIN_SMALL_LETTER_SALTILLO = chr(42892)
LATIN_CAPITAL_LETTER_TURNED_H = chr(42893)
LATIN_SMALL_LETTER_L_WITH_RETROFLEX_HOOK_AND_BELT = chr(42894)
LATIN_LETTER_SINOLOGICAL_DOT = chr(42895)
LATIN_CAPITAL_LETTER_N_WITH_DESCENDER = chr(42896)
LATIN_SMALL_LETTER_N_WITH_DESCENDER = chr(42897)
LATIN_CAPITAL_LETTER_C_WITH_BAR = chr(42898)
LATIN_SMALL_LETTER_C_WITH_BAR = chr(42899)
LATIN_SMALL_LETTER_C_WITH_PALATAL_HOOK = chr(42900)
LATIN_SMALL_LETTER_H_WITH_PALATAL_HOOK = chr(42901)
LATIN_CAPITAL_LETTER_B_WITH_FLOURISH = chr(42902)
LATIN_SMALL_LETTER_B_WITH_FLOURISH = chr(42903)
LATIN_CAPITAL_LETTER_F_WITH_STROKE = chr(42904)
LATIN_SMALL_LETTER_F_WITH_STROKE = chr(42905)
LATIN_CAPITAL_LETTER_VOLAPUK_AE = chr(42906)
LATIN_SMALL_LETTER_VOLAPUK_AE = chr(42907)
LATIN_CAPITAL_LETTER_VOLAPUK_OE = chr(42908)
LATIN_SMALL_LETTER_VOLAPUK_OE = chr(42909)
LATIN_CAPITAL_LETTER_VOLAPUK_UE = chr(42910)
LATIN_SMALL_LETTER_VOLAPUK_UE = chr(42911)
LATIN_CAPITAL_LETTER_G_WITH_OBLIQUE_STROKE = chr(42912)
LATIN_SMALL_LETTER_G_WITH_OBLIQUE_STROKE = chr(42913)
LATIN_CAPITAL_LETTER_K_WITH_OBLIQUE_STROKE = chr(42914)
LATIN_SMALL_LETTER_K_WITH_OBLIQUE_STROKE = chr(42915)
LATIN_CAPITAL_LETTER_N_WITH_OBLIQUE_STROKE = chr(42916)
LATIN_SMALL_LETTER_N_WITH_OBLIQUE_STROKE = chr(42917)
LATIN_CAPITAL_LETTER_R_WITH_OBLIQUE_STROKE = chr(42918)
LATIN_SMALL_LETTER_R_WITH_OBLIQUE_STROKE = chr(42919)
LATIN_CAPITAL_LETTER_S_WITH_OBLIQUE_STROKE = chr(42920)
LATIN_SMALL_LETTER_S_WITH_OBLIQUE_STROKE = chr(42921)
LATIN_CAPITAL_LETTER_H_WITH_HOOK = chr(42922)
LATIN_CAPITAL_LETTER_REVERSED_OPEN_E = chr(42923)
LATIN_CAPITAL_LETTER_SCRIPT_G = chr(42924)
LATIN_CAPITAL_LETTER_L_WITH_BELT = chr(42925)
LATIN_CAPITAL_LETTER_SMALL_CAPITAL_I = chr(42926)
LATIN_LETTER_SMALL_CAPITAL_Q = chr(42927)
LATIN_CAPITAL_LETTER_TURNED_K = chr(42928)
LATIN_CAPITAL_LETTER_TURNED_T = chr(42929)
LATIN_CAPITAL_LETTER_J_WITH_CROSSED_TAIL = chr(42930)
LATIN_CAPITAL_LETTER_CHI = chr(42931)
LATIN_CAPITAL_LETTER_BETA = chr(42932)
LATIN_SMALL_LETTER_BETA = chr(42933)
LATIN_CAPITAL_LETTER_OMEGA = chr(42934)
LATIN_SMALL_LETTER_OMEGA = chr(42935)
LATIN_CAPITAL_LETTER_U_WITH_STROKE = chr(42936)
LATIN_SMALL_LETTER_U_WITH_STROKE = chr(42937)
LATIN_CAPITAL_LETTER_GLOTTAL_A = chr(42938)
LATIN_SMALL_LETTER_GLOTTAL_A = chr(42939)
LATIN_CAPITAL_LETTER_GLOTTAL_I = chr(42940)
LATIN_SMALL_LETTER_GLOTTAL_I = chr(42941)
LATIN_CAPITAL_LETTER_GLOTTAL_U = chr(42942)
LATIN_SMALL_LETTER_GLOTTAL_U = chr(42943)
LATIN_CAPITAL_LETTER_OLD_POLISH_O = chr(42944)
LATIN_SMALL_LETTER_OLD_POLISH_O = chr(42945)
LATIN_CAPITAL_LETTER_ANGLICANA_W = chr(42946)
LATIN_SMALL_LETTER_ANGLICANA_W = chr(42947)
LATIN_CAPITAL_LETTER_C_WITH_PALATAL_HOOK = chr(42948)
LATIN_CAPITAL_LETTER_S_WITH_HOOK = chr(42949)
LATIN_CAPITAL_LETTER_Z_WITH_PALATAL_HOOK = chr(42950)
LATIN_CAPITAL_LETTER_D_WITH_SHORT_STROKE_OVERLAY = chr(42951)
LATIN_SMALL_LETTER_D_WITH_SHORT_STROKE_OVERLAY = chr(42952)
LATIN_CAPITAL_LETTER_S_WITH_SHORT_STROKE_OVERLAY = chr(42953)
LATIN_SMALL_LETTER_S_WITH_SHORT_STROKE_OVERLAY = chr(42954)
LATIN_CAPITAL_LETTER_CLOSED_INSULAR_G = chr(42960)
LATIN_SMALL_LETTER_CLOSED_INSULAR_G = chr(42961)
LATIN_SMALL_LETTER_DOUBLE_THORN = chr(42963)
LATIN_SMALL_LETTER_DOUBLE_WYNN = chr(42965)
LATIN_CAPITAL_LETTER_MIDDLE_SCOTS_S = chr(42966)
LATIN_SMALL_LETTER_MIDDLE_SCOTS_S = chr(42967)
LATIN_CAPITAL_LETTER_SIGMOID_S = chr(42968)
LATIN_SMALL_LETTER_SIGMOID_S = chr(42969)
MODIFIER_LETTER_CAPITAL_C = chr(42994)
MODIFIER_LETTER_CAPITAL_F = chr(42995)
MODIFIER_LETTER_CAPITAL_Q = chr(42996)
LATIN_CAPITAL_LETTER_REVERSED_HALF_H = chr(42997)
LATIN_SMALL_LETTER_REVERSED_HALF_H = chr(42998)
LATIN_EPIGRAPHIC_LETTER_SIDEWAYS_I = chr(42999)
MODIFIER_LETTER_CAPITAL_H_WITH_STROKE = chr(43000)
MODIFIER_LETTER_SMALL_LIGATURE_OE = chr(43001)
LATIN_LETTER_SMALL_CAPITAL_TURNED_M = chr(43002)
LATIN_EPIGRAPHIC_LETTER_REVERSED_F = chr(43003)
LATIN_EPIGRAPHIC_LETTER_REVERSED_P = chr(43004)
LATIN_EPIGRAPHIC_LETTER_INVERTED_M = chr(43005)
LATIN_EPIGRAPHIC_LETTER_I_LONGA = chr(43006)
LATIN_EPIGRAPHIC_LETTER_ARCHAIC_M = chr(43007)
SYLOTI_NAGRI_LETTER_A = chr(43008)
SYLOTI_NAGRI_LETTER_I = chr(43009)
SYLOTI_NAGRI_SIGN_DVISVARA = chr(43010)
SYLOTI_NAGRI_LETTER_U = chr(43011)
SYLOTI_NAGRI_LETTER_E = chr(43012)
SYLOTI_NAGRI_LETTER_O = chr(43013)
SYLOTI_NAGRI_SIGN_HASANTA = chr(43014)
SYLOTI_NAGRI_LETTER_KO = chr(43015)
SYLOTI_NAGRI_LETTER_KHO = chr(43016)
SYLOTI_NAGRI_LETTER_GO = chr(43017)
SYLOTI_NAGRI_LETTER_GHO = chr(43018)
SYLOTI_NAGRI_SIGN_ANUSVARA = chr(43019)
SYLOTI_NAGRI_LETTER_CO = chr(43020)
SYLOTI_NAGRI_LETTER_CHO = chr(43021)
SYLOTI_NAGRI_LETTER_JO = chr(43022)
SYLOTI_NAGRI_LETTER_JHO = chr(43023)
SYLOTI_NAGRI_LETTER_TTO = chr(43024)
SYLOTI_NAGRI_LETTER_TTHO = chr(43025)
SYLOTI_NAGRI_LETTER_DDO = chr(43026)
SYLOTI_NAGRI_LETTER_DDHO = chr(43027)
SYLOTI_NAGRI_LETTER_TO = chr(43028)
SYLOTI_NAGRI_LETTER_THO = chr(43029)
SYLOTI_NAGRI_LETTER_DO = chr(43030)
SYLOTI_NAGRI_LETTER_DHO = chr(43031)
SYLOTI_NAGRI_LETTER_NO = chr(43032)
SYLOTI_NAGRI_LETTER_PO = chr(43033)
SYLOTI_NAGRI_LETTER_PHO = chr(43034)
SYLOTI_NAGRI_LETTER_BO = chr(43035)
SYLOTI_NAGRI_LETTER_BHO = chr(43036)
SYLOTI_NAGRI_LETTER_MO = chr(43037)
SYLOTI_NAGRI_LETTER_RO = chr(43038)
SYLOTI_NAGRI_LETTER_LO = chr(43039)
SYLOTI_NAGRI_LETTER_RRO = chr(43040)
SYLOTI_NAGRI_LETTER_SO = chr(43041)
SYLOTI_NAGRI_LETTER_HO = chr(43042)
SYLOTI_NAGRI_VOWEL_SIGN_A = chr(43043)
SYLOTI_NAGRI_VOWEL_SIGN_I = chr(43044)
SYLOTI_NAGRI_VOWEL_SIGN_U = chr(43045)
SYLOTI_NAGRI_VOWEL_SIGN_E = chr(43046)
SYLOTI_NAGRI_VOWEL_SIGN_OO = chr(43047)
SYLOTI_NAGRI_POETRY_MARK_1 = chr(43048)
SYLOTI_NAGRI_POETRY_MARK_2 = chr(43049)
SYLOTI_NAGRI_POETRY_MARK_3 = chr(43050)
SYLOTI_NAGRI_POETRY_MARK_4 = chr(43051)
SYLOTI_NAGRI_SIGN_ALTERNATE_HASANTA = chr(43052)
NORTH_INDIC_FRACTION_ONE_QUARTER = chr(43056)
NORTH_INDIC_FRACTION_ONE_HALF = chr(43057)
NORTH_INDIC_FRACTION_THREE_QUARTERS = chr(43058)
NORTH_INDIC_FRACTION_ONE_SIXTEENTH = chr(43059)
NORTH_INDIC_FRACTION_ONE_EIGHTH = chr(43060)
NORTH_INDIC_FRACTION_THREE_SIXTEENTHS = chr(43061)
NORTH_INDIC_QUARTER_MARK = chr(43062)
NORTH_INDIC_PLACEHOLDER_MARK = chr(43063)
NORTH_INDIC_RUPEE_MARK = chr(43064)
NORTH_INDIC_QUANTITY_MARK = chr(43065)
PHAGS_PA_LETTER_KA = chr(43072)
PHAGS_PA_LETTER_KHA = chr(43073)
PHAGS_PA_LETTER_GA = chr(43074)
PHAGS_PA_LETTER_NGA = chr(43075)
PHAGS_PA_LETTER_CA = chr(43076)
PHAGS_PA_LETTER_CHA = chr(43077)
PHAGS_PA_LETTER_JA = chr(43078)
PHAGS_PA_LETTER_NYA = chr(43079)
PHAGS_PA_LETTER_TA = chr(43080)
PHAGS_PA_LETTER_THA = chr(43081)
PHAGS_PA_LETTER_DA = chr(43082)
PHAGS_PA_LETTER_NA = chr(43083)
PHAGS_PA_LETTER_PA = chr(43084)
PHAGS_PA_LETTER_PHA = chr(43085)
PHAGS_PA_LETTER_BA = chr(43086)
PHAGS_PA_LETTER_MA = chr(43087)
PHAGS_PA_LETTER_TSA = chr(43088)
PHAGS_PA_LETTER_TSHA = chr(43089)
PHAGS_PA_LETTER_DZA = chr(43090)
PHAGS_PA_LETTER_WA = chr(43091)
PHAGS_PA_LETTER_ZHA = chr(43092)
PHAGS_PA_LETTER_ZA = chr(43093)
PHAGS_PA_LETTER_SMALL_A = chr(43094)
PHAGS_PA_LETTER_YA = chr(43095)
PHAGS_PA_LETTER_RA = chr(43096)
PHAGS_PA_LETTER_LA = chr(43097)
PHAGS_PA_LETTER_SHA = chr(43098)
PHAGS_PA_LETTER_SA = chr(43099)
PHAGS_PA_LETTER_HA = chr(43100)
PHAGS_PA_LETTER_A = chr(43101)
PHAGS_PA_LETTER_I = chr(43102)
PHAGS_PA_LETTER_U = chr(43103)
PHAGS_PA_LETTER_E = chr(43104)
PHAGS_PA_LETTER_O = chr(43105)
PHAGS_PA_LETTER_QA = chr(43106)
PHAGS_PA_LETTER_XA = chr(43107)
PHAGS_PA_LETTER_FA = chr(43108)
PHAGS_PA_LETTER_GGA = chr(43109)
PHAGS_PA_LETTER_EE = chr(43110)
PHAGS_PA_SUBJOINED_LETTER_WA = chr(43111)
PHAGS_PA_SUBJOINED_LETTER_YA = chr(43112)
PHAGS_PA_LETTER_TTA = chr(43113)
PHAGS_PA_LETTER_TTHA = chr(43114)
PHAGS_PA_LETTER_DDA = chr(43115)
PHAGS_PA_LETTER_NNA = chr(43116)
PHAGS_PA_LETTER_ALTERNATE_YA = chr(43117)
PHAGS_PA_LETTER_VOICELESS_SHA = chr(43118)
PHAGS_PA_LETTER_VOICED_HA = chr(43119)
PHAGS_PA_LETTER_ASPIRATED_FA = chr(43120)
PHAGS_PA_SUBJOINED_LETTER_RA = chr(43121)
PHAGS_PA_SUPERFIXED_LETTER_RA = chr(43122)
PHAGS_PA_LETTER_CANDRABINDU = chr(43123)
PHAGS_PA_SINGLE_HEAD_MARK = chr(43124)
PHAGS_PA_DOUBLE_HEAD_MARK = chr(43125)
PHAGS_PA_MARK_SHAD = chr(43126)
PHAGS_PA_MARK_DOUBLE_SHAD = chr(43127)
SAURASHTRA_SIGN_ANUSVARA = chr(43136)
SAURASHTRA_SIGN_VISARGA = chr(43137)
SAURASHTRA_LETTER_A = chr(43138)
SAURASHTRA_LETTER_AA = chr(43139)
SAURASHTRA_LETTER_I = chr(43140)
SAURASHTRA_LETTER_II = chr(43141)
SAURASHTRA_LETTER_U = chr(43142)
SAURASHTRA_LETTER_UU = chr(43143)
SAURASHTRA_LETTER_VOCALIC_R = chr(43144)
SAURASHTRA_LETTER_VOCALIC_RR = chr(43145)
SAURASHTRA_LETTER_VOCALIC_L = chr(43146)
SAURASHTRA_LETTER_VOCALIC_LL = chr(43147)
SAURASHTRA_LETTER_E = chr(43148)
SAURASHTRA_LETTER_EE = chr(43149)
SAURASHTRA_LETTER_AI = chr(43150)
SAURASHTRA_LETTER_O = chr(43151)
SAURASHTRA_LETTER_OO = chr(43152)
SAURASHTRA_LETTER_AU = chr(43153)
SAURASHTRA_LETTER_KA = chr(43154)
SAURASHTRA_LETTER_KHA = chr(43155)
SAURASHTRA_LETTER_GA = chr(43156)
SAURASHTRA_LETTER_GHA = chr(43157)
SAURASHTRA_LETTER_NGA = chr(43158)
SAURASHTRA_LETTER_CA = chr(43159)
SAURASHTRA_LETTER_CHA = chr(43160)
SAURASHTRA_LETTER_JA = chr(43161)
SAURASHTRA_LETTER_JHA = chr(43162)
SAURASHTRA_LETTER_NYA = chr(43163)
SAURASHTRA_LETTER_TTA = chr(43164)
SAURASHTRA_LETTER_TTHA = chr(43165)
SAURASHTRA_LETTER_DDA = chr(43166)
SAURASHTRA_LETTER_DDHA = chr(43167)
SAURASHTRA_LETTER_NNA = chr(43168)
SAURASHTRA_LETTER_TA = chr(43169)
SAURASHTRA_LETTER_THA = chr(43170)
SAURASHTRA_LETTER_DA = chr(43171)
SAURASHTRA_LETTER_DHA = chr(43172)
SAURASHTRA_LETTER_NA = chr(43173)
SAURASHTRA_LETTER_PA = chr(43174)
SAURASHTRA_LETTER_PHA = chr(43175)
SAURASHTRA_LETTER_BA = chr(43176)
SAURASHTRA_LETTER_BHA = chr(43177)
SAURASHTRA_LETTER_MA = chr(43178)
SAURASHTRA_LETTER_YA = chr(43179)
SAURASHTRA_LETTER_RA = chr(43180)
SAURASHTRA_LETTER_LA = chr(43181)
SAURASHTRA_LETTER_VA = chr(43182)
SAURASHTRA_LETTER_SHA = chr(43183)
SAURASHTRA_LETTER_SSA = chr(43184)
SAURASHTRA_LETTER_SA = chr(43185)
SAURASHTRA_LETTER_HA = chr(43186)
SAURASHTRA_LETTER_LLA = chr(43187)
SAURASHTRA_CONSONANT_SIGN_HAARU = chr(43188)
SAURASHTRA_VOWEL_SIGN_AA = chr(43189)
SAURASHTRA_VOWEL_SIGN_I = chr(43190)
SAURASHTRA_VOWEL_SIGN_II = chr(43191)
SAURASHTRA_VOWEL_SIGN_U = chr(43192)
SAURASHTRA_VOWEL_SIGN_UU = chr(43193)
SAURASHTRA_VOWEL_SIGN_VOCALIC_R = chr(43194)
SAURASHTRA_VOWEL_SIGN_VOCALIC_RR = chr(43195)
SAURASHTRA_VOWEL_SIGN_VOCALIC_L = chr(43196)
SAURASHTRA_VOWEL_SIGN_VOCALIC_LL = chr(43197)
SAURASHTRA_VOWEL_SIGN_E = chr(43198)
SAURASHTRA_VOWEL_SIGN_EE = chr(43199)
SAURASHTRA_VOWEL_SIGN_AI = chr(43200)
SAURASHTRA_VOWEL_SIGN_O = chr(43201)
SAURASHTRA_VOWEL_SIGN_OO = chr(43202)
SAURASHTRA_VOWEL_SIGN_AU = chr(43203)
SAURASHTRA_SIGN_VIRAMA = chr(43204)
SAURASHTRA_SIGN_CANDRABINDU = chr(43205)
SAURASHTRA_DANDA = chr(43214)
SAURASHTRA_DOUBLE_DANDA = chr(43215)
SAURASHTRA_DIGIT_ZERO = chr(43216)
SAURASHTRA_DIGIT_ONE = chr(43217)
SAURASHTRA_DIGIT_TWO = chr(43218)
SAURASHTRA_DIGIT_THREE = chr(43219)
SAURASHTRA_DIGIT_FOUR = chr(43220)
SAURASHTRA_DIGIT_FIVE = chr(43221)
SAURASHTRA_DIGIT_SIX = chr(43222)
SAURASHTRA_DIGIT_SEVEN = chr(43223)
SAURASHTRA_DIGIT_EIGHT = chr(43224)
SAURASHTRA_DIGIT_NINE = chr(43225)
COMBINING_DEVANAGARI_DIGIT_ZERO = chr(43232)
COMBINING_DEVANAGARI_DIGIT_ONE = chr(43233)
COMBINING_DEVANAGARI_DIGIT_TWO = chr(43234)
COMBINING_DEVANAGARI_DIGIT_THREE = chr(43235)
COMBINING_DEVANAGARI_DIGIT_FOUR = chr(43236)
COMBINING_DEVANAGARI_DIGIT_FIVE = chr(43237)
COMBINING_DEVANAGARI_DIGIT_SIX = chr(43238)
COMBINING_DEVANAGARI_DIGIT_SEVEN = chr(43239)
COMBINING_DEVANAGARI_DIGIT_EIGHT = chr(43240)
COMBINING_DEVANAGARI_DIGIT_NINE = chr(43241)
COMBINING_DEVANAGARI_LETTER_A = chr(43242)
COMBINING_DEVANAGARI_LETTER_U = chr(43243)
COMBINING_DEVANAGARI_LETTER_KA = chr(43244)
COMBINING_DEVANAGARI_LETTER_NA = chr(43245)
COMBINING_DEVANAGARI_LETTER_PA = chr(43246)
COMBINING_DEVANAGARI_LETTER_RA = chr(43247)
COMBINING_DEVANAGARI_LETTER_VI = chr(43248)
COMBINING_DEVANAGARI_SIGN_AVAGRAHA = chr(43249)
DEVANAGARI_SIGN_SPACING_CANDRABINDU = chr(43250)
DEVANAGARI_SIGN_CANDRABINDU_VIRAMA = chr(43251)
DEVANAGARI_SIGN_DOUBLE_CANDRABINDU_VIRAMA = chr(43252)
DEVANAGARI_SIGN_CANDRABINDU_TWO = chr(43253)
DEVANAGARI_SIGN_CANDRABINDU_THREE = chr(43254)
DEVANAGARI_SIGN_CANDRABINDU_AVAGRAHA = chr(43255)
DEVANAGARI_SIGN_PUSHPIKA = chr(43256)
DEVANAGARI_GAP_FILLER = chr(43257)
DEVANAGARI_CARET = chr(43258)
DEVANAGARI_HEADSTROKE = chr(43259)
DEVANAGARI_SIGN_SIDDHAM = chr(43260)
DEVANAGARI_JAIN_OM = chr(43261)
DEVANAGARI_LETTER_AY = chr(43262)
DEVANAGARI_VOWEL_SIGN_AY = chr(43263)
KAYAH_LI_DIGIT_ZERO = chr(43264)
KAYAH_LI_DIGIT_ONE = chr(43265)
KAYAH_LI_DIGIT_TWO = chr(43266)
KAYAH_LI_DIGIT_THREE = chr(43267)
KAYAH_LI_DIGIT_FOUR = chr(43268)
KAYAH_LI_DIGIT_FIVE = chr(43269)
KAYAH_LI_DIGIT_SIX = chr(43270)
KAYAH_LI_DIGIT_SEVEN = chr(43271)
KAYAH_LI_DIGIT_EIGHT = chr(43272)
KAYAH_LI_DIGIT_NINE = chr(43273)
KAYAH_LI_LETTER_KA = chr(43274)
KAYAH_LI_LETTER_KHA = chr(43275)
KAYAH_LI_LETTER_GA = chr(43276)
KAYAH_LI_LETTER_NGA = chr(43277)
KAYAH_LI_LETTER_SA = chr(43278)
KAYAH_LI_LETTER_SHA = chr(43279)
KAYAH_LI_LETTER_ZA = chr(43280)
KAYAH_LI_LETTER_NYA = chr(43281)
KAYAH_LI_LETTER_TA = chr(43282)
KAYAH_LI_LETTER_HTA = chr(43283)
KAYAH_LI_LETTER_NA = chr(43284)
KAYAH_LI_LETTER_PA = chr(43285)
KAYAH_LI_LETTER_PHA = chr(43286)
KAYAH_LI_LETTER_MA = chr(43287)
KAYAH_LI_LETTER_DA = chr(43288)
KAYAH_LI_LETTER_BA = chr(43289)
KAYAH_LI_LETTER_RA = chr(43290)
KAYAH_LI_LETTER_YA = chr(43291)
KAYAH_LI_LETTER_LA = chr(43292)
KAYAH_LI_LETTER_WA = chr(43293)
KAYAH_LI_LETTER_THA = chr(43294)
KAYAH_LI_LETTER_HA = chr(43295)
KAYAH_LI_LETTER_VA = chr(43296)
KAYAH_LI_LETTER_CA = chr(43297)
KAYAH_LI_LETTER_A = chr(43298)
KAYAH_LI_LETTER_OE = chr(43299)
KAYAH_LI_LETTER_I = chr(43300)
KAYAH_LI_LETTER_OO = chr(43301)
KAYAH_LI_VOWEL_UE = chr(43302)
KAYAH_LI_VOWEL_E = chr(43303)
KAYAH_LI_VOWEL_U = chr(43304)
KAYAH_LI_VOWEL_EE = chr(43305)
KAYAH_LI_VOWEL_O = chr(43306)
KAYAH_LI_TONE_PLOPHU = chr(43307)
KAYAH_LI_TONE_CALYA = chr(43308)
KAYAH_LI_TONE_CALYA_PLOPHU = chr(43309)
KAYAH_LI_SIGN_CWI = chr(43310)
KAYAH_LI_SIGN_SHYA = chr(43311)
REJANG_LETTER_KA = chr(43312)
REJANG_LETTER_GA = chr(43313)
REJANG_LETTER_NGA = chr(43314)
REJANG_LETTER_TA = chr(43315)
REJANG_LETTER_DA = chr(43316)
REJANG_LETTER_NA = chr(43317)
REJANG_LETTER_PA = chr(43318)
REJANG_LETTER_BA = chr(43319)
REJANG_LETTER_MA = chr(43320)
REJANG_LETTER_CA = chr(43321)
REJANG_LETTER_JA = chr(43322)
REJANG_LETTER_NYA = chr(43323)
REJANG_LETTER_SA = chr(43324)
REJANG_LETTER_RA = chr(43325)
REJANG_LETTER_LA = chr(43326)
REJANG_LETTER_YA = chr(43327)
REJANG_LETTER_WA = chr(43328)
REJANG_LETTER_HA = chr(43329)
REJANG_LETTER_MBA = chr(43330)
REJANG_LETTER_NGGA = chr(43331)
REJANG_LETTER_NDA = chr(43332)
REJANG_LETTER_NYJA = chr(43333)
REJANG_LETTER_A = chr(43334)
REJANG_VOWEL_SIGN_I = chr(43335)
REJANG_VOWEL_SIGN_U = chr(43336)
REJANG_VOWEL_SIGN_E = chr(43337)
REJANG_VOWEL_SIGN_AI = chr(43338)
REJANG_VOWEL_SIGN_O = chr(43339)
REJANG_VOWEL_SIGN_AU = chr(43340)
REJANG_VOWEL_SIGN_EU = chr(43341)
REJANG_VOWEL_SIGN_EA = chr(43342)
REJANG_CONSONANT_SIGN_NG = chr(43343)
REJANG_CONSONANT_SIGN_N = chr(43344)
REJANG_CONSONANT_SIGN_R = chr(43345)
REJANG_CONSONANT_SIGN_H = chr(43346)
REJANG_VIRAMA = chr(43347)
REJANG_SECTION_MARK = chr(43359)
HANGUL_CHOSEONG_TIKEUT_MIEUM = chr(43360)
HANGUL_CHOSEONG_TIKEUT_PIEUP = chr(43361)
HANGUL_CHOSEONG_TIKEUT_SIOS = chr(43362)
HANGUL_CHOSEONG_TIKEUT_CIEUC = chr(43363)
HANGUL_CHOSEONG_RIEUL_KIYEOK = chr(43364)
HANGUL_CHOSEONG_RIEUL_SSANGKIYEOK = chr(43365)
HANGUL_CHOSEONG_RIEUL_TIKEUT = chr(43366)
HANGUL_CHOSEONG_RIEUL_SSANGTIKEUT = chr(43367)
HANGUL_CHOSEONG_RIEUL_MIEUM = chr(43368)
HANGUL_CHOSEONG_RIEUL_PIEUP = chr(43369)
HANGUL_CHOSEONG_RIEUL_SSANGPIEUP = chr(43370)
HANGUL_CHOSEONG_RIEUL_KAPYEOUNPIEUP = chr(43371)
HANGUL_CHOSEONG_RIEUL_SIOS = chr(43372)
HANGUL_CHOSEONG_RIEUL_CIEUC = chr(43373)
HANGUL_CHOSEONG_RIEUL_KHIEUKH = chr(43374)
HANGUL_CHOSEONG_MIEUM_KIYEOK = chr(43375)
HANGUL_CHOSEONG_MIEUM_TIKEUT = chr(43376)
HANGUL_CHOSEONG_MIEUM_SIOS = chr(43377)
HANGUL_CHOSEONG_PIEUP_SIOS_THIEUTH = chr(43378)
HANGUL_CHOSEONG_PIEUP_KHIEUKH = chr(43379)
HANGUL_CHOSEONG_PIEUP_HIEUH = chr(43380)
HANGUL_CHOSEONG_SSANGSIOS_PIEUP = chr(43381)
HANGUL_CHOSEONG_IEUNG_RIEUL = chr(43382)
HANGUL_CHOSEONG_IEUNG_HIEUH = chr(43383)
HANGUL_CHOSEONG_SSANGCIEUC_HIEUH = chr(43384)
HANGUL_CHOSEONG_SSANGTHIEUTH = chr(43385)
HANGUL_CHOSEONG_PHIEUPH_HIEUH = chr(43386)
HANGUL_CHOSEONG_HIEUH_SIOS = chr(43387)
HANGUL_CHOSEONG_SSANGYEORINHIEUH = chr(43388)
JAVANESE_SIGN_PANYANGGA = chr(43392)
JAVANESE_SIGN_CECAK = chr(43393)
JAVANESE_SIGN_LAYAR = chr(43394)
JAVANESE_SIGN_WIGNYAN = chr(43395)
JAVANESE_LETTER_A = chr(43396)
JAVANESE_LETTER_I_KAWI = chr(43397)
JAVANESE_LETTER_I = chr(43398)
JAVANESE_LETTER_II = chr(43399)
JAVANESE_LETTER_U = chr(43400)
JAVANESE_LETTER_PA_CEREK = chr(43401)
JAVANESE_LETTER_NGA_LELET = chr(43402)
JAVANESE_LETTER_NGA_LELET_RASWADI = chr(43403)
JAVANESE_LETTER_E = chr(43404)
JAVANESE_LETTER_AI = chr(43405)
JAVANESE_LETTER_O = chr(43406)
JAVANESE_LETTER_KA = chr(43407)
JAVANESE_LETTER_KA_SASAK = chr(43408)
JAVANESE_LETTER_KA_MURDA = chr(43409)
JAVANESE_LETTER_GA = chr(43410)
JAVANESE_LETTER_GA_MURDA = chr(43411)
JAVANESE_LETTER_NGA = chr(43412)
JAVANESE_LETTER_CA = chr(43413)
JAVANESE_LETTER_CA_MURDA = chr(43414)
JAVANESE_LETTER_JA = chr(43415)
JAVANESE_LETTER_NYA_MURDA = chr(43416)
JAVANESE_LETTER_JA_MAHAPRANA = chr(43417)
JAVANESE_LETTER_NYA = chr(43418)
JAVANESE_LETTER_TTA = chr(43419)
JAVANESE_LETTER_TTA_MAHAPRANA = chr(43420)
JAVANESE_LETTER_DDA = chr(43421)
JAVANESE_LETTER_DDA_MAHAPRANA = chr(43422)
JAVANESE_LETTER_NA_MURDA = chr(43423)
JAVANESE_LETTER_TA = chr(43424)
JAVANESE_LETTER_TA_MURDA = chr(43425)
JAVANESE_LETTER_DA = chr(43426)
JAVANESE_LETTER_DA_MAHAPRANA = chr(43427)
JAVANESE_LETTER_NA = chr(43428)
JAVANESE_LETTER_PA = chr(43429)
JAVANESE_LETTER_PA_MURDA = chr(43430)
JAVANESE_LETTER_BA = chr(43431)
JAVANESE_LETTER_BA_MURDA = chr(43432)
JAVANESE_LETTER_MA = chr(43433)
JAVANESE_LETTER_YA = chr(43434)
JAVANESE_LETTER_RA = chr(43435)
JAVANESE_LETTER_RA_AGUNG = chr(43436)
JAVANESE_LETTER_LA = chr(43437)
JAVANESE_LETTER_WA = chr(43438)
JAVANESE_LETTER_SA_MURDA = chr(43439)
JAVANESE_LETTER_SA_MAHAPRANA = chr(43440)
JAVANESE_LETTER_SA = chr(43441)
JAVANESE_LETTER_HA = chr(43442)
JAVANESE_SIGN_CECAK_TELU = chr(43443)
JAVANESE_VOWEL_SIGN_TARUNG = chr(43444)
JAVANESE_VOWEL_SIGN_TOLONG = chr(43445)
JAVANESE_VOWEL_SIGN_WULU = chr(43446)
JAVANESE_VOWEL_SIGN_WULU_MELIK = chr(43447)
JAVANESE_VOWEL_SIGN_SUKU = chr(43448)
JAVANESE_VOWEL_SIGN_SUKU_MENDUT = chr(43449)
JAVANESE_VOWEL_SIGN_TALING = chr(43450)
JAVANESE_VOWEL_SIGN_DIRGA_MURE = chr(43451)
JAVANESE_VOWEL_SIGN_PEPET = chr(43452)
JAVANESE_CONSONANT_SIGN_KERET = chr(43453)
JAVANESE_CONSONANT_SIGN_PENGKAL = chr(43454)
JAVANESE_CONSONANT_SIGN_CAKRA = chr(43455)
JAVANESE_PANGKON = chr(43456)
JAVANESE_LEFT_RERENGGAN = chr(43457)
JAVANESE_RIGHT_RERENGGAN = chr(43458)
JAVANESE_PADA_ANDAP = chr(43459)
JAVANESE_PADA_MADYA = chr(43460)
JAVANESE_PADA_LUHUR = chr(43461)
JAVANESE_PADA_WINDU = chr(43462)
JAVANESE_PADA_PANGKAT = chr(43463)
JAVANESE_PADA_LINGSA = chr(43464)
JAVANESE_PADA_LUNGSI = chr(43465)
JAVANESE_PADA_ADEG = chr(43466)
JAVANESE_PADA_ADEG_ADEG = chr(43467)
JAVANESE_PADA_PISELEH = chr(43468)
JAVANESE_TURNED_PADA_PISELEH = chr(43469)
JAVANESE_PANGRANGKEP = chr(43471)
JAVANESE_DIGIT_ZERO = chr(43472)
JAVANESE_DIGIT_ONE = chr(43473)
JAVANESE_DIGIT_TWO = chr(43474)
JAVANESE_DIGIT_THREE = chr(43475)
JAVANESE_DIGIT_FOUR = chr(43476)
JAVANESE_DIGIT_FIVE = chr(43477)
JAVANESE_DIGIT_SIX = chr(43478)
JAVANESE_DIGIT_SEVEN = chr(43479)
JAVANESE_DIGIT_EIGHT = chr(43480)
JAVANESE_DIGIT_NINE = chr(43481)
JAVANESE_PADA_TIRTA_TUMETES = chr(43486)
JAVANESE_PADA_ISEN_ISEN = chr(43487)
MYANMAR_LETTER_SHAN_GHA = chr(43488)
MYANMAR_LETTER_SHAN_CHA = chr(43489)
MYANMAR_LETTER_SHAN_JHA = chr(43490)
MYANMAR_LETTER_SHAN_NNA = chr(43491)
MYANMAR_LETTER_SHAN_BHA = chr(43492)
MYANMAR_SIGN_SHAN_SAW = chr(43493)
MYANMAR_MODIFIER_LETTER_SHAN_REDUPLICATION = chr(43494)
MYANMAR_LETTER_TAI_LAING_NYA = chr(43495)
MYANMAR_LETTER_TAI_LAING_FA = chr(43496)
MYANMAR_LETTER_TAI_LAING_GA = chr(43497)
MYANMAR_LETTER_TAI_LAING_GHA = chr(43498)
MYANMAR_LETTER_TAI_LAING_JA = chr(43499)
MYANMAR_LETTER_TAI_LAING_JHA = chr(43500)
MYANMAR_LETTER_TAI_LAING_DDA = chr(43501)
MYANMAR_LETTER_TAI_LAING_DDHA = chr(43502)
MYANMAR_LETTER_TAI_LAING_NNA = chr(43503)
MYANMAR_TAI_LAING_DIGIT_ZERO = chr(43504)
MYANMAR_TAI_LAING_DIGIT_ONE = chr(43505)
MYANMAR_TAI_LAING_DIGIT_TWO = chr(43506)
MYANMAR_TAI_LAING_DIGIT_THREE = chr(43507)
MYANMAR_TAI_LAING_DIGIT_FOUR = chr(43508)
MYANMAR_TAI_LAING_DIGIT_FIVE = chr(43509)
MYANMAR_TAI_LAING_DIGIT_SIX = chr(43510)
MYANMAR_TAI_LAING_DIGIT_SEVEN = chr(43511)
MYANMAR_TAI_LAING_DIGIT_EIGHT = chr(43512)
MYANMAR_TAI_LAING_DIGIT_NINE = chr(43513)
MYANMAR_LETTER_TAI_LAING_LLA = chr(43514)
MYANMAR_LETTER_TAI_LAING_DA = chr(43515)
MYANMAR_LETTER_TAI_LAING_DHA = chr(43516)
MYANMAR_LETTER_TAI_LAING_BA = chr(43517)
MYANMAR_LETTER_TAI_LAING_BHA = chr(43518)
CHAM_LETTER_A = chr(43520)
CHAM_LETTER_I = chr(43521)
CHAM_LETTER_U = chr(43522)
CHAM_LETTER_E = chr(43523)
CHAM_LETTER_AI = chr(43524)
CHAM_LETTER_O = chr(43525)
CHAM_LETTER_KA = chr(43526)
CHAM_LETTER_KHA = chr(43527)
CHAM_LETTER_GA = chr(43528)
CHAM_LETTER_GHA = chr(43529)
CHAM_LETTER_NGUE = chr(43530)
CHAM_LETTER_NGA = chr(43531)
CHAM_LETTER_CHA = chr(43532)
CHAM_LETTER_CHHA = chr(43533)
CHAM_LETTER_JA = chr(43534)
CHAM_LETTER_JHA = chr(43535)
CHAM_LETTER_NHUE = chr(43536)
CHAM_LETTER_NHA = chr(43537)
CHAM_LETTER_NHJA = chr(43538)
CHAM_LETTER_TA = chr(43539)
CHAM_LETTER_THA = chr(43540)
CHAM_LETTER_DA = chr(43541)
CHAM_LETTER_DHA = chr(43542)
CHAM_LETTER_NUE = chr(43543)
CHAM_LETTER_NA = chr(43544)
CHAM_LETTER_DDA = chr(43545)
CHAM_LETTER_PA = chr(43546)
CHAM_LETTER_PPA = chr(43547)
CHAM_LETTER_PHA = chr(43548)
CHAM_LETTER_BA = chr(43549)
CHAM_LETTER_BHA = chr(43550)
CHAM_LETTER_MUE = chr(43551)
CHAM_LETTER_MA = chr(43552)
CHAM_LETTER_BBA = chr(43553)
CHAM_LETTER_YA = chr(43554)
CHAM_LETTER_RA = chr(43555)
CHAM_LETTER_LA = chr(43556)
CHAM_LETTER_VA = chr(43557)
CHAM_LETTER_SSA = chr(43558)
CHAM_LETTER_SA = chr(43559)
CHAM_LETTER_HA = chr(43560)
CHAM_VOWEL_SIGN_AA = chr(43561)
CHAM_VOWEL_SIGN_I = chr(43562)
CHAM_VOWEL_SIGN_II = chr(43563)
CHAM_VOWEL_SIGN_EI = chr(43564)
CHAM_VOWEL_SIGN_U = chr(43565)
CHAM_VOWEL_SIGN_OE = chr(43566)
CHAM_VOWEL_SIGN_O = chr(43567)
CHAM_VOWEL_SIGN_AI = chr(43568)
CHAM_VOWEL_SIGN_AU = chr(43569)
CHAM_VOWEL_SIGN_UE = chr(43570)
CHAM_CONSONANT_SIGN_YA = chr(43571)
CHAM_CONSONANT_SIGN_RA = chr(43572)
CHAM_CONSONANT_SIGN_LA = chr(43573)
CHAM_CONSONANT_SIGN_WA = chr(43574)
CHAM_LETTER_FINAL_K = chr(43584)
CHAM_LETTER_FINAL_G = chr(43585)
CHAM_LETTER_FINAL_NG = chr(43586)
CHAM_CONSONANT_SIGN_FINAL_NG = chr(43587)
CHAM_LETTER_FINAL_CH = chr(43588)
CHAM_LETTER_FINAL_T = chr(43589)
CHAM_LETTER_FINAL_N = chr(43590)
CHAM_LETTER_FINAL_P = chr(43591)
CHAM_LETTER_FINAL_Y = chr(43592)
CHAM_LETTER_FINAL_R = chr(43593)
CHAM_LETTER_FINAL_L = chr(43594)
CHAM_LETTER_FINAL_SS = chr(43595)
CHAM_CONSONANT_SIGN_FINAL_M = chr(43596)
CHAM_CONSONANT_SIGN_FINAL_H = chr(43597)
CHAM_DIGIT_ZERO = chr(43600)
CHAM_DIGIT_ONE = chr(43601)
CHAM_DIGIT_TWO = chr(43602)
CHAM_DIGIT_THREE = chr(43603)
CHAM_DIGIT_FOUR = chr(43604)
CHAM_DIGIT_FIVE = chr(43605)
CHAM_DIGIT_SIX = chr(43606)
CHAM_DIGIT_SEVEN = chr(43607)
CHAM_DIGIT_EIGHT = chr(43608)
CHAM_DIGIT_NINE = chr(43609)
CHAM_PUNCTUATION_SPIRAL = chr(43612)
CHAM_PUNCTUATION_DANDA = chr(43613)
CHAM_PUNCTUATION_DOUBLE_DANDA = chr(43614)
CHAM_PUNCTUATION_TRIPLE_DANDA = chr(43615)
MYANMAR_LETTER_KHAMTI_GA = chr(43616)
MYANMAR_LETTER_KHAMTI_CA = chr(43617)
MYANMAR_LETTER_KHAMTI_CHA = chr(43618)
MYANMAR_LETTER_KHAMTI_JA = chr(43619)
MYANMAR_LETTER_KHAMTI_JHA = chr(43620)
MYANMAR_LETTER_KHAMTI_NYA = chr(43621)
MYANMAR_LETTER_KHAMTI_TTA = chr(43622)
MYANMAR_LETTER_KHAMTI_TTHA = chr(43623)
MYANMAR_LETTER_KHAMTI_DDA = chr(43624)
MYANMAR_LETTER_KHAMTI_DDHA = chr(43625)
MYANMAR_LETTER_KHAMTI_DHA = chr(43626)
MYANMAR_LETTER_KHAMTI_NA = chr(43627)
MYANMAR_LETTER_KHAMTI_SA = chr(43628)
MYANMAR_LETTER_KHAMTI_HA = chr(43629)
MYANMAR_LETTER_KHAMTI_HHA = chr(43630)
MYANMAR_LETTER_KHAMTI_FA = chr(43631)
MYANMAR_MODIFIER_LETTER_KHAMTI_REDUPLICATION = chr(43632)
MYANMAR_LETTER_KHAMTI_XA = chr(43633)
MYANMAR_LETTER_KHAMTI_ZA = chr(43634)
MYANMAR_LETTER_KHAMTI_RA = chr(43635)
MYANMAR_LOGOGRAM_KHAMTI_OAY = chr(43636)
MYANMAR_LOGOGRAM_KHAMTI_QN = chr(43637)
MYANMAR_LOGOGRAM_KHAMTI_HM = chr(43638)
MYANMAR_SYMBOL_AITON_EXCLAMATION = chr(43639)
MYANMAR_SYMBOL_AITON_ONE = chr(43640)
MYANMAR_SYMBOL_AITON_TWO = chr(43641)
MYANMAR_LETTER_AITON_RA = chr(43642)
MYANMAR_SIGN_PAO_KAREN_TONE = chr(43643)
MYANMAR_SIGN_TAI_LAING_TONE_2 = chr(43644)
MYANMAR_SIGN_TAI_LAING_TONE_5 = chr(43645)
MYANMAR_LETTER_SHWE_PALAUNG_CHA = chr(43646)
MYANMAR_LETTER_SHWE_PALAUNG_SHA = chr(43647)
TAI_VIET_LETTER_LOW_KO = chr(43648)
TAI_VIET_LETTER_HIGH_KO = chr(43649)
TAI_VIET_LETTER_LOW_KHO = chr(43650)
TAI_VIET_LETTER_HIGH_KHO = chr(43651)
TAI_VIET_LETTER_LOW_KHHO = chr(43652)
TAI_VIET_LETTER_HIGH_KHHO = chr(43653)
TAI_VIET_LETTER_LOW_GO = chr(43654)
TAI_VIET_LETTER_HIGH_GO = chr(43655)
TAI_VIET_LETTER_LOW_NGO = chr(43656)
TAI_VIET_LETTER_HIGH_NGO = chr(43657)
TAI_VIET_LETTER_LOW_CO = chr(43658)
TAI_VIET_LETTER_HIGH_CO = chr(43659)
TAI_VIET_LETTER_LOW_CHO = chr(43660)
TAI_VIET_LETTER_HIGH_CHO = chr(43661)
TAI_VIET_LETTER_LOW_SO = chr(43662)
TAI_VIET_LETTER_HIGH_SO = chr(43663)
TAI_VIET_LETTER_LOW_NYO = chr(43664)
TAI_VIET_LETTER_HIGH_NYO = chr(43665)
TAI_VIET_LETTER_LOW_DO = chr(43666)
TAI_VIET_LETTER_HIGH_DO = chr(43667)
TAI_VIET_LETTER_LOW_TO = chr(43668)
TAI_VIET_LETTER_HIGH_TO = chr(43669)
TAI_VIET_LETTER_LOW_THO = chr(43670)
TAI_VIET_LETTER_HIGH_THO = chr(43671)
TAI_VIET_LETTER_LOW_NO = chr(43672)
TAI_VIET_LETTER_HIGH_NO = chr(43673)
TAI_VIET_LETTER_LOW_BO = chr(43674)
TAI_VIET_LETTER_HIGH_BO = chr(43675)
TAI_VIET_LETTER_LOW_PO = chr(43676)
TAI_VIET_LETTER_HIGH_PO = chr(43677)
TAI_VIET_LETTER_LOW_PHO = chr(43678)
TAI_VIET_LETTER_HIGH_PHO = chr(43679)
TAI_VIET_LETTER_LOW_FO = chr(43680)
TAI_VIET_LETTER_HIGH_FO = chr(43681)
TAI_VIET_LETTER_LOW_MO = chr(43682)
TAI_VIET_LETTER_HIGH_MO = chr(43683)
TAI_VIET_LETTER_LOW_YO = chr(43684)
TAI_VIET_LETTER_HIGH_YO = chr(43685)
TAI_VIET_LETTER_LOW_RO = chr(43686)
TAI_VIET_LETTER_HIGH_RO = chr(43687)
TAI_VIET_LETTER_LOW_LO = chr(43688)
TAI_VIET_LETTER_HIGH_LO = chr(43689)
TAI_VIET_LETTER_LOW_VO = chr(43690)
TAI_VIET_LETTER_HIGH_VO = chr(43691)
TAI_VIET_LETTER_LOW_HO = chr(43692)
TAI_VIET_LETTER_HIGH_HO = chr(43693)
TAI_VIET_LETTER_LOW_O = chr(43694)
TAI_VIET_LETTER_HIGH_O = chr(43695)
TAI_VIET_MAI_KANG = chr(43696)
TAI_VIET_VOWEL_AA = chr(43697)
TAI_VIET_VOWEL_I = chr(43698)
TAI_VIET_VOWEL_UE = chr(43699)
TAI_VIET_VOWEL_U = chr(43700)
TAI_VIET_VOWEL_E = chr(43701)
TAI_VIET_VOWEL_O = chr(43702)
TAI_VIET_MAI_KHIT = chr(43703)
TAI_VIET_VOWEL_IA = chr(43704)
TAI_VIET_VOWEL_UEA = chr(43705)
TAI_VIET_VOWEL_UA = chr(43706)
TAI_VIET_VOWEL_AUE = chr(43707)
TAI_VIET_VOWEL_AY = chr(43708)
TAI_VIET_VOWEL_AN = chr(43709)
TAI_VIET_VOWEL_AM = chr(43710)
TAI_VIET_TONE_MAI_EK = chr(43711)
TAI_VIET_TONE_MAI_NUENG = chr(43712)
TAI_VIET_TONE_MAI_THO = chr(43713)
TAI_VIET_TONE_MAI_SONG = chr(43714)
TAI_VIET_SYMBOL_KON = chr(43739)
TAI_VIET_SYMBOL_NUENG = chr(43740)
TAI_VIET_SYMBOL_SAM = chr(43741)
TAI_VIET_SYMBOL_HO_HOI = chr(43742)
TAI_VIET_SYMBOL_KOI_KOI = chr(43743)
MEETEI_MAYEK_LETTER_E = chr(43744)
MEETEI_MAYEK_LETTER_O = chr(43745)
MEETEI_MAYEK_LETTER_CHA = chr(43746)
MEETEI_MAYEK_LETTER_NYA = chr(43747)
MEETEI_MAYEK_LETTER_TTA = chr(43748)
MEETEI_MAYEK_LETTER_TTHA = chr(43749)
MEETEI_MAYEK_LETTER_DDA = chr(43750)
MEETEI_MAYEK_LETTER_DDHA = chr(43751)
MEETEI_MAYEK_LETTER_NNA = chr(43752)
MEETEI_MAYEK_LETTER_SHA = chr(43753)
MEETEI_MAYEK_LETTER_SSA = chr(43754)
MEETEI_MAYEK_VOWEL_SIGN_II = chr(43755)
MEETEI_MAYEK_VOWEL_SIGN_UU = chr(43756)
MEETEI_MAYEK_VOWEL_SIGN_AAI = chr(43757)
MEETEI_MAYEK_VOWEL_SIGN_AU = chr(43758)
MEETEI_MAYEK_VOWEL_SIGN_AAU = chr(43759)
MEETEI_MAYEK_CHEIKHAN = chr(43760)
MEETEI_MAYEK_AHANG_KHUDAM = chr(43761)
MEETEI_MAYEK_ANJI = chr(43762)
MEETEI_MAYEK_SYLLABLE_REPETITION_MARK = chr(43763)
MEETEI_MAYEK_WORD_REPETITION_MARK = chr(43764)
MEETEI_MAYEK_VOWEL_SIGN_VISARGA = chr(43765)
MEETEI_MAYEK_VIRAMA = chr(43766)
ETHIOPIC_SYLLABLE_TTHU = chr(43777)
ETHIOPIC_SYLLABLE_TTHI = chr(43778)
ETHIOPIC_SYLLABLE_TTHAA = chr(43779)
ETHIOPIC_SYLLABLE_TTHEE = chr(43780)
ETHIOPIC_SYLLABLE_TTHE = chr(43781)
ETHIOPIC_SYLLABLE_TTHO = chr(43782)
ETHIOPIC_SYLLABLE_DDHU = chr(43785)
ETHIOPIC_SYLLABLE_DDHI = chr(43786)
ETHIOPIC_SYLLABLE_DDHAA = chr(43787)
ETHIOPIC_SYLLABLE_DDHEE = chr(43788)
ETHIOPIC_SYLLABLE_DDHE = chr(43789)
ETHIOPIC_SYLLABLE_DDHO = chr(43790)
ETHIOPIC_SYLLABLE_DZU = chr(43793)
ETHIOPIC_SYLLABLE_DZI = chr(43794)
ETHIOPIC_SYLLABLE_DZAA = chr(43795)
ETHIOPIC_SYLLABLE_DZEE = chr(43796)
ETHIOPIC_SYLLABLE_DZE = chr(43797)
ETHIOPIC_SYLLABLE_DZO = chr(43798)
ETHIOPIC_SYLLABLE_CCHHA = chr(43808)
ETHIOPIC_SYLLABLE_CCHHU = chr(43809)
ETHIOPIC_SYLLABLE_CCHHI = chr(43810)
ETHIOPIC_SYLLABLE_CCHHAA = chr(43811)
ETHIOPIC_SYLLABLE_CCHHEE = chr(43812)
ETHIOPIC_SYLLABLE_CCHHE = chr(43813)
ETHIOPIC_SYLLABLE_CCHHO = chr(43814)
ETHIOPIC_SYLLABLE_BBA = chr(43816)
ETHIOPIC_SYLLABLE_BBU = chr(43817)
ETHIOPIC_SYLLABLE_BBI = chr(43818)
ETHIOPIC_SYLLABLE_BBAA = chr(43819)
ETHIOPIC_SYLLABLE_BBEE = chr(43820)
ETHIOPIC_SYLLABLE_BBE = chr(43821)
ETHIOPIC_SYLLABLE_BBO = chr(43822)
LATIN_SMALL_LETTER_BARRED_ALPHA = chr(43824)
LATIN_SMALL_LETTER_A_REVERSED_SCHWA = chr(43825)
LATIN_SMALL_LETTER_BLACKLETTER_E = chr(43826)
LATIN_SMALL_LETTER_BARRED_E = chr(43827)
LATIN_SMALL_LETTER_E_WITH_FLOURISH = chr(43828)
LATIN_SMALL_LETTER_LENIS_F = chr(43829)
LATIN_SMALL_LETTER_SCRIPT_G_WITH_CROSSED_TAIL = chr(43830)
LATIN_SMALL_LETTER_L_WITH_INVERTED_LAZY_S = chr(43831)
LATIN_SMALL_LETTER_L_WITH_DOUBLE_MIDDLE_TILDE = chr(43832)
LATIN_SMALL_LETTER_L_WITH_MIDDLE_RING = chr(43833)
LATIN_SMALL_LETTER_M_WITH_CROSSED_TAIL = chr(43834)
LATIN_SMALL_LETTER_N_WITH_CROSSED_TAIL = chr(43835)
LATIN_SMALL_LETTER_ENG_WITH_CROSSED_TAIL = chr(43836)
LATIN_SMALL_LETTER_BLACKLETTER_O = chr(43837)
LATIN_SMALL_LETTER_BLACKLETTER_O_WITH_STROKE = chr(43838)
LATIN_SMALL_LETTER_OPEN_O_WITH_STROKE = chr(43839)
LATIN_SMALL_LETTER_INVERTED_OE = chr(43840)
LATIN_SMALL_LETTER_TURNED_OE_WITH_STROKE = chr(43841)
LATIN_SMALL_LETTER_TURNED_OE_WITH_HORIZONTAL_STROKE = chr(43842)
LATIN_SMALL_LETTER_TURNED_O_OPEN_O = chr(43843)
LATIN_SMALL_LETTER_TURNED_O_OPEN_O_WITH_STROKE = chr(43844)
LATIN_SMALL_LETTER_STIRRUP_R = chr(43845)
LATIN_LETTER_SMALL_CAPITAL_R_WITH_RIGHT_LEG = chr(43846)
LATIN_SMALL_LETTER_R_WITHOUT_HANDLE = chr(43847)
LATIN_SMALL_LETTER_DOUBLE_R = chr(43848)
LATIN_SMALL_LETTER_R_WITH_CROSSED_TAIL = chr(43849)
LATIN_SMALL_LETTER_DOUBLE_R_WITH_CROSSED_TAIL = chr(43850)
LATIN_SMALL_LETTER_SCRIPT_R = chr(43851)
LATIN_SMALL_LETTER_SCRIPT_R_WITH_RING = chr(43852)
LATIN_SMALL_LETTER_BASELINE_ESH = chr(43853)
LATIN_SMALL_LETTER_U_WITH_SHORT_RIGHT_LEG = chr(43854)
LATIN_SMALL_LETTER_U_BAR_WITH_SHORT_RIGHT_LEG = chr(43855)
LATIN_SMALL_LETTER_UI = chr(43856)
LATIN_SMALL_LETTER_TURNED_UI = chr(43857)
LATIN_SMALL_LETTER_U_WITH_LEFT_HOOK = chr(43858)
LATIN_SMALL_LETTER_CHI = chr(43859)
LATIN_SMALL_LETTER_CHI_WITH_LOW_RIGHT_RING = chr(43860)
LATIN_SMALL_LETTER_CHI_WITH_LOW_LEFT_SERIF = chr(43861)
LATIN_SMALL_LETTER_X_WITH_LOW_RIGHT_RING = chr(43862)
LATIN_SMALL_LETTER_X_WITH_LONG_LEFT_LEG = chr(43863)
LATIN_SMALL_LETTER_X_WITH_LONG_LEFT_LEG_AND_LOW_RIGHT_RING = chr(43864)
LATIN_SMALL_LETTER_X_WITH_LONG_LEFT_LEG_WITH_SERIF = chr(43865)
LATIN_SMALL_LETTER_Y_WITH_SHORT_RIGHT_LEG = chr(43866)
MODIFIER_BREVE_WITH_INVERTED_BREVE = chr(43867)
MODIFIER_LETTER_SMALL_HENG = chr(43868)
MODIFIER_LETTER_SMALL_L_WITH_INVERTED_LAZY_S = chr(43869)
MODIFIER_LETTER_SMALL_L_WITH_MIDDLE_TILDE = chr(43870)
MODIFIER_LETTER_SMALL_U_WITH_LEFT_HOOK = chr(43871)
LATIN_SMALL_LETTER_SAKHA_YAT = chr(43872)
LATIN_SMALL_LETTER_IOTIFIED_E = chr(43873)
LATIN_SMALL_LETTER_OPEN_OE = chr(43874)
LATIN_SMALL_LETTER_UO = chr(43875)
LATIN_SMALL_LETTER_INVERTED_ALPHA = chr(43876)
GREEK_LETTER_SMALL_CAPITAL_OMEGA = chr(43877)
LATIN_SMALL_LETTER_DZ_DIGRAPH_WITH_RETROFLEX_HOOK = chr(43878)
LATIN_SMALL_LETTER_TS_DIGRAPH_WITH_RETROFLEX_HOOK = chr(43879)
LATIN_SMALL_LETTER_TURNED_R_WITH_MIDDLE_TILDE = chr(43880)
MODIFIER_LETTER_SMALL_TURNED_W = chr(43881)
MODIFIER_LETTER_LEFT_TACK = chr(43882)
MODIFIER_LETTER_RIGHT_TACK = chr(43883)
CHEROKEE_SMALL_LETTER_A = chr(43888)
CHEROKEE_SMALL_LETTER_E = chr(43889)
CHEROKEE_SMALL_LETTER_I = chr(43890)
CHEROKEE_SMALL_LETTER_O = chr(43891)
CHEROKEE_SMALL_LETTER_U = chr(43892)
CHEROKEE_SMALL_LETTER_V = chr(43893)
CHEROKEE_SMALL_LETTER_GA = chr(43894)
CHEROKEE_SMALL_LETTER_KA = chr(43895)
CHEROKEE_SMALL_LETTER_GE = chr(43896)
CHEROKEE_SMALL_LETTER_GI = chr(43897)
CHEROKEE_SMALL_LETTER_GO = chr(43898)
CHEROKEE_SMALL_LETTER_GU = chr(43899)
CHEROKEE_SMALL_LETTER_GV = chr(43900)
CHEROKEE_SMALL_LETTER_HA = chr(43901)
CHEROKEE_SMALL_LETTER_HE = chr(43902)
CHEROKEE_SMALL_LETTER_HI = chr(43903)
CHEROKEE_SMALL_LETTER_HO = chr(43904)
CHEROKEE_SMALL_LETTER_HU = chr(43905)
CHEROKEE_SMALL_LETTER_HV = chr(43906)
CHEROKEE_SMALL_LETTER_LA = chr(43907)
CHEROKEE_SMALL_LETTER_LE = chr(43908)
CHEROKEE_SMALL_LETTER_LI = chr(43909)
CHEROKEE_SMALL_LETTER_LO = chr(43910)
CHEROKEE_SMALL_LETTER_LU = chr(43911)
CHEROKEE_SMALL_LETTER_LV = chr(43912)
CHEROKEE_SMALL_LETTER_MA = chr(43913)
CHEROKEE_SMALL_LETTER_ME = chr(43914)
CHEROKEE_SMALL_LETTER_MI = chr(43915)
CHEROKEE_SMALL_LETTER_MO = chr(43916)
CHEROKEE_SMALL_LETTER_MU = chr(43917)
CHEROKEE_SMALL_LETTER_NA = chr(43918)
CHEROKEE_SMALL_LETTER_HNA = chr(43919)
CHEROKEE_SMALL_LETTER_NAH = chr(43920)
CHEROKEE_SMALL_LETTER_NE = chr(43921)
CHEROKEE_SMALL_LETTER_NI = chr(43922)
CHEROKEE_SMALL_LETTER_NO = chr(43923)
CHEROKEE_SMALL_LETTER_NU = chr(43924)
CHEROKEE_SMALL_LETTER_NV = chr(43925)
CHEROKEE_SMALL_LETTER_QUA = chr(43926)
CHEROKEE_SMALL_LETTER_QUE = chr(43927)
CHEROKEE_SMALL_LETTER_QUI = chr(43928)
CHEROKEE_SMALL_LETTER_QUO = chr(43929)
CHEROKEE_SMALL_LETTER_QUU = chr(43930)
CHEROKEE_SMALL_LETTER_QUV = chr(43931)
CHEROKEE_SMALL_LETTER_SA = chr(43932)
CHEROKEE_SMALL_LETTER_S = chr(43933)
CHEROKEE_SMALL_LETTER_SE = chr(43934)
CHEROKEE_SMALL_LETTER_SI = chr(43935)
CHEROKEE_SMALL_LETTER_SO = chr(43936)
CHEROKEE_SMALL_LETTER_SU = chr(43937)
CHEROKEE_SMALL_LETTER_SV = chr(43938)
CHEROKEE_SMALL_LETTER_DA = chr(43939)
CHEROKEE_SMALL_LETTER_TA = chr(43940)
CHEROKEE_SMALL_LETTER_DE = chr(43941)
CHEROKEE_SMALL_LETTER_TE = chr(43942)
CHEROKEE_SMALL_LETTER_DI = chr(43943)
CHEROKEE_SMALL_LETTER_TI = chr(43944)
CHEROKEE_SMALL_LETTER_DO = chr(43945)
CHEROKEE_SMALL_LETTER_DU = chr(43946)
CHEROKEE_SMALL_LETTER_DV = chr(43947)
CHEROKEE_SMALL_LETTER_DLA = chr(43948)
CHEROKEE_SMALL_LETTER_TLA = chr(43949)
CHEROKEE_SMALL_LETTER_TLE = chr(43950)
CHEROKEE_SMALL_LETTER_TLI = chr(43951)
CHEROKEE_SMALL_LETTER_TLO = chr(43952)
CHEROKEE_SMALL_LETTER_TLU = chr(43953)
CHEROKEE_SMALL_LETTER_TLV = chr(43954)
CHEROKEE_SMALL_LETTER_TSA = chr(43955)
CHEROKEE_SMALL_LETTER_TSE = chr(43956)
CHEROKEE_SMALL_LETTER_TSI = chr(43957)
CHEROKEE_SMALL_LETTER_TSO = chr(43958)
CHEROKEE_SMALL_LETTER_TSU = chr(43959)
CHEROKEE_SMALL_LETTER_TSV = chr(43960)
CHEROKEE_SMALL_LETTER_WA = chr(43961)
CHEROKEE_SMALL_LETTER_WE = chr(43962)
CHEROKEE_SMALL_LETTER_WI = chr(43963)
CHEROKEE_SMALL_LETTER_WO = chr(43964)
CHEROKEE_SMALL_LETTER_WU = chr(43965)
CHEROKEE_SMALL_LETTER_WV = chr(43966)
CHEROKEE_SMALL_LETTER_YA = chr(43967)
MEETEI_MAYEK_LETTER_KOK = chr(43968)
MEETEI_MAYEK_LETTER_SAM = chr(43969)
MEETEI_MAYEK_LETTER_LAI = chr(43970)
MEETEI_MAYEK_LETTER_MIT = chr(43971)
MEETEI_MAYEK_LETTER_PA = chr(43972)
MEETEI_MAYEK_LETTER_NA = chr(43973)
MEETEI_MAYEK_LETTER_CHIL = chr(43974)
MEETEI_MAYEK_LETTER_TIL = chr(43975)
MEETEI_MAYEK_LETTER_KHOU = chr(43976)
MEETEI_MAYEK_LETTER_NGOU = chr(43977)
MEETEI_MAYEK_LETTER_THOU = chr(43978)
MEETEI_MAYEK_LETTER_WAI = chr(43979)
MEETEI_MAYEK_LETTER_YANG = chr(43980)
MEETEI_MAYEK_LETTER_HUK = chr(43981)
MEETEI_MAYEK_LETTER_UN = chr(43982)
MEETEI_MAYEK_LETTER_I = chr(43983)
MEETEI_MAYEK_LETTER_PHAM = chr(43984)
MEETEI_MAYEK_LETTER_ATIYA = chr(43985)
MEETEI_MAYEK_LETTER_GOK = chr(43986)
MEETEI_MAYEK_LETTER_JHAM = chr(43987)
MEETEI_MAYEK_LETTER_RAI = chr(43988)
MEETEI_MAYEK_LETTER_BA = chr(43989)
MEETEI_MAYEK_LETTER_JIL = chr(43990)
MEETEI_MAYEK_LETTER_DIL = chr(43991)
MEETEI_MAYEK_LETTER_GHOU = chr(43992)
MEETEI_MAYEK_LETTER_DHOU = chr(43993)
MEETEI_MAYEK_LETTER_BHAM = chr(43994)
MEETEI_MAYEK_LETTER_KOK_LONSUM = chr(43995)
MEETEI_MAYEK_LETTER_LAI_LONSUM = chr(43996)
MEETEI_MAYEK_LETTER_MIT_LONSUM = chr(43997)
MEETEI_MAYEK_LETTER_PA_LONSUM = chr(43998)
MEETEI_MAYEK_LETTER_NA_LONSUM = chr(43999)
MEETEI_MAYEK_LETTER_TIL_LONSUM = chr(44000)
MEETEI_MAYEK_LETTER_NGOU_LONSUM = chr(44001)
MEETEI_MAYEK_LETTER_I_LONSUM = chr(44002)
MEETEI_MAYEK_VOWEL_SIGN_ONAP = chr(44003)
MEETEI_MAYEK_VOWEL_SIGN_INAP = chr(44004)
MEETEI_MAYEK_VOWEL_SIGN_ANAP = chr(44005)
MEETEI_MAYEK_VOWEL_SIGN_YENAP = chr(44006)
MEETEI_MAYEK_VOWEL_SIGN_SOUNAP = chr(44007)
MEETEI_MAYEK_VOWEL_SIGN_UNAP = chr(44008)
MEETEI_MAYEK_VOWEL_SIGN_CHEINAP = chr(44009)
MEETEI_MAYEK_VOWEL_SIGN_NUNG = chr(44010)
MEETEI_MAYEK_CHEIKHEI = chr(44011)
MEETEI_MAYEK_LUM_IYEK = chr(44012)
MEETEI_MAYEK_APUN_IYEK = chr(44013)
MEETEI_MAYEK_DIGIT_ZERO = chr(44016)
MEETEI_MAYEK_DIGIT_ONE = chr(44017)
MEETEI_MAYEK_DIGIT_TWO = chr(44018)
MEETEI_MAYEK_DIGIT_THREE = chr(44019)
MEETEI_MAYEK_DIGIT_FOUR = chr(44020)
MEETEI_MAYEK_DIGIT_FIVE = chr(44021)
MEETEI_MAYEK_DIGIT_SIX = chr(44022)
MEETEI_MAYEK_DIGIT_SEVEN = chr(44023)
MEETEI_MAYEK_DIGIT_EIGHT = chr(44024)
MEETEI_MAYEK_DIGIT_NINE = chr(44025)
HANGUL_JUNGSEONG_O_YEO = chr(55216)
HANGUL_JUNGSEONG_O_O_I = chr(55217)
HANGUL_JUNGSEONG_YO_A = chr(55218)
HANGUL_JUNGSEONG_YO_AE = chr(55219)
HANGUL_JUNGSEONG_YO_EO = chr(55220)
HANGUL_JUNGSEONG_U_YEO = chr(55221)
HANGUL_JUNGSEONG_U_I_I = chr(55222)
HANGUL_JUNGSEONG_YU_AE = chr(55223)
HANGUL_JUNGSEONG_YU_O = chr(55224)
HANGUL_JUNGSEONG_EU_A = chr(55225)
HANGUL_JUNGSEONG_EU_EO = chr(55226)
HANGUL_JUNGSEONG_EU_E = chr(55227)
HANGUL_JUNGSEONG_EU_O = chr(55228)
HANGUL_JUNGSEONG_I_YA_O = chr(55229)
HANGUL_JUNGSEONG_I_YAE = chr(55230)
HANGUL_JUNGSEONG_I_YEO = chr(55231)
HANGUL_JUNGSEONG_I_YE = chr(55232)
HANGUL_JUNGSEONG_I_O_I = chr(55233)
HANGUL_JUNGSEONG_I_YO = chr(55234)
HANGUL_JUNGSEONG_I_YU = chr(55235)
HANGUL_JUNGSEONG_I_I = chr(55236)
HANGUL_JUNGSEONG_ARAEA_A = chr(55237)
HANGUL_JUNGSEONG_ARAEA_E = chr(55238)
HANGUL_JONGSEONG_NIEUN_RIEUL = chr(55243)
HANGUL_JONGSEONG_NIEUN_CHIEUCH = chr(55244)
HANGUL_JONGSEONG_SSANGTIKEUT = chr(55245)
HANGUL_JONGSEONG_SSANGTIKEUT_PIEUP = chr(55246)
HANGUL_JONGSEONG_TIKEUT_PIEUP = chr(55247)
HANGUL_JONGSEONG_TIKEUT_SIOS = chr(55248)
HANGUL_JONGSEONG_TIKEUT_SIOS_KIYEOK = chr(55249)
HANGUL_JONGSEONG_TIKEUT_CIEUC = chr(55250)
HANGUL_JONGSEONG_TIKEUT_CHIEUCH = chr(55251)
HANGUL_JONGSEONG_TIKEUT_THIEUTH = chr(55252)
HANGUL_JONGSEONG_RIEUL_SSANGKIYEOK = chr(55253)
HANGUL_JONGSEONG_RIEUL_KIYEOK_HIEUH = chr(55254)
HANGUL_JONGSEONG_SSANGRIEUL_KHIEUKH = chr(55255)
HANGUL_JONGSEONG_RIEUL_MIEUM_HIEUH = chr(55256)
HANGUL_JONGSEONG_RIEUL_PIEUP_TIKEUT = chr(55257)
HANGUL_JONGSEONG_RIEUL_PIEUP_PHIEUPH = chr(55258)
HANGUL_JONGSEONG_RIEUL_YESIEUNG = chr(55259)
HANGUL_JONGSEONG_RIEUL_YEORINHIEUH_HIEUH = chr(55260)
HANGUL_JONGSEONG_KAPYEOUNRIEUL = chr(55261)
HANGUL_JONGSEONG_MIEUM_NIEUN = chr(55262)
HANGUL_JONGSEONG_MIEUM_SSANGNIEUN = chr(55263)
HANGUL_JONGSEONG_SSANGMIEUM = chr(55264)
HANGUL_JONGSEONG_MIEUM_PIEUP_SIOS = chr(55265)
HANGUL_JONGSEONG_MIEUM_CIEUC = chr(55266)
HANGUL_JONGSEONG_PIEUP_TIKEUT = chr(55267)
HANGUL_JONGSEONG_PIEUP_RIEUL_PHIEUPH = chr(55268)
HANGUL_JONGSEONG_PIEUP_MIEUM = chr(55269)
HANGUL_JONGSEONG_SSANGPIEUP = chr(55270)
HANGUL_JONGSEONG_PIEUP_SIOS_TIKEUT = chr(55271)
HANGUL_JONGSEONG_PIEUP_CIEUC = chr(55272)
HANGUL_JONGSEONG_PIEUP_CHIEUCH = chr(55273)
HANGUL_JONGSEONG_SIOS_MIEUM = chr(55274)
HANGUL_JONGSEONG_SIOS_KAPYEOUNPIEUP = chr(55275)
HANGUL_JONGSEONG_SSANGSIOS_KIYEOK = chr(55276)
HANGUL_JONGSEONG_SSANGSIOS_TIKEUT = chr(55277)
HANGUL_JONGSEONG_SIOS_PANSIOS = chr(55278)
HANGUL_JONGSEONG_SIOS_CIEUC = chr(55279)
HANGUL_JONGSEONG_SIOS_CHIEUCH = chr(55280)
HANGUL_JONGSEONG_SIOS_THIEUTH = chr(55281)
HANGUL_JONGSEONG_SIOS_HIEUH = chr(55282)
HANGUL_JONGSEONG_PANSIOS_PIEUP = chr(55283)
HANGUL_JONGSEONG_PANSIOS_KAPYEOUNPIEUP = chr(55284)
HANGUL_JONGSEONG_YESIEUNG_MIEUM = chr(55285)
HANGUL_JONGSEONG_YESIEUNG_HIEUH = chr(55286)
HANGUL_JONGSEONG_CIEUC_PIEUP = chr(55287)
HANGUL_JONGSEONG_CIEUC_SSANGPIEUP = chr(55288)
HANGUL_JONGSEONG_SSANGCIEUC = chr(55289)
HANGUL_JONGSEONG_PHIEUPH_SIOS = chr(55290)
HANGUL_JONGSEONG_PHIEUPH_THIEUTH = chr(55291)
CJK_COMPATIBILITY_IDEOGRAPH_F900 = chr(63744)
CJK_COMPATIBILITY_IDEOGRAPH_F901 = chr(63745)
CJK_COMPATIBILITY_IDEOGRAPH_F902 = chr(63746)
CJK_COMPATIBILITY_IDEOGRAPH_F903 = chr(63747)
CJK_COMPATIBILITY_IDEOGRAPH_F904 = chr(63748)
CJK_COMPATIBILITY_IDEOGRAPH_F905 = chr(63749)
CJK_COMPATIBILITY_IDEOGRAPH_F906 = chr(63750)
CJK_COMPATIBILITY_IDEOGRAPH_F907 = chr(63751)
CJK_COMPATIBILITY_IDEOGRAPH_F908 = chr(63752)
CJK_COMPATIBILITY_IDEOGRAPH_F909 = chr(63753)
CJK_COMPATIBILITY_IDEOGRAPH_F90A = chr(63754)
CJK_COMPATIBILITY_IDEOGRAPH_F90B = chr(63755)
CJK_COMPATIBILITY_IDEOGRAPH_F90C = chr(63756)
CJK_COMPATIBILITY_IDEOGRAPH_F90D = chr(63757)
CJK_COMPATIBILITY_IDEOGRAPH_F90E = chr(63758)
CJK_COMPATIBILITY_IDEOGRAPH_F90F = chr(63759)
CJK_COMPATIBILITY_IDEOGRAPH_F910 = chr(63760)
CJK_COMPATIBILITY_IDEOGRAPH_F911 = chr(63761)
CJK_COMPATIBILITY_IDEOGRAPH_F912 = chr(63762)
CJK_COMPATIBILITY_IDEOGRAPH_F913 = chr(63763)
CJK_COMPATIBILITY_IDEOGRAPH_F914 = chr(63764)
CJK_COMPATIBILITY_IDEOGRAPH_F915 = chr(63765)
CJK_COMPATIBILITY_IDEOGRAPH_F916 = chr(63766)
CJK_COMPATIBILITY_IDEOGRAPH_F917 = chr(63767)
CJK_COMPATIBILITY_IDEOGRAPH_F918 = chr(63768)
CJK_COMPATIBILITY_IDEOGRAPH_F919 = chr(63769)
CJK_COMPATIBILITY_IDEOGRAPH_F91A = chr(63770)
CJK_COMPATIBILITY_IDEOGRAPH_F91B = chr(63771)
CJK_COMPATIBILITY_IDEOGRAPH_F91C = chr(63772)
CJK_COMPATIBILITY_IDEOGRAPH_F91D = chr(63773)
CJK_COMPATIBILITY_IDEOGRAPH_F91E = chr(63774)
CJK_COMPATIBILITY_IDEOGRAPH_F91F = chr(63775)
CJK_COMPATIBILITY_IDEOGRAPH_F920 = chr(63776)
CJK_COMPATIBILITY_IDEOGRAPH_F921 = chr(63777)
CJK_COMPATIBILITY_IDEOGRAPH_F922 = chr(63778)
CJK_COMPATIBILITY_IDEOGRAPH_F923 = chr(63779)
CJK_COMPATIBILITY_IDEOGRAPH_F924 = chr(63780)
CJK_COMPATIBILITY_IDEOGRAPH_F925 = chr(63781)
CJK_COMPATIBILITY_IDEOGRAPH_F926 = chr(63782)
CJK_COMPATIBILITY_IDEOGRAPH_F927 = chr(63783)
CJK_COMPATIBILITY_IDEOGRAPH_F928 = chr(63784)
CJK_COMPATIBILITY_IDEOGRAPH_F929 = chr(63785)
CJK_COMPATIBILITY_IDEOGRAPH_F92A = chr(63786)
CJK_COMPATIBILITY_IDEOGRAPH_F92B = chr(63787)
CJK_COMPATIBILITY_IDEOGRAPH_F92C = chr(63788)
CJK_COMPATIBILITY_IDEOGRAPH_F92D = chr(63789)
CJK_COMPATIBILITY_IDEOGRAPH_F92E = chr(63790)
CJK_COMPATIBILITY_IDEOGRAPH_F92F = chr(63791)
CJK_COMPATIBILITY_IDEOGRAPH_F930 = chr(63792)
CJK_COMPATIBILITY_IDEOGRAPH_F931 = chr(63793)
CJK_COMPATIBILITY_IDEOGRAPH_F932 = chr(63794)
CJK_COMPATIBILITY_IDEOGRAPH_F933 = chr(63795)
CJK_COMPATIBILITY_IDEOGRAPH_F934 = chr(63796)
CJK_COMPATIBILITY_IDEOGRAPH_F935 = chr(63797)
CJK_COMPATIBILITY_IDEOGRAPH_F936 = chr(63798)
CJK_COMPATIBILITY_IDEOGRAPH_F937 = chr(63799)
CJK_COMPATIBILITY_IDEOGRAPH_F938 = chr(63800)
CJK_COMPATIBILITY_IDEOGRAPH_F939 = chr(63801)
CJK_COMPATIBILITY_IDEOGRAPH_F93A = chr(63802)
CJK_COMPATIBILITY_IDEOGRAPH_F93B = chr(63803)
CJK_COMPATIBILITY_IDEOGRAPH_F93C = chr(63804)
CJK_COMPATIBILITY_IDEOGRAPH_F93D = chr(63805)
CJK_COMPATIBILITY_IDEOGRAPH_F93E = chr(63806)
CJK_COMPATIBILITY_IDEOGRAPH_F93F = chr(63807)
CJK_COMPATIBILITY_IDEOGRAPH_F940 = chr(63808)
CJK_COMPATIBILITY_IDEOGRAPH_F941 = chr(63809)
CJK_COMPATIBILITY_IDEOGRAPH_F942 = chr(63810)
CJK_COMPATIBILITY_IDEOGRAPH_F943 = chr(63811)
CJK_COMPATIBILITY_IDEOGRAPH_F944 = chr(63812)
CJK_COMPATIBILITY_IDEOGRAPH_F945 = chr(63813)
CJK_COMPATIBILITY_IDEOGRAPH_F946 = chr(63814)
CJK_COMPATIBILITY_IDEOGRAPH_F947 = chr(63815)
CJK_COMPATIBILITY_IDEOGRAPH_F948 = chr(63816)
CJK_COMPATIBILITY_IDEOGRAPH_F949 = chr(63817)
CJK_COMPATIBILITY_IDEOGRAPH_F94A = chr(63818)
CJK_COMPATIBILITY_IDEOGRAPH_F94B = chr(63819)
CJK_COMPATIBILITY_IDEOGRAPH_F94C = chr(63820)
CJK_COMPATIBILITY_IDEOGRAPH_F94D = chr(63821)
CJK_COMPATIBILITY_IDEOGRAPH_F94E = chr(63822)
CJK_COMPATIBILITY_IDEOGRAPH_F94F = chr(63823)
CJK_COMPATIBILITY_IDEOGRAPH_F950 = chr(63824)
CJK_COMPATIBILITY_IDEOGRAPH_F951 = chr(63825)
CJK_COMPATIBILITY_IDEOGRAPH_F952 = chr(63826)
CJK_COMPATIBILITY_IDEOGRAPH_F953 = chr(63827)
CJK_COMPATIBILITY_IDEOGRAPH_F954 = chr(63828)
CJK_COMPATIBILITY_IDEOGRAPH_F955 = chr(63829)
CJK_COMPATIBILITY_IDEOGRAPH_F956 = chr(63830)
CJK_COMPATIBILITY_IDEOGRAPH_F957 = chr(63831)
CJK_COMPATIBILITY_IDEOGRAPH_F958 = chr(63832)
CJK_COMPATIBILITY_IDEOGRAPH_F959 = chr(63833)
CJK_COMPATIBILITY_IDEOGRAPH_F95A = chr(63834)
CJK_COMPATIBILITY_IDEOGRAPH_F95B = chr(63835)
CJK_COMPATIBILITY_IDEOGRAPH_F95C = chr(63836)
CJK_COMPATIBILITY_IDEOGRAPH_F95D = chr(63837)
CJK_COMPATIBILITY_IDEOGRAPH_F95E = chr(63838)
CJK_COMPATIBILITY_IDEOGRAPH_F95F = chr(63839)
CJK_COMPATIBILITY_IDEOGRAPH_F960 = chr(63840)
CJK_COMPATIBILITY_IDEOGRAPH_F961 = chr(63841)
CJK_COMPATIBILITY_IDEOGRAPH_F962 = chr(63842)
CJK_COMPATIBILITY_IDEOGRAPH_F963 = chr(63843)
CJK_COMPATIBILITY_IDEOGRAPH_F964 = chr(63844)
CJK_COMPATIBILITY_IDEOGRAPH_F965 = chr(63845)
CJK_COMPATIBILITY_IDEOGRAPH_F966 = chr(63846)
CJK_COMPATIBILITY_IDEOGRAPH_F967 = chr(63847)
CJK_COMPATIBILITY_IDEOGRAPH_F968 = chr(63848)
CJK_COMPATIBILITY_IDEOGRAPH_F969 = chr(63849)
CJK_COMPATIBILITY_IDEOGRAPH_F96A = chr(63850)
CJK_COMPATIBILITY_IDEOGRAPH_F96B = chr(63851)
CJK_COMPATIBILITY_IDEOGRAPH_F96C = chr(63852)
CJK_COMPATIBILITY_IDEOGRAPH_F96D = chr(63853)
CJK_COMPATIBILITY_IDEOGRAPH_F96E = chr(63854)
CJK_COMPATIBILITY_IDEOGRAPH_F96F = chr(63855)
CJK_COMPATIBILITY_IDEOGRAPH_F970 = chr(63856)
CJK_COMPATIBILITY_IDEOGRAPH_F971 = chr(63857)
CJK_COMPATIBILITY_IDEOGRAPH_F972 = chr(63858)
CJK_COMPATIBILITY_IDEOGRAPH_F973 = chr(63859)
CJK_COMPATIBILITY_IDEOGRAPH_F974 = chr(63860)
CJK_COMPATIBILITY_IDEOGRAPH_F975 = chr(63861)
CJK_COMPATIBILITY_IDEOGRAPH_F976 = chr(63862)
CJK_COMPATIBILITY_IDEOGRAPH_F977 = chr(63863)
CJK_COMPATIBILITY_IDEOGRAPH_F978 = chr(63864)
CJK_COMPATIBILITY_IDEOGRAPH_F979 = chr(63865)
CJK_COMPATIBILITY_IDEOGRAPH_F97A = chr(63866)
CJK_COMPATIBILITY_IDEOGRAPH_F97B = chr(63867)
CJK_COMPATIBILITY_IDEOGRAPH_F97C = chr(63868)
CJK_COMPATIBILITY_IDEOGRAPH_F97D = chr(63869)
CJK_COMPATIBILITY_IDEOGRAPH_F97E = chr(63870)
CJK_COMPATIBILITY_IDEOGRAPH_F97F = chr(63871)
CJK_COMPATIBILITY_IDEOGRAPH_F980 = chr(63872)
CJK_COMPATIBILITY_IDEOGRAPH_F981 = chr(63873)
CJK_COMPATIBILITY_IDEOGRAPH_F982 = chr(63874)
CJK_COMPATIBILITY_IDEOGRAPH_F983 = chr(63875)
CJK_COMPATIBILITY_IDEOGRAPH_F984 = chr(63876)
CJK_COMPATIBILITY_IDEOGRAPH_F985 = chr(63877)
CJK_COMPATIBILITY_IDEOGRAPH_F986 = chr(63878)
CJK_COMPATIBILITY_IDEOGRAPH_F987 = chr(63879)
CJK_COMPATIBILITY_IDEOGRAPH_F988 = chr(63880)
CJK_COMPATIBILITY_IDEOGRAPH_F989 = chr(63881)
CJK_COMPATIBILITY_IDEOGRAPH_F98A = chr(63882)
CJK_COMPATIBILITY_IDEOGRAPH_F98B = chr(63883)
CJK_COMPATIBILITY_IDEOGRAPH_F98C = chr(63884)
CJK_COMPATIBILITY_IDEOGRAPH_F98D = chr(63885)
CJK_COMPATIBILITY_IDEOGRAPH_F98E = chr(63886)
CJK_COMPATIBILITY_IDEOGRAPH_F98F = chr(63887)
CJK_COMPATIBILITY_IDEOGRAPH_F990 = chr(63888)
CJK_COMPATIBILITY_IDEOGRAPH_F991 = chr(63889)
CJK_COMPATIBILITY_IDEOGRAPH_F992 = chr(63890)
CJK_COMPATIBILITY_IDEOGRAPH_F993 = chr(63891)
CJK_COMPATIBILITY_IDEOGRAPH_F994 = chr(63892)
CJK_COMPATIBILITY_IDEOGRAPH_F995 = chr(63893)
CJK_COMPATIBILITY_IDEOGRAPH_F996 = chr(63894)
CJK_COMPATIBILITY_IDEOGRAPH_F997 = chr(63895)
CJK_COMPATIBILITY_IDEOGRAPH_F998 = chr(63896)
CJK_COMPATIBILITY_IDEOGRAPH_F999 = chr(63897)
CJK_COMPATIBILITY_IDEOGRAPH_F99A = chr(63898)
CJK_COMPATIBILITY_IDEOGRAPH_F99B = chr(63899)
CJK_COMPATIBILITY_IDEOGRAPH_F99C = chr(63900)
CJK_COMPATIBILITY_IDEOGRAPH_F99D = chr(63901)
CJK_COMPATIBILITY_IDEOGRAPH_F99E = chr(63902)
CJK_COMPATIBILITY_IDEOGRAPH_F99F = chr(63903)
CJK_COMPATIBILITY_IDEOGRAPH_F9A0 = chr(63904)
CJK_COMPATIBILITY_IDEOGRAPH_F9A1 = chr(63905)
CJK_COMPATIBILITY_IDEOGRAPH_F9A2 = chr(63906)
CJK_COMPATIBILITY_IDEOGRAPH_F9A3 = chr(63907)
CJK_COMPATIBILITY_IDEOGRAPH_F9A4 = chr(63908)
CJK_COMPATIBILITY_IDEOGRAPH_F9A5 = chr(63909)
CJK_COMPATIBILITY_IDEOGRAPH_F9A6 = chr(63910)
CJK_COMPATIBILITY_IDEOGRAPH_F9A7 = chr(63911)
CJK_COMPATIBILITY_IDEOGRAPH_F9A8 = chr(63912)
CJK_COMPATIBILITY_IDEOGRAPH_F9A9 = chr(63913)
CJK_COMPATIBILITY_IDEOGRAPH_F9AA = chr(63914)
CJK_COMPATIBILITY_IDEOGRAPH_F9AB = chr(63915)
CJK_COMPATIBILITY_IDEOGRAPH_F9AC = chr(63916)
CJK_COMPATIBILITY_IDEOGRAPH_F9AD = chr(63917)
CJK_COMPATIBILITY_IDEOGRAPH_F9AE = chr(63918)
CJK_COMPATIBILITY_IDEOGRAPH_F9AF = chr(63919)
CJK_COMPATIBILITY_IDEOGRAPH_F9B0 = chr(63920)
CJK_COMPATIBILITY_IDEOGRAPH_F9B1 = chr(63921)
CJK_COMPATIBILITY_IDEOGRAPH_F9B2 = chr(63922)
CJK_COMPATIBILITY_IDEOGRAPH_F9B3 = chr(63923)
CJK_COMPATIBILITY_IDEOGRAPH_F9B4 = chr(63924)
CJK_COMPATIBILITY_IDEOGRAPH_F9B5 = chr(63925)
CJK_COMPATIBILITY_IDEOGRAPH_F9B6 = chr(63926)
CJK_COMPATIBILITY_IDEOGRAPH_F9B7 = chr(63927)
CJK_COMPATIBILITY_IDEOGRAPH_F9B8 = chr(63928)
CJK_COMPATIBILITY_IDEOGRAPH_F9B9 = chr(63929)
CJK_COMPATIBILITY_IDEOGRAPH_F9BA = chr(63930)
CJK_COMPATIBILITY_IDEOGRAPH_F9BB = chr(63931)
CJK_COMPATIBILITY_IDEOGRAPH_F9BC = chr(63932)
CJK_COMPATIBILITY_IDEOGRAPH_F9BD = chr(63933)
CJK_COMPATIBILITY_IDEOGRAPH_F9BE = chr(63934)
CJK_COMPATIBILITY_IDEOGRAPH_F9BF = chr(63935)
CJK_COMPATIBILITY_IDEOGRAPH_F9C0 = chr(63936)
CJK_COMPATIBILITY_IDEOGRAPH_F9C1 = chr(63937)
CJK_COMPATIBILITY_IDEOGRAPH_F9C2 = chr(63938)
CJK_COMPATIBILITY_IDEOGRAPH_F9C3 = chr(63939)
CJK_COMPATIBILITY_IDEOGRAPH_F9C4 = chr(63940)
CJK_COMPATIBILITY_IDEOGRAPH_F9C5 = chr(63941)
CJK_COMPATIBILITY_IDEOGRAPH_F9C6 = chr(63942)
CJK_COMPATIBILITY_IDEOGRAPH_F9C7 = chr(63943)
CJK_COMPATIBILITY_IDEOGRAPH_F9C8 = chr(63944)
CJK_COMPATIBILITY_IDEOGRAPH_F9C9 = chr(63945)
CJK_COMPATIBILITY_IDEOGRAPH_F9CA = chr(63946)
CJK_COMPATIBILITY_IDEOGRAPH_F9CB = chr(63947)
CJK_COMPATIBILITY_IDEOGRAPH_F9CC = chr(63948)
CJK_COMPATIBILITY_IDEOGRAPH_F9CD = chr(63949)
CJK_COMPATIBILITY_IDEOGRAPH_F9CE = chr(63950)
CJK_COMPATIBILITY_IDEOGRAPH_F9CF = chr(63951)
CJK_COMPATIBILITY_IDEOGRAPH_F9D0 = chr(63952)
CJK_COMPATIBILITY_IDEOGRAPH_F9D1 = chr(63953)
CJK_COMPATIBILITY_IDEOGRAPH_F9D2 = chr(63954)
CJK_COMPATIBILITY_IDEOGRAPH_F9D3 = chr(63955)
CJK_COMPATIBILITY_IDEOGRAPH_F9D4 = chr(63956)
CJK_COMPATIBILITY_IDEOGRAPH_F9D5 = chr(63957)
CJK_COMPATIBILITY_IDEOGRAPH_F9D6 = chr(63958)
CJK_COMPATIBILITY_IDEOGRAPH_F9D7 = chr(63959)
CJK_COMPATIBILITY_IDEOGRAPH_F9D8 = chr(63960)
CJK_COMPATIBILITY_IDEOGRAPH_F9D9 = chr(63961)
CJK_COMPATIBILITY_IDEOGRAPH_F9DA = chr(63962)
CJK_COMPATIBILITY_IDEOGRAPH_F9DB = chr(63963)
CJK_COMPATIBILITY_IDEOGRAPH_F9DC = chr(63964)
CJK_COMPATIBILITY_IDEOGRAPH_F9DD = chr(63965)
CJK_COMPATIBILITY_IDEOGRAPH_F9DE = chr(63966)
CJK_COMPATIBILITY_IDEOGRAPH_F9DF = chr(63967)
CJK_COMPATIBILITY_IDEOGRAPH_F9E0 = chr(63968)
CJK_COMPATIBILITY_IDEOGRAPH_F9E1 = chr(63969)
CJK_COMPATIBILITY_IDEOGRAPH_F9E2 = chr(63970)
CJK_COMPATIBILITY_IDEOGRAPH_F9E3 = chr(63971)
CJK_COMPATIBILITY_IDEOGRAPH_F9E4 = chr(63972)
CJK_COMPATIBILITY_IDEOGRAPH_F9E5 = chr(63973)
CJK_COMPATIBILITY_IDEOGRAPH_F9E6 = chr(63974)
CJK_COMPATIBILITY_IDEOGRAPH_F9E7 = chr(63975)
CJK_COMPATIBILITY_IDEOGRAPH_F9E8 = chr(63976)
CJK_COMPATIBILITY_IDEOGRAPH_F9E9 = chr(63977)
CJK_COMPATIBILITY_IDEOGRAPH_F9EA = chr(63978)
CJK_COMPATIBILITY_IDEOGRAPH_F9EB = chr(63979)
CJK_COMPATIBILITY_IDEOGRAPH_F9EC = chr(63980)
CJK_COMPATIBILITY_IDEOGRAPH_F9ED = chr(63981)
CJK_COMPATIBILITY_IDEOGRAPH_F9EE = chr(63982)
CJK_COMPATIBILITY_IDEOGRAPH_F9EF = chr(63983)
CJK_COMPATIBILITY_IDEOGRAPH_F9F0 = chr(63984)
CJK_COMPATIBILITY_IDEOGRAPH_F9F1 = chr(63985)
CJK_COMPATIBILITY_IDEOGRAPH_F9F2 = chr(63986)
CJK_COMPATIBILITY_IDEOGRAPH_F9F3 = chr(63987)
CJK_COMPATIBILITY_IDEOGRAPH_F9F4 = chr(63988)
CJK_COMPATIBILITY_IDEOGRAPH_F9F5 = chr(63989)
CJK_COMPATIBILITY_IDEOGRAPH_F9F6 = chr(63990)
CJK_COMPATIBILITY_IDEOGRAPH_F9F7 = chr(63991)
CJK_COMPATIBILITY_IDEOGRAPH_F9F8 = chr(63992)
CJK_COMPATIBILITY_IDEOGRAPH_F9F9 = chr(63993)
CJK_COMPATIBILITY_IDEOGRAPH_F9FA = chr(63994)
CJK_COMPATIBILITY_IDEOGRAPH_F9FB = chr(63995)
CJK_COMPATIBILITY_IDEOGRAPH_F9FC = chr(63996)
CJK_COMPATIBILITY_IDEOGRAPH_F9FD = chr(63997)
CJK_COMPATIBILITY_IDEOGRAPH_F9FE = chr(63998)
CJK_COMPATIBILITY_IDEOGRAPH_F9FF = chr(63999)
CJK_COMPATIBILITY_IDEOGRAPH_FA00 = chr(64000)
CJK_COMPATIBILITY_IDEOGRAPH_FA01 = chr(64001)
CJK_COMPATIBILITY_IDEOGRAPH_FA02 = chr(64002)
CJK_COMPATIBILITY_IDEOGRAPH_FA03 = chr(64003)
CJK_COMPATIBILITY_IDEOGRAPH_FA04 = chr(64004)
CJK_COMPATIBILITY_IDEOGRAPH_FA05 = chr(64005)
CJK_COMPATIBILITY_IDEOGRAPH_FA06 = chr(64006)
CJK_COMPATIBILITY_IDEOGRAPH_FA07 = chr(64007)
CJK_COMPATIBILITY_IDEOGRAPH_FA08 = chr(64008)
CJK_COMPATIBILITY_IDEOGRAPH_FA09 = chr(64009)
CJK_COMPATIBILITY_IDEOGRAPH_FA0A = chr(64010)
CJK_COMPATIBILITY_IDEOGRAPH_FA0B = chr(64011)
CJK_COMPATIBILITY_IDEOGRAPH_FA0C = chr(64012)
CJK_COMPATIBILITY_IDEOGRAPH_FA0D = chr(64013)
CJK_COMPATIBILITY_IDEOGRAPH_FA0E = chr(64014)
CJK_COMPATIBILITY_IDEOGRAPH_FA0F = chr(64015)
CJK_COMPATIBILITY_IDEOGRAPH_FA10 = chr(64016)
CJK_COMPATIBILITY_IDEOGRAPH_FA11 = chr(64017)
CJK_COMPATIBILITY_IDEOGRAPH_FA12 = chr(64018)
CJK_COMPATIBILITY_IDEOGRAPH_FA13 = chr(64019)
CJK_COMPATIBILITY_IDEOGRAPH_FA14 = chr(64020)
CJK_COMPATIBILITY_IDEOGRAPH_FA15 = chr(64021)
CJK_COMPATIBILITY_IDEOGRAPH_FA16 = chr(64022)
CJK_COMPATIBILITY_IDEOGRAPH_FA17 = chr(64023)
CJK_COMPATIBILITY_IDEOGRAPH_FA18 = chr(64024)
CJK_COMPATIBILITY_IDEOGRAPH_FA19 = chr(64025)
CJK_COMPATIBILITY_IDEOGRAPH_FA1A = chr(64026)
CJK_COMPATIBILITY_IDEOGRAPH_FA1B = chr(64027)
CJK_COMPATIBILITY_IDEOGRAPH_FA1C = chr(64028)
CJK_COMPATIBILITY_IDEOGRAPH_FA1D = chr(64029)
CJK_COMPATIBILITY_IDEOGRAPH_FA1E = chr(64030)
CJK_COMPATIBILITY_IDEOGRAPH_FA1F = chr(64031)
CJK_COMPATIBILITY_IDEOGRAPH_FA20 = chr(64032)
CJK_COMPATIBILITY_IDEOGRAPH_FA21 = chr(64033)
CJK_COMPATIBILITY_IDEOGRAPH_FA22 = chr(64034)
CJK_COMPATIBILITY_IDEOGRAPH_FA23 = chr(64035)
CJK_COMPATIBILITY_IDEOGRAPH_FA24 = chr(64036)
CJK_COMPATIBILITY_IDEOGRAPH_FA25 = chr(64037)
CJK_COMPATIBILITY_IDEOGRAPH_FA26 = chr(64038)
CJK_COMPATIBILITY_IDEOGRAPH_FA27 = chr(64039)
CJK_COMPATIBILITY_IDEOGRAPH_FA28 = chr(64040)
CJK_COMPATIBILITY_IDEOGRAPH_FA29 = chr(64041)
CJK_COMPATIBILITY_IDEOGRAPH_FA2A = chr(64042)
CJK_COMPATIBILITY_IDEOGRAPH_FA2B = chr(64043)
CJK_COMPATIBILITY_IDEOGRAPH_FA2C = chr(64044)
CJK_COMPATIBILITY_IDEOGRAPH_FA2D = chr(64045)
CJK_COMPATIBILITY_IDEOGRAPH_FA2E = chr(64046)
CJK_COMPATIBILITY_IDEOGRAPH_FA2F = chr(64047)
CJK_COMPATIBILITY_IDEOGRAPH_FA30 = chr(64048)
CJK_COMPATIBILITY_IDEOGRAPH_FA31 = chr(64049)
CJK_COMPATIBILITY_IDEOGRAPH_FA32 = chr(64050)
CJK_COMPATIBILITY_IDEOGRAPH_FA33 = chr(64051)
CJK_COMPATIBILITY_IDEOGRAPH_FA34 = chr(64052)
CJK_COMPATIBILITY_IDEOGRAPH_FA35 = chr(64053)
CJK_COMPATIBILITY_IDEOGRAPH_FA36 = chr(64054)
CJK_COMPATIBILITY_IDEOGRAPH_FA37 = chr(64055)
CJK_COMPATIBILITY_IDEOGRAPH_FA38 = chr(64056)
CJK_COMPATIBILITY_IDEOGRAPH_FA39 = chr(64057)
CJK_COMPATIBILITY_IDEOGRAPH_FA3A = chr(64058)
CJK_COMPATIBILITY_IDEOGRAPH_FA3B = chr(64059)
CJK_COMPATIBILITY_IDEOGRAPH_FA3C = chr(64060)
CJK_COMPATIBILITY_IDEOGRAPH_FA3D = chr(64061)
CJK_COMPATIBILITY_IDEOGRAPH_FA3E = chr(64062)
CJK_COMPATIBILITY_IDEOGRAPH_FA3F = chr(64063)
CJK_COMPATIBILITY_IDEOGRAPH_FA40 = chr(64064)
CJK_COMPATIBILITY_IDEOGRAPH_FA41 = chr(64065)
CJK_COMPATIBILITY_IDEOGRAPH_FA42 = chr(64066)
CJK_COMPATIBILITY_IDEOGRAPH_FA43 = chr(64067)
CJK_COMPATIBILITY_IDEOGRAPH_FA44 = chr(64068)
CJK_COMPATIBILITY_IDEOGRAPH_FA45 = chr(64069)
CJK_COMPATIBILITY_IDEOGRAPH_FA46 = chr(64070)
CJK_COMPATIBILITY_IDEOGRAPH_FA47 = chr(64071)
CJK_COMPATIBILITY_IDEOGRAPH_FA48 = chr(64072)
CJK_COMPATIBILITY_IDEOGRAPH_FA49 = chr(64073)
CJK_COMPATIBILITY_IDEOGRAPH_FA4A = chr(64074)
CJK_COMPATIBILITY_IDEOGRAPH_FA4B = chr(64075)
CJK_COMPATIBILITY_IDEOGRAPH_FA4C = chr(64076)
CJK_COMPATIBILITY_IDEOGRAPH_FA4D = chr(64077)
CJK_COMPATIBILITY_IDEOGRAPH_FA4E = chr(64078)
CJK_COMPATIBILITY_IDEOGRAPH_FA4F = chr(64079)
CJK_COMPATIBILITY_IDEOGRAPH_FA50 = chr(64080)
CJK_COMPATIBILITY_IDEOGRAPH_FA51 = chr(64081)
CJK_COMPATIBILITY_IDEOGRAPH_FA52 = chr(64082)
CJK_COMPATIBILITY_IDEOGRAPH_FA53 = chr(64083)
CJK_COMPATIBILITY_IDEOGRAPH_FA54 = chr(64084)
CJK_COMPATIBILITY_IDEOGRAPH_FA55 = chr(64085)
CJK_COMPATIBILITY_IDEOGRAPH_FA56 = chr(64086)
CJK_COMPATIBILITY_IDEOGRAPH_FA57 = chr(64087)
CJK_COMPATIBILITY_IDEOGRAPH_FA58 = chr(64088)
CJK_COMPATIBILITY_IDEOGRAPH_FA59 = chr(64089)
CJK_COMPATIBILITY_IDEOGRAPH_FA5A = chr(64090)
CJK_COMPATIBILITY_IDEOGRAPH_FA5B = chr(64091)
CJK_COMPATIBILITY_IDEOGRAPH_FA5C = chr(64092)
CJK_COMPATIBILITY_IDEOGRAPH_FA5D = chr(64093)
CJK_COMPATIBILITY_IDEOGRAPH_FA5E = chr(64094)
CJK_COMPATIBILITY_IDEOGRAPH_FA5F = chr(64095)
CJK_COMPATIBILITY_IDEOGRAPH_FA60 = chr(64096)
CJK_COMPATIBILITY_IDEOGRAPH_FA61 = chr(64097)
CJK_COMPATIBILITY_IDEOGRAPH_FA62 = chr(64098)
CJK_COMPATIBILITY_IDEOGRAPH_FA63 = chr(64099)
CJK_COMPATIBILITY_IDEOGRAPH_FA64 = chr(64100)
CJK_COMPATIBILITY_IDEOGRAPH_FA65 = chr(64101)
CJK_COMPATIBILITY_IDEOGRAPH_FA66 = chr(64102)
CJK_COMPATIBILITY_IDEOGRAPH_FA67 = chr(64103)
CJK_COMPATIBILITY_IDEOGRAPH_FA68 = chr(64104)
CJK_COMPATIBILITY_IDEOGRAPH_FA69 = chr(64105)
CJK_COMPATIBILITY_IDEOGRAPH_FA6A = chr(64106)
CJK_COMPATIBILITY_IDEOGRAPH_FA6B = chr(64107)
CJK_COMPATIBILITY_IDEOGRAPH_FA6C = chr(64108)
CJK_COMPATIBILITY_IDEOGRAPH_FA6D = chr(64109)
CJK_COMPATIBILITY_IDEOGRAPH_FA70 = chr(64112)
CJK_COMPATIBILITY_IDEOGRAPH_FA71 = chr(64113)
CJK_COMPATIBILITY_IDEOGRAPH_FA72 = chr(64114)
CJK_COMPATIBILITY_IDEOGRAPH_FA73 = chr(64115)
CJK_COMPATIBILITY_IDEOGRAPH_FA74 = chr(64116)
CJK_COMPATIBILITY_IDEOGRAPH_FA75 = chr(64117)
CJK_COMPATIBILITY_IDEOGRAPH_FA76 = chr(64118)
CJK_COMPATIBILITY_IDEOGRAPH_FA77 = chr(64119)
CJK_COMPATIBILITY_IDEOGRAPH_FA78 = chr(64120)
CJK_COMPATIBILITY_IDEOGRAPH_FA79 = chr(64121)
CJK_COMPATIBILITY_IDEOGRAPH_FA7A = chr(64122)
CJK_COMPATIBILITY_IDEOGRAPH_FA7B = chr(64123)
CJK_COMPATIBILITY_IDEOGRAPH_FA7C = chr(64124)
CJK_COMPATIBILITY_IDEOGRAPH_FA7D = chr(64125)
CJK_COMPATIBILITY_IDEOGRAPH_FA7E = chr(64126)
CJK_COMPATIBILITY_IDEOGRAPH_FA7F = chr(64127)
CJK_COMPATIBILITY_IDEOGRAPH_FA80 = chr(64128)
CJK_COMPATIBILITY_IDEOGRAPH_FA81 = chr(64129)
CJK_COMPATIBILITY_IDEOGRAPH_FA82 = chr(64130)
CJK_COMPATIBILITY_IDEOGRAPH_FA83 = chr(64131)
CJK_COMPATIBILITY_IDEOGRAPH_FA84 = chr(64132)
CJK_COMPATIBILITY_IDEOGRAPH_FA85 = chr(64133)
CJK_COMPATIBILITY_IDEOGRAPH_FA86 = chr(64134)
CJK_COMPATIBILITY_IDEOGRAPH_FA87 = chr(64135)
CJK_COMPATIBILITY_IDEOGRAPH_FA88 = chr(64136)
CJK_COMPATIBILITY_IDEOGRAPH_FA89 = chr(64137)
CJK_COMPATIBILITY_IDEOGRAPH_FA8A = chr(64138)
CJK_COMPATIBILITY_IDEOGRAPH_FA8B = chr(64139)
CJK_COMPATIBILITY_IDEOGRAPH_FA8C = chr(64140)
CJK_COMPATIBILITY_IDEOGRAPH_FA8D = chr(64141)
CJK_COMPATIBILITY_IDEOGRAPH_FA8E = chr(64142)
CJK_COMPATIBILITY_IDEOGRAPH_FA8F = chr(64143)
CJK_COMPATIBILITY_IDEOGRAPH_FA90 = chr(64144)
CJK_COMPATIBILITY_IDEOGRAPH_FA91 = chr(64145)
CJK_COMPATIBILITY_IDEOGRAPH_FA92 = chr(64146)
CJK_COMPATIBILITY_IDEOGRAPH_FA93 = chr(64147)
CJK_COMPATIBILITY_IDEOGRAPH_FA94 = chr(64148)
CJK_COMPATIBILITY_IDEOGRAPH_FA95 = chr(64149)
CJK_COMPATIBILITY_IDEOGRAPH_FA96 = chr(64150)
CJK_COMPATIBILITY_IDEOGRAPH_FA97 = chr(64151)
CJK_COMPATIBILITY_IDEOGRAPH_FA98 = chr(64152)
CJK_COMPATIBILITY_IDEOGRAPH_FA99 = chr(64153)
CJK_COMPATIBILITY_IDEOGRAPH_FA9A = chr(64154)
CJK_COMPATIBILITY_IDEOGRAPH_FA9B = chr(64155)
CJK_COMPATIBILITY_IDEOGRAPH_FA9C = chr(64156)
CJK_COMPATIBILITY_IDEOGRAPH_FA9D = chr(64157)
CJK_COMPATIBILITY_IDEOGRAPH_FA9E = chr(64158)
CJK_COMPATIBILITY_IDEOGRAPH_FA9F = chr(64159)
CJK_COMPATIBILITY_IDEOGRAPH_FAA0 = chr(64160)
CJK_COMPATIBILITY_IDEOGRAPH_FAA1 = chr(64161)
CJK_COMPATIBILITY_IDEOGRAPH_FAA2 = chr(64162)
CJK_COMPATIBILITY_IDEOGRAPH_FAA3 = chr(64163)
CJK_COMPATIBILITY_IDEOGRAPH_FAA4 = chr(64164)
CJK_COMPATIBILITY_IDEOGRAPH_FAA5 = chr(64165)
CJK_COMPATIBILITY_IDEOGRAPH_FAA6 = chr(64166)
CJK_COMPATIBILITY_IDEOGRAPH_FAA7 = chr(64167)
CJK_COMPATIBILITY_IDEOGRAPH_FAA8 = chr(64168)
CJK_COMPATIBILITY_IDEOGRAPH_FAA9 = chr(64169)
CJK_COMPATIBILITY_IDEOGRAPH_FAAA = chr(64170)
CJK_COMPATIBILITY_IDEOGRAPH_FAAB = chr(64171)
CJK_COMPATIBILITY_IDEOGRAPH_FAAC = chr(64172)
CJK_COMPATIBILITY_IDEOGRAPH_FAAD = chr(64173)
CJK_COMPATIBILITY_IDEOGRAPH_FAAE = chr(64174)
CJK_COMPATIBILITY_IDEOGRAPH_FAAF = chr(64175)
CJK_COMPATIBILITY_IDEOGRAPH_FAB0 = chr(64176)
CJK_COMPATIBILITY_IDEOGRAPH_FAB1 = chr(64177)
CJK_COMPATIBILITY_IDEOGRAPH_FAB2 = chr(64178)
CJK_COMPATIBILITY_IDEOGRAPH_FAB3 = chr(64179)
CJK_COMPATIBILITY_IDEOGRAPH_FAB4 = chr(64180)
CJK_COMPATIBILITY_IDEOGRAPH_FAB5 = chr(64181)
CJK_COMPATIBILITY_IDEOGRAPH_FAB6 = chr(64182)
CJK_COMPATIBILITY_IDEOGRAPH_FAB7 = chr(64183)
CJK_COMPATIBILITY_IDEOGRAPH_FAB8 = chr(64184)
CJK_COMPATIBILITY_IDEOGRAPH_FAB9 = chr(64185)
CJK_COMPATIBILITY_IDEOGRAPH_FABA = chr(64186)
CJK_COMPATIBILITY_IDEOGRAPH_FABB = chr(64187)
CJK_COMPATIBILITY_IDEOGRAPH_FABC = chr(64188)
CJK_COMPATIBILITY_IDEOGRAPH_FABD = chr(64189)
CJK_COMPATIBILITY_IDEOGRAPH_FABE = chr(64190)
CJK_COMPATIBILITY_IDEOGRAPH_FABF = chr(64191)
CJK_COMPATIBILITY_IDEOGRAPH_FAC0 = chr(64192)
CJK_COMPATIBILITY_IDEOGRAPH_FAC1 = chr(64193)
CJK_COMPATIBILITY_IDEOGRAPH_FAC2 = chr(64194)
CJK_COMPATIBILITY_IDEOGRAPH_FAC3 = chr(64195)
CJK_COMPATIBILITY_IDEOGRAPH_FAC4 = chr(64196)
CJK_COMPATIBILITY_IDEOGRAPH_FAC5 = chr(64197)
CJK_COMPATIBILITY_IDEOGRAPH_FAC6 = chr(64198)
CJK_COMPATIBILITY_IDEOGRAPH_FAC7 = chr(64199)
CJK_COMPATIBILITY_IDEOGRAPH_FAC8 = chr(64200)
CJK_COMPATIBILITY_IDEOGRAPH_FAC9 = chr(64201)
CJK_COMPATIBILITY_IDEOGRAPH_FACA = chr(64202)
CJK_COMPATIBILITY_IDEOGRAPH_FACB = chr(64203)
CJK_COMPATIBILITY_IDEOGRAPH_FACC = chr(64204)
CJK_COMPATIBILITY_IDEOGRAPH_FACD = chr(64205)
CJK_COMPATIBILITY_IDEOGRAPH_FACE = chr(64206)
CJK_COMPATIBILITY_IDEOGRAPH_FACF = chr(64207)
CJK_COMPATIBILITY_IDEOGRAPH_FAD0 = chr(64208)
CJK_COMPATIBILITY_IDEOGRAPH_FAD1 = chr(64209)
CJK_COMPATIBILITY_IDEOGRAPH_FAD2 = chr(64210)
CJK_COMPATIBILITY_IDEOGRAPH_FAD3 = chr(64211)
CJK_COMPATIBILITY_IDEOGRAPH_FAD4 = chr(64212)
CJK_COMPATIBILITY_IDEOGRAPH_FAD5 = chr(64213)
CJK_COMPATIBILITY_IDEOGRAPH_FAD6 = chr(64214)
CJK_COMPATIBILITY_IDEOGRAPH_FAD7 = chr(64215)
CJK_COMPATIBILITY_IDEOGRAPH_FAD8 = chr(64216)
CJK_COMPATIBILITY_IDEOGRAPH_FAD9 = chr(64217)
LATIN_SMALL_LIGATURE_FF = chr(64256)
LATIN_SMALL_LIGATURE_FI = chr(64257)
LATIN_SMALL_LIGATURE_FL = chr(64258)
LATIN_SMALL_LIGATURE_FFI = chr(64259)
LATIN_SMALL_LIGATURE_FFL = chr(64260)
LATIN_SMALL_LIGATURE_LONG_S_T = chr(64261)
LATIN_SMALL_LIGATURE_ST = chr(64262)
ARMENIAN_SMALL_LIGATURE_MEN_NOW = chr(64275)
ARMENIAN_SMALL_LIGATURE_MEN_ECH = chr(64276)
ARMENIAN_SMALL_LIGATURE_MEN_INI = chr(64277)
ARMENIAN_SMALL_LIGATURE_VEW_NOW = chr(64278)
ARMENIAN_SMALL_LIGATURE_MEN_XEH = chr(64279)
HEBREW_LETTER_YOD_WITH_HIRIQ = chr(64285)
HEBREW_POINT_JUDEO_SPANISH_VARIKA = chr(64286)
HEBREW_LIGATURE_YIDDISH_YOD_YOD_PATAH = chr(64287)
HEBREW_LETTER_ALTERNATIVE_AYIN = chr(64288)
HEBREW_LETTER_WIDE_ALEF = chr(64289)
HEBREW_LETTER_WIDE_DALET = chr(64290)
HEBREW_LETTER_WIDE_HE = chr(64291)
HEBREW_LETTER_WIDE_KAF = chr(64292)
HEBREW_LETTER_WIDE_LAMED = chr(64293)
HEBREW_LETTER_WIDE_FINAL_MEM = chr(64294)
HEBREW_LETTER_WIDE_RESH = chr(64295)
HEBREW_LETTER_WIDE_TAV = chr(64296)
HEBREW_LETTER_ALTERNATIVE_PLUS_SIGN = chr(64297)
HEBREW_LETTER_SHIN_WITH_SHIN_DOT = chr(64298)
HEBREW_LETTER_SHIN_WITH_SIN_DOT = chr(64299)
HEBREW_LETTER_SHIN_WITH_DAGESH_AND_SHIN_DOT = chr(64300)
HEBREW_LETTER_SHIN_WITH_DAGESH_AND_SIN_DOT = chr(64301)
HEBREW_LETTER_ALEF_WITH_PATAH = chr(64302)
HEBREW_LETTER_ALEF_WITH_QAMATS = chr(64303)
HEBREW_LETTER_ALEF_WITH_MAPIQ = chr(64304)
HEBREW_LETTER_BET_WITH_DAGESH = chr(64305)
HEBREW_LETTER_GIMEL_WITH_DAGESH = chr(64306)
HEBREW_LETTER_DALET_WITH_DAGESH = chr(64307)
HEBREW_LETTER_HE_WITH_MAPIQ = chr(64308)
HEBREW_LETTER_VAV_WITH_DAGESH = chr(64309)
HEBREW_LETTER_ZAYIN_WITH_DAGESH = chr(64310)
HEBREW_LETTER_TET_WITH_DAGESH = chr(64312)
HEBREW_LETTER_YOD_WITH_DAGESH = chr(64313)
HEBREW_LETTER_FINAL_KAF_WITH_DAGESH = chr(64314)
HEBREW_LETTER_KAF_WITH_DAGESH = chr(64315)
HEBREW_LETTER_LAMED_WITH_DAGESH = chr(64316)
HEBREW_LETTER_MEM_WITH_DAGESH = chr(64318)
HEBREW_LETTER_NUN_WITH_DAGESH = chr(64320)
HEBREW_LETTER_SAMEKH_WITH_DAGESH = chr(64321)
HEBREW_LETTER_FINAL_PE_WITH_DAGESH = chr(64323)
HEBREW_LETTER_PE_WITH_DAGESH = chr(64324)
HEBREW_LETTER_TSADI_WITH_DAGESH = chr(64326)
HEBREW_LETTER_QOF_WITH_DAGESH = chr(64327)
HEBREW_LETTER_RESH_WITH_DAGESH = chr(64328)
HEBREW_LETTER_SHIN_WITH_DAGESH = chr(64329)
HEBREW_LETTER_TAV_WITH_DAGESH = chr(64330)
HEBREW_LETTER_VAV_WITH_HOLAM = chr(64331)
HEBREW_LETTER_BET_WITH_RAFE = chr(64332)
HEBREW_LETTER_KAF_WITH_RAFE = chr(64333)
HEBREW_LETTER_PE_WITH_RAFE = chr(64334)
HEBREW_LIGATURE_ALEF_LAMED = chr(64335)
ARABIC_LETTER_ALEF_WASLA_ISOLATED_FORM = chr(64336)
ARABIC_LETTER_ALEF_WASLA_FINAL_FORM = chr(64337)
ARABIC_LETTER_BEEH_ISOLATED_FORM = chr(64338)
ARABIC_LETTER_BEEH_FINAL_FORM = chr(64339)
ARABIC_LETTER_BEEH_INITIAL_FORM = chr(64340)
ARABIC_LETTER_BEEH_MEDIAL_FORM = chr(64341)
ARABIC_LETTER_PEH_ISOLATED_FORM = chr(64342)
ARABIC_LETTER_PEH_FINAL_FORM = chr(64343)
ARABIC_LETTER_PEH_INITIAL_FORM = chr(64344)
ARABIC_LETTER_PEH_MEDIAL_FORM = chr(64345)
ARABIC_LETTER_BEHEH_ISOLATED_FORM = chr(64346)
ARABIC_LETTER_BEHEH_FINAL_FORM = chr(64347)
ARABIC_LETTER_BEHEH_INITIAL_FORM = chr(64348)
ARABIC_LETTER_BEHEH_MEDIAL_FORM = chr(64349)
ARABIC_LETTER_TTEHEH_ISOLATED_FORM = chr(64350)
ARABIC_LETTER_TTEHEH_FINAL_FORM = chr(64351)
ARABIC_LETTER_TTEHEH_INITIAL_FORM = chr(64352)
ARABIC_LETTER_TTEHEH_MEDIAL_FORM = chr(64353)
ARABIC_LETTER_TEHEH_ISOLATED_FORM = chr(64354)
ARABIC_LETTER_TEHEH_FINAL_FORM = chr(64355)
ARABIC_LETTER_TEHEH_INITIAL_FORM = chr(64356)
ARABIC_LETTER_TEHEH_MEDIAL_FORM = chr(64357)
ARABIC_LETTER_TTEH_ISOLATED_FORM = chr(64358)
ARABIC_LETTER_TTEH_FINAL_FORM = chr(64359)
ARABIC_LETTER_TTEH_INITIAL_FORM = chr(64360)
ARABIC_LETTER_TTEH_MEDIAL_FORM = chr(64361)
ARABIC_LETTER_VEH_ISOLATED_FORM = chr(64362)
ARABIC_LETTER_VEH_FINAL_FORM = chr(64363)
ARABIC_LETTER_VEH_INITIAL_FORM = chr(64364)
ARABIC_LETTER_VEH_MEDIAL_FORM = chr(64365)
ARABIC_LETTER_PEHEH_ISOLATED_FORM = chr(64366)
ARABIC_LETTER_PEHEH_FINAL_FORM = chr(64367)
ARABIC_LETTER_PEHEH_INITIAL_FORM = chr(64368)
ARABIC_LETTER_PEHEH_MEDIAL_FORM = chr(64369)
ARABIC_LETTER_DYEH_ISOLATED_FORM = chr(64370)
ARABIC_LETTER_DYEH_FINAL_FORM = chr(64371)
ARABIC_LETTER_DYEH_INITIAL_FORM = chr(64372)
ARABIC_LETTER_DYEH_MEDIAL_FORM = chr(64373)
ARABIC_LETTER_NYEH_ISOLATED_FORM = chr(64374)
ARABIC_LETTER_NYEH_FINAL_FORM = chr(64375)
ARABIC_LETTER_NYEH_INITIAL_FORM = chr(64376)
ARABIC_LETTER_NYEH_MEDIAL_FORM = chr(64377)
ARABIC_LETTER_TCHEH_ISOLATED_FORM = chr(64378)
ARABIC_LETTER_TCHEH_FINAL_FORM = chr(64379)
ARABIC_LETTER_TCHEH_INITIAL_FORM = chr(64380)
ARABIC_LETTER_TCHEH_MEDIAL_FORM = chr(64381)
ARABIC_LETTER_TCHEHEH_ISOLATED_FORM = chr(64382)
ARABIC_LETTER_TCHEHEH_FINAL_FORM = chr(64383)
ARABIC_LETTER_TCHEHEH_INITIAL_FORM = chr(64384)
ARABIC_LETTER_TCHEHEH_MEDIAL_FORM = chr(64385)
ARABIC_LETTER_DDAHAL_ISOLATED_FORM = chr(64386)
ARABIC_LETTER_DDAHAL_FINAL_FORM = chr(64387)
ARABIC_LETTER_DAHAL_ISOLATED_FORM = chr(64388)
ARABIC_LETTER_DAHAL_FINAL_FORM = chr(64389)
ARABIC_LETTER_DUL_ISOLATED_FORM = chr(64390)
ARABIC_LETTER_DUL_FINAL_FORM = chr(64391)
ARABIC_LETTER_DDAL_ISOLATED_FORM = chr(64392)
ARABIC_LETTER_DDAL_FINAL_FORM = chr(64393)
ARABIC_LETTER_JEH_ISOLATED_FORM = chr(64394)
ARABIC_LETTER_JEH_FINAL_FORM = chr(64395)
ARABIC_LETTER_RREH_ISOLATED_FORM = chr(64396)
ARABIC_LETTER_RREH_FINAL_FORM = chr(64397)
ARABIC_LETTER_KEHEH_ISOLATED_FORM = chr(64398)
ARABIC_LETTER_KEHEH_FINAL_FORM = chr(64399)
ARABIC_LETTER_KEHEH_INITIAL_FORM = chr(64400)
ARABIC_LETTER_KEHEH_MEDIAL_FORM = chr(64401)
ARABIC_LETTER_GAF_ISOLATED_FORM = chr(64402)
ARABIC_LETTER_GAF_FINAL_FORM = chr(64403)
ARABIC_LETTER_GAF_INITIAL_FORM = chr(64404)
ARABIC_LETTER_GAF_MEDIAL_FORM = chr(64405)
ARABIC_LETTER_GUEH_ISOLATED_FORM = chr(64406)
ARABIC_LETTER_GUEH_FINAL_FORM = chr(64407)
ARABIC_LETTER_GUEH_INITIAL_FORM = chr(64408)
ARABIC_LETTER_GUEH_MEDIAL_FORM = chr(64409)
ARABIC_LETTER_NGOEH_ISOLATED_FORM = chr(64410)
ARABIC_LETTER_NGOEH_FINAL_FORM = chr(64411)
ARABIC_LETTER_NGOEH_INITIAL_FORM = chr(64412)
ARABIC_LETTER_NGOEH_MEDIAL_FORM = chr(64413)
ARABIC_LETTER_NOON_GHUNNA_ISOLATED_FORM = chr(64414)
ARABIC_LETTER_NOON_GHUNNA_FINAL_FORM = chr(64415)
ARABIC_LETTER_RNOON_ISOLATED_FORM = chr(64416)
ARABIC_LETTER_RNOON_FINAL_FORM = chr(64417)
ARABIC_LETTER_RNOON_INITIAL_FORM = chr(64418)
ARABIC_LETTER_RNOON_MEDIAL_FORM = chr(64419)
ARABIC_LETTER_HEH_WITH_YEH_ABOVE_ISOLATED_FORM = chr(64420)
ARABIC_LETTER_HEH_WITH_YEH_ABOVE_FINAL_FORM = chr(64421)
ARABIC_LETTER_HEH_GOAL_ISOLATED_FORM = chr(64422)
ARABIC_LETTER_HEH_GOAL_FINAL_FORM = chr(64423)
ARABIC_LETTER_HEH_GOAL_INITIAL_FORM = chr(64424)
ARABIC_LETTER_HEH_GOAL_MEDIAL_FORM = chr(64425)
ARABIC_LETTER_HEH_DOACHASHMEE_ISOLATED_FORM = chr(64426)
ARABIC_LETTER_HEH_DOACHASHMEE_FINAL_FORM = chr(64427)
ARABIC_LETTER_HEH_DOACHASHMEE_INITIAL_FORM = chr(64428)
ARABIC_LETTER_HEH_DOACHASHMEE_MEDIAL_FORM = chr(64429)
ARABIC_LETTER_YEH_BARREE_ISOLATED_FORM = chr(64430)
ARABIC_LETTER_YEH_BARREE_FINAL_FORM = chr(64431)
ARABIC_LETTER_YEH_BARREE_WITH_HAMZA_ABOVE_ISOLATED_FORM = chr(64432)
ARABIC_LETTER_YEH_BARREE_WITH_HAMZA_ABOVE_FINAL_FORM = chr(64433)
ARABIC_SYMBOL_DOT_ABOVE = chr(64434)
ARABIC_SYMBOL_DOT_BELOW = chr(64435)
ARABIC_SYMBOL_TWO_DOTS_ABOVE = chr(64436)
ARABIC_SYMBOL_TWO_DOTS_BELOW = chr(64437)
ARABIC_SYMBOL_THREE_DOTS_ABOVE = chr(64438)
ARABIC_SYMBOL_THREE_DOTS_BELOW = chr(64439)
ARABIC_SYMBOL_THREE_DOTS_POINTING_DOWNWARDS_ABOVE = chr(64440)
ARABIC_SYMBOL_THREE_DOTS_POINTING_DOWNWARDS_BELOW = chr(64441)
ARABIC_SYMBOL_FOUR_DOTS_ABOVE = chr(64442)
ARABIC_SYMBOL_FOUR_DOTS_BELOW = chr(64443)
ARABIC_SYMBOL_DOUBLE_VERTICAL_BAR_BELOW = chr(64444)
ARABIC_SYMBOL_TWO_DOTS_VERTICALLY_ABOVE = chr(64445)
ARABIC_SYMBOL_TWO_DOTS_VERTICALLY_BELOW = chr(64446)
ARABIC_SYMBOL_RING = chr(64447)
ARABIC_SYMBOL_SMALL_TAH_ABOVE = chr(64448)
ARABIC_SYMBOL_SMALL_TAH_BELOW = chr(64449)
ARABIC_SYMBOL_WASLA_ABOVE = chr(64450)
ARABIC_LETTER_NG_ISOLATED_FORM = chr(64467)
ARABIC_LETTER_NG_FINAL_FORM = chr(64468)
ARABIC_LETTER_NG_INITIAL_FORM = chr(64469)
ARABIC_LETTER_NG_MEDIAL_FORM = chr(64470)
ARABIC_LETTER_U_ISOLATED_FORM = chr(64471)
ARABIC_LETTER_U_FINAL_FORM = chr(64472)
ARABIC_LETTER_OE_ISOLATED_FORM = chr(64473)
ARABIC_LETTER_OE_FINAL_FORM = chr(64474)
ARABIC_LETTER_YU_ISOLATED_FORM = chr(64475)
ARABIC_LETTER_YU_FINAL_FORM = chr(64476)
ARABIC_LETTER_U_WITH_HAMZA_ABOVE_ISOLATED_FORM = chr(64477)
ARABIC_LETTER_VE_ISOLATED_FORM = chr(64478)
ARABIC_LETTER_VE_FINAL_FORM = chr(64479)
ARABIC_LETTER_KIRGHIZ_OE_ISOLATED_FORM = chr(64480)
ARABIC_LETTER_KIRGHIZ_OE_FINAL_FORM = chr(64481)
ARABIC_LETTER_KIRGHIZ_YU_ISOLATED_FORM = chr(64482)
ARABIC_LETTER_KIRGHIZ_YU_FINAL_FORM = chr(64483)
ARABIC_LETTER_E_ISOLATED_FORM = chr(64484)
ARABIC_LETTER_E_FINAL_FORM = chr(64485)
ARABIC_LETTER_E_INITIAL_FORM = chr(64486)
ARABIC_LETTER_E_MEDIAL_FORM = chr(64487)
ARABIC_LETTER_UIGHUR_KAZAKH_KIRGHIZ_ALEF_MAKSURA_INITIAL_FORM = chr(64488)
ARABIC_LETTER_UIGHUR_KAZAKH_KIRGHIZ_ALEF_MAKSURA_MEDIAL_FORM = chr(64489)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_ISOLATED_FORM = chr(64490)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_FINAL_FORM = chr(64491)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_AE_ISOLATED_FORM = chr(64492)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_AE_FINAL_FORM = chr(64493)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_WAW_ISOLATED_FORM = chr(64494)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_WAW_FINAL_FORM = chr(64495)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_U_ISOLATED_FORM = chr(64496)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_U_FINAL_FORM = chr(64497)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_OE_ISOLATED_FORM = chr(64498)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_OE_FINAL_FORM = chr(64499)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_YU_ISOLATED_FORM = chr(64500)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_YU_FINAL_FORM = chr(64501)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_E_ISOLATED_FORM = chr(64502)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_E_FINAL_FORM = chr(64503)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_E_INITIAL_FORM = chr(64504)
ARABIC_LIGATURE_UIGHUR_KIRGHIZ_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64505)
ARABIC_LIGATURE_UIGHUR_KIRGHIZ_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64506)
ARABIC_LIGATURE_UIGHUR_KIRGHIZ_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_MAKSURA_INITIAL_FORM = chr(64507)
ARABIC_LETTER_FARSI_YEH_ISOLATED_FORM = chr(64508)
ARABIC_LETTER_FARSI_YEH_FINAL_FORM = chr(64509)
ARABIC_LETTER_FARSI_YEH_INITIAL_FORM = chr(64510)
ARABIC_LETTER_FARSI_YEH_MEDIAL_FORM = chr(64511)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_JEEM_ISOLATED_FORM = chr(64512)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_HAH_ISOLATED_FORM = chr(64513)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_MEEM_ISOLATED_FORM = chr(64514)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64515)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_YEH_ISOLATED_FORM = chr(64516)
ARABIC_LIGATURE_BEH_WITH_JEEM_ISOLATED_FORM = chr(64517)
ARABIC_LIGATURE_BEH_WITH_HAH_ISOLATED_FORM = chr(64518)
ARABIC_LIGATURE_BEH_WITH_KHAH_ISOLATED_FORM = chr(64519)
ARABIC_LIGATURE_BEH_WITH_MEEM_ISOLATED_FORM = chr(64520)
ARABIC_LIGATURE_BEH_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64521)
ARABIC_LIGATURE_BEH_WITH_YEH_ISOLATED_FORM = chr(64522)
ARABIC_LIGATURE_TEH_WITH_JEEM_ISOLATED_FORM = chr(64523)
ARABIC_LIGATURE_TEH_WITH_HAH_ISOLATED_FORM = chr(64524)
ARABIC_LIGATURE_TEH_WITH_KHAH_ISOLATED_FORM = chr(64525)
ARABIC_LIGATURE_TEH_WITH_MEEM_ISOLATED_FORM = chr(64526)
ARABIC_LIGATURE_TEH_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64527)
ARABIC_LIGATURE_TEH_WITH_YEH_ISOLATED_FORM = chr(64528)
ARABIC_LIGATURE_THEH_WITH_JEEM_ISOLATED_FORM = chr(64529)
ARABIC_LIGATURE_THEH_WITH_MEEM_ISOLATED_FORM = chr(64530)
ARABIC_LIGATURE_THEH_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64531)
ARABIC_LIGATURE_THEH_WITH_YEH_ISOLATED_FORM = chr(64532)
ARABIC_LIGATURE_JEEM_WITH_HAH_ISOLATED_FORM = chr(64533)
ARABIC_LIGATURE_JEEM_WITH_MEEM_ISOLATED_FORM = chr(64534)
ARABIC_LIGATURE_HAH_WITH_JEEM_ISOLATED_FORM = chr(64535)
ARABIC_LIGATURE_HAH_WITH_MEEM_ISOLATED_FORM = chr(64536)
ARABIC_LIGATURE_KHAH_WITH_JEEM_ISOLATED_FORM = chr(64537)
ARABIC_LIGATURE_KHAH_WITH_HAH_ISOLATED_FORM = chr(64538)
ARABIC_LIGATURE_KHAH_WITH_MEEM_ISOLATED_FORM = chr(64539)
ARABIC_LIGATURE_SEEN_WITH_JEEM_ISOLATED_FORM = chr(64540)
ARABIC_LIGATURE_SEEN_WITH_HAH_ISOLATED_FORM = chr(64541)
ARABIC_LIGATURE_SEEN_WITH_KHAH_ISOLATED_FORM = chr(64542)
ARABIC_LIGATURE_SEEN_WITH_MEEM_ISOLATED_FORM = chr(64543)
ARABIC_LIGATURE_SAD_WITH_HAH_ISOLATED_FORM = chr(64544)
ARABIC_LIGATURE_SAD_WITH_MEEM_ISOLATED_FORM = chr(64545)
ARABIC_LIGATURE_DAD_WITH_JEEM_ISOLATED_FORM = chr(64546)
ARABIC_LIGATURE_DAD_WITH_HAH_ISOLATED_FORM = chr(64547)
ARABIC_LIGATURE_DAD_WITH_KHAH_ISOLATED_FORM = chr(64548)
ARABIC_LIGATURE_DAD_WITH_MEEM_ISOLATED_FORM = chr(64549)
ARABIC_LIGATURE_TAH_WITH_HAH_ISOLATED_FORM = chr(64550)
ARABIC_LIGATURE_TAH_WITH_MEEM_ISOLATED_FORM = chr(64551)
ARABIC_LIGATURE_ZAH_WITH_MEEM_ISOLATED_FORM = chr(64552)
ARABIC_LIGATURE_AIN_WITH_JEEM_ISOLATED_FORM = chr(64553)
ARABIC_LIGATURE_AIN_WITH_MEEM_ISOLATED_FORM = chr(64554)
ARABIC_LIGATURE_GHAIN_WITH_JEEM_ISOLATED_FORM = chr(64555)
ARABIC_LIGATURE_GHAIN_WITH_MEEM_ISOLATED_FORM = chr(64556)
ARABIC_LIGATURE_FEH_WITH_JEEM_ISOLATED_FORM = chr(64557)
ARABIC_LIGATURE_FEH_WITH_HAH_ISOLATED_FORM = chr(64558)
ARABIC_LIGATURE_FEH_WITH_KHAH_ISOLATED_FORM = chr(64559)
ARABIC_LIGATURE_FEH_WITH_MEEM_ISOLATED_FORM = chr(64560)
ARABIC_LIGATURE_FEH_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64561)
ARABIC_LIGATURE_FEH_WITH_YEH_ISOLATED_FORM = chr(64562)
ARABIC_LIGATURE_QAF_WITH_HAH_ISOLATED_FORM = chr(64563)
ARABIC_LIGATURE_QAF_WITH_MEEM_ISOLATED_FORM = chr(64564)
ARABIC_LIGATURE_QAF_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64565)
ARABIC_LIGATURE_QAF_WITH_YEH_ISOLATED_FORM = chr(64566)
ARABIC_LIGATURE_KAF_WITH_ALEF_ISOLATED_FORM = chr(64567)
ARABIC_LIGATURE_KAF_WITH_JEEM_ISOLATED_FORM = chr(64568)
ARABIC_LIGATURE_KAF_WITH_HAH_ISOLATED_FORM = chr(64569)
ARABIC_LIGATURE_KAF_WITH_KHAH_ISOLATED_FORM = chr(64570)
ARABIC_LIGATURE_KAF_WITH_LAM_ISOLATED_FORM = chr(64571)
ARABIC_LIGATURE_KAF_WITH_MEEM_ISOLATED_FORM = chr(64572)
ARABIC_LIGATURE_KAF_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64573)
ARABIC_LIGATURE_KAF_WITH_YEH_ISOLATED_FORM = chr(64574)
ARABIC_LIGATURE_LAM_WITH_JEEM_ISOLATED_FORM = chr(64575)
ARABIC_LIGATURE_LAM_WITH_HAH_ISOLATED_FORM = chr(64576)
ARABIC_LIGATURE_LAM_WITH_KHAH_ISOLATED_FORM = chr(64577)
ARABIC_LIGATURE_LAM_WITH_MEEM_ISOLATED_FORM = chr(64578)
ARABIC_LIGATURE_LAM_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64579)
ARABIC_LIGATURE_LAM_WITH_YEH_ISOLATED_FORM = chr(64580)
ARABIC_LIGATURE_MEEM_WITH_JEEM_ISOLATED_FORM = chr(64581)
ARABIC_LIGATURE_MEEM_WITH_HAH_ISOLATED_FORM = chr(64582)
ARABIC_LIGATURE_MEEM_WITH_KHAH_ISOLATED_FORM = chr(64583)
ARABIC_LIGATURE_MEEM_WITH_MEEM_ISOLATED_FORM = chr(64584)
ARABIC_LIGATURE_MEEM_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64585)
ARABIC_LIGATURE_MEEM_WITH_YEH_ISOLATED_FORM = chr(64586)
ARABIC_LIGATURE_NOON_WITH_JEEM_ISOLATED_FORM = chr(64587)
ARABIC_LIGATURE_NOON_WITH_HAH_ISOLATED_FORM = chr(64588)
ARABIC_LIGATURE_NOON_WITH_KHAH_ISOLATED_FORM = chr(64589)
ARABIC_LIGATURE_NOON_WITH_MEEM_ISOLATED_FORM = chr(64590)
ARABIC_LIGATURE_NOON_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64591)
ARABIC_LIGATURE_NOON_WITH_YEH_ISOLATED_FORM = chr(64592)
ARABIC_LIGATURE_HEH_WITH_JEEM_ISOLATED_FORM = chr(64593)
ARABIC_LIGATURE_HEH_WITH_MEEM_ISOLATED_FORM = chr(64594)
ARABIC_LIGATURE_HEH_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64595)
ARABIC_LIGATURE_HEH_WITH_YEH_ISOLATED_FORM = chr(64596)
ARABIC_LIGATURE_YEH_WITH_JEEM_ISOLATED_FORM = chr(64597)
ARABIC_LIGATURE_YEH_WITH_HAH_ISOLATED_FORM = chr(64598)
ARABIC_LIGATURE_YEH_WITH_KHAH_ISOLATED_FORM = chr(64599)
ARABIC_LIGATURE_YEH_WITH_MEEM_ISOLATED_FORM = chr(64600)
ARABIC_LIGATURE_YEH_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64601)
ARABIC_LIGATURE_YEH_WITH_YEH_ISOLATED_FORM = chr(64602)
ARABIC_LIGATURE_THAL_WITH_SUPERSCRIPT_ALEF_ISOLATED_FORM = chr(64603)
ARABIC_LIGATURE_REH_WITH_SUPERSCRIPT_ALEF_ISOLATED_FORM = chr(64604)
ARABIC_LIGATURE_ALEF_MAKSURA_WITH_SUPERSCRIPT_ALEF_ISOLATED_FORM = chr(64605)
ARABIC_LIGATURE_SHADDA_WITH_DAMMATAN_ISOLATED_FORM = chr(64606)
ARABIC_LIGATURE_SHADDA_WITH_KASRATAN_ISOLATED_FORM = chr(64607)
ARABIC_LIGATURE_SHADDA_WITH_FATHA_ISOLATED_FORM = chr(64608)
ARABIC_LIGATURE_SHADDA_WITH_DAMMA_ISOLATED_FORM = chr(64609)
ARABIC_LIGATURE_SHADDA_WITH_KASRA_ISOLATED_FORM = chr(64610)
ARABIC_LIGATURE_SHADDA_WITH_SUPERSCRIPT_ALEF_ISOLATED_FORM = chr(64611)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_REH_FINAL_FORM = chr(64612)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_ZAIN_FINAL_FORM = chr(64613)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_MEEM_FINAL_FORM = chr(64614)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_NOON_FINAL_FORM = chr(64615)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64616)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_YEH_FINAL_FORM = chr(64617)
ARABIC_LIGATURE_BEH_WITH_REH_FINAL_FORM = chr(64618)
ARABIC_LIGATURE_BEH_WITH_ZAIN_FINAL_FORM = chr(64619)
ARABIC_LIGATURE_BEH_WITH_MEEM_FINAL_FORM = chr(64620)
ARABIC_LIGATURE_BEH_WITH_NOON_FINAL_FORM = chr(64621)
ARABIC_LIGATURE_BEH_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64622)
ARABIC_LIGATURE_BEH_WITH_YEH_FINAL_FORM = chr(64623)
ARABIC_LIGATURE_TEH_WITH_REH_FINAL_FORM = chr(64624)
ARABIC_LIGATURE_TEH_WITH_ZAIN_FINAL_FORM = chr(64625)
ARABIC_LIGATURE_TEH_WITH_MEEM_FINAL_FORM = chr(64626)
ARABIC_LIGATURE_TEH_WITH_NOON_FINAL_FORM = chr(64627)
ARABIC_LIGATURE_TEH_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64628)
ARABIC_LIGATURE_TEH_WITH_YEH_FINAL_FORM = chr(64629)
ARABIC_LIGATURE_THEH_WITH_REH_FINAL_FORM = chr(64630)
ARABIC_LIGATURE_THEH_WITH_ZAIN_FINAL_FORM = chr(64631)
ARABIC_LIGATURE_THEH_WITH_MEEM_FINAL_FORM = chr(64632)
ARABIC_LIGATURE_THEH_WITH_NOON_FINAL_FORM = chr(64633)
ARABIC_LIGATURE_THEH_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64634)
ARABIC_LIGATURE_THEH_WITH_YEH_FINAL_FORM = chr(64635)
ARABIC_LIGATURE_FEH_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64636)
ARABIC_LIGATURE_FEH_WITH_YEH_FINAL_FORM = chr(64637)
ARABIC_LIGATURE_QAF_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64638)
ARABIC_LIGATURE_QAF_WITH_YEH_FINAL_FORM = chr(64639)
ARABIC_LIGATURE_KAF_WITH_ALEF_FINAL_FORM = chr(64640)
ARABIC_LIGATURE_KAF_WITH_LAM_FINAL_FORM = chr(64641)
ARABIC_LIGATURE_KAF_WITH_MEEM_FINAL_FORM = chr(64642)
ARABIC_LIGATURE_KAF_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64643)
ARABIC_LIGATURE_KAF_WITH_YEH_FINAL_FORM = chr(64644)
ARABIC_LIGATURE_LAM_WITH_MEEM_FINAL_FORM = chr(64645)
ARABIC_LIGATURE_LAM_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64646)
ARABIC_LIGATURE_LAM_WITH_YEH_FINAL_FORM = chr(64647)
ARABIC_LIGATURE_MEEM_WITH_ALEF_FINAL_FORM = chr(64648)
ARABIC_LIGATURE_MEEM_WITH_MEEM_FINAL_FORM = chr(64649)
ARABIC_LIGATURE_NOON_WITH_REH_FINAL_FORM = chr(64650)
ARABIC_LIGATURE_NOON_WITH_ZAIN_FINAL_FORM = chr(64651)
ARABIC_LIGATURE_NOON_WITH_MEEM_FINAL_FORM = chr(64652)
ARABIC_LIGATURE_NOON_WITH_NOON_FINAL_FORM = chr(64653)
ARABIC_LIGATURE_NOON_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64654)
ARABIC_LIGATURE_NOON_WITH_YEH_FINAL_FORM = chr(64655)
ARABIC_LIGATURE_ALEF_MAKSURA_WITH_SUPERSCRIPT_ALEF_FINAL_FORM = chr(64656)
ARABIC_LIGATURE_YEH_WITH_REH_FINAL_FORM = chr(64657)
ARABIC_LIGATURE_YEH_WITH_ZAIN_FINAL_FORM = chr(64658)
ARABIC_LIGATURE_YEH_WITH_MEEM_FINAL_FORM = chr(64659)
ARABIC_LIGATURE_YEH_WITH_NOON_FINAL_FORM = chr(64660)
ARABIC_LIGATURE_YEH_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64661)
ARABIC_LIGATURE_YEH_WITH_YEH_FINAL_FORM = chr(64662)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_JEEM_INITIAL_FORM = chr(64663)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_HAH_INITIAL_FORM = chr(64664)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_KHAH_INITIAL_FORM = chr(64665)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_MEEM_INITIAL_FORM = chr(64666)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_HEH_INITIAL_FORM = chr(64667)
ARABIC_LIGATURE_BEH_WITH_JEEM_INITIAL_FORM = chr(64668)
ARABIC_LIGATURE_BEH_WITH_HAH_INITIAL_FORM = chr(64669)
ARABIC_LIGATURE_BEH_WITH_KHAH_INITIAL_FORM = chr(64670)
ARABIC_LIGATURE_BEH_WITH_MEEM_INITIAL_FORM = chr(64671)
ARABIC_LIGATURE_BEH_WITH_HEH_INITIAL_FORM = chr(64672)
ARABIC_LIGATURE_TEH_WITH_JEEM_INITIAL_FORM = chr(64673)
ARABIC_LIGATURE_TEH_WITH_HAH_INITIAL_FORM = chr(64674)
ARABIC_LIGATURE_TEH_WITH_KHAH_INITIAL_FORM = chr(64675)
ARABIC_LIGATURE_TEH_WITH_MEEM_INITIAL_FORM = chr(64676)
ARABIC_LIGATURE_TEH_WITH_HEH_INITIAL_FORM = chr(64677)
ARABIC_LIGATURE_THEH_WITH_MEEM_INITIAL_FORM = chr(64678)
ARABIC_LIGATURE_JEEM_WITH_HAH_INITIAL_FORM = chr(64679)
ARABIC_LIGATURE_JEEM_WITH_MEEM_INITIAL_FORM = chr(64680)
ARABIC_LIGATURE_HAH_WITH_JEEM_INITIAL_FORM = chr(64681)
ARABIC_LIGATURE_HAH_WITH_MEEM_INITIAL_FORM = chr(64682)
ARABIC_LIGATURE_KHAH_WITH_JEEM_INITIAL_FORM = chr(64683)
ARABIC_LIGATURE_KHAH_WITH_MEEM_INITIAL_FORM = chr(64684)
ARABIC_LIGATURE_SEEN_WITH_JEEM_INITIAL_FORM = chr(64685)
ARABIC_LIGATURE_SEEN_WITH_HAH_INITIAL_FORM = chr(64686)
ARABIC_LIGATURE_SEEN_WITH_KHAH_INITIAL_FORM = chr(64687)
ARABIC_LIGATURE_SEEN_WITH_MEEM_INITIAL_FORM = chr(64688)
ARABIC_LIGATURE_SAD_WITH_HAH_INITIAL_FORM = chr(64689)
ARABIC_LIGATURE_SAD_WITH_KHAH_INITIAL_FORM = chr(64690)
ARABIC_LIGATURE_SAD_WITH_MEEM_INITIAL_FORM = chr(64691)
ARABIC_LIGATURE_DAD_WITH_JEEM_INITIAL_FORM = chr(64692)
ARABIC_LIGATURE_DAD_WITH_HAH_INITIAL_FORM = chr(64693)
ARABIC_LIGATURE_DAD_WITH_KHAH_INITIAL_FORM = chr(64694)
ARABIC_LIGATURE_DAD_WITH_MEEM_INITIAL_FORM = chr(64695)
ARABIC_LIGATURE_TAH_WITH_HAH_INITIAL_FORM = chr(64696)
ARABIC_LIGATURE_ZAH_WITH_MEEM_INITIAL_FORM = chr(64697)
ARABIC_LIGATURE_AIN_WITH_JEEM_INITIAL_FORM = chr(64698)
ARABIC_LIGATURE_AIN_WITH_MEEM_INITIAL_FORM = chr(64699)
ARABIC_LIGATURE_GHAIN_WITH_JEEM_INITIAL_FORM = chr(64700)
ARABIC_LIGATURE_GHAIN_WITH_MEEM_INITIAL_FORM = chr(64701)
ARABIC_LIGATURE_FEH_WITH_JEEM_INITIAL_FORM = chr(64702)
ARABIC_LIGATURE_FEH_WITH_HAH_INITIAL_FORM = chr(64703)
ARABIC_LIGATURE_FEH_WITH_KHAH_INITIAL_FORM = chr(64704)
ARABIC_LIGATURE_FEH_WITH_MEEM_INITIAL_FORM = chr(64705)
ARABIC_LIGATURE_QAF_WITH_HAH_INITIAL_FORM = chr(64706)
ARABIC_LIGATURE_QAF_WITH_MEEM_INITIAL_FORM = chr(64707)
ARABIC_LIGATURE_KAF_WITH_JEEM_INITIAL_FORM = chr(64708)
ARABIC_LIGATURE_KAF_WITH_HAH_INITIAL_FORM = chr(64709)
ARABIC_LIGATURE_KAF_WITH_KHAH_INITIAL_FORM = chr(64710)
ARABIC_LIGATURE_KAF_WITH_LAM_INITIAL_FORM = chr(64711)
ARABIC_LIGATURE_KAF_WITH_MEEM_INITIAL_FORM = chr(64712)
ARABIC_LIGATURE_LAM_WITH_JEEM_INITIAL_FORM = chr(64713)
ARABIC_LIGATURE_LAM_WITH_HAH_INITIAL_FORM = chr(64714)
ARABIC_LIGATURE_LAM_WITH_KHAH_INITIAL_FORM = chr(64715)
ARABIC_LIGATURE_LAM_WITH_MEEM_INITIAL_FORM = chr(64716)
ARABIC_LIGATURE_LAM_WITH_HEH_INITIAL_FORM = chr(64717)
ARABIC_LIGATURE_MEEM_WITH_JEEM_INITIAL_FORM = chr(64718)
ARABIC_LIGATURE_MEEM_WITH_HAH_INITIAL_FORM = chr(64719)
ARABIC_LIGATURE_MEEM_WITH_KHAH_INITIAL_FORM = chr(64720)
ARABIC_LIGATURE_MEEM_WITH_MEEM_INITIAL_FORM = chr(64721)
ARABIC_LIGATURE_NOON_WITH_JEEM_INITIAL_FORM = chr(64722)
ARABIC_LIGATURE_NOON_WITH_HAH_INITIAL_FORM = chr(64723)
ARABIC_LIGATURE_NOON_WITH_KHAH_INITIAL_FORM = chr(64724)
ARABIC_LIGATURE_NOON_WITH_MEEM_INITIAL_FORM = chr(64725)
ARABIC_LIGATURE_NOON_WITH_HEH_INITIAL_FORM = chr(64726)
ARABIC_LIGATURE_HEH_WITH_JEEM_INITIAL_FORM = chr(64727)
ARABIC_LIGATURE_HEH_WITH_MEEM_INITIAL_FORM = chr(64728)
ARABIC_LIGATURE_HEH_WITH_SUPERSCRIPT_ALEF_INITIAL_FORM = chr(64729)
ARABIC_LIGATURE_YEH_WITH_JEEM_INITIAL_FORM = chr(64730)
ARABIC_LIGATURE_YEH_WITH_HAH_INITIAL_FORM = chr(64731)
ARABIC_LIGATURE_YEH_WITH_KHAH_INITIAL_FORM = chr(64732)
ARABIC_LIGATURE_YEH_WITH_MEEM_INITIAL_FORM = chr(64733)
ARABIC_LIGATURE_YEH_WITH_HEH_INITIAL_FORM = chr(64734)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_MEEM_MEDIAL_FORM = chr(64735)
ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_HEH_MEDIAL_FORM = chr(64736)
ARABIC_LIGATURE_BEH_WITH_MEEM_MEDIAL_FORM = chr(64737)
ARABIC_LIGATURE_BEH_WITH_HEH_MEDIAL_FORM = chr(64738)
ARABIC_LIGATURE_TEH_WITH_MEEM_MEDIAL_FORM = chr(64739)
ARABIC_LIGATURE_TEH_WITH_HEH_MEDIAL_FORM = chr(64740)
ARABIC_LIGATURE_THEH_WITH_MEEM_MEDIAL_FORM = chr(64741)
ARABIC_LIGATURE_THEH_WITH_HEH_MEDIAL_FORM = chr(64742)
ARABIC_LIGATURE_SEEN_WITH_MEEM_MEDIAL_FORM = chr(64743)
ARABIC_LIGATURE_SEEN_WITH_HEH_MEDIAL_FORM = chr(64744)
ARABIC_LIGATURE_SHEEN_WITH_MEEM_MEDIAL_FORM = chr(64745)
ARABIC_LIGATURE_SHEEN_WITH_HEH_MEDIAL_FORM = chr(64746)
ARABIC_LIGATURE_KAF_WITH_LAM_MEDIAL_FORM = chr(64747)
ARABIC_LIGATURE_KAF_WITH_MEEM_MEDIAL_FORM = chr(64748)
ARABIC_LIGATURE_LAM_WITH_MEEM_MEDIAL_FORM = chr(64749)
ARABIC_LIGATURE_NOON_WITH_MEEM_MEDIAL_FORM = chr(64750)
ARABIC_LIGATURE_NOON_WITH_HEH_MEDIAL_FORM = chr(64751)
ARABIC_LIGATURE_YEH_WITH_MEEM_MEDIAL_FORM = chr(64752)
ARABIC_LIGATURE_YEH_WITH_HEH_MEDIAL_FORM = chr(64753)
ARABIC_LIGATURE_SHADDA_WITH_FATHA_MEDIAL_FORM = chr(64754)
ARABIC_LIGATURE_SHADDA_WITH_DAMMA_MEDIAL_FORM = chr(64755)
ARABIC_LIGATURE_SHADDA_WITH_KASRA_MEDIAL_FORM = chr(64756)
ARABIC_LIGATURE_TAH_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64757)
ARABIC_LIGATURE_TAH_WITH_YEH_ISOLATED_FORM = chr(64758)
ARABIC_LIGATURE_AIN_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64759)
ARABIC_LIGATURE_AIN_WITH_YEH_ISOLATED_FORM = chr(64760)
ARABIC_LIGATURE_GHAIN_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64761)
ARABIC_LIGATURE_GHAIN_WITH_YEH_ISOLATED_FORM = chr(64762)
ARABIC_LIGATURE_SEEN_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64763)
ARABIC_LIGATURE_SEEN_WITH_YEH_ISOLATED_FORM = chr(64764)
ARABIC_LIGATURE_SHEEN_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64765)
ARABIC_LIGATURE_SHEEN_WITH_YEH_ISOLATED_FORM = chr(64766)
ARABIC_LIGATURE_HAH_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64767)
ARABIC_LIGATURE_HAH_WITH_YEH_ISOLATED_FORM = chr(64768)
ARABIC_LIGATURE_JEEM_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64769)
ARABIC_LIGATURE_JEEM_WITH_YEH_ISOLATED_FORM = chr(64770)
ARABIC_LIGATURE_KHAH_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64771)
ARABIC_LIGATURE_KHAH_WITH_YEH_ISOLATED_FORM = chr(64772)
ARABIC_LIGATURE_SAD_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64773)
ARABIC_LIGATURE_SAD_WITH_YEH_ISOLATED_FORM = chr(64774)
ARABIC_LIGATURE_DAD_WITH_ALEF_MAKSURA_ISOLATED_FORM = chr(64775)
ARABIC_LIGATURE_DAD_WITH_YEH_ISOLATED_FORM = chr(64776)
ARABIC_LIGATURE_SHEEN_WITH_JEEM_ISOLATED_FORM = chr(64777)
ARABIC_LIGATURE_SHEEN_WITH_HAH_ISOLATED_FORM = chr(64778)
ARABIC_LIGATURE_SHEEN_WITH_KHAH_ISOLATED_FORM = chr(64779)
ARABIC_LIGATURE_SHEEN_WITH_MEEM_ISOLATED_FORM = chr(64780)
ARABIC_LIGATURE_SHEEN_WITH_REH_ISOLATED_FORM = chr(64781)
ARABIC_LIGATURE_SEEN_WITH_REH_ISOLATED_FORM = chr(64782)
ARABIC_LIGATURE_SAD_WITH_REH_ISOLATED_FORM = chr(64783)
ARABIC_LIGATURE_DAD_WITH_REH_ISOLATED_FORM = chr(64784)
ARABIC_LIGATURE_TAH_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64785)
ARABIC_LIGATURE_TAH_WITH_YEH_FINAL_FORM = chr(64786)
ARABIC_LIGATURE_AIN_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64787)
ARABIC_LIGATURE_AIN_WITH_YEH_FINAL_FORM = chr(64788)
ARABIC_LIGATURE_GHAIN_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64789)
ARABIC_LIGATURE_GHAIN_WITH_YEH_FINAL_FORM = chr(64790)
ARABIC_LIGATURE_SEEN_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64791)
ARABIC_LIGATURE_SEEN_WITH_YEH_FINAL_FORM = chr(64792)
ARABIC_LIGATURE_SHEEN_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64793)
ARABIC_LIGATURE_SHEEN_WITH_YEH_FINAL_FORM = chr(64794)
ARABIC_LIGATURE_HAH_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64795)
ARABIC_LIGATURE_HAH_WITH_YEH_FINAL_FORM = chr(64796)
ARABIC_LIGATURE_JEEM_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64797)
ARABIC_LIGATURE_JEEM_WITH_YEH_FINAL_FORM = chr(64798)
ARABIC_LIGATURE_KHAH_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64799)
ARABIC_LIGATURE_KHAH_WITH_YEH_FINAL_FORM = chr(64800)
ARABIC_LIGATURE_SAD_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64801)
ARABIC_LIGATURE_SAD_WITH_YEH_FINAL_FORM = chr(64802)
ARABIC_LIGATURE_DAD_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64803)
ARABIC_LIGATURE_DAD_WITH_YEH_FINAL_FORM = chr(64804)
ARABIC_LIGATURE_SHEEN_WITH_JEEM_FINAL_FORM = chr(64805)
ARABIC_LIGATURE_SHEEN_WITH_HAH_FINAL_FORM = chr(64806)
ARABIC_LIGATURE_SHEEN_WITH_KHAH_FINAL_FORM = chr(64807)
ARABIC_LIGATURE_SHEEN_WITH_MEEM_FINAL_FORM = chr(64808)
ARABIC_LIGATURE_SHEEN_WITH_REH_FINAL_FORM = chr(64809)
ARABIC_LIGATURE_SEEN_WITH_REH_FINAL_FORM = chr(64810)
ARABIC_LIGATURE_SAD_WITH_REH_FINAL_FORM = chr(64811)
ARABIC_LIGATURE_DAD_WITH_REH_FINAL_FORM = chr(64812)
ARABIC_LIGATURE_SHEEN_WITH_JEEM_INITIAL_FORM = chr(64813)
ARABIC_LIGATURE_SHEEN_WITH_HAH_INITIAL_FORM = chr(64814)
ARABIC_LIGATURE_SHEEN_WITH_KHAH_INITIAL_FORM = chr(64815)
ARABIC_LIGATURE_SHEEN_WITH_MEEM_INITIAL_FORM = chr(64816)
ARABIC_LIGATURE_SEEN_WITH_HEH_INITIAL_FORM = chr(64817)
ARABIC_LIGATURE_SHEEN_WITH_HEH_INITIAL_FORM = chr(64818)
ARABIC_LIGATURE_TAH_WITH_MEEM_INITIAL_FORM = chr(64819)
ARABIC_LIGATURE_SEEN_WITH_JEEM_MEDIAL_FORM = chr(64820)
ARABIC_LIGATURE_SEEN_WITH_HAH_MEDIAL_FORM = chr(64821)
ARABIC_LIGATURE_SEEN_WITH_KHAH_MEDIAL_FORM = chr(64822)
ARABIC_LIGATURE_SHEEN_WITH_JEEM_MEDIAL_FORM = chr(64823)
ARABIC_LIGATURE_SHEEN_WITH_HAH_MEDIAL_FORM = chr(64824)
ARABIC_LIGATURE_SHEEN_WITH_KHAH_MEDIAL_FORM = chr(64825)
ARABIC_LIGATURE_TAH_WITH_MEEM_MEDIAL_FORM = chr(64826)
ARABIC_LIGATURE_ZAH_WITH_MEEM_MEDIAL_FORM = chr(64827)
ARABIC_LIGATURE_ALEF_WITH_FATHATAN_FINAL_FORM = chr(64828)
ARABIC_LIGATURE_ALEF_WITH_FATHATAN_ISOLATED_FORM = chr(64829)
ORNATE_LEFT_PARENTHESIS = chr(64830)
ORNATE_RIGHT_PARENTHESIS = chr(64831)
ARABIC_LIGATURE_RAHIMAHU_ALLAAH = chr(64832)
ARABIC_LIGATURE_RADI_ALLAAHU_ANH = chr(64833)
ARABIC_LIGATURE_RADI_ALLAAHU_ANHAA = chr(64834)
ARABIC_LIGATURE_RADI_ALLAAHU_ANHUM = chr(64835)
ARABIC_LIGATURE_RADI_ALLAAHU_ANHUMAA = chr(64836)
ARABIC_LIGATURE_RADI_ALLAAHU_ANHUNNA = chr(64837)
ARABIC_LIGATURE_SALLALLAAHU_ALAYHI_WA_AALIH = chr(64838)
ARABIC_LIGATURE_ALAYHI_AS_SALAAM = chr(64839)
ARABIC_LIGATURE_ALAYHIM_AS_SALAAM = chr(64840)
ARABIC_LIGATURE_ALAYHIMAA_AS_SALAAM = chr(64841)
ARABIC_LIGATURE_ALAYHI_AS_SALAATU_WAS_SALAAM = chr(64842)
ARABIC_LIGATURE_QUDDISA_SIRRAH = chr(64843)
ARABIC_LIGATURE_SALLALLAHU_ALAYHI_WAAALIHEE_WA_SALLAM = chr(64844)
ARABIC_LIGATURE_ALAYHAA_AS_SALAAM = chr(64845)
ARABIC_LIGATURE_TABAARAKA_WA_TAAALAA = chr(64846)
ARABIC_LIGATURE_RAHIMAHUM_ALLAAH = chr(64847)
ARABIC_LIGATURE_TEH_WITH_JEEM_WITH_MEEM_INITIAL_FORM = chr(64848)
ARABIC_LIGATURE_TEH_WITH_HAH_WITH_JEEM_FINAL_FORM = chr(64849)
ARABIC_LIGATURE_TEH_WITH_HAH_WITH_JEEM_INITIAL_FORM = chr(64850)
ARABIC_LIGATURE_TEH_WITH_HAH_WITH_MEEM_INITIAL_FORM = chr(64851)
ARABIC_LIGATURE_TEH_WITH_KHAH_WITH_MEEM_INITIAL_FORM = chr(64852)
ARABIC_LIGATURE_TEH_WITH_MEEM_WITH_JEEM_INITIAL_FORM = chr(64853)
ARABIC_LIGATURE_TEH_WITH_MEEM_WITH_HAH_INITIAL_FORM = chr(64854)
ARABIC_LIGATURE_TEH_WITH_MEEM_WITH_KHAH_INITIAL_FORM = chr(64855)
ARABIC_LIGATURE_JEEM_WITH_MEEM_WITH_HAH_FINAL_FORM = chr(64856)
ARABIC_LIGATURE_JEEM_WITH_MEEM_WITH_HAH_INITIAL_FORM = chr(64857)
ARABIC_LIGATURE_HAH_WITH_MEEM_WITH_YEH_FINAL_FORM = chr(64858)
ARABIC_LIGATURE_HAH_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64859)
ARABIC_LIGATURE_SEEN_WITH_HAH_WITH_JEEM_INITIAL_FORM = chr(64860)
ARABIC_LIGATURE_SEEN_WITH_JEEM_WITH_HAH_INITIAL_FORM = chr(64861)
ARABIC_LIGATURE_SEEN_WITH_JEEM_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64862)
ARABIC_LIGATURE_SEEN_WITH_MEEM_WITH_HAH_FINAL_FORM = chr(64863)
ARABIC_LIGATURE_SEEN_WITH_MEEM_WITH_HAH_INITIAL_FORM = chr(64864)
ARABIC_LIGATURE_SEEN_WITH_MEEM_WITH_JEEM_INITIAL_FORM = chr(64865)
ARABIC_LIGATURE_SEEN_WITH_MEEM_WITH_MEEM_FINAL_FORM = chr(64866)
ARABIC_LIGATURE_SEEN_WITH_MEEM_WITH_MEEM_INITIAL_FORM = chr(64867)
ARABIC_LIGATURE_SAD_WITH_HAH_WITH_HAH_FINAL_FORM = chr(64868)
ARABIC_LIGATURE_SAD_WITH_HAH_WITH_HAH_INITIAL_FORM = chr(64869)
ARABIC_LIGATURE_SAD_WITH_MEEM_WITH_MEEM_FINAL_FORM = chr(64870)
ARABIC_LIGATURE_SHEEN_WITH_HAH_WITH_MEEM_FINAL_FORM = chr(64871)
ARABIC_LIGATURE_SHEEN_WITH_HAH_WITH_MEEM_INITIAL_FORM = chr(64872)
ARABIC_LIGATURE_SHEEN_WITH_JEEM_WITH_YEH_FINAL_FORM = chr(64873)
ARABIC_LIGATURE_SHEEN_WITH_MEEM_WITH_KHAH_FINAL_FORM = chr(64874)
ARABIC_LIGATURE_SHEEN_WITH_MEEM_WITH_KHAH_INITIAL_FORM = chr(64875)
ARABIC_LIGATURE_SHEEN_WITH_MEEM_WITH_MEEM_FINAL_FORM = chr(64876)
ARABIC_LIGATURE_SHEEN_WITH_MEEM_WITH_MEEM_INITIAL_FORM = chr(64877)
ARABIC_LIGATURE_DAD_WITH_HAH_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64878)
ARABIC_LIGATURE_DAD_WITH_KHAH_WITH_MEEM_FINAL_FORM = chr(64879)
ARABIC_LIGATURE_DAD_WITH_KHAH_WITH_MEEM_INITIAL_FORM = chr(64880)
ARABIC_LIGATURE_TAH_WITH_MEEM_WITH_HAH_FINAL_FORM = chr(64881)
ARABIC_LIGATURE_TAH_WITH_MEEM_WITH_HAH_INITIAL_FORM = chr(64882)
ARABIC_LIGATURE_TAH_WITH_MEEM_WITH_MEEM_INITIAL_FORM = chr(64883)
ARABIC_LIGATURE_TAH_WITH_MEEM_WITH_YEH_FINAL_FORM = chr(64884)
ARABIC_LIGATURE_AIN_WITH_JEEM_WITH_MEEM_FINAL_FORM = chr(64885)
ARABIC_LIGATURE_AIN_WITH_MEEM_WITH_MEEM_FINAL_FORM = chr(64886)
ARABIC_LIGATURE_AIN_WITH_MEEM_WITH_MEEM_INITIAL_FORM = chr(64887)
ARABIC_LIGATURE_AIN_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64888)
ARABIC_LIGATURE_GHAIN_WITH_MEEM_WITH_MEEM_FINAL_FORM = chr(64889)
ARABIC_LIGATURE_GHAIN_WITH_MEEM_WITH_YEH_FINAL_FORM = chr(64890)
ARABIC_LIGATURE_GHAIN_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64891)
ARABIC_LIGATURE_FEH_WITH_KHAH_WITH_MEEM_FINAL_FORM = chr(64892)
ARABIC_LIGATURE_FEH_WITH_KHAH_WITH_MEEM_INITIAL_FORM = chr(64893)
ARABIC_LIGATURE_QAF_WITH_MEEM_WITH_HAH_FINAL_FORM = chr(64894)
ARABIC_LIGATURE_QAF_WITH_MEEM_WITH_MEEM_FINAL_FORM = chr(64895)
ARABIC_LIGATURE_LAM_WITH_HAH_WITH_MEEM_FINAL_FORM = chr(64896)
ARABIC_LIGATURE_LAM_WITH_HAH_WITH_YEH_FINAL_FORM = chr(64897)
ARABIC_LIGATURE_LAM_WITH_HAH_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64898)
ARABIC_LIGATURE_LAM_WITH_JEEM_WITH_JEEM_INITIAL_FORM = chr(64899)
ARABIC_LIGATURE_LAM_WITH_JEEM_WITH_JEEM_FINAL_FORM = chr(64900)
ARABIC_LIGATURE_LAM_WITH_KHAH_WITH_MEEM_FINAL_FORM = chr(64901)
ARABIC_LIGATURE_LAM_WITH_KHAH_WITH_MEEM_INITIAL_FORM = chr(64902)
ARABIC_LIGATURE_LAM_WITH_MEEM_WITH_HAH_FINAL_FORM = chr(64903)
ARABIC_LIGATURE_LAM_WITH_MEEM_WITH_HAH_INITIAL_FORM = chr(64904)
ARABIC_LIGATURE_MEEM_WITH_HAH_WITH_JEEM_INITIAL_FORM = chr(64905)
ARABIC_LIGATURE_MEEM_WITH_HAH_WITH_MEEM_INITIAL_FORM = chr(64906)
ARABIC_LIGATURE_MEEM_WITH_HAH_WITH_YEH_FINAL_FORM = chr(64907)
ARABIC_LIGATURE_MEEM_WITH_JEEM_WITH_HAH_INITIAL_FORM = chr(64908)
ARABIC_LIGATURE_MEEM_WITH_JEEM_WITH_MEEM_INITIAL_FORM = chr(64909)
ARABIC_LIGATURE_MEEM_WITH_KHAH_WITH_JEEM_INITIAL_FORM = chr(64910)
ARABIC_LIGATURE_MEEM_WITH_KHAH_WITH_MEEM_INITIAL_FORM = chr(64911)
ARABIC_LIGATURE_MEEM_WITH_JEEM_WITH_KHAH_INITIAL_FORM = chr(64914)
ARABIC_LIGATURE_HEH_WITH_MEEM_WITH_JEEM_INITIAL_FORM = chr(64915)
ARABIC_LIGATURE_HEH_WITH_MEEM_WITH_MEEM_INITIAL_FORM = chr(64916)
ARABIC_LIGATURE_NOON_WITH_HAH_WITH_MEEM_INITIAL_FORM = chr(64917)
ARABIC_LIGATURE_NOON_WITH_HAH_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64918)
ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_MEEM_FINAL_FORM = chr(64919)
ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_MEEM_INITIAL_FORM = chr(64920)
ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64921)
ARABIC_LIGATURE_NOON_WITH_MEEM_WITH_YEH_FINAL_FORM = chr(64922)
ARABIC_LIGATURE_NOON_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64923)
ARABIC_LIGATURE_YEH_WITH_MEEM_WITH_MEEM_FINAL_FORM = chr(64924)
ARABIC_LIGATURE_YEH_WITH_MEEM_WITH_MEEM_INITIAL_FORM = chr(64925)
ARABIC_LIGATURE_BEH_WITH_KHAH_WITH_YEH_FINAL_FORM = chr(64926)
ARABIC_LIGATURE_TEH_WITH_JEEM_WITH_YEH_FINAL_FORM = chr(64927)
ARABIC_LIGATURE_TEH_WITH_JEEM_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64928)
ARABIC_LIGATURE_TEH_WITH_KHAH_WITH_YEH_FINAL_FORM = chr(64929)
ARABIC_LIGATURE_TEH_WITH_KHAH_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64930)
ARABIC_LIGATURE_TEH_WITH_MEEM_WITH_YEH_FINAL_FORM = chr(64931)
ARABIC_LIGATURE_TEH_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64932)
ARABIC_LIGATURE_JEEM_WITH_MEEM_WITH_YEH_FINAL_FORM = chr(64933)
ARABIC_LIGATURE_JEEM_WITH_HAH_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64934)
ARABIC_LIGATURE_JEEM_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64935)
ARABIC_LIGATURE_SEEN_WITH_KHAH_WITH_ALEF_MAKSURA_FINAL_FORM = chr(64936)
ARABIC_LIGATURE_SAD_WITH_HAH_WITH_YEH_FINAL_FORM = chr(64937)
ARABIC_LIGATURE_SHEEN_WITH_HAH_WITH_YEH_FINAL_FORM = chr(64938)
ARABIC_LIGATURE_DAD_WITH_HAH_WITH_YEH_FINAL_FORM = chr(64939)
ARABIC_LIGATURE_LAM_WITH_JEEM_WITH_YEH_FINAL_FORM = chr(64940)
ARABIC_LIGATURE_LAM_WITH_MEEM_WITH_YEH_FINAL_FORM = chr(64941)
ARABIC_LIGATURE_YEH_WITH_HAH_WITH_YEH_FINAL_FORM = chr(64942)
ARABIC_LIGATURE_YEH_WITH_JEEM_WITH_YEH_FINAL_FORM = chr(64943)
ARABIC_LIGATURE_YEH_WITH_MEEM_WITH_YEH_FINAL_FORM = chr(64944)
ARABIC_LIGATURE_MEEM_WITH_MEEM_WITH_YEH_FINAL_FORM = chr(64945)
ARABIC_LIGATURE_QAF_WITH_MEEM_WITH_YEH_FINAL_FORM = chr(64946)
ARABIC_LIGATURE_NOON_WITH_HAH_WITH_YEH_FINAL_FORM = chr(64947)
ARABIC_LIGATURE_QAF_WITH_MEEM_WITH_HAH_INITIAL_FORM = chr(64948)
ARABIC_LIGATURE_LAM_WITH_HAH_WITH_MEEM_INITIAL_FORM = chr(64949)
ARABIC_LIGATURE_AIN_WITH_MEEM_WITH_YEH_FINAL_FORM = chr(64950)
ARABIC_LIGATURE_KAF_WITH_MEEM_WITH_YEH_FINAL_FORM = chr(64951)
ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_HAH_INITIAL_FORM = chr(64952)
ARABIC_LIGATURE_MEEM_WITH_KHAH_WITH_YEH_FINAL_FORM = chr(64953)
ARABIC_LIGATURE_LAM_WITH_JEEM_WITH_MEEM_INITIAL_FORM = chr(64954)
ARABIC_LIGATURE_KAF_WITH_MEEM_WITH_MEEM_FINAL_FORM = chr(64955)
ARABIC_LIGATURE_LAM_WITH_JEEM_WITH_MEEM_FINAL_FORM = chr(64956)
ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_HAH_FINAL_FORM = chr(64957)
ARABIC_LIGATURE_JEEM_WITH_HAH_WITH_YEH_FINAL_FORM = chr(64958)
ARABIC_LIGATURE_HAH_WITH_JEEM_WITH_YEH_FINAL_FORM = chr(64959)
ARABIC_LIGATURE_MEEM_WITH_JEEM_WITH_YEH_FINAL_FORM = chr(64960)
ARABIC_LIGATURE_FEH_WITH_MEEM_WITH_YEH_FINAL_FORM = chr(64961)
ARABIC_LIGATURE_BEH_WITH_HAH_WITH_YEH_FINAL_FORM = chr(64962)
ARABIC_LIGATURE_KAF_WITH_MEEM_WITH_MEEM_INITIAL_FORM = chr(64963)
ARABIC_LIGATURE_AIN_WITH_JEEM_WITH_MEEM_INITIAL_FORM = chr(64964)
ARABIC_LIGATURE_SAD_WITH_MEEM_WITH_MEEM_INITIAL_FORM = chr(64965)
ARABIC_LIGATURE_SEEN_WITH_KHAH_WITH_YEH_FINAL_FORM = chr(64966)
ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_YEH_FINAL_FORM = chr(64967)
ARABIC_LIGATURE_SALAAMUHU_ALAYNAA = chr(64975)
ARABIC_LIGATURE_SALLA_USED_AS_KORANIC_STOP_SIGN_ISOLATED_FORM = chr(65008)
ARABIC_LIGATURE_QALA_USED_AS_KORANIC_STOP_SIGN_ISOLATED_FORM = chr(65009)
ARABIC_LIGATURE_ALLAH_ISOLATED_FORM = chr(65010)
ARABIC_LIGATURE_AKBAR_ISOLATED_FORM = chr(65011)
ARABIC_LIGATURE_MOHAMMAD_ISOLATED_FORM = chr(65012)
ARABIC_LIGATURE_SALAM_ISOLATED_FORM = chr(65013)
ARABIC_LIGATURE_RASOUL_ISOLATED_FORM = chr(65014)
ARABIC_LIGATURE_ALAYHE_ISOLATED_FORM = chr(65015)
ARABIC_LIGATURE_WASALLAM_ISOLATED_FORM = chr(65016)
ARABIC_LIGATURE_SALLA_ISOLATED_FORM = chr(65017)
ARABIC_LIGATURE_SALLALLAHOU_ALAYHE_WASALLAM = chr(65018)
ARABIC_LIGATURE_JALLAJALALOUHOU = chr(65019)
RIAL_SIGN = chr(65020)
ARABIC_LIGATURE_BISMILLAH_AR_RAHMAN_AR_RAHEEM = chr(65021)
ARABIC_LIGATURE_SUBHAANAHU_WA_TAAALAA = chr(65022)
ARABIC_LIGATURE_AZZA_WA_JALL = chr(65023)
VARIATION_SELECTOR_1 = chr(65024)
VARIATION_SELECTOR_2 = chr(65025)
VARIATION_SELECTOR_3 = chr(65026)
VARIATION_SELECTOR_4 = chr(65027)
VARIATION_SELECTOR_5 = chr(65028)
VARIATION_SELECTOR_6 = chr(65029)
VARIATION_SELECTOR_7 = chr(65030)
VARIATION_SELECTOR_8 = chr(65031)
VARIATION_SELECTOR_9 = chr(65032)
VARIATION_SELECTOR_10 = chr(65033)
VARIATION_SELECTOR_11 = chr(65034)
VARIATION_SELECTOR_12 = chr(65035)
VARIATION_SELECTOR_13 = chr(65036)
VARIATION_SELECTOR_14 = chr(65037)
VARIATION_SELECTOR_15 = chr(65038)
VARIATION_SELECTOR_16 = chr(65039)
PRESENTATION_FORM_FOR_VERTICAL_COMMA = chr(65040)
PRESENTATION_FORM_FOR_VERTICAL_IDEOGRAPHIC_COMMA = chr(65041)
PRESENTATION_FORM_FOR_VERTICAL_IDEOGRAPHIC_FULL_STOP = chr(65042)
PRESENTATION_FORM_FOR_VERTICAL_COLON = chr(65043)
PRESENTATION_FORM_FOR_VERTICAL_SEMICOLON = chr(65044)
PRESENTATION_FORM_FOR_VERTICAL_EXCLAMATION_MARK = chr(65045)
PRESENTATION_FORM_FOR_VERTICAL_QUESTION_MARK = chr(65046)
PRESENTATION_FORM_FOR_VERTICAL_LEFT_WHITE_LENTICULAR_BRACKET = chr(65047)
PRESENTATION_FORM_FOR_VERTICAL_RIGHT_WHITE_LENTICULAR_BRAKCET = chr(65048)
PRESENTATION_FORM_FOR_VERTICAL_HORIZONTAL_ELLIPSIS = chr(65049)
COMBINING_LIGATURE_LEFT_HALF = chr(65056)
COMBINING_LIGATURE_RIGHT_HALF = chr(65057)
COMBINING_DOUBLE_TILDE_LEFT_HALF = chr(65058)
COMBINING_DOUBLE_TILDE_RIGHT_HALF = chr(65059)
COMBINING_MACRON_LEFT_HALF = chr(65060)
COMBINING_MACRON_RIGHT_HALF = chr(65061)
COMBINING_CONJOINING_MACRON = chr(65062)
COMBINING_LIGATURE_LEFT_HALF_BELOW = chr(65063)
COMBINING_LIGATURE_RIGHT_HALF_BELOW = chr(65064)
COMBINING_TILDE_LEFT_HALF_BELOW = chr(65065)
COMBINING_TILDE_RIGHT_HALF_BELOW = chr(65066)
COMBINING_MACRON_LEFT_HALF_BELOW = chr(65067)
COMBINING_MACRON_RIGHT_HALF_BELOW = chr(65068)
COMBINING_CONJOINING_MACRON_BELOW = chr(65069)
COMBINING_CYRILLIC_TITLO_LEFT_HALF = chr(65070)
COMBINING_CYRILLIC_TITLO_RIGHT_HALF = chr(65071)
PRESENTATION_FORM_FOR_VERTICAL_TWO_DOT_LEADER = chr(65072)
PRESENTATION_FORM_FOR_VERTICAL_EM_DASH = chr(65073)
PRESENTATION_FORM_FOR_VERTICAL_EN_DASH = chr(65074)
PRESENTATION_FORM_FOR_VERTICAL_LOW_LINE = chr(65075)
PRESENTATION_FORM_FOR_VERTICAL_WAVY_LOW_LINE = chr(65076)
PRESENTATION_FORM_FOR_VERTICAL_LEFT_PARENTHESIS = chr(65077)
PRESENTATION_FORM_FOR_VERTICAL_RIGHT_PARENTHESIS = chr(65078)
PRESENTATION_FORM_FOR_VERTICAL_LEFT_CURLY_BRACKET = chr(65079)
PRESENTATION_FORM_FOR_VERTICAL_RIGHT_CURLY_BRACKET = chr(65080)
PRESENTATION_FORM_FOR_VERTICAL_LEFT_TORTOISE_SHELL_BRACKET = chr(65081)
PRESENTATION_FORM_FOR_VERTICAL_RIGHT_TORTOISE_SHELL_BRACKET = chr(65082)
PRESENTATION_FORM_FOR_VERTICAL_LEFT_BLACK_LENTICULAR_BRACKET = chr(65083)
PRESENTATION_FORM_FOR_VERTICAL_RIGHT_BLACK_LENTICULAR_BRACKET = chr(65084)
PRESENTATION_FORM_FOR_VERTICAL_LEFT_DOUBLE_ANGLE_BRACKET = chr(65085)
PRESENTATION_FORM_FOR_VERTICAL_RIGHT_DOUBLE_ANGLE_BRACKET = chr(65086)
PRESENTATION_FORM_FOR_VERTICAL_LEFT_ANGLE_BRACKET = chr(65087)
PRESENTATION_FORM_FOR_VERTICAL_RIGHT_ANGLE_BRACKET = chr(65088)
PRESENTATION_FORM_FOR_VERTICAL_LEFT_CORNER_BRACKET = chr(65089)
PRESENTATION_FORM_FOR_VERTICAL_RIGHT_CORNER_BRACKET = chr(65090)
PRESENTATION_FORM_FOR_VERTICAL_LEFT_WHITE_CORNER_BRACKET = chr(65091)
PRESENTATION_FORM_FOR_VERTICAL_RIGHT_WHITE_CORNER_BRACKET = chr(65092)
SESAME_DOT = chr(65093)
WHITE_SESAME_DOT = chr(65094)
PRESENTATION_FORM_FOR_VERTICAL_LEFT_SQUARE_BRACKET = chr(65095)
PRESENTATION_FORM_FOR_VERTICAL_RIGHT_SQUARE_BRACKET = chr(65096)
DASHED_OVERLINE = chr(65097)
CENTRELINE_OVERLINE = chr(65098)
WAVY_OVERLINE = chr(65099)
DOUBLE_WAVY_OVERLINE = chr(65100)
DASHED_LOW_LINE = chr(65101)
CENTRELINE_LOW_LINE = chr(65102)
WAVY_LOW_LINE = chr(65103)
SMALL_COMMA = chr(65104)
SMALL_IDEOGRAPHIC_COMMA = chr(65105)
SMALL_FULL_STOP = chr(65106)
SMALL_SEMICOLON = chr(65108)
SMALL_COLON = chr(65109)
SMALL_QUESTION_MARK = chr(65110)
SMALL_EXCLAMATION_MARK = chr(65111)
SMALL_EM_DASH = chr(65112)
SMALL_LEFT_PARENTHESIS = chr(65113)
SMALL_RIGHT_PARENTHESIS = chr(65114)
SMALL_LEFT_CURLY_BRACKET = chr(65115)
SMALL_RIGHT_CURLY_BRACKET = chr(65116)
SMALL_LEFT_TORTOISE_SHELL_BRACKET = chr(65117)
SMALL_RIGHT_TORTOISE_SHELL_BRACKET = chr(65118)
SMALL_NUMBER_SIGN = chr(65119)
SMALL_AMPERSAND = chr(65120)
SMALL_ASTERISK = chr(65121)
SMALL_PLUS_SIGN = chr(65122)
SMALL_HYPHEN_MINUS = chr(65123)
SMALL_LESS_THAN_SIGN = chr(65124)
SMALL_GREATER_THAN_SIGN = chr(65125)
SMALL_EQUALS_SIGN = chr(65126)
SMALL_REVERSE_SOLIDUS = chr(65128)
SMALL_DOLLAR_SIGN = chr(65129)
SMALL_PERCENT_SIGN = chr(65130)
SMALL_COMMERCIAL_AT = chr(65131)
ARABIC_FATHATAN_ISOLATED_FORM = chr(65136)
ARABIC_TATWEEL_WITH_FATHATAN_ABOVE = chr(65137)
ARABIC_DAMMATAN_ISOLATED_FORM = chr(65138)
ARABIC_TAIL_FRAGMENT = chr(65139)
ARABIC_KASRATAN_ISOLATED_FORM = chr(65140)
ARABIC_FATHA_ISOLATED_FORM = chr(65142)
ARABIC_FATHA_MEDIAL_FORM = chr(65143)
ARABIC_DAMMA_ISOLATED_FORM = chr(65144)
ARABIC_DAMMA_MEDIAL_FORM = chr(65145)
ARABIC_KASRA_ISOLATED_FORM = chr(65146)
ARABIC_KASRA_MEDIAL_FORM = chr(65147)
ARABIC_SHADDA_ISOLATED_FORM = chr(65148)
ARABIC_SHADDA_MEDIAL_FORM = chr(65149)
ARABIC_SUKUN_ISOLATED_FORM = chr(65150)
ARABIC_SUKUN_MEDIAL_FORM = chr(65151)
ARABIC_LETTER_HAMZA_ISOLATED_FORM = chr(65152)
ARABIC_LETTER_ALEF_WITH_MADDA_ABOVE_ISOLATED_FORM = chr(65153)
ARABIC_LETTER_ALEF_WITH_MADDA_ABOVE_FINAL_FORM = chr(65154)
ARABIC_LETTER_ALEF_WITH_HAMZA_ABOVE_ISOLATED_FORM = chr(65155)
ARABIC_LETTER_ALEF_WITH_HAMZA_ABOVE_FINAL_FORM = chr(65156)
ARABIC_LETTER_WAW_WITH_HAMZA_ABOVE_ISOLATED_FORM = chr(65157)
ARABIC_LETTER_WAW_WITH_HAMZA_ABOVE_FINAL_FORM = chr(65158)
ARABIC_LETTER_ALEF_WITH_HAMZA_BELOW_ISOLATED_FORM = chr(65159)
ARABIC_LETTER_ALEF_WITH_HAMZA_BELOW_FINAL_FORM = chr(65160)
ARABIC_LETTER_YEH_WITH_HAMZA_ABOVE_ISOLATED_FORM = chr(65161)
ARABIC_LETTER_YEH_WITH_HAMZA_ABOVE_FINAL_FORM = chr(65162)
ARABIC_LETTER_YEH_WITH_HAMZA_ABOVE_INITIAL_FORM = chr(65163)
ARABIC_LETTER_YEH_WITH_HAMZA_ABOVE_MEDIAL_FORM = chr(65164)
ARABIC_LETTER_ALEF_ISOLATED_FORM = chr(65165)
ARABIC_LETTER_ALEF_FINAL_FORM = chr(65166)
ARABIC_LETTER_BEH_ISOLATED_FORM = chr(65167)
ARABIC_LETTER_BEH_FINAL_FORM = chr(65168)
ARABIC_LETTER_BEH_INITIAL_FORM = chr(65169)
ARABIC_LETTER_BEH_MEDIAL_FORM = chr(65170)
ARABIC_LETTER_TEH_MARBUTA_ISOLATED_FORM = chr(65171)
ARABIC_LETTER_TEH_MARBUTA_FINAL_FORM = chr(65172)
ARABIC_LETTER_TEH_ISOLATED_FORM = chr(65173)
ARABIC_LETTER_TEH_FINAL_FORM = chr(65174)
ARABIC_LETTER_TEH_INITIAL_FORM = chr(65175)
ARABIC_LETTER_TEH_MEDIAL_FORM = chr(65176)
ARABIC_LETTER_THEH_ISOLATED_FORM = chr(65177)
ARABIC_LETTER_THEH_FINAL_FORM = chr(65178)
ARABIC_LETTER_THEH_INITIAL_FORM = chr(65179)
ARABIC_LETTER_THEH_MEDIAL_FORM = chr(65180)
ARABIC_LETTER_JEEM_ISOLATED_FORM = chr(65181)
ARABIC_LETTER_JEEM_FINAL_FORM = chr(65182)
ARABIC_LETTER_JEEM_INITIAL_FORM = chr(65183)
ARABIC_LETTER_JEEM_MEDIAL_FORM = chr(65184)
ARABIC_LETTER_HAH_ISOLATED_FORM = chr(65185)
ARABIC_LETTER_HAH_FINAL_FORM = chr(65186)
ARABIC_LETTER_HAH_INITIAL_FORM = chr(65187)
ARABIC_LETTER_HAH_MEDIAL_FORM = chr(65188)
ARABIC_LETTER_KHAH_ISOLATED_FORM = chr(65189)
ARABIC_LETTER_KHAH_FINAL_FORM = chr(65190)
ARABIC_LETTER_KHAH_INITIAL_FORM = chr(65191)
ARABIC_LETTER_KHAH_MEDIAL_FORM = chr(65192)
ARABIC_LETTER_DAL_ISOLATED_FORM = chr(65193)
ARABIC_LETTER_DAL_FINAL_FORM = chr(65194)
ARABIC_LETTER_THAL_ISOLATED_FORM = chr(65195)
ARABIC_LETTER_THAL_FINAL_FORM = chr(65196)
ARABIC_LETTER_REH_ISOLATED_FORM = chr(65197)
ARABIC_LETTER_REH_FINAL_FORM = chr(65198)
ARABIC_LETTER_ZAIN_ISOLATED_FORM = chr(65199)
ARABIC_LETTER_ZAIN_FINAL_FORM = chr(65200)
ARABIC_LETTER_SEEN_ISOLATED_FORM = chr(65201)
ARABIC_LETTER_SEEN_FINAL_FORM = chr(65202)
ARABIC_LETTER_SEEN_INITIAL_FORM = chr(65203)
ARABIC_LETTER_SEEN_MEDIAL_FORM = chr(65204)
ARABIC_LETTER_SHEEN_ISOLATED_FORM = chr(65205)
ARABIC_LETTER_SHEEN_FINAL_FORM = chr(65206)
ARABIC_LETTER_SHEEN_INITIAL_FORM = chr(65207)
ARABIC_LETTER_SHEEN_MEDIAL_FORM = chr(65208)
ARABIC_LETTER_SAD_ISOLATED_FORM = chr(65209)
ARABIC_LETTER_SAD_FINAL_FORM = chr(65210)
ARABIC_LETTER_SAD_INITIAL_FORM = chr(65211)
ARABIC_LETTER_SAD_MEDIAL_FORM = chr(65212)
ARABIC_LETTER_DAD_ISOLATED_FORM = chr(65213)
ARABIC_LETTER_DAD_FINAL_FORM = chr(65214)
ARABIC_LETTER_DAD_INITIAL_FORM = chr(65215)
ARABIC_LETTER_DAD_MEDIAL_FORM = chr(65216)
ARABIC_LETTER_TAH_ISOLATED_FORM = chr(65217)
ARABIC_LETTER_TAH_FINAL_FORM = chr(65218)
ARABIC_LETTER_TAH_INITIAL_FORM = chr(65219)
ARABIC_LETTER_TAH_MEDIAL_FORM = chr(65220)
ARABIC_LETTER_ZAH_ISOLATED_FORM = chr(65221)
ARABIC_LETTER_ZAH_FINAL_FORM = chr(65222)
ARABIC_LETTER_ZAH_INITIAL_FORM = chr(65223)
ARABIC_LETTER_ZAH_MEDIAL_FORM = chr(65224)
ARABIC_LETTER_AIN_ISOLATED_FORM = chr(65225)
ARABIC_LETTER_AIN_FINAL_FORM = chr(65226)
ARABIC_LETTER_AIN_INITIAL_FORM = chr(65227)
ARABIC_LETTER_AIN_MEDIAL_FORM = chr(65228)
ARABIC_LETTER_GHAIN_ISOLATED_FORM = chr(65229)
ARABIC_LETTER_GHAIN_FINAL_FORM = chr(65230)
ARABIC_LETTER_GHAIN_INITIAL_FORM = chr(65231)
ARABIC_LETTER_GHAIN_MEDIAL_FORM = chr(65232)
ARABIC_LETTER_FEH_ISOLATED_FORM = chr(65233)
ARABIC_LETTER_FEH_FINAL_FORM = chr(65234)
ARABIC_LETTER_FEH_INITIAL_FORM = chr(65235)
ARABIC_LETTER_FEH_MEDIAL_FORM = chr(65236)
ARABIC_LETTER_QAF_ISOLATED_FORM = chr(65237)
ARABIC_LETTER_QAF_FINAL_FORM = chr(65238)
ARABIC_LETTER_QAF_INITIAL_FORM = chr(65239)
ARABIC_LETTER_QAF_MEDIAL_FORM = chr(65240)
ARABIC_LETTER_KAF_ISOLATED_FORM = chr(65241)
ARABIC_LETTER_KAF_FINAL_FORM = chr(65242)
ARABIC_LETTER_KAF_INITIAL_FORM = chr(65243)
ARABIC_LETTER_KAF_MEDIAL_FORM = chr(65244)
ARABIC_LETTER_LAM_ISOLATED_FORM = chr(65245)
ARABIC_LETTER_LAM_FINAL_FORM = chr(65246)
ARABIC_LETTER_LAM_INITIAL_FORM = chr(65247)
ARABIC_LETTER_LAM_MEDIAL_FORM = chr(65248)
ARABIC_LETTER_MEEM_ISOLATED_FORM = chr(65249)
ARABIC_LETTER_MEEM_FINAL_FORM = chr(65250)
ARABIC_LETTER_MEEM_INITIAL_FORM = chr(65251)
ARABIC_LETTER_MEEM_MEDIAL_FORM = chr(65252)
ARABIC_LETTER_NOON_ISOLATED_FORM = chr(65253)
ARABIC_LETTER_NOON_FINAL_FORM = chr(65254)
ARABIC_LETTER_NOON_INITIAL_FORM = chr(65255)
ARABIC_LETTER_NOON_MEDIAL_FORM = chr(65256)
ARABIC_LETTER_HEH_ISOLATED_FORM = chr(65257)
ARABIC_LETTER_HEH_FINAL_FORM = chr(65258)
ARABIC_LETTER_HEH_INITIAL_FORM = chr(65259)
ARABIC_LETTER_HEH_MEDIAL_FORM = chr(65260)
ARABIC_LETTER_WAW_ISOLATED_FORM = chr(65261)
ARABIC_LETTER_WAW_FINAL_FORM = chr(65262)
ARABIC_LETTER_ALEF_MAKSURA_ISOLATED_FORM = chr(65263)
ARABIC_LETTER_ALEF_MAKSURA_FINAL_FORM = chr(65264)
ARABIC_LETTER_YEH_ISOLATED_FORM = chr(65265)
ARABIC_LETTER_YEH_FINAL_FORM = chr(65266)
ARABIC_LETTER_YEH_INITIAL_FORM = chr(65267)
ARABIC_LETTER_YEH_MEDIAL_FORM = chr(65268)
ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_MADDA_ABOVE_ISOLATED_FORM = chr(65269)
ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_MADDA_ABOVE_FINAL_FORM = chr(65270)
ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_HAMZA_ABOVE_ISOLATED_FORM = chr(65271)
ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_HAMZA_ABOVE_FINAL_FORM = chr(65272)
ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_HAMZA_BELOW_ISOLATED_FORM = chr(65273)
ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_HAMZA_BELOW_FINAL_FORM = chr(65274)
ARABIC_LIGATURE_LAM_WITH_ALEF_ISOLATED_FORM = chr(65275)
ARABIC_LIGATURE_LAM_WITH_ALEF_FINAL_FORM = chr(65276)
ZERO_WIDTH_NO_BREAK_SPACE = chr(65279)
FULLWIDTH_EXCLAMATION_MARK = chr(65281)
FULLWIDTH_QUOTATION_MARK = chr(65282)
FULLWIDTH_NUMBER_SIGN = chr(65283)
FULLWIDTH_DOLLAR_SIGN = chr(65284)
FULLWIDTH_PERCENT_SIGN = chr(65285)
FULLWIDTH_AMPERSAND = chr(65286)
FULLWIDTH_APOSTROPHE = chr(65287)
FULLWIDTH_LEFT_PARENTHESIS = chr(65288)
FULLWIDTH_RIGHT_PARENTHESIS = chr(65289)
FULLWIDTH_ASTERISK = chr(65290)
FULLWIDTH_PLUS_SIGN = chr(65291)
FULLWIDTH_COMMA = chr(65292)
FULLWIDTH_HYPHEN_MINUS = chr(65293)
FULLWIDTH_FULL_STOP = chr(65294)
FULLWIDTH_SOLIDUS = chr(65295)
FULLWIDTH_DIGIT_ZERO = chr(65296)
FULLWIDTH_DIGIT_ONE = chr(65297)
FULLWIDTH_DIGIT_TWO = chr(65298)
FULLWIDTH_DIGIT_THREE = chr(65299)
FULLWIDTH_DIGIT_FOUR = chr(65300)
FULLWIDTH_DIGIT_FIVE = chr(65301)
FULLWIDTH_DIGIT_SIX = chr(65302)
FULLWIDTH_DIGIT_SEVEN = chr(65303)
FULLWIDTH_DIGIT_EIGHT = chr(65304)
FULLWIDTH_DIGIT_NINE = chr(65305)
FULLWIDTH_COLON = chr(65306)
FULLWIDTH_SEMICOLON = chr(65307)
FULLWIDTH_LESS_THAN_SIGN = chr(65308)
FULLWIDTH_EQUALS_SIGN = chr(65309)
FULLWIDTH_GREATER_THAN_SIGN = chr(65310)
FULLWIDTH_QUESTION_MARK = chr(65311)
FULLWIDTH_COMMERCIAL_AT = chr(65312)
FULLWIDTH_LATIN_CAPITAL_LETTER_A = chr(65313)
FULLWIDTH_LATIN_CAPITAL_LETTER_B = chr(65314)
FULLWIDTH_LATIN_CAPITAL_LETTER_C = chr(65315)
FULLWIDTH_LATIN_CAPITAL_LETTER_D = chr(65316)
FULLWIDTH_LATIN_CAPITAL_LETTER_E = chr(65317)
FULLWIDTH_LATIN_CAPITAL_LETTER_F = chr(65318)
FULLWIDTH_LATIN_CAPITAL_LETTER_G = chr(65319)
FULLWIDTH_LATIN_CAPITAL_LETTER_H = chr(65320)
FULLWIDTH_LATIN_CAPITAL_LETTER_I = chr(65321)
FULLWIDTH_LATIN_CAPITAL_LETTER_J = chr(65322)
FULLWIDTH_LATIN_CAPITAL_LETTER_K = chr(65323)
FULLWIDTH_LATIN_CAPITAL_LETTER_L = chr(65324)
FULLWIDTH_LATIN_CAPITAL_LETTER_M = chr(65325)
FULLWIDTH_LATIN_CAPITAL_LETTER_N = chr(65326)
FULLWIDTH_LATIN_CAPITAL_LETTER_O = chr(65327)
FULLWIDTH_LATIN_CAPITAL_LETTER_P = chr(65328)
FULLWIDTH_LATIN_CAPITAL_LETTER_Q = chr(65329)
FULLWIDTH_LATIN_CAPITAL_LETTER_R = chr(65330)
FULLWIDTH_LATIN_CAPITAL_LETTER_S = chr(65331)
FULLWIDTH_LATIN_CAPITAL_LETTER_T = chr(65332)
FULLWIDTH_LATIN_CAPITAL_LETTER_U = chr(65333)
FULLWIDTH_LATIN_CAPITAL_LETTER_V = chr(65334)
FULLWIDTH_LATIN_CAPITAL_LETTER_W = chr(65335)
FULLWIDTH_LATIN_CAPITAL_LETTER_X = chr(65336)
FULLWIDTH_LATIN_CAPITAL_LETTER_Y = chr(65337)
FULLWIDTH_LATIN_CAPITAL_LETTER_Z = chr(65338)
FULLWIDTH_LEFT_SQUARE_BRACKET = chr(65339)
FULLWIDTH_REVERSE_SOLIDUS = chr(65340)
FULLWIDTH_RIGHT_SQUARE_BRACKET = chr(65341)
FULLWIDTH_CIRCUMFLEX_ACCENT = chr(65342)
FULLWIDTH_LOW_LINE = chr(65343)
FULLWIDTH_GRAVE_ACCENT = chr(65344)
FULLWIDTH_LATIN_SMALL_LETTER_A = chr(65345)
FULLWIDTH_LATIN_SMALL_LETTER_B = chr(65346)
FULLWIDTH_LATIN_SMALL_LETTER_C = chr(65347)
FULLWIDTH_LATIN_SMALL_LETTER_D = chr(65348)
FULLWIDTH_LATIN_SMALL_LETTER_E = chr(65349)
FULLWIDTH_LATIN_SMALL_LETTER_F = chr(65350)
FULLWIDTH_LATIN_SMALL_LETTER_G = chr(65351)
FULLWIDTH_LATIN_SMALL_LETTER_H = chr(65352)
FULLWIDTH_LATIN_SMALL_LETTER_I = chr(65353)
FULLWIDTH_LATIN_SMALL_LETTER_J = chr(65354)
FULLWIDTH_LATIN_SMALL_LETTER_K = chr(65355)
FULLWIDTH_LATIN_SMALL_LETTER_L = chr(65356)
FULLWIDTH_LATIN_SMALL_LETTER_M = chr(65357)
FULLWIDTH_LATIN_SMALL_LETTER_N = chr(65358)
FULLWIDTH_LATIN_SMALL_LETTER_O = chr(65359)
FULLWIDTH_LATIN_SMALL_LETTER_P = chr(65360)
FULLWIDTH_LATIN_SMALL_LETTER_Q = chr(65361)
FULLWIDTH_LATIN_SMALL_LETTER_R = chr(65362)
FULLWIDTH_LATIN_SMALL_LETTER_S = chr(65363)
FULLWIDTH_LATIN_SMALL_LETTER_T = chr(65364)
FULLWIDTH_LATIN_SMALL_LETTER_U = chr(65365)
FULLWIDTH_LATIN_SMALL_LETTER_V = chr(65366)
FULLWIDTH_LATIN_SMALL_LETTER_W = chr(65367)
FULLWIDTH_LATIN_SMALL_LETTER_X = chr(65368)
FULLWIDTH_LATIN_SMALL_LETTER_Y = chr(65369)
FULLWIDTH_LATIN_SMALL_LETTER_Z = chr(65370)
FULLWIDTH_LEFT_CURLY_BRACKET = chr(65371)
FULLWIDTH_VERTICAL_LINE = chr(65372)
FULLWIDTH_RIGHT_CURLY_BRACKET = chr(65373)
FULLWIDTH_TILDE = chr(65374)
FULLWIDTH_LEFT_WHITE_PARENTHESIS = chr(65375)
FULLWIDTH_RIGHT_WHITE_PARENTHESIS = chr(65376)
HALFWIDTH_IDEOGRAPHIC_FULL_STOP = chr(65377)
HALFWIDTH_LEFT_CORNER_BRACKET = chr(65378)
HALFWIDTH_RIGHT_CORNER_BRACKET = chr(65379)
HALFWIDTH_IDEOGRAPHIC_COMMA = chr(65380)
HALFWIDTH_KATAKANA_MIDDLE_DOT = chr(65381)
HALFWIDTH_KATAKANA_LETTER_WO = chr(65382)
HALFWIDTH_KATAKANA_LETTER_SMALL_A = chr(65383)
HALFWIDTH_KATAKANA_LETTER_SMALL_I = chr(65384)
HALFWIDTH_KATAKANA_LETTER_SMALL_U = chr(65385)
HALFWIDTH_KATAKANA_LETTER_SMALL_E = chr(65386)
HALFWIDTH_KATAKANA_LETTER_SMALL_O = chr(65387)
HALFWIDTH_KATAKANA_LETTER_SMALL_YA = chr(65388)
HALFWIDTH_KATAKANA_LETTER_SMALL_YU = chr(65389)
HALFWIDTH_KATAKANA_LETTER_SMALL_YO = chr(65390)
HALFWIDTH_KATAKANA_LETTER_SMALL_TU = chr(65391)
HALFWIDTH_KATAKANA_HIRAGANA_PROLONGED_SOUND_MARK = chr(65392)
HALFWIDTH_KATAKANA_LETTER_A = chr(65393)
HALFWIDTH_KATAKANA_LETTER_I = chr(65394)
HALFWIDTH_KATAKANA_LETTER_U = chr(65395)
HALFWIDTH_KATAKANA_LETTER_E = chr(65396)
HALFWIDTH_KATAKANA_LETTER_O = chr(65397)
HALFWIDTH_KATAKANA_LETTER_KA = chr(65398)
HALFWIDTH_KATAKANA_LETTER_KI = chr(65399)
HALFWIDTH_KATAKANA_LETTER_KU = chr(65400)
HALFWIDTH_KATAKANA_LETTER_KE = chr(65401)
HALFWIDTH_KATAKANA_LETTER_KO = chr(65402)
HALFWIDTH_KATAKANA_LETTER_SA = chr(65403)
HALFWIDTH_KATAKANA_LETTER_SI = chr(65404)
HALFWIDTH_KATAKANA_LETTER_SU = chr(65405)
HALFWIDTH_KATAKANA_LETTER_SE = chr(65406)
HALFWIDTH_KATAKANA_LETTER_SO = chr(65407)
HALFWIDTH_KATAKANA_LETTER_TA = chr(65408)
HALFWIDTH_KATAKANA_LETTER_TI = chr(65409)
HALFWIDTH_KATAKANA_LETTER_TU = chr(65410)
HALFWIDTH_KATAKANA_LETTER_TE = chr(65411)
HALFWIDTH_KATAKANA_LETTER_TO = chr(65412)
HALFWIDTH_KATAKANA_LETTER_NA = chr(65413)
HALFWIDTH_KATAKANA_LETTER_NI = chr(65414)
HALFWIDTH_KATAKANA_LETTER_NU = chr(65415)
HALFWIDTH_KATAKANA_LETTER_NE = chr(65416)
HALFWIDTH_KATAKANA_LETTER_NO = chr(65417)
HALFWIDTH_KATAKANA_LETTER_HA = chr(65418)
HALFWIDTH_KATAKANA_LETTER_HI = chr(65419)
HALFWIDTH_KATAKANA_LETTER_HU = chr(65420)
HALFWIDTH_KATAKANA_LETTER_HE = chr(65421)
HALFWIDTH_KATAKANA_LETTER_HO = chr(65422)
HALFWIDTH_KATAKANA_LETTER_MA = chr(65423)
HALFWIDTH_KATAKANA_LETTER_MI = chr(65424)
HALFWIDTH_KATAKANA_LETTER_MU = chr(65425)
HALFWIDTH_KATAKANA_LETTER_ME = chr(65426)
HALFWIDTH_KATAKANA_LETTER_MO = chr(65427)
HALFWIDTH_KATAKANA_LETTER_YA = chr(65428)
HALFWIDTH_KATAKANA_LETTER_YU = chr(65429)
HALFWIDTH_KATAKANA_LETTER_YO = chr(65430)
HALFWIDTH_KATAKANA_LETTER_RA = chr(65431)
HALFWIDTH_KATAKANA_LETTER_RI = chr(65432)
HALFWIDTH_KATAKANA_LETTER_RU = chr(65433)
HALFWIDTH_KATAKANA_LETTER_RE = chr(65434)
HALFWIDTH_KATAKANA_LETTER_RO = chr(65435)
HALFWIDTH_KATAKANA_LETTER_WA = chr(65436)
HALFWIDTH_KATAKANA_LETTER_N = chr(65437)
HALFWIDTH_KATAKANA_VOICED_SOUND_MARK = chr(65438)
HALFWIDTH_KATAKANA_SEMI_VOICED_SOUND_MARK = chr(65439)
HALFWIDTH_HANGUL_FILLER = chr(65440)
HALFWIDTH_HANGUL_LETTER_KIYEOK = chr(65441)
HALFWIDTH_HANGUL_LETTER_SSANGKIYEOK = chr(65442)
HALFWIDTH_HANGUL_LETTER_KIYEOK_SIOS = chr(65443)
HALFWIDTH_HANGUL_LETTER_NIEUN = chr(65444)
HALFWIDTH_HANGUL_LETTER_NIEUN_CIEUC = chr(65445)
HALFWIDTH_HANGUL_LETTER_NIEUN_HIEUH = chr(65446)
HALFWIDTH_HANGUL_LETTER_TIKEUT = chr(65447)
HALFWIDTH_HANGUL_LETTER_SSANGTIKEUT = chr(65448)
HALFWIDTH_HANGUL_LETTER_RIEUL = chr(65449)
HALFWIDTH_HANGUL_LETTER_RIEUL_KIYEOK = chr(65450)
HALFWIDTH_HANGUL_LETTER_RIEUL_MIEUM = chr(65451)
HALFWIDTH_HANGUL_LETTER_RIEUL_PIEUP = chr(65452)
HALFWIDTH_HANGUL_LETTER_RIEUL_SIOS = chr(65453)
HALFWIDTH_HANGUL_LETTER_RIEUL_THIEUTH = chr(65454)
HALFWIDTH_HANGUL_LETTER_RIEUL_PHIEUPH = chr(65455)
HALFWIDTH_HANGUL_LETTER_RIEUL_HIEUH = chr(65456)
HALFWIDTH_HANGUL_LETTER_MIEUM = chr(65457)
HALFWIDTH_HANGUL_LETTER_PIEUP = chr(65458)
HALFWIDTH_HANGUL_LETTER_SSANGPIEUP = chr(65459)
HALFWIDTH_HANGUL_LETTER_PIEUP_SIOS = chr(65460)
HALFWIDTH_HANGUL_LETTER_SIOS = chr(65461)
HALFWIDTH_HANGUL_LETTER_SSANGSIOS = chr(65462)
HALFWIDTH_HANGUL_LETTER_IEUNG = chr(65463)
HALFWIDTH_HANGUL_LETTER_CIEUC = chr(65464)
HALFWIDTH_HANGUL_LETTER_SSANGCIEUC = chr(65465)
HALFWIDTH_HANGUL_LETTER_CHIEUCH = chr(65466)
HALFWIDTH_HANGUL_LETTER_KHIEUKH = chr(65467)
HALFWIDTH_HANGUL_LETTER_THIEUTH = chr(65468)
HALFWIDTH_HANGUL_LETTER_PHIEUPH = chr(65469)
HALFWIDTH_HANGUL_LETTER_HIEUH = chr(65470)
HALFWIDTH_HANGUL_LETTER_A = chr(65474)
HALFWIDTH_HANGUL_LETTER_AE = chr(65475)
HALFWIDTH_HANGUL_LETTER_YA = chr(65476)
HALFWIDTH_HANGUL_LETTER_YAE = chr(65477)
HALFWIDTH_HANGUL_LETTER_EO = chr(65478)
HALFWIDTH_HANGUL_LETTER_E = chr(65479)
HALFWIDTH_HANGUL_LETTER_YEO = chr(65482)
HALFWIDTH_HANGUL_LETTER_YE = chr(65483)
HALFWIDTH_HANGUL_LETTER_O = chr(65484)
HALFWIDTH_HANGUL_LETTER_WA = chr(65485)
HALFWIDTH_HANGUL_LETTER_WAE = chr(65486)
HALFWIDTH_HANGUL_LETTER_OE = chr(65487)
HALFWIDTH_HANGUL_LETTER_YO = chr(65490)
HALFWIDTH_HANGUL_LETTER_U = chr(65491)
HALFWIDTH_HANGUL_LETTER_WEO = chr(65492)
HALFWIDTH_HANGUL_LETTER_WE = chr(65493)
HALFWIDTH_HANGUL_LETTER_WI = chr(65494)
HALFWIDTH_HANGUL_LETTER_YU = chr(65495)
HALFWIDTH_HANGUL_LETTER_EU = chr(65498)
HALFWIDTH_HANGUL_LETTER_YI = chr(65499)
HALFWIDTH_HANGUL_LETTER_I = chr(65500)
FULLWIDTH_CENT_SIGN = chr(65504)
FULLWIDTH_POUND_SIGN = chr(65505)
FULLWIDTH_NOT_SIGN = chr(65506)
FULLWIDTH_MACRON = chr(65507)
FULLWIDTH_BROKEN_BAR = chr(65508)
FULLWIDTH_YEN_SIGN = chr(65509)
FULLWIDTH_WON_SIGN = chr(65510)
HALFWIDTH_FORMS_LIGHT_VERTICAL = chr(65512)
HALFWIDTH_LEFTWARDS_ARROW = chr(65513)
HALFWIDTH_UPWARDS_ARROW = chr(65514)
HALFWIDTH_RIGHTWARDS_ARROW = chr(65515)
HALFWIDTH_DOWNWARDS_ARROW = chr(65516)
HALFWIDTH_BLACK_SQUARE = chr(65517)
HALFWIDTH_WHITE_CIRCLE = chr(65518)
INTERLINEAR_ANNOTATION_ANCHOR = chr(65529)
INTERLINEAR_ANNOTATION_SEPARATOR = chr(65530)
INTERLINEAR_ANNOTATION_TERMINATOR = chr(65531)
OBJECT_REPLACEMENT_CHARACTER = chr(65532)
REPLACEMENT_CHARACTER = chr(65533)
LINEAR_B_SYLLABLE_B008_A = chr(65536)
LINEAR_B_SYLLABLE_B038_E = chr(65537)
LINEAR_B_SYLLABLE_B028_I = chr(65538)
LINEAR_B_SYLLABLE_B061_O = chr(65539)
LINEAR_B_SYLLABLE_B010_U = chr(65540)
LINEAR_B_SYLLABLE_B001_DA = chr(65541)
LINEAR_B_SYLLABLE_B045_DE = chr(65542)
LINEAR_B_SYLLABLE_B007_DI = chr(65543)
LINEAR_B_SYLLABLE_B014_DO = chr(65544)
LINEAR_B_SYLLABLE_B051_DU = chr(65545)
LINEAR_B_SYLLABLE_B057_JA = chr(65546)
LINEAR_B_SYLLABLE_B046_JE = chr(65547)
LINEAR_B_SYLLABLE_B036_JO = chr(65549)
LINEAR_B_SYLLABLE_B065_JU = chr(65550)
LINEAR_B_SYLLABLE_B077_KA = chr(65551)
LINEAR_B_SYLLABLE_B044_KE = chr(65552)
LINEAR_B_SYLLABLE_B067_KI = chr(65553)
LINEAR_B_SYLLABLE_B070_KO = chr(65554)
LINEAR_B_SYLLABLE_B081_KU = chr(65555)
LINEAR_B_SYLLABLE_B080_MA = chr(65556)
LINEAR_B_SYLLABLE_B013_ME = chr(65557)
LINEAR_B_SYLLABLE_B073_MI = chr(65558)
LINEAR_B_SYLLABLE_B015_MO = chr(65559)
LINEAR_B_SYLLABLE_B023_MU = chr(65560)
LINEAR_B_SYLLABLE_B006_NA = chr(65561)
LINEAR_B_SYLLABLE_B024_NE = chr(65562)
LINEAR_B_SYLLABLE_B030_NI = chr(65563)
LINEAR_B_SYLLABLE_B052_NO = chr(65564)
LINEAR_B_SYLLABLE_B055_NU = chr(65565)
LINEAR_B_SYLLABLE_B003_PA = chr(65566)
LINEAR_B_SYLLABLE_B072_PE = chr(65567)
LINEAR_B_SYLLABLE_B039_PI = chr(65568)
LINEAR_B_SYLLABLE_B011_PO = chr(65569)
LINEAR_B_SYLLABLE_B050_PU = chr(65570)
LINEAR_B_SYLLABLE_B016_QA = chr(65571)
LINEAR_B_SYLLABLE_B078_QE = chr(65572)
LINEAR_B_SYLLABLE_B021_QI = chr(65573)
LINEAR_B_SYLLABLE_B032_QO = chr(65574)
LINEAR_B_SYLLABLE_B060_RA = chr(65576)
LINEAR_B_SYLLABLE_B027_RE = chr(65577)
LINEAR_B_SYLLABLE_B053_RI = chr(65578)
LINEAR_B_SYLLABLE_B002_RO = chr(65579)
LINEAR_B_SYLLABLE_B026_RU = chr(65580)
LINEAR_B_SYLLABLE_B031_SA = chr(65581)
LINEAR_B_SYLLABLE_B009_SE = chr(65582)
LINEAR_B_SYLLABLE_B041_SI = chr(65583)
LINEAR_B_SYLLABLE_B012_SO = chr(65584)
LINEAR_B_SYLLABLE_B058_SU = chr(65585)
LINEAR_B_SYLLABLE_B059_TA = chr(65586)
LINEAR_B_SYLLABLE_B004_TE = chr(65587)
LINEAR_B_SYLLABLE_B037_TI = chr(65588)
LINEAR_B_SYLLABLE_B005_TO = chr(65589)
LINEAR_B_SYLLABLE_B069_TU = chr(65590)
LINEAR_B_SYLLABLE_B054_WA = chr(65591)
LINEAR_B_SYLLABLE_B075_WE = chr(65592)
LINEAR_B_SYLLABLE_B040_WI = chr(65593)
LINEAR_B_SYLLABLE_B042_WO = chr(65594)
LINEAR_B_SYLLABLE_B017_ZA = chr(65596)
LINEAR_B_SYLLABLE_B074_ZE = chr(65597)
LINEAR_B_SYLLABLE_B020_ZO = chr(65599)
LINEAR_B_SYLLABLE_B025_A2 = chr(65600)
LINEAR_B_SYLLABLE_B043_A3 = chr(65601)
LINEAR_B_SYLLABLE_B085_AU = chr(65602)
LINEAR_B_SYLLABLE_B071_DWE = chr(65603)
LINEAR_B_SYLLABLE_B090_DWO = chr(65604)
LINEAR_B_SYLLABLE_B048_NWA = chr(65605)
LINEAR_B_SYLLABLE_B029_PU2 = chr(65606)
LINEAR_B_SYLLABLE_B062_PTE = chr(65607)
LINEAR_B_SYLLABLE_B076_RA2 = chr(65608)
LINEAR_B_SYLLABLE_B033_RA3 = chr(65609)
LINEAR_B_SYLLABLE_B068_RO2 = chr(65610)
LINEAR_B_SYLLABLE_B066_TA2 = chr(65611)
LINEAR_B_SYLLABLE_B087_TWE = chr(65612)
LINEAR_B_SYLLABLE_B091_TWO = chr(65613)
LINEAR_B_SYMBOL_B018 = chr(65616)
LINEAR_B_SYMBOL_B019 = chr(65617)
LINEAR_B_SYMBOL_B022 = chr(65618)
LINEAR_B_SYMBOL_B034 = chr(65619)
LINEAR_B_SYMBOL_B047 = chr(65620)
LINEAR_B_SYMBOL_B049 = chr(65621)
LINEAR_B_SYMBOL_B056 = chr(65622)
LINEAR_B_SYMBOL_B063 = chr(65623)
LINEAR_B_SYMBOL_B064 = chr(65624)
LINEAR_B_SYMBOL_B079 = chr(65625)
LINEAR_B_SYMBOL_B082 = chr(65626)
LINEAR_B_SYMBOL_B083 = chr(65627)
LINEAR_B_SYMBOL_B086 = chr(65628)
LINEAR_B_SYMBOL_B089 = chr(65629)
LINEAR_B_IDEOGRAM_B100_MAN = chr(65664)
LINEAR_B_IDEOGRAM_B102_WOMAN = chr(65665)
LINEAR_B_IDEOGRAM_B104_DEER = chr(65666)
LINEAR_B_IDEOGRAM_B105_EQUID = chr(65667)
LINEAR_B_IDEOGRAM_B105F_MARE = chr(65668)
LINEAR_B_IDEOGRAM_B105M_STALLION = chr(65669)
LINEAR_B_IDEOGRAM_B106F_EWE = chr(65670)
LINEAR_B_IDEOGRAM_B106M_RAM = chr(65671)
LINEAR_B_IDEOGRAM_B107F_SHE_GOAT = chr(65672)
LINEAR_B_IDEOGRAM_B107M_HE_GOAT = chr(65673)
LINEAR_B_IDEOGRAM_B108F_SOW = chr(65674)
LINEAR_B_IDEOGRAM_B108M_BOAR = chr(65675)
LINEAR_B_IDEOGRAM_B109F_COW = chr(65676)
LINEAR_B_IDEOGRAM_B109M_BULL = chr(65677)
LINEAR_B_IDEOGRAM_B120_WHEAT = chr(65678)
LINEAR_B_IDEOGRAM_B121_BARLEY = chr(65679)
LINEAR_B_IDEOGRAM_B122_OLIVE = chr(65680)
LINEAR_B_IDEOGRAM_B123_SPICE = chr(65681)
LINEAR_B_IDEOGRAM_B125_CYPERUS = chr(65682)
LINEAR_B_MONOGRAM_B127_KAPO = chr(65683)
LINEAR_B_MONOGRAM_B128_KANAKO = chr(65684)
LINEAR_B_IDEOGRAM_B130_OIL = chr(65685)
LINEAR_B_IDEOGRAM_B131_WINE = chr(65686)
LINEAR_B_IDEOGRAM_B132 = chr(65687)
LINEAR_B_MONOGRAM_B133_AREPA = chr(65688)
LINEAR_B_MONOGRAM_B135_MERI = chr(65689)
LINEAR_B_IDEOGRAM_B140_BRONZE = chr(65690)
LINEAR_B_IDEOGRAM_B141_GOLD = chr(65691)
LINEAR_B_IDEOGRAM_B142 = chr(65692)
LINEAR_B_IDEOGRAM_B145_WOOL = chr(65693)
LINEAR_B_IDEOGRAM_B146 = chr(65694)
LINEAR_B_IDEOGRAM_B150 = chr(65695)
LINEAR_B_IDEOGRAM_B151_HORN = chr(65696)
LINEAR_B_IDEOGRAM_B152 = chr(65697)
LINEAR_B_IDEOGRAM_B153 = chr(65698)
LINEAR_B_IDEOGRAM_B154 = chr(65699)
LINEAR_B_MONOGRAM_B156_TURO2 = chr(65700)
LINEAR_B_IDEOGRAM_B157 = chr(65701)
LINEAR_B_IDEOGRAM_B158 = chr(65702)
LINEAR_B_IDEOGRAM_B159_CLOTH = chr(65703)
LINEAR_B_IDEOGRAM_B160 = chr(65704)
LINEAR_B_IDEOGRAM_B161 = chr(65705)
LINEAR_B_IDEOGRAM_B162_GARMENT = chr(65706)
LINEAR_B_IDEOGRAM_B163_ARMOUR = chr(65707)
LINEAR_B_IDEOGRAM_B164 = chr(65708)
LINEAR_B_IDEOGRAM_B165 = chr(65709)
LINEAR_B_IDEOGRAM_B166 = chr(65710)
LINEAR_B_IDEOGRAM_B167 = chr(65711)
LINEAR_B_IDEOGRAM_B168 = chr(65712)
LINEAR_B_IDEOGRAM_B169 = chr(65713)
LINEAR_B_IDEOGRAM_B170 = chr(65714)
LINEAR_B_IDEOGRAM_B171 = chr(65715)
LINEAR_B_IDEOGRAM_B172 = chr(65716)
LINEAR_B_IDEOGRAM_B173_MONTH = chr(65717)
LINEAR_B_IDEOGRAM_B174 = chr(65718)
LINEAR_B_IDEOGRAM_B176_TREE = chr(65719)
LINEAR_B_IDEOGRAM_B177 = chr(65720)
LINEAR_B_IDEOGRAM_B178 = chr(65721)
LINEAR_B_IDEOGRAM_B179 = chr(65722)
LINEAR_B_IDEOGRAM_B180 = chr(65723)
LINEAR_B_IDEOGRAM_B181 = chr(65724)
LINEAR_B_IDEOGRAM_B182 = chr(65725)
LINEAR_B_IDEOGRAM_B183 = chr(65726)
LINEAR_B_IDEOGRAM_B184 = chr(65727)
LINEAR_B_IDEOGRAM_B185 = chr(65728)
LINEAR_B_IDEOGRAM_B189 = chr(65729)
LINEAR_B_IDEOGRAM_B190 = chr(65730)
LINEAR_B_IDEOGRAM_B191_HELMET = chr(65731)
LINEAR_B_IDEOGRAM_B220_FOOTSTOOL = chr(65732)
LINEAR_B_IDEOGRAM_B225_BATHTUB = chr(65733)
LINEAR_B_IDEOGRAM_B230_SPEAR = chr(65734)
LINEAR_B_IDEOGRAM_B231_ARROW = chr(65735)
LINEAR_B_IDEOGRAM_B232 = chr(65736)
LINEAR_B_IDEOGRAM_B233_SWORD = chr(65737)
LINEAR_B_IDEOGRAM_B234 = chr(65738)
LINEAR_B_IDEOGRAM_B236 = chr(65739)
LINEAR_B_IDEOGRAM_B240_WHEELED_CHARIOT = chr(65740)
LINEAR_B_IDEOGRAM_B241_CHARIOT = chr(65741)
LINEAR_B_IDEOGRAM_B242_CHARIOT_FRAME = chr(65742)
LINEAR_B_IDEOGRAM_B243_WHEEL = chr(65743)
LINEAR_B_IDEOGRAM_B245 = chr(65744)
LINEAR_B_IDEOGRAM_B246 = chr(65745)
LINEAR_B_MONOGRAM_B247_DIPTE = chr(65746)
LINEAR_B_IDEOGRAM_B248 = chr(65747)
LINEAR_B_IDEOGRAM_B249 = chr(65748)
LINEAR_B_IDEOGRAM_B251 = chr(65749)
LINEAR_B_IDEOGRAM_B252 = chr(65750)
LINEAR_B_IDEOGRAM_B253 = chr(65751)
LINEAR_B_IDEOGRAM_B254_DART = chr(65752)
LINEAR_B_IDEOGRAM_B255 = chr(65753)
LINEAR_B_IDEOGRAM_B256 = chr(65754)
LINEAR_B_IDEOGRAM_B257 = chr(65755)
LINEAR_B_IDEOGRAM_B258 = chr(65756)
LINEAR_B_IDEOGRAM_B259 = chr(65757)
LINEAR_B_IDEOGRAM_VESSEL_B155 = chr(65758)
LINEAR_B_IDEOGRAM_VESSEL_B200 = chr(65759)
LINEAR_B_IDEOGRAM_VESSEL_B201 = chr(65760)
LINEAR_B_IDEOGRAM_VESSEL_B202 = chr(65761)
LINEAR_B_IDEOGRAM_VESSEL_B203 = chr(65762)
LINEAR_B_IDEOGRAM_VESSEL_B204 = chr(65763)
LINEAR_B_IDEOGRAM_VESSEL_B205 = chr(65764)
LINEAR_B_IDEOGRAM_VESSEL_B206 = chr(65765)
LINEAR_B_IDEOGRAM_VESSEL_B207 = chr(65766)
LINEAR_B_IDEOGRAM_VESSEL_B208 = chr(65767)
LINEAR_B_IDEOGRAM_VESSEL_B209 = chr(65768)
LINEAR_B_IDEOGRAM_VESSEL_B210 = chr(65769)
LINEAR_B_IDEOGRAM_VESSEL_B211 = chr(65770)
LINEAR_B_IDEOGRAM_VESSEL_B212 = chr(65771)
LINEAR_B_IDEOGRAM_VESSEL_B213 = chr(65772)
LINEAR_B_IDEOGRAM_VESSEL_B214 = chr(65773)
LINEAR_B_IDEOGRAM_VESSEL_B215 = chr(65774)
LINEAR_B_IDEOGRAM_VESSEL_B216 = chr(65775)
LINEAR_B_IDEOGRAM_VESSEL_B217 = chr(65776)
LINEAR_B_IDEOGRAM_VESSEL_B218 = chr(65777)
LINEAR_B_IDEOGRAM_VESSEL_B219 = chr(65778)
LINEAR_B_IDEOGRAM_VESSEL_B221 = chr(65779)
LINEAR_B_IDEOGRAM_VESSEL_B222 = chr(65780)
LINEAR_B_IDEOGRAM_VESSEL_B226 = chr(65781)
LINEAR_B_IDEOGRAM_VESSEL_B227 = chr(65782)
LINEAR_B_IDEOGRAM_VESSEL_B228 = chr(65783)
LINEAR_B_IDEOGRAM_VESSEL_B229 = chr(65784)
LINEAR_B_IDEOGRAM_VESSEL_B250 = chr(65785)
LINEAR_B_IDEOGRAM_VESSEL_B305 = chr(65786)
AEGEAN_WORD_SEPARATOR_LINE = chr(65792)
AEGEAN_WORD_SEPARATOR_DOT = chr(65793)
AEGEAN_CHECK_MARK = chr(65794)
AEGEAN_NUMBER_ONE = chr(65799)
AEGEAN_NUMBER_TWO = chr(65800)
AEGEAN_NUMBER_THREE = chr(65801)
AEGEAN_NUMBER_FOUR = chr(65802)
AEGEAN_NUMBER_FIVE = chr(65803)
AEGEAN_NUMBER_SIX = chr(65804)
AEGEAN_NUMBER_SEVEN = chr(65805)
AEGEAN_NUMBER_EIGHT = chr(65806)
AEGEAN_NUMBER_NINE = chr(65807)
AEGEAN_NUMBER_TEN = chr(65808)
AEGEAN_NUMBER_TWENTY = chr(65809)
AEGEAN_NUMBER_THIRTY = chr(65810)
AEGEAN_NUMBER_FORTY = chr(65811)
AEGEAN_NUMBER_FIFTY = chr(65812)
AEGEAN_NUMBER_SIXTY = chr(65813)
AEGEAN_NUMBER_SEVENTY = chr(65814)
AEGEAN_NUMBER_EIGHTY = chr(65815)
AEGEAN_NUMBER_NINETY = chr(65816)
AEGEAN_NUMBER_ONE_HUNDRED = chr(65817)
AEGEAN_NUMBER_TWO_HUNDRED = chr(65818)
AEGEAN_NUMBER_THREE_HUNDRED = chr(65819)
AEGEAN_NUMBER_FOUR_HUNDRED = chr(65820)
AEGEAN_NUMBER_FIVE_HUNDRED = chr(65821)
AEGEAN_NUMBER_SIX_HUNDRED = chr(65822)
AEGEAN_NUMBER_SEVEN_HUNDRED = chr(65823)
AEGEAN_NUMBER_EIGHT_HUNDRED = chr(65824)
AEGEAN_NUMBER_NINE_HUNDRED = chr(65825)
AEGEAN_NUMBER_ONE_THOUSAND = chr(65826)
AEGEAN_NUMBER_TWO_THOUSAND = chr(65827)
AEGEAN_NUMBER_THREE_THOUSAND = chr(65828)
AEGEAN_NUMBER_FOUR_THOUSAND = chr(65829)
AEGEAN_NUMBER_FIVE_THOUSAND = chr(65830)
AEGEAN_NUMBER_SIX_THOUSAND = chr(65831)
AEGEAN_NUMBER_SEVEN_THOUSAND = chr(65832)
AEGEAN_NUMBER_EIGHT_THOUSAND = chr(65833)
AEGEAN_NUMBER_NINE_THOUSAND = chr(65834)
AEGEAN_NUMBER_TEN_THOUSAND = chr(65835)
AEGEAN_NUMBER_TWENTY_THOUSAND = chr(65836)
AEGEAN_NUMBER_THIRTY_THOUSAND = chr(65837)
AEGEAN_NUMBER_FORTY_THOUSAND = chr(65838)
AEGEAN_NUMBER_FIFTY_THOUSAND = chr(65839)
AEGEAN_NUMBER_SIXTY_THOUSAND = chr(65840)
AEGEAN_NUMBER_SEVENTY_THOUSAND = chr(65841)
AEGEAN_NUMBER_EIGHTY_THOUSAND = chr(65842)
AEGEAN_NUMBER_NINETY_THOUSAND = chr(65843)
AEGEAN_WEIGHT_BASE_UNIT = chr(65847)
AEGEAN_WEIGHT_FIRST_SUBUNIT = chr(65848)
AEGEAN_WEIGHT_SECOND_SUBUNIT = chr(65849)
AEGEAN_WEIGHT_THIRD_SUBUNIT = chr(65850)
AEGEAN_WEIGHT_FOURTH_SUBUNIT = chr(65851)
AEGEAN_DRY_MEASURE_FIRST_SUBUNIT = chr(65852)
AEGEAN_LIQUID_MEASURE_FIRST_SUBUNIT = chr(65853)
AEGEAN_MEASURE_SECOND_SUBUNIT = chr(65854)
AEGEAN_MEASURE_THIRD_SUBUNIT = chr(65855)
GREEK_ACROPHONIC_ATTIC_ONE_QUARTER = chr(65856)
GREEK_ACROPHONIC_ATTIC_ONE_HALF = chr(65857)
GREEK_ACROPHONIC_ATTIC_ONE_DRACHMA = chr(65858)
GREEK_ACROPHONIC_ATTIC_FIVE = chr(65859)
GREEK_ACROPHONIC_ATTIC_FIFTY = chr(65860)
GREEK_ACROPHONIC_ATTIC_FIVE_HUNDRED = chr(65861)
GREEK_ACROPHONIC_ATTIC_FIVE_THOUSAND = chr(65862)
GREEK_ACROPHONIC_ATTIC_FIFTY_THOUSAND = chr(65863)
GREEK_ACROPHONIC_ATTIC_FIVE_TALENTS = chr(65864)
GREEK_ACROPHONIC_ATTIC_TEN_TALENTS = chr(65865)
GREEK_ACROPHONIC_ATTIC_FIFTY_TALENTS = chr(65866)
GREEK_ACROPHONIC_ATTIC_ONE_HUNDRED_TALENTS = chr(65867)
GREEK_ACROPHONIC_ATTIC_FIVE_HUNDRED_TALENTS = chr(65868)
GREEK_ACROPHONIC_ATTIC_ONE_THOUSAND_TALENTS = chr(65869)
GREEK_ACROPHONIC_ATTIC_FIVE_THOUSAND_TALENTS = chr(65870)
GREEK_ACROPHONIC_ATTIC_FIVE_STATERS = chr(65871)
GREEK_ACROPHONIC_ATTIC_TEN_STATERS = chr(65872)
GREEK_ACROPHONIC_ATTIC_FIFTY_STATERS = chr(65873)
GREEK_ACROPHONIC_ATTIC_ONE_HUNDRED_STATERS = chr(65874)
GREEK_ACROPHONIC_ATTIC_FIVE_HUNDRED_STATERS = chr(65875)
GREEK_ACROPHONIC_ATTIC_ONE_THOUSAND_STATERS = chr(65876)
GREEK_ACROPHONIC_ATTIC_TEN_THOUSAND_STATERS = chr(65877)
GREEK_ACROPHONIC_ATTIC_FIFTY_THOUSAND_STATERS = chr(65878)
GREEK_ACROPHONIC_ATTIC_TEN_MNAS = chr(65879)
GREEK_ACROPHONIC_HERAEUM_ONE_PLETHRON = chr(65880)
GREEK_ACROPHONIC_THESPIAN_ONE = chr(65881)
GREEK_ACROPHONIC_HERMIONIAN_ONE = chr(65882)
GREEK_ACROPHONIC_EPIDAUREAN_TWO = chr(65883)
GREEK_ACROPHONIC_THESPIAN_TWO = chr(65884)
GREEK_ACROPHONIC_CYRENAIC_TWO_DRACHMAS = chr(65885)
GREEK_ACROPHONIC_EPIDAUREAN_TWO_DRACHMAS = chr(65886)
GREEK_ACROPHONIC_TROEZENIAN_FIVE = chr(65887)
GREEK_ACROPHONIC_TROEZENIAN_TEN = chr(65888)
GREEK_ACROPHONIC_TROEZENIAN_TEN_ALTERNATE_FORM = chr(65889)
GREEK_ACROPHONIC_HERMIONIAN_TEN = chr(65890)
GREEK_ACROPHONIC_MESSENIAN_TEN = chr(65891)
GREEK_ACROPHONIC_THESPIAN_TEN = chr(65892)
GREEK_ACROPHONIC_THESPIAN_THIRTY = chr(65893)
GREEK_ACROPHONIC_TROEZENIAN_FIFTY = chr(65894)
GREEK_ACROPHONIC_TROEZENIAN_FIFTY_ALTERNATE_FORM = chr(65895)
GREEK_ACROPHONIC_HERMIONIAN_FIFTY = chr(65896)
GREEK_ACROPHONIC_THESPIAN_FIFTY = chr(65897)
GREEK_ACROPHONIC_THESPIAN_ONE_HUNDRED = chr(65898)
GREEK_ACROPHONIC_THESPIAN_THREE_HUNDRED = chr(65899)
GREEK_ACROPHONIC_EPIDAUREAN_FIVE_HUNDRED = chr(65900)
GREEK_ACROPHONIC_TROEZENIAN_FIVE_HUNDRED = chr(65901)
GREEK_ACROPHONIC_THESPIAN_FIVE_HUNDRED = chr(65902)
GREEK_ACROPHONIC_CARYSTIAN_FIVE_HUNDRED = chr(65903)
GREEK_ACROPHONIC_NAXIAN_FIVE_HUNDRED = chr(65904)
GREEK_ACROPHONIC_THESPIAN_ONE_THOUSAND = chr(65905)
GREEK_ACROPHONIC_THESPIAN_FIVE_THOUSAND = chr(65906)
GREEK_ACROPHONIC_DELPHIC_FIVE_MNAS = chr(65907)
GREEK_ACROPHONIC_STRATIAN_FIFTY_MNAS = chr(65908)
GREEK_ONE_HALF_SIGN = chr(65909)
GREEK_ONE_HALF_SIGN_ALTERNATE_FORM = chr(65910)
GREEK_TWO_THIRDS_SIGN = chr(65911)
GREEK_THREE_QUARTERS_SIGN = chr(65912)
GREEK_YEAR_SIGN = chr(65913)
GREEK_TALENT_SIGN = chr(65914)
GREEK_DRACHMA_SIGN = chr(65915)
GREEK_OBOL_SIGN = chr(65916)
GREEK_TWO_OBOLS_SIGN = chr(65917)
GREEK_THREE_OBOLS_SIGN = chr(65918)
GREEK_FOUR_OBOLS_SIGN = chr(65919)
GREEK_FIVE_OBOLS_SIGN = chr(65920)
GREEK_METRETES_SIGN = chr(65921)
GREEK_KYATHOS_BASE_SIGN = chr(65922)
GREEK_LITRA_SIGN = chr(65923)
GREEK_OUNKIA_SIGN = chr(65924)
GREEK_XESTES_SIGN = chr(65925)
GREEK_ARTABE_SIGN = chr(65926)
GREEK_AROURA_SIGN = chr(65927)
GREEK_GRAMMA_SIGN = chr(65928)
GREEK_TRYBLION_BASE_SIGN = chr(65929)
GREEK_ZERO_SIGN = chr(65930)
GREEK_ONE_QUARTER_SIGN = chr(65931)
GREEK_SINUSOID_SIGN = chr(65932)
GREEK_INDICTION_SIGN = chr(65933)
NOMISMA_SIGN = chr(65934)
ROMAN_SEXTANS_SIGN = chr(65936)
ROMAN_UNCIA_SIGN = chr(65937)
ROMAN_SEMUNCIA_SIGN = chr(65938)
ROMAN_SEXTULA_SIGN = chr(65939)
ROMAN_DIMIDIA_SEXTULA_SIGN = chr(65940)
ROMAN_SILIQUA_SIGN = chr(65941)
ROMAN_DENARIUS_SIGN = chr(65942)
ROMAN_QUINARIUS_SIGN = chr(65943)
ROMAN_SESTERTIUS_SIGN = chr(65944)
ROMAN_DUPONDIUS_SIGN = chr(65945)
ROMAN_AS_SIGN = chr(65946)
ROMAN_CENTURIAL_SIGN = chr(65947)
ASCIA_SYMBOL = chr(65948)
GREEK_SYMBOL_TAU_RHO = chr(65952)
PHAISTOS_DISC_SIGN_PEDESTRIAN = chr(66000)
PHAISTOS_DISC_SIGN_PLUMED_HEAD = chr(66001)
PHAISTOS_DISC_SIGN_TATTOOED_HEAD = chr(66002)
PHAISTOS_DISC_SIGN_CAPTIVE = chr(66003)
PHAISTOS_DISC_SIGN_CHILD = chr(66004)
PHAISTOS_DISC_SIGN_WOMAN = chr(66005)
PHAISTOS_DISC_SIGN_HELMET = chr(66006)
PHAISTOS_DISC_SIGN_GAUNTLET = chr(66007)
PHAISTOS_DISC_SIGN_TIARA = chr(66008)
PHAISTOS_DISC_SIGN_ARROW = chr(66009)
PHAISTOS_DISC_SIGN_BOW = chr(66010)
PHAISTOS_DISC_SIGN_SHIELD = chr(66011)
PHAISTOS_DISC_SIGN_CLUB = chr(66012)
PHAISTOS_DISC_SIGN_MANACLES = chr(66013)
PHAISTOS_DISC_SIGN_MATTOCK = chr(66014)
PHAISTOS_DISC_SIGN_SAW = chr(66015)
PHAISTOS_DISC_SIGN_LID = chr(66016)
PHAISTOS_DISC_SIGN_BOOMERANG = chr(66017)
PHAISTOS_DISC_SIGN_CARPENTRY_PLANE = chr(66018)
PHAISTOS_DISC_SIGN_DOLIUM = chr(66019)
PHAISTOS_DISC_SIGN_COMB = chr(66020)
PHAISTOS_DISC_SIGN_SLING = chr(66021)
PHAISTOS_DISC_SIGN_COLUMN = chr(66022)
PHAISTOS_DISC_SIGN_BEEHIVE = chr(66023)
PHAISTOS_DISC_SIGN_SHIP = chr(66024)
PHAISTOS_DISC_SIGN_HORN = chr(66025)
PHAISTOS_DISC_SIGN_HIDE = chr(66026)
PHAISTOS_DISC_SIGN_BULLS_LEG = chr(66027)
PHAISTOS_DISC_SIGN_CAT = chr(66028)
PHAISTOS_DISC_SIGN_RAM = chr(66029)
PHAISTOS_DISC_SIGN_EAGLE = chr(66030)
PHAISTOS_DISC_SIGN_DOVE = chr(66031)
PHAISTOS_DISC_SIGN_TUNNY = chr(66032)
PHAISTOS_DISC_SIGN_BEE = chr(66033)
PHAISTOS_DISC_SIGN_PLANE_TREE = chr(66034)
PHAISTOS_DISC_SIGN_VINE = chr(66035)
PHAISTOS_DISC_SIGN_PAPYRUS = chr(66036)
PHAISTOS_DISC_SIGN_ROSETTE = chr(66037)
PHAISTOS_DISC_SIGN_LILY = chr(66038)
PHAISTOS_DISC_SIGN_OX_BACK = chr(66039)
PHAISTOS_DISC_SIGN_FLUTE = chr(66040)
PHAISTOS_DISC_SIGN_GRATER = chr(66041)
PHAISTOS_DISC_SIGN_STRAINER = chr(66042)
PHAISTOS_DISC_SIGN_SMALL_AXE = chr(66043)
PHAISTOS_DISC_SIGN_WAVY_BAND = chr(66044)
PHAISTOS_DISC_SIGN_COMBINING_OBLIQUE_STROKE = chr(66045)
LYCIAN_LETTER_A = chr(66176)
LYCIAN_LETTER_E = chr(66177)
LYCIAN_LETTER_B = chr(66178)
LYCIAN_LETTER_BH = chr(66179)
LYCIAN_LETTER_G = chr(66180)
LYCIAN_LETTER_D = chr(66181)
LYCIAN_LETTER_I = chr(66182)
LYCIAN_LETTER_W = chr(66183)
LYCIAN_LETTER_Z = chr(66184)
LYCIAN_LETTER_TH = chr(66185)
LYCIAN_LETTER_J = chr(66186)
LYCIAN_LETTER_K = chr(66187)
LYCIAN_LETTER_Q = chr(66188)
LYCIAN_LETTER_L = chr(66189)
LYCIAN_LETTER_M = chr(66190)
LYCIAN_LETTER_N = chr(66191)
LYCIAN_LETTER_MM = chr(66192)
LYCIAN_LETTER_NN = chr(66193)
LYCIAN_LETTER_U = chr(66194)
LYCIAN_LETTER_P = chr(66195)
LYCIAN_LETTER_KK = chr(66196)
LYCIAN_LETTER_R = chr(66197)
LYCIAN_LETTER_S = chr(66198)
LYCIAN_LETTER_T = chr(66199)
LYCIAN_LETTER_TT = chr(66200)
LYCIAN_LETTER_AN = chr(66201)
LYCIAN_LETTER_EN = chr(66202)
LYCIAN_LETTER_H = chr(66203)
LYCIAN_LETTER_X = chr(66204)
CARIAN_LETTER_A = chr(66208)
CARIAN_LETTER_P2 = chr(66209)
CARIAN_LETTER_D = chr(66210)
CARIAN_LETTER_L = chr(66211)
CARIAN_LETTER_UUU = chr(66212)
CARIAN_LETTER_R = chr(66213)
CARIAN_LETTER_LD = chr(66214)
CARIAN_LETTER_A2 = chr(66215)
CARIAN_LETTER_Q = chr(66216)
CARIAN_LETTER_B = chr(66217)
CARIAN_LETTER_M = chr(66218)
CARIAN_LETTER_O = chr(66219)
CARIAN_LETTER_D2 = chr(66220)
CARIAN_LETTER_T = chr(66221)
CARIAN_LETTER_SH = chr(66222)
CARIAN_LETTER_SH2 = chr(66223)
CARIAN_LETTER_S = chr(66224)
CARIAN_LETTER_C_18 = chr(66225)
CARIAN_LETTER_U = chr(66226)
CARIAN_LETTER_NN = chr(66227)
CARIAN_LETTER_X = chr(66228)
CARIAN_LETTER_N = chr(66229)
CARIAN_LETTER_TT2 = chr(66230)
CARIAN_LETTER_P = chr(66231)
CARIAN_LETTER_SS = chr(66232)
CARIAN_LETTER_I = chr(66233)
CARIAN_LETTER_E = chr(66234)
CARIAN_LETTER_UUUU = chr(66235)
CARIAN_LETTER_K = chr(66236)
CARIAN_LETTER_K2 = chr(66237)
CARIAN_LETTER_ND = chr(66238)
CARIAN_LETTER_UU = chr(66239)
CARIAN_LETTER_G = chr(66240)
CARIAN_LETTER_G2 = chr(66241)
CARIAN_LETTER_ST = chr(66242)
CARIAN_LETTER_ST2 = chr(66243)
CARIAN_LETTER_NG = chr(66244)
CARIAN_LETTER_II = chr(66245)
CARIAN_LETTER_C_39 = chr(66246)
CARIAN_LETTER_TT = chr(66247)
CARIAN_LETTER_UUU2 = chr(66248)
CARIAN_LETTER_RR = chr(66249)
CARIAN_LETTER_MB = chr(66250)
CARIAN_LETTER_MB2 = chr(66251)
CARIAN_LETTER_MB3 = chr(66252)
CARIAN_LETTER_MB4 = chr(66253)
CARIAN_LETTER_LD2 = chr(66254)
CARIAN_LETTER_E2 = chr(66255)
CARIAN_LETTER_UUU3 = chr(66256)
COPTIC_EPACT_THOUSANDS_MARK = chr(66272)
COPTIC_EPACT_DIGIT_ONE = chr(66273)
COPTIC_EPACT_DIGIT_TWO = chr(66274)
COPTIC_EPACT_DIGIT_THREE = chr(66275)
COPTIC_EPACT_DIGIT_FOUR = chr(66276)
COPTIC_EPACT_DIGIT_FIVE = chr(66277)
COPTIC_EPACT_DIGIT_SIX = chr(66278)
COPTIC_EPACT_DIGIT_SEVEN = chr(66279)
COPTIC_EPACT_DIGIT_EIGHT = chr(66280)
COPTIC_EPACT_DIGIT_NINE = chr(66281)
COPTIC_EPACT_NUMBER_TEN = chr(66282)
COPTIC_EPACT_NUMBER_TWENTY = chr(66283)
COPTIC_EPACT_NUMBER_THIRTY = chr(66284)
COPTIC_EPACT_NUMBER_FORTY = chr(66285)
COPTIC_EPACT_NUMBER_FIFTY = chr(66286)
COPTIC_EPACT_NUMBER_SIXTY = chr(66287)
COPTIC_EPACT_NUMBER_SEVENTY = chr(66288)
COPTIC_EPACT_NUMBER_EIGHTY = chr(66289)
COPTIC_EPACT_NUMBER_NINETY = chr(66290)
COPTIC_EPACT_NUMBER_ONE_HUNDRED = chr(66291)
COPTIC_EPACT_NUMBER_TWO_HUNDRED = chr(66292)
COPTIC_EPACT_NUMBER_THREE_HUNDRED = chr(66293)
COPTIC_EPACT_NUMBER_FOUR_HUNDRED = chr(66294)
COPTIC_EPACT_NUMBER_FIVE_HUNDRED = chr(66295)
COPTIC_EPACT_NUMBER_SIX_HUNDRED = chr(66296)
COPTIC_EPACT_NUMBER_SEVEN_HUNDRED = chr(66297)
COPTIC_EPACT_NUMBER_EIGHT_HUNDRED = chr(66298)
COPTIC_EPACT_NUMBER_NINE_HUNDRED = chr(66299)
OLD_ITALIC_LETTER_A = chr(66304)
OLD_ITALIC_LETTER_BE = chr(66305)
OLD_ITALIC_LETTER_KE = chr(66306)
OLD_ITALIC_LETTER_DE = chr(66307)
OLD_ITALIC_LETTER_E = chr(66308)
OLD_ITALIC_LETTER_VE = chr(66309)
OLD_ITALIC_LETTER_ZE = chr(66310)
OLD_ITALIC_LETTER_HE = chr(66311)
OLD_ITALIC_LETTER_THE = chr(66312)
OLD_ITALIC_LETTER_I = chr(66313)
OLD_ITALIC_LETTER_KA = chr(66314)
OLD_ITALIC_LETTER_EL = chr(66315)
OLD_ITALIC_LETTER_EM = chr(66316)
OLD_ITALIC_LETTER_EN = chr(66317)
OLD_ITALIC_LETTER_ESH = chr(66318)
OLD_ITALIC_LETTER_O = chr(66319)
OLD_ITALIC_LETTER_PE = chr(66320)
OLD_ITALIC_LETTER_SHE = chr(66321)
OLD_ITALIC_LETTER_KU = chr(66322)
OLD_ITALIC_LETTER_ER = chr(66323)
OLD_ITALIC_LETTER_ES = chr(66324)
OLD_ITALIC_LETTER_TE = chr(66325)
OLD_ITALIC_LETTER_U = chr(66326)
OLD_ITALIC_LETTER_EKS = chr(66327)
OLD_ITALIC_LETTER_PHE = chr(66328)
OLD_ITALIC_LETTER_KHE = chr(66329)
OLD_ITALIC_LETTER_EF = chr(66330)
OLD_ITALIC_LETTER_ERS = chr(66331)
OLD_ITALIC_LETTER_CHE = chr(66332)
OLD_ITALIC_LETTER_II = chr(66333)
OLD_ITALIC_LETTER_UU = chr(66334)
OLD_ITALIC_LETTER_ESS = chr(66335)
OLD_ITALIC_NUMERAL_ONE = chr(66336)
OLD_ITALIC_NUMERAL_FIVE = chr(66337)
OLD_ITALIC_NUMERAL_TEN = chr(66338)
OLD_ITALIC_NUMERAL_FIFTY = chr(66339)
OLD_ITALIC_LETTER_YE = chr(66349)
OLD_ITALIC_LETTER_NORTHERN_TSE = chr(66350)
OLD_ITALIC_LETTER_SOUTHERN_TSE = chr(66351)
GOTHIC_LETTER_AHSA = chr(66352)
GOTHIC_LETTER_BAIRKAN = chr(66353)
GOTHIC_LETTER_GIBA = chr(66354)
GOTHIC_LETTER_DAGS = chr(66355)
GOTHIC_LETTER_AIHVUS = chr(66356)
GOTHIC_LETTER_QAIRTHRA = chr(66357)
GOTHIC_LETTER_IUJA = chr(66358)
GOTHIC_LETTER_HAGL = chr(66359)
GOTHIC_LETTER_THIUTH = chr(66360)
GOTHIC_LETTER_EIS = chr(66361)
GOTHIC_LETTER_KUSMA = chr(66362)
GOTHIC_LETTER_LAGUS = chr(66363)
GOTHIC_LETTER_MANNA = chr(66364)
GOTHIC_LETTER_NAUTHS = chr(66365)
GOTHIC_LETTER_JER = chr(66366)
GOTHIC_LETTER_URUS = chr(66367)
GOTHIC_LETTER_PAIRTHRA = chr(66368)
GOTHIC_LETTER_NINETY = chr(66369)
GOTHIC_LETTER_RAIDA = chr(66370)
GOTHIC_LETTER_SAUIL = chr(66371)
GOTHIC_LETTER_TEIWS = chr(66372)
GOTHIC_LETTER_WINJA = chr(66373)
GOTHIC_LETTER_FAIHU = chr(66374)
GOTHIC_LETTER_IGGWS = chr(66375)
GOTHIC_LETTER_HWAIR = chr(66376)
GOTHIC_LETTER_OTHAL = chr(66377)
GOTHIC_LETTER_NINE_HUNDRED = chr(66378)
OLD_PERMIC_LETTER_AN = chr(66384)
OLD_PERMIC_LETTER_BUR = chr(66385)
OLD_PERMIC_LETTER_GAI = chr(66386)
OLD_PERMIC_LETTER_DOI = chr(66387)
OLD_PERMIC_LETTER_E = chr(66388)
OLD_PERMIC_LETTER_ZHOI = chr(66389)
OLD_PERMIC_LETTER_DZHOI = chr(66390)
OLD_PERMIC_LETTER_ZATA = chr(66391)
OLD_PERMIC_LETTER_DZITA = chr(66392)
OLD_PERMIC_LETTER_I = chr(66393)
OLD_PERMIC_LETTER_KOKE = chr(66394)
OLD_PERMIC_LETTER_LEI = chr(66395)
OLD_PERMIC_LETTER_MENOE = chr(66396)
OLD_PERMIC_LETTER_NENOE = chr(66397)
OLD_PERMIC_LETTER_VOOI = chr(66398)
OLD_PERMIC_LETTER_PEEI = chr(66399)
OLD_PERMIC_LETTER_REI = chr(66400)
OLD_PERMIC_LETTER_SII = chr(66401)
OLD_PERMIC_LETTER_TAI = chr(66402)
OLD_PERMIC_LETTER_U = chr(66403)
OLD_PERMIC_LETTER_CHERY = chr(66404)
OLD_PERMIC_LETTER_SHOOI = chr(66405)
OLD_PERMIC_LETTER_SHCHOOI = chr(66406)
OLD_PERMIC_LETTER_YRY = chr(66407)
OLD_PERMIC_LETTER_YERU = chr(66408)
OLD_PERMIC_LETTER_O = chr(66409)
OLD_PERMIC_LETTER_OO = chr(66410)
OLD_PERMIC_LETTER_EF = chr(66411)
OLD_PERMIC_LETTER_HA = chr(66412)
OLD_PERMIC_LETTER_TSIU = chr(66413)
OLD_PERMIC_LETTER_VER = chr(66414)
OLD_PERMIC_LETTER_YER = chr(66415)
OLD_PERMIC_LETTER_YERI = chr(66416)
OLD_PERMIC_LETTER_YAT = chr(66417)
OLD_PERMIC_LETTER_IE = chr(66418)
OLD_PERMIC_LETTER_YU = chr(66419)
OLD_PERMIC_LETTER_YA = chr(66420)
OLD_PERMIC_LETTER_IA = chr(66421)
COMBINING_OLD_PERMIC_LETTER_AN = chr(66422)
COMBINING_OLD_PERMIC_LETTER_DOI = chr(66423)
COMBINING_OLD_PERMIC_LETTER_ZATA = chr(66424)
COMBINING_OLD_PERMIC_LETTER_NENOE = chr(66425)
COMBINING_OLD_PERMIC_LETTER_SII = chr(66426)
UGARITIC_LETTER_ALPA = chr(66432)
UGARITIC_LETTER_BETA = chr(66433)
UGARITIC_LETTER_GAMLA = chr(66434)
UGARITIC_LETTER_KHA = chr(66435)
UGARITIC_LETTER_DELTA = chr(66436)
UGARITIC_LETTER_HO = chr(66437)
UGARITIC_LETTER_WO = chr(66438)
UGARITIC_LETTER_ZETA = chr(66439)
UGARITIC_LETTER_HOTA = chr(66440)
UGARITIC_LETTER_TET = chr(66441)
UGARITIC_LETTER_YOD = chr(66442)
UGARITIC_LETTER_KAF = chr(66443)
UGARITIC_LETTER_SHIN = chr(66444)
UGARITIC_LETTER_LAMDA = chr(66445)
UGARITIC_LETTER_MEM = chr(66446)
UGARITIC_LETTER_DHAL = chr(66447)
UGARITIC_LETTER_NUN = chr(66448)
UGARITIC_LETTER_ZU = chr(66449)
UGARITIC_LETTER_SAMKA = chr(66450)
UGARITIC_LETTER_AIN = chr(66451)
UGARITIC_LETTER_PU = chr(66452)
UGARITIC_LETTER_SADE = chr(66453)
UGARITIC_LETTER_QOPA = chr(66454)
UGARITIC_LETTER_RASHA = chr(66455)
UGARITIC_LETTER_THANNA = chr(66456)
UGARITIC_LETTER_GHAIN = chr(66457)
UGARITIC_LETTER_TO = chr(66458)
UGARITIC_LETTER_I = chr(66459)
UGARITIC_LETTER_U = chr(66460)
UGARITIC_LETTER_SSU = chr(66461)
UGARITIC_WORD_DIVIDER = chr(66463)
OLD_PERSIAN_SIGN_A = chr(66464)
OLD_PERSIAN_SIGN_I = chr(66465)
OLD_PERSIAN_SIGN_U = chr(66466)
OLD_PERSIAN_SIGN_KA = chr(66467)
OLD_PERSIAN_SIGN_KU = chr(66468)
OLD_PERSIAN_SIGN_GA = chr(66469)
OLD_PERSIAN_SIGN_GU = chr(66470)
OLD_PERSIAN_SIGN_XA = chr(66471)
OLD_PERSIAN_SIGN_CA = chr(66472)
OLD_PERSIAN_SIGN_JA = chr(66473)
OLD_PERSIAN_SIGN_JI = chr(66474)
OLD_PERSIAN_SIGN_TA = chr(66475)
OLD_PERSIAN_SIGN_TU = chr(66476)
OLD_PERSIAN_SIGN_DA = chr(66477)
OLD_PERSIAN_SIGN_DI = chr(66478)
OLD_PERSIAN_SIGN_DU = chr(66479)
OLD_PERSIAN_SIGN_THA = chr(66480)
OLD_PERSIAN_SIGN_PA = chr(66481)
OLD_PERSIAN_SIGN_BA = chr(66482)
OLD_PERSIAN_SIGN_FA = chr(66483)
OLD_PERSIAN_SIGN_NA = chr(66484)
OLD_PERSIAN_SIGN_NU = chr(66485)
OLD_PERSIAN_SIGN_MA = chr(66486)
OLD_PERSIAN_SIGN_MI = chr(66487)
OLD_PERSIAN_SIGN_MU = chr(66488)
OLD_PERSIAN_SIGN_YA = chr(66489)
OLD_PERSIAN_SIGN_VA = chr(66490)
OLD_PERSIAN_SIGN_VI = chr(66491)
OLD_PERSIAN_SIGN_RA = chr(66492)
OLD_PERSIAN_SIGN_RU = chr(66493)
OLD_PERSIAN_SIGN_LA = chr(66494)
OLD_PERSIAN_SIGN_SA = chr(66495)
OLD_PERSIAN_SIGN_ZA = chr(66496)
OLD_PERSIAN_SIGN_SHA = chr(66497)
OLD_PERSIAN_SIGN_SSA = chr(66498)
OLD_PERSIAN_SIGN_HA = chr(66499)
OLD_PERSIAN_SIGN_AURAMAZDAA = chr(66504)
OLD_PERSIAN_SIGN_AURAMAZDAA_2 = chr(66505)
OLD_PERSIAN_SIGN_AURAMAZDAAHA = chr(66506)
OLD_PERSIAN_SIGN_XSHAAYATHIYA = chr(66507)
OLD_PERSIAN_SIGN_DAHYAAUSH = chr(66508)
OLD_PERSIAN_SIGN_DAHYAAUSH_2 = chr(66509)
OLD_PERSIAN_SIGN_BAGA = chr(66510)
OLD_PERSIAN_SIGN_BUUMISH = chr(66511)
OLD_PERSIAN_WORD_DIVIDER = chr(66512)
OLD_PERSIAN_NUMBER_ONE = chr(66513)
OLD_PERSIAN_NUMBER_TWO = chr(66514)
OLD_PERSIAN_NUMBER_TEN = chr(66515)
OLD_PERSIAN_NUMBER_TWENTY = chr(66516)
OLD_PERSIAN_NUMBER_HUNDRED = chr(66517)
DESERET_CAPITAL_LETTER_LONG_I = chr(66560)
DESERET_CAPITAL_LETTER_LONG_E = chr(66561)
DESERET_CAPITAL_LETTER_LONG_A = chr(66562)
DESERET_CAPITAL_LETTER_LONG_AH = chr(66563)
DESERET_CAPITAL_LETTER_LONG_O = chr(66564)
DESERET_CAPITAL_LETTER_LONG_OO = chr(66565)
DESERET_CAPITAL_LETTER_SHORT_I = chr(66566)
DESERET_CAPITAL_LETTER_SHORT_E = chr(66567)
DESERET_CAPITAL_LETTER_SHORT_A = chr(66568)
DESERET_CAPITAL_LETTER_SHORT_AH = chr(66569)
DESERET_CAPITAL_LETTER_SHORT_O = chr(66570)
DESERET_CAPITAL_LETTER_SHORT_OO = chr(66571)
DESERET_CAPITAL_LETTER_AY = chr(66572)
DESERET_CAPITAL_LETTER_OW = chr(66573)
DESERET_CAPITAL_LETTER_WU = chr(66574)
DESERET_CAPITAL_LETTER_YEE = chr(66575)
DESERET_CAPITAL_LETTER_H = chr(66576)
DESERET_CAPITAL_LETTER_PEE = chr(66577)
DESERET_CAPITAL_LETTER_BEE = chr(66578)
DESERET_CAPITAL_LETTER_TEE = chr(66579)
DESERET_CAPITAL_LETTER_DEE = chr(66580)
DESERET_CAPITAL_LETTER_CHEE = chr(66581)
DESERET_CAPITAL_LETTER_JEE = chr(66582)
DESERET_CAPITAL_LETTER_KAY = chr(66583)
DESERET_CAPITAL_LETTER_GAY = chr(66584)
DESERET_CAPITAL_LETTER_EF = chr(66585)
DESERET_CAPITAL_LETTER_VEE = chr(66586)
DESERET_CAPITAL_LETTER_ETH = chr(66587)
DESERET_CAPITAL_LETTER_THEE = chr(66588)
DESERET_CAPITAL_LETTER_ES = chr(66589)
DESERET_CAPITAL_LETTER_ZEE = chr(66590)
DESERET_CAPITAL_LETTER_ESH = chr(66591)
DESERET_CAPITAL_LETTER_ZHEE = chr(66592)
DESERET_CAPITAL_LETTER_ER = chr(66593)
DESERET_CAPITAL_LETTER_EL = chr(66594)
DESERET_CAPITAL_LETTER_EM = chr(66595)
DESERET_CAPITAL_LETTER_EN = chr(66596)
DESERET_CAPITAL_LETTER_ENG = chr(66597)
DESERET_CAPITAL_LETTER_OI = chr(66598)
DESERET_CAPITAL_LETTER_EW = chr(66599)
DESERET_SMALL_LETTER_LONG_I = chr(66600)
DESERET_SMALL_LETTER_LONG_E = chr(66601)
DESERET_SMALL_LETTER_LONG_A = chr(66602)
DESERET_SMALL_LETTER_LONG_AH = chr(66603)
DESERET_SMALL_LETTER_LONG_O = chr(66604)
DESERET_SMALL_LETTER_LONG_OO = chr(66605)
DESERET_SMALL_LETTER_SHORT_I = chr(66606)
DESERET_SMALL_LETTER_SHORT_E = chr(66607)
DESERET_SMALL_LETTER_SHORT_A = chr(66608)
DESERET_SMALL_LETTER_SHORT_AH = chr(66609)
DESERET_SMALL_LETTER_SHORT_O = chr(66610)
DESERET_SMALL_LETTER_SHORT_OO = chr(66611)
DESERET_SMALL_LETTER_AY = chr(66612)
DESERET_SMALL_LETTER_OW = chr(66613)
DESERET_SMALL_LETTER_WU = chr(66614)
DESERET_SMALL_LETTER_YEE = chr(66615)
DESERET_SMALL_LETTER_H = chr(66616)
DESERET_SMALL_LETTER_PEE = chr(66617)
DESERET_SMALL_LETTER_BEE = chr(66618)
DESERET_SMALL_LETTER_TEE = chr(66619)
DESERET_SMALL_LETTER_DEE = chr(66620)
DESERET_SMALL_LETTER_CHEE = chr(66621)
DESERET_SMALL_LETTER_JEE = chr(66622)
DESERET_SMALL_LETTER_KAY = chr(66623)
DESERET_SMALL_LETTER_GAY = chr(66624)
DESERET_SMALL_LETTER_EF = chr(66625)
DESERET_SMALL_LETTER_VEE = chr(66626)
DESERET_SMALL_LETTER_ETH = chr(66627)
DESERET_SMALL_LETTER_THEE = chr(66628)
DESERET_SMALL_LETTER_ES = chr(66629)
DESERET_SMALL_LETTER_ZEE = chr(66630)
DESERET_SMALL_LETTER_ESH = chr(66631)
DESERET_SMALL_LETTER_ZHEE = chr(66632)
DESERET_SMALL_LETTER_ER = chr(66633)
DESERET_SMALL_LETTER_EL = chr(66634)
DESERET_SMALL_LETTER_EM = chr(66635)
DESERET_SMALL_LETTER_EN = chr(66636)
DESERET_SMALL_LETTER_ENG = chr(66637)
DESERET_SMALL_LETTER_OI = chr(66638)
DESERET_SMALL_LETTER_EW = chr(66639)
SHAVIAN_LETTER_PEEP = chr(66640)
SHAVIAN_LETTER_TOT = chr(66641)
SHAVIAN_LETTER_KICK = chr(66642)
SHAVIAN_LETTER_FEE = chr(66643)
SHAVIAN_LETTER_THIGH = chr(66644)
SHAVIAN_LETTER_SO = chr(66645)
SHAVIAN_LETTER_SURE = chr(66646)
SHAVIAN_LETTER_CHURCH = chr(66647)
SHAVIAN_LETTER_YEA = chr(66648)
SHAVIAN_LETTER_HUNG = chr(66649)
SHAVIAN_LETTER_BIB = chr(66650)
SHAVIAN_LETTER_DEAD = chr(66651)
SHAVIAN_LETTER_GAG = chr(66652)
SHAVIAN_LETTER_VOW = chr(66653)
SHAVIAN_LETTER_THEY = chr(66654)
SHAVIAN_LETTER_ZOO = chr(66655)
SHAVIAN_LETTER_MEASURE = chr(66656)
SHAVIAN_LETTER_JUDGE = chr(66657)
SHAVIAN_LETTER_WOE = chr(66658)
SHAVIAN_LETTER_HA_HA = chr(66659)
SHAVIAN_LETTER_LOLL = chr(66660)
SHAVIAN_LETTER_MIME = chr(66661)
SHAVIAN_LETTER_IF = chr(66662)
SHAVIAN_LETTER_EGG = chr(66663)
SHAVIAN_LETTER_ASH = chr(66664)
SHAVIAN_LETTER_ADO = chr(66665)
SHAVIAN_LETTER_ON = chr(66666)
SHAVIAN_LETTER_WOOL = chr(66667)
SHAVIAN_LETTER_OUT = chr(66668)
SHAVIAN_LETTER_AH = chr(66669)
SHAVIAN_LETTER_ROAR = chr(66670)
SHAVIAN_LETTER_NUN = chr(66671)
SHAVIAN_LETTER_EAT = chr(66672)
SHAVIAN_LETTER_AGE = chr(66673)
SHAVIAN_LETTER_ICE = chr(66674)
SHAVIAN_LETTER_UP = chr(66675)
SHAVIAN_LETTER_OAK = chr(66676)
SHAVIAN_LETTER_OOZE = chr(66677)
SHAVIAN_LETTER_OIL = chr(66678)
SHAVIAN_LETTER_AWE = chr(66679)
SHAVIAN_LETTER_ARE = chr(66680)
SHAVIAN_LETTER_OR = chr(66681)
SHAVIAN_LETTER_AIR = chr(66682)
SHAVIAN_LETTER_ERR = chr(66683)
SHAVIAN_LETTER_ARRAY = chr(66684)
SHAVIAN_LETTER_EAR = chr(66685)
SHAVIAN_LETTER_IAN = chr(66686)
SHAVIAN_LETTER_YEW = chr(66687)
OSMANYA_LETTER_ALEF = chr(66688)
OSMANYA_LETTER_BA = chr(66689)
OSMANYA_LETTER_TA = chr(66690)
OSMANYA_LETTER_JA = chr(66691)
OSMANYA_LETTER_XA = chr(66692)
OSMANYA_LETTER_KHA = chr(66693)
OSMANYA_LETTER_DEEL = chr(66694)
OSMANYA_LETTER_RA = chr(66695)
OSMANYA_LETTER_SA = chr(66696)
OSMANYA_LETTER_SHIIN = chr(66697)
OSMANYA_LETTER_DHA = chr(66698)
OSMANYA_LETTER_CAYN = chr(66699)
OSMANYA_LETTER_GA = chr(66700)
OSMANYA_LETTER_FA = chr(66701)
OSMANYA_LETTER_QAAF = chr(66702)
OSMANYA_LETTER_KAAF = chr(66703)
OSMANYA_LETTER_LAAN = chr(66704)
OSMANYA_LETTER_MIIN = chr(66705)
OSMANYA_LETTER_NUUN = chr(66706)
OSMANYA_LETTER_WAW = chr(66707)
OSMANYA_LETTER_HA = chr(66708)
OSMANYA_LETTER_YA = chr(66709)
OSMANYA_LETTER_A = chr(66710)
OSMANYA_LETTER_E = chr(66711)
OSMANYA_LETTER_I = chr(66712)
OSMANYA_LETTER_O = chr(66713)
OSMANYA_LETTER_U = chr(66714)
OSMANYA_LETTER_AA = chr(66715)
OSMANYA_LETTER_EE = chr(66716)
OSMANYA_LETTER_OO = chr(66717)
OSMANYA_DIGIT_ZERO = chr(66720)
OSMANYA_DIGIT_ONE = chr(66721)
OSMANYA_DIGIT_TWO = chr(66722)
OSMANYA_DIGIT_THREE = chr(66723)
OSMANYA_DIGIT_FOUR = chr(66724)
OSMANYA_DIGIT_FIVE = chr(66725)
OSMANYA_DIGIT_SIX = chr(66726)
OSMANYA_DIGIT_SEVEN = chr(66727)
OSMANYA_DIGIT_EIGHT = chr(66728)
OSMANYA_DIGIT_NINE = chr(66729)
OSAGE_CAPITAL_LETTER_A = chr(66736)
OSAGE_CAPITAL_LETTER_AI = chr(66737)
OSAGE_CAPITAL_LETTER_AIN = chr(66738)
OSAGE_CAPITAL_LETTER_AH = chr(66739)
OSAGE_CAPITAL_LETTER_BRA = chr(66740)
OSAGE_CAPITAL_LETTER_CHA = chr(66741)
OSAGE_CAPITAL_LETTER_EHCHA = chr(66742)
OSAGE_CAPITAL_LETTER_E = chr(66743)
OSAGE_CAPITAL_LETTER_EIN = chr(66744)
OSAGE_CAPITAL_LETTER_HA = chr(66745)
OSAGE_CAPITAL_LETTER_HYA = chr(66746)
OSAGE_CAPITAL_LETTER_I = chr(66747)
OSAGE_CAPITAL_LETTER_KA = chr(66748)
OSAGE_CAPITAL_LETTER_EHKA = chr(66749)
OSAGE_CAPITAL_LETTER_KYA = chr(66750)
OSAGE_CAPITAL_LETTER_LA = chr(66751)
OSAGE_CAPITAL_LETTER_MA = chr(66752)
OSAGE_CAPITAL_LETTER_NA = chr(66753)
OSAGE_CAPITAL_LETTER_O = chr(66754)
OSAGE_CAPITAL_LETTER_OIN = chr(66755)
OSAGE_CAPITAL_LETTER_PA = chr(66756)
OSAGE_CAPITAL_LETTER_EHPA = chr(66757)
OSAGE_CAPITAL_LETTER_SA = chr(66758)
OSAGE_CAPITAL_LETTER_SHA = chr(66759)
OSAGE_CAPITAL_LETTER_TA = chr(66760)
OSAGE_CAPITAL_LETTER_EHTA = chr(66761)
OSAGE_CAPITAL_LETTER_TSA = chr(66762)
OSAGE_CAPITAL_LETTER_EHTSA = chr(66763)
OSAGE_CAPITAL_LETTER_TSHA = chr(66764)
OSAGE_CAPITAL_LETTER_DHA = chr(66765)
OSAGE_CAPITAL_LETTER_U = chr(66766)
OSAGE_CAPITAL_LETTER_WA = chr(66767)
OSAGE_CAPITAL_LETTER_KHA = chr(66768)
OSAGE_CAPITAL_LETTER_GHA = chr(66769)
OSAGE_CAPITAL_LETTER_ZA = chr(66770)
OSAGE_CAPITAL_LETTER_ZHA = chr(66771)
OSAGE_SMALL_LETTER_A = chr(66776)
OSAGE_SMALL_LETTER_AI = chr(66777)
OSAGE_SMALL_LETTER_AIN = chr(66778)
OSAGE_SMALL_LETTER_AH = chr(66779)
OSAGE_SMALL_LETTER_BRA = chr(66780)
OSAGE_SMALL_LETTER_CHA = chr(66781)
OSAGE_SMALL_LETTER_EHCHA = chr(66782)
OSAGE_SMALL_LETTER_E = chr(66783)
OSAGE_SMALL_LETTER_EIN = chr(66784)
OSAGE_SMALL_LETTER_HA = chr(66785)
OSAGE_SMALL_LETTER_HYA = chr(66786)
OSAGE_SMALL_LETTER_I = chr(66787)
OSAGE_SMALL_LETTER_KA = chr(66788)
OSAGE_SMALL_LETTER_EHKA = chr(66789)
OSAGE_SMALL_LETTER_KYA = chr(66790)
OSAGE_SMALL_LETTER_LA = chr(66791)
OSAGE_SMALL_LETTER_MA = chr(66792)
OSAGE_SMALL_LETTER_NA = chr(66793)
OSAGE_SMALL_LETTER_O = chr(66794)
OSAGE_SMALL_LETTER_OIN = chr(66795)
OSAGE_SMALL_LETTER_PA = chr(66796)
OSAGE_SMALL_LETTER_EHPA = chr(66797)
OSAGE_SMALL_LETTER_SA = chr(66798)
OSAGE_SMALL_LETTER_SHA = chr(66799)
OSAGE_SMALL_LETTER_TA = chr(66800)
OSAGE_SMALL_LETTER_EHTA = chr(66801)
OSAGE_SMALL_LETTER_TSA = chr(66802)
OSAGE_SMALL_LETTER_EHTSA = chr(66803)
OSAGE_SMALL_LETTER_TSHA = chr(66804)
OSAGE_SMALL_LETTER_DHA = chr(66805)
OSAGE_SMALL_LETTER_U = chr(66806)
OSAGE_SMALL_LETTER_WA = chr(66807)
OSAGE_SMALL_LETTER_KHA = chr(66808)
OSAGE_SMALL_LETTER_GHA = chr(66809)
OSAGE_SMALL_LETTER_ZA = chr(66810)
OSAGE_SMALL_LETTER_ZHA = chr(66811)
ELBASAN_LETTER_A = chr(66816)
ELBASAN_LETTER_BE = chr(66817)
ELBASAN_LETTER_CE = chr(66818)
ELBASAN_LETTER_CHE = chr(66819)
ELBASAN_LETTER_DE = chr(66820)
ELBASAN_LETTER_NDE = chr(66821)
ELBASAN_LETTER_DHE = chr(66822)
ELBASAN_LETTER_EI = chr(66823)
ELBASAN_LETTER_E = chr(66824)
ELBASAN_LETTER_FE = chr(66825)
ELBASAN_LETTER_GE = chr(66826)
ELBASAN_LETTER_GJE = chr(66827)
ELBASAN_LETTER_HE = chr(66828)
ELBASAN_LETTER_I = chr(66829)
ELBASAN_LETTER_JE = chr(66830)
ELBASAN_LETTER_KE = chr(66831)
ELBASAN_LETTER_LE = chr(66832)
ELBASAN_LETTER_LLE = chr(66833)
ELBASAN_LETTER_ME = chr(66834)
ELBASAN_LETTER_NE = chr(66835)
ELBASAN_LETTER_NA = chr(66836)
ELBASAN_LETTER_NJE = chr(66837)
ELBASAN_LETTER_O = chr(66838)
ELBASAN_LETTER_PE = chr(66839)
ELBASAN_LETTER_QE = chr(66840)
ELBASAN_LETTER_RE = chr(66841)
ELBASAN_LETTER_RRE = chr(66842)
ELBASAN_LETTER_SE = chr(66843)
ELBASAN_LETTER_SHE = chr(66844)
ELBASAN_LETTER_TE = chr(66845)
ELBASAN_LETTER_THE = chr(66846)
ELBASAN_LETTER_U = chr(66847)
ELBASAN_LETTER_VE = chr(66848)
ELBASAN_LETTER_XE = chr(66849)
ELBASAN_LETTER_Y = chr(66850)
ELBASAN_LETTER_ZE = chr(66851)
ELBASAN_LETTER_ZHE = chr(66852)
ELBASAN_LETTER_GHE = chr(66853)
ELBASAN_LETTER_GHAMMA = chr(66854)
ELBASAN_LETTER_KHE = chr(66855)
CAUCASIAN_ALBANIAN_LETTER_ALT = chr(66864)
CAUCASIAN_ALBANIAN_LETTER_BET = chr(66865)
CAUCASIAN_ALBANIAN_LETTER_GIM = chr(66866)
CAUCASIAN_ALBANIAN_LETTER_DAT = chr(66867)
CAUCASIAN_ALBANIAN_LETTER_EB = chr(66868)
CAUCASIAN_ALBANIAN_LETTER_ZARL = chr(66869)
CAUCASIAN_ALBANIAN_LETTER_EYN = chr(66870)
CAUCASIAN_ALBANIAN_LETTER_ZHIL = chr(66871)
CAUCASIAN_ALBANIAN_LETTER_TAS = chr(66872)
CAUCASIAN_ALBANIAN_LETTER_CHA = chr(66873)
CAUCASIAN_ALBANIAN_LETTER_YOWD = chr(66874)
CAUCASIAN_ALBANIAN_LETTER_ZHA = chr(66875)
CAUCASIAN_ALBANIAN_LETTER_IRB = chr(66876)
CAUCASIAN_ALBANIAN_LETTER_SHA = chr(66877)
CAUCASIAN_ALBANIAN_LETTER_LAN = chr(66878)
CAUCASIAN_ALBANIAN_LETTER_INYA = chr(66879)
CAUCASIAN_ALBANIAN_LETTER_XEYN = chr(66880)
CAUCASIAN_ALBANIAN_LETTER_DYAN = chr(66881)
CAUCASIAN_ALBANIAN_LETTER_CAR = chr(66882)
CAUCASIAN_ALBANIAN_LETTER_JHOX = chr(66883)
CAUCASIAN_ALBANIAN_LETTER_KAR = chr(66884)
CAUCASIAN_ALBANIAN_LETTER_LYIT = chr(66885)
CAUCASIAN_ALBANIAN_LETTER_HEYT = chr(66886)
CAUCASIAN_ALBANIAN_LETTER_QAY = chr(66887)
CAUCASIAN_ALBANIAN_LETTER_AOR = chr(66888)
CAUCASIAN_ALBANIAN_LETTER_CHOY = chr(66889)
CAUCASIAN_ALBANIAN_LETTER_CHI = chr(66890)
CAUCASIAN_ALBANIAN_LETTER_CYAY = chr(66891)
CAUCASIAN_ALBANIAN_LETTER_MAQ = chr(66892)
CAUCASIAN_ALBANIAN_LETTER_QAR = chr(66893)
CAUCASIAN_ALBANIAN_LETTER_NOWC = chr(66894)
CAUCASIAN_ALBANIAN_LETTER_DZYAY = chr(66895)
CAUCASIAN_ALBANIAN_LETTER_SHAK = chr(66896)
CAUCASIAN_ALBANIAN_LETTER_JAYN = chr(66897)
CAUCASIAN_ALBANIAN_LETTER_ON = chr(66898)
CAUCASIAN_ALBANIAN_LETTER_TYAY = chr(66899)
CAUCASIAN_ALBANIAN_LETTER_FAM = chr(66900)
CAUCASIAN_ALBANIAN_LETTER_DZAY = chr(66901)
CAUCASIAN_ALBANIAN_LETTER_CHAT = chr(66902)
CAUCASIAN_ALBANIAN_LETTER_PEN = chr(66903)
CAUCASIAN_ALBANIAN_LETTER_GHEYS = chr(66904)
CAUCASIAN_ALBANIAN_LETTER_RAT = chr(66905)
CAUCASIAN_ALBANIAN_LETTER_SEYK = chr(66906)
CAUCASIAN_ALBANIAN_LETTER_VEYZ = chr(66907)
CAUCASIAN_ALBANIAN_LETTER_TIWR = chr(66908)
CAUCASIAN_ALBANIAN_LETTER_SHOY = chr(66909)
CAUCASIAN_ALBANIAN_LETTER_IWN = chr(66910)
CAUCASIAN_ALBANIAN_LETTER_CYAW = chr(66911)
CAUCASIAN_ALBANIAN_LETTER_CAYN = chr(66912)
CAUCASIAN_ALBANIAN_LETTER_YAYD = chr(66913)
CAUCASIAN_ALBANIAN_LETTER_PIWR = chr(66914)
CAUCASIAN_ALBANIAN_LETTER_KIW = chr(66915)
CAUCASIAN_ALBANIAN_CITATION_MARK = chr(66927)
VITHKUQI_CAPITAL_LETTER_A = chr(66928)
VITHKUQI_CAPITAL_LETTER_BBE = chr(66929)
VITHKUQI_CAPITAL_LETTER_BE = chr(66930)
VITHKUQI_CAPITAL_LETTER_CE = chr(66931)
VITHKUQI_CAPITAL_LETTER_CHE = chr(66932)
VITHKUQI_CAPITAL_LETTER_DE = chr(66933)
VITHKUQI_CAPITAL_LETTER_DHE = chr(66934)
VITHKUQI_CAPITAL_LETTER_EI = chr(66935)
VITHKUQI_CAPITAL_LETTER_E = chr(66936)
VITHKUQI_CAPITAL_LETTER_FE = chr(66937)
VITHKUQI_CAPITAL_LETTER_GA = chr(66938)
VITHKUQI_CAPITAL_LETTER_HA = chr(66940)
VITHKUQI_CAPITAL_LETTER_HHA = chr(66941)
VITHKUQI_CAPITAL_LETTER_I = chr(66942)
VITHKUQI_CAPITAL_LETTER_IJE = chr(66943)
VITHKUQI_CAPITAL_LETTER_JE = chr(66944)
VITHKUQI_CAPITAL_LETTER_KA = chr(66945)
VITHKUQI_CAPITAL_LETTER_LA = chr(66946)
VITHKUQI_CAPITAL_LETTER_LLA = chr(66947)
VITHKUQI_CAPITAL_LETTER_ME = chr(66948)
VITHKUQI_CAPITAL_LETTER_NE = chr(66949)
VITHKUQI_CAPITAL_LETTER_NJE = chr(66950)
VITHKUQI_CAPITAL_LETTER_O = chr(66951)
VITHKUQI_CAPITAL_LETTER_PE = chr(66952)
VITHKUQI_CAPITAL_LETTER_QA = chr(66953)
VITHKUQI_CAPITAL_LETTER_RE = chr(66954)
VITHKUQI_CAPITAL_LETTER_SE = chr(66956)
VITHKUQI_CAPITAL_LETTER_SHE = chr(66957)
VITHKUQI_CAPITAL_LETTER_TE = chr(66958)
VITHKUQI_CAPITAL_LETTER_THE = chr(66959)
VITHKUQI_CAPITAL_LETTER_U = chr(66960)
VITHKUQI_CAPITAL_LETTER_VE = chr(66961)
VITHKUQI_CAPITAL_LETTER_XE = chr(66962)
VITHKUQI_CAPITAL_LETTER_Y = chr(66964)
VITHKUQI_CAPITAL_LETTER_ZE = chr(66965)
VITHKUQI_SMALL_LETTER_A = chr(66967)
VITHKUQI_SMALL_LETTER_BBE = chr(66968)
VITHKUQI_SMALL_LETTER_BE = chr(66969)
VITHKUQI_SMALL_LETTER_CE = chr(66970)
VITHKUQI_SMALL_LETTER_CHE = chr(66971)
VITHKUQI_SMALL_LETTER_DE = chr(66972)
VITHKUQI_SMALL_LETTER_DHE = chr(66973)
VITHKUQI_SMALL_LETTER_EI = chr(66974)
VITHKUQI_SMALL_LETTER_E = chr(66975)
VITHKUQI_SMALL_LETTER_FE = chr(66976)
VITHKUQI_SMALL_LETTER_GA = chr(66977)
VITHKUQI_SMALL_LETTER_HA = chr(66979)
VITHKUQI_SMALL_LETTER_HHA = chr(66980)
VITHKUQI_SMALL_LETTER_I = chr(66981)
VITHKUQI_SMALL_LETTER_IJE = chr(66982)
VITHKUQI_SMALL_LETTER_JE = chr(66983)
VITHKUQI_SMALL_LETTER_KA = chr(66984)
VITHKUQI_SMALL_LETTER_LA = chr(66985)
VITHKUQI_SMALL_LETTER_LLA = chr(66986)
VITHKUQI_SMALL_LETTER_ME = chr(66987)
VITHKUQI_SMALL_LETTER_NE = chr(66988)
VITHKUQI_SMALL_LETTER_NJE = chr(66989)
VITHKUQI_SMALL_LETTER_O = chr(66990)
VITHKUQI_SMALL_LETTER_PE = chr(66991)
VITHKUQI_SMALL_LETTER_QA = chr(66992)
VITHKUQI_SMALL_LETTER_RE = chr(66993)
VITHKUQI_SMALL_LETTER_SE = chr(66995)
VITHKUQI_SMALL_LETTER_SHE = chr(66996)
VITHKUQI_SMALL_LETTER_TE = chr(66997)
VITHKUQI_SMALL_LETTER_THE = chr(66998)
VITHKUQI_SMALL_LETTER_U = chr(66999)
VITHKUQI_SMALL_LETTER_VE = chr(67000)
VITHKUQI_SMALL_LETTER_XE = chr(67001)
VITHKUQI_SMALL_LETTER_Y = chr(67003)
VITHKUQI_SMALL_LETTER_ZE = chr(67004)
LINEAR_A_SIGN_AB001 = chr(67072)
LINEAR_A_SIGN_AB002 = chr(67073)
LINEAR_A_SIGN_AB003 = chr(67074)
LINEAR_A_SIGN_AB004 = chr(67075)
LINEAR_A_SIGN_AB005 = chr(67076)
LINEAR_A_SIGN_AB006 = chr(67077)
LINEAR_A_SIGN_AB007 = chr(67078)
LINEAR_A_SIGN_AB008 = chr(67079)
LINEAR_A_SIGN_AB009 = chr(67080)
LINEAR_A_SIGN_AB010 = chr(67081)
LINEAR_A_SIGN_AB011 = chr(67082)
LINEAR_A_SIGN_AB013 = chr(67083)
LINEAR_A_SIGN_AB016 = chr(67084)
LINEAR_A_SIGN_AB017 = chr(67085)
LINEAR_A_SIGN_AB020 = chr(67086)
LINEAR_A_SIGN_AB021 = chr(67087)
LINEAR_A_SIGN_AB021F = chr(67088)
LINEAR_A_SIGN_AB021M = chr(67089)
LINEAR_A_SIGN_AB022 = chr(67090)
LINEAR_A_SIGN_AB022F = chr(67091)
LINEAR_A_SIGN_AB022M = chr(67092)
LINEAR_A_SIGN_AB023 = chr(67093)
LINEAR_A_SIGN_AB023M = chr(67094)
LINEAR_A_SIGN_AB024 = chr(67095)
LINEAR_A_SIGN_AB026 = chr(67096)
LINEAR_A_SIGN_AB027 = chr(67097)
LINEAR_A_SIGN_AB028 = chr(67098)
LINEAR_A_SIGN_A028B = chr(67099)
LINEAR_A_SIGN_AB029 = chr(67100)
LINEAR_A_SIGN_AB030 = chr(67101)
LINEAR_A_SIGN_AB031 = chr(67102)
LINEAR_A_SIGN_AB034 = chr(67103)
LINEAR_A_SIGN_AB037 = chr(67104)
LINEAR_A_SIGN_AB038 = chr(67105)
LINEAR_A_SIGN_AB039 = chr(67106)
LINEAR_A_SIGN_AB040 = chr(67107)
LINEAR_A_SIGN_AB041 = chr(67108)
LINEAR_A_SIGN_AB044 = chr(67109)
LINEAR_A_SIGN_AB045 = chr(67110)
LINEAR_A_SIGN_AB046 = chr(67111)
LINEAR_A_SIGN_AB047 = chr(67112)
LINEAR_A_SIGN_AB048 = chr(67113)
LINEAR_A_SIGN_AB049 = chr(67114)
LINEAR_A_SIGN_AB050 = chr(67115)
LINEAR_A_SIGN_AB051 = chr(67116)
LINEAR_A_SIGN_AB053 = chr(67117)
LINEAR_A_SIGN_AB054 = chr(67118)
LINEAR_A_SIGN_AB055 = chr(67119)
LINEAR_A_SIGN_AB056 = chr(67120)
LINEAR_A_SIGN_AB057 = chr(67121)
LINEAR_A_SIGN_AB058 = chr(67122)
LINEAR_A_SIGN_AB059 = chr(67123)
LINEAR_A_SIGN_AB060 = chr(67124)
LINEAR_A_SIGN_AB061 = chr(67125)
LINEAR_A_SIGN_AB065 = chr(67126)
LINEAR_A_SIGN_AB066 = chr(67127)
LINEAR_A_SIGN_AB067 = chr(67128)
LINEAR_A_SIGN_AB069 = chr(67129)
LINEAR_A_SIGN_AB070 = chr(67130)
LINEAR_A_SIGN_AB073 = chr(67131)
LINEAR_A_SIGN_AB074 = chr(67132)
LINEAR_A_SIGN_AB076 = chr(67133)
LINEAR_A_SIGN_AB077 = chr(67134)
LINEAR_A_SIGN_AB078 = chr(67135)
LINEAR_A_SIGN_AB079 = chr(67136)
LINEAR_A_SIGN_AB080 = chr(67137)
LINEAR_A_SIGN_AB081 = chr(67138)
LINEAR_A_SIGN_AB082 = chr(67139)
LINEAR_A_SIGN_AB085 = chr(67140)
LINEAR_A_SIGN_AB086 = chr(67141)
LINEAR_A_SIGN_AB087 = chr(67142)
LINEAR_A_SIGN_A100_102 = chr(67143)
LINEAR_A_SIGN_AB118 = chr(67144)
LINEAR_A_SIGN_AB120 = chr(67145)
LINEAR_A_SIGN_A120B = chr(67146)
LINEAR_A_SIGN_AB122 = chr(67147)
LINEAR_A_SIGN_AB123 = chr(67148)
LINEAR_A_SIGN_AB131A = chr(67149)
LINEAR_A_SIGN_AB131B = chr(67150)
LINEAR_A_SIGN_A131C = chr(67151)
LINEAR_A_SIGN_AB164 = chr(67152)
LINEAR_A_SIGN_AB171 = chr(67153)
LINEAR_A_SIGN_AB180 = chr(67154)
LINEAR_A_SIGN_AB188 = chr(67155)
LINEAR_A_SIGN_AB191 = chr(67156)
LINEAR_A_SIGN_A301 = chr(67157)
LINEAR_A_SIGN_A302 = chr(67158)
LINEAR_A_SIGN_A303 = chr(67159)
LINEAR_A_SIGN_A304 = chr(67160)
LINEAR_A_SIGN_A305 = chr(67161)
LINEAR_A_SIGN_A306 = chr(67162)
LINEAR_A_SIGN_A307 = chr(67163)
LINEAR_A_SIGN_A308 = chr(67164)
LINEAR_A_SIGN_A309A = chr(67165)
LINEAR_A_SIGN_A309B = chr(67166)
LINEAR_A_SIGN_A309C = chr(67167)
LINEAR_A_SIGN_A310 = chr(67168)
LINEAR_A_SIGN_A311 = chr(67169)
LINEAR_A_SIGN_A312 = chr(67170)
LINEAR_A_SIGN_A313A = chr(67171)
LINEAR_A_SIGN_A313B = chr(67172)
LINEAR_A_SIGN_A313C = chr(67173)
LINEAR_A_SIGN_A314 = chr(67174)
LINEAR_A_SIGN_A315 = chr(67175)
LINEAR_A_SIGN_A316 = chr(67176)
LINEAR_A_SIGN_A317 = chr(67177)
LINEAR_A_SIGN_A318 = chr(67178)
LINEAR_A_SIGN_A319 = chr(67179)
LINEAR_A_SIGN_A320 = chr(67180)
LINEAR_A_SIGN_A321 = chr(67181)
LINEAR_A_SIGN_A322 = chr(67182)
LINEAR_A_SIGN_A323 = chr(67183)
LINEAR_A_SIGN_A324 = chr(67184)
LINEAR_A_SIGN_A325 = chr(67185)
LINEAR_A_SIGN_A326 = chr(67186)
LINEAR_A_SIGN_A327 = chr(67187)
LINEAR_A_SIGN_A328 = chr(67188)
LINEAR_A_SIGN_A329 = chr(67189)
LINEAR_A_SIGN_A330 = chr(67190)
LINEAR_A_SIGN_A331 = chr(67191)
LINEAR_A_SIGN_A332 = chr(67192)
LINEAR_A_SIGN_A333 = chr(67193)
LINEAR_A_SIGN_A334 = chr(67194)
LINEAR_A_SIGN_A335 = chr(67195)
LINEAR_A_SIGN_A336 = chr(67196)
LINEAR_A_SIGN_A337 = chr(67197)
LINEAR_A_SIGN_A338 = chr(67198)
LINEAR_A_SIGN_A339 = chr(67199)
LINEAR_A_SIGN_A340 = chr(67200)
LINEAR_A_SIGN_A341 = chr(67201)
LINEAR_A_SIGN_A342 = chr(67202)
LINEAR_A_SIGN_A343 = chr(67203)
LINEAR_A_SIGN_A344 = chr(67204)
LINEAR_A_SIGN_A345 = chr(67205)
LINEAR_A_SIGN_A346 = chr(67206)
LINEAR_A_SIGN_A347 = chr(67207)
LINEAR_A_SIGN_A348 = chr(67208)
LINEAR_A_SIGN_A349 = chr(67209)
LINEAR_A_SIGN_A350 = chr(67210)
LINEAR_A_SIGN_A351 = chr(67211)
LINEAR_A_SIGN_A352 = chr(67212)
LINEAR_A_SIGN_A353 = chr(67213)
LINEAR_A_SIGN_A354 = chr(67214)
LINEAR_A_SIGN_A355 = chr(67215)
LINEAR_A_SIGN_A356 = chr(67216)
LINEAR_A_SIGN_A357 = chr(67217)
LINEAR_A_SIGN_A358 = chr(67218)
LINEAR_A_SIGN_A359 = chr(67219)
LINEAR_A_SIGN_A360 = chr(67220)
LINEAR_A_SIGN_A361 = chr(67221)
LINEAR_A_SIGN_A362 = chr(67222)
LINEAR_A_SIGN_A363 = chr(67223)
LINEAR_A_SIGN_A364 = chr(67224)
LINEAR_A_SIGN_A365 = chr(67225)
LINEAR_A_SIGN_A366 = chr(67226)
LINEAR_A_SIGN_A367 = chr(67227)
LINEAR_A_SIGN_A368 = chr(67228)
LINEAR_A_SIGN_A369 = chr(67229)
LINEAR_A_SIGN_A370 = chr(67230)
LINEAR_A_SIGN_A371 = chr(67231)
LINEAR_A_SIGN_A400_VAS = chr(67232)
LINEAR_A_SIGN_A401_VAS = chr(67233)
LINEAR_A_SIGN_A402_VAS = chr(67234)
LINEAR_A_SIGN_A403_VAS = chr(67235)
LINEAR_A_SIGN_A404_VAS = chr(67236)
LINEAR_A_SIGN_A405_VAS = chr(67237)
LINEAR_A_SIGN_A406_VAS = chr(67238)
LINEAR_A_SIGN_A407_VAS = chr(67239)
LINEAR_A_SIGN_A408_VAS = chr(67240)
LINEAR_A_SIGN_A409_VAS = chr(67241)
LINEAR_A_SIGN_A410_VAS = chr(67242)
LINEAR_A_SIGN_A411_VAS = chr(67243)
LINEAR_A_SIGN_A412_VAS = chr(67244)
LINEAR_A_SIGN_A413_VAS = chr(67245)
LINEAR_A_SIGN_A414_VAS = chr(67246)
LINEAR_A_SIGN_A415_VAS = chr(67247)
LINEAR_A_SIGN_A416_VAS = chr(67248)
LINEAR_A_SIGN_A417_VAS = chr(67249)
LINEAR_A_SIGN_A418_VAS = chr(67250)
LINEAR_A_SIGN_A501 = chr(67251)
LINEAR_A_SIGN_A502 = chr(67252)
LINEAR_A_SIGN_A503 = chr(67253)
LINEAR_A_SIGN_A504 = chr(67254)
LINEAR_A_SIGN_A505 = chr(67255)
LINEAR_A_SIGN_A506 = chr(67256)
LINEAR_A_SIGN_A508 = chr(67257)
LINEAR_A_SIGN_A509 = chr(67258)
LINEAR_A_SIGN_A510 = chr(67259)
LINEAR_A_SIGN_A511 = chr(67260)
LINEAR_A_SIGN_A512 = chr(67261)
LINEAR_A_SIGN_A513 = chr(67262)
LINEAR_A_SIGN_A515 = chr(67263)
LINEAR_A_SIGN_A516 = chr(67264)
LINEAR_A_SIGN_A520 = chr(67265)
LINEAR_A_SIGN_A521 = chr(67266)
LINEAR_A_SIGN_A523 = chr(67267)
LINEAR_A_SIGN_A524 = chr(67268)
LINEAR_A_SIGN_A525 = chr(67269)
LINEAR_A_SIGN_A526 = chr(67270)
LINEAR_A_SIGN_A527 = chr(67271)
LINEAR_A_SIGN_A528 = chr(67272)
LINEAR_A_SIGN_A529 = chr(67273)
LINEAR_A_SIGN_A530 = chr(67274)
LINEAR_A_SIGN_A531 = chr(67275)
LINEAR_A_SIGN_A532 = chr(67276)
LINEAR_A_SIGN_A534 = chr(67277)
LINEAR_A_SIGN_A535 = chr(67278)
LINEAR_A_SIGN_A536 = chr(67279)
LINEAR_A_SIGN_A537 = chr(67280)
LINEAR_A_SIGN_A538 = chr(67281)
LINEAR_A_SIGN_A539 = chr(67282)
LINEAR_A_SIGN_A540 = chr(67283)
LINEAR_A_SIGN_A541 = chr(67284)
LINEAR_A_SIGN_A542 = chr(67285)
LINEAR_A_SIGN_A545 = chr(67286)
LINEAR_A_SIGN_A547 = chr(67287)
LINEAR_A_SIGN_A548 = chr(67288)
LINEAR_A_SIGN_A549 = chr(67289)
LINEAR_A_SIGN_A550 = chr(67290)
LINEAR_A_SIGN_A551 = chr(67291)
LINEAR_A_SIGN_A552 = chr(67292)
LINEAR_A_SIGN_A553 = chr(67293)
LINEAR_A_SIGN_A554 = chr(67294)
LINEAR_A_SIGN_A555 = chr(67295)
LINEAR_A_SIGN_A556 = chr(67296)
LINEAR_A_SIGN_A557 = chr(67297)
LINEAR_A_SIGN_A559 = chr(67298)
LINEAR_A_SIGN_A563 = chr(67299)
LINEAR_A_SIGN_A564 = chr(67300)
LINEAR_A_SIGN_A565 = chr(67301)
LINEAR_A_SIGN_A566 = chr(67302)
LINEAR_A_SIGN_A568 = chr(67303)
LINEAR_A_SIGN_A569 = chr(67304)
LINEAR_A_SIGN_A570 = chr(67305)
LINEAR_A_SIGN_A571 = chr(67306)
LINEAR_A_SIGN_A572 = chr(67307)
LINEAR_A_SIGN_A573 = chr(67308)
LINEAR_A_SIGN_A574 = chr(67309)
LINEAR_A_SIGN_A575 = chr(67310)
LINEAR_A_SIGN_A576 = chr(67311)
LINEAR_A_SIGN_A577 = chr(67312)
LINEAR_A_SIGN_A578 = chr(67313)
LINEAR_A_SIGN_A579 = chr(67314)
LINEAR_A_SIGN_A580 = chr(67315)
LINEAR_A_SIGN_A581 = chr(67316)
LINEAR_A_SIGN_A582 = chr(67317)
LINEAR_A_SIGN_A583 = chr(67318)
LINEAR_A_SIGN_A584 = chr(67319)
LINEAR_A_SIGN_A585 = chr(67320)
LINEAR_A_SIGN_A586 = chr(67321)
LINEAR_A_SIGN_A587 = chr(67322)
LINEAR_A_SIGN_A588 = chr(67323)
LINEAR_A_SIGN_A589 = chr(67324)
LINEAR_A_SIGN_A591 = chr(67325)
LINEAR_A_SIGN_A592 = chr(67326)
LINEAR_A_SIGN_A594 = chr(67327)
LINEAR_A_SIGN_A595 = chr(67328)
LINEAR_A_SIGN_A596 = chr(67329)
LINEAR_A_SIGN_A598 = chr(67330)
LINEAR_A_SIGN_A600 = chr(67331)
LINEAR_A_SIGN_A601 = chr(67332)
LINEAR_A_SIGN_A602 = chr(67333)
LINEAR_A_SIGN_A603 = chr(67334)
LINEAR_A_SIGN_A604 = chr(67335)
LINEAR_A_SIGN_A606 = chr(67336)
LINEAR_A_SIGN_A608 = chr(67337)
LINEAR_A_SIGN_A609 = chr(67338)
LINEAR_A_SIGN_A610 = chr(67339)
LINEAR_A_SIGN_A611 = chr(67340)
LINEAR_A_SIGN_A612 = chr(67341)
LINEAR_A_SIGN_A613 = chr(67342)
LINEAR_A_SIGN_A614 = chr(67343)
LINEAR_A_SIGN_A615 = chr(67344)
LINEAR_A_SIGN_A616 = chr(67345)
LINEAR_A_SIGN_A617 = chr(67346)
LINEAR_A_SIGN_A618 = chr(67347)
LINEAR_A_SIGN_A619 = chr(67348)
LINEAR_A_SIGN_A620 = chr(67349)
LINEAR_A_SIGN_A621 = chr(67350)
LINEAR_A_SIGN_A622 = chr(67351)
LINEAR_A_SIGN_A623 = chr(67352)
LINEAR_A_SIGN_A624 = chr(67353)
LINEAR_A_SIGN_A626 = chr(67354)
LINEAR_A_SIGN_A627 = chr(67355)
LINEAR_A_SIGN_A628 = chr(67356)
LINEAR_A_SIGN_A629 = chr(67357)
LINEAR_A_SIGN_A634 = chr(67358)
LINEAR_A_SIGN_A637 = chr(67359)
LINEAR_A_SIGN_A638 = chr(67360)
LINEAR_A_SIGN_A640 = chr(67361)
LINEAR_A_SIGN_A642 = chr(67362)
LINEAR_A_SIGN_A643 = chr(67363)
LINEAR_A_SIGN_A644 = chr(67364)
LINEAR_A_SIGN_A645 = chr(67365)
LINEAR_A_SIGN_A646 = chr(67366)
LINEAR_A_SIGN_A648 = chr(67367)
LINEAR_A_SIGN_A649 = chr(67368)
LINEAR_A_SIGN_A651 = chr(67369)
LINEAR_A_SIGN_A652 = chr(67370)
LINEAR_A_SIGN_A653 = chr(67371)
LINEAR_A_SIGN_A654 = chr(67372)
LINEAR_A_SIGN_A655 = chr(67373)
LINEAR_A_SIGN_A656 = chr(67374)
LINEAR_A_SIGN_A657 = chr(67375)
LINEAR_A_SIGN_A658 = chr(67376)
LINEAR_A_SIGN_A659 = chr(67377)
LINEAR_A_SIGN_A660 = chr(67378)
LINEAR_A_SIGN_A661 = chr(67379)
LINEAR_A_SIGN_A662 = chr(67380)
LINEAR_A_SIGN_A663 = chr(67381)
LINEAR_A_SIGN_A664 = chr(67382)
LINEAR_A_SIGN_A701_A = chr(67392)
LINEAR_A_SIGN_A702_B = chr(67393)
LINEAR_A_SIGN_A703_D = chr(67394)
LINEAR_A_SIGN_A704_E = chr(67395)
LINEAR_A_SIGN_A705_F = chr(67396)
LINEAR_A_SIGN_A706_H = chr(67397)
LINEAR_A_SIGN_A707_J = chr(67398)
LINEAR_A_SIGN_A708_K = chr(67399)
LINEAR_A_SIGN_A709_L = chr(67400)
LINEAR_A_SIGN_A709_2_L2 = chr(67401)
LINEAR_A_SIGN_A709_3_L3 = chr(67402)
LINEAR_A_SIGN_A709_4_L4 = chr(67403)
LINEAR_A_SIGN_A709_6_L6 = chr(67404)
LINEAR_A_SIGN_A710_W = chr(67405)
LINEAR_A_SIGN_A711_X = chr(67406)
LINEAR_A_SIGN_A712_Y = chr(67407)
LINEAR_A_SIGN_A713_OMEGA = chr(67408)
LINEAR_A_SIGN_A714_ABB = chr(67409)
LINEAR_A_SIGN_A715_BB = chr(67410)
LINEAR_A_SIGN_A717_DD = chr(67411)
LINEAR_A_SIGN_A726_EYYY = chr(67412)
LINEAR_A_SIGN_A732_JE = chr(67413)
LINEAR_A_SIGN_A800 = chr(67424)
LINEAR_A_SIGN_A801 = chr(67425)
LINEAR_A_SIGN_A802 = chr(67426)
LINEAR_A_SIGN_A803 = chr(67427)
LINEAR_A_SIGN_A804 = chr(67428)
LINEAR_A_SIGN_A805 = chr(67429)
LINEAR_A_SIGN_A806 = chr(67430)
LINEAR_A_SIGN_A807 = chr(67431)
MODIFIER_LETTER_SMALL_CAPITAL_AA = chr(67456)
MODIFIER_LETTER_SUPERSCRIPT_TRIANGULAR_COLON = chr(67457)
MODIFIER_LETTER_SUPERSCRIPT_HALF_TRIANGULAR_COLON = chr(67458)
MODIFIER_LETTER_SMALL_AE = chr(67459)
MODIFIER_LETTER_SMALL_CAPITAL_B = chr(67460)
MODIFIER_LETTER_SMALL_B_WITH_HOOK = chr(67461)
MODIFIER_LETTER_SMALL_DZ_DIGRAPH = chr(67463)
MODIFIER_LETTER_SMALL_DZ_DIGRAPH_WITH_RETROFLEX_HOOK = chr(67464)
MODIFIER_LETTER_SMALL_DZ_DIGRAPH_WITH_CURL = chr(67465)
MODIFIER_LETTER_SMALL_DEZH_DIGRAPH = chr(67466)
MODIFIER_LETTER_SMALL_D_WITH_TAIL = chr(67467)
MODIFIER_LETTER_SMALL_D_WITH_HOOK = chr(67468)
MODIFIER_LETTER_SMALL_D_WITH_HOOK_AND_TAIL = chr(67469)
MODIFIER_LETTER_SMALL_REVERSED_E = chr(67470)
MODIFIER_LETTER_SMALL_CLOSED_REVERSED_OPEN_E = chr(67471)
MODIFIER_LETTER_SMALL_FENG_DIGRAPH = chr(67472)
MODIFIER_LETTER_SMALL_RAMS_HORN = chr(67473)
MODIFIER_LETTER_SMALL_CAPITAL_G = chr(67474)
MODIFIER_LETTER_SMALL_G_WITH_HOOK = chr(67475)
MODIFIER_LETTER_SMALL_CAPITAL_G_WITH_HOOK = chr(67476)
MODIFIER_LETTER_SMALL_H_WITH_STROKE = chr(67477)
MODIFIER_LETTER_SMALL_CAPITAL_H = chr(67478)
MODIFIER_LETTER_SMALL_HENG_WITH_HOOK = chr(67479)
MODIFIER_LETTER_SMALL_DOTLESS_J_WITH_STROKE_AND_HOOK = chr(67480)
MODIFIER_LETTER_SMALL_LS_DIGRAPH = chr(67481)
MODIFIER_LETTER_SMALL_LZ_DIGRAPH = chr(67482)
MODIFIER_LETTER_SMALL_L_WITH_BELT = chr(67483)
MODIFIER_LETTER_SMALL_CAPITAL_L_WITH_BELT = chr(67484)
MODIFIER_LETTER_SMALL_L_WITH_RETROFLEX_HOOK_AND_BELT = chr(67485)
MODIFIER_LETTER_SMALL_LEZH = chr(67486)
MODIFIER_LETTER_SMALL_LEZH_WITH_RETROFLEX_HOOK = chr(67487)
MODIFIER_LETTER_SMALL_TURNED_Y = chr(67488)
MODIFIER_LETTER_SMALL_TURNED_Y_WITH_BELT = chr(67489)
MODIFIER_LETTER_SMALL_O_WITH_STROKE = chr(67490)
MODIFIER_LETTER_SMALL_CAPITAL_OE = chr(67491)
MODIFIER_LETTER_SMALL_CLOSED_OMEGA = chr(67492)
MODIFIER_LETTER_SMALL_Q = chr(67493)
MODIFIER_LETTER_SMALL_TURNED_R_WITH_LONG_LEG = chr(67494)
MODIFIER_LETTER_SMALL_TURNED_R_WITH_LONG_LEG_AND_RETROFLEX_HOOK = chr(67495)
MODIFIER_LETTER_SMALL_R_WITH_TAIL = chr(67496)
MODIFIER_LETTER_SMALL_R_WITH_FISHHOOK = chr(67497)
MODIFIER_LETTER_SMALL_CAPITAL_R = chr(67498)
MODIFIER_LETTER_SMALL_TC_DIGRAPH_WITH_CURL = chr(67499)
MODIFIER_LETTER_SMALL_TS_DIGRAPH = chr(67500)
MODIFIER_LETTER_SMALL_TS_DIGRAPH_WITH_RETROFLEX_HOOK = chr(67501)
MODIFIER_LETTER_SMALL_TESH_DIGRAPH = chr(67502)
MODIFIER_LETTER_SMALL_T_WITH_RETROFLEX_HOOK = chr(67503)
MODIFIER_LETTER_SMALL_V_WITH_RIGHT_HOOK = chr(67504)
MODIFIER_LETTER_SMALL_CAPITAL_Y = chr(67506)
MODIFIER_LETTER_GLOTTAL_STOP_WITH_STROKE = chr(67507)
MODIFIER_LETTER_REVERSED_GLOTTAL_STOP_WITH_STROKE = chr(67508)
MODIFIER_LETTER_BILABIAL_CLICK = chr(67509)
MODIFIER_LETTER_DENTAL_CLICK = chr(67510)
MODIFIER_LETTER_LATERAL_CLICK = chr(67511)
MODIFIER_LETTER_ALVEOLAR_CLICK = chr(67512)
MODIFIER_LETTER_RETROFLEX_CLICK_WITH_RETROFLEX_HOOK = chr(67513)
MODIFIER_LETTER_SMALL_S_WITH_CURL = chr(67514)
CYPRIOT_SYLLABLE_A = chr(67584)
CYPRIOT_SYLLABLE_E = chr(67585)
CYPRIOT_SYLLABLE_I = chr(67586)
CYPRIOT_SYLLABLE_O = chr(67587)
CYPRIOT_SYLLABLE_U = chr(67588)
CYPRIOT_SYLLABLE_JA = chr(67589)
CYPRIOT_SYLLABLE_JO = chr(67592)
CYPRIOT_SYLLABLE_KA = chr(67594)
CYPRIOT_SYLLABLE_KE = chr(67595)
CYPRIOT_SYLLABLE_KI = chr(67596)
CYPRIOT_SYLLABLE_KO = chr(67597)
CYPRIOT_SYLLABLE_KU = chr(67598)
CYPRIOT_SYLLABLE_LA = chr(67599)
CYPRIOT_SYLLABLE_LE = chr(67600)
CYPRIOT_SYLLABLE_LI = chr(67601)
CYPRIOT_SYLLABLE_LO = chr(67602)
CYPRIOT_SYLLABLE_LU = chr(67603)
CYPRIOT_SYLLABLE_MA = chr(67604)
CYPRIOT_SYLLABLE_ME = chr(67605)
CYPRIOT_SYLLABLE_MI = chr(67606)
CYPRIOT_SYLLABLE_MO = chr(67607)
CYPRIOT_SYLLABLE_MU = chr(67608)
CYPRIOT_SYLLABLE_NA = chr(67609)
CYPRIOT_SYLLABLE_NE = chr(67610)
CYPRIOT_SYLLABLE_NI = chr(67611)
CYPRIOT_SYLLABLE_NO = chr(67612)
CYPRIOT_SYLLABLE_NU = chr(67613)
CYPRIOT_SYLLABLE_PA = chr(67614)
CYPRIOT_SYLLABLE_PE = chr(67615)
CYPRIOT_SYLLABLE_PI = chr(67616)
CYPRIOT_SYLLABLE_PO = chr(67617)
CYPRIOT_SYLLABLE_PU = chr(67618)
CYPRIOT_SYLLABLE_RA = chr(67619)
CYPRIOT_SYLLABLE_RE = chr(67620)
CYPRIOT_SYLLABLE_RI = chr(67621)
CYPRIOT_SYLLABLE_RO = chr(67622)
CYPRIOT_SYLLABLE_RU = chr(67623)
CYPRIOT_SYLLABLE_SA = chr(67624)
CYPRIOT_SYLLABLE_SE = chr(67625)
CYPRIOT_SYLLABLE_SI = chr(67626)
CYPRIOT_SYLLABLE_SO = chr(67627)
CYPRIOT_SYLLABLE_SU = chr(67628)
CYPRIOT_SYLLABLE_TA = chr(67629)
CYPRIOT_SYLLABLE_TE = chr(67630)
CYPRIOT_SYLLABLE_TI = chr(67631)
CYPRIOT_SYLLABLE_TO = chr(67632)
CYPRIOT_SYLLABLE_TU = chr(67633)
CYPRIOT_SYLLABLE_WA = chr(67634)
CYPRIOT_SYLLABLE_WE = chr(67635)
CYPRIOT_SYLLABLE_WI = chr(67636)
CYPRIOT_SYLLABLE_WO = chr(67637)
CYPRIOT_SYLLABLE_XA = chr(67639)
CYPRIOT_SYLLABLE_XE = chr(67640)
CYPRIOT_SYLLABLE_ZA = chr(67644)
CYPRIOT_SYLLABLE_ZO = chr(67647)
IMPERIAL_ARAMAIC_LETTER_ALEPH = chr(67648)
IMPERIAL_ARAMAIC_LETTER_BETH = chr(67649)
IMPERIAL_ARAMAIC_LETTER_GIMEL = chr(67650)
IMPERIAL_ARAMAIC_LETTER_DALETH = chr(67651)
IMPERIAL_ARAMAIC_LETTER_HE = chr(67652)
IMPERIAL_ARAMAIC_LETTER_WAW = chr(67653)
IMPERIAL_ARAMAIC_LETTER_ZAYIN = chr(67654)
IMPERIAL_ARAMAIC_LETTER_HETH = chr(67655)
IMPERIAL_ARAMAIC_LETTER_TETH = chr(67656)
IMPERIAL_ARAMAIC_LETTER_YODH = chr(67657)
IMPERIAL_ARAMAIC_LETTER_KAPH = chr(67658)
IMPERIAL_ARAMAIC_LETTER_LAMEDH = chr(67659)
IMPERIAL_ARAMAIC_LETTER_MEM = chr(67660)
IMPERIAL_ARAMAIC_LETTER_NUN = chr(67661)
IMPERIAL_ARAMAIC_LETTER_SAMEKH = chr(67662)
IMPERIAL_ARAMAIC_LETTER_AYIN = chr(67663)
IMPERIAL_ARAMAIC_LETTER_PE = chr(67664)
IMPERIAL_ARAMAIC_LETTER_SADHE = chr(67665)
IMPERIAL_ARAMAIC_LETTER_QOPH = chr(67666)
IMPERIAL_ARAMAIC_LETTER_RESH = chr(67667)
IMPERIAL_ARAMAIC_LETTER_SHIN = chr(67668)
IMPERIAL_ARAMAIC_LETTER_TAW = chr(67669)
IMPERIAL_ARAMAIC_SECTION_SIGN = chr(67671)
IMPERIAL_ARAMAIC_NUMBER_ONE = chr(67672)
IMPERIAL_ARAMAIC_NUMBER_TWO = chr(67673)
IMPERIAL_ARAMAIC_NUMBER_THREE = chr(67674)
IMPERIAL_ARAMAIC_NUMBER_TEN = chr(67675)
IMPERIAL_ARAMAIC_NUMBER_TWENTY = chr(67676)
IMPERIAL_ARAMAIC_NUMBER_ONE_HUNDRED = chr(67677)
IMPERIAL_ARAMAIC_NUMBER_ONE_THOUSAND = chr(67678)
IMPERIAL_ARAMAIC_NUMBER_TEN_THOUSAND = chr(67679)
PALMYRENE_LETTER_ALEPH = chr(67680)
PALMYRENE_LETTER_BETH = chr(67681)
PALMYRENE_LETTER_GIMEL = chr(67682)
PALMYRENE_LETTER_DALETH = chr(67683)
PALMYRENE_LETTER_HE = chr(67684)
PALMYRENE_LETTER_WAW = chr(67685)
PALMYRENE_LETTER_ZAYIN = chr(67686)
PALMYRENE_LETTER_HETH = chr(67687)
PALMYRENE_LETTER_TETH = chr(67688)
PALMYRENE_LETTER_YODH = chr(67689)
PALMYRENE_LETTER_KAPH = chr(67690)
PALMYRENE_LETTER_LAMEDH = chr(67691)
PALMYRENE_LETTER_MEM = chr(67692)
PALMYRENE_LETTER_FINAL_NUN = chr(67693)
PALMYRENE_LETTER_NUN = chr(67694)
PALMYRENE_LETTER_SAMEKH = chr(67695)
PALMYRENE_LETTER_AYIN = chr(67696)
PALMYRENE_LETTER_PE = chr(67697)
PALMYRENE_LETTER_SADHE = chr(67698)
PALMYRENE_LETTER_QOPH = chr(67699)
PALMYRENE_LETTER_RESH = chr(67700)
PALMYRENE_LETTER_SHIN = chr(67701)
PALMYRENE_LETTER_TAW = chr(67702)
PALMYRENE_LEFT_POINTING_FLEURON = chr(67703)
PALMYRENE_RIGHT_POINTING_FLEURON = chr(67704)
PALMYRENE_NUMBER_ONE = chr(67705)
PALMYRENE_NUMBER_TWO = chr(67706)
PALMYRENE_NUMBER_THREE = chr(67707)
PALMYRENE_NUMBER_FOUR = chr(67708)
PALMYRENE_NUMBER_FIVE = chr(67709)
PALMYRENE_NUMBER_TEN = chr(67710)
PALMYRENE_NUMBER_TWENTY = chr(67711)
NABATAEAN_LETTER_FINAL_ALEPH = chr(67712)
NABATAEAN_LETTER_ALEPH = chr(67713)
NABATAEAN_LETTER_FINAL_BETH = chr(67714)
NABATAEAN_LETTER_BETH = chr(67715)
NABATAEAN_LETTER_GIMEL = chr(67716)
NABATAEAN_LETTER_DALETH = chr(67717)
NABATAEAN_LETTER_FINAL_HE = chr(67718)
NABATAEAN_LETTER_HE = chr(67719)
NABATAEAN_LETTER_WAW = chr(67720)
NABATAEAN_LETTER_ZAYIN = chr(67721)
NABATAEAN_LETTER_HETH = chr(67722)
NABATAEAN_LETTER_TETH = chr(67723)
NABATAEAN_LETTER_FINAL_YODH = chr(67724)
NABATAEAN_LETTER_YODH = chr(67725)
NABATAEAN_LETTER_FINAL_KAPH = chr(67726)
NABATAEAN_LETTER_KAPH = chr(67727)
NABATAEAN_LETTER_FINAL_LAMEDH = chr(67728)
NABATAEAN_LETTER_LAMEDH = chr(67729)
NABATAEAN_LETTER_FINAL_MEM = chr(67730)
NABATAEAN_LETTER_MEM = chr(67731)
NABATAEAN_LETTER_FINAL_NUN = chr(67732)
NABATAEAN_LETTER_NUN = chr(67733)
NABATAEAN_LETTER_SAMEKH = chr(67734)
NABATAEAN_LETTER_AYIN = chr(67735)
NABATAEAN_LETTER_PE = chr(67736)
NABATAEAN_LETTER_SADHE = chr(67737)
NABATAEAN_LETTER_QOPH = chr(67738)
NABATAEAN_LETTER_RESH = chr(67739)
NABATAEAN_LETTER_FINAL_SHIN = chr(67740)
NABATAEAN_LETTER_SHIN = chr(67741)
NABATAEAN_LETTER_TAW = chr(67742)
NABATAEAN_NUMBER_ONE = chr(67751)
NABATAEAN_NUMBER_TWO = chr(67752)
NABATAEAN_NUMBER_THREE = chr(67753)
NABATAEAN_NUMBER_FOUR = chr(67754)
NABATAEAN_CRUCIFORM_NUMBER_FOUR = chr(67755)
NABATAEAN_NUMBER_FIVE = chr(67756)
NABATAEAN_NUMBER_TEN = chr(67757)
NABATAEAN_NUMBER_TWENTY = chr(67758)
NABATAEAN_NUMBER_ONE_HUNDRED = chr(67759)
HATRAN_LETTER_ALEPH = chr(67808)
HATRAN_LETTER_BETH = chr(67809)
HATRAN_LETTER_GIMEL = chr(67810)
HATRAN_LETTER_DALETH_RESH = chr(67811)
HATRAN_LETTER_HE = chr(67812)
HATRAN_LETTER_WAW = chr(67813)
HATRAN_LETTER_ZAYN = chr(67814)
HATRAN_LETTER_HETH = chr(67815)
HATRAN_LETTER_TETH = chr(67816)
HATRAN_LETTER_YODH = chr(67817)
HATRAN_LETTER_KAPH = chr(67818)
HATRAN_LETTER_LAMEDH = chr(67819)
HATRAN_LETTER_MEM = chr(67820)
HATRAN_LETTER_NUN = chr(67821)
HATRAN_LETTER_SAMEKH = chr(67822)
HATRAN_LETTER_AYN = chr(67823)
HATRAN_LETTER_PE = chr(67824)
HATRAN_LETTER_SADHE = chr(67825)
HATRAN_LETTER_QOPH = chr(67826)
HATRAN_LETTER_SHIN = chr(67828)
HATRAN_LETTER_TAW = chr(67829)
HATRAN_NUMBER_ONE = chr(67835)
HATRAN_NUMBER_FIVE = chr(67836)
HATRAN_NUMBER_TEN = chr(67837)
HATRAN_NUMBER_TWENTY = chr(67838)
HATRAN_NUMBER_ONE_HUNDRED = chr(67839)
PHOENICIAN_LETTER_ALF = chr(67840)
PHOENICIAN_LETTER_BET = chr(67841)
PHOENICIAN_LETTER_GAML = chr(67842)
PHOENICIAN_LETTER_DELT = chr(67843)
PHOENICIAN_LETTER_HE = chr(67844)
PHOENICIAN_LETTER_WAU = chr(67845)
PHOENICIAN_LETTER_ZAI = chr(67846)
PHOENICIAN_LETTER_HET = chr(67847)
PHOENICIAN_LETTER_TET = chr(67848)
PHOENICIAN_LETTER_YOD = chr(67849)
PHOENICIAN_LETTER_KAF = chr(67850)
PHOENICIAN_LETTER_LAMD = chr(67851)
PHOENICIAN_LETTER_MEM = chr(67852)
PHOENICIAN_LETTER_NUN = chr(67853)
PHOENICIAN_LETTER_SEMK = chr(67854)
PHOENICIAN_LETTER_AIN = chr(67855)
PHOENICIAN_LETTER_PE = chr(67856)
PHOENICIAN_LETTER_SADE = chr(67857)
PHOENICIAN_LETTER_QOF = chr(67858)
PHOENICIAN_LETTER_ROSH = chr(67859)
PHOENICIAN_LETTER_SHIN = chr(67860)
PHOENICIAN_LETTER_TAU = chr(67861)
PHOENICIAN_NUMBER_ONE = chr(67862)
PHOENICIAN_NUMBER_TEN = chr(67863)
PHOENICIAN_NUMBER_TWENTY = chr(67864)
PHOENICIAN_NUMBER_ONE_HUNDRED = chr(67865)
PHOENICIAN_NUMBER_TWO = chr(67866)
PHOENICIAN_NUMBER_THREE = chr(67867)
PHOENICIAN_WORD_SEPARATOR = chr(67871)
LYDIAN_LETTER_A = chr(67872)
LYDIAN_LETTER_B = chr(67873)
LYDIAN_LETTER_G = chr(67874)
LYDIAN_LETTER_D = chr(67875)
LYDIAN_LETTER_E = chr(67876)
LYDIAN_LETTER_V = chr(67877)
LYDIAN_LETTER_I = chr(67878)
LYDIAN_LETTER_Y = chr(67879)
LYDIAN_LETTER_K = chr(67880)
LYDIAN_LETTER_L = chr(67881)
LYDIAN_LETTER_M = chr(67882)
LYDIAN_LETTER_N = chr(67883)
LYDIAN_LETTER_O = chr(67884)
LYDIAN_LETTER_R = chr(67885)
LYDIAN_LETTER_SS = chr(67886)
LYDIAN_LETTER_T = chr(67887)
LYDIAN_LETTER_U = chr(67888)
LYDIAN_LETTER_F = chr(67889)
LYDIAN_LETTER_Q = chr(67890)
LYDIAN_LETTER_S = chr(67891)
LYDIAN_LETTER_TT = chr(67892)
LYDIAN_LETTER_AN = chr(67893)
LYDIAN_LETTER_EN = chr(67894)
LYDIAN_LETTER_LY = chr(67895)
LYDIAN_LETTER_NN = chr(67896)
LYDIAN_LETTER_C = chr(67897)
LYDIAN_TRIANGULAR_MARK = chr(67903)
MEROITIC_HIEROGLYPHIC_LETTER_A = chr(67968)
MEROITIC_HIEROGLYPHIC_LETTER_E = chr(67969)
MEROITIC_HIEROGLYPHIC_LETTER_I = chr(67970)
MEROITIC_HIEROGLYPHIC_LETTER_O = chr(67971)
MEROITIC_HIEROGLYPHIC_LETTER_YA = chr(67972)
MEROITIC_HIEROGLYPHIC_LETTER_WA = chr(67973)
MEROITIC_HIEROGLYPHIC_LETTER_BA = chr(67974)
MEROITIC_HIEROGLYPHIC_LETTER_BA_2 = chr(67975)
MEROITIC_HIEROGLYPHIC_LETTER_PA = chr(67976)
MEROITIC_HIEROGLYPHIC_LETTER_MA = chr(67977)
MEROITIC_HIEROGLYPHIC_LETTER_NA = chr(67978)
MEROITIC_HIEROGLYPHIC_LETTER_NA_2 = chr(67979)
MEROITIC_HIEROGLYPHIC_LETTER_NE = chr(67980)
MEROITIC_HIEROGLYPHIC_LETTER_NE_2 = chr(67981)
MEROITIC_HIEROGLYPHIC_LETTER_RA = chr(67982)
MEROITIC_HIEROGLYPHIC_LETTER_RA_2 = chr(67983)
MEROITIC_HIEROGLYPHIC_LETTER_LA = chr(67984)
MEROITIC_HIEROGLYPHIC_LETTER_KHA = chr(67985)
MEROITIC_HIEROGLYPHIC_LETTER_HHA = chr(67986)
MEROITIC_HIEROGLYPHIC_LETTER_SA = chr(67987)
MEROITIC_HIEROGLYPHIC_LETTER_SA_2 = chr(67988)
MEROITIC_HIEROGLYPHIC_LETTER_SE = chr(67989)
MEROITIC_HIEROGLYPHIC_LETTER_KA = chr(67990)
MEROITIC_HIEROGLYPHIC_LETTER_QA = chr(67991)
MEROITIC_HIEROGLYPHIC_LETTER_TA = chr(67992)
MEROITIC_HIEROGLYPHIC_LETTER_TA_2 = chr(67993)
MEROITIC_HIEROGLYPHIC_LETTER_TE = chr(67994)
MEROITIC_HIEROGLYPHIC_LETTER_TE_2 = chr(67995)
MEROITIC_HIEROGLYPHIC_LETTER_TO = chr(67996)
MEROITIC_HIEROGLYPHIC_LETTER_DA = chr(67997)
MEROITIC_HIEROGLYPHIC_SYMBOL_VIDJ = chr(67998)
MEROITIC_HIEROGLYPHIC_SYMBOL_VIDJ_2 = chr(67999)
MEROITIC_CURSIVE_LETTER_A = chr(68000)
MEROITIC_CURSIVE_LETTER_E = chr(68001)
MEROITIC_CURSIVE_LETTER_I = chr(68002)
MEROITIC_CURSIVE_LETTER_O = chr(68003)
MEROITIC_CURSIVE_LETTER_YA = chr(68004)
MEROITIC_CURSIVE_LETTER_WA = chr(68005)
MEROITIC_CURSIVE_LETTER_BA = chr(68006)
MEROITIC_CURSIVE_LETTER_PA = chr(68007)
MEROITIC_CURSIVE_LETTER_MA = chr(68008)
MEROITIC_CURSIVE_LETTER_NA = chr(68009)
MEROITIC_CURSIVE_LETTER_NE = chr(68010)
MEROITIC_CURSIVE_LETTER_RA = chr(68011)
MEROITIC_CURSIVE_LETTER_LA = chr(68012)
MEROITIC_CURSIVE_LETTER_KHA = chr(68013)
MEROITIC_CURSIVE_LETTER_HHA = chr(68014)
MEROITIC_CURSIVE_LETTER_SA = chr(68015)
MEROITIC_CURSIVE_LETTER_ARCHAIC_SA = chr(68016)
MEROITIC_CURSIVE_LETTER_SE = chr(68017)
MEROITIC_CURSIVE_LETTER_KA = chr(68018)
MEROITIC_CURSIVE_LETTER_QA = chr(68019)
MEROITIC_CURSIVE_LETTER_TA = chr(68020)
MEROITIC_CURSIVE_LETTER_TE = chr(68021)
MEROITIC_CURSIVE_LETTER_TO = chr(68022)
MEROITIC_CURSIVE_LETTER_DA = chr(68023)
MEROITIC_CURSIVE_FRACTION_ELEVEN_TWELFTHS = chr(68028)
MEROITIC_CURSIVE_FRACTION_ONE_HALF = chr(68029)
MEROITIC_CURSIVE_LOGOGRAM_RMT = chr(68030)
MEROITIC_CURSIVE_LOGOGRAM_IMN = chr(68031)
MEROITIC_CURSIVE_NUMBER_ONE = chr(68032)
MEROITIC_CURSIVE_NUMBER_TWO = chr(68033)
MEROITIC_CURSIVE_NUMBER_THREE = chr(68034)
MEROITIC_CURSIVE_NUMBER_FOUR = chr(68035)
MEROITIC_CURSIVE_NUMBER_FIVE = chr(68036)
MEROITIC_CURSIVE_NUMBER_SIX = chr(68037)
MEROITIC_CURSIVE_NUMBER_SEVEN = chr(68038)
MEROITIC_CURSIVE_NUMBER_EIGHT = chr(68039)
MEROITIC_CURSIVE_NUMBER_NINE = chr(68040)
MEROITIC_CURSIVE_NUMBER_TEN = chr(68041)
MEROITIC_CURSIVE_NUMBER_TWENTY = chr(68042)
MEROITIC_CURSIVE_NUMBER_THIRTY = chr(68043)
MEROITIC_CURSIVE_NUMBER_FORTY = chr(68044)
MEROITIC_CURSIVE_NUMBER_FIFTY = chr(68045)
MEROITIC_CURSIVE_NUMBER_SIXTY = chr(68046)
MEROITIC_CURSIVE_NUMBER_SEVENTY = chr(68047)
MEROITIC_CURSIVE_NUMBER_ONE_HUNDRED = chr(68050)
MEROITIC_CURSIVE_NUMBER_TWO_HUNDRED = chr(68051)
MEROITIC_CURSIVE_NUMBER_THREE_HUNDRED = chr(68052)
MEROITIC_CURSIVE_NUMBER_FOUR_HUNDRED = chr(68053)
MEROITIC_CURSIVE_NUMBER_FIVE_HUNDRED = chr(68054)
MEROITIC_CURSIVE_NUMBER_SIX_HUNDRED = chr(68055)
MEROITIC_CURSIVE_NUMBER_SEVEN_HUNDRED = chr(68056)
MEROITIC_CURSIVE_NUMBER_EIGHT_HUNDRED = chr(68057)
MEROITIC_CURSIVE_NUMBER_NINE_HUNDRED = chr(68058)
MEROITIC_CURSIVE_NUMBER_ONE_THOUSAND = chr(68059)
MEROITIC_CURSIVE_NUMBER_TWO_THOUSAND = chr(68060)
MEROITIC_CURSIVE_NUMBER_THREE_THOUSAND = chr(68061)
MEROITIC_CURSIVE_NUMBER_FOUR_THOUSAND = chr(68062)
MEROITIC_CURSIVE_NUMBER_FIVE_THOUSAND = chr(68063)
MEROITIC_CURSIVE_NUMBER_SIX_THOUSAND = chr(68064)
MEROITIC_CURSIVE_NUMBER_SEVEN_THOUSAND = chr(68065)
MEROITIC_CURSIVE_NUMBER_EIGHT_THOUSAND = chr(68066)
MEROITIC_CURSIVE_NUMBER_NINE_THOUSAND = chr(68067)
MEROITIC_CURSIVE_NUMBER_TEN_THOUSAND = chr(68068)
MEROITIC_CURSIVE_NUMBER_TWENTY_THOUSAND = chr(68069)
MEROITIC_CURSIVE_NUMBER_THIRTY_THOUSAND = chr(68070)
MEROITIC_CURSIVE_NUMBER_FORTY_THOUSAND = chr(68071)
MEROITIC_CURSIVE_NUMBER_FIFTY_THOUSAND = chr(68072)
MEROITIC_CURSIVE_NUMBER_SIXTY_THOUSAND = chr(68073)
MEROITIC_CURSIVE_NUMBER_SEVENTY_THOUSAND = chr(68074)
MEROITIC_CURSIVE_NUMBER_EIGHTY_THOUSAND = chr(68075)
MEROITIC_CURSIVE_NUMBER_NINETY_THOUSAND = chr(68076)
MEROITIC_CURSIVE_NUMBER_ONE_HUNDRED_THOUSAND = chr(68077)
MEROITIC_CURSIVE_NUMBER_TWO_HUNDRED_THOUSAND = chr(68078)
MEROITIC_CURSIVE_NUMBER_THREE_HUNDRED_THOUSAND = chr(68079)
MEROITIC_CURSIVE_NUMBER_FOUR_HUNDRED_THOUSAND = chr(68080)
MEROITIC_CURSIVE_NUMBER_FIVE_HUNDRED_THOUSAND = chr(68081)
MEROITIC_CURSIVE_NUMBER_SIX_HUNDRED_THOUSAND = chr(68082)
MEROITIC_CURSIVE_NUMBER_SEVEN_HUNDRED_THOUSAND = chr(68083)
MEROITIC_CURSIVE_NUMBER_EIGHT_HUNDRED_THOUSAND = chr(68084)
MEROITIC_CURSIVE_NUMBER_NINE_HUNDRED_THOUSAND = chr(68085)
MEROITIC_CURSIVE_FRACTION_ONE_TWELFTH = chr(68086)
MEROITIC_CURSIVE_FRACTION_TWO_TWELFTHS = chr(68087)
MEROITIC_CURSIVE_FRACTION_THREE_TWELFTHS = chr(68088)
MEROITIC_CURSIVE_FRACTION_FOUR_TWELFTHS = chr(68089)
MEROITIC_CURSIVE_FRACTION_FIVE_TWELFTHS = chr(68090)
MEROITIC_CURSIVE_FRACTION_SIX_TWELFTHS = chr(68091)
MEROITIC_CURSIVE_FRACTION_SEVEN_TWELFTHS = chr(68092)
MEROITIC_CURSIVE_FRACTION_EIGHT_TWELFTHS = chr(68093)
MEROITIC_CURSIVE_FRACTION_NINE_TWELFTHS = chr(68094)
MEROITIC_CURSIVE_FRACTION_TEN_TWELFTHS = chr(68095)
KHAROSHTHI_LETTER_A = chr(68096)
KHAROSHTHI_VOWEL_SIGN_I = chr(68097)
KHAROSHTHI_VOWEL_SIGN_U = chr(68098)
KHAROSHTHI_VOWEL_SIGN_VOCALIC_R = chr(68099)
KHAROSHTHI_VOWEL_SIGN_E = chr(68101)
KHAROSHTHI_VOWEL_SIGN_O = chr(68102)
KHAROSHTHI_VOWEL_LENGTH_MARK = chr(68108)
KHAROSHTHI_SIGN_DOUBLE_RING_BELOW = chr(68109)
KHAROSHTHI_SIGN_ANUSVARA = chr(68110)
KHAROSHTHI_SIGN_VISARGA = chr(68111)
KHAROSHTHI_LETTER_KA = chr(68112)
KHAROSHTHI_LETTER_KHA = chr(68113)
KHAROSHTHI_LETTER_GA = chr(68114)
KHAROSHTHI_LETTER_GHA = chr(68115)
KHAROSHTHI_LETTER_CA = chr(68117)
KHAROSHTHI_LETTER_CHA = chr(68118)
KHAROSHTHI_LETTER_JA = chr(68119)
KHAROSHTHI_LETTER_NYA = chr(68121)
KHAROSHTHI_LETTER_TTA = chr(68122)
KHAROSHTHI_LETTER_TTHA = chr(68123)
KHAROSHTHI_LETTER_DDA = chr(68124)
KHAROSHTHI_LETTER_DDHA = chr(68125)
KHAROSHTHI_LETTER_NNA = chr(68126)
KHAROSHTHI_LETTER_TA = chr(68127)
KHAROSHTHI_LETTER_THA = chr(68128)
KHAROSHTHI_LETTER_DA = chr(68129)
KHAROSHTHI_LETTER_DHA = chr(68130)
KHAROSHTHI_LETTER_NA = chr(68131)
KHAROSHTHI_LETTER_PA = chr(68132)
KHAROSHTHI_LETTER_PHA = chr(68133)
KHAROSHTHI_LETTER_BA = chr(68134)
KHAROSHTHI_LETTER_BHA = chr(68135)
KHAROSHTHI_LETTER_MA = chr(68136)
KHAROSHTHI_LETTER_YA = chr(68137)
KHAROSHTHI_LETTER_RA = chr(68138)
KHAROSHTHI_LETTER_LA = chr(68139)
KHAROSHTHI_LETTER_VA = chr(68140)
KHAROSHTHI_LETTER_SHA = chr(68141)
KHAROSHTHI_LETTER_SSA = chr(68142)
KHAROSHTHI_LETTER_SA = chr(68143)
KHAROSHTHI_LETTER_ZA = chr(68144)
KHAROSHTHI_LETTER_HA = chr(68145)
KHAROSHTHI_LETTER_KKA = chr(68146)
KHAROSHTHI_LETTER_TTTHA = chr(68147)
KHAROSHTHI_LETTER_TTTA = chr(68148)
KHAROSHTHI_LETTER_VHA = chr(68149)
KHAROSHTHI_SIGN_BAR_ABOVE = chr(68152)
KHAROSHTHI_SIGN_CAUDA = chr(68153)
KHAROSHTHI_SIGN_DOT_BELOW = chr(68154)
KHAROSHTHI_VIRAMA = chr(68159)
KHAROSHTHI_DIGIT_ONE = chr(68160)
KHAROSHTHI_DIGIT_TWO = chr(68161)
KHAROSHTHI_DIGIT_THREE = chr(68162)
KHAROSHTHI_DIGIT_FOUR = chr(68163)
KHAROSHTHI_NUMBER_TEN = chr(68164)
KHAROSHTHI_NUMBER_TWENTY = chr(68165)
KHAROSHTHI_NUMBER_ONE_HUNDRED = chr(68166)
KHAROSHTHI_NUMBER_ONE_THOUSAND = chr(68167)
KHAROSHTHI_FRACTION_ONE_HALF = chr(68168)
KHAROSHTHI_PUNCTUATION_DOT = chr(68176)
KHAROSHTHI_PUNCTUATION_SMALL_CIRCLE = chr(68177)
KHAROSHTHI_PUNCTUATION_CIRCLE = chr(68178)
KHAROSHTHI_PUNCTUATION_CRESCENT_BAR = chr(68179)
KHAROSHTHI_PUNCTUATION_MANGALAM = chr(68180)
KHAROSHTHI_PUNCTUATION_LOTUS = chr(68181)
KHAROSHTHI_PUNCTUATION_DANDA = chr(68182)
KHAROSHTHI_PUNCTUATION_DOUBLE_DANDA = chr(68183)
KHAROSHTHI_PUNCTUATION_LINES = chr(68184)
OLD_SOUTH_ARABIAN_LETTER_HE = chr(68192)
OLD_SOUTH_ARABIAN_LETTER_LAMEDH = chr(68193)
OLD_SOUTH_ARABIAN_LETTER_HETH = chr(68194)
OLD_SOUTH_ARABIAN_LETTER_MEM = chr(68195)
OLD_SOUTH_ARABIAN_LETTER_QOPH = chr(68196)
OLD_SOUTH_ARABIAN_LETTER_WAW = chr(68197)
OLD_SOUTH_ARABIAN_LETTER_SHIN = chr(68198)
OLD_SOUTH_ARABIAN_LETTER_RESH = chr(68199)
OLD_SOUTH_ARABIAN_LETTER_BETH = chr(68200)
OLD_SOUTH_ARABIAN_LETTER_TAW = chr(68201)
OLD_SOUTH_ARABIAN_LETTER_SAT = chr(68202)
OLD_SOUTH_ARABIAN_LETTER_KAPH = chr(68203)
OLD_SOUTH_ARABIAN_LETTER_NUN = chr(68204)
OLD_SOUTH_ARABIAN_LETTER_KHETH = chr(68205)
OLD_SOUTH_ARABIAN_LETTER_SADHE = chr(68206)
OLD_SOUTH_ARABIAN_LETTER_SAMEKH = chr(68207)
OLD_SOUTH_ARABIAN_LETTER_FE = chr(68208)
OLD_SOUTH_ARABIAN_LETTER_ALEF = chr(68209)
OLD_SOUTH_ARABIAN_LETTER_AYN = chr(68210)
OLD_SOUTH_ARABIAN_LETTER_DHADHE = chr(68211)
OLD_SOUTH_ARABIAN_LETTER_GIMEL = chr(68212)
OLD_SOUTH_ARABIAN_LETTER_DALETH = chr(68213)
OLD_SOUTH_ARABIAN_LETTER_GHAYN = chr(68214)
OLD_SOUTH_ARABIAN_LETTER_TETH = chr(68215)
OLD_SOUTH_ARABIAN_LETTER_ZAYN = chr(68216)
OLD_SOUTH_ARABIAN_LETTER_DHALETH = chr(68217)
OLD_SOUTH_ARABIAN_LETTER_YODH = chr(68218)
OLD_SOUTH_ARABIAN_LETTER_THAW = chr(68219)
OLD_SOUTH_ARABIAN_LETTER_THETH = chr(68220)
OLD_SOUTH_ARABIAN_NUMBER_ONE = chr(68221)
OLD_SOUTH_ARABIAN_NUMBER_FIFTY = chr(68222)
OLD_SOUTH_ARABIAN_NUMERIC_INDICATOR = chr(68223)
OLD_NORTH_ARABIAN_LETTER_HEH = chr(68224)
OLD_NORTH_ARABIAN_LETTER_LAM = chr(68225)
OLD_NORTH_ARABIAN_LETTER_HAH = chr(68226)
OLD_NORTH_ARABIAN_LETTER_MEEM = chr(68227)
OLD_NORTH_ARABIAN_LETTER_QAF = chr(68228)
OLD_NORTH_ARABIAN_LETTER_WAW = chr(68229)
OLD_NORTH_ARABIAN_LETTER_ES_2 = chr(68230)
OLD_NORTH_ARABIAN_LETTER_REH = chr(68231)
OLD_NORTH_ARABIAN_LETTER_BEH = chr(68232)
OLD_NORTH_ARABIAN_LETTER_TEH = chr(68233)
OLD_NORTH_ARABIAN_LETTER_ES_1 = chr(68234)
OLD_NORTH_ARABIAN_LETTER_KAF = chr(68235)
OLD_NORTH_ARABIAN_LETTER_NOON = chr(68236)
OLD_NORTH_ARABIAN_LETTER_KHAH = chr(68237)
OLD_NORTH_ARABIAN_LETTER_SAD = chr(68238)
OLD_NORTH_ARABIAN_LETTER_ES_3 = chr(68239)
OLD_NORTH_ARABIAN_LETTER_FEH = chr(68240)
OLD_NORTH_ARABIAN_LETTER_ALEF = chr(68241)
OLD_NORTH_ARABIAN_LETTER_AIN = chr(68242)
OLD_NORTH_ARABIAN_LETTER_DAD = chr(68243)
OLD_NORTH_ARABIAN_LETTER_GEEM = chr(68244)
OLD_NORTH_ARABIAN_LETTER_DAL = chr(68245)
OLD_NORTH_ARABIAN_LETTER_GHAIN = chr(68246)
OLD_NORTH_ARABIAN_LETTER_TAH = chr(68247)
OLD_NORTH_ARABIAN_LETTER_ZAIN = chr(68248)
OLD_NORTH_ARABIAN_LETTER_THAL = chr(68249)
OLD_NORTH_ARABIAN_LETTER_YEH = chr(68250)
OLD_NORTH_ARABIAN_LETTER_THEH = chr(68251)
OLD_NORTH_ARABIAN_LETTER_ZAH = chr(68252)
OLD_NORTH_ARABIAN_NUMBER_ONE = chr(68253)
OLD_NORTH_ARABIAN_NUMBER_TEN = chr(68254)
OLD_NORTH_ARABIAN_NUMBER_TWENTY = chr(68255)
MANICHAEAN_LETTER_ALEPH = chr(68288)
MANICHAEAN_LETTER_BETH = chr(68289)
MANICHAEAN_LETTER_BHETH = chr(68290)
MANICHAEAN_LETTER_GIMEL = chr(68291)
MANICHAEAN_LETTER_GHIMEL = chr(68292)
MANICHAEAN_LETTER_DALETH = chr(68293)
MANICHAEAN_LETTER_HE = chr(68294)
MANICHAEAN_LETTER_WAW = chr(68295)
MANICHAEAN_SIGN_UD = chr(68296)
MANICHAEAN_LETTER_ZAYIN = chr(68297)
MANICHAEAN_LETTER_ZHAYIN = chr(68298)
MANICHAEAN_LETTER_JAYIN = chr(68299)
MANICHAEAN_LETTER_JHAYIN = chr(68300)
MANICHAEAN_LETTER_HETH = chr(68301)
MANICHAEAN_LETTER_TETH = chr(68302)
MANICHAEAN_LETTER_YODH = chr(68303)
MANICHAEAN_LETTER_KAPH = chr(68304)
MANICHAEAN_LETTER_XAPH = chr(68305)
MANICHAEAN_LETTER_KHAPH = chr(68306)
MANICHAEAN_LETTER_LAMEDH = chr(68307)
MANICHAEAN_LETTER_DHAMEDH = chr(68308)
MANICHAEAN_LETTER_THAMEDH = chr(68309)
MANICHAEAN_LETTER_MEM = chr(68310)
MANICHAEAN_LETTER_NUN = chr(68311)
MANICHAEAN_LETTER_SAMEKH = chr(68312)
MANICHAEAN_LETTER_AYIN = chr(68313)
MANICHAEAN_LETTER_AAYIN = chr(68314)
MANICHAEAN_LETTER_PE = chr(68315)
MANICHAEAN_LETTER_FE = chr(68316)
MANICHAEAN_LETTER_SADHE = chr(68317)
MANICHAEAN_LETTER_QOPH = chr(68318)
MANICHAEAN_LETTER_XOPH = chr(68319)
MANICHAEAN_LETTER_QHOPH = chr(68320)
MANICHAEAN_LETTER_RESH = chr(68321)
MANICHAEAN_LETTER_SHIN = chr(68322)
MANICHAEAN_LETTER_SSHIN = chr(68323)
MANICHAEAN_LETTER_TAW = chr(68324)
MANICHAEAN_ABBREVIATION_MARK_ABOVE = chr(68325)
MANICHAEAN_ABBREVIATION_MARK_BELOW = chr(68326)
MANICHAEAN_NUMBER_ONE = chr(68331)
MANICHAEAN_NUMBER_FIVE = chr(68332)
MANICHAEAN_NUMBER_TEN = chr(68333)
MANICHAEAN_NUMBER_TWENTY = chr(68334)
MANICHAEAN_NUMBER_ONE_HUNDRED = chr(68335)
MANICHAEAN_PUNCTUATION_STAR = chr(68336)
MANICHAEAN_PUNCTUATION_FLEURON = chr(68337)
MANICHAEAN_PUNCTUATION_DOUBLE_DOT_WITHIN_DOT = chr(68338)
MANICHAEAN_PUNCTUATION_DOT_WITHIN_DOT = chr(68339)
MANICHAEAN_PUNCTUATION_DOT = chr(68340)
MANICHAEAN_PUNCTUATION_TWO_DOTS = chr(68341)
MANICHAEAN_PUNCTUATION_LINE_FILLER = chr(68342)
AVESTAN_LETTER_A = chr(68352)
AVESTAN_LETTER_AA = chr(68353)
AVESTAN_LETTER_AO = chr(68354)
AVESTAN_LETTER_AAO = chr(68355)
AVESTAN_LETTER_AN = chr(68356)
AVESTAN_LETTER_AAN = chr(68357)
AVESTAN_LETTER_AE = chr(68358)
AVESTAN_LETTER_AEE = chr(68359)
AVESTAN_LETTER_E = chr(68360)
AVESTAN_LETTER_EE = chr(68361)
AVESTAN_LETTER_O = chr(68362)
AVESTAN_LETTER_OO = chr(68363)
AVESTAN_LETTER_I = chr(68364)
AVESTAN_LETTER_II = chr(68365)
AVESTAN_LETTER_U = chr(68366)
AVESTAN_LETTER_UU = chr(68367)
AVESTAN_LETTER_KE = chr(68368)
AVESTAN_LETTER_XE = chr(68369)
AVESTAN_LETTER_XYE = chr(68370)
AVESTAN_LETTER_XVE = chr(68371)
AVESTAN_LETTER_GE = chr(68372)
AVESTAN_LETTER_GGE = chr(68373)
AVESTAN_LETTER_GHE = chr(68374)
AVESTAN_LETTER_CE = chr(68375)
AVESTAN_LETTER_JE = chr(68376)
AVESTAN_LETTER_TE = chr(68377)
AVESTAN_LETTER_THE = chr(68378)
AVESTAN_LETTER_DE = chr(68379)
AVESTAN_LETTER_DHE = chr(68380)
AVESTAN_LETTER_TTE = chr(68381)
AVESTAN_LETTER_PE = chr(68382)
AVESTAN_LETTER_FE = chr(68383)
AVESTAN_LETTER_BE = chr(68384)
AVESTAN_LETTER_BHE = chr(68385)
AVESTAN_LETTER_NGE = chr(68386)
AVESTAN_LETTER_NGYE = chr(68387)
AVESTAN_LETTER_NGVE = chr(68388)
AVESTAN_LETTER_NE = chr(68389)
AVESTAN_LETTER_NYE = chr(68390)
AVESTAN_LETTER_NNE = chr(68391)
AVESTAN_LETTER_ME = chr(68392)
AVESTAN_LETTER_HME = chr(68393)
AVESTAN_LETTER_YYE = chr(68394)
AVESTAN_LETTER_YE = chr(68395)
AVESTAN_LETTER_VE = chr(68396)
AVESTAN_LETTER_RE = chr(68397)
AVESTAN_LETTER_LE = chr(68398)
AVESTAN_LETTER_SE = chr(68399)
AVESTAN_LETTER_ZE = chr(68400)
AVESTAN_LETTER_SHE = chr(68401)
AVESTAN_LETTER_ZHE = chr(68402)
AVESTAN_LETTER_SHYE = chr(68403)
AVESTAN_LETTER_SSHE = chr(68404)
AVESTAN_LETTER_HE = chr(68405)
AVESTAN_ABBREVIATION_MARK = chr(68409)
TINY_TWO_DOTS_OVER_ONE_DOT_PUNCTUATION = chr(68410)
SMALL_TWO_DOTS_OVER_ONE_DOT_PUNCTUATION = chr(68411)
LARGE_TWO_DOTS_OVER_ONE_DOT_PUNCTUATION = chr(68412)
LARGE_ONE_DOT_OVER_TWO_DOTS_PUNCTUATION = chr(68413)
LARGE_TWO_RINGS_OVER_ONE_RING_PUNCTUATION = chr(68414)
LARGE_ONE_RING_OVER_TWO_RINGS_PUNCTUATION = chr(68415)
INSCRIPTIONAL_PARTHIAN_LETTER_ALEPH = chr(68416)
INSCRIPTIONAL_PARTHIAN_LETTER_BETH = chr(68417)
INSCRIPTIONAL_PARTHIAN_LETTER_GIMEL = chr(68418)
INSCRIPTIONAL_PARTHIAN_LETTER_DALETH = chr(68419)
INSCRIPTIONAL_PARTHIAN_LETTER_HE = chr(68420)
INSCRIPTIONAL_PARTHIAN_LETTER_WAW = chr(68421)
INSCRIPTIONAL_PARTHIAN_LETTER_ZAYIN = chr(68422)
INSCRIPTIONAL_PARTHIAN_LETTER_HETH = chr(68423)
INSCRIPTIONAL_PARTHIAN_LETTER_TETH = chr(68424)
INSCRIPTIONAL_PARTHIAN_LETTER_YODH = chr(68425)
INSCRIPTIONAL_PARTHIAN_LETTER_KAPH = chr(68426)
INSCRIPTIONAL_PARTHIAN_LETTER_LAMEDH = chr(68427)
INSCRIPTIONAL_PARTHIAN_LETTER_MEM = chr(68428)
INSCRIPTIONAL_PARTHIAN_LETTER_NUN = chr(68429)
INSCRIPTIONAL_PARTHIAN_LETTER_SAMEKH = chr(68430)
INSCRIPTIONAL_PARTHIAN_LETTER_AYIN = chr(68431)
INSCRIPTIONAL_PARTHIAN_LETTER_PE = chr(68432)
INSCRIPTIONAL_PARTHIAN_LETTER_SADHE = chr(68433)
INSCRIPTIONAL_PARTHIAN_LETTER_QOPH = chr(68434)
INSCRIPTIONAL_PARTHIAN_LETTER_RESH = chr(68435)
INSCRIPTIONAL_PARTHIAN_LETTER_SHIN = chr(68436)
INSCRIPTIONAL_PARTHIAN_LETTER_TAW = chr(68437)
INSCRIPTIONAL_PARTHIAN_NUMBER_ONE = chr(68440)
INSCRIPTIONAL_PARTHIAN_NUMBER_TWO = chr(68441)
INSCRIPTIONAL_PARTHIAN_NUMBER_THREE = chr(68442)
INSCRIPTIONAL_PARTHIAN_NUMBER_FOUR = chr(68443)
INSCRIPTIONAL_PARTHIAN_NUMBER_TEN = chr(68444)
INSCRIPTIONAL_PARTHIAN_NUMBER_TWENTY = chr(68445)
INSCRIPTIONAL_PARTHIAN_NUMBER_ONE_HUNDRED = chr(68446)
INSCRIPTIONAL_PARTHIAN_NUMBER_ONE_THOUSAND = chr(68447)
INSCRIPTIONAL_PAHLAVI_LETTER_ALEPH = chr(68448)
INSCRIPTIONAL_PAHLAVI_LETTER_BETH = chr(68449)
INSCRIPTIONAL_PAHLAVI_LETTER_GIMEL = chr(68450)
INSCRIPTIONAL_PAHLAVI_LETTER_DALETH = chr(68451)
INSCRIPTIONAL_PAHLAVI_LETTER_HE = chr(68452)
INSCRIPTIONAL_PAHLAVI_LETTER_WAW_AYIN_RESH = chr(68453)
INSCRIPTIONAL_PAHLAVI_LETTER_ZAYIN = chr(68454)
INSCRIPTIONAL_PAHLAVI_LETTER_HETH = chr(68455)
INSCRIPTIONAL_PAHLAVI_LETTER_TETH = chr(68456)
INSCRIPTIONAL_PAHLAVI_LETTER_YODH = chr(68457)
INSCRIPTIONAL_PAHLAVI_LETTER_KAPH = chr(68458)
INSCRIPTIONAL_PAHLAVI_LETTER_LAMEDH = chr(68459)
INSCRIPTIONAL_PAHLAVI_LETTER_MEM_QOPH = chr(68460)
INSCRIPTIONAL_PAHLAVI_LETTER_NUN = chr(68461)
INSCRIPTIONAL_PAHLAVI_LETTER_SAMEKH = chr(68462)
INSCRIPTIONAL_PAHLAVI_LETTER_PE = chr(68463)
INSCRIPTIONAL_PAHLAVI_LETTER_SADHE = chr(68464)
INSCRIPTIONAL_PAHLAVI_LETTER_SHIN = chr(68465)
INSCRIPTIONAL_PAHLAVI_LETTER_TAW = chr(68466)
INSCRIPTIONAL_PAHLAVI_NUMBER_ONE = chr(68472)
INSCRIPTIONAL_PAHLAVI_NUMBER_TWO = chr(68473)
INSCRIPTIONAL_PAHLAVI_NUMBER_THREE = chr(68474)
INSCRIPTIONAL_PAHLAVI_NUMBER_FOUR = chr(68475)
INSCRIPTIONAL_PAHLAVI_NUMBER_TEN = chr(68476)
INSCRIPTIONAL_PAHLAVI_NUMBER_TWENTY = chr(68477)
INSCRIPTIONAL_PAHLAVI_NUMBER_ONE_HUNDRED = chr(68478)
INSCRIPTIONAL_PAHLAVI_NUMBER_ONE_THOUSAND = chr(68479)
PSALTER_PAHLAVI_LETTER_ALEPH = chr(68480)
PSALTER_PAHLAVI_LETTER_BETH = chr(68481)
PSALTER_PAHLAVI_LETTER_GIMEL = chr(68482)
PSALTER_PAHLAVI_LETTER_DALETH = chr(68483)
PSALTER_PAHLAVI_LETTER_HE = chr(68484)
PSALTER_PAHLAVI_LETTER_WAW_AYIN_RESH = chr(68485)
PSALTER_PAHLAVI_LETTER_ZAYIN = chr(68486)
PSALTER_PAHLAVI_LETTER_HETH = chr(68487)
PSALTER_PAHLAVI_LETTER_YODH = chr(68488)
PSALTER_PAHLAVI_LETTER_KAPH = chr(68489)
PSALTER_PAHLAVI_LETTER_LAMEDH = chr(68490)
PSALTER_PAHLAVI_LETTER_MEM_QOPH = chr(68491)
PSALTER_PAHLAVI_LETTER_NUN = chr(68492)
PSALTER_PAHLAVI_LETTER_SAMEKH = chr(68493)
PSALTER_PAHLAVI_LETTER_PE = chr(68494)
PSALTER_PAHLAVI_LETTER_SADHE = chr(68495)
PSALTER_PAHLAVI_LETTER_SHIN = chr(68496)
PSALTER_PAHLAVI_LETTER_TAW = chr(68497)
PSALTER_PAHLAVI_SECTION_MARK = chr(68505)
PSALTER_PAHLAVI_TURNED_SECTION_MARK = chr(68506)
PSALTER_PAHLAVI_FOUR_DOTS_WITH_CROSS = chr(68507)
PSALTER_PAHLAVI_FOUR_DOTS_WITH_DOT = chr(68508)
PSALTER_PAHLAVI_NUMBER_ONE = chr(68521)
PSALTER_PAHLAVI_NUMBER_TWO = chr(68522)
PSALTER_PAHLAVI_NUMBER_THREE = chr(68523)
PSALTER_PAHLAVI_NUMBER_FOUR = chr(68524)
PSALTER_PAHLAVI_NUMBER_TEN = chr(68525)
PSALTER_PAHLAVI_NUMBER_TWENTY = chr(68526)
PSALTER_PAHLAVI_NUMBER_ONE_HUNDRED = chr(68527)
OLD_TURKIC_LETTER_ORKHON_A = chr(68608)
OLD_TURKIC_LETTER_YENISEI_A = chr(68609)
OLD_TURKIC_LETTER_YENISEI_AE = chr(68610)
OLD_TURKIC_LETTER_ORKHON_I = chr(68611)
OLD_TURKIC_LETTER_YENISEI_I = chr(68612)
OLD_TURKIC_LETTER_YENISEI_E = chr(68613)
OLD_TURKIC_LETTER_ORKHON_O = chr(68614)
OLD_TURKIC_LETTER_ORKHON_OE = chr(68615)
OLD_TURKIC_LETTER_YENISEI_OE = chr(68616)
OLD_TURKIC_LETTER_ORKHON_AB = chr(68617)
OLD_TURKIC_LETTER_YENISEI_AB = chr(68618)
OLD_TURKIC_LETTER_ORKHON_AEB = chr(68619)
OLD_TURKIC_LETTER_YENISEI_AEB = chr(68620)
OLD_TURKIC_LETTER_ORKHON_AG = chr(68621)
OLD_TURKIC_LETTER_YENISEI_AG = chr(68622)
OLD_TURKIC_LETTER_ORKHON_AEG = chr(68623)
OLD_TURKIC_LETTER_YENISEI_AEG = chr(68624)
OLD_TURKIC_LETTER_ORKHON_AD = chr(68625)
OLD_TURKIC_LETTER_YENISEI_AD = chr(68626)
OLD_TURKIC_LETTER_ORKHON_AED = chr(68627)
OLD_TURKIC_LETTER_ORKHON_EZ = chr(68628)
OLD_TURKIC_LETTER_YENISEI_EZ = chr(68629)
OLD_TURKIC_LETTER_ORKHON_AY = chr(68630)
OLD_TURKIC_LETTER_YENISEI_AY = chr(68631)
OLD_TURKIC_LETTER_ORKHON_AEY = chr(68632)
OLD_TURKIC_LETTER_YENISEI_AEY = chr(68633)
OLD_TURKIC_LETTER_ORKHON_AEK = chr(68634)
OLD_TURKIC_LETTER_YENISEI_AEK = chr(68635)
OLD_TURKIC_LETTER_ORKHON_OEK = chr(68636)
OLD_TURKIC_LETTER_YENISEI_OEK = chr(68637)
OLD_TURKIC_LETTER_ORKHON_AL = chr(68638)
OLD_TURKIC_LETTER_YENISEI_AL = chr(68639)
OLD_TURKIC_LETTER_ORKHON_AEL = chr(68640)
OLD_TURKIC_LETTER_ORKHON_ELT = chr(68641)
OLD_TURKIC_LETTER_ORKHON_EM = chr(68642)
OLD_TURKIC_LETTER_ORKHON_AN = chr(68643)
OLD_TURKIC_LETTER_ORKHON_AEN = chr(68644)
OLD_TURKIC_LETTER_YENISEI_AEN = chr(68645)
OLD_TURKIC_LETTER_ORKHON_ENT = chr(68646)
OLD_TURKIC_LETTER_YENISEI_ENT = chr(68647)
OLD_TURKIC_LETTER_ORKHON_ENC = chr(68648)
OLD_TURKIC_LETTER_YENISEI_ENC = chr(68649)
OLD_TURKIC_LETTER_ORKHON_ENY = chr(68650)
OLD_TURKIC_LETTER_YENISEI_ENY = chr(68651)
OLD_TURKIC_LETTER_YENISEI_ANG = chr(68652)
OLD_TURKIC_LETTER_ORKHON_ENG = chr(68653)
OLD_TURKIC_LETTER_YENISEI_AENG = chr(68654)
OLD_TURKIC_LETTER_ORKHON_EP = chr(68655)
OLD_TURKIC_LETTER_ORKHON_OP = chr(68656)
OLD_TURKIC_LETTER_ORKHON_IC = chr(68657)
OLD_TURKIC_LETTER_ORKHON_EC = chr(68658)
OLD_TURKIC_LETTER_YENISEI_EC = chr(68659)
OLD_TURKIC_LETTER_ORKHON_AQ = chr(68660)
OLD_TURKIC_LETTER_YENISEI_AQ = chr(68661)
OLD_TURKIC_LETTER_ORKHON_IQ = chr(68662)
OLD_TURKIC_LETTER_YENISEI_IQ = chr(68663)
OLD_TURKIC_LETTER_ORKHON_OQ = chr(68664)
OLD_TURKIC_LETTER_YENISEI_OQ = chr(68665)
OLD_TURKIC_LETTER_ORKHON_AR = chr(68666)
OLD_TURKIC_LETTER_YENISEI_AR = chr(68667)
OLD_TURKIC_LETTER_ORKHON_AER = chr(68668)
OLD_TURKIC_LETTER_ORKHON_AS = chr(68669)
OLD_TURKIC_LETTER_ORKHON_AES = chr(68670)
OLD_TURKIC_LETTER_ORKHON_ASH = chr(68671)
OLD_TURKIC_LETTER_YENISEI_ASH = chr(68672)
OLD_TURKIC_LETTER_ORKHON_ESH = chr(68673)
OLD_TURKIC_LETTER_YENISEI_ESH = chr(68674)
OLD_TURKIC_LETTER_ORKHON_AT = chr(68675)
OLD_TURKIC_LETTER_YENISEI_AT = chr(68676)
OLD_TURKIC_LETTER_ORKHON_AET = chr(68677)
OLD_TURKIC_LETTER_YENISEI_AET = chr(68678)
OLD_TURKIC_LETTER_ORKHON_OT = chr(68679)
OLD_TURKIC_LETTER_ORKHON_BASH = chr(68680)
OLD_HUNGARIAN_CAPITAL_LETTER_A = chr(68736)
OLD_HUNGARIAN_CAPITAL_LETTER_AA = chr(68737)
OLD_HUNGARIAN_CAPITAL_LETTER_EB = chr(68738)
OLD_HUNGARIAN_CAPITAL_LETTER_AMB = chr(68739)
OLD_HUNGARIAN_CAPITAL_LETTER_EC = chr(68740)
OLD_HUNGARIAN_CAPITAL_LETTER_ENC = chr(68741)
OLD_HUNGARIAN_CAPITAL_LETTER_ECS = chr(68742)
OLD_HUNGARIAN_CAPITAL_LETTER_ED = chr(68743)
OLD_HUNGARIAN_CAPITAL_LETTER_AND = chr(68744)
OLD_HUNGARIAN_CAPITAL_LETTER_E = chr(68745)
OLD_HUNGARIAN_CAPITAL_LETTER_CLOSE_E = chr(68746)
OLD_HUNGARIAN_CAPITAL_LETTER_EE = chr(68747)
OLD_HUNGARIAN_CAPITAL_LETTER_EF = chr(68748)
OLD_HUNGARIAN_CAPITAL_LETTER_EG = chr(68749)
OLD_HUNGARIAN_CAPITAL_LETTER_EGY = chr(68750)
OLD_HUNGARIAN_CAPITAL_LETTER_EH = chr(68751)
OLD_HUNGARIAN_CAPITAL_LETTER_I = chr(68752)
OLD_HUNGARIAN_CAPITAL_LETTER_II = chr(68753)
OLD_HUNGARIAN_CAPITAL_LETTER_EJ = chr(68754)
OLD_HUNGARIAN_CAPITAL_LETTER_EK = chr(68755)
OLD_HUNGARIAN_CAPITAL_LETTER_AK = chr(68756)
OLD_HUNGARIAN_CAPITAL_LETTER_UNK = chr(68757)
OLD_HUNGARIAN_CAPITAL_LETTER_EL = chr(68758)
OLD_HUNGARIAN_CAPITAL_LETTER_ELY = chr(68759)
OLD_HUNGARIAN_CAPITAL_LETTER_EM = chr(68760)
OLD_HUNGARIAN_CAPITAL_LETTER_EN = chr(68761)
OLD_HUNGARIAN_CAPITAL_LETTER_ENY = chr(68762)
OLD_HUNGARIAN_CAPITAL_LETTER_O = chr(68763)
OLD_HUNGARIAN_CAPITAL_LETTER_OO = chr(68764)
OLD_HUNGARIAN_CAPITAL_LETTER_NIKOLSBURG_OE = chr(68765)
OLD_HUNGARIAN_CAPITAL_LETTER_RUDIMENTA_OE = chr(68766)
OLD_HUNGARIAN_CAPITAL_LETTER_OEE = chr(68767)
OLD_HUNGARIAN_CAPITAL_LETTER_EP = chr(68768)
OLD_HUNGARIAN_CAPITAL_LETTER_EMP = chr(68769)
OLD_HUNGARIAN_CAPITAL_LETTER_ER = chr(68770)
OLD_HUNGARIAN_CAPITAL_LETTER_SHORT_ER = chr(68771)
OLD_HUNGARIAN_CAPITAL_LETTER_ES = chr(68772)
OLD_HUNGARIAN_CAPITAL_LETTER_ESZ = chr(68773)
OLD_HUNGARIAN_CAPITAL_LETTER_ET = chr(68774)
OLD_HUNGARIAN_CAPITAL_LETTER_ENT = chr(68775)
OLD_HUNGARIAN_CAPITAL_LETTER_ETY = chr(68776)
OLD_HUNGARIAN_CAPITAL_LETTER_ECH = chr(68777)
OLD_HUNGARIAN_CAPITAL_LETTER_U = chr(68778)
OLD_HUNGARIAN_CAPITAL_LETTER_UU = chr(68779)
OLD_HUNGARIAN_CAPITAL_LETTER_NIKOLSBURG_UE = chr(68780)
OLD_HUNGARIAN_CAPITAL_LETTER_RUDIMENTA_UE = chr(68781)
OLD_HUNGARIAN_CAPITAL_LETTER_EV = chr(68782)
OLD_HUNGARIAN_CAPITAL_LETTER_EZ = chr(68783)
OLD_HUNGARIAN_CAPITAL_LETTER_EZS = chr(68784)
OLD_HUNGARIAN_CAPITAL_LETTER_ENT_SHAPED_SIGN = chr(68785)
OLD_HUNGARIAN_CAPITAL_LETTER_US = chr(68786)
OLD_HUNGARIAN_SMALL_LETTER_A = chr(68800)
OLD_HUNGARIAN_SMALL_LETTER_AA = chr(68801)
OLD_HUNGARIAN_SMALL_LETTER_EB = chr(68802)
OLD_HUNGARIAN_SMALL_LETTER_AMB = chr(68803)
OLD_HUNGARIAN_SMALL_LETTER_EC = chr(68804)
OLD_HUNGARIAN_SMALL_LETTER_ENC = chr(68805)
OLD_HUNGARIAN_SMALL_LETTER_ECS = chr(68806)
OLD_HUNGARIAN_SMALL_LETTER_ED = chr(68807)
OLD_HUNGARIAN_SMALL_LETTER_AND = chr(68808)
OLD_HUNGARIAN_SMALL_LETTER_E = chr(68809)
OLD_HUNGARIAN_SMALL_LETTER_CLOSE_E = chr(68810)
OLD_HUNGARIAN_SMALL_LETTER_EE = chr(68811)
OLD_HUNGARIAN_SMALL_LETTER_EF = chr(68812)
OLD_HUNGARIAN_SMALL_LETTER_EG = chr(68813)
OLD_HUNGARIAN_SMALL_LETTER_EGY = chr(68814)
OLD_HUNGARIAN_SMALL_LETTER_EH = chr(68815)
OLD_HUNGARIAN_SMALL_LETTER_I = chr(68816)
OLD_HUNGARIAN_SMALL_LETTER_II = chr(68817)
OLD_HUNGARIAN_SMALL_LETTER_EJ = chr(68818)
OLD_HUNGARIAN_SMALL_LETTER_EK = chr(68819)
OLD_HUNGARIAN_SMALL_LETTER_AK = chr(68820)
OLD_HUNGARIAN_SMALL_LETTER_UNK = chr(68821)
OLD_HUNGARIAN_SMALL_LETTER_EL = chr(68822)
OLD_HUNGARIAN_SMALL_LETTER_ELY = chr(68823)
OLD_HUNGARIAN_SMALL_LETTER_EM = chr(68824)
OLD_HUNGARIAN_SMALL_LETTER_EN = chr(68825)
OLD_HUNGARIAN_SMALL_LETTER_ENY = chr(68826)
OLD_HUNGARIAN_SMALL_LETTER_O = chr(68827)
OLD_HUNGARIAN_SMALL_LETTER_OO = chr(68828)
OLD_HUNGARIAN_SMALL_LETTER_NIKOLSBURG_OE = chr(68829)
OLD_HUNGARIAN_SMALL_LETTER_RUDIMENTA_OE = chr(68830)
OLD_HUNGARIAN_SMALL_LETTER_OEE = chr(68831)
OLD_HUNGARIAN_SMALL_LETTER_EP = chr(68832)
OLD_HUNGARIAN_SMALL_LETTER_EMP = chr(68833)
OLD_HUNGARIAN_SMALL_LETTER_ER = chr(68834)
OLD_HUNGARIAN_SMALL_LETTER_SHORT_ER = chr(68835)
OLD_HUNGARIAN_SMALL_LETTER_ES = chr(68836)
OLD_HUNGARIAN_SMALL_LETTER_ESZ = chr(68837)
OLD_HUNGARIAN_SMALL_LETTER_ET = chr(68838)
OLD_HUNGARIAN_SMALL_LETTER_ENT = chr(68839)
OLD_HUNGARIAN_SMALL_LETTER_ETY = chr(68840)
OLD_HUNGARIAN_SMALL_LETTER_ECH = chr(68841)
OLD_HUNGARIAN_SMALL_LETTER_U = chr(68842)
OLD_HUNGARIAN_SMALL_LETTER_UU = chr(68843)
OLD_HUNGARIAN_SMALL_LETTER_NIKOLSBURG_UE = chr(68844)
OLD_HUNGARIAN_SMALL_LETTER_RUDIMENTA_UE = chr(68845)
OLD_HUNGARIAN_SMALL_LETTER_EV = chr(68846)
OLD_HUNGARIAN_SMALL_LETTER_EZ = chr(68847)
OLD_HUNGARIAN_SMALL_LETTER_EZS = chr(68848)
OLD_HUNGARIAN_SMALL_LETTER_ENT_SHAPED_SIGN = chr(68849)
OLD_HUNGARIAN_SMALL_LETTER_US = chr(68850)
OLD_HUNGARIAN_NUMBER_ONE = chr(68858)
OLD_HUNGARIAN_NUMBER_FIVE = chr(68859)
OLD_HUNGARIAN_NUMBER_TEN = chr(68860)
OLD_HUNGARIAN_NUMBER_FIFTY = chr(68861)
OLD_HUNGARIAN_NUMBER_ONE_HUNDRED = chr(68862)
OLD_HUNGARIAN_NUMBER_ONE_THOUSAND = chr(68863)
HANIFI_ROHINGYA_LETTER_A = chr(68864)
HANIFI_ROHINGYA_LETTER_BA = chr(68865)
HANIFI_ROHINGYA_LETTER_PA = chr(68866)
HANIFI_ROHINGYA_LETTER_TA = chr(68867)
HANIFI_ROHINGYA_LETTER_TTA = chr(68868)
HANIFI_ROHINGYA_LETTER_JA = chr(68869)
HANIFI_ROHINGYA_LETTER_CA = chr(68870)
HANIFI_ROHINGYA_LETTER_HA = chr(68871)
HANIFI_ROHINGYA_LETTER_KHA = chr(68872)
HANIFI_ROHINGYA_LETTER_FA = chr(68873)
HANIFI_ROHINGYA_LETTER_DA = chr(68874)
HANIFI_ROHINGYA_LETTER_DDA = chr(68875)
HANIFI_ROHINGYA_LETTER_RA = chr(68876)
HANIFI_ROHINGYA_LETTER_RRA = chr(68877)
HANIFI_ROHINGYA_LETTER_ZA = chr(68878)
HANIFI_ROHINGYA_LETTER_SA = chr(68879)
HANIFI_ROHINGYA_LETTER_SHA = chr(68880)
HANIFI_ROHINGYA_LETTER_KA = chr(68881)
HANIFI_ROHINGYA_LETTER_GA = chr(68882)
HANIFI_ROHINGYA_LETTER_LA = chr(68883)
HANIFI_ROHINGYA_LETTER_MA = chr(68884)
HANIFI_ROHINGYA_LETTER_NA = chr(68885)
HANIFI_ROHINGYA_LETTER_WA = chr(68886)
HANIFI_ROHINGYA_LETTER_KINNA_WA = chr(68887)
HANIFI_ROHINGYA_LETTER_YA = chr(68888)
HANIFI_ROHINGYA_LETTER_KINNA_YA = chr(68889)
HANIFI_ROHINGYA_LETTER_NGA = chr(68890)
HANIFI_ROHINGYA_LETTER_NYA = chr(68891)
HANIFI_ROHINGYA_LETTER_VA = chr(68892)
HANIFI_ROHINGYA_VOWEL_A = chr(68893)
HANIFI_ROHINGYA_VOWEL_I = chr(68894)
HANIFI_ROHINGYA_VOWEL_U = chr(68895)
HANIFI_ROHINGYA_VOWEL_E = chr(68896)
HANIFI_ROHINGYA_VOWEL_O = chr(68897)
HANIFI_ROHINGYA_MARK_SAKIN = chr(68898)
HANIFI_ROHINGYA_MARK_NA_KHONNA = chr(68899)
HANIFI_ROHINGYA_SIGN_HARBAHAY = chr(68900)
HANIFI_ROHINGYA_SIGN_TAHALA = chr(68901)
HANIFI_ROHINGYA_SIGN_TANA = chr(68902)
HANIFI_ROHINGYA_SIGN_TASSI = chr(68903)
HANIFI_ROHINGYA_DIGIT_ZERO = chr(68912)
HANIFI_ROHINGYA_DIGIT_ONE = chr(68913)
HANIFI_ROHINGYA_DIGIT_TWO = chr(68914)
HANIFI_ROHINGYA_DIGIT_THREE = chr(68915)
HANIFI_ROHINGYA_DIGIT_FOUR = chr(68916)
HANIFI_ROHINGYA_DIGIT_FIVE = chr(68917)
HANIFI_ROHINGYA_DIGIT_SIX = chr(68918)
HANIFI_ROHINGYA_DIGIT_SEVEN = chr(68919)
HANIFI_ROHINGYA_DIGIT_EIGHT = chr(68920)
HANIFI_ROHINGYA_DIGIT_NINE = chr(68921)
RUMI_DIGIT_ONE = chr(69216)
RUMI_DIGIT_TWO = chr(69217)
RUMI_DIGIT_THREE = chr(69218)
RUMI_DIGIT_FOUR = chr(69219)
RUMI_DIGIT_FIVE = chr(69220)
RUMI_DIGIT_SIX = chr(69221)
RUMI_DIGIT_SEVEN = chr(69222)
RUMI_DIGIT_EIGHT = chr(69223)
RUMI_DIGIT_NINE = chr(69224)
RUMI_NUMBER_TEN = chr(69225)
RUMI_NUMBER_TWENTY = chr(69226)
RUMI_NUMBER_THIRTY = chr(69227)
RUMI_NUMBER_FORTY = chr(69228)
RUMI_NUMBER_FIFTY = chr(69229)
RUMI_NUMBER_SIXTY = chr(69230)
RUMI_NUMBER_SEVENTY = chr(69231)
RUMI_NUMBER_EIGHTY = chr(69232)
RUMI_NUMBER_NINETY = chr(69233)
RUMI_NUMBER_ONE_HUNDRED = chr(69234)
RUMI_NUMBER_TWO_HUNDRED = chr(69235)
RUMI_NUMBER_THREE_HUNDRED = chr(69236)
RUMI_NUMBER_FOUR_HUNDRED = chr(69237)
RUMI_NUMBER_FIVE_HUNDRED = chr(69238)
RUMI_NUMBER_SIX_HUNDRED = chr(69239)
RUMI_NUMBER_SEVEN_HUNDRED = chr(69240)
RUMI_NUMBER_EIGHT_HUNDRED = chr(69241)
RUMI_NUMBER_NINE_HUNDRED = chr(69242)
RUMI_FRACTION_ONE_HALF = chr(69243)
RUMI_FRACTION_ONE_QUARTER = chr(69244)
RUMI_FRACTION_ONE_THIRD = chr(69245)
RUMI_FRACTION_TWO_THIRDS = chr(69246)
YEZIDI_LETTER_ELIF = chr(69248)
YEZIDI_LETTER_BE = chr(69249)
YEZIDI_LETTER_PE = chr(69250)
YEZIDI_LETTER_PHE = chr(69251)
YEZIDI_LETTER_THE = chr(69252)
YEZIDI_LETTER_SE = chr(69253)
YEZIDI_LETTER_CIM = chr(69254)
YEZIDI_LETTER_CHIM = chr(69255)
YEZIDI_LETTER_CHHIM = chr(69256)
YEZIDI_LETTER_HHA = chr(69257)
YEZIDI_LETTER_XA = chr(69258)
YEZIDI_LETTER_DAL = chr(69259)
YEZIDI_LETTER_ZAL = chr(69260)
YEZIDI_LETTER_RA = chr(69261)
YEZIDI_LETTER_RHA = chr(69262)
YEZIDI_LETTER_ZA = chr(69263)
YEZIDI_LETTER_JA = chr(69264)
YEZIDI_LETTER_SIN = chr(69265)
YEZIDI_LETTER_SHIN = chr(69266)
YEZIDI_LETTER_SAD = chr(69267)
YEZIDI_LETTER_DAD = chr(69268)
YEZIDI_LETTER_TA = chr(69269)
YEZIDI_LETTER_ZE = chr(69270)
YEZIDI_LETTER_EYN = chr(69271)
YEZIDI_LETTER_XHEYN = chr(69272)
YEZIDI_LETTER_FA = chr(69273)
YEZIDI_LETTER_VA = chr(69274)
YEZIDI_LETTER_VA_ALTERNATE_FORM = chr(69275)
YEZIDI_LETTER_QAF = chr(69276)
YEZIDI_LETTER_KAF = chr(69277)
YEZIDI_LETTER_KHAF = chr(69278)
YEZIDI_LETTER_GAF = chr(69279)
YEZIDI_LETTER_LAM = chr(69280)
YEZIDI_LETTER_MIM = chr(69281)
YEZIDI_LETTER_NUN = chr(69282)
YEZIDI_LETTER_UM = chr(69283)
YEZIDI_LETTER_WAW = chr(69284)
YEZIDI_LETTER_OW = chr(69285)
YEZIDI_LETTER_EW = chr(69286)
YEZIDI_LETTER_HAY = chr(69287)
YEZIDI_LETTER_YOT = chr(69288)
YEZIDI_LETTER_ET = chr(69289)
YEZIDI_COMBINING_HAMZA_MARK = chr(69291)
YEZIDI_COMBINING_MADDA_MARK = chr(69292)
YEZIDI_HYPHENATION_MARK = chr(69293)
YEZIDI_LETTER_LAM_WITH_DOT_ABOVE = chr(69296)
YEZIDI_LETTER_YOT_WITH_CIRCUMFLEX_ABOVE = chr(69297)
ARABIC_SMALL_LOW_WORD_SAKTA = chr(69373)
ARABIC_SMALL_LOW_WORD_QASR = chr(69374)
ARABIC_SMALL_LOW_WORD_MADDA = chr(69375)
OLD_SOGDIAN_LETTER_ALEPH = chr(69376)
OLD_SOGDIAN_LETTER_FINAL_ALEPH = chr(69377)
OLD_SOGDIAN_LETTER_BETH = chr(69378)
OLD_SOGDIAN_LETTER_FINAL_BETH = chr(69379)
OLD_SOGDIAN_LETTER_GIMEL = chr(69380)
OLD_SOGDIAN_LETTER_HE = chr(69381)
OLD_SOGDIAN_LETTER_FINAL_HE = chr(69382)
OLD_SOGDIAN_LETTER_WAW = chr(69383)
OLD_SOGDIAN_LETTER_ZAYIN = chr(69384)
OLD_SOGDIAN_LETTER_HETH = chr(69385)
OLD_SOGDIAN_LETTER_YODH = chr(69386)
OLD_SOGDIAN_LETTER_KAPH = chr(69387)
OLD_SOGDIAN_LETTER_LAMEDH = chr(69388)
OLD_SOGDIAN_LETTER_MEM = chr(69389)
OLD_SOGDIAN_LETTER_NUN = chr(69390)
OLD_SOGDIAN_LETTER_FINAL_NUN = chr(69391)
OLD_SOGDIAN_LETTER_FINAL_NUN_WITH_VERTICAL_TAIL = chr(69392)
OLD_SOGDIAN_LETTER_SAMEKH = chr(69393)
OLD_SOGDIAN_LETTER_AYIN = chr(69394)
OLD_SOGDIAN_LETTER_ALTERNATE_AYIN = chr(69395)
OLD_SOGDIAN_LETTER_PE = chr(69396)
OLD_SOGDIAN_LETTER_SADHE = chr(69397)
OLD_SOGDIAN_LETTER_FINAL_SADHE = chr(69398)
OLD_SOGDIAN_LETTER_FINAL_SADHE_WITH_VERTICAL_TAIL = chr(69399)
OLD_SOGDIAN_LETTER_RESH_AYIN_DALETH = chr(69400)
OLD_SOGDIAN_LETTER_SHIN = chr(69401)
OLD_SOGDIAN_LETTER_TAW = chr(69402)
OLD_SOGDIAN_LETTER_FINAL_TAW = chr(69403)
OLD_SOGDIAN_LETTER_FINAL_TAW_WITH_VERTICAL_TAIL = chr(69404)
OLD_SOGDIAN_NUMBER_ONE = chr(69405)
OLD_SOGDIAN_NUMBER_TWO = chr(69406)
OLD_SOGDIAN_NUMBER_THREE = chr(69407)
OLD_SOGDIAN_NUMBER_FOUR = chr(69408)
OLD_SOGDIAN_NUMBER_FIVE = chr(69409)
OLD_SOGDIAN_NUMBER_TEN = chr(69410)
OLD_SOGDIAN_NUMBER_TWENTY = chr(69411)
OLD_SOGDIAN_NUMBER_THIRTY = chr(69412)
OLD_SOGDIAN_NUMBER_ONE_HUNDRED = chr(69413)
OLD_SOGDIAN_FRACTION_ONE_HALF = chr(69414)
OLD_SOGDIAN_LIGATURE_AYIN_DALETH = chr(69415)
SOGDIAN_LETTER_ALEPH = chr(69424)
SOGDIAN_LETTER_BETH = chr(69425)
SOGDIAN_LETTER_GIMEL = chr(69426)
SOGDIAN_LETTER_HE = chr(69427)
SOGDIAN_LETTER_WAW = chr(69428)
SOGDIAN_LETTER_ZAYIN = chr(69429)
SOGDIAN_LETTER_HETH = chr(69430)
SOGDIAN_LETTER_YODH = chr(69431)
SOGDIAN_LETTER_KAPH = chr(69432)
SOGDIAN_LETTER_LAMEDH = chr(69433)
SOGDIAN_LETTER_MEM = chr(69434)
SOGDIAN_LETTER_NUN = chr(69435)
SOGDIAN_LETTER_SAMEKH = chr(69436)
SOGDIAN_LETTER_AYIN = chr(69437)
SOGDIAN_LETTER_PE = chr(69438)
SOGDIAN_LETTER_SADHE = chr(69439)
SOGDIAN_LETTER_RESH_AYIN = chr(69440)
SOGDIAN_LETTER_SHIN = chr(69441)
SOGDIAN_LETTER_TAW = chr(69442)
SOGDIAN_LETTER_FETH = chr(69443)
SOGDIAN_LETTER_LESH = chr(69444)
SOGDIAN_INDEPENDENT_SHIN = chr(69445)
SOGDIAN_COMBINING_DOT_BELOW = chr(69446)
SOGDIAN_COMBINING_TWO_DOTS_BELOW = chr(69447)
SOGDIAN_COMBINING_DOT_ABOVE = chr(69448)
SOGDIAN_COMBINING_TWO_DOTS_ABOVE = chr(69449)
SOGDIAN_COMBINING_CURVE_ABOVE = chr(69450)
SOGDIAN_COMBINING_CURVE_BELOW = chr(69451)
SOGDIAN_COMBINING_HOOK_ABOVE = chr(69452)
SOGDIAN_COMBINING_HOOK_BELOW = chr(69453)
SOGDIAN_COMBINING_LONG_HOOK_BELOW = chr(69454)
SOGDIAN_COMBINING_RESH_BELOW = chr(69455)
SOGDIAN_COMBINING_STROKE_BELOW = chr(69456)
SOGDIAN_NUMBER_ONE = chr(69457)
SOGDIAN_NUMBER_TEN = chr(69458)
SOGDIAN_NUMBER_TWENTY = chr(69459)
SOGDIAN_NUMBER_ONE_HUNDRED = chr(69460)
SOGDIAN_PUNCTUATION_TWO_VERTICAL_BARS = chr(69461)
SOGDIAN_PUNCTUATION_TWO_VERTICAL_BARS_WITH_DOTS = chr(69462)
SOGDIAN_PUNCTUATION_CIRCLE_WITH_DOT = chr(69463)
SOGDIAN_PUNCTUATION_TWO_CIRCLES_WITH_DOTS = chr(69464)
SOGDIAN_PUNCTUATION_HALF_CIRCLE_WITH_DOT = chr(69465)
OLD_UYGHUR_LETTER_ALEPH = chr(69488)
OLD_UYGHUR_LETTER_BETH = chr(69489)
OLD_UYGHUR_LETTER_GIMEL_HETH = chr(69490)
OLD_UYGHUR_LETTER_WAW = chr(69491)
OLD_UYGHUR_LETTER_ZAYIN = chr(69492)
OLD_UYGHUR_LETTER_FINAL_HETH = chr(69493)
OLD_UYGHUR_LETTER_YODH = chr(69494)
OLD_UYGHUR_LETTER_KAPH = chr(69495)
OLD_UYGHUR_LETTER_LAMEDH = chr(69496)
OLD_UYGHUR_LETTER_MEM = chr(69497)
OLD_UYGHUR_LETTER_NUN = chr(69498)
OLD_UYGHUR_LETTER_SAMEKH = chr(69499)
OLD_UYGHUR_LETTER_PE = chr(69500)
OLD_UYGHUR_LETTER_SADHE = chr(69501)
OLD_UYGHUR_LETTER_RESH = chr(69502)
OLD_UYGHUR_LETTER_SHIN = chr(69503)
OLD_UYGHUR_LETTER_TAW = chr(69504)
OLD_UYGHUR_LETTER_LESH = chr(69505)
OLD_UYGHUR_COMBINING_DOT_ABOVE = chr(69506)
OLD_UYGHUR_COMBINING_DOT_BELOW = chr(69507)
OLD_UYGHUR_COMBINING_TWO_DOTS_ABOVE = chr(69508)
OLD_UYGHUR_COMBINING_TWO_DOTS_BELOW = chr(69509)
OLD_UYGHUR_PUNCTUATION_BAR = chr(69510)
OLD_UYGHUR_PUNCTUATION_TWO_BARS = chr(69511)
OLD_UYGHUR_PUNCTUATION_TWO_DOTS = chr(69512)
OLD_UYGHUR_PUNCTUATION_FOUR_DOTS = chr(69513)
CHORASMIAN_LETTER_ALEPH = chr(69552)
CHORASMIAN_LETTER_SMALL_ALEPH = chr(69553)
CHORASMIAN_LETTER_BETH = chr(69554)
CHORASMIAN_LETTER_GIMEL = chr(69555)
CHORASMIAN_LETTER_DALETH = chr(69556)
CHORASMIAN_LETTER_HE = chr(69557)
CHORASMIAN_LETTER_WAW = chr(69558)
CHORASMIAN_LETTER_CURLED_WAW = chr(69559)
CHORASMIAN_LETTER_ZAYIN = chr(69560)
CHORASMIAN_LETTER_HETH = chr(69561)
CHORASMIAN_LETTER_YODH = chr(69562)
CHORASMIAN_LETTER_KAPH = chr(69563)
CHORASMIAN_LETTER_LAMEDH = chr(69564)
CHORASMIAN_LETTER_MEM = chr(69565)
CHORASMIAN_LETTER_NUN = chr(69566)
CHORASMIAN_LETTER_SAMEKH = chr(69567)
CHORASMIAN_LETTER_AYIN = chr(69568)
CHORASMIAN_LETTER_PE = chr(69569)
CHORASMIAN_LETTER_RESH = chr(69570)
CHORASMIAN_LETTER_SHIN = chr(69571)
CHORASMIAN_LETTER_TAW = chr(69572)
CHORASMIAN_NUMBER_ONE = chr(69573)
CHORASMIAN_NUMBER_TWO = chr(69574)
CHORASMIAN_NUMBER_THREE = chr(69575)
CHORASMIAN_NUMBER_FOUR = chr(69576)
CHORASMIAN_NUMBER_TEN = chr(69577)
CHORASMIAN_NUMBER_TWENTY = chr(69578)
CHORASMIAN_NUMBER_ONE_HUNDRED = chr(69579)
ELYMAIC_LETTER_ALEPH = chr(69600)
ELYMAIC_LETTER_BETH = chr(69601)
ELYMAIC_LETTER_GIMEL = chr(69602)
ELYMAIC_LETTER_DALETH = chr(69603)
ELYMAIC_LETTER_HE = chr(69604)
ELYMAIC_LETTER_WAW = chr(69605)
ELYMAIC_LETTER_ZAYIN = chr(69606)
ELYMAIC_LETTER_HETH = chr(69607)
ELYMAIC_LETTER_TETH = chr(69608)
ELYMAIC_LETTER_YODH = chr(69609)
ELYMAIC_LETTER_KAPH = chr(69610)
ELYMAIC_LETTER_LAMEDH = chr(69611)
ELYMAIC_LETTER_MEM = chr(69612)
ELYMAIC_LETTER_NUN = chr(69613)
ELYMAIC_LETTER_SAMEKH = chr(69614)
ELYMAIC_LETTER_AYIN = chr(69615)
ELYMAIC_LETTER_PE = chr(69616)
ELYMAIC_LETTER_SADHE = chr(69617)
ELYMAIC_LETTER_QOPH = chr(69618)
ELYMAIC_LETTER_RESH = chr(69619)
ELYMAIC_LETTER_SHIN = chr(69620)
ELYMAIC_LETTER_TAW = chr(69621)
ELYMAIC_LIGATURE_ZAYIN_YODH = chr(69622)
BRAHMI_SIGN_CANDRABINDU = chr(69632)
BRAHMI_SIGN_ANUSVARA = chr(69633)
BRAHMI_SIGN_VISARGA = chr(69634)
BRAHMI_SIGN_JIHVAMULIYA = chr(69635)
BRAHMI_SIGN_UPADHMANIYA = chr(69636)
BRAHMI_LETTER_A = chr(69637)
BRAHMI_LETTER_AA = chr(69638)
BRAHMI_LETTER_I = chr(69639)
BRAHMI_LETTER_II = chr(69640)
BRAHMI_LETTER_U = chr(69641)
BRAHMI_LETTER_UU = chr(69642)
BRAHMI_LETTER_VOCALIC_R = chr(69643)
BRAHMI_LETTER_VOCALIC_RR = chr(69644)
BRAHMI_LETTER_VOCALIC_L = chr(69645)
BRAHMI_LETTER_VOCALIC_LL = chr(69646)
BRAHMI_LETTER_E = chr(69647)
BRAHMI_LETTER_AI = chr(69648)
BRAHMI_LETTER_O = chr(69649)
BRAHMI_LETTER_AU = chr(69650)
BRAHMI_LETTER_KA = chr(69651)
BRAHMI_LETTER_KHA = chr(69652)
BRAHMI_LETTER_GA = chr(69653)
BRAHMI_LETTER_GHA = chr(69654)
BRAHMI_LETTER_NGA = chr(69655)
BRAHMI_LETTER_CA = chr(69656)
BRAHMI_LETTER_CHA = chr(69657)
BRAHMI_LETTER_JA = chr(69658)
BRAHMI_LETTER_JHA = chr(69659)
BRAHMI_LETTER_NYA = chr(69660)
BRAHMI_LETTER_TTA = chr(69661)
BRAHMI_LETTER_TTHA = chr(69662)
BRAHMI_LETTER_DDA = chr(69663)
BRAHMI_LETTER_DDHA = chr(69664)
BRAHMI_LETTER_NNA = chr(69665)
BRAHMI_LETTER_TA = chr(69666)
BRAHMI_LETTER_THA = chr(69667)
BRAHMI_LETTER_DA = chr(69668)
BRAHMI_LETTER_DHA = chr(69669)
BRAHMI_LETTER_NA = chr(69670)
BRAHMI_LETTER_PA = chr(69671)
BRAHMI_LETTER_PHA = chr(69672)
BRAHMI_LETTER_BA = chr(69673)
BRAHMI_LETTER_BHA = chr(69674)
BRAHMI_LETTER_MA = chr(69675)
BRAHMI_LETTER_YA = chr(69676)
BRAHMI_LETTER_RA = chr(69677)
BRAHMI_LETTER_LA = chr(69678)
BRAHMI_LETTER_VA = chr(69679)
BRAHMI_LETTER_SHA = chr(69680)
BRAHMI_LETTER_SSA = chr(69681)
BRAHMI_LETTER_SA = chr(69682)
BRAHMI_LETTER_HA = chr(69683)
BRAHMI_LETTER_LLA = chr(69684)
BRAHMI_LETTER_OLD_TAMIL_LLLA = chr(69685)
BRAHMI_LETTER_OLD_TAMIL_RRA = chr(69686)
BRAHMI_LETTER_OLD_TAMIL_NNNA = chr(69687)
BRAHMI_VOWEL_SIGN_AA = chr(69688)
BRAHMI_VOWEL_SIGN_BHATTIPROLU_AA = chr(69689)
BRAHMI_VOWEL_SIGN_I = chr(69690)
BRAHMI_VOWEL_SIGN_II = chr(69691)
BRAHMI_VOWEL_SIGN_U = chr(69692)
BRAHMI_VOWEL_SIGN_UU = chr(69693)
BRAHMI_VOWEL_SIGN_VOCALIC_R = chr(69694)
BRAHMI_VOWEL_SIGN_VOCALIC_RR = chr(69695)
BRAHMI_VOWEL_SIGN_VOCALIC_L = chr(69696)
BRAHMI_VOWEL_SIGN_VOCALIC_LL = chr(69697)
BRAHMI_VOWEL_SIGN_E = chr(69698)
BRAHMI_VOWEL_SIGN_AI = chr(69699)
BRAHMI_VOWEL_SIGN_O = chr(69700)
BRAHMI_VOWEL_SIGN_AU = chr(69701)
BRAHMI_VIRAMA = chr(69702)
BRAHMI_DANDA = chr(69703)
BRAHMI_DOUBLE_DANDA = chr(69704)
BRAHMI_PUNCTUATION_DOT = chr(69705)
BRAHMI_PUNCTUATION_DOUBLE_DOT = chr(69706)
BRAHMI_PUNCTUATION_LINE = chr(69707)
BRAHMI_PUNCTUATION_CRESCENT_BAR = chr(69708)
BRAHMI_PUNCTUATION_LOTUS = chr(69709)
BRAHMI_NUMBER_ONE = chr(69714)
BRAHMI_NUMBER_TWO = chr(69715)
BRAHMI_NUMBER_THREE = chr(69716)
BRAHMI_NUMBER_FOUR = chr(69717)
BRAHMI_NUMBER_FIVE = chr(69718)
BRAHMI_NUMBER_SIX = chr(69719)
BRAHMI_NUMBER_SEVEN = chr(69720)
BRAHMI_NUMBER_EIGHT = chr(69721)
BRAHMI_NUMBER_NINE = chr(69722)
BRAHMI_NUMBER_TEN = chr(69723)
BRAHMI_NUMBER_TWENTY = chr(69724)
BRAHMI_NUMBER_THIRTY = chr(69725)
BRAHMI_NUMBER_FORTY = chr(69726)
BRAHMI_NUMBER_FIFTY = chr(69727)
BRAHMI_NUMBER_SIXTY = chr(69728)
BRAHMI_NUMBER_SEVENTY = chr(69729)
BRAHMI_NUMBER_EIGHTY = chr(69730)
BRAHMI_NUMBER_NINETY = chr(69731)
BRAHMI_NUMBER_ONE_HUNDRED = chr(69732)
BRAHMI_NUMBER_ONE_THOUSAND = chr(69733)
BRAHMI_DIGIT_ZERO = chr(69734)
BRAHMI_DIGIT_ONE = chr(69735)
BRAHMI_DIGIT_TWO = chr(69736)
BRAHMI_DIGIT_THREE = chr(69737)
BRAHMI_DIGIT_FOUR = chr(69738)
BRAHMI_DIGIT_FIVE = chr(69739)
BRAHMI_DIGIT_SIX = chr(69740)
BRAHMI_DIGIT_SEVEN = chr(69741)
BRAHMI_DIGIT_EIGHT = chr(69742)
BRAHMI_DIGIT_NINE = chr(69743)
BRAHMI_SIGN_OLD_TAMIL_VIRAMA = chr(69744)
BRAHMI_LETTER_OLD_TAMIL_SHORT_E = chr(69745)
BRAHMI_LETTER_OLD_TAMIL_SHORT_O = chr(69746)
BRAHMI_VOWEL_SIGN_OLD_TAMIL_SHORT_E = chr(69747)
BRAHMI_VOWEL_SIGN_OLD_TAMIL_SHORT_O = chr(69748)
BRAHMI_LETTER_OLD_TAMIL_LLA = chr(69749)
BRAHMI_NUMBER_JOINER = chr(69759)
KAITHI_SIGN_CANDRABINDU = chr(69760)
KAITHI_SIGN_ANUSVARA = chr(69761)
KAITHI_SIGN_VISARGA = chr(69762)
KAITHI_LETTER_A = chr(69763)
KAITHI_LETTER_AA = chr(69764)
KAITHI_LETTER_I = chr(69765)
KAITHI_LETTER_II = chr(69766)
KAITHI_LETTER_U = chr(69767)
KAITHI_LETTER_UU = chr(69768)
KAITHI_LETTER_E = chr(69769)
KAITHI_LETTER_AI = chr(69770)
KAITHI_LETTER_O = chr(69771)
KAITHI_LETTER_AU = chr(69772)
KAITHI_LETTER_KA = chr(69773)
KAITHI_LETTER_KHA = chr(69774)
KAITHI_LETTER_GA = chr(69775)
KAITHI_LETTER_GHA = chr(69776)
KAITHI_LETTER_NGA = chr(69777)
KAITHI_LETTER_CA = chr(69778)
KAITHI_LETTER_CHA = chr(69779)
KAITHI_LETTER_JA = chr(69780)
KAITHI_LETTER_JHA = chr(69781)
KAITHI_LETTER_NYA = chr(69782)
KAITHI_LETTER_TTA = chr(69783)
KAITHI_LETTER_TTHA = chr(69784)
KAITHI_LETTER_DDA = chr(69785)
KAITHI_LETTER_DDDHA = chr(69786)
KAITHI_LETTER_DDHA = chr(69787)
KAITHI_LETTER_RHA = chr(69788)
KAITHI_LETTER_NNA = chr(69789)
KAITHI_LETTER_TA = chr(69790)
KAITHI_LETTER_THA = chr(69791)
KAITHI_LETTER_DA = chr(69792)
KAITHI_LETTER_DHA = chr(69793)
KAITHI_LETTER_NA = chr(69794)
KAITHI_LETTER_PA = chr(69795)
KAITHI_LETTER_PHA = chr(69796)
KAITHI_LETTER_BA = chr(69797)
KAITHI_LETTER_BHA = chr(69798)
KAITHI_LETTER_MA = chr(69799)
KAITHI_LETTER_YA = chr(69800)
KAITHI_LETTER_RA = chr(69801)
KAITHI_LETTER_LA = chr(69802)
KAITHI_LETTER_VA = chr(69803)
KAITHI_LETTER_SHA = chr(69804)
KAITHI_LETTER_SSA = chr(69805)
KAITHI_LETTER_SA = chr(69806)
KAITHI_LETTER_HA = chr(69807)
KAITHI_VOWEL_SIGN_AA = chr(69808)
KAITHI_VOWEL_SIGN_I = chr(69809)
KAITHI_VOWEL_SIGN_II = chr(69810)
KAITHI_VOWEL_SIGN_U = chr(69811)
KAITHI_VOWEL_SIGN_UU = chr(69812)
KAITHI_VOWEL_SIGN_E = chr(69813)
KAITHI_VOWEL_SIGN_AI = chr(69814)
KAITHI_VOWEL_SIGN_O = chr(69815)
KAITHI_VOWEL_SIGN_AU = chr(69816)
KAITHI_SIGN_VIRAMA = chr(69817)
KAITHI_SIGN_NUKTA = chr(69818)
KAITHI_ABBREVIATION_SIGN = chr(69819)
KAITHI_ENUMERATION_SIGN = chr(69820)
KAITHI_NUMBER_SIGN = chr(69821)
KAITHI_SECTION_MARK = chr(69822)
KAITHI_DOUBLE_SECTION_MARK = chr(69823)
KAITHI_DANDA = chr(69824)
KAITHI_DOUBLE_DANDA = chr(69825)
KAITHI_VOWEL_SIGN_VOCALIC_R = chr(69826)
KAITHI_NUMBER_SIGN_ABOVE = chr(69837)
SORA_SOMPENG_LETTER_SAH = chr(69840)
SORA_SOMPENG_LETTER_TAH = chr(69841)
SORA_SOMPENG_LETTER_BAH = chr(69842)
SORA_SOMPENG_LETTER_CAH = chr(69843)
SORA_SOMPENG_LETTER_DAH = chr(69844)
SORA_SOMPENG_LETTER_GAH = chr(69845)
SORA_SOMPENG_LETTER_MAH = chr(69846)
SORA_SOMPENG_LETTER_NGAH = chr(69847)
SORA_SOMPENG_LETTER_LAH = chr(69848)
SORA_SOMPENG_LETTER_NAH = chr(69849)
SORA_SOMPENG_LETTER_VAH = chr(69850)
SORA_SOMPENG_LETTER_PAH = chr(69851)
SORA_SOMPENG_LETTER_YAH = chr(69852)
SORA_SOMPENG_LETTER_RAH = chr(69853)
SORA_SOMPENG_LETTER_HAH = chr(69854)
SORA_SOMPENG_LETTER_KAH = chr(69855)
SORA_SOMPENG_LETTER_JAH = chr(69856)
SORA_SOMPENG_LETTER_NYAH = chr(69857)
SORA_SOMPENG_LETTER_AH = chr(69858)
SORA_SOMPENG_LETTER_EEH = chr(69859)
SORA_SOMPENG_LETTER_IH = chr(69860)
SORA_SOMPENG_LETTER_UH = chr(69861)
SORA_SOMPENG_LETTER_OH = chr(69862)
SORA_SOMPENG_LETTER_EH = chr(69863)
SORA_SOMPENG_LETTER_MAE = chr(69864)
SORA_SOMPENG_DIGIT_ZERO = chr(69872)
SORA_SOMPENG_DIGIT_ONE = chr(69873)
SORA_SOMPENG_DIGIT_TWO = chr(69874)
SORA_SOMPENG_DIGIT_THREE = chr(69875)
SORA_SOMPENG_DIGIT_FOUR = chr(69876)
SORA_SOMPENG_DIGIT_FIVE = chr(69877)
SORA_SOMPENG_DIGIT_SIX = chr(69878)
SORA_SOMPENG_DIGIT_SEVEN = chr(69879)
SORA_SOMPENG_DIGIT_EIGHT = chr(69880)
SORA_SOMPENG_DIGIT_NINE = chr(69881)
CHAKMA_SIGN_CANDRABINDU = chr(69888)
CHAKMA_SIGN_ANUSVARA = chr(69889)
CHAKMA_SIGN_VISARGA = chr(69890)
CHAKMA_LETTER_AA = chr(69891)
CHAKMA_LETTER_I = chr(69892)
CHAKMA_LETTER_U = chr(69893)
CHAKMA_LETTER_E = chr(69894)
CHAKMA_LETTER_KAA = chr(69895)
CHAKMA_LETTER_KHAA = chr(69896)
CHAKMA_LETTER_GAA = chr(69897)
CHAKMA_LETTER_GHAA = chr(69898)
CHAKMA_LETTER_NGAA = chr(69899)
CHAKMA_LETTER_CAA = chr(69900)
CHAKMA_LETTER_CHAA = chr(69901)
CHAKMA_LETTER_JAA = chr(69902)
CHAKMA_LETTER_JHAA = chr(69903)
CHAKMA_LETTER_NYAA = chr(69904)
CHAKMA_LETTER_TTAA = chr(69905)
CHAKMA_LETTER_TTHAA = chr(69906)
CHAKMA_LETTER_DDAA = chr(69907)
CHAKMA_LETTER_DDHAA = chr(69908)
CHAKMA_LETTER_NNAA = chr(69909)
CHAKMA_LETTER_TAA = chr(69910)
CHAKMA_LETTER_THAA = chr(69911)
CHAKMA_LETTER_DAA = chr(69912)
CHAKMA_LETTER_DHAA = chr(69913)
CHAKMA_LETTER_NAA = chr(69914)
CHAKMA_LETTER_PAA = chr(69915)
CHAKMA_LETTER_PHAA = chr(69916)
CHAKMA_LETTER_BAA = chr(69917)
CHAKMA_LETTER_BHAA = chr(69918)
CHAKMA_LETTER_MAA = chr(69919)
CHAKMA_LETTER_YYAA = chr(69920)
CHAKMA_LETTER_YAA = chr(69921)
CHAKMA_LETTER_RAA = chr(69922)
CHAKMA_LETTER_LAA = chr(69923)
CHAKMA_LETTER_WAA = chr(69924)
CHAKMA_LETTER_SAA = chr(69925)
CHAKMA_LETTER_HAA = chr(69926)
CHAKMA_VOWEL_SIGN_A = chr(69927)
CHAKMA_VOWEL_SIGN_I = chr(69928)
CHAKMA_VOWEL_SIGN_II = chr(69929)
CHAKMA_VOWEL_SIGN_U = chr(69930)
CHAKMA_VOWEL_SIGN_UU = chr(69931)
CHAKMA_VOWEL_SIGN_E = chr(69932)
CHAKMA_VOWEL_SIGN_AI = chr(69933)
CHAKMA_VOWEL_SIGN_O = chr(69934)
CHAKMA_VOWEL_SIGN_AU = chr(69935)
CHAKMA_VOWEL_SIGN_OI = chr(69936)
CHAKMA_O_MARK = chr(69937)
CHAKMA_AU_MARK = chr(69938)
CHAKMA_VIRAMA = chr(69939)
CHAKMA_MAAYYAA = chr(69940)
CHAKMA_DIGIT_ZERO = chr(69942)
CHAKMA_DIGIT_ONE = chr(69943)
CHAKMA_DIGIT_TWO = chr(69944)
CHAKMA_DIGIT_THREE = chr(69945)
CHAKMA_DIGIT_FOUR = chr(69946)
CHAKMA_DIGIT_FIVE = chr(69947)
CHAKMA_DIGIT_SIX = chr(69948)
CHAKMA_DIGIT_SEVEN = chr(69949)
CHAKMA_DIGIT_EIGHT = chr(69950)
CHAKMA_DIGIT_NINE = chr(69951)
CHAKMA_SECTION_MARK = chr(69952)
CHAKMA_DANDA = chr(69953)
CHAKMA_DOUBLE_DANDA = chr(69954)
CHAKMA_QUESTION_MARK = chr(69955)
CHAKMA_LETTER_LHAA = chr(69956)
CHAKMA_VOWEL_SIGN_AA = chr(69957)
CHAKMA_VOWEL_SIGN_EI = chr(69958)
CHAKMA_LETTER_VAA = chr(69959)
MAHAJANI_LETTER_A = chr(69968)
MAHAJANI_LETTER_I = chr(69969)
MAHAJANI_LETTER_U = chr(69970)
MAHAJANI_LETTER_E = chr(69971)
MAHAJANI_LETTER_O = chr(69972)
MAHAJANI_LETTER_KA = chr(69973)
MAHAJANI_LETTER_KHA = chr(69974)
MAHAJANI_LETTER_GA = chr(69975)
MAHAJANI_LETTER_GHA = chr(69976)
MAHAJANI_LETTER_CA = chr(69977)
MAHAJANI_LETTER_CHA = chr(69978)
MAHAJANI_LETTER_JA = chr(69979)
MAHAJANI_LETTER_JHA = chr(69980)
MAHAJANI_LETTER_NYA = chr(69981)
MAHAJANI_LETTER_TTA = chr(69982)
MAHAJANI_LETTER_TTHA = chr(69983)
MAHAJANI_LETTER_DDA = chr(69984)
MAHAJANI_LETTER_DDHA = chr(69985)
MAHAJANI_LETTER_NNA = chr(69986)
MAHAJANI_LETTER_TA = chr(69987)
MAHAJANI_LETTER_THA = chr(69988)
MAHAJANI_LETTER_DA = chr(69989)
MAHAJANI_LETTER_DHA = chr(69990)
MAHAJANI_LETTER_NA = chr(69991)
MAHAJANI_LETTER_PA = chr(69992)
MAHAJANI_LETTER_PHA = chr(69993)
MAHAJANI_LETTER_BA = chr(69994)
MAHAJANI_LETTER_BHA = chr(69995)
MAHAJANI_LETTER_MA = chr(69996)
MAHAJANI_LETTER_RA = chr(69997)
MAHAJANI_LETTER_LA = chr(69998)
MAHAJANI_LETTER_VA = chr(69999)
MAHAJANI_LETTER_SA = chr(70000)
MAHAJANI_LETTER_HA = chr(70001)
MAHAJANI_LETTER_RRA = chr(70002)
MAHAJANI_SIGN_NUKTA = chr(70003)
MAHAJANI_ABBREVIATION_SIGN = chr(70004)
MAHAJANI_SECTION_MARK = chr(70005)
MAHAJANI_LIGATURE_SHRI = chr(70006)
SHARADA_SIGN_CANDRABINDU = chr(70016)
SHARADA_SIGN_ANUSVARA = chr(70017)
SHARADA_SIGN_VISARGA = chr(70018)
SHARADA_LETTER_A = chr(70019)
SHARADA_LETTER_AA = chr(70020)
SHARADA_LETTER_I = chr(70021)
SHARADA_LETTER_II = chr(70022)
SHARADA_LETTER_U = chr(70023)
SHARADA_LETTER_UU = chr(70024)
SHARADA_LETTER_VOCALIC_R = chr(70025)
SHARADA_LETTER_VOCALIC_RR = chr(70026)
SHARADA_LETTER_VOCALIC_L = chr(70027)
SHARADA_LETTER_VOCALIC_LL = chr(70028)
SHARADA_LETTER_E = chr(70029)
SHARADA_LETTER_AI = chr(70030)
SHARADA_LETTER_O = chr(70031)
SHARADA_LETTER_AU = chr(70032)
SHARADA_LETTER_KA = chr(70033)
SHARADA_LETTER_KHA = chr(70034)
SHARADA_LETTER_GA = chr(70035)
SHARADA_LETTER_GHA = chr(70036)
SHARADA_LETTER_NGA = chr(70037)
SHARADA_LETTER_CA = chr(70038)
SHARADA_LETTER_CHA = chr(70039)
SHARADA_LETTER_JA = chr(70040)
SHARADA_LETTER_JHA = chr(70041)
SHARADA_LETTER_NYA = chr(70042)
SHARADA_LETTER_TTA = chr(70043)
SHARADA_LETTER_TTHA = chr(70044)
SHARADA_LETTER_DDA = chr(70045)
SHARADA_LETTER_DDHA = chr(70046)
SHARADA_LETTER_NNA = chr(70047)
SHARADA_LETTER_TA = chr(70048)
SHARADA_LETTER_THA = chr(70049)
SHARADA_LETTER_DA = chr(70050)
SHARADA_LETTER_DHA = chr(70051)
SHARADA_LETTER_NA = chr(70052)
SHARADA_LETTER_PA = chr(70053)
SHARADA_LETTER_PHA = chr(70054)
SHARADA_LETTER_BA = chr(70055)
SHARADA_LETTER_BHA = chr(70056)
SHARADA_LETTER_MA = chr(70057)
SHARADA_LETTER_YA = chr(70058)
SHARADA_LETTER_RA = chr(70059)
SHARADA_LETTER_LA = chr(70060)
SHARADA_LETTER_LLA = chr(70061)
SHARADA_LETTER_VA = chr(70062)
SHARADA_LETTER_SHA = chr(70063)
SHARADA_LETTER_SSA = chr(70064)
SHARADA_LETTER_SA = chr(70065)
SHARADA_LETTER_HA = chr(70066)
SHARADA_VOWEL_SIGN_AA = chr(70067)
SHARADA_VOWEL_SIGN_I = chr(70068)
SHARADA_VOWEL_SIGN_II = chr(70069)
SHARADA_VOWEL_SIGN_U = chr(70070)
SHARADA_VOWEL_SIGN_UU = chr(70071)
SHARADA_VOWEL_SIGN_VOCALIC_R = chr(70072)
SHARADA_VOWEL_SIGN_VOCALIC_RR = chr(70073)
SHARADA_VOWEL_SIGN_VOCALIC_L = chr(70074)
SHARADA_VOWEL_SIGN_VOCALIC_LL = chr(70075)
SHARADA_VOWEL_SIGN_E = chr(70076)
SHARADA_VOWEL_SIGN_AI = chr(70077)
SHARADA_VOWEL_SIGN_O = chr(70078)
SHARADA_VOWEL_SIGN_AU = chr(70079)
SHARADA_SIGN_VIRAMA = chr(70080)
SHARADA_SIGN_AVAGRAHA = chr(70081)
SHARADA_SIGN_JIHVAMULIYA = chr(70082)
SHARADA_SIGN_UPADHMANIYA = chr(70083)
SHARADA_OM = chr(70084)
SHARADA_DANDA = chr(70085)
SHARADA_DOUBLE_DANDA = chr(70086)
SHARADA_ABBREVIATION_SIGN = chr(70087)
SHARADA_SEPARATOR = chr(70088)
SHARADA_SANDHI_MARK = chr(70089)
SHARADA_SIGN_NUKTA = chr(70090)
SHARADA_VOWEL_MODIFIER_MARK = chr(70091)
SHARADA_EXTRA_SHORT_VOWEL_MARK = chr(70092)
SHARADA_SUTRA_MARK = chr(70093)
SHARADA_VOWEL_SIGN_PRISHTHAMATRA_E = chr(70094)
SHARADA_SIGN_INVERTED_CANDRABINDU = chr(70095)
SHARADA_DIGIT_ZERO = chr(70096)
SHARADA_DIGIT_ONE = chr(70097)
SHARADA_DIGIT_TWO = chr(70098)
SHARADA_DIGIT_THREE = chr(70099)
SHARADA_DIGIT_FOUR = chr(70100)
SHARADA_DIGIT_FIVE = chr(70101)
SHARADA_DIGIT_SIX = chr(70102)
SHARADA_DIGIT_SEVEN = chr(70103)
SHARADA_DIGIT_EIGHT = chr(70104)
SHARADA_DIGIT_NINE = chr(70105)
SHARADA_EKAM = chr(70106)
SHARADA_SIGN_SIDDHAM = chr(70107)
SHARADA_HEADSTROKE = chr(70108)
SHARADA_CONTINUATION_SIGN = chr(70109)
SHARADA_SECTION_MARK_1 = chr(70110)
SHARADA_SECTION_MARK_2 = chr(70111)
SINHALA_ARCHAIC_DIGIT_ONE = chr(70113)
SINHALA_ARCHAIC_DIGIT_TWO = chr(70114)
SINHALA_ARCHAIC_DIGIT_THREE = chr(70115)
SINHALA_ARCHAIC_DIGIT_FOUR = chr(70116)
SINHALA_ARCHAIC_DIGIT_FIVE = chr(70117)
SINHALA_ARCHAIC_DIGIT_SIX = chr(70118)
SINHALA_ARCHAIC_DIGIT_SEVEN = chr(70119)
SINHALA_ARCHAIC_DIGIT_EIGHT = chr(70120)
SINHALA_ARCHAIC_DIGIT_NINE = chr(70121)
SINHALA_ARCHAIC_NUMBER_TEN = chr(70122)
SINHALA_ARCHAIC_NUMBER_TWENTY = chr(70123)
SINHALA_ARCHAIC_NUMBER_THIRTY = chr(70124)
SINHALA_ARCHAIC_NUMBER_FORTY = chr(70125)
SINHALA_ARCHAIC_NUMBER_FIFTY = chr(70126)
SINHALA_ARCHAIC_NUMBER_SIXTY = chr(70127)
SINHALA_ARCHAIC_NUMBER_SEVENTY = chr(70128)
SINHALA_ARCHAIC_NUMBER_EIGHTY = chr(70129)
SINHALA_ARCHAIC_NUMBER_NINETY = chr(70130)
SINHALA_ARCHAIC_NUMBER_ONE_HUNDRED = chr(70131)
SINHALA_ARCHAIC_NUMBER_ONE_THOUSAND = chr(70132)
KHOJKI_LETTER_A = chr(70144)
KHOJKI_LETTER_AA = chr(70145)
KHOJKI_LETTER_I = chr(70146)
KHOJKI_LETTER_U = chr(70147)
KHOJKI_LETTER_E = chr(70148)
KHOJKI_LETTER_AI = chr(70149)
KHOJKI_LETTER_O = chr(70150)
KHOJKI_LETTER_AU = chr(70151)
KHOJKI_LETTER_KA = chr(70152)
KHOJKI_LETTER_KHA = chr(70153)
KHOJKI_LETTER_GA = chr(70154)
KHOJKI_LETTER_GGA = chr(70155)
KHOJKI_LETTER_GHA = chr(70156)
KHOJKI_LETTER_NGA = chr(70157)
KHOJKI_LETTER_CA = chr(70158)
KHOJKI_LETTER_CHA = chr(70159)
KHOJKI_LETTER_JA = chr(70160)
KHOJKI_LETTER_JJA = chr(70161)
KHOJKI_LETTER_NYA = chr(70163)
KHOJKI_LETTER_TTA = chr(70164)
KHOJKI_LETTER_TTHA = chr(70165)
KHOJKI_LETTER_DDA = chr(70166)
KHOJKI_LETTER_DDHA = chr(70167)
KHOJKI_LETTER_NNA = chr(70168)
KHOJKI_LETTER_TA = chr(70169)
KHOJKI_LETTER_THA = chr(70170)
KHOJKI_LETTER_DA = chr(70171)
KHOJKI_LETTER_DDDA = chr(70172)
KHOJKI_LETTER_DHA = chr(70173)
KHOJKI_LETTER_NA = chr(70174)
KHOJKI_LETTER_PA = chr(70175)
KHOJKI_LETTER_PHA = chr(70176)
KHOJKI_LETTER_BA = chr(70177)
KHOJKI_LETTER_BBA = chr(70178)
KHOJKI_LETTER_BHA = chr(70179)
KHOJKI_LETTER_MA = chr(70180)
KHOJKI_LETTER_YA = chr(70181)
KHOJKI_LETTER_RA = chr(70182)
KHOJKI_LETTER_LA = chr(70183)
KHOJKI_LETTER_VA = chr(70184)
KHOJKI_LETTER_SA = chr(70185)
KHOJKI_LETTER_HA = chr(70186)
KHOJKI_LETTER_LLA = chr(70187)
KHOJKI_VOWEL_SIGN_AA = chr(70188)
KHOJKI_VOWEL_SIGN_I = chr(70189)
KHOJKI_VOWEL_SIGN_II = chr(70190)
KHOJKI_VOWEL_SIGN_U = chr(70191)
KHOJKI_VOWEL_SIGN_E = chr(70192)
KHOJKI_VOWEL_SIGN_AI = chr(70193)
KHOJKI_VOWEL_SIGN_O = chr(70194)
KHOJKI_VOWEL_SIGN_AU = chr(70195)
KHOJKI_SIGN_ANUSVARA = chr(70196)
KHOJKI_SIGN_VIRAMA = chr(70197)
KHOJKI_SIGN_NUKTA = chr(70198)
KHOJKI_SIGN_SHADDA = chr(70199)
KHOJKI_DANDA = chr(70200)
KHOJKI_DOUBLE_DANDA = chr(70201)
KHOJKI_WORD_SEPARATOR = chr(70202)
KHOJKI_SECTION_MARK = chr(70203)
KHOJKI_DOUBLE_SECTION_MARK = chr(70204)
KHOJKI_ABBREVIATION_SIGN = chr(70205)
KHOJKI_SIGN_SUKUN = chr(70206)
KHOJKI_LETTER_QA = chr(70207)
KHOJKI_LETTER_SHORT_I = chr(70208)
KHOJKI_VOWEL_SIGN_VOCALIC_R = chr(70209)
MULTANI_LETTER_A = chr(70272)
MULTANI_LETTER_I = chr(70273)
MULTANI_LETTER_U = chr(70274)
MULTANI_LETTER_E = chr(70275)
MULTANI_LETTER_KA = chr(70276)
MULTANI_LETTER_KHA = chr(70277)
MULTANI_LETTER_GA = chr(70278)
MULTANI_LETTER_GHA = chr(70280)
MULTANI_LETTER_CA = chr(70282)
MULTANI_LETTER_CHA = chr(70283)
MULTANI_LETTER_JA = chr(70284)
MULTANI_LETTER_JJA = chr(70285)
MULTANI_LETTER_NYA = chr(70287)
MULTANI_LETTER_TTA = chr(70288)
MULTANI_LETTER_TTHA = chr(70289)
MULTANI_LETTER_DDA = chr(70290)
MULTANI_LETTER_DDDA = chr(70291)
MULTANI_LETTER_DDHA = chr(70292)
MULTANI_LETTER_NNA = chr(70293)
MULTANI_LETTER_TA = chr(70294)
MULTANI_LETTER_THA = chr(70295)
MULTANI_LETTER_DA = chr(70296)
MULTANI_LETTER_DHA = chr(70297)
MULTANI_LETTER_NA = chr(70298)
MULTANI_LETTER_PA = chr(70299)
MULTANI_LETTER_PHA = chr(70300)
MULTANI_LETTER_BA = chr(70301)
MULTANI_LETTER_BHA = chr(70303)
MULTANI_LETTER_MA = chr(70304)
MULTANI_LETTER_YA = chr(70305)
MULTANI_LETTER_RA = chr(70306)
MULTANI_LETTER_LA = chr(70307)
MULTANI_LETTER_VA = chr(70308)
MULTANI_LETTER_SA = chr(70309)
MULTANI_LETTER_HA = chr(70310)
MULTANI_LETTER_RRA = chr(70311)
MULTANI_LETTER_RHA = chr(70312)
MULTANI_SECTION_MARK = chr(70313)
KHUDAWADI_LETTER_A = chr(70320)
KHUDAWADI_LETTER_AA = chr(70321)
KHUDAWADI_LETTER_I = chr(70322)
KHUDAWADI_LETTER_II = chr(70323)
KHUDAWADI_LETTER_U = chr(70324)
KHUDAWADI_LETTER_UU = chr(70325)
KHUDAWADI_LETTER_E = chr(70326)
KHUDAWADI_LETTER_AI = chr(70327)
KHUDAWADI_LETTER_O = chr(70328)
KHUDAWADI_LETTER_AU = chr(70329)
KHUDAWADI_LETTER_KA = chr(70330)
KHUDAWADI_LETTER_KHA = chr(70331)
KHUDAWADI_LETTER_GA = chr(70332)
KHUDAWADI_LETTER_GGA = chr(70333)
KHUDAWADI_LETTER_GHA = chr(70334)
KHUDAWADI_LETTER_NGA = chr(70335)
KHUDAWADI_LETTER_CA = chr(70336)
KHUDAWADI_LETTER_CHA = chr(70337)
KHUDAWADI_LETTER_JA = chr(70338)
KHUDAWADI_LETTER_JJA = chr(70339)
KHUDAWADI_LETTER_JHA = chr(70340)
KHUDAWADI_LETTER_NYA = chr(70341)
KHUDAWADI_LETTER_TTA = chr(70342)
KHUDAWADI_LETTER_TTHA = chr(70343)
KHUDAWADI_LETTER_DDA = chr(70344)
KHUDAWADI_LETTER_DDDA = chr(70345)
KHUDAWADI_LETTER_RRA = chr(70346)
KHUDAWADI_LETTER_DDHA = chr(70347)
KHUDAWADI_LETTER_NNA = chr(70348)
KHUDAWADI_LETTER_TA = chr(70349)
KHUDAWADI_LETTER_THA = chr(70350)
KHUDAWADI_LETTER_DA = chr(70351)
KHUDAWADI_LETTER_DHA = chr(70352)
KHUDAWADI_LETTER_NA = chr(70353)
KHUDAWADI_LETTER_PA = chr(70354)
KHUDAWADI_LETTER_PHA = chr(70355)
KHUDAWADI_LETTER_BA = chr(70356)
KHUDAWADI_LETTER_BBA = chr(70357)
KHUDAWADI_LETTER_BHA = chr(70358)
KHUDAWADI_LETTER_MA = chr(70359)
KHUDAWADI_LETTER_YA = chr(70360)
KHUDAWADI_LETTER_RA = chr(70361)
KHUDAWADI_LETTER_LA = chr(70362)
KHUDAWADI_LETTER_VA = chr(70363)
KHUDAWADI_LETTER_SHA = chr(70364)
KHUDAWADI_LETTER_SA = chr(70365)
KHUDAWADI_LETTER_HA = chr(70366)
KHUDAWADI_SIGN_ANUSVARA = chr(70367)
KHUDAWADI_VOWEL_SIGN_AA = chr(70368)
KHUDAWADI_VOWEL_SIGN_I = chr(70369)
KHUDAWADI_VOWEL_SIGN_II = chr(70370)
KHUDAWADI_VOWEL_SIGN_U = chr(70371)
KHUDAWADI_VOWEL_SIGN_UU = chr(70372)
KHUDAWADI_VOWEL_SIGN_E = chr(70373)
KHUDAWADI_VOWEL_SIGN_AI = chr(70374)
KHUDAWADI_VOWEL_SIGN_O = chr(70375)
KHUDAWADI_VOWEL_SIGN_AU = chr(70376)
KHUDAWADI_SIGN_NUKTA = chr(70377)
KHUDAWADI_SIGN_VIRAMA = chr(70378)
KHUDAWADI_DIGIT_ZERO = chr(70384)
KHUDAWADI_DIGIT_ONE = chr(70385)
KHUDAWADI_DIGIT_TWO = chr(70386)
KHUDAWADI_DIGIT_THREE = chr(70387)
KHUDAWADI_DIGIT_FOUR = chr(70388)
KHUDAWADI_DIGIT_FIVE = chr(70389)
KHUDAWADI_DIGIT_SIX = chr(70390)
KHUDAWADI_DIGIT_SEVEN = chr(70391)
KHUDAWADI_DIGIT_EIGHT = chr(70392)
KHUDAWADI_DIGIT_NINE = chr(70393)
GRANTHA_SIGN_COMBINING_ANUSVARA_ABOVE = chr(70400)
GRANTHA_SIGN_CANDRABINDU = chr(70401)
GRANTHA_SIGN_ANUSVARA = chr(70402)
GRANTHA_SIGN_VISARGA = chr(70403)
GRANTHA_LETTER_A = chr(70405)
GRANTHA_LETTER_AA = chr(70406)
GRANTHA_LETTER_I = chr(70407)
GRANTHA_LETTER_II = chr(70408)
GRANTHA_LETTER_U = chr(70409)
GRANTHA_LETTER_UU = chr(70410)
GRANTHA_LETTER_VOCALIC_R = chr(70411)
GRANTHA_LETTER_VOCALIC_L = chr(70412)
GRANTHA_LETTER_EE = chr(70415)
GRANTHA_LETTER_AI = chr(70416)
GRANTHA_LETTER_OO = chr(70419)
GRANTHA_LETTER_AU = chr(70420)
GRANTHA_LETTER_KA = chr(70421)
GRANTHA_LETTER_KHA = chr(70422)
GRANTHA_LETTER_GA = chr(70423)
GRANTHA_LETTER_GHA = chr(70424)
GRANTHA_LETTER_NGA = chr(70425)
GRANTHA_LETTER_CA = chr(70426)
GRANTHA_LETTER_CHA = chr(70427)
GRANTHA_LETTER_JA = chr(70428)
GRANTHA_LETTER_JHA = chr(70429)
GRANTHA_LETTER_NYA = chr(70430)
GRANTHA_LETTER_TTA = chr(70431)
GRANTHA_LETTER_TTHA = chr(70432)
GRANTHA_LETTER_DDA = chr(70433)
GRANTHA_LETTER_DDHA = chr(70434)
GRANTHA_LETTER_NNA = chr(70435)
GRANTHA_LETTER_TA = chr(70436)
GRANTHA_LETTER_THA = chr(70437)
GRANTHA_LETTER_DA = chr(70438)
GRANTHA_LETTER_DHA = chr(70439)
GRANTHA_LETTER_NA = chr(70440)
GRANTHA_LETTER_PA = chr(70442)
GRANTHA_LETTER_PHA = chr(70443)
GRANTHA_LETTER_BA = chr(70444)
GRANTHA_LETTER_BHA = chr(70445)
GRANTHA_LETTER_MA = chr(70446)
GRANTHA_LETTER_YA = chr(70447)
GRANTHA_LETTER_RA = chr(70448)
GRANTHA_LETTER_LA = chr(70450)
GRANTHA_LETTER_LLA = chr(70451)
GRANTHA_LETTER_VA = chr(70453)
GRANTHA_LETTER_SHA = chr(70454)
GRANTHA_LETTER_SSA = chr(70455)
GRANTHA_LETTER_SA = chr(70456)
GRANTHA_LETTER_HA = chr(70457)
COMBINING_BINDU_BELOW = chr(70459)
GRANTHA_SIGN_NUKTA = chr(70460)
GRANTHA_SIGN_AVAGRAHA = chr(70461)
GRANTHA_VOWEL_SIGN_AA = chr(70462)
GRANTHA_VOWEL_SIGN_I = chr(70463)
GRANTHA_VOWEL_SIGN_II = chr(70464)
GRANTHA_VOWEL_SIGN_U = chr(70465)
GRANTHA_VOWEL_SIGN_UU = chr(70466)
GRANTHA_VOWEL_SIGN_VOCALIC_R = chr(70467)
GRANTHA_VOWEL_SIGN_VOCALIC_RR = chr(70468)
GRANTHA_VOWEL_SIGN_EE = chr(70471)
GRANTHA_VOWEL_SIGN_AI = chr(70472)
GRANTHA_VOWEL_SIGN_OO = chr(70475)
GRANTHA_VOWEL_SIGN_AU = chr(70476)
GRANTHA_SIGN_VIRAMA = chr(70477)
GRANTHA_OM = chr(70480)
GRANTHA_AU_LENGTH_MARK = chr(70487)
GRANTHA_SIGN_PLUTA = chr(70493)
GRANTHA_LETTER_VEDIC_ANUSVARA = chr(70494)
GRANTHA_LETTER_VEDIC_DOUBLE_ANUSVARA = chr(70495)
GRANTHA_LETTER_VOCALIC_RR = chr(70496)
GRANTHA_LETTER_VOCALIC_LL = chr(70497)
GRANTHA_VOWEL_SIGN_VOCALIC_L = chr(70498)
GRANTHA_VOWEL_SIGN_VOCALIC_LL = chr(70499)
COMBINING_GRANTHA_DIGIT_ZERO = chr(70502)
COMBINING_GRANTHA_DIGIT_ONE = chr(70503)
COMBINING_GRANTHA_DIGIT_TWO = chr(70504)
COMBINING_GRANTHA_DIGIT_THREE = chr(70505)
COMBINING_GRANTHA_DIGIT_FOUR = chr(70506)
COMBINING_GRANTHA_DIGIT_FIVE = chr(70507)
COMBINING_GRANTHA_DIGIT_SIX = chr(70508)
COMBINING_GRANTHA_LETTER_A = chr(70512)
COMBINING_GRANTHA_LETTER_KA = chr(70513)
COMBINING_GRANTHA_LETTER_NA = chr(70514)
COMBINING_GRANTHA_LETTER_VI = chr(70515)
COMBINING_GRANTHA_LETTER_PA = chr(70516)
NEWA_LETTER_A = chr(70656)
NEWA_LETTER_AA = chr(70657)
NEWA_LETTER_I = chr(70658)
NEWA_LETTER_II = chr(70659)
NEWA_LETTER_U = chr(70660)
NEWA_LETTER_UU = chr(70661)
NEWA_LETTER_VOCALIC_R = chr(70662)
NEWA_LETTER_VOCALIC_RR = chr(70663)
NEWA_LETTER_VOCALIC_L = chr(70664)
NEWA_LETTER_VOCALIC_LL = chr(70665)
NEWA_LETTER_E = chr(70666)
NEWA_LETTER_AI = chr(70667)
NEWA_LETTER_O = chr(70668)
NEWA_LETTER_AU = chr(70669)
NEWA_LETTER_KA = chr(70670)
NEWA_LETTER_KHA = chr(70671)
NEWA_LETTER_GA = chr(70672)
NEWA_LETTER_GHA = chr(70673)
NEWA_LETTER_NGA = chr(70674)
NEWA_LETTER_NGHA = chr(70675)
NEWA_LETTER_CA = chr(70676)
NEWA_LETTER_CHA = chr(70677)
NEWA_LETTER_JA = chr(70678)
NEWA_LETTER_JHA = chr(70679)
NEWA_LETTER_NYA = chr(70680)
NEWA_LETTER_NYHA = chr(70681)
NEWA_LETTER_TTA = chr(70682)
NEWA_LETTER_TTHA = chr(70683)
NEWA_LETTER_DDA = chr(70684)
NEWA_LETTER_DDHA = chr(70685)
NEWA_LETTER_NNA = chr(70686)
NEWA_LETTER_TA = chr(70687)
NEWA_LETTER_THA = chr(70688)
NEWA_LETTER_DA = chr(70689)
NEWA_LETTER_DHA = chr(70690)
NEWA_LETTER_NA = chr(70691)
NEWA_LETTER_NHA = chr(70692)
NEWA_LETTER_PA = chr(70693)
NEWA_LETTER_PHA = chr(70694)
NEWA_LETTER_BA = chr(70695)
NEWA_LETTER_BHA = chr(70696)
NEWA_LETTER_MA = chr(70697)
NEWA_LETTER_MHA = chr(70698)
NEWA_LETTER_YA = chr(70699)
NEWA_LETTER_RA = chr(70700)
NEWA_LETTER_RHA = chr(70701)
NEWA_LETTER_LA = chr(70702)
NEWA_LETTER_LHA = chr(70703)
NEWA_LETTER_WA = chr(70704)
NEWA_LETTER_SHA = chr(70705)
NEWA_LETTER_SSA = chr(70706)
NEWA_LETTER_SA = chr(70707)
NEWA_LETTER_HA = chr(70708)
NEWA_VOWEL_SIGN_AA = chr(70709)
NEWA_VOWEL_SIGN_I = chr(70710)
NEWA_VOWEL_SIGN_II = chr(70711)
NEWA_VOWEL_SIGN_U = chr(70712)
NEWA_VOWEL_SIGN_UU = chr(70713)
NEWA_VOWEL_SIGN_VOCALIC_R = chr(70714)
NEWA_VOWEL_SIGN_VOCALIC_RR = chr(70715)
NEWA_VOWEL_SIGN_VOCALIC_L = chr(70716)
NEWA_VOWEL_SIGN_VOCALIC_LL = chr(70717)
NEWA_VOWEL_SIGN_E = chr(70718)
NEWA_VOWEL_SIGN_AI = chr(70719)
NEWA_VOWEL_SIGN_O = chr(70720)
NEWA_VOWEL_SIGN_AU = chr(70721)
NEWA_SIGN_VIRAMA = chr(70722)
NEWA_SIGN_CANDRABINDU = chr(70723)
NEWA_SIGN_ANUSVARA = chr(70724)
NEWA_SIGN_VISARGA = chr(70725)
NEWA_SIGN_NUKTA = chr(70726)
NEWA_SIGN_AVAGRAHA = chr(70727)
NEWA_SIGN_FINAL_ANUSVARA = chr(70728)
NEWA_OM = chr(70729)
NEWA_SIDDHI = chr(70730)
NEWA_DANDA = chr(70731)
NEWA_DOUBLE_DANDA = chr(70732)
NEWA_COMMA = chr(70733)
NEWA_GAP_FILLER = chr(70734)
NEWA_ABBREVIATION_SIGN = chr(70735)
NEWA_DIGIT_ZERO = chr(70736)
NEWA_DIGIT_ONE = chr(70737)
NEWA_DIGIT_TWO = chr(70738)
NEWA_DIGIT_THREE = chr(70739)
NEWA_DIGIT_FOUR = chr(70740)
NEWA_DIGIT_FIVE = chr(70741)
NEWA_DIGIT_SIX = chr(70742)
NEWA_DIGIT_SEVEN = chr(70743)
NEWA_DIGIT_EIGHT = chr(70744)
NEWA_DIGIT_NINE = chr(70745)
NEWA_DOUBLE_COMMA = chr(70746)
NEWA_PLACEHOLDER_MARK = chr(70747)
NEWA_INSERTION_SIGN = chr(70749)
NEWA_SANDHI_MARK = chr(70750)
NEWA_LETTER_VEDIC_ANUSVARA = chr(70751)
NEWA_SIGN_JIHVAMULIYA = chr(70752)
NEWA_SIGN_UPADHMANIYA = chr(70753)
TIRHUTA_ANJI = chr(70784)
TIRHUTA_LETTER_A = chr(70785)
TIRHUTA_LETTER_AA = chr(70786)
TIRHUTA_LETTER_I = chr(70787)
TIRHUTA_LETTER_II = chr(70788)
TIRHUTA_LETTER_U = chr(70789)
TIRHUTA_LETTER_UU = chr(70790)
TIRHUTA_LETTER_VOCALIC_R = chr(70791)
TIRHUTA_LETTER_VOCALIC_RR = chr(70792)
TIRHUTA_LETTER_VOCALIC_L = chr(70793)
TIRHUTA_LETTER_VOCALIC_LL = chr(70794)
TIRHUTA_LETTER_E = chr(70795)
TIRHUTA_LETTER_AI = chr(70796)
TIRHUTA_LETTER_O = chr(70797)
TIRHUTA_LETTER_AU = chr(70798)
TIRHUTA_LETTER_KA = chr(70799)
TIRHUTA_LETTER_KHA = chr(70800)
TIRHUTA_LETTER_GA = chr(70801)
TIRHUTA_LETTER_GHA = chr(70802)
TIRHUTA_LETTER_NGA = chr(70803)
TIRHUTA_LETTER_CA = chr(70804)
TIRHUTA_LETTER_CHA = chr(70805)
TIRHUTA_LETTER_JA = chr(70806)
TIRHUTA_LETTER_JHA = chr(70807)
TIRHUTA_LETTER_NYA = chr(70808)
TIRHUTA_LETTER_TTA = chr(70809)
TIRHUTA_LETTER_TTHA = chr(70810)
TIRHUTA_LETTER_DDA = chr(70811)
TIRHUTA_LETTER_DDHA = chr(70812)
TIRHUTA_LETTER_NNA = chr(70813)
TIRHUTA_LETTER_TA = chr(70814)
TIRHUTA_LETTER_THA = chr(70815)
TIRHUTA_LETTER_DA = chr(70816)
TIRHUTA_LETTER_DHA = chr(70817)
TIRHUTA_LETTER_NA = chr(70818)
TIRHUTA_LETTER_PA = chr(70819)
TIRHUTA_LETTER_PHA = chr(70820)
TIRHUTA_LETTER_BA = chr(70821)
TIRHUTA_LETTER_BHA = chr(70822)
TIRHUTA_LETTER_MA = chr(70823)
TIRHUTA_LETTER_YA = chr(70824)
TIRHUTA_LETTER_RA = chr(70825)
TIRHUTA_LETTER_LA = chr(70826)
TIRHUTA_LETTER_VA = chr(70827)
TIRHUTA_LETTER_SHA = chr(70828)
TIRHUTA_LETTER_SSA = chr(70829)
TIRHUTA_LETTER_SA = chr(70830)
TIRHUTA_LETTER_HA = chr(70831)
TIRHUTA_VOWEL_SIGN_AA = chr(70832)
TIRHUTA_VOWEL_SIGN_I = chr(70833)
TIRHUTA_VOWEL_SIGN_II = chr(70834)
TIRHUTA_VOWEL_SIGN_U = chr(70835)
TIRHUTA_VOWEL_SIGN_UU = chr(70836)
TIRHUTA_VOWEL_SIGN_VOCALIC_R = chr(70837)
TIRHUTA_VOWEL_SIGN_VOCALIC_RR = chr(70838)
TIRHUTA_VOWEL_SIGN_VOCALIC_L = chr(70839)
TIRHUTA_VOWEL_SIGN_VOCALIC_LL = chr(70840)
TIRHUTA_VOWEL_SIGN_E = chr(70841)
TIRHUTA_VOWEL_SIGN_SHORT_E = chr(70842)
TIRHUTA_VOWEL_SIGN_AI = chr(70843)
TIRHUTA_VOWEL_SIGN_O = chr(70844)
TIRHUTA_VOWEL_SIGN_SHORT_O = chr(70845)
TIRHUTA_VOWEL_SIGN_AU = chr(70846)
TIRHUTA_SIGN_CANDRABINDU = chr(70847)
TIRHUTA_SIGN_ANUSVARA = chr(70848)
TIRHUTA_SIGN_VISARGA = chr(70849)
TIRHUTA_SIGN_VIRAMA = chr(70850)
TIRHUTA_SIGN_NUKTA = chr(70851)
TIRHUTA_SIGN_AVAGRAHA = chr(70852)
TIRHUTA_GVANG = chr(70853)
TIRHUTA_ABBREVIATION_SIGN = chr(70854)
TIRHUTA_OM = chr(70855)
TIRHUTA_DIGIT_ZERO = chr(70864)
TIRHUTA_DIGIT_ONE = chr(70865)
TIRHUTA_DIGIT_TWO = chr(70866)
TIRHUTA_DIGIT_THREE = chr(70867)
TIRHUTA_DIGIT_FOUR = chr(70868)
TIRHUTA_DIGIT_FIVE = chr(70869)
TIRHUTA_DIGIT_SIX = chr(70870)
TIRHUTA_DIGIT_SEVEN = chr(70871)
TIRHUTA_DIGIT_EIGHT = chr(70872)
TIRHUTA_DIGIT_NINE = chr(70873)
SIDDHAM_LETTER_A = chr(71040)
SIDDHAM_LETTER_AA = chr(71041)
SIDDHAM_LETTER_I = chr(71042)
SIDDHAM_LETTER_II = chr(71043)
SIDDHAM_LETTER_U = chr(71044)
SIDDHAM_LETTER_UU = chr(71045)
SIDDHAM_LETTER_VOCALIC_R = chr(71046)
SIDDHAM_LETTER_VOCALIC_RR = chr(71047)
SIDDHAM_LETTER_VOCALIC_L = chr(71048)
SIDDHAM_LETTER_VOCALIC_LL = chr(71049)
SIDDHAM_LETTER_E = chr(71050)
SIDDHAM_LETTER_AI = chr(71051)
SIDDHAM_LETTER_O = chr(71052)
SIDDHAM_LETTER_AU = chr(71053)
SIDDHAM_LETTER_KA = chr(71054)
SIDDHAM_LETTER_KHA = chr(71055)
SIDDHAM_LETTER_GA = chr(71056)
SIDDHAM_LETTER_GHA = chr(71057)
SIDDHAM_LETTER_NGA = chr(71058)
SIDDHAM_LETTER_CA = chr(71059)
SIDDHAM_LETTER_CHA = chr(71060)
SIDDHAM_LETTER_JA = chr(71061)
SIDDHAM_LETTER_JHA = chr(71062)
SIDDHAM_LETTER_NYA = chr(71063)
SIDDHAM_LETTER_TTA = chr(71064)
SIDDHAM_LETTER_TTHA = chr(71065)
SIDDHAM_LETTER_DDA = chr(71066)
SIDDHAM_LETTER_DDHA = chr(71067)
SIDDHAM_LETTER_NNA = chr(71068)
SIDDHAM_LETTER_TA = chr(71069)
SIDDHAM_LETTER_THA = chr(71070)
SIDDHAM_LETTER_DA = chr(71071)
SIDDHAM_LETTER_DHA = chr(71072)
SIDDHAM_LETTER_NA = chr(71073)
SIDDHAM_LETTER_PA = chr(71074)
SIDDHAM_LETTER_PHA = chr(71075)
SIDDHAM_LETTER_BA = chr(71076)
SIDDHAM_LETTER_BHA = chr(71077)
SIDDHAM_LETTER_MA = chr(71078)
SIDDHAM_LETTER_YA = chr(71079)
SIDDHAM_LETTER_RA = chr(71080)
SIDDHAM_LETTER_LA = chr(71081)
SIDDHAM_LETTER_VA = chr(71082)
SIDDHAM_LETTER_SHA = chr(71083)
SIDDHAM_LETTER_SSA = chr(71084)
SIDDHAM_LETTER_SA = chr(71085)
SIDDHAM_LETTER_HA = chr(71086)
SIDDHAM_VOWEL_SIGN_AA = chr(71087)
SIDDHAM_VOWEL_SIGN_I = chr(71088)
SIDDHAM_VOWEL_SIGN_II = chr(71089)
SIDDHAM_VOWEL_SIGN_U = chr(71090)
SIDDHAM_VOWEL_SIGN_UU = chr(71091)
SIDDHAM_VOWEL_SIGN_VOCALIC_R = chr(71092)
SIDDHAM_VOWEL_SIGN_VOCALIC_RR = chr(71093)
SIDDHAM_VOWEL_SIGN_E = chr(71096)
SIDDHAM_VOWEL_SIGN_AI = chr(71097)
SIDDHAM_VOWEL_SIGN_O = chr(71098)
SIDDHAM_VOWEL_SIGN_AU = chr(71099)
SIDDHAM_SIGN_CANDRABINDU = chr(71100)
SIDDHAM_SIGN_ANUSVARA = chr(71101)
SIDDHAM_SIGN_VISARGA = chr(71102)
SIDDHAM_SIGN_VIRAMA = chr(71103)
SIDDHAM_SIGN_NUKTA = chr(71104)
SIDDHAM_SIGN_SIDDHAM = chr(71105)
SIDDHAM_DANDA = chr(71106)
SIDDHAM_DOUBLE_DANDA = chr(71107)
SIDDHAM_SEPARATOR_DOT = chr(71108)
SIDDHAM_SEPARATOR_BAR = chr(71109)
SIDDHAM_REPETITION_MARK_1 = chr(71110)
SIDDHAM_REPETITION_MARK_2 = chr(71111)
SIDDHAM_REPETITION_MARK_3 = chr(71112)
SIDDHAM_END_OF_TEXT_MARK = chr(71113)
SIDDHAM_SECTION_MARK_WITH_TRIDENT_AND_U_SHAPED_ORNAMENTS = chr(71114)
SIDDHAM_SECTION_MARK_WITH_TRIDENT_AND_DOTTED_CRESCENTS = chr(71115)
SIDDHAM_SECTION_MARK_WITH_RAYS_AND_DOTTED_CRESCENTS = chr(71116)
SIDDHAM_SECTION_MARK_WITH_RAYS_AND_DOTTED_DOUBLE_CRESCENTS = chr(71117)
SIDDHAM_SECTION_MARK_WITH_RAYS_AND_DOTTED_TRIPLE_CRESCENTS = chr(71118)
SIDDHAM_SECTION_MARK_DOUBLE_RING = chr(71119)
SIDDHAM_SECTION_MARK_DOUBLE_RING_WITH_RAYS = chr(71120)
SIDDHAM_SECTION_MARK_WITH_DOUBLE_CRESCENTS = chr(71121)
SIDDHAM_SECTION_MARK_WITH_TRIPLE_CRESCENTS = chr(71122)
SIDDHAM_SECTION_MARK_WITH_QUADRUPLE_CRESCENTS = chr(71123)
SIDDHAM_SECTION_MARK_WITH_SEPTUPLE_CRESCENTS = chr(71124)
SIDDHAM_SECTION_MARK_WITH_CIRCLES_AND_RAYS = chr(71125)
SIDDHAM_SECTION_MARK_WITH_CIRCLES_AND_TWO_ENCLOSURES = chr(71126)
SIDDHAM_SECTION_MARK_WITH_CIRCLES_AND_FOUR_ENCLOSURES = chr(71127)
SIDDHAM_LETTER_THREE_CIRCLE_ALTERNATE_I = chr(71128)
SIDDHAM_LETTER_TWO_CIRCLE_ALTERNATE_I = chr(71129)
SIDDHAM_LETTER_TWO_CIRCLE_ALTERNATE_II = chr(71130)
SIDDHAM_LETTER_ALTERNATE_U = chr(71131)
SIDDHAM_VOWEL_SIGN_ALTERNATE_U = chr(71132)
SIDDHAM_VOWEL_SIGN_ALTERNATE_UU = chr(71133)
MODI_LETTER_A = chr(71168)
MODI_LETTER_AA = chr(71169)
MODI_LETTER_I = chr(71170)
MODI_LETTER_II = chr(71171)
MODI_LETTER_U = chr(71172)
MODI_LETTER_UU = chr(71173)
MODI_LETTER_VOCALIC_R = chr(71174)
MODI_LETTER_VOCALIC_RR = chr(71175)
MODI_LETTER_VOCALIC_L = chr(71176)
MODI_LETTER_VOCALIC_LL = chr(71177)
MODI_LETTER_E = chr(71178)
MODI_LETTER_AI = chr(71179)
MODI_LETTER_O = chr(71180)
MODI_LETTER_AU = chr(71181)
MODI_LETTER_KA = chr(71182)
MODI_LETTER_KHA = chr(71183)
MODI_LETTER_GA = chr(71184)
MODI_LETTER_GHA = chr(71185)
MODI_LETTER_NGA = chr(71186)
MODI_LETTER_CA = chr(71187)
MODI_LETTER_CHA = chr(71188)
MODI_LETTER_JA = chr(71189)
MODI_LETTER_JHA = chr(71190)
MODI_LETTER_NYA = chr(71191)
MODI_LETTER_TTA = chr(71192)
MODI_LETTER_TTHA = chr(71193)
MODI_LETTER_DDA = chr(71194)
MODI_LETTER_DDHA = chr(71195)
MODI_LETTER_NNA = chr(71196)
MODI_LETTER_TA = chr(71197)
MODI_LETTER_THA = chr(71198)
MODI_LETTER_DA = chr(71199)
MODI_LETTER_DHA = chr(71200)
MODI_LETTER_NA = chr(71201)
MODI_LETTER_PA = chr(71202)
MODI_LETTER_PHA = chr(71203)
MODI_LETTER_BA = chr(71204)
MODI_LETTER_BHA = chr(71205)
MODI_LETTER_MA = chr(71206)
MODI_LETTER_YA = chr(71207)
MODI_LETTER_RA = chr(71208)
MODI_LETTER_LA = chr(71209)
MODI_LETTER_VA = chr(71210)
MODI_LETTER_SHA = chr(71211)
MODI_LETTER_SSA = chr(71212)
MODI_LETTER_SA = chr(71213)
MODI_LETTER_HA = chr(71214)
MODI_LETTER_LLA = chr(71215)
MODI_VOWEL_SIGN_AA = chr(71216)
MODI_VOWEL_SIGN_I = chr(71217)
MODI_VOWEL_SIGN_II = chr(71218)
MODI_VOWEL_SIGN_U = chr(71219)
MODI_VOWEL_SIGN_UU = chr(71220)
MODI_VOWEL_SIGN_VOCALIC_R = chr(71221)
MODI_VOWEL_SIGN_VOCALIC_RR = chr(71222)
MODI_VOWEL_SIGN_VOCALIC_L = chr(71223)
MODI_VOWEL_SIGN_VOCALIC_LL = chr(71224)
MODI_VOWEL_SIGN_E = chr(71225)
MODI_VOWEL_SIGN_AI = chr(71226)
MODI_VOWEL_SIGN_O = chr(71227)
MODI_VOWEL_SIGN_AU = chr(71228)
MODI_SIGN_ANUSVARA = chr(71229)
MODI_SIGN_VISARGA = chr(71230)
MODI_SIGN_VIRAMA = chr(71231)
MODI_SIGN_ARDHACANDRA = chr(71232)
MODI_DANDA = chr(71233)
MODI_DOUBLE_DANDA = chr(71234)
MODI_ABBREVIATION_SIGN = chr(71235)
MODI_SIGN_HUVA = chr(71236)
MODI_DIGIT_ZERO = chr(71248)
MODI_DIGIT_ONE = chr(71249)
MODI_DIGIT_TWO = chr(71250)
MODI_DIGIT_THREE = chr(71251)
MODI_DIGIT_FOUR = chr(71252)
MODI_DIGIT_FIVE = chr(71253)
MODI_DIGIT_SIX = chr(71254)
MODI_DIGIT_SEVEN = chr(71255)
MODI_DIGIT_EIGHT = chr(71256)
MODI_DIGIT_NINE = chr(71257)
MONGOLIAN_BIRGA_WITH_ORNAMENT = chr(71264)
MONGOLIAN_ROTATED_BIRGA = chr(71265)
MONGOLIAN_DOUBLE_BIRGA_WITH_ORNAMENT = chr(71266)
MONGOLIAN_TRIPLE_BIRGA_WITH_ORNAMENT = chr(71267)
MONGOLIAN_BIRGA_WITH_DOUBLE_ORNAMENT = chr(71268)
MONGOLIAN_ROTATED_BIRGA_WITH_ORNAMENT = chr(71269)
MONGOLIAN_ROTATED_BIRGA_WITH_DOUBLE_ORNAMENT = chr(71270)
MONGOLIAN_INVERTED_BIRGA = chr(71271)
MONGOLIAN_INVERTED_BIRGA_WITH_DOUBLE_ORNAMENT = chr(71272)
MONGOLIAN_SWIRL_BIRGA = chr(71273)
MONGOLIAN_SWIRL_BIRGA_WITH_ORNAMENT = chr(71274)
MONGOLIAN_SWIRL_BIRGA_WITH_DOUBLE_ORNAMENT = chr(71275)
MONGOLIAN_TURNED_SWIRL_BIRGA_WITH_DOUBLE_ORNAMENT = chr(71276)
TAKRI_LETTER_A = chr(71296)
TAKRI_LETTER_AA = chr(71297)
TAKRI_LETTER_I = chr(71298)
TAKRI_LETTER_II = chr(71299)
TAKRI_LETTER_U = chr(71300)
TAKRI_LETTER_UU = chr(71301)
TAKRI_LETTER_E = chr(71302)
TAKRI_LETTER_AI = chr(71303)
TAKRI_LETTER_O = chr(71304)
TAKRI_LETTER_AU = chr(71305)
TAKRI_LETTER_KA = chr(71306)
TAKRI_LETTER_KHA = chr(71307)
TAKRI_LETTER_GA = chr(71308)
TAKRI_LETTER_GHA = chr(71309)
TAKRI_LETTER_NGA = chr(71310)
TAKRI_LETTER_CA = chr(71311)
TAKRI_LETTER_CHA = chr(71312)
TAKRI_LETTER_JA = chr(71313)
TAKRI_LETTER_JHA = chr(71314)
TAKRI_LETTER_NYA = chr(71315)
TAKRI_LETTER_TTA = chr(71316)
TAKRI_LETTER_TTHA = chr(71317)
TAKRI_LETTER_DDA = chr(71318)
TAKRI_LETTER_DDHA = chr(71319)
TAKRI_LETTER_NNA = chr(71320)
TAKRI_LETTER_TA = chr(71321)
TAKRI_LETTER_THA = chr(71322)
TAKRI_LETTER_DA = chr(71323)
TAKRI_LETTER_DHA = chr(71324)
TAKRI_LETTER_NA = chr(71325)
TAKRI_LETTER_PA = chr(71326)
TAKRI_LETTER_PHA = chr(71327)
TAKRI_LETTER_BA = chr(71328)
TAKRI_LETTER_BHA = chr(71329)
TAKRI_LETTER_MA = chr(71330)
TAKRI_LETTER_YA = chr(71331)
TAKRI_LETTER_RA = chr(71332)
TAKRI_LETTER_LA = chr(71333)
TAKRI_LETTER_VA = chr(71334)
TAKRI_LETTER_SHA = chr(71335)
TAKRI_LETTER_SA = chr(71336)
TAKRI_LETTER_HA = chr(71337)
TAKRI_LETTER_RRA = chr(71338)
TAKRI_SIGN_ANUSVARA = chr(71339)
TAKRI_SIGN_VISARGA = chr(71340)
TAKRI_VOWEL_SIGN_AA = chr(71341)
TAKRI_VOWEL_SIGN_I = chr(71342)
TAKRI_VOWEL_SIGN_II = chr(71343)
TAKRI_VOWEL_SIGN_U = chr(71344)
TAKRI_VOWEL_SIGN_UU = chr(71345)
TAKRI_VOWEL_SIGN_E = chr(71346)
TAKRI_VOWEL_SIGN_AI = chr(71347)
TAKRI_VOWEL_SIGN_O = chr(71348)
TAKRI_VOWEL_SIGN_AU = chr(71349)
TAKRI_SIGN_VIRAMA = chr(71350)
TAKRI_SIGN_NUKTA = chr(71351)
TAKRI_LETTER_ARCHAIC_KHA = chr(71352)
TAKRI_ABBREVIATION_SIGN = chr(71353)
TAKRI_DIGIT_ZERO = chr(71360)
TAKRI_DIGIT_ONE = chr(71361)
TAKRI_DIGIT_TWO = chr(71362)
TAKRI_DIGIT_THREE = chr(71363)
TAKRI_DIGIT_FOUR = chr(71364)
TAKRI_DIGIT_FIVE = chr(71365)
TAKRI_DIGIT_SIX = chr(71366)
TAKRI_DIGIT_SEVEN = chr(71367)
TAKRI_DIGIT_EIGHT = chr(71368)
TAKRI_DIGIT_NINE = chr(71369)
AHOM_LETTER_KA = chr(71424)
AHOM_LETTER_KHA = chr(71425)
AHOM_LETTER_NGA = chr(71426)
AHOM_LETTER_NA = chr(71427)
AHOM_LETTER_TA = chr(71428)
AHOM_LETTER_ALTERNATE_TA = chr(71429)
AHOM_LETTER_PA = chr(71430)
AHOM_LETTER_PHA = chr(71431)
AHOM_LETTER_BA = chr(71432)
AHOM_LETTER_MA = chr(71433)
AHOM_LETTER_JA = chr(71434)
AHOM_LETTER_CHA = chr(71435)
AHOM_LETTER_THA = chr(71436)
AHOM_LETTER_RA = chr(71437)
AHOM_LETTER_LA = chr(71438)
AHOM_LETTER_SA = chr(71439)
AHOM_LETTER_NYA = chr(71440)
AHOM_LETTER_HA = chr(71441)
AHOM_LETTER_A = chr(71442)
AHOM_LETTER_DA = chr(71443)
AHOM_LETTER_DHA = chr(71444)
AHOM_LETTER_GA = chr(71445)
AHOM_LETTER_ALTERNATE_GA = chr(71446)
AHOM_LETTER_GHA = chr(71447)
AHOM_LETTER_BHA = chr(71448)
AHOM_LETTER_JHA = chr(71449)
AHOM_LETTER_ALTERNATE_BA = chr(71450)
AHOM_CONSONANT_SIGN_MEDIAL_LA = chr(71453)
AHOM_CONSONANT_SIGN_MEDIAL_RA = chr(71454)
AHOM_CONSONANT_SIGN_MEDIAL_LIGATING_RA = chr(71455)
AHOM_VOWEL_SIGN_A = chr(71456)
AHOM_VOWEL_SIGN_AA = chr(71457)
AHOM_VOWEL_SIGN_I = chr(71458)
AHOM_VOWEL_SIGN_II = chr(71459)
AHOM_VOWEL_SIGN_U = chr(71460)
AHOM_VOWEL_SIGN_UU = chr(71461)
AHOM_VOWEL_SIGN_E = chr(71462)
AHOM_VOWEL_SIGN_AW = chr(71463)
AHOM_VOWEL_SIGN_O = chr(71464)
AHOM_VOWEL_SIGN_AI = chr(71465)
AHOM_VOWEL_SIGN_AM = chr(71466)
AHOM_SIGN_KILLER = chr(71467)
AHOM_DIGIT_ZERO = chr(71472)
AHOM_DIGIT_ONE = chr(71473)
AHOM_DIGIT_TWO = chr(71474)
AHOM_DIGIT_THREE = chr(71475)
AHOM_DIGIT_FOUR = chr(71476)
AHOM_DIGIT_FIVE = chr(71477)
AHOM_DIGIT_SIX = chr(71478)
AHOM_DIGIT_SEVEN = chr(71479)
AHOM_DIGIT_EIGHT = chr(71480)
AHOM_DIGIT_NINE = chr(71481)
AHOM_NUMBER_TEN = chr(71482)
AHOM_NUMBER_TWENTY = chr(71483)
AHOM_SIGN_SMALL_SECTION = chr(71484)
AHOM_SIGN_SECTION = chr(71485)
AHOM_SIGN_RULAI = chr(71486)
AHOM_SYMBOL_VI = chr(71487)
AHOM_LETTER_CA = chr(71488)
AHOM_LETTER_TTA = chr(71489)
AHOM_LETTER_TTHA = chr(71490)
AHOM_LETTER_DDA = chr(71491)
AHOM_LETTER_DDHA = chr(71492)
AHOM_LETTER_NNA = chr(71493)
AHOM_LETTER_LLA = chr(71494)
DOGRA_LETTER_A = chr(71680)
DOGRA_LETTER_AA = chr(71681)
DOGRA_LETTER_I = chr(71682)
DOGRA_LETTER_II = chr(71683)
DOGRA_LETTER_U = chr(71684)
DOGRA_LETTER_UU = chr(71685)
DOGRA_LETTER_E = chr(71686)
DOGRA_LETTER_AI = chr(71687)
DOGRA_LETTER_O = chr(71688)
DOGRA_LETTER_AU = chr(71689)
DOGRA_LETTER_KA = chr(71690)
DOGRA_LETTER_KHA = chr(71691)
DOGRA_LETTER_GA = chr(71692)
DOGRA_LETTER_GHA = chr(71693)
DOGRA_LETTER_NGA = chr(71694)
DOGRA_LETTER_CA = chr(71695)
DOGRA_LETTER_CHA = chr(71696)
DOGRA_LETTER_JA = chr(71697)
DOGRA_LETTER_JHA = chr(71698)
DOGRA_LETTER_NYA = chr(71699)
DOGRA_LETTER_TTA = chr(71700)
DOGRA_LETTER_TTHA = chr(71701)
DOGRA_LETTER_DDA = chr(71702)
DOGRA_LETTER_DDHA = chr(71703)
DOGRA_LETTER_NNA = chr(71704)
DOGRA_LETTER_TA = chr(71705)
DOGRA_LETTER_THA = chr(71706)
DOGRA_LETTER_DA = chr(71707)
DOGRA_LETTER_DHA = chr(71708)
DOGRA_LETTER_NA = chr(71709)
DOGRA_LETTER_PA = chr(71710)
DOGRA_LETTER_PHA = chr(71711)
DOGRA_LETTER_BA = chr(71712)
DOGRA_LETTER_BHA = chr(71713)
DOGRA_LETTER_MA = chr(71714)
DOGRA_LETTER_YA = chr(71715)
DOGRA_LETTER_RA = chr(71716)
DOGRA_LETTER_LA = chr(71717)
DOGRA_LETTER_VA = chr(71718)
DOGRA_LETTER_SHA = chr(71719)
DOGRA_LETTER_SSA = chr(71720)
DOGRA_LETTER_SA = chr(71721)
DOGRA_LETTER_HA = chr(71722)
DOGRA_LETTER_RRA = chr(71723)
DOGRA_VOWEL_SIGN_AA = chr(71724)
DOGRA_VOWEL_SIGN_I = chr(71725)
DOGRA_VOWEL_SIGN_II = chr(71726)
DOGRA_VOWEL_SIGN_U = chr(71727)
DOGRA_VOWEL_SIGN_UU = chr(71728)
DOGRA_VOWEL_SIGN_VOCALIC_R = chr(71729)
DOGRA_VOWEL_SIGN_VOCALIC_RR = chr(71730)
DOGRA_VOWEL_SIGN_E = chr(71731)
DOGRA_VOWEL_SIGN_AI = chr(71732)
DOGRA_VOWEL_SIGN_O = chr(71733)
DOGRA_VOWEL_SIGN_AU = chr(71734)
DOGRA_SIGN_ANUSVARA = chr(71735)
DOGRA_SIGN_VISARGA = chr(71736)
DOGRA_SIGN_VIRAMA = chr(71737)
DOGRA_SIGN_NUKTA = chr(71738)
DOGRA_ABBREVIATION_SIGN = chr(71739)
WARANG_CITI_CAPITAL_LETTER_NGAA = chr(71840)
WARANG_CITI_CAPITAL_LETTER_A = chr(71841)
WARANG_CITI_CAPITAL_LETTER_WI = chr(71842)
WARANG_CITI_CAPITAL_LETTER_YU = chr(71843)
WARANG_CITI_CAPITAL_LETTER_YA = chr(71844)
WARANG_CITI_CAPITAL_LETTER_YO = chr(71845)
WARANG_CITI_CAPITAL_LETTER_II = chr(71846)
WARANG_CITI_CAPITAL_LETTER_UU = chr(71847)
WARANG_CITI_CAPITAL_LETTER_E = chr(71848)
WARANG_CITI_CAPITAL_LETTER_O = chr(71849)
WARANG_CITI_CAPITAL_LETTER_ANG = chr(71850)
WARANG_CITI_CAPITAL_LETTER_GA = chr(71851)
WARANG_CITI_CAPITAL_LETTER_KO = chr(71852)
WARANG_CITI_CAPITAL_LETTER_ENY = chr(71853)
WARANG_CITI_CAPITAL_LETTER_YUJ = chr(71854)
WARANG_CITI_CAPITAL_LETTER_UC = chr(71855)
WARANG_CITI_CAPITAL_LETTER_ENN = chr(71856)
WARANG_CITI_CAPITAL_LETTER_ODD = chr(71857)
WARANG_CITI_CAPITAL_LETTER_TTE = chr(71858)
WARANG_CITI_CAPITAL_LETTER_NUNG = chr(71859)
WARANG_CITI_CAPITAL_LETTER_DA = chr(71860)
WARANG_CITI_CAPITAL_LETTER_AT = chr(71861)
WARANG_CITI_CAPITAL_LETTER_AM = chr(71862)
WARANG_CITI_CAPITAL_LETTER_BU = chr(71863)
WARANG_CITI_CAPITAL_LETTER_PU = chr(71864)
WARANG_CITI_CAPITAL_LETTER_HIYO = chr(71865)
WARANG_CITI_CAPITAL_LETTER_HOLO = chr(71866)
WARANG_CITI_CAPITAL_LETTER_HORR = chr(71867)
WARANG_CITI_CAPITAL_LETTER_HAR = chr(71868)
WARANG_CITI_CAPITAL_LETTER_SSUU = chr(71869)
WARANG_CITI_CAPITAL_LETTER_SII = chr(71870)
WARANG_CITI_CAPITAL_LETTER_VIYO = chr(71871)
WARANG_CITI_SMALL_LETTER_NGAA = chr(71872)
WARANG_CITI_SMALL_LETTER_A = chr(71873)
WARANG_CITI_SMALL_LETTER_WI = chr(71874)
WARANG_CITI_SMALL_LETTER_YU = chr(71875)
WARANG_CITI_SMALL_LETTER_YA = chr(71876)
WARANG_CITI_SMALL_LETTER_YO = chr(71877)
WARANG_CITI_SMALL_LETTER_II = chr(71878)
WARANG_CITI_SMALL_LETTER_UU = chr(71879)
WARANG_CITI_SMALL_LETTER_E = chr(71880)
WARANG_CITI_SMALL_LETTER_O = chr(71881)
WARANG_CITI_SMALL_LETTER_ANG = chr(71882)
WARANG_CITI_SMALL_LETTER_GA = chr(71883)
WARANG_CITI_SMALL_LETTER_KO = chr(71884)
WARANG_CITI_SMALL_LETTER_ENY = chr(71885)
WARANG_CITI_SMALL_LETTER_YUJ = chr(71886)
WARANG_CITI_SMALL_LETTER_UC = chr(71887)
WARANG_CITI_SMALL_LETTER_ENN = chr(71888)
WARANG_CITI_SMALL_LETTER_ODD = chr(71889)
WARANG_CITI_SMALL_LETTER_TTE = chr(71890)
WARANG_CITI_SMALL_LETTER_NUNG = chr(71891)
WARANG_CITI_SMALL_LETTER_DA = chr(71892)
WARANG_CITI_SMALL_LETTER_AT = chr(71893)
WARANG_CITI_SMALL_LETTER_AM = chr(71894)
WARANG_CITI_SMALL_LETTER_BU = chr(71895)
WARANG_CITI_SMALL_LETTER_PU = chr(71896)
WARANG_CITI_SMALL_LETTER_HIYO = chr(71897)
WARANG_CITI_SMALL_LETTER_HOLO = chr(71898)
WARANG_CITI_SMALL_LETTER_HORR = chr(71899)
WARANG_CITI_SMALL_LETTER_HAR = chr(71900)
WARANG_CITI_SMALL_LETTER_SSUU = chr(71901)
WARANG_CITI_SMALL_LETTER_SII = chr(71902)
WARANG_CITI_SMALL_LETTER_VIYO = chr(71903)
WARANG_CITI_DIGIT_ZERO = chr(71904)
WARANG_CITI_DIGIT_ONE = chr(71905)
WARANG_CITI_DIGIT_TWO = chr(71906)
WARANG_CITI_DIGIT_THREE = chr(71907)
WARANG_CITI_DIGIT_FOUR = chr(71908)
WARANG_CITI_DIGIT_FIVE = chr(71909)
WARANG_CITI_DIGIT_SIX = chr(71910)
WARANG_CITI_DIGIT_SEVEN = chr(71911)
WARANG_CITI_DIGIT_EIGHT = chr(71912)
WARANG_CITI_DIGIT_NINE = chr(71913)
WARANG_CITI_NUMBER_TEN = chr(71914)
WARANG_CITI_NUMBER_TWENTY = chr(71915)
WARANG_CITI_NUMBER_THIRTY = chr(71916)
WARANG_CITI_NUMBER_FORTY = chr(71917)
WARANG_CITI_NUMBER_FIFTY = chr(71918)
WARANG_CITI_NUMBER_SIXTY = chr(71919)
WARANG_CITI_NUMBER_SEVENTY = chr(71920)
WARANG_CITI_NUMBER_EIGHTY = chr(71921)
WARANG_CITI_NUMBER_NINETY = chr(71922)
WARANG_CITI_OM = chr(71935)
DIVES_AKURU_LETTER_A = chr(71936)
DIVES_AKURU_LETTER_AA = chr(71937)
DIVES_AKURU_LETTER_I = chr(71938)
DIVES_AKURU_LETTER_II = chr(71939)
DIVES_AKURU_LETTER_U = chr(71940)
DIVES_AKURU_LETTER_UU = chr(71941)
DIVES_AKURU_LETTER_E = chr(71942)
DIVES_AKURU_LETTER_O = chr(71945)
DIVES_AKURU_LETTER_KA = chr(71948)
DIVES_AKURU_LETTER_KHA = chr(71949)
DIVES_AKURU_LETTER_GA = chr(71950)
DIVES_AKURU_LETTER_GHA = chr(71951)
DIVES_AKURU_LETTER_NGA = chr(71952)
DIVES_AKURU_LETTER_CA = chr(71953)
DIVES_AKURU_LETTER_CHA = chr(71954)
DIVES_AKURU_LETTER_JA = chr(71955)
DIVES_AKURU_LETTER_NYA = chr(71957)
DIVES_AKURU_LETTER_TTA = chr(71958)
DIVES_AKURU_LETTER_DDA = chr(71960)
DIVES_AKURU_LETTER_DDHA = chr(71961)
DIVES_AKURU_LETTER_NNA = chr(71962)
DIVES_AKURU_LETTER_TA = chr(71963)
DIVES_AKURU_LETTER_THA = chr(71964)
DIVES_AKURU_LETTER_DA = chr(71965)
DIVES_AKURU_LETTER_DHA = chr(71966)
DIVES_AKURU_LETTER_NA = chr(71967)
DIVES_AKURU_LETTER_PA = chr(71968)
DIVES_AKURU_LETTER_PHA = chr(71969)
DIVES_AKURU_LETTER_BA = chr(71970)
DIVES_AKURU_LETTER_BHA = chr(71971)
DIVES_AKURU_LETTER_MA = chr(71972)
DIVES_AKURU_LETTER_YA = chr(71973)
DIVES_AKURU_LETTER_YYA = chr(71974)
DIVES_AKURU_LETTER_RA = chr(71975)
DIVES_AKURU_LETTER_LA = chr(71976)
DIVES_AKURU_LETTER_VA = chr(71977)
DIVES_AKURU_LETTER_SHA = chr(71978)
DIVES_AKURU_LETTER_SSA = chr(71979)
DIVES_AKURU_LETTER_SA = chr(71980)
DIVES_AKURU_LETTER_HA = chr(71981)
DIVES_AKURU_LETTER_LLA = chr(71982)
DIVES_AKURU_LETTER_ZA = chr(71983)
DIVES_AKURU_VOWEL_SIGN_AA = chr(71984)
DIVES_AKURU_VOWEL_SIGN_I = chr(71985)
DIVES_AKURU_VOWEL_SIGN_II = chr(71986)
DIVES_AKURU_VOWEL_SIGN_U = chr(71987)
DIVES_AKURU_VOWEL_SIGN_UU = chr(71988)
DIVES_AKURU_VOWEL_SIGN_E = chr(71989)
DIVES_AKURU_VOWEL_SIGN_AI = chr(71991)
DIVES_AKURU_VOWEL_SIGN_O = chr(71992)
DIVES_AKURU_SIGN_ANUSVARA = chr(71995)
DIVES_AKURU_SIGN_CANDRABINDU = chr(71996)
DIVES_AKURU_SIGN_HALANTA = chr(71997)
DIVES_AKURU_VIRAMA = chr(71998)
DIVES_AKURU_PREFIXED_NASAL_SIGN = chr(71999)
DIVES_AKURU_MEDIAL_YA = chr(72000)
DIVES_AKURU_INITIAL_RA = chr(72001)
DIVES_AKURU_MEDIAL_RA = chr(72002)
DIVES_AKURU_SIGN_NUKTA = chr(72003)
DIVES_AKURU_DOUBLE_DANDA = chr(72004)
DIVES_AKURU_GAP_FILLER = chr(72005)
DIVES_AKURU_END_OF_TEXT_MARK = chr(72006)
DIVES_AKURU_DIGIT_ZERO = chr(72016)
DIVES_AKURU_DIGIT_ONE = chr(72017)
DIVES_AKURU_DIGIT_TWO = chr(72018)
DIVES_AKURU_DIGIT_THREE = chr(72019)
DIVES_AKURU_DIGIT_FOUR = chr(72020)
DIVES_AKURU_DIGIT_FIVE = chr(72021)
DIVES_AKURU_DIGIT_SIX = chr(72022)
DIVES_AKURU_DIGIT_SEVEN = chr(72023)
DIVES_AKURU_DIGIT_EIGHT = chr(72024)
DIVES_AKURU_DIGIT_NINE = chr(72025)
NANDINAGARI_LETTER_A = chr(72096)
NANDINAGARI_LETTER_AA = chr(72097)
NANDINAGARI_LETTER_I = chr(72098)
NANDINAGARI_LETTER_II = chr(72099)
NANDINAGARI_LETTER_U = chr(72100)
NANDINAGARI_LETTER_UU = chr(72101)
NANDINAGARI_LETTER_VOCALIC_R = chr(72102)
NANDINAGARI_LETTER_VOCALIC_RR = chr(72103)
NANDINAGARI_LETTER_E = chr(72106)
NANDINAGARI_LETTER_AI = chr(72107)
NANDINAGARI_LETTER_O = chr(72108)
NANDINAGARI_LETTER_AU = chr(72109)
NANDINAGARI_LETTER_KA = chr(72110)
NANDINAGARI_LETTER_KHA = chr(72111)
NANDINAGARI_LETTER_GA = chr(72112)
NANDINAGARI_LETTER_GHA = chr(72113)
NANDINAGARI_LETTER_NGA = chr(72114)
NANDINAGARI_LETTER_CA = chr(72115)
NANDINAGARI_LETTER_CHA = chr(72116)
NANDINAGARI_LETTER_JA = chr(72117)
NANDINAGARI_LETTER_JHA = chr(72118)
NANDINAGARI_LETTER_NYA = chr(72119)
NANDINAGARI_LETTER_TTA = chr(72120)
NANDINAGARI_LETTER_TTHA = chr(72121)
NANDINAGARI_LETTER_DDA = chr(72122)
NANDINAGARI_LETTER_DDHA = chr(72123)
NANDINAGARI_LETTER_NNA = chr(72124)
NANDINAGARI_LETTER_TA = chr(72125)
NANDINAGARI_LETTER_THA = chr(72126)
NANDINAGARI_LETTER_DA = chr(72127)
NANDINAGARI_LETTER_DHA = chr(72128)
NANDINAGARI_LETTER_NA = chr(72129)
NANDINAGARI_LETTER_PA = chr(72130)
NANDINAGARI_LETTER_PHA = chr(72131)
NANDINAGARI_LETTER_BA = chr(72132)
NANDINAGARI_LETTER_BHA = chr(72133)
NANDINAGARI_LETTER_MA = chr(72134)
NANDINAGARI_LETTER_YA = chr(72135)
NANDINAGARI_LETTER_RA = chr(72136)
NANDINAGARI_LETTER_LA = chr(72137)
NANDINAGARI_LETTER_VA = chr(72138)
NANDINAGARI_LETTER_SHA = chr(72139)
NANDINAGARI_LETTER_SSA = chr(72140)
NANDINAGARI_LETTER_SA = chr(72141)
NANDINAGARI_LETTER_HA = chr(72142)
NANDINAGARI_LETTER_LLA = chr(72143)
NANDINAGARI_LETTER_RRA = chr(72144)
NANDINAGARI_VOWEL_SIGN_AA = chr(72145)
NANDINAGARI_VOWEL_SIGN_I = chr(72146)
NANDINAGARI_VOWEL_SIGN_II = chr(72147)
NANDINAGARI_VOWEL_SIGN_U = chr(72148)
NANDINAGARI_VOWEL_SIGN_UU = chr(72149)
NANDINAGARI_VOWEL_SIGN_VOCALIC_R = chr(72150)
NANDINAGARI_VOWEL_SIGN_VOCALIC_RR = chr(72151)
NANDINAGARI_VOWEL_SIGN_E = chr(72154)
NANDINAGARI_VOWEL_SIGN_AI = chr(72155)
NANDINAGARI_VOWEL_SIGN_O = chr(72156)
NANDINAGARI_VOWEL_SIGN_AU = chr(72157)
NANDINAGARI_SIGN_ANUSVARA = chr(72158)
NANDINAGARI_SIGN_VISARGA = chr(72159)
NANDINAGARI_SIGN_VIRAMA = chr(72160)
NANDINAGARI_SIGN_AVAGRAHA = chr(72161)
NANDINAGARI_SIGN_SIDDHAM = chr(72162)
NANDINAGARI_HEADSTROKE = chr(72163)
NANDINAGARI_VOWEL_SIGN_PRISHTHAMATRA_E = chr(72164)
ZANABAZAR_SQUARE_LETTER_A = chr(72192)
ZANABAZAR_SQUARE_VOWEL_SIGN_I = chr(72193)
ZANABAZAR_SQUARE_VOWEL_SIGN_UE = chr(72194)
ZANABAZAR_SQUARE_VOWEL_SIGN_U = chr(72195)
ZANABAZAR_SQUARE_VOWEL_SIGN_E = chr(72196)
ZANABAZAR_SQUARE_VOWEL_SIGN_OE = chr(72197)
ZANABAZAR_SQUARE_VOWEL_SIGN_O = chr(72198)
ZANABAZAR_SQUARE_VOWEL_SIGN_AI = chr(72199)
ZANABAZAR_SQUARE_VOWEL_SIGN_AU = chr(72200)
ZANABAZAR_SQUARE_VOWEL_SIGN_REVERSED_I = chr(72201)
ZANABAZAR_SQUARE_VOWEL_LENGTH_MARK = chr(72202)
ZANABAZAR_SQUARE_LETTER_KA = chr(72203)
ZANABAZAR_SQUARE_LETTER_KHA = chr(72204)
ZANABAZAR_SQUARE_LETTER_GA = chr(72205)
ZANABAZAR_SQUARE_LETTER_GHA = chr(72206)
ZANABAZAR_SQUARE_LETTER_NGA = chr(72207)
ZANABAZAR_SQUARE_LETTER_CA = chr(72208)
ZANABAZAR_SQUARE_LETTER_CHA = chr(72209)
ZANABAZAR_SQUARE_LETTER_JA = chr(72210)
ZANABAZAR_SQUARE_LETTER_NYA = chr(72211)
ZANABAZAR_SQUARE_LETTER_TTA = chr(72212)
ZANABAZAR_SQUARE_LETTER_TTHA = chr(72213)
ZANABAZAR_SQUARE_LETTER_DDA = chr(72214)
ZANABAZAR_SQUARE_LETTER_DDHA = chr(72215)
ZANABAZAR_SQUARE_LETTER_NNA = chr(72216)
ZANABAZAR_SQUARE_LETTER_TA = chr(72217)
ZANABAZAR_SQUARE_LETTER_THA = chr(72218)
ZANABAZAR_SQUARE_LETTER_DA = chr(72219)
ZANABAZAR_SQUARE_LETTER_DHA = chr(72220)
ZANABAZAR_SQUARE_LETTER_NA = chr(72221)
ZANABAZAR_SQUARE_LETTER_PA = chr(72222)
ZANABAZAR_SQUARE_LETTER_PHA = chr(72223)
ZANABAZAR_SQUARE_LETTER_BA = chr(72224)
ZANABAZAR_SQUARE_LETTER_BHA = chr(72225)
ZANABAZAR_SQUARE_LETTER_MA = chr(72226)
ZANABAZAR_SQUARE_LETTER_TSA = chr(72227)
ZANABAZAR_SQUARE_LETTER_TSHA = chr(72228)
ZANABAZAR_SQUARE_LETTER_DZA = chr(72229)
ZANABAZAR_SQUARE_LETTER_DZHA = chr(72230)
ZANABAZAR_SQUARE_LETTER_ZHA = chr(72231)
ZANABAZAR_SQUARE_LETTER_ZA = chr(72232)
ZANABAZAR_SQUARE_LETTER__A = chr(72233)
ZANABAZAR_SQUARE_LETTER_YA = chr(72234)
ZANABAZAR_SQUARE_LETTER_RA = chr(72235)
ZANABAZAR_SQUARE_LETTER_LA = chr(72236)
ZANABAZAR_SQUARE_LETTER_VA = chr(72237)
ZANABAZAR_SQUARE_LETTER_SHA = chr(72238)
ZANABAZAR_SQUARE_LETTER_SSA = chr(72239)
ZANABAZAR_SQUARE_LETTER_SA = chr(72240)
ZANABAZAR_SQUARE_LETTER_HA = chr(72241)
ZANABAZAR_SQUARE_LETTER_KSSA = chr(72242)
ZANABAZAR_SQUARE_FINAL_CONSONANT_MARK = chr(72243)
ZANABAZAR_SQUARE_SIGN_VIRAMA = chr(72244)
ZANABAZAR_SQUARE_SIGN_CANDRABINDU = chr(72245)
ZANABAZAR_SQUARE_SIGN_CANDRABINDU_WITH_ORNAMENT = chr(72246)
ZANABAZAR_SQUARE_SIGN_CANDRA_WITH_ORNAMENT = chr(72247)
ZANABAZAR_SQUARE_SIGN_ANUSVARA = chr(72248)
ZANABAZAR_SQUARE_SIGN_VISARGA = chr(72249)
ZANABAZAR_SQUARE_CLUSTER_INITIAL_LETTER_RA = chr(72250)
ZANABAZAR_SQUARE_CLUSTER_FINAL_LETTER_YA = chr(72251)
ZANABAZAR_SQUARE_CLUSTER_FINAL_LETTER_RA = chr(72252)
ZANABAZAR_SQUARE_CLUSTER_FINAL_LETTER_LA = chr(72253)
ZANABAZAR_SQUARE_CLUSTER_FINAL_LETTER_VA = chr(72254)
ZANABAZAR_SQUARE_INITIAL_HEAD_MARK = chr(72255)
ZANABAZAR_SQUARE_CLOSING_HEAD_MARK = chr(72256)
ZANABAZAR_SQUARE_MARK_TSHEG = chr(72257)
ZANABAZAR_SQUARE_MARK_SHAD = chr(72258)
ZANABAZAR_SQUARE_MARK_DOUBLE_SHAD = chr(72259)
ZANABAZAR_SQUARE_MARK_LONG_TSHEG = chr(72260)
ZANABAZAR_SQUARE_INITIAL_DOUBLE_LINED_HEAD_MARK = chr(72261)
ZANABAZAR_SQUARE_CLOSING_DOUBLE_LINED_HEAD_MARK = chr(72262)
ZANABAZAR_SQUARE_SUBJOINER = chr(72263)
SOYOMBO_LETTER_A = chr(72272)
SOYOMBO_VOWEL_SIGN_I = chr(72273)
SOYOMBO_VOWEL_SIGN_UE = chr(72274)
SOYOMBO_VOWEL_SIGN_U = chr(72275)
SOYOMBO_VOWEL_SIGN_E = chr(72276)
SOYOMBO_VOWEL_SIGN_O = chr(72277)
SOYOMBO_VOWEL_SIGN_OE = chr(72278)
SOYOMBO_VOWEL_SIGN_AI = chr(72279)
SOYOMBO_VOWEL_SIGN_AU = chr(72280)
SOYOMBO_VOWEL_SIGN_VOCALIC_R = chr(72281)
SOYOMBO_VOWEL_SIGN_VOCALIC_L = chr(72282)
SOYOMBO_VOWEL_LENGTH_MARK = chr(72283)
SOYOMBO_LETTER_KA = chr(72284)
SOYOMBO_LETTER_KHA = chr(72285)
SOYOMBO_LETTER_GA = chr(72286)
SOYOMBO_LETTER_GHA = chr(72287)
SOYOMBO_LETTER_NGA = chr(72288)
SOYOMBO_LETTER_CA = chr(72289)
SOYOMBO_LETTER_CHA = chr(72290)
SOYOMBO_LETTER_JA = chr(72291)
SOYOMBO_LETTER_JHA = chr(72292)
SOYOMBO_LETTER_NYA = chr(72293)
SOYOMBO_LETTER_TTA = chr(72294)
SOYOMBO_LETTER_TTHA = chr(72295)
SOYOMBO_LETTER_DDA = chr(72296)
SOYOMBO_LETTER_DDHA = chr(72297)
SOYOMBO_LETTER_NNA = chr(72298)
SOYOMBO_LETTER_TA = chr(72299)
SOYOMBO_LETTER_THA = chr(72300)
SOYOMBO_LETTER_DA = chr(72301)
SOYOMBO_LETTER_DHA = chr(72302)
SOYOMBO_LETTER_NA = chr(72303)
SOYOMBO_LETTER_PA = chr(72304)
SOYOMBO_LETTER_PHA = chr(72305)
SOYOMBO_LETTER_BA = chr(72306)
SOYOMBO_LETTER_BHA = chr(72307)
SOYOMBO_LETTER_MA = chr(72308)
SOYOMBO_LETTER_TSA = chr(72309)
SOYOMBO_LETTER_TSHA = chr(72310)
SOYOMBO_LETTER_DZA = chr(72311)
SOYOMBO_LETTER_ZHA = chr(72312)
SOYOMBO_LETTER_ZA = chr(72313)
SOYOMBO_LETTER__A = chr(72314)
SOYOMBO_LETTER_YA = chr(72315)
SOYOMBO_LETTER_RA = chr(72316)
SOYOMBO_LETTER_LA = chr(72317)
SOYOMBO_LETTER_VA = chr(72318)
SOYOMBO_LETTER_SHA = chr(72319)
SOYOMBO_LETTER_SSA = chr(72320)
SOYOMBO_LETTER_SA = chr(72321)
SOYOMBO_LETTER_HA = chr(72322)
SOYOMBO_LETTER_KSSA = chr(72323)
SOYOMBO_SIGN_JIHVAMULIYA = chr(72324)
SOYOMBO_SIGN_UPADHMANIYA = chr(72325)
SOYOMBO_CLUSTER_INITIAL_LETTER_RA = chr(72326)
SOYOMBO_CLUSTER_INITIAL_LETTER_LA = chr(72327)
SOYOMBO_CLUSTER_INITIAL_LETTER_SHA = chr(72328)
SOYOMBO_CLUSTER_INITIAL_LETTER_SA = chr(72329)
SOYOMBO_FINAL_CONSONANT_SIGN_G = chr(72330)
SOYOMBO_FINAL_CONSONANT_SIGN_K = chr(72331)
SOYOMBO_FINAL_CONSONANT_SIGN_NG = chr(72332)
SOYOMBO_FINAL_CONSONANT_SIGN_D = chr(72333)
SOYOMBO_FINAL_CONSONANT_SIGN_N = chr(72334)
SOYOMBO_FINAL_CONSONANT_SIGN_B = chr(72335)
SOYOMBO_FINAL_CONSONANT_SIGN_M = chr(72336)
SOYOMBO_FINAL_CONSONANT_SIGN_R = chr(72337)
SOYOMBO_FINAL_CONSONANT_SIGN_L = chr(72338)
SOYOMBO_FINAL_CONSONANT_SIGN_SH = chr(72339)
SOYOMBO_FINAL_CONSONANT_SIGN_S = chr(72340)
SOYOMBO_FINAL_CONSONANT_SIGN__A = chr(72341)
SOYOMBO_SIGN_ANUSVARA = chr(72342)
SOYOMBO_SIGN_VISARGA = chr(72343)
SOYOMBO_GEMINATION_MARK = chr(72344)
SOYOMBO_SUBJOINER = chr(72345)
SOYOMBO_MARK_TSHEG = chr(72346)
SOYOMBO_MARK_SHAD = chr(72347)
SOYOMBO_MARK_DOUBLE_SHAD = chr(72348)
SOYOMBO_MARK_PLUTA = chr(72349)
SOYOMBO_HEAD_MARK_WITH_MOON_AND_SUN_AND_TRIPLE_FLAME = chr(72350)
SOYOMBO_HEAD_MARK_WITH_MOON_AND_SUN_AND_FLAME = chr(72351)
SOYOMBO_HEAD_MARK_WITH_MOON_AND_SUN = chr(72352)
SOYOMBO_TERMINAL_MARK_1 = chr(72353)
SOYOMBO_TERMINAL_MARK_2 = chr(72354)
CANADIAN_SYLLABICS_NATTILIK_HI = chr(72368)
CANADIAN_SYLLABICS_NATTILIK_HII = chr(72369)
CANADIAN_SYLLABICS_NATTILIK_HO = chr(72370)
CANADIAN_SYLLABICS_NATTILIK_HOO = chr(72371)
CANADIAN_SYLLABICS_NATTILIK_HA = chr(72372)
CANADIAN_SYLLABICS_NATTILIK_HAA = chr(72373)
CANADIAN_SYLLABICS_NATTILIK_SHRI = chr(72374)
CANADIAN_SYLLABICS_NATTILIK_SHRII = chr(72375)
CANADIAN_SYLLABICS_NATTILIK_SHRO = chr(72376)
CANADIAN_SYLLABICS_NATTILIK_SHROO = chr(72377)
CANADIAN_SYLLABICS_NATTILIK_SHRA = chr(72378)
CANADIAN_SYLLABICS_NATTILIK_SHRAA = chr(72379)
CANADIAN_SYLLABICS_SPE = chr(72380)
CANADIAN_SYLLABICS_SPI = chr(72381)
CANADIAN_SYLLABICS_SPO = chr(72382)
CANADIAN_SYLLABICS_SPA = chr(72383)
PAU_CIN_HAU_LETTER_PA = chr(72384)
PAU_CIN_HAU_LETTER_KA = chr(72385)
PAU_CIN_HAU_LETTER_LA = chr(72386)
PAU_CIN_HAU_LETTER_MA = chr(72387)
PAU_CIN_HAU_LETTER_DA = chr(72388)
PAU_CIN_HAU_LETTER_ZA = chr(72389)
PAU_CIN_HAU_LETTER_VA = chr(72390)
PAU_CIN_HAU_LETTER_NGA = chr(72391)
PAU_CIN_HAU_LETTER_HA = chr(72392)
PAU_CIN_HAU_LETTER_GA = chr(72393)
PAU_CIN_HAU_LETTER_KHA = chr(72394)
PAU_CIN_HAU_LETTER_SA = chr(72395)
PAU_CIN_HAU_LETTER_BA = chr(72396)
PAU_CIN_HAU_LETTER_CA = chr(72397)
PAU_CIN_HAU_LETTER_TA = chr(72398)
PAU_CIN_HAU_LETTER_THA = chr(72399)
PAU_CIN_HAU_LETTER_NA = chr(72400)
PAU_CIN_HAU_LETTER_PHA = chr(72401)
PAU_CIN_HAU_LETTER_RA = chr(72402)
PAU_CIN_HAU_LETTER_FA = chr(72403)
PAU_CIN_HAU_LETTER_CHA = chr(72404)
PAU_CIN_HAU_LETTER_A = chr(72405)
PAU_CIN_HAU_LETTER_E = chr(72406)
PAU_CIN_HAU_LETTER_I = chr(72407)
PAU_CIN_HAU_LETTER_O = chr(72408)
PAU_CIN_HAU_LETTER_U = chr(72409)
PAU_CIN_HAU_LETTER_UA = chr(72410)
PAU_CIN_HAU_LETTER_IA = chr(72411)
PAU_CIN_HAU_LETTER_FINAL_P = chr(72412)
PAU_CIN_HAU_LETTER_FINAL_K = chr(72413)
PAU_CIN_HAU_LETTER_FINAL_T = chr(72414)
PAU_CIN_HAU_LETTER_FINAL_M = chr(72415)
PAU_CIN_HAU_LETTER_FINAL_N = chr(72416)
PAU_CIN_HAU_LETTER_FINAL_L = chr(72417)
PAU_CIN_HAU_LETTER_FINAL_W = chr(72418)
PAU_CIN_HAU_LETTER_FINAL_NG = chr(72419)
PAU_CIN_HAU_LETTER_FINAL_Y = chr(72420)
PAU_CIN_HAU_RISING_TONE_LONG = chr(72421)
PAU_CIN_HAU_RISING_TONE = chr(72422)
PAU_CIN_HAU_SANDHI_GLOTTAL_STOP = chr(72423)
PAU_CIN_HAU_RISING_TONE_LONG_FINAL = chr(72424)
PAU_CIN_HAU_RISING_TONE_FINAL = chr(72425)
PAU_CIN_HAU_SANDHI_GLOTTAL_STOP_FINAL = chr(72426)
PAU_CIN_HAU_SANDHI_TONE_LONG = chr(72427)
PAU_CIN_HAU_SANDHI_TONE = chr(72428)
PAU_CIN_HAU_SANDHI_TONE_LONG_FINAL = chr(72429)
PAU_CIN_HAU_SANDHI_TONE_FINAL = chr(72430)
PAU_CIN_HAU_MID_LEVEL_TONE = chr(72431)
PAU_CIN_HAU_GLOTTAL_STOP_VARIANT = chr(72432)
PAU_CIN_HAU_MID_LEVEL_TONE_LONG_FINAL = chr(72433)
PAU_CIN_HAU_MID_LEVEL_TONE_FINAL = chr(72434)
PAU_CIN_HAU_LOW_FALLING_TONE_LONG = chr(72435)
PAU_CIN_HAU_LOW_FALLING_TONE = chr(72436)
PAU_CIN_HAU_GLOTTAL_STOP = chr(72437)
PAU_CIN_HAU_LOW_FALLING_TONE_LONG_FINAL = chr(72438)
PAU_CIN_HAU_LOW_FALLING_TONE_FINAL = chr(72439)
PAU_CIN_HAU_GLOTTAL_STOP_FINAL = chr(72440)
DEVANAGARI_HEAD_MARK = chr(72448)
DEVANAGARI_HEAD_MARK_WITH_HEADSTROKE = chr(72449)
DEVANAGARI_SIGN_BHALE = chr(72450)
DEVANAGARI_SIGN_BHALE_WITH_HOOK = chr(72451)
DEVANAGARI_SIGN_EXTENDED_BHALE = chr(72452)
DEVANAGARI_SIGN_EXTENDED_BHALE_WITH_HOOK = chr(72453)
DEVANAGARI_SIGN_WESTERN_FIVE_LIKE_BHALE = chr(72454)
DEVANAGARI_SIGN_WESTERN_NINE_LIKE_BHALE = chr(72455)
DEVANAGARI_SIGN_REVERSED_NINE_LIKE_BHALE = chr(72456)
DEVANAGARI_SIGN_MINDU = chr(72457)
BHAIKSUKI_LETTER_A = chr(72704)
BHAIKSUKI_LETTER_AA = chr(72705)
BHAIKSUKI_LETTER_I = chr(72706)
BHAIKSUKI_LETTER_II = chr(72707)
BHAIKSUKI_LETTER_U = chr(72708)
BHAIKSUKI_LETTER_UU = chr(72709)
BHAIKSUKI_LETTER_VOCALIC_R = chr(72710)
BHAIKSUKI_LETTER_VOCALIC_RR = chr(72711)
BHAIKSUKI_LETTER_VOCALIC_L = chr(72712)
BHAIKSUKI_LETTER_E = chr(72714)
BHAIKSUKI_LETTER_AI = chr(72715)
BHAIKSUKI_LETTER_O = chr(72716)
BHAIKSUKI_LETTER_AU = chr(72717)
BHAIKSUKI_LETTER_KA = chr(72718)
BHAIKSUKI_LETTER_KHA = chr(72719)
BHAIKSUKI_LETTER_GA = chr(72720)
BHAIKSUKI_LETTER_GHA = chr(72721)
BHAIKSUKI_LETTER_NGA = chr(72722)
BHAIKSUKI_LETTER_CA = chr(72723)
BHAIKSUKI_LETTER_CHA = chr(72724)
BHAIKSUKI_LETTER_JA = chr(72725)
BHAIKSUKI_LETTER_JHA = chr(72726)
BHAIKSUKI_LETTER_NYA = chr(72727)
BHAIKSUKI_LETTER_TTA = chr(72728)
BHAIKSUKI_LETTER_TTHA = chr(72729)
BHAIKSUKI_LETTER_DDA = chr(72730)
BHAIKSUKI_LETTER_DDHA = chr(72731)
BHAIKSUKI_LETTER_NNA = chr(72732)
BHAIKSUKI_LETTER_TA = chr(72733)
BHAIKSUKI_LETTER_THA = chr(72734)
BHAIKSUKI_LETTER_DA = chr(72735)
BHAIKSUKI_LETTER_DHA = chr(72736)
BHAIKSUKI_LETTER_NA = chr(72737)
BHAIKSUKI_LETTER_PA = chr(72738)
BHAIKSUKI_LETTER_PHA = chr(72739)
BHAIKSUKI_LETTER_BA = chr(72740)
BHAIKSUKI_LETTER_BHA = chr(72741)
BHAIKSUKI_LETTER_MA = chr(72742)
BHAIKSUKI_LETTER_YA = chr(72743)
BHAIKSUKI_LETTER_RA = chr(72744)
BHAIKSUKI_LETTER_LA = chr(72745)
BHAIKSUKI_LETTER_VA = chr(72746)
BHAIKSUKI_LETTER_SHA = chr(72747)
BHAIKSUKI_LETTER_SSA = chr(72748)
BHAIKSUKI_LETTER_SA = chr(72749)
BHAIKSUKI_LETTER_HA = chr(72750)
BHAIKSUKI_VOWEL_SIGN_AA = chr(72751)
BHAIKSUKI_VOWEL_SIGN_I = chr(72752)
BHAIKSUKI_VOWEL_SIGN_II = chr(72753)
BHAIKSUKI_VOWEL_SIGN_U = chr(72754)
BHAIKSUKI_VOWEL_SIGN_UU = chr(72755)
BHAIKSUKI_VOWEL_SIGN_VOCALIC_R = chr(72756)
BHAIKSUKI_VOWEL_SIGN_VOCALIC_RR = chr(72757)
BHAIKSUKI_VOWEL_SIGN_VOCALIC_L = chr(72758)
BHAIKSUKI_VOWEL_SIGN_E = chr(72760)
BHAIKSUKI_VOWEL_SIGN_AI = chr(72761)
BHAIKSUKI_VOWEL_SIGN_O = chr(72762)
BHAIKSUKI_VOWEL_SIGN_AU = chr(72763)
BHAIKSUKI_SIGN_CANDRABINDU = chr(72764)
BHAIKSUKI_SIGN_ANUSVARA = chr(72765)
BHAIKSUKI_SIGN_VISARGA = chr(72766)
BHAIKSUKI_SIGN_VIRAMA = chr(72767)
BHAIKSUKI_SIGN_AVAGRAHA = chr(72768)
BHAIKSUKI_DANDA = chr(72769)
BHAIKSUKI_DOUBLE_DANDA = chr(72770)
BHAIKSUKI_WORD_SEPARATOR = chr(72771)
BHAIKSUKI_GAP_FILLER_1 = chr(72772)
BHAIKSUKI_GAP_FILLER_2 = chr(72773)
BHAIKSUKI_DIGIT_ZERO = chr(72784)
BHAIKSUKI_DIGIT_ONE = chr(72785)
BHAIKSUKI_DIGIT_TWO = chr(72786)
BHAIKSUKI_DIGIT_THREE = chr(72787)
BHAIKSUKI_DIGIT_FOUR = chr(72788)
BHAIKSUKI_DIGIT_FIVE = chr(72789)
BHAIKSUKI_DIGIT_SIX = chr(72790)
BHAIKSUKI_DIGIT_SEVEN = chr(72791)
BHAIKSUKI_DIGIT_EIGHT = chr(72792)
BHAIKSUKI_DIGIT_NINE = chr(72793)
BHAIKSUKI_NUMBER_ONE = chr(72794)
BHAIKSUKI_NUMBER_TWO = chr(72795)
BHAIKSUKI_NUMBER_THREE = chr(72796)
BHAIKSUKI_NUMBER_FOUR = chr(72797)
BHAIKSUKI_NUMBER_FIVE = chr(72798)
BHAIKSUKI_NUMBER_SIX = chr(72799)
BHAIKSUKI_NUMBER_SEVEN = chr(72800)
BHAIKSUKI_NUMBER_EIGHT = chr(72801)
BHAIKSUKI_NUMBER_NINE = chr(72802)
BHAIKSUKI_NUMBER_TEN = chr(72803)
BHAIKSUKI_NUMBER_TWENTY = chr(72804)
BHAIKSUKI_NUMBER_THIRTY = chr(72805)
BHAIKSUKI_NUMBER_FORTY = chr(72806)
BHAIKSUKI_NUMBER_FIFTY = chr(72807)
BHAIKSUKI_NUMBER_SIXTY = chr(72808)
BHAIKSUKI_NUMBER_SEVENTY = chr(72809)
BHAIKSUKI_NUMBER_EIGHTY = chr(72810)
BHAIKSUKI_NUMBER_NINETY = chr(72811)
BHAIKSUKI_HUNDREDS_UNIT_MARK = chr(72812)
MARCHEN_HEAD_MARK = chr(72816)
MARCHEN_MARK_SHAD = chr(72817)
MARCHEN_LETTER_KA = chr(72818)
MARCHEN_LETTER_KHA = chr(72819)
MARCHEN_LETTER_GA = chr(72820)
MARCHEN_LETTER_NGA = chr(72821)
MARCHEN_LETTER_CA = chr(72822)
MARCHEN_LETTER_CHA = chr(72823)
MARCHEN_LETTER_JA = chr(72824)
MARCHEN_LETTER_NYA = chr(72825)
MARCHEN_LETTER_TA = chr(72826)
MARCHEN_LETTER_THA = chr(72827)
MARCHEN_LETTER_DA = chr(72828)
MARCHEN_LETTER_NA = chr(72829)
MARCHEN_LETTER_PA = chr(72830)
MARCHEN_LETTER_PHA = chr(72831)
MARCHEN_LETTER_BA = chr(72832)
MARCHEN_LETTER_MA = chr(72833)
MARCHEN_LETTER_TSA = chr(72834)
MARCHEN_LETTER_TSHA = chr(72835)
MARCHEN_LETTER_DZA = chr(72836)
MARCHEN_LETTER_WA = chr(72837)
MARCHEN_LETTER_ZHA = chr(72838)
MARCHEN_LETTER_ZA = chr(72839)
MARCHEN_LETTER__A = chr(72840)
MARCHEN_LETTER_YA = chr(72841)
MARCHEN_LETTER_RA = chr(72842)
MARCHEN_LETTER_LA = chr(72843)
MARCHEN_LETTER_SHA = chr(72844)
MARCHEN_LETTER_SA = chr(72845)
MARCHEN_LETTER_HA = chr(72846)
MARCHEN_LETTER_A = chr(72847)
MARCHEN_SUBJOINED_LETTER_KA = chr(72850)
MARCHEN_SUBJOINED_LETTER_KHA = chr(72851)
MARCHEN_SUBJOINED_LETTER_GA = chr(72852)
MARCHEN_SUBJOINED_LETTER_NGA = chr(72853)
MARCHEN_SUBJOINED_LETTER_CA = chr(72854)
MARCHEN_SUBJOINED_LETTER_CHA = chr(72855)
MARCHEN_SUBJOINED_LETTER_JA = chr(72856)
MARCHEN_SUBJOINED_LETTER_NYA = chr(72857)
MARCHEN_SUBJOINED_LETTER_TA = chr(72858)
MARCHEN_SUBJOINED_LETTER_THA = chr(72859)
MARCHEN_SUBJOINED_LETTER_DA = chr(72860)
MARCHEN_SUBJOINED_LETTER_NA = chr(72861)
MARCHEN_SUBJOINED_LETTER_PA = chr(72862)
MARCHEN_SUBJOINED_LETTER_PHA = chr(72863)
MARCHEN_SUBJOINED_LETTER_BA = chr(72864)
MARCHEN_SUBJOINED_LETTER_MA = chr(72865)
MARCHEN_SUBJOINED_LETTER_TSA = chr(72866)
MARCHEN_SUBJOINED_LETTER_TSHA = chr(72867)
MARCHEN_SUBJOINED_LETTER_DZA = chr(72868)
MARCHEN_SUBJOINED_LETTER_WA = chr(72869)
MARCHEN_SUBJOINED_LETTER_ZHA = chr(72870)
MARCHEN_SUBJOINED_LETTER_ZA = chr(72871)
MARCHEN_SUBJOINED_LETTER_YA = chr(72873)
MARCHEN_SUBJOINED_LETTER_RA = chr(72874)
MARCHEN_SUBJOINED_LETTER_LA = chr(72875)
MARCHEN_SUBJOINED_LETTER_SHA = chr(72876)
MARCHEN_SUBJOINED_LETTER_SA = chr(72877)
MARCHEN_SUBJOINED_LETTER_HA = chr(72878)
MARCHEN_SUBJOINED_LETTER_A = chr(72879)
MARCHEN_VOWEL_SIGN_AA = chr(72880)
MARCHEN_VOWEL_SIGN_I = chr(72881)
MARCHEN_VOWEL_SIGN_U = chr(72882)
MARCHEN_VOWEL_SIGN_E = chr(72883)
MARCHEN_VOWEL_SIGN_O = chr(72884)
MARCHEN_SIGN_ANUSVARA = chr(72885)
MARCHEN_SIGN_CANDRABINDU = chr(72886)
MASARAM_GONDI_LETTER_A = chr(72960)
MASARAM_GONDI_LETTER_AA = chr(72961)
MASARAM_GONDI_LETTER_I = chr(72962)
MASARAM_GONDI_LETTER_II = chr(72963)
MASARAM_GONDI_LETTER_U = chr(72964)
MASARAM_GONDI_LETTER_UU = chr(72965)
MASARAM_GONDI_LETTER_E = chr(72966)
MASARAM_GONDI_LETTER_AI = chr(72968)
MASARAM_GONDI_LETTER_O = chr(72969)
MASARAM_GONDI_LETTER_AU = chr(72971)
MASARAM_GONDI_LETTER_KA = chr(72972)
MASARAM_GONDI_LETTER_KHA = chr(72973)
MASARAM_GONDI_LETTER_GA = chr(72974)
MASARAM_GONDI_LETTER_GHA = chr(72975)
MASARAM_GONDI_LETTER_NGA = chr(72976)
MASARAM_GONDI_LETTER_CA = chr(72977)
MASARAM_GONDI_LETTER_CHA = chr(72978)
MASARAM_GONDI_LETTER_JA = chr(72979)
MASARAM_GONDI_LETTER_JHA = chr(72980)
MASARAM_GONDI_LETTER_NYA = chr(72981)
MASARAM_GONDI_LETTER_TTA = chr(72982)
MASARAM_GONDI_LETTER_TTHA = chr(72983)
MASARAM_GONDI_LETTER_DDA = chr(72984)
MASARAM_GONDI_LETTER_DDHA = chr(72985)
MASARAM_GONDI_LETTER_NNA = chr(72986)
MASARAM_GONDI_LETTER_TA = chr(72987)
MASARAM_GONDI_LETTER_THA = chr(72988)
MASARAM_GONDI_LETTER_DA = chr(72989)
MASARAM_GONDI_LETTER_DHA = chr(72990)
MASARAM_GONDI_LETTER_NA = chr(72991)
MASARAM_GONDI_LETTER_PA = chr(72992)
MASARAM_GONDI_LETTER_PHA = chr(72993)
MASARAM_GONDI_LETTER_BA = chr(72994)
MASARAM_GONDI_LETTER_BHA = chr(72995)
MASARAM_GONDI_LETTER_MA = chr(72996)
MASARAM_GONDI_LETTER_YA = chr(72997)
MASARAM_GONDI_LETTER_RA = chr(72998)
MASARAM_GONDI_LETTER_LA = chr(72999)
MASARAM_GONDI_LETTER_VA = chr(73000)
MASARAM_GONDI_LETTER_SHA = chr(73001)
MASARAM_GONDI_LETTER_SSA = chr(73002)
MASARAM_GONDI_LETTER_SA = chr(73003)
MASARAM_GONDI_LETTER_HA = chr(73004)
MASARAM_GONDI_LETTER_LLA = chr(73005)
MASARAM_GONDI_LETTER_KSSA = chr(73006)
MASARAM_GONDI_LETTER_JNYA = chr(73007)
MASARAM_GONDI_LETTER_TRA = chr(73008)
MASARAM_GONDI_VOWEL_SIGN_AA = chr(73009)
MASARAM_GONDI_VOWEL_SIGN_I = chr(73010)
MASARAM_GONDI_VOWEL_SIGN_II = chr(73011)
MASARAM_GONDI_VOWEL_SIGN_U = chr(73012)
MASARAM_GONDI_VOWEL_SIGN_UU = chr(73013)
MASARAM_GONDI_VOWEL_SIGN_VOCALIC_R = chr(73014)
MASARAM_GONDI_VOWEL_SIGN_E = chr(73018)
MASARAM_GONDI_VOWEL_SIGN_AI = chr(73020)
MASARAM_GONDI_VOWEL_SIGN_O = chr(73021)
MASARAM_GONDI_VOWEL_SIGN_AU = chr(73023)
MASARAM_GONDI_SIGN_ANUSVARA = chr(73024)
MASARAM_GONDI_SIGN_VISARGA = chr(73025)
MASARAM_GONDI_SIGN_NUKTA = chr(73026)
MASARAM_GONDI_SIGN_CANDRA = chr(73027)
MASARAM_GONDI_SIGN_HALANTA = chr(73028)
MASARAM_GONDI_VIRAMA = chr(73029)
MASARAM_GONDI_REPHA = chr(73030)
MASARAM_GONDI_RA_KARA = chr(73031)
MASARAM_GONDI_DIGIT_ZERO = chr(73040)
MASARAM_GONDI_DIGIT_ONE = chr(73041)
MASARAM_GONDI_DIGIT_TWO = chr(73042)
MASARAM_GONDI_DIGIT_THREE = chr(73043)
MASARAM_GONDI_DIGIT_FOUR = chr(73044)
MASARAM_GONDI_DIGIT_FIVE = chr(73045)
MASARAM_GONDI_DIGIT_SIX = chr(73046)
MASARAM_GONDI_DIGIT_SEVEN = chr(73047)
MASARAM_GONDI_DIGIT_EIGHT = chr(73048)
MASARAM_GONDI_DIGIT_NINE = chr(73049)
GUNJALA_GONDI_LETTER_A = chr(73056)
GUNJALA_GONDI_LETTER_AA = chr(73057)
GUNJALA_GONDI_LETTER_I = chr(73058)
GUNJALA_GONDI_LETTER_II = chr(73059)
GUNJALA_GONDI_LETTER_U = chr(73060)
GUNJALA_GONDI_LETTER_UU = chr(73061)
GUNJALA_GONDI_LETTER_EE = chr(73063)
GUNJALA_GONDI_LETTER_AI = chr(73064)
GUNJALA_GONDI_LETTER_OO = chr(73066)
GUNJALA_GONDI_LETTER_AU = chr(73067)
GUNJALA_GONDI_LETTER_YA = chr(73068)
GUNJALA_GONDI_LETTER_VA = chr(73069)
GUNJALA_GONDI_LETTER_BA = chr(73070)
GUNJALA_GONDI_LETTER_BHA = chr(73071)
GUNJALA_GONDI_LETTER_MA = chr(73072)
GUNJALA_GONDI_LETTER_KA = chr(73073)
GUNJALA_GONDI_LETTER_KHA = chr(73074)
GUNJALA_GONDI_LETTER_TA = chr(73075)
GUNJALA_GONDI_LETTER_THA = chr(73076)
GUNJALA_GONDI_LETTER_LA = chr(73077)
GUNJALA_GONDI_LETTER_GA = chr(73078)
GUNJALA_GONDI_LETTER_GHA = chr(73079)
GUNJALA_GONDI_LETTER_DA = chr(73080)
GUNJALA_GONDI_LETTER_DHA = chr(73081)
GUNJALA_GONDI_LETTER_NA = chr(73082)
GUNJALA_GONDI_LETTER_CA = chr(73083)
GUNJALA_GONDI_LETTER_CHA = chr(73084)
GUNJALA_GONDI_LETTER_TTA = chr(73085)
GUNJALA_GONDI_LETTER_TTHA = chr(73086)
GUNJALA_GONDI_LETTER_LLA = chr(73087)
GUNJALA_GONDI_LETTER_JA = chr(73088)
GUNJALA_GONDI_LETTER_JHA = chr(73089)
GUNJALA_GONDI_LETTER_DDA = chr(73090)
GUNJALA_GONDI_LETTER_DDHA = chr(73091)
GUNJALA_GONDI_LETTER_NGA = chr(73092)
GUNJALA_GONDI_LETTER_PA = chr(73093)
GUNJALA_GONDI_LETTER_PHA = chr(73094)
GUNJALA_GONDI_LETTER_HA = chr(73095)
GUNJALA_GONDI_LETTER_RA = chr(73096)
GUNJALA_GONDI_LETTER_SA = chr(73097)
GUNJALA_GONDI_VOWEL_SIGN_AA = chr(73098)
GUNJALA_GONDI_VOWEL_SIGN_I = chr(73099)
GUNJALA_GONDI_VOWEL_SIGN_II = chr(73100)
GUNJALA_GONDI_VOWEL_SIGN_U = chr(73101)
GUNJALA_GONDI_VOWEL_SIGN_UU = chr(73102)
GUNJALA_GONDI_VOWEL_SIGN_EE = chr(73104)
GUNJALA_GONDI_VOWEL_SIGN_AI = chr(73105)
GUNJALA_GONDI_VOWEL_SIGN_OO = chr(73107)
GUNJALA_GONDI_VOWEL_SIGN_AU = chr(73108)
GUNJALA_GONDI_SIGN_ANUSVARA = chr(73109)
GUNJALA_GONDI_SIGN_VISARGA = chr(73110)
GUNJALA_GONDI_VIRAMA = chr(73111)
GUNJALA_GONDI_OM = chr(73112)
GUNJALA_GONDI_DIGIT_ZERO = chr(73120)
GUNJALA_GONDI_DIGIT_ONE = chr(73121)
GUNJALA_GONDI_DIGIT_TWO = chr(73122)
GUNJALA_GONDI_DIGIT_THREE = chr(73123)
GUNJALA_GONDI_DIGIT_FOUR = chr(73124)
GUNJALA_GONDI_DIGIT_FIVE = chr(73125)
GUNJALA_GONDI_DIGIT_SIX = chr(73126)
GUNJALA_GONDI_DIGIT_SEVEN = chr(73127)
GUNJALA_GONDI_DIGIT_EIGHT = chr(73128)
GUNJALA_GONDI_DIGIT_NINE = chr(73129)
MAKASAR_LETTER_KA = chr(73440)
MAKASAR_LETTER_GA = chr(73441)
MAKASAR_LETTER_NGA = chr(73442)
MAKASAR_LETTER_PA = chr(73443)
MAKASAR_LETTER_BA = chr(73444)
MAKASAR_LETTER_MA = chr(73445)
MAKASAR_LETTER_TA = chr(73446)
MAKASAR_LETTER_DA = chr(73447)
MAKASAR_LETTER_NA = chr(73448)
MAKASAR_LETTER_CA = chr(73449)
MAKASAR_LETTER_JA = chr(73450)
MAKASAR_LETTER_NYA = chr(73451)
MAKASAR_LETTER_YA = chr(73452)
MAKASAR_LETTER_RA = chr(73453)
MAKASAR_LETTER_LA = chr(73454)
MAKASAR_LETTER_VA = chr(73455)
MAKASAR_LETTER_SA = chr(73456)
MAKASAR_LETTER_A = chr(73457)
MAKASAR_ANGKA = chr(73458)
MAKASAR_VOWEL_SIGN_I = chr(73459)
MAKASAR_VOWEL_SIGN_U = chr(73460)
MAKASAR_VOWEL_SIGN_E = chr(73461)
MAKASAR_VOWEL_SIGN_O = chr(73462)
MAKASAR_PASSIMBANG = chr(73463)
MAKASAR_END_OF_SECTION = chr(73464)
KAWI_SIGN_CANDRABINDU = chr(73472)
KAWI_SIGN_ANUSVARA = chr(73473)
KAWI_SIGN_REPHA = chr(73474)
KAWI_SIGN_VISARGA = chr(73475)
KAWI_LETTER_A = chr(73476)
KAWI_LETTER_AA = chr(73477)
KAWI_LETTER_I = chr(73478)
KAWI_LETTER_II = chr(73479)
KAWI_LETTER_U = chr(73480)
KAWI_LETTER_UU = chr(73481)
KAWI_LETTER_VOCALIC_R = chr(73482)
KAWI_LETTER_VOCALIC_RR = chr(73483)
KAWI_LETTER_VOCALIC_L = chr(73484)
KAWI_LETTER_VOCALIC_LL = chr(73485)
KAWI_LETTER_E = chr(73486)
KAWI_LETTER_AI = chr(73487)
KAWI_LETTER_O = chr(73488)
KAWI_LETTER_KA = chr(73490)
KAWI_LETTER_KHA = chr(73491)
KAWI_LETTER_GA = chr(73492)
KAWI_LETTER_GHA = chr(73493)
KAWI_LETTER_NGA = chr(73494)
KAWI_LETTER_CA = chr(73495)
KAWI_LETTER_CHA = chr(73496)
KAWI_LETTER_JA = chr(73497)
KAWI_LETTER_JHA = chr(73498)
KAWI_LETTER_NYA = chr(73499)
KAWI_LETTER_TTA = chr(73500)
KAWI_LETTER_TTHA = chr(73501)
KAWI_LETTER_DDA = chr(73502)
KAWI_LETTER_DDHA = chr(73503)
KAWI_LETTER_NNA = chr(73504)
KAWI_LETTER_TA = chr(73505)
KAWI_LETTER_THA = chr(73506)
KAWI_LETTER_DA = chr(73507)
KAWI_LETTER_DHA = chr(73508)
KAWI_LETTER_NA = chr(73509)
KAWI_LETTER_PA = chr(73510)
KAWI_LETTER_PHA = chr(73511)
KAWI_LETTER_BA = chr(73512)
KAWI_LETTER_BHA = chr(73513)
KAWI_LETTER_MA = chr(73514)
KAWI_LETTER_YA = chr(73515)
KAWI_LETTER_RA = chr(73516)
KAWI_LETTER_LA = chr(73517)
KAWI_LETTER_WA = chr(73518)
KAWI_LETTER_SHA = chr(73519)
KAWI_LETTER_SSA = chr(73520)
KAWI_LETTER_SA = chr(73521)
KAWI_LETTER_HA = chr(73522)
KAWI_LETTER_JNYA = chr(73523)
KAWI_VOWEL_SIGN_AA = chr(73524)
KAWI_VOWEL_SIGN_ALTERNATE_AA = chr(73525)
KAWI_VOWEL_SIGN_I = chr(73526)
KAWI_VOWEL_SIGN_II = chr(73527)
KAWI_VOWEL_SIGN_U = chr(73528)
KAWI_VOWEL_SIGN_UU = chr(73529)
KAWI_VOWEL_SIGN_VOCALIC_R = chr(73530)
KAWI_VOWEL_SIGN_E = chr(73534)
KAWI_VOWEL_SIGN_AI = chr(73535)
KAWI_VOWEL_SIGN_EU = chr(73536)
KAWI_SIGN_KILLER = chr(73537)
KAWI_CONJOINER = chr(73538)
KAWI_DANDA = chr(73539)
KAWI_DOUBLE_DANDA = chr(73540)
KAWI_PUNCTUATION_SECTION_MARKER = chr(73541)
KAWI_PUNCTUATION_ALTERNATE_SECTION_MARKER = chr(73542)
KAWI_PUNCTUATION_FLOWER = chr(73543)
KAWI_PUNCTUATION_SPACE_FILLER = chr(73544)
KAWI_PUNCTUATION_DOT = chr(73545)
KAWI_PUNCTUATION_DOUBLE_DOT = chr(73546)
KAWI_PUNCTUATION_TRIPLE_DOT = chr(73547)
KAWI_PUNCTUATION_CIRCLE = chr(73548)
KAWI_PUNCTUATION_FILLED_CIRCLE = chr(73549)
KAWI_PUNCTUATION_SPIRAL = chr(73550)
KAWI_PUNCTUATION_CLOSING_SPIRAL = chr(73551)
KAWI_DIGIT_ZERO = chr(73552)
KAWI_DIGIT_ONE = chr(73553)
KAWI_DIGIT_TWO = chr(73554)
KAWI_DIGIT_THREE = chr(73555)
KAWI_DIGIT_FOUR = chr(73556)
KAWI_DIGIT_FIVE = chr(73557)
KAWI_DIGIT_SIX = chr(73558)
KAWI_DIGIT_SEVEN = chr(73559)
KAWI_DIGIT_EIGHT = chr(73560)
KAWI_DIGIT_NINE = chr(73561)
LISU_LETTER_YHA = chr(73648)
TAMIL_FRACTION_ONE_THREE_HUNDRED_AND_TWENTIETH = chr(73664)
TAMIL_FRACTION_ONE_ONE_HUNDRED_AND_SIXTIETH = chr(73665)
TAMIL_FRACTION_ONE_EIGHTIETH = chr(73666)
TAMIL_FRACTION_ONE_SIXTY_FOURTH = chr(73667)
TAMIL_FRACTION_ONE_FORTIETH = chr(73668)
TAMIL_FRACTION_ONE_THIRTY_SECOND = chr(73669)
TAMIL_FRACTION_THREE_EIGHTIETHS = chr(73670)
TAMIL_FRACTION_THREE_SIXTY_FOURTHS = chr(73671)
TAMIL_FRACTION_ONE_TWENTIETH = chr(73672)
TAMIL_FRACTION_ONE_SIXTEENTH_1 = chr(73673)
TAMIL_FRACTION_ONE_SIXTEENTH_2 = chr(73674)
TAMIL_FRACTION_ONE_TENTH = chr(73675)
TAMIL_FRACTION_ONE_EIGHTH = chr(73676)
TAMIL_FRACTION_THREE_TWENTIETHS = chr(73677)
TAMIL_FRACTION_THREE_SIXTEENTHS = chr(73678)
TAMIL_FRACTION_ONE_FIFTH = chr(73679)
TAMIL_FRACTION_ONE_QUARTER = chr(73680)
TAMIL_FRACTION_ONE_HALF_1 = chr(73681)
TAMIL_FRACTION_ONE_HALF_2 = chr(73682)
TAMIL_FRACTION_THREE_QUARTERS = chr(73683)
TAMIL_FRACTION_DOWNSCALING_FACTOR_KIIZH = chr(73684)
TAMIL_SIGN_NEL = chr(73685)
TAMIL_SIGN_CEVITU = chr(73686)
TAMIL_SIGN_AAZHAAKKU = chr(73687)
TAMIL_SIGN_UZHAKKU = chr(73688)
TAMIL_SIGN_MUUVUZHAKKU = chr(73689)
TAMIL_SIGN_KURUNI = chr(73690)
TAMIL_SIGN_PATHAKKU = chr(73691)
TAMIL_SIGN_MUKKURUNI = chr(73692)
TAMIL_SIGN_KAACU = chr(73693)
TAMIL_SIGN_PANAM = chr(73694)
TAMIL_SIGN_PON = chr(73695)
TAMIL_SIGN_VARAAKAN = chr(73696)
TAMIL_SIGN_PAARAM = chr(73697)
TAMIL_SIGN_KUZHI = chr(73698)
TAMIL_SIGN_VELI = chr(73699)
TAMIL_WET_CULTIVATION_SIGN = chr(73700)
TAMIL_DRY_CULTIVATION_SIGN = chr(73701)
TAMIL_LAND_SIGN = chr(73702)
TAMIL_SALT_PAN_SIGN = chr(73703)
TAMIL_TRADITIONAL_CREDIT_SIGN = chr(73704)
TAMIL_TRADITIONAL_NUMBER_SIGN = chr(73705)
TAMIL_CURRENT_SIGN = chr(73706)
TAMIL_AND_ODD_SIGN = chr(73707)
TAMIL_SPENT_SIGN = chr(73708)
TAMIL_TOTAL_SIGN = chr(73709)
TAMIL_IN_POSSESSION_SIGN = chr(73710)
TAMIL_STARTING_FROM_SIGN = chr(73711)
TAMIL_SIGN_MUTHALIYA = chr(73712)
TAMIL_SIGN_VAKAIYARAA = chr(73713)
TAMIL_PUNCTUATION_END_OF_TEXT = chr(73727)
CUNEIFORM_SIGN_A = chr(73728)
CUNEIFORM_SIGN_A_TIMES_A = chr(73729)
CUNEIFORM_SIGN_A_TIMES_BAD = chr(73730)
CUNEIFORM_SIGN_A_TIMES_GAN2_TENU = chr(73731)
CUNEIFORM_SIGN_A_TIMES_HA = chr(73732)
CUNEIFORM_SIGN_A_TIMES_IGI = chr(73733)
CUNEIFORM_SIGN_A_TIMES_LAGAR_GUNU = chr(73734)
CUNEIFORM_SIGN_A_TIMES_MUSH = chr(73735)
CUNEIFORM_SIGN_A_TIMES_SAG = chr(73736)
CUNEIFORM_SIGN_A2 = chr(73737)
CUNEIFORM_SIGN_AB = chr(73738)
CUNEIFORM_SIGN_AB_TIMES_ASH2 = chr(73739)
CUNEIFORM_SIGN_AB_TIMES_DUN3_GUNU = chr(73740)
CUNEIFORM_SIGN_AB_TIMES_GAL = chr(73741)
CUNEIFORM_SIGN_AB_TIMES_GAN2_TENU = chr(73742)
CUNEIFORM_SIGN_AB_TIMES_HA = chr(73743)
CUNEIFORM_SIGN_AB_TIMES_IGI_GUNU = chr(73744)
CUNEIFORM_SIGN_AB_TIMES_IMIN = chr(73745)
CUNEIFORM_SIGN_AB_TIMES_LAGAB = chr(73746)
CUNEIFORM_SIGN_AB_TIMES_SHESH = chr(73747)
CUNEIFORM_SIGN_AB_TIMES_U_PLUS_U_PLUS_U = chr(73748)
CUNEIFORM_SIGN_AB_GUNU = chr(73749)
CUNEIFORM_SIGN_AB2 = chr(73750)
CUNEIFORM_SIGN_AB2_TIMES_BALAG = chr(73751)
CUNEIFORM_SIGN_AB2_TIMES_GAN2_TENU = chr(73752)
CUNEIFORM_SIGN_AB2_TIMES_ME_PLUS_EN = chr(73753)
CUNEIFORM_SIGN_AB2_TIMES_SHA3 = chr(73754)
CUNEIFORM_SIGN_AB2_TIMES_TAK4 = chr(73755)
CUNEIFORM_SIGN_AD = chr(73756)
CUNEIFORM_SIGN_AK = chr(73757)
CUNEIFORM_SIGN_AK_TIMES_ERIN2 = chr(73758)
CUNEIFORM_SIGN_AK_TIMES_SHITA_PLUS_GISH = chr(73759)
CUNEIFORM_SIGN_AL = chr(73760)
CUNEIFORM_SIGN_AL_TIMES_AL = chr(73761)
CUNEIFORM_SIGN_AL_TIMES_DIM2 = chr(73762)
CUNEIFORM_SIGN_AL_TIMES_GISH = chr(73763)
CUNEIFORM_SIGN_AL_TIMES_HA = chr(73764)
CUNEIFORM_SIGN_AL_TIMES_KAD3 = chr(73765)
CUNEIFORM_SIGN_AL_TIMES_KI = chr(73766)
CUNEIFORM_SIGN_AL_TIMES_SHE = chr(73767)
CUNEIFORM_SIGN_AL_TIMES_USH = chr(73768)
CUNEIFORM_SIGN_ALAN = chr(73769)
CUNEIFORM_SIGN_ALEPH = chr(73770)
CUNEIFORM_SIGN_AMAR = chr(73771)
CUNEIFORM_SIGN_AMAR_TIMES_SHE = chr(73772)
CUNEIFORM_SIGN_AN = chr(73773)
CUNEIFORM_SIGN_AN_OVER_AN = chr(73774)
CUNEIFORM_SIGN_AN_THREE_TIMES = chr(73775)
CUNEIFORM_SIGN_AN_PLUS_NAGA_OPPOSING_AN_PLUS_NAGA = chr(73776)
CUNEIFORM_SIGN_AN_PLUS_NAGA_SQUARED = chr(73777)
CUNEIFORM_SIGN_ANSHE = chr(73778)
CUNEIFORM_SIGN_APIN = chr(73779)
CUNEIFORM_SIGN_ARAD = chr(73780)
CUNEIFORM_SIGN_ARAD_TIMES_KUR = chr(73781)
CUNEIFORM_SIGN_ARKAB = chr(73782)
CUNEIFORM_SIGN_ASAL2 = chr(73783)
CUNEIFORM_SIGN_ASH = chr(73784)
CUNEIFORM_SIGN_ASH_ZIDA_TENU = chr(73785)
CUNEIFORM_SIGN_ASH_KABA_TENU = chr(73786)
CUNEIFORM_SIGN_ASH_OVER_ASH_TUG2_OVER_TUG2_TUG2_OVER_TUG2_PAP = chr(73787)
CUNEIFORM_SIGN_ASH_OVER_ASH_OVER_ASH = chr(73788)
CUNEIFORM_SIGN_ASH_OVER_ASH_OVER_ASH_CROSSING_ASH_OVER_ASH_OVER_ASH = chr(73789)
CUNEIFORM_SIGN_ASH2 = chr(73790)
CUNEIFORM_SIGN_ASHGAB = chr(73791)
CUNEIFORM_SIGN_BA = chr(73792)
CUNEIFORM_SIGN_BAD = chr(73793)
CUNEIFORM_SIGN_BAG3 = chr(73794)
CUNEIFORM_SIGN_BAHAR2 = chr(73795)
CUNEIFORM_SIGN_BAL = chr(73796)
CUNEIFORM_SIGN_BAL_OVER_BAL = chr(73797)
CUNEIFORM_SIGN_BALAG = chr(73798)
CUNEIFORM_SIGN_BAR = chr(73799)
CUNEIFORM_SIGN_BARA2 = chr(73800)
CUNEIFORM_SIGN_BI = chr(73801)
CUNEIFORM_SIGN_BI_TIMES_A = chr(73802)
CUNEIFORM_SIGN_BI_TIMES_GAR = chr(73803)
CUNEIFORM_SIGN_BI_TIMES_IGI_GUNU = chr(73804)
CUNEIFORM_SIGN_BU = chr(73805)
CUNEIFORM_SIGN_BU_OVER_BU_AB = chr(73806)
CUNEIFORM_SIGN_BU_OVER_BU_UN = chr(73807)
CUNEIFORM_SIGN_BU_CROSSING_BU = chr(73808)
CUNEIFORM_SIGN_BULUG = chr(73809)
CUNEIFORM_SIGN_BULUG_OVER_BULUG = chr(73810)
CUNEIFORM_SIGN_BUR = chr(73811)
CUNEIFORM_SIGN_BUR2 = chr(73812)
CUNEIFORM_SIGN_DA = chr(73813)
CUNEIFORM_SIGN_DAG = chr(73814)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_A_PLUS_MASH = chr(73815)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_AMAR = chr(73816)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_BALAG = chr(73817)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_BI = chr(73818)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_GA = chr(73819)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_GA_PLUS_MASH = chr(73820)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_GI = chr(73821)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_GIR2 = chr(73822)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_GUD = chr(73823)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_HA = chr(73824)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_IR = chr(73825)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_IR_PLUS_LU = chr(73826)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_KAK = chr(73827)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_LA = chr(73828)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_LU = chr(73829)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_LU_PLUS_MASH2 = chr(73830)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_LUM = chr(73831)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_NE = chr(73832)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_PAP_PLUS_PAP = chr(73833)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_SI = chr(73834)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_TAK4 = chr(73835)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_U2_PLUS_GIR2 = chr(73836)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_USH = chr(73837)
CUNEIFORM_SIGN_DAM = chr(73838)
CUNEIFORM_SIGN_DAR = chr(73839)
CUNEIFORM_SIGN_DARA3 = chr(73840)
CUNEIFORM_SIGN_DARA4 = chr(73841)
CUNEIFORM_SIGN_DI = chr(73842)
CUNEIFORM_SIGN_DIB = chr(73843)
CUNEIFORM_SIGN_DIM = chr(73844)
CUNEIFORM_SIGN_DIM_TIMES_SHE = chr(73845)
CUNEIFORM_SIGN_DIM2 = chr(73846)
CUNEIFORM_SIGN_DIN = chr(73847)
CUNEIFORM_SIGN_DIN_KASKAL_U_GUNU_DISH = chr(73848)
CUNEIFORM_SIGN_DISH = chr(73849)
CUNEIFORM_SIGN_DU = chr(73850)
CUNEIFORM_SIGN_DU_OVER_DU = chr(73851)
CUNEIFORM_SIGN_DU_GUNU = chr(73852)
CUNEIFORM_SIGN_DU_SHESHIG = chr(73853)
CUNEIFORM_SIGN_DUB = chr(73854)
CUNEIFORM_SIGN_DUB_TIMES_ESH2 = chr(73855)
CUNEIFORM_SIGN_DUB2 = chr(73856)
CUNEIFORM_SIGN_DUG = chr(73857)
CUNEIFORM_SIGN_DUGUD = chr(73858)
CUNEIFORM_SIGN_DUH = chr(73859)
CUNEIFORM_SIGN_DUN = chr(73860)
CUNEIFORM_SIGN_DUN3 = chr(73861)
CUNEIFORM_SIGN_DUN3_GUNU = chr(73862)
CUNEIFORM_SIGN_DUN3_GUNU_GUNU = chr(73863)
CUNEIFORM_SIGN_DUN4 = chr(73864)
CUNEIFORM_SIGN_DUR2 = chr(73865)
CUNEIFORM_SIGN_E = chr(73866)
CUNEIFORM_SIGN_E_TIMES_PAP = chr(73867)
CUNEIFORM_SIGN_E_OVER_E_NUN_OVER_NUN = chr(73868)
CUNEIFORM_SIGN_E2 = chr(73869)
CUNEIFORM_SIGN_E2_TIMES_A_PLUS_HA_PLUS_DA = chr(73870)
CUNEIFORM_SIGN_E2_TIMES_GAR = chr(73871)
CUNEIFORM_SIGN_E2_TIMES_MI = chr(73872)
CUNEIFORM_SIGN_E2_TIMES_SAL = chr(73873)
CUNEIFORM_SIGN_E2_TIMES_SHE = chr(73874)
CUNEIFORM_SIGN_E2_TIMES_U = chr(73875)
CUNEIFORM_SIGN_EDIN = chr(73876)
CUNEIFORM_SIGN_EGIR = chr(73877)
CUNEIFORM_SIGN_EL = chr(73878)
CUNEIFORM_SIGN_EN = chr(73879)
CUNEIFORM_SIGN_EN_TIMES_GAN2 = chr(73880)
CUNEIFORM_SIGN_EN_TIMES_GAN2_TENU = chr(73881)
CUNEIFORM_SIGN_EN_TIMES_ME = chr(73882)
CUNEIFORM_SIGN_EN_CROSSING_EN = chr(73883)
CUNEIFORM_SIGN_EN_OPPOSING_EN = chr(73884)
CUNEIFORM_SIGN_EN_SQUARED = chr(73885)
CUNEIFORM_SIGN_EREN = chr(73886)
CUNEIFORM_SIGN_ERIN2 = chr(73887)
CUNEIFORM_SIGN_ESH2 = chr(73888)
CUNEIFORM_SIGN_EZEN = chr(73889)
CUNEIFORM_SIGN_EZEN_TIMES_A = chr(73890)
CUNEIFORM_SIGN_EZEN_TIMES_A_PLUS_LAL = chr(73891)
CUNEIFORM_SIGN_EZEN_TIMES_A_PLUS_LAL_TIMES_LAL = chr(73892)
CUNEIFORM_SIGN_EZEN_TIMES_AN = chr(73893)
CUNEIFORM_SIGN_EZEN_TIMES_BAD = chr(73894)
CUNEIFORM_SIGN_EZEN_TIMES_DUN3_GUNU = chr(73895)
CUNEIFORM_SIGN_EZEN_TIMES_DUN3_GUNU_GUNU = chr(73896)
CUNEIFORM_SIGN_EZEN_TIMES_HA = chr(73897)
CUNEIFORM_SIGN_EZEN_TIMES_HA_GUNU = chr(73898)
CUNEIFORM_SIGN_EZEN_TIMES_IGI_GUNU = chr(73899)
CUNEIFORM_SIGN_EZEN_TIMES_KASKAL = chr(73900)
CUNEIFORM_SIGN_EZEN_TIMES_KASKAL_SQUARED = chr(73901)
CUNEIFORM_SIGN_EZEN_TIMES_KU3 = chr(73902)
CUNEIFORM_SIGN_EZEN_TIMES_LA = chr(73903)
CUNEIFORM_SIGN_EZEN_TIMES_LAL_TIMES_LAL = chr(73904)
CUNEIFORM_SIGN_EZEN_TIMES_LI = chr(73905)
CUNEIFORM_SIGN_EZEN_TIMES_LU = chr(73906)
CUNEIFORM_SIGN_EZEN_TIMES_U2 = chr(73907)
CUNEIFORM_SIGN_EZEN_TIMES_UD = chr(73908)
CUNEIFORM_SIGN_GA = chr(73909)
CUNEIFORM_SIGN_GA_GUNU = chr(73910)
CUNEIFORM_SIGN_GA2 = chr(73911)
CUNEIFORM_SIGN_GA2_TIMES_A_PLUS_DA_PLUS_HA = chr(73912)
CUNEIFORM_SIGN_GA2_TIMES_A_PLUS_HA = chr(73913)
CUNEIFORM_SIGN_GA2_TIMES_A_PLUS_IGI = chr(73914)
CUNEIFORM_SIGN_GA2_TIMES_AB2_TENU_PLUS_TAB = chr(73915)
CUNEIFORM_SIGN_GA2_TIMES_AN = chr(73916)
CUNEIFORM_SIGN_GA2_TIMES_ASH = chr(73917)
CUNEIFORM_SIGN_GA2_TIMES_ASH2_PLUS_GAL = chr(73918)
CUNEIFORM_SIGN_GA2_TIMES_BAD = chr(73919)
CUNEIFORM_SIGN_GA2_TIMES_BAR_PLUS_RA = chr(73920)
CUNEIFORM_SIGN_GA2_TIMES_BUR = chr(73921)
CUNEIFORM_SIGN_GA2_TIMES_BUR_PLUS_RA = chr(73922)
CUNEIFORM_SIGN_GA2_TIMES_DA = chr(73923)
CUNEIFORM_SIGN_GA2_TIMES_DI = chr(73924)
CUNEIFORM_SIGN_GA2_TIMES_DIM_TIMES_SHE = chr(73925)
CUNEIFORM_SIGN_GA2_TIMES_DUB = chr(73926)
CUNEIFORM_SIGN_GA2_TIMES_EL = chr(73927)
CUNEIFORM_SIGN_GA2_TIMES_EL_PLUS_LA = chr(73928)
CUNEIFORM_SIGN_GA2_TIMES_EN = chr(73929)
CUNEIFORM_SIGN_GA2_TIMES_EN_TIMES_GAN2_TENU = chr(73930)
CUNEIFORM_SIGN_GA2_TIMES_GAN2_TENU = chr(73931)
CUNEIFORM_SIGN_GA2_TIMES_GAR = chr(73932)
CUNEIFORM_SIGN_GA2_TIMES_GI = chr(73933)
CUNEIFORM_SIGN_GA2_TIMES_GI4 = chr(73934)
CUNEIFORM_SIGN_GA2_TIMES_GI4_PLUS_A = chr(73935)
CUNEIFORM_SIGN_GA2_TIMES_GIR2_PLUS_SU = chr(73936)
CUNEIFORM_SIGN_GA2_TIMES_HA_PLUS_LU_PLUS_ESH2 = chr(73937)
CUNEIFORM_SIGN_GA2_TIMES_HAL = chr(73938)
CUNEIFORM_SIGN_GA2_TIMES_HAL_PLUS_LA = chr(73939)
CUNEIFORM_SIGN_GA2_TIMES_HI_PLUS_LI = chr(73940)
CUNEIFORM_SIGN_GA2_TIMES_HUB2 = chr(73941)
CUNEIFORM_SIGN_GA2_TIMES_IGI_GUNU = chr(73942)
CUNEIFORM_SIGN_GA2_TIMES_ISH_PLUS_HU_PLUS_ASH = chr(73943)
CUNEIFORM_SIGN_GA2_TIMES_KAK = chr(73944)
CUNEIFORM_SIGN_GA2_TIMES_KASKAL = chr(73945)
CUNEIFORM_SIGN_GA2_TIMES_KID = chr(73946)
CUNEIFORM_SIGN_GA2_TIMES_KID_PLUS_LAL = chr(73947)
CUNEIFORM_SIGN_GA2_TIMES_KU3_PLUS_AN = chr(73948)
CUNEIFORM_SIGN_GA2_TIMES_LA = chr(73949)
CUNEIFORM_SIGN_GA2_TIMES_ME_PLUS_EN = chr(73950)
CUNEIFORM_SIGN_GA2_TIMES_MI = chr(73951)
CUNEIFORM_SIGN_GA2_TIMES_NUN = chr(73952)
CUNEIFORM_SIGN_GA2_TIMES_NUN_OVER_NUN = chr(73953)
CUNEIFORM_SIGN_GA2_TIMES_PA = chr(73954)
CUNEIFORM_SIGN_GA2_TIMES_SAL = chr(73955)
CUNEIFORM_SIGN_GA2_TIMES_SAR = chr(73956)
CUNEIFORM_SIGN_GA2_TIMES_SHE = chr(73957)
CUNEIFORM_SIGN_GA2_TIMES_SHE_PLUS_TUR = chr(73958)
CUNEIFORM_SIGN_GA2_TIMES_SHID = chr(73959)
CUNEIFORM_SIGN_GA2_TIMES_SUM = chr(73960)
CUNEIFORM_SIGN_GA2_TIMES_TAK4 = chr(73961)
CUNEIFORM_SIGN_GA2_TIMES_U = chr(73962)
CUNEIFORM_SIGN_GA2_TIMES_UD = chr(73963)
CUNEIFORM_SIGN_GA2_TIMES_UD_PLUS_DU = chr(73964)
CUNEIFORM_SIGN_GA2_OVER_GA2 = chr(73965)
CUNEIFORM_SIGN_GABA = chr(73966)
CUNEIFORM_SIGN_GABA_CROSSING_GABA = chr(73967)
CUNEIFORM_SIGN_GAD = chr(73968)
CUNEIFORM_SIGN_GAD_OVER_GAD_GAR_OVER_GAR = chr(73969)
CUNEIFORM_SIGN_GAL = chr(73970)
CUNEIFORM_SIGN_GAL_GAD_OVER_GAD_GAR_OVER_GAR = chr(73971)
CUNEIFORM_SIGN_GALAM = chr(73972)
CUNEIFORM_SIGN_GAM = chr(73973)
CUNEIFORM_SIGN_GAN = chr(73974)
CUNEIFORM_SIGN_GAN2 = chr(73975)
CUNEIFORM_SIGN_GAN2_TENU = chr(73976)
CUNEIFORM_SIGN_GAN2_OVER_GAN2 = chr(73977)
CUNEIFORM_SIGN_GAN2_CROSSING_GAN2 = chr(73978)
CUNEIFORM_SIGN_GAR = chr(73979)
CUNEIFORM_SIGN_GAR3 = chr(73980)
CUNEIFORM_SIGN_GASHAN = chr(73981)
CUNEIFORM_SIGN_GESHTIN = chr(73982)
CUNEIFORM_SIGN_GESHTIN_TIMES_KUR = chr(73983)
CUNEIFORM_SIGN_GI = chr(73984)
CUNEIFORM_SIGN_GI_TIMES_E = chr(73985)
CUNEIFORM_SIGN_GI_TIMES_U = chr(73986)
CUNEIFORM_SIGN_GI_CROSSING_GI = chr(73987)
CUNEIFORM_SIGN_GI4 = chr(73988)
CUNEIFORM_SIGN_GI4_OVER_GI4 = chr(73989)
CUNEIFORM_SIGN_GI4_CROSSING_GI4 = chr(73990)
CUNEIFORM_SIGN_GIDIM = chr(73991)
CUNEIFORM_SIGN_GIR2 = chr(73992)
CUNEIFORM_SIGN_GIR2_GUNU = chr(73993)
CUNEIFORM_SIGN_GIR3 = chr(73994)
CUNEIFORM_SIGN_GIR3_TIMES_A_PLUS_IGI = chr(73995)
CUNEIFORM_SIGN_GIR3_TIMES_GAN2_TENU = chr(73996)
CUNEIFORM_SIGN_GIR3_TIMES_IGI = chr(73997)
CUNEIFORM_SIGN_GIR3_TIMES_LU_PLUS_IGI = chr(73998)
CUNEIFORM_SIGN_GIR3_TIMES_PA = chr(73999)
CUNEIFORM_SIGN_GISAL = chr(74000)
CUNEIFORM_SIGN_GISH = chr(74001)
CUNEIFORM_SIGN_GISH_CROSSING_GISH = chr(74002)
CUNEIFORM_SIGN_GISH_TIMES_BAD = chr(74003)
CUNEIFORM_SIGN_GISH_TIMES_TAK4 = chr(74004)
CUNEIFORM_SIGN_GISH_TENU = chr(74005)
CUNEIFORM_SIGN_GU = chr(74006)
CUNEIFORM_SIGN_GU_CROSSING_GU = chr(74007)
CUNEIFORM_SIGN_GU2 = chr(74008)
CUNEIFORM_SIGN_GU2_TIMES_KAK = chr(74009)
CUNEIFORM_SIGN_GU2_TIMES_KAK_TIMES_IGI_GUNU = chr(74010)
CUNEIFORM_SIGN_GU2_TIMES_NUN = chr(74011)
CUNEIFORM_SIGN_GU2_TIMES_SAL_PLUS_TUG2 = chr(74012)
CUNEIFORM_SIGN_GU2_GUNU = chr(74013)
CUNEIFORM_SIGN_GUD = chr(74014)
CUNEIFORM_SIGN_GUD_TIMES_A_PLUS_KUR = chr(74015)
CUNEIFORM_SIGN_GUD_TIMES_KUR = chr(74016)
CUNEIFORM_SIGN_GUD_OVER_GUD_LUGAL = chr(74017)
CUNEIFORM_SIGN_GUL = chr(74018)
CUNEIFORM_SIGN_GUM = chr(74019)
CUNEIFORM_SIGN_GUM_TIMES_SHE = chr(74020)
CUNEIFORM_SIGN_GUR = chr(74021)
CUNEIFORM_SIGN_GUR7 = chr(74022)
CUNEIFORM_SIGN_GURUN = chr(74023)
CUNEIFORM_SIGN_GURUSH = chr(74024)
CUNEIFORM_SIGN_HA = chr(74025)
CUNEIFORM_SIGN_HA_TENU = chr(74026)
CUNEIFORM_SIGN_HA_GUNU = chr(74027)
CUNEIFORM_SIGN_HAL = chr(74028)
CUNEIFORM_SIGN_HI = chr(74029)
CUNEIFORM_SIGN_HI_TIMES_ASH = chr(74030)
CUNEIFORM_SIGN_HI_TIMES_ASH2 = chr(74031)
CUNEIFORM_SIGN_HI_TIMES_BAD = chr(74032)
CUNEIFORM_SIGN_HI_TIMES_DISH = chr(74033)
CUNEIFORM_SIGN_HI_TIMES_GAD = chr(74034)
CUNEIFORM_SIGN_HI_TIMES_KIN = chr(74035)
CUNEIFORM_SIGN_HI_TIMES_NUN = chr(74036)
CUNEIFORM_SIGN_HI_TIMES_SHE = chr(74037)
CUNEIFORM_SIGN_HI_TIMES_U = chr(74038)
CUNEIFORM_SIGN_HU = chr(74039)
CUNEIFORM_SIGN_HUB2 = chr(74040)
CUNEIFORM_SIGN_HUB2_TIMES_AN = chr(74041)
CUNEIFORM_SIGN_HUB2_TIMES_HAL = chr(74042)
CUNEIFORM_SIGN_HUB2_TIMES_KASKAL = chr(74043)
CUNEIFORM_SIGN_HUB2_TIMES_LISH = chr(74044)
CUNEIFORM_SIGN_HUB2_TIMES_UD = chr(74045)
CUNEIFORM_SIGN_HUL2 = chr(74046)
CUNEIFORM_SIGN_I = chr(74047)
CUNEIFORM_SIGN_I_A = chr(74048)
CUNEIFORM_SIGN_IB = chr(74049)
CUNEIFORM_SIGN_IDIM = chr(74050)
CUNEIFORM_SIGN_IDIM_OVER_IDIM_BUR = chr(74051)
CUNEIFORM_SIGN_IDIM_OVER_IDIM_SQUARED = chr(74052)
CUNEIFORM_SIGN_IG = chr(74053)
CUNEIFORM_SIGN_IGI = chr(74054)
CUNEIFORM_SIGN_IGI_DIB = chr(74055)
CUNEIFORM_SIGN_IGI_RI = chr(74056)
CUNEIFORM_SIGN_IGI_OVER_IGI_SHIR_OVER_SHIR_UD_OVER_UD = chr(74057)
CUNEIFORM_SIGN_IGI_GUNU = chr(74058)
CUNEIFORM_SIGN_IL = chr(74059)
CUNEIFORM_SIGN_IL_TIMES_GAN2_TENU = chr(74060)
CUNEIFORM_SIGN_IL2 = chr(74061)
CUNEIFORM_SIGN_IM = chr(74062)
CUNEIFORM_SIGN_IM_TIMES_TAK4 = chr(74063)
CUNEIFORM_SIGN_IM_CROSSING_IM = chr(74064)
CUNEIFORM_SIGN_IM_OPPOSING_IM = chr(74065)
CUNEIFORM_SIGN_IM_SQUARED = chr(74066)
CUNEIFORM_SIGN_IMIN = chr(74067)
CUNEIFORM_SIGN_IN = chr(74068)
CUNEIFORM_SIGN_IR = chr(74069)
CUNEIFORM_SIGN_ISH = chr(74070)
CUNEIFORM_SIGN_KA = chr(74071)
CUNEIFORM_SIGN_KA_TIMES_A = chr(74072)
CUNEIFORM_SIGN_KA_TIMES_AD = chr(74073)
CUNEIFORM_SIGN_KA_TIMES_AD_PLUS_KU3 = chr(74074)
CUNEIFORM_SIGN_KA_TIMES_ASH2 = chr(74075)
CUNEIFORM_SIGN_KA_TIMES_BAD = chr(74076)
CUNEIFORM_SIGN_KA_TIMES_BALAG = chr(74077)
CUNEIFORM_SIGN_KA_TIMES_BAR = chr(74078)
CUNEIFORM_SIGN_KA_TIMES_BI = chr(74079)
CUNEIFORM_SIGN_KA_TIMES_ERIN2 = chr(74080)
CUNEIFORM_SIGN_KA_TIMES_ESH2 = chr(74081)
CUNEIFORM_SIGN_KA_TIMES_GA = chr(74082)
CUNEIFORM_SIGN_KA_TIMES_GAL = chr(74083)
CUNEIFORM_SIGN_KA_TIMES_GAN2_TENU = chr(74084)
CUNEIFORM_SIGN_KA_TIMES_GAR = chr(74085)
CUNEIFORM_SIGN_KA_TIMES_GAR_PLUS_SHA3_PLUS_A = chr(74086)
CUNEIFORM_SIGN_KA_TIMES_GI = chr(74087)
CUNEIFORM_SIGN_KA_TIMES_GIR2 = chr(74088)
CUNEIFORM_SIGN_KA_TIMES_GISH_PLUS_SAR = chr(74089)
CUNEIFORM_SIGN_KA_TIMES_GISH_CROSSING_GISH = chr(74090)
CUNEIFORM_SIGN_KA_TIMES_GU = chr(74091)
CUNEIFORM_SIGN_KA_TIMES_GUR7 = chr(74092)
CUNEIFORM_SIGN_KA_TIMES_IGI = chr(74093)
CUNEIFORM_SIGN_KA_TIMES_IM = chr(74094)
CUNEIFORM_SIGN_KA_TIMES_KAK = chr(74095)
CUNEIFORM_SIGN_KA_TIMES_KI = chr(74096)
CUNEIFORM_SIGN_KA_TIMES_KID = chr(74097)
CUNEIFORM_SIGN_KA_TIMES_LI = chr(74098)
CUNEIFORM_SIGN_KA_TIMES_LU = chr(74099)
CUNEIFORM_SIGN_KA_TIMES_ME = chr(74100)
CUNEIFORM_SIGN_KA_TIMES_ME_PLUS_DU = chr(74101)
CUNEIFORM_SIGN_KA_TIMES_ME_PLUS_GI = chr(74102)
CUNEIFORM_SIGN_KA_TIMES_ME_PLUS_TE = chr(74103)
CUNEIFORM_SIGN_KA_TIMES_MI = chr(74104)
CUNEIFORM_SIGN_KA_TIMES_MI_PLUS_NUNUZ = chr(74105)
CUNEIFORM_SIGN_KA_TIMES_NE = chr(74106)
CUNEIFORM_SIGN_KA_TIMES_NUN = chr(74107)
CUNEIFORM_SIGN_KA_TIMES_PI = chr(74108)
CUNEIFORM_SIGN_KA_TIMES_RU = chr(74109)
CUNEIFORM_SIGN_KA_TIMES_SA = chr(74110)
CUNEIFORM_SIGN_KA_TIMES_SAR = chr(74111)
CUNEIFORM_SIGN_KA_TIMES_SHA = chr(74112)
CUNEIFORM_SIGN_KA_TIMES_SHE = chr(74113)
CUNEIFORM_SIGN_KA_TIMES_SHID = chr(74114)
CUNEIFORM_SIGN_KA_TIMES_SHU = chr(74115)
CUNEIFORM_SIGN_KA_TIMES_SIG = chr(74116)
CUNEIFORM_SIGN_KA_TIMES_SUHUR = chr(74117)
CUNEIFORM_SIGN_KA_TIMES_TAR = chr(74118)
CUNEIFORM_SIGN_KA_TIMES_U = chr(74119)
CUNEIFORM_SIGN_KA_TIMES_U2 = chr(74120)
CUNEIFORM_SIGN_KA_TIMES_UD = chr(74121)
CUNEIFORM_SIGN_KA_TIMES_UMUM_TIMES_PA = chr(74122)
CUNEIFORM_SIGN_KA_TIMES_USH = chr(74123)
CUNEIFORM_SIGN_KA_TIMES_ZI = chr(74124)
CUNEIFORM_SIGN_KA2 = chr(74125)
CUNEIFORM_SIGN_KA2_CROSSING_KA2 = chr(74126)
CUNEIFORM_SIGN_KAB = chr(74127)
CUNEIFORM_SIGN_KAD2 = chr(74128)
CUNEIFORM_SIGN_KAD3 = chr(74129)
CUNEIFORM_SIGN_KAD4 = chr(74130)
CUNEIFORM_SIGN_KAD5 = chr(74131)
CUNEIFORM_SIGN_KAD5_OVER_KAD5 = chr(74132)
CUNEIFORM_SIGN_KAK = chr(74133)
CUNEIFORM_SIGN_KAK_TIMES_IGI_GUNU = chr(74134)
CUNEIFORM_SIGN_KAL = chr(74135)
CUNEIFORM_SIGN_KAL_TIMES_BAD = chr(74136)
CUNEIFORM_SIGN_KAL_CROSSING_KAL = chr(74137)
CUNEIFORM_SIGN_KAM2 = chr(74138)
CUNEIFORM_SIGN_KAM4 = chr(74139)
CUNEIFORM_SIGN_KASKAL = chr(74140)
CUNEIFORM_SIGN_KASKAL_LAGAB_TIMES_U_OVER_LAGAB_TIMES_U = chr(74141)
CUNEIFORM_SIGN_KASKAL_OVER_KASKAL_LAGAB_TIMES_U_OVER_LAGAB_TIMES_U = chr(74142)
CUNEIFORM_SIGN_KESH2 = chr(74143)
CUNEIFORM_SIGN_KI = chr(74144)
CUNEIFORM_SIGN_KI_TIMES_BAD = chr(74145)
CUNEIFORM_SIGN_KI_TIMES_U = chr(74146)
CUNEIFORM_SIGN_KI_TIMES_UD = chr(74147)
CUNEIFORM_SIGN_KID = chr(74148)
CUNEIFORM_SIGN_KIN = chr(74149)
CUNEIFORM_SIGN_KISAL = chr(74150)
CUNEIFORM_SIGN_KISH = chr(74151)
CUNEIFORM_SIGN_KISIM5 = chr(74152)
CUNEIFORM_SIGN_KISIM5_OVER_KISIM5 = chr(74153)
CUNEIFORM_SIGN_KU = chr(74154)
CUNEIFORM_SIGN_KU_OVER_HI_TIMES_ASH2_KU_OVER_HI_TIMES_ASH2 = chr(74155)
CUNEIFORM_SIGN_KU3 = chr(74156)
CUNEIFORM_SIGN_KU4 = chr(74157)
CUNEIFORM_SIGN_KU4_VARIANT_FORM = chr(74158)
CUNEIFORM_SIGN_KU7 = chr(74159)
CUNEIFORM_SIGN_KUL = chr(74160)
CUNEIFORM_SIGN_KUL_GUNU = chr(74161)
CUNEIFORM_SIGN_KUN = chr(74162)
CUNEIFORM_SIGN_KUR = chr(74163)
CUNEIFORM_SIGN_KUR_OPPOSING_KUR = chr(74164)
CUNEIFORM_SIGN_KUSHU2 = chr(74165)
CUNEIFORM_SIGN_KWU318 = chr(74166)
CUNEIFORM_SIGN_LA = chr(74167)
CUNEIFORM_SIGN_LAGAB = chr(74168)
CUNEIFORM_SIGN_LAGAB_TIMES_A = chr(74169)
CUNEIFORM_SIGN_LAGAB_TIMES_A_PLUS_DA_PLUS_HA = chr(74170)
CUNEIFORM_SIGN_LAGAB_TIMES_A_PLUS_GAR = chr(74171)
CUNEIFORM_SIGN_LAGAB_TIMES_A_PLUS_LAL = chr(74172)
CUNEIFORM_SIGN_LAGAB_TIMES_AL = chr(74173)
CUNEIFORM_SIGN_LAGAB_TIMES_AN = chr(74174)
CUNEIFORM_SIGN_LAGAB_TIMES_ASH_ZIDA_TENU = chr(74175)
CUNEIFORM_SIGN_LAGAB_TIMES_BAD = chr(74176)
CUNEIFORM_SIGN_LAGAB_TIMES_BI = chr(74177)
CUNEIFORM_SIGN_LAGAB_TIMES_DAR = chr(74178)
CUNEIFORM_SIGN_LAGAB_TIMES_EN = chr(74179)
CUNEIFORM_SIGN_LAGAB_TIMES_GA = chr(74180)
CUNEIFORM_SIGN_LAGAB_TIMES_GAR = chr(74181)
CUNEIFORM_SIGN_LAGAB_TIMES_GUD = chr(74182)
CUNEIFORM_SIGN_LAGAB_TIMES_GUD_PLUS_GUD = chr(74183)
CUNEIFORM_SIGN_LAGAB_TIMES_HA = chr(74184)
CUNEIFORM_SIGN_LAGAB_TIMES_HAL = chr(74185)
CUNEIFORM_SIGN_LAGAB_TIMES_HI_TIMES_NUN = chr(74186)
CUNEIFORM_SIGN_LAGAB_TIMES_IGI_GUNU = chr(74187)
CUNEIFORM_SIGN_LAGAB_TIMES_IM = chr(74188)
CUNEIFORM_SIGN_LAGAB_TIMES_IM_PLUS_HA = chr(74189)
CUNEIFORM_SIGN_LAGAB_TIMES_IM_PLUS_LU = chr(74190)
CUNEIFORM_SIGN_LAGAB_TIMES_KI = chr(74191)
CUNEIFORM_SIGN_LAGAB_TIMES_KIN = chr(74192)
CUNEIFORM_SIGN_LAGAB_TIMES_KU3 = chr(74193)
CUNEIFORM_SIGN_LAGAB_TIMES_KUL = chr(74194)
CUNEIFORM_SIGN_LAGAB_TIMES_KUL_PLUS_HI_PLUS_A = chr(74195)
CUNEIFORM_SIGN_LAGAB_TIMES_LAGAB = chr(74196)
CUNEIFORM_SIGN_LAGAB_TIMES_LISH = chr(74197)
CUNEIFORM_SIGN_LAGAB_TIMES_LU = chr(74198)
CUNEIFORM_SIGN_LAGAB_TIMES_LUL = chr(74199)
CUNEIFORM_SIGN_LAGAB_TIMES_ME = chr(74200)
CUNEIFORM_SIGN_LAGAB_TIMES_ME_PLUS_EN = chr(74201)
CUNEIFORM_SIGN_LAGAB_TIMES_MUSH = chr(74202)
CUNEIFORM_SIGN_LAGAB_TIMES_NE = chr(74203)
CUNEIFORM_SIGN_LAGAB_TIMES_SHE_PLUS_SUM = chr(74204)
CUNEIFORM_SIGN_LAGAB_TIMES_SHITA_PLUS_GISH_PLUS_ERIN2 = chr(74205)
CUNEIFORM_SIGN_LAGAB_TIMES_SHITA_PLUS_GISH_TENU = chr(74206)
CUNEIFORM_SIGN_LAGAB_TIMES_SHU2 = chr(74207)
CUNEIFORM_SIGN_LAGAB_TIMES_SHU2_PLUS_SHU2 = chr(74208)
CUNEIFORM_SIGN_LAGAB_TIMES_SUM = chr(74209)
CUNEIFORM_SIGN_LAGAB_TIMES_TAG = chr(74210)
CUNEIFORM_SIGN_LAGAB_TIMES_TAK4 = chr(74211)
CUNEIFORM_SIGN_LAGAB_TIMES_TE_PLUS_A_PLUS_SU_PLUS_NA = chr(74212)
CUNEIFORM_SIGN_LAGAB_TIMES_U = chr(74213)
CUNEIFORM_SIGN_LAGAB_TIMES_U_PLUS_A = chr(74214)
CUNEIFORM_SIGN_LAGAB_TIMES_U_PLUS_U_PLUS_U = chr(74215)
CUNEIFORM_SIGN_LAGAB_TIMES_U2_PLUS_ASH = chr(74216)
CUNEIFORM_SIGN_LAGAB_TIMES_UD = chr(74217)
CUNEIFORM_SIGN_LAGAB_TIMES_USH = chr(74218)
CUNEIFORM_SIGN_LAGAB_SQUARED = chr(74219)
CUNEIFORM_SIGN_LAGAR = chr(74220)
CUNEIFORM_SIGN_LAGAR_TIMES_SHE = chr(74221)
CUNEIFORM_SIGN_LAGAR_TIMES_SHE_PLUS_SUM = chr(74222)
CUNEIFORM_SIGN_LAGAR_GUNU = chr(74223)
CUNEIFORM_SIGN_LAGAR_GUNU_OVER_LAGAR_GUNU_SHE = chr(74224)
CUNEIFORM_SIGN_LAHSHU = chr(74225)
CUNEIFORM_SIGN_LAL = chr(74226)
CUNEIFORM_SIGN_LAL_TIMES_LAL = chr(74227)
CUNEIFORM_SIGN_LAM = chr(74228)
CUNEIFORM_SIGN_LAM_TIMES_KUR = chr(74229)
CUNEIFORM_SIGN_LAM_TIMES_KUR_PLUS_RU = chr(74230)
CUNEIFORM_SIGN_LI = chr(74231)
CUNEIFORM_SIGN_LIL = chr(74232)
CUNEIFORM_SIGN_LIMMU2 = chr(74233)
CUNEIFORM_SIGN_LISH = chr(74234)
CUNEIFORM_SIGN_LU = chr(74235)
CUNEIFORM_SIGN_LU_TIMES_BAD = chr(74236)
CUNEIFORM_SIGN_LU2 = chr(74237)
CUNEIFORM_SIGN_LU2_TIMES_AL = chr(74238)
CUNEIFORM_SIGN_LU2_TIMES_BAD = chr(74239)
CUNEIFORM_SIGN_LU2_TIMES_ESH2 = chr(74240)
CUNEIFORM_SIGN_LU2_TIMES_ESH2_TENU = chr(74241)
CUNEIFORM_SIGN_LU2_TIMES_GAN2_TENU = chr(74242)
CUNEIFORM_SIGN_LU2_TIMES_HI_TIMES_BAD = chr(74243)
CUNEIFORM_SIGN_LU2_TIMES_IM = chr(74244)
CUNEIFORM_SIGN_LU2_TIMES_KAD2 = chr(74245)
CUNEIFORM_SIGN_LU2_TIMES_KAD3 = chr(74246)
CUNEIFORM_SIGN_LU2_TIMES_KAD3_PLUS_ASH = chr(74247)
CUNEIFORM_SIGN_LU2_TIMES_KI = chr(74248)
CUNEIFORM_SIGN_LU2_TIMES_LA_PLUS_ASH = chr(74249)
CUNEIFORM_SIGN_LU2_TIMES_LAGAB = chr(74250)
CUNEIFORM_SIGN_LU2_TIMES_ME_PLUS_EN = chr(74251)
CUNEIFORM_SIGN_LU2_TIMES_NE = chr(74252)
CUNEIFORM_SIGN_LU2_TIMES_NU = chr(74253)
CUNEIFORM_SIGN_LU2_TIMES_SI_PLUS_ASH = chr(74254)
CUNEIFORM_SIGN_LU2_TIMES_SIK2_PLUS_BU = chr(74255)
CUNEIFORM_SIGN_LU2_TIMES_TUG2 = chr(74256)
CUNEIFORM_SIGN_LU2_TENU = chr(74257)
CUNEIFORM_SIGN_LU2_CROSSING_LU2 = chr(74258)
CUNEIFORM_SIGN_LU2_OPPOSING_LU2 = chr(74259)
CUNEIFORM_SIGN_LU2_SQUARED = chr(74260)
CUNEIFORM_SIGN_LU2_SHESHIG = chr(74261)
CUNEIFORM_SIGN_LU3 = chr(74262)
CUNEIFORM_SIGN_LUGAL = chr(74263)
CUNEIFORM_SIGN_LUGAL_OVER_LUGAL = chr(74264)
CUNEIFORM_SIGN_LUGAL_OPPOSING_LUGAL = chr(74265)
CUNEIFORM_SIGN_LUGAL_SHESHIG = chr(74266)
CUNEIFORM_SIGN_LUH = chr(74267)
CUNEIFORM_SIGN_LUL = chr(74268)
CUNEIFORM_SIGN_LUM = chr(74269)
CUNEIFORM_SIGN_LUM_OVER_LUM = chr(74270)
CUNEIFORM_SIGN_LUM_OVER_LUM_GAR_OVER_GAR = chr(74271)
CUNEIFORM_SIGN_MA = chr(74272)
CUNEIFORM_SIGN_MA_TIMES_TAK4 = chr(74273)
CUNEIFORM_SIGN_MA_GUNU = chr(74274)
CUNEIFORM_SIGN_MA2 = chr(74275)
CUNEIFORM_SIGN_MAH = chr(74276)
CUNEIFORM_SIGN_MAR = chr(74277)
CUNEIFORM_SIGN_MASH = chr(74278)
CUNEIFORM_SIGN_MASH2 = chr(74279)
CUNEIFORM_SIGN_ME = chr(74280)
CUNEIFORM_SIGN_MES = chr(74281)
CUNEIFORM_SIGN_MI = chr(74282)
CUNEIFORM_SIGN_MIN = chr(74283)
CUNEIFORM_SIGN_MU = chr(74284)
CUNEIFORM_SIGN_MU_OVER_MU = chr(74285)
CUNEIFORM_SIGN_MUG = chr(74286)
CUNEIFORM_SIGN_MUG_GUNU = chr(74287)
CUNEIFORM_SIGN_MUNSUB = chr(74288)
CUNEIFORM_SIGN_MURGU2 = chr(74289)
CUNEIFORM_SIGN_MUSH = chr(74290)
CUNEIFORM_SIGN_MUSH_TIMES_A = chr(74291)
CUNEIFORM_SIGN_MUSH_TIMES_KUR = chr(74292)
CUNEIFORM_SIGN_MUSH_TIMES_ZA = chr(74293)
CUNEIFORM_SIGN_MUSH_OVER_MUSH = chr(74294)
CUNEIFORM_SIGN_MUSH_OVER_MUSH_TIMES_A_PLUS_NA = chr(74295)
CUNEIFORM_SIGN_MUSH_CROSSING_MUSH = chr(74296)
CUNEIFORM_SIGN_MUSH3 = chr(74297)
CUNEIFORM_SIGN_MUSH3_TIMES_A = chr(74298)
CUNEIFORM_SIGN_MUSH3_TIMES_A_PLUS_DI = chr(74299)
CUNEIFORM_SIGN_MUSH3_TIMES_DI = chr(74300)
CUNEIFORM_SIGN_MUSH3_GUNU = chr(74301)
CUNEIFORM_SIGN_NA = chr(74302)
CUNEIFORM_SIGN_NA2 = chr(74303)
CUNEIFORM_SIGN_NAGA = chr(74304)
CUNEIFORM_SIGN_NAGA_INVERTED = chr(74305)
CUNEIFORM_SIGN_NAGA_TIMES_SHU_TENU = chr(74306)
CUNEIFORM_SIGN_NAGA_OPPOSING_NAGA = chr(74307)
CUNEIFORM_SIGN_NAGAR = chr(74308)
CUNEIFORM_SIGN_NAM_NUTILLU = chr(74309)
CUNEIFORM_SIGN_NAM = chr(74310)
CUNEIFORM_SIGN_NAM2 = chr(74311)
CUNEIFORM_SIGN_NE = chr(74312)
CUNEIFORM_SIGN_NE_TIMES_A = chr(74313)
CUNEIFORM_SIGN_NE_TIMES_UD = chr(74314)
CUNEIFORM_SIGN_NE_SHESHIG = chr(74315)
CUNEIFORM_SIGN_NI = chr(74316)
CUNEIFORM_SIGN_NI_TIMES_E = chr(74317)
CUNEIFORM_SIGN_NI2 = chr(74318)
CUNEIFORM_SIGN_NIM = chr(74319)
CUNEIFORM_SIGN_NIM_TIMES_GAN2_TENU = chr(74320)
CUNEIFORM_SIGN_NIM_TIMES_GAR_PLUS_GAN2_TENU = chr(74321)
CUNEIFORM_SIGN_NINDA2 = chr(74322)
CUNEIFORM_SIGN_NINDA2_TIMES_AN = chr(74323)
CUNEIFORM_SIGN_NINDA2_TIMES_ASH = chr(74324)
CUNEIFORM_SIGN_NINDA2_TIMES_ASH_PLUS_ASH = chr(74325)
CUNEIFORM_SIGN_NINDA2_TIMES_GUD = chr(74326)
CUNEIFORM_SIGN_NINDA2_TIMES_ME_PLUS_GAN2_TENU = chr(74327)
CUNEIFORM_SIGN_NINDA2_TIMES_NE = chr(74328)
CUNEIFORM_SIGN_NINDA2_TIMES_NUN = chr(74329)
CUNEIFORM_SIGN_NINDA2_TIMES_SHE = chr(74330)
CUNEIFORM_SIGN_NINDA2_TIMES_SHE_PLUS_A_AN = chr(74331)
CUNEIFORM_SIGN_NINDA2_TIMES_SHE_PLUS_ASH = chr(74332)
CUNEIFORM_SIGN_NINDA2_TIMES_SHE_PLUS_ASH_PLUS_ASH = chr(74333)
CUNEIFORM_SIGN_NINDA2_TIMES_U2_PLUS_ASH = chr(74334)
CUNEIFORM_SIGN_NINDA2_TIMES_USH = chr(74335)
CUNEIFORM_SIGN_NISAG = chr(74336)
CUNEIFORM_SIGN_NU = chr(74337)
CUNEIFORM_SIGN_NU11 = chr(74338)
CUNEIFORM_SIGN_NUN = chr(74339)
CUNEIFORM_SIGN_NUN_LAGAR_TIMES_GAR = chr(74340)
CUNEIFORM_SIGN_NUN_LAGAR_TIMES_MASH = chr(74341)
CUNEIFORM_SIGN_NUN_LAGAR_TIMES_SAL = chr(74342)
CUNEIFORM_SIGN_NUN_LAGAR_TIMES_SAL_OVER_NUN_LAGAR_TIMES_SAL = chr(74343)
CUNEIFORM_SIGN_NUN_LAGAR_TIMES_USH = chr(74344)
CUNEIFORM_SIGN_NUN_TENU = chr(74345)
CUNEIFORM_SIGN_NUN_OVER_NUN = chr(74346)
CUNEIFORM_SIGN_NUN_CROSSING_NUN = chr(74347)
CUNEIFORM_SIGN_NUN_CROSSING_NUN_LAGAR_OVER_LAGAR = chr(74348)
CUNEIFORM_SIGN_NUNUZ = chr(74349)
CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_ASHGAB = chr(74350)
CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_BI = chr(74351)
CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_DUG = chr(74352)
CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_GUD = chr(74353)
CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_IGI_GUNU = chr(74354)
CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_KAD3 = chr(74355)
CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_LA = chr(74356)
CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_NE = chr(74357)
CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_SILA3 = chr(74358)
CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_U2 = chr(74359)
CUNEIFORM_SIGN_NUNUZ_KISIM5_TIMES_BI = chr(74360)
CUNEIFORM_SIGN_NUNUZ_KISIM5_TIMES_BI_U = chr(74361)
CUNEIFORM_SIGN_PA = chr(74362)
CUNEIFORM_SIGN_PAD = chr(74363)
CUNEIFORM_SIGN_PAN = chr(74364)
CUNEIFORM_SIGN_PAP = chr(74365)
CUNEIFORM_SIGN_PESH2 = chr(74366)
CUNEIFORM_SIGN_PI = chr(74367)
CUNEIFORM_SIGN_PI_TIMES_A = chr(74368)
CUNEIFORM_SIGN_PI_TIMES_AB = chr(74369)
CUNEIFORM_SIGN_PI_TIMES_BI = chr(74370)
CUNEIFORM_SIGN_PI_TIMES_BU = chr(74371)
CUNEIFORM_SIGN_PI_TIMES_E = chr(74372)
CUNEIFORM_SIGN_PI_TIMES_I = chr(74373)
CUNEIFORM_SIGN_PI_TIMES_IB = chr(74374)
CUNEIFORM_SIGN_PI_TIMES_U = chr(74375)
CUNEIFORM_SIGN_PI_TIMES_U2 = chr(74376)
CUNEIFORM_SIGN_PI_CROSSING_PI = chr(74377)
CUNEIFORM_SIGN_PIRIG = chr(74378)
CUNEIFORM_SIGN_PIRIG_TIMES_KAL = chr(74379)
CUNEIFORM_SIGN_PIRIG_TIMES_UD = chr(74380)
CUNEIFORM_SIGN_PIRIG_TIMES_ZA = chr(74381)
CUNEIFORM_SIGN_PIRIG_OPPOSING_PIRIG = chr(74382)
CUNEIFORM_SIGN_RA = chr(74383)
CUNEIFORM_SIGN_RAB = chr(74384)
CUNEIFORM_SIGN_RI = chr(74385)
CUNEIFORM_SIGN_RU = chr(74386)
CUNEIFORM_SIGN_SA = chr(74387)
CUNEIFORM_SIGN_SAG_NUTILLU = chr(74388)
CUNEIFORM_SIGN_SAG = chr(74389)
CUNEIFORM_SIGN_SAG_TIMES_A = chr(74390)
CUNEIFORM_SIGN_SAG_TIMES_DU = chr(74391)
CUNEIFORM_SIGN_SAG_TIMES_DUB = chr(74392)
CUNEIFORM_SIGN_SAG_TIMES_HA = chr(74393)
CUNEIFORM_SIGN_SAG_TIMES_KAK = chr(74394)
CUNEIFORM_SIGN_SAG_TIMES_KUR = chr(74395)
CUNEIFORM_SIGN_SAG_TIMES_LUM = chr(74396)
CUNEIFORM_SIGN_SAG_TIMES_MI = chr(74397)
CUNEIFORM_SIGN_SAG_TIMES_NUN = chr(74398)
CUNEIFORM_SIGN_SAG_TIMES_SAL = chr(74399)
CUNEIFORM_SIGN_SAG_TIMES_SHID = chr(74400)
CUNEIFORM_SIGN_SAG_TIMES_TAB = chr(74401)
CUNEIFORM_SIGN_SAG_TIMES_U2 = chr(74402)
CUNEIFORM_SIGN_SAG_TIMES_UB = chr(74403)
CUNEIFORM_SIGN_SAG_TIMES_UM = chr(74404)
CUNEIFORM_SIGN_SAG_TIMES_UR = chr(74405)
CUNEIFORM_SIGN_SAG_TIMES_USH = chr(74406)
CUNEIFORM_SIGN_SAG_OVER_SAG = chr(74407)
CUNEIFORM_SIGN_SAG_GUNU = chr(74408)
CUNEIFORM_SIGN_SAL = chr(74409)
CUNEIFORM_SIGN_SAL_LAGAB_TIMES_ASH2 = chr(74410)
CUNEIFORM_SIGN_SANGA2 = chr(74411)
CUNEIFORM_SIGN_SAR = chr(74412)
CUNEIFORM_SIGN_SHA = chr(74413)
CUNEIFORM_SIGN_SHA3 = chr(74414)
CUNEIFORM_SIGN_SHA3_TIMES_A = chr(74415)
CUNEIFORM_SIGN_SHA3_TIMES_BAD = chr(74416)
CUNEIFORM_SIGN_SHA3_TIMES_GISH = chr(74417)
CUNEIFORM_SIGN_SHA3_TIMES_NE = chr(74418)
CUNEIFORM_SIGN_SHA3_TIMES_SHU2 = chr(74419)
CUNEIFORM_SIGN_SHA3_TIMES_TUR = chr(74420)
CUNEIFORM_SIGN_SHA3_TIMES_U = chr(74421)
CUNEIFORM_SIGN_SHA3_TIMES_U_PLUS_A = chr(74422)
CUNEIFORM_SIGN_SHA6 = chr(74423)
CUNEIFORM_SIGN_SHAB6 = chr(74424)
CUNEIFORM_SIGN_SHAR2 = chr(74425)
CUNEIFORM_SIGN_SHE = chr(74426)
CUNEIFORM_SIGN_SHE_HU = chr(74427)
CUNEIFORM_SIGN_SHE_OVER_SHE_GAD_OVER_GAD_GAR_OVER_GAR = chr(74428)
CUNEIFORM_SIGN_SHE_OVER_SHE_TAB_OVER_TAB_GAR_OVER_GAR = chr(74429)
CUNEIFORM_SIGN_SHEG9 = chr(74430)
CUNEIFORM_SIGN_SHEN = chr(74431)
CUNEIFORM_SIGN_SHESH = chr(74432)
CUNEIFORM_SIGN_SHESH2 = chr(74433)
CUNEIFORM_SIGN_SHESHLAM = chr(74434)
CUNEIFORM_SIGN_SHID = chr(74435)
CUNEIFORM_SIGN_SHID_TIMES_A = chr(74436)
CUNEIFORM_SIGN_SHID_TIMES_IM = chr(74437)
CUNEIFORM_SIGN_SHIM = chr(74438)
CUNEIFORM_SIGN_SHIM_TIMES_A = chr(74439)
CUNEIFORM_SIGN_SHIM_TIMES_BAL = chr(74440)
CUNEIFORM_SIGN_SHIM_TIMES_BULUG = chr(74441)
CUNEIFORM_SIGN_SHIM_TIMES_DIN = chr(74442)
CUNEIFORM_SIGN_SHIM_TIMES_GAR = chr(74443)
CUNEIFORM_SIGN_SHIM_TIMES_IGI = chr(74444)
CUNEIFORM_SIGN_SHIM_TIMES_IGI_GUNU = chr(74445)
CUNEIFORM_SIGN_SHIM_TIMES_KUSHU2 = chr(74446)
CUNEIFORM_SIGN_SHIM_TIMES_LUL = chr(74447)
CUNEIFORM_SIGN_SHIM_TIMES_MUG = chr(74448)
CUNEIFORM_SIGN_SHIM_TIMES_SAL = chr(74449)
CUNEIFORM_SIGN_SHINIG = chr(74450)
CUNEIFORM_SIGN_SHIR = chr(74451)
CUNEIFORM_SIGN_SHIR_TENU = chr(74452)
CUNEIFORM_SIGN_SHIR_OVER_SHIR_BUR_OVER_BUR = chr(74453)
CUNEIFORM_SIGN_SHITA = chr(74454)
CUNEIFORM_SIGN_SHU = chr(74455)
CUNEIFORM_SIGN_SHU_OVER_INVERTED_SHU = chr(74456)
CUNEIFORM_SIGN_SHU2 = chr(74457)
CUNEIFORM_SIGN_SHUBUR = chr(74458)
CUNEIFORM_SIGN_SI = chr(74459)
CUNEIFORM_SIGN_SI_GUNU = chr(74460)
CUNEIFORM_SIGN_SIG = chr(74461)
CUNEIFORM_SIGN_SIG4 = chr(74462)
CUNEIFORM_SIGN_SIG4_OVER_SIG4_SHU2 = chr(74463)
CUNEIFORM_SIGN_SIK2 = chr(74464)
CUNEIFORM_SIGN_SILA3 = chr(74465)
CUNEIFORM_SIGN_SU = chr(74466)
CUNEIFORM_SIGN_SU_OVER_SU = chr(74467)
CUNEIFORM_SIGN_SUD = chr(74468)
CUNEIFORM_SIGN_SUD2 = chr(74469)
CUNEIFORM_SIGN_SUHUR = chr(74470)
CUNEIFORM_SIGN_SUM = chr(74471)
CUNEIFORM_SIGN_SUMASH = chr(74472)
CUNEIFORM_SIGN_SUR = chr(74473)
CUNEIFORM_SIGN_SUR9 = chr(74474)
CUNEIFORM_SIGN_TA = chr(74475)
CUNEIFORM_SIGN_TA_ASTERISK = chr(74476)
CUNEIFORM_SIGN_TA_TIMES_HI = chr(74477)
CUNEIFORM_SIGN_TA_TIMES_MI = chr(74478)
CUNEIFORM_SIGN_TA_GUNU = chr(74479)
CUNEIFORM_SIGN_TAB = chr(74480)
CUNEIFORM_SIGN_TAB_OVER_TAB_NI_OVER_NI_DISH_OVER_DISH = chr(74481)
CUNEIFORM_SIGN_TAB_SQUARED = chr(74482)
CUNEIFORM_SIGN_TAG = chr(74483)
CUNEIFORM_SIGN_TAG_TIMES_BI = chr(74484)
CUNEIFORM_SIGN_TAG_TIMES_GUD = chr(74485)
CUNEIFORM_SIGN_TAG_TIMES_SHE = chr(74486)
CUNEIFORM_SIGN_TAG_TIMES_SHU = chr(74487)
CUNEIFORM_SIGN_TAG_TIMES_TUG2 = chr(74488)
CUNEIFORM_SIGN_TAG_TIMES_UD = chr(74489)
CUNEIFORM_SIGN_TAK4 = chr(74490)
CUNEIFORM_SIGN_TAR = chr(74491)
CUNEIFORM_SIGN_TE = chr(74492)
CUNEIFORM_SIGN_TE_GUNU = chr(74493)
CUNEIFORM_SIGN_TI = chr(74494)
CUNEIFORM_SIGN_TI_TENU = chr(74495)
CUNEIFORM_SIGN_TIL = chr(74496)
CUNEIFORM_SIGN_TIR = chr(74497)
CUNEIFORM_SIGN_TIR_TIMES_TAK4 = chr(74498)
CUNEIFORM_SIGN_TIR_OVER_TIR = chr(74499)
CUNEIFORM_SIGN_TIR_OVER_TIR_GAD_OVER_GAD_GAR_OVER_GAR = chr(74500)
CUNEIFORM_SIGN_TU = chr(74501)
CUNEIFORM_SIGN_TUG2 = chr(74502)
CUNEIFORM_SIGN_TUK = chr(74503)
CUNEIFORM_SIGN_TUM = chr(74504)
CUNEIFORM_SIGN_TUR = chr(74505)
CUNEIFORM_SIGN_TUR_OVER_TUR_ZA_OVER_ZA = chr(74506)
CUNEIFORM_SIGN_U = chr(74507)
CUNEIFORM_SIGN_U_GUD = chr(74508)
CUNEIFORM_SIGN_U_U_U = chr(74509)
CUNEIFORM_SIGN_U_OVER_U_PA_OVER_PA_GAR_OVER_GAR = chr(74510)
CUNEIFORM_SIGN_U_OVER_U_SUR_OVER_SUR = chr(74511)
CUNEIFORM_SIGN_U_OVER_U_U_REVERSED_OVER_U_REVERSED = chr(74512)
CUNEIFORM_SIGN_U2 = chr(74513)
CUNEIFORM_SIGN_UB = chr(74514)
CUNEIFORM_SIGN_UD = chr(74515)
CUNEIFORM_SIGN_UD_KUSHU2 = chr(74516)
CUNEIFORM_SIGN_UD_TIMES_BAD = chr(74517)
CUNEIFORM_SIGN_UD_TIMES_MI = chr(74518)
CUNEIFORM_SIGN_UD_TIMES_U_PLUS_U_PLUS_U = chr(74519)
CUNEIFORM_SIGN_UD_TIMES_U_PLUS_U_PLUS_U_GUNU = chr(74520)
CUNEIFORM_SIGN_UD_GUNU = chr(74521)
CUNEIFORM_SIGN_UD_SHESHIG = chr(74522)
CUNEIFORM_SIGN_UD_SHESHIG_TIMES_BAD = chr(74523)
CUNEIFORM_SIGN_UDUG = chr(74524)
CUNEIFORM_SIGN_UM = chr(74525)
CUNEIFORM_SIGN_UM_TIMES_LAGAB = chr(74526)
CUNEIFORM_SIGN_UM_TIMES_ME_PLUS_DA = chr(74527)
CUNEIFORM_SIGN_UM_TIMES_SHA3 = chr(74528)
CUNEIFORM_SIGN_UM_TIMES_U = chr(74529)
CUNEIFORM_SIGN_UMBIN = chr(74530)
CUNEIFORM_SIGN_UMUM = chr(74531)
CUNEIFORM_SIGN_UMUM_TIMES_KASKAL = chr(74532)
CUNEIFORM_SIGN_UMUM_TIMES_PA = chr(74533)
CUNEIFORM_SIGN_UN = chr(74534)
CUNEIFORM_SIGN_UN_GUNU = chr(74535)
CUNEIFORM_SIGN_UR = chr(74536)
CUNEIFORM_SIGN_UR_CROSSING_UR = chr(74537)
CUNEIFORM_SIGN_UR_SHESHIG = chr(74538)
CUNEIFORM_SIGN_UR2 = chr(74539)
CUNEIFORM_SIGN_UR2_TIMES_A_PLUS_HA = chr(74540)
CUNEIFORM_SIGN_UR2_TIMES_A_PLUS_NA = chr(74541)
CUNEIFORM_SIGN_UR2_TIMES_AL = chr(74542)
CUNEIFORM_SIGN_UR2_TIMES_HA = chr(74543)
CUNEIFORM_SIGN_UR2_TIMES_NUN = chr(74544)
CUNEIFORM_SIGN_UR2_TIMES_U2 = chr(74545)
CUNEIFORM_SIGN_UR2_TIMES_U2_PLUS_ASH = chr(74546)
CUNEIFORM_SIGN_UR2_TIMES_U2_PLUS_BI = chr(74547)
CUNEIFORM_SIGN_UR4 = chr(74548)
CUNEIFORM_SIGN_URI = chr(74549)
CUNEIFORM_SIGN_URI3 = chr(74550)
CUNEIFORM_SIGN_URU = chr(74551)
CUNEIFORM_SIGN_URU_TIMES_A = chr(74552)
CUNEIFORM_SIGN_URU_TIMES_ASHGAB = chr(74553)
CUNEIFORM_SIGN_URU_TIMES_BAR = chr(74554)
CUNEIFORM_SIGN_URU_TIMES_DUN = chr(74555)
CUNEIFORM_SIGN_URU_TIMES_GA = chr(74556)
CUNEIFORM_SIGN_URU_TIMES_GAL = chr(74557)
CUNEIFORM_SIGN_URU_TIMES_GAN2_TENU = chr(74558)
CUNEIFORM_SIGN_URU_TIMES_GAR = chr(74559)
CUNEIFORM_SIGN_URU_TIMES_GU = chr(74560)
CUNEIFORM_SIGN_URU_TIMES_HA = chr(74561)
CUNEIFORM_SIGN_URU_TIMES_IGI = chr(74562)
CUNEIFORM_SIGN_URU_TIMES_IM = chr(74563)
CUNEIFORM_SIGN_URU_TIMES_ISH = chr(74564)
CUNEIFORM_SIGN_URU_TIMES_KI = chr(74565)
CUNEIFORM_SIGN_URU_TIMES_LUM = chr(74566)
CUNEIFORM_SIGN_URU_TIMES_MIN = chr(74567)
CUNEIFORM_SIGN_URU_TIMES_PA = chr(74568)
CUNEIFORM_SIGN_URU_TIMES_SHE = chr(74569)
CUNEIFORM_SIGN_URU_TIMES_SIG4 = chr(74570)
CUNEIFORM_SIGN_URU_TIMES_TU = chr(74571)
CUNEIFORM_SIGN_URU_TIMES_U_PLUS_GUD = chr(74572)
CUNEIFORM_SIGN_URU_TIMES_UD = chr(74573)
CUNEIFORM_SIGN_URU_TIMES_URUDA = chr(74574)
CUNEIFORM_SIGN_URUDA = chr(74575)
CUNEIFORM_SIGN_URUDA_TIMES_U = chr(74576)
CUNEIFORM_SIGN_USH = chr(74577)
CUNEIFORM_SIGN_USH_TIMES_A = chr(74578)
CUNEIFORM_SIGN_USH_TIMES_KU = chr(74579)
CUNEIFORM_SIGN_USH_TIMES_KUR = chr(74580)
CUNEIFORM_SIGN_USH_TIMES_TAK4 = chr(74581)
CUNEIFORM_SIGN_USHX = chr(74582)
CUNEIFORM_SIGN_USH2 = chr(74583)
CUNEIFORM_SIGN_USHUMX = chr(74584)
CUNEIFORM_SIGN_UTUKI = chr(74585)
CUNEIFORM_SIGN_UZ3 = chr(74586)
CUNEIFORM_SIGN_UZ3_TIMES_KASKAL = chr(74587)
CUNEIFORM_SIGN_UZU = chr(74588)
CUNEIFORM_SIGN_ZA = chr(74589)
CUNEIFORM_SIGN_ZA_TENU = chr(74590)
CUNEIFORM_SIGN_ZA_SQUARED_TIMES_KUR = chr(74591)
CUNEIFORM_SIGN_ZAG = chr(74592)
CUNEIFORM_SIGN_ZAMX = chr(74593)
CUNEIFORM_SIGN_ZE2 = chr(74594)
CUNEIFORM_SIGN_ZI = chr(74595)
CUNEIFORM_SIGN_ZI_OVER_ZI = chr(74596)
CUNEIFORM_SIGN_ZI3 = chr(74597)
CUNEIFORM_SIGN_ZIB = chr(74598)
CUNEIFORM_SIGN_ZIB_KABA_TENU = chr(74599)
CUNEIFORM_SIGN_ZIG = chr(74600)
CUNEIFORM_SIGN_ZIZ2 = chr(74601)
CUNEIFORM_SIGN_ZU = chr(74602)
CUNEIFORM_SIGN_ZU5 = chr(74603)
CUNEIFORM_SIGN_ZU5_TIMES_A = chr(74604)
CUNEIFORM_SIGN_ZUBUR = chr(74605)
CUNEIFORM_SIGN_ZUM = chr(74606)
CUNEIFORM_SIGN_KAP_ELAMITE = chr(74607)
CUNEIFORM_SIGN_AB_TIMES_NUN = chr(74608)
CUNEIFORM_SIGN_AB2_TIMES_A = chr(74609)
CUNEIFORM_SIGN_AMAR_TIMES_KUG = chr(74610)
CUNEIFORM_SIGN_DAG_KISIM5_TIMES_U2_PLUS_MASH = chr(74611)
CUNEIFORM_SIGN_DAG3 = chr(74612)
CUNEIFORM_SIGN_DISH_PLUS_SHU = chr(74613)
CUNEIFORM_SIGN_DUB_TIMES_SHE = chr(74614)
CUNEIFORM_SIGN_EZEN_TIMES_GUD = chr(74615)
CUNEIFORM_SIGN_EZEN_TIMES_SHE = chr(74616)
CUNEIFORM_SIGN_GA2_TIMES_AN_PLUS_KAK_PLUS_A = chr(74617)
CUNEIFORM_SIGN_GA2_TIMES_ASH2 = chr(74618)
CUNEIFORM_SIGN_GE22 = chr(74619)
CUNEIFORM_SIGN_GIG = chr(74620)
CUNEIFORM_SIGN_HUSH = chr(74621)
CUNEIFORM_SIGN_KA_TIMES_ANSHE = chr(74622)
CUNEIFORM_SIGN_KA_TIMES_ASH3 = chr(74623)
CUNEIFORM_SIGN_KA_TIMES_GISH = chr(74624)
CUNEIFORM_SIGN_KA_TIMES_GUD = chr(74625)
CUNEIFORM_SIGN_KA_TIMES_HI_TIMES_ASH2 = chr(74626)
CUNEIFORM_SIGN_KA_TIMES_LUM = chr(74627)
CUNEIFORM_SIGN_KA_TIMES_PA = chr(74628)
CUNEIFORM_SIGN_KA_TIMES_SHUL = chr(74629)
CUNEIFORM_SIGN_KA_TIMES_TU = chr(74630)
CUNEIFORM_SIGN_KA_TIMES_UR2 = chr(74631)
CUNEIFORM_SIGN_LAGAB_TIMES_GI = chr(74632)
CUNEIFORM_SIGN_LU2_SHESHIG_TIMES_BAD = chr(74633)
CUNEIFORM_SIGN_LU2_TIMES_ESH2_PLUS_LAL = chr(74634)
CUNEIFORM_SIGN_LU2_TIMES_SHU = chr(74635)
CUNEIFORM_SIGN_MESH = chr(74636)
CUNEIFORM_SIGN_MUSH3_TIMES_ZA = chr(74637)
CUNEIFORM_SIGN_NA4 = chr(74638)
CUNEIFORM_SIGN_NIN = chr(74639)
CUNEIFORM_SIGN_NIN9 = chr(74640)
CUNEIFORM_SIGN_NINDA2_TIMES_BAL = chr(74641)
CUNEIFORM_SIGN_NINDA2_TIMES_GI = chr(74642)
CUNEIFORM_SIGN_NU11_ROTATED_NINETY_DEGREES = chr(74643)
CUNEIFORM_SIGN_PESH2_ASTERISK = chr(74644)
CUNEIFORM_SIGN_PIR2 = chr(74645)
CUNEIFORM_SIGN_SAG_TIMES_IGI_GUNU = chr(74646)
CUNEIFORM_SIGN_TI2 = chr(74647)
CUNEIFORM_SIGN_UM_TIMES_ME = chr(74648)
CUNEIFORM_SIGN_U_U = chr(74649)
CUNEIFORM_NUMERIC_SIGN_TWO_ASH = chr(74752)
CUNEIFORM_NUMERIC_SIGN_THREE_ASH = chr(74753)
CUNEIFORM_NUMERIC_SIGN_FOUR_ASH = chr(74754)
CUNEIFORM_NUMERIC_SIGN_FIVE_ASH = chr(74755)
CUNEIFORM_NUMERIC_SIGN_SIX_ASH = chr(74756)
CUNEIFORM_NUMERIC_SIGN_SEVEN_ASH = chr(74757)
CUNEIFORM_NUMERIC_SIGN_EIGHT_ASH = chr(74758)
CUNEIFORM_NUMERIC_SIGN_NINE_ASH = chr(74759)
CUNEIFORM_NUMERIC_SIGN_THREE_DISH = chr(74760)
CUNEIFORM_NUMERIC_SIGN_FOUR_DISH = chr(74761)
CUNEIFORM_NUMERIC_SIGN_FIVE_DISH = chr(74762)
CUNEIFORM_NUMERIC_SIGN_SIX_DISH = chr(74763)
CUNEIFORM_NUMERIC_SIGN_SEVEN_DISH = chr(74764)
CUNEIFORM_NUMERIC_SIGN_EIGHT_DISH = chr(74765)
CUNEIFORM_NUMERIC_SIGN_NINE_DISH = chr(74766)
CUNEIFORM_NUMERIC_SIGN_FOUR_U = chr(74767)
CUNEIFORM_NUMERIC_SIGN_FIVE_U = chr(74768)
CUNEIFORM_NUMERIC_SIGN_SIX_U = chr(74769)
CUNEIFORM_NUMERIC_SIGN_SEVEN_U = chr(74770)
CUNEIFORM_NUMERIC_SIGN_EIGHT_U = chr(74771)
CUNEIFORM_NUMERIC_SIGN_NINE_U = chr(74772)
CUNEIFORM_NUMERIC_SIGN_ONE_GESH2 = chr(74773)
CUNEIFORM_NUMERIC_SIGN_TWO_GESH2 = chr(74774)
CUNEIFORM_NUMERIC_SIGN_THREE_GESH2 = chr(74775)
CUNEIFORM_NUMERIC_SIGN_FOUR_GESH2 = chr(74776)
CUNEIFORM_NUMERIC_SIGN_FIVE_GESH2 = chr(74777)
CUNEIFORM_NUMERIC_SIGN_SIX_GESH2 = chr(74778)
CUNEIFORM_NUMERIC_SIGN_SEVEN_GESH2 = chr(74779)
CUNEIFORM_NUMERIC_SIGN_EIGHT_GESH2 = chr(74780)
CUNEIFORM_NUMERIC_SIGN_NINE_GESH2 = chr(74781)
CUNEIFORM_NUMERIC_SIGN_ONE_GESHU = chr(74782)
CUNEIFORM_NUMERIC_SIGN_TWO_GESHU = chr(74783)
CUNEIFORM_NUMERIC_SIGN_THREE_GESHU = chr(74784)
CUNEIFORM_NUMERIC_SIGN_FOUR_GESHU = chr(74785)
CUNEIFORM_NUMERIC_SIGN_FIVE_GESHU = chr(74786)
CUNEIFORM_NUMERIC_SIGN_TWO_SHAR2 = chr(74787)
CUNEIFORM_NUMERIC_SIGN_THREE_SHAR2 = chr(74788)
CUNEIFORM_NUMERIC_SIGN_THREE_SHAR2_VARIANT_FORM = chr(74789)
CUNEIFORM_NUMERIC_SIGN_FOUR_SHAR2 = chr(74790)
CUNEIFORM_NUMERIC_SIGN_FIVE_SHAR2 = chr(74791)
CUNEIFORM_NUMERIC_SIGN_SIX_SHAR2 = chr(74792)
CUNEIFORM_NUMERIC_SIGN_SEVEN_SHAR2 = chr(74793)
CUNEIFORM_NUMERIC_SIGN_EIGHT_SHAR2 = chr(74794)
CUNEIFORM_NUMERIC_SIGN_NINE_SHAR2 = chr(74795)
CUNEIFORM_NUMERIC_SIGN_ONE_SHARU = chr(74796)
CUNEIFORM_NUMERIC_SIGN_TWO_SHARU = chr(74797)
CUNEIFORM_NUMERIC_SIGN_THREE_SHARU = chr(74798)
CUNEIFORM_NUMERIC_SIGN_THREE_SHARU_VARIANT_FORM = chr(74799)
CUNEIFORM_NUMERIC_SIGN_FOUR_SHARU = chr(74800)
CUNEIFORM_NUMERIC_SIGN_FIVE_SHARU = chr(74801)
CUNEIFORM_NUMERIC_SIGN_SHAR2_TIMES_GAL_PLUS_DISH = chr(74802)
CUNEIFORM_NUMERIC_SIGN_SHAR2_TIMES_GAL_PLUS_MIN = chr(74803)
CUNEIFORM_NUMERIC_SIGN_ONE_BURU = chr(74804)
CUNEIFORM_NUMERIC_SIGN_TWO_BURU = chr(74805)
CUNEIFORM_NUMERIC_SIGN_THREE_BURU = chr(74806)
CUNEIFORM_NUMERIC_SIGN_THREE_BURU_VARIANT_FORM = chr(74807)
CUNEIFORM_NUMERIC_SIGN_FOUR_BURU = chr(74808)
CUNEIFORM_NUMERIC_SIGN_FIVE_BURU = chr(74809)
CUNEIFORM_NUMERIC_SIGN_THREE_VARIANT_FORM_ESH16 = chr(74810)
CUNEIFORM_NUMERIC_SIGN_THREE_VARIANT_FORM_ESH21 = chr(74811)
CUNEIFORM_NUMERIC_SIGN_FOUR_VARIANT_FORM_LIMMU = chr(74812)
CUNEIFORM_NUMERIC_SIGN_FOUR_VARIANT_FORM_LIMMU4 = chr(74813)
CUNEIFORM_NUMERIC_SIGN_FOUR_VARIANT_FORM_LIMMU_A = chr(74814)
CUNEIFORM_NUMERIC_SIGN_FOUR_VARIANT_FORM_LIMMU_B = chr(74815)
CUNEIFORM_NUMERIC_SIGN_SIX_VARIANT_FORM_ASH9 = chr(74816)
CUNEIFORM_NUMERIC_SIGN_SEVEN_VARIANT_FORM_IMIN3 = chr(74817)
CUNEIFORM_NUMERIC_SIGN_SEVEN_VARIANT_FORM_IMIN_A = chr(74818)
CUNEIFORM_NUMERIC_SIGN_SEVEN_VARIANT_FORM_IMIN_B = chr(74819)
CUNEIFORM_NUMERIC_SIGN_EIGHT_VARIANT_FORM_USSU = chr(74820)
CUNEIFORM_NUMERIC_SIGN_EIGHT_VARIANT_FORM_USSU3 = chr(74821)
CUNEIFORM_NUMERIC_SIGN_NINE_VARIANT_FORM_ILIMMU = chr(74822)
CUNEIFORM_NUMERIC_SIGN_NINE_VARIANT_FORM_ILIMMU3 = chr(74823)
CUNEIFORM_NUMERIC_SIGN_NINE_VARIANT_FORM_ILIMMU4 = chr(74824)
CUNEIFORM_NUMERIC_SIGN_NINE_VARIANT_FORM_ILIMMU_A = chr(74825)
CUNEIFORM_NUMERIC_SIGN_TWO_ASH_TENU = chr(74826)
CUNEIFORM_NUMERIC_SIGN_THREE_ASH_TENU = chr(74827)
CUNEIFORM_NUMERIC_SIGN_FOUR_ASH_TENU = chr(74828)
CUNEIFORM_NUMERIC_SIGN_FIVE_ASH_TENU = chr(74829)
CUNEIFORM_NUMERIC_SIGN_SIX_ASH_TENU = chr(74830)
CUNEIFORM_NUMERIC_SIGN_ONE_BAN2 = chr(74831)
CUNEIFORM_NUMERIC_SIGN_TWO_BAN2 = chr(74832)
CUNEIFORM_NUMERIC_SIGN_THREE_BAN2 = chr(74833)
CUNEIFORM_NUMERIC_SIGN_FOUR_BAN2 = chr(74834)
CUNEIFORM_NUMERIC_SIGN_FOUR_BAN2_VARIANT_FORM = chr(74835)
CUNEIFORM_NUMERIC_SIGN_FIVE_BAN2 = chr(74836)
CUNEIFORM_NUMERIC_SIGN_FIVE_BAN2_VARIANT_FORM = chr(74837)
CUNEIFORM_NUMERIC_SIGN_NIGIDAMIN = chr(74838)
CUNEIFORM_NUMERIC_SIGN_NIGIDAESH = chr(74839)
CUNEIFORM_NUMERIC_SIGN_ONE_ESHE3 = chr(74840)
CUNEIFORM_NUMERIC_SIGN_TWO_ESHE3 = chr(74841)
CUNEIFORM_NUMERIC_SIGN_ONE_THIRD_DISH = chr(74842)
CUNEIFORM_NUMERIC_SIGN_TWO_THIRDS_DISH = chr(74843)
CUNEIFORM_NUMERIC_SIGN_FIVE_SIXTHS_DISH = chr(74844)
CUNEIFORM_NUMERIC_SIGN_ONE_THIRD_VARIANT_FORM_A = chr(74845)
CUNEIFORM_NUMERIC_SIGN_TWO_THIRDS_VARIANT_FORM_A = chr(74846)
CUNEIFORM_NUMERIC_SIGN_ONE_EIGHTH_ASH = chr(74847)
CUNEIFORM_NUMERIC_SIGN_ONE_QUARTER_ASH = chr(74848)
CUNEIFORM_NUMERIC_SIGN_OLD_ASSYRIAN_ONE_SIXTH = chr(74849)
CUNEIFORM_NUMERIC_SIGN_OLD_ASSYRIAN_ONE_QUARTER = chr(74850)
CUNEIFORM_NUMERIC_SIGN_ONE_QUARTER_GUR = chr(74851)
CUNEIFORM_NUMERIC_SIGN_ONE_HALF_GUR = chr(74852)
CUNEIFORM_NUMERIC_SIGN_ELAMITE_ONE_THIRD = chr(74853)
CUNEIFORM_NUMERIC_SIGN_ELAMITE_TWO_THIRDS = chr(74854)
CUNEIFORM_NUMERIC_SIGN_ELAMITE_FORTY = chr(74855)
CUNEIFORM_NUMERIC_SIGN_ELAMITE_FIFTY = chr(74856)
CUNEIFORM_NUMERIC_SIGN_FOUR_U_VARIANT_FORM = chr(74857)
CUNEIFORM_NUMERIC_SIGN_FIVE_U_VARIANT_FORM = chr(74858)
CUNEIFORM_NUMERIC_SIGN_SIX_U_VARIANT_FORM = chr(74859)
CUNEIFORM_NUMERIC_SIGN_SEVEN_U_VARIANT_FORM = chr(74860)
CUNEIFORM_NUMERIC_SIGN_EIGHT_U_VARIANT_FORM = chr(74861)
CUNEIFORM_NUMERIC_SIGN_NINE_U_VARIANT_FORM = chr(74862)
CUNEIFORM_PUNCTUATION_SIGN_OLD_ASSYRIAN_WORD_DIVIDER = chr(74864)
CUNEIFORM_PUNCTUATION_SIGN_VERTICAL_COLON = chr(74865)
CUNEIFORM_PUNCTUATION_SIGN_DIAGONAL_COLON = chr(74866)
CUNEIFORM_PUNCTUATION_SIGN_DIAGONAL_TRICOLON = chr(74867)
CUNEIFORM_PUNCTUATION_SIGN_DIAGONAL_QUADCOLON = chr(74868)
CUNEIFORM_SIGN_AB_TIMES_NUN_TENU = chr(74880)
CUNEIFORM_SIGN_AB_TIMES_SHU2 = chr(74881)
CUNEIFORM_SIGN_AD_TIMES_ESH2 = chr(74882)
CUNEIFORM_SIGN_BAD_TIMES_DISH_TENU = chr(74883)
CUNEIFORM_SIGN_BAHAR2_TIMES_AB2 = chr(74884)
CUNEIFORM_SIGN_BAHAR2_TIMES_NI = chr(74885)
CUNEIFORM_SIGN_BAHAR2_TIMES_ZA = chr(74886)
CUNEIFORM_SIGN_BU_OVER_BU_TIMES_NA2 = chr(74887)
CUNEIFORM_SIGN_DA_TIMES_TAK4 = chr(74888)
CUNEIFORM_SIGN_DAG_TIMES_KUR = chr(74889)
CUNEIFORM_SIGN_DIM_TIMES_IGI = chr(74890)
CUNEIFORM_SIGN_DIM_TIMES_U_U_U = chr(74891)
CUNEIFORM_SIGN_DIM2_TIMES_UD = chr(74892)
CUNEIFORM_SIGN_DUG_TIMES_ANSHE = chr(74893)
CUNEIFORM_SIGN_DUG_TIMES_ASH = chr(74894)
CUNEIFORM_SIGN_DUG_TIMES_ASH_AT_LEFT = chr(74895)
CUNEIFORM_SIGN_DUG_TIMES_DIN = chr(74896)
CUNEIFORM_SIGN_DUG_TIMES_DUN = chr(74897)
CUNEIFORM_SIGN_DUG_TIMES_ERIN2 = chr(74898)
CUNEIFORM_SIGN_DUG_TIMES_GA = chr(74899)
CUNEIFORM_SIGN_DUG_TIMES_GI = chr(74900)
CUNEIFORM_SIGN_DUG_TIMES_GIR2_GUNU = chr(74901)
CUNEIFORM_SIGN_DUG_TIMES_GISH = chr(74902)
CUNEIFORM_SIGN_DUG_TIMES_HA = chr(74903)
CUNEIFORM_SIGN_DUG_TIMES_HI = chr(74904)
CUNEIFORM_SIGN_DUG_TIMES_IGI_GUNU = chr(74905)
CUNEIFORM_SIGN_DUG_TIMES_KASKAL = chr(74906)
CUNEIFORM_SIGN_DUG_TIMES_KUR = chr(74907)
CUNEIFORM_SIGN_DUG_TIMES_KUSHU2 = chr(74908)
CUNEIFORM_SIGN_DUG_TIMES_KUSHU2_PLUS_KASKAL = chr(74909)
CUNEIFORM_SIGN_DUG_TIMES_LAK_020 = chr(74910)
CUNEIFORM_SIGN_DUG_TIMES_LAM = chr(74911)
CUNEIFORM_SIGN_DUG_TIMES_LAM_TIMES_KUR = chr(74912)
CUNEIFORM_SIGN_DUG_TIMES_LUH_PLUS_GISH = chr(74913)
CUNEIFORM_SIGN_DUG_TIMES_MASH = chr(74914)
CUNEIFORM_SIGN_DUG_TIMES_MES = chr(74915)
CUNEIFORM_SIGN_DUG_TIMES_MI = chr(74916)
CUNEIFORM_SIGN_DUG_TIMES_NI = chr(74917)
CUNEIFORM_SIGN_DUG_TIMES_PI = chr(74918)
CUNEIFORM_SIGN_DUG_TIMES_SHE = chr(74919)
CUNEIFORM_SIGN_DUG_TIMES_SI_GUNU = chr(74920)
CUNEIFORM_SIGN_E2_TIMES_KUR = chr(74921)
CUNEIFORM_SIGN_E2_TIMES_PAP = chr(74922)
CUNEIFORM_SIGN_ERIN2_X = chr(74923)
CUNEIFORM_SIGN_ESH2_CROSSING_ESH2 = chr(74924)
CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_ASH = chr(74925)
CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_HI = chr(74926)
CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_IGI_GUNU = chr(74927)
CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_LA = chr(74928)
CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_LAL = chr(74929)
CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_ME = chr(74930)
CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_MES = chr(74931)
CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_SU = chr(74932)
CUNEIFORM_SIGN_EZEN_TIMES_SU = chr(74933)
CUNEIFORM_SIGN_GA2_TIMES_BAHAR2 = chr(74934)
CUNEIFORM_SIGN_GA2_TIMES_DIM_GUNU = chr(74935)
CUNEIFORM_SIGN_GA2_TIMES_DUG_TIMES_IGI_GUNU = chr(74936)
CUNEIFORM_SIGN_GA2_TIMES_DUG_TIMES_KASKAL = chr(74937)
CUNEIFORM_SIGN_GA2_TIMES_EREN = chr(74938)
CUNEIFORM_SIGN_GA2_TIMES_GA = chr(74939)
CUNEIFORM_SIGN_GA2_TIMES_GAR_PLUS_DI = chr(74940)
CUNEIFORM_SIGN_GA2_TIMES_GAR_PLUS_NE = chr(74941)
CUNEIFORM_SIGN_GA2_TIMES_HA_PLUS_A = chr(74942)
CUNEIFORM_SIGN_GA2_TIMES_KUSHU2_PLUS_KASKAL = chr(74943)
CUNEIFORM_SIGN_GA2_TIMES_LAM = chr(74944)
CUNEIFORM_SIGN_GA2_TIMES_LAM_TIMES_KUR = chr(74945)
CUNEIFORM_SIGN_GA2_TIMES_LUH = chr(74946)
CUNEIFORM_SIGN_GA2_TIMES_MUSH = chr(74947)
CUNEIFORM_SIGN_GA2_TIMES_NE = chr(74948)
CUNEIFORM_SIGN_GA2_TIMES_NE_PLUS_E2 = chr(74949)
CUNEIFORM_SIGN_GA2_TIMES_NE_PLUS_GI = chr(74950)
CUNEIFORM_SIGN_GA2_TIMES_SHIM = chr(74951)
CUNEIFORM_SIGN_GA2_TIMES_ZIZ2 = chr(74952)
CUNEIFORM_SIGN_GABA_ROTATED_NINETY_DEGREES = chr(74953)
CUNEIFORM_SIGN_GESHTIN_TIMES_U = chr(74954)
CUNEIFORM_SIGN_GISH_TIMES_GISH_CROSSING_GISH = chr(74955)
CUNEIFORM_SIGN_GU2_TIMES_IGI_GUNU = chr(74956)
CUNEIFORM_SIGN_GUD_PLUS_GISH_TIMES_TAK4 = chr(74957)
CUNEIFORM_SIGN_HA_TENU_GUNU = chr(74958)
CUNEIFORM_SIGN_HI_TIMES_ASH_OVER_HI_TIMES_ASH = chr(74959)
CUNEIFORM_SIGN_KA_TIMES_BU = chr(74960)
CUNEIFORM_SIGN_KA_TIMES_KA = chr(74961)
CUNEIFORM_SIGN_KA_TIMES_U_U_U = chr(74962)
CUNEIFORM_SIGN_KA_TIMES_UR = chr(74963)
CUNEIFORM_SIGN_LAGAB_TIMES_ZU_OVER_ZU = chr(74964)
CUNEIFORM_SIGN_LAK_003 = chr(74965)
CUNEIFORM_SIGN_LAK_021 = chr(74966)
CUNEIFORM_SIGN_LAK_025 = chr(74967)
CUNEIFORM_SIGN_LAK_030 = chr(74968)
CUNEIFORM_SIGN_LAK_050 = chr(74969)
CUNEIFORM_SIGN_LAK_051 = chr(74970)
CUNEIFORM_SIGN_LAK_062 = chr(74971)
CUNEIFORM_SIGN_LAK_079_OVER_LAK_079_GUNU = chr(74972)
CUNEIFORM_SIGN_LAK_080 = chr(74973)
CUNEIFORM_SIGN_LAK_081_OVER_LAK_081 = chr(74974)
CUNEIFORM_SIGN_LAK_092 = chr(74975)
CUNEIFORM_SIGN_LAK_130 = chr(74976)
CUNEIFORM_SIGN_LAK_142 = chr(74977)
CUNEIFORM_SIGN_LAK_210 = chr(74978)
CUNEIFORM_SIGN_LAK_219 = chr(74979)
CUNEIFORM_SIGN_LAK_220 = chr(74980)
CUNEIFORM_SIGN_LAK_225 = chr(74981)
CUNEIFORM_SIGN_LAK_228 = chr(74982)
CUNEIFORM_SIGN_LAK_238 = chr(74983)
CUNEIFORM_SIGN_LAK_265 = chr(74984)
CUNEIFORM_SIGN_LAK_266 = chr(74985)
CUNEIFORM_SIGN_LAK_343 = chr(74986)
CUNEIFORM_SIGN_LAK_347 = chr(74987)
CUNEIFORM_SIGN_LAK_348 = chr(74988)
CUNEIFORM_SIGN_LAK_383 = chr(74989)
CUNEIFORM_SIGN_LAK_384 = chr(74990)
CUNEIFORM_SIGN_LAK_390 = chr(74991)
CUNEIFORM_SIGN_LAK_441 = chr(74992)
CUNEIFORM_SIGN_LAK_449 = chr(74993)
CUNEIFORM_SIGN_LAK_449_TIMES_GU = chr(74994)
CUNEIFORM_SIGN_LAK_449_TIMES_IGI = chr(74995)
CUNEIFORM_SIGN_LAK_449_TIMES_PAP_PLUS_LU3 = chr(74996)
CUNEIFORM_SIGN_LAK_449_TIMES_PAP_PLUS_PAP_PLUS_LU3 = chr(74997)
CUNEIFORM_SIGN_LAK_449_TIMES_U2_PLUS_BA = chr(74998)
CUNEIFORM_SIGN_LAK_450 = chr(74999)
CUNEIFORM_SIGN_LAK_457 = chr(75000)
CUNEIFORM_SIGN_LAK_470 = chr(75001)
CUNEIFORM_SIGN_LAK_483 = chr(75002)
CUNEIFORM_SIGN_LAK_490 = chr(75003)
CUNEIFORM_SIGN_LAK_492 = chr(75004)
CUNEIFORM_SIGN_LAK_493 = chr(75005)
CUNEIFORM_SIGN_LAK_495 = chr(75006)
CUNEIFORM_SIGN_LAK_550 = chr(75007)
CUNEIFORM_SIGN_LAK_608 = chr(75008)
CUNEIFORM_SIGN_LAK_617 = chr(75009)
CUNEIFORM_SIGN_LAK_617_TIMES_ASH = chr(75010)
CUNEIFORM_SIGN_LAK_617_TIMES_BAD = chr(75011)
CUNEIFORM_SIGN_LAK_617_TIMES_DUN3_GUNU_GUNU = chr(75012)
CUNEIFORM_SIGN_LAK_617_TIMES_KU3 = chr(75013)
CUNEIFORM_SIGN_LAK_617_TIMES_LA = chr(75014)
CUNEIFORM_SIGN_LAK_617_TIMES_TAR = chr(75015)
CUNEIFORM_SIGN_LAK_617_TIMES_TE = chr(75016)
CUNEIFORM_SIGN_LAK_617_TIMES_U2 = chr(75017)
CUNEIFORM_SIGN_LAK_617_TIMES_UD = chr(75018)
CUNEIFORM_SIGN_LAK_617_TIMES_URUDA = chr(75019)
CUNEIFORM_SIGN_LAK_636 = chr(75020)
CUNEIFORM_SIGN_LAK_648 = chr(75021)
CUNEIFORM_SIGN_LAK_648_TIMES_DUB = chr(75022)
CUNEIFORM_SIGN_LAK_648_TIMES_GA = chr(75023)
CUNEIFORM_SIGN_LAK_648_TIMES_IGI = chr(75024)
CUNEIFORM_SIGN_LAK_648_TIMES_IGI_GUNU = chr(75025)
CUNEIFORM_SIGN_LAK_648_TIMES_NI = chr(75026)
CUNEIFORM_SIGN_LAK_648_TIMES_PAP_PLUS_PAP_PLUS_LU3 = chr(75027)
CUNEIFORM_SIGN_LAK_648_TIMES_SHESH_PLUS_KI = chr(75028)
CUNEIFORM_SIGN_LAK_648_TIMES_UD = chr(75029)
CUNEIFORM_SIGN_LAK_648_TIMES_URUDA = chr(75030)
CUNEIFORM_SIGN_LAK_724 = chr(75031)
CUNEIFORM_SIGN_LAK_749 = chr(75032)
CUNEIFORM_SIGN_LU2_GUNU_TIMES_ASH = chr(75033)
CUNEIFORM_SIGN_LU2_TIMES_DISH = chr(75034)
CUNEIFORM_SIGN_LU2_TIMES_HAL = chr(75035)
CUNEIFORM_SIGN_LU2_TIMES_PAP = chr(75036)
CUNEIFORM_SIGN_LU2_TIMES_PAP_PLUS_PAP_PLUS_LU3 = chr(75037)
CUNEIFORM_SIGN_LU2_TIMES_TAK4 = chr(75038)
CUNEIFORM_SIGN_MI_PLUS_ZA7 = chr(75039)
CUNEIFORM_SIGN_MUSH_OVER_MUSH_TIMES_GA = chr(75040)
CUNEIFORM_SIGN_MUSH_OVER_MUSH_TIMES_KAK = chr(75041)
CUNEIFORM_SIGN_NINDA2_TIMES_DIM_GUNU = chr(75042)
CUNEIFORM_SIGN_NINDA2_TIMES_GISH = chr(75043)
CUNEIFORM_SIGN_NINDA2_TIMES_GUL = chr(75044)
CUNEIFORM_SIGN_NINDA2_TIMES_HI = chr(75045)
CUNEIFORM_SIGN_NINDA2_TIMES_KESH2 = chr(75046)
CUNEIFORM_SIGN_NINDA2_TIMES_LAK_050 = chr(75047)
CUNEIFORM_SIGN_NINDA2_TIMES_MASH = chr(75048)
CUNEIFORM_SIGN_NINDA2_TIMES_PAP_PLUS_PAP = chr(75049)
CUNEIFORM_SIGN_NINDA2_TIMES_U = chr(75050)
CUNEIFORM_SIGN_NINDA2_TIMES_U_PLUS_U = chr(75051)
CUNEIFORM_SIGN_NINDA2_TIMES_URUDA = chr(75052)
CUNEIFORM_SIGN_SAG_GUNU_TIMES_HA = chr(75053)
CUNEIFORM_SIGN_SAG_TIMES_EN = chr(75054)
CUNEIFORM_SIGN_SAG_TIMES_SHE_AT_LEFT = chr(75055)
CUNEIFORM_SIGN_SAG_TIMES_TAK4 = chr(75056)
CUNEIFORM_SIGN_SHA6_TENU = chr(75057)
CUNEIFORM_SIGN_SHE_OVER_SHE = chr(75058)
CUNEIFORM_SIGN_SHE_PLUS_HUB2 = chr(75059)
CUNEIFORM_SIGN_SHE_PLUS_NAM2 = chr(75060)
CUNEIFORM_SIGN_SHE_PLUS_SAR = chr(75061)
CUNEIFORM_SIGN_SHU2_PLUS_DUG_TIMES_NI = chr(75062)
CUNEIFORM_SIGN_SHU2_PLUS_E2_TIMES_AN = chr(75063)
CUNEIFORM_SIGN_SI_TIMES_TAK4 = chr(75064)
CUNEIFORM_SIGN_TAK4_PLUS_SAG = chr(75065)
CUNEIFORM_SIGN_TUM_TIMES_GAN2_TENU = chr(75066)
CUNEIFORM_SIGN_TUM_TIMES_THREE_DISH = chr(75067)
CUNEIFORM_SIGN_UR2_INVERTED = chr(75068)
CUNEIFORM_SIGN_UR2_TIMES_UD = chr(75069)
CUNEIFORM_SIGN_URU_TIMES_DARA3 = chr(75070)
CUNEIFORM_SIGN_URU_TIMES_LAK_668 = chr(75071)
CUNEIFORM_SIGN_URU_TIMES_LU3 = chr(75072)
CUNEIFORM_SIGN_ZA7 = chr(75073)
CUNEIFORM_SIGN_ZU_OVER_ZU_PLUS_SAR = chr(75074)
CUNEIFORM_SIGN_ZU5_TIMES_THREE_DISH_TENU = chr(75075)
CYPRO_MINOAN_SIGN_CM001 = chr(77712)
CYPRO_MINOAN_SIGN_CM002 = chr(77713)
CYPRO_MINOAN_SIGN_CM004 = chr(77714)
CYPRO_MINOAN_SIGN_CM005 = chr(77715)
CYPRO_MINOAN_SIGN_CM006 = chr(77716)
CYPRO_MINOAN_SIGN_CM007 = chr(77717)
CYPRO_MINOAN_SIGN_CM008 = chr(77718)
CYPRO_MINOAN_SIGN_CM009 = chr(77719)
CYPRO_MINOAN_SIGN_CM010 = chr(77720)
CYPRO_MINOAN_SIGN_CM011 = chr(77721)
CYPRO_MINOAN_SIGN_CM012 = chr(77722)
CYPRO_MINOAN_SIGN_CM012B = chr(77723)
CYPRO_MINOAN_SIGN_CM013 = chr(77724)
CYPRO_MINOAN_SIGN_CM015 = chr(77725)
CYPRO_MINOAN_SIGN_CM017 = chr(77726)
CYPRO_MINOAN_SIGN_CM019 = chr(77727)
CYPRO_MINOAN_SIGN_CM021 = chr(77728)
CYPRO_MINOAN_SIGN_CM023 = chr(77729)
CYPRO_MINOAN_SIGN_CM024 = chr(77730)
CYPRO_MINOAN_SIGN_CM025 = chr(77731)
CYPRO_MINOAN_SIGN_CM026 = chr(77732)
CYPRO_MINOAN_SIGN_CM027 = chr(77733)
CYPRO_MINOAN_SIGN_CM028 = chr(77734)
CYPRO_MINOAN_SIGN_CM029 = chr(77735)
CYPRO_MINOAN_SIGN_CM030 = chr(77736)
CYPRO_MINOAN_SIGN_CM033 = chr(77737)
CYPRO_MINOAN_SIGN_CM034 = chr(77738)
CYPRO_MINOAN_SIGN_CM035 = chr(77739)
CYPRO_MINOAN_SIGN_CM036 = chr(77740)
CYPRO_MINOAN_SIGN_CM037 = chr(77741)
CYPRO_MINOAN_SIGN_CM038 = chr(77742)
CYPRO_MINOAN_SIGN_CM039 = chr(77743)
CYPRO_MINOAN_SIGN_CM040 = chr(77744)
CYPRO_MINOAN_SIGN_CM041 = chr(77745)
CYPRO_MINOAN_SIGN_CM044 = chr(77746)
CYPRO_MINOAN_SIGN_CM046 = chr(77747)
CYPRO_MINOAN_SIGN_CM047 = chr(77748)
CYPRO_MINOAN_SIGN_CM049 = chr(77749)
CYPRO_MINOAN_SIGN_CM050 = chr(77750)
CYPRO_MINOAN_SIGN_CM051 = chr(77751)
CYPRO_MINOAN_SIGN_CM052 = chr(77752)
CYPRO_MINOAN_SIGN_CM053 = chr(77753)
CYPRO_MINOAN_SIGN_CM054 = chr(77754)
CYPRO_MINOAN_SIGN_CM055 = chr(77755)
CYPRO_MINOAN_SIGN_CM056 = chr(77756)
CYPRO_MINOAN_SIGN_CM058 = chr(77757)
CYPRO_MINOAN_SIGN_CM059 = chr(77758)
CYPRO_MINOAN_SIGN_CM060 = chr(77759)
CYPRO_MINOAN_SIGN_CM061 = chr(77760)
CYPRO_MINOAN_SIGN_CM062 = chr(77761)
CYPRO_MINOAN_SIGN_CM063 = chr(77762)
CYPRO_MINOAN_SIGN_CM064 = chr(77763)
CYPRO_MINOAN_SIGN_CM066 = chr(77764)
CYPRO_MINOAN_SIGN_CM067 = chr(77765)
CYPRO_MINOAN_SIGN_CM068 = chr(77766)
CYPRO_MINOAN_SIGN_CM069 = chr(77767)
CYPRO_MINOAN_SIGN_CM070 = chr(77768)
CYPRO_MINOAN_SIGN_CM071 = chr(77769)
CYPRO_MINOAN_SIGN_CM072 = chr(77770)
CYPRO_MINOAN_SIGN_CM073 = chr(77771)
CYPRO_MINOAN_SIGN_CM074 = chr(77772)
CYPRO_MINOAN_SIGN_CM075 = chr(77773)
CYPRO_MINOAN_SIGN_CM075B = chr(77774)
CYPRO_MINOAN_SIGN_CM076 = chr(77775)
CYPRO_MINOAN_SIGN_CM078 = chr(77776)
CYPRO_MINOAN_SIGN_CM079 = chr(77777)
CYPRO_MINOAN_SIGN_CM080 = chr(77778)
CYPRO_MINOAN_SIGN_CM081 = chr(77779)
CYPRO_MINOAN_SIGN_CM082 = chr(77780)
CYPRO_MINOAN_SIGN_CM083 = chr(77781)
CYPRO_MINOAN_SIGN_CM084 = chr(77782)
CYPRO_MINOAN_SIGN_CM085 = chr(77783)
CYPRO_MINOAN_SIGN_CM086 = chr(77784)
CYPRO_MINOAN_SIGN_CM087 = chr(77785)
CYPRO_MINOAN_SIGN_CM088 = chr(77786)
CYPRO_MINOAN_SIGN_CM089 = chr(77787)
CYPRO_MINOAN_SIGN_CM090 = chr(77788)
CYPRO_MINOAN_SIGN_CM091 = chr(77789)
CYPRO_MINOAN_SIGN_CM092 = chr(77790)
CYPRO_MINOAN_SIGN_CM094 = chr(77791)
CYPRO_MINOAN_SIGN_CM095 = chr(77792)
CYPRO_MINOAN_SIGN_CM096 = chr(77793)
CYPRO_MINOAN_SIGN_CM097 = chr(77794)
CYPRO_MINOAN_SIGN_CM098 = chr(77795)
CYPRO_MINOAN_SIGN_CM099 = chr(77796)
CYPRO_MINOAN_SIGN_CM100 = chr(77797)
CYPRO_MINOAN_SIGN_CM101 = chr(77798)
CYPRO_MINOAN_SIGN_CM102 = chr(77799)
CYPRO_MINOAN_SIGN_CM103 = chr(77800)
CYPRO_MINOAN_SIGN_CM104 = chr(77801)
CYPRO_MINOAN_SIGN_CM105 = chr(77802)
CYPRO_MINOAN_SIGN_CM107 = chr(77803)
CYPRO_MINOAN_SIGN_CM108 = chr(77804)
CYPRO_MINOAN_SIGN_CM109 = chr(77805)
CYPRO_MINOAN_SIGN_CM110 = chr(77806)
CYPRO_MINOAN_SIGN_CM112 = chr(77807)
CYPRO_MINOAN_SIGN_CM114 = chr(77808)
CYPRO_MINOAN_SIGN_CM301 = chr(77809)
CYPRO_MINOAN_SIGN_CM302 = chr(77810)
EGYPTIAN_HIEROGLYPH_A001 = chr(77824)
EGYPTIAN_HIEROGLYPH_A002 = chr(77825)
EGYPTIAN_HIEROGLYPH_A003 = chr(77826)
EGYPTIAN_HIEROGLYPH_A004 = chr(77827)
EGYPTIAN_HIEROGLYPH_A005 = chr(77828)
EGYPTIAN_HIEROGLYPH_A005A = chr(77829)
EGYPTIAN_HIEROGLYPH_A006 = chr(77830)
EGYPTIAN_HIEROGLYPH_A006A = chr(77831)
EGYPTIAN_HIEROGLYPH_A006B = chr(77832)
EGYPTIAN_HIEROGLYPH_A007 = chr(77833)
EGYPTIAN_HIEROGLYPH_A008 = chr(77834)
EGYPTIAN_HIEROGLYPH_A009 = chr(77835)
EGYPTIAN_HIEROGLYPH_A010 = chr(77836)
EGYPTIAN_HIEROGLYPH_A011 = chr(77837)
EGYPTIAN_HIEROGLYPH_A012 = chr(77838)
EGYPTIAN_HIEROGLYPH_A013 = chr(77839)
EGYPTIAN_HIEROGLYPH_A014 = chr(77840)
EGYPTIAN_HIEROGLYPH_A014A = chr(77841)
EGYPTIAN_HIEROGLYPH_A015 = chr(77842)
EGYPTIAN_HIEROGLYPH_A016 = chr(77843)
EGYPTIAN_HIEROGLYPH_A017 = chr(77844)
EGYPTIAN_HIEROGLYPH_A017A = chr(77845)
EGYPTIAN_HIEROGLYPH_A018 = chr(77846)
EGYPTIAN_HIEROGLYPH_A019 = chr(77847)
EGYPTIAN_HIEROGLYPH_A020 = chr(77848)
EGYPTIAN_HIEROGLYPH_A021 = chr(77849)
EGYPTIAN_HIEROGLYPH_A022 = chr(77850)
EGYPTIAN_HIEROGLYPH_A023 = chr(77851)
EGYPTIAN_HIEROGLYPH_A024 = chr(77852)
EGYPTIAN_HIEROGLYPH_A025 = chr(77853)
EGYPTIAN_HIEROGLYPH_A026 = chr(77854)
EGYPTIAN_HIEROGLYPH_A027 = chr(77855)
EGYPTIAN_HIEROGLYPH_A028 = chr(77856)
EGYPTIAN_HIEROGLYPH_A029 = chr(77857)
EGYPTIAN_HIEROGLYPH_A030 = chr(77858)
EGYPTIAN_HIEROGLYPH_A031 = chr(77859)
EGYPTIAN_HIEROGLYPH_A032 = chr(77860)
EGYPTIAN_HIEROGLYPH_A032A = chr(77861)
EGYPTIAN_HIEROGLYPH_A033 = chr(77862)
EGYPTIAN_HIEROGLYPH_A034 = chr(77863)
EGYPTIAN_HIEROGLYPH_A035 = chr(77864)
EGYPTIAN_HIEROGLYPH_A036 = chr(77865)
EGYPTIAN_HIEROGLYPH_A037 = chr(77866)
EGYPTIAN_HIEROGLYPH_A038 = chr(77867)
EGYPTIAN_HIEROGLYPH_A039 = chr(77868)
EGYPTIAN_HIEROGLYPH_A040 = chr(77869)
EGYPTIAN_HIEROGLYPH_A040A = chr(77870)
EGYPTIAN_HIEROGLYPH_A041 = chr(77871)
EGYPTIAN_HIEROGLYPH_A042 = chr(77872)
EGYPTIAN_HIEROGLYPH_A042A = chr(77873)
EGYPTIAN_HIEROGLYPH_A043 = chr(77874)
EGYPTIAN_HIEROGLYPH_A043A = chr(77875)
EGYPTIAN_HIEROGLYPH_A044 = chr(77876)
EGYPTIAN_HIEROGLYPH_A045 = chr(77877)
EGYPTIAN_HIEROGLYPH_A045A = chr(77878)
EGYPTIAN_HIEROGLYPH_A046 = chr(77879)
EGYPTIAN_HIEROGLYPH_A047 = chr(77880)
EGYPTIAN_HIEROGLYPH_A048 = chr(77881)
EGYPTIAN_HIEROGLYPH_A049 = chr(77882)
EGYPTIAN_HIEROGLYPH_A050 = chr(77883)
EGYPTIAN_HIEROGLYPH_A051 = chr(77884)
EGYPTIAN_HIEROGLYPH_A052 = chr(77885)
EGYPTIAN_HIEROGLYPH_A053 = chr(77886)
EGYPTIAN_HIEROGLYPH_A054 = chr(77887)
EGYPTIAN_HIEROGLYPH_A055 = chr(77888)
EGYPTIAN_HIEROGLYPH_A056 = chr(77889)
EGYPTIAN_HIEROGLYPH_A057 = chr(77890)
EGYPTIAN_HIEROGLYPH_A058 = chr(77891)
EGYPTIAN_HIEROGLYPH_A059 = chr(77892)
EGYPTIAN_HIEROGLYPH_A060 = chr(77893)
EGYPTIAN_HIEROGLYPH_A061 = chr(77894)
EGYPTIAN_HIEROGLYPH_A062 = chr(77895)
EGYPTIAN_HIEROGLYPH_A063 = chr(77896)
EGYPTIAN_HIEROGLYPH_A064 = chr(77897)
EGYPTIAN_HIEROGLYPH_A065 = chr(77898)
EGYPTIAN_HIEROGLYPH_A066 = chr(77899)
EGYPTIAN_HIEROGLYPH_A067 = chr(77900)
EGYPTIAN_HIEROGLYPH_A068 = chr(77901)
EGYPTIAN_HIEROGLYPH_A069 = chr(77902)
EGYPTIAN_HIEROGLYPH_A070 = chr(77903)
EGYPTIAN_HIEROGLYPH_B001 = chr(77904)
EGYPTIAN_HIEROGLYPH_B002 = chr(77905)
EGYPTIAN_HIEROGLYPH_B003 = chr(77906)
EGYPTIAN_HIEROGLYPH_B004 = chr(77907)
EGYPTIAN_HIEROGLYPH_B005 = chr(77908)
EGYPTIAN_HIEROGLYPH_B005A = chr(77909)
EGYPTIAN_HIEROGLYPH_B006 = chr(77910)
EGYPTIAN_HIEROGLYPH_B007 = chr(77911)
EGYPTIAN_HIEROGLYPH_B008 = chr(77912)
EGYPTIAN_HIEROGLYPH_B009 = chr(77913)
EGYPTIAN_HIEROGLYPH_C001 = chr(77914)
EGYPTIAN_HIEROGLYPH_C002 = chr(77915)
EGYPTIAN_HIEROGLYPH_C002A = chr(77916)
EGYPTIAN_HIEROGLYPH_C002B = chr(77917)
EGYPTIAN_HIEROGLYPH_C002C = chr(77918)
EGYPTIAN_HIEROGLYPH_C003 = chr(77919)
EGYPTIAN_HIEROGLYPH_C004 = chr(77920)
EGYPTIAN_HIEROGLYPH_C005 = chr(77921)
EGYPTIAN_HIEROGLYPH_C006 = chr(77922)
EGYPTIAN_HIEROGLYPH_C007 = chr(77923)
EGYPTIAN_HIEROGLYPH_C008 = chr(77924)
EGYPTIAN_HIEROGLYPH_C009 = chr(77925)
EGYPTIAN_HIEROGLYPH_C010 = chr(77926)
EGYPTIAN_HIEROGLYPH_C010A = chr(77927)
EGYPTIAN_HIEROGLYPH_C011 = chr(77928)
EGYPTIAN_HIEROGLYPH_C012 = chr(77929)
EGYPTIAN_HIEROGLYPH_C013 = chr(77930)
EGYPTIAN_HIEROGLYPH_C014 = chr(77931)
EGYPTIAN_HIEROGLYPH_C015 = chr(77932)
EGYPTIAN_HIEROGLYPH_C016 = chr(77933)
EGYPTIAN_HIEROGLYPH_C017 = chr(77934)
EGYPTIAN_HIEROGLYPH_C018 = chr(77935)
EGYPTIAN_HIEROGLYPH_C019 = chr(77936)
EGYPTIAN_HIEROGLYPH_C020 = chr(77937)
EGYPTIAN_HIEROGLYPH_C021 = chr(77938)
EGYPTIAN_HIEROGLYPH_C022 = chr(77939)
EGYPTIAN_HIEROGLYPH_C023 = chr(77940)
EGYPTIAN_HIEROGLYPH_C024 = chr(77941)
EGYPTIAN_HIEROGLYPH_D001 = chr(77942)
EGYPTIAN_HIEROGLYPH_D002 = chr(77943)
EGYPTIAN_HIEROGLYPH_D003 = chr(77944)
EGYPTIAN_HIEROGLYPH_D004 = chr(77945)
EGYPTIAN_HIEROGLYPH_D005 = chr(77946)
EGYPTIAN_HIEROGLYPH_D006 = chr(77947)
EGYPTIAN_HIEROGLYPH_D007 = chr(77948)
EGYPTIAN_HIEROGLYPH_D008 = chr(77949)
EGYPTIAN_HIEROGLYPH_D008A = chr(77950)
EGYPTIAN_HIEROGLYPH_D009 = chr(77951)
EGYPTIAN_HIEROGLYPH_D010 = chr(77952)
EGYPTIAN_HIEROGLYPH_D011 = chr(77953)
EGYPTIAN_HIEROGLYPH_D012 = chr(77954)
EGYPTIAN_HIEROGLYPH_D013 = chr(77955)
EGYPTIAN_HIEROGLYPH_D014 = chr(77956)
EGYPTIAN_HIEROGLYPH_D015 = chr(77957)
EGYPTIAN_HIEROGLYPH_D016 = chr(77958)
EGYPTIAN_HIEROGLYPH_D017 = chr(77959)
EGYPTIAN_HIEROGLYPH_D018 = chr(77960)
EGYPTIAN_HIEROGLYPH_D019 = chr(77961)
EGYPTIAN_HIEROGLYPH_D020 = chr(77962)
EGYPTIAN_HIEROGLYPH_D021 = chr(77963)
EGYPTIAN_HIEROGLYPH_D022 = chr(77964)
EGYPTIAN_HIEROGLYPH_D023 = chr(77965)
EGYPTIAN_HIEROGLYPH_D024 = chr(77966)
EGYPTIAN_HIEROGLYPH_D025 = chr(77967)
EGYPTIAN_HIEROGLYPH_D026 = chr(77968)
EGYPTIAN_HIEROGLYPH_D027 = chr(77969)
EGYPTIAN_HIEROGLYPH_D027A = chr(77970)
EGYPTIAN_HIEROGLYPH_D028 = chr(77971)
EGYPTIAN_HIEROGLYPH_D029 = chr(77972)
EGYPTIAN_HIEROGLYPH_D030 = chr(77973)
EGYPTIAN_HIEROGLYPH_D031 = chr(77974)
EGYPTIAN_HIEROGLYPH_D031A = chr(77975)
EGYPTIAN_HIEROGLYPH_D032 = chr(77976)
EGYPTIAN_HIEROGLYPH_D033 = chr(77977)
EGYPTIAN_HIEROGLYPH_D034 = chr(77978)
EGYPTIAN_HIEROGLYPH_D034A = chr(77979)
EGYPTIAN_HIEROGLYPH_D035 = chr(77980)
EGYPTIAN_HIEROGLYPH_D036 = chr(77981)
EGYPTIAN_HIEROGLYPH_D037 = chr(77982)
EGYPTIAN_HIEROGLYPH_D038 = chr(77983)
EGYPTIAN_HIEROGLYPH_D039 = chr(77984)
EGYPTIAN_HIEROGLYPH_D040 = chr(77985)
EGYPTIAN_HIEROGLYPH_D041 = chr(77986)
EGYPTIAN_HIEROGLYPH_D042 = chr(77987)
EGYPTIAN_HIEROGLYPH_D043 = chr(77988)
EGYPTIAN_HIEROGLYPH_D044 = chr(77989)
EGYPTIAN_HIEROGLYPH_D045 = chr(77990)
EGYPTIAN_HIEROGLYPH_D046 = chr(77991)
EGYPTIAN_HIEROGLYPH_D046A = chr(77992)
EGYPTIAN_HIEROGLYPH_D047 = chr(77993)
EGYPTIAN_HIEROGLYPH_D048 = chr(77994)
EGYPTIAN_HIEROGLYPH_D048A = chr(77995)
EGYPTIAN_HIEROGLYPH_D049 = chr(77996)
EGYPTIAN_HIEROGLYPH_D050 = chr(77997)
EGYPTIAN_HIEROGLYPH_D050A = chr(77998)
EGYPTIAN_HIEROGLYPH_D050B = chr(77999)
EGYPTIAN_HIEROGLYPH_D050C = chr(78000)
EGYPTIAN_HIEROGLYPH_D050D = chr(78001)
EGYPTIAN_HIEROGLYPH_D050E = chr(78002)
EGYPTIAN_HIEROGLYPH_D050F = chr(78003)
EGYPTIAN_HIEROGLYPH_D050G = chr(78004)
EGYPTIAN_HIEROGLYPH_D050H = chr(78005)
EGYPTIAN_HIEROGLYPH_D050I = chr(78006)
EGYPTIAN_HIEROGLYPH_D051 = chr(78007)
EGYPTIAN_HIEROGLYPH_D052 = chr(78008)
EGYPTIAN_HIEROGLYPH_D052A = chr(78009)
EGYPTIAN_HIEROGLYPH_D053 = chr(78010)
EGYPTIAN_HIEROGLYPH_D054 = chr(78011)
EGYPTIAN_HIEROGLYPH_D054A = chr(78012)
EGYPTIAN_HIEROGLYPH_D055 = chr(78013)
EGYPTIAN_HIEROGLYPH_D056 = chr(78014)
EGYPTIAN_HIEROGLYPH_D057 = chr(78015)
EGYPTIAN_HIEROGLYPH_D058 = chr(78016)
EGYPTIAN_HIEROGLYPH_D059 = chr(78017)
EGYPTIAN_HIEROGLYPH_D060 = chr(78018)
EGYPTIAN_HIEROGLYPH_D061 = chr(78019)
EGYPTIAN_HIEROGLYPH_D062 = chr(78020)
EGYPTIAN_HIEROGLYPH_D063 = chr(78021)
EGYPTIAN_HIEROGLYPH_D064 = chr(78022)
EGYPTIAN_HIEROGLYPH_D065 = chr(78023)
EGYPTIAN_HIEROGLYPH_D066 = chr(78024)
EGYPTIAN_HIEROGLYPH_D067 = chr(78025)
EGYPTIAN_HIEROGLYPH_D067A = chr(78026)
EGYPTIAN_HIEROGLYPH_D067B = chr(78027)
EGYPTIAN_HIEROGLYPH_D067C = chr(78028)
EGYPTIAN_HIEROGLYPH_D067D = chr(78029)
EGYPTIAN_HIEROGLYPH_D067E = chr(78030)
EGYPTIAN_HIEROGLYPH_D067F = chr(78031)
EGYPTIAN_HIEROGLYPH_D067G = chr(78032)
EGYPTIAN_HIEROGLYPH_D067H = chr(78033)
EGYPTIAN_HIEROGLYPH_E001 = chr(78034)
EGYPTIAN_HIEROGLYPH_E002 = chr(78035)
EGYPTIAN_HIEROGLYPH_E003 = chr(78036)
EGYPTIAN_HIEROGLYPH_E004 = chr(78037)
EGYPTIAN_HIEROGLYPH_E005 = chr(78038)
EGYPTIAN_HIEROGLYPH_E006 = chr(78039)
EGYPTIAN_HIEROGLYPH_E007 = chr(78040)
EGYPTIAN_HIEROGLYPH_E008 = chr(78041)
EGYPTIAN_HIEROGLYPH_E008A = chr(78042)
EGYPTIAN_HIEROGLYPH_E009 = chr(78043)
EGYPTIAN_HIEROGLYPH_E009A = chr(78044)
EGYPTIAN_HIEROGLYPH_E010 = chr(78045)
EGYPTIAN_HIEROGLYPH_E011 = chr(78046)
EGYPTIAN_HIEROGLYPH_E012 = chr(78047)
EGYPTIAN_HIEROGLYPH_E013 = chr(78048)
EGYPTIAN_HIEROGLYPH_E014 = chr(78049)
EGYPTIAN_HIEROGLYPH_E015 = chr(78050)
EGYPTIAN_HIEROGLYPH_E016 = chr(78051)
EGYPTIAN_HIEROGLYPH_E016A = chr(78052)
EGYPTIAN_HIEROGLYPH_E017 = chr(78053)
EGYPTIAN_HIEROGLYPH_E017A = chr(78054)
EGYPTIAN_HIEROGLYPH_E018 = chr(78055)
EGYPTIAN_HIEROGLYPH_E019 = chr(78056)
EGYPTIAN_HIEROGLYPH_E020 = chr(78057)
EGYPTIAN_HIEROGLYPH_E020A = chr(78058)
EGYPTIAN_HIEROGLYPH_E021 = chr(78059)
EGYPTIAN_HIEROGLYPH_E022 = chr(78060)
EGYPTIAN_HIEROGLYPH_E023 = chr(78061)
EGYPTIAN_HIEROGLYPH_E024 = chr(78062)
EGYPTIAN_HIEROGLYPH_E025 = chr(78063)
EGYPTIAN_HIEROGLYPH_E026 = chr(78064)
EGYPTIAN_HIEROGLYPH_E027 = chr(78065)
EGYPTIAN_HIEROGLYPH_E028 = chr(78066)
EGYPTIAN_HIEROGLYPH_E028A = chr(78067)
EGYPTIAN_HIEROGLYPH_E029 = chr(78068)
EGYPTIAN_HIEROGLYPH_E030 = chr(78069)
EGYPTIAN_HIEROGLYPH_E031 = chr(78070)
EGYPTIAN_HIEROGLYPH_E032 = chr(78071)
EGYPTIAN_HIEROGLYPH_E033 = chr(78072)
EGYPTIAN_HIEROGLYPH_E034 = chr(78073)
EGYPTIAN_HIEROGLYPH_E034A = chr(78074)
EGYPTIAN_HIEROGLYPH_E036 = chr(78075)
EGYPTIAN_HIEROGLYPH_E037 = chr(78076)
EGYPTIAN_HIEROGLYPH_E038 = chr(78077)
EGYPTIAN_HIEROGLYPH_F001 = chr(78078)
EGYPTIAN_HIEROGLYPH_F001A = chr(78079)
EGYPTIAN_HIEROGLYPH_F002 = chr(78080)
EGYPTIAN_HIEROGLYPH_F003 = chr(78081)
EGYPTIAN_HIEROGLYPH_F004 = chr(78082)
EGYPTIAN_HIEROGLYPH_F005 = chr(78083)
EGYPTIAN_HIEROGLYPH_F006 = chr(78084)
EGYPTIAN_HIEROGLYPH_F007 = chr(78085)
EGYPTIAN_HIEROGLYPH_F008 = chr(78086)
EGYPTIAN_HIEROGLYPH_F009 = chr(78087)
EGYPTIAN_HIEROGLYPH_F010 = chr(78088)
EGYPTIAN_HIEROGLYPH_F011 = chr(78089)
EGYPTIAN_HIEROGLYPH_F012 = chr(78090)
EGYPTIAN_HIEROGLYPH_F013 = chr(78091)
EGYPTIAN_HIEROGLYPH_F013A = chr(78092)
EGYPTIAN_HIEROGLYPH_F014 = chr(78093)
EGYPTIAN_HIEROGLYPH_F015 = chr(78094)
EGYPTIAN_HIEROGLYPH_F016 = chr(78095)
EGYPTIAN_HIEROGLYPH_F017 = chr(78096)
EGYPTIAN_HIEROGLYPH_F018 = chr(78097)
EGYPTIAN_HIEROGLYPH_F019 = chr(78098)
EGYPTIAN_HIEROGLYPH_F020 = chr(78099)
EGYPTIAN_HIEROGLYPH_F021 = chr(78100)
EGYPTIAN_HIEROGLYPH_F021A = chr(78101)
EGYPTIAN_HIEROGLYPH_F022 = chr(78102)
EGYPTIAN_HIEROGLYPH_F023 = chr(78103)
EGYPTIAN_HIEROGLYPH_F024 = chr(78104)
EGYPTIAN_HIEROGLYPH_F025 = chr(78105)
EGYPTIAN_HIEROGLYPH_F026 = chr(78106)
EGYPTIAN_HIEROGLYPH_F027 = chr(78107)
EGYPTIAN_HIEROGLYPH_F028 = chr(78108)
EGYPTIAN_HIEROGLYPH_F029 = chr(78109)
EGYPTIAN_HIEROGLYPH_F030 = chr(78110)
EGYPTIAN_HIEROGLYPH_F031 = chr(78111)
EGYPTIAN_HIEROGLYPH_F031A = chr(78112)
EGYPTIAN_HIEROGLYPH_F032 = chr(78113)
EGYPTIAN_HIEROGLYPH_F033 = chr(78114)
EGYPTIAN_HIEROGLYPH_F034 = chr(78115)
EGYPTIAN_HIEROGLYPH_F035 = chr(78116)
EGYPTIAN_HIEROGLYPH_F036 = chr(78117)
EGYPTIAN_HIEROGLYPH_F037 = chr(78118)
EGYPTIAN_HIEROGLYPH_F037A = chr(78119)
EGYPTIAN_HIEROGLYPH_F038 = chr(78120)
EGYPTIAN_HIEROGLYPH_F038A = chr(78121)
EGYPTIAN_HIEROGLYPH_F039 = chr(78122)
EGYPTIAN_HIEROGLYPH_F040 = chr(78123)
EGYPTIAN_HIEROGLYPH_F041 = chr(78124)
EGYPTIAN_HIEROGLYPH_F042 = chr(78125)
EGYPTIAN_HIEROGLYPH_F043 = chr(78126)
EGYPTIAN_HIEROGLYPH_F044 = chr(78127)
EGYPTIAN_HIEROGLYPH_F045 = chr(78128)
EGYPTIAN_HIEROGLYPH_F045A = chr(78129)
EGYPTIAN_HIEROGLYPH_F046 = chr(78130)
EGYPTIAN_HIEROGLYPH_F046A = chr(78131)
EGYPTIAN_HIEROGLYPH_F047 = chr(78132)
EGYPTIAN_HIEROGLYPH_F047A = chr(78133)
EGYPTIAN_HIEROGLYPH_F048 = chr(78134)
EGYPTIAN_HIEROGLYPH_F049 = chr(78135)
EGYPTIAN_HIEROGLYPH_F050 = chr(78136)
EGYPTIAN_HIEROGLYPH_F051 = chr(78137)
EGYPTIAN_HIEROGLYPH_F051A = chr(78138)
EGYPTIAN_HIEROGLYPH_F051B = chr(78139)
EGYPTIAN_HIEROGLYPH_F051C = chr(78140)
EGYPTIAN_HIEROGLYPH_F052 = chr(78141)
EGYPTIAN_HIEROGLYPH_F053 = chr(78142)
EGYPTIAN_HIEROGLYPH_G001 = chr(78143)
EGYPTIAN_HIEROGLYPH_G002 = chr(78144)
EGYPTIAN_HIEROGLYPH_G003 = chr(78145)
EGYPTIAN_HIEROGLYPH_G004 = chr(78146)
EGYPTIAN_HIEROGLYPH_G005 = chr(78147)
EGYPTIAN_HIEROGLYPH_G006 = chr(78148)
EGYPTIAN_HIEROGLYPH_G006A = chr(78149)
EGYPTIAN_HIEROGLYPH_G007 = chr(78150)
EGYPTIAN_HIEROGLYPH_G007A = chr(78151)
EGYPTIAN_HIEROGLYPH_G007B = chr(78152)
EGYPTIAN_HIEROGLYPH_G008 = chr(78153)
EGYPTIAN_HIEROGLYPH_G009 = chr(78154)
EGYPTIAN_HIEROGLYPH_G010 = chr(78155)
EGYPTIAN_HIEROGLYPH_G011 = chr(78156)
EGYPTIAN_HIEROGLYPH_G011A = chr(78157)
EGYPTIAN_HIEROGLYPH_G012 = chr(78158)
EGYPTIAN_HIEROGLYPH_G013 = chr(78159)
EGYPTIAN_HIEROGLYPH_G014 = chr(78160)
EGYPTIAN_HIEROGLYPH_G015 = chr(78161)
EGYPTIAN_HIEROGLYPH_G016 = chr(78162)
EGYPTIAN_HIEROGLYPH_G017 = chr(78163)
EGYPTIAN_HIEROGLYPH_G018 = chr(78164)
EGYPTIAN_HIEROGLYPH_G019 = chr(78165)
EGYPTIAN_HIEROGLYPH_G020 = chr(78166)
EGYPTIAN_HIEROGLYPH_G020A = chr(78167)
EGYPTIAN_HIEROGLYPH_G021 = chr(78168)
EGYPTIAN_HIEROGLYPH_G022 = chr(78169)
EGYPTIAN_HIEROGLYPH_G023 = chr(78170)
EGYPTIAN_HIEROGLYPH_G024 = chr(78171)
EGYPTIAN_HIEROGLYPH_G025 = chr(78172)
EGYPTIAN_HIEROGLYPH_G026 = chr(78173)
EGYPTIAN_HIEROGLYPH_G026A = chr(78174)
EGYPTIAN_HIEROGLYPH_G027 = chr(78175)
EGYPTIAN_HIEROGLYPH_G028 = chr(78176)
EGYPTIAN_HIEROGLYPH_G029 = chr(78177)
EGYPTIAN_HIEROGLYPH_G030 = chr(78178)
EGYPTIAN_HIEROGLYPH_G031 = chr(78179)
EGYPTIAN_HIEROGLYPH_G032 = chr(78180)
EGYPTIAN_HIEROGLYPH_G033 = chr(78181)
EGYPTIAN_HIEROGLYPH_G034 = chr(78182)
EGYPTIAN_HIEROGLYPH_G035 = chr(78183)
EGYPTIAN_HIEROGLYPH_G036 = chr(78184)
EGYPTIAN_HIEROGLYPH_G036A = chr(78185)
EGYPTIAN_HIEROGLYPH_G037 = chr(78186)
EGYPTIAN_HIEROGLYPH_G037A = chr(78187)
EGYPTIAN_HIEROGLYPH_G038 = chr(78188)
EGYPTIAN_HIEROGLYPH_G039 = chr(78189)
EGYPTIAN_HIEROGLYPH_G040 = chr(78190)
EGYPTIAN_HIEROGLYPH_G041 = chr(78191)
EGYPTIAN_HIEROGLYPH_G042 = chr(78192)
EGYPTIAN_HIEROGLYPH_G043 = chr(78193)
EGYPTIAN_HIEROGLYPH_G043A = chr(78194)
EGYPTIAN_HIEROGLYPH_G044 = chr(78195)
EGYPTIAN_HIEROGLYPH_G045 = chr(78196)
EGYPTIAN_HIEROGLYPH_G045A = chr(78197)
EGYPTIAN_HIEROGLYPH_G046 = chr(78198)
EGYPTIAN_HIEROGLYPH_G047 = chr(78199)
EGYPTIAN_HIEROGLYPH_G048 = chr(78200)
EGYPTIAN_HIEROGLYPH_G049 = chr(78201)
EGYPTIAN_HIEROGLYPH_G050 = chr(78202)
EGYPTIAN_HIEROGLYPH_G051 = chr(78203)
EGYPTIAN_HIEROGLYPH_G052 = chr(78204)
EGYPTIAN_HIEROGLYPH_G053 = chr(78205)
EGYPTIAN_HIEROGLYPH_G054 = chr(78206)
EGYPTIAN_HIEROGLYPH_H001 = chr(78207)
EGYPTIAN_HIEROGLYPH_H002 = chr(78208)
EGYPTIAN_HIEROGLYPH_H003 = chr(78209)
EGYPTIAN_HIEROGLYPH_H004 = chr(78210)
EGYPTIAN_HIEROGLYPH_H005 = chr(78211)
EGYPTIAN_HIEROGLYPH_H006 = chr(78212)
EGYPTIAN_HIEROGLYPH_H006A = chr(78213)
EGYPTIAN_HIEROGLYPH_H007 = chr(78214)
EGYPTIAN_HIEROGLYPH_H008 = chr(78215)
EGYPTIAN_HIEROGLYPH_I001 = chr(78216)
EGYPTIAN_HIEROGLYPH_I002 = chr(78217)
EGYPTIAN_HIEROGLYPH_I003 = chr(78218)
EGYPTIAN_HIEROGLYPH_I004 = chr(78219)
EGYPTIAN_HIEROGLYPH_I005 = chr(78220)
EGYPTIAN_HIEROGLYPH_I005A = chr(78221)
EGYPTIAN_HIEROGLYPH_I006 = chr(78222)
EGYPTIAN_HIEROGLYPH_I007 = chr(78223)
EGYPTIAN_HIEROGLYPH_I008 = chr(78224)
EGYPTIAN_HIEROGLYPH_I009 = chr(78225)
EGYPTIAN_HIEROGLYPH_I009A = chr(78226)
EGYPTIAN_HIEROGLYPH_I010 = chr(78227)
EGYPTIAN_HIEROGLYPH_I010A = chr(78228)
EGYPTIAN_HIEROGLYPH_I011 = chr(78229)
EGYPTIAN_HIEROGLYPH_I011A = chr(78230)
EGYPTIAN_HIEROGLYPH_I012 = chr(78231)
EGYPTIAN_HIEROGLYPH_I013 = chr(78232)
EGYPTIAN_HIEROGLYPH_I014 = chr(78233)
EGYPTIAN_HIEROGLYPH_I015 = chr(78234)
EGYPTIAN_HIEROGLYPH_K001 = chr(78235)
EGYPTIAN_HIEROGLYPH_K002 = chr(78236)
EGYPTIAN_HIEROGLYPH_K003 = chr(78237)
EGYPTIAN_HIEROGLYPH_K004 = chr(78238)
EGYPTIAN_HIEROGLYPH_K005 = chr(78239)
EGYPTIAN_HIEROGLYPH_K006 = chr(78240)
EGYPTIAN_HIEROGLYPH_K007 = chr(78241)
EGYPTIAN_HIEROGLYPH_K008 = chr(78242)
EGYPTIAN_HIEROGLYPH_L001 = chr(78243)
EGYPTIAN_HIEROGLYPH_L002 = chr(78244)
EGYPTIAN_HIEROGLYPH_L002A = chr(78245)
EGYPTIAN_HIEROGLYPH_L003 = chr(78246)
EGYPTIAN_HIEROGLYPH_L004 = chr(78247)
EGYPTIAN_HIEROGLYPH_L005 = chr(78248)
EGYPTIAN_HIEROGLYPH_L006 = chr(78249)
EGYPTIAN_HIEROGLYPH_L006A = chr(78250)
EGYPTIAN_HIEROGLYPH_L007 = chr(78251)
EGYPTIAN_HIEROGLYPH_L008 = chr(78252)
EGYPTIAN_HIEROGLYPH_M001 = chr(78253)
EGYPTIAN_HIEROGLYPH_M001A = chr(78254)
EGYPTIAN_HIEROGLYPH_M001B = chr(78255)
EGYPTIAN_HIEROGLYPH_M002 = chr(78256)
EGYPTIAN_HIEROGLYPH_M003 = chr(78257)
EGYPTIAN_HIEROGLYPH_M003A = chr(78258)
EGYPTIAN_HIEROGLYPH_M004 = chr(78259)
EGYPTIAN_HIEROGLYPH_M005 = chr(78260)
EGYPTIAN_HIEROGLYPH_M006 = chr(78261)
EGYPTIAN_HIEROGLYPH_M007 = chr(78262)
EGYPTIAN_HIEROGLYPH_M008 = chr(78263)
EGYPTIAN_HIEROGLYPH_M009 = chr(78264)
EGYPTIAN_HIEROGLYPH_M010 = chr(78265)
EGYPTIAN_HIEROGLYPH_M010A = chr(78266)
EGYPTIAN_HIEROGLYPH_M011 = chr(78267)
EGYPTIAN_HIEROGLYPH_M012 = chr(78268)
EGYPTIAN_HIEROGLYPH_M012A = chr(78269)
EGYPTIAN_HIEROGLYPH_M012B = chr(78270)
EGYPTIAN_HIEROGLYPH_M012C = chr(78271)
EGYPTIAN_HIEROGLYPH_M012D = chr(78272)
EGYPTIAN_HIEROGLYPH_M012E = chr(78273)
EGYPTIAN_HIEROGLYPH_M012F = chr(78274)
EGYPTIAN_HIEROGLYPH_M012G = chr(78275)
EGYPTIAN_HIEROGLYPH_M012H = chr(78276)
EGYPTIAN_HIEROGLYPH_M013 = chr(78277)
EGYPTIAN_HIEROGLYPH_M014 = chr(78278)
EGYPTIAN_HIEROGLYPH_M015 = chr(78279)
EGYPTIAN_HIEROGLYPH_M015A = chr(78280)
EGYPTIAN_HIEROGLYPH_M016 = chr(78281)
EGYPTIAN_HIEROGLYPH_M016A = chr(78282)
EGYPTIAN_HIEROGLYPH_M017 = chr(78283)
EGYPTIAN_HIEROGLYPH_M017A = chr(78284)
EGYPTIAN_HIEROGLYPH_M018 = chr(78285)
EGYPTIAN_HIEROGLYPH_M019 = chr(78286)
EGYPTIAN_HIEROGLYPH_M020 = chr(78287)
EGYPTIAN_HIEROGLYPH_M021 = chr(78288)
EGYPTIAN_HIEROGLYPH_M022 = chr(78289)
EGYPTIAN_HIEROGLYPH_M022A = chr(78290)
EGYPTIAN_HIEROGLYPH_M023 = chr(78291)
EGYPTIAN_HIEROGLYPH_M024 = chr(78292)
EGYPTIAN_HIEROGLYPH_M024A = chr(78293)
EGYPTIAN_HIEROGLYPH_M025 = chr(78294)
EGYPTIAN_HIEROGLYPH_M026 = chr(78295)
EGYPTIAN_HIEROGLYPH_M027 = chr(78296)
EGYPTIAN_HIEROGLYPH_M028 = chr(78297)
EGYPTIAN_HIEROGLYPH_M028A = chr(78298)
EGYPTIAN_HIEROGLYPH_M029 = chr(78299)
EGYPTIAN_HIEROGLYPH_M030 = chr(78300)
EGYPTIAN_HIEROGLYPH_M031 = chr(78301)
EGYPTIAN_HIEROGLYPH_M031A = chr(78302)
EGYPTIAN_HIEROGLYPH_M032 = chr(78303)
EGYPTIAN_HIEROGLYPH_M033 = chr(78304)
EGYPTIAN_HIEROGLYPH_M033A = chr(78305)
EGYPTIAN_HIEROGLYPH_M033B = chr(78306)
EGYPTIAN_HIEROGLYPH_M034 = chr(78307)
EGYPTIAN_HIEROGLYPH_M035 = chr(78308)
EGYPTIAN_HIEROGLYPH_M036 = chr(78309)
EGYPTIAN_HIEROGLYPH_M037 = chr(78310)
EGYPTIAN_HIEROGLYPH_M038 = chr(78311)
EGYPTIAN_HIEROGLYPH_M039 = chr(78312)
EGYPTIAN_HIEROGLYPH_M040 = chr(78313)
EGYPTIAN_HIEROGLYPH_M040A = chr(78314)
EGYPTIAN_HIEROGLYPH_M041 = chr(78315)
EGYPTIAN_HIEROGLYPH_M042 = chr(78316)
EGYPTIAN_HIEROGLYPH_M043 = chr(78317)
EGYPTIAN_HIEROGLYPH_M044 = chr(78318)
EGYPTIAN_HIEROGLYPH_N001 = chr(78319)
EGYPTIAN_HIEROGLYPH_N002 = chr(78320)
EGYPTIAN_HIEROGLYPH_N003 = chr(78321)
EGYPTIAN_HIEROGLYPH_N004 = chr(78322)
EGYPTIAN_HIEROGLYPH_N005 = chr(78323)
EGYPTIAN_HIEROGLYPH_N006 = chr(78324)
EGYPTIAN_HIEROGLYPH_N007 = chr(78325)
EGYPTIAN_HIEROGLYPH_N008 = chr(78326)
EGYPTIAN_HIEROGLYPH_N009 = chr(78327)
EGYPTIAN_HIEROGLYPH_N010 = chr(78328)
EGYPTIAN_HIEROGLYPH_N011 = chr(78329)
EGYPTIAN_HIEROGLYPH_N012 = chr(78330)
EGYPTIAN_HIEROGLYPH_N013 = chr(78331)
EGYPTIAN_HIEROGLYPH_N014 = chr(78332)
EGYPTIAN_HIEROGLYPH_N015 = chr(78333)
EGYPTIAN_HIEROGLYPH_N016 = chr(78334)
EGYPTIAN_HIEROGLYPH_N017 = chr(78335)
EGYPTIAN_HIEROGLYPH_N018 = chr(78336)
EGYPTIAN_HIEROGLYPH_N018A = chr(78337)
EGYPTIAN_HIEROGLYPH_N018B = chr(78338)
EGYPTIAN_HIEROGLYPH_N019 = chr(78339)
EGYPTIAN_HIEROGLYPH_N020 = chr(78340)
EGYPTIAN_HIEROGLYPH_N021 = chr(78341)
EGYPTIAN_HIEROGLYPH_N022 = chr(78342)
EGYPTIAN_HIEROGLYPH_N023 = chr(78343)
EGYPTIAN_HIEROGLYPH_N024 = chr(78344)
EGYPTIAN_HIEROGLYPH_N025 = chr(78345)
EGYPTIAN_HIEROGLYPH_N025A = chr(78346)
EGYPTIAN_HIEROGLYPH_N026 = chr(78347)
EGYPTIAN_HIEROGLYPH_N027 = chr(78348)
EGYPTIAN_HIEROGLYPH_N028 = chr(78349)
EGYPTIAN_HIEROGLYPH_N029 = chr(78350)
EGYPTIAN_HIEROGLYPH_N030 = chr(78351)
EGYPTIAN_HIEROGLYPH_N031 = chr(78352)
EGYPTIAN_HIEROGLYPH_N032 = chr(78353)
EGYPTIAN_HIEROGLYPH_N033 = chr(78354)
EGYPTIAN_HIEROGLYPH_N033A = chr(78355)
EGYPTIAN_HIEROGLYPH_N034 = chr(78356)
EGYPTIAN_HIEROGLYPH_N034A = chr(78357)
EGYPTIAN_HIEROGLYPH_N035 = chr(78358)
EGYPTIAN_HIEROGLYPH_N035A = chr(78359)
EGYPTIAN_HIEROGLYPH_N036 = chr(78360)
EGYPTIAN_HIEROGLYPH_N037 = chr(78361)
EGYPTIAN_HIEROGLYPH_N037A = chr(78362)
EGYPTIAN_HIEROGLYPH_N038 = chr(78363)
EGYPTIAN_HIEROGLYPH_N039 = chr(78364)
EGYPTIAN_HIEROGLYPH_N040 = chr(78365)
EGYPTIAN_HIEROGLYPH_N041 = chr(78366)
EGYPTIAN_HIEROGLYPH_N042 = chr(78367)
EGYPTIAN_HIEROGLYPH_NL001 = chr(78368)
EGYPTIAN_HIEROGLYPH_NL002 = chr(78369)
EGYPTIAN_HIEROGLYPH_NL003 = chr(78370)
EGYPTIAN_HIEROGLYPH_NL004 = chr(78371)
EGYPTIAN_HIEROGLYPH_NL005 = chr(78372)
EGYPTIAN_HIEROGLYPH_NL005A = chr(78373)
EGYPTIAN_HIEROGLYPH_NL006 = chr(78374)
EGYPTIAN_HIEROGLYPH_NL007 = chr(78375)
EGYPTIAN_HIEROGLYPH_NL008 = chr(78376)
EGYPTIAN_HIEROGLYPH_NL009 = chr(78377)
EGYPTIAN_HIEROGLYPH_NL010 = chr(78378)
EGYPTIAN_HIEROGLYPH_NL011 = chr(78379)
EGYPTIAN_HIEROGLYPH_NL012 = chr(78380)
EGYPTIAN_HIEROGLYPH_NL013 = chr(78381)
EGYPTIAN_HIEROGLYPH_NL014 = chr(78382)
EGYPTIAN_HIEROGLYPH_NL015 = chr(78383)
EGYPTIAN_HIEROGLYPH_NL016 = chr(78384)
EGYPTIAN_HIEROGLYPH_NL017 = chr(78385)
EGYPTIAN_HIEROGLYPH_NL017A = chr(78386)
EGYPTIAN_HIEROGLYPH_NL018 = chr(78387)
EGYPTIAN_HIEROGLYPH_NL019 = chr(78388)
EGYPTIAN_HIEROGLYPH_NL020 = chr(78389)
EGYPTIAN_HIEROGLYPH_NU001 = chr(78390)
EGYPTIAN_HIEROGLYPH_NU002 = chr(78391)
EGYPTIAN_HIEROGLYPH_NU003 = chr(78392)
EGYPTIAN_HIEROGLYPH_NU004 = chr(78393)
EGYPTIAN_HIEROGLYPH_NU005 = chr(78394)
EGYPTIAN_HIEROGLYPH_NU006 = chr(78395)
EGYPTIAN_HIEROGLYPH_NU007 = chr(78396)
EGYPTIAN_HIEROGLYPH_NU008 = chr(78397)
EGYPTIAN_HIEROGLYPH_NU009 = chr(78398)
EGYPTIAN_HIEROGLYPH_NU010 = chr(78399)
EGYPTIAN_HIEROGLYPH_NU010A = chr(78400)
EGYPTIAN_HIEROGLYPH_NU011 = chr(78401)
EGYPTIAN_HIEROGLYPH_NU011A = chr(78402)
EGYPTIAN_HIEROGLYPH_NU012 = chr(78403)
EGYPTIAN_HIEROGLYPH_NU013 = chr(78404)
EGYPTIAN_HIEROGLYPH_NU014 = chr(78405)
EGYPTIAN_HIEROGLYPH_NU015 = chr(78406)
EGYPTIAN_HIEROGLYPH_NU016 = chr(78407)
EGYPTIAN_HIEROGLYPH_NU017 = chr(78408)
EGYPTIAN_HIEROGLYPH_NU018 = chr(78409)
EGYPTIAN_HIEROGLYPH_NU018A = chr(78410)
EGYPTIAN_HIEROGLYPH_NU019 = chr(78411)
EGYPTIAN_HIEROGLYPH_NU020 = chr(78412)
EGYPTIAN_HIEROGLYPH_NU021 = chr(78413)
EGYPTIAN_HIEROGLYPH_NU022 = chr(78414)
EGYPTIAN_HIEROGLYPH_NU022A = chr(78415)
EGYPTIAN_HIEROGLYPH_O001 = chr(78416)
EGYPTIAN_HIEROGLYPH_O001A = chr(78417)
EGYPTIAN_HIEROGLYPH_O002 = chr(78418)
EGYPTIAN_HIEROGLYPH_O003 = chr(78419)
EGYPTIAN_HIEROGLYPH_O004 = chr(78420)
EGYPTIAN_HIEROGLYPH_O005 = chr(78421)
EGYPTIAN_HIEROGLYPH_O005A = chr(78422)
EGYPTIAN_HIEROGLYPH_O006 = chr(78423)
EGYPTIAN_HIEROGLYPH_O006A = chr(78424)
EGYPTIAN_HIEROGLYPH_O006B = chr(78425)
EGYPTIAN_HIEROGLYPH_O006C = chr(78426)
EGYPTIAN_HIEROGLYPH_O006D = chr(78427)
EGYPTIAN_HIEROGLYPH_O006E = chr(78428)
EGYPTIAN_HIEROGLYPH_O006F = chr(78429)
EGYPTIAN_HIEROGLYPH_O007 = chr(78430)
EGYPTIAN_HIEROGLYPH_O008 = chr(78431)
EGYPTIAN_HIEROGLYPH_O009 = chr(78432)
EGYPTIAN_HIEROGLYPH_O010 = chr(78433)
EGYPTIAN_HIEROGLYPH_O010A = chr(78434)
EGYPTIAN_HIEROGLYPH_O010B = chr(78435)
EGYPTIAN_HIEROGLYPH_O010C = chr(78436)
EGYPTIAN_HIEROGLYPH_O011 = chr(78437)
EGYPTIAN_HIEROGLYPH_O012 = chr(78438)
EGYPTIAN_HIEROGLYPH_O013 = chr(78439)
EGYPTIAN_HIEROGLYPH_O014 = chr(78440)
EGYPTIAN_HIEROGLYPH_O015 = chr(78441)
EGYPTIAN_HIEROGLYPH_O016 = chr(78442)
EGYPTIAN_HIEROGLYPH_O017 = chr(78443)
EGYPTIAN_HIEROGLYPH_O018 = chr(78444)
EGYPTIAN_HIEROGLYPH_O019 = chr(78445)
EGYPTIAN_HIEROGLYPH_O019A = chr(78446)
EGYPTIAN_HIEROGLYPH_O020 = chr(78447)
EGYPTIAN_HIEROGLYPH_O020A = chr(78448)
EGYPTIAN_HIEROGLYPH_O021 = chr(78449)
EGYPTIAN_HIEROGLYPH_O022 = chr(78450)
EGYPTIAN_HIEROGLYPH_O023 = chr(78451)
EGYPTIAN_HIEROGLYPH_O024 = chr(78452)
EGYPTIAN_HIEROGLYPH_O024A = chr(78453)
EGYPTIAN_HIEROGLYPH_O025 = chr(78454)
EGYPTIAN_HIEROGLYPH_O025A = chr(78455)
EGYPTIAN_HIEROGLYPH_O026 = chr(78456)
EGYPTIAN_HIEROGLYPH_O027 = chr(78457)
EGYPTIAN_HIEROGLYPH_O028 = chr(78458)
EGYPTIAN_HIEROGLYPH_O029 = chr(78459)
EGYPTIAN_HIEROGLYPH_O029A = chr(78460)
EGYPTIAN_HIEROGLYPH_O030 = chr(78461)
EGYPTIAN_HIEROGLYPH_O030A = chr(78462)
EGYPTIAN_HIEROGLYPH_O031 = chr(78463)
EGYPTIAN_HIEROGLYPH_O032 = chr(78464)
EGYPTIAN_HIEROGLYPH_O033 = chr(78465)
EGYPTIAN_HIEROGLYPH_O033A = chr(78466)
EGYPTIAN_HIEROGLYPH_O034 = chr(78467)
EGYPTIAN_HIEROGLYPH_O035 = chr(78468)
EGYPTIAN_HIEROGLYPH_O036 = chr(78469)
EGYPTIAN_HIEROGLYPH_O036A = chr(78470)
EGYPTIAN_HIEROGLYPH_O036B = chr(78471)
EGYPTIAN_HIEROGLYPH_O036C = chr(78472)
EGYPTIAN_HIEROGLYPH_O036D = chr(78473)
EGYPTIAN_HIEROGLYPH_O037 = chr(78474)
EGYPTIAN_HIEROGLYPH_O038 = chr(78475)
EGYPTIAN_HIEROGLYPH_O039 = chr(78476)
EGYPTIAN_HIEROGLYPH_O040 = chr(78477)
EGYPTIAN_HIEROGLYPH_O041 = chr(78478)
EGYPTIAN_HIEROGLYPH_O042 = chr(78479)
EGYPTIAN_HIEROGLYPH_O043 = chr(78480)
EGYPTIAN_HIEROGLYPH_O044 = chr(78481)
EGYPTIAN_HIEROGLYPH_O045 = chr(78482)
EGYPTIAN_HIEROGLYPH_O046 = chr(78483)
EGYPTIAN_HIEROGLYPH_O047 = chr(78484)
EGYPTIAN_HIEROGLYPH_O048 = chr(78485)
EGYPTIAN_HIEROGLYPH_O049 = chr(78486)
EGYPTIAN_HIEROGLYPH_O050 = chr(78487)
EGYPTIAN_HIEROGLYPH_O050A = chr(78488)
EGYPTIAN_HIEROGLYPH_O050B = chr(78489)
EGYPTIAN_HIEROGLYPH_O051 = chr(78490)
EGYPTIAN_HIEROGLYPH_P001 = chr(78491)
EGYPTIAN_HIEROGLYPH_P001A = chr(78492)
EGYPTIAN_HIEROGLYPH_P002 = chr(78493)
EGYPTIAN_HIEROGLYPH_P003 = chr(78494)
EGYPTIAN_HIEROGLYPH_P003A = chr(78495)
EGYPTIAN_HIEROGLYPH_P004 = chr(78496)
EGYPTIAN_HIEROGLYPH_P005 = chr(78497)
EGYPTIAN_HIEROGLYPH_P006 = chr(78498)
EGYPTIAN_HIEROGLYPH_P007 = chr(78499)
EGYPTIAN_HIEROGLYPH_P008 = chr(78500)
EGYPTIAN_HIEROGLYPH_P009 = chr(78501)
EGYPTIAN_HIEROGLYPH_P010 = chr(78502)
EGYPTIAN_HIEROGLYPH_P011 = chr(78503)
EGYPTIAN_HIEROGLYPH_Q001 = chr(78504)
EGYPTIAN_HIEROGLYPH_Q002 = chr(78505)
EGYPTIAN_HIEROGLYPH_Q003 = chr(78506)
EGYPTIAN_HIEROGLYPH_Q004 = chr(78507)
EGYPTIAN_HIEROGLYPH_Q005 = chr(78508)
EGYPTIAN_HIEROGLYPH_Q006 = chr(78509)
EGYPTIAN_HIEROGLYPH_Q007 = chr(78510)
EGYPTIAN_HIEROGLYPH_R001 = chr(78511)
EGYPTIAN_HIEROGLYPH_R002 = chr(78512)
EGYPTIAN_HIEROGLYPH_R002A = chr(78513)
EGYPTIAN_HIEROGLYPH_R003 = chr(78514)
EGYPTIAN_HIEROGLYPH_R003A = chr(78515)
EGYPTIAN_HIEROGLYPH_R003B = chr(78516)
EGYPTIAN_HIEROGLYPH_R004 = chr(78517)
EGYPTIAN_HIEROGLYPH_R005 = chr(78518)
EGYPTIAN_HIEROGLYPH_R006 = chr(78519)
EGYPTIAN_HIEROGLYPH_R007 = chr(78520)
EGYPTIAN_HIEROGLYPH_R008 = chr(78521)
EGYPTIAN_HIEROGLYPH_R009 = chr(78522)
EGYPTIAN_HIEROGLYPH_R010 = chr(78523)
EGYPTIAN_HIEROGLYPH_R010A = chr(78524)
EGYPTIAN_HIEROGLYPH_R011 = chr(78525)
EGYPTIAN_HIEROGLYPH_R012 = chr(78526)
EGYPTIAN_HIEROGLYPH_R013 = chr(78527)
EGYPTIAN_HIEROGLYPH_R014 = chr(78528)
EGYPTIAN_HIEROGLYPH_R015 = chr(78529)
EGYPTIAN_HIEROGLYPH_R016 = chr(78530)
EGYPTIAN_HIEROGLYPH_R016A = chr(78531)
EGYPTIAN_HIEROGLYPH_R017 = chr(78532)
EGYPTIAN_HIEROGLYPH_R018 = chr(78533)
EGYPTIAN_HIEROGLYPH_R019 = chr(78534)
EGYPTIAN_HIEROGLYPH_R020 = chr(78535)
EGYPTIAN_HIEROGLYPH_R021 = chr(78536)
EGYPTIAN_HIEROGLYPH_R022 = chr(78537)
EGYPTIAN_HIEROGLYPH_R023 = chr(78538)
EGYPTIAN_HIEROGLYPH_R024 = chr(78539)
EGYPTIAN_HIEROGLYPH_R025 = chr(78540)
EGYPTIAN_HIEROGLYPH_R026 = chr(78541)
EGYPTIAN_HIEROGLYPH_R027 = chr(78542)
EGYPTIAN_HIEROGLYPH_R028 = chr(78543)
EGYPTIAN_HIEROGLYPH_R029 = chr(78544)
EGYPTIAN_HIEROGLYPH_S001 = chr(78545)
EGYPTIAN_HIEROGLYPH_S002 = chr(78546)
EGYPTIAN_HIEROGLYPH_S002A = chr(78547)
EGYPTIAN_HIEROGLYPH_S003 = chr(78548)
EGYPTIAN_HIEROGLYPH_S004 = chr(78549)
EGYPTIAN_HIEROGLYPH_S005 = chr(78550)
EGYPTIAN_HIEROGLYPH_S006 = chr(78551)
EGYPTIAN_HIEROGLYPH_S006A = chr(78552)
EGYPTIAN_HIEROGLYPH_S007 = chr(78553)
EGYPTIAN_HIEROGLYPH_S008 = chr(78554)
EGYPTIAN_HIEROGLYPH_S009 = chr(78555)
EGYPTIAN_HIEROGLYPH_S010 = chr(78556)
EGYPTIAN_HIEROGLYPH_S011 = chr(78557)
EGYPTIAN_HIEROGLYPH_S012 = chr(78558)
EGYPTIAN_HIEROGLYPH_S013 = chr(78559)
EGYPTIAN_HIEROGLYPH_S014 = chr(78560)
EGYPTIAN_HIEROGLYPH_S014A = chr(78561)
EGYPTIAN_HIEROGLYPH_S014B = chr(78562)
EGYPTIAN_HIEROGLYPH_S015 = chr(78563)
EGYPTIAN_HIEROGLYPH_S016 = chr(78564)
EGYPTIAN_HIEROGLYPH_S017 = chr(78565)
EGYPTIAN_HIEROGLYPH_S017A = chr(78566)
EGYPTIAN_HIEROGLYPH_S018 = chr(78567)
EGYPTIAN_HIEROGLYPH_S019 = chr(78568)
EGYPTIAN_HIEROGLYPH_S020 = chr(78569)
EGYPTIAN_HIEROGLYPH_S021 = chr(78570)
EGYPTIAN_HIEROGLYPH_S022 = chr(78571)
EGYPTIAN_HIEROGLYPH_S023 = chr(78572)
EGYPTIAN_HIEROGLYPH_S024 = chr(78573)
EGYPTIAN_HIEROGLYPH_S025 = chr(78574)
EGYPTIAN_HIEROGLYPH_S026 = chr(78575)
EGYPTIAN_HIEROGLYPH_S026A = chr(78576)
EGYPTIAN_HIEROGLYPH_S026B = chr(78577)
EGYPTIAN_HIEROGLYPH_S027 = chr(78578)
EGYPTIAN_HIEROGLYPH_S028 = chr(78579)
EGYPTIAN_HIEROGLYPH_S029 = chr(78580)
EGYPTIAN_HIEROGLYPH_S030 = chr(78581)
EGYPTIAN_HIEROGLYPH_S031 = chr(78582)
EGYPTIAN_HIEROGLYPH_S032 = chr(78583)
EGYPTIAN_HIEROGLYPH_S033 = chr(78584)
EGYPTIAN_HIEROGLYPH_S034 = chr(78585)
EGYPTIAN_HIEROGLYPH_S035 = chr(78586)
EGYPTIAN_HIEROGLYPH_S035A = chr(78587)
EGYPTIAN_HIEROGLYPH_S036 = chr(78588)
EGYPTIAN_HIEROGLYPH_S037 = chr(78589)
EGYPTIAN_HIEROGLYPH_S038 = chr(78590)
EGYPTIAN_HIEROGLYPH_S039 = chr(78591)
EGYPTIAN_HIEROGLYPH_S040 = chr(78592)
EGYPTIAN_HIEROGLYPH_S041 = chr(78593)
EGYPTIAN_HIEROGLYPH_S042 = chr(78594)
EGYPTIAN_HIEROGLYPH_S043 = chr(78595)
EGYPTIAN_HIEROGLYPH_S044 = chr(78596)
EGYPTIAN_HIEROGLYPH_S045 = chr(78597)
EGYPTIAN_HIEROGLYPH_S046 = chr(78598)
EGYPTIAN_HIEROGLYPH_T001 = chr(78599)
EGYPTIAN_HIEROGLYPH_T002 = chr(78600)
EGYPTIAN_HIEROGLYPH_T003 = chr(78601)
EGYPTIAN_HIEROGLYPH_T003A = chr(78602)
EGYPTIAN_HIEROGLYPH_T004 = chr(78603)
EGYPTIAN_HIEROGLYPH_T005 = chr(78604)
EGYPTIAN_HIEROGLYPH_T006 = chr(78605)
EGYPTIAN_HIEROGLYPH_T007 = chr(78606)
EGYPTIAN_HIEROGLYPH_T007A = chr(78607)
EGYPTIAN_HIEROGLYPH_T008 = chr(78608)
EGYPTIAN_HIEROGLYPH_T008A = chr(78609)
EGYPTIAN_HIEROGLYPH_T009 = chr(78610)
EGYPTIAN_HIEROGLYPH_T009A = chr(78611)
EGYPTIAN_HIEROGLYPH_T010 = chr(78612)
EGYPTIAN_HIEROGLYPH_T011 = chr(78613)
EGYPTIAN_HIEROGLYPH_T011A = chr(78614)
EGYPTIAN_HIEROGLYPH_T012 = chr(78615)
EGYPTIAN_HIEROGLYPH_T013 = chr(78616)
EGYPTIAN_HIEROGLYPH_T014 = chr(78617)
EGYPTIAN_HIEROGLYPH_T015 = chr(78618)
EGYPTIAN_HIEROGLYPH_T016 = chr(78619)
EGYPTIAN_HIEROGLYPH_T016A = chr(78620)
EGYPTIAN_HIEROGLYPH_T017 = chr(78621)
EGYPTIAN_HIEROGLYPH_T018 = chr(78622)
EGYPTIAN_HIEROGLYPH_T019 = chr(78623)
EGYPTIAN_HIEROGLYPH_T020 = chr(78624)
EGYPTIAN_HIEROGLYPH_T021 = chr(78625)
EGYPTIAN_HIEROGLYPH_T022 = chr(78626)
EGYPTIAN_HIEROGLYPH_T023 = chr(78627)
EGYPTIAN_HIEROGLYPH_T024 = chr(78628)
EGYPTIAN_HIEROGLYPH_T025 = chr(78629)
EGYPTIAN_HIEROGLYPH_T026 = chr(78630)
EGYPTIAN_HIEROGLYPH_T027 = chr(78631)
EGYPTIAN_HIEROGLYPH_T028 = chr(78632)
EGYPTIAN_HIEROGLYPH_T029 = chr(78633)
EGYPTIAN_HIEROGLYPH_T030 = chr(78634)
EGYPTIAN_HIEROGLYPH_T031 = chr(78635)
EGYPTIAN_HIEROGLYPH_T032 = chr(78636)
EGYPTIAN_HIEROGLYPH_T032A = chr(78637)
EGYPTIAN_HIEROGLYPH_T033 = chr(78638)
EGYPTIAN_HIEROGLYPH_T033A = chr(78639)
EGYPTIAN_HIEROGLYPH_T034 = chr(78640)
EGYPTIAN_HIEROGLYPH_T035 = chr(78641)
EGYPTIAN_HIEROGLYPH_T036 = chr(78642)
EGYPTIAN_HIEROGLYPH_U001 = chr(78643)
EGYPTIAN_HIEROGLYPH_U002 = chr(78644)
EGYPTIAN_HIEROGLYPH_U003 = chr(78645)
EGYPTIAN_HIEROGLYPH_U004 = chr(78646)
EGYPTIAN_HIEROGLYPH_U005 = chr(78647)
EGYPTIAN_HIEROGLYPH_U006 = chr(78648)
EGYPTIAN_HIEROGLYPH_U006A = chr(78649)
EGYPTIAN_HIEROGLYPH_U006B = chr(78650)
EGYPTIAN_HIEROGLYPH_U007 = chr(78651)
EGYPTIAN_HIEROGLYPH_U008 = chr(78652)
EGYPTIAN_HIEROGLYPH_U009 = chr(78653)
EGYPTIAN_HIEROGLYPH_U010 = chr(78654)
EGYPTIAN_HIEROGLYPH_U011 = chr(78655)
EGYPTIAN_HIEROGLYPH_U012 = chr(78656)
EGYPTIAN_HIEROGLYPH_U013 = chr(78657)
EGYPTIAN_HIEROGLYPH_U014 = chr(78658)
EGYPTIAN_HIEROGLYPH_U015 = chr(78659)
EGYPTIAN_HIEROGLYPH_U016 = chr(78660)
EGYPTIAN_HIEROGLYPH_U017 = chr(78661)
EGYPTIAN_HIEROGLYPH_U018 = chr(78662)
EGYPTIAN_HIEROGLYPH_U019 = chr(78663)
EGYPTIAN_HIEROGLYPH_U020 = chr(78664)
EGYPTIAN_HIEROGLYPH_U021 = chr(78665)
EGYPTIAN_HIEROGLYPH_U022 = chr(78666)
EGYPTIAN_HIEROGLYPH_U023 = chr(78667)
EGYPTIAN_HIEROGLYPH_U023A = chr(78668)
EGYPTIAN_HIEROGLYPH_U024 = chr(78669)
EGYPTIAN_HIEROGLYPH_U025 = chr(78670)
EGYPTIAN_HIEROGLYPH_U026 = chr(78671)
EGYPTIAN_HIEROGLYPH_U027 = chr(78672)
EGYPTIAN_HIEROGLYPH_U028 = chr(78673)
EGYPTIAN_HIEROGLYPH_U029 = chr(78674)
EGYPTIAN_HIEROGLYPH_U029A = chr(78675)
EGYPTIAN_HIEROGLYPH_U030 = chr(78676)
EGYPTIAN_HIEROGLYPH_U031 = chr(78677)
EGYPTIAN_HIEROGLYPH_U032 = chr(78678)
EGYPTIAN_HIEROGLYPH_U032A = chr(78679)
EGYPTIAN_HIEROGLYPH_U033 = chr(78680)
EGYPTIAN_HIEROGLYPH_U034 = chr(78681)
EGYPTIAN_HIEROGLYPH_U035 = chr(78682)
EGYPTIAN_HIEROGLYPH_U036 = chr(78683)
EGYPTIAN_HIEROGLYPH_U037 = chr(78684)
EGYPTIAN_HIEROGLYPH_U038 = chr(78685)
EGYPTIAN_HIEROGLYPH_U039 = chr(78686)
EGYPTIAN_HIEROGLYPH_U040 = chr(78687)
EGYPTIAN_HIEROGLYPH_U041 = chr(78688)
EGYPTIAN_HIEROGLYPH_U042 = chr(78689)
EGYPTIAN_HIEROGLYPH_V001 = chr(78690)
EGYPTIAN_HIEROGLYPH_V001A = chr(78691)
EGYPTIAN_HIEROGLYPH_V001B = chr(78692)
EGYPTIAN_HIEROGLYPH_V001C = chr(78693)
EGYPTIAN_HIEROGLYPH_V001D = chr(78694)
EGYPTIAN_HIEROGLYPH_V001E = chr(78695)
EGYPTIAN_HIEROGLYPH_V001F = chr(78696)
EGYPTIAN_HIEROGLYPH_V001G = chr(78697)
EGYPTIAN_HIEROGLYPH_V001H = chr(78698)
EGYPTIAN_HIEROGLYPH_V001I = chr(78699)
EGYPTIAN_HIEROGLYPH_V002 = chr(78700)
EGYPTIAN_HIEROGLYPH_V002A = chr(78701)
EGYPTIAN_HIEROGLYPH_V003 = chr(78702)
EGYPTIAN_HIEROGLYPH_V004 = chr(78703)
EGYPTIAN_HIEROGLYPH_V005 = chr(78704)
EGYPTIAN_HIEROGLYPH_V006 = chr(78705)
EGYPTIAN_HIEROGLYPH_V007 = chr(78706)
EGYPTIAN_HIEROGLYPH_V007A = chr(78707)
EGYPTIAN_HIEROGLYPH_V007B = chr(78708)
EGYPTIAN_HIEROGLYPH_V008 = chr(78709)
EGYPTIAN_HIEROGLYPH_V009 = chr(78710)
EGYPTIAN_HIEROGLYPH_V010 = chr(78711)
EGYPTIAN_HIEROGLYPH_V011 = chr(78712)
EGYPTIAN_HIEROGLYPH_V011A = chr(78713)
EGYPTIAN_HIEROGLYPH_V011B = chr(78714)
EGYPTIAN_HIEROGLYPH_V011C = chr(78715)
EGYPTIAN_HIEROGLYPH_V012 = chr(78716)
EGYPTIAN_HIEROGLYPH_V012A = chr(78717)
EGYPTIAN_HIEROGLYPH_V012B = chr(78718)
EGYPTIAN_HIEROGLYPH_V013 = chr(78719)
EGYPTIAN_HIEROGLYPH_V014 = chr(78720)
EGYPTIAN_HIEROGLYPH_V015 = chr(78721)
EGYPTIAN_HIEROGLYPH_V016 = chr(78722)
EGYPTIAN_HIEROGLYPH_V017 = chr(78723)
EGYPTIAN_HIEROGLYPH_V018 = chr(78724)
EGYPTIAN_HIEROGLYPH_V019 = chr(78725)
EGYPTIAN_HIEROGLYPH_V020 = chr(78726)
EGYPTIAN_HIEROGLYPH_V020A = chr(78727)
EGYPTIAN_HIEROGLYPH_V020B = chr(78728)
EGYPTIAN_HIEROGLYPH_V020C = chr(78729)
EGYPTIAN_HIEROGLYPH_V020D = chr(78730)
EGYPTIAN_HIEROGLYPH_V020E = chr(78731)
EGYPTIAN_HIEROGLYPH_V020F = chr(78732)
EGYPTIAN_HIEROGLYPH_V020G = chr(78733)
EGYPTIAN_HIEROGLYPH_V020H = chr(78734)
EGYPTIAN_HIEROGLYPH_V020I = chr(78735)
EGYPTIAN_HIEROGLYPH_V020J = chr(78736)
EGYPTIAN_HIEROGLYPH_V020K = chr(78737)
EGYPTIAN_HIEROGLYPH_V020L = chr(78738)
EGYPTIAN_HIEROGLYPH_V021 = chr(78739)
EGYPTIAN_HIEROGLYPH_V022 = chr(78740)
EGYPTIAN_HIEROGLYPH_V023 = chr(78741)
EGYPTIAN_HIEROGLYPH_V023A = chr(78742)
EGYPTIAN_HIEROGLYPH_V024 = chr(78743)
EGYPTIAN_HIEROGLYPH_V025 = chr(78744)
EGYPTIAN_HIEROGLYPH_V026 = chr(78745)
EGYPTIAN_HIEROGLYPH_V027 = chr(78746)
EGYPTIAN_HIEROGLYPH_V028 = chr(78747)
EGYPTIAN_HIEROGLYPH_V028A = chr(78748)
EGYPTIAN_HIEROGLYPH_V029 = chr(78749)
EGYPTIAN_HIEROGLYPH_V029A = chr(78750)
EGYPTIAN_HIEROGLYPH_V030 = chr(78751)
EGYPTIAN_HIEROGLYPH_V030A = chr(78752)
EGYPTIAN_HIEROGLYPH_V031 = chr(78753)
EGYPTIAN_HIEROGLYPH_V031A = chr(78754)
EGYPTIAN_HIEROGLYPH_V032 = chr(78755)
EGYPTIAN_HIEROGLYPH_V033 = chr(78756)
EGYPTIAN_HIEROGLYPH_V033A = chr(78757)
EGYPTIAN_HIEROGLYPH_V034 = chr(78758)
EGYPTIAN_HIEROGLYPH_V035 = chr(78759)
EGYPTIAN_HIEROGLYPH_V036 = chr(78760)
EGYPTIAN_HIEROGLYPH_V037 = chr(78761)
EGYPTIAN_HIEROGLYPH_V037A = chr(78762)
EGYPTIAN_HIEROGLYPH_V038 = chr(78763)
EGYPTIAN_HIEROGLYPH_V039 = chr(78764)
EGYPTIAN_HIEROGLYPH_V040 = chr(78765)
EGYPTIAN_HIEROGLYPH_V040A = chr(78766)
EGYPTIAN_HIEROGLYPH_W001 = chr(78767)
EGYPTIAN_HIEROGLYPH_W002 = chr(78768)
EGYPTIAN_HIEROGLYPH_W003 = chr(78769)
EGYPTIAN_HIEROGLYPH_W003A = chr(78770)
EGYPTIAN_HIEROGLYPH_W004 = chr(78771)
EGYPTIAN_HIEROGLYPH_W005 = chr(78772)
EGYPTIAN_HIEROGLYPH_W006 = chr(78773)
EGYPTIAN_HIEROGLYPH_W007 = chr(78774)
EGYPTIAN_HIEROGLYPH_W008 = chr(78775)
EGYPTIAN_HIEROGLYPH_W009 = chr(78776)
EGYPTIAN_HIEROGLYPH_W009A = chr(78777)
EGYPTIAN_HIEROGLYPH_W010 = chr(78778)
EGYPTIAN_HIEROGLYPH_W010A = chr(78779)
EGYPTIAN_HIEROGLYPH_W011 = chr(78780)
EGYPTIAN_HIEROGLYPH_W012 = chr(78781)
EGYPTIAN_HIEROGLYPH_W013 = chr(78782)
EGYPTIAN_HIEROGLYPH_W014 = chr(78783)
EGYPTIAN_HIEROGLYPH_W014A = chr(78784)
EGYPTIAN_HIEROGLYPH_W015 = chr(78785)
EGYPTIAN_HIEROGLYPH_W016 = chr(78786)
EGYPTIAN_HIEROGLYPH_W017 = chr(78787)
EGYPTIAN_HIEROGLYPH_W017A = chr(78788)
EGYPTIAN_HIEROGLYPH_W018 = chr(78789)
EGYPTIAN_HIEROGLYPH_W018A = chr(78790)
EGYPTIAN_HIEROGLYPH_W019 = chr(78791)
EGYPTIAN_HIEROGLYPH_W020 = chr(78792)
EGYPTIAN_HIEROGLYPH_W021 = chr(78793)
EGYPTIAN_HIEROGLYPH_W022 = chr(78794)
EGYPTIAN_HIEROGLYPH_W023 = chr(78795)
EGYPTIAN_HIEROGLYPH_W024 = chr(78796)
EGYPTIAN_HIEROGLYPH_W024A = chr(78797)
EGYPTIAN_HIEROGLYPH_W025 = chr(78798)
EGYPTIAN_HIEROGLYPH_X001 = chr(78799)
EGYPTIAN_HIEROGLYPH_X002 = chr(78800)
EGYPTIAN_HIEROGLYPH_X003 = chr(78801)
EGYPTIAN_HIEROGLYPH_X004 = chr(78802)
EGYPTIAN_HIEROGLYPH_X004A = chr(78803)
EGYPTIAN_HIEROGLYPH_X004B = chr(78804)
EGYPTIAN_HIEROGLYPH_X005 = chr(78805)
EGYPTIAN_HIEROGLYPH_X006 = chr(78806)
EGYPTIAN_HIEROGLYPH_X006A = chr(78807)
EGYPTIAN_HIEROGLYPH_X007 = chr(78808)
EGYPTIAN_HIEROGLYPH_X008 = chr(78809)
EGYPTIAN_HIEROGLYPH_X008A = chr(78810)
EGYPTIAN_HIEROGLYPH_Y001 = chr(78811)
EGYPTIAN_HIEROGLYPH_Y001A = chr(78812)
EGYPTIAN_HIEROGLYPH_Y002 = chr(78813)
EGYPTIAN_HIEROGLYPH_Y003 = chr(78814)
EGYPTIAN_HIEROGLYPH_Y004 = chr(78815)
EGYPTIAN_HIEROGLYPH_Y005 = chr(78816)
EGYPTIAN_HIEROGLYPH_Y006 = chr(78817)
EGYPTIAN_HIEROGLYPH_Y007 = chr(78818)
EGYPTIAN_HIEROGLYPH_Y008 = chr(78819)
EGYPTIAN_HIEROGLYPH_Z001 = chr(78820)
EGYPTIAN_HIEROGLYPH_Z002 = chr(78821)
EGYPTIAN_HIEROGLYPH_Z002A = chr(78822)
EGYPTIAN_HIEROGLYPH_Z002B = chr(78823)
EGYPTIAN_HIEROGLYPH_Z002C = chr(78824)
EGYPTIAN_HIEROGLYPH_Z002D = chr(78825)
EGYPTIAN_HIEROGLYPH_Z003 = chr(78826)
EGYPTIAN_HIEROGLYPH_Z003A = chr(78827)
EGYPTIAN_HIEROGLYPH_Z003B = chr(78828)
EGYPTIAN_HIEROGLYPH_Z004 = chr(78829)
EGYPTIAN_HIEROGLYPH_Z004A = chr(78830)
EGYPTIAN_HIEROGLYPH_Z005 = chr(78831)
EGYPTIAN_HIEROGLYPH_Z005A = chr(78832)
EGYPTIAN_HIEROGLYPH_Z006 = chr(78833)
EGYPTIAN_HIEROGLYPH_Z007 = chr(78834)
EGYPTIAN_HIEROGLYPH_Z008 = chr(78835)
EGYPTIAN_HIEROGLYPH_Z009 = chr(78836)
EGYPTIAN_HIEROGLYPH_Z010 = chr(78837)
EGYPTIAN_HIEROGLYPH_Z011 = chr(78838)
EGYPTIAN_HIEROGLYPH_Z012 = chr(78839)
EGYPTIAN_HIEROGLYPH_Z013 = chr(78840)
EGYPTIAN_HIEROGLYPH_Z014 = chr(78841)
EGYPTIAN_HIEROGLYPH_Z015 = chr(78842)
EGYPTIAN_HIEROGLYPH_Z015A = chr(78843)
EGYPTIAN_HIEROGLYPH_Z015B = chr(78844)
EGYPTIAN_HIEROGLYPH_Z015C = chr(78845)
EGYPTIAN_HIEROGLYPH_Z015D = chr(78846)
EGYPTIAN_HIEROGLYPH_Z015E = chr(78847)
EGYPTIAN_HIEROGLYPH_Z015F = chr(78848)
EGYPTIAN_HIEROGLYPH_Z015G = chr(78849)
EGYPTIAN_HIEROGLYPH_Z015H = chr(78850)
EGYPTIAN_HIEROGLYPH_Z015I = chr(78851)
EGYPTIAN_HIEROGLYPH_Z016 = chr(78852)
EGYPTIAN_HIEROGLYPH_Z016A = chr(78853)
EGYPTIAN_HIEROGLYPH_Z016B = chr(78854)
EGYPTIAN_HIEROGLYPH_Z016C = chr(78855)
EGYPTIAN_HIEROGLYPH_Z016D = chr(78856)
EGYPTIAN_HIEROGLYPH_Z016E = chr(78857)
EGYPTIAN_HIEROGLYPH_Z016F = chr(78858)
EGYPTIAN_HIEROGLYPH_Z016G = chr(78859)
EGYPTIAN_HIEROGLYPH_Z016H = chr(78860)
EGYPTIAN_HIEROGLYPH_AA001 = chr(78861)
EGYPTIAN_HIEROGLYPH_AA002 = chr(78862)
EGYPTIAN_HIEROGLYPH_AA003 = chr(78863)
EGYPTIAN_HIEROGLYPH_AA004 = chr(78864)
EGYPTIAN_HIEROGLYPH_AA005 = chr(78865)
EGYPTIAN_HIEROGLYPH_AA006 = chr(78866)
EGYPTIAN_HIEROGLYPH_AA007 = chr(78867)
EGYPTIAN_HIEROGLYPH_AA007A = chr(78868)
EGYPTIAN_HIEROGLYPH_AA007B = chr(78869)
EGYPTIAN_HIEROGLYPH_AA008 = chr(78870)
EGYPTIAN_HIEROGLYPH_AA009 = chr(78871)
EGYPTIAN_HIEROGLYPH_AA010 = chr(78872)
EGYPTIAN_HIEROGLYPH_AA011 = chr(78873)
EGYPTIAN_HIEROGLYPH_AA012 = chr(78874)
EGYPTIAN_HIEROGLYPH_AA013 = chr(78875)
EGYPTIAN_HIEROGLYPH_AA014 = chr(78876)
EGYPTIAN_HIEROGLYPH_AA015 = chr(78877)
EGYPTIAN_HIEROGLYPH_AA016 = chr(78878)
EGYPTIAN_HIEROGLYPH_AA017 = chr(78879)
EGYPTIAN_HIEROGLYPH_AA018 = chr(78880)
EGYPTIAN_HIEROGLYPH_AA019 = chr(78881)
EGYPTIAN_HIEROGLYPH_AA020 = chr(78882)
EGYPTIAN_HIEROGLYPH_AA021 = chr(78883)
EGYPTIAN_HIEROGLYPH_AA022 = chr(78884)
EGYPTIAN_HIEROGLYPH_AA023 = chr(78885)
EGYPTIAN_HIEROGLYPH_AA024 = chr(78886)
EGYPTIAN_HIEROGLYPH_AA025 = chr(78887)
EGYPTIAN_HIEROGLYPH_AA026 = chr(78888)
EGYPTIAN_HIEROGLYPH_AA027 = chr(78889)
EGYPTIAN_HIEROGLYPH_AA028 = chr(78890)
EGYPTIAN_HIEROGLYPH_AA029 = chr(78891)
EGYPTIAN_HIEROGLYPH_AA030 = chr(78892)
EGYPTIAN_HIEROGLYPH_AA031 = chr(78893)
EGYPTIAN_HIEROGLYPH_AA032 = chr(78894)
EGYPTIAN_HIEROGLYPH_V011D = chr(78895)
EGYPTIAN_HIEROGLYPH_VERTICAL_JOINER = chr(78896)
EGYPTIAN_HIEROGLYPH_HORIZONTAL_JOINER = chr(78897)
EGYPTIAN_HIEROGLYPH_INSERT_AT_TOP_START = chr(78898)
EGYPTIAN_HIEROGLYPH_INSERT_AT_BOTTOM_START = chr(78899)
EGYPTIAN_HIEROGLYPH_INSERT_AT_TOP_END = chr(78900)
EGYPTIAN_HIEROGLYPH_INSERT_AT_BOTTOM_END = chr(78901)
EGYPTIAN_HIEROGLYPH_OVERLAY_MIDDLE = chr(78902)
EGYPTIAN_HIEROGLYPH_BEGIN_SEGMENT = chr(78903)
EGYPTIAN_HIEROGLYPH_END_SEGMENT = chr(78904)
EGYPTIAN_HIEROGLYPH_INSERT_AT_MIDDLE = chr(78905)
EGYPTIAN_HIEROGLYPH_INSERT_AT_TOP = chr(78906)
EGYPTIAN_HIEROGLYPH_INSERT_AT_BOTTOM = chr(78907)
EGYPTIAN_HIEROGLYPH_BEGIN_ENCLOSURE = chr(78908)
EGYPTIAN_HIEROGLYPH_END_ENCLOSURE = chr(78909)
EGYPTIAN_HIEROGLYPH_BEGIN_WALLED_ENCLOSURE = chr(78910)
EGYPTIAN_HIEROGLYPH_END_WALLED_ENCLOSURE = chr(78911)
EGYPTIAN_HIEROGLYPH_MIRROR_HORIZONTALLY = chr(78912)
EGYPTIAN_HIEROGLYPH_FULL_BLANK = chr(78913)
EGYPTIAN_HIEROGLYPH_HALF_BLANK = chr(78914)
EGYPTIAN_HIEROGLYPH_LOST_SIGN = chr(78915)
EGYPTIAN_HIEROGLYPH_HALF_LOST_SIGN = chr(78916)
EGYPTIAN_HIEROGLYPH_TALL_LOST_SIGN = chr(78917)
EGYPTIAN_HIEROGLYPH_WIDE_LOST_SIGN = chr(78918)
EGYPTIAN_HIEROGLYPH_MODIFIER_DAMAGED_AT_TOP_START = chr(78919)
EGYPTIAN_HIEROGLYPH_MODIFIER_DAMAGED_AT_BOTTOM_START = chr(78920)
EGYPTIAN_HIEROGLYPH_MODIFIER_DAMAGED_AT_START = chr(78921)
EGYPTIAN_HIEROGLYPH_MODIFIER_DAMAGED_AT_TOP_END = chr(78922)
EGYPTIAN_HIEROGLYPH_MODIFIER_DAMAGED_AT_TOP = chr(78923)
EGYPTIAN_HIEROGLYPH_MODIFIER_DAMAGED_AT_BOTTOM_START_AND_TOP_END = chr(78924)
EGYPTIAN_HIEROGLYPH_MODIFIER_DAMAGED_AT_START_AND_TOP = chr(78925)
EGYPTIAN_HIEROGLYPH_MODIFIER_DAMAGED_AT_BOTTOM_END = chr(78926)
EGYPTIAN_HIEROGLYPH_MODIFIER_DAMAGED_AT_TOP_START_AND_BOTTOM_END = chr(78927)
EGYPTIAN_HIEROGLYPH_MODIFIER_DAMAGED_AT_BOTTOM = chr(78928)
EGYPTIAN_HIEROGLYPH_MODIFIER_DAMAGED_AT_START_AND_BOTTOM = chr(78929)
EGYPTIAN_HIEROGLYPH_MODIFIER_DAMAGED_AT_END = chr(78930)
EGYPTIAN_HIEROGLYPH_MODIFIER_DAMAGED_AT_TOP_AND_END = chr(78931)
EGYPTIAN_HIEROGLYPH_MODIFIER_DAMAGED_AT_BOTTOM_AND_END = chr(78932)
EGYPTIAN_HIEROGLYPH_MODIFIER_DAMAGED = chr(78933)
ANATOLIAN_HIEROGLYPH_A001 = chr(82944)
ANATOLIAN_HIEROGLYPH_A002 = chr(82945)
ANATOLIAN_HIEROGLYPH_A003 = chr(82946)
ANATOLIAN_HIEROGLYPH_A004 = chr(82947)
ANATOLIAN_HIEROGLYPH_A005 = chr(82948)
ANATOLIAN_HIEROGLYPH_A006 = chr(82949)
ANATOLIAN_HIEROGLYPH_A007 = chr(82950)
ANATOLIAN_HIEROGLYPH_A008 = chr(82951)
ANATOLIAN_HIEROGLYPH_A009 = chr(82952)
ANATOLIAN_HIEROGLYPH_A010 = chr(82953)
ANATOLIAN_HIEROGLYPH_A010A = chr(82954)
ANATOLIAN_HIEROGLYPH_A011 = chr(82955)
ANATOLIAN_HIEROGLYPH_A012 = chr(82956)
ANATOLIAN_HIEROGLYPH_A013 = chr(82957)
ANATOLIAN_HIEROGLYPH_A014 = chr(82958)
ANATOLIAN_HIEROGLYPH_A015 = chr(82959)
ANATOLIAN_HIEROGLYPH_A016 = chr(82960)
ANATOLIAN_HIEROGLYPH_A017 = chr(82961)
ANATOLIAN_HIEROGLYPH_A018 = chr(82962)
ANATOLIAN_HIEROGLYPH_A019 = chr(82963)
ANATOLIAN_HIEROGLYPH_A020 = chr(82964)
ANATOLIAN_HIEROGLYPH_A021 = chr(82965)
ANATOLIAN_HIEROGLYPH_A022 = chr(82966)
ANATOLIAN_HIEROGLYPH_A023 = chr(82967)
ANATOLIAN_HIEROGLYPH_A024 = chr(82968)
ANATOLIAN_HIEROGLYPH_A025 = chr(82969)
ANATOLIAN_HIEROGLYPH_A026 = chr(82970)
ANATOLIAN_HIEROGLYPH_A026A = chr(82971)
ANATOLIAN_HIEROGLYPH_A027 = chr(82972)
ANATOLIAN_HIEROGLYPH_A028 = chr(82973)
ANATOLIAN_HIEROGLYPH_A029 = chr(82974)
ANATOLIAN_HIEROGLYPH_A030 = chr(82975)
ANATOLIAN_HIEROGLYPH_A031 = chr(82976)
ANATOLIAN_HIEROGLYPH_A032 = chr(82977)
ANATOLIAN_HIEROGLYPH_A033 = chr(82978)
ANATOLIAN_HIEROGLYPH_A034 = chr(82979)
ANATOLIAN_HIEROGLYPH_A035 = chr(82980)
ANATOLIAN_HIEROGLYPH_A036 = chr(82981)
ANATOLIAN_HIEROGLYPH_A037 = chr(82982)
ANATOLIAN_HIEROGLYPH_A038 = chr(82983)
ANATOLIAN_HIEROGLYPH_A039 = chr(82984)
ANATOLIAN_HIEROGLYPH_A039A = chr(82985)
ANATOLIAN_HIEROGLYPH_A040 = chr(82986)
ANATOLIAN_HIEROGLYPH_A041 = chr(82987)
ANATOLIAN_HIEROGLYPH_A041A = chr(82988)
ANATOLIAN_HIEROGLYPH_A042 = chr(82989)
ANATOLIAN_HIEROGLYPH_A043 = chr(82990)
ANATOLIAN_HIEROGLYPH_A044 = chr(82991)
ANATOLIAN_HIEROGLYPH_A045 = chr(82992)
ANATOLIAN_HIEROGLYPH_A045A = chr(82993)
ANATOLIAN_HIEROGLYPH_A046 = chr(82994)
ANATOLIAN_HIEROGLYPH_A046A = chr(82995)
ANATOLIAN_HIEROGLYPH_A046B = chr(82996)
ANATOLIAN_HIEROGLYPH_A047 = chr(82997)
ANATOLIAN_HIEROGLYPH_A048 = chr(82998)
ANATOLIAN_HIEROGLYPH_A049 = chr(82999)
ANATOLIAN_HIEROGLYPH_A050 = chr(83000)
ANATOLIAN_HIEROGLYPH_A051 = chr(83001)
ANATOLIAN_HIEROGLYPH_A052 = chr(83002)
ANATOLIAN_HIEROGLYPH_A053 = chr(83003)
ANATOLIAN_HIEROGLYPH_A054 = chr(83004)
ANATOLIAN_HIEROGLYPH_A055 = chr(83005)
ANATOLIAN_HIEROGLYPH_A056 = chr(83006)
ANATOLIAN_HIEROGLYPH_A057 = chr(83007)
ANATOLIAN_HIEROGLYPH_A058 = chr(83008)
ANATOLIAN_HIEROGLYPH_A059 = chr(83009)
ANATOLIAN_HIEROGLYPH_A060 = chr(83010)
ANATOLIAN_HIEROGLYPH_A061 = chr(83011)
ANATOLIAN_HIEROGLYPH_A062 = chr(83012)
ANATOLIAN_HIEROGLYPH_A063 = chr(83013)
ANATOLIAN_HIEROGLYPH_A064 = chr(83014)
ANATOLIAN_HIEROGLYPH_A065 = chr(83015)
ANATOLIAN_HIEROGLYPH_A066 = chr(83016)
ANATOLIAN_HIEROGLYPH_A066A = chr(83017)
ANATOLIAN_HIEROGLYPH_A066B = chr(83018)
ANATOLIAN_HIEROGLYPH_A066C = chr(83019)
ANATOLIAN_HIEROGLYPH_A067 = chr(83020)
ANATOLIAN_HIEROGLYPH_A068 = chr(83021)
ANATOLIAN_HIEROGLYPH_A069 = chr(83022)
ANATOLIAN_HIEROGLYPH_A070 = chr(83023)
ANATOLIAN_HIEROGLYPH_A071 = chr(83024)
ANATOLIAN_HIEROGLYPH_A072 = chr(83025)
ANATOLIAN_HIEROGLYPH_A073 = chr(83026)
ANATOLIAN_HIEROGLYPH_A074 = chr(83027)
ANATOLIAN_HIEROGLYPH_A075 = chr(83028)
ANATOLIAN_HIEROGLYPH_A076 = chr(83029)
ANATOLIAN_HIEROGLYPH_A077 = chr(83030)
ANATOLIAN_HIEROGLYPH_A078 = chr(83031)
ANATOLIAN_HIEROGLYPH_A079 = chr(83032)
ANATOLIAN_HIEROGLYPH_A080 = chr(83033)
ANATOLIAN_HIEROGLYPH_A081 = chr(83034)
ANATOLIAN_HIEROGLYPH_A082 = chr(83035)
ANATOLIAN_HIEROGLYPH_A083 = chr(83036)
ANATOLIAN_HIEROGLYPH_A084 = chr(83037)
ANATOLIAN_HIEROGLYPH_A085 = chr(83038)
ANATOLIAN_HIEROGLYPH_A086 = chr(83039)
ANATOLIAN_HIEROGLYPH_A087 = chr(83040)
ANATOLIAN_HIEROGLYPH_A088 = chr(83041)
ANATOLIAN_HIEROGLYPH_A089 = chr(83042)
ANATOLIAN_HIEROGLYPH_A090 = chr(83043)
ANATOLIAN_HIEROGLYPH_A091 = chr(83044)
ANATOLIAN_HIEROGLYPH_A092 = chr(83045)
ANATOLIAN_HIEROGLYPH_A093 = chr(83046)
ANATOLIAN_HIEROGLYPH_A094 = chr(83047)
ANATOLIAN_HIEROGLYPH_A095 = chr(83048)
ANATOLIAN_HIEROGLYPH_A096 = chr(83049)
ANATOLIAN_HIEROGLYPH_A097 = chr(83050)
ANATOLIAN_HIEROGLYPH_A097A = chr(83051)
ANATOLIAN_HIEROGLYPH_A098 = chr(83052)
ANATOLIAN_HIEROGLYPH_A098A = chr(83053)
ANATOLIAN_HIEROGLYPH_A099 = chr(83054)
ANATOLIAN_HIEROGLYPH_A100 = chr(83055)
ANATOLIAN_HIEROGLYPH_A100A = chr(83056)
ANATOLIAN_HIEROGLYPH_A101 = chr(83057)
ANATOLIAN_HIEROGLYPH_A101A = chr(83058)
ANATOLIAN_HIEROGLYPH_A102 = chr(83059)
ANATOLIAN_HIEROGLYPH_A102A = chr(83060)
ANATOLIAN_HIEROGLYPH_A103 = chr(83061)
ANATOLIAN_HIEROGLYPH_A104 = chr(83062)
ANATOLIAN_HIEROGLYPH_A104A = chr(83063)
ANATOLIAN_HIEROGLYPH_A104B = chr(83064)
ANATOLIAN_HIEROGLYPH_A104C = chr(83065)
ANATOLIAN_HIEROGLYPH_A105 = chr(83066)
ANATOLIAN_HIEROGLYPH_A105A = chr(83067)
ANATOLIAN_HIEROGLYPH_A105B = chr(83068)
ANATOLIAN_HIEROGLYPH_A106 = chr(83069)
ANATOLIAN_HIEROGLYPH_A107 = chr(83070)
ANATOLIAN_HIEROGLYPH_A107A = chr(83071)
ANATOLIAN_HIEROGLYPH_A107B = chr(83072)
ANATOLIAN_HIEROGLYPH_A107C = chr(83073)
ANATOLIAN_HIEROGLYPH_A108 = chr(83074)
ANATOLIAN_HIEROGLYPH_A109 = chr(83075)
ANATOLIAN_HIEROGLYPH_A110 = chr(83076)
ANATOLIAN_HIEROGLYPH_A110A = chr(83077)
ANATOLIAN_HIEROGLYPH_A110B = chr(83078)
ANATOLIAN_HIEROGLYPH_A111 = chr(83079)
ANATOLIAN_HIEROGLYPH_A112 = chr(83080)
ANATOLIAN_HIEROGLYPH_A113 = chr(83081)
ANATOLIAN_HIEROGLYPH_A114 = chr(83082)
ANATOLIAN_HIEROGLYPH_A115 = chr(83083)
ANATOLIAN_HIEROGLYPH_A115A = chr(83084)
ANATOLIAN_HIEROGLYPH_A116 = chr(83085)
ANATOLIAN_HIEROGLYPH_A117 = chr(83086)
ANATOLIAN_HIEROGLYPH_A118 = chr(83087)
ANATOLIAN_HIEROGLYPH_A119 = chr(83088)
ANATOLIAN_HIEROGLYPH_A120 = chr(83089)
ANATOLIAN_HIEROGLYPH_A121 = chr(83090)
ANATOLIAN_HIEROGLYPH_A122 = chr(83091)
ANATOLIAN_HIEROGLYPH_A123 = chr(83092)
ANATOLIAN_HIEROGLYPH_A124 = chr(83093)
ANATOLIAN_HIEROGLYPH_A125 = chr(83094)
ANATOLIAN_HIEROGLYPH_A125A = chr(83095)
ANATOLIAN_HIEROGLYPH_A126 = chr(83096)
ANATOLIAN_HIEROGLYPH_A127 = chr(83097)
ANATOLIAN_HIEROGLYPH_A128 = chr(83098)
ANATOLIAN_HIEROGLYPH_A129 = chr(83099)
ANATOLIAN_HIEROGLYPH_A130 = chr(83100)
ANATOLIAN_HIEROGLYPH_A131 = chr(83101)
ANATOLIAN_HIEROGLYPH_A132 = chr(83102)
ANATOLIAN_HIEROGLYPH_A133 = chr(83103)
ANATOLIAN_HIEROGLYPH_A134 = chr(83104)
ANATOLIAN_HIEROGLYPH_A135 = chr(83105)
ANATOLIAN_HIEROGLYPH_A135A = chr(83106)
ANATOLIAN_HIEROGLYPH_A136 = chr(83107)
ANATOLIAN_HIEROGLYPH_A137 = chr(83108)
ANATOLIAN_HIEROGLYPH_A138 = chr(83109)
ANATOLIAN_HIEROGLYPH_A139 = chr(83110)
ANATOLIAN_HIEROGLYPH_A140 = chr(83111)
ANATOLIAN_HIEROGLYPH_A141 = chr(83112)
ANATOLIAN_HIEROGLYPH_A142 = chr(83113)
ANATOLIAN_HIEROGLYPH_A143 = chr(83114)
ANATOLIAN_HIEROGLYPH_A144 = chr(83115)
ANATOLIAN_HIEROGLYPH_A145 = chr(83116)
ANATOLIAN_HIEROGLYPH_A146 = chr(83117)
ANATOLIAN_HIEROGLYPH_A147 = chr(83118)
ANATOLIAN_HIEROGLYPH_A148 = chr(83119)
ANATOLIAN_HIEROGLYPH_A149 = chr(83120)
ANATOLIAN_HIEROGLYPH_A150 = chr(83121)
ANATOLIAN_HIEROGLYPH_A151 = chr(83122)
ANATOLIAN_HIEROGLYPH_A152 = chr(83123)
ANATOLIAN_HIEROGLYPH_A153 = chr(83124)
ANATOLIAN_HIEROGLYPH_A154 = chr(83125)
ANATOLIAN_HIEROGLYPH_A155 = chr(83126)
ANATOLIAN_HIEROGLYPH_A156 = chr(83127)
ANATOLIAN_HIEROGLYPH_A157 = chr(83128)
ANATOLIAN_HIEROGLYPH_A158 = chr(83129)
ANATOLIAN_HIEROGLYPH_A159 = chr(83130)
ANATOLIAN_HIEROGLYPH_A160 = chr(83131)
ANATOLIAN_HIEROGLYPH_A161 = chr(83132)
ANATOLIAN_HIEROGLYPH_A162 = chr(83133)
ANATOLIAN_HIEROGLYPH_A163 = chr(83134)
ANATOLIAN_HIEROGLYPH_A164 = chr(83135)
ANATOLIAN_HIEROGLYPH_A165 = chr(83136)
ANATOLIAN_HIEROGLYPH_A166 = chr(83137)
ANATOLIAN_HIEROGLYPH_A167 = chr(83138)
ANATOLIAN_HIEROGLYPH_A168 = chr(83139)
ANATOLIAN_HIEROGLYPH_A169 = chr(83140)
ANATOLIAN_HIEROGLYPH_A170 = chr(83141)
ANATOLIAN_HIEROGLYPH_A171 = chr(83142)
ANATOLIAN_HIEROGLYPH_A172 = chr(83143)
ANATOLIAN_HIEROGLYPH_A173 = chr(83144)
ANATOLIAN_HIEROGLYPH_A174 = chr(83145)
ANATOLIAN_HIEROGLYPH_A175 = chr(83146)
ANATOLIAN_HIEROGLYPH_A176 = chr(83147)
ANATOLIAN_HIEROGLYPH_A177 = chr(83148)
ANATOLIAN_HIEROGLYPH_A178 = chr(83149)
ANATOLIAN_HIEROGLYPH_A179 = chr(83150)
ANATOLIAN_HIEROGLYPH_A180 = chr(83151)
ANATOLIAN_HIEROGLYPH_A181 = chr(83152)
ANATOLIAN_HIEROGLYPH_A182 = chr(83153)
ANATOLIAN_HIEROGLYPH_A183 = chr(83154)
ANATOLIAN_HIEROGLYPH_A184 = chr(83155)
ANATOLIAN_HIEROGLYPH_A185 = chr(83156)
ANATOLIAN_HIEROGLYPH_A186 = chr(83157)
ANATOLIAN_HIEROGLYPH_A187 = chr(83158)
ANATOLIAN_HIEROGLYPH_A188 = chr(83159)
ANATOLIAN_HIEROGLYPH_A189 = chr(83160)
ANATOLIAN_HIEROGLYPH_A190 = chr(83161)
ANATOLIAN_HIEROGLYPH_A191 = chr(83162)
ANATOLIAN_HIEROGLYPH_A192 = chr(83163)
ANATOLIAN_HIEROGLYPH_A193 = chr(83164)
ANATOLIAN_HIEROGLYPH_A194 = chr(83165)
ANATOLIAN_HIEROGLYPH_A195 = chr(83166)
ANATOLIAN_HIEROGLYPH_A196 = chr(83167)
ANATOLIAN_HIEROGLYPH_A197 = chr(83168)
ANATOLIAN_HIEROGLYPH_A198 = chr(83169)
ANATOLIAN_HIEROGLYPH_A199 = chr(83170)
ANATOLIAN_HIEROGLYPH_A200 = chr(83171)
ANATOLIAN_HIEROGLYPH_A201 = chr(83172)
ANATOLIAN_HIEROGLYPH_A202 = chr(83173)
ANATOLIAN_HIEROGLYPH_A202A = chr(83174)
ANATOLIAN_HIEROGLYPH_A202B = chr(83175)
ANATOLIAN_HIEROGLYPH_A203 = chr(83176)
ANATOLIAN_HIEROGLYPH_A204 = chr(83177)
ANATOLIAN_HIEROGLYPH_A205 = chr(83178)
ANATOLIAN_HIEROGLYPH_A206 = chr(83179)
ANATOLIAN_HIEROGLYPH_A207 = chr(83180)
ANATOLIAN_HIEROGLYPH_A207A = chr(83181)
ANATOLIAN_HIEROGLYPH_A208 = chr(83182)
ANATOLIAN_HIEROGLYPH_A209 = chr(83183)
ANATOLIAN_HIEROGLYPH_A209A = chr(83184)
ANATOLIAN_HIEROGLYPH_A210 = chr(83185)
ANATOLIAN_HIEROGLYPH_A211 = chr(83186)
ANATOLIAN_HIEROGLYPH_A212 = chr(83187)
ANATOLIAN_HIEROGLYPH_A213 = chr(83188)
ANATOLIAN_HIEROGLYPH_A214 = chr(83189)
ANATOLIAN_HIEROGLYPH_A215 = chr(83190)
ANATOLIAN_HIEROGLYPH_A215A = chr(83191)
ANATOLIAN_HIEROGLYPH_A216 = chr(83192)
ANATOLIAN_HIEROGLYPH_A216A = chr(83193)
ANATOLIAN_HIEROGLYPH_A217 = chr(83194)
ANATOLIAN_HIEROGLYPH_A218 = chr(83195)
ANATOLIAN_HIEROGLYPH_A219 = chr(83196)
ANATOLIAN_HIEROGLYPH_A220 = chr(83197)
ANATOLIAN_HIEROGLYPH_A221 = chr(83198)
ANATOLIAN_HIEROGLYPH_A222 = chr(83199)
ANATOLIAN_HIEROGLYPH_A223 = chr(83200)
ANATOLIAN_HIEROGLYPH_A224 = chr(83201)
ANATOLIAN_HIEROGLYPH_A225 = chr(83202)
ANATOLIAN_HIEROGLYPH_A226 = chr(83203)
ANATOLIAN_HIEROGLYPH_A227 = chr(83204)
ANATOLIAN_HIEROGLYPH_A227A = chr(83205)
ANATOLIAN_HIEROGLYPH_A228 = chr(83206)
ANATOLIAN_HIEROGLYPH_A229 = chr(83207)
ANATOLIAN_HIEROGLYPH_A230 = chr(83208)
ANATOLIAN_HIEROGLYPH_A231 = chr(83209)
ANATOLIAN_HIEROGLYPH_A232 = chr(83210)
ANATOLIAN_HIEROGLYPH_A233 = chr(83211)
ANATOLIAN_HIEROGLYPH_A234 = chr(83212)
ANATOLIAN_HIEROGLYPH_A235 = chr(83213)
ANATOLIAN_HIEROGLYPH_A236 = chr(83214)
ANATOLIAN_HIEROGLYPH_A237 = chr(83215)
ANATOLIAN_HIEROGLYPH_A238 = chr(83216)
ANATOLIAN_HIEROGLYPH_A239 = chr(83217)
ANATOLIAN_HIEROGLYPH_A240 = chr(83218)
ANATOLIAN_HIEROGLYPH_A241 = chr(83219)
ANATOLIAN_HIEROGLYPH_A242 = chr(83220)
ANATOLIAN_HIEROGLYPH_A243 = chr(83221)
ANATOLIAN_HIEROGLYPH_A244 = chr(83222)
ANATOLIAN_HIEROGLYPH_A245 = chr(83223)
ANATOLIAN_HIEROGLYPH_A246 = chr(83224)
ANATOLIAN_HIEROGLYPH_A247 = chr(83225)
ANATOLIAN_HIEROGLYPH_A248 = chr(83226)
ANATOLIAN_HIEROGLYPH_A249 = chr(83227)
ANATOLIAN_HIEROGLYPH_A250 = chr(83228)
ANATOLIAN_HIEROGLYPH_A251 = chr(83229)
ANATOLIAN_HIEROGLYPH_A252 = chr(83230)
ANATOLIAN_HIEROGLYPH_A253 = chr(83231)
ANATOLIAN_HIEROGLYPH_A254 = chr(83232)
ANATOLIAN_HIEROGLYPH_A255 = chr(83233)
ANATOLIAN_HIEROGLYPH_A256 = chr(83234)
ANATOLIAN_HIEROGLYPH_A257 = chr(83235)
ANATOLIAN_HIEROGLYPH_A258 = chr(83236)
ANATOLIAN_HIEROGLYPH_A259 = chr(83237)
ANATOLIAN_HIEROGLYPH_A260 = chr(83238)
ANATOLIAN_HIEROGLYPH_A261 = chr(83239)
ANATOLIAN_HIEROGLYPH_A262 = chr(83240)
ANATOLIAN_HIEROGLYPH_A263 = chr(83241)
ANATOLIAN_HIEROGLYPH_A264 = chr(83242)
ANATOLIAN_HIEROGLYPH_A265 = chr(83243)
ANATOLIAN_HIEROGLYPH_A266 = chr(83244)
ANATOLIAN_HIEROGLYPH_A267 = chr(83245)
ANATOLIAN_HIEROGLYPH_A267A = chr(83246)
ANATOLIAN_HIEROGLYPH_A268 = chr(83247)
ANATOLIAN_HIEROGLYPH_A269 = chr(83248)
ANATOLIAN_HIEROGLYPH_A270 = chr(83249)
ANATOLIAN_HIEROGLYPH_A271 = chr(83250)
ANATOLIAN_HIEROGLYPH_A272 = chr(83251)
ANATOLIAN_HIEROGLYPH_A273 = chr(83252)
ANATOLIAN_HIEROGLYPH_A274 = chr(83253)
ANATOLIAN_HIEROGLYPH_A275 = chr(83254)
ANATOLIAN_HIEROGLYPH_A276 = chr(83255)
ANATOLIAN_HIEROGLYPH_A277 = chr(83256)
ANATOLIAN_HIEROGLYPH_A278 = chr(83257)
ANATOLIAN_HIEROGLYPH_A279 = chr(83258)
ANATOLIAN_HIEROGLYPH_A280 = chr(83259)
ANATOLIAN_HIEROGLYPH_A281 = chr(83260)
ANATOLIAN_HIEROGLYPH_A282 = chr(83261)
ANATOLIAN_HIEROGLYPH_A283 = chr(83262)
ANATOLIAN_HIEROGLYPH_A284 = chr(83263)
ANATOLIAN_HIEROGLYPH_A285 = chr(83264)
ANATOLIAN_HIEROGLYPH_A286 = chr(83265)
ANATOLIAN_HIEROGLYPH_A287 = chr(83266)
ANATOLIAN_HIEROGLYPH_A288 = chr(83267)
ANATOLIAN_HIEROGLYPH_A289 = chr(83268)
ANATOLIAN_HIEROGLYPH_A289A = chr(83269)
ANATOLIAN_HIEROGLYPH_A290 = chr(83270)
ANATOLIAN_HIEROGLYPH_A291 = chr(83271)
ANATOLIAN_HIEROGLYPH_A292 = chr(83272)
ANATOLIAN_HIEROGLYPH_A293 = chr(83273)
ANATOLIAN_HIEROGLYPH_A294 = chr(83274)
ANATOLIAN_HIEROGLYPH_A294A = chr(83275)
ANATOLIAN_HIEROGLYPH_A295 = chr(83276)
ANATOLIAN_HIEROGLYPH_A296 = chr(83277)
ANATOLIAN_HIEROGLYPH_A297 = chr(83278)
ANATOLIAN_HIEROGLYPH_A298 = chr(83279)
ANATOLIAN_HIEROGLYPH_A299 = chr(83280)
ANATOLIAN_HIEROGLYPH_A299A = chr(83281)
ANATOLIAN_HIEROGLYPH_A300 = chr(83282)
ANATOLIAN_HIEROGLYPH_A301 = chr(83283)
ANATOLIAN_HIEROGLYPH_A302 = chr(83284)
ANATOLIAN_HIEROGLYPH_A303 = chr(83285)
ANATOLIAN_HIEROGLYPH_A304 = chr(83286)
ANATOLIAN_HIEROGLYPH_A305 = chr(83287)
ANATOLIAN_HIEROGLYPH_A306 = chr(83288)
ANATOLIAN_HIEROGLYPH_A307 = chr(83289)
ANATOLIAN_HIEROGLYPH_A308 = chr(83290)
ANATOLIAN_HIEROGLYPH_A309 = chr(83291)
ANATOLIAN_HIEROGLYPH_A309A = chr(83292)
ANATOLIAN_HIEROGLYPH_A310 = chr(83293)
ANATOLIAN_HIEROGLYPH_A311 = chr(83294)
ANATOLIAN_HIEROGLYPH_A312 = chr(83295)
ANATOLIAN_HIEROGLYPH_A313 = chr(83296)
ANATOLIAN_HIEROGLYPH_A314 = chr(83297)
ANATOLIAN_HIEROGLYPH_A315 = chr(83298)
ANATOLIAN_HIEROGLYPH_A316 = chr(83299)
ANATOLIAN_HIEROGLYPH_A317 = chr(83300)
ANATOLIAN_HIEROGLYPH_A318 = chr(83301)
ANATOLIAN_HIEROGLYPH_A319 = chr(83302)
ANATOLIAN_HIEROGLYPH_A320 = chr(83303)
ANATOLIAN_HIEROGLYPH_A321 = chr(83304)
ANATOLIAN_HIEROGLYPH_A322 = chr(83305)
ANATOLIAN_HIEROGLYPH_A323 = chr(83306)
ANATOLIAN_HIEROGLYPH_A324 = chr(83307)
ANATOLIAN_HIEROGLYPH_A325 = chr(83308)
ANATOLIAN_HIEROGLYPH_A326 = chr(83309)
ANATOLIAN_HIEROGLYPH_A327 = chr(83310)
ANATOLIAN_HIEROGLYPH_A328 = chr(83311)
ANATOLIAN_HIEROGLYPH_A329 = chr(83312)
ANATOLIAN_HIEROGLYPH_A329A = chr(83313)
ANATOLIAN_HIEROGLYPH_A330 = chr(83314)
ANATOLIAN_HIEROGLYPH_A331 = chr(83315)
ANATOLIAN_HIEROGLYPH_A332A = chr(83316)
ANATOLIAN_HIEROGLYPH_A332B = chr(83317)
ANATOLIAN_HIEROGLYPH_A332C = chr(83318)
ANATOLIAN_HIEROGLYPH_A333 = chr(83319)
ANATOLIAN_HIEROGLYPH_A334 = chr(83320)
ANATOLIAN_HIEROGLYPH_A335 = chr(83321)
ANATOLIAN_HIEROGLYPH_A336 = chr(83322)
ANATOLIAN_HIEROGLYPH_A336A = chr(83323)
ANATOLIAN_HIEROGLYPH_A336B = chr(83324)
ANATOLIAN_HIEROGLYPH_A336C = chr(83325)
ANATOLIAN_HIEROGLYPH_A337 = chr(83326)
ANATOLIAN_HIEROGLYPH_A338 = chr(83327)
ANATOLIAN_HIEROGLYPH_A339 = chr(83328)
ANATOLIAN_HIEROGLYPH_A340 = chr(83329)
ANATOLIAN_HIEROGLYPH_A341 = chr(83330)
ANATOLIAN_HIEROGLYPH_A342 = chr(83331)
ANATOLIAN_HIEROGLYPH_A343 = chr(83332)
ANATOLIAN_HIEROGLYPH_A344 = chr(83333)
ANATOLIAN_HIEROGLYPH_A345 = chr(83334)
ANATOLIAN_HIEROGLYPH_A346 = chr(83335)
ANATOLIAN_HIEROGLYPH_A347 = chr(83336)
ANATOLIAN_HIEROGLYPH_A348 = chr(83337)
ANATOLIAN_HIEROGLYPH_A349 = chr(83338)
ANATOLIAN_HIEROGLYPH_A350 = chr(83339)
ANATOLIAN_HIEROGLYPH_A351 = chr(83340)
ANATOLIAN_HIEROGLYPH_A352 = chr(83341)
ANATOLIAN_HIEROGLYPH_A353 = chr(83342)
ANATOLIAN_HIEROGLYPH_A354 = chr(83343)
ANATOLIAN_HIEROGLYPH_A355 = chr(83344)
ANATOLIAN_HIEROGLYPH_A356 = chr(83345)
ANATOLIAN_HIEROGLYPH_A357 = chr(83346)
ANATOLIAN_HIEROGLYPH_A358 = chr(83347)
ANATOLIAN_HIEROGLYPH_A359 = chr(83348)
ANATOLIAN_HIEROGLYPH_A359A = chr(83349)
ANATOLIAN_HIEROGLYPH_A360 = chr(83350)
ANATOLIAN_HIEROGLYPH_A361 = chr(83351)
ANATOLIAN_HIEROGLYPH_A362 = chr(83352)
ANATOLIAN_HIEROGLYPH_A363 = chr(83353)
ANATOLIAN_HIEROGLYPH_A364 = chr(83354)
ANATOLIAN_HIEROGLYPH_A364A = chr(83355)
ANATOLIAN_HIEROGLYPH_A365 = chr(83356)
ANATOLIAN_HIEROGLYPH_A366 = chr(83357)
ANATOLIAN_HIEROGLYPH_A367 = chr(83358)
ANATOLIAN_HIEROGLYPH_A368 = chr(83359)
ANATOLIAN_HIEROGLYPH_A368A = chr(83360)
ANATOLIAN_HIEROGLYPH_A369 = chr(83361)
ANATOLIAN_HIEROGLYPH_A370 = chr(83362)
ANATOLIAN_HIEROGLYPH_A371 = chr(83363)
ANATOLIAN_HIEROGLYPH_A371A = chr(83364)
ANATOLIAN_HIEROGLYPH_A372 = chr(83365)
ANATOLIAN_HIEROGLYPH_A373 = chr(83366)
ANATOLIAN_HIEROGLYPH_A374 = chr(83367)
ANATOLIAN_HIEROGLYPH_A375 = chr(83368)
ANATOLIAN_HIEROGLYPH_A376 = chr(83369)
ANATOLIAN_HIEROGLYPH_A377 = chr(83370)
ANATOLIAN_HIEROGLYPH_A378 = chr(83371)
ANATOLIAN_HIEROGLYPH_A379 = chr(83372)
ANATOLIAN_HIEROGLYPH_A380 = chr(83373)
ANATOLIAN_HIEROGLYPH_A381 = chr(83374)
ANATOLIAN_HIEROGLYPH_A381A = chr(83375)
ANATOLIAN_HIEROGLYPH_A382 = chr(83376)
ANATOLIAN_HIEROGLYPH_A383_RA_OR_RI = chr(83377)
ANATOLIAN_HIEROGLYPH_A383A = chr(83378)
ANATOLIAN_HIEROGLYPH_A384 = chr(83379)
ANATOLIAN_HIEROGLYPH_A385 = chr(83380)
ANATOLIAN_HIEROGLYPH_A386 = chr(83381)
ANATOLIAN_HIEROGLYPH_A386A = chr(83382)
ANATOLIAN_HIEROGLYPH_A387 = chr(83383)
ANATOLIAN_HIEROGLYPH_A388 = chr(83384)
ANATOLIAN_HIEROGLYPH_A389 = chr(83385)
ANATOLIAN_HIEROGLYPH_A390 = chr(83386)
ANATOLIAN_HIEROGLYPH_A391 = chr(83387)
ANATOLIAN_HIEROGLYPH_A392 = chr(83388)
ANATOLIAN_HIEROGLYPH_A393_EIGHT = chr(83389)
ANATOLIAN_HIEROGLYPH_A394 = chr(83390)
ANATOLIAN_HIEROGLYPH_A395 = chr(83391)
ANATOLIAN_HIEROGLYPH_A396 = chr(83392)
ANATOLIAN_HIEROGLYPH_A397 = chr(83393)
ANATOLIAN_HIEROGLYPH_A398 = chr(83394)
ANATOLIAN_HIEROGLYPH_A399 = chr(83395)
ANATOLIAN_HIEROGLYPH_A400 = chr(83396)
ANATOLIAN_HIEROGLYPH_A401 = chr(83397)
ANATOLIAN_HIEROGLYPH_A402 = chr(83398)
ANATOLIAN_HIEROGLYPH_A403 = chr(83399)
ANATOLIAN_HIEROGLYPH_A404 = chr(83400)
ANATOLIAN_HIEROGLYPH_A405 = chr(83401)
ANATOLIAN_HIEROGLYPH_A406 = chr(83402)
ANATOLIAN_HIEROGLYPH_A407 = chr(83403)
ANATOLIAN_HIEROGLYPH_A408 = chr(83404)
ANATOLIAN_HIEROGLYPH_A409 = chr(83405)
ANATOLIAN_HIEROGLYPH_A410_BEGIN_LOGOGRAM_MARK = chr(83406)
ANATOLIAN_HIEROGLYPH_A410A_END_LOGOGRAM_MARK = chr(83407)
ANATOLIAN_HIEROGLYPH_A411 = chr(83408)
ANATOLIAN_HIEROGLYPH_A412 = chr(83409)
ANATOLIAN_HIEROGLYPH_A413 = chr(83410)
ANATOLIAN_HIEROGLYPH_A414 = chr(83411)
ANATOLIAN_HIEROGLYPH_A415 = chr(83412)
ANATOLIAN_HIEROGLYPH_A416 = chr(83413)
ANATOLIAN_HIEROGLYPH_A417 = chr(83414)
ANATOLIAN_HIEROGLYPH_A418 = chr(83415)
ANATOLIAN_HIEROGLYPH_A419 = chr(83416)
ANATOLIAN_HIEROGLYPH_A420 = chr(83417)
ANATOLIAN_HIEROGLYPH_A421 = chr(83418)
ANATOLIAN_HIEROGLYPH_A422 = chr(83419)
ANATOLIAN_HIEROGLYPH_A423 = chr(83420)
ANATOLIAN_HIEROGLYPH_A424 = chr(83421)
ANATOLIAN_HIEROGLYPH_A425 = chr(83422)
ANATOLIAN_HIEROGLYPH_A426 = chr(83423)
ANATOLIAN_HIEROGLYPH_A427 = chr(83424)
ANATOLIAN_HIEROGLYPH_A428 = chr(83425)
ANATOLIAN_HIEROGLYPH_A429 = chr(83426)
ANATOLIAN_HIEROGLYPH_A430 = chr(83427)
ANATOLIAN_HIEROGLYPH_A431 = chr(83428)
ANATOLIAN_HIEROGLYPH_A432 = chr(83429)
ANATOLIAN_HIEROGLYPH_A433 = chr(83430)
ANATOLIAN_HIEROGLYPH_A434 = chr(83431)
ANATOLIAN_HIEROGLYPH_A435 = chr(83432)
ANATOLIAN_HIEROGLYPH_A436 = chr(83433)
ANATOLIAN_HIEROGLYPH_A437 = chr(83434)
ANATOLIAN_HIEROGLYPH_A438 = chr(83435)
ANATOLIAN_HIEROGLYPH_A439 = chr(83436)
ANATOLIAN_HIEROGLYPH_A440 = chr(83437)
ANATOLIAN_HIEROGLYPH_A441 = chr(83438)
ANATOLIAN_HIEROGLYPH_A442 = chr(83439)
ANATOLIAN_HIEROGLYPH_A443 = chr(83440)
ANATOLIAN_HIEROGLYPH_A444 = chr(83441)
ANATOLIAN_HIEROGLYPH_A445 = chr(83442)
ANATOLIAN_HIEROGLYPH_A446 = chr(83443)
ANATOLIAN_HIEROGLYPH_A447 = chr(83444)
ANATOLIAN_HIEROGLYPH_A448 = chr(83445)
ANATOLIAN_HIEROGLYPH_A449 = chr(83446)
ANATOLIAN_HIEROGLYPH_A450 = chr(83447)
ANATOLIAN_HIEROGLYPH_A450A = chr(83448)
ANATOLIAN_HIEROGLYPH_A451 = chr(83449)
ANATOLIAN_HIEROGLYPH_A452 = chr(83450)
ANATOLIAN_HIEROGLYPH_A453 = chr(83451)
ANATOLIAN_HIEROGLYPH_A454 = chr(83452)
ANATOLIAN_HIEROGLYPH_A455 = chr(83453)
ANATOLIAN_HIEROGLYPH_A456 = chr(83454)
ANATOLIAN_HIEROGLYPH_A457 = chr(83455)
ANATOLIAN_HIEROGLYPH_A457A = chr(83456)
ANATOLIAN_HIEROGLYPH_A458 = chr(83457)
ANATOLIAN_HIEROGLYPH_A459 = chr(83458)
ANATOLIAN_HIEROGLYPH_A460 = chr(83459)
ANATOLIAN_HIEROGLYPH_A461 = chr(83460)
ANATOLIAN_HIEROGLYPH_A462 = chr(83461)
ANATOLIAN_HIEROGLYPH_A463 = chr(83462)
ANATOLIAN_HIEROGLYPH_A464 = chr(83463)
ANATOLIAN_HIEROGLYPH_A465 = chr(83464)
ANATOLIAN_HIEROGLYPH_A466 = chr(83465)
ANATOLIAN_HIEROGLYPH_A467 = chr(83466)
ANATOLIAN_HIEROGLYPH_A468 = chr(83467)
ANATOLIAN_HIEROGLYPH_A469 = chr(83468)
ANATOLIAN_HIEROGLYPH_A470 = chr(83469)
ANATOLIAN_HIEROGLYPH_A471 = chr(83470)
ANATOLIAN_HIEROGLYPH_A472 = chr(83471)
ANATOLIAN_HIEROGLYPH_A473 = chr(83472)
ANATOLIAN_HIEROGLYPH_A474 = chr(83473)
ANATOLIAN_HIEROGLYPH_A475 = chr(83474)
ANATOLIAN_HIEROGLYPH_A476 = chr(83475)
ANATOLIAN_HIEROGLYPH_A477 = chr(83476)
ANATOLIAN_HIEROGLYPH_A478 = chr(83477)
ANATOLIAN_HIEROGLYPH_A479 = chr(83478)
ANATOLIAN_HIEROGLYPH_A480 = chr(83479)
ANATOLIAN_HIEROGLYPH_A481 = chr(83480)
ANATOLIAN_HIEROGLYPH_A482 = chr(83481)
ANATOLIAN_HIEROGLYPH_A483 = chr(83482)
ANATOLIAN_HIEROGLYPH_A484 = chr(83483)
ANATOLIAN_HIEROGLYPH_A485 = chr(83484)
ANATOLIAN_HIEROGLYPH_A486 = chr(83485)
ANATOLIAN_HIEROGLYPH_A487 = chr(83486)
ANATOLIAN_HIEROGLYPH_A488 = chr(83487)
ANATOLIAN_HIEROGLYPH_A489 = chr(83488)
ANATOLIAN_HIEROGLYPH_A490 = chr(83489)
ANATOLIAN_HIEROGLYPH_A491 = chr(83490)
ANATOLIAN_HIEROGLYPH_A492 = chr(83491)
ANATOLIAN_HIEROGLYPH_A493 = chr(83492)
ANATOLIAN_HIEROGLYPH_A494 = chr(83493)
ANATOLIAN_HIEROGLYPH_A495 = chr(83494)
ANATOLIAN_HIEROGLYPH_A496 = chr(83495)
ANATOLIAN_HIEROGLYPH_A497 = chr(83496)
ANATOLIAN_HIEROGLYPH_A501 = chr(83497)
ANATOLIAN_HIEROGLYPH_A502 = chr(83498)
ANATOLIAN_HIEROGLYPH_A503 = chr(83499)
ANATOLIAN_HIEROGLYPH_A504 = chr(83500)
ANATOLIAN_HIEROGLYPH_A505 = chr(83501)
ANATOLIAN_HIEROGLYPH_A506 = chr(83502)
ANATOLIAN_HIEROGLYPH_A507 = chr(83503)
ANATOLIAN_HIEROGLYPH_A508 = chr(83504)
ANATOLIAN_HIEROGLYPH_A509 = chr(83505)
ANATOLIAN_HIEROGLYPH_A510 = chr(83506)
ANATOLIAN_HIEROGLYPH_A511 = chr(83507)
ANATOLIAN_HIEROGLYPH_A512 = chr(83508)
ANATOLIAN_HIEROGLYPH_A513 = chr(83509)
ANATOLIAN_HIEROGLYPH_A514 = chr(83510)
ANATOLIAN_HIEROGLYPH_A515 = chr(83511)
ANATOLIAN_HIEROGLYPH_A516 = chr(83512)
ANATOLIAN_HIEROGLYPH_A517 = chr(83513)
ANATOLIAN_HIEROGLYPH_A518 = chr(83514)
ANATOLIAN_HIEROGLYPH_A519 = chr(83515)
ANATOLIAN_HIEROGLYPH_A520 = chr(83516)
ANATOLIAN_HIEROGLYPH_A521 = chr(83517)
ANATOLIAN_HIEROGLYPH_A522 = chr(83518)
ANATOLIAN_HIEROGLYPH_A523 = chr(83519)
ANATOLIAN_HIEROGLYPH_A524 = chr(83520)
ANATOLIAN_HIEROGLYPH_A525 = chr(83521)
ANATOLIAN_HIEROGLYPH_A526 = chr(83522)
ANATOLIAN_HIEROGLYPH_A527 = chr(83523)
ANATOLIAN_HIEROGLYPH_A528 = chr(83524)
ANATOLIAN_HIEROGLYPH_A529 = chr(83525)
ANATOLIAN_HIEROGLYPH_A530 = chr(83526)
BAMUM_LETTER_PHASE_A_NGKUE_MFON = chr(92160)
BAMUM_LETTER_PHASE_A_GBIEE_FON = chr(92161)
BAMUM_LETTER_PHASE_A_PON_MFON_PIPAEMGBIEE = chr(92162)
BAMUM_LETTER_PHASE_A_PON_MFON_PIPAEMBA = chr(92163)
BAMUM_LETTER_PHASE_A_NAA_MFON = chr(92164)
BAMUM_LETTER_PHASE_A_SHUENSHUET = chr(92165)
BAMUM_LETTER_PHASE_A_TITA_MFON = chr(92166)
BAMUM_LETTER_PHASE_A_NZA_MFON = chr(92167)
BAMUM_LETTER_PHASE_A_SHINDA_PA_NJI = chr(92168)
BAMUM_LETTER_PHASE_A_PON_PA_NJI_PIPAEMGBIEE = chr(92169)
BAMUM_LETTER_PHASE_A_PON_PA_NJI_PIPAEMBA = chr(92170)
BAMUM_LETTER_PHASE_A_MAEMBGBIEE = chr(92171)
BAMUM_LETTER_PHASE_A_TU_MAEMBA = chr(92172)
BAMUM_LETTER_PHASE_A_NGANGU = chr(92173)
BAMUM_LETTER_PHASE_A_MAEMVEUX = chr(92174)
BAMUM_LETTER_PHASE_A_MANSUAE = chr(92175)
BAMUM_LETTER_PHASE_A_MVEUAENGAM = chr(92176)
BAMUM_LETTER_PHASE_A_SEUNYAM = chr(92177)
BAMUM_LETTER_PHASE_A_NTOQPEN = chr(92178)
BAMUM_LETTER_PHASE_A_KEUKEUTNDA = chr(92179)
BAMUM_LETTER_PHASE_A_NKINDI = chr(92180)
BAMUM_LETTER_PHASE_A_SUU = chr(92181)
BAMUM_LETTER_PHASE_A_NGKUENZEUM = chr(92182)
BAMUM_LETTER_PHASE_A_LAPAQ = chr(92183)
BAMUM_LETTER_PHASE_A_LET_KUT = chr(92184)
BAMUM_LETTER_PHASE_A_NTAP_MFAA = chr(92185)
BAMUM_LETTER_PHASE_A_MAEKEUP = chr(92186)
BAMUM_LETTER_PHASE_A_PASHAE = chr(92187)
BAMUM_LETTER_PHASE_A_GHEUAERAE = chr(92188)
BAMUM_LETTER_PHASE_A_PAMSHAE = chr(92189)
BAMUM_LETTER_PHASE_A_MON_NGGEUAET = chr(92190)
BAMUM_LETTER_PHASE_A_NZUN_MEUT = chr(92191)
BAMUM_LETTER_PHASE_A_U_YUQ_NAE = chr(92192)
BAMUM_LETTER_PHASE_A_GHEUAEGHEUAE = chr(92193)
BAMUM_LETTER_PHASE_A_NTAP_NTAA = chr(92194)
BAMUM_LETTER_PHASE_A_SISA = chr(92195)
BAMUM_LETTER_PHASE_A_MGBASA = chr(92196)
BAMUM_LETTER_PHASE_A_MEUNJOMNDEUQ = chr(92197)
BAMUM_LETTER_PHASE_A_MOOMPUQ = chr(92198)
BAMUM_LETTER_PHASE_A_KAFA = chr(92199)
BAMUM_LETTER_PHASE_A_PA_LEERAEWA = chr(92200)
BAMUM_LETTER_PHASE_A_NDA_LEERAEWA = chr(92201)
BAMUM_LETTER_PHASE_A_PET = chr(92202)
BAMUM_LETTER_PHASE_A_MAEMKPEN = chr(92203)
BAMUM_LETTER_PHASE_A_NIKA = chr(92204)
BAMUM_LETTER_PHASE_A_PUP = chr(92205)
BAMUM_LETTER_PHASE_A_TUAEP = chr(92206)
BAMUM_LETTER_PHASE_A_LUAEP = chr(92207)
BAMUM_LETTER_PHASE_A_SONJAM = chr(92208)
BAMUM_LETTER_PHASE_A_TEUTEUWEN = chr(92209)
BAMUM_LETTER_PHASE_A_MAENYI = chr(92210)
BAMUM_LETTER_PHASE_A_KET = chr(92211)
BAMUM_LETTER_PHASE_A_NDAANGGEUAET = chr(92212)
BAMUM_LETTER_PHASE_A_KUOQ = chr(92213)
BAMUM_LETTER_PHASE_A_MOOMEUT = chr(92214)
BAMUM_LETTER_PHASE_A_SHUM = chr(92215)
BAMUM_LETTER_PHASE_A_LOMMAE = chr(92216)
BAMUM_LETTER_PHASE_A_FIRI = chr(92217)
BAMUM_LETTER_PHASE_A_ROM = chr(92218)
BAMUM_LETTER_PHASE_A_KPOQ = chr(92219)
BAMUM_LETTER_PHASE_A_SOQ = chr(92220)
BAMUM_LETTER_PHASE_A_MAP_PIEET = chr(92221)
BAMUM_LETTER_PHASE_A_SHIRAE = chr(92222)
BAMUM_LETTER_PHASE_A_NTAP = chr(92223)
BAMUM_LETTER_PHASE_A_SHOQ_NSHUT_YUM = chr(92224)
BAMUM_LETTER_PHASE_A_NYIT_MONGKEUAEQ = chr(92225)
BAMUM_LETTER_PHASE_A_PAARAE = chr(92226)
BAMUM_LETTER_PHASE_A_NKAARAE = chr(92227)
BAMUM_LETTER_PHASE_A_UNKNOWN = chr(92228)
BAMUM_LETTER_PHASE_A_NGGEN = chr(92229)
BAMUM_LETTER_PHASE_A_MAESI = chr(92230)
BAMUM_LETTER_PHASE_A_NJAM = chr(92231)
BAMUM_LETTER_PHASE_A_MBANYI = chr(92232)
BAMUM_LETTER_PHASE_A_NYET = chr(92233)
BAMUM_LETTER_PHASE_A_TEUAEN = chr(92234)
BAMUM_LETTER_PHASE_A_SOT = chr(92235)
BAMUM_LETTER_PHASE_A_PAAM = chr(92236)
BAMUM_LETTER_PHASE_A_NSHIEE = chr(92237)
BAMUM_LETTER_PHASE_A_MAEM = chr(92238)
BAMUM_LETTER_PHASE_A_NYI = chr(92239)
BAMUM_LETTER_PHASE_A_KAQ = chr(92240)
BAMUM_LETTER_PHASE_A_NSHA = chr(92241)
BAMUM_LETTER_PHASE_A_VEE = chr(92242)
BAMUM_LETTER_PHASE_A_LU = chr(92243)
BAMUM_LETTER_PHASE_A_NEN = chr(92244)
BAMUM_LETTER_PHASE_A_NAQ = chr(92245)
BAMUM_LETTER_PHASE_A_MBAQ = chr(92246)
BAMUM_LETTER_PHASE_B_NSHUET = chr(92247)
BAMUM_LETTER_PHASE_B_TU_MAEMGBIEE = chr(92248)
BAMUM_LETTER_PHASE_B_SIEE = chr(92249)
BAMUM_LETTER_PHASE_B_SET_TU = chr(92250)
BAMUM_LETTER_PHASE_B_LOM_NTEUM = chr(92251)
BAMUM_LETTER_PHASE_B_MBA_MAELEE = chr(92252)
BAMUM_LETTER_PHASE_B_KIEEM = chr(92253)
BAMUM_LETTER_PHASE_B_YEURAE = chr(92254)
BAMUM_LETTER_PHASE_B_MBAARAE = chr(92255)
BAMUM_LETTER_PHASE_B_KAM = chr(92256)
BAMUM_LETTER_PHASE_B_PEESHI = chr(92257)
BAMUM_LETTER_PHASE_B_YAFU_LEERAEWA = chr(92258)
BAMUM_LETTER_PHASE_B_LAM_NSHUT_NYAM = chr(92259)
BAMUM_LETTER_PHASE_B_NTIEE_SHEUOQ = chr(92260)
BAMUM_LETTER_PHASE_B_NDU_NJAA = chr(92261)
BAMUM_LETTER_PHASE_B_GHEUGHEUAEM = chr(92262)
BAMUM_LETTER_PHASE_B_PIT = chr(92263)
BAMUM_LETTER_PHASE_B_TU_NSIEE = chr(92264)
BAMUM_LETTER_PHASE_B_SHET_NJAQ = chr(92265)
BAMUM_LETTER_PHASE_B_SHEUAEQTU = chr(92266)
BAMUM_LETTER_PHASE_B_MFON_TEUAEQ = chr(92267)
BAMUM_LETTER_PHASE_B_MBIT_MBAAKET = chr(92268)
BAMUM_LETTER_PHASE_B_NYI_NTEUM = chr(92269)
BAMUM_LETTER_PHASE_B_KEUPUQ = chr(92270)
BAMUM_LETTER_PHASE_B_GHEUGHEN = chr(92271)
BAMUM_LETTER_PHASE_B_KEUYEUX = chr(92272)
BAMUM_LETTER_PHASE_B_LAANAE = chr(92273)
BAMUM_LETTER_PHASE_B_PARUM = chr(92274)
BAMUM_LETTER_PHASE_B_VEUM = chr(92275)
BAMUM_LETTER_PHASE_B_NGKINDI_MVOP = chr(92276)
BAMUM_LETTER_PHASE_B_NGGEU_MBU = chr(92277)
BAMUM_LETTER_PHASE_B_WUAET = chr(92278)
BAMUM_LETTER_PHASE_B_SAKEUAE = chr(92279)
BAMUM_LETTER_PHASE_B_TAAM = chr(92280)
BAMUM_LETTER_PHASE_B_MEUQ = chr(92281)
BAMUM_LETTER_PHASE_B_NGGUOQ = chr(92282)
BAMUM_LETTER_PHASE_B_NGGUOQ_LARGE = chr(92283)
BAMUM_LETTER_PHASE_B_MFIYAQ = chr(92284)
BAMUM_LETTER_PHASE_B_SUE = chr(92285)
BAMUM_LETTER_PHASE_B_MBEURI = chr(92286)
BAMUM_LETTER_PHASE_B_MONTIEEN = chr(92287)
BAMUM_LETTER_PHASE_B_NYAEMAE = chr(92288)
BAMUM_LETTER_PHASE_B_PUNGAAM = chr(92289)
BAMUM_LETTER_PHASE_B_MEUT_NGGEET = chr(92290)
BAMUM_LETTER_PHASE_B_FEUX = chr(92291)
BAMUM_LETTER_PHASE_B_MBUOQ = chr(92292)
BAMUM_LETTER_PHASE_B_FEE = chr(92293)
BAMUM_LETTER_PHASE_B_KEUAEM = chr(92294)
BAMUM_LETTER_PHASE_B_MA_NJEUAENA = chr(92295)
BAMUM_LETTER_PHASE_B_MA_NJUQA = chr(92296)
BAMUM_LETTER_PHASE_B_LET = chr(92297)
BAMUM_LETTER_PHASE_B_NGGAAM = chr(92298)
BAMUM_LETTER_PHASE_B_NSEN = chr(92299)
BAMUM_LETTER_PHASE_B_MA = chr(92300)
BAMUM_LETTER_PHASE_B_KIQ = chr(92301)
BAMUM_LETTER_PHASE_B_NGOM = chr(92302)
BAMUM_LETTER_PHASE_C_NGKUE_MAEMBA = chr(92303)
BAMUM_LETTER_PHASE_C_NZA = chr(92304)
BAMUM_LETTER_PHASE_C_YUM = chr(92305)
BAMUM_LETTER_PHASE_C_WANGKUOQ = chr(92306)
BAMUM_LETTER_PHASE_C_NGGEN = chr(92307)
BAMUM_LETTER_PHASE_C_NDEUAEREE = chr(92308)
BAMUM_LETTER_PHASE_C_NGKAQ = chr(92309)
BAMUM_LETTER_PHASE_C_GHARAE = chr(92310)
BAMUM_LETTER_PHASE_C_MBEEKEET = chr(92311)
BAMUM_LETTER_PHASE_C_GBAYI = chr(92312)
BAMUM_LETTER_PHASE_C_NYIR_MKPARAQ_MEUN = chr(92313)
BAMUM_LETTER_PHASE_C_NTU_MBIT = chr(92314)
BAMUM_LETTER_PHASE_C_MBEUM = chr(92315)
BAMUM_LETTER_PHASE_C_PIRIEEN = chr(92316)
BAMUM_LETTER_PHASE_C_NDOMBU = chr(92317)
BAMUM_LETTER_PHASE_C_MBAA_CABBAGE_TREE = chr(92318)
BAMUM_LETTER_PHASE_C_KEUSHEUAEP = chr(92319)
BAMUM_LETTER_PHASE_C_GHAP = chr(92320)
BAMUM_LETTER_PHASE_C_KEUKAQ = chr(92321)
BAMUM_LETTER_PHASE_C_YU_MUOMAE = chr(92322)
BAMUM_LETTER_PHASE_C_NZEUM = chr(92323)
BAMUM_LETTER_PHASE_C_MBUE = chr(92324)
BAMUM_LETTER_PHASE_C_NSEUAEN = chr(92325)
BAMUM_LETTER_PHASE_C_MBIT = chr(92326)
BAMUM_LETTER_PHASE_C_YEUQ = chr(92327)
BAMUM_LETTER_PHASE_C_KPARAQ = chr(92328)
BAMUM_LETTER_PHASE_C_KAA = chr(92329)
BAMUM_LETTER_PHASE_C_SEUX = chr(92330)
BAMUM_LETTER_PHASE_C_NDIDA = chr(92331)
BAMUM_LETTER_PHASE_C_TAASHAE = chr(92332)
BAMUM_LETTER_PHASE_C_NJUEQ = chr(92333)
BAMUM_LETTER_PHASE_C_TITA_YUE = chr(92334)
BAMUM_LETTER_PHASE_C_SUAET = chr(92335)
BAMUM_LETTER_PHASE_C_NGGUAEN_NYAM = chr(92336)
BAMUM_LETTER_PHASE_C_VEUX = chr(92337)
BAMUM_LETTER_PHASE_C_NANSANAQ = chr(92338)
BAMUM_LETTER_PHASE_C_MA_KEUAERI = chr(92339)
BAMUM_LETTER_PHASE_C_NTAA = chr(92340)
BAMUM_LETTER_PHASE_C_NGGUON = chr(92341)
BAMUM_LETTER_PHASE_C_LAP = chr(92342)
BAMUM_LETTER_PHASE_C_MBIRIEEN = chr(92343)
BAMUM_LETTER_PHASE_C_MGBASAQ = chr(92344)
BAMUM_LETTER_PHASE_C_NTEUNGBA = chr(92345)
BAMUM_LETTER_PHASE_C_TEUTEUX = chr(92346)
BAMUM_LETTER_PHASE_C_NGGUM = chr(92347)
BAMUM_LETTER_PHASE_C_FUE = chr(92348)
BAMUM_LETTER_PHASE_C_NDEUT = chr(92349)
BAMUM_LETTER_PHASE_C_NSA = chr(92350)
BAMUM_LETTER_PHASE_C_NSHAQ = chr(92351)
BAMUM_LETTER_PHASE_C_BUNG = chr(92352)
BAMUM_LETTER_PHASE_C_VEUAEPEN = chr(92353)
BAMUM_LETTER_PHASE_C_MBERAE = chr(92354)
BAMUM_LETTER_PHASE_C_RU = chr(92355)
BAMUM_LETTER_PHASE_C_NJAEM = chr(92356)
BAMUM_LETTER_PHASE_C_LAM = chr(92357)
BAMUM_LETTER_PHASE_C_TITUAEP = chr(92358)
BAMUM_LETTER_PHASE_C_NSUOT_NGOM = chr(92359)
BAMUM_LETTER_PHASE_C_NJEEEE = chr(92360)
BAMUM_LETTER_PHASE_C_KET = chr(92361)
BAMUM_LETTER_PHASE_C_NGGU = chr(92362)
BAMUM_LETTER_PHASE_C_MAESI = chr(92363)
BAMUM_LETTER_PHASE_C_MBUAEM = chr(92364)
BAMUM_LETTER_PHASE_C_LU = chr(92365)
BAMUM_LETTER_PHASE_C_KUT = chr(92366)
BAMUM_LETTER_PHASE_C_NJAM = chr(92367)
BAMUM_LETTER_PHASE_C_NGOM = chr(92368)
BAMUM_LETTER_PHASE_C_WUP = chr(92369)
BAMUM_LETTER_PHASE_C_NGGUEET = chr(92370)
BAMUM_LETTER_PHASE_C_NSOM = chr(92371)
BAMUM_LETTER_PHASE_C_NTEN = chr(92372)
BAMUM_LETTER_PHASE_C_KUOP_NKAARAE = chr(92373)
BAMUM_LETTER_PHASE_C_NSUN = chr(92374)
BAMUM_LETTER_PHASE_C_NDAM = chr(92375)
BAMUM_LETTER_PHASE_C_MA_NSIEE = chr(92376)
BAMUM_LETTER_PHASE_C_YAA = chr(92377)
BAMUM_LETTER_PHASE_C_NDAP = chr(92378)
BAMUM_LETTER_PHASE_C_SHUEQ = chr(92379)
BAMUM_LETTER_PHASE_C_SETFON = chr(92380)
BAMUM_LETTER_PHASE_C_MBI = chr(92381)
BAMUM_LETTER_PHASE_C_MAEMBA = chr(92382)
BAMUM_LETTER_PHASE_C_MBANYI = chr(92383)
BAMUM_LETTER_PHASE_C_KEUSEUX = chr(92384)
BAMUM_LETTER_PHASE_C_MBEUX = chr(92385)
BAMUM_LETTER_PHASE_C_KEUM = chr(92386)
BAMUM_LETTER_PHASE_C_MBAA_PICKET = chr(92387)
BAMUM_LETTER_PHASE_C_YUWOQ = chr(92388)
BAMUM_LETTER_PHASE_C_NJEUX = chr(92389)
BAMUM_LETTER_PHASE_C_MIEE = chr(92390)
BAMUM_LETTER_PHASE_C_MUAE = chr(92391)
BAMUM_LETTER_PHASE_C_SHIQ = chr(92392)
BAMUM_LETTER_PHASE_C_KEN_LAW = chr(92393)
BAMUM_LETTER_PHASE_C_KEN_FATIGUE = chr(92394)
BAMUM_LETTER_PHASE_C_NGAQ = chr(92395)
BAMUM_LETTER_PHASE_C_NAQ = chr(92396)
BAMUM_LETTER_PHASE_C_LIQ = chr(92397)
BAMUM_LETTER_PHASE_C_PIN = chr(92398)
BAMUM_LETTER_PHASE_C_PEN = chr(92399)
BAMUM_LETTER_PHASE_C_TET = chr(92400)
BAMUM_LETTER_PHASE_D_MBUO = chr(92401)
BAMUM_LETTER_PHASE_D_WAP = chr(92402)
BAMUM_LETTER_PHASE_D_NJI = chr(92403)
BAMUM_LETTER_PHASE_D_MFON = chr(92404)
BAMUM_LETTER_PHASE_D_NJIEE = chr(92405)
BAMUM_LETTER_PHASE_D_LIEE = chr(92406)
BAMUM_LETTER_PHASE_D_NJEUT = chr(92407)
BAMUM_LETTER_PHASE_D_NSHEE = chr(92408)
BAMUM_LETTER_PHASE_D_NGGAAMAE = chr(92409)
BAMUM_LETTER_PHASE_D_NYAM = chr(92410)
BAMUM_LETTER_PHASE_D_WUAEN = chr(92411)
BAMUM_LETTER_PHASE_D_NGKUN = chr(92412)
BAMUM_LETTER_PHASE_D_SHEE = chr(92413)
BAMUM_LETTER_PHASE_D_NGKAP = chr(92414)
BAMUM_LETTER_PHASE_D_KEUAETMEUN = chr(92415)
BAMUM_LETTER_PHASE_D_TEUT = chr(92416)
BAMUM_LETTER_PHASE_D_SHEUAE = chr(92417)
BAMUM_LETTER_PHASE_D_NJAP = chr(92418)
BAMUM_LETTER_PHASE_D_SUE = chr(92419)
BAMUM_LETTER_PHASE_D_KET = chr(92420)
BAMUM_LETTER_PHASE_D_YAEMMAE = chr(92421)
BAMUM_LETTER_PHASE_D_KUOM = chr(92422)
BAMUM_LETTER_PHASE_D_SAP = chr(92423)
BAMUM_LETTER_PHASE_D_MFEUT = chr(92424)
BAMUM_LETTER_PHASE_D_NDEUX = chr(92425)
BAMUM_LETTER_PHASE_D_MALEERI = chr(92426)
BAMUM_LETTER_PHASE_D_MEUT = chr(92427)
BAMUM_LETTER_PHASE_D_SEUAEQ = chr(92428)
BAMUM_LETTER_PHASE_D_YEN = chr(92429)
BAMUM_LETTER_PHASE_D_NJEUAEM = chr(92430)
BAMUM_LETTER_PHASE_D_KEUOT_MBUAE = chr(92431)
BAMUM_LETTER_PHASE_D_NGKEURI = chr(92432)
BAMUM_LETTER_PHASE_D_TU = chr(92433)
BAMUM_LETTER_PHASE_D_GHAA = chr(92434)
BAMUM_LETTER_PHASE_D_NGKYEE = chr(92435)
BAMUM_LETTER_PHASE_D_FEUFEUAET = chr(92436)
BAMUM_LETTER_PHASE_D_NDEE = chr(92437)
BAMUM_LETTER_PHASE_D_MGBOFUM = chr(92438)
BAMUM_LETTER_PHASE_D_LEUAEP = chr(92439)
BAMUM_LETTER_PHASE_D_NDON = chr(92440)
BAMUM_LETTER_PHASE_D_MONI = chr(92441)
BAMUM_LETTER_PHASE_D_MGBEUN = chr(92442)
BAMUM_LETTER_PHASE_D_PUUT = chr(92443)
BAMUM_LETTER_PHASE_D_MGBIEE = chr(92444)
BAMUM_LETTER_PHASE_D_MFO = chr(92445)
BAMUM_LETTER_PHASE_D_LUM = chr(92446)
BAMUM_LETTER_PHASE_D_NSIEEP = chr(92447)
BAMUM_LETTER_PHASE_D_MBAA = chr(92448)
BAMUM_LETTER_PHASE_D_KWAET = chr(92449)
BAMUM_LETTER_PHASE_D_NYET = chr(92450)
BAMUM_LETTER_PHASE_D_TEUAEN = chr(92451)
BAMUM_LETTER_PHASE_D_SOT = chr(92452)
BAMUM_LETTER_PHASE_D_YUWOQ = chr(92453)
BAMUM_LETTER_PHASE_D_KEUM = chr(92454)
BAMUM_LETTER_PHASE_D_RAEM = chr(92455)
BAMUM_LETTER_PHASE_D_TEEEE = chr(92456)
BAMUM_LETTER_PHASE_D_NGKEUAEQ = chr(92457)
BAMUM_LETTER_PHASE_D_MFEUAE = chr(92458)
BAMUM_LETTER_PHASE_D_NSIEET = chr(92459)
BAMUM_LETTER_PHASE_D_KEUP = chr(92460)
BAMUM_LETTER_PHASE_D_PIP = chr(92461)
BAMUM_LETTER_PHASE_D_PEUTAE = chr(92462)
BAMUM_LETTER_PHASE_D_NYUE = chr(92463)
BAMUM_LETTER_PHASE_D_LET = chr(92464)
BAMUM_LETTER_PHASE_D_NGGAAM = chr(92465)
BAMUM_LETTER_PHASE_D_MFIEE = chr(92466)
BAMUM_LETTER_PHASE_D_NGGWAEN = chr(92467)
BAMUM_LETTER_PHASE_D_YUOM = chr(92468)
BAMUM_LETTER_PHASE_D_PAP = chr(92469)
BAMUM_LETTER_PHASE_D_YUOP = chr(92470)
BAMUM_LETTER_PHASE_D_NDAM = chr(92471)
BAMUM_LETTER_PHASE_D_NTEUM = chr(92472)
BAMUM_LETTER_PHASE_D_SUAE = chr(92473)
BAMUM_LETTER_PHASE_D_KUN = chr(92474)
BAMUM_LETTER_PHASE_D_NGGEUX = chr(92475)
BAMUM_LETTER_PHASE_D_NGKIEE = chr(92476)
BAMUM_LETTER_PHASE_D_TUOT = chr(92477)
BAMUM_LETTER_PHASE_D_MEUN = chr(92478)
BAMUM_LETTER_PHASE_D_KUQ = chr(92479)
BAMUM_LETTER_PHASE_D_NSUM = chr(92480)
BAMUM_LETTER_PHASE_D_TEUN = chr(92481)
BAMUM_LETTER_PHASE_D_MAENJET = chr(92482)
BAMUM_LETTER_PHASE_D_NGGAP = chr(92483)
BAMUM_LETTER_PHASE_D_LEUM = chr(92484)
BAMUM_LETTER_PHASE_D_NGGUOM = chr(92485)
BAMUM_LETTER_PHASE_D_NSHUT = chr(92486)
BAMUM_LETTER_PHASE_D_NJUEQ = chr(92487)
BAMUM_LETTER_PHASE_D_GHEUAE = chr(92488)
BAMUM_LETTER_PHASE_D_KU = chr(92489)
BAMUM_LETTER_PHASE_D_REN_OLD = chr(92490)
BAMUM_LETTER_PHASE_D_TAE = chr(92491)
BAMUM_LETTER_PHASE_D_TOQ = chr(92492)
BAMUM_LETTER_PHASE_D_NYI = chr(92493)
BAMUM_LETTER_PHASE_D_RII = chr(92494)
BAMUM_LETTER_PHASE_D_LEEEE = chr(92495)
BAMUM_LETTER_PHASE_D_MEEEE = chr(92496)
BAMUM_LETTER_PHASE_D_M = chr(92497)
BAMUM_LETTER_PHASE_D_SUU = chr(92498)
BAMUM_LETTER_PHASE_D_MU = chr(92499)
BAMUM_LETTER_PHASE_D_SHII = chr(92500)
BAMUM_LETTER_PHASE_D_SHEUX = chr(92501)
BAMUM_LETTER_PHASE_D_KYEE = chr(92502)
BAMUM_LETTER_PHASE_D_NU = chr(92503)
BAMUM_LETTER_PHASE_D_SHU = chr(92504)
BAMUM_LETTER_PHASE_D_NTEE = chr(92505)
BAMUM_LETTER_PHASE_D_PEE = chr(92506)
BAMUM_LETTER_PHASE_D_NI = chr(92507)
BAMUM_LETTER_PHASE_D_SHOQ = chr(92508)
BAMUM_LETTER_PHASE_D_PUQ = chr(92509)
BAMUM_LETTER_PHASE_D_MVOP = chr(92510)
BAMUM_LETTER_PHASE_D_LOQ = chr(92511)
BAMUM_LETTER_PHASE_D_REN_MUCH = chr(92512)
BAMUM_LETTER_PHASE_D_TI = chr(92513)
BAMUM_LETTER_PHASE_D_NTUU = chr(92514)
BAMUM_LETTER_PHASE_D_MBAA_SEVEN = chr(92515)
BAMUM_LETTER_PHASE_D_SAQ = chr(92516)
BAMUM_LETTER_PHASE_D_FAA = chr(92517)
BAMUM_LETTER_PHASE_E_NDAP = chr(92518)
BAMUM_LETTER_PHASE_E_TOON = chr(92519)
BAMUM_LETTER_PHASE_E_MBEUM = chr(92520)
BAMUM_LETTER_PHASE_E_LAP = chr(92521)
BAMUM_LETTER_PHASE_E_VOM = chr(92522)
BAMUM_LETTER_PHASE_E_LOON = chr(92523)
BAMUM_LETTER_PHASE_E_PAA = chr(92524)
BAMUM_LETTER_PHASE_E_SOM = chr(92525)
BAMUM_LETTER_PHASE_E_RAQ = chr(92526)
BAMUM_LETTER_PHASE_E_NSHUOP = chr(92527)
BAMUM_LETTER_PHASE_E_NDUN = chr(92528)
BAMUM_LETTER_PHASE_E_PUAE = chr(92529)
BAMUM_LETTER_PHASE_E_TAM = chr(92530)
BAMUM_LETTER_PHASE_E_NGKA = chr(92531)
BAMUM_LETTER_PHASE_E_KPEUX = chr(92532)
BAMUM_LETTER_PHASE_E_WUO = chr(92533)
BAMUM_LETTER_PHASE_E_SEE = chr(92534)
BAMUM_LETTER_PHASE_E_NGGEUAET = chr(92535)
BAMUM_LETTER_PHASE_E_PAAM = chr(92536)
BAMUM_LETTER_PHASE_E_TOO = chr(92537)
BAMUM_LETTER_PHASE_E_KUOP = chr(92538)
BAMUM_LETTER_PHASE_E_LOM = chr(92539)
BAMUM_LETTER_PHASE_E_NSHIEE = chr(92540)
BAMUM_LETTER_PHASE_E_NGOP = chr(92541)
BAMUM_LETTER_PHASE_E_MAEM = chr(92542)
BAMUM_LETTER_PHASE_E_NGKEUX = chr(92543)
BAMUM_LETTER_PHASE_E_NGOQ = chr(92544)
BAMUM_LETTER_PHASE_E_NSHUE = chr(92545)
BAMUM_LETTER_PHASE_E_RIMGBA = chr(92546)
BAMUM_LETTER_PHASE_E_NJEUX = chr(92547)
BAMUM_LETTER_PHASE_E_PEEM = chr(92548)
BAMUM_LETTER_PHASE_E_SAA = chr(92549)
BAMUM_LETTER_PHASE_E_NGGURAE = chr(92550)
BAMUM_LETTER_PHASE_E_MGBA = chr(92551)
BAMUM_LETTER_PHASE_E_GHEUX = chr(92552)
BAMUM_LETTER_PHASE_E_NGKEUAEM = chr(92553)
BAMUM_LETTER_PHASE_E_NJAEMLI = chr(92554)
BAMUM_LETTER_PHASE_E_MAP = chr(92555)
BAMUM_LETTER_PHASE_E_LOOT = chr(92556)
BAMUM_LETTER_PHASE_E_NGGEEEE = chr(92557)
BAMUM_LETTER_PHASE_E_NDIQ = chr(92558)
BAMUM_LETTER_PHASE_E_TAEN_NTEUM = chr(92559)
BAMUM_LETTER_PHASE_E_SET = chr(92560)
BAMUM_LETTER_PHASE_E_PUM = chr(92561)
BAMUM_LETTER_PHASE_E_NDAA_SOFTNESS = chr(92562)
BAMUM_LETTER_PHASE_E_NGGUAESHAE_NYAM = chr(92563)
BAMUM_LETTER_PHASE_E_YIEE = chr(92564)
BAMUM_LETTER_PHASE_E_GHEUN = chr(92565)
BAMUM_LETTER_PHASE_E_TUAE = chr(92566)
BAMUM_LETTER_PHASE_E_YEUAE = chr(92567)
BAMUM_LETTER_PHASE_E_PO = chr(92568)
BAMUM_LETTER_PHASE_E_TUMAE = chr(92569)
BAMUM_LETTER_PHASE_E_KEUAE = chr(92570)
BAMUM_LETTER_PHASE_E_SUAEN = chr(92571)
BAMUM_LETTER_PHASE_E_TEUAEQ = chr(92572)
BAMUM_LETTER_PHASE_E_VEUAE = chr(92573)
BAMUM_LETTER_PHASE_E_WEUX = chr(92574)
BAMUM_LETTER_PHASE_E_LAAM = chr(92575)
BAMUM_LETTER_PHASE_E_PU = chr(92576)
BAMUM_LETTER_PHASE_E_TAAQ = chr(92577)
BAMUM_LETTER_PHASE_E_GHAAMAE = chr(92578)
BAMUM_LETTER_PHASE_E_NGEUREUT = chr(92579)
BAMUM_LETTER_PHASE_E_SHEUAEQ = chr(92580)
BAMUM_LETTER_PHASE_E_MGBEN = chr(92581)
BAMUM_LETTER_PHASE_E_MBEE = chr(92582)
BAMUM_LETTER_PHASE_E_NZAQ = chr(92583)
BAMUM_LETTER_PHASE_E_NKOM = chr(92584)
BAMUM_LETTER_PHASE_E_GBET = chr(92585)
BAMUM_LETTER_PHASE_E_TUM = chr(92586)
BAMUM_LETTER_PHASE_E_KUET = chr(92587)
BAMUM_LETTER_PHASE_E_YAP = chr(92588)
BAMUM_LETTER_PHASE_E_NYI_CLEAVER = chr(92589)
BAMUM_LETTER_PHASE_E_YIT = chr(92590)
BAMUM_LETTER_PHASE_E_MFEUQ = chr(92591)
BAMUM_LETTER_PHASE_E_NDIAQ = chr(92592)
BAMUM_LETTER_PHASE_E_PIEEQ = chr(92593)
BAMUM_LETTER_PHASE_E_YUEQ = chr(92594)
BAMUM_LETTER_PHASE_E_LEUAEM = chr(92595)
BAMUM_LETTER_PHASE_E_FUE = chr(92596)
BAMUM_LETTER_PHASE_E_GBEUX = chr(92597)
BAMUM_LETTER_PHASE_E_NGKUP = chr(92598)
BAMUM_LETTER_PHASE_E_KET = chr(92599)
BAMUM_LETTER_PHASE_E_MAE = chr(92600)
BAMUM_LETTER_PHASE_E_NGKAAMI = chr(92601)
BAMUM_LETTER_PHASE_E_GHET = chr(92602)
BAMUM_LETTER_PHASE_E_FA = chr(92603)
BAMUM_LETTER_PHASE_E_NTUM = chr(92604)
BAMUM_LETTER_PHASE_E_PEUT = chr(92605)
BAMUM_LETTER_PHASE_E_YEUM = chr(92606)
BAMUM_LETTER_PHASE_E_NGGEUAE = chr(92607)
BAMUM_LETTER_PHASE_E_NYI_BETWEEN = chr(92608)
BAMUM_LETTER_PHASE_E_NZUQ = chr(92609)
BAMUM_LETTER_PHASE_E_POON = chr(92610)
BAMUM_LETTER_PHASE_E_MIEE = chr(92611)
BAMUM_LETTER_PHASE_E_FUET = chr(92612)
BAMUM_LETTER_PHASE_E_NAE = chr(92613)
BAMUM_LETTER_PHASE_E_MUAE = chr(92614)
BAMUM_LETTER_PHASE_E_GHEUAE = chr(92615)
BAMUM_LETTER_PHASE_E_FU_I = chr(92616)
BAMUM_LETTER_PHASE_E_MVI = chr(92617)
BAMUM_LETTER_PHASE_E_PUAQ = chr(92618)
BAMUM_LETTER_PHASE_E_NGKUM = chr(92619)
BAMUM_LETTER_PHASE_E_KUT = chr(92620)
BAMUM_LETTER_PHASE_E_PIET = chr(92621)
BAMUM_LETTER_PHASE_E_NTAP = chr(92622)
BAMUM_LETTER_PHASE_E_YEUAET = chr(92623)
BAMUM_LETTER_PHASE_E_NGGUP = chr(92624)
BAMUM_LETTER_PHASE_E_PA_PEOPLE = chr(92625)
BAMUM_LETTER_PHASE_E_FU_CALL = chr(92626)
BAMUM_LETTER_PHASE_E_FOM = chr(92627)
BAMUM_LETTER_PHASE_E_NJEE = chr(92628)
BAMUM_LETTER_PHASE_E_A = chr(92629)
BAMUM_LETTER_PHASE_E_TOQ = chr(92630)
BAMUM_LETTER_PHASE_E_O = chr(92631)
BAMUM_LETTER_PHASE_E_I = chr(92632)
BAMUM_LETTER_PHASE_E_LAQ = chr(92633)
BAMUM_LETTER_PHASE_E_PA_PLURAL = chr(92634)
BAMUM_LETTER_PHASE_E_TAA = chr(92635)
BAMUM_LETTER_PHASE_E_TAQ = chr(92636)
BAMUM_LETTER_PHASE_E_NDAA_MY_HOUSE = chr(92637)
BAMUM_LETTER_PHASE_E_SHIQ = chr(92638)
BAMUM_LETTER_PHASE_E_YEUX = chr(92639)
BAMUM_LETTER_PHASE_E_NGUAE = chr(92640)
BAMUM_LETTER_PHASE_E_YUAEN = chr(92641)
BAMUM_LETTER_PHASE_E_YOQ_SWIMMING = chr(92642)
BAMUM_LETTER_PHASE_E_YOQ_COVER = chr(92643)
BAMUM_LETTER_PHASE_E_YUQ = chr(92644)
BAMUM_LETTER_PHASE_E_YUN = chr(92645)
BAMUM_LETTER_PHASE_E_KEUX = chr(92646)
BAMUM_LETTER_PHASE_E_PEUX = chr(92647)
BAMUM_LETTER_PHASE_E_NJEE_EPOCH = chr(92648)
BAMUM_LETTER_PHASE_E_PUE = chr(92649)
BAMUM_LETTER_PHASE_E_WUE = chr(92650)
BAMUM_LETTER_PHASE_E_FEE = chr(92651)
BAMUM_LETTER_PHASE_E_VEE = chr(92652)
BAMUM_LETTER_PHASE_E_LU = chr(92653)
BAMUM_LETTER_PHASE_E_MI = chr(92654)
BAMUM_LETTER_PHASE_E_REUX = chr(92655)
BAMUM_LETTER_PHASE_E_RAE = chr(92656)
BAMUM_LETTER_PHASE_E_NGUAET = chr(92657)
BAMUM_LETTER_PHASE_E_NGA = chr(92658)
BAMUM_LETTER_PHASE_E_SHO = chr(92659)
BAMUM_LETTER_PHASE_E_SHOQ = chr(92660)
BAMUM_LETTER_PHASE_E_FU_REMEDY = chr(92661)
BAMUM_LETTER_PHASE_E_NA = chr(92662)
BAMUM_LETTER_PHASE_E_PI = chr(92663)
BAMUM_LETTER_PHASE_E_LOQ = chr(92664)
BAMUM_LETTER_PHASE_E_KO = chr(92665)
BAMUM_LETTER_PHASE_E_MEN = chr(92666)
BAMUM_LETTER_PHASE_E_MA = chr(92667)
BAMUM_LETTER_PHASE_E_MAQ = chr(92668)
BAMUM_LETTER_PHASE_E_TEU = chr(92669)
BAMUM_LETTER_PHASE_E_KI = chr(92670)
BAMUM_LETTER_PHASE_E_MON = chr(92671)
BAMUM_LETTER_PHASE_E_TEN = chr(92672)
BAMUM_LETTER_PHASE_E_FAQ = chr(92673)
BAMUM_LETTER_PHASE_E_GHOM = chr(92674)
BAMUM_LETTER_PHASE_F_KA = chr(92675)
BAMUM_LETTER_PHASE_F_U = chr(92676)
BAMUM_LETTER_PHASE_F_KU = chr(92677)
BAMUM_LETTER_PHASE_F_EE = chr(92678)
BAMUM_LETTER_PHASE_F_REE = chr(92679)
BAMUM_LETTER_PHASE_F_TAE = chr(92680)
BAMUM_LETTER_PHASE_F_NYI = chr(92681)
BAMUM_LETTER_PHASE_F_LA = chr(92682)
BAMUM_LETTER_PHASE_F_RII = chr(92683)
BAMUM_LETTER_PHASE_F_RIEE = chr(92684)
BAMUM_LETTER_PHASE_F_MEEEE = chr(92685)
BAMUM_LETTER_PHASE_F_TAA = chr(92686)
BAMUM_LETTER_PHASE_F_NDAA = chr(92687)
BAMUM_LETTER_PHASE_F_NJAEM = chr(92688)
BAMUM_LETTER_PHASE_F_M = chr(92689)
BAMUM_LETTER_PHASE_F_SUU = chr(92690)
BAMUM_LETTER_PHASE_F_SHII = chr(92691)
BAMUM_LETTER_PHASE_F_SI = chr(92692)
BAMUM_LETTER_PHASE_F_SEUX = chr(92693)
BAMUM_LETTER_PHASE_F_KYEE = chr(92694)
BAMUM_LETTER_PHASE_F_KET = chr(92695)
BAMUM_LETTER_PHASE_F_NUAE = chr(92696)
BAMUM_LETTER_PHASE_F_NU = chr(92697)
BAMUM_LETTER_PHASE_F_NJUAE = chr(92698)
BAMUM_LETTER_PHASE_F_YOQ = chr(92699)
BAMUM_LETTER_PHASE_F_SHU = chr(92700)
BAMUM_LETTER_PHASE_F_YA = chr(92701)
BAMUM_LETTER_PHASE_F_NSHA = chr(92702)
BAMUM_LETTER_PHASE_F_PEUX = chr(92703)
BAMUM_LETTER_PHASE_F_NTEE = chr(92704)
BAMUM_LETTER_PHASE_F_WUE = chr(92705)
BAMUM_LETTER_PHASE_F_PEE = chr(92706)
BAMUM_LETTER_PHASE_F_RU = chr(92707)
BAMUM_LETTER_PHASE_F_NI = chr(92708)
BAMUM_LETTER_PHASE_F_REUX = chr(92709)
BAMUM_LETTER_PHASE_F_KEN = chr(92710)
BAMUM_LETTER_PHASE_F_NGKWAEN = chr(92711)
BAMUM_LETTER_PHASE_F_NGGA = chr(92712)
BAMUM_LETTER_PHASE_F_SHO = chr(92713)
BAMUM_LETTER_PHASE_F_PUAE = chr(92714)
BAMUM_LETTER_PHASE_F_FOM = chr(92715)
BAMUM_LETTER_PHASE_F_WA = chr(92716)
BAMUM_LETTER_PHASE_F_LI = chr(92717)
BAMUM_LETTER_PHASE_F_LOQ = chr(92718)
BAMUM_LETTER_PHASE_F_KO = chr(92719)
BAMUM_LETTER_PHASE_F_MBEN = chr(92720)
BAMUM_LETTER_PHASE_F_REN = chr(92721)
BAMUM_LETTER_PHASE_F_MA = chr(92722)
BAMUM_LETTER_PHASE_F_MO = chr(92723)
BAMUM_LETTER_PHASE_F_MBAA = chr(92724)
BAMUM_LETTER_PHASE_F_TET = chr(92725)
BAMUM_LETTER_PHASE_F_KPA = chr(92726)
BAMUM_LETTER_PHASE_F_SAMBA = chr(92727)
BAMUM_LETTER_PHASE_F_VUEQ = chr(92728)
MRO_LETTER_TA = chr(92736)
MRO_LETTER_NGI = chr(92737)
MRO_LETTER_YO = chr(92738)
MRO_LETTER_MIM = chr(92739)
MRO_LETTER_BA = chr(92740)
MRO_LETTER_DA = chr(92741)
MRO_LETTER_A = chr(92742)
MRO_LETTER_PHI = chr(92743)
MRO_LETTER_KHAI = chr(92744)
MRO_LETTER_HAO = chr(92745)
MRO_LETTER_DAI = chr(92746)
MRO_LETTER_CHU = chr(92747)
MRO_LETTER_KEAAE = chr(92748)
MRO_LETTER_OL = chr(92749)
MRO_LETTER_MAEM = chr(92750)
MRO_LETTER_NIN = chr(92751)
MRO_LETTER_PA = chr(92752)
MRO_LETTER_OO = chr(92753)
MRO_LETTER_O = chr(92754)
MRO_LETTER_RO = chr(92755)
MRO_LETTER_SHI = chr(92756)
MRO_LETTER_THEA = chr(92757)
MRO_LETTER_EA = chr(92758)
MRO_LETTER_WA = chr(92759)
MRO_LETTER_E = chr(92760)
MRO_LETTER_KO = chr(92761)
MRO_LETTER_LAN = chr(92762)
MRO_LETTER_LA = chr(92763)
MRO_LETTER_HAI = chr(92764)
MRO_LETTER_RI = chr(92765)
MRO_LETTER_TEK = chr(92766)
MRO_DIGIT_ZERO = chr(92768)
MRO_DIGIT_ONE = chr(92769)
MRO_DIGIT_TWO = chr(92770)
MRO_DIGIT_THREE = chr(92771)
MRO_DIGIT_FOUR = chr(92772)
MRO_DIGIT_FIVE = chr(92773)
MRO_DIGIT_SIX = chr(92774)
MRO_DIGIT_SEVEN = chr(92775)
MRO_DIGIT_EIGHT = chr(92776)
MRO_DIGIT_NINE = chr(92777)
MRO_DANDA = chr(92782)
MRO_DOUBLE_DANDA = chr(92783)
TANGSA_LETTER_OZ = chr(92784)
TANGSA_LETTER_OC = chr(92785)
TANGSA_LETTER_OQ = chr(92786)
TANGSA_LETTER_OX = chr(92787)
TANGSA_LETTER_AZ = chr(92788)
TANGSA_LETTER_AC = chr(92789)
TANGSA_LETTER_AQ = chr(92790)
TANGSA_LETTER_AX = chr(92791)
TANGSA_LETTER_VZ = chr(92792)
TANGSA_LETTER_VC = chr(92793)
TANGSA_LETTER_VQ = chr(92794)
TANGSA_LETTER_VX = chr(92795)
TANGSA_LETTER_EZ = chr(92796)
TANGSA_LETTER_EC = chr(92797)
TANGSA_LETTER_EQ = chr(92798)
TANGSA_LETTER_EX = chr(92799)
TANGSA_LETTER_IZ = chr(92800)
TANGSA_LETTER_IC = chr(92801)
TANGSA_LETTER_IQ = chr(92802)
TANGSA_LETTER_IX = chr(92803)
TANGSA_LETTER_UZ = chr(92804)
TANGSA_LETTER_UC = chr(92805)
TANGSA_LETTER_UQ = chr(92806)
TANGSA_LETTER_UX = chr(92807)
TANGSA_LETTER_AWZ = chr(92808)
TANGSA_LETTER_AWC = chr(92809)
TANGSA_LETTER_AWQ = chr(92810)
TANGSA_LETTER_AWX = chr(92811)
TANGSA_LETTER_UIZ = chr(92812)
TANGSA_LETTER_UIC = chr(92813)
TANGSA_LETTER_UIQ = chr(92814)
TANGSA_LETTER_UIX = chr(92815)
TANGSA_LETTER_FINAL_NG = chr(92816)
TANGSA_LETTER_LONG_UEX = chr(92817)
TANGSA_LETTER_SHORT_UEZ = chr(92818)
TANGSA_LETTER_SHORT_AWX = chr(92819)
TANGSA_LETTER_UEC = chr(92820)
TANGSA_LETTER_UEZ = chr(92821)
TANGSA_LETTER_UEQ = chr(92822)
TANGSA_LETTER_UEX = chr(92823)
TANGSA_LETTER_UIUZ = chr(92824)
TANGSA_LETTER_UIUC = chr(92825)
TANGSA_LETTER_UIUQ = chr(92826)
TANGSA_LETTER_UIUX = chr(92827)
TANGSA_LETTER_MZ = chr(92828)
TANGSA_LETTER_MC = chr(92829)
TANGSA_LETTER_MQ = chr(92830)
TANGSA_LETTER_MX = chr(92831)
TANGSA_LETTER_KA = chr(92832)
TANGSA_LETTER_KHA = chr(92833)
TANGSA_LETTER_GA = chr(92834)
TANGSA_LETTER_NGA = chr(92835)
TANGSA_LETTER_SA = chr(92836)
TANGSA_LETTER_YA = chr(92837)
TANGSA_LETTER_WA = chr(92838)
TANGSA_LETTER_PA = chr(92839)
TANGSA_LETTER_NYA = chr(92840)
TANGSA_LETTER_PHA = chr(92841)
TANGSA_LETTER_BA = chr(92842)
TANGSA_LETTER_MA = chr(92843)
TANGSA_LETTER_NA = chr(92844)
TANGSA_LETTER_HA = chr(92845)
TANGSA_LETTER_LA = chr(92846)
TANGSA_LETTER_HTA = chr(92847)
TANGSA_LETTER_TA = chr(92848)
TANGSA_LETTER_DA = chr(92849)
TANGSA_LETTER_RA = chr(92850)
TANGSA_LETTER_NHA = chr(92851)
TANGSA_LETTER_SHA = chr(92852)
TANGSA_LETTER_CA = chr(92853)
TANGSA_LETTER_TSA = chr(92854)
TANGSA_LETTER_GHA = chr(92855)
TANGSA_LETTER_HTTA = chr(92856)
TANGSA_LETTER_THA = chr(92857)
TANGSA_LETTER_XA = chr(92858)
TANGSA_LETTER_FA = chr(92859)
TANGSA_LETTER_DHA = chr(92860)
TANGSA_LETTER_CHA = chr(92861)
TANGSA_LETTER_ZA = chr(92862)
TANGSA_DIGIT_ZERO = chr(92864)
TANGSA_DIGIT_ONE = chr(92865)
TANGSA_DIGIT_TWO = chr(92866)
TANGSA_DIGIT_THREE = chr(92867)
TANGSA_DIGIT_FOUR = chr(92868)
TANGSA_DIGIT_FIVE = chr(92869)
TANGSA_DIGIT_SIX = chr(92870)
TANGSA_DIGIT_SEVEN = chr(92871)
TANGSA_DIGIT_EIGHT = chr(92872)
TANGSA_DIGIT_NINE = chr(92873)
BASSA_VAH_LETTER_ENNI = chr(92880)
BASSA_VAH_LETTER_KA = chr(92881)
BASSA_VAH_LETTER_SE = chr(92882)
BASSA_VAH_LETTER_FA = chr(92883)
BASSA_VAH_LETTER_MBE = chr(92884)
BASSA_VAH_LETTER_YIE = chr(92885)
BASSA_VAH_LETTER_GAH = chr(92886)
BASSA_VAH_LETTER_DHII = chr(92887)
BASSA_VAH_LETTER_KPAH = chr(92888)
BASSA_VAH_LETTER_JO = chr(92889)
BASSA_VAH_LETTER_HWAH = chr(92890)
BASSA_VAH_LETTER_WA = chr(92891)
BASSA_VAH_LETTER_ZO = chr(92892)
BASSA_VAH_LETTER_GBU = chr(92893)
BASSA_VAH_LETTER_DO = chr(92894)
BASSA_VAH_LETTER_CE = chr(92895)
BASSA_VAH_LETTER_UWU = chr(92896)
BASSA_VAH_LETTER_TO = chr(92897)
BASSA_VAH_LETTER_BA = chr(92898)
BASSA_VAH_LETTER_VU = chr(92899)
BASSA_VAH_LETTER_YEIN = chr(92900)
BASSA_VAH_LETTER_PA = chr(92901)
BASSA_VAH_LETTER_WADDA = chr(92902)
BASSA_VAH_LETTER_A = chr(92903)
BASSA_VAH_LETTER_O = chr(92904)
BASSA_VAH_LETTER_OO = chr(92905)
BASSA_VAH_LETTER_U = chr(92906)
BASSA_VAH_LETTER_EE = chr(92907)
BASSA_VAH_LETTER_E = chr(92908)
BASSA_VAH_LETTER_I = chr(92909)
BASSA_VAH_COMBINING_HIGH_TONE = chr(92912)
BASSA_VAH_COMBINING_LOW_TONE = chr(92913)
BASSA_VAH_COMBINING_MID_TONE = chr(92914)
BASSA_VAH_COMBINING_LOW_MID_TONE = chr(92915)
BASSA_VAH_COMBINING_HIGH_LOW_TONE = chr(92916)
BASSA_VAH_FULL_STOP = chr(92917)
PAHAWH_HMONG_VOWEL_KEEB = chr(92928)
PAHAWH_HMONG_VOWEL_KEEV = chr(92929)
PAHAWH_HMONG_VOWEL_KIB = chr(92930)
PAHAWH_HMONG_VOWEL_KIV = chr(92931)
PAHAWH_HMONG_VOWEL_KAUB = chr(92932)
PAHAWH_HMONG_VOWEL_KAUV = chr(92933)
PAHAWH_HMONG_VOWEL_KUB = chr(92934)
PAHAWH_HMONG_VOWEL_KUV = chr(92935)
PAHAWH_HMONG_VOWEL_KEB = chr(92936)
PAHAWH_HMONG_VOWEL_KEV = chr(92937)
PAHAWH_HMONG_VOWEL_KAIB = chr(92938)
PAHAWH_HMONG_VOWEL_KAIV = chr(92939)
PAHAWH_HMONG_VOWEL_KOOB = chr(92940)
PAHAWH_HMONG_VOWEL_KOOV = chr(92941)
PAHAWH_HMONG_VOWEL_KAWB = chr(92942)
PAHAWH_HMONG_VOWEL_KAWV = chr(92943)
PAHAWH_HMONG_VOWEL_KUAB = chr(92944)
PAHAWH_HMONG_VOWEL_KUAV = chr(92945)
PAHAWH_HMONG_VOWEL_KOB = chr(92946)
PAHAWH_HMONG_VOWEL_KOV = chr(92947)
PAHAWH_HMONG_VOWEL_KIAB = chr(92948)
PAHAWH_HMONG_VOWEL_KIAV = chr(92949)
PAHAWH_HMONG_VOWEL_KAB = chr(92950)
PAHAWH_HMONG_VOWEL_KAV = chr(92951)
PAHAWH_HMONG_VOWEL_KWB = chr(92952)
PAHAWH_HMONG_VOWEL_KWV = chr(92953)
PAHAWH_HMONG_VOWEL_KAAB = chr(92954)
PAHAWH_HMONG_VOWEL_KAAV = chr(92955)
PAHAWH_HMONG_CONSONANT_VAU = chr(92956)
PAHAWH_HMONG_CONSONANT_NTSAU = chr(92957)
PAHAWH_HMONG_CONSONANT_LAU = chr(92958)
PAHAWH_HMONG_CONSONANT_HAU = chr(92959)
PAHAWH_HMONG_CONSONANT_NLAU = chr(92960)
PAHAWH_HMONG_CONSONANT_RAU = chr(92961)
PAHAWH_HMONG_CONSONANT_NKAU = chr(92962)
PAHAWH_HMONG_CONSONANT_QHAU = chr(92963)
PAHAWH_HMONG_CONSONANT_YAU = chr(92964)
PAHAWH_HMONG_CONSONANT_HLAU = chr(92965)
PAHAWH_HMONG_CONSONANT_MAU = chr(92966)
PAHAWH_HMONG_CONSONANT_CHAU = chr(92967)
PAHAWH_HMONG_CONSONANT_NCHAU = chr(92968)
PAHAWH_HMONG_CONSONANT_HNAU = chr(92969)
PAHAWH_HMONG_CONSONANT_PLHAU = chr(92970)
PAHAWH_HMONG_CONSONANT_NTHAU = chr(92971)
PAHAWH_HMONG_CONSONANT_NAU = chr(92972)
PAHAWH_HMONG_CONSONANT_AU = chr(92973)
PAHAWH_HMONG_CONSONANT_XAU = chr(92974)
PAHAWH_HMONG_CONSONANT_CAU = chr(92975)
PAHAWH_HMONG_MARK_CIM_TUB = chr(92976)
PAHAWH_HMONG_MARK_CIM_SO = chr(92977)
PAHAWH_HMONG_MARK_CIM_KES = chr(92978)
PAHAWH_HMONG_MARK_CIM_KHAV = chr(92979)
PAHAWH_HMONG_MARK_CIM_SUAM = chr(92980)
PAHAWH_HMONG_MARK_CIM_HOM = chr(92981)
PAHAWH_HMONG_MARK_CIM_TAUM = chr(92982)
PAHAWH_HMONG_SIGN_VOS_THOM = chr(92983)
PAHAWH_HMONG_SIGN_VOS_TSHAB_CEEB = chr(92984)
PAHAWH_HMONG_SIGN_CIM_CHEEM = chr(92985)
PAHAWH_HMONG_SIGN_VOS_THIAB = chr(92986)
PAHAWH_HMONG_SIGN_VOS_FEEM = chr(92987)
PAHAWH_HMONG_SIGN_XYEEM_NTXIV = chr(92988)
PAHAWH_HMONG_SIGN_XYEEM_RHO = chr(92989)
PAHAWH_HMONG_SIGN_XYEEM_TOV = chr(92990)
PAHAWH_HMONG_SIGN_XYEEM_FAIB = chr(92991)
PAHAWH_HMONG_SIGN_VOS_SEEV = chr(92992)
PAHAWH_HMONG_SIGN_MEEJ_SUAB = chr(92993)
PAHAWH_HMONG_SIGN_VOS_NRUA = chr(92994)
PAHAWH_HMONG_SIGN_IB_YAM = chr(92995)
PAHAWH_HMONG_SIGN_XAUS = chr(92996)
PAHAWH_HMONG_SIGN_CIM_TSOV_ROG = chr(92997)
PAHAWH_HMONG_DIGIT_ZERO = chr(93008)
PAHAWH_HMONG_DIGIT_ONE = chr(93009)
PAHAWH_HMONG_DIGIT_TWO = chr(93010)
PAHAWH_HMONG_DIGIT_THREE = chr(93011)
PAHAWH_HMONG_DIGIT_FOUR = chr(93012)
PAHAWH_HMONG_DIGIT_FIVE = chr(93013)
PAHAWH_HMONG_DIGIT_SIX = chr(93014)
PAHAWH_HMONG_DIGIT_SEVEN = chr(93015)
PAHAWH_HMONG_DIGIT_EIGHT = chr(93016)
PAHAWH_HMONG_DIGIT_NINE = chr(93017)
PAHAWH_HMONG_NUMBER_TENS = chr(93019)
PAHAWH_HMONG_NUMBER_HUNDREDS = chr(93020)
PAHAWH_HMONG_NUMBER_TEN_THOUSANDS = chr(93021)
PAHAWH_HMONG_NUMBER_MILLIONS = chr(93022)
PAHAWH_HMONG_NUMBER_HUNDRED_MILLIONS = chr(93023)
PAHAWH_HMONG_NUMBER_TEN_BILLIONS = chr(93024)
PAHAWH_HMONG_NUMBER_TRILLIONS = chr(93025)
PAHAWH_HMONG_SIGN_VOS_LUB = chr(93027)
PAHAWH_HMONG_SIGN_XYOO = chr(93028)
PAHAWH_HMONG_SIGN_HLI = chr(93029)
PAHAWH_HMONG_SIGN_THIRD_STAGE_HLI = chr(93030)
PAHAWH_HMONG_SIGN_ZWJ_THAJ = chr(93031)
PAHAWH_HMONG_SIGN_HNUB = chr(93032)
PAHAWH_HMONG_SIGN_NQIG = chr(93033)
PAHAWH_HMONG_SIGN_XIAB = chr(93034)
PAHAWH_HMONG_SIGN_NTUJ = chr(93035)
PAHAWH_HMONG_SIGN_AV = chr(93036)
PAHAWH_HMONG_SIGN_TXHEEJ_CEEV = chr(93037)
PAHAWH_HMONG_SIGN_MEEJ_TSEEB = chr(93038)
PAHAWH_HMONG_SIGN_TAU = chr(93039)
PAHAWH_HMONG_SIGN_LOS = chr(93040)
PAHAWH_HMONG_SIGN_MUS = chr(93041)
PAHAWH_HMONG_SIGN_CIM_HAIS_LUS_NTOG_NTOG = chr(93042)
PAHAWH_HMONG_SIGN_CIM_CUAM_TSHOOJ = chr(93043)
PAHAWH_HMONG_SIGN_CIM_TXWV = chr(93044)
PAHAWH_HMONG_SIGN_CIM_TXWV_CHWV = chr(93045)
PAHAWH_HMONG_SIGN_CIM_PUB_DAWB = chr(93046)
PAHAWH_HMONG_SIGN_CIM_NRES_TOS = chr(93047)
PAHAWH_HMONG_CLAN_SIGN_TSHEEJ = chr(93053)
PAHAWH_HMONG_CLAN_SIGN_YEEG = chr(93054)
PAHAWH_HMONG_CLAN_SIGN_LIS = chr(93055)
PAHAWH_HMONG_CLAN_SIGN_LAUJ = chr(93056)
PAHAWH_HMONG_CLAN_SIGN_XYOOJ = chr(93057)
PAHAWH_HMONG_CLAN_SIGN_KOO = chr(93058)
PAHAWH_HMONG_CLAN_SIGN_HAWJ = chr(93059)
PAHAWH_HMONG_CLAN_SIGN_MUAS = chr(93060)
PAHAWH_HMONG_CLAN_SIGN_THOJ = chr(93061)
PAHAWH_HMONG_CLAN_SIGN_TSAB = chr(93062)
PAHAWH_HMONG_CLAN_SIGN_PHAB = chr(93063)
PAHAWH_HMONG_CLAN_SIGN_KHAB = chr(93064)
PAHAWH_HMONG_CLAN_SIGN_HAM = chr(93065)
PAHAWH_HMONG_CLAN_SIGN_VAJ = chr(93066)
PAHAWH_HMONG_CLAN_SIGN_FAJ = chr(93067)
PAHAWH_HMONG_CLAN_SIGN_YAJ = chr(93068)
PAHAWH_HMONG_CLAN_SIGN_TSWB = chr(93069)
PAHAWH_HMONG_CLAN_SIGN_KWM = chr(93070)
PAHAWH_HMONG_CLAN_SIGN_VWJ = chr(93071)
MEDEFAIDRIN_CAPITAL_LETTER_M = chr(93760)
MEDEFAIDRIN_CAPITAL_LETTER_S = chr(93761)
MEDEFAIDRIN_CAPITAL_LETTER_V = chr(93762)
MEDEFAIDRIN_CAPITAL_LETTER_W = chr(93763)
MEDEFAIDRIN_CAPITAL_LETTER_ATIU = chr(93764)
MEDEFAIDRIN_CAPITAL_LETTER_Z = chr(93765)
MEDEFAIDRIN_CAPITAL_LETTER_KP = chr(93766)
MEDEFAIDRIN_CAPITAL_LETTER_P = chr(93767)
MEDEFAIDRIN_CAPITAL_LETTER_T = chr(93768)
MEDEFAIDRIN_CAPITAL_LETTER_G = chr(93769)
MEDEFAIDRIN_CAPITAL_LETTER_F = chr(93770)
MEDEFAIDRIN_CAPITAL_LETTER_I = chr(93771)
MEDEFAIDRIN_CAPITAL_LETTER_K = chr(93772)
MEDEFAIDRIN_CAPITAL_LETTER_A = chr(93773)
MEDEFAIDRIN_CAPITAL_LETTER_J = chr(93774)
MEDEFAIDRIN_CAPITAL_LETTER_E = chr(93775)
MEDEFAIDRIN_CAPITAL_LETTER_B = chr(93776)
MEDEFAIDRIN_CAPITAL_LETTER_C = chr(93777)
MEDEFAIDRIN_CAPITAL_LETTER_U = chr(93778)
MEDEFAIDRIN_CAPITAL_LETTER_YU = chr(93779)
MEDEFAIDRIN_CAPITAL_LETTER_L = chr(93780)
MEDEFAIDRIN_CAPITAL_LETTER_Q = chr(93781)
MEDEFAIDRIN_CAPITAL_LETTER_HP = chr(93782)
MEDEFAIDRIN_CAPITAL_LETTER_NY = chr(93783)
MEDEFAIDRIN_CAPITAL_LETTER_X = chr(93784)
MEDEFAIDRIN_CAPITAL_LETTER_D = chr(93785)
MEDEFAIDRIN_CAPITAL_LETTER_OE = chr(93786)
MEDEFAIDRIN_CAPITAL_LETTER_N = chr(93787)
MEDEFAIDRIN_CAPITAL_LETTER_R = chr(93788)
MEDEFAIDRIN_CAPITAL_LETTER_O = chr(93789)
MEDEFAIDRIN_CAPITAL_LETTER_AI = chr(93790)
MEDEFAIDRIN_CAPITAL_LETTER_Y = chr(93791)
MEDEFAIDRIN_SMALL_LETTER_M = chr(93792)
MEDEFAIDRIN_SMALL_LETTER_S = chr(93793)
MEDEFAIDRIN_SMALL_LETTER_V = chr(93794)
MEDEFAIDRIN_SMALL_LETTER_W = chr(93795)
MEDEFAIDRIN_SMALL_LETTER_ATIU = chr(93796)
MEDEFAIDRIN_SMALL_LETTER_Z = chr(93797)
MEDEFAIDRIN_SMALL_LETTER_KP = chr(93798)
MEDEFAIDRIN_SMALL_LETTER_P = chr(93799)
MEDEFAIDRIN_SMALL_LETTER_T = chr(93800)
MEDEFAIDRIN_SMALL_LETTER_G = chr(93801)
MEDEFAIDRIN_SMALL_LETTER_F = chr(93802)
MEDEFAIDRIN_SMALL_LETTER_I = chr(93803)
MEDEFAIDRIN_SMALL_LETTER_K = chr(93804)
MEDEFAIDRIN_SMALL_LETTER_A = chr(93805)
MEDEFAIDRIN_SMALL_LETTER_J = chr(93806)
MEDEFAIDRIN_SMALL_LETTER_E = chr(93807)
MEDEFAIDRIN_SMALL_LETTER_B = chr(93808)
MEDEFAIDRIN_SMALL_LETTER_C = chr(93809)
MEDEFAIDRIN_SMALL_LETTER_U = chr(93810)
MEDEFAIDRIN_SMALL_LETTER_YU = chr(93811)
MEDEFAIDRIN_SMALL_LETTER_L = chr(93812)
MEDEFAIDRIN_SMALL_LETTER_Q = chr(93813)
MEDEFAIDRIN_SMALL_LETTER_HP = chr(93814)
MEDEFAIDRIN_SMALL_LETTER_NY = chr(93815)
MEDEFAIDRIN_SMALL_LETTER_X = chr(93816)
MEDEFAIDRIN_SMALL_LETTER_D = chr(93817)
MEDEFAIDRIN_SMALL_LETTER_OE = chr(93818)
MEDEFAIDRIN_SMALL_LETTER_N = chr(93819)
MEDEFAIDRIN_SMALL_LETTER_R = chr(93820)
MEDEFAIDRIN_SMALL_LETTER_O = chr(93821)
MEDEFAIDRIN_SMALL_LETTER_AI = chr(93822)
MEDEFAIDRIN_SMALL_LETTER_Y = chr(93823)
MEDEFAIDRIN_DIGIT_ZERO = chr(93824)
MEDEFAIDRIN_DIGIT_ONE = chr(93825)
MEDEFAIDRIN_DIGIT_TWO = chr(93826)
MEDEFAIDRIN_DIGIT_THREE = chr(93827)
MEDEFAIDRIN_DIGIT_FOUR = chr(93828)
MEDEFAIDRIN_DIGIT_FIVE = chr(93829)
MEDEFAIDRIN_DIGIT_SIX = chr(93830)
MEDEFAIDRIN_DIGIT_SEVEN = chr(93831)
MEDEFAIDRIN_DIGIT_EIGHT = chr(93832)
MEDEFAIDRIN_DIGIT_NINE = chr(93833)
MEDEFAIDRIN_NUMBER_TEN = chr(93834)
MEDEFAIDRIN_NUMBER_ELEVEN = chr(93835)
MEDEFAIDRIN_NUMBER_TWELVE = chr(93836)
MEDEFAIDRIN_NUMBER_THIRTEEN = chr(93837)
MEDEFAIDRIN_NUMBER_FOURTEEN = chr(93838)
MEDEFAIDRIN_NUMBER_FIFTEEN = chr(93839)
MEDEFAIDRIN_NUMBER_SIXTEEN = chr(93840)
MEDEFAIDRIN_NUMBER_SEVENTEEN = chr(93841)
MEDEFAIDRIN_NUMBER_EIGHTEEN = chr(93842)
MEDEFAIDRIN_NUMBER_NINETEEN = chr(93843)
MEDEFAIDRIN_DIGIT_ONE_ALTERNATE_FORM = chr(93844)
MEDEFAIDRIN_DIGIT_TWO_ALTERNATE_FORM = chr(93845)
MEDEFAIDRIN_DIGIT_THREE_ALTERNATE_FORM = chr(93846)
MEDEFAIDRIN_COMMA = chr(93847)
MEDEFAIDRIN_FULL_STOP = chr(93848)
MEDEFAIDRIN_SYMBOL_AIVA = chr(93849)
MEDEFAIDRIN_EXCLAMATION_OH = chr(93850)
MIAO_LETTER_PA = chr(93952)
MIAO_LETTER_BA = chr(93953)
MIAO_LETTER_YI_PA = chr(93954)
MIAO_LETTER_PLA = chr(93955)
MIAO_LETTER_MA = chr(93956)
MIAO_LETTER_MHA = chr(93957)
MIAO_LETTER_ARCHAIC_MA = chr(93958)
MIAO_LETTER_FA = chr(93959)
MIAO_LETTER_VA = chr(93960)
MIAO_LETTER_VFA = chr(93961)
MIAO_LETTER_TA = chr(93962)
MIAO_LETTER_DA = chr(93963)
MIAO_LETTER_YI_TTA = chr(93964)
MIAO_LETTER_YI_TA = chr(93965)
MIAO_LETTER_TTA = chr(93966)
MIAO_LETTER_DDA = chr(93967)
MIAO_LETTER_NA = chr(93968)
MIAO_LETTER_NHA = chr(93969)
MIAO_LETTER_YI_NNA = chr(93970)
MIAO_LETTER_ARCHAIC_NA = chr(93971)
MIAO_LETTER_NNA = chr(93972)
MIAO_LETTER_NNHA = chr(93973)
MIAO_LETTER_LA = chr(93974)
MIAO_LETTER_LYA = chr(93975)
MIAO_LETTER_LHA = chr(93976)
MIAO_LETTER_LHYA = chr(93977)
MIAO_LETTER_TLHA = chr(93978)
MIAO_LETTER_DLHA = chr(93979)
MIAO_LETTER_TLHYA = chr(93980)
MIAO_LETTER_DLHYA = chr(93981)
MIAO_LETTER_KA = chr(93982)
MIAO_LETTER_GA = chr(93983)
MIAO_LETTER_YI_KA = chr(93984)
MIAO_LETTER_QA = chr(93985)
MIAO_LETTER_QGA = chr(93986)
MIAO_LETTER_NGA = chr(93987)
MIAO_LETTER_NGHA = chr(93988)
MIAO_LETTER_ARCHAIC_NGA = chr(93989)
MIAO_LETTER_HA = chr(93990)
MIAO_LETTER_XA = chr(93991)
MIAO_LETTER_GHA = chr(93992)
MIAO_LETTER_GHHA = chr(93993)
MIAO_LETTER_TSSA = chr(93994)
MIAO_LETTER_DZZA = chr(93995)
MIAO_LETTER_NYA = chr(93996)
MIAO_LETTER_NYHA = chr(93997)
MIAO_LETTER_TSHA = chr(93998)
MIAO_LETTER_DZHA = chr(93999)
MIAO_LETTER_YI_TSHA = chr(94000)
MIAO_LETTER_YI_DZHA = chr(94001)
MIAO_LETTER_REFORMED_TSHA = chr(94002)
MIAO_LETTER_SHA = chr(94003)
MIAO_LETTER_SSA = chr(94004)
MIAO_LETTER_ZHA = chr(94005)
MIAO_LETTER_ZSHA = chr(94006)
MIAO_LETTER_TSA = chr(94007)
MIAO_LETTER_DZA = chr(94008)
MIAO_LETTER_YI_TSA = chr(94009)
MIAO_LETTER_SA = chr(94010)
MIAO_LETTER_ZA = chr(94011)
MIAO_LETTER_ZSA = chr(94012)
MIAO_LETTER_ZZA = chr(94013)
MIAO_LETTER_ZZSA = chr(94014)
MIAO_LETTER_ARCHAIC_ZZA = chr(94015)
MIAO_LETTER_ZZYA = chr(94016)
MIAO_LETTER_ZZSYA = chr(94017)
MIAO_LETTER_WA = chr(94018)
MIAO_LETTER_AH = chr(94019)
MIAO_LETTER_HHA = chr(94020)
MIAO_LETTER_BRI = chr(94021)
MIAO_LETTER_SYI = chr(94022)
MIAO_LETTER_DZYI = chr(94023)
MIAO_LETTER_TE = chr(94024)
MIAO_LETTER_TSE = chr(94025)
MIAO_LETTER_RTE = chr(94026)
MIAO_SIGN_CONSONANT_MODIFIER_BAR = chr(94031)
MIAO_LETTER_NASALIZATION = chr(94032)
MIAO_SIGN_ASPIRATION = chr(94033)
MIAO_SIGN_REFORMED_VOICING = chr(94034)
MIAO_SIGN_REFORMED_ASPIRATION = chr(94035)
MIAO_VOWEL_SIGN_A = chr(94036)
MIAO_VOWEL_SIGN_AA = chr(94037)
MIAO_VOWEL_SIGN_AHH = chr(94038)
MIAO_VOWEL_SIGN_AN = chr(94039)
MIAO_VOWEL_SIGN_ANG = chr(94040)
MIAO_VOWEL_SIGN_O = chr(94041)
MIAO_VOWEL_SIGN_OO = chr(94042)
MIAO_VOWEL_SIGN_WO = chr(94043)
MIAO_VOWEL_SIGN_W = chr(94044)
MIAO_VOWEL_SIGN_E = chr(94045)
MIAO_VOWEL_SIGN_EN = chr(94046)
MIAO_VOWEL_SIGN_ENG = chr(94047)
MIAO_VOWEL_SIGN_OEY = chr(94048)
MIAO_VOWEL_SIGN_I = chr(94049)
MIAO_VOWEL_SIGN_IA = chr(94050)
MIAO_VOWEL_SIGN_IAN = chr(94051)
MIAO_VOWEL_SIGN_IANG = chr(94052)
MIAO_VOWEL_SIGN_IO = chr(94053)
MIAO_VOWEL_SIGN_IE = chr(94054)
MIAO_VOWEL_SIGN_II = chr(94055)
MIAO_VOWEL_SIGN_IU = chr(94056)
MIAO_VOWEL_SIGN_ING = chr(94057)
MIAO_VOWEL_SIGN_U = chr(94058)
MIAO_VOWEL_SIGN_UA = chr(94059)
MIAO_VOWEL_SIGN_UAN = chr(94060)
MIAO_VOWEL_SIGN_UANG = chr(94061)
MIAO_VOWEL_SIGN_UU = chr(94062)
MIAO_VOWEL_SIGN_UEI = chr(94063)
MIAO_VOWEL_SIGN_UNG = chr(94064)
MIAO_VOWEL_SIGN_Y = chr(94065)
MIAO_VOWEL_SIGN_YI = chr(94066)
MIAO_VOWEL_SIGN_AE = chr(94067)
MIAO_VOWEL_SIGN_AEE = chr(94068)
MIAO_VOWEL_SIGN_ERR = chr(94069)
MIAO_VOWEL_SIGN_ROUNDED_ERR = chr(94070)
MIAO_VOWEL_SIGN_ER = chr(94071)
MIAO_VOWEL_SIGN_ROUNDED_ER = chr(94072)
MIAO_VOWEL_SIGN_AI = chr(94073)
MIAO_VOWEL_SIGN_EI = chr(94074)
MIAO_VOWEL_SIGN_AU = chr(94075)
MIAO_VOWEL_SIGN_OU = chr(94076)
MIAO_VOWEL_SIGN_N = chr(94077)
MIAO_VOWEL_SIGN_NG = chr(94078)
MIAO_VOWEL_SIGN_UOG = chr(94079)
MIAO_VOWEL_SIGN_YUI = chr(94080)
MIAO_VOWEL_SIGN_OG = chr(94081)
MIAO_VOWEL_SIGN_OER = chr(94082)
MIAO_VOWEL_SIGN_VW = chr(94083)
MIAO_VOWEL_SIGN_IG = chr(94084)
MIAO_VOWEL_SIGN_EA = chr(94085)
MIAO_VOWEL_SIGN_IONG = chr(94086)
MIAO_VOWEL_SIGN_UI = chr(94087)
MIAO_TONE_RIGHT = chr(94095)
MIAO_TONE_TOP_RIGHT = chr(94096)
MIAO_TONE_ABOVE = chr(94097)
MIAO_TONE_BELOW = chr(94098)
MIAO_LETTER_TONE_2 = chr(94099)
MIAO_LETTER_TONE_3 = chr(94100)
MIAO_LETTER_TONE_4 = chr(94101)
MIAO_LETTER_TONE_5 = chr(94102)
MIAO_LETTER_TONE_6 = chr(94103)
MIAO_LETTER_TONE_7 = chr(94104)
MIAO_LETTER_TONE_8 = chr(94105)
MIAO_LETTER_REFORMED_TONE_1 = chr(94106)
MIAO_LETTER_REFORMED_TONE_2 = chr(94107)
MIAO_LETTER_REFORMED_TONE_4 = chr(94108)
MIAO_LETTER_REFORMED_TONE_5 = chr(94109)
MIAO_LETTER_REFORMED_TONE_6 = chr(94110)
MIAO_LETTER_REFORMED_TONE_8 = chr(94111)
TANGUT_ITERATION_MARK = chr(94176)
NUSHU_ITERATION_MARK = chr(94177)
OLD_CHINESE_HOOK_MARK = chr(94178)
OLD_CHINESE_ITERATION_MARK = chr(94179)
KHITAN_SMALL_SCRIPT_FILLER = chr(94180)
VIETNAMESE_ALTERNATE_READING_MARK_CA = chr(94192)
VIETNAMESE_ALTERNATE_READING_MARK_NHAY = chr(94193)
TANGUT_COMPONENT_001 = chr(100352)
TANGUT_COMPONENT_002 = chr(100353)
TANGUT_COMPONENT_003 = chr(100354)
TANGUT_COMPONENT_004 = chr(100355)
TANGUT_COMPONENT_005 = chr(100356)
TANGUT_COMPONENT_006 = chr(100357)
TANGUT_COMPONENT_007 = chr(100358)
TANGUT_COMPONENT_008 = chr(100359)
TANGUT_COMPONENT_009 = chr(100360)
TANGUT_COMPONENT_010 = chr(100361)
TANGUT_COMPONENT_011 = chr(100362)
TANGUT_COMPONENT_012 = chr(100363)
TANGUT_COMPONENT_013 = chr(100364)
TANGUT_COMPONENT_014 = chr(100365)
TANGUT_COMPONENT_015 = chr(100366)
TANGUT_COMPONENT_016 = chr(100367)
TANGUT_COMPONENT_017 = chr(100368)
TANGUT_COMPONENT_018 = chr(100369)
TANGUT_COMPONENT_019 = chr(100370)
TANGUT_COMPONENT_020 = chr(100371)
TANGUT_COMPONENT_021 = chr(100372)
TANGUT_COMPONENT_022 = chr(100373)
TANGUT_COMPONENT_023 = chr(100374)
TANGUT_COMPONENT_024 = chr(100375)
TANGUT_COMPONENT_025 = chr(100376)
TANGUT_COMPONENT_026 = chr(100377)
TANGUT_COMPONENT_027 = chr(100378)
TANGUT_COMPONENT_028 = chr(100379)
TANGUT_COMPONENT_029 = chr(100380)
TANGUT_COMPONENT_030 = chr(100381)
TANGUT_COMPONENT_031 = chr(100382)
TANGUT_COMPONENT_032 = chr(100383)
TANGUT_COMPONENT_033 = chr(100384)
TANGUT_COMPONENT_034 = chr(100385)
TANGUT_COMPONENT_035 = chr(100386)
TANGUT_COMPONENT_036 = chr(100387)
TANGUT_COMPONENT_037 = chr(100388)
TANGUT_COMPONENT_038 = chr(100389)
TANGUT_COMPONENT_039 = chr(100390)
TANGUT_COMPONENT_040 = chr(100391)
TANGUT_COMPONENT_041 = chr(100392)
TANGUT_COMPONENT_042 = chr(100393)
TANGUT_COMPONENT_043 = chr(100394)
TANGUT_COMPONENT_044 = chr(100395)
TANGUT_COMPONENT_045 = chr(100396)
TANGUT_COMPONENT_046 = chr(100397)
TANGUT_COMPONENT_047 = chr(100398)
TANGUT_COMPONENT_048 = chr(100399)
TANGUT_COMPONENT_049 = chr(100400)
TANGUT_COMPONENT_050 = chr(100401)
TANGUT_COMPONENT_051 = chr(100402)
TANGUT_COMPONENT_052 = chr(100403)
TANGUT_COMPONENT_053 = chr(100404)
TANGUT_COMPONENT_054 = chr(100405)
TANGUT_COMPONENT_055 = chr(100406)
TANGUT_COMPONENT_056 = chr(100407)
TANGUT_COMPONENT_057 = chr(100408)
TANGUT_COMPONENT_058 = chr(100409)
TANGUT_COMPONENT_059 = chr(100410)
TANGUT_COMPONENT_060 = chr(100411)
TANGUT_COMPONENT_061 = chr(100412)
TANGUT_COMPONENT_062 = chr(100413)
TANGUT_COMPONENT_063 = chr(100414)
TANGUT_COMPONENT_064 = chr(100415)
TANGUT_COMPONENT_065 = chr(100416)
TANGUT_COMPONENT_066 = chr(100417)
TANGUT_COMPONENT_067 = chr(100418)
TANGUT_COMPONENT_068 = chr(100419)
TANGUT_COMPONENT_069 = chr(100420)
TANGUT_COMPONENT_070 = chr(100421)
TANGUT_COMPONENT_071 = chr(100422)
TANGUT_COMPONENT_072 = chr(100423)
TANGUT_COMPONENT_073 = chr(100424)
TANGUT_COMPONENT_074 = chr(100425)
TANGUT_COMPONENT_075 = chr(100426)
TANGUT_COMPONENT_076 = chr(100427)
TANGUT_COMPONENT_077 = chr(100428)
TANGUT_COMPONENT_078 = chr(100429)
TANGUT_COMPONENT_079 = chr(100430)
TANGUT_COMPONENT_080 = chr(100431)
TANGUT_COMPONENT_081 = chr(100432)
TANGUT_COMPONENT_082 = chr(100433)
TANGUT_COMPONENT_083 = chr(100434)
TANGUT_COMPONENT_084 = chr(100435)
TANGUT_COMPONENT_085 = chr(100436)
TANGUT_COMPONENT_086 = chr(100437)
TANGUT_COMPONENT_087 = chr(100438)
TANGUT_COMPONENT_088 = chr(100439)
TANGUT_COMPONENT_089 = chr(100440)
TANGUT_COMPONENT_090 = chr(100441)
TANGUT_COMPONENT_091 = chr(100442)
TANGUT_COMPONENT_092 = chr(100443)
TANGUT_COMPONENT_093 = chr(100444)
TANGUT_COMPONENT_094 = chr(100445)
TANGUT_COMPONENT_095 = chr(100446)
TANGUT_COMPONENT_096 = chr(100447)
TANGUT_COMPONENT_097 = chr(100448)
TANGUT_COMPONENT_098 = chr(100449)
TANGUT_COMPONENT_099 = chr(100450)
TANGUT_COMPONENT_100 = chr(100451)
TANGUT_COMPONENT_101 = chr(100452)
TANGUT_COMPONENT_102 = chr(100453)
TANGUT_COMPONENT_103 = chr(100454)
TANGUT_COMPONENT_104 = chr(100455)
TANGUT_COMPONENT_105 = chr(100456)
TANGUT_COMPONENT_106 = chr(100457)
TANGUT_COMPONENT_107 = chr(100458)
TANGUT_COMPONENT_108 = chr(100459)
TANGUT_COMPONENT_109 = chr(100460)
TANGUT_COMPONENT_110 = chr(100461)
TANGUT_COMPONENT_111 = chr(100462)
TANGUT_COMPONENT_112 = chr(100463)
TANGUT_COMPONENT_113 = chr(100464)
TANGUT_COMPONENT_114 = chr(100465)
TANGUT_COMPONENT_115 = chr(100466)
TANGUT_COMPONENT_116 = chr(100467)
TANGUT_COMPONENT_117 = chr(100468)
TANGUT_COMPONENT_118 = chr(100469)
TANGUT_COMPONENT_119 = chr(100470)
TANGUT_COMPONENT_120 = chr(100471)
TANGUT_COMPONENT_121 = chr(100472)
TANGUT_COMPONENT_122 = chr(100473)
TANGUT_COMPONENT_123 = chr(100474)
TANGUT_COMPONENT_124 = chr(100475)
TANGUT_COMPONENT_125 = chr(100476)
TANGUT_COMPONENT_126 = chr(100477)
TANGUT_COMPONENT_127 = chr(100478)
TANGUT_COMPONENT_128 = chr(100479)
TANGUT_COMPONENT_129 = chr(100480)
TANGUT_COMPONENT_130 = chr(100481)
TANGUT_COMPONENT_131 = chr(100482)
TANGUT_COMPONENT_132 = chr(100483)
TANGUT_COMPONENT_133 = chr(100484)
TANGUT_COMPONENT_134 = chr(100485)
TANGUT_COMPONENT_135 = chr(100486)
TANGUT_COMPONENT_136 = chr(100487)
TANGUT_COMPONENT_137 = chr(100488)
TANGUT_COMPONENT_138 = chr(100489)
TANGUT_COMPONENT_139 = chr(100490)
TANGUT_COMPONENT_140 = chr(100491)
TANGUT_COMPONENT_141 = chr(100492)
TANGUT_COMPONENT_142 = chr(100493)
TANGUT_COMPONENT_143 = chr(100494)
TANGUT_COMPONENT_144 = chr(100495)
TANGUT_COMPONENT_145 = chr(100496)
TANGUT_COMPONENT_146 = chr(100497)
TANGUT_COMPONENT_147 = chr(100498)
TANGUT_COMPONENT_148 = chr(100499)
TANGUT_COMPONENT_149 = chr(100500)
TANGUT_COMPONENT_150 = chr(100501)
TANGUT_COMPONENT_151 = chr(100502)
TANGUT_COMPONENT_152 = chr(100503)
TANGUT_COMPONENT_153 = chr(100504)
TANGUT_COMPONENT_154 = chr(100505)
TANGUT_COMPONENT_155 = chr(100506)
TANGUT_COMPONENT_156 = chr(100507)
TANGUT_COMPONENT_157 = chr(100508)
TANGUT_COMPONENT_158 = chr(100509)
TANGUT_COMPONENT_159 = chr(100510)
TANGUT_COMPONENT_160 = chr(100511)
TANGUT_COMPONENT_161 = chr(100512)
TANGUT_COMPONENT_162 = chr(100513)
TANGUT_COMPONENT_163 = chr(100514)
TANGUT_COMPONENT_164 = chr(100515)
TANGUT_COMPONENT_165 = chr(100516)
TANGUT_COMPONENT_166 = chr(100517)
TANGUT_COMPONENT_167 = chr(100518)
TANGUT_COMPONENT_168 = chr(100519)
TANGUT_COMPONENT_169 = chr(100520)
TANGUT_COMPONENT_170 = chr(100521)
TANGUT_COMPONENT_171 = chr(100522)
TANGUT_COMPONENT_172 = chr(100523)
TANGUT_COMPONENT_173 = chr(100524)
TANGUT_COMPONENT_174 = chr(100525)
TANGUT_COMPONENT_175 = chr(100526)
TANGUT_COMPONENT_176 = chr(100527)
TANGUT_COMPONENT_177 = chr(100528)
TANGUT_COMPONENT_178 = chr(100529)
TANGUT_COMPONENT_179 = chr(100530)
TANGUT_COMPONENT_180 = chr(100531)
TANGUT_COMPONENT_181 = chr(100532)
TANGUT_COMPONENT_182 = chr(100533)
TANGUT_COMPONENT_183 = chr(100534)
TANGUT_COMPONENT_184 = chr(100535)
TANGUT_COMPONENT_185 = chr(100536)
TANGUT_COMPONENT_186 = chr(100537)
TANGUT_COMPONENT_187 = chr(100538)
TANGUT_COMPONENT_188 = chr(100539)
TANGUT_COMPONENT_189 = chr(100540)
TANGUT_COMPONENT_190 = chr(100541)
TANGUT_COMPONENT_191 = chr(100542)
TANGUT_COMPONENT_192 = chr(100543)
TANGUT_COMPONENT_193 = chr(100544)
TANGUT_COMPONENT_194 = chr(100545)
TANGUT_COMPONENT_195 = chr(100546)
TANGUT_COMPONENT_196 = chr(100547)
TANGUT_COMPONENT_197 = chr(100548)
TANGUT_COMPONENT_198 = chr(100549)
TANGUT_COMPONENT_199 = chr(100550)
TANGUT_COMPONENT_200 = chr(100551)
TANGUT_COMPONENT_201 = chr(100552)
TANGUT_COMPONENT_202 = chr(100553)
TANGUT_COMPONENT_203 = chr(100554)
TANGUT_COMPONENT_204 = chr(100555)
TANGUT_COMPONENT_205 = chr(100556)
TANGUT_COMPONENT_206 = chr(100557)
TANGUT_COMPONENT_207 = chr(100558)
TANGUT_COMPONENT_208 = chr(100559)
TANGUT_COMPONENT_209 = chr(100560)
TANGUT_COMPONENT_210 = chr(100561)
TANGUT_COMPONENT_211 = chr(100562)
TANGUT_COMPONENT_212 = chr(100563)
TANGUT_COMPONENT_213 = chr(100564)
TANGUT_COMPONENT_214 = chr(100565)
TANGUT_COMPONENT_215 = chr(100566)
TANGUT_COMPONENT_216 = chr(100567)
TANGUT_COMPONENT_217 = chr(100568)
TANGUT_COMPONENT_218 = chr(100569)
TANGUT_COMPONENT_219 = chr(100570)
TANGUT_COMPONENT_220 = chr(100571)
TANGUT_COMPONENT_221 = chr(100572)
TANGUT_COMPONENT_222 = chr(100573)
TANGUT_COMPONENT_223 = chr(100574)
TANGUT_COMPONENT_224 = chr(100575)
TANGUT_COMPONENT_225 = chr(100576)
TANGUT_COMPONENT_226 = chr(100577)
TANGUT_COMPONENT_227 = chr(100578)
TANGUT_COMPONENT_228 = chr(100579)
TANGUT_COMPONENT_229 = chr(100580)
TANGUT_COMPONENT_230 = chr(100581)
TANGUT_COMPONENT_231 = chr(100582)
TANGUT_COMPONENT_232 = chr(100583)
TANGUT_COMPONENT_233 = chr(100584)
TANGUT_COMPONENT_234 = chr(100585)
TANGUT_COMPONENT_235 = chr(100586)
TANGUT_COMPONENT_236 = chr(100587)
TANGUT_COMPONENT_237 = chr(100588)
TANGUT_COMPONENT_238 = chr(100589)
TANGUT_COMPONENT_239 = chr(100590)
TANGUT_COMPONENT_240 = chr(100591)
TANGUT_COMPONENT_241 = chr(100592)
TANGUT_COMPONENT_242 = chr(100593)
TANGUT_COMPONENT_243 = chr(100594)
TANGUT_COMPONENT_244 = chr(100595)
TANGUT_COMPONENT_245 = chr(100596)
TANGUT_COMPONENT_246 = chr(100597)
TANGUT_COMPONENT_247 = chr(100598)
TANGUT_COMPONENT_248 = chr(100599)
TANGUT_COMPONENT_249 = chr(100600)
TANGUT_COMPONENT_250 = chr(100601)
TANGUT_COMPONENT_251 = chr(100602)
TANGUT_COMPONENT_252 = chr(100603)
TANGUT_COMPONENT_253 = chr(100604)
TANGUT_COMPONENT_254 = chr(100605)
TANGUT_COMPONENT_255 = chr(100606)
TANGUT_COMPONENT_256 = chr(100607)
TANGUT_COMPONENT_257 = chr(100608)
TANGUT_COMPONENT_258 = chr(100609)
TANGUT_COMPONENT_259 = chr(100610)
TANGUT_COMPONENT_260 = chr(100611)
TANGUT_COMPONENT_261 = chr(100612)
TANGUT_COMPONENT_262 = chr(100613)
TANGUT_COMPONENT_263 = chr(100614)
TANGUT_COMPONENT_264 = chr(100615)
TANGUT_COMPONENT_265 = chr(100616)
TANGUT_COMPONENT_266 = chr(100617)
TANGUT_COMPONENT_267 = chr(100618)
TANGUT_COMPONENT_268 = chr(100619)
TANGUT_COMPONENT_269 = chr(100620)
TANGUT_COMPONENT_270 = chr(100621)
TANGUT_COMPONENT_271 = chr(100622)
TANGUT_COMPONENT_272 = chr(100623)
TANGUT_COMPONENT_273 = chr(100624)
TANGUT_COMPONENT_274 = chr(100625)
TANGUT_COMPONENT_275 = chr(100626)
TANGUT_COMPONENT_276 = chr(100627)
TANGUT_COMPONENT_277 = chr(100628)
TANGUT_COMPONENT_278 = chr(100629)
TANGUT_COMPONENT_279 = chr(100630)
TANGUT_COMPONENT_280 = chr(100631)
TANGUT_COMPONENT_281 = chr(100632)
TANGUT_COMPONENT_282 = chr(100633)
TANGUT_COMPONENT_283 = chr(100634)
TANGUT_COMPONENT_284 = chr(100635)
TANGUT_COMPONENT_285 = chr(100636)
TANGUT_COMPONENT_286 = chr(100637)
TANGUT_COMPONENT_287 = chr(100638)
TANGUT_COMPONENT_288 = chr(100639)
TANGUT_COMPONENT_289 = chr(100640)
TANGUT_COMPONENT_290 = chr(100641)
TANGUT_COMPONENT_291 = chr(100642)
TANGUT_COMPONENT_292 = chr(100643)
TANGUT_COMPONENT_293 = chr(100644)
TANGUT_COMPONENT_294 = chr(100645)
TANGUT_COMPONENT_295 = chr(100646)
TANGUT_COMPONENT_296 = chr(100647)
TANGUT_COMPONENT_297 = chr(100648)
TANGUT_COMPONENT_298 = chr(100649)
TANGUT_COMPONENT_299 = chr(100650)
TANGUT_COMPONENT_300 = chr(100651)
TANGUT_COMPONENT_301 = chr(100652)
TANGUT_COMPONENT_302 = chr(100653)
TANGUT_COMPONENT_303 = chr(100654)
TANGUT_COMPONENT_304 = chr(100655)
TANGUT_COMPONENT_305 = chr(100656)
TANGUT_COMPONENT_306 = chr(100657)
TANGUT_COMPONENT_307 = chr(100658)
TANGUT_COMPONENT_308 = chr(100659)
TANGUT_COMPONENT_309 = chr(100660)
TANGUT_COMPONENT_310 = chr(100661)
TANGUT_COMPONENT_311 = chr(100662)
TANGUT_COMPONENT_312 = chr(100663)
TANGUT_COMPONENT_313 = chr(100664)
TANGUT_COMPONENT_314 = chr(100665)
TANGUT_COMPONENT_315 = chr(100666)
TANGUT_COMPONENT_316 = chr(100667)
TANGUT_COMPONENT_317 = chr(100668)
TANGUT_COMPONENT_318 = chr(100669)
TANGUT_COMPONENT_319 = chr(100670)
TANGUT_COMPONENT_320 = chr(100671)
TANGUT_COMPONENT_321 = chr(100672)
TANGUT_COMPONENT_322 = chr(100673)
TANGUT_COMPONENT_323 = chr(100674)
TANGUT_COMPONENT_324 = chr(100675)
TANGUT_COMPONENT_325 = chr(100676)
TANGUT_COMPONENT_326 = chr(100677)
TANGUT_COMPONENT_327 = chr(100678)
TANGUT_COMPONENT_328 = chr(100679)
TANGUT_COMPONENT_329 = chr(100680)
TANGUT_COMPONENT_330 = chr(100681)
TANGUT_COMPONENT_331 = chr(100682)
TANGUT_COMPONENT_332 = chr(100683)
TANGUT_COMPONENT_333 = chr(100684)
TANGUT_COMPONENT_334 = chr(100685)
TANGUT_COMPONENT_335 = chr(100686)
TANGUT_COMPONENT_336 = chr(100687)
TANGUT_COMPONENT_337 = chr(100688)
TANGUT_COMPONENT_338 = chr(100689)
TANGUT_COMPONENT_339 = chr(100690)
TANGUT_COMPONENT_340 = chr(100691)
TANGUT_COMPONENT_341 = chr(100692)
TANGUT_COMPONENT_342 = chr(100693)
TANGUT_COMPONENT_343 = chr(100694)
TANGUT_COMPONENT_344 = chr(100695)
TANGUT_COMPONENT_345 = chr(100696)
TANGUT_COMPONENT_346 = chr(100697)
TANGUT_COMPONENT_347 = chr(100698)
TANGUT_COMPONENT_348 = chr(100699)
TANGUT_COMPONENT_349 = chr(100700)
TANGUT_COMPONENT_350 = chr(100701)
TANGUT_COMPONENT_351 = chr(100702)
TANGUT_COMPONENT_352 = chr(100703)
TANGUT_COMPONENT_353 = chr(100704)
TANGUT_COMPONENT_354 = chr(100705)
TANGUT_COMPONENT_355 = chr(100706)
TANGUT_COMPONENT_356 = chr(100707)
TANGUT_COMPONENT_357 = chr(100708)
TANGUT_COMPONENT_358 = chr(100709)
TANGUT_COMPONENT_359 = chr(100710)
TANGUT_COMPONENT_360 = chr(100711)
TANGUT_COMPONENT_361 = chr(100712)
TANGUT_COMPONENT_362 = chr(100713)
TANGUT_COMPONENT_363 = chr(100714)
TANGUT_COMPONENT_364 = chr(100715)
TANGUT_COMPONENT_365 = chr(100716)
TANGUT_COMPONENT_366 = chr(100717)
TANGUT_COMPONENT_367 = chr(100718)
TANGUT_COMPONENT_368 = chr(100719)
TANGUT_COMPONENT_369 = chr(100720)
TANGUT_COMPONENT_370 = chr(100721)
TANGUT_COMPONENT_371 = chr(100722)
TANGUT_COMPONENT_372 = chr(100723)
TANGUT_COMPONENT_373 = chr(100724)
TANGUT_COMPONENT_374 = chr(100725)
TANGUT_COMPONENT_375 = chr(100726)
TANGUT_COMPONENT_376 = chr(100727)
TANGUT_COMPONENT_377 = chr(100728)
TANGUT_COMPONENT_378 = chr(100729)
TANGUT_COMPONENT_379 = chr(100730)
TANGUT_COMPONENT_380 = chr(100731)
TANGUT_COMPONENT_381 = chr(100732)
TANGUT_COMPONENT_382 = chr(100733)
TANGUT_COMPONENT_383 = chr(100734)
TANGUT_COMPONENT_384 = chr(100735)
TANGUT_COMPONENT_385 = chr(100736)
TANGUT_COMPONENT_386 = chr(100737)
TANGUT_COMPONENT_387 = chr(100738)
TANGUT_COMPONENT_388 = chr(100739)
TANGUT_COMPONENT_389 = chr(100740)
TANGUT_COMPONENT_390 = chr(100741)
TANGUT_COMPONENT_391 = chr(100742)
TANGUT_COMPONENT_392 = chr(100743)
TANGUT_COMPONENT_393 = chr(100744)
TANGUT_COMPONENT_394 = chr(100745)
TANGUT_COMPONENT_395 = chr(100746)
TANGUT_COMPONENT_396 = chr(100747)
TANGUT_COMPONENT_397 = chr(100748)
TANGUT_COMPONENT_398 = chr(100749)
TANGUT_COMPONENT_399 = chr(100750)
TANGUT_COMPONENT_400 = chr(100751)
TANGUT_COMPONENT_401 = chr(100752)
TANGUT_COMPONENT_402 = chr(100753)
TANGUT_COMPONENT_403 = chr(100754)
TANGUT_COMPONENT_404 = chr(100755)
TANGUT_COMPONENT_405 = chr(100756)
TANGUT_COMPONENT_406 = chr(100757)
TANGUT_COMPONENT_407 = chr(100758)
TANGUT_COMPONENT_408 = chr(100759)
TANGUT_COMPONENT_409 = chr(100760)
TANGUT_COMPONENT_410 = chr(100761)
TANGUT_COMPONENT_411 = chr(100762)
TANGUT_COMPONENT_412 = chr(100763)
TANGUT_COMPONENT_413 = chr(100764)
TANGUT_COMPONENT_414 = chr(100765)
TANGUT_COMPONENT_415 = chr(100766)
TANGUT_COMPONENT_416 = chr(100767)
TANGUT_COMPONENT_417 = chr(100768)
TANGUT_COMPONENT_418 = chr(100769)
TANGUT_COMPONENT_419 = chr(100770)
TANGUT_COMPONENT_420 = chr(100771)
TANGUT_COMPONENT_421 = chr(100772)
TANGUT_COMPONENT_422 = chr(100773)
TANGUT_COMPONENT_423 = chr(100774)
TANGUT_COMPONENT_424 = chr(100775)
TANGUT_COMPONENT_425 = chr(100776)
TANGUT_COMPONENT_426 = chr(100777)
TANGUT_COMPONENT_427 = chr(100778)
TANGUT_COMPONENT_428 = chr(100779)
TANGUT_COMPONENT_429 = chr(100780)
TANGUT_COMPONENT_430 = chr(100781)
TANGUT_COMPONENT_431 = chr(100782)
TANGUT_COMPONENT_432 = chr(100783)
TANGUT_COMPONENT_433 = chr(100784)
TANGUT_COMPONENT_434 = chr(100785)
TANGUT_COMPONENT_435 = chr(100786)
TANGUT_COMPONENT_436 = chr(100787)
TANGUT_COMPONENT_437 = chr(100788)
TANGUT_COMPONENT_438 = chr(100789)
TANGUT_COMPONENT_439 = chr(100790)
TANGUT_COMPONENT_440 = chr(100791)
TANGUT_COMPONENT_441 = chr(100792)
TANGUT_COMPONENT_442 = chr(100793)
TANGUT_COMPONENT_443 = chr(100794)
TANGUT_COMPONENT_444 = chr(100795)
TANGUT_COMPONENT_445 = chr(100796)
TANGUT_COMPONENT_446 = chr(100797)
TANGUT_COMPONENT_447 = chr(100798)
TANGUT_COMPONENT_448 = chr(100799)
TANGUT_COMPONENT_449 = chr(100800)
TANGUT_COMPONENT_450 = chr(100801)
TANGUT_COMPONENT_451 = chr(100802)
TANGUT_COMPONENT_452 = chr(100803)
TANGUT_COMPONENT_453 = chr(100804)
TANGUT_COMPONENT_454 = chr(100805)
TANGUT_COMPONENT_455 = chr(100806)
TANGUT_COMPONENT_456 = chr(100807)
TANGUT_COMPONENT_457 = chr(100808)
TANGUT_COMPONENT_458 = chr(100809)
TANGUT_COMPONENT_459 = chr(100810)
TANGUT_COMPONENT_460 = chr(100811)
TANGUT_COMPONENT_461 = chr(100812)
TANGUT_COMPONENT_462 = chr(100813)
TANGUT_COMPONENT_463 = chr(100814)
TANGUT_COMPONENT_464 = chr(100815)
TANGUT_COMPONENT_465 = chr(100816)
TANGUT_COMPONENT_466 = chr(100817)
TANGUT_COMPONENT_467 = chr(100818)
TANGUT_COMPONENT_468 = chr(100819)
TANGUT_COMPONENT_469 = chr(100820)
TANGUT_COMPONENT_470 = chr(100821)
TANGUT_COMPONENT_471 = chr(100822)
TANGUT_COMPONENT_472 = chr(100823)
TANGUT_COMPONENT_473 = chr(100824)
TANGUT_COMPONENT_474 = chr(100825)
TANGUT_COMPONENT_475 = chr(100826)
TANGUT_COMPONENT_476 = chr(100827)
TANGUT_COMPONENT_477 = chr(100828)
TANGUT_COMPONENT_478 = chr(100829)
TANGUT_COMPONENT_479 = chr(100830)
TANGUT_COMPONENT_480 = chr(100831)
TANGUT_COMPONENT_481 = chr(100832)
TANGUT_COMPONENT_482 = chr(100833)
TANGUT_COMPONENT_483 = chr(100834)
TANGUT_COMPONENT_484 = chr(100835)
TANGUT_COMPONENT_485 = chr(100836)
TANGUT_COMPONENT_486 = chr(100837)
TANGUT_COMPONENT_487 = chr(100838)
TANGUT_COMPONENT_488 = chr(100839)
TANGUT_COMPONENT_489 = chr(100840)
TANGUT_COMPONENT_490 = chr(100841)
TANGUT_COMPONENT_491 = chr(100842)
TANGUT_COMPONENT_492 = chr(100843)
TANGUT_COMPONENT_493 = chr(100844)
TANGUT_COMPONENT_494 = chr(100845)
TANGUT_COMPONENT_495 = chr(100846)
TANGUT_COMPONENT_496 = chr(100847)
TANGUT_COMPONENT_497 = chr(100848)
TANGUT_COMPONENT_498 = chr(100849)
TANGUT_COMPONENT_499 = chr(100850)
TANGUT_COMPONENT_500 = chr(100851)
TANGUT_COMPONENT_501 = chr(100852)
TANGUT_COMPONENT_502 = chr(100853)
TANGUT_COMPONENT_503 = chr(100854)
TANGUT_COMPONENT_504 = chr(100855)
TANGUT_COMPONENT_505 = chr(100856)
TANGUT_COMPONENT_506 = chr(100857)
TANGUT_COMPONENT_507 = chr(100858)
TANGUT_COMPONENT_508 = chr(100859)
TANGUT_COMPONENT_509 = chr(100860)
TANGUT_COMPONENT_510 = chr(100861)
TANGUT_COMPONENT_511 = chr(100862)
TANGUT_COMPONENT_512 = chr(100863)
TANGUT_COMPONENT_513 = chr(100864)
TANGUT_COMPONENT_514 = chr(100865)
TANGUT_COMPONENT_515 = chr(100866)
TANGUT_COMPONENT_516 = chr(100867)
TANGUT_COMPONENT_517 = chr(100868)
TANGUT_COMPONENT_518 = chr(100869)
TANGUT_COMPONENT_519 = chr(100870)
TANGUT_COMPONENT_520 = chr(100871)
TANGUT_COMPONENT_521 = chr(100872)
TANGUT_COMPONENT_522 = chr(100873)
TANGUT_COMPONENT_523 = chr(100874)
TANGUT_COMPONENT_524 = chr(100875)
TANGUT_COMPONENT_525 = chr(100876)
TANGUT_COMPONENT_526 = chr(100877)
TANGUT_COMPONENT_527 = chr(100878)
TANGUT_COMPONENT_528 = chr(100879)
TANGUT_COMPONENT_529 = chr(100880)
TANGUT_COMPONENT_530 = chr(100881)
TANGUT_COMPONENT_531 = chr(100882)
TANGUT_COMPONENT_532 = chr(100883)
TANGUT_COMPONENT_533 = chr(100884)
TANGUT_COMPONENT_534 = chr(100885)
TANGUT_COMPONENT_535 = chr(100886)
TANGUT_COMPONENT_536 = chr(100887)
TANGUT_COMPONENT_537 = chr(100888)
TANGUT_COMPONENT_538 = chr(100889)
TANGUT_COMPONENT_539 = chr(100890)
TANGUT_COMPONENT_540 = chr(100891)
TANGUT_COMPONENT_541 = chr(100892)
TANGUT_COMPONENT_542 = chr(100893)
TANGUT_COMPONENT_543 = chr(100894)
TANGUT_COMPONENT_544 = chr(100895)
TANGUT_COMPONENT_545 = chr(100896)
TANGUT_COMPONENT_546 = chr(100897)
TANGUT_COMPONENT_547 = chr(100898)
TANGUT_COMPONENT_548 = chr(100899)
TANGUT_COMPONENT_549 = chr(100900)
TANGUT_COMPONENT_550 = chr(100901)
TANGUT_COMPONENT_551 = chr(100902)
TANGUT_COMPONENT_552 = chr(100903)
TANGUT_COMPONENT_553 = chr(100904)
TANGUT_COMPONENT_554 = chr(100905)
TANGUT_COMPONENT_555 = chr(100906)
TANGUT_COMPONENT_556 = chr(100907)
TANGUT_COMPONENT_557 = chr(100908)
TANGUT_COMPONENT_558 = chr(100909)
TANGUT_COMPONENT_559 = chr(100910)
TANGUT_COMPONENT_560 = chr(100911)
TANGUT_COMPONENT_561 = chr(100912)
TANGUT_COMPONENT_562 = chr(100913)
TANGUT_COMPONENT_563 = chr(100914)
TANGUT_COMPONENT_564 = chr(100915)
TANGUT_COMPONENT_565 = chr(100916)
TANGUT_COMPONENT_566 = chr(100917)
TANGUT_COMPONENT_567 = chr(100918)
TANGUT_COMPONENT_568 = chr(100919)
TANGUT_COMPONENT_569 = chr(100920)
TANGUT_COMPONENT_570 = chr(100921)
TANGUT_COMPONENT_571 = chr(100922)
TANGUT_COMPONENT_572 = chr(100923)
TANGUT_COMPONENT_573 = chr(100924)
TANGUT_COMPONENT_574 = chr(100925)
TANGUT_COMPONENT_575 = chr(100926)
TANGUT_COMPONENT_576 = chr(100927)
TANGUT_COMPONENT_577 = chr(100928)
TANGUT_COMPONENT_578 = chr(100929)
TANGUT_COMPONENT_579 = chr(100930)
TANGUT_COMPONENT_580 = chr(100931)
TANGUT_COMPONENT_581 = chr(100932)
TANGUT_COMPONENT_582 = chr(100933)
TANGUT_COMPONENT_583 = chr(100934)
TANGUT_COMPONENT_584 = chr(100935)
TANGUT_COMPONENT_585 = chr(100936)
TANGUT_COMPONENT_586 = chr(100937)
TANGUT_COMPONENT_587 = chr(100938)
TANGUT_COMPONENT_588 = chr(100939)
TANGUT_COMPONENT_589 = chr(100940)
TANGUT_COMPONENT_590 = chr(100941)
TANGUT_COMPONENT_591 = chr(100942)
TANGUT_COMPONENT_592 = chr(100943)
TANGUT_COMPONENT_593 = chr(100944)
TANGUT_COMPONENT_594 = chr(100945)
TANGUT_COMPONENT_595 = chr(100946)
TANGUT_COMPONENT_596 = chr(100947)
TANGUT_COMPONENT_597 = chr(100948)
TANGUT_COMPONENT_598 = chr(100949)
TANGUT_COMPONENT_599 = chr(100950)
TANGUT_COMPONENT_600 = chr(100951)
TANGUT_COMPONENT_601 = chr(100952)
TANGUT_COMPONENT_602 = chr(100953)
TANGUT_COMPONENT_603 = chr(100954)
TANGUT_COMPONENT_604 = chr(100955)
TANGUT_COMPONENT_605 = chr(100956)
TANGUT_COMPONENT_606 = chr(100957)
TANGUT_COMPONENT_607 = chr(100958)
TANGUT_COMPONENT_608 = chr(100959)
TANGUT_COMPONENT_609 = chr(100960)
TANGUT_COMPONENT_610 = chr(100961)
TANGUT_COMPONENT_611 = chr(100962)
TANGUT_COMPONENT_612 = chr(100963)
TANGUT_COMPONENT_613 = chr(100964)
TANGUT_COMPONENT_614 = chr(100965)
TANGUT_COMPONENT_615 = chr(100966)
TANGUT_COMPONENT_616 = chr(100967)
TANGUT_COMPONENT_617 = chr(100968)
TANGUT_COMPONENT_618 = chr(100969)
TANGUT_COMPONENT_619 = chr(100970)
TANGUT_COMPONENT_620 = chr(100971)
TANGUT_COMPONENT_621 = chr(100972)
TANGUT_COMPONENT_622 = chr(100973)
TANGUT_COMPONENT_623 = chr(100974)
TANGUT_COMPONENT_624 = chr(100975)
TANGUT_COMPONENT_625 = chr(100976)
TANGUT_COMPONENT_626 = chr(100977)
TANGUT_COMPONENT_627 = chr(100978)
TANGUT_COMPONENT_628 = chr(100979)
TANGUT_COMPONENT_629 = chr(100980)
TANGUT_COMPONENT_630 = chr(100981)
TANGUT_COMPONENT_631 = chr(100982)
TANGUT_COMPONENT_632 = chr(100983)
TANGUT_COMPONENT_633 = chr(100984)
TANGUT_COMPONENT_634 = chr(100985)
TANGUT_COMPONENT_635 = chr(100986)
TANGUT_COMPONENT_636 = chr(100987)
TANGUT_COMPONENT_637 = chr(100988)
TANGUT_COMPONENT_638 = chr(100989)
TANGUT_COMPONENT_639 = chr(100990)
TANGUT_COMPONENT_640 = chr(100991)
TANGUT_COMPONENT_641 = chr(100992)
TANGUT_COMPONENT_642 = chr(100993)
TANGUT_COMPONENT_643 = chr(100994)
TANGUT_COMPONENT_644 = chr(100995)
TANGUT_COMPONENT_645 = chr(100996)
TANGUT_COMPONENT_646 = chr(100997)
TANGUT_COMPONENT_647 = chr(100998)
TANGUT_COMPONENT_648 = chr(100999)
TANGUT_COMPONENT_649 = chr(101000)
TANGUT_COMPONENT_650 = chr(101001)
TANGUT_COMPONENT_651 = chr(101002)
TANGUT_COMPONENT_652 = chr(101003)
TANGUT_COMPONENT_653 = chr(101004)
TANGUT_COMPONENT_654 = chr(101005)
TANGUT_COMPONENT_655 = chr(101006)
TANGUT_COMPONENT_656 = chr(101007)
TANGUT_COMPONENT_657 = chr(101008)
TANGUT_COMPONENT_658 = chr(101009)
TANGUT_COMPONENT_659 = chr(101010)
TANGUT_COMPONENT_660 = chr(101011)
TANGUT_COMPONENT_661 = chr(101012)
TANGUT_COMPONENT_662 = chr(101013)
TANGUT_COMPONENT_663 = chr(101014)
TANGUT_COMPONENT_664 = chr(101015)
TANGUT_COMPONENT_665 = chr(101016)
TANGUT_COMPONENT_666 = chr(101017)
TANGUT_COMPONENT_667 = chr(101018)
TANGUT_COMPONENT_668 = chr(101019)
TANGUT_COMPONENT_669 = chr(101020)
TANGUT_COMPONENT_670 = chr(101021)
TANGUT_COMPONENT_671 = chr(101022)
TANGUT_COMPONENT_672 = chr(101023)
TANGUT_COMPONENT_673 = chr(101024)
TANGUT_COMPONENT_674 = chr(101025)
TANGUT_COMPONENT_675 = chr(101026)
TANGUT_COMPONENT_676 = chr(101027)
TANGUT_COMPONENT_677 = chr(101028)
TANGUT_COMPONENT_678 = chr(101029)
TANGUT_COMPONENT_679 = chr(101030)
TANGUT_COMPONENT_680 = chr(101031)
TANGUT_COMPONENT_681 = chr(101032)
TANGUT_COMPONENT_682 = chr(101033)
TANGUT_COMPONENT_683 = chr(101034)
TANGUT_COMPONENT_684 = chr(101035)
TANGUT_COMPONENT_685 = chr(101036)
TANGUT_COMPONENT_686 = chr(101037)
TANGUT_COMPONENT_687 = chr(101038)
TANGUT_COMPONENT_688 = chr(101039)
TANGUT_COMPONENT_689 = chr(101040)
TANGUT_COMPONENT_690 = chr(101041)
TANGUT_COMPONENT_691 = chr(101042)
TANGUT_COMPONENT_692 = chr(101043)
TANGUT_COMPONENT_693 = chr(101044)
TANGUT_COMPONENT_694 = chr(101045)
TANGUT_COMPONENT_695 = chr(101046)
TANGUT_COMPONENT_696 = chr(101047)
TANGUT_COMPONENT_697 = chr(101048)
TANGUT_COMPONENT_698 = chr(101049)
TANGUT_COMPONENT_699 = chr(101050)
TANGUT_COMPONENT_700 = chr(101051)
TANGUT_COMPONENT_701 = chr(101052)
TANGUT_COMPONENT_702 = chr(101053)
TANGUT_COMPONENT_703 = chr(101054)
TANGUT_COMPONENT_704 = chr(101055)
TANGUT_COMPONENT_705 = chr(101056)
TANGUT_COMPONENT_706 = chr(101057)
TANGUT_COMPONENT_707 = chr(101058)
TANGUT_COMPONENT_708 = chr(101059)
TANGUT_COMPONENT_709 = chr(101060)
TANGUT_COMPONENT_710 = chr(101061)
TANGUT_COMPONENT_711 = chr(101062)
TANGUT_COMPONENT_712 = chr(101063)
TANGUT_COMPONENT_713 = chr(101064)
TANGUT_COMPONENT_714 = chr(101065)
TANGUT_COMPONENT_715 = chr(101066)
TANGUT_COMPONENT_716 = chr(101067)
TANGUT_COMPONENT_717 = chr(101068)
TANGUT_COMPONENT_718 = chr(101069)
TANGUT_COMPONENT_719 = chr(101070)
TANGUT_COMPONENT_720 = chr(101071)
TANGUT_COMPONENT_721 = chr(101072)
TANGUT_COMPONENT_722 = chr(101073)
TANGUT_COMPONENT_723 = chr(101074)
TANGUT_COMPONENT_724 = chr(101075)
TANGUT_COMPONENT_725 = chr(101076)
TANGUT_COMPONENT_726 = chr(101077)
TANGUT_COMPONENT_727 = chr(101078)
TANGUT_COMPONENT_728 = chr(101079)
TANGUT_COMPONENT_729 = chr(101080)
TANGUT_COMPONENT_730 = chr(101081)
TANGUT_COMPONENT_731 = chr(101082)
TANGUT_COMPONENT_732 = chr(101083)
TANGUT_COMPONENT_733 = chr(101084)
TANGUT_COMPONENT_734 = chr(101085)
TANGUT_COMPONENT_735 = chr(101086)
TANGUT_COMPONENT_736 = chr(101087)
TANGUT_COMPONENT_737 = chr(101088)
TANGUT_COMPONENT_738 = chr(101089)
TANGUT_COMPONENT_739 = chr(101090)
TANGUT_COMPONENT_740 = chr(101091)
TANGUT_COMPONENT_741 = chr(101092)
TANGUT_COMPONENT_742 = chr(101093)
TANGUT_COMPONENT_743 = chr(101094)
TANGUT_COMPONENT_744 = chr(101095)
TANGUT_COMPONENT_745 = chr(101096)
TANGUT_COMPONENT_746 = chr(101097)
TANGUT_COMPONENT_747 = chr(101098)
TANGUT_COMPONENT_748 = chr(101099)
TANGUT_COMPONENT_749 = chr(101100)
TANGUT_COMPONENT_750 = chr(101101)
TANGUT_COMPONENT_751 = chr(101102)
TANGUT_COMPONENT_752 = chr(101103)
TANGUT_COMPONENT_753 = chr(101104)
TANGUT_COMPONENT_754 = chr(101105)
TANGUT_COMPONENT_755 = chr(101106)
TANGUT_COMPONENT_756 = chr(101107)
TANGUT_COMPONENT_757 = chr(101108)
TANGUT_COMPONENT_758 = chr(101109)
TANGUT_COMPONENT_759 = chr(101110)
TANGUT_COMPONENT_760 = chr(101111)
TANGUT_COMPONENT_761 = chr(101112)
TANGUT_COMPONENT_762 = chr(101113)
TANGUT_COMPONENT_763 = chr(101114)
TANGUT_COMPONENT_764 = chr(101115)
TANGUT_COMPONENT_765 = chr(101116)
TANGUT_COMPONENT_766 = chr(101117)
TANGUT_COMPONENT_767 = chr(101118)
TANGUT_COMPONENT_768 = chr(101119)
KHITAN_SMALL_SCRIPT_CHARACTER_18B00 = chr(101120)
KHITAN_SMALL_SCRIPT_CHARACTER_18B01 = chr(101121)
KHITAN_SMALL_SCRIPT_CHARACTER_18B02 = chr(101122)
KHITAN_SMALL_SCRIPT_CHARACTER_18B03 = chr(101123)
KHITAN_SMALL_SCRIPT_CHARACTER_18B04 = chr(101124)
KHITAN_SMALL_SCRIPT_CHARACTER_18B05 = chr(101125)
KHITAN_SMALL_SCRIPT_CHARACTER_18B06 = chr(101126)
KHITAN_SMALL_SCRIPT_CHARACTER_18B07 = chr(101127)
KHITAN_SMALL_SCRIPT_CHARACTER_18B08 = chr(101128)
KHITAN_SMALL_SCRIPT_CHARACTER_18B09 = chr(101129)
KHITAN_SMALL_SCRIPT_CHARACTER_18B0A = chr(101130)
KHITAN_SMALL_SCRIPT_CHARACTER_18B0B = chr(101131)
KHITAN_SMALL_SCRIPT_CHARACTER_18B0C = chr(101132)
KHITAN_SMALL_SCRIPT_CHARACTER_18B0D = chr(101133)
KHITAN_SMALL_SCRIPT_CHARACTER_18B0E = chr(101134)
KHITAN_SMALL_SCRIPT_CHARACTER_18B0F = chr(101135)
KHITAN_SMALL_SCRIPT_CHARACTER_18B10 = chr(101136)
KHITAN_SMALL_SCRIPT_CHARACTER_18B11 = chr(101137)
KHITAN_SMALL_SCRIPT_CHARACTER_18B12 = chr(101138)
KHITAN_SMALL_SCRIPT_CHARACTER_18B13 = chr(101139)
KHITAN_SMALL_SCRIPT_CHARACTER_18B14 = chr(101140)
KHITAN_SMALL_SCRIPT_CHARACTER_18B15 = chr(101141)
KHITAN_SMALL_SCRIPT_CHARACTER_18B16 = chr(101142)
KHITAN_SMALL_SCRIPT_CHARACTER_18B17 = chr(101143)
KHITAN_SMALL_SCRIPT_CHARACTER_18B18 = chr(101144)
KHITAN_SMALL_SCRIPT_CHARACTER_18B19 = chr(101145)
KHITAN_SMALL_SCRIPT_CHARACTER_18B1A = chr(101146)
KHITAN_SMALL_SCRIPT_CHARACTER_18B1B = chr(101147)
KHITAN_SMALL_SCRIPT_CHARACTER_18B1C = chr(101148)
KHITAN_SMALL_SCRIPT_CHARACTER_18B1D = chr(101149)
KHITAN_SMALL_SCRIPT_CHARACTER_18B1E = chr(101150)
KHITAN_SMALL_SCRIPT_CHARACTER_18B1F = chr(101151)
KHITAN_SMALL_SCRIPT_CHARACTER_18B20 = chr(101152)
KHITAN_SMALL_SCRIPT_CHARACTER_18B21 = chr(101153)
KHITAN_SMALL_SCRIPT_CHARACTER_18B22 = chr(101154)
KHITAN_SMALL_SCRIPT_CHARACTER_18B23 = chr(101155)
KHITAN_SMALL_SCRIPT_CHARACTER_18B24 = chr(101156)
KHITAN_SMALL_SCRIPT_CHARACTER_18B25 = chr(101157)
KHITAN_SMALL_SCRIPT_CHARACTER_18B26 = chr(101158)
KHITAN_SMALL_SCRIPT_CHARACTER_18B27 = chr(101159)
KHITAN_SMALL_SCRIPT_CHARACTER_18B28 = chr(101160)
KHITAN_SMALL_SCRIPT_CHARACTER_18B29 = chr(101161)
KHITAN_SMALL_SCRIPT_CHARACTER_18B2A = chr(101162)
KHITAN_SMALL_SCRIPT_CHARACTER_18B2B = chr(101163)
KHITAN_SMALL_SCRIPT_CHARACTER_18B2C = chr(101164)
KHITAN_SMALL_SCRIPT_CHARACTER_18B2D = chr(101165)
KHITAN_SMALL_SCRIPT_CHARACTER_18B2E = chr(101166)
KHITAN_SMALL_SCRIPT_CHARACTER_18B2F = chr(101167)
KHITAN_SMALL_SCRIPT_CHARACTER_18B30 = chr(101168)
KHITAN_SMALL_SCRIPT_CHARACTER_18B31 = chr(101169)
KHITAN_SMALL_SCRIPT_CHARACTER_18B32 = chr(101170)
KHITAN_SMALL_SCRIPT_CHARACTER_18B33 = chr(101171)
KHITAN_SMALL_SCRIPT_CHARACTER_18B34 = chr(101172)
KHITAN_SMALL_SCRIPT_CHARACTER_18B35 = chr(101173)
KHITAN_SMALL_SCRIPT_CHARACTER_18B36 = chr(101174)
KHITAN_SMALL_SCRIPT_CHARACTER_18B37 = chr(101175)
KHITAN_SMALL_SCRIPT_CHARACTER_18B38 = chr(101176)
KHITAN_SMALL_SCRIPT_CHARACTER_18B39 = chr(101177)
KHITAN_SMALL_SCRIPT_CHARACTER_18B3A = chr(101178)
KHITAN_SMALL_SCRIPT_CHARACTER_18B3B = chr(101179)
KHITAN_SMALL_SCRIPT_CHARACTER_18B3C = chr(101180)
KHITAN_SMALL_SCRIPT_CHARACTER_18B3D = chr(101181)
KHITAN_SMALL_SCRIPT_CHARACTER_18B3E = chr(101182)
KHITAN_SMALL_SCRIPT_CHARACTER_18B3F = chr(101183)
KHITAN_SMALL_SCRIPT_CHARACTER_18B40 = chr(101184)
KHITAN_SMALL_SCRIPT_CHARACTER_18B41 = chr(101185)
KHITAN_SMALL_SCRIPT_CHARACTER_18B42 = chr(101186)
KHITAN_SMALL_SCRIPT_CHARACTER_18B43 = chr(101187)
KHITAN_SMALL_SCRIPT_CHARACTER_18B44 = chr(101188)
KHITAN_SMALL_SCRIPT_CHARACTER_18B45 = chr(101189)
KHITAN_SMALL_SCRIPT_CHARACTER_18B46 = chr(101190)
KHITAN_SMALL_SCRIPT_CHARACTER_18B47 = chr(101191)
KHITAN_SMALL_SCRIPT_CHARACTER_18B48 = chr(101192)
KHITAN_SMALL_SCRIPT_CHARACTER_18B49 = chr(101193)
KHITAN_SMALL_SCRIPT_CHARACTER_18B4A = chr(101194)
KHITAN_SMALL_SCRIPT_CHARACTER_18B4B = chr(101195)
KHITAN_SMALL_SCRIPT_CHARACTER_18B4C = chr(101196)
KHITAN_SMALL_SCRIPT_CHARACTER_18B4D = chr(101197)
KHITAN_SMALL_SCRIPT_CHARACTER_18B4E = chr(101198)
KHITAN_SMALL_SCRIPT_CHARACTER_18B4F = chr(101199)
KHITAN_SMALL_SCRIPT_CHARACTER_18B50 = chr(101200)
KHITAN_SMALL_SCRIPT_CHARACTER_18B51 = chr(101201)
KHITAN_SMALL_SCRIPT_CHARACTER_18B52 = chr(101202)
KHITAN_SMALL_SCRIPT_CHARACTER_18B53 = chr(101203)
KHITAN_SMALL_SCRIPT_CHARACTER_18B54 = chr(101204)
KHITAN_SMALL_SCRIPT_CHARACTER_18B55 = chr(101205)
KHITAN_SMALL_SCRIPT_CHARACTER_18B56 = chr(101206)
KHITAN_SMALL_SCRIPT_CHARACTER_18B57 = chr(101207)
KHITAN_SMALL_SCRIPT_CHARACTER_18B58 = chr(101208)
KHITAN_SMALL_SCRIPT_CHARACTER_18B59 = chr(101209)
KHITAN_SMALL_SCRIPT_CHARACTER_18B5A = chr(101210)
KHITAN_SMALL_SCRIPT_CHARACTER_18B5B = chr(101211)
KHITAN_SMALL_SCRIPT_CHARACTER_18B5C = chr(101212)
KHITAN_SMALL_SCRIPT_CHARACTER_18B5D = chr(101213)
KHITAN_SMALL_SCRIPT_CHARACTER_18B5E = chr(101214)
KHITAN_SMALL_SCRIPT_CHARACTER_18B5F = chr(101215)
KHITAN_SMALL_SCRIPT_CHARACTER_18B60 = chr(101216)
KHITAN_SMALL_SCRIPT_CHARACTER_18B61 = chr(101217)
KHITAN_SMALL_SCRIPT_CHARACTER_18B62 = chr(101218)
KHITAN_SMALL_SCRIPT_CHARACTER_18B63 = chr(101219)
KHITAN_SMALL_SCRIPT_CHARACTER_18B64 = chr(101220)
KHITAN_SMALL_SCRIPT_CHARACTER_18B65 = chr(101221)
KHITAN_SMALL_SCRIPT_CHARACTER_18B66 = chr(101222)
KHITAN_SMALL_SCRIPT_CHARACTER_18B67 = chr(101223)
KHITAN_SMALL_SCRIPT_CHARACTER_18B68 = chr(101224)
KHITAN_SMALL_SCRIPT_CHARACTER_18B69 = chr(101225)
KHITAN_SMALL_SCRIPT_CHARACTER_18B6A = chr(101226)
KHITAN_SMALL_SCRIPT_CHARACTER_18B6B = chr(101227)
KHITAN_SMALL_SCRIPT_CHARACTER_18B6C = chr(101228)
KHITAN_SMALL_SCRIPT_CHARACTER_18B6D = chr(101229)
KHITAN_SMALL_SCRIPT_CHARACTER_18B6E = chr(101230)
KHITAN_SMALL_SCRIPT_CHARACTER_18B6F = chr(101231)
KHITAN_SMALL_SCRIPT_CHARACTER_18B70 = chr(101232)
KHITAN_SMALL_SCRIPT_CHARACTER_18B71 = chr(101233)
KHITAN_SMALL_SCRIPT_CHARACTER_18B72 = chr(101234)
KHITAN_SMALL_SCRIPT_CHARACTER_18B73 = chr(101235)
KHITAN_SMALL_SCRIPT_CHARACTER_18B74 = chr(101236)
KHITAN_SMALL_SCRIPT_CHARACTER_18B75 = chr(101237)
KHITAN_SMALL_SCRIPT_CHARACTER_18B76 = chr(101238)
KHITAN_SMALL_SCRIPT_CHARACTER_18B77 = chr(101239)
KHITAN_SMALL_SCRIPT_CHARACTER_18B78 = chr(101240)
KHITAN_SMALL_SCRIPT_CHARACTER_18B79 = chr(101241)
KHITAN_SMALL_SCRIPT_CHARACTER_18B7A = chr(101242)
KHITAN_SMALL_SCRIPT_CHARACTER_18B7B = chr(101243)
KHITAN_SMALL_SCRIPT_CHARACTER_18B7C = chr(101244)
KHITAN_SMALL_SCRIPT_CHARACTER_18B7D = chr(101245)
KHITAN_SMALL_SCRIPT_CHARACTER_18B7E = chr(101246)
KHITAN_SMALL_SCRIPT_CHARACTER_18B7F = chr(101247)
KHITAN_SMALL_SCRIPT_CHARACTER_18B80 = chr(101248)
KHITAN_SMALL_SCRIPT_CHARACTER_18B81 = chr(101249)
KHITAN_SMALL_SCRIPT_CHARACTER_18B82 = chr(101250)
KHITAN_SMALL_SCRIPT_CHARACTER_18B83 = chr(101251)
KHITAN_SMALL_SCRIPT_CHARACTER_18B84 = chr(101252)
KHITAN_SMALL_SCRIPT_CHARACTER_18B85 = chr(101253)
KHITAN_SMALL_SCRIPT_CHARACTER_18B86 = chr(101254)
KHITAN_SMALL_SCRIPT_CHARACTER_18B87 = chr(101255)
KHITAN_SMALL_SCRIPT_CHARACTER_18B88 = chr(101256)
KHITAN_SMALL_SCRIPT_CHARACTER_18B89 = chr(101257)
KHITAN_SMALL_SCRIPT_CHARACTER_18B8A = chr(101258)
KHITAN_SMALL_SCRIPT_CHARACTER_18B8B = chr(101259)
KHITAN_SMALL_SCRIPT_CHARACTER_18B8C = chr(101260)
KHITAN_SMALL_SCRIPT_CHARACTER_18B8D = chr(101261)
KHITAN_SMALL_SCRIPT_CHARACTER_18B8E = chr(101262)
KHITAN_SMALL_SCRIPT_CHARACTER_18B8F = chr(101263)
KHITAN_SMALL_SCRIPT_CHARACTER_18B90 = chr(101264)
KHITAN_SMALL_SCRIPT_CHARACTER_18B91 = chr(101265)
KHITAN_SMALL_SCRIPT_CHARACTER_18B92 = chr(101266)
KHITAN_SMALL_SCRIPT_CHARACTER_18B93 = chr(101267)
KHITAN_SMALL_SCRIPT_CHARACTER_18B94 = chr(101268)
KHITAN_SMALL_SCRIPT_CHARACTER_18B95 = chr(101269)
KHITAN_SMALL_SCRIPT_CHARACTER_18B96 = chr(101270)
KHITAN_SMALL_SCRIPT_CHARACTER_18B97 = chr(101271)
KHITAN_SMALL_SCRIPT_CHARACTER_18B98 = chr(101272)
KHITAN_SMALL_SCRIPT_CHARACTER_18B99 = chr(101273)
KHITAN_SMALL_SCRIPT_CHARACTER_18B9A = chr(101274)
KHITAN_SMALL_SCRIPT_CHARACTER_18B9B = chr(101275)
KHITAN_SMALL_SCRIPT_CHARACTER_18B9C = chr(101276)
KHITAN_SMALL_SCRIPT_CHARACTER_18B9D = chr(101277)
KHITAN_SMALL_SCRIPT_CHARACTER_18B9E = chr(101278)
KHITAN_SMALL_SCRIPT_CHARACTER_18B9F = chr(101279)
KHITAN_SMALL_SCRIPT_CHARACTER_18BA0 = chr(101280)
KHITAN_SMALL_SCRIPT_CHARACTER_18BA1 = chr(101281)
KHITAN_SMALL_SCRIPT_CHARACTER_18BA2 = chr(101282)
KHITAN_SMALL_SCRIPT_CHARACTER_18BA3 = chr(101283)
KHITAN_SMALL_SCRIPT_CHARACTER_18BA4 = chr(101284)
KHITAN_SMALL_SCRIPT_CHARACTER_18BA5 = chr(101285)
KHITAN_SMALL_SCRIPT_CHARACTER_18BA6 = chr(101286)
KHITAN_SMALL_SCRIPT_CHARACTER_18BA7 = chr(101287)
KHITAN_SMALL_SCRIPT_CHARACTER_18BA8 = chr(101288)
KHITAN_SMALL_SCRIPT_CHARACTER_18BA9 = chr(101289)
KHITAN_SMALL_SCRIPT_CHARACTER_18BAA = chr(101290)
KHITAN_SMALL_SCRIPT_CHARACTER_18BAB = chr(101291)
KHITAN_SMALL_SCRIPT_CHARACTER_18BAC = chr(101292)
KHITAN_SMALL_SCRIPT_CHARACTER_18BAD = chr(101293)
KHITAN_SMALL_SCRIPT_CHARACTER_18BAE = chr(101294)
KHITAN_SMALL_SCRIPT_CHARACTER_18BAF = chr(101295)
KHITAN_SMALL_SCRIPT_CHARACTER_18BB0 = chr(101296)
KHITAN_SMALL_SCRIPT_CHARACTER_18BB1 = chr(101297)
KHITAN_SMALL_SCRIPT_CHARACTER_18BB2 = chr(101298)
KHITAN_SMALL_SCRIPT_CHARACTER_18BB3 = chr(101299)
KHITAN_SMALL_SCRIPT_CHARACTER_18BB4 = chr(101300)
KHITAN_SMALL_SCRIPT_CHARACTER_18BB5 = chr(101301)
KHITAN_SMALL_SCRIPT_CHARACTER_18BB6 = chr(101302)
KHITAN_SMALL_SCRIPT_CHARACTER_18BB7 = chr(101303)
KHITAN_SMALL_SCRIPT_CHARACTER_18BB8 = chr(101304)
KHITAN_SMALL_SCRIPT_CHARACTER_18BB9 = chr(101305)
KHITAN_SMALL_SCRIPT_CHARACTER_18BBA = chr(101306)
KHITAN_SMALL_SCRIPT_CHARACTER_18BBB = chr(101307)
KHITAN_SMALL_SCRIPT_CHARACTER_18BBC = chr(101308)
KHITAN_SMALL_SCRIPT_CHARACTER_18BBD = chr(101309)
KHITAN_SMALL_SCRIPT_CHARACTER_18BBE = chr(101310)
KHITAN_SMALL_SCRIPT_CHARACTER_18BBF = chr(101311)
KHITAN_SMALL_SCRIPT_CHARACTER_18BC0 = chr(101312)
KHITAN_SMALL_SCRIPT_CHARACTER_18BC1 = chr(101313)
KHITAN_SMALL_SCRIPT_CHARACTER_18BC2 = chr(101314)
KHITAN_SMALL_SCRIPT_CHARACTER_18BC3 = chr(101315)
KHITAN_SMALL_SCRIPT_CHARACTER_18BC4 = chr(101316)
KHITAN_SMALL_SCRIPT_CHARACTER_18BC5 = chr(101317)
KHITAN_SMALL_SCRIPT_CHARACTER_18BC6 = chr(101318)
KHITAN_SMALL_SCRIPT_CHARACTER_18BC7 = chr(101319)
KHITAN_SMALL_SCRIPT_CHARACTER_18BC8 = chr(101320)
KHITAN_SMALL_SCRIPT_CHARACTER_18BC9 = chr(101321)
KHITAN_SMALL_SCRIPT_CHARACTER_18BCA = chr(101322)
KHITAN_SMALL_SCRIPT_CHARACTER_18BCB = chr(101323)
KHITAN_SMALL_SCRIPT_CHARACTER_18BCC = chr(101324)
KHITAN_SMALL_SCRIPT_CHARACTER_18BCD = chr(101325)
KHITAN_SMALL_SCRIPT_CHARACTER_18BCE = chr(101326)
KHITAN_SMALL_SCRIPT_CHARACTER_18BCF = chr(101327)
KHITAN_SMALL_SCRIPT_CHARACTER_18BD0 = chr(101328)
KHITAN_SMALL_SCRIPT_CHARACTER_18BD1 = chr(101329)
KHITAN_SMALL_SCRIPT_CHARACTER_18BD2 = chr(101330)
KHITAN_SMALL_SCRIPT_CHARACTER_18BD3 = chr(101331)
KHITAN_SMALL_SCRIPT_CHARACTER_18BD4 = chr(101332)
KHITAN_SMALL_SCRIPT_CHARACTER_18BD5 = chr(101333)
KHITAN_SMALL_SCRIPT_CHARACTER_18BD6 = chr(101334)
KHITAN_SMALL_SCRIPT_CHARACTER_18BD7 = chr(101335)
KHITAN_SMALL_SCRIPT_CHARACTER_18BD8 = chr(101336)
KHITAN_SMALL_SCRIPT_CHARACTER_18BD9 = chr(101337)
KHITAN_SMALL_SCRIPT_CHARACTER_18BDA = chr(101338)
KHITAN_SMALL_SCRIPT_CHARACTER_18BDB = chr(101339)
KHITAN_SMALL_SCRIPT_CHARACTER_18BDC = chr(101340)
KHITAN_SMALL_SCRIPT_CHARACTER_18BDD = chr(101341)
KHITAN_SMALL_SCRIPT_CHARACTER_18BDE = chr(101342)
KHITAN_SMALL_SCRIPT_CHARACTER_18BDF = chr(101343)
KHITAN_SMALL_SCRIPT_CHARACTER_18BE0 = chr(101344)
KHITAN_SMALL_SCRIPT_CHARACTER_18BE1 = chr(101345)
KHITAN_SMALL_SCRIPT_CHARACTER_18BE2 = chr(101346)
KHITAN_SMALL_SCRIPT_CHARACTER_18BE3 = chr(101347)
KHITAN_SMALL_SCRIPT_CHARACTER_18BE4 = chr(101348)
KHITAN_SMALL_SCRIPT_CHARACTER_18BE5 = chr(101349)
KHITAN_SMALL_SCRIPT_CHARACTER_18BE6 = chr(101350)
KHITAN_SMALL_SCRIPT_CHARACTER_18BE7 = chr(101351)
KHITAN_SMALL_SCRIPT_CHARACTER_18BE8 = chr(101352)
KHITAN_SMALL_SCRIPT_CHARACTER_18BE9 = chr(101353)
KHITAN_SMALL_SCRIPT_CHARACTER_18BEA = chr(101354)
KHITAN_SMALL_SCRIPT_CHARACTER_18BEB = chr(101355)
KHITAN_SMALL_SCRIPT_CHARACTER_18BEC = chr(101356)
KHITAN_SMALL_SCRIPT_CHARACTER_18BED = chr(101357)
KHITAN_SMALL_SCRIPT_CHARACTER_18BEE = chr(101358)
KHITAN_SMALL_SCRIPT_CHARACTER_18BEF = chr(101359)
KHITAN_SMALL_SCRIPT_CHARACTER_18BF0 = chr(101360)
KHITAN_SMALL_SCRIPT_CHARACTER_18BF1 = chr(101361)
KHITAN_SMALL_SCRIPT_CHARACTER_18BF2 = chr(101362)
KHITAN_SMALL_SCRIPT_CHARACTER_18BF3 = chr(101363)
KHITAN_SMALL_SCRIPT_CHARACTER_18BF4 = chr(101364)
KHITAN_SMALL_SCRIPT_CHARACTER_18BF5 = chr(101365)
KHITAN_SMALL_SCRIPT_CHARACTER_18BF6 = chr(101366)
KHITAN_SMALL_SCRIPT_CHARACTER_18BF7 = chr(101367)
KHITAN_SMALL_SCRIPT_CHARACTER_18BF8 = chr(101368)
KHITAN_SMALL_SCRIPT_CHARACTER_18BF9 = chr(101369)
KHITAN_SMALL_SCRIPT_CHARACTER_18BFA = chr(101370)
KHITAN_SMALL_SCRIPT_CHARACTER_18BFB = chr(101371)
KHITAN_SMALL_SCRIPT_CHARACTER_18BFC = chr(101372)
KHITAN_SMALL_SCRIPT_CHARACTER_18BFD = chr(101373)
KHITAN_SMALL_SCRIPT_CHARACTER_18BFE = chr(101374)
KHITAN_SMALL_SCRIPT_CHARACTER_18BFF = chr(101375)
KHITAN_SMALL_SCRIPT_CHARACTER_18C00 = chr(101376)
KHITAN_SMALL_SCRIPT_CHARACTER_18C01 = chr(101377)
KHITAN_SMALL_SCRIPT_CHARACTER_18C02 = chr(101378)
KHITAN_SMALL_SCRIPT_CHARACTER_18C03 = chr(101379)
KHITAN_SMALL_SCRIPT_CHARACTER_18C04 = chr(101380)
KHITAN_SMALL_SCRIPT_CHARACTER_18C05 = chr(101381)
KHITAN_SMALL_SCRIPT_CHARACTER_18C06 = chr(101382)
KHITAN_SMALL_SCRIPT_CHARACTER_18C07 = chr(101383)
KHITAN_SMALL_SCRIPT_CHARACTER_18C08 = chr(101384)
KHITAN_SMALL_SCRIPT_CHARACTER_18C09 = chr(101385)
KHITAN_SMALL_SCRIPT_CHARACTER_18C0A = chr(101386)
KHITAN_SMALL_SCRIPT_CHARACTER_18C0B = chr(101387)
KHITAN_SMALL_SCRIPT_CHARACTER_18C0C = chr(101388)
KHITAN_SMALL_SCRIPT_CHARACTER_18C0D = chr(101389)
KHITAN_SMALL_SCRIPT_CHARACTER_18C0E = chr(101390)
KHITAN_SMALL_SCRIPT_CHARACTER_18C0F = chr(101391)
KHITAN_SMALL_SCRIPT_CHARACTER_18C10 = chr(101392)
KHITAN_SMALL_SCRIPT_CHARACTER_18C11 = chr(101393)
KHITAN_SMALL_SCRIPT_CHARACTER_18C12 = chr(101394)
KHITAN_SMALL_SCRIPT_CHARACTER_18C13 = chr(101395)
KHITAN_SMALL_SCRIPT_CHARACTER_18C14 = chr(101396)
KHITAN_SMALL_SCRIPT_CHARACTER_18C15 = chr(101397)
KHITAN_SMALL_SCRIPT_CHARACTER_18C16 = chr(101398)
KHITAN_SMALL_SCRIPT_CHARACTER_18C17 = chr(101399)
KHITAN_SMALL_SCRIPT_CHARACTER_18C18 = chr(101400)
KHITAN_SMALL_SCRIPT_CHARACTER_18C19 = chr(101401)
KHITAN_SMALL_SCRIPT_CHARACTER_18C1A = chr(101402)
KHITAN_SMALL_SCRIPT_CHARACTER_18C1B = chr(101403)
KHITAN_SMALL_SCRIPT_CHARACTER_18C1C = chr(101404)
KHITAN_SMALL_SCRIPT_CHARACTER_18C1D = chr(101405)
KHITAN_SMALL_SCRIPT_CHARACTER_18C1E = chr(101406)
KHITAN_SMALL_SCRIPT_CHARACTER_18C1F = chr(101407)
KHITAN_SMALL_SCRIPT_CHARACTER_18C20 = chr(101408)
KHITAN_SMALL_SCRIPT_CHARACTER_18C21 = chr(101409)
KHITAN_SMALL_SCRIPT_CHARACTER_18C22 = chr(101410)
KHITAN_SMALL_SCRIPT_CHARACTER_18C23 = chr(101411)
KHITAN_SMALL_SCRIPT_CHARACTER_18C24 = chr(101412)
KHITAN_SMALL_SCRIPT_CHARACTER_18C25 = chr(101413)
KHITAN_SMALL_SCRIPT_CHARACTER_18C26 = chr(101414)
KHITAN_SMALL_SCRIPT_CHARACTER_18C27 = chr(101415)
KHITAN_SMALL_SCRIPT_CHARACTER_18C28 = chr(101416)
KHITAN_SMALL_SCRIPT_CHARACTER_18C29 = chr(101417)
KHITAN_SMALL_SCRIPT_CHARACTER_18C2A = chr(101418)
KHITAN_SMALL_SCRIPT_CHARACTER_18C2B = chr(101419)
KHITAN_SMALL_SCRIPT_CHARACTER_18C2C = chr(101420)
KHITAN_SMALL_SCRIPT_CHARACTER_18C2D = chr(101421)
KHITAN_SMALL_SCRIPT_CHARACTER_18C2E = chr(101422)
KHITAN_SMALL_SCRIPT_CHARACTER_18C2F = chr(101423)
KHITAN_SMALL_SCRIPT_CHARACTER_18C30 = chr(101424)
KHITAN_SMALL_SCRIPT_CHARACTER_18C31 = chr(101425)
KHITAN_SMALL_SCRIPT_CHARACTER_18C32 = chr(101426)
KHITAN_SMALL_SCRIPT_CHARACTER_18C33 = chr(101427)
KHITAN_SMALL_SCRIPT_CHARACTER_18C34 = chr(101428)
KHITAN_SMALL_SCRIPT_CHARACTER_18C35 = chr(101429)
KHITAN_SMALL_SCRIPT_CHARACTER_18C36 = chr(101430)
KHITAN_SMALL_SCRIPT_CHARACTER_18C37 = chr(101431)
KHITAN_SMALL_SCRIPT_CHARACTER_18C38 = chr(101432)
KHITAN_SMALL_SCRIPT_CHARACTER_18C39 = chr(101433)
KHITAN_SMALL_SCRIPT_CHARACTER_18C3A = chr(101434)
KHITAN_SMALL_SCRIPT_CHARACTER_18C3B = chr(101435)
KHITAN_SMALL_SCRIPT_CHARACTER_18C3C = chr(101436)
KHITAN_SMALL_SCRIPT_CHARACTER_18C3D = chr(101437)
KHITAN_SMALL_SCRIPT_CHARACTER_18C3E = chr(101438)
KHITAN_SMALL_SCRIPT_CHARACTER_18C3F = chr(101439)
KHITAN_SMALL_SCRIPT_CHARACTER_18C40 = chr(101440)
KHITAN_SMALL_SCRIPT_CHARACTER_18C41 = chr(101441)
KHITAN_SMALL_SCRIPT_CHARACTER_18C42 = chr(101442)
KHITAN_SMALL_SCRIPT_CHARACTER_18C43 = chr(101443)
KHITAN_SMALL_SCRIPT_CHARACTER_18C44 = chr(101444)
KHITAN_SMALL_SCRIPT_CHARACTER_18C45 = chr(101445)
KHITAN_SMALL_SCRIPT_CHARACTER_18C46 = chr(101446)
KHITAN_SMALL_SCRIPT_CHARACTER_18C47 = chr(101447)
KHITAN_SMALL_SCRIPT_CHARACTER_18C48 = chr(101448)
KHITAN_SMALL_SCRIPT_CHARACTER_18C49 = chr(101449)
KHITAN_SMALL_SCRIPT_CHARACTER_18C4A = chr(101450)
KHITAN_SMALL_SCRIPT_CHARACTER_18C4B = chr(101451)
KHITAN_SMALL_SCRIPT_CHARACTER_18C4C = chr(101452)
KHITAN_SMALL_SCRIPT_CHARACTER_18C4D = chr(101453)
KHITAN_SMALL_SCRIPT_CHARACTER_18C4E = chr(101454)
KHITAN_SMALL_SCRIPT_CHARACTER_18C4F = chr(101455)
KHITAN_SMALL_SCRIPT_CHARACTER_18C50 = chr(101456)
KHITAN_SMALL_SCRIPT_CHARACTER_18C51 = chr(101457)
KHITAN_SMALL_SCRIPT_CHARACTER_18C52 = chr(101458)
KHITAN_SMALL_SCRIPT_CHARACTER_18C53 = chr(101459)
KHITAN_SMALL_SCRIPT_CHARACTER_18C54 = chr(101460)
KHITAN_SMALL_SCRIPT_CHARACTER_18C55 = chr(101461)
KHITAN_SMALL_SCRIPT_CHARACTER_18C56 = chr(101462)
KHITAN_SMALL_SCRIPT_CHARACTER_18C57 = chr(101463)
KHITAN_SMALL_SCRIPT_CHARACTER_18C58 = chr(101464)
KHITAN_SMALL_SCRIPT_CHARACTER_18C59 = chr(101465)
KHITAN_SMALL_SCRIPT_CHARACTER_18C5A = chr(101466)
KHITAN_SMALL_SCRIPT_CHARACTER_18C5B = chr(101467)
KHITAN_SMALL_SCRIPT_CHARACTER_18C5C = chr(101468)
KHITAN_SMALL_SCRIPT_CHARACTER_18C5D = chr(101469)
KHITAN_SMALL_SCRIPT_CHARACTER_18C5E = chr(101470)
KHITAN_SMALL_SCRIPT_CHARACTER_18C5F = chr(101471)
KHITAN_SMALL_SCRIPT_CHARACTER_18C60 = chr(101472)
KHITAN_SMALL_SCRIPT_CHARACTER_18C61 = chr(101473)
KHITAN_SMALL_SCRIPT_CHARACTER_18C62 = chr(101474)
KHITAN_SMALL_SCRIPT_CHARACTER_18C63 = chr(101475)
KHITAN_SMALL_SCRIPT_CHARACTER_18C64 = chr(101476)
KHITAN_SMALL_SCRIPT_CHARACTER_18C65 = chr(101477)
KHITAN_SMALL_SCRIPT_CHARACTER_18C66 = chr(101478)
KHITAN_SMALL_SCRIPT_CHARACTER_18C67 = chr(101479)
KHITAN_SMALL_SCRIPT_CHARACTER_18C68 = chr(101480)
KHITAN_SMALL_SCRIPT_CHARACTER_18C69 = chr(101481)
KHITAN_SMALL_SCRIPT_CHARACTER_18C6A = chr(101482)
KHITAN_SMALL_SCRIPT_CHARACTER_18C6B = chr(101483)
KHITAN_SMALL_SCRIPT_CHARACTER_18C6C = chr(101484)
KHITAN_SMALL_SCRIPT_CHARACTER_18C6D = chr(101485)
KHITAN_SMALL_SCRIPT_CHARACTER_18C6E = chr(101486)
KHITAN_SMALL_SCRIPT_CHARACTER_18C6F = chr(101487)
KHITAN_SMALL_SCRIPT_CHARACTER_18C70 = chr(101488)
KHITAN_SMALL_SCRIPT_CHARACTER_18C71 = chr(101489)
KHITAN_SMALL_SCRIPT_CHARACTER_18C72 = chr(101490)
KHITAN_SMALL_SCRIPT_CHARACTER_18C73 = chr(101491)
KHITAN_SMALL_SCRIPT_CHARACTER_18C74 = chr(101492)
KHITAN_SMALL_SCRIPT_CHARACTER_18C75 = chr(101493)
KHITAN_SMALL_SCRIPT_CHARACTER_18C76 = chr(101494)
KHITAN_SMALL_SCRIPT_CHARACTER_18C77 = chr(101495)
KHITAN_SMALL_SCRIPT_CHARACTER_18C78 = chr(101496)
KHITAN_SMALL_SCRIPT_CHARACTER_18C79 = chr(101497)
KHITAN_SMALL_SCRIPT_CHARACTER_18C7A = chr(101498)
KHITAN_SMALL_SCRIPT_CHARACTER_18C7B = chr(101499)
KHITAN_SMALL_SCRIPT_CHARACTER_18C7C = chr(101500)
KHITAN_SMALL_SCRIPT_CHARACTER_18C7D = chr(101501)
KHITAN_SMALL_SCRIPT_CHARACTER_18C7E = chr(101502)
KHITAN_SMALL_SCRIPT_CHARACTER_18C7F = chr(101503)
KHITAN_SMALL_SCRIPT_CHARACTER_18C80 = chr(101504)
KHITAN_SMALL_SCRIPT_CHARACTER_18C81 = chr(101505)
KHITAN_SMALL_SCRIPT_CHARACTER_18C82 = chr(101506)
KHITAN_SMALL_SCRIPT_CHARACTER_18C83 = chr(101507)
KHITAN_SMALL_SCRIPT_CHARACTER_18C84 = chr(101508)
KHITAN_SMALL_SCRIPT_CHARACTER_18C85 = chr(101509)
KHITAN_SMALL_SCRIPT_CHARACTER_18C86 = chr(101510)
KHITAN_SMALL_SCRIPT_CHARACTER_18C87 = chr(101511)
KHITAN_SMALL_SCRIPT_CHARACTER_18C88 = chr(101512)
KHITAN_SMALL_SCRIPT_CHARACTER_18C89 = chr(101513)
KHITAN_SMALL_SCRIPT_CHARACTER_18C8A = chr(101514)
KHITAN_SMALL_SCRIPT_CHARACTER_18C8B = chr(101515)
KHITAN_SMALL_SCRIPT_CHARACTER_18C8C = chr(101516)
KHITAN_SMALL_SCRIPT_CHARACTER_18C8D = chr(101517)
KHITAN_SMALL_SCRIPT_CHARACTER_18C8E = chr(101518)
KHITAN_SMALL_SCRIPT_CHARACTER_18C8F = chr(101519)
KHITAN_SMALL_SCRIPT_CHARACTER_18C90 = chr(101520)
KHITAN_SMALL_SCRIPT_CHARACTER_18C91 = chr(101521)
KHITAN_SMALL_SCRIPT_CHARACTER_18C92 = chr(101522)
KHITAN_SMALL_SCRIPT_CHARACTER_18C93 = chr(101523)
KHITAN_SMALL_SCRIPT_CHARACTER_18C94 = chr(101524)
KHITAN_SMALL_SCRIPT_CHARACTER_18C95 = chr(101525)
KHITAN_SMALL_SCRIPT_CHARACTER_18C96 = chr(101526)
KHITAN_SMALL_SCRIPT_CHARACTER_18C97 = chr(101527)
KHITAN_SMALL_SCRIPT_CHARACTER_18C98 = chr(101528)
KHITAN_SMALL_SCRIPT_CHARACTER_18C99 = chr(101529)
KHITAN_SMALL_SCRIPT_CHARACTER_18C9A = chr(101530)
KHITAN_SMALL_SCRIPT_CHARACTER_18C9B = chr(101531)
KHITAN_SMALL_SCRIPT_CHARACTER_18C9C = chr(101532)
KHITAN_SMALL_SCRIPT_CHARACTER_18C9D = chr(101533)
KHITAN_SMALL_SCRIPT_CHARACTER_18C9E = chr(101534)
KHITAN_SMALL_SCRIPT_CHARACTER_18C9F = chr(101535)
KHITAN_SMALL_SCRIPT_CHARACTER_18CA0 = chr(101536)
KHITAN_SMALL_SCRIPT_CHARACTER_18CA1 = chr(101537)
KHITAN_SMALL_SCRIPT_CHARACTER_18CA2 = chr(101538)
KHITAN_SMALL_SCRIPT_CHARACTER_18CA3 = chr(101539)
KHITAN_SMALL_SCRIPT_CHARACTER_18CA4 = chr(101540)
KHITAN_SMALL_SCRIPT_CHARACTER_18CA5 = chr(101541)
KHITAN_SMALL_SCRIPT_CHARACTER_18CA6 = chr(101542)
KHITAN_SMALL_SCRIPT_CHARACTER_18CA7 = chr(101543)
KHITAN_SMALL_SCRIPT_CHARACTER_18CA8 = chr(101544)
KHITAN_SMALL_SCRIPT_CHARACTER_18CA9 = chr(101545)
KHITAN_SMALL_SCRIPT_CHARACTER_18CAA = chr(101546)
KHITAN_SMALL_SCRIPT_CHARACTER_18CAB = chr(101547)
KHITAN_SMALL_SCRIPT_CHARACTER_18CAC = chr(101548)
KHITAN_SMALL_SCRIPT_CHARACTER_18CAD = chr(101549)
KHITAN_SMALL_SCRIPT_CHARACTER_18CAE = chr(101550)
KHITAN_SMALL_SCRIPT_CHARACTER_18CAF = chr(101551)
KHITAN_SMALL_SCRIPT_CHARACTER_18CB0 = chr(101552)
KHITAN_SMALL_SCRIPT_CHARACTER_18CB1 = chr(101553)
KHITAN_SMALL_SCRIPT_CHARACTER_18CB2 = chr(101554)
KHITAN_SMALL_SCRIPT_CHARACTER_18CB3 = chr(101555)
KHITAN_SMALL_SCRIPT_CHARACTER_18CB4 = chr(101556)
KHITAN_SMALL_SCRIPT_CHARACTER_18CB5 = chr(101557)
KHITAN_SMALL_SCRIPT_CHARACTER_18CB6 = chr(101558)
KHITAN_SMALL_SCRIPT_CHARACTER_18CB7 = chr(101559)
KHITAN_SMALL_SCRIPT_CHARACTER_18CB8 = chr(101560)
KHITAN_SMALL_SCRIPT_CHARACTER_18CB9 = chr(101561)
KHITAN_SMALL_SCRIPT_CHARACTER_18CBA = chr(101562)
KHITAN_SMALL_SCRIPT_CHARACTER_18CBB = chr(101563)
KHITAN_SMALL_SCRIPT_CHARACTER_18CBC = chr(101564)
KHITAN_SMALL_SCRIPT_CHARACTER_18CBD = chr(101565)
KHITAN_SMALL_SCRIPT_CHARACTER_18CBE = chr(101566)
KHITAN_SMALL_SCRIPT_CHARACTER_18CBF = chr(101567)
KHITAN_SMALL_SCRIPT_CHARACTER_18CC0 = chr(101568)
KHITAN_SMALL_SCRIPT_CHARACTER_18CC1 = chr(101569)
KHITAN_SMALL_SCRIPT_CHARACTER_18CC2 = chr(101570)
KHITAN_SMALL_SCRIPT_CHARACTER_18CC3 = chr(101571)
KHITAN_SMALL_SCRIPT_CHARACTER_18CC4 = chr(101572)
KHITAN_SMALL_SCRIPT_CHARACTER_18CC5 = chr(101573)
KHITAN_SMALL_SCRIPT_CHARACTER_18CC6 = chr(101574)
KHITAN_SMALL_SCRIPT_CHARACTER_18CC7 = chr(101575)
KHITAN_SMALL_SCRIPT_CHARACTER_18CC8 = chr(101576)
KHITAN_SMALL_SCRIPT_CHARACTER_18CC9 = chr(101577)
KHITAN_SMALL_SCRIPT_CHARACTER_18CCA = chr(101578)
KHITAN_SMALL_SCRIPT_CHARACTER_18CCB = chr(101579)
KHITAN_SMALL_SCRIPT_CHARACTER_18CCC = chr(101580)
KHITAN_SMALL_SCRIPT_CHARACTER_18CCD = chr(101581)
KHITAN_SMALL_SCRIPT_CHARACTER_18CCE = chr(101582)
KHITAN_SMALL_SCRIPT_CHARACTER_18CCF = chr(101583)
KHITAN_SMALL_SCRIPT_CHARACTER_18CD0 = chr(101584)
KHITAN_SMALL_SCRIPT_CHARACTER_18CD1 = chr(101585)
KHITAN_SMALL_SCRIPT_CHARACTER_18CD2 = chr(101586)
KHITAN_SMALL_SCRIPT_CHARACTER_18CD3 = chr(101587)
KHITAN_SMALL_SCRIPT_CHARACTER_18CD4 = chr(101588)
KHITAN_SMALL_SCRIPT_CHARACTER_18CD5 = chr(101589)
KATAKANA_LETTER_MINNAN_TONE_2 = chr(110576)
KATAKANA_LETTER_MINNAN_TONE_3 = chr(110577)
KATAKANA_LETTER_MINNAN_TONE_4 = chr(110578)
KATAKANA_LETTER_MINNAN_TONE_5 = chr(110579)
KATAKANA_LETTER_MINNAN_TONE_7 = chr(110581)
KATAKANA_LETTER_MINNAN_TONE_8 = chr(110582)
KATAKANA_LETTER_MINNAN_NASALIZED_TONE_1 = chr(110583)
KATAKANA_LETTER_MINNAN_NASALIZED_TONE_2 = chr(110584)
KATAKANA_LETTER_MINNAN_NASALIZED_TONE_3 = chr(110585)
KATAKANA_LETTER_MINNAN_NASALIZED_TONE_4 = chr(110586)
KATAKANA_LETTER_MINNAN_NASALIZED_TONE_5 = chr(110587)
KATAKANA_LETTER_MINNAN_NASALIZED_TONE_7 = chr(110589)
KATAKANA_LETTER_MINNAN_NASALIZED_TONE_8 = chr(110590)
KATAKANA_LETTER_ARCHAIC_E = chr(110592)
HIRAGANA_LETTER_ARCHAIC_YE = chr(110593)
HENTAIGANA_LETTER_A_1 = chr(110594)
HENTAIGANA_LETTER_A_2 = chr(110595)
HENTAIGANA_LETTER_A_3 = chr(110596)
HENTAIGANA_LETTER_A_WO = chr(110597)
HENTAIGANA_LETTER_I_1 = chr(110598)
HENTAIGANA_LETTER_I_2 = chr(110599)
HENTAIGANA_LETTER_I_3 = chr(110600)
HENTAIGANA_LETTER_I_4 = chr(110601)
HENTAIGANA_LETTER_U_1 = chr(110602)
HENTAIGANA_LETTER_U_2 = chr(110603)
HENTAIGANA_LETTER_U_3 = chr(110604)
HENTAIGANA_LETTER_U_4 = chr(110605)
HENTAIGANA_LETTER_U_5 = chr(110606)
HENTAIGANA_LETTER_E_2 = chr(110607)
HENTAIGANA_LETTER_E_3 = chr(110608)
HENTAIGANA_LETTER_E_4 = chr(110609)
HENTAIGANA_LETTER_E_5 = chr(110610)
HENTAIGANA_LETTER_E_6 = chr(110611)
HENTAIGANA_LETTER_O_1 = chr(110612)
HENTAIGANA_LETTER_O_2 = chr(110613)
HENTAIGANA_LETTER_O_3 = chr(110614)
HENTAIGANA_LETTER_KA_1 = chr(110615)
HENTAIGANA_LETTER_KA_2 = chr(110616)
HENTAIGANA_LETTER_KA_3 = chr(110617)
HENTAIGANA_LETTER_KA_4 = chr(110618)
HENTAIGANA_LETTER_KA_5 = chr(110619)
HENTAIGANA_LETTER_KA_6 = chr(110620)
HENTAIGANA_LETTER_KA_7 = chr(110621)
HENTAIGANA_LETTER_KA_8 = chr(110622)
HENTAIGANA_LETTER_KA_9 = chr(110623)
HENTAIGANA_LETTER_KA_10 = chr(110624)
HENTAIGANA_LETTER_KA_11 = chr(110625)
HENTAIGANA_LETTER_KA_KE = chr(110626)
HENTAIGANA_LETTER_KI_1 = chr(110627)
HENTAIGANA_LETTER_KI_2 = chr(110628)
HENTAIGANA_LETTER_KI_3 = chr(110629)
HENTAIGANA_LETTER_KI_4 = chr(110630)
HENTAIGANA_LETTER_KI_5 = chr(110631)
HENTAIGANA_LETTER_KI_6 = chr(110632)
HENTAIGANA_LETTER_KI_7 = chr(110633)
HENTAIGANA_LETTER_KI_8 = chr(110634)
HENTAIGANA_LETTER_KU_1 = chr(110635)
HENTAIGANA_LETTER_KU_2 = chr(110636)
HENTAIGANA_LETTER_KU_3 = chr(110637)
HENTAIGANA_LETTER_KU_4 = chr(110638)
HENTAIGANA_LETTER_KU_5 = chr(110639)
HENTAIGANA_LETTER_KU_6 = chr(110640)
HENTAIGANA_LETTER_KU_7 = chr(110641)
HENTAIGANA_LETTER_KE_1 = chr(110642)
HENTAIGANA_LETTER_KE_2 = chr(110643)
HENTAIGANA_LETTER_KE_3 = chr(110644)
HENTAIGANA_LETTER_KE_4 = chr(110645)
HENTAIGANA_LETTER_KE_5 = chr(110646)
HENTAIGANA_LETTER_KE_6 = chr(110647)
HENTAIGANA_LETTER_KO_1 = chr(110648)
HENTAIGANA_LETTER_KO_2 = chr(110649)
HENTAIGANA_LETTER_KO_3 = chr(110650)
HENTAIGANA_LETTER_KO_KI = chr(110651)
HENTAIGANA_LETTER_SA_1 = chr(110652)
HENTAIGANA_LETTER_SA_2 = chr(110653)
HENTAIGANA_LETTER_SA_3 = chr(110654)
HENTAIGANA_LETTER_SA_4 = chr(110655)
HENTAIGANA_LETTER_SA_5 = chr(110656)
HENTAIGANA_LETTER_SA_6 = chr(110657)
HENTAIGANA_LETTER_SA_7 = chr(110658)
HENTAIGANA_LETTER_SA_8 = chr(110659)
HENTAIGANA_LETTER_SI_1 = chr(110660)
HENTAIGANA_LETTER_SI_2 = chr(110661)
HENTAIGANA_LETTER_SI_3 = chr(110662)
HENTAIGANA_LETTER_SI_4 = chr(110663)
HENTAIGANA_LETTER_SI_5 = chr(110664)
HENTAIGANA_LETTER_SI_6 = chr(110665)
HENTAIGANA_LETTER_SU_1 = chr(110666)
HENTAIGANA_LETTER_SU_2 = chr(110667)
HENTAIGANA_LETTER_SU_3 = chr(110668)
HENTAIGANA_LETTER_SU_4 = chr(110669)
HENTAIGANA_LETTER_SU_5 = chr(110670)
HENTAIGANA_LETTER_SU_6 = chr(110671)
HENTAIGANA_LETTER_SU_7 = chr(110672)
HENTAIGANA_LETTER_SU_8 = chr(110673)
HENTAIGANA_LETTER_SE_1 = chr(110674)
HENTAIGANA_LETTER_SE_2 = chr(110675)
HENTAIGANA_LETTER_SE_3 = chr(110676)
HENTAIGANA_LETTER_SE_4 = chr(110677)
HENTAIGANA_LETTER_SE_5 = chr(110678)
HENTAIGANA_LETTER_SO_1 = chr(110679)
HENTAIGANA_LETTER_SO_2 = chr(110680)
HENTAIGANA_LETTER_SO_3 = chr(110681)
HENTAIGANA_LETTER_SO_4 = chr(110682)
HENTAIGANA_LETTER_SO_5 = chr(110683)
HENTAIGANA_LETTER_SO_6 = chr(110684)
HENTAIGANA_LETTER_SO_7 = chr(110685)
HENTAIGANA_LETTER_TA_1 = chr(110686)
HENTAIGANA_LETTER_TA_2 = chr(110687)
HENTAIGANA_LETTER_TA_3 = chr(110688)
HENTAIGANA_LETTER_TA_4 = chr(110689)
HENTAIGANA_LETTER_TI_1 = chr(110690)
HENTAIGANA_LETTER_TI_2 = chr(110691)
HENTAIGANA_LETTER_TI_3 = chr(110692)
HENTAIGANA_LETTER_TI_4 = chr(110693)
HENTAIGANA_LETTER_TI_5 = chr(110694)
HENTAIGANA_LETTER_TI_6 = chr(110695)
HENTAIGANA_LETTER_TI_7 = chr(110696)
HENTAIGANA_LETTER_TU_1 = chr(110697)
HENTAIGANA_LETTER_TU_2 = chr(110698)
HENTAIGANA_LETTER_TU_3 = chr(110699)
HENTAIGANA_LETTER_TU_4 = chr(110700)
HENTAIGANA_LETTER_TU_TO = chr(110701)
HENTAIGANA_LETTER_TE_1 = chr(110702)
HENTAIGANA_LETTER_TE_2 = chr(110703)
HENTAIGANA_LETTER_TE_3 = chr(110704)
HENTAIGANA_LETTER_TE_4 = chr(110705)
HENTAIGANA_LETTER_TE_5 = chr(110706)
HENTAIGANA_LETTER_TE_6 = chr(110707)
HENTAIGANA_LETTER_TE_7 = chr(110708)
HENTAIGANA_LETTER_TE_8 = chr(110709)
HENTAIGANA_LETTER_TE_9 = chr(110710)
HENTAIGANA_LETTER_TO_1 = chr(110711)
HENTAIGANA_LETTER_TO_2 = chr(110712)
HENTAIGANA_LETTER_TO_3 = chr(110713)
HENTAIGANA_LETTER_TO_4 = chr(110714)
HENTAIGANA_LETTER_TO_5 = chr(110715)
HENTAIGANA_LETTER_TO_6 = chr(110716)
HENTAIGANA_LETTER_TO_RA = chr(110717)
HENTAIGANA_LETTER_NA_1 = chr(110718)
HENTAIGANA_LETTER_NA_2 = chr(110719)
HENTAIGANA_LETTER_NA_3 = chr(110720)
HENTAIGANA_LETTER_NA_4 = chr(110721)
HENTAIGANA_LETTER_NA_5 = chr(110722)
HENTAIGANA_LETTER_NA_6 = chr(110723)
HENTAIGANA_LETTER_NA_7 = chr(110724)
HENTAIGANA_LETTER_NA_8 = chr(110725)
HENTAIGANA_LETTER_NA_9 = chr(110726)
HENTAIGANA_LETTER_NI_1 = chr(110727)
HENTAIGANA_LETTER_NI_2 = chr(110728)
HENTAIGANA_LETTER_NI_3 = chr(110729)
HENTAIGANA_LETTER_NI_4 = chr(110730)
HENTAIGANA_LETTER_NI_5 = chr(110731)
HENTAIGANA_LETTER_NI_6 = chr(110732)
HENTAIGANA_LETTER_NI_7 = chr(110733)
HENTAIGANA_LETTER_NI_TE = chr(110734)
HENTAIGANA_LETTER_NU_1 = chr(110735)
HENTAIGANA_LETTER_NU_2 = chr(110736)
HENTAIGANA_LETTER_NU_3 = chr(110737)
HENTAIGANA_LETTER_NE_1 = chr(110738)
HENTAIGANA_LETTER_NE_2 = chr(110739)
HENTAIGANA_LETTER_NE_3 = chr(110740)
HENTAIGANA_LETTER_NE_4 = chr(110741)
HENTAIGANA_LETTER_NE_5 = chr(110742)
HENTAIGANA_LETTER_NE_6 = chr(110743)
HENTAIGANA_LETTER_NE_KO = chr(110744)
HENTAIGANA_LETTER_NO_1 = chr(110745)
HENTAIGANA_LETTER_NO_2 = chr(110746)
HENTAIGANA_LETTER_NO_3 = chr(110747)
HENTAIGANA_LETTER_NO_4 = chr(110748)
HENTAIGANA_LETTER_NO_5 = chr(110749)
HENTAIGANA_LETTER_HA_1 = chr(110750)
HENTAIGANA_LETTER_HA_2 = chr(110751)
HENTAIGANA_LETTER_HA_3 = chr(110752)
HENTAIGANA_LETTER_HA_4 = chr(110753)
HENTAIGANA_LETTER_HA_5 = chr(110754)
HENTAIGANA_LETTER_HA_6 = chr(110755)
HENTAIGANA_LETTER_HA_7 = chr(110756)
HENTAIGANA_LETTER_HA_8 = chr(110757)
HENTAIGANA_LETTER_HA_9 = chr(110758)
HENTAIGANA_LETTER_HA_10 = chr(110759)
HENTAIGANA_LETTER_HA_11 = chr(110760)
HENTAIGANA_LETTER_HI_1 = chr(110761)
HENTAIGANA_LETTER_HI_2 = chr(110762)
HENTAIGANA_LETTER_HI_3 = chr(110763)
HENTAIGANA_LETTER_HI_4 = chr(110764)
HENTAIGANA_LETTER_HI_5 = chr(110765)
HENTAIGANA_LETTER_HI_6 = chr(110766)
HENTAIGANA_LETTER_HI_7 = chr(110767)
HENTAIGANA_LETTER_HU_1 = chr(110768)
HENTAIGANA_LETTER_HU_2 = chr(110769)
HENTAIGANA_LETTER_HU_3 = chr(110770)
HENTAIGANA_LETTER_HE_1 = chr(110771)
HENTAIGANA_LETTER_HE_2 = chr(110772)
HENTAIGANA_LETTER_HE_3 = chr(110773)
HENTAIGANA_LETTER_HE_4 = chr(110774)
HENTAIGANA_LETTER_HE_5 = chr(110775)
HENTAIGANA_LETTER_HE_6 = chr(110776)
HENTAIGANA_LETTER_HE_7 = chr(110777)
HENTAIGANA_LETTER_HO_1 = chr(110778)
HENTAIGANA_LETTER_HO_2 = chr(110779)
HENTAIGANA_LETTER_HO_3 = chr(110780)
HENTAIGANA_LETTER_HO_4 = chr(110781)
HENTAIGANA_LETTER_HO_5 = chr(110782)
HENTAIGANA_LETTER_HO_6 = chr(110783)
HENTAIGANA_LETTER_HO_7 = chr(110784)
HENTAIGANA_LETTER_HO_8 = chr(110785)
HENTAIGANA_LETTER_MA_1 = chr(110786)
HENTAIGANA_LETTER_MA_2 = chr(110787)
HENTAIGANA_LETTER_MA_3 = chr(110788)
HENTAIGANA_LETTER_MA_4 = chr(110789)
HENTAIGANA_LETTER_MA_5 = chr(110790)
HENTAIGANA_LETTER_MA_6 = chr(110791)
HENTAIGANA_LETTER_MA_7 = chr(110792)
HENTAIGANA_LETTER_MI_1 = chr(110793)
HENTAIGANA_LETTER_MI_2 = chr(110794)
HENTAIGANA_LETTER_MI_3 = chr(110795)
HENTAIGANA_LETTER_MI_4 = chr(110796)
HENTAIGANA_LETTER_MI_5 = chr(110797)
HENTAIGANA_LETTER_MI_6 = chr(110798)
HENTAIGANA_LETTER_MI_7 = chr(110799)
HENTAIGANA_LETTER_MU_1 = chr(110800)
HENTAIGANA_LETTER_MU_2 = chr(110801)
HENTAIGANA_LETTER_MU_3 = chr(110802)
HENTAIGANA_LETTER_MU_4 = chr(110803)
HENTAIGANA_LETTER_ME_1 = chr(110804)
HENTAIGANA_LETTER_ME_2 = chr(110805)
HENTAIGANA_LETTER_ME_MA = chr(110806)
HENTAIGANA_LETTER_MO_1 = chr(110807)
HENTAIGANA_LETTER_MO_2 = chr(110808)
HENTAIGANA_LETTER_MO_3 = chr(110809)
HENTAIGANA_LETTER_MO_4 = chr(110810)
HENTAIGANA_LETTER_MO_5 = chr(110811)
HENTAIGANA_LETTER_MO_6 = chr(110812)
HENTAIGANA_LETTER_YA_1 = chr(110813)
HENTAIGANA_LETTER_YA_2 = chr(110814)
HENTAIGANA_LETTER_YA_3 = chr(110815)
HENTAIGANA_LETTER_YA_4 = chr(110816)
HENTAIGANA_LETTER_YA_5 = chr(110817)
HENTAIGANA_LETTER_YA_YO = chr(110818)
HENTAIGANA_LETTER_YU_1 = chr(110819)
HENTAIGANA_LETTER_YU_2 = chr(110820)
HENTAIGANA_LETTER_YU_3 = chr(110821)
HENTAIGANA_LETTER_YU_4 = chr(110822)
HENTAIGANA_LETTER_YO_1 = chr(110823)
HENTAIGANA_LETTER_YO_2 = chr(110824)
HENTAIGANA_LETTER_YO_3 = chr(110825)
HENTAIGANA_LETTER_YO_4 = chr(110826)
HENTAIGANA_LETTER_YO_5 = chr(110827)
HENTAIGANA_LETTER_YO_6 = chr(110828)
HENTAIGANA_LETTER_RA_1 = chr(110829)
HENTAIGANA_LETTER_RA_2 = chr(110830)
HENTAIGANA_LETTER_RA_3 = chr(110831)
HENTAIGANA_LETTER_RA_4 = chr(110832)
HENTAIGANA_LETTER_RI_1 = chr(110833)
HENTAIGANA_LETTER_RI_2 = chr(110834)
HENTAIGANA_LETTER_RI_3 = chr(110835)
HENTAIGANA_LETTER_RI_4 = chr(110836)
HENTAIGANA_LETTER_RI_5 = chr(110837)
HENTAIGANA_LETTER_RI_6 = chr(110838)
HENTAIGANA_LETTER_RI_7 = chr(110839)
HENTAIGANA_LETTER_RU_1 = chr(110840)
HENTAIGANA_LETTER_RU_2 = chr(110841)
HENTAIGANA_LETTER_RU_3 = chr(110842)
HENTAIGANA_LETTER_RU_4 = chr(110843)
HENTAIGANA_LETTER_RU_5 = chr(110844)
HENTAIGANA_LETTER_RU_6 = chr(110845)
HENTAIGANA_LETTER_RE_1 = chr(110846)
HENTAIGANA_LETTER_RE_2 = chr(110847)
HENTAIGANA_LETTER_RE_3 = chr(110848)
HENTAIGANA_LETTER_RE_4 = chr(110849)
HENTAIGANA_LETTER_RO_1 = chr(110850)
HENTAIGANA_LETTER_RO_2 = chr(110851)
HENTAIGANA_LETTER_RO_3 = chr(110852)
HENTAIGANA_LETTER_RO_4 = chr(110853)
HENTAIGANA_LETTER_RO_5 = chr(110854)
HENTAIGANA_LETTER_RO_6 = chr(110855)
HENTAIGANA_LETTER_WA_1 = chr(110856)
HENTAIGANA_LETTER_WA_2 = chr(110857)
HENTAIGANA_LETTER_WA_3 = chr(110858)
HENTAIGANA_LETTER_WA_4 = chr(110859)
HENTAIGANA_LETTER_WA_5 = chr(110860)
HENTAIGANA_LETTER_WI_1 = chr(110861)
HENTAIGANA_LETTER_WI_2 = chr(110862)
HENTAIGANA_LETTER_WI_3 = chr(110863)
HENTAIGANA_LETTER_WI_4 = chr(110864)
HENTAIGANA_LETTER_WI_5 = chr(110865)
HENTAIGANA_LETTER_WE_1 = chr(110866)
HENTAIGANA_LETTER_WE_2 = chr(110867)
HENTAIGANA_LETTER_WE_3 = chr(110868)
HENTAIGANA_LETTER_WE_4 = chr(110869)
HENTAIGANA_LETTER_WO_1 = chr(110870)
HENTAIGANA_LETTER_WO_2 = chr(110871)
HENTAIGANA_LETTER_WO_3 = chr(110872)
HENTAIGANA_LETTER_WO_4 = chr(110873)
HENTAIGANA_LETTER_WO_5 = chr(110874)
HENTAIGANA_LETTER_WO_6 = chr(110875)
HENTAIGANA_LETTER_WO_7 = chr(110876)
HENTAIGANA_LETTER_N_MU_MO_1 = chr(110877)
HENTAIGANA_LETTER_N_MU_MO_2 = chr(110878)
HIRAGANA_LETTER_ARCHAIC_WU = chr(110879)
KATAKANA_LETTER_ARCHAIC_YI = chr(110880)
KATAKANA_LETTER_ARCHAIC_YE = chr(110881)
KATAKANA_LETTER_ARCHAIC_WU = chr(110882)
HIRAGANA_LETTER_SMALL_KO = chr(110898)
HIRAGANA_LETTER_SMALL_WI = chr(110928)
HIRAGANA_LETTER_SMALL_WE = chr(110929)
HIRAGANA_LETTER_SMALL_WO = chr(110930)
KATAKANA_LETTER_SMALL_KO = chr(110933)
KATAKANA_LETTER_SMALL_WI = chr(110948)
KATAKANA_LETTER_SMALL_WE = chr(110949)
KATAKANA_LETTER_SMALL_WO = chr(110950)
KATAKANA_LETTER_SMALL_N = chr(110951)
NUSHU_CHARACTER_1B170 = chr(110960)
NUSHU_CHARACTER_1B171 = chr(110961)
NUSHU_CHARACTER_1B172 = chr(110962)
NUSHU_CHARACTER_1B173 = chr(110963)
NUSHU_CHARACTER_1B174 = chr(110964)
NUSHU_CHARACTER_1B175 = chr(110965)
NUSHU_CHARACTER_1B176 = chr(110966)
NUSHU_CHARACTER_1B177 = chr(110967)
NUSHU_CHARACTER_1B178 = chr(110968)
NUSHU_CHARACTER_1B179 = chr(110969)
NUSHU_CHARACTER_1B17A = chr(110970)
NUSHU_CHARACTER_1B17B = chr(110971)
NUSHU_CHARACTER_1B17C = chr(110972)
NUSHU_CHARACTER_1B17D = chr(110973)
NUSHU_CHARACTER_1B17E = chr(110974)
NUSHU_CHARACTER_1B17F = chr(110975)
NUSHU_CHARACTER_1B180 = chr(110976)
NUSHU_CHARACTER_1B181 = chr(110977)
NUSHU_CHARACTER_1B182 = chr(110978)
NUSHU_CHARACTER_1B183 = chr(110979)
NUSHU_CHARACTER_1B184 = chr(110980)
NUSHU_CHARACTER_1B185 = chr(110981)
NUSHU_CHARACTER_1B186 = chr(110982)
NUSHU_CHARACTER_1B187 = chr(110983)
NUSHU_CHARACTER_1B188 = chr(110984)
NUSHU_CHARACTER_1B189 = chr(110985)
NUSHU_CHARACTER_1B18A = chr(110986)
NUSHU_CHARACTER_1B18B = chr(110987)
NUSHU_CHARACTER_1B18C = chr(110988)
NUSHU_CHARACTER_1B18D = chr(110989)
NUSHU_CHARACTER_1B18E = chr(110990)
NUSHU_CHARACTER_1B18F = chr(110991)
NUSHU_CHARACTER_1B190 = chr(110992)
NUSHU_CHARACTER_1B191 = chr(110993)
NUSHU_CHARACTER_1B192 = chr(110994)
NUSHU_CHARACTER_1B193 = chr(110995)
NUSHU_CHARACTER_1B194 = chr(110996)
NUSHU_CHARACTER_1B195 = chr(110997)
NUSHU_CHARACTER_1B196 = chr(110998)
NUSHU_CHARACTER_1B197 = chr(110999)
NUSHU_CHARACTER_1B198 = chr(111000)
NUSHU_CHARACTER_1B199 = chr(111001)
NUSHU_CHARACTER_1B19A = chr(111002)
NUSHU_CHARACTER_1B19B = chr(111003)
NUSHU_CHARACTER_1B19C = chr(111004)
NUSHU_CHARACTER_1B19D = chr(111005)
NUSHU_CHARACTER_1B19E = chr(111006)
NUSHU_CHARACTER_1B19F = chr(111007)
NUSHU_CHARACTER_1B1A0 = chr(111008)
NUSHU_CHARACTER_1B1A1 = chr(111009)
NUSHU_CHARACTER_1B1A2 = chr(111010)
NUSHU_CHARACTER_1B1A3 = chr(111011)
NUSHU_CHARACTER_1B1A4 = chr(111012)
NUSHU_CHARACTER_1B1A5 = chr(111013)
NUSHU_CHARACTER_1B1A6 = chr(111014)
NUSHU_CHARACTER_1B1A7 = chr(111015)
NUSHU_CHARACTER_1B1A8 = chr(111016)
NUSHU_CHARACTER_1B1A9 = chr(111017)
NUSHU_CHARACTER_1B1AA = chr(111018)
NUSHU_CHARACTER_1B1AB = chr(111019)
NUSHU_CHARACTER_1B1AC = chr(111020)
NUSHU_CHARACTER_1B1AD = chr(111021)
NUSHU_CHARACTER_1B1AE = chr(111022)
NUSHU_CHARACTER_1B1AF = chr(111023)
NUSHU_CHARACTER_1B1B0 = chr(111024)
NUSHU_CHARACTER_1B1B1 = chr(111025)
NUSHU_CHARACTER_1B1B2 = chr(111026)
NUSHU_CHARACTER_1B1B3 = chr(111027)
NUSHU_CHARACTER_1B1B4 = chr(111028)
NUSHU_CHARACTER_1B1B5 = chr(111029)
NUSHU_CHARACTER_1B1B6 = chr(111030)
NUSHU_CHARACTER_1B1B7 = chr(111031)
NUSHU_CHARACTER_1B1B8 = chr(111032)
NUSHU_CHARACTER_1B1B9 = chr(111033)
NUSHU_CHARACTER_1B1BA = chr(111034)
NUSHU_CHARACTER_1B1BB = chr(111035)
NUSHU_CHARACTER_1B1BC = chr(111036)
NUSHU_CHARACTER_1B1BD = chr(111037)
NUSHU_CHARACTER_1B1BE = chr(111038)
NUSHU_CHARACTER_1B1BF = chr(111039)
NUSHU_CHARACTER_1B1C0 = chr(111040)
NUSHU_CHARACTER_1B1C1 = chr(111041)
NUSHU_CHARACTER_1B1C2 = chr(111042)
NUSHU_CHARACTER_1B1C3 = chr(111043)
NUSHU_CHARACTER_1B1C4 = chr(111044)
NUSHU_CHARACTER_1B1C5 = chr(111045)
NUSHU_CHARACTER_1B1C6 = chr(111046)
NUSHU_CHARACTER_1B1C7 = chr(111047)
NUSHU_CHARACTER_1B1C8 = chr(111048)
NUSHU_CHARACTER_1B1C9 = chr(111049)
NUSHU_CHARACTER_1B1CA = chr(111050)
NUSHU_CHARACTER_1B1CB = chr(111051)
NUSHU_CHARACTER_1B1CC = chr(111052)
NUSHU_CHARACTER_1B1CD = chr(111053)
NUSHU_CHARACTER_1B1CE = chr(111054)
NUSHU_CHARACTER_1B1CF = chr(111055)
NUSHU_CHARACTER_1B1D0 = chr(111056)
NUSHU_CHARACTER_1B1D1 = chr(111057)
NUSHU_CHARACTER_1B1D2 = chr(111058)
NUSHU_CHARACTER_1B1D3 = chr(111059)
NUSHU_CHARACTER_1B1D4 = chr(111060)
NUSHU_CHARACTER_1B1D5 = chr(111061)
NUSHU_CHARACTER_1B1D6 = chr(111062)
NUSHU_CHARACTER_1B1D7 = chr(111063)
NUSHU_CHARACTER_1B1D8 = chr(111064)
NUSHU_CHARACTER_1B1D9 = chr(111065)
NUSHU_CHARACTER_1B1DA = chr(111066)
NUSHU_CHARACTER_1B1DB = chr(111067)
NUSHU_CHARACTER_1B1DC = chr(111068)
NUSHU_CHARACTER_1B1DD = chr(111069)
NUSHU_CHARACTER_1B1DE = chr(111070)
NUSHU_CHARACTER_1B1DF = chr(111071)
NUSHU_CHARACTER_1B1E0 = chr(111072)
NUSHU_CHARACTER_1B1E1 = chr(111073)
NUSHU_CHARACTER_1B1E2 = chr(111074)
NUSHU_CHARACTER_1B1E3 = chr(111075)
NUSHU_CHARACTER_1B1E4 = chr(111076)
NUSHU_CHARACTER_1B1E5 = chr(111077)
NUSHU_CHARACTER_1B1E6 = chr(111078)
NUSHU_CHARACTER_1B1E7 = chr(111079)
NUSHU_CHARACTER_1B1E8 = chr(111080)
NUSHU_CHARACTER_1B1E9 = chr(111081)
NUSHU_CHARACTER_1B1EA = chr(111082)
NUSHU_CHARACTER_1B1EB = chr(111083)
NUSHU_CHARACTER_1B1EC = chr(111084)
NUSHU_CHARACTER_1B1ED = chr(111085)
NUSHU_CHARACTER_1B1EE = chr(111086)
NUSHU_CHARACTER_1B1EF = chr(111087)
NUSHU_CHARACTER_1B1F0 = chr(111088)
NUSHU_CHARACTER_1B1F1 = chr(111089)
NUSHU_CHARACTER_1B1F2 = chr(111090)
NUSHU_CHARACTER_1B1F3 = chr(111091)
NUSHU_CHARACTER_1B1F4 = chr(111092)
NUSHU_CHARACTER_1B1F5 = chr(111093)
NUSHU_CHARACTER_1B1F6 = chr(111094)
NUSHU_CHARACTER_1B1F7 = chr(111095)
NUSHU_CHARACTER_1B1F8 = chr(111096)
NUSHU_CHARACTER_1B1F9 = chr(111097)
NUSHU_CHARACTER_1B1FA = chr(111098)
NUSHU_CHARACTER_1B1FB = chr(111099)
NUSHU_CHARACTER_1B1FC = chr(111100)
NUSHU_CHARACTER_1B1FD = chr(111101)
NUSHU_CHARACTER_1B1FE = chr(111102)
NUSHU_CHARACTER_1B1FF = chr(111103)
NUSHU_CHARACTER_1B200 = chr(111104)
NUSHU_CHARACTER_1B201 = chr(111105)
NUSHU_CHARACTER_1B202 = chr(111106)
NUSHU_CHARACTER_1B203 = chr(111107)
NUSHU_CHARACTER_1B204 = chr(111108)
NUSHU_CHARACTER_1B205 = chr(111109)
NUSHU_CHARACTER_1B206 = chr(111110)
NUSHU_CHARACTER_1B207 = chr(111111)
NUSHU_CHARACTER_1B208 = chr(111112)
NUSHU_CHARACTER_1B209 = chr(111113)
NUSHU_CHARACTER_1B20A = chr(111114)
NUSHU_CHARACTER_1B20B = chr(111115)
NUSHU_CHARACTER_1B20C = chr(111116)
NUSHU_CHARACTER_1B20D = chr(111117)
NUSHU_CHARACTER_1B20E = chr(111118)
NUSHU_CHARACTER_1B20F = chr(111119)
NUSHU_CHARACTER_1B210 = chr(111120)
NUSHU_CHARACTER_1B211 = chr(111121)
NUSHU_CHARACTER_1B212 = chr(111122)
NUSHU_CHARACTER_1B213 = chr(111123)
NUSHU_CHARACTER_1B214 = chr(111124)
NUSHU_CHARACTER_1B215 = chr(111125)
NUSHU_CHARACTER_1B216 = chr(111126)
NUSHU_CHARACTER_1B217 = chr(111127)
NUSHU_CHARACTER_1B218 = chr(111128)
NUSHU_CHARACTER_1B219 = chr(111129)
NUSHU_CHARACTER_1B21A = chr(111130)
NUSHU_CHARACTER_1B21B = chr(111131)
NUSHU_CHARACTER_1B21C = chr(111132)
NUSHU_CHARACTER_1B21D = chr(111133)
NUSHU_CHARACTER_1B21E = chr(111134)
NUSHU_CHARACTER_1B21F = chr(111135)
NUSHU_CHARACTER_1B220 = chr(111136)
NUSHU_CHARACTER_1B221 = chr(111137)
NUSHU_CHARACTER_1B222 = chr(111138)
NUSHU_CHARACTER_1B223 = chr(111139)
NUSHU_CHARACTER_1B224 = chr(111140)
NUSHU_CHARACTER_1B225 = chr(111141)
NUSHU_CHARACTER_1B226 = chr(111142)
NUSHU_CHARACTER_1B227 = chr(111143)
NUSHU_CHARACTER_1B228 = chr(111144)
NUSHU_CHARACTER_1B229 = chr(111145)
NUSHU_CHARACTER_1B22A = chr(111146)
NUSHU_CHARACTER_1B22B = chr(111147)
NUSHU_CHARACTER_1B22C = chr(111148)
NUSHU_CHARACTER_1B22D = chr(111149)
NUSHU_CHARACTER_1B22E = chr(111150)
NUSHU_CHARACTER_1B22F = chr(111151)
NUSHU_CHARACTER_1B230 = chr(111152)
NUSHU_CHARACTER_1B231 = chr(111153)
NUSHU_CHARACTER_1B232 = chr(111154)
NUSHU_CHARACTER_1B233 = chr(111155)
NUSHU_CHARACTER_1B234 = chr(111156)
NUSHU_CHARACTER_1B235 = chr(111157)
NUSHU_CHARACTER_1B236 = chr(111158)
NUSHU_CHARACTER_1B237 = chr(111159)
NUSHU_CHARACTER_1B238 = chr(111160)
NUSHU_CHARACTER_1B239 = chr(111161)
NUSHU_CHARACTER_1B23A = chr(111162)
NUSHU_CHARACTER_1B23B = chr(111163)
NUSHU_CHARACTER_1B23C = chr(111164)
NUSHU_CHARACTER_1B23D = chr(111165)
NUSHU_CHARACTER_1B23E = chr(111166)
NUSHU_CHARACTER_1B23F = chr(111167)
NUSHU_CHARACTER_1B240 = chr(111168)
NUSHU_CHARACTER_1B241 = chr(111169)
NUSHU_CHARACTER_1B242 = chr(111170)
NUSHU_CHARACTER_1B243 = chr(111171)
NUSHU_CHARACTER_1B244 = chr(111172)
NUSHU_CHARACTER_1B245 = chr(111173)
NUSHU_CHARACTER_1B246 = chr(111174)
NUSHU_CHARACTER_1B247 = chr(111175)
NUSHU_CHARACTER_1B248 = chr(111176)
NUSHU_CHARACTER_1B249 = chr(111177)
NUSHU_CHARACTER_1B24A = chr(111178)
NUSHU_CHARACTER_1B24B = chr(111179)
NUSHU_CHARACTER_1B24C = chr(111180)
NUSHU_CHARACTER_1B24D = chr(111181)
NUSHU_CHARACTER_1B24E = chr(111182)
NUSHU_CHARACTER_1B24F = chr(111183)
NUSHU_CHARACTER_1B250 = chr(111184)
NUSHU_CHARACTER_1B251 = chr(111185)
NUSHU_CHARACTER_1B252 = chr(111186)
NUSHU_CHARACTER_1B253 = chr(111187)
NUSHU_CHARACTER_1B254 = chr(111188)
NUSHU_CHARACTER_1B255 = chr(111189)
NUSHU_CHARACTER_1B256 = chr(111190)
NUSHU_CHARACTER_1B257 = chr(111191)
NUSHU_CHARACTER_1B258 = chr(111192)
NUSHU_CHARACTER_1B259 = chr(111193)
NUSHU_CHARACTER_1B25A = chr(111194)
NUSHU_CHARACTER_1B25B = chr(111195)
NUSHU_CHARACTER_1B25C = chr(111196)
NUSHU_CHARACTER_1B25D = chr(111197)
NUSHU_CHARACTER_1B25E = chr(111198)
NUSHU_CHARACTER_1B25F = chr(111199)
NUSHU_CHARACTER_1B260 = chr(111200)
NUSHU_CHARACTER_1B261 = chr(111201)
NUSHU_CHARACTER_1B262 = chr(111202)
NUSHU_CHARACTER_1B263 = chr(111203)
NUSHU_CHARACTER_1B264 = chr(111204)
NUSHU_CHARACTER_1B265 = chr(111205)
NUSHU_CHARACTER_1B266 = chr(111206)
NUSHU_CHARACTER_1B267 = chr(111207)
NUSHU_CHARACTER_1B268 = chr(111208)
NUSHU_CHARACTER_1B269 = chr(111209)
NUSHU_CHARACTER_1B26A = chr(111210)
NUSHU_CHARACTER_1B26B = chr(111211)
NUSHU_CHARACTER_1B26C = chr(111212)
NUSHU_CHARACTER_1B26D = chr(111213)
NUSHU_CHARACTER_1B26E = chr(111214)
NUSHU_CHARACTER_1B26F = chr(111215)
NUSHU_CHARACTER_1B270 = chr(111216)
NUSHU_CHARACTER_1B271 = chr(111217)
NUSHU_CHARACTER_1B272 = chr(111218)
NUSHU_CHARACTER_1B273 = chr(111219)
NUSHU_CHARACTER_1B274 = chr(111220)
NUSHU_CHARACTER_1B275 = chr(111221)
NUSHU_CHARACTER_1B276 = chr(111222)
NUSHU_CHARACTER_1B277 = chr(111223)
NUSHU_CHARACTER_1B278 = chr(111224)
NUSHU_CHARACTER_1B279 = chr(111225)
NUSHU_CHARACTER_1B27A = chr(111226)
NUSHU_CHARACTER_1B27B = chr(111227)
NUSHU_CHARACTER_1B27C = chr(111228)
NUSHU_CHARACTER_1B27D = chr(111229)
NUSHU_CHARACTER_1B27E = chr(111230)
NUSHU_CHARACTER_1B27F = chr(111231)
NUSHU_CHARACTER_1B280 = chr(111232)
NUSHU_CHARACTER_1B281 = chr(111233)
NUSHU_CHARACTER_1B282 = chr(111234)
NUSHU_CHARACTER_1B283 = chr(111235)
NUSHU_CHARACTER_1B284 = chr(111236)
NUSHU_CHARACTER_1B285 = chr(111237)
NUSHU_CHARACTER_1B286 = chr(111238)
NUSHU_CHARACTER_1B287 = chr(111239)
NUSHU_CHARACTER_1B288 = chr(111240)
NUSHU_CHARACTER_1B289 = chr(111241)
NUSHU_CHARACTER_1B28A = chr(111242)
NUSHU_CHARACTER_1B28B = chr(111243)
NUSHU_CHARACTER_1B28C = chr(111244)
NUSHU_CHARACTER_1B28D = chr(111245)
NUSHU_CHARACTER_1B28E = chr(111246)
NUSHU_CHARACTER_1B28F = chr(111247)
NUSHU_CHARACTER_1B290 = chr(111248)
NUSHU_CHARACTER_1B291 = chr(111249)
NUSHU_CHARACTER_1B292 = chr(111250)
NUSHU_CHARACTER_1B293 = chr(111251)
NUSHU_CHARACTER_1B294 = chr(111252)
NUSHU_CHARACTER_1B295 = chr(111253)
NUSHU_CHARACTER_1B296 = chr(111254)
NUSHU_CHARACTER_1B297 = chr(111255)
NUSHU_CHARACTER_1B298 = chr(111256)
NUSHU_CHARACTER_1B299 = chr(111257)
NUSHU_CHARACTER_1B29A = chr(111258)
NUSHU_CHARACTER_1B29B = chr(111259)
NUSHU_CHARACTER_1B29C = chr(111260)
NUSHU_CHARACTER_1B29D = chr(111261)
NUSHU_CHARACTER_1B29E = chr(111262)
NUSHU_CHARACTER_1B29F = chr(111263)
NUSHU_CHARACTER_1B2A0 = chr(111264)
NUSHU_CHARACTER_1B2A1 = chr(111265)
NUSHU_CHARACTER_1B2A2 = chr(111266)
NUSHU_CHARACTER_1B2A3 = chr(111267)
NUSHU_CHARACTER_1B2A4 = chr(111268)
NUSHU_CHARACTER_1B2A5 = chr(111269)
NUSHU_CHARACTER_1B2A6 = chr(111270)
NUSHU_CHARACTER_1B2A7 = chr(111271)
NUSHU_CHARACTER_1B2A8 = chr(111272)
NUSHU_CHARACTER_1B2A9 = chr(111273)
NUSHU_CHARACTER_1B2AA = chr(111274)
NUSHU_CHARACTER_1B2AB = chr(111275)
NUSHU_CHARACTER_1B2AC = chr(111276)
NUSHU_CHARACTER_1B2AD = chr(111277)
NUSHU_CHARACTER_1B2AE = chr(111278)
NUSHU_CHARACTER_1B2AF = chr(111279)
NUSHU_CHARACTER_1B2B0 = chr(111280)
NUSHU_CHARACTER_1B2B1 = chr(111281)
NUSHU_CHARACTER_1B2B2 = chr(111282)
NUSHU_CHARACTER_1B2B3 = chr(111283)
NUSHU_CHARACTER_1B2B4 = chr(111284)
NUSHU_CHARACTER_1B2B5 = chr(111285)
NUSHU_CHARACTER_1B2B6 = chr(111286)
NUSHU_CHARACTER_1B2B7 = chr(111287)
NUSHU_CHARACTER_1B2B8 = chr(111288)
NUSHU_CHARACTER_1B2B9 = chr(111289)
NUSHU_CHARACTER_1B2BA = chr(111290)
NUSHU_CHARACTER_1B2BB = chr(111291)
NUSHU_CHARACTER_1B2BC = chr(111292)
NUSHU_CHARACTER_1B2BD = chr(111293)
NUSHU_CHARACTER_1B2BE = chr(111294)
NUSHU_CHARACTER_1B2BF = chr(111295)
NUSHU_CHARACTER_1B2C0 = chr(111296)
NUSHU_CHARACTER_1B2C1 = chr(111297)
NUSHU_CHARACTER_1B2C2 = chr(111298)
NUSHU_CHARACTER_1B2C3 = chr(111299)
NUSHU_CHARACTER_1B2C4 = chr(111300)
NUSHU_CHARACTER_1B2C5 = chr(111301)
NUSHU_CHARACTER_1B2C6 = chr(111302)
NUSHU_CHARACTER_1B2C7 = chr(111303)
NUSHU_CHARACTER_1B2C8 = chr(111304)
NUSHU_CHARACTER_1B2C9 = chr(111305)
NUSHU_CHARACTER_1B2CA = chr(111306)
NUSHU_CHARACTER_1B2CB = chr(111307)
NUSHU_CHARACTER_1B2CC = chr(111308)
NUSHU_CHARACTER_1B2CD = chr(111309)
NUSHU_CHARACTER_1B2CE = chr(111310)
NUSHU_CHARACTER_1B2CF = chr(111311)
NUSHU_CHARACTER_1B2D0 = chr(111312)
NUSHU_CHARACTER_1B2D1 = chr(111313)
NUSHU_CHARACTER_1B2D2 = chr(111314)
NUSHU_CHARACTER_1B2D3 = chr(111315)
NUSHU_CHARACTER_1B2D4 = chr(111316)
NUSHU_CHARACTER_1B2D5 = chr(111317)
NUSHU_CHARACTER_1B2D6 = chr(111318)
NUSHU_CHARACTER_1B2D7 = chr(111319)
NUSHU_CHARACTER_1B2D8 = chr(111320)
NUSHU_CHARACTER_1B2D9 = chr(111321)
NUSHU_CHARACTER_1B2DA = chr(111322)
NUSHU_CHARACTER_1B2DB = chr(111323)
NUSHU_CHARACTER_1B2DC = chr(111324)
NUSHU_CHARACTER_1B2DD = chr(111325)
NUSHU_CHARACTER_1B2DE = chr(111326)
NUSHU_CHARACTER_1B2DF = chr(111327)
NUSHU_CHARACTER_1B2E0 = chr(111328)
NUSHU_CHARACTER_1B2E1 = chr(111329)
NUSHU_CHARACTER_1B2E2 = chr(111330)
NUSHU_CHARACTER_1B2E3 = chr(111331)
NUSHU_CHARACTER_1B2E4 = chr(111332)
NUSHU_CHARACTER_1B2E5 = chr(111333)
NUSHU_CHARACTER_1B2E6 = chr(111334)
NUSHU_CHARACTER_1B2E7 = chr(111335)
NUSHU_CHARACTER_1B2E8 = chr(111336)
NUSHU_CHARACTER_1B2E9 = chr(111337)
NUSHU_CHARACTER_1B2EA = chr(111338)
NUSHU_CHARACTER_1B2EB = chr(111339)
NUSHU_CHARACTER_1B2EC = chr(111340)
NUSHU_CHARACTER_1B2ED = chr(111341)
NUSHU_CHARACTER_1B2EE = chr(111342)
NUSHU_CHARACTER_1B2EF = chr(111343)
NUSHU_CHARACTER_1B2F0 = chr(111344)
NUSHU_CHARACTER_1B2F1 = chr(111345)
NUSHU_CHARACTER_1B2F2 = chr(111346)
NUSHU_CHARACTER_1B2F3 = chr(111347)
NUSHU_CHARACTER_1B2F4 = chr(111348)
NUSHU_CHARACTER_1B2F5 = chr(111349)
NUSHU_CHARACTER_1B2F6 = chr(111350)
NUSHU_CHARACTER_1B2F7 = chr(111351)
NUSHU_CHARACTER_1B2F8 = chr(111352)
NUSHU_CHARACTER_1B2F9 = chr(111353)
NUSHU_CHARACTER_1B2FA = chr(111354)
NUSHU_CHARACTER_1B2FB = chr(111355)
DUPLOYAN_LETTER_H = chr(113664)
DUPLOYAN_LETTER_X = chr(113665)
DUPLOYAN_LETTER_P = chr(113666)
DUPLOYAN_LETTER_T = chr(113667)
DUPLOYAN_LETTER_F = chr(113668)
DUPLOYAN_LETTER_K = chr(113669)
DUPLOYAN_LETTER_L = chr(113670)
DUPLOYAN_LETTER_B = chr(113671)
DUPLOYAN_LETTER_D = chr(113672)
DUPLOYAN_LETTER_V = chr(113673)
DUPLOYAN_LETTER_G = chr(113674)
DUPLOYAN_LETTER_R = chr(113675)
DUPLOYAN_LETTER_P_N = chr(113676)
DUPLOYAN_LETTER_D_S = chr(113677)
DUPLOYAN_LETTER_F_N = chr(113678)
DUPLOYAN_LETTER_K_M = chr(113679)
DUPLOYAN_LETTER_R_S = chr(113680)
DUPLOYAN_LETTER_TH = chr(113681)
DUPLOYAN_LETTER_SLOAN_DH = chr(113682)
DUPLOYAN_LETTER_DH = chr(113683)
DUPLOYAN_LETTER_KK = chr(113684)
DUPLOYAN_LETTER_SLOAN_J = chr(113685)
DUPLOYAN_LETTER_HL = chr(113686)
DUPLOYAN_LETTER_LH = chr(113687)
DUPLOYAN_LETTER_RH = chr(113688)
DUPLOYAN_LETTER_M = chr(113689)
DUPLOYAN_LETTER_N = chr(113690)
DUPLOYAN_LETTER_J = chr(113691)
DUPLOYAN_LETTER_S = chr(113692)
DUPLOYAN_LETTER_M_N = chr(113693)
DUPLOYAN_LETTER_N_M = chr(113694)
DUPLOYAN_LETTER_J_M = chr(113695)
DUPLOYAN_LETTER_S_J = chr(113696)
DUPLOYAN_LETTER_M_WITH_DOT = chr(113697)
DUPLOYAN_LETTER_N_WITH_DOT = chr(113698)
DUPLOYAN_LETTER_J_WITH_DOT = chr(113699)
DUPLOYAN_LETTER_J_WITH_DOTS_INSIDE_AND_ABOVE = chr(113700)
DUPLOYAN_LETTER_S_WITH_DOT = chr(113701)
DUPLOYAN_LETTER_S_WITH_DOT_BELOW = chr(113702)
DUPLOYAN_LETTER_M_S = chr(113703)
DUPLOYAN_LETTER_N_S = chr(113704)
DUPLOYAN_LETTER_J_S = chr(113705)
DUPLOYAN_LETTER_S_S = chr(113706)
DUPLOYAN_LETTER_M_N_S = chr(113707)
DUPLOYAN_LETTER_N_M_S = chr(113708)
DUPLOYAN_LETTER_J_M_S = chr(113709)
DUPLOYAN_LETTER_S_J_S = chr(113710)
DUPLOYAN_LETTER_J_S_WITH_DOT = chr(113711)
DUPLOYAN_LETTER_J_N = chr(113712)
DUPLOYAN_LETTER_J_N_S = chr(113713)
DUPLOYAN_LETTER_S_T = chr(113714)
DUPLOYAN_LETTER_S_T_R = chr(113715)
DUPLOYAN_LETTER_S_P = chr(113716)
DUPLOYAN_LETTER_S_P_R = chr(113717)
DUPLOYAN_LETTER_T_S = chr(113718)
DUPLOYAN_LETTER_T_R_S = chr(113719)
DUPLOYAN_LETTER_W = chr(113720)
DUPLOYAN_LETTER_WH = chr(113721)
DUPLOYAN_LETTER_W_R = chr(113722)
DUPLOYAN_LETTER_S_N = chr(113723)
DUPLOYAN_LETTER_S_M = chr(113724)
DUPLOYAN_LETTER_K_R_S = chr(113725)
DUPLOYAN_LETTER_G_R_S = chr(113726)
DUPLOYAN_LETTER_S_K = chr(113727)
DUPLOYAN_LETTER_S_K_R = chr(113728)
DUPLOYAN_LETTER_A = chr(113729)
DUPLOYAN_LETTER_SLOAN_OW = chr(113730)
DUPLOYAN_LETTER_OA = chr(113731)
DUPLOYAN_LETTER_O = chr(113732)
DUPLOYAN_LETTER_AOU = chr(113733)
DUPLOYAN_LETTER_I = chr(113734)
DUPLOYAN_LETTER_E = chr(113735)
DUPLOYAN_LETTER_IE = chr(113736)
DUPLOYAN_LETTER_SHORT_I = chr(113737)
DUPLOYAN_LETTER_UI = chr(113738)
DUPLOYAN_LETTER_EE = chr(113739)
DUPLOYAN_LETTER_SLOAN_EH = chr(113740)
DUPLOYAN_LETTER_ROMANIAN_I = chr(113741)
DUPLOYAN_LETTER_SLOAN_EE = chr(113742)
DUPLOYAN_LETTER_LONG_I = chr(113743)
DUPLOYAN_LETTER_YE = chr(113744)
DUPLOYAN_LETTER_U = chr(113745)
DUPLOYAN_LETTER_EU = chr(113746)
DUPLOYAN_LETTER_XW = chr(113747)
DUPLOYAN_LETTER_U_N = chr(113748)
DUPLOYAN_LETTER_LONG_U = chr(113749)
DUPLOYAN_LETTER_ROMANIAN_U = chr(113750)
DUPLOYAN_LETTER_UH = chr(113751)
DUPLOYAN_LETTER_SLOAN_U = chr(113752)
DUPLOYAN_LETTER_OOH = chr(113753)
DUPLOYAN_LETTER_OW = chr(113754)
DUPLOYAN_LETTER_OU = chr(113755)
DUPLOYAN_LETTER_WA = chr(113756)
DUPLOYAN_LETTER_WO = chr(113757)
DUPLOYAN_LETTER_WI = chr(113758)
DUPLOYAN_LETTER_WEI = chr(113759)
DUPLOYAN_LETTER_WOW = chr(113760)
DUPLOYAN_LETTER_NASAL_U = chr(113761)
DUPLOYAN_LETTER_NASAL_O = chr(113762)
DUPLOYAN_LETTER_NASAL_I = chr(113763)
DUPLOYAN_LETTER_NASAL_A = chr(113764)
DUPLOYAN_LETTER_PERNIN_AN = chr(113765)
DUPLOYAN_LETTER_PERNIN_AM = chr(113766)
DUPLOYAN_LETTER_SLOAN_EN = chr(113767)
DUPLOYAN_LETTER_SLOAN_AN = chr(113768)
DUPLOYAN_LETTER_SLOAN_ON = chr(113769)
DUPLOYAN_LETTER_VOCALIC_M = chr(113770)
DUPLOYAN_AFFIX_LEFT_HORIZONTAL_SECANT = chr(113776)
DUPLOYAN_AFFIX_MID_HORIZONTAL_SECANT = chr(113777)
DUPLOYAN_AFFIX_RIGHT_HORIZONTAL_SECANT = chr(113778)
DUPLOYAN_AFFIX_LOW_VERTICAL_SECANT = chr(113779)
DUPLOYAN_AFFIX_MID_VERTICAL_SECANT = chr(113780)
DUPLOYAN_AFFIX_HIGH_VERTICAL_SECANT = chr(113781)
DUPLOYAN_AFFIX_ATTACHED_SECANT = chr(113782)
DUPLOYAN_AFFIX_ATTACHED_LEFT_TO_RIGHT_SECANT = chr(113783)
DUPLOYAN_AFFIX_ATTACHED_TANGENT = chr(113784)
DUPLOYAN_AFFIX_ATTACHED_TAIL = chr(113785)
DUPLOYAN_AFFIX_ATTACHED_E_HOOK = chr(113786)
DUPLOYAN_AFFIX_ATTACHED_I_HOOK = chr(113787)
DUPLOYAN_AFFIX_ATTACHED_TANGENT_HOOK = chr(113788)
DUPLOYAN_AFFIX_HIGH_ACUTE = chr(113792)
DUPLOYAN_AFFIX_HIGH_TIGHT_ACUTE = chr(113793)
DUPLOYAN_AFFIX_HIGH_GRAVE = chr(113794)
DUPLOYAN_AFFIX_HIGH_LONG_GRAVE = chr(113795)
DUPLOYAN_AFFIX_HIGH_DOT = chr(113796)
DUPLOYAN_AFFIX_HIGH_CIRCLE = chr(113797)
DUPLOYAN_AFFIX_HIGH_LINE = chr(113798)
DUPLOYAN_AFFIX_HIGH_WAVE = chr(113799)
DUPLOYAN_AFFIX_HIGH_VERTICAL = chr(113800)
DUPLOYAN_AFFIX_LOW_ACUTE = chr(113808)
DUPLOYAN_AFFIX_LOW_TIGHT_ACUTE = chr(113809)
DUPLOYAN_AFFIX_LOW_GRAVE = chr(113810)
DUPLOYAN_AFFIX_LOW_LONG_GRAVE = chr(113811)
DUPLOYAN_AFFIX_LOW_DOT = chr(113812)
DUPLOYAN_AFFIX_LOW_CIRCLE = chr(113813)
DUPLOYAN_AFFIX_LOW_LINE = chr(113814)
DUPLOYAN_AFFIX_LOW_WAVE = chr(113815)
DUPLOYAN_AFFIX_LOW_VERTICAL = chr(113816)
DUPLOYAN_AFFIX_LOW_ARROW = chr(113817)
DUPLOYAN_SIGN_O_WITH_CROSS = chr(113820)
DUPLOYAN_THICK_LETTER_SELECTOR = chr(113821)
DUPLOYAN_DOUBLE_MARK = chr(113822)
DUPLOYAN_PUNCTUATION_CHINOOK_FULL_STOP = chr(113823)
SHORTHAND_FORMAT_LETTER_OVERLAP = chr(113824)
SHORTHAND_FORMAT_CONTINUING_OVERLAP = chr(113825)
SHORTHAND_FORMAT_DOWN_STEP = chr(113826)
SHORTHAND_FORMAT_UP_STEP = chr(113827)
ZNAMENNY_COMBINING_MARK_GORAZDO_NIZKO_S_KRYZHEM_ON_LEFT = chr(118528)
ZNAMENNY_COMBINING_MARK_NIZKO_S_KRYZHEM_ON_LEFT = chr(118529)
ZNAMENNY_COMBINING_MARK_TSATA_ON_LEFT = chr(118530)
ZNAMENNY_COMBINING_MARK_GORAZDO_NIZKO_ON_LEFT = chr(118531)
ZNAMENNY_COMBINING_MARK_NIZKO_ON_LEFT = chr(118532)
ZNAMENNY_COMBINING_MARK_SREDNE_ON_LEFT = chr(118533)
ZNAMENNY_COMBINING_MARK_MALO_POVYSHE_ON_LEFT = chr(118534)
ZNAMENNY_COMBINING_MARK_POVYSHE_ON_LEFT = chr(118535)
ZNAMENNY_COMBINING_MARK_VYSOKO_ON_LEFT = chr(118536)
ZNAMENNY_COMBINING_MARK_MALO_POVYSHE_S_KHOKHLOM_ON_LEFT = chr(118537)
ZNAMENNY_COMBINING_MARK_POVYSHE_S_KHOKHLOM_ON_LEFT = chr(118538)
ZNAMENNY_COMBINING_MARK_VYSOKO_S_KHOKHLOM_ON_LEFT = chr(118539)
ZNAMENNY_COMBINING_MARK_GORAZDO_NIZKO_S_KRYZHEM_ON_RIGHT = chr(118540)
ZNAMENNY_COMBINING_MARK_NIZKO_S_KRYZHEM_ON_RIGHT = chr(118541)
ZNAMENNY_COMBINING_MARK_TSATA_ON_RIGHT = chr(118542)
ZNAMENNY_COMBINING_MARK_GORAZDO_NIZKO_ON_RIGHT = chr(118543)
ZNAMENNY_COMBINING_MARK_NIZKO_ON_RIGHT = chr(118544)
ZNAMENNY_COMBINING_MARK_SREDNE_ON_RIGHT = chr(118545)
ZNAMENNY_COMBINING_MARK_MALO_POVYSHE_ON_RIGHT = chr(118546)
ZNAMENNY_COMBINING_MARK_POVYSHE_ON_RIGHT = chr(118547)
ZNAMENNY_COMBINING_MARK_VYSOKO_ON_RIGHT = chr(118548)
ZNAMENNY_COMBINING_MARK_MALO_POVYSHE_S_KHOKHLOM_ON_RIGHT = chr(118549)
ZNAMENNY_COMBINING_MARK_POVYSHE_S_KHOKHLOM_ON_RIGHT = chr(118550)
ZNAMENNY_COMBINING_MARK_VYSOKO_S_KHOKHLOM_ON_RIGHT = chr(118551)
ZNAMENNY_COMBINING_MARK_TSATA_S_KRYZHEM = chr(118552)
ZNAMENNY_COMBINING_MARK_MALO_POVYSHE_S_KRYZHEM = chr(118553)
ZNAMENNY_COMBINING_MARK_STRANNO_MALO_POVYSHE = chr(118554)
ZNAMENNY_COMBINING_MARK_POVYSHE_S_KRYZHEM = chr(118555)
ZNAMENNY_COMBINING_MARK_POVYSHE_STRANNO = chr(118556)
ZNAMENNY_COMBINING_MARK_VYSOKO_S_KRYZHEM = chr(118557)
ZNAMENNY_COMBINING_MARK_MALO_POVYSHE_STRANNO = chr(118558)
ZNAMENNY_COMBINING_MARK_GORAZDO_VYSOKO = chr(118559)
ZNAMENNY_COMBINING_MARK_ZELO = chr(118560)
ZNAMENNY_COMBINING_MARK_ON = chr(118561)
ZNAMENNY_COMBINING_MARK_RAVNO = chr(118562)
ZNAMENNY_COMBINING_MARK_TIKHAYA = chr(118563)
ZNAMENNY_COMBINING_MARK_BORZAYA = chr(118564)
ZNAMENNY_COMBINING_MARK_UDARKA = chr(118565)
ZNAMENNY_COMBINING_MARK_PODVERTKA = chr(118566)
ZNAMENNY_COMBINING_MARK_LOMKA = chr(118567)
ZNAMENNY_COMBINING_MARK_KUPNAYA = chr(118568)
ZNAMENNY_COMBINING_MARK_KACHKA = chr(118569)
ZNAMENNY_COMBINING_MARK_ZEVOK = chr(118570)
ZNAMENNY_COMBINING_MARK_SKOBA = chr(118571)
ZNAMENNY_COMBINING_MARK_RAZSEKA = chr(118572)
ZNAMENNY_COMBINING_MARK_KRYZH_ON_LEFT = chr(118573)
ZNAMENNY_COMBINING_TONAL_RANGE_MARK_MRACHNO = chr(118576)
ZNAMENNY_COMBINING_TONAL_RANGE_MARK_SVETLO = chr(118577)
ZNAMENNY_COMBINING_TONAL_RANGE_MARK_TRESVETLO = chr(118578)
ZNAMENNY_COMBINING_MARK_ZADERZHKA = chr(118579)
ZNAMENNY_COMBINING_MARK_DEMESTVENNY_ZADERZHKA = chr(118580)
ZNAMENNY_COMBINING_MARK_OTSECHKA = chr(118581)
ZNAMENNY_COMBINING_MARK_PODCHASHIE = chr(118582)
ZNAMENNY_COMBINING_MARK_PODCHASHIE_WITH_VERTICAL_STROKE = chr(118583)
ZNAMENNY_COMBINING_MARK_CHASHKA = chr(118584)
ZNAMENNY_COMBINING_MARK_CHASHKA_POLNAYA = chr(118585)
ZNAMENNY_COMBINING_MARK_OBLACHKO = chr(118586)
ZNAMENNY_COMBINING_MARK_SOROCHYA_NOZHKA = chr(118587)
ZNAMENNY_COMBINING_MARK_TOCHKA = chr(118588)
ZNAMENNY_COMBINING_MARK_DVOETOCHIE = chr(118589)
ZNAMENNY_COMBINING_ATTACHING_VERTICAL_OMET = chr(118590)
ZNAMENNY_COMBINING_MARK_CURVED_OMET = chr(118591)
ZNAMENNY_COMBINING_MARK_KRYZH = chr(118592)
ZNAMENNY_COMBINING_LOWER_TONAL_RANGE_INDICATOR = chr(118593)
ZNAMENNY_PRIZNAK_MODIFIER_LEVEL_2 = chr(118594)
ZNAMENNY_PRIZNAK_MODIFIER_LEVEL_3 = chr(118595)
ZNAMENNY_PRIZNAK_MODIFIER_DIRECTION_FLIP = chr(118596)
ZNAMENNY_PRIZNAK_MODIFIER_KRYZH = chr(118597)
ZNAMENNY_PRIZNAK_MODIFIER_ROG = chr(118598)
ZNAMENNY_NEUME_KRYUK = chr(118608)
ZNAMENNY_NEUME_KRYUK_TIKHY = chr(118609)
ZNAMENNY_NEUME_PARAKLIT = chr(118610)
ZNAMENNY_NEUME_DVA_V_CHELNU = chr(118611)
ZNAMENNY_NEUME_KLYUCH = chr(118612)
ZNAMENNY_NEUME_ZANOZHEK = chr(118613)
ZNAMENNY_NEUME_STOPITSA = chr(118614)
ZNAMENNY_NEUME_STOPITSA_S_OCHKOM = chr(118615)
ZNAMENNY_NEUME_PEREVODKA = chr(118616)
ZNAMENNY_NEUME_PEREVODKA_NEPOSTOYANNAYA = chr(118617)
ZNAMENNY_NEUME_STOPITSA_WITH_SOROCHYA_NOZHKA = chr(118618)
ZNAMENNY_NEUME_CHELYUSTKA = chr(118619)
ZNAMENNY_NEUME_PALKA = chr(118620)
ZNAMENNY_NEUME_ZAPYATAYA = chr(118621)
ZNAMENNY_NEUME_GOLUBCHIK_BORZY = chr(118622)
ZNAMENNY_NEUME_GOLUBCHIK_TIKHY = chr(118623)
ZNAMENNY_NEUME_GOLUBCHIK_MRACHNY = chr(118624)
ZNAMENNY_NEUME_GOLUBCHIK_SVETLY = chr(118625)
ZNAMENNY_NEUME_GOLUBCHIK_TRESVETLY = chr(118626)
ZNAMENNY_NEUME_VRAKHIYA_PROSTAYA = chr(118627)
ZNAMENNY_NEUME_VRAKHIYA_MRACHNAYA = chr(118628)
ZNAMENNY_NEUME_VRAKHIYA_SVETLAYA = chr(118629)
ZNAMENNY_NEUME_VRAKHIYA_TRESVETLAYA = chr(118630)
ZNAMENNY_NEUME_VRAKHIYA_KLYUCHEVAYA_PROSTAYA = chr(118631)
ZNAMENNY_NEUME_VRAKHIYA_KLYUCHEVAYA_MRACHNAYA = chr(118632)
ZNAMENNY_NEUME_VRAKHIYA_KLYUCHEVAYA_SVETLAYA = chr(118633)
ZNAMENNY_NEUME_VRAKHIYA_KLYUCHEVAYA_TRESVETLAYA = chr(118634)
ZNAMENNY_NEUME_DOUBLE_ZAPYATAYA = chr(118635)
ZNAMENNY_NEUME_REVERSED_CHELYUSTKA = chr(118636)
ZNAMENNY_NEUME_DERBITSA = chr(118637)
ZNAMENNY_NEUME_KHAMILO = chr(118638)
ZNAMENNY_NEUME_CHASHKA = chr(118639)
ZNAMENNY_NEUME_PODCHASHIE = chr(118640)
ZNAMENNY_NEUME_SKAMEYTSA_MRACHNAYA = chr(118641)
ZNAMENNY_NEUME_SKAMEYTSA_SVETLAYA = chr(118642)
ZNAMENNY_NEUME_SKAMEYTSA_TRESVETLAYA = chr(118643)
ZNAMENNY_NEUME_SKAMEYTSA_TIKHAYA = chr(118644)
ZNAMENNY_NEUME_DEMESTVENNY_KLYUCH = chr(118645)
ZNAMENNY_NEUME_SKAMEYTSA_KLYUCHEVAYA_SVETLAYA = chr(118646)
ZNAMENNY_NEUME_SKAMEYTSA_KLYUCHENEPOSTOYANNAYA = chr(118647)
ZNAMENNY_NEUME_SKAMEYTSA_KLYUCHEVAYA_TIKHAYA = chr(118648)
ZNAMENNY_NEUME_SKAMEYTSA_DVOECHELNAYA_PROSTAYA = chr(118649)
ZNAMENNY_NEUME_SKAMEYTSA_DVOECHELNAYA_SVETLAYA = chr(118650)
ZNAMENNY_NEUME_SKAMEYTSA_DVOECHELNAYA_NEPOSTOYANNAYA = chr(118651)
ZNAMENNY_NEUME_SKAMEYTSA_DVOECHELNAYA_KLYUCHEVAYA = chr(118652)
ZNAMENNY_NEUME_SLOZHITIE = chr(118653)
ZNAMENNY_NEUME_SLOZHITIE_S_ZAPYATOY = chr(118654)
ZNAMENNY_NEUME_SLOZHITIE_ZAKRYTOE = chr(118655)
ZNAMENNY_NEUME_SLOZHITIE_S_KRYZHEM = chr(118656)
ZNAMENNY_NEUME_KRYZH = chr(118657)
ZNAMENNY_NEUME_ROG = chr(118658)
ZNAMENNY_NEUME_FITA = chr(118659)
ZNAMENNY_NEUME_KOBYLA = chr(118660)
ZNAMENNY_NEUME_ZMEYTSA = chr(118661)
ZNAMENNY_NEUME_STATYA = chr(118662)
ZNAMENNY_NEUME_STATYA_S_ZAPYATOY = chr(118663)
ZNAMENNY_NEUME_STATYA_S_KRYZHEM = chr(118664)
ZNAMENNY_NEUME_STATYA_S_ZAPYATOY_I_KRYZHEM = chr(118665)
ZNAMENNY_NEUME_STATYA_S_KRYZHEM_I_ZAPYATOY = chr(118666)
ZNAMENNY_NEUME_STATYA_ZAKRYTAYA = chr(118667)
ZNAMENNY_NEUME_STATYA_ZAKRYTAYA_S_ZAPYATOY = chr(118668)
ZNAMENNY_NEUME_STATYA_S_ROGOM = chr(118669)
ZNAMENNY_NEUME_STATYA_S_DVUMYA_ZAPYATYMI = chr(118670)
ZNAMENNY_NEUME_STATYA_S_ZAPYATOY_I_PODCHASHIEM = chr(118671)
ZNAMENNY_NEUME_POLKULIZMY = chr(118672)
ZNAMENNY_NEUME_STATYA_NEPOSTOYANNAYA = chr(118673)
ZNAMENNY_NEUME_STRELA_PROSTAYA = chr(118674)
ZNAMENNY_NEUME_STRELA_MRACHNOTIKHAYA = chr(118675)
ZNAMENNY_NEUME_STRELA_KRYZHEVAYA = chr(118676)
ZNAMENNY_NEUME_STRELA_POLUPOVODNAYA = chr(118677)
ZNAMENNY_NEUME_STRELA_POVODNAYA = chr(118678)
ZNAMENNY_NEUME_STRELA_NEPOSTOYANNAYA = chr(118679)
ZNAMENNY_NEUME_STRELA_KLYUCHEPOVODNAYA = chr(118680)
ZNAMENNY_NEUME_STRELA_KLYUCHENEPOSTOYANNAYA = chr(118681)
ZNAMENNY_NEUME_STRELA_TIKHAYA_PUTNAYA = chr(118682)
ZNAMENNY_NEUME_STRELA_DVOECHELNAYA = chr(118683)
ZNAMENNY_NEUME_STRELA_DVOECHELNOKRYZHEVAYA = chr(118684)
ZNAMENNY_NEUME_STRELA_DVOECHELNOPOVODNAYA = chr(118685)
ZNAMENNY_NEUME_STRELA_DVOECHELNAYA_KLYUCHEVAYA = chr(118686)
ZNAMENNY_NEUME_STRELA_DVOECHELNOPOVODNAYA_KLYUCHEVAYA = chr(118687)
ZNAMENNY_NEUME_STRELA_GROMNAYA_WITH_SINGLE_ZAPYATAYA = chr(118688)
ZNAMENNY_NEUME_STRELA_GROMOPOVODNAYA_WITH_SINGLE_ZAPYATAYA = chr(118689)
ZNAMENNY_NEUME_STRELA_GROMNAYA = chr(118690)
ZNAMENNY_NEUME_STRELA_GROMOPOVODNAYA = chr(118691)
ZNAMENNY_NEUME_STRELA_GROMOPOVODNAYA_WITH_DOUBLE_ZAPYATAYA = chr(118692)
ZNAMENNY_NEUME_STRELA_GROMOKRYZHEVAYA = chr(118693)
ZNAMENNY_NEUME_STRELA_GROMOKRYZHEVAYA_POVODNAYA = chr(118694)
ZNAMENNY_NEUME_MECHIK = chr(118695)
ZNAMENNY_NEUME_MECHIK_POVODNY = chr(118696)
ZNAMENNY_NEUME_MECHIK_KLYUCHEVOY = chr(118697)
ZNAMENNY_NEUME_MECHIK_KLYUCHEPOVODNY = chr(118698)
ZNAMENNY_NEUME_MECHIK_KLYUCHENEPOSTOYANNY = chr(118699)
ZNAMENNY_NEUME_STRELA_TRYASOGLASNAYA = chr(118700)
ZNAMENNY_NEUME_STRELA_TRYASOPOVODNAYA = chr(118701)
ZNAMENNY_NEUME_STRELA_TRYASOSTRELNAYA = chr(118702)
ZNAMENNY_NEUME_OSOKA = chr(118703)
ZNAMENNY_NEUME_OSOKA_SVETLAYA = chr(118704)
ZNAMENNY_NEUME_OSOKA_TRESVETLAYA = chr(118705)
ZNAMENNY_NEUME_OSOKA_KRYUKOVAYA_SVETLAYA = chr(118706)
ZNAMENNY_NEUME_OSOKA_KLYUCHEVAYA_SVETLAYA = chr(118707)
ZNAMENNY_NEUME_OSOKA_KLYUCHEVAYA_NEPOSTOYANNAYA = chr(118708)
ZNAMENNY_NEUME_STRELA_KRYUKOVAYA = chr(118709)
ZNAMENNY_NEUME_STRELA_KRYUKOVAYA_POVODNAYA = chr(118710)
ZNAMENNY_NEUME_STRELA_KRYUKOVAYA_GROMNAYA_WITH_SINGLE_ZAPYATAYA = chr(118711)
ZNAMENNY_NEUME_STRELA_KRYUKOVAYA_GROMOPOVODNAYA_WITH_SINGLE_ZAPYATAYA = chr(118712)
ZNAMENNY_NEUME_STRELA_KRYUKOVAYA_GROMNAYA = chr(118713)
ZNAMENNY_NEUME_STRELA_KRYUKOVAYA_GROMOPOVODNAYA = chr(118714)
ZNAMENNY_NEUME_STRELA_KRYUKOVAYA_GROMOPOVODNAYA_WITH_DOUBLE_ZAPYATAYA = chr(118715)
ZNAMENNY_NEUME_STRELA_KRYUKOVAYA_GROMOKRYZHEVAYA = chr(118716)
ZNAMENNY_NEUME_STRELA_KRYUKOVAYA_GROMOKRYZHEVAYA_POVODNAYA = chr(118717)
ZNAMENNY_NEUME_STRELA_KRYUKOVAYA_TRYASKA = chr(118718)
ZNAMENNY_NEUME_KUFISMA = chr(118719)
ZNAMENNY_NEUME_OBLAKO = chr(118720)
ZNAMENNY_NEUME_DUDA = chr(118721)
ZNAMENNY_NEUME_NEMKA = chr(118722)
ZNAMENNY_NEUME_PAUK = chr(118723)
BYZANTINE_MUSICAL_SYMBOL_PSILI = chr(118784)
BYZANTINE_MUSICAL_SYMBOL_DASEIA = chr(118785)
BYZANTINE_MUSICAL_SYMBOL_PERISPOMENI = chr(118786)
BYZANTINE_MUSICAL_SYMBOL_OXEIA_EKFONITIKON = chr(118787)
BYZANTINE_MUSICAL_SYMBOL_OXEIA_DIPLI = chr(118788)
BYZANTINE_MUSICAL_SYMBOL_VAREIA_EKFONITIKON = chr(118789)
BYZANTINE_MUSICAL_SYMBOL_VAREIA_DIPLI = chr(118790)
BYZANTINE_MUSICAL_SYMBOL_KATHISTI = chr(118791)
BYZANTINE_MUSICAL_SYMBOL_SYRMATIKI = chr(118792)
BYZANTINE_MUSICAL_SYMBOL_PARAKLITIKI = chr(118793)
BYZANTINE_MUSICAL_SYMBOL_YPOKRISIS = chr(118794)
BYZANTINE_MUSICAL_SYMBOL_YPOKRISIS_DIPLI = chr(118795)
BYZANTINE_MUSICAL_SYMBOL_KREMASTI = chr(118796)
BYZANTINE_MUSICAL_SYMBOL_APESO_EKFONITIKON = chr(118797)
BYZANTINE_MUSICAL_SYMBOL_EXO_EKFONITIKON = chr(118798)
BYZANTINE_MUSICAL_SYMBOL_TELEIA = chr(118799)
BYZANTINE_MUSICAL_SYMBOL_KENTIMATA = chr(118800)
BYZANTINE_MUSICAL_SYMBOL_APOSTROFOS = chr(118801)
BYZANTINE_MUSICAL_SYMBOL_APOSTROFOS_DIPLI = chr(118802)
BYZANTINE_MUSICAL_SYMBOL_SYNEVMA = chr(118803)
BYZANTINE_MUSICAL_SYMBOL_THITA = chr(118804)
BYZANTINE_MUSICAL_SYMBOL_OLIGON_ARCHAION = chr(118805)
BYZANTINE_MUSICAL_SYMBOL_GORGON_ARCHAION = chr(118806)
BYZANTINE_MUSICAL_SYMBOL_PSILON = chr(118807)
BYZANTINE_MUSICAL_SYMBOL_CHAMILON = chr(118808)
BYZANTINE_MUSICAL_SYMBOL_VATHY = chr(118809)
BYZANTINE_MUSICAL_SYMBOL_ISON_ARCHAION = chr(118810)
BYZANTINE_MUSICAL_SYMBOL_KENTIMA_ARCHAION = chr(118811)
BYZANTINE_MUSICAL_SYMBOL_KENTIMATA_ARCHAION = chr(118812)
BYZANTINE_MUSICAL_SYMBOL_SAXIMATA = chr(118813)
BYZANTINE_MUSICAL_SYMBOL_PARICHON = chr(118814)
BYZANTINE_MUSICAL_SYMBOL_STAVROS_APODEXIA = chr(118815)
BYZANTINE_MUSICAL_SYMBOL_OXEIAI_ARCHAION = chr(118816)
BYZANTINE_MUSICAL_SYMBOL_VAREIAI_ARCHAION = chr(118817)
BYZANTINE_MUSICAL_SYMBOL_APODERMA_ARCHAION = chr(118818)
BYZANTINE_MUSICAL_SYMBOL_APOTHEMA = chr(118819)
BYZANTINE_MUSICAL_SYMBOL_KLASMA = chr(118820)
BYZANTINE_MUSICAL_SYMBOL_REVMA = chr(118821)
BYZANTINE_MUSICAL_SYMBOL_PIASMA_ARCHAION = chr(118822)
BYZANTINE_MUSICAL_SYMBOL_TINAGMA = chr(118823)
BYZANTINE_MUSICAL_SYMBOL_ANATRICHISMA = chr(118824)
BYZANTINE_MUSICAL_SYMBOL_SEISMA = chr(118825)
BYZANTINE_MUSICAL_SYMBOL_SYNAGMA_ARCHAION = chr(118826)
BYZANTINE_MUSICAL_SYMBOL_SYNAGMA_META_STAVROU = chr(118827)
BYZANTINE_MUSICAL_SYMBOL_OYRANISMA_ARCHAION = chr(118828)
BYZANTINE_MUSICAL_SYMBOL_THEMA = chr(118829)
BYZANTINE_MUSICAL_SYMBOL_LEMOI = chr(118830)
BYZANTINE_MUSICAL_SYMBOL_DYO = chr(118831)
BYZANTINE_MUSICAL_SYMBOL_TRIA = chr(118832)
BYZANTINE_MUSICAL_SYMBOL_TESSERA = chr(118833)
BYZANTINE_MUSICAL_SYMBOL_KRATIMATA = chr(118834)
BYZANTINE_MUSICAL_SYMBOL_APESO_EXO_NEO = chr(118835)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_ARCHAION = chr(118836)
BYZANTINE_MUSICAL_SYMBOL_IMIFTHORA = chr(118837)
BYZANTINE_MUSICAL_SYMBOL_TROMIKON_ARCHAION = chr(118838)
BYZANTINE_MUSICAL_SYMBOL_KATAVA_TROMIKON = chr(118839)
BYZANTINE_MUSICAL_SYMBOL_PELASTON = chr(118840)
BYZANTINE_MUSICAL_SYMBOL_PSIFISTON = chr(118841)
BYZANTINE_MUSICAL_SYMBOL_KONTEVMA = chr(118842)
BYZANTINE_MUSICAL_SYMBOL_CHOREVMA_ARCHAION = chr(118843)
BYZANTINE_MUSICAL_SYMBOL_RAPISMA = chr(118844)
BYZANTINE_MUSICAL_SYMBOL_PARAKALESMA_ARCHAION = chr(118845)
BYZANTINE_MUSICAL_SYMBOL_PARAKLITIKI_ARCHAION = chr(118846)
BYZANTINE_MUSICAL_SYMBOL_ICHADIN = chr(118847)
BYZANTINE_MUSICAL_SYMBOL_NANA = chr(118848)
BYZANTINE_MUSICAL_SYMBOL_PETASMA = chr(118849)
BYZANTINE_MUSICAL_SYMBOL_KONTEVMA_ALLO = chr(118850)
BYZANTINE_MUSICAL_SYMBOL_TROMIKON_ALLO = chr(118851)
BYZANTINE_MUSICAL_SYMBOL_STRAGGISMATA = chr(118852)
BYZANTINE_MUSICAL_SYMBOL_GRONTHISMATA = chr(118853)
BYZANTINE_MUSICAL_SYMBOL_ISON_NEO = chr(118854)
BYZANTINE_MUSICAL_SYMBOL_OLIGON_NEO = chr(118855)
BYZANTINE_MUSICAL_SYMBOL_OXEIA_NEO = chr(118856)
BYZANTINE_MUSICAL_SYMBOL_PETASTI = chr(118857)
BYZANTINE_MUSICAL_SYMBOL_KOUFISMA = chr(118858)
BYZANTINE_MUSICAL_SYMBOL_PETASTOKOUFISMA = chr(118859)
BYZANTINE_MUSICAL_SYMBOL_KRATIMOKOUFISMA = chr(118860)
BYZANTINE_MUSICAL_SYMBOL_PELASTON_NEO = chr(118861)
BYZANTINE_MUSICAL_SYMBOL_KENTIMATA_NEO_ANO = chr(118862)
BYZANTINE_MUSICAL_SYMBOL_KENTIMA_NEO_ANO = chr(118863)
BYZANTINE_MUSICAL_SYMBOL_YPSILI = chr(118864)
BYZANTINE_MUSICAL_SYMBOL_APOSTROFOS_NEO = chr(118865)
BYZANTINE_MUSICAL_SYMBOL_APOSTROFOI_SYNDESMOS_NEO = chr(118866)
BYZANTINE_MUSICAL_SYMBOL_YPORROI = chr(118867)
BYZANTINE_MUSICAL_SYMBOL_KRATIMOYPORROON = chr(118868)
BYZANTINE_MUSICAL_SYMBOL_ELAFRON = chr(118869)
BYZANTINE_MUSICAL_SYMBOL_CHAMILI = chr(118870)
BYZANTINE_MUSICAL_SYMBOL_MIKRON_ISON = chr(118871)
BYZANTINE_MUSICAL_SYMBOL_VAREIA_NEO = chr(118872)
BYZANTINE_MUSICAL_SYMBOL_PIASMA_NEO = chr(118873)
BYZANTINE_MUSICAL_SYMBOL_PSIFISTON_NEO = chr(118874)
BYZANTINE_MUSICAL_SYMBOL_OMALON = chr(118875)
BYZANTINE_MUSICAL_SYMBOL_ANTIKENOMA = chr(118876)
BYZANTINE_MUSICAL_SYMBOL_LYGISMA = chr(118877)
BYZANTINE_MUSICAL_SYMBOL_PARAKLITIKI_NEO = chr(118878)
BYZANTINE_MUSICAL_SYMBOL_PARAKALESMA_NEO = chr(118879)
BYZANTINE_MUSICAL_SYMBOL_ETERON_PARAKALESMA = chr(118880)
BYZANTINE_MUSICAL_SYMBOL_KYLISMA = chr(118881)
BYZANTINE_MUSICAL_SYMBOL_ANTIKENOKYLISMA = chr(118882)
BYZANTINE_MUSICAL_SYMBOL_TROMIKON_NEO = chr(118883)
BYZANTINE_MUSICAL_SYMBOL_EKSTREPTON = chr(118884)
BYZANTINE_MUSICAL_SYMBOL_SYNAGMA_NEO = chr(118885)
BYZANTINE_MUSICAL_SYMBOL_SYRMA = chr(118886)
BYZANTINE_MUSICAL_SYMBOL_CHOREVMA_NEO = chr(118887)
BYZANTINE_MUSICAL_SYMBOL_EPEGERMA = chr(118888)
BYZANTINE_MUSICAL_SYMBOL_SEISMA_NEO = chr(118889)
BYZANTINE_MUSICAL_SYMBOL_XIRON_KLASMA = chr(118890)
BYZANTINE_MUSICAL_SYMBOL_TROMIKOPSIFISTON = chr(118891)
BYZANTINE_MUSICAL_SYMBOL_PSIFISTOLYGISMA = chr(118892)
BYZANTINE_MUSICAL_SYMBOL_TROMIKOLYGISMA = chr(118893)
BYZANTINE_MUSICAL_SYMBOL_TROMIKOPARAKALESMA = chr(118894)
BYZANTINE_MUSICAL_SYMBOL_PSIFISTOPARAKALESMA = chr(118895)
BYZANTINE_MUSICAL_SYMBOL_TROMIKOSYNAGMA = chr(118896)
BYZANTINE_MUSICAL_SYMBOL_PSIFISTOSYNAGMA = chr(118897)
BYZANTINE_MUSICAL_SYMBOL_GORGOSYNTHETON = chr(118898)
BYZANTINE_MUSICAL_SYMBOL_ARGOSYNTHETON = chr(118899)
BYZANTINE_MUSICAL_SYMBOL_ETERON_ARGOSYNTHETON = chr(118900)
BYZANTINE_MUSICAL_SYMBOL_OYRANISMA_NEO = chr(118901)
BYZANTINE_MUSICAL_SYMBOL_THEMATISMOS_ESO = chr(118902)
BYZANTINE_MUSICAL_SYMBOL_THEMATISMOS_EXO = chr(118903)
BYZANTINE_MUSICAL_SYMBOL_THEMA_APLOUN = chr(118904)
BYZANTINE_MUSICAL_SYMBOL_THES_KAI_APOTHES = chr(118905)
BYZANTINE_MUSICAL_SYMBOL_KATAVASMA = chr(118906)
BYZANTINE_MUSICAL_SYMBOL_ENDOFONON = chr(118907)
BYZANTINE_MUSICAL_SYMBOL_YFEN_KATO = chr(118908)
BYZANTINE_MUSICAL_SYMBOL_YFEN_ANO = chr(118909)
BYZANTINE_MUSICAL_SYMBOL_STAVROS = chr(118910)
BYZANTINE_MUSICAL_SYMBOL_KLASMA_ANO = chr(118911)
BYZANTINE_MUSICAL_SYMBOL_DIPLI_ARCHAION = chr(118912)
BYZANTINE_MUSICAL_SYMBOL_KRATIMA_ARCHAION = chr(118913)
BYZANTINE_MUSICAL_SYMBOL_KRATIMA_ALLO = chr(118914)
BYZANTINE_MUSICAL_SYMBOL_KRATIMA_NEO = chr(118915)
BYZANTINE_MUSICAL_SYMBOL_APODERMA_NEO = chr(118916)
BYZANTINE_MUSICAL_SYMBOL_APLI = chr(118917)
BYZANTINE_MUSICAL_SYMBOL_DIPLI = chr(118918)
BYZANTINE_MUSICAL_SYMBOL_TRIPLI = chr(118919)
BYZANTINE_MUSICAL_SYMBOL_TETRAPLI = chr(118920)
BYZANTINE_MUSICAL_SYMBOL_KORONIS = chr(118921)
BYZANTINE_MUSICAL_SYMBOL_LEIMMA_ENOS_CHRONOU = chr(118922)
BYZANTINE_MUSICAL_SYMBOL_LEIMMA_DYO_CHRONON = chr(118923)
BYZANTINE_MUSICAL_SYMBOL_LEIMMA_TRION_CHRONON = chr(118924)
BYZANTINE_MUSICAL_SYMBOL_LEIMMA_TESSARON_CHRONON = chr(118925)
BYZANTINE_MUSICAL_SYMBOL_LEIMMA_IMISEOS_CHRONOU = chr(118926)
BYZANTINE_MUSICAL_SYMBOL_GORGON_NEO_ANO = chr(118927)
BYZANTINE_MUSICAL_SYMBOL_GORGON_PARESTIGMENON_ARISTERA = chr(118928)
BYZANTINE_MUSICAL_SYMBOL_GORGON_PARESTIGMENON_DEXIA = chr(118929)
BYZANTINE_MUSICAL_SYMBOL_DIGORGON = chr(118930)
BYZANTINE_MUSICAL_SYMBOL_DIGORGON_PARESTIGMENON_ARISTERA_KATO = chr(118931)
BYZANTINE_MUSICAL_SYMBOL_DIGORGON_PARESTIGMENON_ARISTERA_ANO = chr(118932)
BYZANTINE_MUSICAL_SYMBOL_DIGORGON_PARESTIGMENON_DEXIA = chr(118933)
BYZANTINE_MUSICAL_SYMBOL_TRIGORGON = chr(118934)
BYZANTINE_MUSICAL_SYMBOL_ARGON = chr(118935)
BYZANTINE_MUSICAL_SYMBOL_IMIDIARGON = chr(118936)
BYZANTINE_MUSICAL_SYMBOL_DIARGON = chr(118937)
BYZANTINE_MUSICAL_SYMBOL_AGOGI_POLI_ARGI = chr(118938)
BYZANTINE_MUSICAL_SYMBOL_AGOGI_ARGOTERI = chr(118939)
BYZANTINE_MUSICAL_SYMBOL_AGOGI_ARGI = chr(118940)
BYZANTINE_MUSICAL_SYMBOL_AGOGI_METRIA = chr(118941)
BYZANTINE_MUSICAL_SYMBOL_AGOGI_MESI = chr(118942)
BYZANTINE_MUSICAL_SYMBOL_AGOGI_GORGI = chr(118943)
BYZANTINE_MUSICAL_SYMBOL_AGOGI_GORGOTERI = chr(118944)
BYZANTINE_MUSICAL_SYMBOL_AGOGI_POLI_GORGI = chr(118945)
BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_PROTOS_ICHOS = chr(118946)
BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_ALLI_PROTOS_ICHOS = chr(118947)
BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_DEYTEROS_ICHOS = chr(118948)
BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_ALLI_DEYTEROS_ICHOS = chr(118949)
BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_TRITOS_ICHOS = chr(118950)
BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_TRIFONIAS = chr(118951)
BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_TETARTOS_ICHOS = chr(118952)
BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_TETARTOS_LEGETOS_ICHOS = chr(118953)
BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_LEGETOS_ICHOS = chr(118954)
BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_PLAGIOS_ICHOS = chr(118955)
BYZANTINE_MUSICAL_SYMBOL_ISAKIA_TELOUS_ICHIMATOS = chr(118956)
BYZANTINE_MUSICAL_SYMBOL_APOSTROFOI_TELOUS_ICHIMATOS = chr(118957)
BYZANTINE_MUSICAL_SYMBOL_FANEROSIS_TETRAFONIAS = chr(118958)
BYZANTINE_MUSICAL_SYMBOL_FANEROSIS_MONOFONIAS = chr(118959)
BYZANTINE_MUSICAL_SYMBOL_FANEROSIS_DIFONIAS = chr(118960)
BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_VARYS_ICHOS = chr(118961)
BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_PROTOVARYS_ICHOS = chr(118962)
BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_PLAGIOS_TETARTOS_ICHOS = chr(118963)
BYZANTINE_MUSICAL_SYMBOL_GORTHMIKON_N_APLOUN = chr(118964)
BYZANTINE_MUSICAL_SYMBOL_GORTHMIKON_N_DIPLOUN = chr(118965)
BYZANTINE_MUSICAL_SYMBOL_ENARXIS_KAI_FTHORA_VOU = chr(118966)
BYZANTINE_MUSICAL_SYMBOL_IMIFONON = chr(118967)
BYZANTINE_MUSICAL_SYMBOL_IMIFTHORON = chr(118968)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_ARCHAION_DEYTEROU_ICHOU = chr(118969)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_PA = chr(118970)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_NANA = chr(118971)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_NAOS_ICHOS = chr(118972)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_DI = chr(118973)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_SKLIRON_DIATONON_DI = chr(118974)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_KE = chr(118975)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_ZO = chr(118976)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_NI_KATO = chr(118977)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_NI_ANO = chr(118978)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_MALAKON_CHROMA_DIFONIAS = chr(118979)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_MALAKON_CHROMA_MONOFONIAS = chr(118980)
BYZANTINE_MUSICAL_SYMBOL_FHTORA_SKLIRON_CHROMA_VASIS = chr(118981)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_SKLIRON_CHROMA_SYNAFI = chr(118982)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_NENANO = chr(118983)
BYZANTINE_MUSICAL_SYMBOL_CHROA_ZYGOS = chr(118984)
BYZANTINE_MUSICAL_SYMBOL_CHROA_KLITON = chr(118985)
BYZANTINE_MUSICAL_SYMBOL_CHROA_SPATHI = chr(118986)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_I_YFESIS_TETARTIMORION = chr(118987)
BYZANTINE_MUSICAL_SYMBOL_FTHORA_ENARMONIOS_ANTIFONIA = chr(118988)
BYZANTINE_MUSICAL_SYMBOL_YFESIS_TRITIMORION = chr(118989)
BYZANTINE_MUSICAL_SYMBOL_DIESIS_TRITIMORION = chr(118990)
BYZANTINE_MUSICAL_SYMBOL_DIESIS_TETARTIMORION = chr(118991)
BYZANTINE_MUSICAL_SYMBOL_DIESIS_APLI_DYO_DODEKATA = chr(118992)
BYZANTINE_MUSICAL_SYMBOL_DIESIS_MONOGRAMMOS_TESSERA_DODEKATA = chr(118993)
BYZANTINE_MUSICAL_SYMBOL_DIESIS_DIGRAMMOS_EX_DODEKATA = chr(118994)
BYZANTINE_MUSICAL_SYMBOL_DIESIS_TRIGRAMMOS_OKTO_DODEKATA = chr(118995)
BYZANTINE_MUSICAL_SYMBOL_YFESIS_APLI_DYO_DODEKATA = chr(118996)
BYZANTINE_MUSICAL_SYMBOL_YFESIS_MONOGRAMMOS_TESSERA_DODEKATA = chr(118997)
BYZANTINE_MUSICAL_SYMBOL_YFESIS_DIGRAMMOS_EX_DODEKATA = chr(118998)
BYZANTINE_MUSICAL_SYMBOL_YFESIS_TRIGRAMMOS_OKTO_DODEKATA = chr(118999)
BYZANTINE_MUSICAL_SYMBOL_GENIKI_DIESIS = chr(119000)
BYZANTINE_MUSICAL_SYMBOL_GENIKI_YFESIS = chr(119001)
BYZANTINE_MUSICAL_SYMBOL_DIASTOLI_APLI_MIKRI = chr(119002)
BYZANTINE_MUSICAL_SYMBOL_DIASTOLI_APLI_MEGALI = chr(119003)
BYZANTINE_MUSICAL_SYMBOL_DIASTOLI_DIPLI = chr(119004)
BYZANTINE_MUSICAL_SYMBOL_DIASTOLI_THESEOS = chr(119005)
BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_THESEOS = chr(119006)
BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_THESEOS_DISIMOU = chr(119007)
BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_THESEOS_TRISIMOU = chr(119008)
BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_THESEOS_TETRASIMOU = chr(119009)
BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_ARSEOS = chr(119010)
BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_ARSEOS_DISIMOU = chr(119011)
BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_ARSEOS_TRISIMOU = chr(119012)
BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_ARSEOS_TETRASIMOU = chr(119013)
BYZANTINE_MUSICAL_SYMBOL_DIGRAMMA_GG = chr(119014)
BYZANTINE_MUSICAL_SYMBOL_DIFTOGGOS_OU = chr(119015)
BYZANTINE_MUSICAL_SYMBOL_STIGMA = chr(119016)
BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_PA = chr(119017)
BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_VOU = chr(119018)
BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_GA = chr(119019)
BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_DI = chr(119020)
BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_KE = chr(119021)
BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_ZO = chr(119022)
BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_NI = chr(119023)
BYZANTINE_MUSICAL_SYMBOL_KENTIMATA_NEO_MESO = chr(119024)
BYZANTINE_MUSICAL_SYMBOL_KENTIMA_NEO_MESO = chr(119025)
BYZANTINE_MUSICAL_SYMBOL_KENTIMATA_NEO_KATO = chr(119026)
BYZANTINE_MUSICAL_SYMBOL_KENTIMA_NEO_KATO = chr(119027)
BYZANTINE_MUSICAL_SYMBOL_KLASMA_KATO = chr(119028)
BYZANTINE_MUSICAL_SYMBOL_GORGON_NEO_KATO = chr(119029)
MUSICAL_SYMBOL_SINGLE_BARLINE = chr(119040)
MUSICAL_SYMBOL_DOUBLE_BARLINE = chr(119041)
MUSICAL_SYMBOL_FINAL_BARLINE = chr(119042)
MUSICAL_SYMBOL_REVERSE_FINAL_BARLINE = chr(119043)
MUSICAL_SYMBOL_DASHED_BARLINE = chr(119044)
MUSICAL_SYMBOL_SHORT_BARLINE = chr(119045)
MUSICAL_SYMBOL_LEFT_REPEAT_SIGN = chr(119046)
MUSICAL_SYMBOL_RIGHT_REPEAT_SIGN = chr(119047)
MUSICAL_SYMBOL_REPEAT_DOTS = chr(119048)
MUSICAL_SYMBOL_DAL_SEGNO = chr(119049)
MUSICAL_SYMBOL_DA_CAPO = chr(119050)
MUSICAL_SYMBOL_SEGNO = chr(119051)
MUSICAL_SYMBOL_CODA = chr(119052)
MUSICAL_SYMBOL_REPEATED_FIGURE_1 = chr(119053)
MUSICAL_SYMBOL_REPEATED_FIGURE_2 = chr(119054)
MUSICAL_SYMBOL_REPEATED_FIGURE_3 = chr(119055)
MUSICAL_SYMBOL_FERMATA = chr(119056)
MUSICAL_SYMBOL_FERMATA_BELOW = chr(119057)
MUSICAL_SYMBOL_BREATH_MARK = chr(119058)
MUSICAL_SYMBOL_CAESURA = chr(119059)
MUSICAL_SYMBOL_BRACE = chr(119060)
MUSICAL_SYMBOL_BRACKET = chr(119061)
MUSICAL_SYMBOL_ONE_LINE_STAFF = chr(119062)
MUSICAL_SYMBOL_TWO_LINE_STAFF = chr(119063)
MUSICAL_SYMBOL_THREE_LINE_STAFF = chr(119064)
MUSICAL_SYMBOL_FOUR_LINE_STAFF = chr(119065)
MUSICAL_SYMBOL_FIVE_LINE_STAFF = chr(119066)
MUSICAL_SYMBOL_SIX_LINE_STAFF = chr(119067)
MUSICAL_SYMBOL_SIX_STRING_FRETBOARD = chr(119068)
MUSICAL_SYMBOL_FOUR_STRING_FRETBOARD = chr(119069)
MUSICAL_SYMBOL_G_CLEF = chr(119070)
MUSICAL_SYMBOL_G_CLEF_OTTAVA_ALTA = chr(119071)
MUSICAL_SYMBOL_G_CLEF_OTTAVA_BASSA = chr(119072)
MUSICAL_SYMBOL_C_CLEF = chr(119073)
MUSICAL_SYMBOL_F_CLEF = chr(119074)
MUSICAL_SYMBOL_F_CLEF_OTTAVA_ALTA = chr(119075)
MUSICAL_SYMBOL_F_CLEF_OTTAVA_BASSA = chr(119076)
MUSICAL_SYMBOL_DRUM_CLEF_1 = chr(119077)
MUSICAL_SYMBOL_DRUM_CLEF_2 = chr(119078)
MUSICAL_SYMBOL_MULTIPLE_MEASURE_REST = chr(119081)
MUSICAL_SYMBOL_DOUBLE_SHARP = chr(119082)
MUSICAL_SYMBOL_DOUBLE_FLAT = chr(119083)
MUSICAL_SYMBOL_FLAT_UP = chr(119084)
MUSICAL_SYMBOL_FLAT_DOWN = chr(119085)
MUSICAL_SYMBOL_NATURAL_UP = chr(119086)
MUSICAL_SYMBOL_NATURAL_DOWN = chr(119087)
MUSICAL_SYMBOL_SHARP_UP = chr(119088)
MUSICAL_SYMBOL_SHARP_DOWN = chr(119089)
MUSICAL_SYMBOL_QUARTER_TONE_SHARP = chr(119090)
MUSICAL_SYMBOL_QUARTER_TONE_FLAT = chr(119091)
MUSICAL_SYMBOL_COMMON_TIME = chr(119092)
MUSICAL_SYMBOL_CUT_TIME = chr(119093)
MUSICAL_SYMBOL_OTTAVA_ALTA = chr(119094)
MUSICAL_SYMBOL_OTTAVA_BASSA = chr(119095)
MUSICAL_SYMBOL_QUINDICESIMA_ALTA = chr(119096)
MUSICAL_SYMBOL_QUINDICESIMA_BASSA = chr(119097)
MUSICAL_SYMBOL_MULTI_REST = chr(119098)
MUSICAL_SYMBOL_WHOLE_REST = chr(119099)
MUSICAL_SYMBOL_HALF_REST = chr(119100)
MUSICAL_SYMBOL_QUARTER_REST = chr(119101)
MUSICAL_SYMBOL_EIGHTH_REST = chr(119102)
MUSICAL_SYMBOL_SIXTEENTH_REST = chr(119103)
MUSICAL_SYMBOL_THIRTY_SECOND_REST = chr(119104)
MUSICAL_SYMBOL_SIXTY_FOURTH_REST = chr(119105)
MUSICAL_SYMBOL_ONE_HUNDRED_TWENTY_EIGHTH_REST = chr(119106)
MUSICAL_SYMBOL_X_NOTEHEAD = chr(119107)
MUSICAL_SYMBOL_PLUS_NOTEHEAD = chr(119108)
MUSICAL_SYMBOL_CIRCLE_X_NOTEHEAD = chr(119109)
MUSICAL_SYMBOL_SQUARE_NOTEHEAD_WHITE = chr(119110)
MUSICAL_SYMBOL_SQUARE_NOTEHEAD_BLACK = chr(119111)
MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_UP_WHITE = chr(119112)
MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_UP_BLACK = chr(119113)
MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_LEFT_WHITE = chr(119114)
MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_LEFT_BLACK = chr(119115)
MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_RIGHT_WHITE = chr(119116)
MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_RIGHT_BLACK = chr(119117)
MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_DOWN_WHITE = chr(119118)
MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_DOWN_BLACK = chr(119119)
MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_UP_RIGHT_WHITE = chr(119120)
MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_UP_RIGHT_BLACK = chr(119121)
MUSICAL_SYMBOL_MOON_NOTEHEAD_WHITE = chr(119122)
MUSICAL_SYMBOL_MOON_NOTEHEAD_BLACK = chr(119123)
MUSICAL_SYMBOL_TRIANGLE_ROUND_NOTEHEAD_DOWN_WHITE = chr(119124)
MUSICAL_SYMBOL_TRIANGLE_ROUND_NOTEHEAD_DOWN_BLACK = chr(119125)
MUSICAL_SYMBOL_PARENTHESIS_NOTEHEAD = chr(119126)
MUSICAL_SYMBOL_VOID_NOTEHEAD = chr(119127)
MUSICAL_SYMBOL_NOTEHEAD_BLACK = chr(119128)
MUSICAL_SYMBOL_NULL_NOTEHEAD = chr(119129)
MUSICAL_SYMBOL_CLUSTER_NOTEHEAD_WHITE = chr(119130)
MUSICAL_SYMBOL_CLUSTER_NOTEHEAD_BLACK = chr(119131)
MUSICAL_SYMBOL_BREVE = chr(119132)
MUSICAL_SYMBOL_WHOLE_NOTE = chr(119133)
MUSICAL_SYMBOL_HALF_NOTE = chr(119134)
MUSICAL_SYMBOL_QUARTER_NOTE = chr(119135)
MUSICAL_SYMBOL_EIGHTH_NOTE = chr(119136)
MUSICAL_SYMBOL_SIXTEENTH_NOTE = chr(119137)
MUSICAL_SYMBOL_THIRTY_SECOND_NOTE = chr(119138)
MUSICAL_SYMBOL_SIXTY_FOURTH_NOTE = chr(119139)
MUSICAL_SYMBOL_ONE_HUNDRED_TWENTY_EIGHTH_NOTE = chr(119140)
MUSICAL_SYMBOL_COMBINING_STEM = chr(119141)
MUSICAL_SYMBOL_COMBINING_SPRECHGESANG_STEM = chr(119142)
MUSICAL_SYMBOL_COMBINING_TREMOLO_1 = chr(119143)
MUSICAL_SYMBOL_COMBINING_TREMOLO_2 = chr(119144)
MUSICAL_SYMBOL_COMBINING_TREMOLO_3 = chr(119145)
MUSICAL_SYMBOL_FINGERED_TREMOLO_1 = chr(119146)
MUSICAL_SYMBOL_FINGERED_TREMOLO_2 = chr(119147)
MUSICAL_SYMBOL_FINGERED_TREMOLO_3 = chr(119148)
MUSICAL_SYMBOL_COMBINING_AUGMENTATION_DOT = chr(119149)
MUSICAL_SYMBOL_COMBINING_FLAG_1 = chr(119150)
MUSICAL_SYMBOL_COMBINING_FLAG_2 = chr(119151)
MUSICAL_SYMBOL_COMBINING_FLAG_3 = chr(119152)
MUSICAL_SYMBOL_COMBINING_FLAG_4 = chr(119153)
MUSICAL_SYMBOL_COMBINING_FLAG_5 = chr(119154)
MUSICAL_SYMBOL_BEGIN_BEAM = chr(119155)
MUSICAL_SYMBOL_END_BEAM = chr(119156)
MUSICAL_SYMBOL_BEGIN_TIE = chr(119157)
MUSICAL_SYMBOL_END_TIE = chr(119158)
MUSICAL_SYMBOL_BEGIN_SLUR = chr(119159)
MUSICAL_SYMBOL_END_SLUR = chr(119160)
MUSICAL_SYMBOL_BEGIN_PHRASE = chr(119161)
MUSICAL_SYMBOL_END_PHRASE = chr(119162)
MUSICAL_SYMBOL_COMBINING_ACCENT = chr(119163)
MUSICAL_SYMBOL_COMBINING_STACCATO = chr(119164)
MUSICAL_SYMBOL_COMBINING_TENUTO = chr(119165)
MUSICAL_SYMBOL_COMBINING_STACCATISSIMO = chr(119166)
MUSICAL_SYMBOL_COMBINING_MARCATO = chr(119167)
MUSICAL_SYMBOL_COMBINING_MARCATO_STACCATO = chr(119168)
MUSICAL_SYMBOL_COMBINING_ACCENT_STACCATO = chr(119169)
MUSICAL_SYMBOL_COMBINING_LOURE = chr(119170)
MUSICAL_SYMBOL_ARPEGGIATO_UP = chr(119171)
MUSICAL_SYMBOL_ARPEGGIATO_DOWN = chr(119172)
MUSICAL_SYMBOL_COMBINING_DOIT = chr(119173)
MUSICAL_SYMBOL_COMBINING_RIP = chr(119174)
MUSICAL_SYMBOL_COMBINING_FLIP = chr(119175)
MUSICAL_SYMBOL_COMBINING_SMEAR = chr(119176)
MUSICAL_SYMBOL_COMBINING_BEND = chr(119177)
MUSICAL_SYMBOL_COMBINING_DOUBLE_TONGUE = chr(119178)
MUSICAL_SYMBOL_COMBINING_TRIPLE_TONGUE = chr(119179)
MUSICAL_SYMBOL_RINFORZANDO = chr(119180)
MUSICAL_SYMBOL_SUBITO = chr(119181)
MUSICAL_SYMBOL_Z = chr(119182)
MUSICAL_SYMBOL_PIANO = chr(119183)
MUSICAL_SYMBOL_MEZZO = chr(119184)
MUSICAL_SYMBOL_FORTE = chr(119185)
MUSICAL_SYMBOL_CRESCENDO = chr(119186)
MUSICAL_SYMBOL_DECRESCENDO = chr(119187)
MUSICAL_SYMBOL_GRACE_NOTE_SLASH = chr(119188)
MUSICAL_SYMBOL_GRACE_NOTE_NO_SLASH = chr(119189)
MUSICAL_SYMBOL_TR = chr(119190)
MUSICAL_SYMBOL_TURN = chr(119191)
MUSICAL_SYMBOL_INVERTED_TURN = chr(119192)
MUSICAL_SYMBOL_TURN_SLASH = chr(119193)
MUSICAL_SYMBOL_TURN_UP = chr(119194)
MUSICAL_SYMBOL_ORNAMENT_STROKE_1 = chr(119195)
MUSICAL_SYMBOL_ORNAMENT_STROKE_2 = chr(119196)
MUSICAL_SYMBOL_ORNAMENT_STROKE_3 = chr(119197)
MUSICAL_SYMBOL_ORNAMENT_STROKE_4 = chr(119198)
MUSICAL_SYMBOL_ORNAMENT_STROKE_5 = chr(119199)
MUSICAL_SYMBOL_ORNAMENT_STROKE_6 = chr(119200)
MUSICAL_SYMBOL_ORNAMENT_STROKE_7 = chr(119201)
MUSICAL_SYMBOL_ORNAMENT_STROKE_8 = chr(119202)
MUSICAL_SYMBOL_ORNAMENT_STROKE_9 = chr(119203)
MUSICAL_SYMBOL_ORNAMENT_STROKE_10 = chr(119204)
MUSICAL_SYMBOL_ORNAMENT_STROKE_11 = chr(119205)
MUSICAL_SYMBOL_HAUPTSTIMME = chr(119206)
MUSICAL_SYMBOL_NEBENSTIMME = chr(119207)
MUSICAL_SYMBOL_END_OF_STIMME = chr(119208)
MUSICAL_SYMBOL_DEGREE_SLASH = chr(119209)
MUSICAL_SYMBOL_COMBINING_DOWN_BOW = chr(119210)
MUSICAL_SYMBOL_COMBINING_UP_BOW = chr(119211)
MUSICAL_SYMBOL_COMBINING_HARMONIC = chr(119212)
MUSICAL_SYMBOL_COMBINING_SNAP_PIZZICATO = chr(119213)
MUSICAL_SYMBOL_PEDAL_MARK = chr(119214)
MUSICAL_SYMBOL_PEDAL_UP_MARK = chr(119215)
MUSICAL_SYMBOL_HALF_PEDAL_MARK = chr(119216)
MUSICAL_SYMBOL_GLISSANDO_UP = chr(119217)
MUSICAL_SYMBOL_GLISSANDO_DOWN = chr(119218)
MUSICAL_SYMBOL_WITH_FINGERNAILS = chr(119219)
MUSICAL_SYMBOL_DAMP = chr(119220)
MUSICAL_SYMBOL_DAMP_ALL = chr(119221)
MUSICAL_SYMBOL_MAXIMA = chr(119222)
MUSICAL_SYMBOL_LONGA = chr(119223)
MUSICAL_SYMBOL_BREVIS = chr(119224)
MUSICAL_SYMBOL_SEMIBREVIS_WHITE = chr(119225)
MUSICAL_SYMBOL_SEMIBREVIS_BLACK = chr(119226)
MUSICAL_SYMBOL_MINIMA = chr(119227)
MUSICAL_SYMBOL_MINIMA_BLACK = chr(119228)
MUSICAL_SYMBOL_SEMIMINIMA_WHITE = chr(119229)
MUSICAL_SYMBOL_SEMIMINIMA_BLACK = chr(119230)
MUSICAL_SYMBOL_FUSA_WHITE = chr(119231)
MUSICAL_SYMBOL_FUSA_BLACK = chr(119232)
MUSICAL_SYMBOL_LONGA_PERFECTA_REST = chr(119233)
MUSICAL_SYMBOL_LONGA_IMPERFECTA_REST = chr(119234)
MUSICAL_SYMBOL_BREVIS_REST = chr(119235)
MUSICAL_SYMBOL_SEMIBREVIS_REST = chr(119236)
MUSICAL_SYMBOL_MINIMA_REST = chr(119237)
MUSICAL_SYMBOL_SEMIMINIMA_REST = chr(119238)
MUSICAL_SYMBOL_TEMPUS_PERFECTUM_CUM_PROLATIONE_PERFECTA = chr(119239)
MUSICAL_SYMBOL_TEMPUS_PERFECTUM_CUM_PROLATIONE_IMPERFECTA = chr(119240)
MUSICAL_SYMBOL_TEMPUS_PERFECTUM_CUM_PROLATIONE_PERFECTA_DIMINUTION_1 = chr(119241)
MUSICAL_SYMBOL_TEMPUS_IMPERFECTUM_CUM_PROLATIONE_PERFECTA = chr(119242)
MUSICAL_SYMBOL_TEMPUS_IMPERFECTUM_CUM_PROLATIONE_IMPERFECTA = chr(119243)
MUSICAL_SYMBOL_TEMPUS_IMPERFECTUM_CUM_PROLATIONE_IMPERFECTA_DIMINUTION_1 = chr(119244)
MUSICAL_SYMBOL_TEMPUS_IMPERFECTUM_CUM_PROLATIONE_IMPERFECTA_DIMINUTION_2 = chr(119245)
MUSICAL_SYMBOL_TEMPUS_IMPERFECTUM_CUM_PROLATIONE_IMPERFECTA_DIMINUTION_3 = chr(119246)
MUSICAL_SYMBOL_CROIX = chr(119247)
MUSICAL_SYMBOL_GREGORIAN_C_CLEF = chr(119248)
MUSICAL_SYMBOL_GREGORIAN_F_CLEF = chr(119249)
MUSICAL_SYMBOL_SQUARE_B = chr(119250)
MUSICAL_SYMBOL_VIRGA = chr(119251)
MUSICAL_SYMBOL_PODATUS = chr(119252)
MUSICAL_SYMBOL_CLIVIS = chr(119253)
MUSICAL_SYMBOL_SCANDICUS = chr(119254)
MUSICAL_SYMBOL_CLIMACUS = chr(119255)
MUSICAL_SYMBOL_TORCULUS = chr(119256)
MUSICAL_SYMBOL_PORRECTUS = chr(119257)
MUSICAL_SYMBOL_PORRECTUS_FLEXUS = chr(119258)
MUSICAL_SYMBOL_SCANDICUS_FLEXUS = chr(119259)
MUSICAL_SYMBOL_TORCULUS_RESUPINUS = chr(119260)
MUSICAL_SYMBOL_PES_SUBPUNCTIS = chr(119261)
MUSICAL_SYMBOL_KIEVAN_C_CLEF = chr(119262)
MUSICAL_SYMBOL_KIEVAN_END_OF_PIECE = chr(119263)
MUSICAL_SYMBOL_KIEVAN_FINAL_NOTE = chr(119264)
MUSICAL_SYMBOL_KIEVAN_RECITATIVE_MARK = chr(119265)
MUSICAL_SYMBOL_KIEVAN_WHOLE_NOTE = chr(119266)
MUSICAL_SYMBOL_KIEVAN_HALF_NOTE = chr(119267)
MUSICAL_SYMBOL_KIEVAN_QUARTER_NOTE_STEM_DOWN = chr(119268)
MUSICAL_SYMBOL_KIEVAN_QUARTER_NOTE_STEM_UP = chr(119269)
MUSICAL_SYMBOL_KIEVAN_EIGHTH_NOTE_STEM_DOWN = chr(119270)
MUSICAL_SYMBOL_KIEVAN_EIGHTH_NOTE_STEM_UP = chr(119271)
MUSICAL_SYMBOL_KIEVAN_FLAT_SIGN = chr(119272)
MUSICAL_SYMBOL_SORI = chr(119273)
MUSICAL_SYMBOL_KORON = chr(119274)
GREEK_VOCAL_NOTATION_SYMBOL_1 = chr(119296)
GREEK_VOCAL_NOTATION_SYMBOL_2 = chr(119297)
GREEK_VOCAL_NOTATION_SYMBOL_3 = chr(119298)
GREEK_VOCAL_NOTATION_SYMBOL_4 = chr(119299)
GREEK_VOCAL_NOTATION_SYMBOL_5 = chr(119300)
GREEK_VOCAL_NOTATION_SYMBOL_6 = chr(119301)
GREEK_VOCAL_NOTATION_SYMBOL_7 = chr(119302)
GREEK_VOCAL_NOTATION_SYMBOL_8 = chr(119303)
GREEK_VOCAL_NOTATION_SYMBOL_9 = chr(119304)
GREEK_VOCAL_NOTATION_SYMBOL_10 = chr(119305)
GREEK_VOCAL_NOTATION_SYMBOL_11 = chr(119306)
GREEK_VOCAL_NOTATION_SYMBOL_12 = chr(119307)
GREEK_VOCAL_NOTATION_SYMBOL_13 = chr(119308)
GREEK_VOCAL_NOTATION_SYMBOL_14 = chr(119309)
GREEK_VOCAL_NOTATION_SYMBOL_15 = chr(119310)
GREEK_VOCAL_NOTATION_SYMBOL_16 = chr(119311)
GREEK_VOCAL_NOTATION_SYMBOL_17 = chr(119312)
GREEK_VOCAL_NOTATION_SYMBOL_18 = chr(119313)
GREEK_VOCAL_NOTATION_SYMBOL_19 = chr(119314)
GREEK_VOCAL_NOTATION_SYMBOL_20 = chr(119315)
GREEK_VOCAL_NOTATION_SYMBOL_21 = chr(119316)
GREEK_VOCAL_NOTATION_SYMBOL_22 = chr(119317)
GREEK_VOCAL_NOTATION_SYMBOL_23 = chr(119318)
GREEK_VOCAL_NOTATION_SYMBOL_24 = chr(119319)
GREEK_VOCAL_NOTATION_SYMBOL_50 = chr(119320)
GREEK_VOCAL_NOTATION_SYMBOL_51 = chr(119321)
GREEK_VOCAL_NOTATION_SYMBOL_52 = chr(119322)
GREEK_VOCAL_NOTATION_SYMBOL_53 = chr(119323)
GREEK_VOCAL_NOTATION_SYMBOL_54 = chr(119324)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_1 = chr(119325)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_2 = chr(119326)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_4 = chr(119327)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_5 = chr(119328)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_7 = chr(119329)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_8 = chr(119330)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_11 = chr(119331)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_12 = chr(119332)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_13 = chr(119333)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_14 = chr(119334)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_17 = chr(119335)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_18 = chr(119336)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_19 = chr(119337)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_23 = chr(119338)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_24 = chr(119339)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_25 = chr(119340)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_26 = chr(119341)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_27 = chr(119342)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_29 = chr(119343)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_30 = chr(119344)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_32 = chr(119345)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_36 = chr(119346)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_37 = chr(119347)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_38 = chr(119348)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_39 = chr(119349)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_40 = chr(119350)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_42 = chr(119351)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_43 = chr(119352)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_45 = chr(119353)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_47 = chr(119354)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_48 = chr(119355)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_49 = chr(119356)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_50 = chr(119357)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_51 = chr(119358)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_52 = chr(119359)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_53 = chr(119360)
GREEK_INSTRUMENTAL_NOTATION_SYMBOL_54 = chr(119361)
COMBINING_GREEK_MUSICAL_TRISEME = chr(119362)
COMBINING_GREEK_MUSICAL_TETRASEME = chr(119363)
COMBINING_GREEK_MUSICAL_PENTASEME = chr(119364)
GREEK_MUSICAL_LEIMMA = chr(119365)
KAKTOVIK_NUMERAL_ZERO = chr(119488)
KAKTOVIK_NUMERAL_ONE = chr(119489)
KAKTOVIK_NUMERAL_TWO = chr(119490)
KAKTOVIK_NUMERAL_THREE = chr(119491)
KAKTOVIK_NUMERAL_FOUR = chr(119492)
KAKTOVIK_NUMERAL_FIVE = chr(119493)
KAKTOVIK_NUMERAL_SIX = chr(119494)
KAKTOVIK_NUMERAL_SEVEN = chr(119495)
KAKTOVIK_NUMERAL_EIGHT = chr(119496)
KAKTOVIK_NUMERAL_NINE = chr(119497)
KAKTOVIK_NUMERAL_TEN = chr(119498)
KAKTOVIK_NUMERAL_ELEVEN = chr(119499)
KAKTOVIK_NUMERAL_TWELVE = chr(119500)
KAKTOVIK_NUMERAL_THIRTEEN = chr(119501)
KAKTOVIK_NUMERAL_FOURTEEN = chr(119502)
KAKTOVIK_NUMERAL_FIFTEEN = chr(119503)
KAKTOVIK_NUMERAL_SIXTEEN = chr(119504)
KAKTOVIK_NUMERAL_SEVENTEEN = chr(119505)
KAKTOVIK_NUMERAL_EIGHTEEN = chr(119506)
KAKTOVIK_NUMERAL_NINETEEN = chr(119507)
MAYAN_NUMERAL_ZERO = chr(119520)
MAYAN_NUMERAL_ONE = chr(119521)
MAYAN_NUMERAL_TWO = chr(119522)
MAYAN_NUMERAL_THREE = chr(119523)
MAYAN_NUMERAL_FOUR = chr(119524)
MAYAN_NUMERAL_FIVE = chr(119525)
MAYAN_NUMERAL_SIX = chr(119526)
MAYAN_NUMERAL_SEVEN = chr(119527)
MAYAN_NUMERAL_EIGHT = chr(119528)
MAYAN_NUMERAL_NINE = chr(119529)
MAYAN_NUMERAL_TEN = chr(119530)
MAYAN_NUMERAL_ELEVEN = chr(119531)
MAYAN_NUMERAL_TWELVE = chr(119532)
MAYAN_NUMERAL_THIRTEEN = chr(119533)
MAYAN_NUMERAL_FOURTEEN = chr(119534)
MAYAN_NUMERAL_FIFTEEN = chr(119535)
MAYAN_NUMERAL_SIXTEEN = chr(119536)
MAYAN_NUMERAL_SEVENTEEN = chr(119537)
MAYAN_NUMERAL_EIGHTEEN = chr(119538)
MAYAN_NUMERAL_NINETEEN = chr(119539)
MONOGRAM_FOR_EARTH = chr(119552)
DIGRAM_FOR_HEAVENLY_EARTH = chr(119553)
DIGRAM_FOR_HUMAN_EARTH = chr(119554)
DIGRAM_FOR_EARTHLY_HEAVEN = chr(119555)
DIGRAM_FOR_EARTHLY_HUMAN = chr(119556)
DIGRAM_FOR_EARTH = chr(119557)
TETRAGRAM_FOR_CENTRE = chr(119558)
TETRAGRAM_FOR_FULL_CIRCLE = chr(119559)
TETRAGRAM_FOR_MIRED = chr(119560)
TETRAGRAM_FOR_BARRIER = chr(119561)
TETRAGRAM_FOR_KEEPING_SMALL = chr(119562)
TETRAGRAM_FOR_CONTRARIETY = chr(119563)
TETRAGRAM_FOR_ASCENT = chr(119564)
TETRAGRAM_FOR_OPPOSITION = chr(119565)
TETRAGRAM_FOR_BRANCHING_OUT = chr(119566)
TETRAGRAM_FOR_DEFECTIVENESS_OR_DISTORTION = chr(119567)
TETRAGRAM_FOR_DIVERGENCE = chr(119568)
TETRAGRAM_FOR_YOUTHFULNESS = chr(119569)
TETRAGRAM_FOR_INCREASE = chr(119570)
TETRAGRAM_FOR_PENETRATION = chr(119571)
TETRAGRAM_FOR_REACH = chr(119572)
TETRAGRAM_FOR_CONTACT = chr(119573)
TETRAGRAM_FOR_HOLDING_BACK = chr(119574)
TETRAGRAM_FOR_WAITING = chr(119575)
TETRAGRAM_FOR_FOLLOWING = chr(119576)
TETRAGRAM_FOR_ADVANCE = chr(119577)
TETRAGRAM_FOR_RELEASE = chr(119578)
TETRAGRAM_FOR_RESISTANCE = chr(119579)
TETRAGRAM_FOR_EASE = chr(119580)
TETRAGRAM_FOR_JOY = chr(119581)
TETRAGRAM_FOR_CONTENTION = chr(119582)
TETRAGRAM_FOR_ENDEAVOUR = chr(119583)
TETRAGRAM_FOR_DUTIES = chr(119584)
TETRAGRAM_FOR_CHANGE = chr(119585)
TETRAGRAM_FOR_DECISIVENESS = chr(119586)
TETRAGRAM_FOR_BOLD_RESOLUTION = chr(119587)
TETRAGRAM_FOR_PACKING = chr(119588)
TETRAGRAM_FOR_LEGION = chr(119589)
TETRAGRAM_FOR_CLOSENESS = chr(119590)
TETRAGRAM_FOR_KINSHIP = chr(119591)
TETRAGRAM_FOR_GATHERING = chr(119592)
TETRAGRAM_FOR_STRENGTH = chr(119593)
TETRAGRAM_FOR_PURITY = chr(119594)
TETRAGRAM_FOR_FULLNESS = chr(119595)
TETRAGRAM_FOR_RESIDENCE = chr(119596)
TETRAGRAM_FOR_LAW_OR_MODEL = chr(119597)
TETRAGRAM_FOR_RESPONSE = chr(119598)
TETRAGRAM_FOR_GOING_TO_MEET = chr(119599)
TETRAGRAM_FOR_ENCOUNTERS = chr(119600)
TETRAGRAM_FOR_STOVE = chr(119601)
TETRAGRAM_FOR_GREATNESS = chr(119602)
TETRAGRAM_FOR_ENLARGEMENT = chr(119603)
TETRAGRAM_FOR_PATTERN = chr(119604)
TETRAGRAM_FOR_RITUAL = chr(119605)
TETRAGRAM_FOR_FLIGHT = chr(119606)
TETRAGRAM_FOR_VASTNESS_OR_WASTING = chr(119607)
TETRAGRAM_FOR_CONSTANCY = chr(119608)
TETRAGRAM_FOR_MEASURE = chr(119609)
TETRAGRAM_FOR_ETERNITY = chr(119610)
TETRAGRAM_FOR_UNITY = chr(119611)
TETRAGRAM_FOR_DIMINISHMENT = chr(119612)
TETRAGRAM_FOR_CLOSED_MOUTH = chr(119613)
TETRAGRAM_FOR_GUARDEDNESS = chr(119614)
TETRAGRAM_FOR_GATHERING_IN = chr(119615)
TETRAGRAM_FOR_MASSING = chr(119616)
TETRAGRAM_FOR_ACCUMULATION = chr(119617)
TETRAGRAM_FOR_EMBELLISHMENT = chr(119618)
TETRAGRAM_FOR_DOUBT = chr(119619)
TETRAGRAM_FOR_WATCH = chr(119620)
TETRAGRAM_FOR_SINKING = chr(119621)
TETRAGRAM_FOR_INNER = chr(119622)
TETRAGRAM_FOR_DEPARTURE = chr(119623)
TETRAGRAM_FOR_DARKENING = chr(119624)
TETRAGRAM_FOR_DIMMING = chr(119625)
TETRAGRAM_FOR_EXHAUSTION = chr(119626)
TETRAGRAM_FOR_SEVERANCE = chr(119627)
TETRAGRAM_FOR_STOPPAGE = chr(119628)
TETRAGRAM_FOR_HARDNESS = chr(119629)
TETRAGRAM_FOR_COMPLETION = chr(119630)
TETRAGRAM_FOR_CLOSURE = chr(119631)
TETRAGRAM_FOR_FAILURE = chr(119632)
TETRAGRAM_FOR_AGGRAVATION = chr(119633)
TETRAGRAM_FOR_COMPLIANCE = chr(119634)
TETRAGRAM_FOR_ON_THE_VERGE = chr(119635)
TETRAGRAM_FOR_DIFFICULTIES = chr(119636)
TETRAGRAM_FOR_LABOURING = chr(119637)
TETRAGRAM_FOR_FOSTERING = chr(119638)
COUNTING_ROD_UNIT_DIGIT_ONE = chr(119648)
COUNTING_ROD_UNIT_DIGIT_TWO = chr(119649)
COUNTING_ROD_UNIT_DIGIT_THREE = chr(119650)
COUNTING_ROD_UNIT_DIGIT_FOUR = chr(119651)
COUNTING_ROD_UNIT_DIGIT_FIVE = chr(119652)
COUNTING_ROD_UNIT_DIGIT_SIX = chr(119653)
COUNTING_ROD_UNIT_DIGIT_SEVEN = chr(119654)
COUNTING_ROD_UNIT_DIGIT_EIGHT = chr(119655)
COUNTING_ROD_UNIT_DIGIT_NINE = chr(119656)
COUNTING_ROD_TENS_DIGIT_ONE = chr(119657)
COUNTING_ROD_TENS_DIGIT_TWO = chr(119658)
COUNTING_ROD_TENS_DIGIT_THREE = chr(119659)
COUNTING_ROD_TENS_DIGIT_FOUR = chr(119660)
COUNTING_ROD_TENS_DIGIT_FIVE = chr(119661)
COUNTING_ROD_TENS_DIGIT_SIX = chr(119662)
COUNTING_ROD_TENS_DIGIT_SEVEN = chr(119663)
COUNTING_ROD_TENS_DIGIT_EIGHT = chr(119664)
COUNTING_ROD_TENS_DIGIT_NINE = chr(119665)
IDEOGRAPHIC_TALLY_MARK_ONE = chr(119666)
IDEOGRAPHIC_TALLY_MARK_TWO = chr(119667)
IDEOGRAPHIC_TALLY_MARK_THREE = chr(119668)
IDEOGRAPHIC_TALLY_MARK_FOUR = chr(119669)
IDEOGRAPHIC_TALLY_MARK_FIVE = chr(119670)
TALLY_MARK_ONE = chr(119671)
TALLY_MARK_FIVE = chr(119672)
MATHEMATICAL_BOLD_CAPITAL_A = chr(119808)
MATHEMATICAL_BOLD_CAPITAL_B = chr(119809)
MATHEMATICAL_BOLD_CAPITAL_C = chr(119810)
MATHEMATICAL_BOLD_CAPITAL_D = chr(119811)
MATHEMATICAL_BOLD_CAPITAL_E = chr(119812)
MATHEMATICAL_BOLD_CAPITAL_F = chr(119813)
MATHEMATICAL_BOLD_CAPITAL_G = chr(119814)
MATHEMATICAL_BOLD_CAPITAL_H = chr(119815)
MATHEMATICAL_BOLD_CAPITAL_I = chr(119816)
MATHEMATICAL_BOLD_CAPITAL_J = chr(119817)
MATHEMATICAL_BOLD_CAPITAL_K = chr(119818)
MATHEMATICAL_BOLD_CAPITAL_L = chr(119819)
MATHEMATICAL_BOLD_CAPITAL_M = chr(119820)
MATHEMATICAL_BOLD_CAPITAL_N = chr(119821)
MATHEMATICAL_BOLD_CAPITAL_O = chr(119822)
MATHEMATICAL_BOLD_CAPITAL_P = chr(119823)
MATHEMATICAL_BOLD_CAPITAL_Q = chr(119824)
MATHEMATICAL_BOLD_CAPITAL_R = chr(119825)
MATHEMATICAL_BOLD_CAPITAL_S = chr(119826)
MATHEMATICAL_BOLD_CAPITAL_T = chr(119827)
MATHEMATICAL_BOLD_CAPITAL_U = chr(119828)
MATHEMATICAL_BOLD_CAPITAL_V = chr(119829)
MATHEMATICAL_BOLD_CAPITAL_W = chr(119830)
MATHEMATICAL_BOLD_CAPITAL_X = chr(119831)
MATHEMATICAL_BOLD_CAPITAL_Y = chr(119832)
MATHEMATICAL_BOLD_CAPITAL_Z = chr(119833)
MATHEMATICAL_BOLD_SMALL_A = chr(119834)
MATHEMATICAL_BOLD_SMALL_B = chr(119835)
MATHEMATICAL_BOLD_SMALL_C = chr(119836)
MATHEMATICAL_BOLD_SMALL_D = chr(119837)
MATHEMATICAL_BOLD_SMALL_E = chr(119838)
MATHEMATICAL_BOLD_SMALL_F = chr(119839)
MATHEMATICAL_BOLD_SMALL_G = chr(119840)
MATHEMATICAL_BOLD_SMALL_H = chr(119841)
MATHEMATICAL_BOLD_SMALL_I = chr(119842)
MATHEMATICAL_BOLD_SMALL_J = chr(119843)
MATHEMATICAL_BOLD_SMALL_K = chr(119844)
MATHEMATICAL_BOLD_SMALL_L = chr(119845)
MATHEMATICAL_BOLD_SMALL_M = chr(119846)
MATHEMATICAL_BOLD_SMALL_N = chr(119847)
MATHEMATICAL_BOLD_SMALL_O = chr(119848)
MATHEMATICAL_BOLD_SMALL_P = chr(119849)
MATHEMATICAL_BOLD_SMALL_Q = chr(119850)
MATHEMATICAL_BOLD_SMALL_R = chr(119851)
MATHEMATICAL_BOLD_SMALL_S = chr(119852)
MATHEMATICAL_BOLD_SMALL_T = chr(119853)
MATHEMATICAL_BOLD_SMALL_U = chr(119854)
MATHEMATICAL_BOLD_SMALL_V = chr(119855)
MATHEMATICAL_BOLD_SMALL_W = chr(119856)
MATHEMATICAL_BOLD_SMALL_X = chr(119857)
MATHEMATICAL_BOLD_SMALL_Y = chr(119858)
MATHEMATICAL_BOLD_SMALL_Z = chr(119859)
MATHEMATICAL_ITALIC_CAPITAL_A = chr(119860)
MATHEMATICAL_ITALIC_CAPITAL_B = chr(119861)
MATHEMATICAL_ITALIC_CAPITAL_C = chr(119862)
MATHEMATICAL_ITALIC_CAPITAL_D = chr(119863)
MATHEMATICAL_ITALIC_CAPITAL_E = chr(119864)
MATHEMATICAL_ITALIC_CAPITAL_F = chr(119865)
MATHEMATICAL_ITALIC_CAPITAL_G = chr(119866)
MATHEMATICAL_ITALIC_CAPITAL_H = chr(119867)
MATHEMATICAL_ITALIC_CAPITAL_I = chr(119868)
MATHEMATICAL_ITALIC_CAPITAL_J = chr(119869)
MATHEMATICAL_ITALIC_CAPITAL_K = chr(119870)
MATHEMATICAL_ITALIC_CAPITAL_L = chr(119871)
MATHEMATICAL_ITALIC_CAPITAL_M = chr(119872)
MATHEMATICAL_ITALIC_CAPITAL_N = chr(119873)
MATHEMATICAL_ITALIC_CAPITAL_O = chr(119874)
MATHEMATICAL_ITALIC_CAPITAL_P = chr(119875)
MATHEMATICAL_ITALIC_CAPITAL_Q = chr(119876)
MATHEMATICAL_ITALIC_CAPITAL_R = chr(119877)
MATHEMATICAL_ITALIC_CAPITAL_S = chr(119878)
MATHEMATICAL_ITALIC_CAPITAL_T = chr(119879)
MATHEMATICAL_ITALIC_CAPITAL_U = chr(119880)
MATHEMATICAL_ITALIC_CAPITAL_V = chr(119881)
MATHEMATICAL_ITALIC_CAPITAL_W = chr(119882)
MATHEMATICAL_ITALIC_CAPITAL_X = chr(119883)
MATHEMATICAL_ITALIC_CAPITAL_Y = chr(119884)
MATHEMATICAL_ITALIC_CAPITAL_Z = chr(119885)
MATHEMATICAL_ITALIC_SMALL_A = chr(119886)
MATHEMATICAL_ITALIC_SMALL_B = chr(119887)
MATHEMATICAL_ITALIC_SMALL_C = chr(119888)
MATHEMATICAL_ITALIC_SMALL_D = chr(119889)
MATHEMATICAL_ITALIC_SMALL_E = chr(119890)
MATHEMATICAL_ITALIC_SMALL_F = chr(119891)
MATHEMATICAL_ITALIC_SMALL_G = chr(119892)
MATHEMATICAL_ITALIC_SMALL_I = chr(119894)
MATHEMATICAL_ITALIC_SMALL_J = chr(119895)
MATHEMATICAL_ITALIC_SMALL_K = chr(119896)
MATHEMATICAL_ITALIC_SMALL_L = chr(119897)
MATHEMATICAL_ITALIC_SMALL_M = chr(119898)
MATHEMATICAL_ITALIC_SMALL_N = chr(119899)
MATHEMATICAL_ITALIC_SMALL_O = chr(119900)
MATHEMATICAL_ITALIC_SMALL_P = chr(119901)
MATHEMATICAL_ITALIC_SMALL_Q = chr(119902)
MATHEMATICAL_ITALIC_SMALL_R = chr(119903)
MATHEMATICAL_ITALIC_SMALL_S = chr(119904)
MATHEMATICAL_ITALIC_SMALL_T = chr(119905)
MATHEMATICAL_ITALIC_SMALL_U = chr(119906)
MATHEMATICAL_ITALIC_SMALL_V = chr(119907)
MATHEMATICAL_ITALIC_SMALL_W = chr(119908)
MATHEMATICAL_ITALIC_SMALL_X = chr(119909)
MATHEMATICAL_ITALIC_SMALL_Y = chr(119910)
MATHEMATICAL_ITALIC_SMALL_Z = chr(119911)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_A = chr(119912)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_B = chr(119913)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_C = chr(119914)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_D = chr(119915)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_E = chr(119916)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_F = chr(119917)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_G = chr(119918)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_H = chr(119919)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_I = chr(119920)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_J = chr(119921)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_K = chr(119922)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_L = chr(119923)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_M = chr(119924)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_N = chr(119925)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_O = chr(119926)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_P = chr(119927)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_Q = chr(119928)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_R = chr(119929)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_S = chr(119930)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_T = chr(119931)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_U = chr(119932)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_V = chr(119933)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_W = chr(119934)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_X = chr(119935)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_Y = chr(119936)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_Z = chr(119937)
MATHEMATICAL_BOLD_ITALIC_SMALL_A = chr(119938)
MATHEMATICAL_BOLD_ITALIC_SMALL_B = chr(119939)
MATHEMATICAL_BOLD_ITALIC_SMALL_C = chr(119940)
MATHEMATICAL_BOLD_ITALIC_SMALL_D = chr(119941)
MATHEMATICAL_BOLD_ITALIC_SMALL_E = chr(119942)
MATHEMATICAL_BOLD_ITALIC_SMALL_F = chr(119943)
MATHEMATICAL_BOLD_ITALIC_SMALL_G = chr(119944)
MATHEMATICAL_BOLD_ITALIC_SMALL_H = chr(119945)
MATHEMATICAL_BOLD_ITALIC_SMALL_I = chr(119946)
MATHEMATICAL_BOLD_ITALIC_SMALL_J = chr(119947)
MATHEMATICAL_BOLD_ITALIC_SMALL_K = chr(119948)
MATHEMATICAL_BOLD_ITALIC_SMALL_L = chr(119949)
MATHEMATICAL_BOLD_ITALIC_SMALL_M = chr(119950)
MATHEMATICAL_BOLD_ITALIC_SMALL_N = chr(119951)
MATHEMATICAL_BOLD_ITALIC_SMALL_O = chr(119952)
MATHEMATICAL_BOLD_ITALIC_SMALL_P = chr(119953)
MATHEMATICAL_BOLD_ITALIC_SMALL_Q = chr(119954)
MATHEMATICAL_BOLD_ITALIC_SMALL_R = chr(119955)
MATHEMATICAL_BOLD_ITALIC_SMALL_S = chr(119956)
MATHEMATICAL_BOLD_ITALIC_SMALL_T = chr(119957)
MATHEMATICAL_BOLD_ITALIC_SMALL_U = chr(119958)
MATHEMATICAL_BOLD_ITALIC_SMALL_V = chr(119959)
MATHEMATICAL_BOLD_ITALIC_SMALL_W = chr(119960)
MATHEMATICAL_BOLD_ITALIC_SMALL_X = chr(119961)
MATHEMATICAL_BOLD_ITALIC_SMALL_Y = chr(119962)
MATHEMATICAL_BOLD_ITALIC_SMALL_Z = chr(119963)
MATHEMATICAL_SCRIPT_CAPITAL_A = chr(119964)
MATHEMATICAL_SCRIPT_CAPITAL_C = chr(119966)
MATHEMATICAL_SCRIPT_CAPITAL_D = chr(119967)
MATHEMATICAL_SCRIPT_CAPITAL_G = chr(119970)
MATHEMATICAL_SCRIPT_CAPITAL_J = chr(119973)
MATHEMATICAL_SCRIPT_CAPITAL_K = chr(119974)
MATHEMATICAL_SCRIPT_CAPITAL_N = chr(119977)
MATHEMATICAL_SCRIPT_CAPITAL_O = chr(119978)
MATHEMATICAL_SCRIPT_CAPITAL_P = chr(119979)
MATHEMATICAL_SCRIPT_CAPITAL_Q = chr(119980)
MATHEMATICAL_SCRIPT_CAPITAL_S = chr(119982)
MATHEMATICAL_SCRIPT_CAPITAL_T = chr(119983)
MATHEMATICAL_SCRIPT_CAPITAL_U = chr(119984)
MATHEMATICAL_SCRIPT_CAPITAL_V = chr(119985)
MATHEMATICAL_SCRIPT_CAPITAL_W = chr(119986)
MATHEMATICAL_SCRIPT_CAPITAL_X = chr(119987)
MATHEMATICAL_SCRIPT_CAPITAL_Y = chr(119988)
MATHEMATICAL_SCRIPT_CAPITAL_Z = chr(119989)
MATHEMATICAL_SCRIPT_SMALL_A = chr(119990)
MATHEMATICAL_SCRIPT_SMALL_B = chr(119991)
MATHEMATICAL_SCRIPT_SMALL_C = chr(119992)
MATHEMATICAL_SCRIPT_SMALL_D = chr(119993)
MATHEMATICAL_SCRIPT_SMALL_F = chr(119995)
MATHEMATICAL_SCRIPT_SMALL_H = chr(119997)
MATHEMATICAL_SCRIPT_SMALL_I = chr(119998)
MATHEMATICAL_SCRIPT_SMALL_J = chr(119999)
MATHEMATICAL_SCRIPT_SMALL_K = chr(120000)
MATHEMATICAL_SCRIPT_SMALL_L = chr(120001)
MATHEMATICAL_SCRIPT_SMALL_M = chr(120002)
MATHEMATICAL_SCRIPT_SMALL_N = chr(120003)
MATHEMATICAL_SCRIPT_SMALL_P = chr(120005)
MATHEMATICAL_SCRIPT_SMALL_Q = chr(120006)
MATHEMATICAL_SCRIPT_SMALL_R = chr(120007)
MATHEMATICAL_SCRIPT_SMALL_S = chr(120008)
MATHEMATICAL_SCRIPT_SMALL_T = chr(120009)
MATHEMATICAL_SCRIPT_SMALL_U = chr(120010)
MATHEMATICAL_SCRIPT_SMALL_V = chr(120011)
MATHEMATICAL_SCRIPT_SMALL_W = chr(120012)
MATHEMATICAL_SCRIPT_SMALL_X = chr(120013)
MATHEMATICAL_SCRIPT_SMALL_Y = chr(120014)
MATHEMATICAL_SCRIPT_SMALL_Z = chr(120015)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_A = chr(120016)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_B = chr(120017)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_C = chr(120018)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_D = chr(120019)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_E = chr(120020)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_F = chr(120021)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_G = chr(120022)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_H = chr(120023)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_I = chr(120024)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_J = chr(120025)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_K = chr(120026)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_L = chr(120027)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_M = chr(120028)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_N = chr(120029)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_O = chr(120030)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_P = chr(120031)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_Q = chr(120032)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_R = chr(120033)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_S = chr(120034)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_T = chr(120035)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_U = chr(120036)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_V = chr(120037)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_W = chr(120038)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_X = chr(120039)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_Y = chr(120040)
MATHEMATICAL_BOLD_SCRIPT_CAPITAL_Z = chr(120041)
MATHEMATICAL_BOLD_SCRIPT_SMALL_A = chr(120042)
MATHEMATICAL_BOLD_SCRIPT_SMALL_B = chr(120043)
MATHEMATICAL_BOLD_SCRIPT_SMALL_C = chr(120044)
MATHEMATICAL_BOLD_SCRIPT_SMALL_D = chr(120045)
MATHEMATICAL_BOLD_SCRIPT_SMALL_E = chr(120046)
MATHEMATICAL_BOLD_SCRIPT_SMALL_F = chr(120047)
MATHEMATICAL_BOLD_SCRIPT_SMALL_G = chr(120048)
MATHEMATICAL_BOLD_SCRIPT_SMALL_H = chr(120049)
MATHEMATICAL_BOLD_SCRIPT_SMALL_I = chr(120050)
MATHEMATICAL_BOLD_SCRIPT_SMALL_J = chr(120051)
MATHEMATICAL_BOLD_SCRIPT_SMALL_K = chr(120052)
MATHEMATICAL_BOLD_SCRIPT_SMALL_L = chr(120053)
MATHEMATICAL_BOLD_SCRIPT_SMALL_M = chr(120054)
MATHEMATICAL_BOLD_SCRIPT_SMALL_N = chr(120055)
MATHEMATICAL_BOLD_SCRIPT_SMALL_O = chr(120056)
MATHEMATICAL_BOLD_SCRIPT_SMALL_P = chr(120057)
MATHEMATICAL_BOLD_SCRIPT_SMALL_Q = chr(120058)
MATHEMATICAL_BOLD_SCRIPT_SMALL_R = chr(120059)
MATHEMATICAL_BOLD_SCRIPT_SMALL_S = chr(120060)
MATHEMATICAL_BOLD_SCRIPT_SMALL_T = chr(120061)
MATHEMATICAL_BOLD_SCRIPT_SMALL_U = chr(120062)
MATHEMATICAL_BOLD_SCRIPT_SMALL_V = chr(120063)
MATHEMATICAL_BOLD_SCRIPT_SMALL_W = chr(120064)
MATHEMATICAL_BOLD_SCRIPT_SMALL_X = chr(120065)
MATHEMATICAL_BOLD_SCRIPT_SMALL_Y = chr(120066)
MATHEMATICAL_BOLD_SCRIPT_SMALL_Z = chr(120067)
MATHEMATICAL_FRAKTUR_CAPITAL_A = chr(120068)
MATHEMATICAL_FRAKTUR_CAPITAL_B = chr(120069)
MATHEMATICAL_FRAKTUR_CAPITAL_D = chr(120071)
MATHEMATICAL_FRAKTUR_CAPITAL_E = chr(120072)
MATHEMATICAL_FRAKTUR_CAPITAL_F = chr(120073)
MATHEMATICAL_FRAKTUR_CAPITAL_G = chr(120074)
MATHEMATICAL_FRAKTUR_CAPITAL_J = chr(120077)
MATHEMATICAL_FRAKTUR_CAPITAL_K = chr(120078)
MATHEMATICAL_FRAKTUR_CAPITAL_L = chr(120079)
MATHEMATICAL_FRAKTUR_CAPITAL_M = chr(120080)
MATHEMATICAL_FRAKTUR_CAPITAL_N = chr(120081)
MATHEMATICAL_FRAKTUR_CAPITAL_O = chr(120082)
MATHEMATICAL_FRAKTUR_CAPITAL_P = chr(120083)
MATHEMATICAL_FRAKTUR_CAPITAL_Q = chr(120084)
MATHEMATICAL_FRAKTUR_CAPITAL_S = chr(120086)
MATHEMATICAL_FRAKTUR_CAPITAL_T = chr(120087)
MATHEMATICAL_FRAKTUR_CAPITAL_U = chr(120088)
MATHEMATICAL_FRAKTUR_CAPITAL_V = chr(120089)
MATHEMATICAL_FRAKTUR_CAPITAL_W = chr(120090)
MATHEMATICAL_FRAKTUR_CAPITAL_X = chr(120091)
MATHEMATICAL_FRAKTUR_CAPITAL_Y = chr(120092)
MATHEMATICAL_FRAKTUR_SMALL_A = chr(120094)
MATHEMATICAL_FRAKTUR_SMALL_B = chr(120095)
MATHEMATICAL_FRAKTUR_SMALL_C = chr(120096)
MATHEMATICAL_FRAKTUR_SMALL_D = chr(120097)
MATHEMATICAL_FRAKTUR_SMALL_E = chr(120098)
MATHEMATICAL_FRAKTUR_SMALL_F = chr(120099)
MATHEMATICAL_FRAKTUR_SMALL_G = chr(120100)
MATHEMATICAL_FRAKTUR_SMALL_H = chr(120101)
MATHEMATICAL_FRAKTUR_SMALL_I = chr(120102)
MATHEMATICAL_FRAKTUR_SMALL_J = chr(120103)
MATHEMATICAL_FRAKTUR_SMALL_K = chr(120104)
MATHEMATICAL_FRAKTUR_SMALL_L = chr(120105)
MATHEMATICAL_FRAKTUR_SMALL_M = chr(120106)
MATHEMATICAL_FRAKTUR_SMALL_N = chr(120107)
MATHEMATICAL_FRAKTUR_SMALL_O = chr(120108)
MATHEMATICAL_FRAKTUR_SMALL_P = chr(120109)
MATHEMATICAL_FRAKTUR_SMALL_Q = chr(120110)
MATHEMATICAL_FRAKTUR_SMALL_R = chr(120111)
MATHEMATICAL_FRAKTUR_SMALL_S = chr(120112)
MATHEMATICAL_FRAKTUR_SMALL_T = chr(120113)
MATHEMATICAL_FRAKTUR_SMALL_U = chr(120114)
MATHEMATICAL_FRAKTUR_SMALL_V = chr(120115)
MATHEMATICAL_FRAKTUR_SMALL_W = chr(120116)
MATHEMATICAL_FRAKTUR_SMALL_X = chr(120117)
MATHEMATICAL_FRAKTUR_SMALL_Y = chr(120118)
MATHEMATICAL_FRAKTUR_SMALL_Z = chr(120119)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_A = chr(120120)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_B = chr(120121)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_D = chr(120123)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_E = chr(120124)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_F = chr(120125)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_G = chr(120126)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_I = chr(120128)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_J = chr(120129)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_K = chr(120130)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_L = chr(120131)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_M = chr(120132)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_O = chr(120134)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_S = chr(120138)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_T = chr(120139)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_U = chr(120140)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_V = chr(120141)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_W = chr(120142)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_X = chr(120143)
MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_Y = chr(120144)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_A = chr(120146)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_B = chr(120147)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_C = chr(120148)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_D = chr(120149)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_E = chr(120150)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_F = chr(120151)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_G = chr(120152)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_H = chr(120153)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_I = chr(120154)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_J = chr(120155)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_K = chr(120156)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_L = chr(120157)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_M = chr(120158)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_N = chr(120159)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_O = chr(120160)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_P = chr(120161)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_Q = chr(120162)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_R = chr(120163)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_S = chr(120164)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_T = chr(120165)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_U = chr(120166)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_V = chr(120167)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_W = chr(120168)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_X = chr(120169)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_Y = chr(120170)
MATHEMATICAL_DOUBLE_STRUCK_SMALL_Z = chr(120171)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_A = chr(120172)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_B = chr(120173)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_C = chr(120174)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_D = chr(120175)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_E = chr(120176)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_F = chr(120177)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_G = chr(120178)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_H = chr(120179)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_I = chr(120180)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_J = chr(120181)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_K = chr(120182)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_L = chr(120183)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_M = chr(120184)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_N = chr(120185)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_O = chr(120186)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_P = chr(120187)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_Q = chr(120188)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_R = chr(120189)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_S = chr(120190)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_T = chr(120191)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_U = chr(120192)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_V = chr(120193)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_W = chr(120194)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_X = chr(120195)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_Y = chr(120196)
MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_Z = chr(120197)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_A = chr(120198)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_B = chr(120199)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_C = chr(120200)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_D = chr(120201)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_E = chr(120202)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_F = chr(120203)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_G = chr(120204)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_H = chr(120205)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_I = chr(120206)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_J = chr(120207)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_K = chr(120208)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_L = chr(120209)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_M = chr(120210)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_N = chr(120211)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_O = chr(120212)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_P = chr(120213)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_Q = chr(120214)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_R = chr(120215)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_S = chr(120216)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_T = chr(120217)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_U = chr(120218)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_V = chr(120219)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_W = chr(120220)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_X = chr(120221)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_Y = chr(120222)
MATHEMATICAL_BOLD_FRAKTUR_SMALL_Z = chr(120223)
MATHEMATICAL_SANS_SERIF_CAPITAL_A = chr(120224)
MATHEMATICAL_SANS_SERIF_CAPITAL_B = chr(120225)
MATHEMATICAL_SANS_SERIF_CAPITAL_C = chr(120226)
MATHEMATICAL_SANS_SERIF_CAPITAL_D = chr(120227)
MATHEMATICAL_SANS_SERIF_CAPITAL_E = chr(120228)
MATHEMATICAL_SANS_SERIF_CAPITAL_F = chr(120229)
MATHEMATICAL_SANS_SERIF_CAPITAL_G = chr(120230)
MATHEMATICAL_SANS_SERIF_CAPITAL_H = chr(120231)
MATHEMATICAL_SANS_SERIF_CAPITAL_I = chr(120232)
MATHEMATICAL_SANS_SERIF_CAPITAL_J = chr(120233)
MATHEMATICAL_SANS_SERIF_CAPITAL_K = chr(120234)
MATHEMATICAL_SANS_SERIF_CAPITAL_L = chr(120235)
MATHEMATICAL_SANS_SERIF_CAPITAL_M = chr(120236)
MATHEMATICAL_SANS_SERIF_CAPITAL_N = chr(120237)
MATHEMATICAL_SANS_SERIF_CAPITAL_O = chr(120238)
MATHEMATICAL_SANS_SERIF_CAPITAL_P = chr(120239)
MATHEMATICAL_SANS_SERIF_CAPITAL_Q = chr(120240)
MATHEMATICAL_SANS_SERIF_CAPITAL_R = chr(120241)
MATHEMATICAL_SANS_SERIF_CAPITAL_S = chr(120242)
MATHEMATICAL_SANS_SERIF_CAPITAL_T = chr(120243)
MATHEMATICAL_SANS_SERIF_CAPITAL_U = chr(120244)
MATHEMATICAL_SANS_SERIF_CAPITAL_V = chr(120245)
MATHEMATICAL_SANS_SERIF_CAPITAL_W = chr(120246)
MATHEMATICAL_SANS_SERIF_CAPITAL_X = chr(120247)
MATHEMATICAL_SANS_SERIF_CAPITAL_Y = chr(120248)
MATHEMATICAL_SANS_SERIF_CAPITAL_Z = chr(120249)
MATHEMATICAL_SANS_SERIF_SMALL_A = chr(120250)
MATHEMATICAL_SANS_SERIF_SMALL_B = chr(120251)
MATHEMATICAL_SANS_SERIF_SMALL_C = chr(120252)
MATHEMATICAL_SANS_SERIF_SMALL_D = chr(120253)
MATHEMATICAL_SANS_SERIF_SMALL_E = chr(120254)
MATHEMATICAL_SANS_SERIF_SMALL_F = chr(120255)
MATHEMATICAL_SANS_SERIF_SMALL_G = chr(120256)
MATHEMATICAL_SANS_SERIF_SMALL_H = chr(120257)
MATHEMATICAL_SANS_SERIF_SMALL_I = chr(120258)
MATHEMATICAL_SANS_SERIF_SMALL_J = chr(120259)
MATHEMATICAL_SANS_SERIF_SMALL_K = chr(120260)
MATHEMATICAL_SANS_SERIF_SMALL_L = chr(120261)
MATHEMATICAL_SANS_SERIF_SMALL_M = chr(120262)
MATHEMATICAL_SANS_SERIF_SMALL_N = chr(120263)
MATHEMATICAL_SANS_SERIF_SMALL_O = chr(120264)
MATHEMATICAL_SANS_SERIF_SMALL_P = chr(120265)
MATHEMATICAL_SANS_SERIF_SMALL_Q = chr(120266)
MATHEMATICAL_SANS_SERIF_SMALL_R = chr(120267)
MATHEMATICAL_SANS_SERIF_SMALL_S = chr(120268)
MATHEMATICAL_SANS_SERIF_SMALL_T = chr(120269)
MATHEMATICAL_SANS_SERIF_SMALL_U = chr(120270)
MATHEMATICAL_SANS_SERIF_SMALL_V = chr(120271)
MATHEMATICAL_SANS_SERIF_SMALL_W = chr(120272)
MATHEMATICAL_SANS_SERIF_SMALL_X = chr(120273)
MATHEMATICAL_SANS_SERIF_SMALL_Y = chr(120274)
MATHEMATICAL_SANS_SERIF_SMALL_Z = chr(120275)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_A = chr(120276)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_B = chr(120277)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_C = chr(120278)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_D = chr(120279)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_E = chr(120280)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_F = chr(120281)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_G = chr(120282)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_H = chr(120283)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_I = chr(120284)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_J = chr(120285)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_K = chr(120286)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_L = chr(120287)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_M = chr(120288)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_N = chr(120289)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_O = chr(120290)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_P = chr(120291)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_Q = chr(120292)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_R = chr(120293)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_S = chr(120294)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_T = chr(120295)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_U = chr(120296)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_V = chr(120297)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_W = chr(120298)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_X = chr(120299)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_Y = chr(120300)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_Z = chr(120301)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_A = chr(120302)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_B = chr(120303)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_C = chr(120304)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_D = chr(120305)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_E = chr(120306)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_F = chr(120307)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_G = chr(120308)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_H = chr(120309)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_I = chr(120310)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_J = chr(120311)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_K = chr(120312)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_L = chr(120313)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_M = chr(120314)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_N = chr(120315)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_O = chr(120316)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_P = chr(120317)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_Q = chr(120318)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_R = chr(120319)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_S = chr(120320)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_T = chr(120321)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_U = chr(120322)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_V = chr(120323)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_W = chr(120324)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_X = chr(120325)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_Y = chr(120326)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_Z = chr(120327)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_A = chr(120328)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_B = chr(120329)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_C = chr(120330)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_D = chr(120331)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_E = chr(120332)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_F = chr(120333)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_G = chr(120334)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_H = chr(120335)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_I = chr(120336)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_J = chr(120337)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_K = chr(120338)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_L = chr(120339)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_M = chr(120340)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_N = chr(120341)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_O = chr(120342)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_P = chr(120343)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_Q = chr(120344)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_R = chr(120345)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_S = chr(120346)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_T = chr(120347)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_U = chr(120348)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_V = chr(120349)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_W = chr(120350)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_X = chr(120351)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_Y = chr(120352)
MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_Z = chr(120353)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_A = chr(120354)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_B = chr(120355)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_C = chr(120356)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_D = chr(120357)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_E = chr(120358)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_F = chr(120359)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_G = chr(120360)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_H = chr(120361)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_I = chr(120362)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_J = chr(120363)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_K = chr(120364)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_L = chr(120365)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_M = chr(120366)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_N = chr(120367)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_O = chr(120368)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_P = chr(120369)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_Q = chr(120370)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_R = chr(120371)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_S = chr(120372)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_T = chr(120373)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_U = chr(120374)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_V = chr(120375)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_W = chr(120376)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_X = chr(120377)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_Y = chr(120378)
MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_Z = chr(120379)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_A = chr(120380)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_B = chr(120381)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_C = chr(120382)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_D = chr(120383)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_E = chr(120384)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_F = chr(120385)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_G = chr(120386)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_H = chr(120387)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_I = chr(120388)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_J = chr(120389)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_K = chr(120390)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_L = chr(120391)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_M = chr(120392)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_N = chr(120393)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_O = chr(120394)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_P = chr(120395)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_Q = chr(120396)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_R = chr(120397)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_S = chr(120398)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_T = chr(120399)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_U = chr(120400)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_V = chr(120401)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_W = chr(120402)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_X = chr(120403)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_Y = chr(120404)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_Z = chr(120405)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_A = chr(120406)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_B = chr(120407)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_C = chr(120408)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_D = chr(120409)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_E = chr(120410)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_F = chr(120411)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_G = chr(120412)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_H = chr(120413)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_I = chr(120414)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_J = chr(120415)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_K = chr(120416)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_L = chr(120417)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_M = chr(120418)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_N = chr(120419)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_O = chr(120420)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_P = chr(120421)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_Q = chr(120422)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_R = chr(120423)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_S = chr(120424)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_T = chr(120425)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_U = chr(120426)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_V = chr(120427)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_W = chr(120428)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_X = chr(120429)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_Y = chr(120430)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_Z = chr(120431)
MATHEMATICAL_MONOSPACE_CAPITAL_A = chr(120432)
MATHEMATICAL_MONOSPACE_CAPITAL_B = chr(120433)
MATHEMATICAL_MONOSPACE_CAPITAL_C = chr(120434)
MATHEMATICAL_MONOSPACE_CAPITAL_D = chr(120435)
MATHEMATICAL_MONOSPACE_CAPITAL_E = chr(120436)
MATHEMATICAL_MONOSPACE_CAPITAL_F = chr(120437)
MATHEMATICAL_MONOSPACE_CAPITAL_G = chr(120438)
MATHEMATICAL_MONOSPACE_CAPITAL_H = chr(120439)
MATHEMATICAL_MONOSPACE_CAPITAL_I = chr(120440)
MATHEMATICAL_MONOSPACE_CAPITAL_J = chr(120441)
MATHEMATICAL_MONOSPACE_CAPITAL_K = chr(120442)
MATHEMATICAL_MONOSPACE_CAPITAL_L = chr(120443)
MATHEMATICAL_MONOSPACE_CAPITAL_M = chr(120444)
MATHEMATICAL_MONOSPACE_CAPITAL_N = chr(120445)
MATHEMATICAL_MONOSPACE_CAPITAL_O = chr(120446)
MATHEMATICAL_MONOSPACE_CAPITAL_P = chr(120447)
MATHEMATICAL_MONOSPACE_CAPITAL_Q = chr(120448)
MATHEMATICAL_MONOSPACE_CAPITAL_R = chr(120449)
MATHEMATICAL_MONOSPACE_CAPITAL_S = chr(120450)
MATHEMATICAL_MONOSPACE_CAPITAL_T = chr(120451)
MATHEMATICAL_MONOSPACE_CAPITAL_U = chr(120452)
MATHEMATICAL_MONOSPACE_CAPITAL_V = chr(120453)
MATHEMATICAL_MONOSPACE_CAPITAL_W = chr(120454)
MATHEMATICAL_MONOSPACE_CAPITAL_X = chr(120455)
MATHEMATICAL_MONOSPACE_CAPITAL_Y = chr(120456)
MATHEMATICAL_MONOSPACE_CAPITAL_Z = chr(120457)
MATHEMATICAL_MONOSPACE_SMALL_A = chr(120458)
MATHEMATICAL_MONOSPACE_SMALL_B = chr(120459)
MATHEMATICAL_MONOSPACE_SMALL_C = chr(120460)
MATHEMATICAL_MONOSPACE_SMALL_D = chr(120461)
MATHEMATICAL_MONOSPACE_SMALL_E = chr(120462)
MATHEMATICAL_MONOSPACE_SMALL_F = chr(120463)
MATHEMATICAL_MONOSPACE_SMALL_G = chr(120464)
MATHEMATICAL_MONOSPACE_SMALL_H = chr(120465)
MATHEMATICAL_MONOSPACE_SMALL_I = chr(120466)
MATHEMATICAL_MONOSPACE_SMALL_J = chr(120467)
MATHEMATICAL_MONOSPACE_SMALL_K = chr(120468)
MATHEMATICAL_MONOSPACE_SMALL_L = chr(120469)
MATHEMATICAL_MONOSPACE_SMALL_M = chr(120470)
MATHEMATICAL_MONOSPACE_SMALL_N = chr(120471)
MATHEMATICAL_MONOSPACE_SMALL_O = chr(120472)
MATHEMATICAL_MONOSPACE_SMALL_P = chr(120473)
MATHEMATICAL_MONOSPACE_SMALL_Q = chr(120474)
MATHEMATICAL_MONOSPACE_SMALL_R = chr(120475)
MATHEMATICAL_MONOSPACE_SMALL_S = chr(120476)
MATHEMATICAL_MONOSPACE_SMALL_T = chr(120477)
MATHEMATICAL_MONOSPACE_SMALL_U = chr(120478)
MATHEMATICAL_MONOSPACE_SMALL_V = chr(120479)
MATHEMATICAL_MONOSPACE_SMALL_W = chr(120480)
MATHEMATICAL_MONOSPACE_SMALL_X = chr(120481)
MATHEMATICAL_MONOSPACE_SMALL_Y = chr(120482)
MATHEMATICAL_MONOSPACE_SMALL_Z = chr(120483)
MATHEMATICAL_ITALIC_SMALL_DOTLESS_I = chr(120484)
MATHEMATICAL_ITALIC_SMALL_DOTLESS_J = chr(120485)
MATHEMATICAL_BOLD_CAPITAL_ALPHA = chr(120488)
MATHEMATICAL_BOLD_CAPITAL_BETA = chr(120489)
MATHEMATICAL_BOLD_CAPITAL_GAMMA = chr(120490)
MATHEMATICAL_BOLD_CAPITAL_DELTA = chr(120491)
MATHEMATICAL_BOLD_CAPITAL_EPSILON = chr(120492)
MATHEMATICAL_BOLD_CAPITAL_ZETA = chr(120493)
MATHEMATICAL_BOLD_CAPITAL_ETA = chr(120494)
MATHEMATICAL_BOLD_CAPITAL_THETA = chr(120495)
MATHEMATICAL_BOLD_CAPITAL_IOTA = chr(120496)
MATHEMATICAL_BOLD_CAPITAL_KAPPA = chr(120497)
MATHEMATICAL_BOLD_CAPITAL_LAMDA = chr(120498)
MATHEMATICAL_BOLD_CAPITAL_MU = chr(120499)
MATHEMATICAL_BOLD_CAPITAL_NU = chr(120500)
MATHEMATICAL_BOLD_CAPITAL_XI = chr(120501)
MATHEMATICAL_BOLD_CAPITAL_OMICRON = chr(120502)
MATHEMATICAL_BOLD_CAPITAL_PI = chr(120503)
MATHEMATICAL_BOLD_CAPITAL_RHO = chr(120504)
MATHEMATICAL_BOLD_CAPITAL_THETA_SYMBOL = chr(120505)
MATHEMATICAL_BOLD_CAPITAL_SIGMA = chr(120506)
MATHEMATICAL_BOLD_CAPITAL_TAU = chr(120507)
MATHEMATICAL_BOLD_CAPITAL_UPSILON = chr(120508)
MATHEMATICAL_BOLD_CAPITAL_PHI = chr(120509)
MATHEMATICAL_BOLD_CAPITAL_CHI = chr(120510)
MATHEMATICAL_BOLD_CAPITAL_PSI = chr(120511)
MATHEMATICAL_BOLD_CAPITAL_OMEGA = chr(120512)
MATHEMATICAL_BOLD_NABLA = chr(120513)
MATHEMATICAL_BOLD_SMALL_ALPHA = chr(120514)
MATHEMATICAL_BOLD_SMALL_BETA = chr(120515)
MATHEMATICAL_BOLD_SMALL_GAMMA = chr(120516)
MATHEMATICAL_BOLD_SMALL_DELTA = chr(120517)
MATHEMATICAL_BOLD_SMALL_EPSILON = chr(120518)
MATHEMATICAL_BOLD_SMALL_ZETA = chr(120519)
MATHEMATICAL_BOLD_SMALL_ETA = chr(120520)
MATHEMATICAL_BOLD_SMALL_THETA = chr(120521)
MATHEMATICAL_BOLD_SMALL_IOTA = chr(120522)
MATHEMATICAL_BOLD_SMALL_KAPPA = chr(120523)
MATHEMATICAL_BOLD_SMALL_LAMDA = chr(120524)
MATHEMATICAL_BOLD_SMALL_MU = chr(120525)
MATHEMATICAL_BOLD_SMALL_NU = chr(120526)
MATHEMATICAL_BOLD_SMALL_XI = chr(120527)
MATHEMATICAL_BOLD_SMALL_OMICRON = chr(120528)
MATHEMATICAL_BOLD_SMALL_PI = chr(120529)
MATHEMATICAL_BOLD_SMALL_RHO = chr(120530)
MATHEMATICAL_BOLD_SMALL_FINAL_SIGMA = chr(120531)
MATHEMATICAL_BOLD_SMALL_SIGMA = chr(120532)
MATHEMATICAL_BOLD_SMALL_TAU = chr(120533)
MATHEMATICAL_BOLD_SMALL_UPSILON = chr(120534)
MATHEMATICAL_BOLD_SMALL_PHI = chr(120535)
MATHEMATICAL_BOLD_SMALL_CHI = chr(120536)
MATHEMATICAL_BOLD_SMALL_PSI = chr(120537)
MATHEMATICAL_BOLD_SMALL_OMEGA = chr(120538)
MATHEMATICAL_BOLD_PARTIAL_DIFFERENTIAL = chr(120539)
MATHEMATICAL_BOLD_EPSILON_SYMBOL = chr(120540)
MATHEMATICAL_BOLD_THETA_SYMBOL = chr(120541)
MATHEMATICAL_BOLD_KAPPA_SYMBOL = chr(120542)
MATHEMATICAL_BOLD_PHI_SYMBOL = chr(120543)
MATHEMATICAL_BOLD_RHO_SYMBOL = chr(120544)
MATHEMATICAL_BOLD_PI_SYMBOL = chr(120545)
MATHEMATICAL_ITALIC_CAPITAL_ALPHA = chr(120546)
MATHEMATICAL_ITALIC_CAPITAL_BETA = chr(120547)
MATHEMATICAL_ITALIC_CAPITAL_GAMMA = chr(120548)
MATHEMATICAL_ITALIC_CAPITAL_DELTA = chr(120549)
MATHEMATICAL_ITALIC_CAPITAL_EPSILON = chr(120550)
MATHEMATICAL_ITALIC_CAPITAL_ZETA = chr(120551)
MATHEMATICAL_ITALIC_CAPITAL_ETA = chr(120552)
MATHEMATICAL_ITALIC_CAPITAL_THETA = chr(120553)
MATHEMATICAL_ITALIC_CAPITAL_IOTA = chr(120554)
MATHEMATICAL_ITALIC_CAPITAL_KAPPA = chr(120555)
MATHEMATICAL_ITALIC_CAPITAL_LAMDA = chr(120556)
MATHEMATICAL_ITALIC_CAPITAL_MU = chr(120557)
MATHEMATICAL_ITALIC_CAPITAL_NU = chr(120558)
MATHEMATICAL_ITALIC_CAPITAL_XI = chr(120559)
MATHEMATICAL_ITALIC_CAPITAL_OMICRON = chr(120560)
MATHEMATICAL_ITALIC_CAPITAL_PI = chr(120561)
MATHEMATICAL_ITALIC_CAPITAL_RHO = chr(120562)
MATHEMATICAL_ITALIC_CAPITAL_THETA_SYMBOL = chr(120563)
MATHEMATICAL_ITALIC_CAPITAL_SIGMA = chr(120564)
MATHEMATICAL_ITALIC_CAPITAL_TAU = chr(120565)
MATHEMATICAL_ITALIC_CAPITAL_UPSILON = chr(120566)
MATHEMATICAL_ITALIC_CAPITAL_PHI = chr(120567)
MATHEMATICAL_ITALIC_CAPITAL_CHI = chr(120568)
MATHEMATICAL_ITALIC_CAPITAL_PSI = chr(120569)
MATHEMATICAL_ITALIC_CAPITAL_OMEGA = chr(120570)
MATHEMATICAL_ITALIC_NABLA = chr(120571)
MATHEMATICAL_ITALIC_SMALL_ALPHA = chr(120572)
MATHEMATICAL_ITALIC_SMALL_BETA = chr(120573)
MATHEMATICAL_ITALIC_SMALL_GAMMA = chr(120574)
MATHEMATICAL_ITALIC_SMALL_DELTA = chr(120575)
MATHEMATICAL_ITALIC_SMALL_EPSILON = chr(120576)
MATHEMATICAL_ITALIC_SMALL_ZETA = chr(120577)
MATHEMATICAL_ITALIC_SMALL_ETA = chr(120578)
MATHEMATICAL_ITALIC_SMALL_THETA = chr(120579)
MATHEMATICAL_ITALIC_SMALL_IOTA = chr(120580)
MATHEMATICAL_ITALIC_SMALL_KAPPA = chr(120581)
MATHEMATICAL_ITALIC_SMALL_LAMDA = chr(120582)
MATHEMATICAL_ITALIC_SMALL_MU = chr(120583)
MATHEMATICAL_ITALIC_SMALL_NU = chr(120584)
MATHEMATICAL_ITALIC_SMALL_XI = chr(120585)
MATHEMATICAL_ITALIC_SMALL_OMICRON = chr(120586)
MATHEMATICAL_ITALIC_SMALL_PI = chr(120587)
MATHEMATICAL_ITALIC_SMALL_RHO = chr(120588)
MATHEMATICAL_ITALIC_SMALL_FINAL_SIGMA = chr(120589)
MATHEMATICAL_ITALIC_SMALL_SIGMA = chr(120590)
MATHEMATICAL_ITALIC_SMALL_TAU = chr(120591)
MATHEMATICAL_ITALIC_SMALL_UPSILON = chr(120592)
MATHEMATICAL_ITALIC_SMALL_PHI = chr(120593)
MATHEMATICAL_ITALIC_SMALL_CHI = chr(120594)
MATHEMATICAL_ITALIC_SMALL_PSI = chr(120595)
MATHEMATICAL_ITALIC_SMALL_OMEGA = chr(120596)
MATHEMATICAL_ITALIC_PARTIAL_DIFFERENTIAL = chr(120597)
MATHEMATICAL_ITALIC_EPSILON_SYMBOL = chr(120598)
MATHEMATICAL_ITALIC_THETA_SYMBOL = chr(120599)
MATHEMATICAL_ITALIC_KAPPA_SYMBOL = chr(120600)
MATHEMATICAL_ITALIC_PHI_SYMBOL = chr(120601)
MATHEMATICAL_ITALIC_RHO_SYMBOL = chr(120602)
MATHEMATICAL_ITALIC_PI_SYMBOL = chr(120603)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_ALPHA = chr(120604)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_BETA = chr(120605)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_GAMMA = chr(120606)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_DELTA = chr(120607)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_EPSILON = chr(120608)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_ZETA = chr(120609)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_ETA = chr(120610)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_THETA = chr(120611)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_IOTA = chr(120612)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_KAPPA = chr(120613)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_LAMDA = chr(120614)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_MU = chr(120615)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_NU = chr(120616)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_XI = chr(120617)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_OMICRON = chr(120618)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_PI = chr(120619)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_RHO = chr(120620)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_THETA_SYMBOL = chr(120621)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_SIGMA = chr(120622)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_TAU = chr(120623)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_UPSILON = chr(120624)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_PHI = chr(120625)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_CHI = chr(120626)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_PSI = chr(120627)
MATHEMATICAL_BOLD_ITALIC_CAPITAL_OMEGA = chr(120628)
MATHEMATICAL_BOLD_ITALIC_NABLA = chr(120629)
MATHEMATICAL_BOLD_ITALIC_SMALL_ALPHA = chr(120630)
MATHEMATICAL_BOLD_ITALIC_SMALL_BETA = chr(120631)
MATHEMATICAL_BOLD_ITALIC_SMALL_GAMMA = chr(120632)
MATHEMATICAL_BOLD_ITALIC_SMALL_DELTA = chr(120633)
MATHEMATICAL_BOLD_ITALIC_SMALL_EPSILON = chr(120634)
MATHEMATICAL_BOLD_ITALIC_SMALL_ZETA = chr(120635)
MATHEMATICAL_BOLD_ITALIC_SMALL_ETA = chr(120636)
MATHEMATICAL_BOLD_ITALIC_SMALL_THETA = chr(120637)
MATHEMATICAL_BOLD_ITALIC_SMALL_IOTA = chr(120638)
MATHEMATICAL_BOLD_ITALIC_SMALL_KAPPA = chr(120639)
MATHEMATICAL_BOLD_ITALIC_SMALL_LAMDA = chr(120640)
MATHEMATICAL_BOLD_ITALIC_SMALL_MU = chr(120641)
MATHEMATICAL_BOLD_ITALIC_SMALL_NU = chr(120642)
MATHEMATICAL_BOLD_ITALIC_SMALL_XI = chr(120643)
MATHEMATICAL_BOLD_ITALIC_SMALL_OMICRON = chr(120644)
MATHEMATICAL_BOLD_ITALIC_SMALL_PI = chr(120645)
MATHEMATICAL_BOLD_ITALIC_SMALL_RHO = chr(120646)
MATHEMATICAL_BOLD_ITALIC_SMALL_FINAL_SIGMA = chr(120647)
MATHEMATICAL_BOLD_ITALIC_SMALL_SIGMA = chr(120648)
MATHEMATICAL_BOLD_ITALIC_SMALL_TAU = chr(120649)
MATHEMATICAL_BOLD_ITALIC_SMALL_UPSILON = chr(120650)
MATHEMATICAL_BOLD_ITALIC_SMALL_PHI = chr(120651)
MATHEMATICAL_BOLD_ITALIC_SMALL_CHI = chr(120652)
MATHEMATICAL_BOLD_ITALIC_SMALL_PSI = chr(120653)
MATHEMATICAL_BOLD_ITALIC_SMALL_OMEGA = chr(120654)
MATHEMATICAL_BOLD_ITALIC_PARTIAL_DIFFERENTIAL = chr(120655)
MATHEMATICAL_BOLD_ITALIC_EPSILON_SYMBOL = chr(120656)
MATHEMATICAL_BOLD_ITALIC_THETA_SYMBOL = chr(120657)
MATHEMATICAL_BOLD_ITALIC_KAPPA_SYMBOL = chr(120658)
MATHEMATICAL_BOLD_ITALIC_PHI_SYMBOL = chr(120659)
MATHEMATICAL_BOLD_ITALIC_RHO_SYMBOL = chr(120660)
MATHEMATICAL_BOLD_ITALIC_PI_SYMBOL = chr(120661)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_ALPHA = chr(120662)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_BETA = chr(120663)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_GAMMA = chr(120664)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_DELTA = chr(120665)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_EPSILON = chr(120666)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_ZETA = chr(120667)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_ETA = chr(120668)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_THETA = chr(120669)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_IOTA = chr(120670)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_KAPPA = chr(120671)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_LAMDA = chr(120672)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_MU = chr(120673)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_NU = chr(120674)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_XI = chr(120675)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_OMICRON = chr(120676)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_PI = chr(120677)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_RHO = chr(120678)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_THETA_SYMBOL = chr(120679)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_SIGMA = chr(120680)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_TAU = chr(120681)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_UPSILON = chr(120682)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_PHI = chr(120683)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_CHI = chr(120684)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_PSI = chr(120685)
MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_OMEGA = chr(120686)
MATHEMATICAL_SANS_SERIF_BOLD_NABLA = chr(120687)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_ALPHA = chr(120688)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_BETA = chr(120689)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_GAMMA = chr(120690)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_DELTA = chr(120691)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_EPSILON = chr(120692)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_ZETA = chr(120693)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_ETA = chr(120694)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_THETA = chr(120695)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_IOTA = chr(120696)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_KAPPA = chr(120697)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_LAMDA = chr(120698)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_MU = chr(120699)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_NU = chr(120700)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_XI = chr(120701)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_OMICRON = chr(120702)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_PI = chr(120703)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_RHO = chr(120704)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_FINAL_SIGMA = chr(120705)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_SIGMA = chr(120706)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_TAU = chr(120707)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_UPSILON = chr(120708)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_PHI = chr(120709)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_CHI = chr(120710)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_PSI = chr(120711)
MATHEMATICAL_SANS_SERIF_BOLD_SMALL_OMEGA = chr(120712)
MATHEMATICAL_SANS_SERIF_BOLD_PARTIAL_DIFFERENTIAL = chr(120713)
MATHEMATICAL_SANS_SERIF_BOLD_EPSILON_SYMBOL = chr(120714)
MATHEMATICAL_SANS_SERIF_BOLD_THETA_SYMBOL = chr(120715)
MATHEMATICAL_SANS_SERIF_BOLD_KAPPA_SYMBOL = chr(120716)
MATHEMATICAL_SANS_SERIF_BOLD_PHI_SYMBOL = chr(120717)
MATHEMATICAL_SANS_SERIF_BOLD_RHO_SYMBOL = chr(120718)
MATHEMATICAL_SANS_SERIF_BOLD_PI_SYMBOL = chr(120719)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_ALPHA = chr(120720)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_BETA = chr(120721)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_GAMMA = chr(120722)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_DELTA = chr(120723)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_EPSILON = chr(120724)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_ZETA = chr(120725)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_ETA = chr(120726)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_THETA = chr(120727)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_IOTA = chr(120728)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_KAPPA = chr(120729)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_LAMDA = chr(120730)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_MU = chr(120731)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_NU = chr(120732)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_XI = chr(120733)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_OMICRON = chr(120734)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_PI = chr(120735)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_RHO = chr(120736)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_THETA_SYMBOL = chr(120737)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_SIGMA = chr(120738)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_TAU = chr(120739)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_UPSILON = chr(120740)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_PHI = chr(120741)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_CHI = chr(120742)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_PSI = chr(120743)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_OMEGA = chr(120744)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_NABLA = chr(120745)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_ALPHA = chr(120746)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_BETA = chr(120747)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_GAMMA = chr(120748)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_DELTA = chr(120749)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_EPSILON = chr(120750)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_ZETA = chr(120751)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_ETA = chr(120752)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_THETA = chr(120753)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_IOTA = chr(120754)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_KAPPA = chr(120755)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_LAMDA = chr(120756)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_MU = chr(120757)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_NU = chr(120758)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_XI = chr(120759)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_OMICRON = chr(120760)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_PI = chr(120761)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_RHO = chr(120762)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_FINAL_SIGMA = chr(120763)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_SIGMA = chr(120764)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_TAU = chr(120765)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_UPSILON = chr(120766)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_PHI = chr(120767)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_CHI = chr(120768)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_PSI = chr(120769)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_OMEGA = chr(120770)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_PARTIAL_DIFFERENTIAL = chr(120771)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_EPSILON_SYMBOL = chr(120772)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_THETA_SYMBOL = chr(120773)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_KAPPA_SYMBOL = chr(120774)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_PHI_SYMBOL = chr(120775)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_RHO_SYMBOL = chr(120776)
MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_PI_SYMBOL = chr(120777)
MATHEMATICAL_BOLD_CAPITAL_DIGAMMA = chr(120778)
MATHEMATICAL_BOLD_SMALL_DIGAMMA = chr(120779)
MATHEMATICAL_BOLD_DIGIT_ZERO = chr(120782)
MATHEMATICAL_BOLD_DIGIT_ONE = chr(120783)
MATHEMATICAL_BOLD_DIGIT_TWO = chr(120784)
MATHEMATICAL_BOLD_DIGIT_THREE = chr(120785)
MATHEMATICAL_BOLD_DIGIT_FOUR = chr(120786)
MATHEMATICAL_BOLD_DIGIT_FIVE = chr(120787)
MATHEMATICAL_BOLD_DIGIT_SIX = chr(120788)
MATHEMATICAL_BOLD_DIGIT_SEVEN = chr(120789)
MATHEMATICAL_BOLD_DIGIT_EIGHT = chr(120790)
MATHEMATICAL_BOLD_DIGIT_NINE = chr(120791)
MATHEMATICAL_DOUBLE_STRUCK_DIGIT_ZERO = chr(120792)
MATHEMATICAL_DOUBLE_STRUCK_DIGIT_ONE = chr(120793)
MATHEMATICAL_DOUBLE_STRUCK_DIGIT_TWO = chr(120794)
MATHEMATICAL_DOUBLE_STRUCK_DIGIT_THREE = chr(120795)
MATHEMATICAL_DOUBLE_STRUCK_DIGIT_FOUR = chr(120796)
MATHEMATICAL_DOUBLE_STRUCK_DIGIT_FIVE = chr(120797)
MATHEMATICAL_DOUBLE_STRUCK_DIGIT_SIX = chr(120798)
MATHEMATICAL_DOUBLE_STRUCK_DIGIT_SEVEN = chr(120799)
MATHEMATICAL_DOUBLE_STRUCK_DIGIT_EIGHT = chr(120800)
MATHEMATICAL_DOUBLE_STRUCK_DIGIT_NINE = chr(120801)
MATHEMATICAL_SANS_SERIF_DIGIT_ZERO = chr(120802)
MATHEMATICAL_SANS_SERIF_DIGIT_ONE = chr(120803)
MATHEMATICAL_SANS_SERIF_DIGIT_TWO = chr(120804)
MATHEMATICAL_SANS_SERIF_DIGIT_THREE = chr(120805)
MATHEMATICAL_SANS_SERIF_DIGIT_FOUR = chr(120806)
MATHEMATICAL_SANS_SERIF_DIGIT_FIVE = chr(120807)
MATHEMATICAL_SANS_SERIF_DIGIT_SIX = chr(120808)
MATHEMATICAL_SANS_SERIF_DIGIT_SEVEN = chr(120809)
MATHEMATICAL_SANS_SERIF_DIGIT_EIGHT = chr(120810)
MATHEMATICAL_SANS_SERIF_DIGIT_NINE = chr(120811)
MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_ZERO = chr(120812)
MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_ONE = chr(120813)
MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_TWO = chr(120814)
MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_THREE = chr(120815)
MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_FOUR = chr(120816)
MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_FIVE = chr(120817)
MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_SIX = chr(120818)
MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_SEVEN = chr(120819)
MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_EIGHT = chr(120820)
MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_NINE = chr(120821)
MATHEMATICAL_MONOSPACE_DIGIT_ZERO = chr(120822)
MATHEMATICAL_MONOSPACE_DIGIT_ONE = chr(120823)
MATHEMATICAL_MONOSPACE_DIGIT_TWO = chr(120824)
MATHEMATICAL_MONOSPACE_DIGIT_THREE = chr(120825)
MATHEMATICAL_MONOSPACE_DIGIT_FOUR = chr(120826)
MATHEMATICAL_MONOSPACE_DIGIT_FIVE = chr(120827)
MATHEMATICAL_MONOSPACE_DIGIT_SIX = chr(120828)
MATHEMATICAL_MONOSPACE_DIGIT_SEVEN = chr(120829)
MATHEMATICAL_MONOSPACE_DIGIT_EIGHT = chr(120830)
MATHEMATICAL_MONOSPACE_DIGIT_NINE = chr(120831)
SIGNWRITING_HAND_FIST_INDEX = chr(120832)
SIGNWRITING_HAND_CIRCLE_INDEX = chr(120833)
SIGNWRITING_HAND_CUP_INDEX = chr(120834)
SIGNWRITING_HAND_OVAL_INDEX = chr(120835)
SIGNWRITING_HAND_HINGE_INDEX = chr(120836)
SIGNWRITING_HAND_ANGLE_INDEX = chr(120837)
SIGNWRITING_HAND_FIST_INDEX_BENT = chr(120838)
SIGNWRITING_HAND_CIRCLE_INDEX_BENT = chr(120839)
SIGNWRITING_HAND_FIST_THUMB_UNDER_INDEX_BENT = chr(120840)
SIGNWRITING_HAND_FIST_INDEX_RAISED_KNUCKLE = chr(120841)
SIGNWRITING_HAND_FIST_INDEX_CUPPED = chr(120842)
SIGNWRITING_HAND_FIST_INDEX_HINGED = chr(120843)
SIGNWRITING_HAND_FIST_INDEX_HINGED_LOW = chr(120844)
SIGNWRITING_HAND_CIRCLE_INDEX_HINGE = chr(120845)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE = chr(120846)
SIGNWRITING_HAND_CIRCLE_INDEX_MIDDLE = chr(120847)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_BENT = chr(120848)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_RAISED_KNUCKLES = chr(120849)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_HINGED = chr(120850)
SIGNWRITING_HAND_FIST_INDEX_UP_MIDDLE_HINGED = chr(120851)
SIGNWRITING_HAND_FIST_INDEX_HINGED_MIDDLE_UP = chr(120852)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED = chr(120853)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_INDEX_BENT = chr(120854)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_MIDDLE_BENT = chr(120855)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_CUPPED = chr(120856)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_HINGED = chr(120857)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CROSSED = chr(120858)
SIGNWRITING_HAND_CIRCLE_INDEX_MIDDLE_CROSSED = chr(120859)
SIGNWRITING_HAND_FIST_MIDDLE_BENT_OVER_INDEX = chr(120860)
SIGNWRITING_HAND_FIST_INDEX_BENT_OVER_MIDDLE = chr(120861)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB = chr(120862)
SIGNWRITING_HAND_CIRCLE_INDEX_MIDDLE_THUMB = chr(120863)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_STRAIGHT_THUMB_BENT = chr(120864)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_BENT_THUMB_STRAIGHT = chr(120865)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_BENT = chr(120866)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_HINGED_SPREAD_THUMB_SIDE = chr(120867)
SIGNWRITING_HAND_FIST_INDEX_UP_MIDDLE_HINGED_THUMB_SIDE = chr(120868)
SIGNWRITING_HAND_FIST_INDEX_UP_MIDDLE_HINGED_THUMB_CONJOINED = chr(120869)
SIGNWRITING_HAND_FIST_INDEX_HINGED_MIDDLE_UP_THUMB_SIDE = chr(120870)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_UP_SPREAD_THUMB_FORWARD = chr(120871)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_CUPPED = chr(120872)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_CIRCLED = chr(120873)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_HOOKED = chr(120874)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_HINGED = chr(120875)
SIGNWRITING_HAND_FIST_THUMB_BETWEEN_INDEX_MIDDLE_STRAIGHT = chr(120876)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_THUMB_SIDE = chr(120877)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_THUMB_SIDE_CONJOINED = chr(120878)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_THUMB_SIDE_BENT = chr(120879)
SIGNWRITING_HAND_FIST_MIDDLE_THUMB_HOOKED_INDEX_UP = chr(120880)
SIGNWRITING_HAND_FIST_INDEX_THUMB_HOOKED_MIDDLE_UP = chr(120881)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_HINGED_THUMB_SIDE = chr(120882)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CROSSED_THUMB_SIDE = chr(120883)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_THUMB_FORWARD = chr(120884)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_CUPPED_THUMB_FORWARD = chr(120885)
SIGNWRITING_HAND_FIST_MIDDLE_THUMB_CUPPED_INDEX_UP = chr(120886)
SIGNWRITING_HAND_FIST_INDEX_THUMB_CUPPED_MIDDLE_UP = chr(120887)
SIGNWRITING_HAND_FIST_MIDDLE_THUMB_CIRCLED_INDEX_UP = chr(120888)
SIGNWRITING_HAND_FIST_MIDDLE_THUMB_CIRCLED_INDEX_HINGED = chr(120889)
SIGNWRITING_HAND_FIST_INDEX_THUMB_ANGLED_OUT_MIDDLE_UP = chr(120890)
SIGNWRITING_HAND_FIST_INDEX_THUMB_ANGLED_IN_MIDDLE_UP = chr(120891)
SIGNWRITING_HAND_FIST_INDEX_THUMB_CIRCLED_MIDDLE_UP = chr(120892)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_CONJOINED_HINGED = chr(120893)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_ANGLED_OUT = chr(120894)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_ANGLED = chr(120895)
SIGNWRITING_HAND_FIST_MIDDLE_THUMB_ANGLED_OUT_INDEX_UP = chr(120896)
SIGNWRITING_HAND_FIST_MIDDLE_THUMB_ANGLED_OUT_INDEX_CROSSED = chr(120897)
SIGNWRITING_HAND_FIST_MIDDLE_THUMB_ANGLED_INDEX_UP = chr(120898)
SIGNWRITING_HAND_FIST_INDEX_THUMB_HOOKED_MIDDLE_HINGED = chr(120899)
SIGNWRITING_HAND_FLAT_FOUR_FINGERS = chr(120900)
SIGNWRITING_HAND_FLAT_FOUR_FINGERS_BENT = chr(120901)
SIGNWRITING_HAND_FLAT_FOUR_FINGERS_HINGED = chr(120902)
SIGNWRITING_HAND_FLAT_FOUR_FINGERS_CONJOINED = chr(120903)
SIGNWRITING_HAND_FLAT_FOUR_FINGERS_CONJOINED_SPLIT = chr(120904)
SIGNWRITING_HAND_CLAW_FOUR_FINGERS_CONJOINED = chr(120905)
SIGNWRITING_HAND_FIST_FOUR_FINGERS_CONJOINED_BENT = chr(120906)
SIGNWRITING_HAND_HINGE_FOUR_FINGERS_CONJOINED = chr(120907)
SIGNWRITING_HAND_FLAT_FIVE_FINGERS_SPREAD = chr(120908)
SIGNWRITING_HAND_FLAT_HEEL_FIVE_FINGERS_SPREAD = chr(120909)
SIGNWRITING_HAND_FLAT_FIVE_FINGERS_SPREAD_FOUR_BENT = chr(120910)
SIGNWRITING_HAND_FLAT_HEEL_FIVE_FINGERS_SPREAD_FOUR_BENT = chr(120911)
SIGNWRITING_HAND_FLAT_FIVE_FINGERS_SPREAD_BENT = chr(120912)
SIGNWRITING_HAND_FLAT_HEEL_FIVE_FINGERS_SPREAD_BENT = chr(120913)
SIGNWRITING_HAND_FLAT_FIVE_FINGERS_SPREAD_THUMB_FORWARD = chr(120914)
SIGNWRITING_HAND_CUP_FIVE_FINGERS_SPREAD = chr(120915)
SIGNWRITING_HAND_CUP_FIVE_FINGERS_SPREAD_OPEN = chr(120916)
SIGNWRITING_HAND_HINGE_FIVE_FINGERS_SPREAD_OPEN = chr(120917)
SIGNWRITING_HAND_OVAL_FIVE_FINGERS_SPREAD = chr(120918)
SIGNWRITING_HAND_FLAT_FIVE_FINGERS_SPREAD_HINGED = chr(120919)
SIGNWRITING_HAND_FLAT_FIVE_FINGERS_SPREAD_HINGED_THUMB_SIDE = chr(120920)
SIGNWRITING_HAND_FLAT_FIVE_FINGERS_SPREAD_HINGED_NO_THUMB = chr(120921)
SIGNWRITING_HAND_FLAT = chr(120922)
SIGNWRITING_HAND_FLAT_BETWEEN_PALM_FACINGS = chr(120923)
SIGNWRITING_HAND_FLAT_HEEL = chr(120924)
SIGNWRITING_HAND_FLAT_THUMB_SIDE = chr(120925)
SIGNWRITING_HAND_FLAT_HEEL_THUMB_SIDE = chr(120926)
SIGNWRITING_HAND_FLAT_THUMB_BENT = chr(120927)
SIGNWRITING_HAND_FLAT_THUMB_FORWARD = chr(120928)
SIGNWRITING_HAND_FLAT_SPLIT_INDEX_THUMB_SIDE = chr(120929)
SIGNWRITING_HAND_FLAT_SPLIT_CENTRE = chr(120930)
SIGNWRITING_HAND_FLAT_SPLIT_CENTRE_THUMB_SIDE = chr(120931)
SIGNWRITING_HAND_FLAT_SPLIT_CENTRE_THUMB_SIDE_BENT = chr(120932)
SIGNWRITING_HAND_FLAT_SPLIT_LITTLE = chr(120933)
SIGNWRITING_HAND_CLAW = chr(120934)
SIGNWRITING_HAND_CLAW_THUMB_SIDE = chr(120935)
SIGNWRITING_HAND_CLAW_NO_THUMB = chr(120936)
SIGNWRITING_HAND_CLAW_THUMB_FORWARD = chr(120937)
SIGNWRITING_HAND_HOOK_CURLICUE = chr(120938)
SIGNWRITING_HAND_HOOK = chr(120939)
SIGNWRITING_HAND_CUP_OPEN = chr(120940)
SIGNWRITING_HAND_CUP = chr(120941)
SIGNWRITING_HAND_CUP_OPEN_THUMB_SIDE = chr(120942)
SIGNWRITING_HAND_CUP_THUMB_SIDE = chr(120943)
SIGNWRITING_HAND_CUP_OPEN_NO_THUMB = chr(120944)
SIGNWRITING_HAND_CUP_NO_THUMB = chr(120945)
SIGNWRITING_HAND_CUP_OPEN_THUMB_FORWARD = chr(120946)
SIGNWRITING_HAND_CUP_THUMB_FORWARD = chr(120947)
SIGNWRITING_HAND_CURLICUE_OPEN = chr(120948)
SIGNWRITING_HAND_CURLICUE = chr(120949)
SIGNWRITING_HAND_CIRCLE = chr(120950)
SIGNWRITING_HAND_OVAL = chr(120951)
SIGNWRITING_HAND_OVAL_THUMB_SIDE = chr(120952)
SIGNWRITING_HAND_OVAL_NO_THUMB = chr(120953)
SIGNWRITING_HAND_OVAL_THUMB_FORWARD = chr(120954)
SIGNWRITING_HAND_HINGE_OPEN = chr(120955)
SIGNWRITING_HAND_HINGE_OPEN_THUMB_FORWARD = chr(120956)
SIGNWRITING_HAND_HINGE = chr(120957)
SIGNWRITING_HAND_HINGE_SMALL = chr(120958)
SIGNWRITING_HAND_HINGE_OPEN_THUMB_SIDE = chr(120959)
SIGNWRITING_HAND_HINGE_THUMB_SIDE = chr(120960)
SIGNWRITING_HAND_HINGE_OPEN_NO_THUMB = chr(120961)
SIGNWRITING_HAND_HINGE_NO_THUMB = chr(120962)
SIGNWRITING_HAND_HINGE_THUMB_SIDE_TOUCHING_INDEX = chr(120963)
SIGNWRITING_HAND_HINGE_THUMB_BETWEEN_MIDDLE_RING = chr(120964)
SIGNWRITING_HAND_ANGLE = chr(120965)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_RING = chr(120966)
SIGNWRITING_HAND_CIRCLE_INDEX_MIDDLE_RING = chr(120967)
SIGNWRITING_HAND_HINGE_INDEX_MIDDLE_RING = chr(120968)
SIGNWRITING_HAND_ANGLE_INDEX_MIDDLE_RING = chr(120969)
SIGNWRITING_HAND_HINGE_LITTLE = chr(120970)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_RING_BENT = chr(120971)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_RING_CONJOINED = chr(120972)
SIGNWRITING_HAND_HINGE_INDEX_MIDDLE_RING_CONJOINED = chr(120973)
SIGNWRITING_HAND_FIST_LITTLE_DOWN = chr(120974)
SIGNWRITING_HAND_FIST_LITTLE_DOWN_RIPPLE_STRAIGHT = chr(120975)
SIGNWRITING_HAND_FIST_LITTLE_DOWN_RIPPLE_CURVED = chr(120976)
SIGNWRITING_HAND_FIST_LITTLE_DOWN_OTHERS_CIRCLED = chr(120977)
SIGNWRITING_HAND_FIST_LITTLE_UP = chr(120978)
SIGNWRITING_HAND_FIST_THUMB_UNDER_LITTLE_UP = chr(120979)
SIGNWRITING_HAND_CIRCLE_LITTLE_UP = chr(120980)
SIGNWRITING_HAND_OVAL_LITTLE_UP = chr(120981)
SIGNWRITING_HAND_ANGLE_LITTLE_UP = chr(120982)
SIGNWRITING_HAND_FIST_LITTLE_RAISED_KNUCKLE = chr(120983)
SIGNWRITING_HAND_FIST_LITTLE_BENT = chr(120984)
SIGNWRITING_HAND_FIST_LITTLE_TOUCHES_THUMB = chr(120985)
SIGNWRITING_HAND_FIST_LITTLE_THUMB = chr(120986)
SIGNWRITING_HAND_HINGE_LITTLE_THUMB = chr(120987)
SIGNWRITING_HAND_FIST_LITTLE_INDEX_THUMB = chr(120988)
SIGNWRITING_HAND_HINGE_LITTLE_INDEX_THUMB = chr(120989)
SIGNWRITING_HAND_ANGLE_LITTLE_INDEX_THUMB_INDEX_THUMB_OUT = chr(120990)
SIGNWRITING_HAND_ANGLE_LITTLE_INDEX_THUMB_INDEX_THUMB = chr(120991)
SIGNWRITING_HAND_FIST_LITTLE_INDEX = chr(120992)
SIGNWRITING_HAND_CIRCLE_LITTLE_INDEX = chr(120993)
SIGNWRITING_HAND_HINGE_LITTLE_INDEX = chr(120994)
SIGNWRITING_HAND_ANGLE_LITTLE_INDEX = chr(120995)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_LITTLE = chr(120996)
SIGNWRITING_HAND_CIRCLE_INDEX_MIDDLE_LITTLE = chr(120997)
SIGNWRITING_HAND_HINGE_INDEX_MIDDLE_LITTLE = chr(120998)
SIGNWRITING_HAND_HINGE_RING = chr(120999)
SIGNWRITING_HAND_ANGLE_INDEX_MIDDLE_LITTLE = chr(121000)
SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CROSS_LITTLE = chr(121001)
SIGNWRITING_HAND_CIRCLE_INDEX_MIDDLE_CROSS_LITTLE = chr(121002)
SIGNWRITING_HAND_FIST_RING_DOWN = chr(121003)
SIGNWRITING_HAND_HINGE_RING_DOWN_INDEX_THUMB_HOOK_MIDDLE = chr(121004)
SIGNWRITING_HAND_ANGLE_RING_DOWN_MIDDLE_THUMB_INDEX_CROSS = chr(121005)
SIGNWRITING_HAND_FIST_RING_UP = chr(121006)
SIGNWRITING_HAND_FIST_RING_RAISED_KNUCKLE = chr(121007)
SIGNWRITING_HAND_FIST_RING_LITTLE = chr(121008)
SIGNWRITING_HAND_CIRCLE_RING_LITTLE = chr(121009)
SIGNWRITING_HAND_OVAL_RING_LITTLE = chr(121010)
SIGNWRITING_HAND_ANGLE_RING_LITTLE = chr(121011)
SIGNWRITING_HAND_FIST_RING_MIDDLE = chr(121012)
SIGNWRITING_HAND_FIST_RING_MIDDLE_CONJOINED = chr(121013)
SIGNWRITING_HAND_FIST_RING_MIDDLE_RAISED_KNUCKLES = chr(121014)
SIGNWRITING_HAND_FIST_RING_INDEX = chr(121015)
SIGNWRITING_HAND_FIST_RING_THUMB = chr(121016)
SIGNWRITING_HAND_HOOK_RING_THUMB = chr(121017)
SIGNWRITING_HAND_FIST_INDEX_RING_LITTLE = chr(121018)
SIGNWRITING_HAND_CIRCLE_INDEX_RING_LITTLE = chr(121019)
SIGNWRITING_HAND_CURLICUE_INDEX_RING_LITTLE_ON = chr(121020)
SIGNWRITING_HAND_HOOK_INDEX_RING_LITTLE_OUT = chr(121021)
SIGNWRITING_HAND_HOOK_INDEX_RING_LITTLE_IN = chr(121022)
SIGNWRITING_HAND_HOOK_INDEX_RING_LITTLE_UNDER = chr(121023)
SIGNWRITING_HAND_CUP_INDEX_RING_LITTLE = chr(121024)
SIGNWRITING_HAND_HINGE_INDEX_RING_LITTLE = chr(121025)
SIGNWRITING_HAND_ANGLE_INDEX_RING_LITTLE_OUT = chr(121026)
SIGNWRITING_HAND_ANGLE_INDEX_RING_LITTLE = chr(121027)
SIGNWRITING_HAND_FIST_MIDDLE_DOWN = chr(121028)
SIGNWRITING_HAND_HINGE_MIDDLE = chr(121029)
SIGNWRITING_HAND_FIST_MIDDLE_UP = chr(121030)
SIGNWRITING_HAND_CIRCLE_MIDDLE_UP = chr(121031)
SIGNWRITING_HAND_FIST_MIDDLE_RAISED_KNUCKLE = chr(121032)
SIGNWRITING_HAND_FIST_MIDDLE_UP_THUMB_SIDE = chr(121033)
SIGNWRITING_HAND_HOOK_MIDDLE_THUMB = chr(121034)
SIGNWRITING_HAND_FIST_MIDDLE_THUMB_LITTLE = chr(121035)
SIGNWRITING_HAND_FIST_MIDDLE_LITTLE = chr(121036)
SIGNWRITING_HAND_FIST_MIDDLE_RING_LITTLE = chr(121037)
SIGNWRITING_HAND_CIRCLE_MIDDLE_RING_LITTLE = chr(121038)
SIGNWRITING_HAND_CURLICUE_MIDDLE_RING_LITTLE_ON = chr(121039)
SIGNWRITING_HAND_CUP_MIDDLE_RING_LITTLE = chr(121040)
SIGNWRITING_HAND_HINGE_MIDDLE_RING_LITTLE = chr(121041)
SIGNWRITING_HAND_ANGLE_MIDDLE_RING_LITTLE_OUT = chr(121042)
SIGNWRITING_HAND_ANGLE_MIDDLE_RING_LITTLE_IN = chr(121043)
SIGNWRITING_HAND_ANGLE_MIDDLE_RING_LITTLE = chr(121044)
SIGNWRITING_HAND_CIRCLE_MIDDLE_RING_LITTLE_BENT = chr(121045)
SIGNWRITING_HAND_CLAW_MIDDLE_RING_LITTLE_CONJOINED = chr(121046)
SIGNWRITING_HAND_CLAW_MIDDLE_RING_LITTLE_CONJOINED_SIDE = chr(121047)
SIGNWRITING_HAND_HOOK_MIDDLE_RING_LITTLE_CONJOINED_OUT = chr(121048)
SIGNWRITING_HAND_HOOK_MIDDLE_RING_LITTLE_CONJOINED_IN = chr(121049)
SIGNWRITING_HAND_HOOK_MIDDLE_RING_LITTLE_CONJOINED = chr(121050)
SIGNWRITING_HAND_HINGE_INDEX_HINGED = chr(121051)
SIGNWRITING_HAND_FIST_INDEX_THUMB_SIDE = chr(121052)
SIGNWRITING_HAND_HINGE_INDEX_THUMB_SIDE = chr(121053)
SIGNWRITING_HAND_FIST_INDEX_THUMB_SIDE_THUMB_DIAGONAL = chr(121054)
SIGNWRITING_HAND_FIST_INDEX_THUMB_SIDE_THUMB_CONJOINED = chr(121055)
SIGNWRITING_HAND_FIST_INDEX_THUMB_SIDE_THUMB_BENT = chr(121056)
SIGNWRITING_HAND_FIST_INDEX_THUMB_SIDE_INDEX_BENT = chr(121057)
SIGNWRITING_HAND_FIST_INDEX_THUMB_SIDE_BOTH_BENT = chr(121058)
SIGNWRITING_HAND_FIST_INDEX_THUMB_SIDE_INDEX_HINGE = chr(121059)
SIGNWRITING_HAND_FIST_INDEX_THUMB_FORWARD_INDEX_STRAIGHT = chr(121060)
SIGNWRITING_HAND_FIST_INDEX_THUMB_FORWARD_INDEX_BENT = chr(121061)
SIGNWRITING_HAND_FIST_INDEX_THUMB_HOOK = chr(121062)
SIGNWRITING_HAND_FIST_INDEX_THUMB_CURLICUE = chr(121063)
SIGNWRITING_HAND_FIST_INDEX_THUMB_CURVE_THUMB_INSIDE = chr(121064)
SIGNWRITING_HAND_CLAW_INDEX_THUMB_CURVE_THUMB_INSIDE = chr(121065)
SIGNWRITING_HAND_FIST_INDEX_THUMB_CURVE_THUMB_UNDER = chr(121066)
SIGNWRITING_HAND_FIST_INDEX_THUMB_CIRCLE = chr(121067)
SIGNWRITING_HAND_CUP_INDEX_THUMB = chr(121068)
SIGNWRITING_HAND_CUP_INDEX_THUMB_OPEN = chr(121069)
SIGNWRITING_HAND_HINGE_INDEX_THUMB_OPEN = chr(121070)
SIGNWRITING_HAND_HINGE_INDEX_THUMB_LARGE = chr(121071)
SIGNWRITING_HAND_HINGE_INDEX_THUMB = chr(121072)
SIGNWRITING_HAND_HINGE_INDEX_THUMB_SMALL = chr(121073)
SIGNWRITING_HAND_ANGLE_INDEX_THUMB_OUT = chr(121074)
SIGNWRITING_HAND_ANGLE_INDEX_THUMB_IN = chr(121075)
SIGNWRITING_HAND_ANGLE_INDEX_THUMB = chr(121076)
SIGNWRITING_HAND_FIST_THUMB = chr(121077)
SIGNWRITING_HAND_FIST_THUMB_HEEL = chr(121078)
SIGNWRITING_HAND_FIST_THUMB_SIDE_DIAGONAL = chr(121079)
SIGNWRITING_HAND_FIST_THUMB_SIDE_CONJOINED = chr(121080)
SIGNWRITING_HAND_FIST_THUMB_SIDE_BENT = chr(121081)
SIGNWRITING_HAND_FIST_THUMB_FORWARD = chr(121082)
SIGNWRITING_HAND_FIST_THUMB_BETWEEN_INDEX_MIDDLE = chr(121083)
SIGNWRITING_HAND_FIST_THUMB_BETWEEN_MIDDLE_RING = chr(121084)
SIGNWRITING_HAND_FIST_THUMB_BETWEEN_RING_LITTLE = chr(121085)
SIGNWRITING_HAND_FIST_THUMB_UNDER_TWO_FINGERS = chr(121086)
SIGNWRITING_HAND_FIST_THUMB_OVER_TWO_FINGERS = chr(121087)
SIGNWRITING_HAND_FIST_THUMB_UNDER_THREE_FINGERS = chr(121088)
SIGNWRITING_HAND_FIST_THUMB_UNDER_FOUR_FINGERS = chr(121089)
SIGNWRITING_HAND_FIST_THUMB_OVER_FOUR_RAISED_KNUCKLES = chr(121090)
SIGNWRITING_HAND_FIST = chr(121091)
SIGNWRITING_HAND_FIST_HEEL = chr(121092)
SIGNWRITING_TOUCH_SINGLE = chr(121093)
SIGNWRITING_TOUCH_MULTIPLE = chr(121094)
SIGNWRITING_TOUCH_BETWEEN = chr(121095)
SIGNWRITING_GRASP_SINGLE = chr(121096)
SIGNWRITING_GRASP_MULTIPLE = chr(121097)
SIGNWRITING_GRASP_BETWEEN = chr(121098)
SIGNWRITING_STRIKE_SINGLE = chr(121099)
SIGNWRITING_STRIKE_MULTIPLE = chr(121100)
SIGNWRITING_STRIKE_BETWEEN = chr(121101)
SIGNWRITING_BRUSH_SINGLE = chr(121102)
SIGNWRITING_BRUSH_MULTIPLE = chr(121103)
SIGNWRITING_BRUSH_BETWEEN = chr(121104)
SIGNWRITING_RUB_SINGLE = chr(121105)
SIGNWRITING_RUB_MULTIPLE = chr(121106)
SIGNWRITING_RUB_BETWEEN = chr(121107)
SIGNWRITING_SURFACE_SYMBOLS = chr(121108)
SIGNWRITING_SURFACE_BETWEEN = chr(121109)
SIGNWRITING_SQUEEZE_LARGE_SINGLE = chr(121110)
SIGNWRITING_SQUEEZE_SMALL_SINGLE = chr(121111)
SIGNWRITING_SQUEEZE_LARGE_MULTIPLE = chr(121112)
SIGNWRITING_SQUEEZE_SMALL_MULTIPLE = chr(121113)
SIGNWRITING_SQUEEZE_SEQUENTIAL = chr(121114)
SIGNWRITING_FLICK_LARGE_SINGLE = chr(121115)
SIGNWRITING_FLICK_SMALL_SINGLE = chr(121116)
SIGNWRITING_FLICK_LARGE_MULTIPLE = chr(121117)
SIGNWRITING_FLICK_SMALL_MULTIPLE = chr(121118)
SIGNWRITING_FLICK_SEQUENTIAL = chr(121119)
SIGNWRITING_SQUEEZE_FLICK_ALTERNATING = chr(121120)
SIGNWRITING_MOVEMENT_HINGE_UP_DOWN_LARGE = chr(121121)
SIGNWRITING_MOVEMENT_HINGE_UP_DOWN_SMALL = chr(121122)
SIGNWRITING_MOVEMENT_HINGE_UP_SEQUENTIAL = chr(121123)
SIGNWRITING_MOVEMENT_HINGE_DOWN_SEQUENTIAL = chr(121124)
SIGNWRITING_MOVEMENT_HINGE_UP_DOWN_ALTERNATING_LARGE = chr(121125)
SIGNWRITING_MOVEMENT_HINGE_UP_DOWN_ALTERNATING_SMALL = chr(121126)
SIGNWRITING_MOVEMENT_HINGE_SIDE_TO_SIDE_SCISSORS = chr(121127)
SIGNWRITING_MOVEMENT_WALLPLANE_FINGER_CONTACT = chr(121128)
SIGNWRITING_MOVEMENT_FLOORPLANE_FINGER_CONTACT = chr(121129)
SIGNWRITING_MOVEMENT_WALLPLANE_SINGLE_STRAIGHT_SMALL = chr(121130)
SIGNWRITING_MOVEMENT_WALLPLANE_SINGLE_STRAIGHT_MEDIUM = chr(121131)
SIGNWRITING_MOVEMENT_WALLPLANE_SINGLE_STRAIGHT_LARGE = chr(121132)
SIGNWRITING_MOVEMENT_WALLPLANE_SINGLE_STRAIGHT_LARGEST = chr(121133)
SIGNWRITING_MOVEMENT_WALLPLANE_SINGLE_WRIST_FLEX = chr(121134)
SIGNWRITING_MOVEMENT_WALLPLANE_DOUBLE_STRAIGHT = chr(121135)
SIGNWRITING_MOVEMENT_WALLPLANE_DOUBLE_WRIST_FLEX = chr(121136)
SIGNWRITING_MOVEMENT_WALLPLANE_DOUBLE_ALTERNATING = chr(121137)
SIGNWRITING_MOVEMENT_WALLPLANE_DOUBLE_ALTERNATING_WRIST_FLEX = chr(121138)
SIGNWRITING_MOVEMENT_WALLPLANE_CROSS = chr(121139)
SIGNWRITING_MOVEMENT_WALLPLANE_TRIPLE_STRAIGHT_MOVEMENT = chr(121140)
SIGNWRITING_MOVEMENT_WALLPLANE_TRIPLE_WRIST_FLEX = chr(121141)
SIGNWRITING_MOVEMENT_WALLPLANE_TRIPLE_ALTERNATING = chr(121142)
SIGNWRITING_MOVEMENT_WALLPLANE_TRIPLE_ALTERNATING_WRIST_FLEX = chr(121143)
SIGNWRITING_MOVEMENT_WALLPLANE_BEND_SMALL = chr(121144)
SIGNWRITING_MOVEMENT_WALLPLANE_BEND_MEDIUM = chr(121145)
SIGNWRITING_MOVEMENT_WALLPLANE_BEND_LARGE = chr(121146)
SIGNWRITING_MOVEMENT_WALLPLANE_CORNER_SMALL = chr(121147)
SIGNWRITING_MOVEMENT_WALLPLANE_CORNER_MEDIUM = chr(121148)
SIGNWRITING_MOVEMENT_WALLPLANE_CORNER_LARGE = chr(121149)
SIGNWRITING_MOVEMENT_WALLPLANE_CORNER_ROTATION = chr(121150)
SIGNWRITING_MOVEMENT_WALLPLANE_CHECK_SMALL = chr(121151)
SIGNWRITING_MOVEMENT_WALLPLANE_CHECK_MEDIUM = chr(121152)
SIGNWRITING_MOVEMENT_WALLPLANE_CHECK_LARGE = chr(121153)
SIGNWRITING_MOVEMENT_WALLPLANE_BOX_SMALL = chr(121154)
SIGNWRITING_MOVEMENT_WALLPLANE_BOX_MEDIUM = chr(121155)
SIGNWRITING_MOVEMENT_WALLPLANE_BOX_LARGE = chr(121156)
SIGNWRITING_MOVEMENT_WALLPLANE_ZIGZAG_SMALL = chr(121157)
SIGNWRITING_MOVEMENT_WALLPLANE_ZIGZAG_MEDIUM = chr(121158)
SIGNWRITING_MOVEMENT_WALLPLANE_ZIGZAG_LARGE = chr(121159)
SIGNWRITING_MOVEMENT_WALLPLANE_PEAKS_SMALL = chr(121160)
SIGNWRITING_MOVEMENT_WALLPLANE_PEAKS_MEDIUM = chr(121161)
SIGNWRITING_MOVEMENT_WALLPLANE_PEAKS_LARGE = chr(121162)
SIGNWRITING_TRAVEL_WALLPLANE_ROTATION_WALLPLANE_SINGLE = chr(121163)
SIGNWRITING_TRAVEL_WALLPLANE_ROTATION_WALLPLANE_DOUBLE = chr(121164)
SIGNWRITING_TRAVEL_WALLPLANE_ROTATION_WALLPLANE_ALTERNATING = chr(121165)
SIGNWRITING_TRAVEL_WALLPLANE_ROTATION_FLOORPLANE_SINGLE = chr(121166)
SIGNWRITING_TRAVEL_WALLPLANE_ROTATION_FLOORPLANE_DOUBLE = chr(121167)
SIGNWRITING_TRAVEL_WALLPLANE_ROTATION_FLOORPLANE_ALTERNATING = chr(121168)
SIGNWRITING_TRAVEL_WALLPLANE_SHAKING = chr(121169)
SIGNWRITING_TRAVEL_WALLPLANE_ARM_SPIRAL_SINGLE = chr(121170)
SIGNWRITING_TRAVEL_WALLPLANE_ARM_SPIRAL_DOUBLE = chr(121171)
SIGNWRITING_TRAVEL_WALLPLANE_ARM_SPIRAL_TRIPLE = chr(121172)
SIGNWRITING_MOVEMENT_DIAGONAL_AWAY_SMALL = chr(121173)
SIGNWRITING_MOVEMENT_DIAGONAL_AWAY_MEDIUM = chr(121174)
SIGNWRITING_MOVEMENT_DIAGONAL_AWAY_LARGE = chr(121175)
SIGNWRITING_MOVEMENT_DIAGONAL_AWAY_LARGEST = chr(121176)
SIGNWRITING_MOVEMENT_DIAGONAL_TOWARDS_SMALL = chr(121177)
SIGNWRITING_MOVEMENT_DIAGONAL_TOWARDS_MEDIUM = chr(121178)
SIGNWRITING_MOVEMENT_DIAGONAL_TOWARDS_LARGE = chr(121179)
SIGNWRITING_MOVEMENT_DIAGONAL_TOWARDS_LARGEST = chr(121180)
SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_AWAY_SMALL = chr(121181)
SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_AWAY_MEDIUM = chr(121182)
SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_AWAY_LARGE = chr(121183)
SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_AWAY_LARGEST = chr(121184)
SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_TOWARDS_SMALL = chr(121185)
SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_TOWARDS_MEDIUM = chr(121186)
SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_TOWARDS_LARGE = chr(121187)
SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_TOWARDS_LARGEST = chr(121188)
SIGNWRITING_MOVEMENT_FLOORPLANE_SINGLE_STRAIGHT_SMALL = chr(121189)
SIGNWRITING_MOVEMENT_FLOORPLANE_SINGLE_STRAIGHT_MEDIUM = chr(121190)
SIGNWRITING_MOVEMENT_FLOORPLANE_SINGLE_STRAIGHT_LARGE = chr(121191)
SIGNWRITING_MOVEMENT_FLOORPLANE_SINGLE_STRAIGHT_LARGEST = chr(121192)
SIGNWRITING_MOVEMENT_FLOORPLANE_SINGLE_WRIST_FLEX = chr(121193)
SIGNWRITING_MOVEMENT_FLOORPLANE_DOUBLE_STRAIGHT = chr(121194)
SIGNWRITING_MOVEMENT_FLOORPLANE_DOUBLE_WRIST_FLEX = chr(121195)
SIGNWRITING_MOVEMENT_FLOORPLANE_DOUBLE_ALTERNATING = chr(121196)
SIGNWRITING_MOVEMENT_FLOORPLANE_DOUBLE_ALTERNATING_WRIST_FLEX = chr(121197)
SIGNWRITING_MOVEMENT_FLOORPLANE_CROSS = chr(121198)
SIGNWRITING_MOVEMENT_FLOORPLANE_TRIPLE_STRAIGHT_MOVEMENT = chr(121199)
SIGNWRITING_MOVEMENT_FLOORPLANE_TRIPLE_WRIST_FLEX = chr(121200)
SIGNWRITING_MOVEMENT_FLOORPLANE_TRIPLE_ALTERNATING_MOVEMENT = chr(121201)
SIGNWRITING_MOVEMENT_FLOORPLANE_TRIPLE_ALTERNATING_WRIST_FLEX = chr(121202)
SIGNWRITING_MOVEMENT_FLOORPLANE_BEND = chr(121203)
SIGNWRITING_MOVEMENT_FLOORPLANE_CORNER_SMALL = chr(121204)
SIGNWRITING_MOVEMENT_FLOORPLANE_CORNER_MEDIUM = chr(121205)
SIGNWRITING_MOVEMENT_FLOORPLANE_CORNER_LARGE = chr(121206)
SIGNWRITING_MOVEMENT_FLOORPLANE_CHECK = chr(121207)
SIGNWRITING_MOVEMENT_FLOORPLANE_BOX_SMALL = chr(121208)
SIGNWRITING_MOVEMENT_FLOORPLANE_BOX_MEDIUM = chr(121209)
SIGNWRITING_MOVEMENT_FLOORPLANE_BOX_LARGE = chr(121210)
SIGNWRITING_MOVEMENT_FLOORPLANE_ZIGZAG_SMALL = chr(121211)
SIGNWRITING_MOVEMENT_FLOORPLANE_ZIGZAG_MEDIUM = chr(121212)
SIGNWRITING_MOVEMENT_FLOORPLANE_ZIGZAG_LARGE = chr(121213)
SIGNWRITING_MOVEMENT_FLOORPLANE_PEAKS_SMALL = chr(121214)
SIGNWRITING_MOVEMENT_FLOORPLANE_PEAKS_MEDIUM = chr(121215)
SIGNWRITING_MOVEMENT_FLOORPLANE_PEAKS_LARGE = chr(121216)
SIGNWRITING_TRAVEL_FLOORPLANE_ROTATION_FLOORPLANE_SINGLE = chr(121217)
SIGNWRITING_TRAVEL_FLOORPLANE_ROTATION_FLOORPLANE_DOUBLE = chr(121218)
SIGNWRITING_TRAVEL_FLOORPLANE_ROTATION_FLOORPLANE_ALTERNATING = chr(121219)
SIGNWRITING_TRAVEL_FLOORPLANE_ROTATION_WALLPLANE_SINGLE = chr(121220)
SIGNWRITING_TRAVEL_FLOORPLANE_ROTATION_WALLPLANE_DOUBLE = chr(121221)
SIGNWRITING_TRAVEL_FLOORPLANE_ROTATION_WALLPLANE_ALTERNATING = chr(121222)
SIGNWRITING_TRAVEL_FLOORPLANE_SHAKING = chr(121223)
SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_QUARTER_SMALL = chr(121224)
SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_QUARTER_MEDIUM = chr(121225)
SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_QUARTER_LARGE = chr(121226)
SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_QUARTER_LARGEST = chr(121227)
SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_HALF_CIRCLE_SMALL = chr(121228)
SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_HALF_CIRCLE_MEDIUM = chr(121229)
SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_HALF_CIRCLE_LARGE = chr(121230)
SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_HALF_CIRCLE_LARGEST = chr(121231)
SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_THREE_QUARTER_CIRCLE_SMALL = chr(121232)
SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_THREE_QUARTER_CIRCLE_MEDIUM = chr(121233)
SIGNWRITING_MOVEMENT_WALLPLANE_HUMP_SMALL = chr(121234)
SIGNWRITING_MOVEMENT_WALLPLANE_HUMP_MEDIUM = chr(121235)
SIGNWRITING_MOVEMENT_WALLPLANE_HUMP_LARGE = chr(121236)
SIGNWRITING_MOVEMENT_WALLPLANE_LOOP_SMALL = chr(121237)
SIGNWRITING_MOVEMENT_WALLPLANE_LOOP_MEDIUM = chr(121238)
SIGNWRITING_MOVEMENT_WALLPLANE_LOOP_LARGE = chr(121239)
SIGNWRITING_MOVEMENT_WALLPLANE_LOOP_SMALL_DOUBLE = chr(121240)
SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_CURVE_DOUBLE_SMALL = chr(121241)
SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_CURVE_DOUBLE_MEDIUM = chr(121242)
SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_CURVE_DOUBLE_LARGE = chr(121243)
SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_CURVE_TRIPLE_SMALL = chr(121244)
SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_CURVE_TRIPLE_MEDIUM = chr(121245)
SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_CURVE_TRIPLE_LARGE = chr(121246)
SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_THEN_STRAIGHT = chr(121247)
SIGNWRITING_MOVEMENT_WALLPLANE_CURVED_CROSS_SMALL = chr(121248)
SIGNWRITING_MOVEMENT_WALLPLANE_CURVED_CROSS_MEDIUM = chr(121249)
SIGNWRITING_ROTATION_WALLPLANE_SINGLE = chr(121250)
SIGNWRITING_ROTATION_WALLPLANE_DOUBLE = chr(121251)
SIGNWRITING_ROTATION_WALLPLANE_ALTERNATE = chr(121252)
SIGNWRITING_MOVEMENT_WALLPLANE_SHAKING = chr(121253)
SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_HITTING_FRONT_WALL = chr(121254)
SIGNWRITING_MOVEMENT_WALLPLANE_HUMP_HITTING_FRONT_WALL = chr(121255)
SIGNWRITING_MOVEMENT_WALLPLANE_LOOP_HITTING_FRONT_WALL = chr(121256)
SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_HITTING_FRONT_WALL = chr(121257)
SIGNWRITING_ROTATION_WALLPLANE_SINGLE_HITTING_FRONT_WALL = chr(121258)
SIGNWRITING_ROTATION_WALLPLANE_DOUBLE_HITTING_FRONT_WALL = chr(121259)
SIGNWRITING_ROTATION_WALLPLANE_ALTERNATING_HITTING_FRONT_WALL = chr(121260)
SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_HITTING_CHEST = chr(121261)
SIGNWRITING_MOVEMENT_WALLPLANE_HUMP_HITTING_CHEST = chr(121262)
SIGNWRITING_MOVEMENT_WALLPLANE_LOOP_HITTING_CHEST = chr(121263)
SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_HITTING_CHEST = chr(121264)
SIGNWRITING_ROTATION_WALLPLANE_SINGLE_HITTING_CHEST = chr(121265)
SIGNWRITING_ROTATION_WALLPLANE_DOUBLE_HITTING_CHEST = chr(121266)
SIGNWRITING_ROTATION_WALLPLANE_ALTERNATING_HITTING_CHEST = chr(121267)
SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_DIAGONAL_PATH_SMALL = chr(121268)
SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_DIAGONAL_PATH_MEDIUM = chr(121269)
SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_DIAGONAL_PATH_LARGE = chr(121270)
SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_HITTING_CEILING_SMALL = chr(121271)
SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_HITTING_CEILING_LARGE = chr(121272)
SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_CEILING_SMALL_DOUBLE = chr(121273)
SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_CEILING_LARGE_DOUBLE = chr(121274)
SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_CEILING_SMALL_TRIPLE = chr(121275)
SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_CEILING_LARGE_TRIPLE = chr(121276)
SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_CEILING_SMALL_SINGLE = chr(121277)
SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_CEILING_LARGE_SINGLE = chr(121278)
SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_CEILING_SMALL_DOUBLE = chr(121279)
SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_CEILING_LARGE_DOUBLE = chr(121280)
SIGNWRITING_MOVEMENT_FLOORPLANE_WAVE_HITTING_CEILING_SMALL = chr(121281)
SIGNWRITING_MOVEMENT_FLOORPLANE_WAVE_HITTING_CEILING_LARGE = chr(121282)
SIGNWRITING_ROTATION_FLOORPLANE_SINGLE_HITTING_CEILING = chr(121283)
SIGNWRITING_ROTATION_FLOORPLANE_DOUBLE_HITTING_CEILING = chr(121284)
SIGNWRITING_ROTATION_FLOORPLANE_ALTERNATING_HITTING_CEILING = chr(121285)
SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_HITTING_FLOOR_SMALL = chr(121286)
SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_HITTING_FLOOR_LARGE = chr(121287)
SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_FLOOR_SMALL_DOUBLE = chr(121288)
SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_FLOOR_LARGE_DOUBLE = chr(121289)
SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_FLOOR_TRIPLE_SMALL_TRIPLE = chr(121290)
SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_FLOOR_TRIPLE_LARGE_TRIPLE = chr(121291)
SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_FLOOR_SMALL_SINGLE = chr(121292)
SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_FLOOR_LARGE_SINGLE = chr(121293)
SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_FLOOR_SMALL_DOUBLE = chr(121294)
SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_FLOOR_LARGE_DOUBLE = chr(121295)
SIGNWRITING_MOVEMENT_FLOORPLANE_WAVE_HITTING_FLOOR_SMALL = chr(121296)
SIGNWRITING_MOVEMENT_FLOORPLANE_WAVE_HITTING_FLOOR_LARGE = chr(121297)
SIGNWRITING_ROTATION_FLOORPLANE_SINGLE_HITTING_FLOOR = chr(121298)
SIGNWRITING_ROTATION_FLOORPLANE_DOUBLE_HITTING_FLOOR = chr(121299)
SIGNWRITING_ROTATION_FLOORPLANE_ALTERNATING_HITTING_FLOOR = chr(121300)
SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_SMALL = chr(121301)
SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_MEDIUM = chr(121302)
SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_LARGE = chr(121303)
SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_LARGEST = chr(121304)
SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_COMBINED = chr(121305)
SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_SMALL = chr(121306)
SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_SMALL = chr(121307)
SIGNWRITING_MOVEMENT_FLOORPLANE_WAVE_SNAKE = chr(121308)
SIGNWRITING_MOVEMENT_FLOORPLANE_WAVE_SMALL = chr(121309)
SIGNWRITING_MOVEMENT_FLOORPLANE_WAVE_LARGE = chr(121310)
SIGNWRITING_ROTATION_FLOORPLANE_SINGLE = chr(121311)
SIGNWRITING_ROTATION_FLOORPLANE_DOUBLE = chr(121312)
SIGNWRITING_ROTATION_FLOORPLANE_ALTERNATING = chr(121313)
SIGNWRITING_MOVEMENT_FLOORPLANE_SHAKING_PARALLEL = chr(121314)
SIGNWRITING_MOVEMENT_WALLPLANE_ARM_CIRCLE_SMALL_SINGLE = chr(121315)
SIGNWRITING_MOVEMENT_WALLPLANE_ARM_CIRCLE_MEDIUM_SINGLE = chr(121316)
SIGNWRITING_MOVEMENT_WALLPLANE_ARM_CIRCLE_SMALL_DOUBLE = chr(121317)
SIGNWRITING_MOVEMENT_WALLPLANE_ARM_CIRCLE_MEDIUM_DOUBLE = chr(121318)
SIGNWRITING_MOVEMENT_FLOORPLANE_ARM_CIRCLE_HITTING_WALL_SMALL_SINGLE = chr(121319)
SIGNWRITING_MOVEMENT_FLOORPLANE_ARM_CIRCLE_HITTING_WALL_MEDIUM_SINGLE = chr(121320)
SIGNWRITING_MOVEMENT_FLOORPLANE_ARM_CIRCLE_HITTING_WALL_LARGE_SINGLE = chr(121321)
SIGNWRITING_MOVEMENT_FLOORPLANE_ARM_CIRCLE_HITTING_WALL_SMALL_DOUBLE = chr(121322)
SIGNWRITING_MOVEMENT_FLOORPLANE_ARM_CIRCLE_HITTING_WALL_MEDIUM_DOUBLE = chr(121323)
SIGNWRITING_MOVEMENT_FLOORPLANE_ARM_CIRCLE_HITTING_WALL_LARGE_DOUBLE = chr(121324)
SIGNWRITING_MOVEMENT_WALLPLANE_WRIST_CIRCLE_FRONT_SINGLE = chr(121325)
SIGNWRITING_MOVEMENT_WALLPLANE_WRIST_CIRCLE_FRONT_DOUBLE = chr(121326)
SIGNWRITING_MOVEMENT_FLOORPLANE_WRIST_CIRCLE_HITTING_WALL_SINGLE = chr(121327)
SIGNWRITING_MOVEMENT_FLOORPLANE_WRIST_CIRCLE_HITTING_WALL_DOUBLE = chr(121328)
SIGNWRITING_MOVEMENT_WALLPLANE_FINGER_CIRCLES_SINGLE = chr(121329)
SIGNWRITING_MOVEMENT_WALLPLANE_FINGER_CIRCLES_DOUBLE = chr(121330)
SIGNWRITING_MOVEMENT_FLOORPLANE_FINGER_CIRCLES_HITTING_WALL_SINGLE = chr(121331)
SIGNWRITING_MOVEMENT_FLOORPLANE_FINGER_CIRCLES_HITTING_WALL_DOUBLE = chr(121332)
SIGNWRITING_DYNAMIC_ARROWHEAD_SMALL = chr(121333)
SIGNWRITING_DYNAMIC_ARROWHEAD_LARGE = chr(121334)
SIGNWRITING_DYNAMIC_FAST = chr(121335)
SIGNWRITING_DYNAMIC_SLOW = chr(121336)
SIGNWRITING_DYNAMIC_TENSE = chr(121337)
SIGNWRITING_DYNAMIC_RELAXED = chr(121338)
SIGNWRITING_DYNAMIC_SIMULTANEOUS = chr(121339)
SIGNWRITING_DYNAMIC_SIMULTANEOUS_ALTERNATING = chr(121340)
SIGNWRITING_DYNAMIC_EVERY_OTHER_TIME = chr(121341)
SIGNWRITING_DYNAMIC_GRADUAL = chr(121342)
SIGNWRITING_HEAD = chr(121343)
SIGNWRITING_HEAD_RIM = chr(121344)
SIGNWRITING_HEAD_MOVEMENT_WALLPLANE_STRAIGHT = chr(121345)
SIGNWRITING_HEAD_MOVEMENT_WALLPLANE_TILT = chr(121346)
SIGNWRITING_HEAD_MOVEMENT_FLOORPLANE_STRAIGHT = chr(121347)
SIGNWRITING_HEAD_MOVEMENT_WALLPLANE_CURVE = chr(121348)
SIGNWRITING_HEAD_MOVEMENT_FLOORPLANE_CURVE = chr(121349)
SIGNWRITING_HEAD_MOVEMENT_CIRCLE = chr(121350)
SIGNWRITING_FACE_DIRECTION_POSITION_NOSE_FORWARD_TILTING = chr(121351)
SIGNWRITING_FACE_DIRECTION_POSITION_NOSE_UP_OR_DOWN = chr(121352)
SIGNWRITING_FACE_DIRECTION_POSITION_NOSE_UP_OR_DOWN_TILTING = chr(121353)
SIGNWRITING_EYEBROWS_STRAIGHT_UP = chr(121354)
SIGNWRITING_EYEBROWS_STRAIGHT_NEUTRAL = chr(121355)
SIGNWRITING_EYEBROWS_STRAIGHT_DOWN = chr(121356)
SIGNWRITING_DREAMY_EYEBROWS_NEUTRAL_DOWN = chr(121357)
SIGNWRITING_DREAMY_EYEBROWS_DOWN_NEUTRAL = chr(121358)
SIGNWRITING_DREAMY_EYEBROWS_UP_NEUTRAL = chr(121359)
SIGNWRITING_DREAMY_EYEBROWS_NEUTRAL_UP = chr(121360)
SIGNWRITING_FOREHEAD_NEUTRAL = chr(121361)
SIGNWRITING_FOREHEAD_CONTACT = chr(121362)
SIGNWRITING_FOREHEAD_WRINKLED = chr(121363)
SIGNWRITING_EYES_OPEN = chr(121364)
SIGNWRITING_EYES_SQUEEZED = chr(121365)
SIGNWRITING_EYES_CLOSED = chr(121366)
SIGNWRITING_EYE_BLINK_SINGLE = chr(121367)
SIGNWRITING_EYE_BLINK_MULTIPLE = chr(121368)
SIGNWRITING_EYES_HALF_OPEN = chr(121369)
SIGNWRITING_EYES_WIDE_OPEN = chr(121370)
SIGNWRITING_EYES_HALF_CLOSED = chr(121371)
SIGNWRITING_EYES_WIDENING_MOVEMENT = chr(121372)
SIGNWRITING_EYE_WINK = chr(121373)
SIGNWRITING_EYELASHES_UP = chr(121374)
SIGNWRITING_EYELASHES_DOWN = chr(121375)
SIGNWRITING_EYELASHES_FLUTTERING = chr(121376)
SIGNWRITING_EYEGAZE_WALLPLANE_STRAIGHT = chr(121377)
SIGNWRITING_EYEGAZE_WALLPLANE_STRAIGHT_DOUBLE = chr(121378)
SIGNWRITING_EYEGAZE_WALLPLANE_STRAIGHT_ALTERNATING = chr(121379)
SIGNWRITING_EYEGAZE_FLOORPLANE_STRAIGHT = chr(121380)
SIGNWRITING_EYEGAZE_FLOORPLANE_STRAIGHT_DOUBLE = chr(121381)
SIGNWRITING_EYEGAZE_FLOORPLANE_STRAIGHT_ALTERNATING = chr(121382)
SIGNWRITING_EYEGAZE_WALLPLANE_CURVED = chr(121383)
SIGNWRITING_EYEGAZE_FLOORPLANE_CURVED = chr(121384)
SIGNWRITING_EYEGAZE_WALLPLANE_CIRCLING = chr(121385)
SIGNWRITING_CHEEKS_PUFFED = chr(121386)
SIGNWRITING_CHEEKS_NEUTRAL = chr(121387)
SIGNWRITING_CHEEKS_SUCKED = chr(121388)
SIGNWRITING_TENSE_CHEEKS_HIGH = chr(121389)
SIGNWRITING_TENSE_CHEEKS_MIDDLE = chr(121390)
SIGNWRITING_TENSE_CHEEKS_LOW = chr(121391)
SIGNWRITING_EARS = chr(121392)
SIGNWRITING_NOSE_NEUTRAL = chr(121393)
SIGNWRITING_NOSE_CONTACT = chr(121394)
SIGNWRITING_NOSE_WRINKLES = chr(121395)
SIGNWRITING_NOSE_WIGGLES = chr(121396)
SIGNWRITING_AIR_BLOWING_OUT = chr(121397)
SIGNWRITING_AIR_SUCKING_IN = chr(121398)
SIGNWRITING_AIR_BLOW_SMALL_ROTATIONS = chr(121399)
SIGNWRITING_AIR_SUCK_SMALL_ROTATIONS = chr(121400)
SIGNWRITING_BREATH_INHALE = chr(121401)
SIGNWRITING_BREATH_EXHALE = chr(121402)
SIGNWRITING_MOUTH_CLOSED_NEUTRAL = chr(121403)
SIGNWRITING_MOUTH_CLOSED_FORWARD = chr(121404)
SIGNWRITING_MOUTH_CLOSED_CONTACT = chr(121405)
SIGNWRITING_MOUTH_SMILE = chr(121406)
SIGNWRITING_MOUTH_SMILE_WRINKLED = chr(121407)
SIGNWRITING_MOUTH_SMILE_OPEN = chr(121408)
SIGNWRITING_MOUTH_FROWN = chr(121409)
SIGNWRITING_MOUTH_FROWN_WRINKLED = chr(121410)
SIGNWRITING_MOUTH_FROWN_OPEN = chr(121411)
SIGNWRITING_MOUTH_OPEN_CIRCLE = chr(121412)
SIGNWRITING_MOUTH_OPEN_FORWARD = chr(121413)
SIGNWRITING_MOUTH_OPEN_WRINKLED = chr(121414)
SIGNWRITING_MOUTH_OPEN_OVAL = chr(121415)
SIGNWRITING_MOUTH_OPEN_OVAL_WRINKLED = chr(121416)
SIGNWRITING_MOUTH_OPEN_OVAL_YAWN = chr(121417)
SIGNWRITING_MOUTH_OPEN_RECTANGLE = chr(121418)
SIGNWRITING_MOUTH_OPEN_RECTANGLE_WRINKLED = chr(121419)
SIGNWRITING_MOUTH_OPEN_RECTANGLE_YAWN = chr(121420)
SIGNWRITING_MOUTH_KISS = chr(121421)
SIGNWRITING_MOUTH_KISS_FORWARD = chr(121422)
SIGNWRITING_MOUTH_KISS_WRINKLED = chr(121423)
SIGNWRITING_MOUTH_TENSE = chr(121424)
SIGNWRITING_MOUTH_TENSE_FORWARD = chr(121425)
SIGNWRITING_MOUTH_TENSE_SUCKED = chr(121426)
SIGNWRITING_LIPS_PRESSED_TOGETHER = chr(121427)
SIGNWRITING_LIP_LOWER_OVER_UPPER = chr(121428)
SIGNWRITING_LIP_UPPER_OVER_LOWER = chr(121429)
SIGNWRITING_MOUTH_CORNERS = chr(121430)
SIGNWRITING_MOUTH_WRINKLES_SINGLE = chr(121431)
SIGNWRITING_MOUTH_WRINKLES_DOUBLE = chr(121432)
SIGNWRITING_TONGUE_STICKING_OUT_FAR = chr(121433)
SIGNWRITING_TONGUE_LICKING_LIPS = chr(121434)
SIGNWRITING_TONGUE_TIP_BETWEEN_LIPS = chr(121435)
SIGNWRITING_TONGUE_TIP_TOUCHING_INSIDE_MOUTH = chr(121436)
SIGNWRITING_TONGUE_INSIDE_MOUTH_RELAXED = chr(121437)
SIGNWRITING_TONGUE_MOVES_AGAINST_CHEEK = chr(121438)
SIGNWRITING_TONGUE_CENTRE_STICKING_OUT = chr(121439)
SIGNWRITING_TONGUE_CENTRE_INSIDE_MOUTH = chr(121440)
SIGNWRITING_TEETH = chr(121441)
SIGNWRITING_TEETH_MOVEMENT = chr(121442)
SIGNWRITING_TEETH_ON_TONGUE = chr(121443)
SIGNWRITING_TEETH_ON_TONGUE_MOVEMENT = chr(121444)
SIGNWRITING_TEETH_ON_LIPS = chr(121445)
SIGNWRITING_TEETH_ON_LIPS_MOVEMENT = chr(121446)
SIGNWRITING_TEETH_BITE_LIPS = chr(121447)
SIGNWRITING_MOVEMENT_WALLPLANE_JAW = chr(121448)
SIGNWRITING_MOVEMENT_FLOORPLANE_JAW = chr(121449)
SIGNWRITING_NECK = chr(121450)
SIGNWRITING_HAIR = chr(121451)
SIGNWRITING_EXCITEMENT = chr(121452)
SIGNWRITING_SHOULDER_HIP_SPINE = chr(121453)
SIGNWRITING_SHOULDER_HIP_POSITIONS = chr(121454)
SIGNWRITING_WALLPLANE_SHOULDER_HIP_MOVE = chr(121455)
SIGNWRITING_FLOORPLANE_SHOULDER_HIP_MOVE = chr(121456)
SIGNWRITING_SHOULDER_TILTING_FROM_WAIST = chr(121457)
SIGNWRITING_TORSO_WALLPLANE_STRAIGHT_STRETCH = chr(121458)
SIGNWRITING_TORSO_WALLPLANE_CURVED_BEND = chr(121459)
SIGNWRITING_TORSO_FLOORPLANE_TWISTING = chr(121460)
SIGNWRITING_UPPER_BODY_TILTING_FROM_HIP_JOINTS = chr(121461)
SIGNWRITING_LIMB_COMBINATION = chr(121462)
SIGNWRITING_LIMB_LENGTH_1 = chr(121463)
SIGNWRITING_LIMB_LENGTH_2 = chr(121464)
SIGNWRITING_LIMB_LENGTH_3 = chr(121465)
SIGNWRITING_LIMB_LENGTH_4 = chr(121466)
SIGNWRITING_LIMB_LENGTH_5 = chr(121467)
SIGNWRITING_LIMB_LENGTH_6 = chr(121468)
SIGNWRITING_LIMB_LENGTH_7 = chr(121469)
SIGNWRITING_FINGER = chr(121470)
SIGNWRITING_LOCATION_WALLPLANE_SPACE = chr(121471)
SIGNWRITING_LOCATION_FLOORPLANE_SPACE = chr(121472)
SIGNWRITING_LOCATION_HEIGHT = chr(121473)
SIGNWRITING_LOCATION_WIDTH = chr(121474)
SIGNWRITING_LOCATION_DEPTH = chr(121475)
SIGNWRITING_LOCATION_HEAD_NECK = chr(121476)
SIGNWRITING_LOCATION_TORSO = chr(121477)
SIGNWRITING_LOCATION_LIMBS_DIGITS = chr(121478)
SIGNWRITING_COMMA = chr(121479)
SIGNWRITING_FULL_STOP = chr(121480)
SIGNWRITING_SEMICOLON = chr(121481)
SIGNWRITING_COLON = chr(121482)
SIGNWRITING_PARENTHESIS = chr(121483)
SIGNWRITING_FILL_MODIFIER_2 = chr(121499)
SIGNWRITING_FILL_MODIFIER_3 = chr(121500)
SIGNWRITING_FILL_MODIFIER_4 = chr(121501)
SIGNWRITING_FILL_MODIFIER_5 = chr(121502)
SIGNWRITING_FILL_MODIFIER_6 = chr(121503)
SIGNWRITING_ROTATION_MODIFIER_2 = chr(121505)
SIGNWRITING_ROTATION_MODIFIER_3 = chr(121506)
SIGNWRITING_ROTATION_MODIFIER_4 = chr(121507)
SIGNWRITING_ROTATION_MODIFIER_5 = chr(121508)
SIGNWRITING_ROTATION_MODIFIER_6 = chr(121509)
SIGNWRITING_ROTATION_MODIFIER_7 = chr(121510)
SIGNWRITING_ROTATION_MODIFIER_8 = chr(121511)
SIGNWRITING_ROTATION_MODIFIER_9 = chr(121512)
SIGNWRITING_ROTATION_MODIFIER_10 = chr(121513)
SIGNWRITING_ROTATION_MODIFIER_11 = chr(121514)
SIGNWRITING_ROTATION_MODIFIER_12 = chr(121515)
SIGNWRITING_ROTATION_MODIFIER_13 = chr(121516)
SIGNWRITING_ROTATION_MODIFIER_14 = chr(121517)
SIGNWRITING_ROTATION_MODIFIER_15 = chr(121518)
SIGNWRITING_ROTATION_MODIFIER_16 = chr(121519)
LATIN_SMALL_LETTER_FENG_DIGRAPH_WITH_TRILL = chr(122624)
LATIN_SMALL_LETTER_REVERSED_SCRIPT_G = chr(122625)
LATIN_LETTER_SMALL_CAPITAL_TURNED_G = chr(122626)
LATIN_SMALL_LETTER_REVERSED_K = chr(122627)
LATIN_LETTER_SMALL_CAPITAL_L_WITH_BELT = chr(122628)
LATIN_SMALL_LETTER_LEZH_WITH_RETROFLEX_HOOK = chr(122629)
LATIN_SMALL_LETTER_TURNED_Y_WITH_BELT = chr(122630)
LATIN_SMALL_LETTER_REVERSED_ENG = chr(122631)
LATIN_SMALL_LETTER_TURNED_R_WITH_LONG_LEG_AND_RETROFLEX_HOOK = chr(122632)
LATIN_SMALL_LETTER_T_WITH_HOOK_AND_RETROFLEX_HOOK = chr(122633)
LATIN_LETTER_RETROFLEX_CLICK_WITH_RETROFLEX_HOOK = chr(122634)
LATIN_SMALL_LETTER_ESH_WITH_DOUBLE_BAR = chr(122635)
LATIN_SMALL_LETTER_ESH_WITH_DOUBLE_BAR_AND_CURL = chr(122636)
LATIN_SMALL_LETTER_TURNED_T_WITH_CURL = chr(122637)
LATIN_LETTER_INVERTED_GLOTTAL_STOP_WITH_CURL = chr(122638)
LATIN_LETTER_STRETCHED_C_WITH_CURL = chr(122639)
LATIN_LETTER_SMALL_CAPITAL_TURNED_K = chr(122640)
LATIN_SMALL_LETTER_L_WITH_FISHHOOK = chr(122641)
LATIN_SMALL_LETTER_DEZH_DIGRAPH_WITH_PALATAL_HOOK = chr(122642)
LATIN_SMALL_LETTER_L_WITH_BELT_AND_PALATAL_HOOK = chr(122643)
LATIN_SMALL_LETTER_ENG_WITH_PALATAL_HOOK = chr(122644)
LATIN_SMALL_LETTER_TURNED_R_WITH_PALATAL_HOOK = chr(122645)
LATIN_SMALL_LETTER_R_WITH_FISHHOOK_AND_PALATAL_HOOK = chr(122646)
LATIN_SMALL_LETTER_TESH_DIGRAPH_WITH_PALATAL_HOOK = chr(122647)
LATIN_SMALL_LETTER_EZH_WITH_PALATAL_HOOK = chr(122648)
LATIN_SMALL_LETTER_DEZH_DIGRAPH_WITH_RETROFLEX_HOOK = chr(122649)
LATIN_SMALL_LETTER_I_WITH_STROKE_AND_RETROFLEX_HOOK = chr(122650)
LATIN_SMALL_LETTER_O_WITH_RETROFLEX_HOOK = chr(122651)
LATIN_SMALL_LETTER_TESH_DIGRAPH_WITH_RETROFLEX_HOOK = chr(122652)
LATIN_SMALL_LETTER_C_WITH_RETROFLEX_HOOK = chr(122653)
LATIN_SMALL_LETTER_S_WITH_CURL = chr(122654)
LATIN_SMALL_LETTER_D_WITH_MID_HEIGHT_LEFT_HOOK = chr(122661)
LATIN_SMALL_LETTER_L_WITH_MID_HEIGHT_LEFT_HOOK = chr(122662)
LATIN_SMALL_LETTER_N_WITH_MID_HEIGHT_LEFT_HOOK = chr(122663)
LATIN_SMALL_LETTER_R_WITH_MID_HEIGHT_LEFT_HOOK = chr(122664)
LATIN_SMALL_LETTER_S_WITH_MID_HEIGHT_LEFT_HOOK = chr(122665)
LATIN_SMALL_LETTER_T_WITH_MID_HEIGHT_LEFT_HOOK = chr(122666)
COMBINING_GLAGOLITIC_LETTER_AZU = chr(122880)
COMBINING_GLAGOLITIC_LETTER_BUKY = chr(122881)
COMBINING_GLAGOLITIC_LETTER_VEDE = chr(122882)
COMBINING_GLAGOLITIC_LETTER_GLAGOLI = chr(122883)
COMBINING_GLAGOLITIC_LETTER_DOBRO = chr(122884)
COMBINING_GLAGOLITIC_LETTER_YESTU = chr(122885)
COMBINING_GLAGOLITIC_LETTER_ZHIVETE = chr(122886)
COMBINING_GLAGOLITIC_LETTER_ZEMLJA = chr(122888)
COMBINING_GLAGOLITIC_LETTER_IZHE = chr(122889)
COMBINING_GLAGOLITIC_LETTER_INITIAL_IZHE = chr(122890)
COMBINING_GLAGOLITIC_LETTER_I = chr(122891)
COMBINING_GLAGOLITIC_LETTER_DJERVI = chr(122892)
COMBINING_GLAGOLITIC_LETTER_KAKO = chr(122893)
COMBINING_GLAGOLITIC_LETTER_LJUDIJE = chr(122894)
COMBINING_GLAGOLITIC_LETTER_MYSLITE = chr(122895)
COMBINING_GLAGOLITIC_LETTER_NASHI = chr(122896)
COMBINING_GLAGOLITIC_LETTER_ONU = chr(122897)
COMBINING_GLAGOLITIC_LETTER_POKOJI = chr(122898)
COMBINING_GLAGOLITIC_LETTER_RITSI = chr(122899)
COMBINING_GLAGOLITIC_LETTER_SLOVO = chr(122900)
COMBINING_GLAGOLITIC_LETTER_TVRIDO = chr(122901)
COMBINING_GLAGOLITIC_LETTER_UKU = chr(122902)
COMBINING_GLAGOLITIC_LETTER_FRITU = chr(122903)
COMBINING_GLAGOLITIC_LETTER_HERU = chr(122904)
COMBINING_GLAGOLITIC_LETTER_SHTA = chr(122907)
COMBINING_GLAGOLITIC_LETTER_TSI = chr(122908)
COMBINING_GLAGOLITIC_LETTER_CHRIVI = chr(122909)
COMBINING_GLAGOLITIC_LETTER_SHA = chr(122910)
COMBINING_GLAGOLITIC_LETTER_YERU = chr(122911)
COMBINING_GLAGOLITIC_LETTER_YERI = chr(122912)
COMBINING_GLAGOLITIC_LETTER_YATI = chr(122913)
COMBINING_GLAGOLITIC_LETTER_YU = chr(122915)
COMBINING_GLAGOLITIC_LETTER_SMALL_YUS = chr(122916)
COMBINING_GLAGOLITIC_LETTER_YO = chr(122918)
COMBINING_GLAGOLITIC_LETTER_IOTATED_SMALL_YUS = chr(122919)
COMBINING_GLAGOLITIC_LETTER_BIG_YUS = chr(122920)
COMBINING_GLAGOLITIC_LETTER_IOTATED_BIG_YUS = chr(122921)
COMBINING_GLAGOLITIC_LETTER_FITA = chr(122922)
MODIFIER_LETTER_CYRILLIC_SMALL_A = chr(122928)
MODIFIER_LETTER_CYRILLIC_SMALL_BE = chr(122929)
MODIFIER_LETTER_CYRILLIC_SMALL_VE = chr(122930)
MODIFIER_LETTER_CYRILLIC_SMALL_GHE = chr(122931)
MODIFIER_LETTER_CYRILLIC_SMALL_DE = chr(122932)
MODIFIER_LETTER_CYRILLIC_SMALL_IE = chr(122933)
MODIFIER_LETTER_CYRILLIC_SMALL_ZHE = chr(122934)
MODIFIER_LETTER_CYRILLIC_SMALL_ZE = chr(122935)
MODIFIER_LETTER_CYRILLIC_SMALL_I = chr(122936)
MODIFIER_LETTER_CYRILLIC_SMALL_KA = chr(122937)
MODIFIER_LETTER_CYRILLIC_SMALL_EL = chr(122938)
MODIFIER_LETTER_CYRILLIC_SMALL_EM = chr(122939)
MODIFIER_LETTER_CYRILLIC_SMALL_O = chr(122940)
MODIFIER_LETTER_CYRILLIC_SMALL_PE = chr(122941)
MODIFIER_LETTER_CYRILLIC_SMALL_ER = chr(122942)
MODIFIER_LETTER_CYRILLIC_SMALL_ES = chr(122943)
MODIFIER_LETTER_CYRILLIC_SMALL_TE = chr(122944)
MODIFIER_LETTER_CYRILLIC_SMALL_U = chr(122945)
MODIFIER_LETTER_CYRILLIC_SMALL_EF = chr(122946)
MODIFIER_LETTER_CYRILLIC_SMALL_HA = chr(122947)
MODIFIER_LETTER_CYRILLIC_SMALL_TSE = chr(122948)
MODIFIER_LETTER_CYRILLIC_SMALL_CHE = chr(122949)
MODIFIER_LETTER_CYRILLIC_SMALL_SHA = chr(122950)
MODIFIER_LETTER_CYRILLIC_SMALL_YERU = chr(122951)
MODIFIER_LETTER_CYRILLIC_SMALL_E = chr(122952)
MODIFIER_LETTER_CYRILLIC_SMALL_YU = chr(122953)
MODIFIER_LETTER_CYRILLIC_SMALL_DZZE = chr(122954)
MODIFIER_LETTER_CYRILLIC_SMALL_SCHWA = chr(122955)
MODIFIER_LETTER_CYRILLIC_SMALL_BYELORUSSIAN_UKRAINIAN_I = chr(122956)
MODIFIER_LETTER_CYRILLIC_SMALL_JE = chr(122957)
MODIFIER_LETTER_CYRILLIC_SMALL_BARRED_O = chr(122958)
MODIFIER_LETTER_CYRILLIC_SMALL_STRAIGHT_U = chr(122959)
MODIFIER_LETTER_CYRILLIC_SMALL_PALOCHKA = chr(122960)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_A = chr(122961)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_BE = chr(122962)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_VE = chr(122963)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_GHE = chr(122964)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_DE = chr(122965)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_IE = chr(122966)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_ZHE = chr(122967)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_ZE = chr(122968)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_I = chr(122969)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_KA = chr(122970)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_EL = chr(122971)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_O = chr(122972)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_PE = chr(122973)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_ES = chr(122974)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_U = chr(122975)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_EF = chr(122976)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_HA = chr(122977)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_TSE = chr(122978)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_CHE = chr(122979)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_SHA = chr(122980)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_HARD_SIGN = chr(122981)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_YERU = chr(122982)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_GHE_WITH_UPTURN = chr(122983)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_BYELORUSSIAN_UKRAINIAN_I = chr(122984)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_DZE = chr(122985)
CYRILLIC_SUBSCRIPT_SMALL_LETTER_DZHE = chr(122986)
MODIFIER_LETTER_CYRILLIC_SMALL_ES_WITH_DESCENDER = chr(122987)
MODIFIER_LETTER_CYRILLIC_SMALL_YERU_WITH_BACK_YER = chr(122988)
MODIFIER_LETTER_CYRILLIC_SMALL_STRAIGHT_U_WITH_STROKE = chr(122989)
COMBINING_CYRILLIC_SMALL_LETTER_BYELORUSSIAN_UKRAINIAN_I = chr(123023)
NYIAKENG_PUACHUE_HMONG_LETTER_MA = chr(123136)
NYIAKENG_PUACHUE_HMONG_LETTER_TSA = chr(123137)
NYIAKENG_PUACHUE_HMONG_LETTER_NTA = chr(123138)
NYIAKENG_PUACHUE_HMONG_LETTER_TA = chr(123139)
NYIAKENG_PUACHUE_HMONG_LETTER_HA = chr(123140)
NYIAKENG_PUACHUE_HMONG_LETTER_NA = chr(123141)
NYIAKENG_PUACHUE_HMONG_LETTER_XA = chr(123142)
NYIAKENG_PUACHUE_HMONG_LETTER_NKA = chr(123143)
NYIAKENG_PUACHUE_HMONG_LETTER_CA = chr(123144)
NYIAKENG_PUACHUE_HMONG_LETTER_LA = chr(123145)
NYIAKENG_PUACHUE_HMONG_LETTER_SA = chr(123146)
NYIAKENG_PUACHUE_HMONG_LETTER_ZA = chr(123147)
NYIAKENG_PUACHUE_HMONG_LETTER_NCA = chr(123148)
NYIAKENG_PUACHUE_HMONG_LETTER_NTSA = chr(123149)
NYIAKENG_PUACHUE_HMONG_LETTER_KA = chr(123150)
NYIAKENG_PUACHUE_HMONG_LETTER_DA = chr(123151)
NYIAKENG_PUACHUE_HMONG_LETTER_NYA = chr(123152)
NYIAKENG_PUACHUE_HMONG_LETTER_NRA = chr(123153)
NYIAKENG_PUACHUE_HMONG_LETTER_VA = chr(123154)
NYIAKENG_PUACHUE_HMONG_LETTER_NTXA = chr(123155)
NYIAKENG_PUACHUE_HMONG_LETTER_TXA = chr(123156)
NYIAKENG_PUACHUE_HMONG_LETTER_FA = chr(123157)
NYIAKENG_PUACHUE_HMONG_LETTER_RA = chr(123158)
NYIAKENG_PUACHUE_HMONG_LETTER_QA = chr(123159)
NYIAKENG_PUACHUE_HMONG_LETTER_YA = chr(123160)
NYIAKENG_PUACHUE_HMONG_LETTER_NQA = chr(123161)
NYIAKENG_PUACHUE_HMONG_LETTER_PA = chr(123162)
NYIAKENG_PUACHUE_HMONG_LETTER_XYA = chr(123163)
NYIAKENG_PUACHUE_HMONG_LETTER_NPA = chr(123164)
NYIAKENG_PUACHUE_HMONG_LETTER_DLA = chr(123165)
NYIAKENG_PUACHUE_HMONG_LETTER_NPLA = chr(123166)
NYIAKENG_PUACHUE_HMONG_LETTER_HAH = chr(123167)
NYIAKENG_PUACHUE_HMONG_LETTER_MLA = chr(123168)
NYIAKENG_PUACHUE_HMONG_LETTER_PLA = chr(123169)
NYIAKENG_PUACHUE_HMONG_LETTER_GA = chr(123170)
NYIAKENG_PUACHUE_HMONG_LETTER_RRA = chr(123171)
NYIAKENG_PUACHUE_HMONG_LETTER_A = chr(123172)
NYIAKENG_PUACHUE_HMONG_LETTER_AA = chr(123173)
NYIAKENG_PUACHUE_HMONG_LETTER_I = chr(123174)
NYIAKENG_PUACHUE_HMONG_LETTER_U = chr(123175)
NYIAKENG_PUACHUE_HMONG_LETTER_O = chr(123176)
NYIAKENG_PUACHUE_HMONG_LETTER_OO = chr(123177)
NYIAKENG_PUACHUE_HMONG_LETTER_E = chr(123178)
NYIAKENG_PUACHUE_HMONG_LETTER_EE = chr(123179)
NYIAKENG_PUACHUE_HMONG_LETTER_W = chr(123180)
NYIAKENG_PUACHUE_HMONG_TONE_B = chr(123184)
NYIAKENG_PUACHUE_HMONG_TONE_M = chr(123185)
NYIAKENG_PUACHUE_HMONG_TONE_J = chr(123186)
NYIAKENG_PUACHUE_HMONG_TONE_V = chr(123187)
NYIAKENG_PUACHUE_HMONG_TONE_S = chr(123188)
NYIAKENG_PUACHUE_HMONG_TONE_G = chr(123189)
NYIAKENG_PUACHUE_HMONG_TONE_D = chr(123190)
NYIAKENG_PUACHUE_HMONG_SIGN_FOR_PERSON = chr(123191)
NYIAKENG_PUACHUE_HMONG_SIGN_FOR_THING = chr(123192)
NYIAKENG_PUACHUE_HMONG_SIGN_FOR_LOCATION = chr(123193)
NYIAKENG_PUACHUE_HMONG_SIGN_FOR_ANIMAL = chr(123194)
NYIAKENG_PUACHUE_HMONG_SIGN_FOR_INVERTEBRATE = chr(123195)
NYIAKENG_PUACHUE_HMONG_SIGN_XW_XW = chr(123196)
NYIAKENG_PUACHUE_HMONG_SYLLABLE_LENGTHENER = chr(123197)
NYIAKENG_PUACHUE_HMONG_DIGIT_ZERO = chr(123200)
NYIAKENG_PUACHUE_HMONG_DIGIT_ONE = chr(123201)
NYIAKENG_PUACHUE_HMONG_DIGIT_TWO = chr(123202)
NYIAKENG_PUACHUE_HMONG_DIGIT_THREE = chr(123203)
NYIAKENG_PUACHUE_HMONG_DIGIT_FOUR = chr(123204)
NYIAKENG_PUACHUE_HMONG_DIGIT_FIVE = chr(123205)
NYIAKENG_PUACHUE_HMONG_DIGIT_SIX = chr(123206)
NYIAKENG_PUACHUE_HMONG_DIGIT_SEVEN = chr(123207)
NYIAKENG_PUACHUE_HMONG_DIGIT_EIGHT = chr(123208)
NYIAKENG_PUACHUE_HMONG_DIGIT_NINE = chr(123209)
NYIAKENG_PUACHUE_HMONG_LOGOGRAM_NYAJ = chr(123214)
NYIAKENG_PUACHUE_HMONG_CIRCLED_CA = chr(123215)
TOTO_LETTER_PA = chr(123536)
TOTO_LETTER_BA = chr(123537)
TOTO_LETTER_TA = chr(123538)
TOTO_LETTER_DA = chr(123539)
TOTO_LETTER_KA = chr(123540)
TOTO_LETTER_GA = chr(123541)
TOTO_LETTER_MA = chr(123542)
TOTO_LETTER_NA = chr(123543)
TOTO_LETTER_NGA = chr(123544)
TOTO_LETTER_SA = chr(123545)
TOTO_LETTER_CHA = chr(123546)
TOTO_LETTER_YA = chr(123547)
TOTO_LETTER_WA = chr(123548)
TOTO_LETTER_JA = chr(123549)
TOTO_LETTER_HA = chr(123550)
TOTO_LETTER_RA = chr(123551)
TOTO_LETTER_LA = chr(123552)
TOTO_LETTER_I = chr(123553)
TOTO_LETTER_BREATHY_I = chr(123554)
TOTO_LETTER_IU = chr(123555)
TOTO_LETTER_BREATHY_IU = chr(123556)
TOTO_LETTER_U = chr(123557)
TOTO_LETTER_E = chr(123558)
TOTO_LETTER_BREATHY_E = chr(123559)
TOTO_LETTER_EO = chr(123560)
TOTO_LETTER_BREATHY_EO = chr(123561)
TOTO_LETTER_O = chr(123562)
TOTO_LETTER_AE = chr(123563)
TOTO_LETTER_BREATHY_AE = chr(123564)
TOTO_LETTER_A = chr(123565)
TOTO_SIGN_RISING_TONE = chr(123566)
WANCHO_LETTER_AA = chr(123584)
WANCHO_LETTER_A = chr(123585)
WANCHO_LETTER_BA = chr(123586)
WANCHO_LETTER_CA = chr(123587)
WANCHO_LETTER_DA = chr(123588)
WANCHO_LETTER_GA = chr(123589)
WANCHO_LETTER_YA = chr(123590)
WANCHO_LETTER_PHA = chr(123591)
WANCHO_LETTER_LA = chr(123592)
WANCHO_LETTER_NA = chr(123593)
WANCHO_LETTER_PA = chr(123594)
WANCHO_LETTER_TA = chr(123595)
WANCHO_LETTER_THA = chr(123596)
WANCHO_LETTER_FA = chr(123597)
WANCHO_LETTER_SA = chr(123598)
WANCHO_LETTER_SHA = chr(123599)
WANCHO_LETTER_JA = chr(123600)
WANCHO_LETTER_ZA = chr(123601)
WANCHO_LETTER_WA = chr(123602)
WANCHO_LETTER_VA = chr(123603)
WANCHO_LETTER_KA = chr(123604)
WANCHO_LETTER_O = chr(123605)
WANCHO_LETTER_AU = chr(123606)
WANCHO_LETTER_RA = chr(123607)
WANCHO_LETTER_MA = chr(123608)
WANCHO_LETTER_KHA = chr(123609)
WANCHO_LETTER_HA = chr(123610)
WANCHO_LETTER_E = chr(123611)
WANCHO_LETTER_I = chr(123612)
WANCHO_LETTER_NGA = chr(123613)
WANCHO_LETTER_U = chr(123614)
WANCHO_LETTER_LLHA = chr(123615)
WANCHO_LETTER_TSA = chr(123616)
WANCHO_LETTER_TRA = chr(123617)
WANCHO_LETTER_ONG = chr(123618)
WANCHO_LETTER_AANG = chr(123619)
WANCHO_LETTER_ANG = chr(123620)
WANCHO_LETTER_ING = chr(123621)
WANCHO_LETTER_ON = chr(123622)
WANCHO_LETTER_EN = chr(123623)
WANCHO_LETTER_AAN = chr(123624)
WANCHO_LETTER_NYA = chr(123625)
WANCHO_LETTER_UEN = chr(123626)
WANCHO_LETTER_YIH = chr(123627)
WANCHO_TONE_TUP = chr(123628)
WANCHO_TONE_TUPNI = chr(123629)
WANCHO_TONE_KOI = chr(123630)
WANCHO_TONE_KOINI = chr(123631)
WANCHO_DIGIT_ZERO = chr(123632)
WANCHO_DIGIT_ONE = chr(123633)
WANCHO_DIGIT_TWO = chr(123634)
WANCHO_DIGIT_THREE = chr(123635)
WANCHO_DIGIT_FOUR = chr(123636)
WANCHO_DIGIT_FIVE = chr(123637)
WANCHO_DIGIT_SIX = chr(123638)
WANCHO_DIGIT_SEVEN = chr(123639)
WANCHO_DIGIT_EIGHT = chr(123640)
WANCHO_DIGIT_NINE = chr(123641)
WANCHO_NGUN_SIGN = chr(123647)
NAG_MUNDARI_LETTER_O = chr(124112)
NAG_MUNDARI_LETTER_OP = chr(124113)
NAG_MUNDARI_LETTER_OL = chr(124114)
NAG_MUNDARI_LETTER_OY = chr(124115)
NAG_MUNDARI_LETTER_ONG = chr(124116)
NAG_MUNDARI_LETTER_A = chr(124117)
NAG_MUNDARI_LETTER_AJ = chr(124118)
NAG_MUNDARI_LETTER_AB = chr(124119)
NAG_MUNDARI_LETTER_ANY = chr(124120)
NAG_MUNDARI_LETTER_AH = chr(124121)
NAG_MUNDARI_LETTER_I = chr(124122)
NAG_MUNDARI_LETTER_IS = chr(124123)
NAG_MUNDARI_LETTER_IDD = chr(124124)
NAG_MUNDARI_LETTER_IT = chr(124125)
NAG_MUNDARI_LETTER_IH = chr(124126)
NAG_MUNDARI_LETTER_U = chr(124127)
NAG_MUNDARI_LETTER_UC = chr(124128)
NAG_MUNDARI_LETTER_UD = chr(124129)
NAG_MUNDARI_LETTER_UK = chr(124130)
NAG_MUNDARI_LETTER_UR = chr(124131)
NAG_MUNDARI_LETTER_E = chr(124132)
NAG_MUNDARI_LETTER_ENN = chr(124133)
NAG_MUNDARI_LETTER_EG = chr(124134)
NAG_MUNDARI_LETTER_EM = chr(124135)
NAG_MUNDARI_LETTER_EN = chr(124136)
NAG_MUNDARI_LETTER_ETT = chr(124137)
NAG_MUNDARI_LETTER_ELL = chr(124138)
NAG_MUNDARI_SIGN_OJOD = chr(124139)
NAG_MUNDARI_SIGN_MUHOR = chr(124140)
NAG_MUNDARI_SIGN_TOYOR = chr(124141)
NAG_MUNDARI_SIGN_IKIR = chr(124142)
NAG_MUNDARI_SIGN_SUTUH = chr(124143)
NAG_MUNDARI_DIGIT_ZERO = chr(124144)
NAG_MUNDARI_DIGIT_ONE = chr(124145)
NAG_MUNDARI_DIGIT_TWO = chr(124146)
NAG_MUNDARI_DIGIT_THREE = chr(124147)
NAG_MUNDARI_DIGIT_FOUR = chr(124148)
NAG_MUNDARI_DIGIT_FIVE = chr(124149)
NAG_MUNDARI_DIGIT_SIX = chr(124150)
NAG_MUNDARI_DIGIT_SEVEN = chr(124151)
NAG_MUNDARI_DIGIT_EIGHT = chr(124152)
NAG_MUNDARI_DIGIT_NINE = chr(124153)
ETHIOPIC_SYLLABLE_HHYA = chr(124896)
ETHIOPIC_SYLLABLE_HHYU = chr(124897)
ETHIOPIC_SYLLABLE_HHYI = chr(124898)
ETHIOPIC_SYLLABLE_HHYAA = chr(124899)
ETHIOPIC_SYLLABLE_HHYEE = chr(124900)
ETHIOPIC_SYLLABLE_HHYE = chr(124901)
ETHIOPIC_SYLLABLE_HHYO = chr(124902)
ETHIOPIC_SYLLABLE_GURAGE_HHWA = chr(124904)
ETHIOPIC_SYLLABLE_HHWI = chr(124905)
ETHIOPIC_SYLLABLE_HHWEE = chr(124906)
ETHIOPIC_SYLLABLE_HHWE = chr(124907)
ETHIOPIC_SYLLABLE_GURAGE_MWI = chr(124909)
ETHIOPIC_SYLLABLE_GURAGE_MWEE = chr(124910)
ETHIOPIC_SYLLABLE_GURAGE_QWI = chr(124912)
ETHIOPIC_SYLLABLE_GURAGE_QWEE = chr(124913)
ETHIOPIC_SYLLABLE_GURAGE_QWE = chr(124914)
ETHIOPIC_SYLLABLE_GURAGE_BWI = chr(124915)
ETHIOPIC_SYLLABLE_GURAGE_BWEE = chr(124916)
ETHIOPIC_SYLLABLE_GURAGE_KWI = chr(124917)
ETHIOPIC_SYLLABLE_GURAGE_KWEE = chr(124918)
ETHIOPIC_SYLLABLE_GURAGE_KWE = chr(124919)
ETHIOPIC_SYLLABLE_GURAGE_GWI = chr(124920)
ETHIOPIC_SYLLABLE_GURAGE_GWEE = chr(124921)
ETHIOPIC_SYLLABLE_GURAGE_GWE = chr(124922)
ETHIOPIC_SYLLABLE_GURAGE_FWI = chr(124923)
ETHIOPIC_SYLLABLE_GURAGE_FWEE = chr(124924)
ETHIOPIC_SYLLABLE_GURAGE_PWI = chr(124925)
ETHIOPIC_SYLLABLE_GURAGE_PWEE = chr(124926)
MENDE_KIKAKUI_SYLLABLE_M001_KI = chr(124928)
MENDE_KIKAKUI_SYLLABLE_M002_KA = chr(124929)
MENDE_KIKAKUI_SYLLABLE_M003_KU = chr(124930)
MENDE_KIKAKUI_SYLLABLE_M065_KEE = chr(124931)
MENDE_KIKAKUI_SYLLABLE_M095_KE = chr(124932)
MENDE_KIKAKUI_SYLLABLE_M076_KOO = chr(124933)
MENDE_KIKAKUI_SYLLABLE_M048_KO = chr(124934)
MENDE_KIKAKUI_SYLLABLE_M179_KUA = chr(124935)
MENDE_KIKAKUI_SYLLABLE_M004_WI = chr(124936)
MENDE_KIKAKUI_SYLLABLE_M005_WA = chr(124937)
MENDE_KIKAKUI_SYLLABLE_M006_WU = chr(124938)
MENDE_KIKAKUI_SYLLABLE_M126_WEE = chr(124939)
MENDE_KIKAKUI_SYLLABLE_M118_WE = chr(124940)
MENDE_KIKAKUI_SYLLABLE_M114_WOO = chr(124941)
MENDE_KIKAKUI_SYLLABLE_M045_WO = chr(124942)
MENDE_KIKAKUI_SYLLABLE_M194_WUI = chr(124943)
MENDE_KIKAKUI_SYLLABLE_M143_WEI = chr(124944)
MENDE_KIKAKUI_SYLLABLE_M061_WVI = chr(124945)
MENDE_KIKAKUI_SYLLABLE_M049_WVA = chr(124946)
MENDE_KIKAKUI_SYLLABLE_M139_WVE = chr(124947)
MENDE_KIKAKUI_SYLLABLE_M007_MIN = chr(124948)
MENDE_KIKAKUI_SYLLABLE_M008_MAN = chr(124949)
MENDE_KIKAKUI_SYLLABLE_M009_MUN = chr(124950)
MENDE_KIKAKUI_SYLLABLE_M059_MEN = chr(124951)
MENDE_KIKAKUI_SYLLABLE_M094_MON = chr(124952)
MENDE_KIKAKUI_SYLLABLE_M154_MUAN = chr(124953)
MENDE_KIKAKUI_SYLLABLE_M189_MUEN = chr(124954)
MENDE_KIKAKUI_SYLLABLE_M010_BI = chr(124955)
MENDE_KIKAKUI_SYLLABLE_M011_BA = chr(124956)
MENDE_KIKAKUI_SYLLABLE_M012_BU = chr(124957)
MENDE_KIKAKUI_SYLLABLE_M150_BEE = chr(124958)
MENDE_KIKAKUI_SYLLABLE_M097_BE = chr(124959)
MENDE_KIKAKUI_SYLLABLE_M103_BOO = chr(124960)
MENDE_KIKAKUI_SYLLABLE_M138_BO = chr(124961)
MENDE_KIKAKUI_SYLLABLE_M013_I = chr(124962)
MENDE_KIKAKUI_SYLLABLE_M014_A = chr(124963)
MENDE_KIKAKUI_SYLLABLE_M015_U = chr(124964)
MENDE_KIKAKUI_SYLLABLE_M163_EE = chr(124965)
MENDE_KIKAKUI_SYLLABLE_M100_E = chr(124966)
MENDE_KIKAKUI_SYLLABLE_M165_OO = chr(124967)
MENDE_KIKAKUI_SYLLABLE_M147_O = chr(124968)
MENDE_KIKAKUI_SYLLABLE_M137_EI = chr(124969)
MENDE_KIKAKUI_SYLLABLE_M131_IN = chr(124970)
MENDE_KIKAKUI_SYLLABLE_M135_IN = chr(124971)
MENDE_KIKAKUI_SYLLABLE_M195_AN = chr(124972)
MENDE_KIKAKUI_SYLLABLE_M178_EN = chr(124973)
MENDE_KIKAKUI_SYLLABLE_M019_SI = chr(124974)
MENDE_KIKAKUI_SYLLABLE_M020_SA = chr(124975)
MENDE_KIKAKUI_SYLLABLE_M021_SU = chr(124976)
MENDE_KIKAKUI_SYLLABLE_M162_SEE = chr(124977)
MENDE_KIKAKUI_SYLLABLE_M116_SE = chr(124978)
MENDE_KIKAKUI_SYLLABLE_M136_SOO = chr(124979)
MENDE_KIKAKUI_SYLLABLE_M079_SO = chr(124980)
MENDE_KIKAKUI_SYLLABLE_M196_SIA = chr(124981)
MENDE_KIKAKUI_SYLLABLE_M025_LI = chr(124982)
MENDE_KIKAKUI_SYLLABLE_M026_LA = chr(124983)
MENDE_KIKAKUI_SYLLABLE_M027_LU = chr(124984)
MENDE_KIKAKUI_SYLLABLE_M084_LEE = chr(124985)
MENDE_KIKAKUI_SYLLABLE_M073_LE = chr(124986)
MENDE_KIKAKUI_SYLLABLE_M054_LOO = chr(124987)
MENDE_KIKAKUI_SYLLABLE_M153_LO = chr(124988)
MENDE_KIKAKUI_SYLLABLE_M110_LONG_LE = chr(124989)
MENDE_KIKAKUI_SYLLABLE_M016_DI = chr(124990)
MENDE_KIKAKUI_SYLLABLE_M017_DA = chr(124991)
MENDE_KIKAKUI_SYLLABLE_M018_DU = chr(124992)
MENDE_KIKAKUI_SYLLABLE_M089_DEE = chr(124993)
MENDE_KIKAKUI_SYLLABLE_M180_DOO = chr(124994)
MENDE_KIKAKUI_SYLLABLE_M181_DO = chr(124995)
MENDE_KIKAKUI_SYLLABLE_M022_TI = chr(124996)
MENDE_KIKAKUI_SYLLABLE_M023_TA = chr(124997)
MENDE_KIKAKUI_SYLLABLE_M024_TU = chr(124998)
MENDE_KIKAKUI_SYLLABLE_M091_TEE = chr(124999)
MENDE_KIKAKUI_SYLLABLE_M055_TE = chr(125000)
MENDE_KIKAKUI_SYLLABLE_M104_TOO = chr(125001)
MENDE_KIKAKUI_SYLLABLE_M069_TO = chr(125002)
MENDE_KIKAKUI_SYLLABLE_M028_JI = chr(125003)
MENDE_KIKAKUI_SYLLABLE_M029_JA = chr(125004)
MENDE_KIKAKUI_SYLLABLE_M030_JU = chr(125005)
MENDE_KIKAKUI_SYLLABLE_M157_JEE = chr(125006)
MENDE_KIKAKUI_SYLLABLE_M113_JE = chr(125007)
MENDE_KIKAKUI_SYLLABLE_M160_JOO = chr(125008)
MENDE_KIKAKUI_SYLLABLE_M063_JO = chr(125009)
MENDE_KIKAKUI_SYLLABLE_M175_LONG_JO = chr(125010)
MENDE_KIKAKUI_SYLLABLE_M031_YI = chr(125011)
MENDE_KIKAKUI_SYLLABLE_M032_YA = chr(125012)
MENDE_KIKAKUI_SYLLABLE_M033_YU = chr(125013)
MENDE_KIKAKUI_SYLLABLE_M109_YEE = chr(125014)
MENDE_KIKAKUI_SYLLABLE_M080_YE = chr(125015)
MENDE_KIKAKUI_SYLLABLE_M141_YOO = chr(125016)
MENDE_KIKAKUI_SYLLABLE_M121_YO = chr(125017)
MENDE_KIKAKUI_SYLLABLE_M034_FI = chr(125018)
MENDE_KIKAKUI_SYLLABLE_M035_FA = chr(125019)
MENDE_KIKAKUI_SYLLABLE_M036_FU = chr(125020)
MENDE_KIKAKUI_SYLLABLE_M078_FEE = chr(125021)
MENDE_KIKAKUI_SYLLABLE_M075_FE = chr(125022)
MENDE_KIKAKUI_SYLLABLE_M133_FOO = chr(125023)
MENDE_KIKAKUI_SYLLABLE_M088_FO = chr(125024)
MENDE_KIKAKUI_SYLLABLE_M197_FUA = chr(125025)
MENDE_KIKAKUI_SYLLABLE_M101_FAN = chr(125026)
MENDE_KIKAKUI_SYLLABLE_M037_NIN = chr(125027)
MENDE_KIKAKUI_SYLLABLE_M038_NAN = chr(125028)
MENDE_KIKAKUI_SYLLABLE_M039_NUN = chr(125029)
MENDE_KIKAKUI_SYLLABLE_M117_NEN = chr(125030)
MENDE_KIKAKUI_SYLLABLE_M169_NON = chr(125031)
MENDE_KIKAKUI_SYLLABLE_M176_HI = chr(125032)
MENDE_KIKAKUI_SYLLABLE_M041_HA = chr(125033)
MENDE_KIKAKUI_SYLLABLE_M186_HU = chr(125034)
MENDE_KIKAKUI_SYLLABLE_M040_HEE = chr(125035)
MENDE_KIKAKUI_SYLLABLE_M096_HE = chr(125036)
MENDE_KIKAKUI_SYLLABLE_M042_HOO = chr(125037)
MENDE_KIKAKUI_SYLLABLE_M140_HO = chr(125038)
MENDE_KIKAKUI_SYLLABLE_M083_HEEI = chr(125039)
MENDE_KIKAKUI_SYLLABLE_M128_HOOU = chr(125040)
MENDE_KIKAKUI_SYLLABLE_M053_HIN = chr(125041)
MENDE_KIKAKUI_SYLLABLE_M130_HAN = chr(125042)
MENDE_KIKAKUI_SYLLABLE_M087_HUN = chr(125043)
MENDE_KIKAKUI_SYLLABLE_M052_HEN = chr(125044)
MENDE_KIKAKUI_SYLLABLE_M193_HON = chr(125045)
MENDE_KIKAKUI_SYLLABLE_M046_HUAN = chr(125046)
MENDE_KIKAKUI_SYLLABLE_M090_NGGI = chr(125047)
MENDE_KIKAKUI_SYLLABLE_M043_NGGA = chr(125048)
MENDE_KIKAKUI_SYLLABLE_M082_NGGU = chr(125049)
MENDE_KIKAKUI_SYLLABLE_M115_NGGEE = chr(125050)
MENDE_KIKAKUI_SYLLABLE_M146_NGGE = chr(125051)
MENDE_KIKAKUI_SYLLABLE_M156_NGGOO = chr(125052)
MENDE_KIKAKUI_SYLLABLE_M120_NGGO = chr(125053)
MENDE_KIKAKUI_SYLLABLE_M159_NGGAA = chr(125054)
MENDE_KIKAKUI_SYLLABLE_M127_NGGUA = chr(125055)
MENDE_KIKAKUI_SYLLABLE_M086_LONG_NGGE = chr(125056)
MENDE_KIKAKUI_SYLLABLE_M106_LONG_NGGOO = chr(125057)
MENDE_KIKAKUI_SYLLABLE_M183_LONG_NGGO = chr(125058)
MENDE_KIKAKUI_SYLLABLE_M155_GI = chr(125059)
MENDE_KIKAKUI_SYLLABLE_M111_GA = chr(125060)
MENDE_KIKAKUI_SYLLABLE_M168_GU = chr(125061)
MENDE_KIKAKUI_SYLLABLE_M190_GEE = chr(125062)
MENDE_KIKAKUI_SYLLABLE_M166_GUEI = chr(125063)
MENDE_KIKAKUI_SYLLABLE_M167_GUAN = chr(125064)
MENDE_KIKAKUI_SYLLABLE_M184_NGEN = chr(125065)
MENDE_KIKAKUI_SYLLABLE_M057_NGON = chr(125066)
MENDE_KIKAKUI_SYLLABLE_M177_NGUAN = chr(125067)
MENDE_KIKAKUI_SYLLABLE_M068_PI = chr(125068)
MENDE_KIKAKUI_SYLLABLE_M099_PA = chr(125069)
MENDE_KIKAKUI_SYLLABLE_M050_PU = chr(125070)
MENDE_KIKAKUI_SYLLABLE_M081_PEE = chr(125071)
MENDE_KIKAKUI_SYLLABLE_M051_PE = chr(125072)
MENDE_KIKAKUI_SYLLABLE_M102_POO = chr(125073)
MENDE_KIKAKUI_SYLLABLE_M066_PO = chr(125074)
MENDE_KIKAKUI_SYLLABLE_M145_MBI = chr(125075)
MENDE_KIKAKUI_SYLLABLE_M062_MBA = chr(125076)
MENDE_KIKAKUI_SYLLABLE_M122_MBU = chr(125077)
MENDE_KIKAKUI_SYLLABLE_M047_MBEE = chr(125078)
MENDE_KIKAKUI_SYLLABLE_M188_MBEE = chr(125079)
MENDE_KIKAKUI_SYLLABLE_M072_MBE = chr(125080)
MENDE_KIKAKUI_SYLLABLE_M172_MBOO = chr(125081)
MENDE_KIKAKUI_SYLLABLE_M174_MBO = chr(125082)
MENDE_KIKAKUI_SYLLABLE_M187_MBUU = chr(125083)
MENDE_KIKAKUI_SYLLABLE_M161_LONG_MBE = chr(125084)
MENDE_KIKAKUI_SYLLABLE_M105_LONG_MBOO = chr(125085)
MENDE_KIKAKUI_SYLLABLE_M142_LONG_MBO = chr(125086)
MENDE_KIKAKUI_SYLLABLE_M132_KPI = chr(125087)
MENDE_KIKAKUI_SYLLABLE_M092_KPA = chr(125088)
MENDE_KIKAKUI_SYLLABLE_M074_KPU = chr(125089)
MENDE_KIKAKUI_SYLLABLE_M044_KPEE = chr(125090)
MENDE_KIKAKUI_SYLLABLE_M108_KPE = chr(125091)
MENDE_KIKAKUI_SYLLABLE_M112_KPOO = chr(125092)
MENDE_KIKAKUI_SYLLABLE_M158_KPO = chr(125093)
MENDE_KIKAKUI_SYLLABLE_M124_GBI = chr(125094)
MENDE_KIKAKUI_SYLLABLE_M056_GBA = chr(125095)
MENDE_KIKAKUI_SYLLABLE_M148_GBU = chr(125096)
MENDE_KIKAKUI_SYLLABLE_M093_GBEE = chr(125097)
MENDE_KIKAKUI_SYLLABLE_M107_GBE = chr(125098)
MENDE_KIKAKUI_SYLLABLE_M071_GBOO = chr(125099)
MENDE_KIKAKUI_SYLLABLE_M070_GBO = chr(125100)
MENDE_KIKAKUI_SYLLABLE_M171_RA = chr(125101)
MENDE_KIKAKUI_SYLLABLE_M123_NDI = chr(125102)
MENDE_KIKAKUI_SYLLABLE_M129_NDA = chr(125103)
MENDE_KIKAKUI_SYLLABLE_M125_NDU = chr(125104)
MENDE_KIKAKUI_SYLLABLE_M191_NDEE = chr(125105)
MENDE_KIKAKUI_SYLLABLE_M119_NDE = chr(125106)
MENDE_KIKAKUI_SYLLABLE_M067_NDOO = chr(125107)
MENDE_KIKAKUI_SYLLABLE_M064_NDO = chr(125108)
MENDE_KIKAKUI_SYLLABLE_M152_NJA = chr(125109)
MENDE_KIKAKUI_SYLLABLE_M192_NJU = chr(125110)
MENDE_KIKAKUI_SYLLABLE_M149_NJEE = chr(125111)
MENDE_KIKAKUI_SYLLABLE_M134_NJOO = chr(125112)
MENDE_KIKAKUI_SYLLABLE_M182_VI = chr(125113)
MENDE_KIKAKUI_SYLLABLE_M185_VA = chr(125114)
MENDE_KIKAKUI_SYLLABLE_M151_VU = chr(125115)
MENDE_KIKAKUI_SYLLABLE_M173_VEE = chr(125116)
MENDE_KIKAKUI_SYLLABLE_M085_VE = chr(125117)
MENDE_KIKAKUI_SYLLABLE_M144_VOO = chr(125118)
MENDE_KIKAKUI_SYLLABLE_M077_VO = chr(125119)
MENDE_KIKAKUI_SYLLABLE_M164_NYIN = chr(125120)
MENDE_KIKAKUI_SYLLABLE_M058_NYAN = chr(125121)
MENDE_KIKAKUI_SYLLABLE_M170_NYUN = chr(125122)
MENDE_KIKAKUI_SYLLABLE_M098_NYEN = chr(125123)
MENDE_KIKAKUI_SYLLABLE_M060_NYON = chr(125124)
MENDE_KIKAKUI_DIGIT_ONE = chr(125127)
MENDE_KIKAKUI_DIGIT_TWO = chr(125128)
MENDE_KIKAKUI_DIGIT_THREE = chr(125129)
MENDE_KIKAKUI_DIGIT_FOUR = chr(125130)
MENDE_KIKAKUI_DIGIT_FIVE = chr(125131)
MENDE_KIKAKUI_DIGIT_SIX = chr(125132)
MENDE_KIKAKUI_DIGIT_SEVEN = chr(125133)
MENDE_KIKAKUI_DIGIT_EIGHT = chr(125134)
MENDE_KIKAKUI_DIGIT_NINE = chr(125135)
MENDE_KIKAKUI_COMBINING_NUMBER_TEENS = chr(125136)
MENDE_KIKAKUI_COMBINING_NUMBER_TENS = chr(125137)
MENDE_KIKAKUI_COMBINING_NUMBER_HUNDREDS = chr(125138)
MENDE_KIKAKUI_COMBINING_NUMBER_THOUSANDS = chr(125139)
MENDE_KIKAKUI_COMBINING_NUMBER_TEN_THOUSANDS = chr(125140)
MENDE_KIKAKUI_COMBINING_NUMBER_HUNDRED_THOUSANDS = chr(125141)
MENDE_KIKAKUI_COMBINING_NUMBER_MILLIONS = chr(125142)
ADLAM_CAPITAL_LETTER_ALIF = chr(125184)
ADLAM_CAPITAL_LETTER_DAALI = chr(125185)
ADLAM_CAPITAL_LETTER_LAAM = chr(125186)
ADLAM_CAPITAL_LETTER_MIIM = chr(125187)
ADLAM_CAPITAL_LETTER_BA = chr(125188)
ADLAM_CAPITAL_LETTER_SINNYIIYHE = chr(125189)
ADLAM_CAPITAL_LETTER_PE = chr(125190)
ADLAM_CAPITAL_LETTER_BHE = chr(125191)
ADLAM_CAPITAL_LETTER_RA = chr(125192)
ADLAM_CAPITAL_LETTER_E = chr(125193)
ADLAM_CAPITAL_LETTER_FA = chr(125194)
ADLAM_CAPITAL_LETTER_I = chr(125195)
ADLAM_CAPITAL_LETTER_O = chr(125196)
ADLAM_CAPITAL_LETTER_DHA = chr(125197)
ADLAM_CAPITAL_LETTER_YHE = chr(125198)
ADLAM_CAPITAL_LETTER_WAW = chr(125199)
ADLAM_CAPITAL_LETTER_NUN = chr(125200)
ADLAM_CAPITAL_LETTER_KAF = chr(125201)
ADLAM_CAPITAL_LETTER_YA = chr(125202)
ADLAM_CAPITAL_LETTER_U = chr(125203)
ADLAM_CAPITAL_LETTER_JIIM = chr(125204)
ADLAM_CAPITAL_LETTER_CHI = chr(125205)
ADLAM_CAPITAL_LETTER_HA = chr(125206)
ADLAM_CAPITAL_LETTER_QAAF = chr(125207)
ADLAM_CAPITAL_LETTER_GA = chr(125208)
ADLAM_CAPITAL_LETTER_NYA = chr(125209)
ADLAM_CAPITAL_LETTER_TU = chr(125210)
ADLAM_CAPITAL_LETTER_NHA = chr(125211)
ADLAM_CAPITAL_LETTER_VA = chr(125212)
ADLAM_CAPITAL_LETTER_KHA = chr(125213)
ADLAM_CAPITAL_LETTER_GBE = chr(125214)
ADLAM_CAPITAL_LETTER_ZAL = chr(125215)
ADLAM_CAPITAL_LETTER_KPO = chr(125216)
ADLAM_CAPITAL_LETTER_SHA = chr(125217)
ADLAM_SMALL_LETTER_ALIF = chr(125218)
ADLAM_SMALL_LETTER_DAALI = chr(125219)
ADLAM_SMALL_LETTER_LAAM = chr(125220)
ADLAM_SMALL_LETTER_MIIM = chr(125221)
ADLAM_SMALL_LETTER_BA = chr(125222)
ADLAM_SMALL_LETTER_SINNYIIYHE = chr(125223)
ADLAM_SMALL_LETTER_PE = chr(125224)
ADLAM_SMALL_LETTER_BHE = chr(125225)
ADLAM_SMALL_LETTER_RA = chr(125226)
ADLAM_SMALL_LETTER_E = chr(125227)
ADLAM_SMALL_LETTER_FA = chr(125228)
ADLAM_SMALL_LETTER_I = chr(125229)
ADLAM_SMALL_LETTER_O = chr(125230)
ADLAM_SMALL_LETTER_DHA = chr(125231)
ADLAM_SMALL_LETTER_YHE = chr(125232)
ADLAM_SMALL_LETTER_WAW = chr(125233)
ADLAM_SMALL_LETTER_NUN = chr(125234)
ADLAM_SMALL_LETTER_KAF = chr(125235)
ADLAM_SMALL_LETTER_YA = chr(125236)
ADLAM_SMALL_LETTER_U = chr(125237)
ADLAM_SMALL_LETTER_JIIM = chr(125238)
ADLAM_SMALL_LETTER_CHI = chr(125239)
ADLAM_SMALL_LETTER_HA = chr(125240)
ADLAM_SMALL_LETTER_QAAF = chr(125241)
ADLAM_SMALL_LETTER_GA = chr(125242)
ADLAM_SMALL_LETTER_NYA = chr(125243)
ADLAM_SMALL_LETTER_TU = chr(125244)
ADLAM_SMALL_LETTER_NHA = chr(125245)
ADLAM_SMALL_LETTER_VA = chr(125246)
ADLAM_SMALL_LETTER_KHA = chr(125247)
ADLAM_SMALL_LETTER_GBE = chr(125248)
ADLAM_SMALL_LETTER_ZAL = chr(125249)
ADLAM_SMALL_LETTER_KPO = chr(125250)
ADLAM_SMALL_LETTER_SHA = chr(125251)
ADLAM_ALIF_LENGTHENER = chr(125252)
ADLAM_VOWEL_LENGTHENER = chr(125253)
ADLAM_GEMINATION_MARK = chr(125254)
ADLAM_HAMZA = chr(125255)
ADLAM_CONSONANT_MODIFIER = chr(125256)
ADLAM_GEMINATE_CONSONANT_MODIFIER = chr(125257)
ADLAM_NUKTA = chr(125258)
ADLAM_NASALIZATION_MARK = chr(125259)
ADLAM_DIGIT_ZERO = chr(125264)
ADLAM_DIGIT_ONE = chr(125265)
ADLAM_DIGIT_TWO = chr(125266)
ADLAM_DIGIT_THREE = chr(125267)
ADLAM_DIGIT_FOUR = chr(125268)
ADLAM_DIGIT_FIVE = chr(125269)
ADLAM_DIGIT_SIX = chr(125270)
ADLAM_DIGIT_SEVEN = chr(125271)
ADLAM_DIGIT_EIGHT = chr(125272)
ADLAM_DIGIT_NINE = chr(125273)
ADLAM_INITIAL_EXCLAMATION_MARK = chr(125278)
ADLAM_INITIAL_QUESTION_MARK = chr(125279)
INDIC_SIYAQ_NUMBER_ONE = chr(126065)
INDIC_SIYAQ_NUMBER_TWO = chr(126066)
INDIC_SIYAQ_NUMBER_THREE = chr(126067)
INDIC_SIYAQ_NUMBER_FOUR = chr(126068)
INDIC_SIYAQ_NUMBER_FIVE = chr(126069)
INDIC_SIYAQ_NUMBER_SIX = chr(126070)
INDIC_SIYAQ_NUMBER_SEVEN = chr(126071)
INDIC_SIYAQ_NUMBER_EIGHT = chr(126072)
INDIC_SIYAQ_NUMBER_NINE = chr(126073)
INDIC_SIYAQ_NUMBER_TEN = chr(126074)
INDIC_SIYAQ_NUMBER_TWENTY = chr(126075)
INDIC_SIYAQ_NUMBER_THIRTY = chr(126076)
INDIC_SIYAQ_NUMBER_FORTY = chr(126077)
INDIC_SIYAQ_NUMBER_FIFTY = chr(126078)
INDIC_SIYAQ_NUMBER_SIXTY = chr(126079)
INDIC_SIYAQ_NUMBER_SEVENTY = chr(126080)
INDIC_SIYAQ_NUMBER_EIGHTY = chr(126081)
INDIC_SIYAQ_NUMBER_NINETY = chr(126082)
INDIC_SIYAQ_NUMBER_ONE_HUNDRED = chr(126083)
INDIC_SIYAQ_NUMBER_TWO_HUNDRED = chr(126084)
INDIC_SIYAQ_NUMBER_THREE_HUNDRED = chr(126085)
INDIC_SIYAQ_NUMBER_FOUR_HUNDRED = chr(126086)
INDIC_SIYAQ_NUMBER_FIVE_HUNDRED = chr(126087)
INDIC_SIYAQ_NUMBER_SIX_HUNDRED = chr(126088)
INDIC_SIYAQ_NUMBER_SEVEN_HUNDRED = chr(126089)
INDIC_SIYAQ_NUMBER_EIGHT_HUNDRED = chr(126090)
INDIC_SIYAQ_NUMBER_NINE_HUNDRED = chr(126091)
INDIC_SIYAQ_NUMBER_ONE_THOUSAND = chr(126092)
INDIC_SIYAQ_NUMBER_TWO_THOUSAND = chr(126093)
INDIC_SIYAQ_NUMBER_THREE_THOUSAND = chr(126094)
INDIC_SIYAQ_NUMBER_FOUR_THOUSAND = chr(126095)
INDIC_SIYAQ_NUMBER_FIVE_THOUSAND = chr(126096)
INDIC_SIYAQ_NUMBER_SIX_THOUSAND = chr(126097)
INDIC_SIYAQ_NUMBER_SEVEN_THOUSAND = chr(126098)
INDIC_SIYAQ_NUMBER_EIGHT_THOUSAND = chr(126099)
INDIC_SIYAQ_NUMBER_NINE_THOUSAND = chr(126100)
INDIC_SIYAQ_NUMBER_TEN_THOUSAND = chr(126101)
INDIC_SIYAQ_NUMBER_TWENTY_THOUSAND = chr(126102)
INDIC_SIYAQ_NUMBER_THIRTY_THOUSAND = chr(126103)
INDIC_SIYAQ_NUMBER_FORTY_THOUSAND = chr(126104)
INDIC_SIYAQ_NUMBER_FIFTY_THOUSAND = chr(126105)
INDIC_SIYAQ_NUMBER_SIXTY_THOUSAND = chr(126106)
INDIC_SIYAQ_NUMBER_SEVENTY_THOUSAND = chr(126107)
INDIC_SIYAQ_NUMBER_EIGHTY_THOUSAND = chr(126108)
INDIC_SIYAQ_NUMBER_NINETY_THOUSAND = chr(126109)
INDIC_SIYAQ_NUMBER_LAKH = chr(126110)
INDIC_SIYAQ_NUMBER_LAKHAN = chr(126111)
INDIC_SIYAQ_LAKH_MARK = chr(126112)
INDIC_SIYAQ_NUMBER_KAROR = chr(126113)
INDIC_SIYAQ_NUMBER_KARORAN = chr(126114)
INDIC_SIYAQ_NUMBER_PREFIXED_ONE = chr(126115)
INDIC_SIYAQ_NUMBER_PREFIXED_TWO = chr(126116)
INDIC_SIYAQ_NUMBER_PREFIXED_THREE = chr(126117)
INDIC_SIYAQ_NUMBER_PREFIXED_FOUR = chr(126118)
INDIC_SIYAQ_NUMBER_PREFIXED_FIVE = chr(126119)
INDIC_SIYAQ_NUMBER_PREFIXED_SIX = chr(126120)
INDIC_SIYAQ_NUMBER_PREFIXED_SEVEN = chr(126121)
INDIC_SIYAQ_NUMBER_PREFIXED_EIGHT = chr(126122)
INDIC_SIYAQ_NUMBER_PREFIXED_NINE = chr(126123)
INDIC_SIYAQ_PLACEHOLDER = chr(126124)
INDIC_SIYAQ_FRACTION_ONE_QUARTER = chr(126125)
INDIC_SIYAQ_FRACTION_ONE_HALF = chr(126126)
INDIC_SIYAQ_FRACTION_THREE_QUARTERS = chr(126127)
INDIC_SIYAQ_RUPEE_MARK = chr(126128)
INDIC_SIYAQ_NUMBER_ALTERNATE_ONE = chr(126129)
INDIC_SIYAQ_NUMBER_ALTERNATE_TWO = chr(126130)
INDIC_SIYAQ_NUMBER_ALTERNATE_TEN_THOUSAND = chr(126131)
INDIC_SIYAQ_ALTERNATE_LAKH_MARK = chr(126132)
OTTOMAN_SIYAQ_NUMBER_ONE = chr(126209)
OTTOMAN_SIYAQ_NUMBER_TWO = chr(126210)
OTTOMAN_SIYAQ_NUMBER_THREE = chr(126211)
OTTOMAN_SIYAQ_NUMBER_FOUR = chr(126212)
OTTOMAN_SIYAQ_NUMBER_FIVE = chr(126213)
OTTOMAN_SIYAQ_NUMBER_SIX = chr(126214)
OTTOMAN_SIYAQ_NUMBER_SEVEN = chr(126215)
OTTOMAN_SIYAQ_NUMBER_EIGHT = chr(126216)
OTTOMAN_SIYAQ_NUMBER_NINE = chr(126217)
OTTOMAN_SIYAQ_NUMBER_TEN = chr(126218)
OTTOMAN_SIYAQ_NUMBER_TWENTY = chr(126219)
OTTOMAN_SIYAQ_NUMBER_THIRTY = chr(126220)
OTTOMAN_SIYAQ_NUMBER_FORTY = chr(126221)
OTTOMAN_SIYAQ_NUMBER_FIFTY = chr(126222)
OTTOMAN_SIYAQ_NUMBER_SIXTY = chr(126223)
OTTOMAN_SIYAQ_NUMBER_SEVENTY = chr(126224)
OTTOMAN_SIYAQ_NUMBER_EIGHTY = chr(126225)
OTTOMAN_SIYAQ_NUMBER_NINETY = chr(126226)
OTTOMAN_SIYAQ_NUMBER_ONE_HUNDRED = chr(126227)
OTTOMAN_SIYAQ_NUMBER_TWO_HUNDRED = chr(126228)
OTTOMAN_SIYAQ_NUMBER_THREE_HUNDRED = chr(126229)
OTTOMAN_SIYAQ_NUMBER_FOUR_HUNDRED = chr(126230)
OTTOMAN_SIYAQ_NUMBER_FIVE_HUNDRED = chr(126231)
OTTOMAN_SIYAQ_NUMBER_SIX_HUNDRED = chr(126232)
OTTOMAN_SIYAQ_NUMBER_SEVEN_HUNDRED = chr(126233)
OTTOMAN_SIYAQ_NUMBER_EIGHT_HUNDRED = chr(126234)
OTTOMAN_SIYAQ_NUMBER_NINE_HUNDRED = chr(126235)
OTTOMAN_SIYAQ_NUMBER_ONE_THOUSAND = chr(126236)
OTTOMAN_SIYAQ_NUMBER_TWO_THOUSAND = chr(126237)
OTTOMAN_SIYAQ_NUMBER_THREE_THOUSAND = chr(126238)
OTTOMAN_SIYAQ_NUMBER_FOUR_THOUSAND = chr(126239)
OTTOMAN_SIYAQ_NUMBER_FIVE_THOUSAND = chr(126240)
OTTOMAN_SIYAQ_NUMBER_SIX_THOUSAND = chr(126241)
OTTOMAN_SIYAQ_NUMBER_SEVEN_THOUSAND = chr(126242)
OTTOMAN_SIYAQ_NUMBER_EIGHT_THOUSAND = chr(126243)
OTTOMAN_SIYAQ_NUMBER_NINE_THOUSAND = chr(126244)
OTTOMAN_SIYAQ_NUMBER_TEN_THOUSAND = chr(126245)
OTTOMAN_SIYAQ_NUMBER_TWENTY_THOUSAND = chr(126246)
OTTOMAN_SIYAQ_NUMBER_THIRTY_THOUSAND = chr(126247)
OTTOMAN_SIYAQ_NUMBER_FORTY_THOUSAND = chr(126248)
OTTOMAN_SIYAQ_NUMBER_FIFTY_THOUSAND = chr(126249)
OTTOMAN_SIYAQ_NUMBER_SIXTY_THOUSAND = chr(126250)
OTTOMAN_SIYAQ_NUMBER_SEVENTY_THOUSAND = chr(126251)
OTTOMAN_SIYAQ_NUMBER_EIGHTY_THOUSAND = chr(126252)
OTTOMAN_SIYAQ_NUMBER_NINETY_THOUSAND = chr(126253)
OTTOMAN_SIYAQ_MARRATAN = chr(126254)
OTTOMAN_SIYAQ_ALTERNATE_NUMBER_TWO = chr(126255)
OTTOMAN_SIYAQ_ALTERNATE_NUMBER_THREE = chr(126256)
OTTOMAN_SIYAQ_ALTERNATE_NUMBER_FOUR = chr(126257)
OTTOMAN_SIYAQ_ALTERNATE_NUMBER_FIVE = chr(126258)
OTTOMAN_SIYAQ_ALTERNATE_NUMBER_SIX = chr(126259)
OTTOMAN_SIYAQ_ALTERNATE_NUMBER_SEVEN = chr(126260)
OTTOMAN_SIYAQ_ALTERNATE_NUMBER_EIGHT = chr(126261)
OTTOMAN_SIYAQ_ALTERNATE_NUMBER_NINE = chr(126262)
OTTOMAN_SIYAQ_ALTERNATE_NUMBER_TEN = chr(126263)
OTTOMAN_SIYAQ_ALTERNATE_NUMBER_FOUR_HUNDRED = chr(126264)
OTTOMAN_SIYAQ_ALTERNATE_NUMBER_SIX_HUNDRED = chr(126265)
OTTOMAN_SIYAQ_ALTERNATE_NUMBER_TWO_THOUSAND = chr(126266)
OTTOMAN_SIYAQ_ALTERNATE_NUMBER_TEN_THOUSAND = chr(126267)
OTTOMAN_SIYAQ_FRACTION_ONE_HALF = chr(126268)
OTTOMAN_SIYAQ_FRACTION_ONE_SIXTH = chr(126269)
ARABIC_MATHEMATICAL_ALEF = chr(126464)
ARABIC_MATHEMATICAL_BEH = chr(126465)
ARABIC_MATHEMATICAL_JEEM = chr(126466)
ARABIC_MATHEMATICAL_DAL = chr(126467)
ARABIC_MATHEMATICAL_WAW = chr(126469)
ARABIC_MATHEMATICAL_ZAIN = chr(126470)
ARABIC_MATHEMATICAL_HAH = chr(126471)
ARABIC_MATHEMATICAL_TAH = chr(126472)
ARABIC_MATHEMATICAL_YEH = chr(126473)
ARABIC_MATHEMATICAL_KAF = chr(126474)
ARABIC_MATHEMATICAL_LAM = chr(126475)
ARABIC_MATHEMATICAL_MEEM = chr(126476)
ARABIC_MATHEMATICAL_NOON = chr(126477)
ARABIC_MATHEMATICAL_SEEN = chr(126478)
ARABIC_MATHEMATICAL_AIN = chr(126479)
ARABIC_MATHEMATICAL_FEH = chr(126480)
ARABIC_MATHEMATICAL_SAD = chr(126481)
ARABIC_MATHEMATICAL_QAF = chr(126482)
ARABIC_MATHEMATICAL_REH = chr(126483)
ARABIC_MATHEMATICAL_SHEEN = chr(126484)
ARABIC_MATHEMATICAL_TEH = chr(126485)
ARABIC_MATHEMATICAL_THEH = chr(126486)
ARABIC_MATHEMATICAL_KHAH = chr(126487)
ARABIC_MATHEMATICAL_THAL = chr(126488)
ARABIC_MATHEMATICAL_DAD = chr(126489)
ARABIC_MATHEMATICAL_ZAH = chr(126490)
ARABIC_MATHEMATICAL_GHAIN = chr(126491)
ARABIC_MATHEMATICAL_DOTLESS_BEH = chr(126492)
ARABIC_MATHEMATICAL_DOTLESS_NOON = chr(126493)
ARABIC_MATHEMATICAL_DOTLESS_FEH = chr(126494)
ARABIC_MATHEMATICAL_DOTLESS_QAF = chr(126495)
ARABIC_MATHEMATICAL_INITIAL_BEH = chr(126497)
ARABIC_MATHEMATICAL_INITIAL_JEEM = chr(126498)
ARABIC_MATHEMATICAL_INITIAL_HEH = chr(126500)
ARABIC_MATHEMATICAL_INITIAL_HAH = chr(126503)
ARABIC_MATHEMATICAL_INITIAL_YEH = chr(126505)
ARABIC_MATHEMATICAL_INITIAL_KAF = chr(126506)
ARABIC_MATHEMATICAL_INITIAL_LAM = chr(126507)
ARABIC_MATHEMATICAL_INITIAL_MEEM = chr(126508)
ARABIC_MATHEMATICAL_INITIAL_NOON = chr(126509)
ARABIC_MATHEMATICAL_INITIAL_SEEN = chr(126510)
ARABIC_MATHEMATICAL_INITIAL_AIN = chr(126511)
ARABIC_MATHEMATICAL_INITIAL_FEH = chr(126512)
ARABIC_MATHEMATICAL_INITIAL_SAD = chr(126513)
ARABIC_MATHEMATICAL_INITIAL_QAF = chr(126514)
ARABIC_MATHEMATICAL_INITIAL_SHEEN = chr(126516)
ARABIC_MATHEMATICAL_INITIAL_TEH = chr(126517)
ARABIC_MATHEMATICAL_INITIAL_THEH = chr(126518)
ARABIC_MATHEMATICAL_INITIAL_KHAH = chr(126519)
ARABIC_MATHEMATICAL_INITIAL_DAD = chr(126521)
ARABIC_MATHEMATICAL_INITIAL_GHAIN = chr(126523)
ARABIC_MATHEMATICAL_TAILED_JEEM = chr(126530)
ARABIC_MATHEMATICAL_TAILED_HAH = chr(126535)
ARABIC_MATHEMATICAL_TAILED_YEH = chr(126537)
ARABIC_MATHEMATICAL_TAILED_LAM = chr(126539)
ARABIC_MATHEMATICAL_TAILED_NOON = chr(126541)
ARABIC_MATHEMATICAL_TAILED_SEEN = chr(126542)
ARABIC_MATHEMATICAL_TAILED_AIN = chr(126543)
ARABIC_MATHEMATICAL_TAILED_SAD = chr(126545)
ARABIC_MATHEMATICAL_TAILED_QAF = chr(126546)
ARABIC_MATHEMATICAL_TAILED_SHEEN = chr(126548)
ARABIC_MATHEMATICAL_TAILED_KHAH = chr(126551)
ARABIC_MATHEMATICAL_TAILED_DAD = chr(126553)
ARABIC_MATHEMATICAL_TAILED_GHAIN = chr(126555)
ARABIC_MATHEMATICAL_TAILED_DOTLESS_NOON = chr(126557)
ARABIC_MATHEMATICAL_TAILED_DOTLESS_QAF = chr(126559)
ARABIC_MATHEMATICAL_STRETCHED_BEH = chr(126561)
ARABIC_MATHEMATICAL_STRETCHED_JEEM = chr(126562)
ARABIC_MATHEMATICAL_STRETCHED_HEH = chr(126564)
ARABIC_MATHEMATICAL_STRETCHED_HAH = chr(126567)
ARABIC_MATHEMATICAL_STRETCHED_TAH = chr(126568)
ARABIC_MATHEMATICAL_STRETCHED_YEH = chr(126569)
ARABIC_MATHEMATICAL_STRETCHED_KAF = chr(126570)
ARABIC_MATHEMATICAL_STRETCHED_MEEM = chr(126572)
ARABIC_MATHEMATICAL_STRETCHED_NOON = chr(126573)
ARABIC_MATHEMATICAL_STRETCHED_SEEN = chr(126574)
ARABIC_MATHEMATICAL_STRETCHED_AIN = chr(126575)
ARABIC_MATHEMATICAL_STRETCHED_FEH = chr(126576)
ARABIC_MATHEMATICAL_STRETCHED_SAD = chr(126577)
ARABIC_MATHEMATICAL_STRETCHED_QAF = chr(126578)
ARABIC_MATHEMATICAL_STRETCHED_SHEEN = chr(126580)
ARABIC_MATHEMATICAL_STRETCHED_TEH = chr(126581)
ARABIC_MATHEMATICAL_STRETCHED_THEH = chr(126582)
ARABIC_MATHEMATICAL_STRETCHED_KHAH = chr(126583)
ARABIC_MATHEMATICAL_STRETCHED_DAD = chr(126585)
ARABIC_MATHEMATICAL_STRETCHED_ZAH = chr(126586)
ARABIC_MATHEMATICAL_STRETCHED_GHAIN = chr(126587)
ARABIC_MATHEMATICAL_STRETCHED_DOTLESS_BEH = chr(126588)
ARABIC_MATHEMATICAL_STRETCHED_DOTLESS_FEH = chr(126590)
ARABIC_MATHEMATICAL_LOOPED_ALEF = chr(126592)
ARABIC_MATHEMATICAL_LOOPED_BEH = chr(126593)
ARABIC_MATHEMATICAL_LOOPED_JEEM = chr(126594)
ARABIC_MATHEMATICAL_LOOPED_DAL = chr(126595)
ARABIC_MATHEMATICAL_LOOPED_HEH = chr(126596)
ARABIC_MATHEMATICAL_LOOPED_WAW = chr(126597)
ARABIC_MATHEMATICAL_LOOPED_ZAIN = chr(126598)
ARABIC_MATHEMATICAL_LOOPED_HAH = chr(126599)
ARABIC_MATHEMATICAL_LOOPED_TAH = chr(126600)
ARABIC_MATHEMATICAL_LOOPED_YEH = chr(126601)
ARABIC_MATHEMATICAL_LOOPED_LAM = chr(126603)
ARABIC_MATHEMATICAL_LOOPED_MEEM = chr(126604)
ARABIC_MATHEMATICAL_LOOPED_NOON = chr(126605)
ARABIC_MATHEMATICAL_LOOPED_SEEN = chr(126606)
ARABIC_MATHEMATICAL_LOOPED_AIN = chr(126607)
ARABIC_MATHEMATICAL_LOOPED_FEH = chr(126608)
ARABIC_MATHEMATICAL_LOOPED_SAD = chr(126609)
ARABIC_MATHEMATICAL_LOOPED_QAF = chr(126610)
ARABIC_MATHEMATICAL_LOOPED_REH = chr(126611)
ARABIC_MATHEMATICAL_LOOPED_SHEEN = chr(126612)
ARABIC_MATHEMATICAL_LOOPED_TEH = chr(126613)
ARABIC_MATHEMATICAL_LOOPED_THEH = chr(126614)
ARABIC_MATHEMATICAL_LOOPED_KHAH = chr(126615)
ARABIC_MATHEMATICAL_LOOPED_THAL = chr(126616)
ARABIC_MATHEMATICAL_LOOPED_DAD = chr(126617)
ARABIC_MATHEMATICAL_LOOPED_ZAH = chr(126618)
ARABIC_MATHEMATICAL_LOOPED_GHAIN = chr(126619)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_BEH = chr(126625)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_JEEM = chr(126626)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_DAL = chr(126627)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_WAW = chr(126629)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_ZAIN = chr(126630)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_HAH = chr(126631)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_TAH = chr(126632)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_YEH = chr(126633)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_LAM = chr(126635)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_MEEM = chr(126636)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_NOON = chr(126637)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_SEEN = chr(126638)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_AIN = chr(126639)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_FEH = chr(126640)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_SAD = chr(126641)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_QAF = chr(126642)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_REH = chr(126643)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_SHEEN = chr(126644)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_TEH = chr(126645)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_THEH = chr(126646)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_KHAH = chr(126647)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_THAL = chr(126648)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_DAD = chr(126649)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_ZAH = chr(126650)
ARABIC_MATHEMATICAL_DOUBLE_STRUCK_GHAIN = chr(126651)
ARABIC_MATHEMATICAL_OPERATOR_MEEM_WITH_HAH_WITH_TATWEEL = chr(126704)
ARABIC_MATHEMATICAL_OPERATOR_HAH_WITH_DAL = chr(126705)
MAHJONG_TILE_EAST_WIND = chr(126976)
MAHJONG_TILE_SOUTH_WIND = chr(126977)
MAHJONG_TILE_WEST_WIND = chr(126978)
MAHJONG_TILE_NORTH_WIND = chr(126979)
MAHJONG_TILE_RED_DRAGON = chr(126980)
MAHJONG_TILE_GREEN_DRAGON = chr(126981)
MAHJONG_TILE_WHITE_DRAGON = chr(126982)
MAHJONG_TILE_ONE_OF_CHARACTERS = chr(126983)
MAHJONG_TILE_TWO_OF_CHARACTERS = chr(126984)
MAHJONG_TILE_THREE_OF_CHARACTERS = chr(126985)
MAHJONG_TILE_FOUR_OF_CHARACTERS = chr(126986)
MAHJONG_TILE_FIVE_OF_CHARACTERS = chr(126987)
MAHJONG_TILE_SIX_OF_CHARACTERS = chr(126988)
MAHJONG_TILE_SEVEN_OF_CHARACTERS = chr(126989)
MAHJONG_TILE_EIGHT_OF_CHARACTERS = chr(126990)
MAHJONG_TILE_NINE_OF_CHARACTERS = chr(126991)
MAHJONG_TILE_ONE_OF_BAMBOOS = chr(126992)
MAHJONG_TILE_TWO_OF_BAMBOOS = chr(126993)
MAHJONG_TILE_THREE_OF_BAMBOOS = chr(126994)
MAHJONG_TILE_FOUR_OF_BAMBOOS = chr(126995)
MAHJONG_TILE_FIVE_OF_BAMBOOS = chr(126996)
MAHJONG_TILE_SIX_OF_BAMBOOS = chr(126997)
MAHJONG_TILE_SEVEN_OF_BAMBOOS = chr(126998)
MAHJONG_TILE_EIGHT_OF_BAMBOOS = chr(126999)
MAHJONG_TILE_NINE_OF_BAMBOOS = chr(127000)
MAHJONG_TILE_ONE_OF_CIRCLES = chr(127001)
MAHJONG_TILE_TWO_OF_CIRCLES = chr(127002)
MAHJONG_TILE_THREE_OF_CIRCLES = chr(127003)
MAHJONG_TILE_FOUR_OF_CIRCLES = chr(127004)
MAHJONG_TILE_FIVE_OF_CIRCLES = chr(127005)
MAHJONG_TILE_SIX_OF_CIRCLES = chr(127006)
MAHJONG_TILE_SEVEN_OF_CIRCLES = chr(127007)
MAHJONG_TILE_EIGHT_OF_CIRCLES = chr(127008)
MAHJONG_TILE_NINE_OF_CIRCLES = chr(127009)
MAHJONG_TILE_PLUM = chr(127010)
MAHJONG_TILE_ORCHID = chr(127011)
MAHJONG_TILE_BAMBOO = chr(127012)
MAHJONG_TILE_CHRYSANTHEMUM = chr(127013)
MAHJONG_TILE_SPRING = chr(127014)
MAHJONG_TILE_SUMMER = chr(127015)
MAHJONG_TILE_AUTUMN = chr(127016)
MAHJONG_TILE_WINTER = chr(127017)
MAHJONG_TILE_JOKER = chr(127018)
MAHJONG_TILE_BACK = chr(127019)
DOMINO_TILE_HORIZONTAL_BACK = chr(127024)
DOMINO_TILE_HORIZONTAL_00_00 = chr(127025)
DOMINO_TILE_HORIZONTAL_00_01 = chr(127026)
DOMINO_TILE_HORIZONTAL_00_02 = chr(127027)
DOMINO_TILE_HORIZONTAL_00_03 = chr(127028)
DOMINO_TILE_HORIZONTAL_00_04 = chr(127029)
DOMINO_TILE_HORIZONTAL_00_05 = chr(127030)
DOMINO_TILE_HORIZONTAL_00_06 = chr(127031)
DOMINO_TILE_HORIZONTAL_01_00 = chr(127032)
DOMINO_TILE_HORIZONTAL_01_01 = chr(127033)
DOMINO_TILE_HORIZONTAL_01_02 = chr(127034)
DOMINO_TILE_HORIZONTAL_01_03 = chr(127035)
DOMINO_TILE_HORIZONTAL_01_04 = chr(127036)
DOMINO_TILE_HORIZONTAL_01_05 = chr(127037)
DOMINO_TILE_HORIZONTAL_01_06 = chr(127038)
DOMINO_TILE_HORIZONTAL_02_00 = chr(127039)
DOMINO_TILE_HORIZONTAL_02_01 = chr(127040)
DOMINO_TILE_HORIZONTAL_02_02 = chr(127041)
DOMINO_TILE_HORIZONTAL_02_03 = chr(127042)
DOMINO_TILE_HORIZONTAL_02_04 = chr(127043)
DOMINO_TILE_HORIZONTAL_02_05 = chr(127044)
DOMINO_TILE_HORIZONTAL_02_06 = chr(127045)
DOMINO_TILE_HORIZONTAL_03_00 = chr(127046)
DOMINO_TILE_HORIZONTAL_03_01 = chr(127047)
DOMINO_TILE_HORIZONTAL_03_02 = chr(127048)
DOMINO_TILE_HORIZONTAL_03_03 = chr(127049)
DOMINO_TILE_HORIZONTAL_03_04 = chr(127050)
DOMINO_TILE_HORIZONTAL_03_05 = chr(127051)
DOMINO_TILE_HORIZONTAL_03_06 = chr(127052)
DOMINO_TILE_HORIZONTAL_04_00 = chr(127053)
DOMINO_TILE_HORIZONTAL_04_01 = chr(127054)
DOMINO_TILE_HORIZONTAL_04_02 = chr(127055)
DOMINO_TILE_HORIZONTAL_04_03 = chr(127056)
DOMINO_TILE_HORIZONTAL_04_04 = chr(127057)
DOMINO_TILE_HORIZONTAL_04_05 = chr(127058)
DOMINO_TILE_HORIZONTAL_04_06 = chr(127059)
DOMINO_TILE_HORIZONTAL_05_00 = chr(127060)
DOMINO_TILE_HORIZONTAL_05_01 = chr(127061)
DOMINO_TILE_HORIZONTAL_05_02 = chr(127062)
DOMINO_TILE_HORIZONTAL_05_03 = chr(127063)
DOMINO_TILE_HORIZONTAL_05_04 = chr(127064)
DOMINO_TILE_HORIZONTAL_05_05 = chr(127065)
DOMINO_TILE_HORIZONTAL_05_06 = chr(127066)
DOMINO_TILE_HORIZONTAL_06_00 = chr(127067)
DOMINO_TILE_HORIZONTAL_06_01 = chr(127068)
DOMINO_TILE_HORIZONTAL_06_02 = chr(127069)
DOMINO_TILE_HORIZONTAL_06_03 = chr(127070)
DOMINO_TILE_HORIZONTAL_06_04 = chr(127071)
DOMINO_TILE_HORIZONTAL_06_05 = chr(127072)
DOMINO_TILE_HORIZONTAL_06_06 = chr(127073)
DOMINO_TILE_VERTICAL_BACK = chr(127074)
DOMINO_TILE_VERTICAL_00_00 = chr(127075)
DOMINO_TILE_VERTICAL_00_01 = chr(127076)
DOMINO_TILE_VERTICAL_00_02 = chr(127077)
DOMINO_TILE_VERTICAL_00_03 = chr(127078)
DOMINO_TILE_VERTICAL_00_04 = chr(127079)
DOMINO_TILE_VERTICAL_00_05 = chr(127080)
DOMINO_TILE_VERTICAL_00_06 = chr(127081)
DOMINO_TILE_VERTICAL_01_00 = chr(127082)
DOMINO_TILE_VERTICAL_01_01 = chr(127083)
DOMINO_TILE_VERTICAL_01_02 = chr(127084)
DOMINO_TILE_VERTICAL_01_03 = chr(127085)
DOMINO_TILE_VERTICAL_01_04 = chr(127086)
DOMINO_TILE_VERTICAL_01_05 = chr(127087)
DOMINO_TILE_VERTICAL_01_06 = chr(127088)
DOMINO_TILE_VERTICAL_02_00 = chr(127089)
DOMINO_TILE_VERTICAL_02_01 = chr(127090)
DOMINO_TILE_VERTICAL_02_02 = chr(127091)
DOMINO_TILE_VERTICAL_02_03 = chr(127092)
DOMINO_TILE_VERTICAL_02_04 = chr(127093)
DOMINO_TILE_VERTICAL_02_05 = chr(127094)
DOMINO_TILE_VERTICAL_02_06 = chr(127095)
DOMINO_TILE_VERTICAL_03_00 = chr(127096)
DOMINO_TILE_VERTICAL_03_01 = chr(127097)
DOMINO_TILE_VERTICAL_03_02 = chr(127098)
DOMINO_TILE_VERTICAL_03_03 = chr(127099)
DOMINO_TILE_VERTICAL_03_04 = chr(127100)
DOMINO_TILE_VERTICAL_03_05 = chr(127101)
DOMINO_TILE_VERTICAL_03_06 = chr(127102)
DOMINO_TILE_VERTICAL_04_00 = chr(127103)
DOMINO_TILE_VERTICAL_04_01 = chr(127104)
DOMINO_TILE_VERTICAL_04_02 = chr(127105)
DOMINO_TILE_VERTICAL_04_03 = chr(127106)
DOMINO_TILE_VERTICAL_04_04 = chr(127107)
DOMINO_TILE_VERTICAL_04_05 = chr(127108)
DOMINO_TILE_VERTICAL_04_06 = chr(127109)
DOMINO_TILE_VERTICAL_05_00 = chr(127110)
DOMINO_TILE_VERTICAL_05_01 = chr(127111)
DOMINO_TILE_VERTICAL_05_02 = chr(127112)
DOMINO_TILE_VERTICAL_05_03 = chr(127113)
DOMINO_TILE_VERTICAL_05_04 = chr(127114)
DOMINO_TILE_VERTICAL_05_05 = chr(127115)
DOMINO_TILE_VERTICAL_05_06 = chr(127116)
DOMINO_TILE_VERTICAL_06_00 = chr(127117)
DOMINO_TILE_VERTICAL_06_01 = chr(127118)
DOMINO_TILE_VERTICAL_06_02 = chr(127119)
DOMINO_TILE_VERTICAL_06_03 = chr(127120)
DOMINO_TILE_VERTICAL_06_04 = chr(127121)
DOMINO_TILE_VERTICAL_06_05 = chr(127122)
DOMINO_TILE_VERTICAL_06_06 = chr(127123)
PLAYING_CARD_BACK = chr(127136)
PLAYING_CARD_ACE_OF_SPADES = chr(127137)
PLAYING_CARD_TWO_OF_SPADES = chr(127138)
PLAYING_CARD_THREE_OF_SPADES = chr(127139)
PLAYING_CARD_FOUR_OF_SPADES = chr(127140)
PLAYING_CARD_FIVE_OF_SPADES = chr(127141)
PLAYING_CARD_SIX_OF_SPADES = chr(127142)
PLAYING_CARD_SEVEN_OF_SPADES = chr(127143)
PLAYING_CARD_EIGHT_OF_SPADES = chr(127144)
PLAYING_CARD_NINE_OF_SPADES = chr(127145)
PLAYING_CARD_TEN_OF_SPADES = chr(127146)
PLAYING_CARD_JACK_OF_SPADES = chr(127147)
PLAYING_CARD_KNIGHT_OF_SPADES = chr(127148)
PLAYING_CARD_QUEEN_OF_SPADES = chr(127149)
PLAYING_CARD_KING_OF_SPADES = chr(127150)
PLAYING_CARD_ACE_OF_HEARTS = chr(127153)
PLAYING_CARD_TWO_OF_HEARTS = chr(127154)
PLAYING_CARD_THREE_OF_HEARTS = chr(127155)
PLAYING_CARD_FOUR_OF_HEARTS = chr(127156)
PLAYING_CARD_FIVE_OF_HEARTS = chr(127157)
PLAYING_CARD_SIX_OF_HEARTS = chr(127158)
PLAYING_CARD_SEVEN_OF_HEARTS = chr(127159)
PLAYING_CARD_EIGHT_OF_HEARTS = chr(127160)
PLAYING_CARD_NINE_OF_HEARTS = chr(127161)
PLAYING_CARD_TEN_OF_HEARTS = chr(127162)
PLAYING_CARD_JACK_OF_HEARTS = chr(127163)
PLAYING_CARD_KNIGHT_OF_HEARTS = chr(127164)
PLAYING_CARD_QUEEN_OF_HEARTS = chr(127165)
PLAYING_CARD_KING_OF_HEARTS = chr(127166)
PLAYING_CARD_RED_JOKER = chr(127167)
PLAYING_CARD_ACE_OF_DIAMONDS = chr(127169)
PLAYING_CARD_TWO_OF_DIAMONDS = chr(127170)
PLAYING_CARD_THREE_OF_DIAMONDS = chr(127171)
PLAYING_CARD_FOUR_OF_DIAMONDS = chr(127172)
PLAYING_CARD_FIVE_OF_DIAMONDS = chr(127173)
PLAYING_CARD_SIX_OF_DIAMONDS = chr(127174)
PLAYING_CARD_SEVEN_OF_DIAMONDS = chr(127175)
PLAYING_CARD_EIGHT_OF_DIAMONDS = chr(127176)
PLAYING_CARD_NINE_OF_DIAMONDS = chr(127177)
PLAYING_CARD_TEN_OF_DIAMONDS = chr(127178)
PLAYING_CARD_JACK_OF_DIAMONDS = chr(127179)
PLAYING_CARD_KNIGHT_OF_DIAMONDS = chr(127180)
PLAYING_CARD_QUEEN_OF_DIAMONDS = chr(127181)
PLAYING_CARD_KING_OF_DIAMONDS = chr(127182)
PLAYING_CARD_BLACK_JOKER = chr(127183)
PLAYING_CARD_ACE_OF_CLUBS = chr(127185)
PLAYING_CARD_TWO_OF_CLUBS = chr(127186)
PLAYING_CARD_THREE_OF_CLUBS = chr(127187)
PLAYING_CARD_FOUR_OF_CLUBS = chr(127188)
PLAYING_CARD_FIVE_OF_CLUBS = chr(127189)
PLAYING_CARD_SIX_OF_CLUBS = chr(127190)
PLAYING_CARD_SEVEN_OF_CLUBS = chr(127191)
PLAYING_CARD_EIGHT_OF_CLUBS = chr(127192)
PLAYING_CARD_NINE_OF_CLUBS = chr(127193)
PLAYING_CARD_TEN_OF_CLUBS = chr(127194)
PLAYING_CARD_JACK_OF_CLUBS = chr(127195)
PLAYING_CARD_KNIGHT_OF_CLUBS = chr(127196)
PLAYING_CARD_QUEEN_OF_CLUBS = chr(127197)
PLAYING_CARD_KING_OF_CLUBS = chr(127198)
PLAYING_CARD_WHITE_JOKER = chr(127199)
PLAYING_CARD_FOOL = chr(127200)
PLAYING_CARD_TRUMP_1 = chr(127201)
PLAYING_CARD_TRUMP_2 = chr(127202)
PLAYING_CARD_TRUMP_3 = chr(127203)
PLAYING_CARD_TRUMP_4 = chr(127204)
PLAYING_CARD_TRUMP_5 = chr(127205)
PLAYING_CARD_TRUMP_6 = chr(127206)
PLAYING_CARD_TRUMP_7 = chr(127207)
PLAYING_CARD_TRUMP_8 = chr(127208)
PLAYING_CARD_TRUMP_9 = chr(127209)
PLAYING_CARD_TRUMP_10 = chr(127210)
PLAYING_CARD_TRUMP_11 = chr(127211)
PLAYING_CARD_TRUMP_12 = chr(127212)
PLAYING_CARD_TRUMP_13 = chr(127213)
PLAYING_CARD_TRUMP_14 = chr(127214)
PLAYING_CARD_TRUMP_15 = chr(127215)
PLAYING_CARD_TRUMP_16 = chr(127216)
PLAYING_CARD_TRUMP_17 = chr(127217)
PLAYING_CARD_TRUMP_18 = chr(127218)
PLAYING_CARD_TRUMP_19 = chr(127219)
PLAYING_CARD_TRUMP_20 = chr(127220)
PLAYING_CARD_TRUMP_21 = chr(127221)
DIGIT_ZERO_FULL_STOP = chr(127232)
DIGIT_ZERO_COMMA = chr(127233)
DIGIT_ONE_COMMA = chr(127234)
DIGIT_TWO_COMMA = chr(127235)
DIGIT_THREE_COMMA = chr(127236)
DIGIT_FOUR_COMMA = chr(127237)
DIGIT_FIVE_COMMA = chr(127238)
DIGIT_SIX_COMMA = chr(127239)
DIGIT_SEVEN_COMMA = chr(127240)
DIGIT_EIGHT_COMMA = chr(127241)
DIGIT_NINE_COMMA = chr(127242)
DINGBAT_CIRCLED_SANS_SERIF_DIGIT_ZERO = chr(127243)
DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_ZERO = chr(127244)
CIRCLED_ZERO_WITH_SLASH = chr(127245)
CIRCLED_ANTICLOCKWISE_ARROW = chr(127246)
CIRCLED_DOLLAR_SIGN_WITH_OVERLAID_BACKSLASH = chr(127247)
PARENTHESIZED_LATIN_CAPITAL_LETTER_A = chr(127248)
PARENTHESIZED_LATIN_CAPITAL_LETTER_B = chr(127249)
PARENTHESIZED_LATIN_CAPITAL_LETTER_C = chr(127250)
PARENTHESIZED_LATIN_CAPITAL_LETTER_D = chr(127251)
PARENTHESIZED_LATIN_CAPITAL_LETTER_E = chr(127252)
PARENTHESIZED_LATIN_CAPITAL_LETTER_F = chr(127253)
PARENTHESIZED_LATIN_CAPITAL_LETTER_G = chr(127254)
PARENTHESIZED_LATIN_CAPITAL_LETTER_H = chr(127255)
PARENTHESIZED_LATIN_CAPITAL_LETTER_I = chr(127256)
PARENTHESIZED_LATIN_CAPITAL_LETTER_J = chr(127257)
PARENTHESIZED_LATIN_CAPITAL_LETTER_K = chr(127258)
PARENTHESIZED_LATIN_CAPITAL_LETTER_L = chr(127259)
PARENTHESIZED_LATIN_CAPITAL_LETTER_M = chr(127260)
PARENTHESIZED_LATIN_CAPITAL_LETTER_N = chr(127261)
PARENTHESIZED_LATIN_CAPITAL_LETTER_O = chr(127262)
PARENTHESIZED_LATIN_CAPITAL_LETTER_P = chr(127263)
PARENTHESIZED_LATIN_CAPITAL_LETTER_Q = chr(127264)
PARENTHESIZED_LATIN_CAPITAL_LETTER_R = chr(127265)
PARENTHESIZED_LATIN_CAPITAL_LETTER_S = chr(127266)
PARENTHESIZED_LATIN_CAPITAL_LETTER_T = chr(127267)
PARENTHESIZED_LATIN_CAPITAL_LETTER_U = chr(127268)
PARENTHESIZED_LATIN_CAPITAL_LETTER_V = chr(127269)
PARENTHESIZED_LATIN_CAPITAL_LETTER_W = chr(127270)
PARENTHESIZED_LATIN_CAPITAL_LETTER_X = chr(127271)
PARENTHESIZED_LATIN_CAPITAL_LETTER_Y = chr(127272)
PARENTHESIZED_LATIN_CAPITAL_LETTER_Z = chr(127273)
TORTOISE_SHELL_BRACKETED_LATIN_CAPITAL_LETTER_S = chr(127274)
CIRCLED_ITALIC_LATIN_CAPITAL_LETTER_C = chr(127275)
CIRCLED_ITALIC_LATIN_CAPITAL_LETTER_R = chr(127276)
CIRCLED_CD = chr(127277)
CIRCLED_WZ = chr(127278)
COPYLEFT_SYMBOL = chr(127279)
SQUARED_LATIN_CAPITAL_LETTER_A = chr(127280)
SQUARED_LATIN_CAPITAL_LETTER_B = chr(127281)
SQUARED_LATIN_CAPITAL_LETTER_C = chr(127282)
SQUARED_LATIN_CAPITAL_LETTER_D = chr(127283)
SQUARED_LATIN_CAPITAL_LETTER_E = chr(127284)
SQUARED_LATIN_CAPITAL_LETTER_F = chr(127285)
SQUARED_LATIN_CAPITAL_LETTER_G = chr(127286)
SQUARED_LATIN_CAPITAL_LETTER_H = chr(127287)
SQUARED_LATIN_CAPITAL_LETTER_I = chr(127288)
SQUARED_LATIN_CAPITAL_LETTER_J = chr(127289)
SQUARED_LATIN_CAPITAL_LETTER_K = chr(127290)
SQUARED_LATIN_CAPITAL_LETTER_L = chr(127291)
SQUARED_LATIN_CAPITAL_LETTER_M = chr(127292)
SQUARED_LATIN_CAPITAL_LETTER_N = chr(127293)
SQUARED_LATIN_CAPITAL_LETTER_O = chr(127294)
SQUARED_LATIN_CAPITAL_LETTER_P = chr(127295)
SQUARED_LATIN_CAPITAL_LETTER_Q = chr(127296)
SQUARED_LATIN_CAPITAL_LETTER_R = chr(127297)
SQUARED_LATIN_CAPITAL_LETTER_S = chr(127298)
SQUARED_LATIN_CAPITAL_LETTER_T = chr(127299)
SQUARED_LATIN_CAPITAL_LETTER_U = chr(127300)
SQUARED_LATIN_CAPITAL_LETTER_V = chr(127301)
SQUARED_LATIN_CAPITAL_LETTER_W = chr(127302)
SQUARED_LATIN_CAPITAL_LETTER_X = chr(127303)
SQUARED_LATIN_CAPITAL_LETTER_Y = chr(127304)
SQUARED_LATIN_CAPITAL_LETTER_Z = chr(127305)
SQUARED_HV = chr(127306)
SQUARED_MV = chr(127307)
SQUARED_SD = chr(127308)
SQUARED_SS = chr(127309)
SQUARED_PPV = chr(127310)
SQUARED_WC = chr(127311)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_A = chr(127312)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_B = chr(127313)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_C = chr(127314)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_D = chr(127315)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_E = chr(127316)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_F = chr(127317)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_G = chr(127318)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_H = chr(127319)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_I = chr(127320)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_J = chr(127321)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_K = chr(127322)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_L = chr(127323)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_M = chr(127324)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_N = chr(127325)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_O = chr(127326)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_P = chr(127327)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_Q = chr(127328)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_R = chr(127329)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_S = chr(127330)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_T = chr(127331)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_U = chr(127332)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_V = chr(127333)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_W = chr(127334)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_X = chr(127335)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_Y = chr(127336)
NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_Z = chr(127337)
RAISED_MC_SIGN = chr(127338)
RAISED_MD_SIGN = chr(127339)
RAISED_MR_SIGN = chr(127340)
CIRCLED_CC = chr(127341)
CIRCLED_C_WITH_OVERLAID_BACKSLASH = chr(127342)
CIRCLED_HUMAN_FIGURE = chr(127343)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_A = chr(127344)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_B = chr(127345)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_C = chr(127346)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_D = chr(127347)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_E = chr(127348)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_F = chr(127349)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_G = chr(127350)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_H = chr(127351)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_I = chr(127352)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_J = chr(127353)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_K = chr(127354)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_L = chr(127355)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_M = chr(127356)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_N = chr(127357)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_O = chr(127358)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_P = chr(127359)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_Q = chr(127360)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_R = chr(127361)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_S = chr(127362)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_T = chr(127363)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_U = chr(127364)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_V = chr(127365)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_W = chr(127366)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_X = chr(127367)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_Y = chr(127368)
NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_Z = chr(127369)
CROSSED_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_P = chr(127370)
NEGATIVE_SQUARED_IC = chr(127371)
NEGATIVE_SQUARED_PA = chr(127372)
NEGATIVE_SQUARED_SA = chr(127373)
NEGATIVE_SQUARED_AB = chr(127374)
NEGATIVE_SQUARED_WC = chr(127375)
SQUARE_DJ = chr(127376)
SQUARED_CL = chr(127377)
SQUARED_COOL = chr(127378)
SQUARED_FREE = chr(127379)
SQUARED_ID = chr(127380)
SQUARED_NEW = chr(127381)
SQUARED_NG = chr(127382)
SQUARED_OK = chr(127383)
SQUARED_SOS = chr(127384)
SQUARED_UP_WITH_EXCLAMATION_MARK = chr(127385)
SQUARED_VS = chr(127386)
SQUARED_THREE_D = chr(127387)
SQUARED_SECOND_SCREEN = chr(127388)
SQUARED_TWO_K = chr(127389)
SQUARED_FOUR_K = chr(127390)
SQUARED_EIGHT_K = chr(127391)
SQUARED_FIVE_POINT_ONE = chr(127392)
SQUARED_SEVEN_POINT_ONE = chr(127393)
SQUARED_TWENTY_TWO_POINT_TWO = chr(127394)
SQUARED_SIXTY_P = chr(127395)
SQUARED_ONE_HUNDRED_TWENTY_P = chr(127396)
SQUARED_LATIN_SMALL_LETTER_D = chr(127397)
SQUARED_HC = chr(127398)
SQUARED_HDR = chr(127399)
SQUARED_HI_RES = chr(127400)
SQUARED_LOSSLESS = chr(127401)
SQUARED_SHV = chr(127402)
SQUARED_UHD = chr(127403)
SQUARED_VOD = chr(127404)
MASK_WORK_SYMBOL = chr(127405)
REGIONAL_INDICATOR_SYMBOL_LETTER_A = chr(127462)
REGIONAL_INDICATOR_SYMBOL_LETTER_B = chr(127463)
REGIONAL_INDICATOR_SYMBOL_LETTER_C = chr(127464)
REGIONAL_INDICATOR_SYMBOL_LETTER_D = chr(127465)
REGIONAL_INDICATOR_SYMBOL_LETTER_E = chr(127466)
REGIONAL_INDICATOR_SYMBOL_LETTER_F = chr(127467)
REGIONAL_INDICATOR_SYMBOL_LETTER_G = chr(127468)
REGIONAL_INDICATOR_SYMBOL_LETTER_H = chr(127469)
REGIONAL_INDICATOR_SYMBOL_LETTER_I = chr(127470)
REGIONAL_INDICATOR_SYMBOL_LETTER_J = chr(127471)
REGIONAL_INDICATOR_SYMBOL_LETTER_K = chr(127472)
REGIONAL_INDICATOR_SYMBOL_LETTER_L = chr(127473)
REGIONAL_INDICATOR_SYMBOL_LETTER_M = chr(127474)
REGIONAL_INDICATOR_SYMBOL_LETTER_N = chr(127475)
REGIONAL_INDICATOR_SYMBOL_LETTER_O = chr(127476)
REGIONAL_INDICATOR_SYMBOL_LETTER_P = chr(127477)
REGIONAL_INDICATOR_SYMBOL_LETTER_Q = chr(127478)
REGIONAL_INDICATOR_SYMBOL_LETTER_R = chr(127479)
REGIONAL_INDICATOR_SYMBOL_LETTER_S = chr(127480)
REGIONAL_INDICATOR_SYMBOL_LETTER_T = chr(127481)
REGIONAL_INDICATOR_SYMBOL_LETTER_U = chr(127482)
REGIONAL_INDICATOR_SYMBOL_LETTER_V = chr(127483)
REGIONAL_INDICATOR_SYMBOL_LETTER_W = chr(127484)
REGIONAL_INDICATOR_SYMBOL_LETTER_X = chr(127485)
REGIONAL_INDICATOR_SYMBOL_LETTER_Y = chr(127486)
REGIONAL_INDICATOR_SYMBOL_LETTER_Z = chr(127487)
SQUARE_HIRAGANA_HOKA = chr(127488)
SQUARED_KATAKANA_KOKO = chr(127489)
SQUARED_KATAKANA_SA = chr(127490)
SQUARED_CJK_UNIFIED_IDEOGRAPH_624B = chr(127504)
SQUARED_CJK_UNIFIED_IDEOGRAPH_5B57 = chr(127505)
SQUARED_CJK_UNIFIED_IDEOGRAPH_53CC = chr(127506)
SQUARED_KATAKANA_DE = chr(127507)
SQUARED_CJK_UNIFIED_IDEOGRAPH_4E8C = chr(127508)
SQUARED_CJK_UNIFIED_IDEOGRAPH_591A = chr(127509)
SQUARED_CJK_UNIFIED_IDEOGRAPH_89E3 = chr(127510)
SQUARED_CJK_UNIFIED_IDEOGRAPH_5929 = chr(127511)
SQUARED_CJK_UNIFIED_IDEOGRAPH_4EA4 = chr(127512)
SQUARED_CJK_UNIFIED_IDEOGRAPH_6620 = chr(127513)
SQUARED_CJK_UNIFIED_IDEOGRAPH_7121 = chr(127514)
SQUARED_CJK_UNIFIED_IDEOGRAPH_6599 = chr(127515)
SQUARED_CJK_UNIFIED_IDEOGRAPH_524D = chr(127516)
SQUARED_CJK_UNIFIED_IDEOGRAPH_5F8C = chr(127517)
SQUARED_CJK_UNIFIED_IDEOGRAPH_518D = chr(127518)
SQUARED_CJK_UNIFIED_IDEOGRAPH_65B0 = chr(127519)
SQUARED_CJK_UNIFIED_IDEOGRAPH_521D = chr(127520)
SQUARED_CJK_UNIFIED_IDEOGRAPH_7D42 = chr(127521)
SQUARED_CJK_UNIFIED_IDEOGRAPH_751F = chr(127522)
SQUARED_CJK_UNIFIED_IDEOGRAPH_8CA9 = chr(127523)
SQUARED_CJK_UNIFIED_IDEOGRAPH_58F0 = chr(127524)
SQUARED_CJK_UNIFIED_IDEOGRAPH_5439 = chr(127525)
SQUARED_CJK_UNIFIED_IDEOGRAPH_6F14 = chr(127526)
SQUARED_CJK_UNIFIED_IDEOGRAPH_6295 = chr(127527)
SQUARED_CJK_UNIFIED_IDEOGRAPH_6355 = chr(127528)
SQUARED_CJK_UNIFIED_IDEOGRAPH_4E00 = chr(127529)
SQUARED_CJK_UNIFIED_IDEOGRAPH_4E09 = chr(127530)
SQUARED_CJK_UNIFIED_IDEOGRAPH_904A = chr(127531)
SQUARED_CJK_UNIFIED_IDEOGRAPH_5DE6 = chr(127532)
SQUARED_CJK_UNIFIED_IDEOGRAPH_4E2D = chr(127533)
SQUARED_CJK_UNIFIED_IDEOGRAPH_53F3 = chr(127534)
SQUARED_CJK_UNIFIED_IDEOGRAPH_6307 = chr(127535)
SQUARED_CJK_UNIFIED_IDEOGRAPH_8D70 = chr(127536)
SQUARED_CJK_UNIFIED_IDEOGRAPH_6253 = chr(127537)
SQUARED_CJK_UNIFIED_IDEOGRAPH_7981 = chr(127538)
SQUARED_CJK_UNIFIED_IDEOGRAPH_7A7A = chr(127539)
SQUARED_CJK_UNIFIED_IDEOGRAPH_5408 = chr(127540)
SQUARED_CJK_UNIFIED_IDEOGRAPH_6E80 = chr(127541)
SQUARED_CJK_UNIFIED_IDEOGRAPH_6709 = chr(127542)
SQUARED_CJK_UNIFIED_IDEOGRAPH_6708 = chr(127543)
SQUARED_CJK_UNIFIED_IDEOGRAPH_7533 = chr(127544)
SQUARED_CJK_UNIFIED_IDEOGRAPH_5272 = chr(127545)
SQUARED_CJK_UNIFIED_IDEOGRAPH_55B6 = chr(127546)
SQUARED_CJK_UNIFIED_IDEOGRAPH_914D = chr(127547)
TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_672C = chr(127552)
TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_4E09 = chr(127553)
TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_4E8C = chr(127554)
TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_5B89 = chr(127555)
TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_70B9 = chr(127556)
TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_6253 = chr(127557)
TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_76D7 = chr(127558)
TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_52DD = chr(127559)
TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_6557 = chr(127560)
CIRCLED_IDEOGRAPH_ADVANTAGE = chr(127568)
CIRCLED_IDEOGRAPH_ACCEPT = chr(127569)
ROUNDED_SYMBOL_FOR_FU = chr(127584)
ROUNDED_SYMBOL_FOR_LU = chr(127585)
ROUNDED_SYMBOL_FOR_SHOU = chr(127586)
ROUNDED_SYMBOL_FOR_XI = chr(127587)
ROUNDED_SYMBOL_FOR_SHUANGXI = chr(127588)
ROUNDED_SYMBOL_FOR_CAI = chr(127589)
CYCLONE = chr(127744)
FOGGY = chr(127745)
CLOSED_UMBRELLA = chr(127746)
NIGHT_WITH_STARS = chr(127747)
SUNRISE_OVER_MOUNTAINS = chr(127748)
SUNRISE = chr(127749)
CITYSCAPE_AT_DUSK = chr(127750)
SUNSET_OVER_BUILDINGS = chr(127751)
RAINBOW = chr(127752)
BRIDGE_AT_NIGHT = chr(127753)
WATER_WAVE = chr(127754)
VOLCANO = chr(127755)
MILKY_WAY = chr(127756)
EARTH_GLOBE_EUROPE_AFRICA = chr(127757)
EARTH_GLOBE_AMERICAS = chr(127758)
EARTH_GLOBE_ASIA_AUSTRALIA = chr(127759)
GLOBE_WITH_MERIDIANS = chr(127760)
NEW_MOON_SYMBOL = chr(127761)
WAXING_CRESCENT_MOON_SYMBOL = chr(127762)
FIRST_QUARTER_MOON_SYMBOL = chr(127763)
WAXING_GIBBOUS_MOON_SYMBOL = chr(127764)
FULL_MOON_SYMBOL = chr(127765)
WANING_GIBBOUS_MOON_SYMBOL = chr(127766)
LAST_QUARTER_MOON_SYMBOL = chr(127767)
WANING_CRESCENT_MOON_SYMBOL = chr(127768)
CRESCENT_MOON = chr(127769)
NEW_MOON_WITH_FACE = chr(127770)
FIRST_QUARTER_MOON_WITH_FACE = chr(127771)
LAST_QUARTER_MOON_WITH_FACE = chr(127772)
FULL_MOON_WITH_FACE = chr(127773)
SUN_WITH_FACE = chr(127774)
GLOWING_STAR = chr(127775)
SHOOTING_STAR = chr(127776)
THERMOMETER = chr(127777)
BLACK_DROPLET = chr(127778)
WHITE_SUN = chr(127779)
WHITE_SUN_WITH_SMALL_CLOUD = chr(127780)
WHITE_SUN_BEHIND_CLOUD = chr(127781)
WHITE_SUN_BEHIND_CLOUD_WITH_RAIN = chr(127782)
CLOUD_WITH_RAIN = chr(127783)
CLOUD_WITH_SNOW = chr(127784)
CLOUD_WITH_LIGHTNING = chr(127785)
CLOUD_WITH_TORNADO = chr(127786)
FOG = chr(127787)
WIND_BLOWING_FACE = chr(127788)
HOT_DOG = chr(127789)
TACO = chr(127790)
BURRITO = chr(127791)
CHESTNUT = chr(127792)
SEEDLING = chr(127793)
EVERGREEN_TREE = chr(127794)
DECIDUOUS_TREE = chr(127795)
PALM_TREE = chr(127796)
CACTUS = chr(127797)
HOT_PEPPER = chr(127798)
TULIP = chr(127799)
CHERRY_BLOSSOM = chr(127800)
ROSE = chr(127801)
HIBISCUS = chr(127802)
SUNFLOWER = chr(127803)
BLOSSOM = chr(127804)
EAR_OF_MAIZE = chr(127805)
EAR_OF_RICE = chr(127806)
HERB = chr(127807)
FOUR_LEAF_CLOVER = chr(127808)
MAPLE_LEAF = chr(127809)
FALLEN_LEAF = chr(127810)
LEAF_FLUTTERING_IN_WIND = chr(127811)
MUSHROOM = chr(127812)
TOMATO = chr(127813)
AUBERGINE = chr(127814)
GRAPES = chr(127815)
MELON = chr(127816)
WATERMELON = chr(127817)
TANGERINE = chr(127818)
LEMON = chr(127819)
BANANA = chr(127820)
PINEAPPLE = chr(127821)
RED_APPLE = chr(127822)
GREEN_APPLE = chr(127823)
PEAR = chr(127824)
PEACH = chr(127825)
CHERRIES = chr(127826)
STRAWBERRY = chr(127827)
HAMBURGER = chr(127828)
SLICE_OF_PIZZA = chr(127829)
MEAT_ON_BONE = chr(127830)
POULTRY_LEG = chr(127831)
RICE_CRACKER = chr(127832)
RICE_BALL = chr(127833)
COOKED_RICE = chr(127834)
CURRY_AND_RICE = chr(127835)
STEAMING_BOWL = chr(127836)
SPAGHETTI = chr(127837)
BREAD = chr(127838)
FRENCH_FRIES = chr(127839)
ROASTED_SWEET_POTATO = chr(127840)
DANGO = chr(127841)
ODEN = chr(127842)
SUSHI = chr(127843)
FRIED_SHRIMP = chr(127844)
FISH_CAKE_WITH_SWIRL_DESIGN = chr(127845)
SOFT_ICE_CREAM = chr(127846)
SHAVED_ICE = chr(127847)
ICE_CREAM = chr(127848)
DOUGHNUT = chr(127849)
COOKIE = chr(127850)
CHOCOLATE_BAR = chr(127851)
CANDY = chr(127852)
LOLLIPOP = chr(127853)
CUSTARD = chr(127854)
HONEY_POT = chr(127855)
SHORTCAKE = chr(127856)
BENTO_BOX = chr(127857)
POT_OF_FOOD = chr(127858)
COOKING = chr(127859)
FORK_AND_KNIFE = chr(127860)
TEACUP_WITHOUT_HANDLE = chr(127861)
SAKE_BOTTLE_AND_CUP = chr(127862)
WINE_GLASS = chr(127863)
COCKTAIL_GLASS = chr(127864)
TROPICAL_DRINK = chr(127865)
BEER_MUG = chr(127866)
CLINKING_BEER_MUGS = chr(127867)
BABY_BOTTLE = chr(127868)
FORK_AND_KNIFE_WITH_PLATE = chr(127869)
BOTTLE_WITH_POPPING_CORK = chr(127870)
POPCORN = chr(127871)
RIBBON = chr(127872)
WRAPPED_PRESENT = chr(127873)
BIRTHDAY_CAKE = chr(127874)
JACK_O_LANTERN = chr(127875)
CHRISTMAS_TREE = chr(127876)
FATHER_CHRISTMAS = chr(127877)
FIREWORKS = chr(127878)
FIREWORK_SPARKLER = chr(127879)
BALLOON = chr(127880)
PARTY_POPPER = chr(127881)
CONFETTI_BALL = chr(127882)
TANABATA_TREE = chr(127883)
CROSSED_FLAGS = chr(127884)
PINE_DECORATION = chr(127885)
JAPANESE_DOLLS = chr(127886)
CARP_STREAMER = chr(127887)
WIND_CHIME = chr(127888)
MOON_VIEWING_CEREMONY = chr(127889)
SCHOOL_SATCHEL = chr(127890)
GRADUATION_CAP = chr(127891)
HEART_WITH_TIP_ON_THE_LEFT = chr(127892)
BOUQUET_OF_FLOWERS = chr(127893)
MILITARY_MEDAL = chr(127894)
REMINDER_RIBBON = chr(127895)
MUSICAL_KEYBOARD_WITH_JACKS = chr(127896)
STUDIO_MICROPHONE = chr(127897)
LEVEL_SLIDER = chr(127898)
CONTROL_KNOBS = chr(127899)
BEAMED_ASCENDING_MUSICAL_NOTES = chr(127900)
BEAMED_DESCENDING_MUSICAL_NOTES = chr(127901)
FILM_FRAMES = chr(127902)
ADMISSION_TICKETS = chr(127903)
CAROUSEL_HORSE = chr(127904)
FERRIS_WHEEL = chr(127905)
ROLLER_COASTER = chr(127906)
FISHING_POLE_AND_FISH = chr(127907)
MICROPHONE = chr(127908)
MOVIE_CAMERA = chr(127909)
CINEMA = chr(127910)
HEADPHONE = chr(127911)
ARTIST_PALETTE = chr(127912)
TOP_HAT = chr(127913)
CIRCUS_TENT = chr(127914)
TICKET = chr(127915)
CLAPPER_BOARD = chr(127916)
PERFORMING_ARTS = chr(127917)
VIDEO_GAME = chr(127918)
DIRECT_HIT = chr(127919)
SLOT_MACHINE = chr(127920)
BILLIARDS = chr(127921)
GAME_DIE = chr(127922)
BOWLING = chr(127923)
FLOWER_PLAYING_CARDS = chr(127924)
MUSICAL_NOTE = chr(127925)
MULTIPLE_MUSICAL_NOTES = chr(127926)
SAXOPHONE = chr(127927)
GUITAR = chr(127928)
MUSICAL_KEYBOARD = chr(127929)
TRUMPET = chr(127930)
VIOLIN = chr(127931)
MUSICAL_SCORE = chr(127932)
RUNNING_SHIRT_WITH_SASH = chr(127933)
TENNIS_RACQUET_AND_BALL = chr(127934)
SKI_AND_SKI_BOOT = chr(127935)
BASKETBALL_AND_HOOP = chr(127936)
CHEQUERED_FLAG = chr(127937)
SNOWBOARDER = chr(127938)
RUNNER = chr(127939)
SURFER = chr(127940)
SPORTS_MEDAL = chr(127941)
TROPHY = chr(127942)
HORSE_RACING = chr(127943)
AMERICAN_FOOTBALL = chr(127944)
RUGBY_FOOTBALL = chr(127945)
SWIMMER = chr(127946)
WEIGHT_LIFTER = chr(127947)
GOLFER = chr(127948)
RACING_MOTORCYCLE = chr(127949)
RACING_CAR = chr(127950)
CRICKET_BAT_AND_BALL = chr(127951)
VOLLEYBALL = chr(127952)
FIELD_HOCKEY_STICK_AND_BALL = chr(127953)
ICE_HOCKEY_STICK_AND_PUCK = chr(127954)
TABLE_TENNIS_PADDLE_AND_BALL = chr(127955)
SNOW_CAPPED_MOUNTAIN = chr(127956)
CAMPING = chr(127957)
BEACH_WITH_UMBRELLA = chr(127958)
BUILDING_CONSTRUCTION = chr(127959)
HOUSE_BUILDINGS = chr(127960)
CITYSCAPE = chr(127961)
DERELICT_HOUSE_BUILDING = chr(127962)
CLASSICAL_BUILDING = chr(127963)
DESERT = chr(127964)
DESERT_ISLAND = chr(127965)
NATIONAL_PARK = chr(127966)
STADIUM = chr(127967)
HOUSE_BUILDING = chr(127968)
HOUSE_WITH_GARDEN = chr(127969)
OFFICE_BUILDING = chr(127970)
JAPANESE_POST_OFFICE = chr(127971)
EUROPEAN_POST_OFFICE = chr(127972)
HOSPITAL = chr(127973)
BANK = chr(127974)
AUTOMATED_TELLER_MACHINE = chr(127975)
HOTEL = chr(127976)
LOVE_HOTEL = chr(127977)
CONVENIENCE_STORE = chr(127978)
SCHOOL = chr(127979)
DEPARTMENT_STORE = chr(127980)
FACTORY = chr(127981)
IZAKAYA_LANTERN = chr(127982)
JAPANESE_CASTLE = chr(127983)
EUROPEAN_CASTLE = chr(127984)
WHITE_PENNANT = chr(127985)
BLACK_PENNANT = chr(127986)
WAVING_WHITE_FLAG = chr(127987)
WAVING_BLACK_FLAG = chr(127988)
ROSETTE = chr(127989)
BLACK_ROSETTE = chr(127990)
LABEL = chr(127991)
BADMINTON_RACQUET_AND_SHUTTLECOCK = chr(127992)
BOW_AND_ARROW = chr(127993)
AMPHORA = chr(127994)
EMOJI_MODIFIER_FITZPATRICK_TYPE_1_2 = chr(127995)
EMOJI_MODIFIER_FITZPATRICK_TYPE_3 = chr(127996)
EMOJI_MODIFIER_FITZPATRICK_TYPE_4 = chr(127997)
EMOJI_MODIFIER_FITZPATRICK_TYPE_5 = chr(127998)
EMOJI_MODIFIER_FITZPATRICK_TYPE_6 = chr(127999)
RAT = chr(128000)
MOUSE = chr(128001)
OX = chr(128002)
WATER_BUFFALO = chr(128003)
COW = chr(128004)
TIGER = chr(128005)
LEOPARD = chr(128006)
RABBIT = chr(128007)
CAT = chr(128008)
DRAGON = chr(128009)
CROCODILE = chr(128010)
WHALE = chr(128011)
SNAIL = chr(128012)
SNAKE = chr(128013)
HORSE = chr(128014)
RAM = chr(128015)
GOAT = chr(128016)
SHEEP = chr(128017)
MONKEY = chr(128018)
ROOSTER = chr(128019)
CHICKEN = chr(128020)
DOG = chr(128021)
PIG = chr(128022)
BOAR = chr(128023)
ELEPHANT = chr(128024)
OCTOPUS = chr(128025)
SPIRAL_SHELL = chr(128026)
BUG = chr(128027)
ANT = chr(128028)
HONEYBEE = chr(128029)
LADY_BEETLE = chr(128030)
FISH = chr(128031)
TROPICAL_FISH = chr(128032)
BLOWFISH = chr(128033)
TURTLE = chr(128034)
HATCHING_CHICK = chr(128035)
BABY_CHICK = chr(128036)
FRONT_FACING_BABY_CHICK = chr(128037)
BIRD = chr(128038)
PENGUIN = chr(128039)
KOALA = chr(128040)
POODLE = chr(128041)
DROMEDARY_CAMEL = chr(128042)
BACTRIAN_CAMEL = chr(128043)
DOLPHIN = chr(128044)
MOUSE_FACE = chr(128045)
COW_FACE = chr(128046)
TIGER_FACE = chr(128047)
RABBIT_FACE = chr(128048)
CAT_FACE = chr(128049)
DRAGON_FACE = chr(128050)
SPOUTING_WHALE = chr(128051)
HORSE_FACE = chr(128052)
MONKEY_FACE = chr(128053)
DOG_FACE = chr(128054)
PIG_FACE = chr(128055)
FROG_FACE = chr(128056)
HAMSTER_FACE = chr(128057)
WOLF_FACE = chr(128058)
BEAR_FACE = chr(128059)
PANDA_FACE = chr(128060)
PIG_NOSE = chr(128061)
PAW_PRINTS = chr(128062)
CHIPMUNK = chr(128063)
EYES = chr(128064)
EYE = chr(128065)
EAR = chr(128066)
NOSE = chr(128067)
MOUTH = chr(128068)
TONGUE = chr(128069)
WHITE_UP_POINTING_BACKHAND_INDEX = chr(128070)
WHITE_DOWN_POINTING_BACKHAND_INDEX = chr(128071)
WHITE_LEFT_POINTING_BACKHAND_INDEX = chr(128072)
WHITE_RIGHT_POINTING_BACKHAND_INDEX = chr(128073)
FISTED_HAND_SIGN = chr(128074)
WAVING_HAND_SIGN = chr(128075)
OK_HAND_SIGN = chr(128076)
THUMBS_UP_SIGN = chr(128077)
THUMBS_DOWN_SIGN = chr(128078)
CLAPPING_HANDS_SIGN = chr(128079)
OPEN_HANDS_SIGN = chr(128080)
CROWN = chr(128081)
WOMANS_HAT = chr(128082)
EYEGLASSES = chr(128083)
NECKTIE = chr(128084)
T_SHIRT = chr(128085)
JEANS = chr(128086)
DRESS = chr(128087)
KIMONO = chr(128088)
BIKINI = chr(128089)
WOMANS_CLOTHES = chr(128090)
PURSE = chr(128091)
HANDBAG = chr(128092)
POUCH = chr(128093)
MANS_SHOE = chr(128094)
ATHLETIC_SHOE = chr(128095)
HIGH_HEELED_SHOE = chr(128096)
WOMANS_SANDAL = chr(128097)
WOMANS_BOOTS = chr(128098)
FOOTPRINTS = chr(128099)
BUST_IN_SILHOUETTE = chr(128100)
BUSTS_IN_SILHOUETTE = chr(128101)
BOY = chr(128102)
GIRL = chr(128103)
MAN = chr(128104)
WOMAN = chr(128105)
FAMILY = chr(128106)
MAN_AND_WOMAN_HOLDING_HANDS = chr(128107)
TWO_MEN_HOLDING_HANDS = chr(128108)
TWO_WOMEN_HOLDING_HANDS = chr(128109)
POLICE_OFFICER = chr(128110)
WOMAN_WITH_BUNNY_EARS = chr(128111)
BRIDE_WITH_VEIL = chr(128112)
PERSON_WITH_BLOND_HAIR = chr(128113)
MAN_WITH_GUA_PI_MAO = chr(128114)
MAN_WITH_TURBAN = chr(128115)
OLDER_MAN = chr(128116)
OLDER_WOMAN = chr(128117)
BABY = chr(128118)
CONSTRUCTION_WORKER = chr(128119)
PRINCESS = chr(128120)
JAPANESE_OGRE = chr(128121)
JAPANESE_GOBLIN = chr(128122)
GHOST = chr(128123)
BABY_ANGEL = chr(128124)
EXTRATERRESTRIAL_ALIEN = chr(128125)
ALIEN_MONSTER = chr(128126)
IMP = chr(128127)
SKULL = chr(128128)
INFORMATION_DESK_PERSON = chr(128129)
GUARDSMAN = chr(128130)
DANCER = chr(128131)
LIPSTICK = chr(128132)
NAIL_POLISH = chr(128133)
FACE_MASSAGE = chr(128134)
HAIRCUT = chr(128135)
BARBER_POLE = chr(128136)
SYRINGE = chr(128137)
PILL = chr(128138)
KISS_MARK = chr(128139)
LOVE_LETTER = chr(128140)
RING = chr(128141)
GEM_STONE = chr(128142)
KISS = chr(128143)
BOUQUET = chr(128144)
COUPLE_WITH_HEART = chr(128145)
WEDDING = chr(128146)
BEATING_HEART = chr(128147)
BROKEN_HEART = chr(128148)
TWO_HEARTS = chr(128149)
SPARKLING_HEART = chr(128150)
GROWING_HEART = chr(128151)
HEART_WITH_ARROW = chr(128152)
BLUE_HEART = chr(128153)
GREEN_HEART = chr(128154)
YELLOW_HEART = chr(128155)
PURPLE_HEART = chr(128156)
HEART_WITH_RIBBON = chr(128157)
REVOLVING_HEARTS = chr(128158)
HEART_DECORATION = chr(128159)
DIAMOND_SHAPE_WITH_A_DOT_INSIDE = chr(128160)
ELECTRIC_LIGHT_BULB = chr(128161)
ANGER_SYMBOL = chr(128162)
BOMB = chr(128163)
SLEEPING_SYMBOL = chr(128164)
COLLISION_SYMBOL = chr(128165)
SPLASHING_SWEAT_SYMBOL = chr(128166)
DROPLET = chr(128167)
DASH_SYMBOL = chr(128168)
PILE_OF_POO = chr(128169)
FLEXED_BICEPS = chr(128170)
DIZZY_SYMBOL = chr(128171)
SPEECH_BALLOON = chr(128172)
THOUGHT_BALLOON = chr(128173)
WHITE_FLOWER = chr(128174)
HUNDRED_POINTS_SYMBOL = chr(128175)
MONEY_BAG = chr(128176)
CURRENCY_EXCHANGE = chr(128177)
HEAVY_DOLLAR_SIGN = chr(128178)
CREDIT_CARD = chr(128179)
BANKNOTE_WITH_YEN_SIGN = chr(128180)
BANKNOTE_WITH_DOLLAR_SIGN = chr(128181)
BANKNOTE_WITH_EURO_SIGN = chr(128182)
BANKNOTE_WITH_POUND_SIGN = chr(128183)
MONEY_WITH_WINGS = chr(128184)
CHART_WITH_UPWARDS_TREND_AND_YEN_SIGN = chr(128185)
SEAT = chr(128186)
PERSONAL_COMPUTER = chr(128187)
BRIEFCASE = chr(128188)
MINIDISC = chr(128189)
FLOPPY_DISK = chr(128190)
OPTICAL_DISC = chr(128191)
DVD = chr(128192)
FILE_FOLDER = chr(128193)
OPEN_FILE_FOLDER = chr(128194)
PAGE_WITH_CURL = chr(128195)
PAGE_FACING_UP = chr(128196)
CALENDAR = chr(128197)
TEAR_OFF_CALENDAR = chr(128198)
CARD_INDEX = chr(128199)
CHART_WITH_UPWARDS_TREND = chr(128200)
CHART_WITH_DOWNWARDS_TREND = chr(128201)
BAR_CHART = chr(128202)
CLIPBOARD = chr(128203)
PUSHPIN = chr(128204)
ROUND_PUSHPIN = chr(128205)
PAPERCLIP = chr(128206)
STRAIGHT_RULER = chr(128207)
TRIANGULAR_RULER = chr(128208)
BOOKMARK_TABS = chr(128209)
LEDGER = chr(128210)
NOTEBOOK = chr(128211)
NOTEBOOK_WITH_DECORATIVE_COVER = chr(128212)
CLOSED_BOOK = chr(128213)
OPEN_BOOK = chr(128214)
GREEN_BOOK = chr(128215)
BLUE_BOOK = chr(128216)
ORANGE_BOOK = chr(128217)
BOOKS = chr(128218)
NAME_BADGE = chr(128219)
SCROLL = chr(128220)
MEMO = chr(128221)
TELEPHONE_RECEIVER = chr(128222)
PAGER = chr(128223)
FAX_MACHINE = chr(128224)
SATELLITE_ANTENNA = chr(128225)
PUBLIC_ADDRESS_LOUDSPEAKER = chr(128226)
CHEERING_MEGAPHONE = chr(128227)
OUTBOX_TRAY = chr(128228)
INBOX_TRAY = chr(128229)
PACKAGE = chr(128230)
E_MAIL_SYMBOL = chr(128231)
INCOMING_ENVELOPE = chr(128232)
ENVELOPE_WITH_DOWNWARDS_ARROW_ABOVE = chr(128233)
CLOSED_MAILBOX_WITH_LOWERED_FLAG = chr(128234)
CLOSED_MAILBOX_WITH_RAISED_FLAG = chr(128235)
OPEN_MAILBOX_WITH_RAISED_FLAG = chr(128236)
OPEN_MAILBOX_WITH_LOWERED_FLAG = chr(128237)
POSTBOX = chr(128238)
POSTAL_HORN = chr(128239)
NEWSPAPER = chr(128240)
MOBILE_PHONE = chr(128241)
MOBILE_PHONE_WITH_RIGHTWARDS_ARROW_AT_LEFT = chr(128242)
VIBRATION_MODE = chr(128243)
MOBILE_PHONE_OFF = chr(128244)
NO_MOBILE_PHONES = chr(128245)
ANTENNA_WITH_BARS = chr(128246)
CAMERA = chr(128247)
CAMERA_WITH_FLASH = chr(128248)
VIDEO_CAMERA = chr(128249)
TELEVISION = chr(128250)
RADIO = chr(128251)
VIDEOCASSETTE = chr(128252)
FILM_PROJECTOR = chr(128253)
PORTABLE_STEREO = chr(128254)
PRAYER_BEADS = chr(128255)
TWISTED_RIGHTWARDS_ARROWS = chr(128256)
CLOCKWISE_RIGHTWARDS_AND_LEFTWARDS_OPEN_CIRCLE_ARROWS = chr(128257)
CLOCKWISE_RIGHTWARDS_AND_LEFTWARDS_OPEN_CIRCLE_ARROWS_WITH_CIRCLED_ONE_OVERLAY = chr(128258)
CLOCKWISE_DOWNWARDS_AND_UPWARDS_OPEN_CIRCLE_ARROWS = chr(128259)
ANTICLOCKWISE_DOWNWARDS_AND_UPWARDS_OPEN_CIRCLE_ARROWS = chr(128260)
LOW_BRIGHTNESS_SYMBOL = chr(128261)
HIGH_BRIGHTNESS_SYMBOL = chr(128262)
SPEAKER_WITH_CANCELLATION_STROKE = chr(128263)
SPEAKER = chr(128264)
SPEAKER_WITH_ONE_SOUND_WAVE = chr(128265)
SPEAKER_WITH_THREE_SOUND_WAVES = chr(128266)
BATTERY = chr(128267)
ELECTRIC_PLUG = chr(128268)
LEFT_POINTING_MAGNIFYING_GLASS = chr(128269)
RIGHT_POINTING_MAGNIFYING_GLASS = chr(128270)
LOCK_WITH_INK_PEN = chr(128271)
CLOSED_LOCK_WITH_KEY = chr(128272)
KEY = chr(128273)
LOCK = chr(128274)
OPEN_LOCK = chr(128275)
BELL = chr(128276)
BELL_WITH_CANCELLATION_STROKE = chr(128277)
BOOKMARK = chr(128278)
LINK_SYMBOL = chr(128279)
RADIO_BUTTON = chr(128280)
BACK_WITH_LEFTWARDS_ARROW_ABOVE = chr(128281)
END_WITH_LEFTWARDS_ARROW_ABOVE = chr(128282)
ON_WITH_EXCLAMATION_MARK_WITH_LEFT_RIGHT_ARROW_ABOVE = chr(128283)
SOON_WITH_RIGHTWARDS_ARROW_ABOVE = chr(128284)
TOP_WITH_UPWARDS_ARROW_ABOVE = chr(128285)
NO_ONE_UNDER_EIGHTEEN_SYMBOL = chr(128286)
KEYCAP_TEN = chr(128287)
INPUT_SYMBOL_FOR_LATIN_CAPITAL_LETTERS = chr(128288)
INPUT_SYMBOL_FOR_LATIN_SMALL_LETTERS = chr(128289)
INPUT_SYMBOL_FOR_NUMBERS = chr(128290)
INPUT_SYMBOL_FOR_SYMBOLS = chr(128291)
INPUT_SYMBOL_FOR_LATIN_LETTERS = chr(128292)
FIRE = chr(128293)
ELECTRIC_TORCH = chr(128294)
WRENCH = chr(128295)
HAMMER = chr(128296)
NUT_AND_BOLT = chr(128297)
HOCHO = chr(128298)
PISTOL = chr(128299)
MICROSCOPE = chr(128300)
TELESCOPE = chr(128301)
CRYSTAL_BALL = chr(128302)
SIX_POINTED_STAR_WITH_MIDDLE_DOT = chr(128303)
JAPANESE_SYMBOL_FOR_BEGINNER = chr(128304)
TRIDENT_EMBLEM = chr(128305)
BLACK_SQUARE_BUTTON = chr(128306)
WHITE_SQUARE_BUTTON = chr(128307)
LARGE_RED_CIRCLE = chr(128308)
LARGE_BLUE_CIRCLE = chr(128309)
LARGE_ORANGE_DIAMOND = chr(128310)
LARGE_BLUE_DIAMOND = chr(128311)
SMALL_ORANGE_DIAMOND = chr(128312)
SMALL_BLUE_DIAMOND = chr(128313)
UP_POINTING_RED_TRIANGLE = chr(128314)
DOWN_POINTING_RED_TRIANGLE = chr(128315)
UP_POINTING_SMALL_RED_TRIANGLE = chr(128316)
DOWN_POINTING_SMALL_RED_TRIANGLE = chr(128317)
LOWER_RIGHT_SHADOWED_WHITE_CIRCLE = chr(128318)
UPPER_RIGHT_SHADOWED_WHITE_CIRCLE = chr(128319)
CIRCLED_CROSS_POMMEE = chr(128320)
CROSS_POMMEE_WITH_HALF_CIRCLE_BELOW = chr(128321)
CROSS_POMMEE = chr(128322)
NOTCHED_LEFT_SEMICIRCLE_WITH_THREE_DOTS = chr(128323)
NOTCHED_RIGHT_SEMICIRCLE_WITH_THREE_DOTS = chr(128324)
SYMBOL_FOR_MARKS_CHAPTER = chr(128325)
WHITE_LATIN_CROSS = chr(128326)
HEAVY_LATIN_CROSS = chr(128327)
CELTIC_CROSS = chr(128328)
OM_SYMBOL = chr(128329)
DOVE_OF_PEACE = chr(128330)
KAABA = chr(128331)
MOSQUE = chr(128332)
SYNAGOGUE = chr(128333)
MENORAH_WITH_NINE_BRANCHES = chr(128334)
BOWL_OF_HYGIEIA = chr(128335)
CLOCK_FACE_ONE_OCLOCK = chr(128336)
CLOCK_FACE_TWO_OCLOCK = chr(128337)
CLOCK_FACE_THREE_OCLOCK = chr(128338)
CLOCK_FACE_FOUR_OCLOCK = chr(128339)
CLOCK_FACE_FIVE_OCLOCK = chr(128340)
CLOCK_FACE_SIX_OCLOCK = chr(128341)
CLOCK_FACE_SEVEN_OCLOCK = chr(128342)
CLOCK_FACE_EIGHT_OCLOCK = chr(128343)
CLOCK_FACE_NINE_OCLOCK = chr(128344)
CLOCK_FACE_TEN_OCLOCK = chr(128345)
CLOCK_FACE_ELEVEN_OCLOCK = chr(128346)
CLOCK_FACE_TWELVE_OCLOCK = chr(128347)
CLOCK_FACE_ONE_THIRTY = chr(128348)
CLOCK_FACE_TWO_THIRTY = chr(128349)
CLOCK_FACE_THREE_THIRTY = chr(128350)
CLOCK_FACE_FOUR_THIRTY = chr(128351)
CLOCK_FACE_FIVE_THIRTY = chr(128352)
CLOCK_FACE_SIX_THIRTY = chr(128353)
CLOCK_FACE_SEVEN_THIRTY = chr(128354)
CLOCK_FACE_EIGHT_THIRTY = chr(128355)
CLOCK_FACE_NINE_THIRTY = chr(128356)
CLOCK_FACE_TEN_THIRTY = chr(128357)
CLOCK_FACE_ELEVEN_THIRTY = chr(128358)
CLOCK_FACE_TWELVE_THIRTY = chr(128359)
RIGHT_SPEAKER = chr(128360)
RIGHT_SPEAKER_WITH_ONE_SOUND_WAVE = chr(128361)
RIGHT_SPEAKER_WITH_THREE_SOUND_WAVES = chr(128362)
BULLHORN = chr(128363)
BULLHORN_WITH_SOUND_WAVES = chr(128364)
RINGING_BELL = chr(128365)
BOOK = chr(128366)
CANDLE = chr(128367)
MANTELPIECE_CLOCK = chr(128368)
BLACK_SKULL_AND_CROSSBONES = chr(128369)
NO_PIRACY = chr(128370)
HOLE = chr(128371)
MAN_IN_BUSINESS_SUIT_LEVITATING = chr(128372)
SLEUTH_OR_SPY = chr(128373)
DARK_SUNGLASSES = chr(128374)
SPIDER = chr(128375)
SPIDER_WEB = chr(128376)
JOYSTICK = chr(128377)
MAN_DANCING = chr(128378)
LEFT_HAND_TELEPHONE_RECEIVER = chr(128379)
TELEPHONE_RECEIVER_WITH_PAGE = chr(128380)
RIGHT_HAND_TELEPHONE_RECEIVER = chr(128381)
WHITE_TOUCHTONE_TELEPHONE = chr(128382)
BLACK_TOUCHTONE_TELEPHONE = chr(128383)
TELEPHONE_ON_TOP_OF_MODEM = chr(128384)
CLAMSHELL_MOBILE_PHONE = chr(128385)
BACK_OF_ENVELOPE = chr(128386)
STAMPED_ENVELOPE = chr(128387)
ENVELOPE_WITH_LIGHTNING = chr(128388)
FLYING_ENVELOPE = chr(128389)
PEN_OVER_STAMPED_ENVELOPE = chr(128390)
LINKED_PAPERCLIPS = chr(128391)
BLACK_PUSHPIN = chr(128392)
LOWER_LEFT_PENCIL = chr(128393)
LOWER_LEFT_BALLPOINT_PEN = chr(128394)
LOWER_LEFT_FOUNTAIN_PEN = chr(128395)
LOWER_LEFT_PAINTBRUSH = chr(128396)
LOWER_LEFT_CRAYON = chr(128397)
LEFT_WRITING_HAND = chr(128398)
TURNED_OK_HAND_SIGN = chr(128399)
RAISED_HAND_WITH_FINGERS_SPLAYED = chr(128400)
REVERSED_RAISED_HAND_WITH_FINGERS_SPLAYED = chr(128401)
REVERSED_THUMBS_UP_SIGN = chr(128402)
REVERSED_THUMBS_DOWN_SIGN = chr(128403)
REVERSED_VICTORY_HAND = chr(128404)
REVERSED_HAND_WITH_MIDDLE_FINGER_EXTENDED = chr(128405)
RAISED_HAND_WITH_PART_BETWEEN_MIDDLE_AND_RING_FINGERS = chr(128406)
WHITE_DOWN_POINTING_LEFT_HAND_INDEX = chr(128407)
SIDEWAYS_WHITE_LEFT_POINTING_INDEX = chr(128408)
SIDEWAYS_WHITE_RIGHT_POINTING_INDEX = chr(128409)
SIDEWAYS_BLACK_LEFT_POINTING_INDEX = chr(128410)
SIDEWAYS_BLACK_RIGHT_POINTING_INDEX = chr(128411)
BLACK_LEFT_POINTING_BACKHAND_INDEX = chr(128412)
BLACK_RIGHT_POINTING_BACKHAND_INDEX = chr(128413)
SIDEWAYS_WHITE_UP_POINTING_INDEX = chr(128414)
SIDEWAYS_WHITE_DOWN_POINTING_INDEX = chr(128415)
SIDEWAYS_BLACK_UP_POINTING_INDEX = chr(128416)
SIDEWAYS_BLACK_DOWN_POINTING_INDEX = chr(128417)
BLACK_UP_POINTING_BACKHAND_INDEX = chr(128418)
BLACK_DOWN_POINTING_BACKHAND_INDEX = chr(128419)
BLACK_HEART = chr(128420)
DESKTOP_COMPUTER = chr(128421)
KEYBOARD_AND_MOUSE = chr(128422)
THREE_NETWORKED_COMPUTERS = chr(128423)
PRINTER = chr(128424)
POCKET_CALCULATOR = chr(128425)
BLACK_HARD_SHELL_FLOPPY_DISK = chr(128426)
WHITE_HARD_SHELL_FLOPPY_DISK = chr(128427)
SOFT_SHELL_FLOPPY_DISK = chr(128428)
TAPE_CARTRIDGE = chr(128429)
WIRED_KEYBOARD = chr(128430)
ONE_BUTTON_MOUSE = chr(128431)
TWO_BUTTON_MOUSE = chr(128432)
THREE_BUTTON_MOUSE = chr(128433)
TRACKBALL = chr(128434)
OLD_PERSONAL_COMPUTER = chr(128435)
HARD_DISK = chr(128436)
SCREEN = chr(128437)
PRINTER_ICON = chr(128438)
FAX_ICON = chr(128439)
OPTICAL_DISC_ICON = chr(128440)
DOCUMENT_WITH_TEXT = chr(128441)
DOCUMENT_WITH_TEXT_AND_PICTURE = chr(128442)
DOCUMENT_WITH_PICTURE = chr(128443)
FRAME_WITH_PICTURE = chr(128444)
FRAME_WITH_TILES = chr(128445)
FRAME_WITH_AN_X = chr(128446)
BLACK_FOLDER = chr(128447)
FOLDER = chr(128448)
OPEN_FOLDER = chr(128449)
CARD_INDEX_DIVIDERS = chr(128450)
CARD_FILE_BOX = chr(128451)
FILE_CABINET = chr(128452)
EMPTY_NOTE = chr(128453)
EMPTY_NOTE_PAGE = chr(128454)
EMPTY_NOTE_PAD = chr(128455)
NOTE = chr(128456)
NOTE_PAGE = chr(128457)
NOTE_PAD = chr(128458)
EMPTY_DOCUMENT = chr(128459)
EMPTY_PAGE = chr(128460)
EMPTY_PAGES = chr(128461)
DOCUMENT = chr(128462)
PAGE = chr(128463)
PAGES = chr(128464)
WASTEBASKET = chr(128465)
SPIRAL_NOTE_PAD = chr(128466)
SPIRAL_CALENDAR_PAD = chr(128467)
DESKTOP_WINDOW = chr(128468)
MINIMIZE = chr(128469)
MAXIMIZE = chr(128470)
OVERLAP = chr(128471)
CLOCKWISE_RIGHT_AND_LEFT_SEMICIRCLE_ARROWS = chr(128472)
CANCELLATION_X = chr(128473)
INCREASE_FONT_SIZE_SYMBOL = chr(128474)
DECREASE_FONT_SIZE_SYMBOL = chr(128475)
COMPRESSION = chr(128476)
OLD_KEY = chr(128477)
ROLLED_UP_NEWSPAPER = chr(128478)
PAGE_WITH_CIRCLED_TEXT = chr(128479)
STOCK_CHART = chr(128480)
DAGGER_KNIFE = chr(128481)
LIPS = chr(128482)
SPEAKING_HEAD_IN_SILHOUETTE = chr(128483)
THREE_RAYS_ABOVE = chr(128484)
THREE_RAYS_BELOW = chr(128485)
THREE_RAYS_LEFT = chr(128486)
THREE_RAYS_RIGHT = chr(128487)
LEFT_SPEECH_BUBBLE = chr(128488)
RIGHT_SPEECH_BUBBLE = chr(128489)
TWO_SPEECH_BUBBLES = chr(128490)
THREE_SPEECH_BUBBLES = chr(128491)
LEFT_THOUGHT_BUBBLE = chr(128492)
RIGHT_THOUGHT_BUBBLE = chr(128493)
LEFT_ANGER_BUBBLE = chr(128494)
RIGHT_ANGER_BUBBLE = chr(128495)
MOOD_BUBBLE = chr(128496)
LIGHTNING_MOOD_BUBBLE = chr(128497)
LIGHTNING_MOOD = chr(128498)
BALLOT_BOX_WITH_BALLOT = chr(128499)
BALLOT_SCRIPT_X = chr(128500)
BALLOT_BOX_WITH_SCRIPT_X = chr(128501)
BALLOT_BOLD_SCRIPT_X = chr(128502)
BALLOT_BOX_WITH_BOLD_SCRIPT_X = chr(128503)
LIGHT_CHECK_MARK = chr(128504)
BALLOT_BOX_WITH_BOLD_CHECK = chr(128505)
WORLD_MAP = chr(128506)
MOUNT_FUJI = chr(128507)
TOKYO_TOWER = chr(128508)
STATUE_OF_LIBERTY = chr(128509)
SILHOUETTE_OF_JAPAN = chr(128510)
MOYAI = chr(128511)
GRINNING_FACE = chr(128512)
GRINNING_FACE_WITH_SMILING_EYES = chr(128513)
FACE_WITH_TEARS_OF_JOY = chr(128514)
SMILING_FACE_WITH_OPEN_MOUTH = chr(128515)
SMILING_FACE_WITH_OPEN_MOUTH_AND_SMILING_EYES = chr(128516)
SMILING_FACE_WITH_OPEN_MOUTH_AND_COLD_SWEAT = chr(128517)
SMILING_FACE_WITH_OPEN_MOUTH_AND_TIGHTLY_CLOSED_EYES = chr(128518)
SMILING_FACE_WITH_HALO = chr(128519)
SMILING_FACE_WITH_HORNS = chr(128520)
WINKING_FACE = chr(128521)
SMILING_FACE_WITH_SMILING_EYES = chr(128522)
FACE_SAVOURING_DELICIOUS_FOOD = chr(128523)
RELIEVED_FACE = chr(128524)
SMILING_FACE_WITH_HEART_SHAPED_EYES = chr(128525)
SMILING_FACE_WITH_SUNGLASSES = chr(128526)
SMIRKING_FACE = chr(128527)
NEUTRAL_FACE = chr(128528)
EXPRESSIONLESS_FACE = chr(128529)
UNAMUSED_FACE = chr(128530)
FACE_WITH_COLD_SWEAT = chr(128531)
PENSIVE_FACE = chr(128532)
CONFUSED_FACE = chr(128533)
CONFOUNDED_FACE = chr(128534)
KISSING_FACE = chr(128535)
FACE_THROWING_A_KISS = chr(128536)
KISSING_FACE_WITH_SMILING_EYES = chr(128537)
KISSING_FACE_WITH_CLOSED_EYES = chr(128538)
FACE_WITH_STUCK_OUT_TONGUE = chr(128539)
FACE_WITH_STUCK_OUT_TONGUE_AND_WINKING_EYE = chr(128540)
FACE_WITH_STUCK_OUT_TONGUE_AND_TIGHTLY_CLOSED_EYES = chr(128541)
DISAPPOINTED_FACE = chr(128542)
WORRIED_FACE = chr(128543)
ANGRY_FACE = chr(128544)
POUTING_FACE = chr(128545)
CRYING_FACE = chr(128546)
PERSEVERING_FACE = chr(128547)
FACE_WITH_LOOK_OF_TRIUMPH = chr(128548)
DISAPPOINTED_BUT_RELIEVED_FACE = chr(128549)
FROWNING_FACE_WITH_OPEN_MOUTH = chr(128550)
ANGUISHED_FACE = chr(128551)
FEARFUL_FACE = chr(128552)
WEARY_FACE = chr(128553)
SLEEPY_FACE = chr(128554)
TIRED_FACE = chr(128555)
GRIMACING_FACE = chr(128556)
LOUDLY_CRYING_FACE = chr(128557)
FACE_WITH_OPEN_MOUTH = chr(128558)
HUSHED_FACE = chr(128559)
FACE_WITH_OPEN_MOUTH_AND_COLD_SWEAT = chr(128560)
FACE_SCREAMING_IN_FEAR = chr(128561)
ASTONISHED_FACE = chr(128562)
FLUSHED_FACE = chr(128563)
SLEEPING_FACE = chr(128564)
DIZZY_FACE = chr(128565)
FACE_WITHOUT_MOUTH = chr(128566)
FACE_WITH_MEDICAL_MASK = chr(128567)
GRINNING_CAT_FACE_WITH_SMILING_EYES = chr(128568)
CAT_FACE_WITH_TEARS_OF_JOY = chr(128569)
SMILING_CAT_FACE_WITH_OPEN_MOUTH = chr(128570)
SMILING_CAT_FACE_WITH_HEART_SHAPED_EYES = chr(128571)
CAT_FACE_WITH_WRY_SMILE = chr(128572)
KISSING_CAT_FACE_WITH_CLOSED_EYES = chr(128573)
POUTING_CAT_FACE = chr(128574)
CRYING_CAT_FACE = chr(128575)
WEARY_CAT_FACE = chr(128576)
SLIGHTLY_FROWNING_FACE = chr(128577)
SLIGHTLY_SMILING_FACE = chr(128578)
UPSIDE_DOWN_FACE = chr(128579)
FACE_WITH_ROLLING_EYES = chr(128580)
FACE_WITH_NO_GOOD_GESTURE = chr(128581)
FACE_WITH_OK_GESTURE = chr(128582)
PERSON_BOWING_DEEPLY = chr(128583)
SEE_NO_EVIL_MONKEY = chr(128584)
HEAR_NO_EVIL_MONKEY = chr(128585)
SPEAK_NO_EVIL_MONKEY = chr(128586)
HAPPY_PERSON_RAISING_ONE_HAND = chr(128587)
PERSON_RAISING_BOTH_HANDS_IN_CELEBRATION = chr(128588)
PERSON_FROWNING = chr(128589)
PERSON_WITH_POUTING_FACE = chr(128590)
PERSON_WITH_FOLDED_HANDS = chr(128591)
NORTH_WEST_POINTING_LEAF = chr(128592)
SOUTH_WEST_POINTING_LEAF = chr(128593)
NORTH_EAST_POINTING_LEAF = chr(128594)
SOUTH_EAST_POINTING_LEAF = chr(128595)
TURNED_NORTH_WEST_POINTING_LEAF = chr(128596)
TURNED_SOUTH_WEST_POINTING_LEAF = chr(128597)
TURNED_NORTH_EAST_POINTING_LEAF = chr(128598)
TURNED_SOUTH_EAST_POINTING_LEAF = chr(128599)
NORTH_WEST_POINTING_VINE_LEAF = chr(128600)
SOUTH_WEST_POINTING_VINE_LEAF = chr(128601)
NORTH_EAST_POINTING_VINE_LEAF = chr(128602)
SOUTH_EAST_POINTING_VINE_LEAF = chr(128603)
HEAVY_NORTH_WEST_POINTING_VINE_LEAF = chr(128604)
HEAVY_SOUTH_WEST_POINTING_VINE_LEAF = chr(128605)
HEAVY_NORTH_EAST_POINTING_VINE_LEAF = chr(128606)
HEAVY_SOUTH_EAST_POINTING_VINE_LEAF = chr(128607)
NORTH_WEST_POINTING_BUD = chr(128608)
SOUTH_WEST_POINTING_BUD = chr(128609)
NORTH_EAST_POINTING_BUD = chr(128610)
SOUTH_EAST_POINTING_BUD = chr(128611)
HEAVY_NORTH_WEST_POINTING_BUD = chr(128612)
HEAVY_SOUTH_WEST_POINTING_BUD = chr(128613)
HEAVY_NORTH_EAST_POINTING_BUD = chr(128614)
HEAVY_SOUTH_EAST_POINTING_BUD = chr(128615)
HOLLOW_QUILT_SQUARE_ORNAMENT = chr(128616)
HOLLOW_QUILT_SQUARE_ORNAMENT_IN_BLACK_SQUARE = chr(128617)
SOLID_QUILT_SQUARE_ORNAMENT = chr(128618)
SOLID_QUILT_SQUARE_ORNAMENT_IN_BLACK_SQUARE = chr(128619)
LEFTWARDS_ROCKET = chr(128620)
UPWARDS_ROCKET = chr(128621)
RIGHTWARDS_ROCKET = chr(128622)
DOWNWARDS_ROCKET = chr(128623)
SCRIPT_LIGATURE_ET_ORNAMENT = chr(128624)
HEAVY_SCRIPT_LIGATURE_ET_ORNAMENT = chr(128625)
LIGATURE_OPEN_ET_ORNAMENT = chr(128626)
HEAVY_LIGATURE_OPEN_ET_ORNAMENT = chr(128627)
HEAVY_AMPERSAND_ORNAMENT = chr(128628)
SWASH_AMPERSAND_ORNAMENT = chr(128629)
SANS_SERIF_HEAVY_DOUBLE_TURNED_COMMA_QUOTATION_MARK_ORNAMENT = chr(128630)
SANS_SERIF_HEAVY_DOUBLE_COMMA_QUOTATION_MARK_ORNAMENT = chr(128631)
SANS_SERIF_HEAVY_LOW_DOUBLE_COMMA_QUOTATION_MARK_ORNAMENT = chr(128632)
HEAVY_INTERROBANG_ORNAMENT = chr(128633)
SANS_SERIF_INTERROBANG_ORNAMENT = chr(128634)
HEAVY_SANS_SERIF_INTERROBANG_ORNAMENT = chr(128635)
VERY_HEAVY_SOLIDUS = chr(128636)
VERY_HEAVY_REVERSE_SOLIDUS = chr(128637)
CHECKER_BOARD = chr(128638)
REVERSE_CHECKER_BOARD = chr(128639)
ROCKET = chr(128640)
HELICOPTER = chr(128641)
STEAM_LOCOMOTIVE = chr(128642)
RAILWAY_CAR = chr(128643)
HIGH_SPEED_TRAIN = chr(128644)
HIGH_SPEED_TRAIN_WITH_BULLET_NOSE = chr(128645)
TRAIN = chr(128646)
METRO = chr(128647)
LIGHT_RAIL = chr(128648)
STATION = chr(128649)
TRAM = chr(128650)
TRAM_CAR = chr(128651)
BUS = chr(128652)
ONCOMING_BUS = chr(128653)
TROLLEYBUS = chr(128654)
BUS_STOP = chr(128655)
MINIBUS = chr(128656)
AMBULANCE = chr(128657)
FIRE_ENGINE = chr(128658)
POLICE_CAR = chr(128659)
ONCOMING_POLICE_CAR = chr(128660)
TAXI = chr(128661)
ONCOMING_TAXI = chr(128662)
AUTOMOBILE = chr(128663)
ONCOMING_AUTOMOBILE = chr(128664)
RECREATIONAL_VEHICLE = chr(128665)
DELIVERY_TRUCK = chr(128666)
ARTICULATED_LORRY = chr(128667)
TRACTOR = chr(128668)
MONORAIL = chr(128669)
MOUNTAIN_RAILWAY = chr(128670)
SUSPENSION_RAILWAY = chr(128671)
MOUNTAIN_CABLEWAY = chr(128672)
AERIAL_TRAMWAY = chr(128673)
SHIP = chr(128674)
ROWBOAT = chr(128675)
SPEEDBOAT = chr(128676)
HORIZONTAL_TRAFFIC_LIGHT = chr(128677)
VERTICAL_TRAFFIC_LIGHT = chr(128678)
CONSTRUCTION_SIGN = chr(128679)
POLICE_CARS_REVOLVING_LIGHT = chr(128680)
TRIANGULAR_FLAG_ON_POST = chr(128681)
DOOR = chr(128682)
NO_ENTRY_SIGN = chr(128683)
SMOKING_SYMBOL = chr(128684)
NO_SMOKING_SYMBOL = chr(128685)
PUT_LITTER_IN_ITS_PLACE_SYMBOL = chr(128686)
DO_NOT_LITTER_SYMBOL = chr(128687)
POTABLE_WATER_SYMBOL = chr(128688)
NON_POTABLE_WATER_SYMBOL = chr(128689)
BICYCLE = chr(128690)
NO_BICYCLES = chr(128691)
BICYCLIST = chr(128692)
MOUNTAIN_BICYCLIST = chr(128693)
PEDESTRIAN = chr(128694)
NO_PEDESTRIANS = chr(128695)
CHILDREN_CROSSING = chr(128696)
MENS_SYMBOL = chr(128697)
WOMENS_SYMBOL = chr(128698)
RESTROOM = chr(128699)
BABY_SYMBOL = chr(128700)
TOILET = chr(128701)
WATER_CLOSET = chr(128702)
SHOWER = chr(128703)
BATH = chr(128704)
BATHTUB = chr(128705)
PASSPORT_CONTROL = chr(128706)
CUSTOMS = chr(128707)
BAGGAGE_CLAIM = chr(128708)
LEFT_LUGGAGE = chr(128709)
TRIANGLE_WITH_ROUNDED_CORNERS = chr(128710)
PROHIBITED_SIGN = chr(128711)
CIRCLED_INFORMATION_SOURCE = chr(128712)
BOYS_SYMBOL = chr(128713)
GIRLS_SYMBOL = chr(128714)
COUCH_AND_LAMP = chr(128715)
SLEEPING_ACCOMMODATION = chr(128716)
SHOPPING_BAGS = chr(128717)
BELLHOP_BELL = chr(128718)
BED = chr(128719)
PLACE_OF_WORSHIP = chr(128720)
OCTAGONAL_SIGN = chr(128721)
SHOPPING_TROLLEY = chr(128722)
STUPA = chr(128723)
PAGODA = chr(128724)
HINDU_TEMPLE = chr(128725)
HUT = chr(128726)
ELEVATOR = chr(128727)
WIRELESS = chr(128732)
PLAYGROUND_SLIDE = chr(128733)
WHEEL = chr(128734)
RING_BUOY = chr(128735)
HAMMER_AND_WRENCH = chr(128736)
SHIELD = chr(128737)
OIL_DRUM = chr(128738)
MOTORWAY = chr(128739)
RAILWAY_TRACK = chr(128740)
MOTOR_BOAT = chr(128741)
UP_POINTING_MILITARY_AIRPLANE = chr(128742)
UP_POINTING_AIRPLANE = chr(128743)
UP_POINTING_SMALL_AIRPLANE = chr(128744)
SMALL_AIRPLANE = chr(128745)
NORTHEAST_POINTING_AIRPLANE = chr(128746)
AIRPLANE_DEPARTURE = chr(128747)
AIRPLANE_ARRIVING = chr(128748)
SATELLITE = chr(128752)
ONCOMING_FIRE_ENGINE = chr(128753)
DIESEL_LOCOMOTIVE = chr(128754)
PASSENGER_SHIP = chr(128755)
SCOOTER = chr(128756)
MOTOR_SCOOTER = chr(128757)
CANOE = chr(128758)
SLED = chr(128759)
FLYING_SAUCER = chr(128760)
SKATEBOARD = chr(128761)
AUTO_RICKSHAW = chr(128762)
PICKUP_TRUCK = chr(128763)
ROLLER_SKATE = chr(128764)
ALCHEMICAL_SYMBOL_FOR_QUINTESSENCE = chr(128768)
ALCHEMICAL_SYMBOL_FOR_AIR = chr(128769)
ALCHEMICAL_SYMBOL_FOR_FIRE = chr(128770)
ALCHEMICAL_SYMBOL_FOR_EARTH = chr(128771)
ALCHEMICAL_SYMBOL_FOR_WATER = chr(128772)
ALCHEMICAL_SYMBOL_FOR_AQUAFORTIS = chr(128773)
ALCHEMICAL_SYMBOL_FOR_AQUA_REGIA = chr(128774)
ALCHEMICAL_SYMBOL_FOR_AQUA_REGIA_2 = chr(128775)
ALCHEMICAL_SYMBOL_FOR_AQUA_VITAE = chr(128776)
ALCHEMICAL_SYMBOL_FOR_AQUA_VITAE_2 = chr(128777)
ALCHEMICAL_SYMBOL_FOR_VINEGAR = chr(128778)
ALCHEMICAL_SYMBOL_FOR_VINEGAR_2 = chr(128779)
ALCHEMICAL_SYMBOL_FOR_VINEGAR_3 = chr(128780)
ALCHEMICAL_SYMBOL_FOR_SULFUR = chr(128781)
ALCHEMICAL_SYMBOL_FOR_PHILOSOPHERS_SULFUR = chr(128782)
ALCHEMICAL_SYMBOL_FOR_BLACK_SULFUR = chr(128783)
ALCHEMICAL_SYMBOL_FOR_MERCURY_SUBLIMATE = chr(128784)
ALCHEMICAL_SYMBOL_FOR_MERCURY_SUBLIMATE_2 = chr(128785)
ALCHEMICAL_SYMBOL_FOR_MERCURY_SUBLIMATE_3 = chr(128786)
ALCHEMICAL_SYMBOL_FOR_CINNABAR = chr(128787)
ALCHEMICAL_SYMBOL_FOR_SALT = chr(128788)
ALCHEMICAL_SYMBOL_FOR_NITRE = chr(128789)
ALCHEMICAL_SYMBOL_FOR_VITRIOL = chr(128790)
ALCHEMICAL_SYMBOL_FOR_VITRIOL_2 = chr(128791)
ALCHEMICAL_SYMBOL_FOR_ROCK_SALT = chr(128792)
ALCHEMICAL_SYMBOL_FOR_ROCK_SALT_2 = chr(128793)
ALCHEMICAL_SYMBOL_FOR_GOLD = chr(128794)
ALCHEMICAL_SYMBOL_FOR_SILVER = chr(128795)
ALCHEMICAL_SYMBOL_FOR_IRON_ORE = chr(128796)
ALCHEMICAL_SYMBOL_FOR_IRON_ORE_2 = chr(128797)
ALCHEMICAL_SYMBOL_FOR_CROCUS_OF_IRON = chr(128798)
ALCHEMICAL_SYMBOL_FOR_REGULUS_OF_IRON = chr(128799)
ALCHEMICAL_SYMBOL_FOR_COPPER_ORE = chr(128800)
ALCHEMICAL_SYMBOL_FOR_IRON_COPPER_ORE = chr(128801)
ALCHEMICAL_SYMBOL_FOR_SUBLIMATE_OF_COPPER = chr(128802)
ALCHEMICAL_SYMBOL_FOR_CROCUS_OF_COPPER = chr(128803)
ALCHEMICAL_SYMBOL_FOR_CROCUS_OF_COPPER_2 = chr(128804)
ALCHEMICAL_SYMBOL_FOR_COPPER_ANTIMONIATE = chr(128805)
ALCHEMICAL_SYMBOL_FOR_SALT_OF_COPPER_ANTIMONIATE = chr(128806)
ALCHEMICAL_SYMBOL_FOR_SUBLIMATE_OF_SALT_OF_COPPER = chr(128807)
ALCHEMICAL_SYMBOL_FOR_VERDIGRIS = chr(128808)
ALCHEMICAL_SYMBOL_FOR_TIN_ORE = chr(128809)
ALCHEMICAL_SYMBOL_FOR_LEAD_ORE = chr(128810)
ALCHEMICAL_SYMBOL_FOR_ANTIMONY_ORE = chr(128811)
ALCHEMICAL_SYMBOL_FOR_SUBLIMATE_OF_ANTIMONY = chr(128812)
ALCHEMICAL_SYMBOL_FOR_SALT_OF_ANTIMONY = chr(128813)
ALCHEMICAL_SYMBOL_FOR_SUBLIMATE_OF_SALT_OF_ANTIMONY = chr(128814)
ALCHEMICAL_SYMBOL_FOR_VINEGAR_OF_ANTIMONY = chr(128815)
ALCHEMICAL_SYMBOL_FOR_REGULUS_OF_ANTIMONY = chr(128816)
ALCHEMICAL_SYMBOL_FOR_REGULUS_OF_ANTIMONY_2 = chr(128817)
ALCHEMICAL_SYMBOL_FOR_REGULUS = chr(128818)
ALCHEMICAL_SYMBOL_FOR_REGULUS_2 = chr(128819)
ALCHEMICAL_SYMBOL_FOR_REGULUS_3 = chr(128820)
ALCHEMICAL_SYMBOL_FOR_REGULUS_4 = chr(128821)
ALCHEMICAL_SYMBOL_FOR_ALKALI = chr(128822)
ALCHEMICAL_SYMBOL_FOR_ALKALI_2 = chr(128823)
ALCHEMICAL_SYMBOL_FOR_MARCASITE = chr(128824)
ALCHEMICAL_SYMBOL_FOR_SAL_AMMONIAC = chr(128825)
ALCHEMICAL_SYMBOL_FOR_ARSENIC = chr(128826)
ALCHEMICAL_SYMBOL_FOR_REALGAR = chr(128827)
ALCHEMICAL_SYMBOL_FOR_REALGAR_2 = chr(128828)
ALCHEMICAL_SYMBOL_FOR_AURIPIGMENT = chr(128829)
ALCHEMICAL_SYMBOL_FOR_BISMUTH_ORE = chr(128830)
ALCHEMICAL_SYMBOL_FOR_TARTAR = chr(128831)
ALCHEMICAL_SYMBOL_FOR_TARTAR_2 = chr(128832)
ALCHEMICAL_SYMBOL_FOR_QUICK_LIME = chr(128833)
ALCHEMICAL_SYMBOL_FOR_BORAX = chr(128834)
ALCHEMICAL_SYMBOL_FOR_BORAX_2 = chr(128835)
ALCHEMICAL_SYMBOL_FOR_BORAX_3 = chr(128836)
ALCHEMICAL_SYMBOL_FOR_ALUM = chr(128837)
ALCHEMICAL_SYMBOL_FOR_OIL = chr(128838)
ALCHEMICAL_SYMBOL_FOR_SPIRIT = chr(128839)
ALCHEMICAL_SYMBOL_FOR_TINCTURE = chr(128840)
ALCHEMICAL_SYMBOL_FOR_GUM = chr(128841)
ALCHEMICAL_SYMBOL_FOR_WAX = chr(128842)
ALCHEMICAL_SYMBOL_FOR_POWDER = chr(128843)
ALCHEMICAL_SYMBOL_FOR_CALX = chr(128844)
ALCHEMICAL_SYMBOL_FOR_TUTTY = chr(128845)
ALCHEMICAL_SYMBOL_FOR_CAPUT_MORTUUM = chr(128846)
ALCHEMICAL_SYMBOL_FOR_SCEPTER_OF_JOVE = chr(128847)
ALCHEMICAL_SYMBOL_FOR_CADUCEUS = chr(128848)
ALCHEMICAL_SYMBOL_FOR_TRIDENT = chr(128849)
ALCHEMICAL_SYMBOL_FOR_STARRED_TRIDENT = chr(128850)
ALCHEMICAL_SYMBOL_FOR_LODESTONE = chr(128851)
ALCHEMICAL_SYMBOL_FOR_SOAP = chr(128852)
ALCHEMICAL_SYMBOL_FOR_URINE = chr(128853)
ALCHEMICAL_SYMBOL_FOR_HORSE_DUNG = chr(128854)
ALCHEMICAL_SYMBOL_FOR_ASHES = chr(128855)
ALCHEMICAL_SYMBOL_FOR_POT_ASHES = chr(128856)
ALCHEMICAL_SYMBOL_FOR_BRICK = chr(128857)
ALCHEMICAL_SYMBOL_FOR_POWDERED_BRICK = chr(128858)
ALCHEMICAL_SYMBOL_FOR_AMALGAM = chr(128859)
ALCHEMICAL_SYMBOL_FOR_STRATUM_SUPER_STRATUM = chr(128860)
ALCHEMICAL_SYMBOL_FOR_STRATUM_SUPER_STRATUM_2 = chr(128861)
ALCHEMICAL_SYMBOL_FOR_SUBLIMATION = chr(128862)
ALCHEMICAL_SYMBOL_FOR_PRECIPITATE = chr(128863)
ALCHEMICAL_SYMBOL_FOR_DISTILL = chr(128864)
ALCHEMICAL_SYMBOL_FOR_DISSOLVE = chr(128865)
ALCHEMICAL_SYMBOL_FOR_DISSOLVE_2 = chr(128866)
ALCHEMICAL_SYMBOL_FOR_PURIFY = chr(128867)
ALCHEMICAL_SYMBOL_FOR_PUTREFACTION = chr(128868)
ALCHEMICAL_SYMBOL_FOR_CRUCIBLE = chr(128869)
ALCHEMICAL_SYMBOL_FOR_CRUCIBLE_2 = chr(128870)
ALCHEMICAL_SYMBOL_FOR_CRUCIBLE_3 = chr(128871)
ALCHEMICAL_SYMBOL_FOR_CRUCIBLE_4 = chr(128872)
ALCHEMICAL_SYMBOL_FOR_CRUCIBLE_5 = chr(128873)
ALCHEMICAL_SYMBOL_FOR_ALEMBIC = chr(128874)
ALCHEMICAL_SYMBOL_FOR_BATH_OF_MARY = chr(128875)
ALCHEMICAL_SYMBOL_FOR_BATH_OF_VAPOURS = chr(128876)
ALCHEMICAL_SYMBOL_FOR_RETORT = chr(128877)
ALCHEMICAL_SYMBOL_FOR_HOUR = chr(128878)
ALCHEMICAL_SYMBOL_FOR_NIGHT = chr(128879)
ALCHEMICAL_SYMBOL_FOR_DAY_NIGHT = chr(128880)
ALCHEMICAL_SYMBOL_FOR_MONTH = chr(128881)
ALCHEMICAL_SYMBOL_FOR_HALF_DRAM = chr(128882)
ALCHEMICAL_SYMBOL_FOR_HALF_OUNCE = chr(128883)
LOT_OF_FORTUNE = chr(128884)
OCCULTATION = chr(128885)
LUNAR_ECLIPSE = chr(128886)
HAUMEA = chr(128891)
MAKEMAKE = chr(128892)
GONGGONG = chr(128893)
QUAOAR = chr(128894)
ORCUS = chr(128895)
BLACK_LEFT_POINTING_ISOSCELES_RIGHT_TRIANGLE = chr(128896)
BLACK_UP_POINTING_ISOSCELES_RIGHT_TRIANGLE = chr(128897)
BLACK_RIGHT_POINTING_ISOSCELES_RIGHT_TRIANGLE = chr(128898)
BLACK_DOWN_POINTING_ISOSCELES_RIGHT_TRIANGLE = chr(128899)
BLACK_SLIGHTLY_SMALL_CIRCLE = chr(128900)
MEDIUM_BOLD_WHITE_CIRCLE = chr(128901)
BOLD_WHITE_CIRCLE = chr(128902)
HEAVY_WHITE_CIRCLE = chr(128903)
VERY_HEAVY_WHITE_CIRCLE = chr(128904)
EXTREMELY_HEAVY_WHITE_CIRCLE = chr(128905)
WHITE_CIRCLE_CONTAINING_BLACK_SMALL_CIRCLE = chr(128906)
ROUND_TARGET = chr(128907)
BLACK_TINY_SQUARE = chr(128908)
BLACK_SLIGHTLY_SMALL_SQUARE = chr(128909)
LIGHT_WHITE_SQUARE = chr(128910)
MEDIUM_WHITE_SQUARE = chr(128911)
BOLD_WHITE_SQUARE = chr(128912)
HEAVY_WHITE_SQUARE = chr(128913)
VERY_HEAVY_WHITE_SQUARE = chr(128914)
EXTREMELY_HEAVY_WHITE_SQUARE = chr(128915)
WHITE_SQUARE_CONTAINING_BLACK_VERY_SMALL_SQUARE = chr(128916)
WHITE_SQUARE_CONTAINING_BLACK_MEDIUM_SQUARE = chr(128917)
SQUARE_TARGET = chr(128918)
BLACK_TINY_DIAMOND = chr(128919)
BLACK_VERY_SMALL_DIAMOND = chr(128920)
BLACK_MEDIUM_SMALL_DIAMOND = chr(128921)
WHITE_DIAMOND_CONTAINING_BLACK_VERY_SMALL_DIAMOND = chr(128922)
WHITE_DIAMOND_CONTAINING_BLACK_MEDIUM_DIAMOND = chr(128923)
DIAMOND_TARGET = chr(128924)
BLACK_TINY_LOZENGE = chr(128925)
BLACK_VERY_SMALL_LOZENGE = chr(128926)
BLACK_MEDIUM_SMALL_LOZENGE = chr(128927)
WHITE_LOZENGE_CONTAINING_BLACK_SMALL_LOZENGE = chr(128928)
THIN_GREEK_CROSS = chr(128929)
LIGHT_GREEK_CROSS = chr(128930)
MEDIUM_GREEK_CROSS = chr(128931)
BOLD_GREEK_CROSS = chr(128932)
VERY_BOLD_GREEK_CROSS = chr(128933)
VERY_HEAVY_GREEK_CROSS = chr(128934)
EXTREMELY_HEAVY_GREEK_CROSS = chr(128935)
THIN_SALTIRE = chr(128936)
LIGHT_SALTIRE = chr(128937)
MEDIUM_SALTIRE = chr(128938)
BOLD_SALTIRE = chr(128939)
HEAVY_SALTIRE = chr(128940)
VERY_HEAVY_SALTIRE = chr(128941)
EXTREMELY_HEAVY_SALTIRE = chr(128942)
LIGHT_FIVE_SPOKED_ASTERISK = chr(128943)
MEDIUM_FIVE_SPOKED_ASTERISK = chr(128944)
BOLD_FIVE_SPOKED_ASTERISK = chr(128945)
HEAVY_FIVE_SPOKED_ASTERISK = chr(128946)
VERY_HEAVY_FIVE_SPOKED_ASTERISK = chr(128947)
EXTREMELY_HEAVY_FIVE_SPOKED_ASTERISK = chr(128948)
LIGHT_SIX_SPOKED_ASTERISK = chr(128949)
MEDIUM_SIX_SPOKED_ASTERISK = chr(128950)
BOLD_SIX_SPOKED_ASTERISK = chr(128951)
HEAVY_SIX_SPOKED_ASTERISK = chr(128952)
VERY_HEAVY_SIX_SPOKED_ASTERISK = chr(128953)
EXTREMELY_HEAVY_SIX_SPOKED_ASTERISK = chr(128954)
LIGHT_EIGHT_SPOKED_ASTERISK = chr(128955)
MEDIUM_EIGHT_SPOKED_ASTERISK = chr(128956)
BOLD_EIGHT_SPOKED_ASTERISK = chr(128957)
HEAVY_EIGHT_SPOKED_ASTERISK = chr(128958)
VERY_HEAVY_EIGHT_SPOKED_ASTERISK = chr(128959)
LIGHT_THREE_POINTED_BLACK_STAR = chr(128960)
MEDIUM_THREE_POINTED_BLACK_STAR = chr(128961)
THREE_POINTED_BLACK_STAR = chr(128962)
MEDIUM_THREE_POINTED_PINWHEEL_STAR = chr(128963)
LIGHT_FOUR_POINTED_BLACK_STAR = chr(128964)
MEDIUM_FOUR_POINTED_BLACK_STAR = chr(128965)
FOUR_POINTED_BLACK_STAR = chr(128966)
MEDIUM_FOUR_POINTED_PINWHEEL_STAR = chr(128967)
REVERSE_LIGHT_FOUR_POINTED_PINWHEEL_STAR = chr(128968)
LIGHT_FIVE_POINTED_BLACK_STAR = chr(128969)
HEAVY_FIVE_POINTED_BLACK_STAR = chr(128970)
MEDIUM_SIX_POINTED_BLACK_STAR = chr(128971)
HEAVY_SIX_POINTED_BLACK_STAR = chr(128972)
SIX_POINTED_PINWHEEL_STAR = chr(128973)
MEDIUM_EIGHT_POINTED_BLACK_STAR = chr(128974)
HEAVY_EIGHT_POINTED_BLACK_STAR = chr(128975)
VERY_HEAVY_EIGHT_POINTED_BLACK_STAR = chr(128976)
HEAVY_EIGHT_POINTED_PINWHEEL_STAR = chr(128977)
LIGHT_TWELVE_POINTED_BLACK_STAR = chr(128978)
HEAVY_TWELVE_POINTED_BLACK_STAR = chr(128979)
HEAVY_TWELVE_POINTED_PINWHEEL_STAR = chr(128980)
CIRCLED_TRIANGLE = chr(128981)
NEGATIVE_CIRCLED_TRIANGLE = chr(128982)
CIRCLED_SQUARE = chr(128983)
NEGATIVE_CIRCLED_SQUARE = chr(128984)
NINE_POINTED_WHITE_STAR = chr(128985)
LARGE_ORANGE_CIRCLE = chr(128992)
LARGE_YELLOW_CIRCLE = chr(128993)
LARGE_GREEN_CIRCLE = chr(128994)
LARGE_PURPLE_CIRCLE = chr(128995)
LARGE_BROWN_CIRCLE = chr(128996)
LARGE_RED_SQUARE = chr(128997)
LARGE_BLUE_SQUARE = chr(128998)
LARGE_ORANGE_SQUARE = chr(128999)
LARGE_YELLOW_SQUARE = chr(129000)
LARGE_GREEN_SQUARE = chr(129001)
LARGE_PURPLE_SQUARE = chr(129002)
LARGE_BROWN_SQUARE = chr(129003)
HEAVY_EQUALS_SIGN = chr(129008)
LEFTWARDS_ARROW_WITH_SMALL_TRIANGLE_ARROWHEAD = chr(129024)
UPWARDS_ARROW_WITH_SMALL_TRIANGLE_ARROWHEAD = chr(129025)
RIGHTWARDS_ARROW_WITH_SMALL_TRIANGLE_ARROWHEAD = chr(129026)
DOWNWARDS_ARROW_WITH_SMALL_TRIANGLE_ARROWHEAD = chr(129027)
LEFTWARDS_ARROW_WITH_MEDIUM_TRIANGLE_ARROWHEAD = chr(129028)
UPWARDS_ARROW_WITH_MEDIUM_TRIANGLE_ARROWHEAD = chr(129029)
RIGHTWARDS_ARROW_WITH_MEDIUM_TRIANGLE_ARROWHEAD = chr(129030)
DOWNWARDS_ARROW_WITH_MEDIUM_TRIANGLE_ARROWHEAD = chr(129031)
LEFTWARDS_ARROW_WITH_LARGE_TRIANGLE_ARROWHEAD = chr(129032)
UPWARDS_ARROW_WITH_LARGE_TRIANGLE_ARROWHEAD = chr(129033)
RIGHTWARDS_ARROW_WITH_LARGE_TRIANGLE_ARROWHEAD = chr(129034)
DOWNWARDS_ARROW_WITH_LARGE_TRIANGLE_ARROWHEAD = chr(129035)
LEFTWARDS_ARROW_WITH_SMALL_EQUILATERAL_ARROWHEAD = chr(129040)
UPWARDS_ARROW_WITH_SMALL_EQUILATERAL_ARROWHEAD = chr(129041)
RIGHTWARDS_ARROW_WITH_SMALL_EQUILATERAL_ARROWHEAD = chr(129042)
DOWNWARDS_ARROW_WITH_SMALL_EQUILATERAL_ARROWHEAD = chr(129043)
LEFTWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD = chr(129044)
UPWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD = chr(129045)
RIGHTWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD = chr(129046)
DOWNWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD = chr(129047)
HEAVY_LEFTWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD = chr(129048)
HEAVY_UPWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD = chr(129049)
HEAVY_RIGHTWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD = chr(129050)
HEAVY_DOWNWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD = chr(129051)
HEAVY_LEFTWARDS_ARROW_WITH_LARGE_EQUILATERAL_ARROWHEAD = chr(129052)
HEAVY_UPWARDS_ARROW_WITH_LARGE_EQUILATERAL_ARROWHEAD = chr(129053)
HEAVY_RIGHTWARDS_ARROW_WITH_LARGE_EQUILATERAL_ARROWHEAD = chr(129054)
HEAVY_DOWNWARDS_ARROW_WITH_LARGE_EQUILATERAL_ARROWHEAD = chr(129055)
LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_NARROW_SHAFT = chr(129056)
UPWARDS_TRIANGLE_HEADED_ARROW_WITH_NARROW_SHAFT = chr(129057)
RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_NARROW_SHAFT = chr(129058)
DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_NARROW_SHAFT = chr(129059)
LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_MEDIUM_SHAFT = chr(129060)
UPWARDS_TRIANGLE_HEADED_ARROW_WITH_MEDIUM_SHAFT = chr(129061)
RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_MEDIUM_SHAFT = chr(129062)
DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_MEDIUM_SHAFT = chr(129063)
LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_BOLD_SHAFT = chr(129064)
UPWARDS_TRIANGLE_HEADED_ARROW_WITH_BOLD_SHAFT = chr(129065)
RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_BOLD_SHAFT = chr(129066)
DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_BOLD_SHAFT = chr(129067)
LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_HEAVY_SHAFT = chr(129068)
UPWARDS_TRIANGLE_HEADED_ARROW_WITH_HEAVY_SHAFT = chr(129069)
RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_HEAVY_SHAFT = chr(129070)
DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_HEAVY_SHAFT = chr(129071)
LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_VERY_HEAVY_SHAFT = chr(129072)
UPWARDS_TRIANGLE_HEADED_ARROW_WITH_VERY_HEAVY_SHAFT = chr(129073)
RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_VERY_HEAVY_SHAFT = chr(129074)
DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_VERY_HEAVY_SHAFT = chr(129075)
LEFTWARDS_FINGER_POST_ARROW = chr(129076)
UPWARDS_FINGER_POST_ARROW = chr(129077)
RIGHTWARDS_FINGER_POST_ARROW = chr(129078)
DOWNWARDS_FINGER_POST_ARROW = chr(129079)
LEFTWARDS_SQUARED_ARROW = chr(129080)
UPWARDS_SQUARED_ARROW = chr(129081)
RIGHTWARDS_SQUARED_ARROW = chr(129082)
DOWNWARDS_SQUARED_ARROW = chr(129083)
LEFTWARDS_COMPRESSED_ARROW = chr(129084)
UPWARDS_COMPRESSED_ARROW = chr(129085)
RIGHTWARDS_COMPRESSED_ARROW = chr(129086)
DOWNWARDS_COMPRESSED_ARROW = chr(129087)
LEFTWARDS_HEAVY_COMPRESSED_ARROW = chr(129088)
UPWARDS_HEAVY_COMPRESSED_ARROW = chr(129089)
RIGHTWARDS_HEAVY_COMPRESSED_ARROW = chr(129090)
DOWNWARDS_HEAVY_COMPRESSED_ARROW = chr(129091)
LEFTWARDS_HEAVY_ARROW = chr(129092)
UPWARDS_HEAVY_ARROW = chr(129093)
RIGHTWARDS_HEAVY_ARROW = chr(129094)
DOWNWARDS_HEAVY_ARROW = chr(129095)
LEFTWARDS_SANS_SERIF_ARROW = chr(129104)
UPWARDS_SANS_SERIF_ARROW = chr(129105)
RIGHTWARDS_SANS_SERIF_ARROW = chr(129106)
DOWNWARDS_SANS_SERIF_ARROW = chr(129107)
NORTH_WEST_SANS_SERIF_ARROW = chr(129108)
NORTH_EAST_SANS_SERIF_ARROW = chr(129109)
SOUTH_EAST_SANS_SERIF_ARROW = chr(129110)
SOUTH_WEST_SANS_SERIF_ARROW = chr(129111)
LEFT_RIGHT_SANS_SERIF_ARROW = chr(129112)
UP_DOWN_SANS_SERIF_ARROW = chr(129113)
WIDE_HEADED_LEFTWARDS_LIGHT_BARB_ARROW = chr(129120)
WIDE_HEADED_UPWARDS_LIGHT_BARB_ARROW = chr(129121)
WIDE_HEADED_RIGHTWARDS_LIGHT_BARB_ARROW = chr(129122)
WIDE_HEADED_DOWNWARDS_LIGHT_BARB_ARROW = chr(129123)
WIDE_HEADED_NORTH_WEST_LIGHT_BARB_ARROW = chr(129124)
WIDE_HEADED_NORTH_EAST_LIGHT_BARB_ARROW = chr(129125)
WIDE_HEADED_SOUTH_EAST_LIGHT_BARB_ARROW = chr(129126)
WIDE_HEADED_SOUTH_WEST_LIGHT_BARB_ARROW = chr(129127)
WIDE_HEADED_LEFTWARDS_BARB_ARROW = chr(129128)
WIDE_HEADED_UPWARDS_BARB_ARROW = chr(129129)
WIDE_HEADED_RIGHTWARDS_BARB_ARROW = chr(129130)
WIDE_HEADED_DOWNWARDS_BARB_ARROW = chr(129131)
WIDE_HEADED_NORTH_WEST_BARB_ARROW = chr(129132)
WIDE_HEADED_NORTH_EAST_BARB_ARROW = chr(129133)
WIDE_HEADED_SOUTH_EAST_BARB_ARROW = chr(129134)
WIDE_HEADED_SOUTH_WEST_BARB_ARROW = chr(129135)
WIDE_HEADED_LEFTWARDS_MEDIUM_BARB_ARROW = chr(129136)
WIDE_HEADED_UPWARDS_MEDIUM_BARB_ARROW = chr(129137)
WIDE_HEADED_RIGHTWARDS_MEDIUM_BARB_ARROW = chr(129138)
WIDE_HEADED_DOWNWARDS_MEDIUM_BARB_ARROW = chr(129139)
WIDE_HEADED_NORTH_WEST_MEDIUM_BARB_ARROW = chr(129140)
WIDE_HEADED_NORTH_EAST_MEDIUM_BARB_ARROW = chr(129141)
WIDE_HEADED_SOUTH_EAST_MEDIUM_BARB_ARROW = chr(129142)
WIDE_HEADED_SOUTH_WEST_MEDIUM_BARB_ARROW = chr(129143)
WIDE_HEADED_LEFTWARDS_HEAVY_BARB_ARROW = chr(129144)
WIDE_HEADED_UPWARDS_HEAVY_BARB_ARROW = chr(129145)
WIDE_HEADED_RIGHTWARDS_HEAVY_BARB_ARROW = chr(129146)
WIDE_HEADED_DOWNWARDS_HEAVY_BARB_ARROW = chr(129147)
WIDE_HEADED_NORTH_WEST_HEAVY_BARB_ARROW = chr(129148)
WIDE_HEADED_NORTH_EAST_HEAVY_BARB_ARROW = chr(129149)
WIDE_HEADED_SOUTH_EAST_HEAVY_BARB_ARROW = chr(129150)
WIDE_HEADED_SOUTH_WEST_HEAVY_BARB_ARROW = chr(129151)
WIDE_HEADED_LEFTWARDS_VERY_HEAVY_BARB_ARROW = chr(129152)
WIDE_HEADED_UPWARDS_VERY_HEAVY_BARB_ARROW = chr(129153)
WIDE_HEADED_RIGHTWARDS_VERY_HEAVY_BARB_ARROW = chr(129154)
WIDE_HEADED_DOWNWARDS_VERY_HEAVY_BARB_ARROW = chr(129155)
WIDE_HEADED_NORTH_WEST_VERY_HEAVY_BARB_ARROW = chr(129156)
WIDE_HEADED_NORTH_EAST_VERY_HEAVY_BARB_ARROW = chr(129157)
WIDE_HEADED_SOUTH_EAST_VERY_HEAVY_BARB_ARROW = chr(129158)
WIDE_HEADED_SOUTH_WEST_VERY_HEAVY_BARB_ARROW = chr(129159)
LEFTWARDS_TRIANGLE_ARROWHEAD = chr(129168)
UPWARDS_TRIANGLE_ARROWHEAD = chr(129169)
RIGHTWARDS_TRIANGLE_ARROWHEAD = chr(129170)
DOWNWARDS_TRIANGLE_ARROWHEAD = chr(129171)
LEFTWARDS_WHITE_ARROW_WITHIN_TRIANGLE_ARROWHEAD = chr(129172)
UPWARDS_WHITE_ARROW_WITHIN_TRIANGLE_ARROWHEAD = chr(129173)
RIGHTWARDS_WHITE_ARROW_WITHIN_TRIANGLE_ARROWHEAD = chr(129174)
DOWNWARDS_WHITE_ARROW_WITHIN_TRIANGLE_ARROWHEAD = chr(129175)
LEFTWARDS_ARROW_WITH_NOTCHED_TAIL = chr(129176)
UPWARDS_ARROW_WITH_NOTCHED_TAIL = chr(129177)
RIGHTWARDS_ARROW_WITH_NOTCHED_TAIL = chr(129178)
DOWNWARDS_ARROW_WITH_NOTCHED_TAIL = chr(129179)
HEAVY_ARROW_SHAFT_WIDTH_ONE = chr(129180)
HEAVY_ARROW_SHAFT_WIDTH_TWO_THIRDS = chr(129181)
HEAVY_ARROW_SHAFT_WIDTH_ONE_HALF = chr(129182)
HEAVY_ARROW_SHAFT_WIDTH_ONE_THIRD = chr(129183)
LEFTWARDS_BOTTOM_SHADED_WHITE_ARROW = chr(129184)
RIGHTWARDS_BOTTOM_SHADED_WHITE_ARROW = chr(129185)
LEFTWARDS_TOP_SHADED_WHITE_ARROW = chr(129186)
RIGHTWARDS_TOP_SHADED_WHITE_ARROW = chr(129187)
LEFTWARDS_LEFT_SHADED_WHITE_ARROW = chr(129188)
RIGHTWARDS_RIGHT_SHADED_WHITE_ARROW = chr(129189)
LEFTWARDS_RIGHT_SHADED_WHITE_ARROW = chr(129190)
RIGHTWARDS_LEFT_SHADED_WHITE_ARROW = chr(129191)
LEFTWARDS_BACK_TILTED_SHADOWED_WHITE_ARROW = chr(129192)
RIGHTWARDS_BACK_TILTED_SHADOWED_WHITE_ARROW = chr(129193)
LEFTWARDS_FRONT_TILTED_SHADOWED_WHITE_ARROW = chr(129194)
RIGHTWARDS_FRONT_TILTED_SHADOWED_WHITE_ARROW = chr(129195)
WHITE_ARROW_SHAFT_WIDTH_ONE = chr(129196)
WHITE_ARROW_SHAFT_WIDTH_TWO_THIRDS = chr(129197)
ARROW_POINTING_UPWARDS_THEN_NORTH_WEST = chr(129200)
ARROW_POINTING_RIGHTWARDS_THEN_CURVING_SOUTH_WEST = chr(129201)
CIRCLED_CROSS_FORMEE_WITH_FOUR_DOTS = chr(129280)
CIRCLED_CROSS_FORMEE_WITH_TWO_DOTS = chr(129281)
CIRCLED_CROSS_FORMEE = chr(129282)
LEFT_HALF_CIRCLE_WITH_FOUR_DOTS = chr(129283)
LEFT_HALF_CIRCLE_WITH_THREE_DOTS = chr(129284)
LEFT_HALF_CIRCLE_WITH_TWO_DOTS = chr(129285)
LEFT_HALF_CIRCLE_WITH_DOT = chr(129286)
LEFT_HALF_CIRCLE = chr(129287)
DOWNWARD_FACING_HOOK = chr(129288)
DOWNWARD_FACING_NOTCHED_HOOK = chr(129289)
DOWNWARD_FACING_HOOK_WITH_DOT = chr(129290)
DOWNWARD_FACING_NOTCHED_HOOK_WITH_DOT = chr(129291)
PINCHED_FINGERS = chr(129292)
WHITE_HEART = chr(129293)
BROWN_HEART = chr(129294)
PINCHING_HAND = chr(129295)
ZIPPER_MOUTH_FACE = chr(129296)
MONEY_MOUTH_FACE = chr(129297)
FACE_WITH_THERMOMETER = chr(129298)
NERD_FACE = chr(129299)
THINKING_FACE = chr(129300)
FACE_WITH_HEAD_BANDAGE = chr(129301)
ROBOT_FACE = chr(129302)
HUGGING_FACE = chr(129303)
SIGN_OF_THE_HORNS = chr(129304)
CALL_ME_HAND = chr(129305)
RAISED_BACK_OF_HAND = chr(129306)
LEFT_FACING_FIST = chr(129307)
RIGHT_FACING_FIST = chr(129308)
HANDSHAKE = chr(129309)
HAND_WITH_INDEX_AND_MIDDLE_FINGERS_CROSSED = chr(129310)
I_LOVE_YOU_HAND_SIGN = chr(129311)
FACE_WITH_COWBOY_HAT = chr(129312)
CLOWN_FACE = chr(129313)
NAUSEATED_FACE = chr(129314)
ROLLING_ON_THE_FLOOR_LAUGHING = chr(129315)
DROOLING_FACE = chr(129316)
LYING_FACE = chr(129317)
FACE_PALM = chr(129318)
SNEEZING_FACE = chr(129319)
FACE_WITH_ONE_EYEBROW_RAISED = chr(129320)
GRINNING_FACE_WITH_STAR_EYES = chr(129321)
GRINNING_FACE_WITH_ONE_LARGE_AND_ONE_SMALL_EYE = chr(129322)
FACE_WITH_FINGER_COVERING_CLOSED_LIPS = chr(129323)
SERIOUS_FACE_WITH_SYMBOLS_COVERING_MOUTH = chr(129324)
SMILING_FACE_WITH_SMILING_EYES_AND_HAND_COVERING_MOUTH = chr(129325)
FACE_WITH_OPEN_MOUTH_VOMITING = chr(129326)
SHOCKED_FACE_WITH_EXPLODING_HEAD = chr(129327)
PREGNANT_WOMAN = chr(129328)
BREAST_FEEDING = chr(129329)
PALMS_UP_TOGETHER = chr(129330)
SELFIE = chr(129331)
PRINCE = chr(129332)
MAN_IN_TUXEDO = chr(129333)
MOTHER_CHRISTMAS = chr(129334)
SHRUG = chr(129335)
PERSON_DOING_CARTWHEEL = chr(129336)
JUGGLING = chr(129337)
FENCER = chr(129338)
MODERN_PENTATHLON = chr(129339)
WRESTLERS = chr(129340)
WATER_POLO = chr(129341)
HANDBALL = chr(129342)
DIVING_MASK = chr(129343)
WILTED_FLOWER = chr(129344)
DRUM_WITH_DRUMSTICKS = chr(129345)
CLINKING_GLASSES = chr(129346)
TUMBLER_GLASS = chr(129347)
SPOON = chr(129348)
GOAL_NET = chr(129349)
RIFLE = chr(129350)
FIRST_PLACE_MEDAL = chr(129351)
SECOND_PLACE_MEDAL = chr(129352)
THIRD_PLACE_MEDAL = chr(129353)
BOXING_GLOVE = chr(129354)
MARTIAL_ARTS_UNIFORM = chr(129355)
CURLING_STONE = chr(129356)
LACROSSE_STICK_AND_BALL = chr(129357)
SOFTBALL = chr(129358)
FLYING_DISC = chr(129359)
CROISSANT = chr(129360)
AVOCADO = chr(129361)
CUCUMBER = chr(129362)
BACON = chr(129363)
POTATO = chr(129364)
CARROT = chr(129365)
BAGUETTE_BREAD = chr(129366)
GREEN_SALAD = chr(129367)
SHALLOW_PAN_OF_FOOD = chr(129368)
STUFFED_FLATBREAD = chr(129369)
EGG = chr(129370)
GLASS_OF_MILK = chr(129371)
PEANUTS = chr(129372)
KIWIFRUIT = chr(129373)
PANCAKES = chr(129374)
DUMPLING = chr(129375)
FORTUNE_COOKIE = chr(129376)
TAKEOUT_BOX = chr(129377)
CHOPSTICKS = chr(129378)
BOWL_WITH_SPOON = chr(129379)
CUP_WITH_STRAW = chr(129380)
COCONUT = chr(129381)
BROCCOLI = chr(129382)
PIE = chr(129383)
PRETZEL = chr(129384)
CUT_OF_MEAT = chr(129385)
SANDWICH = chr(129386)
CANNED_FOOD = chr(129387)
LEAFY_GREEN = chr(129388)
MANGO = chr(129389)
MOON_CAKE = chr(129390)
BAGEL = chr(129391)
SMILING_FACE_WITH_SMILING_EYES_AND_THREE_HEARTS = chr(129392)
YAWNING_FACE = chr(129393)
SMILING_FACE_WITH_TEAR = chr(129394)
FACE_WITH_PARTY_HORN_AND_PARTY_HAT = chr(129395)
FACE_WITH_UNEVEN_EYES_AND_WAVY_MOUTH = chr(129396)
OVERHEATED_FACE = chr(129397)
FREEZING_FACE = chr(129398)
NINJA = chr(129399)
DISGUISED_FACE = chr(129400)
FACE_HOLDING_BACK_TEARS = chr(129401)
FACE_WITH_PLEADING_EYES = chr(129402)
SARI = chr(129403)
LAB_COAT = chr(129404)
GOGGLES = chr(129405)
HIKING_BOOT = chr(129406)
FLAT_SHOE = chr(129407)
CRAB = chr(129408)
LION_FACE = chr(129409)
SCORPION = chr(129410)
TURKEY = chr(129411)
UNICORN_FACE = chr(129412)
EAGLE = chr(129413)
DUCK = chr(129414)
BAT = chr(129415)
SHARK = chr(129416)
OWL = chr(129417)
FOX_FACE = chr(129418)
BUTTERFLY = chr(129419)
DEER = chr(129420)
GORILLA = chr(129421)
LIZARD = chr(129422)
RHINOCEROS = chr(129423)
SHRIMP = chr(129424)
SQUID = chr(129425)
GIRAFFE_FACE = chr(129426)
ZEBRA_FACE = chr(129427)
HEDGEHOG = chr(129428)
SAUROPOD = chr(129429)
T_REX = chr(129430)
CRICKET = chr(129431)
KANGAROO = chr(129432)
LLAMA = chr(129433)
PEACOCK = chr(129434)
HIPPOPOTAMUS = chr(129435)
PARROT = chr(129436)
RACCOON = chr(129437)
LOBSTER = chr(129438)
MOSQUITO = chr(129439)
MICROBE = chr(129440)
BADGER = chr(129441)
SWAN = chr(129442)
MAMMOTH = chr(129443)
DODO = chr(129444)
SLOTH = chr(129445)
OTTER = chr(129446)
ORANGUTAN = chr(129447)
SKUNK = chr(129448)
FLAMINGO = chr(129449)
OYSTER = chr(129450)
BEAVER = chr(129451)
BISON = chr(129452)
SEAL = chr(129453)
GUIDE_DOG = chr(129454)
PROBING_CANE = chr(129455)
EMOJI_COMPONENT_RED_HAIR = chr(129456)
EMOJI_COMPONENT_CURLY_HAIR = chr(129457)
EMOJI_COMPONENT_BALD = chr(129458)
EMOJI_COMPONENT_WHITE_HAIR = chr(129459)
BONE = chr(129460)
LEG = chr(129461)
FOOT = chr(129462)
TOOTH = chr(129463)
SUPERHERO = chr(129464)
SUPERVILLAIN = chr(129465)
SAFETY_VEST = chr(129466)
EAR_WITH_HEARING_AID = chr(129467)
MOTORIZED_WHEELCHAIR = chr(129468)
MANUAL_WHEELCHAIR = chr(129469)
MECHANICAL_ARM = chr(129470)
MECHANICAL_LEG = chr(129471)
CHEESE_WEDGE = chr(129472)
CUPCAKE = chr(129473)
SALT_SHAKER = chr(129474)
BEVERAGE_BOX = chr(129475)
GARLIC = chr(129476)
ONION = chr(129477)
FALAFEL = chr(129478)
WAFFLE = chr(129479)
BUTTER = chr(129480)
MATE_DRINK = chr(129481)
ICE_CUBE = chr(129482)
BUBBLE_TEA = chr(129483)
TROLL = chr(129484)
STANDING_PERSON = chr(129485)
KNEELING_PERSON = chr(129486)
DEAF_PERSON = chr(129487)
FACE_WITH_MONOCLE = chr(129488)
ADULT = chr(129489)
CHILD = chr(129490)
OLDER_ADULT = chr(129491)
BEARDED_PERSON = chr(129492)
PERSON_WITH_HEADSCARF = chr(129493)
PERSON_IN_STEAMY_ROOM = chr(129494)
PERSON_CLIMBING = chr(129495)
PERSON_IN_LOTUS_POSITION = chr(129496)
MAGE = chr(129497)
FAIRY = chr(129498)
VAMPIRE = chr(129499)
MERPERSON = chr(129500)
ELF = chr(129501)
GENIE = chr(129502)
ZOMBIE = chr(129503)
BRAIN = chr(129504)
ORANGE_HEART = chr(129505)
BILLED_CAP = chr(129506)
SCARF = chr(129507)
GLOVES = chr(129508)
COAT = chr(129509)
SOCKS = chr(129510)
RED_GIFT_ENVELOPE = chr(129511)
FIRECRACKER = chr(129512)
JIGSAW_PUZZLE_PIECE = chr(129513)
TEST_TUBE = chr(129514)
PETRI_DISH = chr(129515)
DNA_DOUBLE_HELIX = chr(129516)
COMPASS = chr(129517)
ABACUS = chr(129518)
FIRE_EXTINGUISHER = chr(129519)
TOOLBOX = chr(129520)
BRICK = chr(129521)
MAGNET = chr(129522)
LUGGAGE = chr(129523)
LOTION_BOTTLE = chr(129524)
SPOOL_OF_THREAD = chr(129525)
BALL_OF_YARN = chr(129526)
SAFETY_PIN = chr(129527)
TEDDY_BEAR = chr(129528)
BROOM = chr(129529)
BASKET = chr(129530)
ROLL_OF_PAPER = chr(129531)
BAR_OF_SOAP = chr(129532)
SPONGE = chr(129533)
RECEIPT = chr(129534)
NAZAR_AMULET = chr(129535)
NEUTRAL_CHESS_KING = chr(129536)
NEUTRAL_CHESS_QUEEN = chr(129537)
NEUTRAL_CHESS_ROOK = chr(129538)
NEUTRAL_CHESS_BISHOP = chr(129539)
NEUTRAL_CHESS_KNIGHT = chr(129540)
NEUTRAL_CHESS_PAWN = chr(129541)
WHITE_CHESS_KNIGHT_ROTATED_FORTY_FIVE_DEGREES = chr(129542)
BLACK_CHESS_KNIGHT_ROTATED_FORTY_FIVE_DEGREES = chr(129543)
NEUTRAL_CHESS_KNIGHT_ROTATED_FORTY_FIVE_DEGREES = chr(129544)
WHITE_CHESS_KING_ROTATED_NINETY_DEGREES = chr(129545)
WHITE_CHESS_QUEEN_ROTATED_NINETY_DEGREES = chr(129546)
WHITE_CHESS_ROOK_ROTATED_NINETY_DEGREES = chr(129547)
WHITE_CHESS_BISHOP_ROTATED_NINETY_DEGREES = chr(129548)
WHITE_CHESS_KNIGHT_ROTATED_NINETY_DEGREES = chr(129549)
WHITE_CHESS_PAWN_ROTATED_NINETY_DEGREES = chr(129550)
BLACK_CHESS_KING_ROTATED_NINETY_DEGREES = chr(129551)
BLACK_CHESS_QUEEN_ROTATED_NINETY_DEGREES = chr(129552)
BLACK_CHESS_ROOK_ROTATED_NINETY_DEGREES = chr(129553)
BLACK_CHESS_BISHOP_ROTATED_NINETY_DEGREES = chr(129554)
BLACK_CHESS_KNIGHT_ROTATED_NINETY_DEGREES = chr(129555)
BLACK_CHESS_PAWN_ROTATED_NINETY_DEGREES = chr(129556)
NEUTRAL_CHESS_KING_ROTATED_NINETY_DEGREES = chr(129557)
NEUTRAL_CHESS_QUEEN_ROTATED_NINETY_DEGREES = chr(129558)
NEUTRAL_CHESS_ROOK_ROTATED_NINETY_DEGREES = chr(129559)
NEUTRAL_CHESS_BISHOP_ROTATED_NINETY_DEGREES = chr(129560)
NEUTRAL_CHESS_KNIGHT_ROTATED_NINETY_DEGREES = chr(129561)
NEUTRAL_CHESS_PAWN_ROTATED_NINETY_DEGREES = chr(129562)
WHITE_CHESS_KNIGHT_ROTATED_ONE_HUNDRED_THIRTY_FIVE_DEGREES = chr(129563)
BLACK_CHESS_KNIGHT_ROTATED_ONE_HUNDRED_THIRTY_FIVE_DEGREES = chr(129564)
NEUTRAL_CHESS_KNIGHT_ROTATED_ONE_HUNDRED_THIRTY_FIVE_DEGREES = chr(129565)
WHITE_CHESS_TURNED_KING = chr(129566)
WHITE_CHESS_TURNED_QUEEN = chr(129567)
WHITE_CHESS_TURNED_ROOK = chr(129568)
WHITE_CHESS_TURNED_BISHOP = chr(129569)
WHITE_CHESS_TURNED_KNIGHT = chr(129570)
WHITE_CHESS_TURNED_PAWN = chr(129571)
BLACK_CHESS_TURNED_KING = chr(129572)
BLACK_CHESS_TURNED_QUEEN = chr(129573)
BLACK_CHESS_TURNED_ROOK = chr(129574)
BLACK_CHESS_TURNED_BISHOP = chr(129575)
BLACK_CHESS_TURNED_KNIGHT = chr(129576)
BLACK_CHESS_TURNED_PAWN = chr(129577)
NEUTRAL_CHESS_TURNED_KING = chr(129578)
NEUTRAL_CHESS_TURNED_QUEEN = chr(129579)
NEUTRAL_CHESS_TURNED_ROOK = chr(129580)
NEUTRAL_CHESS_TURNED_BISHOP = chr(129581)
NEUTRAL_CHESS_TURNED_KNIGHT = chr(129582)
NEUTRAL_CHESS_TURNED_PAWN = chr(129583)
WHITE_CHESS_KNIGHT_ROTATED_TWO_HUNDRED_TWENTY_FIVE_DEGREES = chr(129584)
BLACK_CHESS_KNIGHT_ROTATED_TWO_HUNDRED_TWENTY_FIVE_DEGREES = chr(129585)
NEUTRAL_CHESS_KNIGHT_ROTATED_TWO_HUNDRED_TWENTY_FIVE_DEGREES = chr(129586)
WHITE_CHESS_KING_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129587)
WHITE_CHESS_QUEEN_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129588)
WHITE_CHESS_ROOK_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129589)
WHITE_CHESS_BISHOP_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129590)
WHITE_CHESS_KNIGHT_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129591)
WHITE_CHESS_PAWN_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129592)
BLACK_CHESS_KING_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129593)
BLACK_CHESS_QUEEN_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129594)
BLACK_CHESS_ROOK_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129595)
BLACK_CHESS_BISHOP_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129596)
BLACK_CHESS_KNIGHT_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129597)
BLACK_CHESS_PAWN_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129598)
NEUTRAL_CHESS_KING_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129599)
NEUTRAL_CHESS_QUEEN_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129600)
NEUTRAL_CHESS_ROOK_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129601)
NEUTRAL_CHESS_BISHOP_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129602)
NEUTRAL_CHESS_KNIGHT_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129603)
NEUTRAL_CHESS_PAWN_ROTATED_TWO_HUNDRED_SEVENTY_DEGREES = chr(129604)
WHITE_CHESS_KNIGHT_ROTATED_THREE_HUNDRED_FIFTEEN_DEGREES = chr(129605)
BLACK_CHESS_KNIGHT_ROTATED_THREE_HUNDRED_FIFTEEN_DEGREES = chr(129606)
NEUTRAL_CHESS_KNIGHT_ROTATED_THREE_HUNDRED_FIFTEEN_DEGREES = chr(129607)
WHITE_CHESS_EQUIHOPPER = chr(129608)
BLACK_CHESS_EQUIHOPPER = chr(129609)
NEUTRAL_CHESS_EQUIHOPPER = chr(129610)
WHITE_CHESS_EQUIHOPPER_ROTATED_NINETY_DEGREES = chr(129611)
BLACK_CHESS_EQUIHOPPER_ROTATED_NINETY_DEGREES = chr(129612)
NEUTRAL_CHESS_EQUIHOPPER_ROTATED_NINETY_DEGREES = chr(129613)
WHITE_CHESS_KNIGHT_QUEEN = chr(129614)
WHITE_CHESS_KNIGHT_ROOK = chr(129615)
WHITE_CHESS_KNIGHT_BISHOP = chr(129616)
BLACK_CHESS_KNIGHT_QUEEN = chr(129617)
BLACK_CHESS_KNIGHT_ROOK = chr(129618)
BLACK_CHESS_KNIGHT_BISHOP = chr(129619)
XIANGQI_RED_GENERAL = chr(129632)
XIANGQI_RED_MANDARIN = chr(129633)
XIANGQI_RED_ELEPHANT = chr(129634)
XIANGQI_RED_HORSE = chr(129635)
XIANGQI_RED_CHARIOT = chr(129636)
XIANGQI_RED_CANNON = chr(129637)
XIANGQI_RED_SOLDIER = chr(129638)
XIANGQI_BLACK_GENERAL = chr(129639)
XIANGQI_BLACK_MANDARIN = chr(129640)
XIANGQI_BLACK_ELEPHANT = chr(129641)
XIANGQI_BLACK_HORSE = chr(129642)
XIANGQI_BLACK_CHARIOT = chr(129643)
XIANGQI_BLACK_CANNON = chr(129644)
XIANGQI_BLACK_SOLDIER = chr(129645)
BALLET_SHOES = chr(129648)
ONE_PIECE_SWIMSUIT = chr(129649)
BRIEFS = chr(129650)
SHORTS = chr(129651)
THONG_SANDAL = chr(129652)
LIGHT_BLUE_HEART = chr(129653)
GREY_HEART = chr(129654)
PINK_HEART = chr(129655)
DROP_OF_BLOOD = chr(129656)
ADHESIVE_BANDAGE = chr(129657)
STETHOSCOPE = chr(129658)
X_RAY = chr(129659)
CRUTCH = chr(129660)
YO_YO = chr(129664)
KITE = chr(129665)
PARACHUTE = chr(129666)
BOOMERANG = chr(129667)
MAGIC_WAND = chr(129668)
PINATA = chr(129669)
NESTING_DOLLS = chr(129670)
MARACAS = chr(129671)
FLUTE = chr(129672)
RINGED_PLANET = chr(129680)
CHAIR = chr(129681)
RAZOR = chr(129682)
AXE = chr(129683)
DIYA_LAMP = chr(129684)
BANJO = chr(129685)
MILITARY_HELMET = chr(129686)
ACCORDION = chr(129687)
LONG_DRUM = chr(129688)
COIN = chr(129689)
CARPENTRY_SAW = chr(129690)
SCREWDRIVER = chr(129691)
LADDER = chr(129692)
HOOK = chr(129693)
MIRROR = chr(129694)
WINDOW = chr(129695)
PLUNGER = chr(129696)
SEWING_NEEDLE = chr(129697)
KNOT = chr(129698)
BUCKET = chr(129699)
MOUSE_TRAP = chr(129700)
TOOTHBRUSH = chr(129701)
HEADSTONE = chr(129702)
PLACARD = chr(129703)
ROCK = chr(129704)
MIRROR_BALL = chr(129705)
IDENTIFICATION_CARD = chr(129706)
LOW_BATTERY = chr(129707)
HAMSA = chr(129708)
FOLDING_HAND_FAN = chr(129709)
HAIR_PICK = chr(129710)
KHANDA = chr(129711)
FLY = chr(129712)
WORM = chr(129713)
BEETLE = chr(129714)
COCKROACH = chr(129715)
POTTED_PLANT = chr(129716)
WOOD = chr(129717)
FEATHER = chr(129718)
LOTUS = chr(129719)
CORAL = chr(129720)
EMPTY_NEST = chr(129721)
NEST_WITH_EGGS = chr(129722)
HYACINTH = chr(129723)
JELLYFISH = chr(129724)
WING = chr(129725)
GOOSE = chr(129727)
ANATOMICAL_HEART = chr(129728)
LUNGS = chr(129729)
PEOPLE_HUGGING = chr(129730)
PREGNANT_MAN = chr(129731)
PREGNANT_PERSON = chr(129732)
PERSON_WITH_CROWN = chr(129733)
MOOSE = chr(129742)
DONKEY = chr(129743)
BLUEBERRIES = chr(129744)
BELL_PEPPER = chr(129745)
OLIVE = chr(129746)
FLATBREAD = chr(129747)
TAMALE = chr(129748)
FONDUE = chr(129749)
TEAPOT = chr(129750)
POURING_LIQUID = chr(129751)
BEANS = chr(129752)
JAR = chr(129753)
GINGER_ROOT = chr(129754)
PEA_POD = chr(129755)
MELTING_FACE = chr(129760)
SALUTING_FACE = chr(129761)
FACE_WITH_OPEN_EYES_AND_HAND_OVER_MOUTH = chr(129762)
FACE_WITH_PEEKING_EYE = chr(129763)
FACE_WITH_DIAGONAL_MOUTH = chr(129764)
DOTTED_LINE_FACE = chr(129765)
BITING_LIP = chr(129766)
BUBBLES = chr(129767)
SHAKING_FACE = chr(129768)
HAND_WITH_INDEX_FINGER_AND_THUMB_CROSSED = chr(129776)
RIGHTWARDS_HAND = chr(129777)
LEFTWARDS_HAND = chr(129778)
PALM_DOWN_HAND = chr(129779)
PALM_UP_HAND = chr(129780)
INDEX_POINTING_AT_THE_VIEWER = chr(129781)
HEART_HANDS = chr(129782)
LEFTWARDS_PUSHING_HAND = chr(129783)
RIGHTWARDS_PUSHING_HAND = chr(129784)
BLOCK_SEXTANT_1 = chr(129792)
BLOCK_SEXTANT_2 = chr(129793)
BLOCK_SEXTANT_12 = chr(129794)
BLOCK_SEXTANT_3 = chr(129795)
BLOCK_SEXTANT_13 = chr(129796)
BLOCK_SEXTANT_23 = chr(129797)
BLOCK_SEXTANT_123 = chr(129798)
BLOCK_SEXTANT_4 = chr(129799)
BLOCK_SEXTANT_14 = chr(129800)
BLOCK_SEXTANT_24 = chr(129801)
BLOCK_SEXTANT_124 = chr(129802)
BLOCK_SEXTANT_34 = chr(129803)
BLOCK_SEXTANT_134 = chr(129804)
BLOCK_SEXTANT_234 = chr(129805)
BLOCK_SEXTANT_1234 = chr(129806)
BLOCK_SEXTANT_5 = chr(129807)
BLOCK_SEXTANT_15 = chr(129808)
BLOCK_SEXTANT_25 = chr(129809)
BLOCK_SEXTANT_125 = chr(129810)
BLOCK_SEXTANT_35 = chr(129811)
BLOCK_SEXTANT_235 = chr(129812)
BLOCK_SEXTANT_1235 = chr(129813)
BLOCK_SEXTANT_45 = chr(129814)
BLOCK_SEXTANT_145 = chr(129815)
BLOCK_SEXTANT_245 = chr(129816)
BLOCK_SEXTANT_1245 = chr(129817)
BLOCK_SEXTANT_345 = chr(129818)
BLOCK_SEXTANT_1345 = chr(129819)
BLOCK_SEXTANT_2345 = chr(129820)
BLOCK_SEXTANT_12345 = chr(129821)
BLOCK_SEXTANT_6 = chr(129822)
BLOCK_SEXTANT_16 = chr(129823)
BLOCK_SEXTANT_26 = chr(129824)
BLOCK_SEXTANT_126 = chr(129825)
BLOCK_SEXTANT_36 = chr(129826)
BLOCK_SEXTANT_136 = chr(129827)
BLOCK_SEXTANT_236 = chr(129828)
BLOCK_SEXTANT_1236 = chr(129829)
BLOCK_SEXTANT_46 = chr(129830)
BLOCK_SEXTANT_146 = chr(129831)
BLOCK_SEXTANT_1246 = chr(129832)
BLOCK_SEXTANT_346 = chr(129833)
BLOCK_SEXTANT_1346 = chr(129834)
BLOCK_SEXTANT_2346 = chr(129835)
BLOCK_SEXTANT_12346 = chr(129836)
BLOCK_SEXTANT_56 = chr(129837)
BLOCK_SEXTANT_156 = chr(129838)
BLOCK_SEXTANT_256 = chr(129839)
BLOCK_SEXTANT_1256 = chr(129840)
BLOCK_SEXTANT_356 = chr(129841)
BLOCK_SEXTANT_1356 = chr(129842)
BLOCK_SEXTANT_2356 = chr(129843)
BLOCK_SEXTANT_12356 = chr(129844)
BLOCK_SEXTANT_456 = chr(129845)
BLOCK_SEXTANT_1456 = chr(129846)
BLOCK_SEXTANT_2456 = chr(129847)
BLOCK_SEXTANT_12456 = chr(129848)
BLOCK_SEXTANT_3456 = chr(129849)
BLOCK_SEXTANT_13456 = chr(129850)
BLOCK_SEXTANT_23456 = chr(129851)
LOWER_LEFT_BLOCK_DIAGONAL_LOWER_MIDDLE_LEFT_TO_LOWER_CENTRE = chr(129852)
LOWER_LEFT_BLOCK_DIAGONAL_LOWER_MIDDLE_LEFT_TO_LOWER_RIGHT = chr(129853)
LOWER_LEFT_BLOCK_DIAGONAL_UPPER_MIDDLE_LEFT_TO_LOWER_CENTRE = chr(129854)
LOWER_LEFT_BLOCK_DIAGONAL_UPPER_MIDDLE_LEFT_TO_LOWER_RIGHT = chr(129855)
LOWER_LEFT_BLOCK_DIAGONAL_UPPER_LEFT_TO_LOWER_CENTRE = chr(129856)
LOWER_RIGHT_BLOCK_DIAGONAL_UPPER_MIDDLE_LEFT_TO_UPPER_CENTRE = chr(129857)
LOWER_RIGHT_BLOCK_DIAGONAL_UPPER_MIDDLE_LEFT_TO_UPPER_RIGHT = chr(129858)
LOWER_RIGHT_BLOCK_DIAGONAL_LOWER_MIDDLE_LEFT_TO_UPPER_CENTRE = chr(129859)
LOWER_RIGHT_BLOCK_DIAGONAL_LOWER_MIDDLE_LEFT_TO_UPPER_RIGHT = chr(129860)
LOWER_RIGHT_BLOCK_DIAGONAL_LOWER_LEFT_TO_UPPER_CENTRE = chr(129861)
LOWER_RIGHT_BLOCK_DIAGONAL_LOWER_MIDDLE_LEFT_TO_UPPER_MIDDLE_RIGHT = chr(129862)
LOWER_RIGHT_BLOCK_DIAGONAL_LOWER_CENTRE_TO_LOWER_MIDDLE_RIGHT = chr(129863)
LOWER_RIGHT_BLOCK_DIAGONAL_LOWER_LEFT_TO_LOWER_MIDDLE_RIGHT = chr(129864)
LOWER_RIGHT_BLOCK_DIAGONAL_LOWER_CENTRE_TO_UPPER_MIDDLE_RIGHT = chr(129865)
LOWER_RIGHT_BLOCK_DIAGONAL_LOWER_LEFT_TO_UPPER_MIDDLE_RIGHT = chr(129866)
LOWER_RIGHT_BLOCK_DIAGONAL_LOWER_CENTRE_TO_UPPER_RIGHT = chr(129867)
LOWER_LEFT_BLOCK_DIAGONAL_UPPER_CENTRE_TO_UPPER_MIDDLE_RIGHT = chr(129868)
LOWER_LEFT_BLOCK_DIAGONAL_UPPER_LEFT_TO_UPPER_MIDDLE_RIGHT = chr(129869)
LOWER_LEFT_BLOCK_DIAGONAL_UPPER_CENTRE_TO_LOWER_MIDDLE_RIGHT = chr(129870)
LOWER_LEFT_BLOCK_DIAGONAL_UPPER_LEFT_TO_LOWER_MIDDLE_RIGHT = chr(129871)
LOWER_LEFT_BLOCK_DIAGONAL_UPPER_CENTRE_TO_LOWER_RIGHT = chr(129872)
LOWER_LEFT_BLOCK_DIAGONAL_UPPER_MIDDLE_LEFT_TO_LOWER_MIDDLE_RIGHT = chr(129873)
UPPER_RIGHT_BLOCK_DIAGONAL_LOWER_MIDDLE_LEFT_TO_LOWER_CENTRE = chr(129874)
UPPER_RIGHT_BLOCK_DIAGONAL_LOWER_MIDDLE_LEFT_TO_LOWER_RIGHT = chr(129875)
UPPER_RIGHT_BLOCK_DIAGONAL_UPPER_MIDDLE_LEFT_TO_LOWER_CENTRE = chr(129876)
UPPER_RIGHT_BLOCK_DIAGONAL_UPPER_MIDDLE_LEFT_TO_LOWER_RIGHT = chr(129877)
UPPER_RIGHT_BLOCK_DIAGONAL_UPPER_LEFT_TO_LOWER_CENTRE = chr(129878)
UPPER_LEFT_BLOCK_DIAGONAL_UPPER_MIDDLE_LEFT_TO_UPPER_CENTRE = chr(129879)
UPPER_LEFT_BLOCK_DIAGONAL_UPPER_MIDDLE_LEFT_TO_UPPER_RIGHT = chr(129880)
UPPER_LEFT_BLOCK_DIAGONAL_LOWER_MIDDLE_LEFT_TO_UPPER_CENTRE = chr(129881)
UPPER_LEFT_BLOCK_DIAGONAL_LOWER_MIDDLE_LEFT_TO_UPPER_RIGHT = chr(129882)
UPPER_LEFT_BLOCK_DIAGONAL_LOWER_LEFT_TO_UPPER_CENTRE = chr(129883)
UPPER_LEFT_BLOCK_DIAGONAL_LOWER_MIDDLE_LEFT_TO_UPPER_MIDDLE_RIGHT = chr(129884)
UPPER_LEFT_BLOCK_DIAGONAL_LOWER_CENTRE_TO_LOWER_MIDDLE_RIGHT = chr(129885)
UPPER_LEFT_BLOCK_DIAGONAL_LOWER_LEFT_TO_LOWER_MIDDLE_RIGHT = chr(129886)
UPPER_LEFT_BLOCK_DIAGONAL_LOWER_CENTRE_TO_UPPER_MIDDLE_RIGHT = chr(129887)
UPPER_LEFT_BLOCK_DIAGONAL_LOWER_LEFT_TO_UPPER_MIDDLE_RIGHT = chr(129888)
UPPER_LEFT_BLOCK_DIAGONAL_LOWER_CENTRE_TO_UPPER_RIGHT = chr(129889)
UPPER_RIGHT_BLOCK_DIAGONAL_UPPER_CENTRE_TO_UPPER_MIDDLE_RIGHT = chr(129890)
UPPER_RIGHT_BLOCK_DIAGONAL_UPPER_LEFT_TO_UPPER_MIDDLE_RIGHT = chr(129891)
UPPER_RIGHT_BLOCK_DIAGONAL_UPPER_CENTRE_TO_LOWER_MIDDLE_RIGHT = chr(129892)
UPPER_RIGHT_BLOCK_DIAGONAL_UPPER_LEFT_TO_LOWER_MIDDLE_RIGHT = chr(129893)
UPPER_RIGHT_BLOCK_DIAGONAL_UPPER_CENTRE_TO_LOWER_RIGHT = chr(129894)
UPPER_RIGHT_BLOCK_DIAGONAL_UPPER_MIDDLE_LEFT_TO_LOWER_MIDDLE_RIGHT = chr(129895)
UPPER_AND_RIGHT_AND_LOWER_TRIANGULAR_THREE_QUARTERS_BLOCK = chr(129896)
LEFT_AND_LOWER_AND_RIGHT_TRIANGULAR_THREE_QUARTERS_BLOCK = chr(129897)
UPPER_AND_LEFT_AND_LOWER_TRIANGULAR_THREE_QUARTERS_BLOCK = chr(129898)
LEFT_AND_UPPER_AND_RIGHT_TRIANGULAR_THREE_QUARTERS_BLOCK = chr(129899)
LEFT_TRIANGULAR_ONE_QUARTER_BLOCK = chr(129900)
UPPER_TRIANGULAR_ONE_QUARTER_BLOCK = chr(129901)
RIGHT_TRIANGULAR_ONE_QUARTER_BLOCK = chr(129902)
LOWER_TRIANGULAR_ONE_QUARTER_BLOCK = chr(129903)
VERTICAL_ONE_EIGHTH_BLOCK_2 = chr(129904)
VERTICAL_ONE_EIGHTH_BLOCK_3 = chr(129905)
VERTICAL_ONE_EIGHTH_BLOCK_4 = chr(129906)
VERTICAL_ONE_EIGHTH_BLOCK_5 = chr(129907)
VERTICAL_ONE_EIGHTH_BLOCK_6 = chr(129908)
VERTICAL_ONE_EIGHTH_BLOCK_7 = chr(129909)
HORIZONTAL_ONE_EIGHTH_BLOCK_2 = chr(129910)
HORIZONTAL_ONE_EIGHTH_BLOCK_3 = chr(129911)
HORIZONTAL_ONE_EIGHTH_BLOCK_4 = chr(129912)
HORIZONTAL_ONE_EIGHTH_BLOCK_5 = chr(129913)
HORIZONTAL_ONE_EIGHTH_BLOCK_6 = chr(129914)
HORIZONTAL_ONE_EIGHTH_BLOCK_7 = chr(129915)
LEFT_AND_LOWER_ONE_EIGHTH_BLOCK = chr(129916)
LEFT_AND_UPPER_ONE_EIGHTH_BLOCK = chr(129917)
RIGHT_AND_UPPER_ONE_EIGHTH_BLOCK = chr(129918)
RIGHT_AND_LOWER_ONE_EIGHTH_BLOCK = chr(129919)
UPPER_AND_LOWER_ONE_EIGHTH_BLOCK = chr(129920)
HORIZONTAL_ONE_EIGHTH_BLOCK_1358 = chr(129921)
UPPER_ONE_QUARTER_BLOCK = chr(129922)
UPPER_THREE_EIGHTHS_BLOCK = chr(129923)
UPPER_FIVE_EIGHTHS_BLOCK = chr(129924)
UPPER_THREE_QUARTERS_BLOCK = chr(129925)
UPPER_SEVEN_EIGHTHS_BLOCK = chr(129926)
RIGHT_ONE_QUARTER_BLOCK = chr(129927)
RIGHT_THREE_EIGHTHS_BLOCK = chr(129928)
RIGHT_FIVE_EIGHTHS_BLOCK = chr(129929)
RIGHT_THREE_QUARTERS_BLOCK = chr(129930)
RIGHT_SEVEN_EIGHTHS_BLOCK = chr(129931)
LEFT_HALF_MEDIUM_SHADE = chr(129932)
RIGHT_HALF_MEDIUM_SHADE = chr(129933)
UPPER_HALF_MEDIUM_SHADE = chr(129934)
LOWER_HALF_MEDIUM_SHADE = chr(129935)
INVERSE_MEDIUM_SHADE = chr(129936)
UPPER_HALF_BLOCK_AND_LOWER_HALF_INVERSE_MEDIUM_SHADE = chr(129937)
UPPER_HALF_INVERSE_MEDIUM_SHADE_AND_LOWER_HALF_BLOCK = chr(129938)
LEFT_HALF_INVERSE_MEDIUM_SHADE_AND_RIGHT_HALF_BLOCK = chr(129940)
CHECKER_BOARD_FILL = chr(129941)
INVERSE_CHECKER_BOARD_FILL = chr(129942)
HEAVY_HORIZONTAL_FILL = chr(129943)
UPPER_LEFT_TO_LOWER_RIGHT_FILL = chr(129944)
UPPER_RIGHT_TO_LOWER_LEFT_FILL = chr(129945)
UPPER_AND_LOWER_TRIANGULAR_HALF_BLOCK = chr(129946)
LEFT_AND_RIGHT_TRIANGULAR_HALF_BLOCK = chr(129947)
UPPER_LEFT_TRIANGULAR_MEDIUM_SHADE = chr(129948)
UPPER_RIGHT_TRIANGULAR_MEDIUM_SHADE = chr(129949)
LOWER_RIGHT_TRIANGULAR_MEDIUM_SHADE = chr(129950)
LOWER_LEFT_TRIANGULAR_MEDIUM_SHADE = chr(129951)
BOX_DRAWINGS_LIGHT_DIAGONAL_UPPER_CENTRE_TO_MIDDLE_LEFT = chr(129952)
BOX_DRAWINGS_LIGHT_DIAGONAL_UPPER_CENTRE_TO_MIDDLE_RIGHT = chr(129953)
BOX_DRAWINGS_LIGHT_DIAGONAL_MIDDLE_LEFT_TO_LOWER_CENTRE = chr(129954)
BOX_DRAWINGS_LIGHT_DIAGONAL_MIDDLE_RIGHT_TO_LOWER_CENTRE = chr(129955)
BOX_DRAWINGS_LIGHT_DIAGONAL_UPPER_CENTRE_TO_MIDDLE_LEFT_TO_LOWER_CENTRE = chr(129956)
BOX_DRAWINGS_LIGHT_DIAGONAL_UPPER_CENTRE_TO_MIDDLE_RIGHT_TO_LOWER_CENTRE = chr(129957)
BOX_DRAWINGS_LIGHT_DIAGONAL_MIDDLE_LEFT_TO_LOWER_CENTRE_TO_MIDDLE_RIGHT = chr(129958)
BOX_DRAWINGS_LIGHT_DIAGONAL_MIDDLE_LEFT_TO_UPPER_CENTRE_TO_MIDDLE_RIGHT = chr(129959)
BOX_DRAWINGS_LIGHT_DIAGONAL_UPPER_CENTRE_TO_MIDDLE_LEFT_AND_MIDDLE_RIGHT_TO_LOWER_CENTRE = chr(129960)
BOX_DRAWINGS_LIGHT_DIAGONAL_UPPER_CENTRE_TO_MIDDLE_RIGHT_AND_MIDDLE_LEFT_TO_LOWER_CENTRE = chr(129961)
BOX_DRAWINGS_LIGHT_DIAGONAL_UPPER_CENTRE_TO_MIDDLE_RIGHT_TO_LOWER_CENTRE_TO_MIDDLE_LEFT = chr(129962)
BOX_DRAWINGS_LIGHT_DIAGONAL_UPPER_CENTRE_TO_MIDDLE_LEFT_TO_LOWER_CENTRE_TO_MIDDLE_RIGHT = chr(129963)
BOX_DRAWINGS_LIGHT_DIAGONAL_MIDDLE_LEFT_TO_UPPER_CENTRE_TO_MIDDLE_RIGHT_TO_LOWER_CENTRE = chr(129964)
BOX_DRAWINGS_LIGHT_DIAGONAL_MIDDLE_RIGHT_TO_UPPER_CENTRE_TO_MIDDLE_LEFT_TO_LOWER_CENTRE = chr(129965)
BOX_DRAWINGS_LIGHT_DIAGONAL_DIAMOND = chr(129966)
BOX_DRAWINGS_LIGHT_HORIZONTAL_WITH_VERTICAL_STROKE = chr(129967)
ARROWHEAD_SHAPED_POINTER = chr(129968)
INVERSE_CHECK_MARK = chr(129969)
LEFT_HALF_RUNNING_MAN = chr(129970)
RIGHT_HALF_RUNNING_MAN = chr(129971)
INVERSE_DOWNWARDS_ARROW_WITH_TIP_LEFTWARDS = chr(129972)
LEFTWARDS_ARROW_AND_UPPER_AND_LOWER_ONE_EIGHTH_BLOCK = chr(129973)
RIGHTWARDS_ARROW_AND_UPPER_AND_LOWER_ONE_EIGHTH_BLOCK = chr(129974)
DOWNWARDS_ARROW_AND_RIGHT_ONE_EIGHTH_BLOCK = chr(129975)
UPWARDS_ARROW_AND_RIGHT_ONE_EIGHTH_BLOCK = chr(129976)
LEFT_HALF_FOLDER = chr(129977)
RIGHT_HALF_FOLDER = chr(129978)
VOIDED_GREEK_CROSS = chr(129979)
RIGHT_OPEN_SQUARED_DOT = chr(129980)
NEGATIVE_DIAGONAL_CROSS = chr(129981)
NEGATIVE_DIAGONAL_MIDDLE_RIGHT_TO_LOWER_CENTRE = chr(129982)
NEGATIVE_DIAGONAL_DIAMOND = chr(129983)
WHITE_HEAVY_SALTIRE_WITH_ROUNDED_CORNERS = chr(129984)
LEFT_THIRD_WHITE_RIGHT_POINTING_INDEX = chr(129985)
MIDDLE_THIRD_WHITE_RIGHT_POINTING_INDEX = chr(129986)
RIGHT_THIRD_WHITE_RIGHT_POINTING_INDEX = chr(129987)
NEGATIVE_SQUARED_QUESTION_MARK = chr(129988)
STICK_FIGURE = chr(129989)
STICK_FIGURE_WITH_ARMS_RAISED = chr(129990)
STICK_FIGURE_LEANING_LEFT = chr(129991)
STICK_FIGURE_LEANING_RIGHT = chr(129992)
STICK_FIGURE_WITH_DRESS = chr(129993)
WHITE_UP_POINTING_CHEVRON = chr(129994)
SEGMENTED_DIGIT_ZERO = chr(130032)
SEGMENTED_DIGIT_ONE = chr(130033)
SEGMENTED_DIGIT_TWO = chr(130034)
SEGMENTED_DIGIT_THREE = chr(130035)
SEGMENTED_DIGIT_FOUR = chr(130036)
SEGMENTED_DIGIT_FIVE = chr(130037)
SEGMENTED_DIGIT_SIX = chr(130038)
SEGMENTED_DIGIT_SEVEN = chr(130039)
SEGMENTED_DIGIT_EIGHT = chr(130040)
SEGMENTED_DIGIT_NINE = chr(130041)
CJK_COMPATIBILITY_IDEOGRAPH_2F800 = chr(194560)
CJK_COMPATIBILITY_IDEOGRAPH_2F801 = chr(194561)
CJK_COMPATIBILITY_IDEOGRAPH_2F802 = chr(194562)
CJK_COMPATIBILITY_IDEOGRAPH_2F803 = chr(194563)
CJK_COMPATIBILITY_IDEOGRAPH_2F804 = chr(194564)
CJK_COMPATIBILITY_IDEOGRAPH_2F805 = chr(194565)
CJK_COMPATIBILITY_IDEOGRAPH_2F806 = chr(194566)
CJK_COMPATIBILITY_IDEOGRAPH_2F807 = chr(194567)
CJK_COMPATIBILITY_IDEOGRAPH_2F808 = chr(194568)
CJK_COMPATIBILITY_IDEOGRAPH_2F809 = chr(194569)
CJK_COMPATIBILITY_IDEOGRAPH_2F80A = chr(194570)
CJK_COMPATIBILITY_IDEOGRAPH_2F80B = chr(194571)
CJK_COMPATIBILITY_IDEOGRAPH_2F80C = chr(194572)
CJK_COMPATIBILITY_IDEOGRAPH_2F80D = chr(194573)
CJK_COMPATIBILITY_IDEOGRAPH_2F80E = chr(194574)
CJK_COMPATIBILITY_IDEOGRAPH_2F80F = chr(194575)
CJK_COMPATIBILITY_IDEOGRAPH_2F810 = chr(194576)
CJK_COMPATIBILITY_IDEOGRAPH_2F811 = chr(194577)
CJK_COMPATIBILITY_IDEOGRAPH_2F812 = chr(194578)
CJK_COMPATIBILITY_IDEOGRAPH_2F813 = chr(194579)
CJK_COMPATIBILITY_IDEOGRAPH_2F814 = chr(194580)
CJK_COMPATIBILITY_IDEOGRAPH_2F815 = chr(194581)
CJK_COMPATIBILITY_IDEOGRAPH_2F816 = chr(194582)
CJK_COMPATIBILITY_IDEOGRAPH_2F817 = chr(194583)
CJK_COMPATIBILITY_IDEOGRAPH_2F818 = chr(194584)
CJK_COMPATIBILITY_IDEOGRAPH_2F819 = chr(194585)
CJK_COMPATIBILITY_IDEOGRAPH_2F81A = chr(194586)
CJK_COMPATIBILITY_IDEOGRAPH_2F81B = chr(194587)
CJK_COMPATIBILITY_IDEOGRAPH_2F81C = chr(194588)
CJK_COMPATIBILITY_IDEOGRAPH_2F81D = chr(194589)
CJK_COMPATIBILITY_IDEOGRAPH_2F81E = chr(194590)
CJK_COMPATIBILITY_IDEOGRAPH_2F81F = chr(194591)
CJK_COMPATIBILITY_IDEOGRAPH_2F820 = chr(194592)
CJK_COMPATIBILITY_IDEOGRAPH_2F821 = chr(194593)
CJK_COMPATIBILITY_IDEOGRAPH_2F822 = chr(194594)
CJK_COMPATIBILITY_IDEOGRAPH_2F823 = chr(194595)
CJK_COMPATIBILITY_IDEOGRAPH_2F824 = chr(194596)
CJK_COMPATIBILITY_IDEOGRAPH_2F825 = chr(194597)
CJK_COMPATIBILITY_IDEOGRAPH_2F826 = chr(194598)
CJK_COMPATIBILITY_IDEOGRAPH_2F827 = chr(194599)
CJK_COMPATIBILITY_IDEOGRAPH_2F828 = chr(194600)
CJK_COMPATIBILITY_IDEOGRAPH_2F829 = chr(194601)
CJK_COMPATIBILITY_IDEOGRAPH_2F82A = chr(194602)
CJK_COMPATIBILITY_IDEOGRAPH_2F82B = chr(194603)
CJK_COMPATIBILITY_IDEOGRAPH_2F82C = chr(194604)
CJK_COMPATIBILITY_IDEOGRAPH_2F82D = chr(194605)
CJK_COMPATIBILITY_IDEOGRAPH_2F82E = chr(194606)
CJK_COMPATIBILITY_IDEOGRAPH_2F82F = chr(194607)
CJK_COMPATIBILITY_IDEOGRAPH_2F830 = chr(194608)
CJK_COMPATIBILITY_IDEOGRAPH_2F831 = chr(194609)
CJK_COMPATIBILITY_IDEOGRAPH_2F832 = chr(194610)
CJK_COMPATIBILITY_IDEOGRAPH_2F833 = chr(194611)
CJK_COMPATIBILITY_IDEOGRAPH_2F834 = chr(194612)
CJK_COMPATIBILITY_IDEOGRAPH_2F835 = chr(194613)
CJK_COMPATIBILITY_IDEOGRAPH_2F836 = chr(194614)
CJK_COMPATIBILITY_IDEOGRAPH_2F837 = chr(194615)
CJK_COMPATIBILITY_IDEOGRAPH_2F838 = chr(194616)
CJK_COMPATIBILITY_IDEOGRAPH_2F839 = chr(194617)
CJK_COMPATIBILITY_IDEOGRAPH_2F83A = chr(194618)
CJK_COMPATIBILITY_IDEOGRAPH_2F83B = chr(194619)
CJK_COMPATIBILITY_IDEOGRAPH_2F83C = chr(194620)
CJK_COMPATIBILITY_IDEOGRAPH_2F83D = chr(194621)
CJK_COMPATIBILITY_IDEOGRAPH_2F83E = chr(194622)
CJK_COMPATIBILITY_IDEOGRAPH_2F83F = chr(194623)
CJK_COMPATIBILITY_IDEOGRAPH_2F840 = chr(194624)
CJK_COMPATIBILITY_IDEOGRAPH_2F841 = chr(194625)
CJK_COMPATIBILITY_IDEOGRAPH_2F842 = chr(194626)
CJK_COMPATIBILITY_IDEOGRAPH_2F843 = chr(194627)
CJK_COMPATIBILITY_IDEOGRAPH_2F844 = chr(194628)
CJK_COMPATIBILITY_IDEOGRAPH_2F845 = chr(194629)
CJK_COMPATIBILITY_IDEOGRAPH_2F846 = chr(194630)
CJK_COMPATIBILITY_IDEOGRAPH_2F847 = chr(194631)
CJK_COMPATIBILITY_IDEOGRAPH_2F848 = chr(194632)
CJK_COMPATIBILITY_IDEOGRAPH_2F849 = chr(194633)
CJK_COMPATIBILITY_IDEOGRAPH_2F84A = chr(194634)
CJK_COMPATIBILITY_IDEOGRAPH_2F84B = chr(194635)
CJK_COMPATIBILITY_IDEOGRAPH_2F84C = chr(194636)
CJK_COMPATIBILITY_IDEOGRAPH_2F84D = chr(194637)
CJK_COMPATIBILITY_IDEOGRAPH_2F84E = chr(194638)
CJK_COMPATIBILITY_IDEOGRAPH_2F84F = chr(194639)
CJK_COMPATIBILITY_IDEOGRAPH_2F850 = chr(194640)
CJK_COMPATIBILITY_IDEOGRAPH_2F851 = chr(194641)
CJK_COMPATIBILITY_IDEOGRAPH_2F852 = chr(194642)
CJK_COMPATIBILITY_IDEOGRAPH_2F853 = chr(194643)
CJK_COMPATIBILITY_IDEOGRAPH_2F854 = chr(194644)
CJK_COMPATIBILITY_IDEOGRAPH_2F855 = chr(194645)
CJK_COMPATIBILITY_IDEOGRAPH_2F856 = chr(194646)
CJK_COMPATIBILITY_IDEOGRAPH_2F857 = chr(194647)
CJK_COMPATIBILITY_IDEOGRAPH_2F858 = chr(194648)
CJK_COMPATIBILITY_IDEOGRAPH_2F859 = chr(194649)
CJK_COMPATIBILITY_IDEOGRAPH_2F85A = chr(194650)
CJK_COMPATIBILITY_IDEOGRAPH_2F85B = chr(194651)
CJK_COMPATIBILITY_IDEOGRAPH_2F85C = chr(194652)
CJK_COMPATIBILITY_IDEOGRAPH_2F85D = chr(194653)
CJK_COMPATIBILITY_IDEOGRAPH_2F85E = chr(194654)
CJK_COMPATIBILITY_IDEOGRAPH_2F85F = chr(194655)
CJK_COMPATIBILITY_IDEOGRAPH_2F860 = chr(194656)
CJK_COMPATIBILITY_IDEOGRAPH_2F861 = chr(194657)
CJK_COMPATIBILITY_IDEOGRAPH_2F862 = chr(194658)
CJK_COMPATIBILITY_IDEOGRAPH_2F863 = chr(194659)
CJK_COMPATIBILITY_IDEOGRAPH_2F864 = chr(194660)
CJK_COMPATIBILITY_IDEOGRAPH_2F865 = chr(194661)
CJK_COMPATIBILITY_IDEOGRAPH_2F866 = chr(194662)
CJK_COMPATIBILITY_IDEOGRAPH_2F867 = chr(194663)
CJK_COMPATIBILITY_IDEOGRAPH_2F868 = chr(194664)
CJK_COMPATIBILITY_IDEOGRAPH_2F869 = chr(194665)
CJK_COMPATIBILITY_IDEOGRAPH_2F86A = chr(194666)
CJK_COMPATIBILITY_IDEOGRAPH_2F86B = chr(194667)
CJK_COMPATIBILITY_IDEOGRAPH_2F86C = chr(194668)
CJK_COMPATIBILITY_IDEOGRAPH_2F86D = chr(194669)
CJK_COMPATIBILITY_IDEOGRAPH_2F86E = chr(194670)
CJK_COMPATIBILITY_IDEOGRAPH_2F86F = chr(194671)
CJK_COMPATIBILITY_IDEOGRAPH_2F870 = chr(194672)
CJK_COMPATIBILITY_IDEOGRAPH_2F871 = chr(194673)
CJK_COMPATIBILITY_IDEOGRAPH_2F872 = chr(194674)
CJK_COMPATIBILITY_IDEOGRAPH_2F873 = chr(194675)
CJK_COMPATIBILITY_IDEOGRAPH_2F874 = chr(194676)
CJK_COMPATIBILITY_IDEOGRAPH_2F875 = chr(194677)
CJK_COMPATIBILITY_IDEOGRAPH_2F876 = chr(194678)
CJK_COMPATIBILITY_IDEOGRAPH_2F877 = chr(194679)
CJK_COMPATIBILITY_IDEOGRAPH_2F878 = chr(194680)
CJK_COMPATIBILITY_IDEOGRAPH_2F879 = chr(194681)
CJK_COMPATIBILITY_IDEOGRAPH_2F87A = chr(194682)
CJK_COMPATIBILITY_IDEOGRAPH_2F87B = chr(194683)
CJK_COMPATIBILITY_IDEOGRAPH_2F87C = chr(194684)
CJK_COMPATIBILITY_IDEOGRAPH_2F87D = chr(194685)
CJK_COMPATIBILITY_IDEOGRAPH_2F87E = chr(194686)
CJK_COMPATIBILITY_IDEOGRAPH_2F87F = chr(194687)
CJK_COMPATIBILITY_IDEOGRAPH_2F880 = chr(194688)
CJK_COMPATIBILITY_IDEOGRAPH_2F881 = chr(194689)
CJK_COMPATIBILITY_IDEOGRAPH_2F882 = chr(194690)
CJK_COMPATIBILITY_IDEOGRAPH_2F883 = chr(194691)
CJK_COMPATIBILITY_IDEOGRAPH_2F884 = chr(194692)
CJK_COMPATIBILITY_IDEOGRAPH_2F885 = chr(194693)
CJK_COMPATIBILITY_IDEOGRAPH_2F886 = chr(194694)
CJK_COMPATIBILITY_IDEOGRAPH_2F887 = chr(194695)
CJK_COMPATIBILITY_IDEOGRAPH_2F888 = chr(194696)
CJK_COMPATIBILITY_IDEOGRAPH_2F889 = chr(194697)
CJK_COMPATIBILITY_IDEOGRAPH_2F88A = chr(194698)
CJK_COMPATIBILITY_IDEOGRAPH_2F88B = chr(194699)
CJK_COMPATIBILITY_IDEOGRAPH_2F88C = chr(194700)
CJK_COMPATIBILITY_IDEOGRAPH_2F88D = chr(194701)
CJK_COMPATIBILITY_IDEOGRAPH_2F88E = chr(194702)
CJK_COMPATIBILITY_IDEOGRAPH_2F88F = chr(194703)
CJK_COMPATIBILITY_IDEOGRAPH_2F890 = chr(194704)
CJK_COMPATIBILITY_IDEOGRAPH_2F891 = chr(194705)
CJK_COMPATIBILITY_IDEOGRAPH_2F892 = chr(194706)
CJK_COMPATIBILITY_IDEOGRAPH_2F893 = chr(194707)
CJK_COMPATIBILITY_IDEOGRAPH_2F894 = chr(194708)
CJK_COMPATIBILITY_IDEOGRAPH_2F895 = chr(194709)
CJK_COMPATIBILITY_IDEOGRAPH_2F896 = chr(194710)
CJK_COMPATIBILITY_IDEOGRAPH_2F897 = chr(194711)
CJK_COMPATIBILITY_IDEOGRAPH_2F898 = chr(194712)
CJK_COMPATIBILITY_IDEOGRAPH_2F899 = chr(194713)
CJK_COMPATIBILITY_IDEOGRAPH_2F89A = chr(194714)
CJK_COMPATIBILITY_IDEOGRAPH_2F89B = chr(194715)
CJK_COMPATIBILITY_IDEOGRAPH_2F89C = chr(194716)
CJK_COMPATIBILITY_IDEOGRAPH_2F89D = chr(194717)
CJK_COMPATIBILITY_IDEOGRAPH_2F89E = chr(194718)
CJK_COMPATIBILITY_IDEOGRAPH_2F89F = chr(194719)
CJK_COMPATIBILITY_IDEOGRAPH_2F8A0 = chr(194720)
CJK_COMPATIBILITY_IDEOGRAPH_2F8A1 = chr(194721)
CJK_COMPATIBILITY_IDEOGRAPH_2F8A2 = chr(194722)
CJK_COMPATIBILITY_IDEOGRAPH_2F8A3 = chr(194723)
CJK_COMPATIBILITY_IDEOGRAPH_2F8A4 = chr(194724)
CJK_COMPATIBILITY_IDEOGRAPH_2F8A5 = chr(194725)
CJK_COMPATIBILITY_IDEOGRAPH_2F8A6 = chr(194726)
CJK_COMPATIBILITY_IDEOGRAPH_2F8A7 = chr(194727)
CJK_COMPATIBILITY_IDEOGRAPH_2F8A8 = chr(194728)
CJK_COMPATIBILITY_IDEOGRAPH_2F8A9 = chr(194729)
CJK_COMPATIBILITY_IDEOGRAPH_2F8AA = chr(194730)
CJK_COMPATIBILITY_IDEOGRAPH_2F8AB = chr(194731)
CJK_COMPATIBILITY_IDEOGRAPH_2F8AC = chr(194732)
CJK_COMPATIBILITY_IDEOGRAPH_2F8AD = chr(194733)
CJK_COMPATIBILITY_IDEOGRAPH_2F8AE = chr(194734)
CJK_COMPATIBILITY_IDEOGRAPH_2F8AF = chr(194735)
CJK_COMPATIBILITY_IDEOGRAPH_2F8B0 = chr(194736)
CJK_COMPATIBILITY_IDEOGRAPH_2F8B1 = chr(194737)
CJK_COMPATIBILITY_IDEOGRAPH_2F8B2 = chr(194738)
CJK_COMPATIBILITY_IDEOGRAPH_2F8B3 = chr(194739)
CJK_COMPATIBILITY_IDEOGRAPH_2F8B4 = chr(194740)
CJK_COMPATIBILITY_IDEOGRAPH_2F8B5 = chr(194741)
CJK_COMPATIBILITY_IDEOGRAPH_2F8B6 = chr(194742)
CJK_COMPATIBILITY_IDEOGRAPH_2F8B7 = chr(194743)
CJK_COMPATIBILITY_IDEOGRAPH_2F8B8 = chr(194744)
CJK_COMPATIBILITY_IDEOGRAPH_2F8B9 = chr(194745)
CJK_COMPATIBILITY_IDEOGRAPH_2F8BA = chr(194746)
CJK_COMPATIBILITY_IDEOGRAPH_2F8BB = chr(194747)
CJK_COMPATIBILITY_IDEOGRAPH_2F8BC = chr(194748)
CJK_COMPATIBILITY_IDEOGRAPH_2F8BD = chr(194749)
CJK_COMPATIBILITY_IDEOGRAPH_2F8BE = chr(194750)
CJK_COMPATIBILITY_IDEOGRAPH_2F8BF = chr(194751)
CJK_COMPATIBILITY_IDEOGRAPH_2F8C0 = chr(194752)
CJK_COMPATIBILITY_IDEOGRAPH_2F8C1 = chr(194753)
CJK_COMPATIBILITY_IDEOGRAPH_2F8C2 = chr(194754)
CJK_COMPATIBILITY_IDEOGRAPH_2F8C3 = chr(194755)
CJK_COMPATIBILITY_IDEOGRAPH_2F8C4 = chr(194756)
CJK_COMPATIBILITY_IDEOGRAPH_2F8C5 = chr(194757)
CJK_COMPATIBILITY_IDEOGRAPH_2F8C6 = chr(194758)
CJK_COMPATIBILITY_IDEOGRAPH_2F8C7 = chr(194759)
CJK_COMPATIBILITY_IDEOGRAPH_2F8C8 = chr(194760)
CJK_COMPATIBILITY_IDEOGRAPH_2F8C9 = chr(194761)
CJK_COMPATIBILITY_IDEOGRAPH_2F8CA = chr(194762)
CJK_COMPATIBILITY_IDEOGRAPH_2F8CB = chr(194763)
CJK_COMPATIBILITY_IDEOGRAPH_2F8CC = chr(194764)
CJK_COMPATIBILITY_IDEOGRAPH_2F8CD = chr(194765)
CJK_COMPATIBILITY_IDEOGRAPH_2F8CE = chr(194766)
CJK_COMPATIBILITY_IDEOGRAPH_2F8CF = chr(194767)
CJK_COMPATIBILITY_IDEOGRAPH_2F8D0 = chr(194768)
CJK_COMPATIBILITY_IDEOGRAPH_2F8D1 = chr(194769)
CJK_COMPATIBILITY_IDEOGRAPH_2F8D2 = chr(194770)
CJK_COMPATIBILITY_IDEOGRAPH_2F8D3 = chr(194771)
CJK_COMPATIBILITY_IDEOGRAPH_2F8D4 = chr(194772)
CJK_COMPATIBILITY_IDEOGRAPH_2F8D5 = chr(194773)
CJK_COMPATIBILITY_IDEOGRAPH_2F8D6 = chr(194774)
CJK_COMPATIBILITY_IDEOGRAPH_2F8D7 = chr(194775)
CJK_COMPATIBILITY_IDEOGRAPH_2F8D8 = chr(194776)
CJK_COMPATIBILITY_IDEOGRAPH_2F8D9 = chr(194777)
CJK_COMPATIBILITY_IDEOGRAPH_2F8DA = chr(194778)
CJK_COMPATIBILITY_IDEOGRAPH_2F8DB = chr(194779)
CJK_COMPATIBILITY_IDEOGRAPH_2F8DC = chr(194780)
CJK_COMPATIBILITY_IDEOGRAPH_2F8DD = chr(194781)
CJK_COMPATIBILITY_IDEOGRAPH_2F8DE = chr(194782)
CJK_COMPATIBILITY_IDEOGRAPH_2F8DF = chr(194783)
CJK_COMPATIBILITY_IDEOGRAPH_2F8E0 = chr(194784)
CJK_COMPATIBILITY_IDEOGRAPH_2F8E1 = chr(194785)
CJK_COMPATIBILITY_IDEOGRAPH_2F8E2 = chr(194786)
CJK_COMPATIBILITY_IDEOGRAPH_2F8E3 = chr(194787)
CJK_COMPATIBILITY_IDEOGRAPH_2F8E4 = chr(194788)
CJK_COMPATIBILITY_IDEOGRAPH_2F8E5 = chr(194789)
CJK_COMPATIBILITY_IDEOGRAPH_2F8E6 = chr(194790)
CJK_COMPATIBILITY_IDEOGRAPH_2F8E7 = chr(194791)
CJK_COMPATIBILITY_IDEOGRAPH_2F8E8 = chr(194792)
CJK_COMPATIBILITY_IDEOGRAPH_2F8E9 = chr(194793)
CJK_COMPATIBILITY_IDEOGRAPH_2F8EA = chr(194794)
CJK_COMPATIBILITY_IDEOGRAPH_2F8EB = chr(194795)
CJK_COMPATIBILITY_IDEOGRAPH_2F8EC = chr(194796)
CJK_COMPATIBILITY_IDEOGRAPH_2F8ED = chr(194797)
CJK_COMPATIBILITY_IDEOGRAPH_2F8EE = chr(194798)
CJK_COMPATIBILITY_IDEOGRAPH_2F8EF = chr(194799)
CJK_COMPATIBILITY_IDEOGRAPH_2F8F0 = chr(194800)
CJK_COMPATIBILITY_IDEOGRAPH_2F8F1 = chr(194801)
CJK_COMPATIBILITY_IDEOGRAPH_2F8F2 = chr(194802)
CJK_COMPATIBILITY_IDEOGRAPH_2F8F3 = chr(194803)
CJK_COMPATIBILITY_IDEOGRAPH_2F8F4 = chr(194804)
CJK_COMPATIBILITY_IDEOGRAPH_2F8F5 = chr(194805)
CJK_COMPATIBILITY_IDEOGRAPH_2F8F6 = chr(194806)
CJK_COMPATIBILITY_IDEOGRAPH_2F8F7 = chr(194807)
CJK_COMPATIBILITY_IDEOGRAPH_2F8F8 = chr(194808)
CJK_COMPATIBILITY_IDEOGRAPH_2F8F9 = chr(194809)
CJK_COMPATIBILITY_IDEOGRAPH_2F8FA = chr(194810)
CJK_COMPATIBILITY_IDEOGRAPH_2F8FB = chr(194811)
CJK_COMPATIBILITY_IDEOGRAPH_2F8FC = chr(194812)
CJK_COMPATIBILITY_IDEOGRAPH_2F8FD = chr(194813)
CJK_COMPATIBILITY_IDEOGRAPH_2F8FE = chr(194814)
CJK_COMPATIBILITY_IDEOGRAPH_2F8FF = chr(194815)
CJK_COMPATIBILITY_IDEOGRAPH_2F900 = chr(194816)
CJK_COMPATIBILITY_IDEOGRAPH_2F901 = chr(194817)
CJK_COMPATIBILITY_IDEOGRAPH_2F902 = chr(194818)
CJK_COMPATIBILITY_IDEOGRAPH_2F903 = chr(194819)
CJK_COMPATIBILITY_IDEOGRAPH_2F904 = chr(194820)
CJK_COMPATIBILITY_IDEOGRAPH_2F905 = chr(194821)
CJK_COMPATIBILITY_IDEOGRAPH_2F906 = chr(194822)
CJK_COMPATIBILITY_IDEOGRAPH_2F907 = chr(194823)
CJK_COMPATIBILITY_IDEOGRAPH_2F908 = chr(194824)
CJK_COMPATIBILITY_IDEOGRAPH_2F909 = chr(194825)
CJK_COMPATIBILITY_IDEOGRAPH_2F90A = chr(194826)
CJK_COMPATIBILITY_IDEOGRAPH_2F90B = chr(194827)
CJK_COMPATIBILITY_IDEOGRAPH_2F90C = chr(194828)
CJK_COMPATIBILITY_IDEOGRAPH_2F90D = chr(194829)
CJK_COMPATIBILITY_IDEOGRAPH_2F90E = chr(194830)
CJK_COMPATIBILITY_IDEOGRAPH_2F90F = chr(194831)
CJK_COMPATIBILITY_IDEOGRAPH_2F910 = chr(194832)
CJK_COMPATIBILITY_IDEOGRAPH_2F911 = chr(194833)
CJK_COMPATIBILITY_IDEOGRAPH_2F912 = chr(194834)
CJK_COMPATIBILITY_IDEOGRAPH_2F913 = chr(194835)
CJK_COMPATIBILITY_IDEOGRAPH_2F914 = chr(194836)
CJK_COMPATIBILITY_IDEOGRAPH_2F915 = chr(194837)
CJK_COMPATIBILITY_IDEOGRAPH_2F916 = chr(194838)
CJK_COMPATIBILITY_IDEOGRAPH_2F917 = chr(194839)
CJK_COMPATIBILITY_IDEOGRAPH_2F918 = chr(194840)
CJK_COMPATIBILITY_IDEOGRAPH_2F919 = chr(194841)
CJK_COMPATIBILITY_IDEOGRAPH_2F91A = chr(194842)
CJK_COMPATIBILITY_IDEOGRAPH_2F91B = chr(194843)
CJK_COMPATIBILITY_IDEOGRAPH_2F91C = chr(194844)
CJK_COMPATIBILITY_IDEOGRAPH_2F91D = chr(194845)
CJK_COMPATIBILITY_IDEOGRAPH_2F91E = chr(194846)
CJK_COMPATIBILITY_IDEOGRAPH_2F91F = chr(194847)
CJK_COMPATIBILITY_IDEOGRAPH_2F920 = chr(194848)
CJK_COMPATIBILITY_IDEOGRAPH_2F921 = chr(194849)
CJK_COMPATIBILITY_IDEOGRAPH_2F922 = chr(194850)
CJK_COMPATIBILITY_IDEOGRAPH_2F923 = chr(194851)
CJK_COMPATIBILITY_IDEOGRAPH_2F924 = chr(194852)
CJK_COMPATIBILITY_IDEOGRAPH_2F925 = chr(194853)
CJK_COMPATIBILITY_IDEOGRAPH_2F926 = chr(194854)
CJK_COMPATIBILITY_IDEOGRAPH_2F927 = chr(194855)
CJK_COMPATIBILITY_IDEOGRAPH_2F928 = chr(194856)
CJK_COMPATIBILITY_IDEOGRAPH_2F929 = chr(194857)
CJK_COMPATIBILITY_IDEOGRAPH_2F92A = chr(194858)
CJK_COMPATIBILITY_IDEOGRAPH_2F92B = chr(194859)
CJK_COMPATIBILITY_IDEOGRAPH_2F92C = chr(194860)
CJK_COMPATIBILITY_IDEOGRAPH_2F92D = chr(194861)
CJK_COMPATIBILITY_IDEOGRAPH_2F92E = chr(194862)
CJK_COMPATIBILITY_IDEOGRAPH_2F92F = chr(194863)
CJK_COMPATIBILITY_IDEOGRAPH_2F930 = chr(194864)
CJK_COMPATIBILITY_IDEOGRAPH_2F931 = chr(194865)
CJK_COMPATIBILITY_IDEOGRAPH_2F932 = chr(194866)
CJK_COMPATIBILITY_IDEOGRAPH_2F933 = chr(194867)
CJK_COMPATIBILITY_IDEOGRAPH_2F934 = chr(194868)
CJK_COMPATIBILITY_IDEOGRAPH_2F935 = chr(194869)
CJK_COMPATIBILITY_IDEOGRAPH_2F936 = chr(194870)
CJK_COMPATIBILITY_IDEOGRAPH_2F937 = chr(194871)
CJK_COMPATIBILITY_IDEOGRAPH_2F938 = chr(194872)
CJK_COMPATIBILITY_IDEOGRAPH_2F939 = chr(194873)
CJK_COMPATIBILITY_IDEOGRAPH_2F93A = chr(194874)
CJK_COMPATIBILITY_IDEOGRAPH_2F93B = chr(194875)
CJK_COMPATIBILITY_IDEOGRAPH_2F93C = chr(194876)
CJK_COMPATIBILITY_IDEOGRAPH_2F93D = chr(194877)
CJK_COMPATIBILITY_IDEOGRAPH_2F93E = chr(194878)
CJK_COMPATIBILITY_IDEOGRAPH_2F93F = chr(194879)
CJK_COMPATIBILITY_IDEOGRAPH_2F940 = chr(194880)
CJK_COMPATIBILITY_IDEOGRAPH_2F941 = chr(194881)
CJK_COMPATIBILITY_IDEOGRAPH_2F942 = chr(194882)
CJK_COMPATIBILITY_IDEOGRAPH_2F943 = chr(194883)
CJK_COMPATIBILITY_IDEOGRAPH_2F944 = chr(194884)
CJK_COMPATIBILITY_IDEOGRAPH_2F945 = chr(194885)
CJK_COMPATIBILITY_IDEOGRAPH_2F946 = chr(194886)
CJK_COMPATIBILITY_IDEOGRAPH_2F947 = chr(194887)
CJK_COMPATIBILITY_IDEOGRAPH_2F948 = chr(194888)
CJK_COMPATIBILITY_IDEOGRAPH_2F949 = chr(194889)
CJK_COMPATIBILITY_IDEOGRAPH_2F94A = chr(194890)
CJK_COMPATIBILITY_IDEOGRAPH_2F94B = chr(194891)
CJK_COMPATIBILITY_IDEOGRAPH_2F94C = chr(194892)
CJK_COMPATIBILITY_IDEOGRAPH_2F94D = chr(194893)
CJK_COMPATIBILITY_IDEOGRAPH_2F94E = chr(194894)
CJK_COMPATIBILITY_IDEOGRAPH_2F94F = chr(194895)
CJK_COMPATIBILITY_IDEOGRAPH_2F950 = chr(194896)
CJK_COMPATIBILITY_IDEOGRAPH_2F951 = chr(194897)
CJK_COMPATIBILITY_IDEOGRAPH_2F952 = chr(194898)
CJK_COMPATIBILITY_IDEOGRAPH_2F953 = chr(194899)
CJK_COMPATIBILITY_IDEOGRAPH_2F954 = chr(194900)
CJK_COMPATIBILITY_IDEOGRAPH_2F955 = chr(194901)
CJK_COMPATIBILITY_IDEOGRAPH_2F956 = chr(194902)
CJK_COMPATIBILITY_IDEOGRAPH_2F957 = chr(194903)
CJK_COMPATIBILITY_IDEOGRAPH_2F958 = chr(194904)
CJK_COMPATIBILITY_IDEOGRAPH_2F959 = chr(194905)
CJK_COMPATIBILITY_IDEOGRAPH_2F95A = chr(194906)
CJK_COMPATIBILITY_IDEOGRAPH_2F95B = chr(194907)
CJK_COMPATIBILITY_IDEOGRAPH_2F95C = chr(194908)
CJK_COMPATIBILITY_IDEOGRAPH_2F95D = chr(194909)
CJK_COMPATIBILITY_IDEOGRAPH_2F95E = chr(194910)
CJK_COMPATIBILITY_IDEOGRAPH_2F95F = chr(194911)
CJK_COMPATIBILITY_IDEOGRAPH_2F960 = chr(194912)
CJK_COMPATIBILITY_IDEOGRAPH_2F961 = chr(194913)
CJK_COMPATIBILITY_IDEOGRAPH_2F962 = chr(194914)
CJK_COMPATIBILITY_IDEOGRAPH_2F963 = chr(194915)
CJK_COMPATIBILITY_IDEOGRAPH_2F964 = chr(194916)
CJK_COMPATIBILITY_IDEOGRAPH_2F965 = chr(194917)
CJK_COMPATIBILITY_IDEOGRAPH_2F966 = chr(194918)
CJK_COMPATIBILITY_IDEOGRAPH_2F967 = chr(194919)
CJK_COMPATIBILITY_IDEOGRAPH_2F968 = chr(194920)
CJK_COMPATIBILITY_IDEOGRAPH_2F969 = chr(194921)
CJK_COMPATIBILITY_IDEOGRAPH_2F96A = chr(194922)
CJK_COMPATIBILITY_IDEOGRAPH_2F96B = chr(194923)
CJK_COMPATIBILITY_IDEOGRAPH_2F96C = chr(194924)
CJK_COMPATIBILITY_IDEOGRAPH_2F96D = chr(194925)
CJK_COMPATIBILITY_IDEOGRAPH_2F96E = chr(194926)
CJK_COMPATIBILITY_IDEOGRAPH_2F96F = chr(194927)
CJK_COMPATIBILITY_IDEOGRAPH_2F970 = chr(194928)
CJK_COMPATIBILITY_IDEOGRAPH_2F971 = chr(194929)
CJK_COMPATIBILITY_IDEOGRAPH_2F972 = chr(194930)
CJK_COMPATIBILITY_IDEOGRAPH_2F973 = chr(194931)
CJK_COMPATIBILITY_IDEOGRAPH_2F974 = chr(194932)
CJK_COMPATIBILITY_IDEOGRAPH_2F975 = chr(194933)
CJK_COMPATIBILITY_IDEOGRAPH_2F976 = chr(194934)
CJK_COMPATIBILITY_IDEOGRAPH_2F977 = chr(194935)
CJK_COMPATIBILITY_IDEOGRAPH_2F978 = chr(194936)
CJK_COMPATIBILITY_IDEOGRAPH_2F979 = chr(194937)
CJK_COMPATIBILITY_IDEOGRAPH_2F97A = chr(194938)
CJK_COMPATIBILITY_IDEOGRAPH_2F97B = chr(194939)
CJK_COMPATIBILITY_IDEOGRAPH_2F97C = chr(194940)
CJK_COMPATIBILITY_IDEOGRAPH_2F97D = chr(194941)
CJK_COMPATIBILITY_IDEOGRAPH_2F97E = chr(194942)
CJK_COMPATIBILITY_IDEOGRAPH_2F97F = chr(194943)
CJK_COMPATIBILITY_IDEOGRAPH_2F980 = chr(194944)
CJK_COMPATIBILITY_IDEOGRAPH_2F981 = chr(194945)
CJK_COMPATIBILITY_IDEOGRAPH_2F982 = chr(194946)
CJK_COMPATIBILITY_IDEOGRAPH_2F983 = chr(194947)
CJK_COMPATIBILITY_IDEOGRAPH_2F984 = chr(194948)
CJK_COMPATIBILITY_IDEOGRAPH_2F985 = chr(194949)
CJK_COMPATIBILITY_IDEOGRAPH_2F986 = chr(194950)
CJK_COMPATIBILITY_IDEOGRAPH_2F987 = chr(194951)
CJK_COMPATIBILITY_IDEOGRAPH_2F988 = chr(194952)
CJK_COMPATIBILITY_IDEOGRAPH_2F989 = chr(194953)
CJK_COMPATIBILITY_IDEOGRAPH_2F98A = chr(194954)
CJK_COMPATIBILITY_IDEOGRAPH_2F98B = chr(194955)
CJK_COMPATIBILITY_IDEOGRAPH_2F98C = chr(194956)
CJK_COMPATIBILITY_IDEOGRAPH_2F98D = chr(194957)
CJK_COMPATIBILITY_IDEOGRAPH_2F98E = chr(194958)
CJK_COMPATIBILITY_IDEOGRAPH_2F98F = chr(194959)
CJK_COMPATIBILITY_IDEOGRAPH_2F990 = chr(194960)
CJK_COMPATIBILITY_IDEOGRAPH_2F991 = chr(194961)
CJK_COMPATIBILITY_IDEOGRAPH_2F992 = chr(194962)
CJK_COMPATIBILITY_IDEOGRAPH_2F993 = chr(194963)
CJK_COMPATIBILITY_IDEOGRAPH_2F994 = chr(194964)
CJK_COMPATIBILITY_IDEOGRAPH_2F995 = chr(194965)
CJK_COMPATIBILITY_IDEOGRAPH_2F996 = chr(194966)
CJK_COMPATIBILITY_IDEOGRAPH_2F997 = chr(194967)
CJK_COMPATIBILITY_IDEOGRAPH_2F998 = chr(194968)
CJK_COMPATIBILITY_IDEOGRAPH_2F999 = chr(194969)
CJK_COMPATIBILITY_IDEOGRAPH_2F99A = chr(194970)
CJK_COMPATIBILITY_IDEOGRAPH_2F99B = chr(194971)
CJK_COMPATIBILITY_IDEOGRAPH_2F99C = chr(194972)
CJK_COMPATIBILITY_IDEOGRAPH_2F99D = chr(194973)
CJK_COMPATIBILITY_IDEOGRAPH_2F99E = chr(194974)
CJK_COMPATIBILITY_IDEOGRAPH_2F99F = chr(194975)
CJK_COMPATIBILITY_IDEOGRAPH_2F9A0 = chr(194976)
CJK_COMPATIBILITY_IDEOGRAPH_2F9A1 = chr(194977)
CJK_COMPATIBILITY_IDEOGRAPH_2F9A2 = chr(194978)
CJK_COMPATIBILITY_IDEOGRAPH_2F9A3 = chr(194979)
CJK_COMPATIBILITY_IDEOGRAPH_2F9A4 = chr(194980)
CJK_COMPATIBILITY_IDEOGRAPH_2F9A5 = chr(194981)
CJK_COMPATIBILITY_IDEOGRAPH_2F9A6 = chr(194982)
CJK_COMPATIBILITY_IDEOGRAPH_2F9A7 = chr(194983)
CJK_COMPATIBILITY_IDEOGRAPH_2F9A8 = chr(194984)
CJK_COMPATIBILITY_IDEOGRAPH_2F9A9 = chr(194985)
CJK_COMPATIBILITY_IDEOGRAPH_2F9AA = chr(194986)
CJK_COMPATIBILITY_IDEOGRAPH_2F9AB = chr(194987)
CJK_COMPATIBILITY_IDEOGRAPH_2F9AC = chr(194988)
CJK_COMPATIBILITY_IDEOGRAPH_2F9AD = chr(194989)
CJK_COMPATIBILITY_IDEOGRAPH_2F9AE = chr(194990)
CJK_COMPATIBILITY_IDEOGRAPH_2F9AF = chr(194991)
CJK_COMPATIBILITY_IDEOGRAPH_2F9B0 = chr(194992)
CJK_COMPATIBILITY_IDEOGRAPH_2F9B1 = chr(194993)
CJK_COMPATIBILITY_IDEOGRAPH_2F9B2 = chr(194994)
CJK_COMPATIBILITY_IDEOGRAPH_2F9B3 = chr(194995)
CJK_COMPATIBILITY_IDEOGRAPH_2F9B4 = chr(194996)
CJK_COMPATIBILITY_IDEOGRAPH_2F9B5 = chr(194997)
CJK_COMPATIBILITY_IDEOGRAPH_2F9B6 = chr(194998)
CJK_COMPATIBILITY_IDEOGRAPH_2F9B7 = chr(194999)
CJK_COMPATIBILITY_IDEOGRAPH_2F9B8 = chr(195000)
CJK_COMPATIBILITY_IDEOGRAPH_2F9B9 = chr(195001)
CJK_COMPATIBILITY_IDEOGRAPH_2F9BA = chr(195002)
CJK_COMPATIBILITY_IDEOGRAPH_2F9BB = chr(195003)
CJK_COMPATIBILITY_IDEOGRAPH_2F9BC = chr(195004)
CJK_COMPATIBILITY_IDEOGRAPH_2F9BD = chr(195005)
CJK_COMPATIBILITY_IDEOGRAPH_2F9BE = chr(195006)
CJK_COMPATIBILITY_IDEOGRAPH_2F9BF = chr(195007)
CJK_COMPATIBILITY_IDEOGRAPH_2F9C0 = chr(195008)
CJK_COMPATIBILITY_IDEOGRAPH_2F9C1 = chr(195009)
CJK_COMPATIBILITY_IDEOGRAPH_2F9C2 = chr(195010)
CJK_COMPATIBILITY_IDEOGRAPH_2F9C3 = chr(195011)
CJK_COMPATIBILITY_IDEOGRAPH_2F9C4 = chr(195012)
CJK_COMPATIBILITY_IDEOGRAPH_2F9C5 = chr(195013)
CJK_COMPATIBILITY_IDEOGRAPH_2F9C6 = chr(195014)
CJK_COMPATIBILITY_IDEOGRAPH_2F9C7 = chr(195015)
CJK_COMPATIBILITY_IDEOGRAPH_2F9C8 = chr(195016)
CJK_COMPATIBILITY_IDEOGRAPH_2F9C9 = chr(195017)
CJK_COMPATIBILITY_IDEOGRAPH_2F9CA = chr(195018)
CJK_COMPATIBILITY_IDEOGRAPH_2F9CB = chr(195019)
CJK_COMPATIBILITY_IDEOGRAPH_2F9CC = chr(195020)
CJK_COMPATIBILITY_IDEOGRAPH_2F9CD = chr(195021)
CJK_COMPATIBILITY_IDEOGRAPH_2F9CE = chr(195022)
CJK_COMPATIBILITY_IDEOGRAPH_2F9CF = chr(195023)
CJK_COMPATIBILITY_IDEOGRAPH_2F9D0 = chr(195024)
CJK_COMPATIBILITY_IDEOGRAPH_2F9D1 = chr(195025)
CJK_COMPATIBILITY_IDEOGRAPH_2F9D2 = chr(195026)
CJK_COMPATIBILITY_IDEOGRAPH_2F9D3 = chr(195027)
CJK_COMPATIBILITY_IDEOGRAPH_2F9D4 = chr(195028)
CJK_COMPATIBILITY_IDEOGRAPH_2F9D5 = chr(195029)
CJK_COMPATIBILITY_IDEOGRAPH_2F9D6 = chr(195030)
CJK_COMPATIBILITY_IDEOGRAPH_2F9D7 = chr(195031)
CJK_COMPATIBILITY_IDEOGRAPH_2F9D8 = chr(195032)
CJK_COMPATIBILITY_IDEOGRAPH_2F9D9 = chr(195033)
CJK_COMPATIBILITY_IDEOGRAPH_2F9DA = chr(195034)
CJK_COMPATIBILITY_IDEOGRAPH_2F9DB = chr(195035)
CJK_COMPATIBILITY_IDEOGRAPH_2F9DC = chr(195036)
CJK_COMPATIBILITY_IDEOGRAPH_2F9DD = chr(195037)
CJK_COMPATIBILITY_IDEOGRAPH_2F9DE = chr(195038)
CJK_COMPATIBILITY_IDEOGRAPH_2F9DF = chr(195039)
CJK_COMPATIBILITY_IDEOGRAPH_2F9E0 = chr(195040)
CJK_COMPATIBILITY_IDEOGRAPH_2F9E1 = chr(195041)
CJK_COMPATIBILITY_IDEOGRAPH_2F9E2 = chr(195042)
CJK_COMPATIBILITY_IDEOGRAPH_2F9E3 = chr(195043)
CJK_COMPATIBILITY_IDEOGRAPH_2F9E4 = chr(195044)
CJK_COMPATIBILITY_IDEOGRAPH_2F9E5 = chr(195045)
CJK_COMPATIBILITY_IDEOGRAPH_2F9E6 = chr(195046)
CJK_COMPATIBILITY_IDEOGRAPH_2F9E7 = chr(195047)
CJK_COMPATIBILITY_IDEOGRAPH_2F9E8 = chr(195048)
CJK_COMPATIBILITY_IDEOGRAPH_2F9E9 = chr(195049)
CJK_COMPATIBILITY_IDEOGRAPH_2F9EA = chr(195050)
CJK_COMPATIBILITY_IDEOGRAPH_2F9EB = chr(195051)
CJK_COMPATIBILITY_IDEOGRAPH_2F9EC = chr(195052)
CJK_COMPATIBILITY_IDEOGRAPH_2F9ED = chr(195053)
CJK_COMPATIBILITY_IDEOGRAPH_2F9EE = chr(195054)
CJK_COMPATIBILITY_IDEOGRAPH_2F9EF = chr(195055)
CJK_COMPATIBILITY_IDEOGRAPH_2F9F0 = chr(195056)
CJK_COMPATIBILITY_IDEOGRAPH_2F9F1 = chr(195057)
CJK_COMPATIBILITY_IDEOGRAPH_2F9F2 = chr(195058)
CJK_COMPATIBILITY_IDEOGRAPH_2F9F3 = chr(195059)
CJK_COMPATIBILITY_IDEOGRAPH_2F9F4 = chr(195060)
CJK_COMPATIBILITY_IDEOGRAPH_2F9F5 = chr(195061)
CJK_COMPATIBILITY_IDEOGRAPH_2F9F6 = chr(195062)
CJK_COMPATIBILITY_IDEOGRAPH_2F9F7 = chr(195063)
CJK_COMPATIBILITY_IDEOGRAPH_2F9F8 = chr(195064)
CJK_COMPATIBILITY_IDEOGRAPH_2F9F9 = chr(195065)
CJK_COMPATIBILITY_IDEOGRAPH_2F9FA = chr(195066)
CJK_COMPATIBILITY_IDEOGRAPH_2F9FB = chr(195067)
CJK_COMPATIBILITY_IDEOGRAPH_2F9FC = chr(195068)
CJK_COMPATIBILITY_IDEOGRAPH_2F9FD = chr(195069)
CJK_COMPATIBILITY_IDEOGRAPH_2F9FE = chr(195070)
CJK_COMPATIBILITY_IDEOGRAPH_2F9FF = chr(195071)
CJK_COMPATIBILITY_IDEOGRAPH_2FA00 = chr(195072)
CJK_COMPATIBILITY_IDEOGRAPH_2FA01 = chr(195073)
CJK_COMPATIBILITY_IDEOGRAPH_2FA02 = chr(195074)
CJK_COMPATIBILITY_IDEOGRAPH_2FA03 = chr(195075)
CJK_COMPATIBILITY_IDEOGRAPH_2FA04 = chr(195076)
CJK_COMPATIBILITY_IDEOGRAPH_2FA05 = chr(195077)
CJK_COMPATIBILITY_IDEOGRAPH_2FA06 = chr(195078)
CJK_COMPATIBILITY_IDEOGRAPH_2FA07 = chr(195079)
CJK_COMPATIBILITY_IDEOGRAPH_2FA08 = chr(195080)
CJK_COMPATIBILITY_IDEOGRAPH_2FA09 = chr(195081)
CJK_COMPATIBILITY_IDEOGRAPH_2FA0A = chr(195082)
CJK_COMPATIBILITY_IDEOGRAPH_2FA0B = chr(195083)
CJK_COMPATIBILITY_IDEOGRAPH_2FA0C = chr(195084)
CJK_COMPATIBILITY_IDEOGRAPH_2FA0D = chr(195085)
CJK_COMPATIBILITY_IDEOGRAPH_2FA0E = chr(195086)
CJK_COMPATIBILITY_IDEOGRAPH_2FA0F = chr(195087)
CJK_COMPATIBILITY_IDEOGRAPH_2FA10 = chr(195088)
CJK_COMPATIBILITY_IDEOGRAPH_2FA11 = chr(195089)
CJK_COMPATIBILITY_IDEOGRAPH_2FA12 = chr(195090)
CJK_COMPATIBILITY_IDEOGRAPH_2FA13 = chr(195091)
CJK_COMPATIBILITY_IDEOGRAPH_2FA14 = chr(195092)
CJK_COMPATIBILITY_IDEOGRAPH_2FA15 = chr(195093)
CJK_COMPATIBILITY_IDEOGRAPH_2FA16 = chr(195094)
CJK_COMPATIBILITY_IDEOGRAPH_2FA17 = chr(195095)
CJK_COMPATIBILITY_IDEOGRAPH_2FA18 = chr(195096)
CJK_COMPATIBILITY_IDEOGRAPH_2FA19 = chr(195097)
CJK_COMPATIBILITY_IDEOGRAPH_2FA1A = chr(195098)
CJK_COMPATIBILITY_IDEOGRAPH_2FA1B = chr(195099)
CJK_COMPATIBILITY_IDEOGRAPH_2FA1C = chr(195100)
CJK_COMPATIBILITY_IDEOGRAPH_2FA1D = chr(195101)
LANGUAGE_TAG = chr(917505)
TAG_SPACE = chr(917536)
TAG_EXCLAMATION_MARK = chr(917537)
TAG_QUOTATION_MARK = chr(917538)
TAG_NUMBER_SIGN = chr(917539)
TAG_DOLLAR_SIGN = chr(917540)
TAG_PERCENT_SIGN = chr(917541)
TAG_AMPERSAND = chr(917542)
TAG_APOSTROPHE = chr(917543)
TAG_LEFT_PARENTHESIS = chr(917544)
TAG_RIGHT_PARENTHESIS = chr(917545)
TAG_ASTERISK = chr(917546)
TAG_PLUS_SIGN = chr(917547)
TAG_COMMA = chr(917548)
TAG_HYPHEN_MINUS = chr(917549)
TAG_FULL_STOP = chr(917550)
TAG_SOLIDUS = chr(917551)
TAG_DIGIT_ZERO = chr(917552)
TAG_DIGIT_ONE = chr(917553)
TAG_DIGIT_TWO = chr(917554)
TAG_DIGIT_THREE = chr(917555)
TAG_DIGIT_FOUR = chr(917556)
TAG_DIGIT_FIVE = chr(917557)
TAG_DIGIT_SIX = chr(917558)
TAG_DIGIT_SEVEN = chr(917559)
TAG_DIGIT_EIGHT = chr(917560)
TAG_DIGIT_NINE = chr(917561)
TAG_COLON = chr(917562)
TAG_SEMICOLON = chr(917563)
TAG_LESS_THAN_SIGN = chr(917564)
TAG_EQUALS_SIGN = chr(917565)
TAG_GREATER_THAN_SIGN = chr(917566)
TAG_QUESTION_MARK = chr(917567)
TAG_COMMERCIAL_AT = chr(917568)
TAG_LATIN_CAPITAL_LETTER_A = chr(917569)
TAG_LATIN_CAPITAL_LETTER_B = chr(917570)
TAG_LATIN_CAPITAL_LETTER_C = chr(917571)
TAG_LATIN_CAPITAL_LETTER_D = chr(917572)
TAG_LATIN_CAPITAL_LETTER_E = chr(917573)
TAG_LATIN_CAPITAL_LETTER_F = chr(917574)
TAG_LATIN_CAPITAL_LETTER_G = chr(917575)
TAG_LATIN_CAPITAL_LETTER_H = chr(917576)
TAG_LATIN_CAPITAL_LETTER_I = chr(917577)
TAG_LATIN_CAPITAL_LETTER_J = chr(917578)
TAG_LATIN_CAPITAL_LETTER_K = chr(917579)
TAG_LATIN_CAPITAL_LETTER_L = chr(917580)
TAG_LATIN_CAPITAL_LETTER_M = chr(917581)
TAG_LATIN_CAPITAL_LETTER_N = chr(917582)
TAG_LATIN_CAPITAL_LETTER_O = chr(917583)
TAG_LATIN_CAPITAL_LETTER_P = chr(917584)
TAG_LATIN_CAPITAL_LETTER_Q = chr(917585)
TAG_LATIN_CAPITAL_LETTER_R = chr(917586)
TAG_LATIN_CAPITAL_LETTER_S = chr(917587)
TAG_LATIN_CAPITAL_LETTER_T = chr(917588)
TAG_LATIN_CAPITAL_LETTER_U = chr(917589)
TAG_LATIN_CAPITAL_LETTER_V = chr(917590)
TAG_LATIN_CAPITAL_LETTER_W = chr(917591)
TAG_LATIN_CAPITAL_LETTER_X = chr(917592)
TAG_LATIN_CAPITAL_LETTER_Y = chr(917593)
TAG_LATIN_CAPITAL_LETTER_Z = chr(917594)
TAG_LEFT_SQUARE_BRACKET = chr(917595)
TAG_REVERSE_SOLIDUS = chr(917596)
TAG_RIGHT_SQUARE_BRACKET = chr(917597)
TAG_CIRCUMFLEX_ACCENT = chr(917598)
TAG_LOW_LINE = chr(917599)
TAG_GRAVE_ACCENT = chr(917600)
TAG_LATIN_SMALL_LETTER_A = chr(917601)
TAG_LATIN_SMALL_LETTER_B = chr(917602)
TAG_LATIN_SMALL_LETTER_C = chr(917603)
TAG_LATIN_SMALL_LETTER_D = chr(917604)
TAG_LATIN_SMALL_LETTER_E = chr(917605)
TAG_LATIN_SMALL_LETTER_F = chr(917606)
TAG_LATIN_SMALL_LETTER_G = chr(917607)
TAG_LATIN_SMALL_LETTER_H = chr(917608)
TAG_LATIN_SMALL_LETTER_I = chr(917609)
TAG_LATIN_SMALL_LETTER_J = chr(917610)
TAG_LATIN_SMALL_LETTER_K = chr(917611)
TAG_LATIN_SMALL_LETTER_L = chr(917612)
TAG_LATIN_SMALL_LETTER_M = chr(917613)
TAG_LATIN_SMALL_LETTER_N = chr(917614)
TAG_LATIN_SMALL_LETTER_O = chr(917615)
TAG_LATIN_SMALL_LETTER_P = chr(917616)
TAG_LATIN_SMALL_LETTER_Q = chr(917617)
TAG_LATIN_SMALL_LETTER_R = chr(917618)
TAG_LATIN_SMALL_LETTER_S = chr(917619)
TAG_LATIN_SMALL_LETTER_T = chr(917620)
TAG_LATIN_SMALL_LETTER_U = chr(917621)
TAG_LATIN_SMALL_LETTER_V = chr(917622)
TAG_LATIN_SMALL_LETTER_W = chr(917623)
TAG_LATIN_SMALL_LETTER_X = chr(917624)
TAG_LATIN_SMALL_LETTER_Y = chr(917625)
TAG_LATIN_SMALL_LETTER_Z = chr(917626)
TAG_LEFT_CURLY_BRACKET = chr(917627)
TAG_VERTICAL_LINE = chr(917628)
TAG_RIGHT_CURLY_BRACKET = chr(917629)
TAG_TILDE = chr(917630)
CANCEL_TAG = chr(917631)
VARIATION_SELECTOR_17 = chr(917760)
VARIATION_SELECTOR_18 = chr(917761)
VARIATION_SELECTOR_19 = chr(917762)
VARIATION_SELECTOR_20 = chr(917763)
VARIATION_SELECTOR_21 = chr(917764)
VARIATION_SELECTOR_22 = chr(917765)
VARIATION_SELECTOR_23 = chr(917766)
VARIATION_SELECTOR_24 = chr(917767)
VARIATION_SELECTOR_25 = chr(917768)
VARIATION_SELECTOR_26 = chr(917769)
VARIATION_SELECTOR_27 = chr(917770)
VARIATION_SELECTOR_28 = chr(917771)
VARIATION_SELECTOR_29 = chr(917772)
VARIATION_SELECTOR_30 = chr(917773)
VARIATION_SELECTOR_31 = chr(917774)
VARIATION_SELECTOR_32 = chr(917775)
VARIATION_SELECTOR_33 = chr(917776)
VARIATION_SELECTOR_34 = chr(917777)
VARIATION_SELECTOR_35 = chr(917778)
VARIATION_SELECTOR_36 = chr(917779)
VARIATION_SELECTOR_37 = chr(917780)
VARIATION_SELECTOR_38 = chr(917781)
VARIATION_SELECTOR_39 = chr(917782)
VARIATION_SELECTOR_40 = chr(917783)
VARIATION_SELECTOR_41 = chr(917784)
VARIATION_SELECTOR_42 = chr(917785)
VARIATION_SELECTOR_43 = chr(917786)
VARIATION_SELECTOR_44 = chr(917787)
VARIATION_SELECTOR_45 = chr(917788)
VARIATION_SELECTOR_46 = chr(917789)
VARIATION_SELECTOR_47 = chr(917790)
VARIATION_SELECTOR_48 = chr(917791)
VARIATION_SELECTOR_49 = chr(917792)
VARIATION_SELECTOR_50 = chr(917793)
VARIATION_SELECTOR_51 = chr(917794)
VARIATION_SELECTOR_52 = chr(917795)
VARIATION_SELECTOR_53 = chr(917796)
VARIATION_SELECTOR_54 = chr(917797)
VARIATION_SELECTOR_55 = chr(917798)
VARIATION_SELECTOR_56 = chr(917799)
VARIATION_SELECTOR_57 = chr(917800)
VARIATION_SELECTOR_58 = chr(917801)
VARIATION_SELECTOR_59 = chr(917802)
VARIATION_SELECTOR_60 = chr(917803)
VARIATION_SELECTOR_61 = chr(917804)
VARIATION_SELECTOR_62 = chr(917805)
VARIATION_SELECTOR_63 = chr(917806)
VARIATION_SELECTOR_64 = chr(917807)
VARIATION_SELECTOR_65 = chr(917808)
VARIATION_SELECTOR_66 = chr(917809)
VARIATION_SELECTOR_67 = chr(917810)
VARIATION_SELECTOR_68 = chr(917811)
VARIATION_SELECTOR_69 = chr(917812)
VARIATION_SELECTOR_70 = chr(917813)
VARIATION_SELECTOR_71 = chr(917814)
VARIATION_SELECTOR_72 = chr(917815)
VARIATION_SELECTOR_73 = chr(917816)
VARIATION_SELECTOR_74 = chr(917817)
VARIATION_SELECTOR_75 = chr(917818)
VARIATION_SELECTOR_76 = chr(917819)
VARIATION_SELECTOR_77 = chr(917820)
VARIATION_SELECTOR_78 = chr(917821)
VARIATION_SELECTOR_79 = chr(917822)
VARIATION_SELECTOR_80 = chr(917823)
VARIATION_SELECTOR_81 = chr(917824)
VARIATION_SELECTOR_82 = chr(917825)
VARIATION_SELECTOR_83 = chr(917826)
VARIATION_SELECTOR_84 = chr(917827)
VARIATION_SELECTOR_85 = chr(917828)
VARIATION_SELECTOR_86 = chr(917829)
VARIATION_SELECTOR_87 = chr(917830)
VARIATION_SELECTOR_88 = chr(917831)
VARIATION_SELECTOR_89 = chr(917832)
VARIATION_SELECTOR_90 = chr(917833)
VARIATION_SELECTOR_91 = chr(917834)
VARIATION_SELECTOR_92 = chr(917835)
VARIATION_SELECTOR_93 = chr(917836)
VARIATION_SELECTOR_94 = chr(917837)
VARIATION_SELECTOR_95 = chr(917838)
VARIATION_SELECTOR_96 = chr(917839)
VARIATION_SELECTOR_97 = chr(917840)
VARIATION_SELECTOR_98 = chr(917841)
VARIATION_SELECTOR_99 = chr(917842)
VARIATION_SELECTOR_100 = chr(917843)
VARIATION_SELECTOR_101 = chr(917844)
VARIATION_SELECTOR_102 = chr(917845)
VARIATION_SELECTOR_103 = chr(917846)
VARIATION_SELECTOR_104 = chr(917847)
VARIATION_SELECTOR_105 = chr(917848)
VARIATION_SELECTOR_106 = chr(917849)
VARIATION_SELECTOR_107 = chr(917850)
VARIATION_SELECTOR_108 = chr(917851)
VARIATION_SELECTOR_109 = chr(917852)
VARIATION_SELECTOR_110 = chr(917853)
VARIATION_SELECTOR_111 = chr(917854)
VARIATION_SELECTOR_112 = chr(917855)
VARIATION_SELECTOR_113 = chr(917856)
VARIATION_SELECTOR_114 = chr(917857)
VARIATION_SELECTOR_115 = chr(917858)
VARIATION_SELECTOR_116 = chr(917859)
VARIATION_SELECTOR_117 = chr(917860)
VARIATION_SELECTOR_118 = chr(917861)
VARIATION_SELECTOR_119 = chr(917862)
VARIATION_SELECTOR_120 = chr(917863)
VARIATION_SELECTOR_121 = chr(917864)
VARIATION_SELECTOR_122 = chr(917865)
VARIATION_SELECTOR_123 = chr(917866)
VARIATION_SELECTOR_124 = chr(917867)
VARIATION_SELECTOR_125 = chr(917868)
VARIATION_SELECTOR_126 = chr(917869)
VARIATION_SELECTOR_127 = chr(917870)
VARIATION_SELECTOR_128 = chr(917871)
VARIATION_SELECTOR_129 = chr(917872)
VARIATION_SELECTOR_130 = chr(917873)
VARIATION_SELECTOR_131 = chr(917874)
VARIATION_SELECTOR_132 = chr(917875)
VARIATION_SELECTOR_133 = chr(917876)
VARIATION_SELECTOR_134 = chr(917877)
VARIATION_SELECTOR_135 = chr(917878)
VARIATION_SELECTOR_136 = chr(917879)
VARIATION_SELECTOR_137 = chr(917880)
VARIATION_SELECTOR_138 = chr(917881)
VARIATION_SELECTOR_139 = chr(917882)
VARIATION_SELECTOR_140 = chr(917883)
VARIATION_SELECTOR_141 = chr(917884)
VARIATION_SELECTOR_142 = chr(917885)
VARIATION_SELECTOR_143 = chr(917886)
VARIATION_SELECTOR_144 = chr(917887)
VARIATION_SELECTOR_145 = chr(917888)
VARIATION_SELECTOR_146 = chr(917889)
VARIATION_SELECTOR_147 = chr(917890)
VARIATION_SELECTOR_148 = chr(917891)
VARIATION_SELECTOR_149 = chr(917892)
VARIATION_SELECTOR_150 = chr(917893)
VARIATION_SELECTOR_151 = chr(917894)
VARIATION_SELECTOR_152 = chr(917895)
VARIATION_SELECTOR_153 = chr(917896)
VARIATION_SELECTOR_154 = chr(917897)
VARIATION_SELECTOR_155 = chr(917898)
VARIATION_SELECTOR_156 = chr(917899)
VARIATION_SELECTOR_157 = chr(917900)
VARIATION_SELECTOR_158 = chr(917901)
VARIATION_SELECTOR_159 = chr(917902)
VARIATION_SELECTOR_160 = chr(917903)
VARIATION_SELECTOR_161 = chr(917904)
VARIATION_SELECTOR_162 = chr(917905)
VARIATION_SELECTOR_163 = chr(917906)
VARIATION_SELECTOR_164 = chr(917907)
VARIATION_SELECTOR_165 = chr(917908)
VARIATION_SELECTOR_166 = chr(917909)
VARIATION_SELECTOR_167 = chr(917910)
VARIATION_SELECTOR_168 = chr(917911)
VARIATION_SELECTOR_169 = chr(917912)
VARIATION_SELECTOR_170 = chr(917913)
VARIATION_SELECTOR_171 = chr(917914)
VARIATION_SELECTOR_172 = chr(917915)
VARIATION_SELECTOR_173 = chr(917916)
VARIATION_SELECTOR_174 = chr(917917)
VARIATION_SELECTOR_175 = chr(917918)
VARIATION_SELECTOR_176 = chr(917919)
VARIATION_SELECTOR_177 = chr(917920)
VARIATION_SELECTOR_178 = chr(917921)
VARIATION_SELECTOR_179 = chr(917922)
VARIATION_SELECTOR_180 = chr(917923)
VARIATION_SELECTOR_181 = chr(917924)
VARIATION_SELECTOR_182 = chr(917925)
VARIATION_SELECTOR_183 = chr(917926)
VARIATION_SELECTOR_184 = chr(917927)
VARIATION_SELECTOR_185 = chr(917928)
VARIATION_SELECTOR_186 = chr(917929)
VARIATION_SELECTOR_187 = chr(917930)
VARIATION_SELECTOR_188 = chr(917931)
VARIATION_SELECTOR_189 = chr(917932)
VARIATION_SELECTOR_190 = chr(917933)
VARIATION_SELECTOR_191 = chr(917934)
VARIATION_SELECTOR_192 = chr(917935)
VARIATION_SELECTOR_193 = chr(917936)
VARIATION_SELECTOR_194 = chr(917937)
VARIATION_SELECTOR_195 = chr(917938)
VARIATION_SELECTOR_196 = chr(917939)
VARIATION_SELECTOR_197 = chr(917940)
VARIATION_SELECTOR_198 = chr(917941)
VARIATION_SELECTOR_199 = chr(917942)
VARIATION_SELECTOR_200 = chr(917943)
VARIATION_SELECTOR_201 = chr(917944)
VARIATION_SELECTOR_202 = chr(917945)
VARIATION_SELECTOR_203 = chr(917946)
VARIATION_SELECTOR_204 = chr(917947)
VARIATION_SELECTOR_205 = chr(917948)
VARIATION_SELECTOR_206 = chr(917949)
VARIATION_SELECTOR_207 = chr(917950)
VARIATION_SELECTOR_208 = chr(917951)
VARIATION_SELECTOR_209 = chr(917952)
VARIATION_SELECTOR_210 = chr(917953)
VARIATION_SELECTOR_211 = chr(917954)
VARIATION_SELECTOR_212 = chr(917955)
VARIATION_SELECTOR_213 = chr(917956)
VARIATION_SELECTOR_214 = chr(917957)
VARIATION_SELECTOR_215 = chr(917958)
VARIATION_SELECTOR_216 = chr(917959)
VARIATION_SELECTOR_217 = chr(917960)
VARIATION_SELECTOR_218 = chr(917961)
VARIATION_SELECTOR_219 = chr(917962)
VARIATION_SELECTOR_220 = chr(917963)
VARIATION_SELECTOR_221 = chr(917964)
VARIATION_SELECTOR_222 = chr(917965)
VARIATION_SELECTOR_223 = chr(917966)
VARIATION_SELECTOR_224 = chr(917967)
VARIATION_SELECTOR_225 = chr(917968)
VARIATION_SELECTOR_226 = chr(917969)
VARIATION_SELECTOR_227 = chr(917970)
VARIATION_SELECTOR_228 = chr(917971)
VARIATION_SELECTOR_229 = chr(917972)
VARIATION_SELECTOR_230 = chr(917973)
VARIATION_SELECTOR_231 = chr(917974)
VARIATION_SELECTOR_232 = chr(917975)
VARIATION_SELECTOR_233 = chr(917976)
VARIATION_SELECTOR_234 = chr(917977)
VARIATION_SELECTOR_235 = chr(917978)
VARIATION_SELECTOR_236 = chr(917979)
VARIATION_SELECTOR_237 = chr(917980)
VARIATION_SELECTOR_238 = chr(917981)
VARIATION_SELECTOR_239 = chr(917982)
VARIATION_SELECTOR_240 = chr(917983)
VARIATION_SELECTOR_241 = chr(917984)
VARIATION_SELECTOR_242 = chr(917985)
VARIATION_SELECTOR_243 = chr(917986)
VARIATION_SELECTOR_244 = chr(917987)
VARIATION_SELECTOR_245 = chr(917988)
VARIATION_SELECTOR_246 = chr(917989)
VARIATION_SELECTOR_247 = chr(917990)
VARIATION_SELECTOR_248 = chr(917991)
VARIATION_SELECTOR_249 = chr(917992)
VARIATION_SELECTOR_250 = chr(917993)
VARIATION_SELECTOR_251 = chr(917994)
VARIATION_SELECTOR_252 = chr(917995)
VARIATION_SELECTOR_253 = chr(917996)
VARIATION_SELECTOR_254 = chr(917997)
VARIATION_SELECTOR_255 = chr(917998)
VARIATION_SELECTOR_256 = chr(917999)
